"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T16:46:10.331394
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:46:10.579905.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = np.copy(t2)
    tmp0 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    e_cc = einsum(f.ov, (0, 1), t1, (0, 1), ())
    e_cc += einsum(v.oovv, (0, 1, 2, 3), tmp0, (0, 1, 2, 3), ()) * 0.25
    del tmp0

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:46:14.108530.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    t1new : array
        Updated T1 residuals.
    t2new : array
        Updated T2 residuals.
    """

    tmp16 = einsum(v.ooov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp0 = einsum(v.oovv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp17 = einsum(tmp16, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4)) * -1
    del tmp16
    tmp4 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp8 = einsum(v.ovvv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp23 = np.copy(v.oooo)
    tmp23 += einsum(t1, (0, 1), tmp0, (2, 3, 4, 1), (4, 3, 0, 2)) * -1
    tmp11 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp13 = einsum(v.ovov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 2, 1))
    tmp18 = einsum(t1, (0, 1), tmp17, (2, 0, 3, 4), (2, 3, 4, 1)) * -1
    del tmp17
    tmp15 = einsum(t2, (0, 1, 2, 3), tmp4, (1, 4), (4, 0, 2, 3))
    tmp9 = einsum(t1, (0, 1), tmp8, (2, 3, 4, 1), (2, 0, 3, 4)) * -1
    del tmp8
    tmp5 = np.copy(t2)
    tmp5 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    tmp24 = np.copy(v.ooov) * -1
    tmp24 += einsum(tmp23, (0, 1, 2, 3), t1, (0, 4), (2, 3, 1, 4)) * -1
    del tmp23
    tmp21 = einsum(v.ovvv, (0, 1, 2, 3), t1, (4, 1), (4, 0, 2, 3))
    tmp7 = einsum(t1, (0, 1), v.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp20 = einsum(t2, (0, 1, 2, 3), f.vv, (4, 3), (0, 1, 4, 2))
    tmp22 = einsum(t2, (0, 1, 2, 3), f.oo, (4, 1), (4, 0, 2, 3))
    tmp12 = einsum(t1, (0, 1), tmp11, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp11
    tmp14 = einsum(t1, (0, 1), tmp13, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp13
    tmp19 = np.copy(np.transpose(tmp15, (0, 1, 3, 2))) * -1
    del tmp15
    tmp19 += np.transpose(tmp18, (0, 1, 3, 2))
    del tmp18
    tmp10 = einsum(tmp9, (0, 1, 2, 3), t1, (2, 4), (1, 0, 4, 3)) * -1
    del tmp9
    tmp2 = np.copy(t2) * 0.5
    tmp2 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    tmp3 = np.copy(f.ov)
    tmp3 += einsum(t1, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3))
    tmp1 = np.copy(np.transpose(v.ovoo, (0, 2, 3, 1))) * -1
    tmp1 += np.transpose(tmp0, (0, 2, 1, 3)) * -1
    del tmp0
    tmp6 = np.copy(f.oo)
    tmp6 += tmp4
    del tmp4
    tmp6 += einsum(v.ooov, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp6 += einsum(tmp5, (0, 1, 2, 3), v.oovv, (4, 0, 2, 3), (4, 1)) * -0.5
    del tmp5
    t2new = einsum(tmp7, (0, 1, 2, 3), t1, (4, 3), (4, 0, 2, 1)) * -1
    del tmp7
    t2new += v.oovv
    t2new += einsum(v.ooov, (0, 1, 2, 3), t1, (2, 4), (0, 1, 3, 4))
    t2new += tmp10 * -1
    t2new += np.transpose(tmp10, (0, 1, 3, 2))
    del tmp10
    t2new += tmp12
    t2new += np.transpose(tmp12, (0, 1, 3, 2)) * -1
    del tmp12
    t2new += tmp14
    t2new += np.transpose(tmp14, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp14, (1, 0, 2, 3)) * -1
    t2new += np.transpose(tmp14, (1, 0, 3, 2))
    del tmp14
    t2new += tmp19
    t2new += np.transpose(tmp19, (1, 0, 2, 3)) * -1
    del tmp19
    t2new += np.transpose(tmp20, (1, 0, 2, 3))
    t2new += np.transpose(tmp20, (1, 0, 3, 2)) * -1
    del tmp20
    t2new += np.transpose(tmp21, (0, 1, 3, 2))
    t2new += np.transpose(tmp21, (1, 0, 3, 2)) * -1
    del tmp21
    t2new += np.transpose(tmp22, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp22, (1, 0, 3, 2))
    del tmp22
    t2new += einsum(t1, (0, 1), tmp24, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp24
    t1new = np.copy(f.ov)
    t1new += einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))
    t1new += einsum(t1, (0, 1), v.ovov, (2, 1, 0, 3), (2, 3)) * -1
    t1new += einsum(tmp1, (0, 1, 2, 3), t2, (1, 2, 4, 3), (0, 4)) * 0.5
    del tmp1
    t1new += einsum(v.ovvv, (0, 1, 2, 3), tmp2, (0, 4, 2, 3), (4, 1))
    del tmp2
    t1new += einsum(tmp3, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    del tmp3
    t1new += einsum(t1, (0, 1), tmp6, (0, 2), (2, 1)) * -1
    del tmp6

    return {f"t1new": t1new, f"t2new": t2new}

def update_lams(f=None, l1=None, l2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:46:23.597177.

    Parameters
    ----------
    f : array
        Fock matrix.
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    l1new : array
        Updated L1 residuals.
    l2new : array
        Updated L2 residuals.
    """

    tmp5 = einsum(v.oovv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp2 = einsum(v.ovvv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp0 = einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp33 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp23 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp17 = einsum(t1, (0, 1), l1, (1, 2), (2, 0))
    tmp6 = np.copy(np.transpose(v.ovoo, (0, 2, 3, 1))) * -1
    tmp6 += np.transpose(tmp5, (0, 2, 1, 3)) * -1
    tmp21 = einsum(v.ovvv, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    tmp7 = einsum(t1, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3))
    tmp26 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * -1
    tmp26 += tmp2
    tmp10 = np.copy(v.ooov)
    tmp10 += np.transpose(tmp5, (2, 1, 0, 3)) * 0.5
    tmp18 = einsum(t2, (0, 1, 2, 3), l2, (2, 3, 4, 1), (4, 0))
    tmp3 = einsum(t2, (0, 1, 2, 3), l2, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp4 = einsum(tmp0, (0, 1, 2, 3), t1, (4, 3), (1, 0, 2, 4))
    tmp34 = einsum(tmp33, (0, 1), l2, (2, 3, 4, 1), (0, 4, 2, 3))
    del tmp33
    tmp36 = einsum(l2, (0, 1, 2, 3), tmp23, (4, 3), (2, 4, 0, 1))
    tmp35 = einsum(tmp17, (0, 1), v.oovv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp29 = einsum(tmp0, (0, 1, 2, 3), f.ov, (2, 4), (0, 1, 4, 3))
    tmp31 = einsum(tmp6, (0, 1, 2, 3), l1, (4, 0), (1, 2, 4, 3))
    tmp30 = einsum(tmp21, (0, 1), l2, (2, 0, 3, 4), (3, 4, 2, 1))
    tmp44 = einsum(tmp7, (0, 1), t1, (2, 1), (2, 0))
    tmp25 = einsum(tmp0, (0, 1, 2, 3), v.ooov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp27 = einsum(l2, (0, 1, 2, 3), tmp26, (3, 4, 1, 5), (4, 2, 5, 0))
    del tmp26
    tmp42 = einsum(v.ovvv, (0, 1, 2, 3), l1, (1, 4), (4, 0, 2, 3))
    tmp41 = einsum(f.oo, (0, 1), l2, (2, 3, 4, 1), (0, 4, 2, 3))
    tmp39 = einsum(tmp7, (0, 1), tmp0, (2, 3, 0, 4), (2, 3, 4, 1))
    tmp38 = einsum(l2, (0, 1, 2, 3), f.vv, (4, 1), (2, 3, 4, 0))
    tmp8 = np.copy(f.ov)
    tmp8 += tmp7
    tmp9 = np.copy(np.transpose(v.ovov, (0, 2, 1, 3)))
    tmp9 += np.transpose(tmp2, (0, 1, 3, 2)) * -0.5
    tmp11 = np.copy(v.oooo) * -0.5
    tmp11 += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 2, 3), (4, 5, 0, 1)) * -0.25
    tmp11 += einsum(t1, (0, 1), tmp10, (2, 3, 4, 1), (3, 2, 0, 4)) * -1
    tmp19 = np.copy(tmp17) * 2
    del tmp17
    tmp19 += tmp18
    del tmp18
    tmp14 = np.copy(np.transpose(tmp3, (1, 0, 3, 2))) * -0.5
    tmp14 += np.transpose(tmp4, (0, 1, 3, 2))
    tmp37 = np.copy(np.transpose(tmp34, (0, 1, 3, 2))) * -1
    del tmp34
    tmp37 += np.transpose(tmp35, (0, 1, 3, 2)) * -1
    del tmp35
    tmp37 += np.transpose(tmp36, (0, 1, 3, 2))
    del tmp36
    tmp32 = np.copy(tmp29) * -1
    del tmp29
    tmp32 += tmp30
    del tmp30
    tmp32 += np.transpose(tmp31, (1, 0, 2, 3))
    del tmp31
    tmp47 = np.copy(v.oooo)
    tmp47 += einsum(t1, (0, 1), tmp10, (2, 3, 4, 1), (4, 0, 3, 2)) * -2
    del tmp10
    tmp46 = einsum(tmp5, (0, 1, 2, 3), tmp0, (0, 4, 2, 5), (4, 1, 5, 3)) * -1
    del tmp5
    tmp45 = einsum(l2, (0, 1, 2, 3), tmp44, (3, 4), (2, 4, 0, 1))
    del tmp44
    tmp28 = einsum(tmp7, (0, 1), l1, (2, 3), (3, 0, 2, 1))
    del tmp7
    tmp28 += tmp25
    del tmp25
    tmp28 += np.transpose(tmp27, (1, 0, 3, 2))
    del tmp27
    tmp43 = np.copy(np.transpose(tmp41, (0, 1, 3, 2))) * -1
    del tmp41
    tmp43 += np.transpose(tmp42, (0, 1, 3, 2))
    del tmp42
    tmp40 = np.copy(np.transpose(tmp38, (1, 0, 2, 3))) * -1
    del tmp38
    tmp40 += tmp39
    del tmp39
    tmp12 = np.copy(np.transpose(v.ovoo, (0, 2, 3, 1))) * -0.5
    tmp12 += einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 5, 2, 3), (0, 4, 5, 1)) * -0.25
    tmp12 += einsum(tmp6, (0, 1, 2, 3), t2, (4, 1, 5, 3), (2, 4, 0, 5))
    del tmp6
    tmp12 += einsum(t2, (0, 1, 2, 3), tmp8, (4, 3), (4, 0, 1, 2)) * 0.5
    tmp12 += einsum(tmp9, (0, 1, 2, 3), t1, (4, 2), (1, 0, 4, 3)) * -1
    del tmp9
    tmp12 += einsum(tmp11, (0, 1, 2, 3), t1, (0, 4), (1, 3, 2, 4)) * -1
    del tmp11
    tmp13 = np.copy(v.ovvv)
    tmp13 += einsum(v.vvvv, (0, 1, 2, 3), t1, (4, 1), (4, 0, 2, 3)) * -1
    tmp20 = np.copy(t1) * -1
    tmp20 += einsum(l1, (0, 1), t2, (2, 1, 3, 0), (2, 3)) * -1
    tmp20 += einsum(tmp0, (0, 1, 2, 3), t2, (1, 0, 4, 3), (2, 4)) * 0.5
    tmp20 += einsum(tmp19, (0, 1), t1, (0, 2), (1, 2)) * 0.5
    tmp16 = einsum(l1, (0, 1), t1, (1, 2), (0, 2)) * 2
    tmp16 += einsum(l2, (0, 1, 2, 3), t2, (2, 3, 4, 1), (0, 4))
    tmp15 = einsum(l1, (0, 1), t2, (2, 3, 4, 0), (1, 2, 3, 4)) * 0.5
    tmp15 += einsum(tmp0, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 2, 5)) * -1
    tmp15 += einsum(tmp14, (0, 1, 2, 3), t1, (0, 4), (1, 3, 2, 4)) * -0.5
    del tmp14
    tmp22 = np.copy(f.vv)
    tmp22 += tmp21 * -1
    del tmp21
    tmp24 = np.copy(f.oo) * 2
    tmp24 += np.transpose(tmp23, (1, 0)) * 2
    del tmp23
    tmp24 += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 2, 3), (0, 4))
    tmp24 += einsum(tmp8, (0, 1), t1, (2, 1), (2, 0)) * 2
    tmp1 = einsum(t2, (0, 1, 2, 3), l2, (4, 3, 5, 1), (5, 0, 4, 2))
    l2new = einsum(tmp0, (0, 1, 2, 3), v.ovvv, (2, 3, 4, 5), (4, 5, 0, 1))
    l2new += einsum(v.vvvv, (0, 1, 2, 3), l2, (2, 3, 4, 5), (0, 1, 4, 5)) * 0.5
    l2new += np.transpose(v.oovv, (2, 3, 0, 1))
    l2new += einsum(tmp4, (0, 1, 2, 3), v.oovv, (3, 2, 4, 5), (4, 5, 1, 0)) * 0.5
    l2new += np.transpose(tmp28, (2, 3, 0, 1))
    l2new += np.transpose(tmp28, (3, 2, 0, 1)) * -1
    l2new += np.transpose(tmp28, (2, 3, 1, 0)) * -1
    l2new += np.transpose(tmp28, (3, 2, 1, 0))
    del tmp28
    l2new += np.transpose(tmp32, (2, 3, 0, 1)) * -1
    l2new += np.transpose(tmp32, (3, 2, 0, 1))
    del tmp32
    l2new += np.transpose(tmp37, (3, 2, 0, 1)) * -1
    l2new += np.transpose(tmp37, (3, 2, 1, 0))
    del tmp37
    l2new += einsum(l1, (0, 1), f.ov, (2, 3), (3, 0, 2, 1))
    l2new += einsum(l1, (0, 1), f.ov, (2, 3), (0, 3, 2, 1)) * -1
    l2new += einsum(f.ov, (0, 1), l1, (2, 3), (1, 2, 3, 0)) * -1
    l2new += einsum(l1, (0, 1), f.ov, (2, 3), (0, 3, 1, 2))
    l2new += np.transpose(tmp40, (2, 3, 0, 1)) * -1
    l2new += np.transpose(tmp40, (3, 2, 0, 1))
    del tmp40
    l2new += np.transpose(tmp43, (2, 3, 0, 1))
    l2new += np.transpose(tmp43, (2, 3, 1, 0)) * -1
    del tmp43
    l2new += np.transpose(tmp45, (2, 3, 0, 1)) * -1
    l2new += np.transpose(tmp45, (2, 3, 1, 0))
    del tmp45
    l2new += np.transpose(tmp46, (2, 3, 0, 1)) * -1
    l2new += np.transpose(tmp46, (3, 2, 0, 1))
    l2new += np.transpose(tmp46, (2, 3, 1, 0))
    l2new += np.transpose(tmp46, (3, 2, 1, 0)) * -1
    del tmp46
    l2new += einsum(l2, (0, 1, 2, 3), tmp47, (2, 3, 4, 5), (0, 1, 4, 5)) * 0.5
    del tmp47
    l1new = einsum(tmp0, (0, 1, 2, 3), v.ovov, (2, 3, 1, 4), (4, 0)) * -1
    l1new += np.transpose(f.ov, (1, 0))
    l1new += einsum(v.ovvv, (0, 1, 2, 3), tmp1, (4, 0, 1, 3), (2, 4)) * -1
    del tmp1
    l1new += einsum(tmp0, (0, 1, 2, 3), tmp2, (1, 2, 3, 4), (4, 0))
    del tmp2, tmp0
    l1new += einsum(l1, (0, 1), v.ovov, (2, 0, 1, 3), (3, 2)) * -1
    l1new += einsum(v.ovoo, (0, 1, 2, 3), tmp3, (4, 0, 3, 2), (1, 4)) * 0.25
    del tmp3
    l1new += einsum(v.ooov, (0, 1, 2, 3), tmp4, (4, 2, 0, 1), (3, 4)) * -0.5
    del tmp4
    l1new += einsum(tmp12, (0, 1, 2, 3), l2, (4, 3, 1, 2), (4, 0))
    del tmp12
    l1new += einsum(tmp13, (0, 1, 2, 3), l2, (2, 3, 4, 0), (1, 4)) * -0.5
    del tmp13
    l1new += einsum(tmp15, (0, 1, 2, 3), v.oovv, (1, 2, 4, 3), (4, 0))
    del tmp15
    l1new += einsum(v.ovvv, (0, 1, 2, 3), tmp16, (1, 3), (2, 0)) * 0.5
    del tmp16
    l1new += einsum(tmp20, (0, 1), v.oovv, (2, 0, 3, 1), (3, 2)) * -1
    del tmp20
    l1new += einsum(v.ooov, (0, 1, 2, 3), tmp19, (2, 1), (3, 0)) * 0.5
    l1new += einsum(l1, (0, 1), tmp22, (0, 2), (2, 1))
    del tmp22
    l1new += einsum(l1, (0, 1), tmp24, (1, 2), (0, 2)) * -0.5
    del tmp24
    l1new += einsum(tmp8, (0, 1), tmp19, (2, 0), (1, 2)) * -0.5
    del tmp8, tmp19

    return {f"l1new": l1new, f"l2new": l2new}

def make_rdm1_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:46:24.279058.

    Parameters
    ----------
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.

    Returns
    -------
    rdm1 : array
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    delta = Namespace(
        oo=np.eye(t2.shape[0]),
        vv=np.eye(t2.shape[-1]),
    )
    tmp1 = einsum(t1, (0, 1), l1, (1, 2), (2, 0))
    tmp0 = einsum(l2, (0, 1, 2, 3), t2, (4, 3, 0, 1), (2, 4))
    tmp2 = einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp3 = np.copy(tmp1) * 2
    tmp3 += tmp0
    rdm1.vv = einsum(l1, (0, 1), t1, (1, 2), (0, 2))
    rdm1.vv += einsum(l2, (0, 1, 2, 3), t2, (2, 3, 4, 1), (0, 4)) * 0.5
    rdm1.vo = np.copy(l1)
    rdm1.ov = einsum(l1, (0, 1), t2, (2, 1, 3, 0), (2, 3))
    rdm1.ov += einsum(t2, (0, 1, 2, 3), tmp2, (1, 0, 4, 3), (4, 2)) * -0.5
    del tmp2
    rdm1.ov += t1
    rdm1.ov += einsum(tmp3, (0, 1), t1, (0, 2), (1, 2)) * -0.5
    del tmp3
    rdm1.oo = np.copy(delta.oo)
    del delta
    rdm1.oo += np.transpose(tmp0, (1, 0)) * -0.5
    del tmp0
    rdm1.oo += np.transpose(tmp1, (1, 0)) * -1
    del tmp1
    rdm1 = np.block([[rdm1.oo, rdm1.ov], [rdm1.vo, rdm1.vv]])

    return rdm1

def make_rdm2_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:46:35.023382.

    Parameters
    ----------
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.

    Returns
    -------
    rdm2 : array
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    delta = Namespace(
        oo=np.eye(t2.shape[0]),
        vv=np.eye(t2.shape[-1]),
    )
    tmp1 = einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp4 = einsum(t1, (0, 1), l1, (1, 2), (2, 0))
    tmp3 = einsum(l2, (0, 1, 2, 3), t2, (4, 3, 0, 1), (2, 4))
    tmp19 = einsum(l2, (0, 1, 2, 3), t2, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp5 = einsum(t2, (0, 1, 2, 3), l1, (3, 4), (4, 0, 1, 2))
    tmp2 = einsum(t1, (0, 1), tmp1, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp0 = einsum(t2, (0, 1, 2, 3), l2, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp12 = einsum(tmp1, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 2, 4, 5)) * -1
    tmp7 = einsum(t1, (0, 1), tmp4, (0, 2), (2, 1))
    tmp6 = einsum(l1, (0, 1), t2, (2, 1, 3, 0), (2, 3))
    tmp14 = np.copy(tmp4) * 2
    tmp14 += tmp3
    tmp22 = einsum(l2, (0, 1, 2, 3), t2, (2, 3, 4, 1), (0, 4))
    tmp30 = einsum(l1, (0, 1), t1, (1, 2), (0, 2))
    tmp29 = einsum(tmp1, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    tmp36 = einsum(t1, (0, 1), tmp19, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp18 = einsum(t1, (0, 1), tmp5, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp20 = einsum(t2, (0, 1, 2, 3), tmp19, (1, 4, 3, 5), (4, 0, 5, 2))
    tmp13 = np.copy(np.transpose(tmp0, (1, 0, 3, 2))) * -0.5
    tmp13 += np.transpose(tmp2, (0, 1, 3, 2))
    tmp25 = einsum(tmp12, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3))
    tmp8 = np.copy(tmp6)
    tmp8 += tmp7 * -1
    del tmp7
    tmp10 = einsum(tmp3, (0, 1), t1, (0, 2), (1, 2))
    tmp9 = einsum(tmp1, (0, 1, 2, 3), t2, (1, 0, 4, 3), (2, 4))
    tmp15 = einsum(t1, (0, 1), tmp14, (0, 2), (2, 1)) * 0.5
    del tmp14
    tmp38 = einsum(t1, (0, 1), l2, (2, 3, 4, 0), (4, 2, 3, 1))
    tmp31 = np.copy(tmp30)
    tmp31 += tmp22 * 0.5
    tmp33 = einsum(l1, (0, 1), t2, (2, 1, 3, 4), (2, 0, 3, 4))
    tmp34 = einsum(tmp1, (0, 1, 2, 3), t2, (1, 0, 4, 5), (2, 3, 4, 5)) * -1
    tmp35 = einsum(t1, (0, 1), tmp29, (0, 2, 3, 4), (2, 3, 4, 1)) * -1
    tmp37 = np.copy(tmp36)
    tmp37 += einsum(tmp22, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * -0.5
    tmp32 = np.copy(tmp30) * 2
    tmp32 += tmp22
    tmp24 = einsum(t2, (0, 1, 2, 3), tmp3, (1, 4), (0, 4, 2, 3))
    tmp21 = np.copy(tmp18)
    del tmp18
    tmp21 += tmp20
    del tmp20
    tmp28 = einsum(tmp13, (0, 1, 2, 3), t1, (0, 4), (1, 3, 2, 4)) * -2
    tmp26 = np.copy(tmp25)
    del tmp25
    tmp26 += einsum(tmp8, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * -1
    tmp11 = np.copy(tmp9)
    tmp11 += tmp10
    del tmp10
    tmp23 = einsum(tmp22, (0, 1), t2, (2, 3, 4, 0), (2, 3, 4, 1))
    del tmp22
    tmp27 = einsum(t2, (0, 1, 2, 3), tmp4, (1, 4), (4, 0, 2, 3))
    tmp17 = np.copy(np.transpose(tmp0, (1, 0, 3, 2))) * -1
    tmp17 += np.transpose(tmp2, (0, 1, 3, 2)) * 2
    tmp16 = np.copy(tmp6) * -1
    del tmp6
    tmp16 += tmp9 * 0.5
    del tmp9
    tmp16 += tmp15
    del tmp15
    rdm2.vvvv = einsum(t2, (0, 1, 2, 3), l2, (4, 5, 0, 1), (4, 5, 2, 3)) * 0.5
    rdm2.vvvv += einsum(tmp38, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3))
    rdm2.vvvo = np.copy(np.transpose(tmp38, (2, 1, 3, 0)))
    rdm2.vvov = np.copy(np.transpose(tmp38, (2, 1, 0, 3))) * -1
    del tmp38
    rdm2.vovv = np.copy(np.transpose(tmp33, (1, 0, 3, 2)))
    rdm2.vovv += np.transpose(tmp34, (1, 0, 3, 2)) * 0.5
    rdm2.vovv += np.transpose(tmp35, (1, 0, 3, 2))
    rdm2.vovv += einsum(t1, (0, 1), tmp31, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.vovv += einsum(tmp31, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.vovv += np.transpose(tmp36, (1, 0, 2, 3))
    rdm2.vovv += np.transpose(tmp36, (1, 0, 3, 2)) * -1
    del tmp36
    rdm2.ovvv = np.copy(np.transpose(tmp33, (0, 1, 3, 2))) * -1
    del tmp33
    rdm2.ovvv += np.transpose(tmp34, (0, 1, 3, 2)) * -0.5
    del tmp34
    rdm2.ovvv += np.transpose(tmp35, (0, 1, 3, 2)) * -1
    del tmp35
    rdm2.ovvv += einsum(tmp30, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2.ovvv += einsum(tmp30, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1
    del tmp30
    rdm2.ovvv += tmp37 * -1
    rdm2.ovvv += np.transpose(tmp37, (0, 1, 3, 2))
    del tmp37
    rdm2.vvoo = np.copy(l2)
    rdm2.vovo = einsum(l1, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.vovo += np.transpose(tmp19, (2, 1, 3, 0)) * -1
    rdm2.vovo += np.transpose(tmp29, (2, 1, 3, 0))
    rdm2.vovo += einsum(delta.oo, (0, 1), tmp32, (2, 3), (2, 0, 3, 1)) * 0.5
    rdm2.voov = einsum(l1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.voov += np.transpose(tmp19, (2, 1, 0, 3))
    rdm2.voov += np.transpose(tmp29, (2, 1, 0, 3)) * -1
    rdm2.voov += einsum(tmp31, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovvo = einsum(l1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2.ovvo += np.transpose(tmp19, (1, 2, 3, 0))
    rdm2.ovvo += np.transpose(tmp29, (1, 2, 3, 0)) * -1
    rdm2.ovvo += einsum(delta.oo, (0, 1), tmp32, (2, 3), (0, 2, 3, 1)) * -0.5
    del tmp32
    rdm2.ovov = einsum(l1, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.ovov += np.transpose(tmp19, (1, 2, 0, 3)) * -1
    del tmp19
    rdm2.ovov += np.transpose(tmp29, (1, 2, 0, 3))
    del tmp29
    rdm2.ovov += einsum(tmp31, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1))
    del tmp31
    rdm2.oovv = np.copy(t2)
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2.oovv += tmp21
    rdm2.oovv += np.transpose(tmp21, (0, 1, 3, 2)) * -1
    del tmp21
    rdm2.oovv += tmp23 * -0.5
    rdm2.oovv += np.transpose(tmp23, (0, 1, 3, 2)) * 0.5
    del tmp23
    rdm2.oovv += np.transpose(tmp24, (0, 1, 3, 2)) * 0.5
    rdm2.oovv += np.transpose(tmp24, (1, 0, 3, 2)) * -0.5
    del tmp24
    rdm2.oovv += tmp26 * -1
    rdm2.oovv += np.transpose(tmp26, (0, 1, 3, 2))
    rdm2.oovv += np.transpose(tmp26, (1, 0, 2, 3))
    rdm2.oovv += np.transpose(tmp26, (1, 0, 3, 2)) * -1
    del tmp26
    rdm2.oovv += einsum(tmp11, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * -0.5
    rdm2.oovv += einsum(tmp11, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * 0.5
    rdm2.oovv += einsum(t1, (0, 1), tmp11, (2, 3), (2, 0, 1, 3)) * 0.5
    rdm2.oovv += einsum(t1, (0, 1), tmp11, (2, 3), (2, 0, 3, 1)) * -0.5
    rdm2.oovv += np.transpose(tmp27, (0, 1, 3, 2)) * -1
    rdm2.oovv += np.transpose(tmp27, (1, 0, 3, 2))
    del tmp27
    rdm2.oovv += einsum(tmp13, (0, 1, 2, 3), t2, (0, 1, 4, 5), (3, 2, 4, 5)) * 0.5
    rdm2.oovv += einsum(t1, (0, 1), tmp28, (0, 2, 3, 4), (2, 3, 1, 4)) * 0.5
    del tmp28
    rdm2.vooo = np.copy(np.transpose(tmp1, (3, 2, 1, 0)))
    rdm2.vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2.vooo += einsum(l1, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovoo = np.copy(np.transpose(tmp1, (2, 3, 1, 0))) * -1
    del tmp1
    rdm2.ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ovoo += einsum(l1, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1))
    rdm2.oovo = np.copy(np.transpose(tmp5, (2, 1, 3, 0)))
    rdm2.oovo += einsum(tmp16, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp16, (2, 3), (0, 2, 3, 1))
    del tmp16
    rdm2.oovo += einsum(delta.oo, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2.oovo += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.oovo += einsum(tmp4, (0, 1), t1, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.oovo += einsum(t1, (0, 1), tmp4, (2, 3), (3, 0, 1, 2))
    rdm2.oovo += np.transpose(tmp12, (1, 2, 3, 0))
    rdm2.oovo += np.transpose(tmp12, (2, 1, 3, 0)) * -1
    rdm2.oovo += einsum(tmp3, (0, 1), t1, (2, 3), (2, 1, 3, 0)) * -0.5
    rdm2.oovo += einsum(t1, (0, 1), tmp3, (2, 3), (3, 0, 1, 2)) * 0.5
    rdm2.oovo += einsum(tmp17, (0, 1, 2, 3), t1, (0, 4), (3, 2, 4, 1)) * 0.5
    del tmp17
    rdm2.ooov = np.copy(np.transpose(tmp5, (2, 1, 0, 3))) * -1
    del tmp5
    rdm2.ooov += einsum(tmp8, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.ooov += einsum(tmp8, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1))
    del tmp8
    rdm2.ooov += einsum(delta.oo, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.ooov += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2.ooov += einsum(tmp4, (0, 1), t1, (2, 3), (2, 1, 0, 3))
    rdm2.ooov += einsum(t1, (0, 1), tmp4, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp11, (2, 3), (2, 0, 1, 3)) * 0.5
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp11, (2, 3), (0, 2, 1, 3)) * -0.5
    del tmp11
    rdm2.ooov += np.transpose(tmp12, (1, 2, 0, 3)) * -1
    rdm2.ooov += np.transpose(tmp12, (2, 1, 0, 3))
    del tmp12
    rdm2.ooov += einsum(tmp3, (0, 1), t1, (2, 3), (2, 1, 0, 3)) * 0.5
    rdm2.ooov += einsum(t1, (0, 1), tmp3, (2, 3), (3, 0, 2, 1)) * -0.5
    rdm2.ooov += einsum(tmp13, (0, 1, 2, 3), t1, (0, 4), (3, 2, 1, 4)) * -1
    del tmp13
    rdm2.oooo = np.copy(np.transpose(tmp0, (3, 2, 1, 0))) * 0.5
    del tmp0
    rdm2.oooo += np.transpose(tmp2, (2, 3, 1, 0)) * -1
    del tmp2
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp3, (2, 3), (3, 0, 2, 1)) * -0.5
    rdm2.oooo += einsum(tmp3, (0, 1), delta.oo, (2, 3), (2, 1, 0, 3)) * 0.5
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp3, (2, 3), (3, 0, 1, 2)) * 0.5
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp3, (2, 3), (0, 3, 1, 2)) * -0.5
    del tmp3
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp4, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.oooo += einsum(tmp4, (0, 1), delta.oo, (2, 3), (2, 1, 0, 3))
    rdm2.oooo += einsum(tmp4, (0, 1), delta.oo, (2, 3), (1, 2, 3, 0))
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp4, (2, 3), (0, 3, 1, 2)) * -1
    del tmp4, delta
    rdm2 = pack_2e(rdm2.oooo, rdm2.ooov, rdm2.oovo, rdm2.ovoo, rdm2.vooo, rdm2.oovv, rdm2.ovov, rdm2.ovvo, rdm2.voov, rdm2.vovo, rdm2.vvoo, rdm2.ovvv, rdm2.vovv, rdm2.vvov, rdm2.vvvo, rdm2.vvvv)
    rdm2 = np.transpose(rdm2, (0, 2, 1, 3))

    return rdm2

def hbar_matvec_ip_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:46:40.972111.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp0 : array
    tmp1 : array
    tmp11 : array
    tmp12 : array
    tmp13 : array
    tmp15 : array
    tmp16 : array
    tmp18 : array
    tmp19 : array
    tmp2 : array
    tmp21 : array
    tmp22 : array
    tmp23 : array
    tmp3 : array
    tmp4 : array
    tmp5 : array
    tmp7 : array
    tmp8 : array
    """

    tmp0 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp2 = einsum(t1, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3))
    tmp23 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp22 = einsum(v.oovv, (0, 1, 2, 3), t2, (0, 1, 4, 3), (4, 2))
    tmp21 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 5, 2, 3), (4, 5, 0, 1))
    tmp19 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 5, 2, 3), (4, 5, 0, 1))
    tmp18 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 2, 3), (0, 4))
    tmp16 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp15 = einsum(v.ovoo, (0, 1, 2, 3), t2, (2, 3, 4, 1), (0, 4))
    tmp13 = einsum(t1, (0, 1), tmp0, (0, 2), (2, 1))
    tmp12 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp11 = einsum(t2, (0, 1, 2, 3), f.ov, (1, 3), (0, 2))
    tmp8 = einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))
    tmp7 = einsum(t1, (0, 1), f.oo, (2, 0), (2, 1))
    tmp5 = einsum(tmp2, (0, 1), t1, (2, 1), (2, 0))
    tmp4 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 1, 2, 3), (4, 0))
    tmp3 = einsum(v.oovv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp1 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 3), (0, 2))

    return {f"tmp0": tmp0, f"tmp1": tmp1, f"tmp11": tmp11, f"tmp12": tmp12, f"tmp13": tmp13, f"tmp15": tmp15, f"tmp16": tmp16, f"tmp18": tmp18, f"tmp19": tmp19, f"tmp2": tmp2, f"tmp21": tmp21, f"tmp22": tmp22, f"tmp23": tmp23, f"tmp3": tmp3, f"tmp4": tmp4, f"tmp5": tmp5, f"tmp7": tmp7, f"tmp8": tmp8}

def hbar_matvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:46:40.989837.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp5 = np.copy(f.oo)
    tmp5 += ints.tmp0
    tmp6 = einsum(r2, (0, 1, 2), tmp5, (1, 3), (0, 3, 2)) * -1
    del tmp5
    tmp4 = einsum(ints.tmp16, (0, 1, 2, 3), r1, (1,), (0, 2, 3))
    del ints.tmp16
    tmp8 = einsum(ints.tmp4, (0, 1), r2, (2, 1, 3), (0, 2, 3))
    tmp10 = einsum(v.ovov, (0, 1, 2, 3), r2, (4, 2, 1), (4, 0, 3))
    tmp9 = einsum(ints.tmp23, (0, 1, 2, 3), r2, (4, 1, 3), (0, 4, 2))
    del ints.tmp23
    tmp3 = einsum(r2, (0, 1, 2), v.oovv, (0, 1, 3, 2), (3,))
    tmp7 = np.copy(tmp4)
    del tmp4
    tmp7 += np.transpose(tmp6, (1, 0, 2)) * -1
    del tmp6
    tmp13 = np.copy(np.transpose(ints.tmp22, (1, 0))) * 0.5
    del ints.tmp22
    tmp13 += f.vv * -1
    tmp13 += einsum(t1, (0, 1), f.ov, (0, 2), (2, 1))
    tmp11 = np.copy(tmp8) * -0.5
    del tmp8
    tmp11 += tmp9
    del tmp9
    tmp11 += tmp10
    del tmp10
    tmp15 = np.copy(ints.tmp13)
    del ints.tmp13
    tmp15 += ints.tmp15 * 0.5
    del ints.tmp15
    tmp15 += ints.tmp18 * 0.5
    del ints.tmp18
    tmp15 += ints.tmp7
    del ints.tmp7
    tmp15 += f.ov * -1
    tmp15 += ints.tmp11 * -1
    del ints.tmp11
    tmp15 += ints.tmp8 * -1
    del ints.tmp8
    tmp12 = np.copy(ints.tmp21) * -0.5
    del ints.tmp21
    tmp12 += v.oooo * -1
    tmp14 = np.copy(np.transpose(ints.tmp19, (2, 0, 1, 3))) * 0.5
    del ints.tmp19
    tmp14 += np.transpose(v.ovoo, (0, 2, 3, 1))
    tmp14 += ints.tmp12 * -1
    del ints.tmp12
    tmp2 = np.copy(f.oo) * 2
    tmp2 += ints.tmp0 * 2
    del ints.tmp0
    tmp2 += ints.tmp1 * 2
    del ints.tmp1
    tmp2 += np.transpose(ints.tmp4, (1, 0))
    del ints.tmp4
    tmp2 += np.transpose(ints.tmp5, (1, 0)) * 2
    del ints.tmp5
    tmp0 = np.copy(ints.tmp3)
    del ints.tmp3
    tmp0 += np.transpose(v.ovoo, (0, 2, 3, 1)) * -1
    tmp1 = np.copy(f.ov)
    tmp1 += ints.tmp2
    del ints.tmp2
    r2new = einsum(t2, (0, 1, 2, 3), tmp3, (3,), (0, 1, 2)) * 0.5
    del tmp3
    r2new += tmp7
    r2new += np.transpose(tmp7, (1, 0, 2)) * -1
    del tmp7
    r2new += tmp11 * -1
    r2new += np.transpose(tmp11, (1, 0, 2))
    del tmp11
    r2new += einsum(r2, (0, 1, 2), tmp12, (3, 4, 1, 0), (3, 4, 2)) * 0.5
    del tmp12
    r2new += einsum(r2, (0, 1, 2), tmp13, (2, 3), (0, 1, 3)) * -1
    del tmp13
    r2new += einsum(tmp14, (0, 1, 2, 3), r1, (0,), (2, 1, 3))
    del tmp14
    r2new += einsum(tmp15, (0, 1), r1, (2,), (2, 0, 1)) * -1
    r2new += einsum(tmp15, (0, 1), r1, (2,), (0, 2, 1))
    del tmp15
    r1new = einsum(r2, (0, 1, 2), tmp0, (3, 0, 1, 2), (3,)) * 0.5
    del tmp0
    r1new += einsum(r2, (0, 1, 2), tmp1, (1, 2), (0,))
    del tmp1
    r1new += einsum(r1, (0,), tmp2, (0, 1), (1,)) * -0.5
    del tmp2

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_matvec_ea_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:46:47.228395.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp12 : array
    tmp13 : array
    tmp15 : array
    tmp16 : array
    tmp17 : array
    tmp18 : array
    tmp2 : array
    tmp20 : array
    tmp22 : array
    tmp4 : array
    tmp7 : array
    tmp8 : array
    tmp9 : array
    """

    tmp9 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp22 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp20 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 1, 2, 3), (4, 0))
    tmp18 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 3), (0, 2, 4, 5))
    tmp17 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 2, 3), (0, 4))
    tmp16 = einsum(v.ovoo, (0, 1, 2, 3), t2, (2, 3, 4, 5), (0, 4, 5, 1))
    tmp15 = einsum(v.ovoo, (0, 1, 2, 3), t2, (2, 3, 4, 1), (0, 4))
    tmp13 = einsum(tmp9, (0, 1), t1, (0, 2), (1, 2))
    tmp12 = einsum(t2, (0, 1, 2, 3), f.ov, (1, 3), (0, 2))
    tmp8 = einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))
    tmp7 = einsum(t1, (0, 1), f.oo, (2, 0), (2, 1))
    tmp4 = einsum(v.oovv, (0, 1, 2, 3), t2, (0, 1, 4, 3), (4, 2))
    tmp2 = einsum(t1, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3))
    tmp1 = einsum(v.ovvv, (0, 1, 2, 3), t1, (0, 3), (1, 2))

    return {f"tmp1": tmp1, f"tmp12": tmp12, f"tmp13": tmp13, f"tmp15": tmp15, f"tmp16": tmp16, f"tmp17": tmp17, f"tmp18": tmp18, f"tmp2": tmp2, f"tmp20": tmp20, f"tmp22": tmp22, f"tmp4": tmp4, f"tmp7": tmp7, f"tmp8": tmp8, f"tmp9": tmp9}

def hbar_matvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:46:47.243478.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp7 = einsum(r2, (0, 1, 2), f.ov, (3, 1), (3, 2, 0))
    tmp9 = np.copy(f.vv) * 2
    tmp9 += np.transpose(ints.tmp4, (1, 0)) * -1
    tmp5 = einsum(r2, (0, 1, 2), ints.tmp22, (3, 2, 4, 1), (3, 4, 0))
    del ints.tmp22
    tmp8 = einsum(t1, (0, 1), tmp7, (0, 2, 3), (2, 3, 1))
    del tmp7
    tmp6 = einsum(v.ovov, (0, 1, 2, 3), r2, (4, 1, 2), (0, 4, 3))
    tmp10 = einsum(tmp9, (0, 1), r2, (2, 0, 3), (3, 2, 1)) * -0.5
    del tmp9
    tmp2 = einsum(r2, (0, 1, 2), v.oovv, (3, 2, 0, 1), (3,))
    tmp0 = np.copy(f.ov)
    tmp0 += ints.tmp2
    del ints.tmp2
    tmp13 = np.copy(ints.tmp16) * 0.5
    del ints.tmp16
    tmp13 += np.transpose(v.ovvv, (0, 2, 3, 1))
    tmp4 = einsum(r2, (0, 1, 2), v.oovv, (3, 4, 0, 1), (2, 3, 4))
    tmp11 = np.copy(tmp5)
    del tmp5
    tmp11 += tmp6
    del tmp6
    tmp11 += tmp8
    del tmp8
    tmp11 += np.transpose(tmp10, (0, 2, 1)) * -1
    del tmp10
    tmp15 = einsum(r1, (0,), f.ov, (1, 0), (1,)) * 2
    tmp15 += tmp2
    tmp12 = einsum(r1, (0,), ints.tmp18, (1, 2, 3, 0), (1, 2, 3))
    del ints.tmp18
    tmp16 = np.copy(ints.tmp13)
    del ints.tmp13
    tmp16 += ints.tmp15 * 0.5
    del ints.tmp15
    tmp16 += ints.tmp17 * 0.5
    del ints.tmp17
    tmp16 += ints.tmp7
    del ints.tmp7
    tmp16 += f.ov * -1
    tmp16 += ints.tmp12 * -1
    del ints.tmp12
    tmp16 += ints.tmp8 * -1
    del ints.tmp8
    tmp14 = np.copy(f.oo)
    tmp14 += np.transpose(ints.tmp20, (1, 0)) * 0.5
    del ints.tmp20
    tmp14 += ints.tmp9
    del ints.tmp9
    tmp3 = np.copy(tmp2) * 0.5
    del tmp2
    tmp3 += einsum(tmp0, (0, 1), r1, (1,), (0,))
    tmp1 = np.copy(np.transpose(ints.tmp1, (1, 0)))
    del ints.tmp1
    tmp1 += np.transpose(ints.tmp4, (1, 0)) * 0.5
    del ints.tmp4
    tmp1 += f.vv * -1
    r2new = einsum(v.vvvv, (0, 1, 2, 3), r2, (2, 3, 4), (0, 1, 4)) * 0.5
    r2new += einsum(t2, (0, 1, 2, 3), tmp4, (4, 1, 0), (2, 3, 4)) * -0.25
    del tmp4
    r2new += np.transpose(tmp11, (1, 2, 0)) * -1
    r2new += np.transpose(tmp11, (2, 1, 0))
    del tmp11
    r2new += np.transpose(tmp12, (1, 2, 0))
    r2new += np.transpose(tmp12, (2, 1, 0)) * -1
    del tmp12
    r2new += einsum(r1, (0,), tmp13, (1, 2, 3, 0), (3, 2, 1))
    del tmp13
    r2new += einsum(r2, (0, 1, 2), tmp14, (2, 3), (0, 1, 3)) * -1
    del tmp14
    r2new += einsum(tmp15, (0,), t2, (1, 0, 2, 3), (2, 3, 1)) * 0.5
    del tmp15
    r2new += einsum(tmp16, (0, 1), r1, (2,), (2, 1, 0)) * -1
    r2new += einsum(r1, (0,), tmp16, (1, 2), (2, 0, 1))
    del tmp16
    r1new = einsum(v.ovvv, (0, 1, 2, 3), r2, (2, 3, 0), (1,)) * -0.5
    r1new += einsum(r2, (0, 1, 2), tmp0, (2, 1), (0,))
    del tmp0
    r1new += einsum(r1, (0,), tmp1, (0, 1), (1,)) * -1
    del tmp1
    r1new += einsum(tmp3, (0,), t1, (0, 1), (1,)) * -1
    del tmp3

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_matvec_ee_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:47:01.424327.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp0 : array
    tmp10 : array
    tmp12 : array
    tmp17 : array
    tmp18 : array
    tmp2 : array
    tmp22 : array
    tmp23 : array
    tmp26 : array
    tmp30 : array
    tmp31 : array
    tmp33 : array
    tmp36 : array
    tmp37 : array
    tmp39 : array
    tmp4 : array
    tmp44 : array
    tmp46 : array
    tmp5 : array
    tmp6 : array
    tmp7 : array
    tmp9 : array
    """

    tmp0 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp6 = einsum(t1, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3))
    tmp46 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp44 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 5, 2, 3), (4, 5, 0, 1))
    tmp39 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 3), (0, 2, 4, 5))
    tmp37 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 5, 2, 3), (4, 5, 0, 1))
    tmp36 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 2, 3), (0, 4))
    tmp33 = einsum(v.ovoo, (0, 1, 2, 3), t2, (2, 3, 4, 5), (0, 4, 5, 1))
    tmp31 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp30 = einsum(v.ovoo, (0, 1, 2, 3), t2, (2, 3, 4, 1), (0, 4))
    tmp26 = einsum(t1, (0, 1), tmp0, (0, 2), (2, 1))
    tmp23 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp22 = einsum(t2, (0, 1, 2, 3), f.ov, (1, 3), (0, 2))
    tmp18 = einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))
    tmp17 = einsum(t1, (0, 1), f.oo, (2, 0), (2, 1))
    tmp12 = einsum(tmp6, (0, 1), t1, (2, 1), (2, 0))
    tmp10 = einsum(v.oovv, (0, 1, 2, 3), t2, (0, 1, 4, 3), (4, 2))
    tmp9 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 1, 2, 3), (4, 0))
    tmp7 = einsum(v.oovv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp5 = einsum(v.ovvv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp4 = einsum(v.ovvv, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    tmp2 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 3), (0, 2))

    return {f"tmp0": tmp0, f"tmp10": tmp10, f"tmp12": tmp12, f"tmp17": tmp17, f"tmp18": tmp18, f"tmp2": tmp2, f"tmp22": tmp22, f"tmp23": tmp23, f"tmp26": tmp26, f"tmp30": tmp30, f"tmp31": tmp31, f"tmp33": tmp33, f"tmp36": tmp36, f"tmp37": tmp37, f"tmp39": tmp39, f"tmp4": tmp4, f"tmp44": tmp44, f"tmp46": tmp46, f"tmp5": tmp5, f"tmp6": tmp6, f"tmp7": tmp7, f"tmp9": tmp9}

def hbar_matvec_ee(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:47:01.450592.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp5 = einsum(v.oovv, (0, 1, 2, 3), r2, (4, 1, 2, 3), (4, 0))
    tmp25 = einsum(r1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp30 = einsum(r1, (0, 1), v.ooov, (2, 0, 3, 1), (2, 3))
    tmp17 = einsum(f.ov, (0, 1), r2, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp19 = einsum(r2, (0, 1, 2, 3), v.oovv, (0, 1, 4, 3), (2, 4))
    tmp26 = np.copy(np.transpose(tmp25, (1, 0)))
    del tmp25
    tmp26 += tmp5 * 0.5
    tmp23 = np.copy(f.oo)
    tmp23 += ints.tmp0
    tmp23 += np.transpose(ints.tmp9, (1, 0)) * 0.5
    tmp29 = einsum(v.ovvv, (0, 1, 2, 3), r1, (4, 1), (4, 0, 2, 3))
    tmp31 = einsum(t2, (0, 1, 2, 3), tmp30, (1, 4), (0, 4, 2, 3)) * -1
    del tmp30
    tmp16 = einsum(ints.tmp23, (0, 1, 2, 3), r1, (0, 4), (1, 2, 3, 4))
    del ints.tmp23
    tmp18 = einsum(t1, (0, 1), tmp17, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp17
    tmp20 = einsum(tmp19, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4)) * -1
    del tmp19
    tmp27 = einsum(t2, (0, 1, 2, 3), tmp26, (4, 1), (4, 0, 2, 3)) * -1
    del tmp26
    tmp24 = einsum(tmp23, (0, 1), r2, (2, 0, 3, 4), (1, 2, 3, 4)) * -1
    del tmp23
    tmp22 = einsum(ints.tmp33, (0, 1, 2, 3), r1, (4, 3), (0, 4, 1, 2))
    del ints.tmp33
    tmp37 = einsum(r2, (0, 1, 2, 3), ints.tmp10, (4, 3), (0, 1, 4, 2))
    tmp36 = einsum(ints.tmp37, (0, 1, 2, 3), r1, (2, 4), (0, 1, 3, 4))
    del ints.tmp37
    tmp14 = einsum(r2, (0, 1, 2, 3), ints.tmp46, (4, 1, 5, 3), (4, 0, 5, 2))
    del ints.tmp46
    tmp11 = einsum(ints.tmp31, (0, 1, 2, 3), r1, (1, 4), (0, 2, 3, 4))
    del ints.tmp31
    tmp13 = einsum(v.ovov, (0, 1, 2, 3), r2, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp12 = einsum(ints.tmp39, (0, 1, 2, 3), r1, (4, 3), (0, 4, 1, 2))
    del ints.tmp39
    tmp34 = einsum(r2, (0, 1, 2, 3), f.vv, (4, 3), (0, 1, 4, 2))
    tmp33 = einsum(r1, (0, 1), v.ooov, (2, 3, 0, 4), (2, 3, 1, 4))
    tmp9 = einsum(v.ovvv, (0, 1, 2, 3), r1, (0, 3), (1, 2))
    tmp2 = np.copy(f.ov)
    tmp2 += ints.tmp6
    del ints.tmp6
    tmp1 = np.copy(ints.tmp7)
    del ints.tmp7
    tmp1 += np.transpose(v.ovoo, (0, 2, 3, 1)) * -1
    tmp32 = np.copy(np.transpose(tmp29, (0, 1, 3, 2))) * -1
    del tmp29
    tmp32 += np.transpose(tmp31, (0, 1, 3, 2))
    del tmp31
    tmp8 = einsum(v.oovv, (0, 1, 2, 3), r2, (4, 5, 2, 3), (4, 5, 0, 1))
    tmp21 = np.copy(tmp16)
    del tmp16
    tmp21 += tmp18
    del tmp18
    tmp21 += tmp20 * 0.5
    del tmp20
    tmp28 = np.copy(np.transpose(tmp22, (0, 1, 3, 2))) * -0.5
    del tmp22
    tmp28 += np.transpose(tmp24, (0, 1, 3, 2))
    del tmp24
    tmp28 += np.transpose(tmp27, (0, 1, 3, 2))
    del tmp27
    tmp38 = np.copy(tmp36) * 0.5
    del tmp36
    tmp38 += np.transpose(tmp37, (1, 0, 2, 3)) * -0.5
    del tmp37
    tmp15 = np.copy(tmp11)
    del tmp11
    tmp15 += tmp12
    del tmp12
    tmp15 += tmp13
    del tmp13
    tmp15 += tmp14 * -1
    del tmp14
    tmp39 = np.copy(ints.tmp44) * -0.5
    del ints.tmp44
    tmp39 += v.oooo * -1
    tmp40 = np.copy(ints.tmp17)
    del ints.tmp17
    tmp40 += ints.tmp26
    del ints.tmp26
    tmp40 += ints.tmp30 * 0.5
    del ints.tmp30
    tmp40 += ints.tmp36 * 0.5
    del ints.tmp36
    tmp40 += f.ov * -1
    tmp40 += ints.tmp18 * -1
    del ints.tmp18
    tmp40 += ints.tmp22 * -1
    del ints.tmp22
    tmp35 = np.copy(np.transpose(tmp33, (1, 0, 2, 3))) * -1
    del tmp33
    tmp35 += np.transpose(tmp34, (1, 0, 2, 3)) * -1
    del tmp34
    tmp10 = einsum(t2, (0, 1, 2, 3), tmp9, (4, 3), (0, 1, 2, 4)) * -1
    del tmp9
    tmp3 = np.copy(ints.tmp5)
    del ints.tmp5
    tmp3 += np.transpose(v.ovov, (0, 2, 3, 1)) * -1
    tmp7 = np.copy(f.oo)
    tmp7 += ints.tmp0
    del ints.tmp0
    tmp7 += np.transpose(ints.tmp12, (1, 0))
    del ints.tmp12
    tmp7 += ints.tmp2
    del ints.tmp2
    tmp7 += np.transpose(ints.tmp9, (1, 0)) * 0.5
    del ints.tmp9
    tmp4 = np.copy(np.transpose(ints.tmp10, (1, 0))) * 0.5
    del ints.tmp10
    tmp4 += np.transpose(ints.tmp4, (1, 0))
    del ints.tmp4
    tmp4 += f.vv * -1
    tmp0 = einsum(v.oovv, (0, 1, 2, 3), r1, (1, 3), (0, 2))
    tmp6 = np.copy(np.transpose(tmp5, (1, 0))) * 0.5
    del tmp5
    tmp6 += einsum(tmp1, (0, 1, 2, 3), r1, (1, 3), (2, 0))
    tmp6 += einsum(tmp2, (0, 1), r1, (2, 1), (0, 2))
    r2new = einsum(v.vvvv, (0, 1, 2, 3), r2, (4, 5, 2, 3), (4, 5, 0, 1)) * 0.5
    r2new += einsum(t2, (0, 1, 2, 3), tmp8, (4, 5, 1, 0), (5, 4, 2, 3)) * 0.25
    del tmp8
    r2new += tmp10
    r2new += np.transpose(tmp10, (0, 1, 3, 2)) * -1
    del tmp10
    r2new += tmp15 * -1
    r2new += np.transpose(tmp15, (0, 1, 3, 2))
    r2new += np.transpose(tmp15, (1, 0, 2, 3))
    r2new += np.transpose(tmp15, (1, 0, 3, 2)) * -1
    del tmp15
    r2new += tmp21 * -1
    r2new += np.transpose(tmp21, (0, 1, 3, 2))
    del tmp21
    r2new += tmp28
    r2new += np.transpose(tmp28, (1, 0, 2, 3)) * -1
    del tmp28
    r2new += tmp32 * -1
    r2new += np.transpose(tmp32, (1, 0, 2, 3))
    del tmp32
    r2new += tmp35 * -1
    r2new += np.transpose(tmp35, (0, 1, 3, 2))
    del tmp35
    r2new += np.transpose(tmp38, (1, 0, 2, 3)) * -1
    r2new += np.transpose(tmp38, (1, 0, 3, 2))
    del tmp38
    r2new += einsum(r2, (0, 1, 2, 3), tmp39, (4, 5, 0, 1), (4, 5, 2, 3)) * -0.5
    del tmp39
    r2new += einsum(tmp40, (0, 1), r1, (2, 3), (0, 2, 1, 3)) * -1
    r2new += einsum(tmp40, (0, 1), r1, (2, 3), (2, 0, 3, 1)) * -1
    r2new += einsum(r1, (0, 1), tmp40, (2, 3), (0, 2, 3, 1))
    r2new += einsum(tmp40, (0, 1), r1, (2, 3), (0, 2, 3, 1))
    del tmp40
    r1new = einsum(tmp0, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    del tmp0
    r1new += einsum(v.ovvv, (0, 1, 2, 3), r2, (4, 0, 2, 3), (4, 1)) * -0.5
    r1new += einsum(tmp1, (0, 1, 2, 3), r2, (1, 2, 4, 3), (0, 4)) * 0.5
    del tmp1
    r1new += einsum(r2, (0, 1, 2, 3), tmp2, (1, 3), (0, 2))
    del tmp2
    r1new += einsum(tmp3, (0, 1, 2, 3), r1, (1, 3), (0, 2))
    del tmp3
    r1new += einsum(r1, (0, 1), tmp4, (1, 2), (0, 2)) * -1
    del tmp4
    r1new += einsum(t1, (0, 1), tmp6, (0, 2), (2, 1)) * -1
    del tmp6
    r1new += einsum(tmp7, (0, 1), r1, (0, 2), (1, 2)) * -1
    del tmp7

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ip_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:47:09.827585.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp0 : array
    tmp1 : array
    tmp10 : array
    tmp11 : array
    tmp12 : array
    tmp13 : array
    tmp14 : array
    tmp16 : array
    tmp17 : array
    tmp19 : array
    tmp2 : array
    tmp20 : array
    tmp21 : array
    tmp22 : array
    tmp23 : array
    tmp24 : array
    tmp25 : array
    tmp27 : array
    tmp29 : array
    tmp3 : array
    tmp31 : array
    tmp32 : array
    tmp34 : array
    tmp4 : array
    tmp40 : array
    tmp41 : array
    tmp5 : array
    tmp6 : array
    tmp7 : array
    tmp8 : array
    tmp9 : array
    """

    tmp18 = einsum(v.oovv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp15 = einsum(t1, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3))
    tmp33 = einsum(tmp18, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp24 = einsum(tmp15, (0, 1), t1, (2, 1), (2, 0))
    tmp30 = einsum(v.ovvv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp28 = einsum(v.ovvv, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    tmp26 = einsum(v.ooov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp6 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp22 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 5, 2, 3), (4, 5, 0, 1))
    tmp10 = einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 2, 3), (0, 4))
    tmp0 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp41 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp40 = einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 4, 3), (2, 4))
    tmp34 = einsum(tmp33, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    del tmp33
    tmp32 = einsum(tmp24, (0, 1), t1, (1, 2), (0, 2))
    tmp31 = einsum(tmp30, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    del tmp30
    tmp29 = einsum(tmp28, (0, 1), t1, (2, 1), (2, 0))
    del tmp28
    tmp27 = einsum(tmp26, (0, 1, 2, 3), t1, (2, 4), (0, 1, 3, 4))
    del tmp26
    tmp25 = einsum(t1, (0, 1), tmp6, (0, 2), (2, 1))
    tmp23 = einsum(tmp22, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    tmp21 = einsum(tmp10, (0, 1), t1, (1, 2), (0, 2))
    tmp20 = einsum(tmp18, (0, 1, 2, 3), t2, (4, 2, 5, 3), (0, 4, 1, 5)) * -1
    tmp19 = einsum(tmp18, (0, 1, 2, 3), t2, (2, 1, 4, 3), (0, 4))
    del tmp18
    tmp17 = einsum(t2, (0, 1, 2, 3), tmp15, (4, 3), (0, 1, 4, 2)) * -1
    tmp16 = einsum(tmp15, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    del tmp15
    tmp14 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 5, 2, 3), (4, 5, 0, 1))
    tmp13 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 0, 2, 3), (4, 1))
    tmp12 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp11 = einsum(v.ovoo, (0, 1, 2, 3), t2, (2, 3, 4, 1), (0, 4))
    tmp9 = einsum(v.ovov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 2, 1))
    tmp8 = einsum(t1, (0, 1), v.ovov, (2, 1, 0, 3), (2, 3))
    tmp7 = einsum(v.oooo, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    tmp5 = einsum(t1, (0, 1), tmp0, (0, 2), (2, 1))
    tmp4 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp3 = einsum(t2, (0, 1, 2, 3), f.ov, (1, 3), (0, 2))
    tmp2 = einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))
    tmp1 = einsum(t1, (0, 1), f.oo, (2, 0), (2, 1))

    return {f"tmp0": tmp0, f"tmp1": tmp1, f"tmp10": tmp10, f"tmp11": tmp11, f"tmp12": tmp12, f"tmp13": tmp13, f"tmp14": tmp14, f"tmp16": tmp16, f"tmp17": tmp17, f"tmp19": tmp19, f"tmp2": tmp2, f"tmp20": tmp20, f"tmp21": tmp21, f"tmp22": tmp22, f"tmp23": tmp23, f"tmp24": tmp24, f"tmp25": tmp25, f"tmp27": tmp27, f"tmp29": tmp29, f"tmp3": tmp3, f"tmp31": tmp31, f"tmp32": tmp32, f"tmp34": tmp34, f"tmp4": tmp4, f"tmp40": tmp40, f"tmp41": tmp41, f"tmp5": tmp5, f"tmp6": tmp6, f"tmp7": tmp7, f"tmp8": tmp8, f"tmp9": tmp9}

def hbar_lmatvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:47:09.858516.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp5 = einsum(ints.tmp41, (0, 1, 2, 3), r2, (4, 0, 2), (1, 4, 3))
    del ints.tmp41
    tmp4 = einsum(r2, (0, 1, 2), ints.tmp10, (1, 3), (3, 0, 2))
    tmp6 = einsum(v.ovov, (0, 1, 2, 3), r2, (4, 2, 1), (4, 0, 3))
    tmp8 = np.copy(f.oo)
    tmp8 += np.transpose(ints.tmp0, (1, 0))
    tmp3 = einsum(r2, (0, 1, 2), t2, (0, 1, 3, 2), (3,))
    tmp7 = einsum(r1, (0,), f.ov, (1, 2), (1, 0, 2))
    tmp7 += tmp4 * -0.5
    del tmp4
    tmp7 += tmp5
    del tmp5
    tmp7 += tmp6
    del tmp6
    tmp9 = einsum(r2, (0, 1, 2), tmp8, (1, 3), (3, 0, 2)) * -1
    del tmp8
    tmp11 = np.copy(ints.tmp40) * 0.5
    del ints.tmp40
    tmp11 += f.vv * -1
    tmp11 += einsum(f.ov, (0, 1), t1, (0, 2), (2, 1))
    tmp10 = np.copy(ints.tmp22) * -0.5
    del ints.tmp22
    tmp10 += v.oooo * -1
    tmp2 = np.copy(f.oo) * 2
    tmp2 += np.transpose(ints.tmp0, (1, 0)) * 2
    del ints.tmp0
    tmp2 += ints.tmp10
    del ints.tmp10
    tmp2 += ints.tmp24 * 2
    del ints.tmp24
    tmp2 += np.transpose(ints.tmp6, (1, 0)) * 2
    del ints.tmp6
    tmp0 = np.copy(ints.tmp12)
    del ints.tmp12
    tmp0 += np.transpose(ints.tmp23, (0, 2, 1, 3)) * 0.25
    del ints.tmp23
    tmp0 += np.transpose(ints.tmp34, (0, 2, 1, 3)) * 0.5
    del ints.tmp34
    tmp0 += np.transpose(ints.tmp4, (1, 0, 2, 3)) * 0.5
    del ints.tmp4
    tmp0 += np.transpose(ints.tmp7, (0, 2, 1, 3)) * 0.5
    del ints.tmp7
    tmp0 += ints.tmp9
    del ints.tmp9
    tmp0 += np.transpose(ints.tmp14, (0, 2, 1, 3)) * -0.25
    del ints.tmp14
    tmp0 += np.transpose(ints.tmp17, (0, 2, 1, 3)) * -0.5
    del ints.tmp17
    tmp0 += np.transpose(ints.tmp20, (0, 2, 1, 3)) * -1
    del ints.tmp20
    tmp0 += ints.tmp27 * -1
    del ints.tmp27
    tmp0 += np.transpose(ints.tmp31, (0, 2, 1, 3)) * -0.5
    del ints.tmp31
    tmp0 += np.transpose(v.ooov, (0, 2, 1, 3)) * -0.5
    tmp1 = np.copy(ints.tmp11)
    del ints.tmp11
    tmp1 += ints.tmp13
    del ints.tmp13
    tmp1 += ints.tmp19
    del ints.tmp19
    tmp1 += ints.tmp1 * 2
    del ints.tmp1
    tmp1 += ints.tmp21
    del ints.tmp21
    tmp1 += ints.tmp25 * 2
    del ints.tmp25
    tmp1 += ints.tmp29 * 2
    del ints.tmp29
    tmp1 += ints.tmp32 * 2
    del ints.tmp32
    tmp1 += ints.tmp5 * 2
    del ints.tmp5
    tmp1 += ints.tmp8 * 2
    del ints.tmp8
    tmp1 += f.ov * -2
    tmp1 += ints.tmp16 * -2
    del ints.tmp16
    tmp1 += ints.tmp2 * -2
    del ints.tmp2
    tmp1 += ints.tmp3 * -2
    del ints.tmp3
    r2new = einsum(v.oovv, (0, 1, 2, 3), tmp3, (3,), (0, 1, 2)) * 0.5
    del tmp3
    r2new += einsum(v.ooov, (0, 1, 2, 3), r1, (2,), (0, 1, 3)) * -1
    r2new += tmp7 * -1
    r2new += np.transpose(tmp7, (1, 0, 2))
    del tmp7
    r2new += tmp9 * -1
    r2new += np.transpose(tmp9, (1, 0, 2))
    del tmp9
    r2new += einsum(r2, (0, 1, 2), tmp10, (1, 0, 3, 4), (3, 4, 2)) * 0.5
    del tmp10
    r2new += einsum(r2, (0, 1, 2), tmp11, (2, 3), (0, 1, 3)) * -1
    del tmp11
    r1new = einsum(r2, (0, 1, 2), tmp0, (0, 3, 1, 2), (3,))
    del tmp0
    r1new += einsum(r2, (0, 1, 2), tmp1, (1, 2), (0,)) * -0.5
    del tmp1
    r1new += einsum(r1, (0,), tmp2, (0, 1), (1,)) * -0.5
    del tmp2

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ea_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:47:18.915865.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp10 : array
    tmp11 : array
    tmp12 : array
    tmp13 : array
    tmp14 : array
    tmp15 : array
    tmp16 : array
    tmp17 : array
    tmp18 : array
    tmp19 : array
    tmp2 : array
    tmp20 : array
    tmp21 : array
    tmp22 : array
    tmp23 : array
    tmp25 : array
    tmp27 : array
    tmp28 : array
    tmp3 : array
    tmp30 : array
    tmp5 : array
    tmp6 : array
    tmp7 : array
    tmp8 : array
    """

    tmp16 = einsum(t1, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3))
    tmp29 = einsum(tmp16, (0, 1), t1, (2, 1), (2, 0))
    tmp7 = einsum(v.ovvv, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    tmp24 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp21 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 1, 2, 3), (4, 0))
    tmp18 = einsum(v.oovv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp5 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp30 = einsum(t1, (0, 1), tmp29, (2, 0), (2, 1))
    del tmp29
    tmp28 = einsum(v.ovvv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp27 = einsum(tmp7, (0, 1), t1, (2, 1), (2, 0))
    tmp25 = einsum(t1, (0, 1), tmp24, (0, 2), (2, 1))
    del tmp24
    tmp23 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp22 = einsum(t1, (0, 1), tmp21, (2, 0), (2, 1))
    tmp20 = einsum(tmp18, (0, 1, 2, 3), t2, (2, 1, 4, 5), (0, 4, 5, 3)) * -1
    tmp19 = einsum(tmp18, (0, 1, 2, 3), t2, (2, 1, 4, 3), (0, 4))
    tmp17 = einsum(tmp16, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp15 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 0, 5, 3), (4, 5, 1, 2))
    tmp14 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 0, 2, 3), (4, 1))
    tmp13 = einsum(v.ovoo, (0, 1, 2, 3), t2, (2, 3, 4, 5), (0, 4, 5, 1))
    tmp12 = einsum(v.ovoo, (0, 1, 2, 3), t2, (2, 3, 4, 1), (0, 4))
    tmp11 = einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 4, 3), (2, 4))
    tmp10 = einsum(t1, (0, 1), v.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp8 = einsum(t1, (0, 1), v.ovov, (2, 1, 0, 3), (2, 3))
    tmp6 = einsum(t1, (0, 1), tmp5, (0, 2), (2, 1))
    tmp3 = einsum(t2, (0, 1, 2, 3), f.ov, (1, 3), (0, 2))
    tmp2 = einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))
    tmp1 = einsum(t1, (0, 1), f.oo, (2, 0), (2, 1))

    return {f"tmp1": tmp1, f"tmp10": tmp10, f"tmp11": tmp11, f"tmp12": tmp12, f"tmp13": tmp13, f"tmp14": tmp14, f"tmp15": tmp15, f"tmp16": tmp16, f"tmp17": tmp17, f"tmp18": tmp18, f"tmp19": tmp19, f"tmp2": tmp2, f"tmp20": tmp20, f"tmp21": tmp21, f"tmp22": tmp22, f"tmp23": tmp23, f"tmp25": tmp25, f"tmp27": tmp27, f"tmp28": tmp28, f"tmp3": tmp3, f"tmp30": tmp30, f"tmp5": tmp5, f"tmp6": tmp6, f"tmp7": tmp7, f"tmp8": tmp8}

def hbar_lmatvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:47:18.940212.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp13 = einsum(t1, (0, 1), f.ov, (0, 2), (2, 1))
    tmp14 = np.copy(ints.tmp11)
    tmp14 += f.vv * -2
    tmp14 += np.transpose(tmp13, (1, 0)) * 2
    del tmp13
    tmp11 = einsum(ints.tmp23, (0, 1, 2, 3), r2, (4, 2, 0), (1, 3, 4))
    tmp15 = einsum(tmp14, (0, 1), r2, (2, 0, 3), (3, 1, 2)) * -0.5
    del tmp14
    tmp12 = einsum(v.ovov, (0, 1, 2, 3), r2, (4, 1, 2), (0, 4, 3))
    tmp7 = einsum(r2, (0, 1, 2), t2, (3, 2, 0, 1), (3,))
    tmp1 = einsum(t1, (0, 1), r2, (2, 1, 3), (3, 0, 2))
    tmp17 = np.copy(f.oo)
    tmp17 += ints.tmp21 * 0.5
    del ints.tmp21
    tmp17 += np.transpose(ints.tmp5, (1, 0))
    del ints.tmp5
    tmp16 = einsum(r1, (0,), f.ov, (1, 2), (1, 2, 0))
    tmp16 += tmp11
    del tmp11
    tmp16 += tmp12
    del tmp12
    tmp16 += tmp15
    del tmp15
    tmp10 = einsum(r2, (0, 1, 2), t2, (3, 4, 0, 1), (2, 3, 4))
    tmp5 = np.copy(ints.tmp12) * 0.5
    del ints.tmp12
    tmp5 += ints.tmp14 * 0.5
    del ints.tmp14
    tmp5 += ints.tmp19 * 0.5
    del ints.tmp19
    tmp5 += ints.tmp1
    del ints.tmp1
    tmp5 += ints.tmp22 * 0.5
    del ints.tmp22
    tmp5 += ints.tmp25
    del ints.tmp25
    tmp5 += ints.tmp27
    del ints.tmp27
    tmp5 += ints.tmp30
    del ints.tmp30
    tmp5 += ints.tmp6
    del ints.tmp6
    tmp5 += ints.tmp8
    del ints.tmp8
    tmp5 += f.ov * -1
    tmp5 += ints.tmp17 * -1
    del ints.tmp17
    tmp5 += ints.tmp2 * -1
    del ints.tmp2
    tmp5 += ints.tmp3 * -1
    del ints.tmp3
    tmp8 = einsum(r1, (0,), t1, (1, 0), (1,)) * 2
    tmp8 += tmp7
    tmp3 = einsum(tmp1, (0, 1, 2), t1, (3, 2), (0, 1, 3)) * -1
    tmp2 = np.copy(ints.tmp23)
    del ints.tmp23
    tmp2 += ints.tmp28
    del ints.tmp28
    tmp2 += np.transpose(v.ovov, (0, 2, 3, 1)) * -1
    tmp9 = np.copy(f.ov)
    tmp9 += ints.tmp16
    del ints.tmp16
    tmp4 = np.copy(ints.tmp18)
    del ints.tmp18
    tmp4 += np.transpose(v.ovoo, (0, 2, 3, 1)) * -1
    tmp0 = np.copy(ints.tmp10) * 0.5
    del ints.tmp10
    tmp0 += ints.tmp15
    del ints.tmp15
    tmp0 += ints.tmp20 * 0.25
    del ints.tmp20
    tmp0 += ints.tmp13 * -0.25
    del ints.tmp13
    tmp0 += np.transpose(v.ovvv, (0, 2, 3, 1)) * -0.5
    tmp6 = np.copy(ints.tmp11) * 0.5
    del ints.tmp11
    tmp6 += ints.tmp7
    del ints.tmp7
    tmp6 += f.vv * -1
    r2new = einsum(v.vvvv, (0, 1, 2, 3), r2, (2, 3, 4), (0, 1, 4)) * 0.5
    r2new += einsum(v.ovvv, (0, 1, 2, 3), r1, (1,), (2, 3, 0)) * -1
    r2new += einsum(v.oovv, (0, 1, 2, 3), tmp10, (4, 1, 0), (2, 3, 4)) * -0.25
    del tmp10
    r2new += einsum(tmp7, (0,), v.oovv, (1, 0, 2, 3), (2, 3, 1)) * 0.5
    del tmp7
    r2new += np.transpose(tmp16, (1, 2, 0)) * -1
    r2new += np.transpose(tmp16, (2, 1, 0))
    del tmp16
    r2new += einsum(r2, (0, 1, 2), tmp17, (2, 3), (0, 1, 3)) * -1
    del tmp17
    r1new = einsum(r2, (0, 1, 2), tmp0, (2, 0, 1, 3), (3,))
    del tmp0
    r1new += einsum(tmp1, (0, 1, 2), tmp2, (0, 1, 2, 3), (3,))
    del tmp1, tmp2
    r1new += einsum(tmp3, (0, 1, 2), tmp4, (0, 2, 1, 3), (3,)) * -0.5
    del tmp3, tmp4
    r1new += einsum(tmp5, (0, 1), r2, (2, 1, 0), (2,)) * -1
    del tmp5
    r1new += einsum(r1, (0,), tmp6, (0, 1), (1,)) * -1
    del tmp6
    r1new += einsum(tmp9, (0, 1), tmp8, (0,), (1,)) * -0.5
    del tmp9, tmp8

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ee_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:47:34.487851.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp0 : array
    tmp10 : array
    tmp11 : array
    tmp12 : array
    tmp13 : array
    tmp15 : array
    tmp16 : array
    tmp17 : array
    tmp19 : array
    tmp2 : array
    tmp20 : array
    tmp21 : array
    tmp22 : array
    tmp23 : array
    tmp24 : array
    tmp26 : array
    tmp27 : array
    tmp28 : array
    tmp29 : array
    tmp3 : array
    tmp30 : array
    tmp31 : array
    tmp32 : array
    tmp33 : array
    tmp34 : array
    tmp35 : array
    tmp36 : array
    tmp38 : array
    tmp39 : array
    tmp4 : array
    tmp41 : array
    tmp43 : array
    tmp44 : array
    tmp45 : array
    tmp47 : array
    tmp5 : array
    tmp7 : array
    tmp8 : array
    tmp9 : array
    """

    tmp29 = einsum(v.oovv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp26 = einsum(t1, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3))
    tmp46 = einsum(tmp29, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp38 = einsum(tmp26, (0, 1), t1, (2, 1), (2, 0))
    tmp10 = einsum(v.ovvv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp9 = einsum(v.ovvv, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    tmp40 = einsum(v.ooov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp8 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp34 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 5, 2, 3), (4, 5, 0, 1))
    tmp16 = einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 2, 3), (0, 4))
    tmp0 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp47 = einsum(tmp46, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    del tmp46
    tmp45 = einsum(tmp38, (0, 1), t1, (1, 2), (0, 2))
    tmp44 = einsum(tmp10, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp43 = einsum(tmp9, (0, 1), t1, (2, 1), (2, 0))
    tmp41 = einsum(tmp40, (0, 1, 2, 3), t1, (2, 4), (0, 1, 3, 4))
    del tmp40
    tmp39 = einsum(t1, (0, 1), tmp8, (0, 2), (2, 1))
    tmp36 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp35 = einsum(tmp34, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    tmp33 = einsum(t1, (0, 1), tmp16, (2, 0), (2, 1))
    tmp32 = einsum(tmp29, (0, 1, 2, 3), t2, (2, 1, 4, 5), (0, 4, 5, 3)) * -1
    tmp31 = einsum(tmp29, (0, 1, 2, 3), t2, (4, 2, 5, 3), (0, 4, 1, 5)) * -1
    tmp30 = einsum(tmp29, (0, 1, 2, 3), t2, (2, 1, 4, 3), (0, 4))
    tmp28 = einsum(t2, (0, 1, 2, 3), tmp26, (4, 3), (0, 1, 4, 2)) * -1
    tmp27 = einsum(tmp26, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp24 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 3), (0, 2, 4, 5))
    tmp23 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 5, 2, 3), (4, 5, 0, 1))
    tmp22 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 0, 2, 3), (4, 1))
    tmp21 = einsum(v.ovoo, (0, 1, 2, 3), t2, (2, 3, 4, 5), (0, 4, 5, 1))
    tmp20 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp19 = einsum(v.ovoo, (0, 1, 2, 3), t2, (2, 3, 4, 1), (0, 4))
    tmp17 = einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 4, 3), (2, 4))
    tmp15 = einsum(t1, (0, 1), v.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp13 = einsum(v.ovov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 2, 1))
    tmp12 = einsum(t1, (0, 1), v.ovov, (2, 1, 0, 3), (2, 3))
    tmp11 = einsum(v.oooo, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    tmp7 = einsum(t1, (0, 1), tmp0, (0, 2), (2, 1))
    tmp5 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp4 = einsum(t2, (0, 1, 2, 3), f.ov, (1, 3), (0, 2))
    tmp3 = einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))
    tmp2 = einsum(t1, (0, 1), f.oo, (2, 0), (2, 1))

    return {f"tmp0": tmp0, f"tmp10": tmp10, f"tmp11": tmp11, f"tmp12": tmp12, f"tmp13": tmp13, f"tmp15": tmp15, f"tmp16": tmp16, f"tmp17": tmp17, f"tmp19": tmp19, f"tmp2": tmp2, f"tmp20": tmp20, f"tmp21": tmp21, f"tmp22": tmp22, f"tmp23": tmp23, f"tmp24": tmp24, f"tmp26": tmp26, f"tmp27": tmp27, f"tmp28": tmp28, f"tmp29": tmp29, f"tmp3": tmp3, f"tmp30": tmp30, f"tmp31": tmp31, f"tmp32": tmp32, f"tmp33": tmp33, f"tmp34": tmp34, f"tmp35": tmp35, f"tmp36": tmp36, f"tmp38": tmp38, f"tmp39": tmp39, f"tmp4": tmp4, f"tmp41": tmp41, f"tmp43": tmp43, f"tmp44": tmp44, f"tmp45": tmp45, f"tmp47": tmp47, f"tmp5": tmp5, f"tmp7": tmp7, f"tmp8": tmp8, f"tmp9": tmp9}

def hbar_lmatvec_ee(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:47:34.528052.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp2 = einsum(t2, (0, 1, 2, 3), r2, (4, 1, 2, 3), (4, 0))
    tmp30 = np.copy(f.oo)
    tmp30 += np.transpose(ints.tmp0, (1, 0))
    tmp30 += ints.tmp16 * 0.5
    tmp1 = einsum(r2, (0, 1, 2, 3), t2, (0, 1, 4, 3), (2, 4))
    tmp6 = einsum(r2, (0, 1, 2, 3), t1, (4, 3), (0, 1, 4, 2))
    tmp29 = einsum(tmp2, (0, 1), v.oovv, (2, 1, 3, 4), (0, 2, 3, 4)) * -1
    tmp31 = einsum(tmp30, (0, 1), r2, (2, 0, 3, 4), (1, 2, 3, 4)) * -1
    del tmp30
    tmp18 = einsum(r2, (0, 1, 2, 3), ints.tmp36, (1, 4, 3, 5), (4, 0, 5, 2))
    tmp19 = einsum(r2, (0, 1, 2, 3), v.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp22 = einsum(tmp1, (0, 1), v.oovv, (2, 3, 4, 1), (2, 3, 0, 4)) * -1
    tmp21 = einsum(tmp6, (0, 1, 2, 3), f.ov, (2, 4), (0, 1, 4, 3))
    tmp25 = einsum(r1, (0, 1), v.ooov, (2, 3, 0, 4), (2, 3, 1, 4))
    tmp26 = einsum(r2, (0, 1, 2, 3), f.vv, (4, 3), (0, 1, 4, 2))
    tmp0 = einsum(t1, (0, 1), r1, (2, 1), (2, 0))
    tmp32 = np.copy(np.transpose(tmp29, (0, 1, 3, 2))) * 0.5
    del tmp29
    tmp32 += np.transpose(tmp31, (0, 1, 3, 2))
    del tmp31
    tmp24 = einsum(v.ovvv, (0, 1, 2, 3), r1, (4, 1), (4, 0, 2, 3))
    tmp28 = einsum(ints.tmp17, (0, 1), r2, (2, 3, 4, 0), (2, 3, 1, 4))
    tmp20 = einsum(r1, (0, 1), f.ov, (2, 3), (2, 0, 3, 1))
    tmp20 += tmp18
    del tmp18
    tmp20 += tmp19 * -1
    del tmp19
    tmp23 = np.copy(tmp21)
    del tmp21
    tmp23 += tmp22 * -0.5
    del tmp22
    tmp17 = einsum(t2, (0, 1, 2, 3), r2, (4, 5, 2, 3), (4, 5, 0, 1))
    tmp33 = np.copy(ints.tmp34) * -0.5
    del ints.tmp34
    tmp33 += v.oooo * -1
    tmp27 = np.copy(np.transpose(tmp25, (1, 0, 2, 3))) * -1
    del tmp25
    tmp27 += np.transpose(tmp26, (1, 0, 2, 3)) * -1
    del tmp26
    tmp3 = np.copy(ints.tmp15) * 0.5
    del ints.tmp15
    tmp3 += ints.tmp24
    del ints.tmp24
    tmp3 += ints.tmp32 * 0.25
    del ints.tmp32
    tmp3 += ints.tmp21 * -0.25
    del ints.tmp21
    tmp3 += np.transpose(v.ovvv, (0, 2, 3, 1)) * -0.5
    tmp9 = np.copy(ints.tmp12)
    del ints.tmp12
    tmp9 += ints.tmp19 * 0.5
    del ints.tmp19
    tmp9 += ints.tmp22 * 0.5
    del ints.tmp22
    tmp9 += ints.tmp2
    del ints.tmp2
    tmp9 += ints.tmp30 * 0.5
    del ints.tmp30
    tmp9 += ints.tmp33 * 0.5
    del ints.tmp33
    tmp9 += ints.tmp39
    del ints.tmp39
    tmp9 += ints.tmp43
    del ints.tmp43
    tmp9 += ints.tmp45
    del ints.tmp45
    tmp9 += ints.tmp7
    del ints.tmp7
    tmp9 += f.ov * -1
    tmp9 += ints.tmp27 * -1
    del ints.tmp27
    tmp9 += ints.tmp3 * -1
    del ints.tmp3
    tmp9 += ints.tmp4 * -1
    del ints.tmp4
    tmp11 = np.copy(ints.tmp10)
    tmp11 += np.transpose(v.ovov, (0, 2, 3, 1)) * -1
    tmp12 = np.copy(tmp0) * 2
    tmp12 += tmp2
    tmp13 = np.copy(ints.tmp17) * 0.5
    del ints.tmp17
    tmp13 += ints.tmp9
    del ints.tmp9
    tmp13 += f.vv * -1
    tmp4 = np.copy(ints.tmp11) * 0.5
    del ints.tmp11
    tmp4 += np.transpose(ints.tmp13, (0, 2, 1, 3))
    del ints.tmp13
    tmp4 += np.transpose(ints.tmp20, (0, 2, 1, 3))
    del ints.tmp20
    tmp4 += ints.tmp35 * 0.25
    del ints.tmp35
    tmp4 += ints.tmp47 * 0.5
    del ints.tmp47
    tmp4 += np.transpose(ints.tmp5, (1, 2, 0, 3)) * 0.5
    del ints.tmp5
    tmp4 += ints.tmp23 * -0.25
    del ints.tmp23
    tmp4 += ints.tmp28 * -0.5
    del ints.tmp28
    tmp4 += ints.tmp31 * -1
    del ints.tmp31
    tmp4 += np.transpose(ints.tmp41, (0, 2, 1, 3)) * -1
    del ints.tmp41
    tmp4 += ints.tmp44 * -0.5
    del ints.tmp44
    tmp4 += v.ooov * -0.5
    tmp16 = np.copy(f.ov)
    tmp16 += ints.tmp26
    del ints.tmp26
    tmp14 = np.copy(f.oo)
    tmp14 += np.transpose(ints.tmp0, (1, 0))
    del ints.tmp0
    tmp14 += ints.tmp16 * 0.5
    del ints.tmp16
    tmp14 += ints.tmp38
    del ints.tmp38
    tmp14 += np.transpose(ints.tmp8, (1, 0))
    del ints.tmp8
    tmp5 = np.copy(ints.tmp10)
    del ints.tmp10
    tmp5 += ints.tmp36
    del ints.tmp36
    tmp5 += np.transpose(v.ovov, (0, 2, 3, 1)) * -1
    tmp7 = einsum(tmp6, (0, 1, 2, 3), t1, (4, 3), (0, 1, 4, 2))
    tmp15 = np.copy(tmp0)
    tmp15 += tmp2 * 0.5
    tmp10 = einsum(t2, (0, 1, 2, 3), r1, (1, 3), (0, 2))
    tmp10 += einsum(tmp6, (0, 1, 2, 3), t2, (1, 0, 4, 3), (2, 4)) * -0.5
    tmp8 = np.copy(ints.tmp29)
    tmp8 += np.transpose(v.ovoo, (0, 2, 3, 1)) * -1
    r2new = einsum(v.vvvv, (0, 1, 2, 3), r2, (4, 5, 2, 3), (4, 5, 0, 1)) * 0.5
    r2new += einsum(v.oovv, (0, 1, 2, 3), tmp17, (4, 5, 1, 0), (5, 4, 2, 3)) * 0.25
    del tmp17
    r2new += tmp20
    r2new += np.transpose(tmp20, (0, 1, 3, 2)) * -1
    r2new += np.transpose(tmp20, (1, 0, 2, 3)) * -1
    r2new += np.transpose(tmp20, (1, 0, 3, 2))
    del tmp20
    r2new += tmp23
    r2new += np.transpose(tmp23, (0, 1, 3, 2)) * -1
    del tmp23
    r2new += np.transpose(tmp24, (0, 1, 3, 2))
    r2new += np.transpose(tmp24, (1, 0, 3, 2)) * -1
    del tmp24
    r2new += tmp27 * -1
    r2new += np.transpose(tmp27, (0, 1, 3, 2))
    del tmp27
    r2new += np.transpose(tmp28, (1, 0, 2, 3)) * -0.5
    r2new += np.transpose(tmp28, (1, 0, 3, 2)) * 0.5
    del tmp28
    r2new += tmp32
    r2new += np.transpose(tmp32, (1, 0, 2, 3)) * -1
    del tmp32
    r2new += einsum(r2, (0, 1, 2, 3), tmp33, (0, 1, 4, 5), (4, 5, 2, 3)) * -0.5
    del tmp33
    r1new = einsum(tmp0, (0, 1), ints.tmp29, (0, 2, 1, 3), (2, 3)) * -1
    del tmp0
    r1new += einsum(tmp1, (0, 1), v.ovvv, (2, 0, 3, 1), (2, 3)) * 0.5
    del tmp1
    r1new += einsum(tmp2, (0, 1), ints.tmp29, (0, 2, 1, 3), (2, 3)) * -0.5
    del tmp2, ints.tmp29
    r1new += einsum(tmp3, (0, 1, 2, 3), r2, (4, 0, 1, 2), (4, 3))
    del tmp3
    r1new += einsum(tmp4, (0, 1, 2, 3), r2, (0, 1, 4, 3), (2, 4))
    del tmp4
    r1new += einsum(tmp6, (0, 1, 2, 3), tmp5, (0, 2, 3, 4), (1, 4)) * -1
    del tmp6, tmp5
    r1new += einsum(tmp8, (0, 1, 2, 3), tmp7, (4, 0, 2, 1), (4, 3)) * -0.5
    del tmp8, tmp7
    r1new += einsum(r2, (0, 1, 2, 3), tmp9, (1, 3), (0, 2)) * -1
    del tmp9
    r1new += einsum(tmp10, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3))
    del tmp10
    r1new += einsum(tmp11, (0, 1, 2, 3), r1, (0, 2), (1, 3))
    del tmp11
    r1new += einsum(v.ooov, (0, 1, 2, 3), tmp12, (2, 1), (0, 3)) * 0.5
    del tmp12
    r1new += einsum(r1, (0, 1), tmp13, (1, 2), (0, 2)) * -1
    del tmp13
    r1new += einsum(tmp14, (0, 1), r1, (0, 2), (1, 2)) * -1
    del tmp14
    r1new += einsum(tmp15, (0, 1), tmp16, (1, 2), (0, 2)) * -1
    del tmp15, tmp16

    return {f"r1new": r1new, f"r2new": r2new}

