"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T17:18:28.820515
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace
from ebcc.backend import _inflate


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:18:29.071491.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = np.copy(t2)
    tmp0 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    e_cc = einsum(f.ov, (0, 1), t1, (0, 1), ())
    e_cc += einsum(tmp0, (0, 1, 2, 3), v.oovv, (0, 1, 2, 3), ()) * 0.25
    del tmp0

    return e_cc

def update_amps(f=None, t1=None, t2=None, t3=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:19:16.670741.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    t3 : array
        T3 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    t1new : array
        Updated T1 residuals.
    t2new : array
        Updated T2 residuals.
    t3new : array
        Updated T3 residuals.
    """

    space = kwargs["space"]
    t1new = Namespace()
    t2new = Namespace()
    t3new = Namespace()
    so = np.ones((t1.shape[0],), dtype=bool)
    sv = np.ones((t1.shape[1],), dtype=bool)
    sO = space.active[space.correlated][space.occupied[space.correlated]]
    sV = space.active[space.correlated][space.virtual[space.correlated]]
    t2_OOvv = np.copy(t2[np.ix_(sO, sO, sv, sv)])
    t2_OoVv = np.copy(t2[np.ix_(sO, so, sV, sv)])
    t1_ov = np.copy(t1[np.ix_(so, sv)])
    t1_Ov = np.copy(t1[np.ix_(sO, sv)])
    t2_oovv = np.copy(t2[np.ix_(so, so, sv, sv)])
    t2_OoVV = np.copy(t2[np.ix_(sO, so, sV, sV)])
    t2_ooVv = np.copy(t2[np.ix_(so, so, sV, sv)])
    t2_Oovv = np.copy(t2[np.ix_(sO, so, sv, sv)])
    t1_oV = np.copy(t1[np.ix_(so, sV)])
    t2_OOVv = np.copy(t2[np.ix_(sO, sO, sV, sv)])
    t2_ooVV = np.copy(t2[np.ix_(so, so, sV, sV)])

    tmp110 = einsum(t1_Ov, (0, 1), v.oovv, (2, 3, 4, 1), (2, 3, 4, 0))
    tmp140 = einsum(v.OoVv, (0, 1, 2, 3), t1_Ov, (4, 3), (1, 4, 0, 2))
    tmp115 = einsum(t1_oV, (0, 1), v.oovv, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp137 = einsum(t1_Ov, (0, 1), v.OOvv, (2, 3, 4, 1), (4, 0, 2, 3))
    tmp123 = einsum(t1_oV, (0, 1), v.Ovoo, (2, 3, 4, 0), (4, 3, 2, 1)) * -1
    tmp126 = einsum(v.Vovv, (0, 1, 2, 3), t1_Ov, (4, 3), (1, 2, 4, 0)) * -1
    tmp146 = einsum(t1_Ov, (0, 1), tmp110, (2, 3, 1, 4), (3, 2, 4, 0))
    tmp1 = einsum(t1, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3))
    tmp143 = einsum(v.VVoo, (0, 1, 2, 3), t1_oV, (3, 4), (2, 4, 0, 1))
    tmp120 = einsum(v.Ovoo, (0, 1, 2, 3), t1_Ov, (4, 1), (2, 3, 4, 0)) * -1
    tmp131 = einsum(v.Oovv, (0, 1, 2, 3), t1, (1, 3), (2, 0)) * -1
    tmp149 = einsum(t1_oV, (0, 1), tmp110, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp134 = einsum(t1, (0, 1), v.Vvoo, (2, 1, 3, 0), (3, 2)) * -1
    tmp2 = einsum(v.oovv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp18 = einsum(v.ooov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp23 = einsum(v.ovvv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp104 = einsum(v.Vovv, (0, 1, 2, 3), t2_OOvv, (4, 5, 2, 3), (1, 4, 5, 0)) * -1
    tmp87 = einsum(v.Oovv, (0, 1, 2, 3), t2_Oovv, (4, 1, 2, 3), (4, 0))
    tmp100 = einsum(t2_OoVv, (0, 1, 2, 3), v.Ovoo, (4, 3, 5, 1), (5, 0, 4, 2)) * -1
    tmp106 = einsum(v.Vovv, (0, 1, 2, 3), t2_OoVv, (4, 1, 5, 3), (2, 4, 5, 0)) * -1
    tmp141 = einsum(tmp140, (0, 1, 2, 3), t1_oV, (0, 4), (1, 2, 4, 3))
    del tmp140
    tmp118 = einsum(tmp115, (0, 1, 2, 3), t2_OoVv, (4, 0, 5, 1), (2, 4, 3, 5))
    tmp138 = einsum(t1_Ov, (0, 1), tmp137, (1, 2, 3, 4), (2, 0, 4, 3))
    del tmp137
    tmp102 = einsum(t2_ooVV, (0, 1, 2, 3), v.Ovoo, (4, 5, 0, 1), (5, 4, 2, 3)) * -1
    tmp56 = einsum(f.Ov, (0, 1), t1_Ov, (2, 1), (0, 2))
    tmp97 = einsum(t2_ooVV, (0, 1, 2, 3), v.VVoo, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp124 = einsum(tmp123, (0, 1, 2, 3), t1_oV, (0, 4), (1, 2, 3, 4)) * -1
    del tmp123
    tmp129 = einsum(tmp126, (0, 1, 2, 3), t1_oV, (0, 4), (1, 2, 4, 3))
    tmp147 = einsum(t1_oV, (0, 1), tmp146, (0, 2, 3, 4), (2, 3, 4, 1)) * -1
    del tmp146
    tmp108 = einsum(t2_OOVv, (0, 1, 2, 3), tmp1, (4, 3), (4, 0, 1, 2))
    tmp116 = einsum(tmp115, (0, 1, 2, 3), t2_OOvv, (4, 5, 2, 1), (0, 4, 5, 3)) * -1
    del tmp115
    tmp85 = einsum(v.VoVV, (0, 1, 2, 3), t1_oV, (1, 4), (4, 0, 2, 3)) * -1
    tmp111 = einsum(t2_OoVv, (0, 1, 2, 3), tmp110, (1, 4, 3, 5), (4, 5, 0, 2))
    tmp91 = einsum(t2_ooVv, (0, 1, 2, 3), v.Vvoo, (4, 3, 0, 1), (2, 4))
    tmp144 = einsum(t1_oV, (0, 1), tmp143, (0, 2, 3, 4), (2, 1, 4, 3))
    del tmp143
    tmp113 = einsum(t2_ooVV, (0, 1, 2, 3), tmp110, (1, 0, 4, 5), (4, 5, 2, 3)) * -1
    del tmp110
    tmp93 = einsum(v.OoVv, (0, 1, 2, 3), t2_OoVv, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp121 = einsum(t1_oV, (0, 1), tmp120, (2, 0, 3, 4), (2, 3, 4, 1))
    del tmp120
    tmp69 = einsum(v.OvVo, (0, 1, 2, 3), t1_Ov, (4, 1), (3, 4, 0, 2))
    tmp132 = einsum(tmp131, (0, 1), t1_Ov, (2, 0), (2, 1)) * -1
    del tmp131
    tmp150 = einsum(tmp149, (0, 1, 2, 3), t1_oV, (0, 4), (1, 2, 3, 4)) * -1
    del tmp149
    tmp71 = einsum(v.OvVo, (0, 1, 2, 3), t1_oV, (3, 4), (1, 0, 4, 2))
    tmp127 = einsum(t1_Ov, (0, 1), tmp126, (2, 1, 3, 4), (2, 3, 0, 4)) * -1
    del tmp126
    tmp75 = einsum(v.OoOv, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp60 = einsum(f.ov, (0, 1), t2_OOVv, (2, 3, 4, 1), (0, 2, 3, 4)) * -1
    tmp30 = einsum(t3, (0, 1, 2, 3, 4, 5), v.OoVV, (2, 6, 4, 5), (6, 0, 1, 3)) * -1
    tmp79 = einsum(v.OoOV, (0, 1, 2, 3), t1_oV, (1, 4), (0, 2, 4, 3)) * -1
    tmp73 = einsum(v.VVvv, (0, 1, 2, 3), t1_Ov, (4, 3), (2, 4, 0, 1))
    tmp77 = einsum(v.OvOO, (0, 1, 2, 3), t1_Ov, (4, 1), (4, 0, 2, 3)) * -1
    tmp81 = einsum(v.VoVv, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp89 = einsum(v.OOvv, (0, 1, 2, 3), t2_OOvv, (4, 5, 2, 3), (4, 5, 0, 1))
    tmp83 = einsum(v.OVVv, (0, 1, 2, 3), t1_Ov, (4, 3), (4, 0, 2, 1)) * -1
    tmp67 = einsum(t1_oV, (0, 1), v.OOoo, (2, 3, 4, 0), (4, 2, 3, 1))
    tmp95 = einsum(t2_OOVv, (0, 1, 2, 3), v.OOVv, (4, 5, 6, 3), (0, 1, 4, 5, 2, 6))
    tmp58 = einsum(t1_oV, (0, 1), f.Vo, (2, 0), (2, 1))
    tmp135 = einsum(tmp134, (0, 1), t1_oV, (0, 2), (2, 1)) * -1
    del tmp134
    tmp28 = einsum(v.OOVv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2)) * -1
    tmp43 = einsum(t2, (0, 1, 2, 3), tmp1, (4, 3), (0, 1, 4, 2)) * -1
    tmp0 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp4 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp37 = einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 2, 3), (0, 1, 4, 5))
    tmp3 = einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 2, 3), (0, 4))
    tmp40 = einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp46 = einsum(tmp2, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp20 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp25 = einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), (0, 1, 4, 5))
    tmp33 = einsum(v.ovov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 2, 1))
    tmp5 = einsum(v.ovvv, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    tmp10 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp6 = einsum(tmp1, (0, 1), t1, (2, 1), (2, 0))
    tmp45 = einsum(tmp2, (0, 1, 2, 3), t1, (4, 3), (0, 4, 2, 1))
    tmp49 = einsum(tmp18, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4)) * -1
    tmp51 = einsum(t1, (0, 1), tmp23, (2, 3, 4, 1), (2, 0, 3, 4)) * -1
    tmp38 = einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 4, 3), (2, 4))
    tmp105 = einsum(t2_OoVV, (0, 1, 2, 3), tmp104, (1, 4, 5, 6), (4, 5, 0, 2, 3, 6)) * -1
    del tmp104
    tmp88 = einsum(tmp87, (0, 1), t3, (2, 3, 1, 4, 5, 6), (0, 2, 3, 4, 5, 6))
    del tmp87
    tmp101 = einsum(tmp100, (0, 1, 2, 3), t2_OoVV, (4, 0, 5, 6), (4, 1, 2, 5, 6, 3)) * -1
    del tmp100
    tmp107 = einsum(t2_OOVv, (0, 1, 2, 3), tmp106, (3, 4, 5, 6), (0, 1, 4, 2, 5, 6)) * -1
    del tmp106
    tmp142 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp141, (6, 2, 7, 5), (6, 0, 1, 7, 3, 4))
    del tmp141
    tmp119 = einsum(t2_OOVv, (0, 1, 2, 3), tmp118, (3, 4, 5, 6), (0, 1, 4, 5, 2, 6)) * -1
    del tmp118
    tmp139 = einsum(tmp138, (0, 1, 2, 3), t3, (4, 2, 3, 5, 6, 7), (1, 0, 4, 5, 6, 7)) * -1
    del tmp138
    tmp103 = einsum(tmp102, (0, 1, 2, 3), t2_OOVv, (4, 5, 6, 0), (4, 5, 1, 2, 3, 6)) * -1
    del tmp102
    tmp57 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp56, (2, 6), (6, 0, 1, 3, 4, 5))
    del tmp56
    tmp98 = einsum(tmp97, (0, 1, 2, 3), t3, (4, 5, 6, 7, 3, 2), (4, 5, 6, 1, 0, 7))
    del tmp97
    tmp125 = einsum(tmp124, (0, 1, 2, 3), t2_OOVv, (4, 5, 6, 0), (4, 5, 1, 2, 3, 6)) * -1
    del tmp124
    tmp130 = einsum(t2_OOVv, (0, 1, 2, 3), tmp129, (3, 4, 5, 6), (4, 0, 1, 5, 2, 6))
    del tmp129
    tmp148 = einsum(t2_OoVV, (0, 1, 2, 3), tmp147, (1, 4, 5, 6), (5, 4, 0, 6, 2, 3)) * -1
    del tmp147
    tmp109 = einsum(t2_OoVV, (0, 1, 2, 3), tmp108, (1, 4, 5, 6), (4, 5, 0, 6, 2, 3))
    del tmp108
    tmp66 = einsum(v.VVVV, (0, 1, 2, 3), t3, (4, 5, 6, 7, 2, 3), (4, 5, 6, 7, 0, 1))
    tmp55 = einsum(f.VV, (0, 1), t3, (2, 3, 4, 5, 6, 1), (2, 3, 4, 0, 5, 6))
    tmp117 = einsum(t2_OoVV, (0, 1, 2, 3), tmp116, (1, 4, 5, 6), (4, 5, 0, 6, 2, 3))
    del tmp116
    tmp54 = einsum(f.OO, (0, 1), t3, (2, 3, 1, 4, 5, 6), (0, 2, 3, 4, 5, 6))
    tmp86 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp85, (6, 7, 5, 4), (0, 1, 2, 6, 3, 7)) * -1
    del tmp85
    tmp65 = einsum(v.OVOV, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 1), (4, 5, 0, 6, 7, 3))
    tmp112 = einsum(tmp111, (0, 1, 2, 3), t2_OoVV, (4, 0, 5, 6), (1, 4, 2, 5, 6, 3)) * -1
    del tmp111
    tmp92 = einsum(tmp91, (0, 1), t3, (2, 3, 4, 5, 6, 1), (2, 3, 4, 0, 5, 6))
    del tmp91
    tmp145 = einsum(tmp144, (0, 1, 2, 3), t3, (4, 5, 6, 7, 2, 3), (4, 5, 6, 0, 1, 7))
    del tmp144
    tmp114 = einsum(t2_OOVv, (0, 1, 2, 3), tmp113, (3, 4, 5, 6), (4, 0, 1, 5, 6, 2))
    del tmp113
    tmp94 = einsum(tmp93, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 3), (0, 4, 5, 2, 6, 7))
    del tmp93
    tmp122 = einsum(tmp121, (0, 1, 2, 3), t2_OoVV, (4, 0, 5, 6), (1, 4, 2, 3, 5, 6))
    del tmp121
    tmp70 = einsum(tmp69, (0, 1, 2, 3), t2_OoVV, (4, 0, 5, 6), (1, 4, 2, 5, 6, 3)) * -1
    del tmp69
    tmp133 = einsum(tmp132, (0, 1), t3, (2, 3, 1, 4, 5, 6), (0, 2, 3, 4, 5, 6))
    del tmp132
    tmp151 = einsum(tmp150, (0, 1, 2, 3), t2_OOVv, (4, 5, 6, 0), (1, 4, 5, 2, 3, 6))
    del tmp150
    tmp63 = einsum(t2_OOVv, (0, 1, 2, 3), v.OvVV, (4, 3, 5, 6), (0, 1, 4, 2, 5, 6))
    tmp72 = einsum(t2_OOVv, (0, 1, 2, 3), tmp71, (3, 4, 5, 6), (0, 1, 4, 5, 2, 6)) * -1
    del tmp71
    tmp128 = einsum(t2_OoVV, (0, 1, 2, 3), tmp127, (1, 4, 5, 6), (4, 5, 0, 2, 3, 6)) * -1
    del tmp127
    tmp76 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp75, (2, 6), (0, 1, 6, 3, 4, 5))
    del tmp75
    tmp61 = einsum(tmp60, (0, 1, 2, 3), t2_OoVV, (4, 0, 5, 6), (1, 2, 4, 3, 5, 6)) * -1
    del tmp60
    tmp64 = einsum(t3, (0, 1, 2, 3, 4, 5), v.OOOO, (6, 7, 1, 2), (0, 6, 7, 3, 4, 5))
    tmp99 = einsum(tmp30, (0, 1, 2, 3), t2_OoVV, (4, 0, 5, 6), (4, 2, 1, 5, 6, 3))
    tmp80 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp79, (2, 6, 7, 5), (0, 1, 6, 7, 3, 4))
    del tmp79
    tmp74 = einsum(t2_OOVv, (0, 1, 2, 3), tmp73, (3, 4, 5, 6), (4, 0, 1, 2, 5, 6))
    del tmp73
    tmp78 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp77, (6, 7, 2, 1), (6, 0, 7, 3, 4, 5)) * -1
    del tmp77
    tmp62 = einsum(v.OOVo, (0, 1, 2, 3), t2_OoVV, (4, 3, 5, 6), (4, 0, 1, 5, 6, 2))
    tmp82 = einsum(tmp81, (0, 1), t3, (2, 3, 4, 5, 6, 1), (2, 3, 4, 5, 6, 0))
    del tmp81
    tmp90 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp89, (6, 7, 2, 1), (7, 6, 0, 3, 4, 5))
    del tmp89
    tmp84 = einsum(tmp83, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 2), (0, 4, 5, 6, 7, 3))
    del tmp83
    tmp68 = einsum(tmp67, (0, 1, 2, 3), t2_OoVV, (4, 0, 5, 6), (4, 1, 2, 3, 5, 6))
    del tmp67
    tmp96 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp95, (6, 7, 1, 2, 8, 5), (6, 7, 0, 8, 3, 4))
    del tmp95
    tmp59 = einsum(tmp58, (0, 1), t3, (2, 3, 4, 5, 6, 0), (2, 3, 4, 1, 5, 6))
    del tmp58
    tmp136 = einsum(tmp135, (0, 1), t3, (2, 3, 4, 5, 6, 1), (2, 3, 4, 0, 5, 6))
    del tmp135
    tmp16 = einsum(t3, (0, 1, 2, 3, 4, 5), v.OvVV, (2, 6, 4, 5), (6, 0, 1, 3)) * -1
    tmp31 = einsum(tmp30, (0, 1, 2, 3), t1, (0, 4), (4, 1, 2, 3))
    del tmp30
    tmp29 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp28, (6, 2, 1, 5), (6, 0, 3, 4)) * -1
    del tmp28
    tmp15 = einsum(v.OOVo, (0, 1, 2, 3), t3, (4, 0, 1, 5, 6, 2), (3, 4, 5, 6)) * -1
    tmp27 = einsum(v.OoVv, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp44 = einsum(tmp43, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp43
    tmp9 = einsum(tmp0, (0, 1), t2, (2, 0, 3, 4), (1, 2, 3, 4))
    tmp8 = einsum(f.vv, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp14 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp17 = einsum(t2, (0, 1, 2, 3), tmp4, (1, 4), (0, 4, 2, 3)) * -1
    tmp48 = einsum(tmp37, (0, 1, 2, 3), t1, (2, 4), (0, 1, 3, 4)) * -1
    tmp36 = einsum(tmp3, (0, 1), t2, (2, 1, 3, 4), (2, 0, 3, 4))
    tmp12 = einsum(v.ooov, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    tmp41 = einsum(tmp40, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp40
    tmp47 = einsum(tmp46, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp46
    tmp21 = einsum(t1, (0, 1), tmp20, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp20
    tmp26 = einsum(tmp25, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp25
    tmp19 = einsum(tmp18, (0, 1, 2, 3), t2, (2, 1, 4, 5), (0, 3, 4, 5)) * -1
    del tmp18
    tmp34 = einsum(t1, (0, 1), tmp33, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp33
    tmp22 = einsum(tmp5, (0, 1), t2, (2, 3, 4, 1), (2, 3, 4, 0)) * -1
    tmp24 = einsum(t2, (0, 1, 2, 3), tmp23, (4, 1, 5, 3), (4, 0, 2, 5)) * -1
    del tmp23
    tmp11 = einsum(tmp10, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3))
    del tmp10
    tmp7 = einsum(f.oo, (0, 1), t2, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp13 = einsum(v.ovvv, (0, 1, 2, 3), t1, (4, 1), (4, 0, 2, 3))
    tmp42 = einsum(tmp6, (0, 1), t2, (2, 1, 3, 4), (0, 2, 3, 4)) * -1
    tmp53 = einsum(tmp45, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    tmp50 = einsum(t1, (0, 1), tmp49, (2, 0, 3, 4), (2, 3, 4, 1)) * -1
    del tmp49
    tmp35 = einsum(t1, (0, 1), v.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp52 = einsum(t1, (0, 1), tmp51, (2, 3, 0, 4), (3, 2, 1, 4)) * -1
    del tmp51
    tmp32 = einsum(v.oooo, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    tmp39 = einsum(tmp38, (0, 1), t2, (2, 3, 4, 1), (2, 3, 4, 0))
    del tmp38
    t3new = np.copy(np.transpose(tmp54, (1, 2, 0, 4, 5, 3))) * -1
    t3new += np.transpose(tmp54, (1, 0, 2, 4, 5, 3))
    t3new += np.transpose(tmp54, (0, 2, 1, 4, 5, 3))
    del tmp54
    t3new += np.transpose(tmp55, (0, 1, 2, 3, 5, 4)) * -1
    t3new += np.transpose(tmp55, (0, 1, 2, 5, 3, 4))
    t3new += np.transpose(tmp55, (0, 1, 2, 5, 4, 3)) * -1
    del tmp55
    t3new += np.transpose(tmp57, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp57, (1, 0, 2, 4, 5, 3))
    t3new += np.transpose(tmp57, (0, 2, 1, 4, 5, 3))
    del tmp57
    t3new += np.transpose(tmp59, (0, 1, 2, 3, 5, 4))
    t3new += np.transpose(tmp59, (0, 1, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp59, (0, 1, 2, 5, 4, 3))
    del tmp59
    t3new += np.transpose(tmp61, (2, 1, 0, 3, 5, 4))
    t3new += np.transpose(tmp61, (0, 2, 1, 3, 5, 4))
    t3new += np.transpose(tmp61, (2, 1, 0, 5, 3, 4)) * -1
    t3new += np.transpose(tmp61, (0, 2, 1, 5, 3, 4)) * -1
    t3new += np.transpose(tmp61, (0, 1, 2, 3, 5, 4)) * -1
    t3new += np.transpose(tmp61, (0, 1, 2, 5, 3, 4))
    t3new += np.transpose(tmp61, (2, 1, 0, 5, 4, 3))
    t3new += np.transpose(tmp61, (0, 2, 1, 5, 4, 3))
    t3new += np.transpose(tmp61, (0, 1, 2, 5, 4, 3)) * -1
    del tmp61
    t3new += np.transpose(tmp62, (0, 2, 1, 5, 4, 3))
    t3new += np.transpose(tmp62, (1, 0, 2, 5, 4, 3))
    t3new += np.transpose(tmp62, (0, 2, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp62, (1, 0, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp62, (1, 2, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp62, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp62, (0, 2, 1, 4, 3, 5))
    t3new += np.transpose(tmp62, (1, 0, 2, 4, 3, 5))
    t3new += np.transpose(tmp62, (1, 2, 0, 4, 3, 5)) * -1
    del tmp62
    t3new += np.transpose(tmp63, (0, 1, 2, 5, 4, 3))
    t3new += np.transpose(tmp63, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp63, (0, 1, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp63, (0, 2, 1, 5, 3, 4))
    t3new += np.transpose(tmp63, (2, 1, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp63, (2, 1, 0, 5, 3, 4))
    t3new += np.transpose(tmp63, (0, 1, 2, 3, 5, 4))
    t3new += np.transpose(tmp63, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp63, (2, 1, 0, 3, 5, 4)) * -1
    del tmp63
    t3new += np.transpose(tmp64, (0, 2, 1, 4, 5, 3)) * -0.5
    t3new += np.transpose(tmp64, (1, 0, 2, 4, 5, 3)) * -0.5
    t3new += np.transpose(tmp64, (1, 2, 0, 4, 5, 3)) * 0.5
    del tmp64
    t3new += np.transpose(tmp65, (0, 1, 2, 5, 4, 3))
    t3new += np.transpose(tmp65, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp65, (0, 1, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp65, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp65, (2, 1, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp65, (2, 1, 0, 4, 5, 3))
    t3new += np.transpose(tmp65, (0, 1, 2, 4, 3, 5))
    t3new += np.transpose(tmp65, (0, 2, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp65, (2, 1, 0, 4, 3, 5)) * -1
    del tmp65
    t3new += np.transpose(tmp66, (0, 1, 2, 5, 4, 3)) * -0.5
    t3new += np.transpose(tmp66, (0, 1, 2, 5, 3, 4)) * 0.5
    t3new += np.transpose(tmp66, (0, 1, 2, 3, 5, 4)) * -0.5
    del tmp66
    t3new += np.transpose(tmp68, (0, 2, 1, 3, 5, 4))
    t3new += np.transpose(tmp68, (1, 0, 2, 3, 5, 4))
    t3new += np.transpose(tmp68, (0, 2, 1, 5, 3, 4)) * -1
    t3new += np.transpose(tmp68, (1, 0, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp68, (0, 2, 1, 5, 4, 3))
    t3new += np.transpose(tmp68, (1, 0, 2, 5, 4, 3))
    t3new += np.transpose(tmp68, (1, 2, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp68, (1, 2, 0, 5, 3, 4))
    t3new += np.transpose(tmp68, (1, 2, 0, 5, 4, 3)) * -1
    del tmp68
    t3new += np.transpose(tmp70, (1, 0, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp70, (0, 1, 2, 5, 4, 3))
    t3new += np.transpose(tmp70, (1, 0, 2, 4, 5, 3))
    t3new += np.transpose(tmp70, (0, 1, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp72, (0, 1, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp72, (0, 2, 1, 5, 3, 4))
    t3new += np.transpose(tmp72, (0, 1, 2, 5, 4, 3))
    t3new += np.transpose(tmp72, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp70, (1, 2, 0, 5, 4, 3))
    t3new += np.transpose(tmp70, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp70, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp70, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp70, (2, 1, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp70, (2, 0, 1, 5, 4, 3))
    t3new += np.transpose(tmp70, (2, 1, 0, 4, 5, 3))
    t3new += np.transpose(tmp70, (2, 0, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp72, (2, 1, 0, 5, 3, 4))
    t3new += np.transpose(tmp72, (2, 1, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp72, (0, 1, 2, 3, 5, 4))
    t3new += np.transpose(tmp72, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp72, (0, 1, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp72, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp72, (2, 1, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp72, (2, 1, 0, 4, 5, 3))
    t3new += np.transpose(tmp70, (1, 0, 2, 4, 3, 5)) * -1
    t3new += np.transpose(tmp70, (0, 1, 2, 4, 3, 5))
    t3new += tmp72 * -1
    t3new += np.transpose(tmp72, (0, 2, 1, 3, 4, 5))
    t3new += np.transpose(tmp72, (0, 1, 2, 4, 3, 5))
    t3new += np.transpose(tmp72, (0, 2, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp70, (1, 2, 0, 4, 3, 5))
    t3new += np.transpose(tmp70, (0, 2, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp70, (2, 1, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp70, (2, 0, 1, 4, 3, 5))
    del tmp70
    t3new += np.transpose(tmp72, (2, 1, 0, 3, 4, 5))
    t3new += np.transpose(tmp72, (2, 1, 0, 4, 3, 5)) * -1
    del tmp72
    t3new += np.transpose(tmp74, (1, 2, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp74, (1, 0, 2, 5, 4, 3))
    t3new += np.transpose(tmp74, (1, 2, 0, 5, 3, 4))
    t3new += np.transpose(tmp74, (1, 0, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp74, (0, 2, 1, 5, 4, 3))
    t3new += np.transpose(tmp74, (0, 2, 1, 5, 3, 4)) * -1
    t3new += np.transpose(tmp74, (1, 2, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp74, (1, 0, 2, 3, 5, 4))
    t3new += np.transpose(tmp74, (0, 2, 1, 3, 5, 4))
    del tmp74
    t3new += np.transpose(tmp76, (0, 1, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp76, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp78, (1, 0, 2, 4, 5, 3)) * 0.5
    t3new += np.transpose(tmp78, (0, 1, 2, 4, 5, 3)) * -0.5
    t3new += np.transpose(tmp80, (0, 1, 2, 3, 5, 4))
    t3new += np.transpose(tmp80, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp80, (0, 1, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp80, (0, 2, 1, 5, 3, 4))
    t3new += np.transpose(tmp80, (0, 1, 2, 5, 4, 3))
    t3new += np.transpose(tmp80, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp78, (1, 2, 0, 4, 5, 3)) * -0.5
    t3new += np.transpose(tmp78, (0, 2, 1, 4, 5, 3)) * 0.5
    t3new += np.transpose(tmp76, (2, 1, 0, 4, 5, 3))
    del tmp76
    t3new += np.transpose(tmp78, (2, 1, 0, 4, 5, 3)) * 0.5
    t3new += np.transpose(tmp78, (2, 0, 1, 4, 5, 3)) * -0.5
    del tmp78
    t3new += np.transpose(tmp80, (2, 1, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp80, (2, 1, 0, 5, 3, 4))
    t3new += np.transpose(tmp80, (2, 1, 0, 5, 4, 3)) * -1
    del tmp80
    t3new += np.transpose(tmp82, (0, 1, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp82, (0, 1, 2, 4, 5, 3))
    t3new += np.transpose(tmp84, (1, 2, 0, 5, 4, 3))
    t3new += np.transpose(tmp84, (1, 0, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp84, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp84, (1, 0, 2, 4, 5, 3))
    t3new += np.transpose(tmp84, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp84, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp86, (0, 1, 2, 5, 3, 4)) * 0.5
    t3new += np.transpose(tmp86, (0, 1, 2, 5, 4, 3)) * -0.5
    t3new += np.transpose(tmp86, (0, 1, 2, 3, 5, 4)) * -0.5
    t3new += np.transpose(tmp86, (0, 1, 2, 4, 5, 3)) * 0.5
    t3new += np.transpose(tmp82, (0, 1, 2, 4, 3, 5)) * -1
    del tmp82
    t3new += np.transpose(tmp84, (1, 2, 0, 4, 3, 5))
    t3new += np.transpose(tmp84, (1, 0, 2, 4, 3, 5)) * -1
    t3new += np.transpose(tmp84, (0, 2, 1, 4, 3, 5)) * -1
    del tmp84
    t3new += tmp86 * 0.5
    t3new += np.transpose(tmp86, (0, 1, 2, 4, 3, 5)) * -0.5
    del tmp86
    t3new += np.transpose(tmp88, (1, 2, 0, 3, 5, 4)) * 0.5
    t3new += np.transpose(tmp88, (2, 0, 1, 3, 5, 4)) * 0.5
    t3new += np.transpose(tmp88, (0, 2, 1, 3, 5, 4)) * -0.5
    del tmp88
    t3new += np.transpose(tmp90, (2, 1, 0, 3, 4, 5)) * -0.25
    t3new += np.transpose(tmp90, (1, 2, 0, 3, 4, 5)) * 0.25
    t3new += tmp90 * 0.25
    del tmp90
    t3new += np.transpose(tmp92, (2, 1, 0, 3, 4, 5)) * 0.5
    t3new += np.transpose(tmp92, (2, 1, 0, 4, 3, 5)) * -0.5
    t3new += np.transpose(tmp94, (1, 2, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp94, (2, 0, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp94, (1, 2, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp94, (2, 0, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp94, (0, 2, 1, 3, 5, 4))
    t3new += np.transpose(tmp94, (0, 2, 1, 4, 3, 5))
    t3new += np.transpose(tmp96, (2, 1, 0, 3, 5, 4)) * -0.5
    t3new += np.transpose(tmp96, (1, 2, 0, 3, 5, 4)) * 0.5
    t3new += np.transpose(tmp96, (2, 1, 0, 5, 3, 4)) * 0.5
    t3new += np.transpose(tmp96, (1, 2, 0, 5, 3, 4)) * -0.5
    t3new += np.transpose(tmp96, (0, 1, 2, 3, 5, 4)) * 0.5
    t3new += np.transpose(tmp96, (0, 1, 2, 5, 3, 4)) * -0.5
    t3new += np.transpose(tmp92, (2, 1, 0, 4, 5, 3)) * 0.5
    del tmp92
    t3new += np.transpose(tmp94, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp94, (2, 0, 1, 4, 5, 3))
    t3new += np.transpose(tmp94, (0, 2, 1, 4, 5, 3)) * -1
    del tmp94
    t3new += np.transpose(tmp96, (2, 1, 0, 5, 4, 3)) * -0.5
    t3new += np.transpose(tmp96, (1, 2, 0, 5, 4, 3)) * 0.5
    t3new += np.transpose(tmp96, (0, 1, 2, 5, 4, 3)) * 0.5
    del tmp96
    t3new += np.transpose(tmp98, (2, 1, 0, 3, 4, 5)) * -0.25
    t3new += np.transpose(tmp98, (2, 1, 0, 3, 5, 4)) * 0.25
    t3new += np.transpose(tmp99, (1, 2, 0, 4, 3, 5)) * 0.5
    t3new += np.transpose(tmp99, (2, 0, 1, 4, 3, 5)) * 0.5
    t3new += np.transpose(tmp99, (1, 2, 0, 4, 5, 3)) * -0.5
    t3new += np.transpose(tmp99, (2, 0, 1, 4, 5, 3)) * -0.5
    t3new += np.transpose(tmp99, (0, 2, 1, 4, 3, 5)) * -0.5
    t3new += np.transpose(tmp99, (0, 2, 1, 4, 5, 3)) * 0.5
    t3new += np.transpose(tmp98, (2, 1, 0, 5, 4, 3)) * 0.25
    del tmp98
    t3new += np.transpose(tmp99, (1, 2, 0, 5, 4, 3)) * 0.5
    t3new += np.transpose(tmp99, (2, 0, 1, 5, 4, 3)) * 0.5
    t3new += np.transpose(tmp99, (0, 2, 1, 5, 4, 3)) * -0.5
    del tmp99
    t3new += np.transpose(tmp101, (0, 1, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp101, (1, 0, 2, 5, 4, 3))
    t3new += np.transpose(tmp101, (0, 1, 2, 4, 5, 3))
    t3new += np.transpose(tmp101, (1, 0, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp103, (0, 1, 2, 5, 4, 3)) * 0.5
    t3new += np.transpose(tmp103, (0, 2, 1, 5, 4, 3)) * -0.5
    t3new += np.transpose(tmp103, (0, 1, 2, 4, 5, 3)) * -0.5
    t3new += np.transpose(tmp103, (0, 2, 1, 4, 5, 3)) * 0.5
    t3new += np.transpose(tmp101, (0, 1, 2, 4, 3, 5)) * -1
    t3new += np.transpose(tmp101, (1, 0, 2, 4, 3, 5))
    t3new += np.transpose(tmp103, (0, 1, 2, 4, 3, 5)) * 0.5
    t3new += np.transpose(tmp103, (0, 2, 1, 4, 3, 5)) * -0.5
    t3new += np.transpose(tmp101, (0, 2, 1, 5, 4, 3))
    t3new += np.transpose(tmp101, (1, 2, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp101, (0, 2, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp101, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp101, (0, 2, 1, 4, 3, 5))
    t3new += np.transpose(tmp101, (1, 2, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp101, (2, 0, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp101, (2, 1, 0, 5, 4, 3))
    t3new += np.transpose(tmp101, (2, 0, 1, 4, 5, 3))
    t3new += np.transpose(tmp101, (2, 1, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp103, (2, 1, 0, 5, 4, 3)) * -0.5
    t3new += np.transpose(tmp103, (2, 1, 0, 4, 5, 3)) * 0.5
    t3new += np.transpose(tmp101, (2, 0, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp101, (2, 1, 0, 4, 3, 5))
    del tmp101
    t3new += np.transpose(tmp103, (2, 1, 0, 4, 3, 5)) * -0.5
    del tmp103
    t3new += np.transpose(tmp105, (2, 1, 0, 5, 4, 3)) * 0.5
    t3new += np.transpose(tmp105, (0, 2, 1, 5, 4, 3)) * 0.5
    t3new += np.transpose(tmp105, (2, 1, 0, 4, 5, 3)) * -0.5
    t3new += np.transpose(tmp105, (0, 2, 1, 4, 5, 3)) * -0.5
    t3new += np.transpose(tmp105, (0, 1, 2, 5, 4, 3)) * -0.5
    t3new += np.transpose(tmp105, (0, 1, 2, 4, 5, 3)) * 0.5
    t3new += np.transpose(tmp107, (0, 1, 2, 5, 4, 3))
    t3new += np.transpose(tmp107, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp107, (0, 1, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp107, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp107, (2, 1, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp107, (2, 1, 0, 4, 5, 3))
    t3new += np.transpose(tmp107, (2, 1, 0, 5, 3, 4))
    t3new += np.transpose(tmp107, (0, 2, 1, 5, 3, 4))
    t3new += np.transpose(tmp107, (2, 1, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp107, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp107, (0, 1, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp107, (0, 1, 2, 3, 5, 4))
    t3new += np.transpose(tmp105, (2, 1, 0, 4, 3, 5)) * 0.5
    t3new += np.transpose(tmp105, (0, 2, 1, 4, 3, 5)) * 0.5
    t3new += np.transpose(tmp105, (0, 1, 2, 4, 3, 5)) * -0.5
    del tmp105
    t3new += np.transpose(tmp107, (0, 1, 2, 4, 3, 5))
    t3new += np.transpose(tmp107, (0, 2, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp107, (2, 1, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp107, (2, 1, 0, 3, 4, 5))
    t3new += np.transpose(tmp107, (0, 2, 1, 3, 4, 5))
    t3new += tmp107 * -1
    del tmp107
    t3new += np.transpose(tmp109, (2, 1, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp109, (1, 2, 0, 3, 4, 5))
    t3new += np.transpose(tmp109, (2, 1, 0, 4, 3, 5))
    t3new += np.transpose(tmp109, (1, 2, 0, 4, 3, 5)) * -1
    t3new += tmp109
    t3new += np.transpose(tmp109, (0, 1, 2, 4, 3, 5)) * -1
    t3new += np.transpose(tmp109, (2, 1, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp109, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp109, (0, 1, 2, 4, 5, 3))
    del tmp109
    t3new += np.transpose(tmp112, (1, 2, 0, 5, 3, 4)) * -1
    t3new += np.transpose(tmp112, (2, 1, 0, 5, 3, 4))
    t3new += np.transpose(tmp112, (1, 2, 0, 3, 5, 4))
    t3new += np.transpose(tmp112, (2, 1, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp114, (1, 2, 0, 5, 3, 4)) * 0.5
    t3new += np.transpose(tmp114, (2, 0, 1, 5, 3, 4)) * 0.5
    t3new += np.transpose(tmp114, (1, 2, 0, 3, 5, 4)) * -0.5
    t3new += np.transpose(tmp114, (2, 0, 1, 3, 5, 4)) * -0.5
    t3new += np.transpose(tmp112, (1, 2, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp112, (2, 1, 0, 3, 4, 5))
    t3new += np.transpose(tmp114, (1, 2, 0, 3, 4, 5)) * 0.5
    t3new += np.transpose(tmp114, (2, 0, 1, 3, 4, 5)) * 0.5
    t3new += np.transpose(tmp112, (1, 0, 2, 5, 3, 4))
    t3new += np.transpose(tmp112, (2, 0, 1, 5, 3, 4)) * -1
    t3new += np.transpose(tmp112, (1, 0, 2, 3, 5, 4)) * -1
    t3new += np.transpose(tmp112, (2, 0, 1, 3, 5, 4))
    t3new += np.transpose(tmp112, (1, 0, 2, 3, 4, 5))
    t3new += np.transpose(tmp112, (2, 0, 1, 3, 4, 5)) * -1
    t3new += np.transpose(tmp112, (0, 1, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp112, (0, 2, 1, 5, 3, 4))
    t3new += np.transpose(tmp112, (0, 1, 2, 3, 5, 4))
    t3new += np.transpose(tmp112, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp114, (0, 2, 1, 5, 3, 4)) * -0.5
    t3new += np.transpose(tmp114, (0, 2, 1, 3, 5, 4)) * 0.5
    t3new += tmp112 * -1
    t3new += np.transpose(tmp112, (0, 2, 1, 3, 4, 5))
    del tmp112
    t3new += np.transpose(tmp114, (0, 2, 1, 3, 4, 5)) * -0.5
    del tmp114
    t3new += np.transpose(tmp117, (2, 1, 0, 3, 4, 5)) * -0.5
    t3new += np.transpose(tmp117, (1, 2, 0, 3, 4, 5)) * 0.5
    t3new += np.transpose(tmp117, (2, 1, 0, 4, 3, 5)) * 0.5
    t3new += np.transpose(tmp117, (1, 2, 0, 4, 3, 5)) * -0.5
    t3new += tmp117 * 0.5
    t3new += np.transpose(tmp117, (0, 1, 2, 4, 3, 5)) * -0.5
    t3new += np.transpose(tmp119, (0, 1, 2, 3, 5, 4))
    t3new += np.transpose(tmp119, (1, 2, 0, 3, 5, 4))
    t3new += np.transpose(tmp119, (0, 1, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp119, (1, 2, 0, 5, 3, 4)) * -1
    t3new += np.transpose(tmp119, (2, 1, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp119, (2, 1, 0, 5, 3, 4))
    t3new += np.transpose(tmp119, (2, 1, 0, 3, 4, 5))
    t3new += np.transpose(tmp119, (1, 2, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp119, (2, 1, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp119, (1, 2, 0, 4, 3, 5))
    t3new += tmp119 * -1
    t3new += np.transpose(tmp119, (0, 1, 2, 4, 3, 5))
    t3new += np.transpose(tmp117, (2, 1, 0, 4, 5, 3)) * -0.5
    t3new += np.transpose(tmp117, (1, 2, 0, 4, 5, 3)) * 0.5
    t3new += np.transpose(tmp117, (0, 1, 2, 4, 5, 3)) * 0.5
    del tmp117
    t3new += np.transpose(tmp119, (0, 1, 2, 5, 4, 3))
    t3new += np.transpose(tmp119, (1, 2, 0, 5, 4, 3))
    t3new += np.transpose(tmp119, (2, 1, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp119, (2, 1, 0, 4, 5, 3))
    t3new += np.transpose(tmp119, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp119, (0, 1, 2, 4, 5, 3)) * -1
    del tmp119
    t3new += np.transpose(tmp122, (1, 0, 2, 3, 5, 4)) * -1
    t3new += np.transpose(tmp122, (0, 1, 2, 3, 5, 4))
    t3new += np.transpose(tmp122, (1, 0, 2, 5, 3, 4))
    t3new += np.transpose(tmp122, (0, 1, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp122, (1, 0, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp122, (0, 1, 2, 5, 4, 3))
    t3new += np.transpose(tmp125, (0, 1, 2, 4, 3, 5))
    t3new += np.transpose(tmp125, (0, 2, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp125, (0, 1, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp125, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp125, (0, 1, 2, 5, 4, 3))
    t3new += np.transpose(tmp125, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp122, (1, 2, 0, 3, 5, 4))
    t3new += np.transpose(tmp122, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp122, (1, 2, 0, 5, 3, 4)) * -1
    t3new += np.transpose(tmp122, (0, 2, 1, 5, 3, 4))
    t3new += np.transpose(tmp122, (1, 2, 0, 5, 4, 3))
    t3new += np.transpose(tmp122, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp122, (2, 1, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp122, (2, 0, 1, 3, 5, 4))
    t3new += np.transpose(tmp122, (2, 1, 0, 5, 3, 4))
    t3new += np.transpose(tmp122, (2, 0, 1, 5, 3, 4)) * -1
    t3new += np.transpose(tmp122, (2, 1, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp122, (2, 0, 1, 5, 4, 3))
    del tmp122
    t3new += np.transpose(tmp125, (2, 1, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp125, (2, 1, 0, 4, 5, 3))
    t3new += np.transpose(tmp125, (2, 1, 0, 5, 4, 3)) * -1
    del tmp125
    t3new += np.transpose(tmp128, (2, 1, 0, 5, 4, 3))
    t3new += np.transpose(tmp128, (1, 2, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp128, (2, 1, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp128, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp130, (1, 2, 0, 5, 3, 4))
    t3new += np.transpose(tmp130, (1, 0, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp130, (1, 2, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp130, (1, 0, 2, 5, 4, 3))
    t3new += np.transpose(tmp128, (1, 0, 2, 5, 4, 3))
    t3new += np.transpose(tmp128, (1, 0, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp130, (0, 2, 1, 5, 3, 4)) * -1
    t3new += np.transpose(tmp130, (0, 2, 1, 5, 4, 3))
    t3new += np.transpose(tmp130, (1, 2, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp130, (1, 0, 2, 3, 5, 4))
    t3new += np.transpose(tmp130, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp130, (1, 0, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp130, (0, 2, 1, 3, 5, 4))
    t3new += np.transpose(tmp130, (0, 2, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp128, (2, 1, 0, 4, 3, 5))
    t3new += np.transpose(tmp128, (1, 2, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp130, (1, 2, 0, 3, 4, 5))
    t3new += np.transpose(tmp130, (1, 0, 2, 3, 4, 5)) * -1
    t3new += np.transpose(tmp130, (1, 2, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp130, (1, 0, 2, 4, 3, 5))
    t3new += np.transpose(tmp128, (1, 0, 2, 4, 3, 5))
    del tmp128
    t3new += np.transpose(tmp130, (0, 2, 1, 3, 4, 5)) * -1
    t3new += np.transpose(tmp130, (0, 2, 1, 4, 3, 5))
    del tmp130
    t3new += np.transpose(tmp133, (1, 2, 0, 3, 5, 4))
    t3new += np.transpose(tmp133, (2, 0, 1, 3, 5, 4))
    t3new += np.transpose(tmp133, (0, 2, 1, 3, 5, 4)) * -1
    del tmp133
    t3new += np.transpose(tmp136, (2, 1, 0, 3, 4, 5))
    t3new += np.transpose(tmp136, (2, 1, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp136, (2, 1, 0, 4, 5, 3))
    del tmp136
    t3new += np.transpose(tmp139, (2, 0, 1, 3, 4, 5)) * 0.5
    t3new += np.transpose(tmp139, (0, 2, 1, 3, 4, 5)) * -0.5
    t3new += np.transpose(tmp142, (1, 2, 0, 3, 5, 4))
    t3new += np.transpose(tmp142, (2, 0, 1, 3, 5, 4))
    t3new += np.transpose(tmp142, (1, 2, 0, 4, 3, 5))
    t3new += np.transpose(tmp142, (2, 0, 1, 4, 3, 5))
    t3new += np.transpose(tmp142, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp142, (2, 0, 1, 4, 5, 3)) * -1
    t3new += tmp139 * 0.5
    del tmp139
    t3new += np.transpose(tmp142, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp142, (0, 2, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp142, (0, 2, 1, 4, 5, 3))
    del tmp142
    t3new += np.transpose(tmp145, (2, 1, 0, 3, 4, 5)) * -0.5
    t3new += np.transpose(tmp145, (2, 1, 0, 3, 5, 4)) * 0.5
    t3new += np.transpose(tmp145, (2, 1, 0, 5, 3, 4)) * -0.5
    del tmp145
    t3new += np.transpose(tmp148, (2, 0, 1, 3, 4, 5))
    t3new += np.transpose(tmp148, (0, 2, 1, 3, 4, 5)) * -1
    t3new += np.transpose(tmp148, (2, 0, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp148, (0, 2, 1, 4, 3, 5))
    t3new += np.transpose(tmp148, (2, 0, 1, 4, 5, 3))
    t3new += np.transpose(tmp148, (0, 2, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp151, (1, 2, 0, 3, 4, 5))
    t3new += np.transpose(tmp151, (2, 0, 1, 3, 4, 5))
    t3new += np.transpose(tmp151, (1, 2, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp151, (2, 0, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp151, (1, 2, 0, 5, 3, 4))
    t3new += np.transpose(tmp151, (2, 0, 1, 5, 3, 4))
    t3new += tmp148
    t3new += np.transpose(tmp148, (0, 1, 2, 4, 3, 5)) * -1
    t3new += np.transpose(tmp148, (0, 1, 2, 4, 5, 3))
    del tmp148
    t3new += np.transpose(tmp151, (0, 2, 1, 3, 4, 5)) * -1
    t3new += np.transpose(tmp151, (0, 2, 1, 3, 5, 4))
    t3new += np.transpose(tmp151, (0, 2, 1, 5, 3, 4)) * -1
    del tmp151
    t2new_OOVv = np.copy(np.transpose(tmp16, (1, 2, 3, 0))) * 0.5
    t2new_OOVv += np.transpose(tmp31, (1, 2, 3, 0)) * -0.5
    t2new_OOvV = np.copy(np.transpose(tmp16, (1, 2, 0, 3))) * -0.5
    del tmp16
    t2new_OOvV += np.transpose(tmp31, (1, 2, 0, 3)) * 0.5
    del tmp31
    t2new_oOVV = np.copy(np.transpose(tmp15, (0, 1, 3, 2))) * -0.5
    t2new_oOVV += np.transpose(tmp29, (0, 1, 3, 2)) * -0.5
    t2new_OoVV = np.copy(np.transpose(tmp15, (1, 0, 3, 2))) * 0.5
    del tmp15
    t2new_OoVV += np.transpose(tmp29, (1, 0, 3, 2)) * 0.5
    del tmp29
    t2new_OOVV = einsum(f.OV, (0, 1), t3, (2, 3, 0, 4, 5, 1), (2, 3, 4, 5))
    t2new_OOVV += einsum(t3, (0, 1, 2, 3, 4, 5), tmp27, (2, 5), (0, 1, 3, 4))
    del tmp27
    t2new = np.copy(np.transpose(tmp7, (1, 0, 3, 2)))
    t2new += np.transpose(tmp7, (0, 1, 3, 2)) * -1
    del tmp7
    t2new += np.transpose(tmp8, (1, 0, 2, 3))
    t2new += np.transpose(tmp8, (1, 0, 3, 2)) * -1
    del tmp8
    t2new += np.transpose(tmp9, (1, 0, 3, 2))
    t2new += np.transpose(tmp9, (0, 1, 3, 2)) * -1
    del tmp9
    t2new += tmp11
    t2new += np.transpose(tmp11, (0, 1, 3, 2)) * -1
    del tmp11
    t2new += v.oovv
    t2new += np.transpose(tmp12, (1, 0, 3, 2)) * -1
    t2new += np.transpose(tmp12, (1, 0, 2, 3))
    del tmp12
    t2new += np.transpose(tmp13, (0, 1, 3, 2))
    t2new += np.transpose(tmp13, (1, 0, 3, 2)) * -1
    del tmp13
    t2new += einsum(v.oooo, (0, 1, 2, 3), t2, (2, 3, 4, 5), (0, 1, 4, 5)) * 0.5
    t2new += np.transpose(tmp14, (0, 1, 3, 2))
    t2new += np.transpose(tmp14, (1, 0, 3, 2)) * -1
    t2new += tmp14 * -1
    t2new += np.transpose(tmp14, (1, 0, 2, 3))
    del tmp14
    t2new += einsum(v.vvvv, (0, 1, 2, 3), t2, (4, 5, 2, 3), (4, 5, 0, 1)) * 0.5
    t2new += np.transpose(tmp17, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp17, (1, 0, 3, 2))
    del tmp17
    t2new += np.transpose(tmp19, (0, 1, 3, 2)) * 0.5
    t2new += np.transpose(tmp19, (1, 0, 3, 2)) * -0.5
    del tmp19
    t2new += tmp21
    t2new += np.transpose(tmp21, (1, 0, 2, 3)) * -1
    t2new += np.transpose(tmp21, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp21, (1, 0, 3, 2))
    del tmp21
    t2new += np.transpose(tmp22, (0, 1, 3, 2)) * -1
    t2new += tmp22
    del tmp22
    t2new += np.transpose(tmp24, (1, 0, 3, 2))
    t2new += np.transpose(tmp24, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp24, (1, 0, 2, 3)) * -1
    t2new += tmp24
    del tmp24
    t2new += np.transpose(tmp26, (0, 1, 3, 2)) * 0.5
    t2new += tmp26 * -0.5
    del tmp26
    t2new += einsum(tmp32, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp32
    t2new += np.transpose(tmp34, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp34, (1, 0, 3, 2))
    t2new += tmp34
    t2new += np.transpose(tmp34, (1, 0, 2, 3)) * -1
    del tmp34
    t2new += einsum(tmp35, (0, 1, 2, 3), t1, (4, 3), (4, 0, 2, 1)) * -1
    del tmp35
    t2new += np.transpose(tmp36, (0, 1, 3, 2)) * 0.5
    t2new += np.transpose(tmp36, (1, 0, 3, 2)) * -0.5
    del tmp36
    t2new += einsum(tmp37, (0, 1, 2, 3), t2, (3, 2, 4, 5), (1, 0, 4, 5)) * 0.25
    del tmp37
    t2new += np.transpose(tmp39, (0, 1, 3, 2)) * 0.5
    t2new += np.transpose(tmp41, (0, 1, 3, 2)) * -1
    t2new += tmp41
    del tmp41
    t2new += tmp39 * -0.5
    del tmp39
    t2new += np.transpose(tmp42, (1, 0, 3, 2)) * -1
    t2new += np.transpose(tmp42, (0, 1, 3, 2))
    del tmp42
    t2new += tmp44 * -1
    t2new += np.transpose(tmp44, (0, 1, 3, 2))
    del tmp44
    t2new += einsum(tmp45, (0, 1, 2, 3), t2, (2, 3, 4, 5), (1, 0, 4, 5)) * -0.5
    del tmp45
    t2new += np.transpose(tmp47, (1, 0, 2, 3))
    t2new += tmp47 * -1
    t2new += np.transpose(tmp47, (1, 0, 3, 2)) * -1
    t2new += np.transpose(tmp47, (0, 1, 3, 2))
    del tmp47
    t2new += einsum(tmp48, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3)) * 0.5
    del tmp48
    t2new += np.transpose(tmp50, (0, 1, 3, 2))
    t2new += np.transpose(tmp50, (1, 0, 3, 2)) * -1
    del tmp50
    t2new += np.transpose(tmp52, (0, 1, 3, 2))
    t2new += tmp52 * -1
    del tmp52
    t2new += einsum(tmp53, (0, 1, 2, 3), t1, (2, 4), (1, 0, 4, 3)) * -1
    del tmp53
    t1new_OV = einsum(t3, (0, 1, 2, 3, 4, 5), v.OOVV, (1, 2, 4, 5), (0, 3)) * 0.25
    t1new = np.copy(f.ov)
    t1new += einsum(f.oo, (0, 1), t1, (1, 2), (0, 2)) * -1
    t1new += einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))
    t1new += einsum(t2, (0, 1, 2, 3), f.ov, (1, 3), (0, 2))
    t1new += einsum(tmp0, (0, 1), t1, (0, 2), (1, 2)) * -1
    del tmp0
    t1new += einsum(t1, (0, 1), v.ovov, (2, 1, 0, 3), (2, 3)) * -1
    t1new += einsum(t2, (0, 1, 2, 3), v.ovoo, (4, 3, 0, 1), (4, 2)) * -0.5
    t1new += einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 0, 2, 3), (4, 1)) * -0.5
    t1new += einsum(tmp1, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    del tmp1
    t1new += einsum(t2, (0, 1, 2, 3), tmp2, (4, 1, 0, 3), (4, 2)) * -0.5
    del tmp2
    t1new += einsum(tmp3, (0, 1), t1, (1, 2), (0, 2)) * -0.5
    del tmp3
    t1new += einsum(t1, (0, 1), tmp4, (0, 2), (2, 1)) * -1
    del tmp4
    t1new += einsum(tmp5, (0, 1), t1, (2, 1), (2, 0)) * -1
    del tmp5
    t1new += einsum(tmp6, (0, 1), t1, (1, 2), (0, 2)) * -1
    del tmp6

    t2new += _inflate(t2new.shape, np.ix_(sO, sO, sV, sV), t2new_OOVV)
    t2new += _inflate(t2new.shape, np.ix_(sO, sO, sv, sV), t2new_OOvV)
    t2new += _inflate(t2new.shape, np.ix_(sO, so, sV, sV), t2new_OoVV)
    t2new += _inflate(t2new.shape, np.ix_(so, sO, sV, sV), t2new_oOVV)
    t1new += _inflate(t1new.shape, np.ix_(sO, sV), t1new_OV)
    t2new += _inflate(t2new.shape, np.ix_(sO, sO, sV, sv), t2new_OOVv)

    return {f"t1new": t1new, f"t2new": t2new, f"t3new": t3new}

