"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T16:30:02.028619
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:30:02.094697.

    Parameters
    ----------
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    e_cc = einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 2, 3), ()) * 0.25

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:30:04.131102.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    t1new : array
        Updated T1 residuals.
    t2new : array
        Updated T2 residuals.
    """

    tmp7 = einsum(v.oovv, (0, 1, 2, 3), t2, (0, 1, 4, 3), (4, 2))
    tmp2 = einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 2, 3), (0, 4))
    tmp11 = einsum(f.vv, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp10 = einsum(v.ooov, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    tmp5 = einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp14 = einsum(v.ovvv, (0, 1, 2, 3), t1, (4, 1), (4, 0, 2, 3))
    tmp8 = einsum(tmp7, (0, 1), t2, (2, 3, 4, 1), (2, 3, 4, 0))
    del tmp7
    tmp4 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp13 = einsum(f.oo, (0, 1), t2, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp9 = einsum(tmp2, (0, 1), t2, (2, 1, 3, 4), (2, 0, 3, 4))
    tmp15 = np.copy(v.oooo)
    tmp15 += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 2, 3), (4, 5, 0, 1)) * 0.5
    tmp12 = np.copy(np.transpose(tmp10, (1, 0, 2, 3))) * -1
    del tmp10
    tmp12 += np.transpose(tmp11, (1, 0, 2, 3)) * -1
    del tmp11
    tmp6 = einsum(tmp5, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp5
    tmp3 = np.copy(f.oo) * 2
    tmp3 += np.transpose(tmp2, (1, 0))
    del tmp2
    tmp0 = np.copy(np.transpose(v.ovoo, (0, 2, 3, 1))) * -1
    tmp0 += einsum(v.oovv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp1 = np.copy(f.ov)
    tmp1 += einsum(t1, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3))
    t2new = einsum(v.vvvv, (0, 1, 2, 3), t2, (4, 5, 2, 3), (4, 5, 0, 1)) * 0.5
    t2new += v.oovv
    t2new += tmp4 * -1
    t2new += np.transpose(tmp4, (0, 1, 3, 2))
    t2new += np.transpose(tmp4, (1, 0, 2, 3))
    t2new += np.transpose(tmp4, (1, 0, 3, 2)) * -1
    del tmp4
    t2new += tmp6
    t2new += np.transpose(tmp6, (0, 1, 3, 2)) * -1
    del tmp6
    t2new += tmp8 * -0.5
    t2new += np.transpose(tmp8, (0, 1, 3, 2)) * 0.5
    del tmp8
    t2new += np.transpose(tmp9, (0, 1, 3, 2)) * 0.5
    t2new += np.transpose(tmp9, (1, 0, 3, 2)) * -0.5
    del tmp9
    t2new += tmp12 * -1
    t2new += np.transpose(tmp12, (0, 1, 3, 2))
    del tmp12
    t2new += np.transpose(tmp13, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp13, (1, 0, 3, 2))
    del tmp13
    t2new += np.transpose(tmp14, (0, 1, 3, 2))
    t2new += np.transpose(tmp14, (1, 0, 3, 2)) * -1
    del tmp14
    t2new += einsum(t2, (0, 1, 2, 3), tmp15, (0, 1, 4, 5), (4, 5, 2, 3)) * 0.5
    del tmp15
    t1new = einsum(t1, (0, 1), v.ovov, (2, 1, 0, 3), (2, 3)) * -1
    t1new += einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))
    t1new += einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 0, 2, 3), (4, 1)) * -0.5
    t1new += einsum(tmp0, (0, 1, 2, 3), t2, (1, 2, 4, 3), (0, 4)) * 0.5
    del tmp0
    t1new += einsum(t2, (0, 1, 2, 3), tmp1, (1, 3), (0, 2))
    del tmp1
    t1new += einsum(tmp3, (0, 1), t1, (0, 2), (1, 2)) * -0.5
    del tmp3

    return {f"t1new": t1new, f"t2new": t2new}

