"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T16:30:45.916354
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:30:46.628800.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1)))
    tmp0 += np.transpose(v.ovov, (0, 2, 1, 3)) * -0.5
    tmp1 = np.copy(f.ov)
    tmp1 += einsum(tmp0, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    del tmp0
    e_cc = einsum(v.ovov, (0, 1, 2, 3), t2, (0, 2, 1, 3), ()) * 2
    e_cc += einsum(t2, (0, 1, 2, 3), v.ovov, (0, 3, 1, 2), ()) * -1
    e_cc += einsum(tmp1, (0, 1), t1, (0, 1), ()) * 2
    del tmp1

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:30:52.503298.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    t1new : array
        Updated T1 residuals.
    t2new : array
        Updated T2 residuals.
    """

    tmp17 = einsum(v.ooov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp26 = einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp27 = einsum(t1, (0, 1), v.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp18 = einsum(tmp17, (0, 1, 2, 3), t1, (3, 4), (0, 2, 1, 4))
    del tmp17
    tmp16 = einsum(t1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp28 = np.copy(tmp26)
    del tmp26
    tmp28 += np.transpose(tmp27, (2, 0, 1, 3))
    del tmp27
    tmp24 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp1 = einsum(t1, (0, 1), v.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp11 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1)))
    tmp11 += np.transpose(v.ovov, (0, 2, 1, 3)) * -0.5
    tmp15 = einsum(f.vv, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp19 = einsum(tmp18, (0, 1, 2, 3), t1, (1, 4), (0, 2, 4, 3))
    del tmp18
    tmp21 = einsum(t1, (0, 1), tmp16, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp29 = einsum(tmp28, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp28
    tmp25 = einsum(t2, (0, 1, 2, 3), tmp24, (1, 4), (4, 0, 2, 3))
    del tmp24
    tmp32 = np.copy(v.oooo)
    tmp32 += einsum(tmp1, (0, 1, 2, 3), t1, (4, 3), (1, 4, 2, 0))
    tmp3 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * 2
    tmp3 += np.transpose(v.ovov, (0, 2, 1, 3)) * -1
    tmp7 = np.copy(v.ovvv)
    tmp7 += np.transpose(v.ovvv, (0, 2, 3, 1)) * -0.5
    tmp9 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * -1
    tmp9 += np.transpose(v.ovov, (0, 2, 1, 3)) * 2
    tmp10 = np.copy(v.ooov) * -0.5
    tmp10 += np.transpose(v.ovoo, (0, 2, 3, 1))
    tmp12 = np.copy(f.ov) * 0.5
    tmp12 += einsum(tmp11, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    del tmp11
    tmp20 = np.copy(tmp15)
    del tmp15
    tmp20 += tmp16
    del tmp16
    tmp20 += tmp19
    del tmp19
    tmp22 = einsum(tmp21, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp21
    tmp14 = einsum(t1, (0, 1), v.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp23 = einsum(t2, (0, 1, 2, 3), f.oo, (4, 1), (4, 0, 2, 3))
    tmp30 = np.copy(tmp25)
    del tmp25
    tmp30 += np.transpose(tmp29, (0, 1, 3, 2))
    del tmp29
    tmp31 = einsum(tmp1, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    tmp33 = np.copy(v.ooov) * -1
    tmp33 += einsum(tmp32, (0, 1, 2, 3), t1, (0, 4), (2, 3, 1, 4))
    del tmp32
    tmp4 = np.copy(f.ov)
    tmp4 += einsum(t1, (0, 1), tmp3, (0, 2, 3, 1), (2, 3))
    del tmp3
    tmp8 = np.copy(f.vv) * 0.5
    tmp8 += einsum(t1, (0, 1), tmp7, (0, 1, 2, 3), (3, 2))
    del tmp7
    tmp6 = np.copy(np.transpose(v.ovov, (0, 2, 1, 3))) * 2
    tmp6 += v.oovv * -1
    tmp5 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp5 += t2 * -1
    tmp13 = np.copy(f.oo)
    tmp13 += einsum(tmp9, (0, 1, 2, 3), t2, (4, 0, 3, 2), (1, 4))
    del tmp9
    tmp13 += einsum(tmp10, (0, 1, 2, 3), t1, (0, 3), (2, 1)) * 2
    del tmp10
    tmp13 += einsum(t1, (0, 1), tmp12, (2, 1), (2, 0)) * 2
    del tmp12
    tmp2 = np.copy(v.ooov)
    tmp2 += np.transpose(v.ooov, (0, 2, 1, 3)) * -0.5
    tmp2 += tmp1 * -0.5
    tmp2 += np.transpose(tmp1, (0, 2, 1, 3))
    del tmp1
    tmp0 = np.copy(v.ovvv) * -0.5
    tmp0 += np.transpose(v.ovvv, (0, 2, 1, 3))
    t2new = einsum(tmp14, (0, 1, 2, 3), t1, (4, 2), (4, 0, 1, 3))
    del tmp14
    t2new += np.transpose(v.ovov, (0, 2, 1, 3))
    t2new += einsum(v.ooov, (0, 1, 2, 3), t1, (1, 4), (0, 2, 4, 3)) * -1
    t2new += np.transpose(tmp20, (0, 1, 3, 2))
    t2new += np.transpose(tmp20, (1, 0, 2, 3))
    del tmp20
    t2new += tmp22 * -1
    t2new += np.transpose(tmp22, (1, 0, 3, 2)) * -1
    del tmp22
    t2new += np.transpose(tmp23, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp23, (1, 0, 2, 3)) * -1
    del tmp23
    t2new += np.transpose(tmp30, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp30, (1, 0, 2, 3)) * -1
    del tmp30
    t2new += tmp31 * -1
    t2new += np.transpose(tmp31, (1, 0, 3, 2)) * -1
    del tmp31
    t2new += einsum(tmp33, (0, 1, 2, 3), t1, (0, 4), (2, 1, 3, 4))
    del tmp33
    t1new = np.copy(f.ov)
    t1new += einsum(t2, (0, 1, 2, 3), tmp0, (1, 2, 3, 4), (0, 4)) * 2
    del tmp0
    t1new += einsum(t2, (0, 1, 2, 3), tmp2, (4, 0, 1, 3), (4, 2)) * -2
    del tmp2
    t1new += einsum(tmp4, (0, 1), tmp5, (0, 2, 3, 1), (2, 3))
    del tmp4, tmp5
    t1new += einsum(tmp6, (0, 1, 2, 3), t1, (0, 2), (1, 3))
    del tmp6
    t1new += einsum(t1, (0, 1), tmp8, (1, 2), (0, 2)) * 2
    del tmp8
    t1new += einsum(tmp13, (0, 1), t1, (0, 2), (1, 2)) * -1
    del tmp13

    return {f"t1new": t1new, f"t2new": t2new}

def update_lams(f=None, l1=None, l2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:31:44.304343.

    Parameters
    ----------
    f : array
        Fock matrix.
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    l1new : array
        Updated L1 residuals.
    l2new : array
        Updated L2 residuals.
    """

    tmp50 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * 2
    tmp50 += np.transpose(v.ovov, (0, 2, 1, 3)) * -1
    tmp86 = einsum(tmp50, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    tmp8 = einsum(t1, (0, 1), v.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp17 = einsum(l2, (0, 1, 2, 3), t1, (4, 1), (2, 3, 4, 0))
    tmp25 = einsum(t1, (0, 1), v.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp78 = einsum(t1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp85 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp87 = einsum(tmp86, (0, 1), t1, (2, 1), (2, 0))
    tmp2 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp5 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1)))
    tmp5 += np.transpose(v.ovov, (0, 2, 1, 3)) * -0.5
    tmp27 = einsum(tmp8, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp34 = einsum(l2, (0, 1, 2, 3), t2, (4, 5, 1, 0), (3, 2, 4, 5))
    tmp35 = einsum(tmp17, (0, 1, 2, 3), t1, (4, 3), (1, 0, 2, 4))
    tmp47 = einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    tmp12 = einsum(v.ooov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp69 = np.copy(v.oovv)
    tmp69 += np.transpose(tmp25, (0, 1, 3, 2))
    tmp63 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp79 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1)))
    tmp79 += tmp78
    del tmp78
    tmp77 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * -1
    tmp77 += np.transpose(l2, (2, 3, 0, 1)) * 2
    tmp73 = einsum(t1, (0, 1), v.ovvv, (0, 1, 2, 3), (2, 3))
    tmp83 = np.copy(tmp8) * -1
    tmp83 += np.transpose(tmp8, (0, 2, 1, 3)) * 2
    tmp42 = np.copy(tmp17) * -1
    tmp42 += np.transpose(tmp17, (1, 0, 2, 3)) * 2
    tmp88 = np.copy(tmp85)
    del tmp85
    tmp88 += tmp87 * -1
    del tmp87
    tmp93 = einsum(v.ooov, (0, 1, 2, 3), t1, (2, 3), (0, 1))
    tmp3 = einsum(tmp2, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    del tmp2
    tmp1 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp6 = einsum(t1, (0, 1), tmp5, (0, 2, 3, 1), (2, 3)) * 2
    tmp28 = einsum(tmp27, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    tmp26 = einsum(tmp25, (0, 1, 2, 3), t1, (4, 3), (0, 4, 1, 2))
    del tmp25
    tmp16 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -0.5
    tmp16 += t2
    tmp36 = np.copy(np.transpose(tmp34, (1, 0, 3, 2)))
    tmp36 += tmp35
    tmp98 = einsum(l2, (0, 1, 2, 3), f.oo, (4, 3), (4, 2, 0, 1))
    tmp100 = einsum(tmp47, (0, 1), v.ovov, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp99 = einsum(tmp8, (0, 1, 2, 3), l1, (4, 0), (1, 2, 4, 3))
    tmp66 = einsum(tmp12, (0, 1, 2, 3), l2, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp70 = einsum(l2, (0, 1, 2, 3), tmp69, (2, 4, 1, 5), (3, 4, 0, 5))
    tmp61 = einsum(l2, (0, 1, 2, 3), f.vv, (4, 1), (2, 3, 4, 0))
    tmp65 = einsum(tmp17, (0, 1, 2, 3), f.ov, (2, 4), (0, 1, 4, 3))
    tmp64 = einsum(tmp63, (0, 1), l2, (2, 3, 4, 1), (0, 4, 2, 3))
    del tmp63
    tmp67 = einsum(v.ooov, (0, 1, 2, 3), tmp17, (1, 4, 2, 5), (4, 0, 5, 3))
    tmp68 = einsum(tmp8, (0, 1, 2, 3), tmp17, (0, 4, 1, 5), (4, 2, 5, 3))
    tmp62 = einsum(v.ovvv, (0, 1, 2, 3), l1, (3, 4), (4, 0, 1, 2))
    tmp72 = einsum(tmp17, (0, 1, 2, 3), v.ooov, (4, 1, 2, 5), (0, 4, 3, 5))
    tmp76 = einsum(tmp8, (0, 1, 2, 3), tmp17, (0, 4, 2, 5), (4, 1, 5, 3))
    tmp80 = einsum(tmp79, (0, 1, 2, 3), tmp77, (0, 4, 3, 5), (4, 1, 5, 2))
    del tmp79, tmp77
    tmp74 = einsum(l2, (0, 1, 2, 3), tmp73, (4, 1), (2, 3, 0, 4))
    del tmp73
    tmp84 = einsum(tmp83, (0, 1, 2, 3), tmp17, (4, 0, 1, 5), (4, 2, 5, 3))
    del tmp83
    tmp75 = einsum(v.ovvv, (0, 1, 2, 3), tmp17, (4, 5, 0, 3), (5, 4, 1, 2))
    tmp81 = einsum(tmp69, (0, 1, 2, 3), l2, (4, 2, 5, 0), (5, 1, 4, 3))
    del tmp69
    tmp82 = einsum(v.ovoo, (0, 1, 2, 3), tmp42, (2, 4, 3, 5), (0, 4, 1, 5))
    tmp90 = einsum(tmp86, (0, 1), tmp17, (2, 3, 0, 4), (2, 3, 4, 1))
    tmp89 = einsum(l2, (0, 1, 2, 3), tmp88, (2, 4), (3, 4, 0, 1))
    del tmp88
    tmp96 = einsum(v.ovvv, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    tmp94 = einsum(tmp93, (0, 1), l2, (2, 3, 4, 1), (4, 0, 2, 3))
    del tmp93
    tmp92 = einsum(v.ooov, (0, 1, 2, 3), l1, (4, 1), (0, 2, 4, 3))
    tmp4 = np.copy(tmp1)
    del tmp1
    tmp4 += tmp3 * -1
    del tmp3
    tmp9 = np.copy(v.ooov) * 2
    tmp9 += np.transpose(v.ooov, (0, 2, 1, 3)) * -1
    tmp9 += tmp8 * -1
    tmp9 += np.transpose(tmp8, (0, 2, 1, 3)) * 2
    tmp11 = np.copy(v.oovv) * 2
    tmp11 += np.transpose(v.ovov, (0, 2, 1, 3)) * -1
    tmp10 = np.copy(v.ooov) * -0.5
    tmp10 += np.transpose(v.ooov, (0, 2, 1, 3))
    tmp10 += tmp8
    tmp10 += np.transpose(tmp8, (0, 2, 1, 3)) * -0.5
    del tmp8
    tmp7 = einsum(tmp6, (0, 1), t2, (2, 3, 1, 4), (2, 3, 0, 4)) * 2
    tmp13 = np.copy(np.transpose(v.oooo, (0, 2, 1, 3))) * 2
    tmp13 += v.oooo * -1
    tmp13 += np.transpose(tmp12, (2, 1, 0, 3)) * -1
    tmp13 += np.transpose(tmp12, (3, 2, 0, 1)) * 2
    tmp0 = einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp55 = np.copy(v.ovvv)
    tmp55 += np.transpose(v.ovvv, (0, 2, 1, 3)) * -0.5
    tmp15 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp15 += t2 * -1
    tmp18 = np.copy(tmp17)
    tmp18 += np.transpose(tmp17, (1, 0, 2, 3)) * -0.5
    tmp30 = np.copy(np.transpose(v.ovov, (0, 2, 1, 3))) * 2
    tmp30 += v.oovv * -1
    tmp31 = np.copy(np.transpose(tmp12, (0, 2, 1, 3))) * 2
    tmp31 += np.transpose(tmp12, (0, 3, 2, 1)) * -1
    del tmp12
    tmp29 = np.copy(tmp26) * 2
    del tmp26
    tmp29 += tmp28 * -2
    del tmp28
    tmp48 = np.copy(tmp47) * 0.5
    tmp48 += einsum(l2, (0, 1, 2, 3), tmp16, (2, 4, 0, 1), (3, 4))
    tmp22 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * -1
    tmp22 += np.transpose(l2, (2, 3, 0, 1)) * 2
    tmp23 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp23 += t2 * 2
    tmp58 = np.copy(v.ooov) * -0.5
    tmp58 += np.transpose(v.ovoo, (0, 2, 3, 1))
    tmp59 = np.copy(f.ov)
    tmp59 += tmp6
    del tmp6
    tmp51 = einsum(l2, (0, 1, 2, 3), tmp16, (2, 4, 0, 1), (3, 4)) * 2
    tmp38 = np.copy(tmp17) * -1
    tmp38 += np.transpose(tmp17, (1, 0, 2, 3)) * 2
    tmp37 = einsum(tmp36, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp36
    tmp40 = einsum(l1, (0, 1), t2, (2, 3, 4, 0), (1, 2, 3, 4))
    tmp102 = np.copy(v.oooo)
    tmp102 += np.transpose(tmp27, (0, 2, 3, 1))
    del tmp27
    tmp101 = np.copy(tmp98)
    del tmp98
    tmp101 += tmp99
    del tmp99
    tmp101 += tmp100
    del tmp100
    tmp71 = np.copy(tmp61)
    del tmp61
    tmp71 += tmp62
    del tmp62
    tmp71 += tmp64 * -1
    del tmp64
    tmp71 += tmp65 * -1
    del tmp65
    tmp71 += tmp66
    del tmp66
    tmp71 += tmp67
    del tmp67
    tmp71 += tmp68
    del tmp68
    tmp71 += tmp70 * -1
    del tmp70
    tmp91 = einsum(l1, (0, 1), f.ov, (2, 3), (2, 1, 3, 0))
    tmp91 += tmp72
    del tmp72
    tmp91 += tmp74 * 2
    del tmp74
    tmp91 += tmp75 * -1
    del tmp75
    tmp91 += tmp76
    del tmp76
    tmp91 += tmp80
    del tmp80
    tmp91 += tmp81 * -1
    del tmp81
    tmp91 += np.transpose(tmp82, (1, 0, 3, 2)) * -1
    del tmp82
    tmp91 += tmp84 * -1
    del tmp84
    tmp91 += np.transpose(tmp89, (0, 1, 3, 2))
    del tmp89
    tmp91 += tmp90 * -1
    del tmp90
    tmp91 += einsum(l1, (0, 1), tmp86, (2, 3), (1, 2, 0, 3))
    del tmp86
    tmp97 = einsum(l2, (0, 1, 2, 3), tmp96, (4, 1), (2, 3, 0, 4))
    del tmp96
    tmp95 = np.copy(tmp92)
    del tmp92
    tmp95 += tmp94 * 2
    del tmp94
    tmp14 = np.copy(np.transpose(v.ooov, (0, 2, 1, 3)))
    tmp14 += np.transpose(v.ovoo, (0, 2, 3, 1)) * -2
    tmp14 += np.transpose(tmp0, (1, 2, 0, 3)) * -2
    tmp14 += np.transpose(tmp0, (2, 1, 0, 3))
    del tmp0
    tmp14 += tmp4
    tmp14 += np.transpose(tmp4, (1, 0, 2, 3)) * -2
    del tmp4
    tmp14 += np.transpose(tmp7, (1, 0, 2, 3)) * -1
    tmp14 += tmp7 * 0.5
    del tmp7
    tmp14 += einsum(t2, (0, 1, 2, 3), tmp9, (4, 5, 1, 3), (4, 0, 5, 2))
    del tmp9
    tmp14 += einsum(t2, (0, 1, 2, 3), tmp10, (4, 5, 1, 2), (4, 0, 5, 3)) * 2
    tmp14 += einsum(t1, (0, 1), tmp11, (2, 3, 1, 4), (0, 3, 2, 4)) * -1
    del tmp11
    tmp14 += einsum(tmp13, (0, 1, 2, 3), t1, (0, 4), (2, 1, 3, 4))
    del tmp13
    tmp57 = np.copy(f.ov) * 0.5
    tmp57 += einsum(t1, (0, 1), tmp5, (0, 2, 3, 1), (2, 3))
    del tmp5
    tmp44 = np.copy(np.transpose(tmp34, (1, 0, 2, 3))) * -1
    tmp44 += np.transpose(tmp34, (1, 0, 3, 2)) * 2
    del tmp34
    tmp56 = np.copy(f.vv)
    tmp56 += einsum(t1, (0, 1), tmp55, (0, 1, 2, 3), (3, 2)) * 2
    del tmp55
    tmp19 = einsum(l2, (0, 1, 2, 3), tmp15, (2, 4, 1, 5), (3, 4, 0, 5))
    tmp19 += einsum(l2, (0, 1, 2, 3), tmp16, (3, 4, 1, 5), (2, 4, 0, 5)) * 2
    tmp19 += einsum(tmp18, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3)) * 2
    tmp32 = np.copy(tmp29) * -1
    tmp32 += np.transpose(tmp29, (1, 0, 2, 3)) * 0.5
    del tmp29
    tmp32 += einsum(tmp16, (0, 1, 2, 3), tmp10, (4, 0, 5, 2), (4, 1, 5, 3)) * -4
    del tmp10
    tmp32 += einsum(t1, (0, 1), tmp30, (2, 3, 1, 4), (0, 3, 2, 4)) * -1
    del tmp30
    tmp32 += einsum(tmp31, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    del tmp31
    tmp53 = np.copy(v.ooov) * 2
    tmp53 += np.transpose(v.ovoo, (0, 2, 3, 1)) * -1
    tmp20 = einsum(t1, (0, 1), l2, (2, 3, 4, 0), (4, 2, 3, 1))
    tmp54 = np.copy(np.transpose(v.ovov, (0, 2, 1, 3))) * 2
    tmp54 += v.oovv * -1
    tmp49 = np.copy(t1) * -0.5
    tmp49 += einsum(tmp17, (0, 1, 2, 3), tmp16, (1, 0, 4, 3), (2, 4))
    tmp49 += einsum(l1, (0, 1), tmp15, (1, 2, 3, 0), (2, 3)) * -0.5
    del tmp15
    tmp49 += einsum(tmp48, (0, 1), t1, (0, 2), (1, 2))
    del tmp48
    tmp24 = np.copy(np.transpose(l2, (3, 2, 0, 1)))
    tmp24 += einsum(tmp23, (0, 1, 2, 3), tmp22, (0, 4, 2, 5), (4, 1, 5, 3)) * -1
    del tmp22
    tmp60 = np.copy(f.oo)
    tmp60 += einsum(v.ovov, (0, 1, 2, 3), tmp23, (2, 4, 3, 1), (4, 0))
    tmp60 += einsum(tmp58, (0, 1, 2, 3), t1, (0, 3), (1, 2)) * 2
    del tmp58
    tmp60 += einsum(tmp59, (0, 1), t1, (2, 1), (2, 0))
    del tmp59
    tmp46 = np.copy(v.ovvv) * -1
    tmp46 += np.transpose(v.ovvv, (0, 2, 3, 1)) * 2
    tmp43 = np.copy(tmp35) * -0.5
    tmp43 += np.transpose(tmp35, (0, 1, 3, 2))
    tmp52 = np.copy(tmp47)
    del tmp47
    tmp52 += tmp51
    del tmp51
    tmp21 = np.copy(np.transpose(v.vvvv, (0, 2, 1, 3))) * 2
    tmp21 += v.vvvv * -1
    tmp45 = einsum(t1, (0, 1), l1, (2, 0), (2, 1))
    tmp45 += einsum(l2, (0, 1, 2, 3), tmp16, (3, 2, 1, 4), (0, 4)) * 2
    del tmp16
    tmp33 = np.copy(np.transpose(l2, (2, 3, 0, 1)))
    tmp33 += einsum(tmp18, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4)) * -1
    tmp39 = np.copy(np.transpose(tmp17, (0, 2, 1, 3))) * 0.5
    tmp39 += np.transpose(tmp17, (1, 2, 0, 3)) * -1
    del tmp17
    tmp39 += np.transpose(tmp37, (0, 2, 1, 3))
    tmp39 += tmp37 * -0.5
    del tmp37
    tmp39 += einsum(tmp38, (0, 1, 2, 3), tmp23, (1, 4, 3, 5), (0, 2, 4, 5)) * -0.5
    del tmp23
    tmp41 = np.copy(tmp40) * -2
    tmp41 += np.transpose(tmp40, (0, 2, 1, 3))
    del tmp40
    tmp41 += einsum(t2, (0, 1, 2, 3), tmp38, (4, 1, 5, 3), (4, 5, 0, 2))
    del tmp38
    tmp41 += einsum(tmp18, (0, 1, 2, 3), t2, (4, 1, 3, 5), (0, 2, 4, 5)) * 2
    del tmp18
    l2new = einsum(v.vvvv, (0, 1, 2, 3), l2, (1, 3, 4, 5), (0, 2, 4, 5))
    l2new += einsum(v.ovov, (0, 1, 2, 3), tmp35, (4, 5, 2, 0), (1, 3, 5, 4))
    del tmp35
    l2new += np.transpose(v.ovov, (1, 3, 0, 2))
    l2new += np.transpose(tmp71, (3, 2, 0, 1))
    l2new += np.transpose(tmp71, (2, 3, 1, 0))
    del tmp71
    l2new += np.transpose(tmp91, (2, 3, 0, 1))
    l2new += np.transpose(tmp91, (3, 2, 1, 0))
    del tmp91
    l2new += np.transpose(tmp95, (2, 3, 0, 1)) * -1
    l2new += np.transpose(tmp95, (3, 2, 1, 0)) * -1
    del tmp95
    l2new += np.transpose(tmp97, (2, 3, 0, 1)) * -1
    l2new += np.transpose(tmp97, (3, 2, 1, 0)) * -1
    del tmp97
    l2new += np.transpose(tmp101, (3, 2, 0, 1)) * -1
    l2new += np.transpose(tmp101, (2, 3, 1, 0)) * -1
    del tmp101
    l2new += einsum(tmp102, (0, 1, 2, 3), l2, (4, 5, 3, 0), (4, 5, 2, 1))
    del tmp102
    l1new = np.copy(np.transpose(f.ov, (1, 0)))
    l1new += einsum(tmp14, (0, 1, 2, 3), l2, (4, 3, 1, 0), (4, 2))
    del tmp14
    l1new += einsum(tmp19, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 2), (4, 0)) * -1
    del tmp19
    l1new += einsum(tmp21, (0, 1, 2, 3), tmp20, (4, 0, 3, 1), (2, 4))
    del tmp21, tmp20
    l1new += einsum(v.ovvv, (0, 1, 2, 3), tmp24, (4, 0, 3, 1), (2, 4)) * -1
    del tmp24
    l1new += einsum(tmp32, (0, 1, 2, 3), l2, (4, 3, 0, 1), (4, 2))
    del tmp32
    l1new += einsum(v.ovvv, (0, 1, 2, 3), tmp33, (4, 0, 3, 1), (2, 4)) * 2
    del tmp33
    l1new += einsum(tmp39, (0, 1, 2, 3), v.ovov, (2, 3, 1, 4), (4, 0)) * 2
    del tmp39
    l1new += einsum(tmp41, (0, 1, 2, 3), v.ovov, (2, 4, 1, 3), (4, 0))
    del tmp41
    l1new += einsum(v.oovv, (0, 1, 2, 3), tmp42, (0, 4, 1, 3), (2, 4)) * -1
    del tmp42
    l1new += einsum(v.ooov, (0, 1, 2, 3), tmp43, (4, 0, 1, 2), (3, 4)) * 2
    del tmp43
    l1new += einsum(v.ooov, (0, 1, 2, 3), tmp44, (1, 4, 0, 2), (3, 4))
    del tmp44
    l1new += einsum(tmp45, (0, 1), tmp46, (2, 1, 0, 3), (3, 2))
    del tmp45, tmp46
    l1new += einsum(tmp49, (0, 1), tmp50, (0, 2, 3, 1), (3, 2)) * -2
    del tmp50, tmp49
    l1new += einsum(tmp53, (0, 1, 2, 3), tmp52, (1, 0), (3, 2)) * -1
    del tmp53
    l1new += einsum(l1, (0, 1), tmp54, (1, 2, 0, 3), (3, 2))
    del tmp54
    l1new += einsum(l1, (0, 1), tmp56, (0, 2), (2, 1))
    del tmp56
    l1new += einsum(tmp52, (0, 1), tmp57, (1, 2), (2, 0)) * -2
    del tmp52, tmp57
    l1new += einsum(tmp60, (0, 1), l1, (2, 0), (2, 1)) * -1
    del tmp60

    return {f"l1new": l1new, f"l2new": l2new}

def make_rdm1_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:31:45.848778.

    Parameters
    ----------
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.

    Returns
    -------
    rdm1 : array
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    delta = Namespace(
        oo=np.eye(t2.shape[0]),
        vv=np.eye(t2.shape[-1]),
    )
    tmp5 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -0.5
    tmp5 += t2
    tmp0 = einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    tmp2 = einsum(l2, (0, 1, 2, 3), t1, (4, 1), (2, 3, 4, 0))
    tmp7 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * -1
    tmp7 += np.transpose(l2, (2, 3, 0, 1)) * 2
    tmp4 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp4 += t2 * -1
    tmp6 = np.copy(tmp0)
    tmp6 += einsum(l2, (0, 1, 2, 3), tmp5, (2, 4, 0, 1), (3, 4)) * 2
    del tmp5
    tmp3 = np.copy(tmp2)
    tmp3 += np.transpose(tmp2, (1, 0, 2, 3)) * -0.5
    del tmp2
    tmp1 = np.copy(np.transpose(t2, (0, 1, 3, 2)))
    tmp1 += t2 * -0.5
    rdm1.vv = einsum(t1, (0, 1), l1, (2, 0), (2, 1)) * 2
    rdm1.vv += einsum(t2, (0, 1, 2, 3), tmp7, (0, 1, 4, 3), (4, 2)) * 2
    del tmp7
    rdm1.vo = np.copy(l1) * 2
    rdm1.ov = np.copy(t1) * 2
    rdm1.ov += einsum(t2, (0, 1, 2, 3), tmp3, (1, 0, 4, 3), (4, 2)) * -4
    del tmp3
    rdm1.ov += einsum(tmp4, (0, 1, 2, 3), l1, (3, 0), (1, 2)) * 2
    del tmp4
    rdm1.ov += einsum(t1, (0, 1), tmp6, (0, 2), (2, 1)) * -2
    del tmp6
    rdm1.oo = np.copy(np.transpose(tmp0, (1, 0))) * -2
    del tmp0
    rdm1.oo += delta.oo * 2
    del delta
    rdm1.oo += einsum(l2, (0, 1, 2, 3), tmp1, (2, 4, 1, 0), (4, 3)) * -4
    del tmp1
    rdm1 = np.block([[rdm1.oo, rdm1.ov], [rdm1.vo, rdm1.vv]])

    return rdm1

def make_rdm2_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:32:58.107243.

    Parameters
    ----------
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.

    Returns
    -------
    rdm2 : array
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    delta = Namespace(
        oo=np.eye(t2.shape[0]),
        vv=np.eye(t2.shape[-1]),
    )
    tmp1 = einsum(l2, (0, 1, 2, 3), t1, (4, 1), (2, 3, 4, 0))
    tmp74 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp74 += t2
    tmp76 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp76 += t2 * 2
    tmp5 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -0.5
    tmp5 += t2
    tmp12 = np.copy(tmp1) * -1
    tmp12 += np.transpose(tmp1, (1, 0, 2, 3)) * 2
    tmp10 = np.copy(tmp1) * -1
    tmp10 += np.transpose(tmp1, (1, 0, 2, 3))
    tmp57 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * -1
    tmp57 += np.transpose(l2, (2, 3, 0, 1)) * 2
    tmp75 = einsum(l2, (0, 1, 2, 3), tmp74, (2, 4, 1, 5), (4, 3, 5, 0))
    del tmp74
    tmp83 = einsum(tmp1, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    tmp77 = einsum(l2, (0, 1, 2, 3), tmp76, (3, 4, 1, 5), (4, 2, 5, 0))
    del tmp76
    tmp42 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * -1
    tmp42 += np.transpose(l2, (2, 3, 0, 1)) * 2
    tmp2 = einsum(tmp1, (0, 1, 2, 3), t1, (4, 3), (1, 0, 2, 4))
    tmp0 = einsum(t2, (0, 1, 2, 3), l2, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp26 = einsum(tmp1, (0, 1, 2, 3), t2, (4, 1, 3, 5), (0, 2, 4, 5))
    tmp8 = einsum(l1, (0, 1), t2, (2, 3, 4, 0), (1, 2, 3, 4))
    tmp6 = einsum(l2, (0, 1, 2, 3), tmp5, (2, 4, 0, 1), (3, 4)) * 2
    tmp15 = np.copy(tmp1) * 2
    tmp15 += np.transpose(tmp1, (1, 0, 2, 3)) * -1
    tmp25 = einsum(tmp1, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 2, 4, 5))
    tmp13 = einsum(tmp12, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 2, 4, 5))
    del tmp12
    tmp45 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * -1
    tmp45 += np.transpose(l2, (2, 3, 0, 1))
    tmp20 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp20 += t2 * -1
    tmp4 = einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    tmp11 = einsum(t2, (0, 1, 2, 3), tmp10, (4, 1, 5, 2), (4, 5, 0, 3))
    tmp31 = einsum(l2, (0, 1, 2, 3), tmp5, (2, 4, 0, 1), (3, 4))
    del tmp5
    tmp106 = einsum(t1, (0, 1), l2, (2, 3, 4, 0), (4, 2, 3, 1))
    tmp79 = einsum(t1, (0, 1), l1, (2, 0), (2, 1))
    tmp80 = einsum(tmp57, (0, 1, 2, 3), t2, (0, 1, 4, 3), (2, 4))
    tmp100 = np.copy(tmp83)
    tmp100 += np.transpose(tmp75, (1, 0, 3, 2))
    tmp100 += np.transpose(tmp77, (1, 0, 3, 2)) * -1
    tmp43 = einsum(tmp42, (0, 1, 2, 3), t2, (4, 0, 5, 2), (1, 4, 3, 5))
    del tmp42
    tmp62 = einsum(l2, (0, 1, 2, 3), t2, (4, 3, 1, 5), (2, 4, 0, 5))
    tmp97 = einsum(tmp57, (0, 1, 2, 3), t2, (4, 0, 5, 2), (1, 4, 3, 5))
    tmp90 = np.copy(np.transpose(tmp77, (1, 0, 3, 2)))
    tmp90 += np.transpose(tmp75, (1, 0, 3, 2)) * -1
    tmp3 = np.copy(np.transpose(tmp0, (1, 0, 3, 2)))
    tmp3 += tmp2
    tmp69 = np.copy(tmp8)
    tmp69 += tmp26 * -1
    tmp58 = einsum(tmp57, (0, 1, 2, 3), t2, (0, 1, 4, 3), (2, 4)) * 0.5
    del tmp57
    tmp17 = einsum(t1, (0, 1), tmp6, (0, 2), (2, 1)) * 0.5
    tmp16 = einsum(tmp15, (0, 1, 2, 3), t2, (0, 1, 3, 4), (2, 4)) * 0.5
    tmp23 = einsum(tmp0, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    tmp66 = np.copy(tmp25)
    tmp66 += tmp13 * -1
    tmp9 = einsum(tmp2, (0, 1, 2, 3), t1, (0, 4), (1, 3, 2, 4))
    tmp46 = einsum(t2, (0, 1, 2, 3), tmp45, (1, 4, 2, 5), (4, 0, 5, 3))
    del tmp45
    tmp21 = einsum(l1, (0, 1), tmp20, (1, 2, 3, 0), (2, 3))
    del tmp20
    tmp19 = einsum(tmp4, (0, 1), t1, (0, 2), (1, 2))
    tmp51 = np.copy(tmp8)
    tmp51 += tmp11
    tmp51 += tmp13 * -1
    tmp29 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp29 += t2 * -1
    tmp32 = np.copy(tmp4) * 0.5
    tmp32 += tmp31
    del tmp31
    tmp108 = einsum(tmp106, (0, 1, 2, 3), t1, (0, 4), (2, 1, 3, 4))
    tmp107 = einsum(l2, (0, 1, 2, 3), t2, (3, 2, 4, 5), (0, 1, 5, 4))
    tmp81 = np.copy(tmp79)
    tmp81 += tmp80
    del tmp80
    tmp93 = einsum(t2, (0, 1, 2, 3), tmp1, (1, 0, 4, 5), (4, 5, 3, 2))
    tmp101 = einsum(t1, (0, 1), tmp100, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp100
    tmp89 = einsum(l1, (0, 1), t2, (2, 1, 3, 4), (2, 0, 3, 4))
    tmp104 = np.copy(tmp62)
    tmp104 += tmp83
    tmp104 += tmp43 * -1
    tmp64 = einsum(l2, (0, 1, 2, 3), t2, (4, 2, 1, 5), (3, 4, 0, 5))
    tmp98 = np.copy(tmp62)
    tmp98 += tmp83
    tmp98 += tmp97 * -1
    del tmp97
    tmp91 = einsum(t1, (0, 1), tmp90, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp90
    tmp84 = np.copy(tmp1)
    tmp84 += np.transpose(tmp1, (1, 0, 2, 3)) * -1
    tmp86 = np.copy(np.transpose(l2, (3, 2, 0, 1)))
    tmp86 += np.transpose(l2, (2, 3, 0, 1)) * -1
    tmp27 = einsum(tmp3, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    tmp70 = einsum(tmp69, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp69
    tmp49 = einsum(tmp4, (0, 1), t2, (2, 0, 3, 4), (1, 2, 3, 4))
    tmp60 = einsum(tmp6, (0, 1), t2, (2, 0, 3, 4), (2, 1, 4, 3))
    tmp59 = einsum(t2, (0, 1, 2, 3), tmp58, (2, 4), (0, 1, 4, 3)) * 2
    tmp18 = np.copy(tmp16)
    del tmp16
    tmp18 += tmp17
    del tmp17
    tmp55 = einsum(tmp3, (0, 1, 2, 3), t2, (0, 1, 4, 5), (2, 3, 4, 5))
    tmp54 = einsum(t1, (0, 1), tmp23, (0, 2, 3, 4), (3, 2, 4, 1))
    tmp50 = einsum(t2, (0, 1, 2, 3), tmp43, (1, 4, 2, 5), (4, 0, 5, 3))
    tmp67 = einsum(t1, (0, 1), tmp66, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp66
    tmp41 = einsum(tmp9, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3))
    tmp44 = einsum(tmp43, (0, 1, 2, 3), t2, (4, 0, 5, 2), (1, 4, 3, 5))
    tmp47 = einsum(t2, (0, 1, 2, 3), tmp46, (1, 4, 2, 5), (4, 0, 5, 3))
    tmp22 = np.copy(tmp19)
    tmp22 += tmp21 * -1
    tmp52 = einsum(tmp51, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp51
    tmp30 = einsum(l1, (0, 1), tmp29, (1, 2, 3, 0), (2, 3))
    del tmp29
    tmp33 = einsum(tmp32, (0, 1), t1, (0, 2), (1, 2)) * 2
    del tmp32
    tmp28 = einsum(tmp15, (0, 1, 2, 3), t2, (0, 1, 3, 4), (2, 4))
    del tmp15
    tmp39 = np.copy(tmp1) * 2
    tmp39 += np.transpose(tmp1, (1, 0, 2, 3)) * -1
    tmp109 = np.copy(np.transpose(tmp107, (1, 0, 3, 2)))
    tmp109 += np.transpose(tmp108, (1, 0, 3, 2))
    tmp103 = np.copy(tmp93)
    tmp103 += einsum(t1, (0, 1), tmp81, (2, 3), (0, 2, 1, 3))
    tmp102 = np.copy(tmp89)
    tmp102 += np.transpose(tmp101, (0, 1, 3, 2))
    del tmp101
    tmp105 = einsum(t1, (0, 1), tmp104, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp104
    tmp88 = np.copy(tmp79) * 0.5
    tmp88 += tmp58
    tmp96 = einsum(t1, (0, 1), tmp64, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp99 = einsum(t1, (0, 1), tmp98, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp98
    tmp94 = np.copy(tmp93)
    tmp94 += einsum(t1, (0, 1), tmp58, (2, 3), (0, 2, 1, 3)) * 2
    del tmp58
    tmp92 = np.copy(tmp89)
    tmp92 += einsum(t1, (0, 1), tmp79, (2, 3), (0, 2, 1, 3))
    del tmp79
    tmp92 += np.transpose(tmp91, (0, 1, 3, 2)) * -1
    del tmp91
    tmp95 = einsum(t1, (0, 1), tmp83, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp82 = einsum(t1, (0, 1), tmp1, (0, 2, 3, 4), (2, 3, 4, 1))
    tmp85 = einsum(tmp84, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp84
    tmp87 = einsum(t2, (0, 1, 2, 3), tmp86, (1, 4, 2, 5), (4, 0, 5, 3))
    del tmp86
    tmp78 = einsum(tmp10, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp10
    tmp72 = einsum(tmp27, (0, 1, 2, 3), t1, (0, 4), (2, 1, 3, 4))
    tmp63 = einsum(t2, (0, 1, 2, 3), tmp62, (1, 4, 2, 5), (0, 4, 3, 5))
    tmp71 = np.copy(tmp49)
    tmp71 += np.transpose(tmp70, (0, 1, 3, 2))
    del tmp70
    tmp61 = np.copy(np.transpose(tmp59, (1, 0, 3, 2)))
    del tmp59
    tmp61 += np.transpose(tmp60, (0, 1, 3, 2))
    del tmp60
    tmp61 += einsum(tmp18, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    tmp56 = np.copy(tmp54)
    del tmp54
    tmp56 += np.transpose(tmp55, (1, 0, 3, 2))
    tmp73 = np.copy(t1)
    tmp73 += tmp19 * -1
    tmp65 = einsum(t2, (0, 1, 2, 3), tmp64, (1, 4, 2, 5), (0, 4, 3, 5))
    tmp68 = np.copy(tmp50) * -1
    tmp68 += np.transpose(tmp67, (0, 1, 3, 2))
    del tmp67
    tmp68 += einsum(tmp21, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    tmp48 = np.copy(tmp41)
    del tmp41
    tmp48 += np.transpose(tmp44, (1, 0, 3, 2)) * 2
    tmp48 += tmp47
    del tmp47
    tmp53 = np.copy(tmp49)
    del tmp49
    tmp53 += tmp50 * -1
    del tmp50
    tmp53 += np.transpose(tmp52, (0, 1, 3, 2))
    del tmp52
    tmp53 += einsum(tmp22, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * -1
    tmp37 = einsum(t1, (0, 1), tmp4, (2, 3), (2, 0, 3, 1))
    tmp37 += tmp11
    tmp37 += tmp13 * -1
    tmp35 = np.copy(tmp4)
    tmp35 += tmp6
    tmp34 = np.copy(t1) * -1
    tmp34 += tmp28
    tmp34 += tmp30 * -1
    del tmp30
    tmp34 += tmp33
    tmp40 = einsum(t2, (0, 1, 2, 3), tmp39, (1, 4, 5, 3), (4, 5, 0, 2))
    del tmp39
    tmp38 = np.copy(tmp28)
    del tmp28
    tmp38 += tmp33
    del tmp33
    tmp36 = np.copy(tmp8)
    tmp36 += np.transpose(tmp27, (0, 2, 1, 3))
    tmp36 += einsum(t1, (0, 1), tmp6, (2, 3), (2, 0, 3, 1))
    tmp14 = np.copy(tmp8)
    tmp14 += tmp9
    del tmp9
    tmp14 += tmp11
    del tmp11
    tmp14 += tmp13 * -1
    tmp24 = np.copy(tmp23)
    del tmp23
    tmp24 += einsum(t1, (0, 1), tmp6, (2, 3), (2, 0, 3, 1))
    tmp7 = np.copy(delta.oo)
    tmp7 += tmp4 * -1
    rdm2.vvvv = np.copy(np.transpose(tmp109, (0, 1, 3, 2))) * -2
    rdm2.vvvv += tmp109 * 2
    del tmp109
    rdm2.vvvv += np.transpose(tmp107, (1, 0, 3, 2)) * 2
    del tmp107
    rdm2.vvvv += np.transpose(tmp108, (1, 0, 3, 2)) * 2
    del tmp108
    rdm2.vvvo = np.copy(np.transpose(tmp106, (1, 2, 3, 0))) * -2
    rdm2.vvvo += np.transpose(tmp106, (2, 1, 3, 0)) * 4
    rdm2.vvov = np.copy(np.transpose(tmp106, (1, 2, 0, 3))) * 4
    rdm2.vvov += np.transpose(tmp106, (2, 1, 0, 3)) * -2
    del tmp106
    rdm2.vovv = np.copy(np.transpose(tmp102, (1, 0, 2, 3))) * -2
    rdm2.vovv += np.transpose(tmp102, (1, 0, 3, 2)) * 2
    del tmp102
    rdm2.vovv += np.transpose(tmp103, (1, 0, 2, 3)) * -2
    rdm2.vovv += np.transpose(tmp103, (1, 0, 3, 2)) * 2
    del tmp103
    rdm2.vovv += np.transpose(tmp89, (1, 0, 3, 2)) * 2
    rdm2.vovv += np.transpose(tmp96, (1, 0, 3, 2)) * -2
    rdm2.vovv += np.transpose(tmp93, (1, 0, 2, 3)) * -2
    rdm2.vovv += np.transpose(tmp105, (1, 0, 3, 2)) * -2
    del tmp105
    rdm2.vovv += einsum(t1, (0, 1), tmp88, (2, 3), (2, 0, 3, 1)) * 4
    rdm2.ovvv = np.copy(tmp92) * 2
    rdm2.ovvv += np.transpose(tmp92, (0, 1, 3, 2)) * -2
    del tmp92
    rdm2.ovvv += tmp94 * 2
    rdm2.ovvv += np.transpose(tmp94, (0, 1, 3, 2)) * -2
    del tmp94
    rdm2.ovvv += tmp95 * 2
    rdm2.ovvv += np.transpose(tmp95, (0, 1, 3, 2)) * -2
    del tmp95
    rdm2.ovvv += tmp89 * 2
    del tmp89
    rdm2.ovvv += np.transpose(tmp93, (0, 1, 3, 2)) * -2
    del tmp93
    rdm2.ovvv += tmp96 * -2
    del tmp96
    rdm2.ovvv += tmp99 * -2
    del tmp99
    rdm2.ovvv += einsum(t1, (0, 1), tmp81, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.vvoo = np.copy(np.transpose(l2, (0, 1, 3, 2))) * -2
    rdm2.vvoo += l2 * 4
    rdm2.vovo = einsum(t1, (0, 1), l1, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.vovo += np.transpose(tmp43, (2, 1, 3, 0)) * -2
    rdm2.vovo += np.transpose(tmp87, (2, 1, 3, 0)) * -2
    del tmp87
    rdm2.vovo += np.transpose(tmp85, (2, 1, 3, 0)) * -2
    rdm2.vovo += einsum(delta.oo, (0, 1), tmp88, (2, 3), (2, 0, 3, 1)) * 8
    del tmp88
    rdm2.vovo += np.transpose(tmp64, (2, 1, 3, 0)) * -2
    rdm2.vovo += np.transpose(tmp82, (2, 1, 3, 0)) * -2
    rdm2.voov = einsum(t1, (0, 1), l1, (2, 3), (2, 0, 3, 1)) * 4
    rdm2.voov += np.transpose(tmp77, (3, 0, 1, 2)) * 2
    rdm2.voov += np.transpose(tmp75, (3, 0, 1, 2)) * -2
    rdm2.voov += np.transpose(tmp85, (2, 1, 0, 3)) * 2
    del tmp85
    rdm2.voov += einsum(delta.oo, (0, 1), tmp81, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.voov += np.transpose(tmp62, (2, 1, 0, 3)) * -2
    rdm2.voov += np.transpose(tmp83, (2, 1, 0, 3)) * -2
    rdm2.voov += np.transpose(tmp43, (2, 1, 0, 3)) * 2
    rdm2.ovvo = einsum(t1, (0, 1), l1, (2, 3), (0, 2, 1, 3)) * 4
    rdm2.ovvo += np.transpose(tmp43, (1, 2, 3, 0)) * 4
    del tmp43
    rdm2.ovvo += np.transpose(tmp46, (1, 2, 3, 0)) * -2
    del tmp46
    rdm2.ovvo += np.transpose(tmp78, (1, 2, 3, 0)) * -2
    rdm2.ovvo += einsum(delta.oo, (0, 1), tmp81, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.ovvo += np.transpose(tmp62, (1, 2, 3, 0)) * -2
    del tmp62
    rdm2.ovvo += np.transpose(tmp83, (1, 2, 3, 0)) * -2
    del tmp83
    rdm2.ovov = einsum(t1, (0, 1), l1, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.ovov += np.transpose(tmp75, (0, 3, 1, 2)) * 2
    del tmp75
    rdm2.ovov += np.transpose(tmp77, (0, 3, 1, 2)) * -2
    del tmp77
    rdm2.ovov += np.transpose(tmp78, (1, 2, 0, 3)) * 2
    del tmp78
    rdm2.ovov += einsum(delta.oo, (0, 1), tmp81, (2, 3), (0, 2, 1, 3)) * 4
    del tmp81
    rdm2.ovov += np.transpose(tmp64, (1, 2, 0, 3)) * -2
    del tmp64
    rdm2.ovov += np.transpose(tmp82, (1, 2, 0, 3)) * -2
    del tmp82
    rdm2.oovv = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -2
    rdm2.oovv += t2 * 4
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.oovv += tmp48 * 2
    rdm2.oovv += np.transpose(tmp48, (0, 1, 3, 2)) * -2
    del tmp48
    rdm2.oovv += tmp53 * 2
    rdm2.oovv += np.transpose(tmp53, (0, 1, 3, 2)) * -2
    rdm2.oovv += np.transpose(tmp53, (1, 0, 2, 3)) * -2
    rdm2.oovv += np.transpose(tmp53, (1, 0, 3, 2)) * 2
    del tmp53
    rdm2.oovv += tmp56 * 2
    rdm2.oovv += np.transpose(tmp56, (0, 1, 3, 2)) * -2
    del tmp56
    rdm2.oovv += tmp61 * -4
    rdm2.oovv += np.transpose(tmp61, (0, 1, 3, 2)) * 2
    rdm2.oovv += np.transpose(tmp61, (1, 0, 2, 3)) * 2
    rdm2.oovv += np.transpose(tmp61, (1, 0, 3, 2)) * -4
    del tmp61
    rdm2.oovv += tmp63 * 2
    del tmp63
    rdm2.oovv += np.transpose(tmp65, (0, 1, 3, 2)) * 2
    del tmp65
    rdm2.oovv += einsum(tmp19, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * -2
    del tmp19
    rdm2.oovv += tmp68 * 2
    rdm2.oovv += np.transpose(tmp68, (1, 0, 3, 2)) * 2
    del tmp68
    rdm2.oovv += np.transpose(tmp71, (0, 1, 3, 2)) * -2
    rdm2.oovv += np.transpose(tmp71, (1, 0, 2, 3)) * -2
    del tmp71
    rdm2.oovv += np.transpose(tmp44, (1, 0, 3, 2)) * 4
    del tmp44
    rdm2.oovv += np.transpose(tmp55, (1, 0, 3, 2)) * 2
    del tmp55
    rdm2.oovv += np.transpose(tmp72, (0, 1, 3, 2)) * 2
    del tmp72
    rdm2.oovv += einsum(tmp73, (0, 1), t1, (2, 3), (0, 2, 1, 3)) * 2
    del tmp73
    rdm2.vooo = np.copy(np.transpose(tmp1, (3, 2, 0, 1))) * -4
    rdm2.vooo += np.transpose(tmp1, (3, 2, 1, 0)) * 2
    rdm2.vooo += einsum(l1, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * 4
    rdm2.vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.ovoo = np.copy(np.transpose(tmp1, (2, 3, 0, 1))) * 2
    rdm2.ovoo += np.transpose(tmp1, (2, 3, 1, 0)) * -4
    del tmp1
    rdm2.ovoo += einsum(l1, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 1, 3)) * 4
    rdm2.oovo = np.copy(np.transpose(tmp36, (1, 2, 3, 0))) * -2
    rdm2.oovo += np.transpose(tmp36, (2, 1, 3, 0)) * 2
    del tmp36
    rdm2.oovo += np.transpose(tmp37, (1, 2, 3, 0)) * -2
    rdm2.oovo += np.transpose(tmp37, (2, 1, 3, 0)) * 2
    del tmp37
    rdm2.oovo += einsum(delta.oo, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.oovo += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp38, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.oovo += einsum(tmp38, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * 2
    del tmp38
    rdm2.oovo += einsum(tmp21, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.oovo += einsum(tmp21, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * -2
    del tmp21
    rdm2.oovo += np.transpose(tmp8, (1, 2, 3, 0)) * -2
    rdm2.oovo += np.transpose(tmp26, (1, 2, 3, 0)) * 2
    rdm2.oovo += np.transpose(tmp25, (2, 1, 3, 0)) * 2
    rdm2.oovo += np.transpose(tmp40, (2, 1, 3, 0)) * -2
    del tmp40
    rdm2.oovo += np.transpose(tmp27, (1, 2, 3, 0)) * 2
    rdm2.oovo += einsum(tmp34, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.oovo += einsum(tmp35, (0, 1), t1, (2, 3), (2, 1, 3, 0)) * -2
    rdm2.ooov = np.copy(np.transpose(tmp14, (1, 2, 0, 3))) * 2
    rdm2.ooov += np.transpose(tmp14, (2, 1, 0, 3)) * -2
    del tmp14
    rdm2.ooov += einsum(tmp4, (0, 1), t1, (2, 3), (2, 1, 0, 3)) * 2
    rdm2.ooov += einsum(tmp4, (0, 1), t1, (2, 3), (1, 2, 0, 3)) * -2
    rdm2.ooov += einsum(delta.oo, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.ooov += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp18, (2, 3), (2, 0, 1, 3)) * 4
    rdm2.ooov += einsum(tmp18, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -4
    del tmp18
    rdm2.ooov += einsum(tmp22, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * 2
    rdm2.ooov += einsum(tmp22, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -2
    del tmp22
    rdm2.ooov += np.transpose(tmp24, (1, 2, 0, 3)) * 2
    rdm2.ooov += np.transpose(tmp24, (2, 1, 0, 3)) * -2
    del tmp24
    rdm2.ooov += np.transpose(tmp8, (2, 1, 0, 3)) * -2
    del tmp8
    rdm2.ooov += np.transpose(tmp25, (1, 2, 0, 3)) * 2
    del tmp25
    rdm2.ooov += np.transpose(tmp26, (2, 1, 0, 3)) * 2
    del tmp26
    rdm2.ooov += np.transpose(tmp13, (1, 2, 0, 3)) * -2
    del tmp13
    rdm2.ooov += np.transpose(tmp27, (2, 1, 0, 3)) * 2
    del tmp27
    rdm2.ooov += einsum(tmp34, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -2
    del tmp34
    rdm2.ooov += einsum(t1, (0, 1), tmp35, (2, 3), (3, 0, 2, 1)) * -2
    del tmp35
    rdm2.oooo = np.copy(np.transpose(tmp3, (3, 2, 0, 1))) * -2
    rdm2.oooo += np.transpose(tmp3, (2, 3, 0, 1)) * 2
    del tmp3
    rdm2.oooo += einsum(tmp4, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3)) * -2
    rdm2.oooo += einsum(tmp4, (0, 1), delta.oo, (2, 3), (2, 1, 0, 3)) * 2
    rdm2.oooo += einsum(tmp4, (0, 1), delta.oo, (2, 3), (1, 2, 3, 0)) * 2
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp4, (2, 3), (0, 3, 1, 2)) * -4
    del tmp4
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (3, 0, 2, 1)) * -4
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (2, 1, 0, 3)) * 2
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (1, 2, 3, 0)) * 2
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -4
    del tmp6
    rdm2.oooo += np.transpose(tmp0, (3, 2, 1, 0)) * 2
    del tmp0
    rdm2.oooo += np.transpose(tmp2, (3, 2, 1, 0)) * 2
    del tmp2
    rdm2.oooo += einsum(tmp7, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3)) * 2
    del delta, tmp7
    rdm2 = pack_2e(rdm2.oooo, rdm2.ooov, rdm2.oovo, rdm2.ovoo, rdm2.vooo, rdm2.oovv, rdm2.ovov, rdm2.ovvo, rdm2.voov, rdm2.vovo, rdm2.vvoo, rdm2.ovvv, rdm2.vovv, rdm2.vvov, rdm2.vvvo, rdm2.vvvv)
    rdm2 = np.transpose(rdm2, (0, 2, 1, 3))

    return rdm2

def hbar_matvec_ip_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:33:10.694438.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp0 : array
    tmp12 : array
    tmp14 : array
    tmp16 : array
    tmp17 : array
    tmp19 : array
    tmp21 : array
    tmp25 : array
    tmp26 : array
    tmp28 : array
    tmp29 : array
    tmp3 : array
    tmp31 : array
    tmp32 : array
    tmp33 : array
    tmp34 : array
    tmp35 : array
    tmp37 : array
    tmp39 : array
    tmp4 : array
    tmp40 : array
    tmp41 : array
    tmp42 : array
    tmp43 : array
    tmp45 : array
    tmp5 : array
    tmp51 : array
    tmp52 : array
    tmp53 : array
    tmp54 : array
    tmp6 : array
    tmp9 : array
    """

    tmp0 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp6 = einsum(t1, (0, 1), v.ovov, (2, 3, 0, 1), (2, 3))
    tmp5 = einsum(v.ovov, (0, 1, 2, 3), t1, (2, 1), (0, 3))
    tmp54 = einsum(tmp0, (0, 1), t1, (0, 2), (1, 2))
    tmp53 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 2, 4, 3), (0, 4))
    tmp52 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 3, 4, 2), (0, 4))
    tmp51 = einsum(t1, (0, 1), f.vv, (2, 1), (0, 2))
    tmp45 = einsum(v.ovov, (0, 1, 2, 3), t2, (0, 2, 4, 3), (4, 1))
    tmp43 = einsum(v.ovov, (0, 1, 2, 3), t2, (0, 2, 4, 1), (4, 3))
    tmp42 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 1, 3, 5), (4, 0, 2, 5))
    tmp41 = einsum(v.ooov, (0, 1, 2, 3), t2, (1, 2, 4, 3), (0, 4))
    tmp40 = einsum(v.ooov, (0, 1, 2, 3), t2, (2, 1, 4, 3), (0, 4))
    tmp39 = einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp37 = einsum(f.oo, (0, 1), t1, (1, 2), (0, 2))
    tmp35 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp34 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 5, 1, 2), (0, 4, 3, 5))
    tmp33 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp32 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp31 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 2, 3, 5), (4, 0, 1, 5))
    tmp29 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp28 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp26 = einsum(t2, (0, 1, 2, 3), f.ov, (1, 3), (0, 2))
    tmp25 = einsum(f.ov, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp21 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp19 = einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp17 = einsum(tmp6, (0, 1), t1, (2, 1), (2, 0))
    tmp16 = einsum(tmp5, (0, 1), t1, (2, 1), (2, 0))
    tmp14 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 1, 3), (0, 4))
    tmp12 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 3, 1, 2), (0, 4))
    tmp9 = einsum(t1, (0, 1), v.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp4 = einsum(v.ooov, (0, 1, 2, 3), t1, (2, 3), (0, 1))
    tmp3 = einsum(t1, (0, 1), v.ooov, (2, 0, 3, 1), (2, 3))

    return {f"tmp0": tmp0, f"tmp12": tmp12, f"tmp14": tmp14, f"tmp16": tmp16, f"tmp17": tmp17, f"tmp19": tmp19, f"tmp21": tmp21, f"tmp25": tmp25, f"tmp26": tmp26, f"tmp28": tmp28, f"tmp29": tmp29, f"tmp3": tmp3, f"tmp31": tmp31, f"tmp32": tmp32, f"tmp33": tmp33, f"tmp34": tmp34, f"tmp35": tmp35, f"tmp37": tmp37, f"tmp39": tmp39, f"tmp4": tmp4, f"tmp40": tmp40, f"tmp41": tmp41, f"tmp42": tmp42, f"tmp43": tmp43, f"tmp45": tmp45, f"tmp5": tmp5, f"tmp51": tmp51, f"tmp52": tmp52, f"tmp53": tmp53, f"tmp54": tmp54, f"tmp6": tmp6, f"tmp9": tmp9}

def hbar_matvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:33:10.724699.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp8 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * -0.5
    tmp8 += np.transpose(v.ovov, (0, 2, 1, 3))
    tmp4 = np.copy(r2) * -0.5
    tmp4 += np.transpose(r2, (1, 0, 2))
    tmp11 = np.copy(f.oo)
    tmp11 += ints.tmp0
    tmp11 += np.transpose(ints.tmp14, (1, 0)) * 2
    tmp11 += np.transpose(ints.tmp12, (1, 0)) * -1
    tmp6 = np.copy(ints.tmp32)
    del ints.tmp32
    tmp6 += v.oovv * -1
    tmp5 = np.copy(ints.tmp35) * 2
    del ints.tmp35
    tmp5 += np.transpose(v.ovov, (0, 2, 1, 3))
    tmp5 += ints.tmp33 * -1
    del ints.tmp33
    tmp5 += ints.tmp34 * -1
    del ints.tmp34
    tmp9 = einsum(r2, (0, 1, 2), tmp8, (1, 0, 3, 2), (3,))
    del tmp8
    tmp10 = np.copy(ints.tmp19)
    del ints.tmp19
    tmp10 += np.transpose(ints.tmp29, (1, 0, 2, 3)) * 2
    del ints.tmp29
    tmp10 += np.transpose(ints.tmp39, (2, 1, 0, 3))
    del ints.tmp39
    tmp10 += np.transpose(v.ooov, (0, 2, 1, 3))
    tmp10 += np.transpose(ints.tmp28, (1, 0, 2, 3)) * -1
    del ints.tmp28
    tmp10 += np.transpose(ints.tmp31, (1, 0, 2, 3)) * -1
    del ints.tmp31
    tmp10 += ints.tmp42 * -1
    del ints.tmp42
    tmp12 = np.copy(f.ov)
    tmp12 += ints.tmp26 * 2
    del ints.tmp26
    tmp12 += ints.tmp40
    del ints.tmp40
    tmp12 += ints.tmp51
    del ints.tmp51
    tmp12 += ints.tmp52 * 2
    del ints.tmp52
    tmp12 += ints.tmp25 * -1
    del ints.tmp25
    tmp12 += ints.tmp37 * -1
    del ints.tmp37
    tmp12 += ints.tmp41 * -2
    del ints.tmp41
    tmp12 += ints.tmp53 * -1
    del ints.tmp53
    tmp12 += ints.tmp54 * -1
    del ints.tmp54
    tmp7 = np.copy(np.transpose(ints.tmp45, (1, 0))) * 2
    del ints.tmp45
    tmp7 += f.vv * -1
    tmp7 += np.transpose(ints.tmp43, (1, 0)) * -1
    del ints.tmp43
    tmp7 += einsum(t1, (0, 1), f.ov, (0, 2), (2, 1))
    tmp1 = np.copy(f.ov) * 0.5
    tmp1 += ints.tmp6
    del ints.tmp6
    tmp1 += ints.tmp5 * -0.5
    del ints.tmp5
    tmp3 = np.copy(f.oo)
    tmp3 += ints.tmp0
    del ints.tmp0
    tmp3 += np.transpose(ints.tmp14, (1, 0)) * 2
    del ints.tmp14
    tmp3 += np.transpose(ints.tmp17, (1, 0)) * 2
    del ints.tmp17
    tmp3 += np.transpose(ints.tmp4, (1, 0)) * 2
    del ints.tmp4
    tmp3 += np.transpose(ints.tmp12, (1, 0)) * -1
    del ints.tmp12
    tmp3 += np.transpose(ints.tmp16, (1, 0)) * -1
    del ints.tmp16
    tmp3 += np.transpose(ints.tmp3, (1, 0)) * -1
    del ints.tmp3
    tmp0 = np.copy(ints.tmp9)
    tmp0 += v.ooov * -0.5
    tmp0 += np.transpose(v.ooov, (0, 2, 1, 3))
    tmp2 = np.copy(r2) * -1
    tmp2 += np.transpose(r2, (1, 0, 2)) * 2
    r2new = einsum(r2, (0, 1, 2), v.oooo, (3, 0, 4, 1), (3, 4, 2))
    r2new += einsum(ints.tmp21, (0, 1, 2, 3), r2, (3, 2, 4), (1, 0, 4))
    del ints.tmp21
    r2new += einsum(tmp5, (0, 1, 2, 3), tmp4, (4, 1, 3), (0, 4, 2)) * 2
    del tmp5, tmp4
    r2new += einsum(r2, (0, 1, 2), tmp6, (3, 1, 4, 2), (0, 3, 4))
    r2new += einsum(r2, (0, 1, 2), tmp6, (3, 0, 4, 2), (3, 1, 4))
    del tmp6
    r2new += einsum(tmp7, (0, 1), r2, (2, 3, 0), (2, 3, 1)) * -1
    del tmp7
    r2new += einsum(tmp9, (0,), t2, (1, 2, 3, 0), (1, 2, 3)) * -2
    del tmp9
    r2new += einsum(tmp10, (0, 1, 2, 3), r1, (2,), (1, 0, 3))
    del tmp10
    r2new += einsum(tmp11, (0, 1), r2, (0, 2, 3), (1, 2, 3)) * -1
    r2new += einsum(r2, (0, 1, 2), tmp11, (1, 3), (0, 3, 2)) * -1
    del tmp11
    r2new += einsum(r1, (0,), tmp12, (1, 2), (1, 0, 2)) * -1
    del tmp12
    r1new = einsum(r2, (0, 1, 2), ints.tmp9, (3, 1, 0, 2), (3,)) * -1
    del ints.tmp9
    r1new += einsum(r2, (0, 1, 2), tmp0, (3, 0, 1, 2), (3,)) * 2
    del tmp0
    r1new += einsum(tmp1, (0, 1), tmp2, (2, 0, 1), (2,)) * -2
    del tmp1, tmp2
    r1new += einsum(tmp3, (0, 1), r1, (0,), (1,)) * -1
    del tmp3

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_matvec_ea_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:33:23.509700.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp14 : array
    tmp16 : array
    tmp22 : array
    tmp25 : array
    tmp26 : array
    tmp3 : array
    tmp32 : array
    tmp33 : array
    tmp35 : array
    tmp36 : array
    tmp37 : array
    tmp39 : array
    tmp41 : array
    tmp42 : array
    tmp43 : array
    tmp44 : array
    tmp46 : array
    tmp47 : array
    tmp48 : array
    tmp49 : array
    tmp5 : array
    tmp50 : array
    tmp53 : array
    tmp54 : array
    tmp55 : array
    tmp6 : array
    tmp7 : array
    """

    tmp33 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp55 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp54 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 5, 1, 2), (0, 4, 3, 5))
    tmp53 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp50 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 0, 1, 5), (4, 5, 2, 3))
    tmp49 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 3), (0, 2, 4, 5))
    tmp48 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 0, 5, 1), (4, 5, 2, 3))
    tmp47 = einsum(t2, (0, 1, 2, 3), f.ov, (1, 3), (0, 2))
    tmp46 = einsum(f.ov, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp44 = einsum(v.ooov, (0, 1, 2, 3), t2, (2, 1, 3, 4), (0, 4))
    tmp43 = einsum(v.ooov, (0, 1, 2, 3), t2, (1, 2, 3, 4), (0, 4))
    tmp42 = einsum(f.oo, (0, 1), t1, (1, 2), (0, 2))
    tmp41 = einsum(tmp33, (0, 1), t1, (0, 2), (1, 2))
    tmp39 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 1, 3), (4, 0))
    tmp37 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 3, 1), (4, 0))
    tmp36 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 0, 1, 3), (4, 2))
    tmp35 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 0, 3, 1), (4, 2))
    tmp32 = einsum(t1, (0, 1), f.vv, (2, 1), (0, 2))
    tmp26 = einsum(v.ooov, (0, 1, 2, 3), t2, (2, 1, 4, 5), (0, 5, 4, 3))
    tmp25 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp22 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 2), (0, 3, 4, 5))
    tmp16 = einsum(v.ovov, (0, 1, 2, 3), t2, (0, 2, 4, 3), (4, 1))
    tmp14 = einsum(v.ovov, (0, 1, 2, 3), t2, (0, 2, 4, 1), (4, 3))
    tmp7 = einsum(t1, (0, 1), v.ovov, (2, 3, 0, 1), (2, 3))
    tmp6 = einsum(v.ovov, (0, 1, 2, 3), t1, (2, 1), (0, 3))
    tmp5 = einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 1), (2, 3))
    tmp3 = einsum(t1, (0, 1), v.ovvv, (0, 1, 2, 3), (2, 3))

    return {f"tmp14": tmp14, f"tmp16": tmp16, f"tmp22": tmp22, f"tmp25": tmp25, f"tmp26": tmp26, f"tmp3": tmp3, f"tmp32": tmp32, f"tmp33": tmp33, f"tmp35": tmp35, f"tmp36": tmp36, f"tmp37": tmp37, f"tmp39": tmp39, f"tmp41": tmp41, f"tmp42": tmp42, f"tmp43": tmp43, f"tmp44": tmp44, f"tmp46": tmp46, f"tmp47": tmp47, f"tmp48": tmp48, f"tmp49": tmp49, f"tmp5": tmp5, f"tmp50": tmp50, f"tmp53": tmp53, f"tmp54": tmp54, f"tmp55": tmp55, f"tmp6": tmp6, f"tmp7": tmp7}

def hbar_matvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:33:23.536514.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp12 = einsum(t1, (0, 1), f.ov, (0, 2), (2, 1))
    tmp4 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * -1
    tmp4 += np.transpose(v.ovov, (0, 2, 1, 3)) * 2
    tmp5 = np.copy(f.ov)
    tmp5 += ints.tmp7 * 2
    tmp5 += ints.tmp6 * -1
    tmp14 = np.copy(f.oo)
    tmp14 += ints.tmp33
    del ints.tmp33
    tmp14 += np.transpose(ints.tmp39, (1, 0)) * 2
    del ints.tmp39
    tmp14 += np.transpose(ints.tmp37, (1, 0)) * -1
    del ints.tmp37
    tmp8 = np.copy(np.transpose(r2, (2, 0, 1)))
    tmp8 += np.transpose(r2, (2, 1, 0)) * -0.5
    tmp9 = np.copy(ints.tmp55) * 2
    del ints.tmp55
    tmp9 += np.transpose(v.ovov, (0, 2, 1, 3))
    tmp9 += ints.tmp53 * -1
    del ints.tmp53
    tmp9 += ints.tmp54 * -1
    del ints.tmp54
    tmp11 = np.copy(np.transpose(ints.tmp26, (0, 2, 3, 1)))
    del ints.tmp26
    tmp11 += np.transpose(ints.tmp48, (0, 2, 3, 1)) * 2
    del ints.tmp48
    tmp11 += np.transpose(v.ovvv, (0, 2, 3, 1))
    tmp11 += ints.tmp22 * -1
    del ints.tmp22
    tmp11 += np.transpose(ints.tmp49, (0, 3, 2, 1)) * -1
    del ints.tmp49
    tmp11 += np.transpose(ints.tmp50, (0, 2, 3, 1)) * -1
    del ints.tmp50
    tmp10 = np.copy(ints.tmp25)
    del ints.tmp25
    tmp10 += v.oovv * -1
    tmp7 = einsum(v.ovov, (0, 1, 2, 3), r2, (1, 3, 4), (4, 0, 2))
    tmp13 = np.copy(np.transpose(ints.tmp16, (1, 0))) * 2
    tmp13 += f.vv * -1
    tmp13 += np.transpose(ints.tmp14, (1, 0)) * -1
    tmp13 += tmp12
    del tmp12
    tmp15 = einsum(f.ov, (0, 1), r1, (1,), (0,)) * 0.5
    tmp15 += einsum(r2, (0, 1, 2), tmp4, (2, 3, 0, 1), (3,)) * -0.5
    tmp16 = np.copy(f.ov)
    tmp16 += ints.tmp32
    del ints.tmp32
    tmp16 += ints.tmp35 * 2
    del ints.tmp35
    tmp16 += ints.tmp43
    del ints.tmp43
    tmp16 += ints.tmp47 * 2
    del ints.tmp47
    tmp16 += ints.tmp36 * -1
    del ints.tmp36
    tmp16 += ints.tmp41 * -1
    del ints.tmp41
    tmp16 += ints.tmp42 * -1
    del ints.tmp42
    tmp16 += ints.tmp44 * -2
    del ints.tmp44
    tmp16 += ints.tmp46 * -1
    del ints.tmp46
    tmp1 = np.copy(f.ov) * 0.5
    tmp1 += ints.tmp7
    del ints.tmp7
    tmp1 += ints.tmp6 * -0.5
    del ints.tmp6
    tmp6 = einsum(r2, (0, 1, 2), tmp4, (2, 3, 0, 1), (3,)) * -1
    del tmp4
    tmp6 += einsum(tmp5, (0, 1), r1, (1,), (0,))
    del tmp5
    tmp3 = np.copy(f.vv)
    tmp3 += np.transpose(ints.tmp14, (1, 0))
    del ints.tmp14
    tmp3 += np.transpose(ints.tmp3, (1, 0)) * 2
    del ints.tmp3
    tmp3 += np.transpose(ints.tmp16, (1, 0)) * -2
    del ints.tmp16
    tmp3 += ints.tmp5 * -1
    del ints.tmp5
    tmp2 = np.copy(np.transpose(r2, (2, 0, 1))) * -1
    tmp2 += np.transpose(r2, (2, 1, 0)) * 2
    tmp0 = np.copy(v.ovvv) * -1
    tmp0 += np.transpose(v.ovvv, (0, 2, 1, 3)) * 2
    r2new = einsum(tmp7, (0, 1, 2), t2, (2, 1, 3, 4), (4, 3, 0))
    del tmp7
    r2new += einsum(r2, (0, 1, 2), v.vvvv, (3, 0, 4, 1), (3, 4, 2))
    r2new += einsum(tmp9, (0, 1, 2, 3), tmp8, (1, 3, 4), (2, 4, 0)) * 2
    del tmp9, tmp8
    r2new += einsum(tmp10, (0, 1, 2, 3), r2, (4, 3, 1), (4, 2, 0))
    r2new += einsum(r2, (0, 1, 2), tmp10, (3, 2, 4, 0), (4, 1, 3))
    del tmp10
    r2new += einsum(r1, (0,), tmp11, (1, 2, 0, 3), (3, 2, 1)) * -1
    del tmp11
    r2new += einsum(tmp13, (0, 1), r2, (0, 2, 3), (1, 2, 3)) * -1
    r2new += einsum(tmp13, (0, 1), r2, (2, 0, 3), (2, 1, 3)) * -1
    del tmp13
    r2new += einsum(r2, (0, 1, 2), tmp14, (2, 3), (0, 1, 3)) * -1
    del tmp14
    r2new += einsum(tmp15, (0,), t2, (1, 0, 2, 3), (2, 3, 1)) * 2
    del tmp15
    r2new += einsum(r1, (0,), tmp16, (1, 2), (2, 0, 1)) * -1
    del tmp16
    r1new = einsum(r2, (0, 1, 2), tmp0, (2, 1, 0, 3), (3,)) * -1
    del tmp0
    r1new += einsum(tmp2, (0, 1, 2), tmp1, (0, 2), (1,)) * -2
    del tmp2, tmp1
    r1new += einsum(r1, (0,), tmp3, (0, 1), (1,))
    del tmp3
    r1new += einsum(tmp6, (0,), t1, (0, 1), (1,)) * -1
    del tmp6

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ip_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:34:09.605351.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp0 : array
    tmp1 : array
    tmp100 : array
    tmp103 : array
    tmp104 : array
    tmp108 : array
    tmp111 : array
    tmp112 : array
    tmp114 : array
    tmp115 : array
    tmp12 : array
    tmp129 : array
    tmp13 : array
    tmp131 : array
    tmp14 : array
    tmp17 : array
    tmp19 : array
    tmp2 : array
    tmp20 : array
    tmp21 : array
    tmp22 : array
    tmp24 : array
    tmp26 : array
    tmp29 : array
    tmp3 : array
    tmp32 : array
    tmp33 : array
    tmp35 : array
    tmp36 : array
    tmp38 : array
    tmp4 : array
    tmp41 : array
    tmp44 : array
    tmp48 : array
    tmp49 : array
    tmp51 : array
    tmp54 : array
    tmp57 : array
    tmp6 : array
    tmp60 : array
    tmp63 : array
    tmp66 : array
    tmp69 : array
    tmp70 : array
    tmp72 : array
    tmp73 : array
    tmp75 : array
    tmp78 : array
    tmp81 : array
    tmp82 : array
    tmp85 : array
    tmp86 : array
    tmp87 : array
    tmp88 : array
    tmp9 : array
    tmp91 : array
    tmp92 : array
    tmp94 : array
    tmp98 : array
    """

    tmp20 = einsum(t1, (0, 1), v.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp17 = einsum(t1, (0, 1), v.ovov, (2, 3, 0, 1), (2, 3))
    tmp47 = einsum(v.ovov, (0, 1, 2, 3), t1, (2, 1), (0, 3))
    tmp107 = einsum(tmp20, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp86 = einsum(tmp17, (0, 1), t1, (2, 1), (2, 0))
    tmp85 = einsum(tmp47, (0, 1), t1, (2, 1), (2, 0))
    tmp99 = einsum(t1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp97 = einsum(v.ovvv, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    tmp93 = einsum(t1, (0, 1), v.ovvv, (0, 1, 2, 3), (2, 3))
    tmp90 = einsum(v.ooov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp13 = einsum(v.ooov, (0, 1, 2, 3), t1, (2, 3), (0, 1))
    tmp12 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp81 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp22 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 3, 1), (4, 0))
    tmp24 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 1, 3), (4, 0))
    tmp0 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp131 = einsum(v.ovov, (0, 1, 2, 3), t2, (0, 2, 4, 3), (4, 1))
    tmp129 = einsum(v.ovov, (0, 1, 2, 3), t2, (0, 2, 4, 1), (4, 3))
    tmp115 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp114 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 5, 1, 2), (0, 4, 3, 5))
    tmp112 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp111 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp108 = einsum(tmp107, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    del tmp107
    tmp104 = einsum(tmp86, (0, 1), t1, (1, 2), (0, 2))
    tmp103 = einsum(t1, (0, 1), tmp85, (2, 0), (2, 1))
    tmp100 = einsum(t1, (0, 1), tmp99, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp99
    tmp98 = einsum(t1, (0, 1), tmp97, (1, 2), (0, 2))
    del tmp97
    tmp94 = einsum(t1, (0, 1), tmp93, (2, 1), (0, 2))
    del tmp93
    tmp92 = einsum(tmp90, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    tmp91 = einsum(tmp90, (0, 1, 2, 3), t1, (2, 4), (0, 1, 3, 4))
    del tmp90
    tmp88 = einsum(tmp13, (0, 1), t1, (1, 2), (0, 2))
    tmp87 = einsum(t1, (0, 1), tmp12, (2, 0), (2, 1))
    tmp82 = einsum(tmp81, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    tmp78 = einsum(t1, (0, 1), tmp22, (2, 0), (2, 1))
    tmp75 = einsum(tmp24, (0, 1), t1, (1, 2), (0, 2))
    tmp73 = einsum(tmp20, (0, 1, 2, 3), t2, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp72 = einsum(t2, (0, 1, 2, 3), tmp20, (4, 5, 1, 2), (4, 0, 5, 3))
    tmp70 = einsum(t2, (0, 1, 2, 3), tmp20, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp69 = einsum(t2, (0, 1, 2, 3), tmp20, (4, 1, 5, 2), (4, 0, 5, 3))
    tmp66 = einsum(tmp20, (0, 1, 2, 3), t2, (1, 2, 4, 3), (0, 4))
    tmp63 = einsum(tmp20, (0, 1, 2, 3), t2, (2, 1, 4, 3), (0, 4))
    tmp60 = einsum(t2, (0, 1, 2, 3), tmp17, (4, 3), (0, 1, 4, 2))
    tmp57 = einsum(t2, (0, 1, 2, 3), tmp47, (4, 3), (0, 1, 4, 2))
    tmp54 = einsum(tmp17, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp51 = einsum(tmp17, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp49 = einsum(tmp47, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp48 = einsum(tmp47, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    del tmp47
    tmp44 = einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp41 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 2, 4, 3), (0, 4))
    tmp38 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 0, 3, 1), (4, 2))
    tmp36 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp35 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 1, 2), (0, 4, 5, 3))
    tmp33 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp32 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 1, 5, 2), (0, 4, 5, 3))
    tmp29 = einsum(v.ooov, (0, 1, 2, 3), t2, (1, 2, 4, 3), (0, 4))
    tmp26 = einsum(v.ooov, (0, 1, 2, 3), t2, (1, 2, 3, 4), (0, 4))
    tmp21 = einsum(t1, (0, 1), v.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp19 = einsum(v.oovv, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp14 = einsum(v.oooo, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    tmp9 = einsum(tmp0, (0, 1), t1, (0, 2), (1, 2))
    tmp6 = einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp4 = einsum(t2, (0, 1, 2, 3), f.ov, (1, 3), (0, 2))
    tmp3 = einsum(f.ov, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp2 = einsum(t1, (0, 1), f.vv, (2, 1), (0, 2))
    tmp1 = einsum(t1, (0, 1), f.oo, (2, 0), (2, 1))

    return {f"tmp0": tmp0, f"tmp1": tmp1, f"tmp100": tmp100, f"tmp103": tmp103, f"tmp104": tmp104, f"tmp108": tmp108, f"tmp111": tmp111, f"tmp112": tmp112, f"tmp114": tmp114, f"tmp115": tmp115, f"tmp12": tmp12, f"tmp129": tmp129, f"tmp13": tmp13, f"tmp131": tmp131, f"tmp14": tmp14, f"tmp17": tmp17, f"tmp19": tmp19, f"tmp2": tmp2, f"tmp20": tmp20, f"tmp21": tmp21, f"tmp22": tmp22, f"tmp24": tmp24, f"tmp26": tmp26, f"tmp29": tmp29, f"tmp3": tmp3, f"tmp32": tmp32, f"tmp33": tmp33, f"tmp35": tmp35, f"tmp36": tmp36, f"tmp38": tmp38, f"tmp4": tmp4, f"tmp41": tmp41, f"tmp44": tmp44, f"tmp48": tmp48, f"tmp49": tmp49, f"tmp51": tmp51, f"tmp54": tmp54, f"tmp57": tmp57, f"tmp6": tmp6, f"tmp60": tmp60, f"tmp63": tmp63, f"tmp66": tmp66, f"tmp69": tmp69, f"tmp70": tmp70, f"tmp72": tmp72, f"tmp73": tmp73, f"tmp75": tmp75, f"tmp78": tmp78, f"tmp81": tmp81, f"tmp82": tmp82, f"tmp85": tmp85, f"tmp86": tmp86, f"tmp87": tmp87, f"tmp88": tmp88, f"tmp9": tmp9, f"tmp91": tmp91, f"tmp92": tmp92, f"tmp94": tmp94, f"tmp98": tmp98}

def hbar_lmatvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:34:09.656859.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp12 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -0.5
    tmp12 += t2
    tmp14 = np.copy(f.oo)
    tmp14 += np.transpose(ints.tmp0, (1, 0))
    tmp14 += ints.tmp24 * 2
    tmp14 += ints.tmp22 * -1
    tmp8 = np.copy(ints.tmp115) * 2
    del ints.tmp115
    tmp8 += np.transpose(v.ovov, (0, 2, 1, 3))
    tmp8 += ints.tmp112 * -1
    del ints.tmp112
    tmp8 += ints.tmp114 * -1
    del ints.tmp114
    tmp9 = np.copy(ints.tmp111)
    del ints.tmp111
    tmp9 += v.oovv * -1
    tmp11 = np.copy(ints.tmp131) * 2
    del ints.tmp131
    tmp11 += f.vv * -1
    tmp11 += ints.tmp129 * -1
    del ints.tmp129
    tmp11 += einsum(f.ov, (0, 1), t1, (0, 2), (2, 1))
    tmp10 = np.copy(ints.tmp81)
    del ints.tmp81
    tmp10 += np.transpose(v.oooo, (0, 2, 1, 3))
    tmp13 = einsum(tmp12, (0, 1, 2, 3), r2, (1, 0, 3), (2,))
    del tmp12
    tmp0 = np.copy(r2) * -0.5
    tmp0 += np.transpose(r2, (1, 0, 2))
    tmp4 = np.copy(v.ooov) * -0.5
    tmp4 += np.transpose(v.ovoo, (0, 2, 3, 1))
    tmp1 = np.copy(ints.tmp108)
    del ints.tmp108
    tmp1 += np.transpose(ints.tmp14, (1, 2, 0, 3))
    del ints.tmp14
    tmp1 += ints.tmp32
    del ints.tmp32
    tmp1 += ints.tmp69
    del ints.tmp69
    tmp1 += ints.tmp73
    del ints.tmp73
    tmp1 += ints.tmp82
    del ints.tmp82
    tmp1 += ints.tmp91
    del ints.tmp91
    tmp1 += ints.tmp100 * -1
    del ints.tmp100
    tmp1 += ints.tmp20 * -1
    del ints.tmp20
    tmp1 += ints.tmp44 * -1
    del ints.tmp44
    tmp1 += ints.tmp70 * -2
    del ints.tmp70
    tmp5 = np.copy(ints.tmp104) * 2
    del ints.tmp104
    tmp5 += ints.tmp19
    del ints.tmp19
    tmp5 += ints.tmp1
    del ints.tmp1
    tmp5 += ints.tmp29 * 2
    del ints.tmp29
    tmp5 += ints.tmp3
    del ints.tmp3
    tmp5 += ints.tmp41
    del ints.tmp41
    tmp5 += ints.tmp49 * 2
    del ints.tmp49
    tmp5 += ints.tmp51 * 2
    del ints.tmp51
    tmp5 += ints.tmp63 * 2
    del ints.tmp63
    tmp5 += ints.tmp75 * 2
    del ints.tmp75
    tmp5 += ints.tmp88 * 2
    del ints.tmp88
    tmp5 += ints.tmp98
    del ints.tmp98
    tmp5 += ints.tmp9
    del ints.tmp9
    tmp5 += f.ov * -1
    tmp5 += ints.tmp103 * -1
    del ints.tmp103
    tmp5 += ints.tmp17 * -2
    del ints.tmp17
    tmp5 += ints.tmp26 * -1
    del ints.tmp26
    tmp5 += ints.tmp2 * -1
    del ints.tmp2
    tmp5 += ints.tmp38 * -2
    del ints.tmp38
    tmp5 += ints.tmp48 * -1
    del ints.tmp48
    tmp5 += ints.tmp4 * -2
    del ints.tmp4
    tmp5 += ints.tmp54 * -4
    del ints.tmp54
    tmp5 += ints.tmp66 * -1
    del ints.tmp66
    tmp5 += ints.tmp78 * -1
    del ints.tmp78
    tmp5 += ints.tmp87 * -1
    del ints.tmp87
    tmp5 += ints.tmp94 * -2
    del ints.tmp94
    tmp6 = np.copy(r2) * -1
    tmp6 += np.transpose(r2, (1, 0, 2)) * 2
    tmp7 = np.copy(f.oo)
    tmp7 += np.transpose(ints.tmp0, (1, 0))
    del ints.tmp0
    tmp7 += np.transpose(ints.tmp13, (1, 0)) * 2
    del ints.tmp13
    tmp7 += ints.tmp24 * 2
    del ints.tmp24
    tmp7 += ints.tmp86 * 2
    del ints.tmp86
    tmp7 += ints.tmp12 * -1
    del ints.tmp12
    tmp7 += ints.tmp22 * -1
    del ints.tmp22
    tmp7 += ints.tmp85 * -1
    del ints.tmp85
    tmp3 = np.copy(np.transpose(ints.tmp33, (0, 2, 1, 3)))
    del ints.tmp33
    tmp3 += ints.tmp35
    del ints.tmp35
    tmp3 += np.transpose(ints.tmp57, (0, 2, 1, 3))
    del ints.tmp57
    tmp3 += np.transpose(ints.tmp72, (0, 2, 1, 3))
    del ints.tmp72
    tmp3 += ints.tmp92
    del ints.tmp92
    tmp3 += ints.tmp21 * -1
    del ints.tmp21
    tmp3 += ints.tmp36 * -2
    del ints.tmp36
    tmp3 += np.transpose(ints.tmp60, (0, 2, 1, 3)) * -2
    del ints.tmp60
    tmp3 += np.transpose(ints.tmp6, (1, 0, 2, 3)) * -1
    del ints.tmp6
    tmp2 = np.copy(r2) * 2
    tmp2 += np.transpose(r2, (1, 0, 2)) * -1
    r2new = einsum(f.ov, (0, 1), r1, (2,), (0, 2, 1)) * -1
    r2new += einsum(r1, (0,), v.ovoo, (1, 2, 3, 0), (1, 3, 2))
    r2new += einsum(tmp8, (0, 1, 2, 3), tmp0, (4, 0, 2), (1, 4, 3)) * 2
    del tmp8
    r2new += einsum(r2, (0, 1, 2), tmp9, (1, 3, 2, 4), (0, 3, 4))
    r2new += einsum(r2, (0, 1, 2), tmp9, (0, 3, 2, 4), (3, 1, 4))
    del tmp9
    r2new += einsum(r2, (0, 1, 2), tmp10, (0, 1, 3, 4), (3, 4, 2))
    del tmp10
    r2new += einsum(tmp11, (0, 1), r2, (2, 3, 0), (2, 3, 1)) * -1
    del tmp11
    r2new += einsum(tmp13, (0,), v.ovov, (1, 2, 3, 0), (1, 3, 2)) * -2
    del tmp13
    r2new += einsum(tmp14, (0, 1), r2, (0, 2, 3), (1, 2, 3)) * -1
    r2new += einsum(r2, (0, 1, 2), tmp14, (1, 3), (0, 3, 2)) * -1
    del tmp14
    r1new = einsum(tmp1, (0, 1, 2, 3), tmp0, (0, 1, 3), (2,)) * -2
    del tmp0, tmp1
    r1new += einsum(tmp3, (0, 1, 2, 3), tmp2, (0, 2, 3), (1,)) * -1
    del tmp3, tmp2
    r1new += einsum(r2, (0, 1, 2), tmp4, (0, 3, 1, 2), (3,)) * 2
    del tmp4
    r1new += einsum(tmp5, (0, 1), tmp6, (2, 0, 1), (2,))
    del tmp5, tmp6
    r1new += einsum(tmp7, (0, 1), r1, (0,), (1,)) * -1
    del tmp7

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ea_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:35:01.209629.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp10 : array
    tmp103 : array
    tmp106 : array
    tmp107 : array
    tmp109 : array
    tmp11 : array
    tmp111 : array
    tmp113 : array
    tmp14 : array
    tmp16 : array
    tmp17 : array
    tmp19 : array
    tmp2 : array
    tmp24 : array
    tmp27 : array
    tmp29 : array
    tmp3 : array
    tmp31 : array
    tmp34 : array
    tmp37 : array
    tmp4 : array
    tmp40 : array
    tmp43 : array
    tmp46 : array
    tmp48 : array
    tmp51 : array
    tmp53 : array
    tmp55 : array
    tmp56 : array
    tmp57 : array
    tmp59 : array
    tmp62 : array
    tmp69 : array
    tmp70 : array
    tmp73 : array
    tmp76 : array
    tmp79 : array
    tmp80 : array
    tmp83 : array
    tmp84 : array
    tmp87 : array
    tmp88 : array
    tmp90 : array
    tmp92 : array
    tmp96 : array
    tmp98 : array
    """

    tmp17 = einsum(t1, (0, 1), v.ovov, (2, 3, 0, 1), (2, 3))
    tmp55 = einsum(v.ovov, (0, 1, 2, 3), t1, (2, 1), (0, 3))
    tmp112 = einsum(tmp17, (0, 1), t1, (2, 1), (2, 0))
    tmp110 = einsum(tmp55, (0, 1), t1, (2, 1), (2, 0))
    tmp16 = einsum(v.ovvv, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    tmp14 = einsum(t1, (0, 1), v.ovvv, (0, 1, 2, 3), (2, 3))
    tmp97 = einsum(v.ooov, (0, 1, 2, 3), t1, (2, 3), (0, 1))
    tmp95 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp83 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 3, 1), (4, 0))
    tmp79 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 1, 3), (4, 0))
    tmp69 = einsum(t1, (0, 1), v.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp10 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp113 = einsum(t1, (0, 1), tmp112, (2, 0), (2, 1))
    del tmp112
    tmp111 = einsum(tmp110, (0, 1), t1, (1, 2), (0, 2))
    del tmp110
    tmp109 = einsum(t1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp107 = einsum(t1, (0, 1), v.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp106 = einsum(t1, (0, 1), tmp16, (1, 2), (0, 2))
    tmp103 = einsum(t1, (0, 1), tmp14, (2, 1), (0, 2))
    tmp98 = einsum(tmp97, (0, 1), t1, (1, 2), (0, 2))
    del tmp97
    tmp96 = einsum(t1, (0, 1), tmp95, (2, 0), (2, 1))
    del tmp95
    tmp92 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp90 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp88 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp87 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 5, 1, 2), (0, 4, 3, 5))
    tmp84 = einsum(t1, (0, 1), tmp83, (2, 0), (2, 1))
    tmp80 = einsum(tmp79, (0, 1), t1, (1, 2), (0, 2))
    tmp76 = einsum(tmp69, (0, 1, 2, 3), t2, (2, 1, 4, 5), (0, 5, 4, 3))
    tmp73 = einsum(tmp69, (0, 1, 2, 3), t2, (2, 1, 3, 4), (0, 4))
    tmp70 = einsum(tmp69, (0, 1, 2, 3), t2, (1, 2, 3, 4), (0, 4))
    tmp62 = einsum(tmp17, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp59 = einsum(tmp17, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp57 = einsum(t2, (0, 1, 2, 3), tmp55, (1, 3), (0, 2))
    tmp56 = einsum(t2, (0, 1, 2, 3), tmp55, (1, 2), (0, 3))
    tmp53 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 3), (0, 2, 4, 5))
    tmp51 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 2), (0, 3, 4, 5))
    tmp48 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 3, 4, 5), (0, 2, 4, 5))
    tmp46 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 2, 4, 5), (0, 3, 4, 5))
    tmp43 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 0, 1, 3), (4, 2))
    tmp40 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 3, 4, 2), (0, 4))
    tmp37 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 1, 0, 5), (4, 3, 2, 5))
    tmp34 = einsum(v.ooov, (0, 1, 2, 3), t2, (2, 1, 3, 4), (0, 4))
    tmp31 = einsum(v.ooov, (0, 1, 2, 3), t2, (2, 1, 4, 3), (0, 4))
    tmp29 = einsum(v.ovov, (0, 1, 2, 3), t2, (0, 2, 4, 3), (4, 1))
    tmp27 = einsum(t2, (0, 1, 2, 3), v.ovov, (0, 4, 1, 2), (3, 4))
    tmp24 = einsum(t1, (0, 1), v.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp19 = einsum(v.oovv, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp11 = einsum(tmp10, (0, 1), t1, (0, 2), (1, 2))
    tmp4 = einsum(t2, (0, 1, 2, 3), f.ov, (1, 3), (0, 2))
    tmp3 = einsum(f.ov, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp2 = einsum(t1, (0, 1), f.vv, (2, 1), (0, 2))
    tmp1 = einsum(f.oo, (0, 1), t1, (1, 2), (0, 2))

    return {f"tmp1": tmp1, f"tmp10": tmp10, f"tmp103": tmp103, f"tmp106": tmp106, f"tmp107": tmp107, f"tmp109": tmp109, f"tmp11": tmp11, f"tmp111": tmp111, f"tmp113": tmp113, f"tmp14": tmp14, f"tmp16": tmp16, f"tmp17": tmp17, f"tmp19": tmp19, f"tmp2": tmp2, f"tmp24": tmp24, f"tmp27": tmp27, f"tmp29": tmp29, f"tmp3": tmp3, f"tmp31": tmp31, f"tmp34": tmp34, f"tmp37": tmp37, f"tmp4": tmp4, f"tmp40": tmp40, f"tmp43": tmp43, f"tmp46": tmp46, f"tmp48": tmp48, f"tmp51": tmp51, f"tmp53": tmp53, f"tmp55": tmp55, f"tmp56": tmp56, f"tmp57": tmp57, f"tmp59": tmp59, f"tmp62": tmp62, f"tmp69": tmp69, f"tmp70": tmp70, f"tmp73": tmp73, f"tmp76": tmp76, f"tmp79": tmp79, f"tmp80": tmp80, f"tmp83": tmp83, f"tmp84": tmp84, f"tmp87": tmp87, f"tmp88": tmp88, f"tmp90": tmp90, f"tmp92": tmp92, f"tmp96": tmp96, f"tmp98": tmp98}

def hbar_lmatvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:35:01.254922.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp9 = einsum(r2, (0, 1, 2), t1, (3, 1), (2, 3, 0))
    tmp23 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -0.5
    tmp23 += t2
    tmp20 = einsum(t1, (0, 1), f.ov, (0, 2), (2, 1))
    tmp2 = np.copy(np.transpose(r2, (2, 0, 1)))
    tmp2 += np.transpose(r2, (2, 1, 0)) * -0.5
    tmp10 = einsum(t1, (0, 1), tmp9, (2, 3, 1), (2, 0, 3))
    del tmp9
    tmp14 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp14 += t2 * 2
    tmp22 = np.copy(f.oo)
    tmp22 += np.transpose(ints.tmp10, (1, 0))
    del ints.tmp10
    tmp22 += ints.tmp79 * 2
    del ints.tmp79
    tmp22 += ints.tmp83 * -1
    del ints.tmp83
    tmp17 = einsum(t2, (0, 1, 2, 3), r2, (2, 3, 4), (4, 0, 1))
    tmp24 = einsum(r2, (0, 1, 2), tmp23, (2, 3, 0, 1), (3,))
    del tmp23
    tmp21 = np.copy(ints.tmp29) * 2
    tmp21 += f.vv * -1
    tmp21 += ints.tmp27 * -1
    tmp21 += np.transpose(tmp20, (1, 0))
    del tmp20
    tmp19 = np.copy(ints.tmp90)
    tmp19 += v.oovv * -1
    tmp18 = np.copy(ints.tmp88) * 2
    tmp18 += np.transpose(v.ovov, (0, 2, 1, 3))
    tmp18 += ints.tmp87 * -1
    tmp18 += ints.tmp92 * -1
    tmp4 = np.copy(ints.tmp107)
    del ints.tmp107
    tmp4 += v.oovv
    tmp4 += np.transpose(ints.tmp90, (0, 1, 3, 2)) * -1
    del ints.tmp90
    tmp8 = np.copy(np.transpose(r2, (2, 0, 1))) * -1
    tmp8 += np.transpose(r2, (2, 1, 0)) * 2
    tmp1 = np.copy(ints.tmp24)
    tmp1 += np.transpose(ints.tmp46, (0, 2, 1, 3)) * 0.5
    tmp1 += np.transpose(ints.tmp53, (0, 2, 1, 3)) * 0.5
    tmp1 += np.transpose(ints.tmp76, (0, 3, 1, 2))
    tmp1 += np.transpose(ints.tmp37, (0, 3, 1, 2)) * -0.5
    tmp1 += np.transpose(ints.tmp48, (0, 2, 1, 3)) * -1
    tmp1 += np.transpose(ints.tmp51, (0, 2, 1, 3)) * -1
    tmp3 = einsum(tmp2, (0, 1, 2), t1, (3, 1), (0, 3, 2))
    tmp5 = einsum(tmp2, (0, 1, 2), t1, (3, 2), (0, 3, 1)) * 2
    tmp11 = np.copy(tmp10)
    tmp11 += np.transpose(tmp10, (0, 2, 1)) * -0.5
    tmp6 = np.copy(ints.tmp109)
    del ints.tmp109
    tmp6 += np.transpose(ints.tmp88, (0, 1, 3, 2)) * 2
    del ints.tmp88
    tmp6 += np.transpose(v.ovov, (0, 2, 3, 1))
    tmp6 += np.transpose(ints.tmp87, (0, 1, 3, 2)) * -1
    del ints.tmp87
    tmp6 += np.transpose(ints.tmp92, (0, 1, 3, 2)) * -1
    del ints.tmp92
    tmp12 = np.copy(tmp10) * -1
    tmp12 += np.transpose(tmp10, (0, 2, 1)) * 2
    del tmp10
    tmp7 = np.copy(ints.tmp106)
    del ints.tmp106
    tmp7 += ints.tmp113 * 2
    del ints.tmp113
    tmp7 += ints.tmp11
    del ints.tmp11
    tmp7 += ints.tmp19
    del ints.tmp19
    tmp7 += ints.tmp1
    del ints.tmp1
    tmp7 += ints.tmp34 * 2
    del ints.tmp34
    tmp7 += ints.tmp3
    del ints.tmp3
    tmp7 += ints.tmp43
    del ints.tmp43
    tmp7 += ints.tmp57 * 2
    del ints.tmp57
    tmp7 += ints.tmp59 * 2
    del ints.tmp59
    tmp7 += ints.tmp70 * 2
    del ints.tmp70
    tmp7 += ints.tmp80 * 2
    del ints.tmp80
    tmp7 += ints.tmp98 * 2
    del ints.tmp98
    tmp7 += f.ov * -1
    tmp7 += ints.tmp103 * -2
    del ints.tmp103
    tmp7 += ints.tmp111 * -1
    del ints.tmp111
    tmp7 += ints.tmp17 * -2
    tmp7 += ints.tmp2 * -1
    del ints.tmp2
    tmp7 += ints.tmp31 * -1
    del ints.tmp31
    tmp7 += ints.tmp40 * -2
    del ints.tmp40
    tmp7 += ints.tmp4 * -2
    del ints.tmp4
    tmp7 += ints.tmp56 * -1
    del ints.tmp56
    tmp7 += ints.tmp62 * -4
    del ints.tmp62
    tmp7 += ints.tmp73 * -1
    del ints.tmp73
    tmp7 += ints.tmp84 * -1
    del ints.tmp84
    tmp7 += ints.tmp96 * -1
    del ints.tmp96
    tmp13 = np.copy(f.vv)
    tmp13 += np.transpose(ints.tmp14, (1, 0)) * 2
    del ints.tmp14
    tmp13 += ints.tmp27
    del ints.tmp27
    tmp13 += np.transpose(ints.tmp16, (1, 0)) * -1
    del ints.tmp16
    tmp13 += ints.tmp29 * -2
    del ints.tmp29
    tmp15 = einsum(t1, (0, 1), r1, (1,), (0,)) * 0.5
    tmp15 += einsum(r2, (0, 1, 2), tmp14, (2, 3, 0, 1), (3,)) * -0.5
    del tmp14
    tmp0 = np.copy(ints.tmp24)
    del ints.tmp24
    tmp0 += np.transpose(ints.tmp46, (0, 2, 1, 3)) * 2
    del ints.tmp46
    tmp0 += np.transpose(ints.tmp53, (0, 2, 1, 3)) * 2
    del ints.tmp53
    tmp0 += np.transpose(ints.tmp76, (0, 3, 1, 2))
    del ints.tmp76
    tmp0 += np.transpose(ints.tmp37, (0, 3, 1, 2)) * -2
    del ints.tmp37
    tmp0 += np.transpose(ints.tmp48, (0, 2, 1, 3)) * -4
    del ints.tmp48
    tmp0 += np.transpose(ints.tmp51, (0, 2, 1, 3)) * -1
    del ints.tmp51
    tmp0 += np.transpose(v.ovvv, (0, 2, 1, 3)) * -2
    tmp0 += np.transpose(v.ovvv, (0, 2, 3, 1))
    tmp16 = np.copy(f.ov)
    tmp16 += ints.tmp17 * 2
    del ints.tmp17
    tmp16 += ints.tmp55 * -1
    del ints.tmp55
    r2new = einsum(tmp17, (0, 1, 2), v.ovov, (2, 3, 1, 4), (4, 3, 0))
    del tmp17
    r2new += einsum(r1, (0,), v.ovvv, (1, 2, 3, 0), (2, 3, 1)) * -1
    r2new += einsum(r2, (0, 1, 2), v.vvvv, (3, 0, 4, 1), (3, 4, 2))
    r2new += einsum(r1, (0,), f.ov, (1, 2), (2, 0, 1)) * -1
    r2new += einsum(tmp18, (0, 1, 2, 3), tmp2, (0, 2, 4), (3, 4, 1)) * 2
    del tmp2, tmp18
    r2new += einsum(tmp19, (0, 1, 2, 3), r2, (4, 2, 0), (4, 3, 1))
    r2new += einsum(tmp19, (0, 1, 2, 3), r2, (2, 4, 0), (3, 4, 1))
    del tmp19
    r2new += einsum(tmp21, (0, 1), r2, (0, 2, 3), (1, 2, 3)) * -1
    r2new += einsum(r2, (0, 1, 2), tmp21, (1, 3), (0, 3, 2)) * -1
    del tmp21
    r2new += einsum(r2, (0, 1, 2), tmp22, (2, 3), (0, 1, 3)) * -1
    del tmp22
    r2new += einsum(tmp24, (0,), v.ovov, (1, 2, 0, 3), (2, 3, 1)) * -2
    del tmp24
    r1new = einsum(tmp0, (0, 1, 2, 3), r2, (2, 3, 0), (1,))
    del tmp0
    r1new += einsum(r2, (0, 1, 2), tmp1, (2, 3, 1, 0), (3,)) * -2
    del tmp1
    r1new += einsum(tmp4, (0, 1, 2, 3), tmp3, (0, 1, 3), (2,)) * 2
    del tmp4, tmp3
    r1new += einsum(tmp5, (0, 1, 2), tmp6, (0, 1, 3, 2), (3,))
    del tmp5, tmp6
    r1new += einsum(tmp8, (0, 1, 2), tmp7, (0, 2), (1,))
    del tmp8, tmp7
    r1new += einsum(ints.tmp69, (0, 1, 2, 3), tmp11, (0, 2, 1), (3,)) * -2
    del ints.tmp69, tmp11
    r1new += einsum(v.ooov, (0, 1, 2, 3), tmp12, (0, 2, 1), (3,)) * -1
    del tmp12
    r1new += einsum(r1, (0,), tmp13, (0, 1), (1,))
    del tmp13
    r1new += einsum(tmp15, (0,), tmp16, (0, 1), (1,)) * -2
    del tmp15, tmp16

    return {f"r1new": r1new, f"r2new": r2new}

