"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T17:11:19.393637
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:11:20.097058.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1)))
    tmp0 += np.transpose(v.ovov, (0, 2, 1, 3)) * -0.5
    tmp1 = np.copy(f.ov)
    tmp1 += einsum(tmp0, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    del tmp0
    e_cc = einsum(t2, (0, 1, 2, 3), v.ovov, (0, 2, 1, 3), ()) * 2
    e_cc += einsum(t2, (0, 1, 2, 3), v.ovov, (0, 3, 1, 2), ()) * -1
    e_cc += einsum(t1, (0, 1), tmp1, (0, 1), ()) * 2
    del tmp1

    return e_cc

def update_amps(f=None, t1=None, t2=None, t3=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:12:13.059035.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    t3 : array
        T3 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    t1new : array
        Updated T1 residuals.
    t2new : array
        Updated T2 residuals.
    t3new : array
        Updated T3 residuals.
    """

    tmp2 = einsum(t1, (0, 1), v.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp4 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * 2
    tmp4 += np.transpose(v.ovov, (0, 2, 1, 3)) * -1
    tmp17 = einsum(tmp2, (0, 1, 2, 3), t1, (4, 3), (0, 4, 2, 1))
    tmp70 = np.copy(tmp2) * -1
    tmp70 += np.transpose(tmp2, (0, 2, 1, 3)) * 2
    tmp5 = einsum(tmp4, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    tmp51 = einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp51 += np.transpose(t2, (0, 1, 3, 2)) * -2
    tmp51 += t2
    tmp44 = einsum(t1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp94 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), (0, 1, 4, 5, 6, 2))
    tmp19 = einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp106 = einsum(tmp2, (0, 1, 2, 3), t2, (4, 5, 6, 3), (0, 4, 5, 2, 1, 6))
    tmp78 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp87 = einsum(t1, (0, 1), tmp17, (2, 3, 0, 4), (3, 2, 4, 1))
    tmp80 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp32 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * -0.5
    tmp32 += np.transpose(v.ovov, (0, 2, 1, 3))
    tmp71 = einsum(tmp70, (0, 1, 2, 3), t2, (4, 2, 5, 3), (4, 0, 1, 5))
    del tmp70
    tmp69 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 1, 3, 5), (4, 0, 2, 5))
    tmp66 = np.copy(v.ovvv) * 2
    tmp66 += np.transpose(v.ovvv, (0, 2, 3, 1)) * -1
    tmp74 = np.copy(v.ooov) * -1
    tmp74 += np.transpose(v.ovoo, (0, 2, 3, 1)) * 2
    tmp60 = einsum(tmp4, (0, 1, 2, 3), t2, (4, 0, 5, 3), (4, 1, 5, 2))
    del tmp4
    tmp59 = einsum(t1, (0, 1), tmp2, (2, 3, 0, 4), (2, 3, 1, 4))
    tmp63 = einsum(v.ovov, (0, 1, 2, 3), t1, (2, 3), (0, 1))
    tmp49 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp53 = einsum(tmp5, (0, 1), t2, (2, 3, 1, 4), (2, 3, 0, 4))
    tmp48 = einsum(t1, (0, 1), v.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp52 = einsum(tmp51, (0, 1, 2, 3), v.ooov, (4, 5, 0, 3), (4, 5, 1, 2))
    del tmp51
    tmp50 = einsum(tmp2, (0, 1, 2, 3), t2, (4, 2, 3, 5), (0, 4, 1, 5))
    tmp96 = einsum(tmp44, (0, 1, 2, 3), t2, (4, 5, 6, 2), (0, 4, 5, 1, 6, 3))
    tmp95 = einsum(t1, (0, 1), tmp94, (2, 3, 4, 5, 0, 6), (2, 3, 4, 5, 1, 6))
    del tmp94
    tmp93 = einsum(tmp19, (0, 1, 2, 3), t2, (4, 3, 5, 6), (0, 4, 2, 1, 5, 6))
    tmp103 = einsum(t1, (0, 1), v.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp101 = einsum(t1, (0, 1), v.oooo, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp40 = einsum(t1, (0, 1), v.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp107 = einsum(t1, (0, 1), tmp106, (2, 3, 4, 5, 0, 6), (2, 3, 4, 5, 1, 6))
    del tmp106
    tmp109 = np.copy(np.transpose(tmp78, (2, 1, 0, 3))) * -1
    tmp109 += tmp87
    tmp123 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 5, 6, 3), (4, 5, 0, 2, 6, 1))
    tmp81 = np.copy(f.oo)
    tmp81 += tmp80
    tmp28 = einsum(v.ovov, (0, 1, 2, 3), t3, (4, 5, 2, 3, 6, 1), (4, 5, 0, 6)) * -1
    tmp33 = einsum(tmp32, (0, 1, 2, 3), t2, (0, 1, 2, 4), (4, 3))
    tmp37 = einsum(t2, (0, 1, 2, 3), tmp32, (1, 4, 3, 2), (0, 4)) * 2
    del tmp32
    tmp35 = np.copy(np.transpose(t3, (0, 2, 1, 3, 5, 4)))
    tmp35 += einsum(t1, (0, 1), t2, (2, 3, 4, 5), (0, 2, 3, 4, 1, 5)) * -1
    tmp30 = einsum(t1, (0, 1), v.ovov, (2, 1, 0, 3), (2, 3))
    tmp23 = einsum(t3, (0, 1, 2, 3, 4, 5), v.ovov, (6, 4, 2, 5), (0, 1, 6, 3))
    tmp72 = np.copy(tmp2)
    tmp72 += tmp69 * -1
    del tmp69
    tmp72 += np.transpose(tmp71, (1, 0, 2, 3))
    del tmp71
    tmp67 = einsum(t1, (0, 1), tmp66, (0, 1, 2, 3), (2, 3))
    del tmp66
    tmp75 = einsum(tmp74, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    del tmp74
    tmp61 = np.copy(tmp59)
    del tmp59
    tmp61 += tmp60 * -1
    tmp64 = np.copy(f.ov)
    tmp64 += tmp63 * 2
    del tmp63
    tmp54 = np.copy(np.transpose(tmp48, (0, 2, 1, 3))) * -1
    tmp54 += np.transpose(tmp49, (0, 2, 1, 3))
    del tmp49
    tmp54 += np.transpose(tmp50, (0, 2, 1, 3))
    del tmp50
    tmp54 += np.transpose(tmp52, (2, 1, 0, 3))
    del tmp52
    tmp54 += np.transpose(tmp53, (1, 2, 0, 3)) * -1
    del tmp53
    tmp56 = einsum(tmp5, (0, 1), t1, (2, 1), (2, 0))
    tmp46 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp46 += t2 * 2
    tmp13 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1)))
    tmp13 += np.transpose(v.ovov, (0, 2, 1, 3)) * -0.5
    tmp97 = np.copy(np.transpose(tmp93, (0, 1, 3, 2, 4, 5)))
    del tmp93
    tmp97 += np.transpose(tmp95, (0, 1, 3, 2, 4, 5))
    del tmp95
    tmp97 += np.transpose(tmp96, (0, 1, 3, 2, 4, 5)) * -1
    del tmp96
    tmp104 = einsum(tmp103, (0, 1, 2, 3), t2, (4, 5, 6, 2), (0, 4, 5, 6, 3, 1))
    del tmp103
    tmp102 = einsum(t2, (0, 1, 2, 3), tmp101, (4, 1, 5, 6), (0, 5, 4, 6, 2, 3))
    del tmp101
    tmp91 = einsum(t1, (0, 1), tmp44, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp117 = einsum(t1, (0, 1), tmp19, (2, 3, 4, 0), (2, 4, 3, 1))
    tmp126 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 5, 6, 3), (4, 5, 0, 1, 6, 2))
    tmp99 = einsum(tmp40, (0, 1, 2, 3), t2, (4, 5, 6, 3), (0, 4, 5, 1, 6, 2))
    tmp113 = np.copy(f.oo)
    tmp113 += tmp80
    del tmp80
    tmp119 = einsum(f.ov, (0, 1), t3, (2, 3, 4, 5, 6, 1), (0, 2, 4, 3, 5, 6))
    tmp108 = einsum(t1, (0, 1), tmp107, (2, 3, 4, 0, 5, 6), (2, 3, 4, 1, 5, 6))
    del tmp107
    tmp110 = einsum(t2, (0, 1, 2, 3), tmp109, (4, 5, 1, 6), (0, 4, 5, 3, 2, 6))
    del tmp109
    tmp122 = einsum(tmp2, (0, 1, 2, 3), t2, (4, 2, 5, 6), (0, 4, 1, 5, 6, 3))
    tmp124 = einsum(t1, (0, 1), tmp123, (2, 3, 4, 0, 5, 6), (2, 3, 4, 1, 5, 6))
    del tmp123
    tmp82 = einsum(t2, (0, 1, 2, 3), tmp81, (1, 4), (0, 4, 3, 2))
    del tmp81
    tmp79 = einsum(tmp78, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3))
    del tmp78
    tmp16 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 3, 5), (4, 0, 5, 1))
    tmp26 = einsum(v.ooov, (0, 1, 2, 3), t3, (4, 1, 2, 5, 6, 3), (4, 0, 5, 6))
    tmp29 = einsum(tmp28, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp28
    tmp27 = einsum(tmp2, (0, 1, 2, 3), t3, (1, 4, 2, 5, 6, 3), (0, 4, 5, 6)) * -1
    tmp34 = einsum(tmp33, (0, 1), t2, (2, 3, 1, 4), (2, 3, 4, 0)) * 2
    del tmp33
    tmp38 = einsum(t2, (0, 1, 2, 3), tmp37, (4, 1), (0, 4, 3, 2))
    del tmp37
    tmp36 = einsum(tmp35, (0, 1, 2, 3, 4, 5), v.ovvv, (0, 3, 6, 5), (1, 2, 6, 4))
    del tmp35
    tmp31 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp30, (2, 5), (0, 1, 3, 4))
    del tmp30
    tmp41 = np.copy(t2)
    tmp41 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp18 = einsum(t3, (0, 1, 2, 3, 4, 5), v.ooov, (6, 2, 0, 5), (1, 6, 3, 4)) * -1
    tmp24 = einsum(tmp23, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp23
    tmp22 = einsum(tmp2, (0, 1, 2, 3), t3, (4, 2, 1, 5, 6, 3), (0, 4, 5, 6))
    tmp20 = einsum(tmp19, (0, 1, 2, 3), t2, (3, 2, 4, 5), (0, 1, 5, 4))
    del tmp19
    tmp21 = einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 0, 3, 6, 1), (4, 5, 6, 2)) * -1
    tmp73 = einsum(t1, (0, 1), tmp72, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp72
    tmp68 = einsum(tmp67, (0, 1), t2, (2, 3, 1, 4), (2, 3, 4, 0))
    del tmp67
    tmp76 = einsum(t2, (0, 1, 2, 3), tmp75, (4, 1), (0, 4, 3, 2))
    del tmp75
    tmp62 = einsum(tmp61, (0, 1, 2, 3), t2, (4, 1, 3, 5), (4, 0, 5, 2))
    del tmp61
    tmp65 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp64, (2, 5), (0, 1, 3, 4))
    del tmp64
    tmp45 = einsum(tmp40, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp55 = einsum(t1, (0, 1), tmp54, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp54
    tmp57 = einsum(t2, (0, 1, 2, 3), tmp56, (4, 1), (0, 4, 3, 2))
    del tmp56
    tmp47 = einsum(tmp44, (0, 1, 2, 3), tmp46, (1, 4, 2, 5), (4, 0, 5, 3))
    del tmp46
    tmp43 = einsum(f.vv, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp9 = np.copy(v.ovvv)
    tmp9 += np.transpose(v.ovvv, (0, 2, 3, 1)) * -0.5
    tmp12 = np.copy(v.ooov) * -0.5
    tmp12 += np.transpose(v.ovoo, (0, 2, 3, 1))
    tmp11 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * -1
    tmp11 += np.transpose(v.ovov, (0, 2, 1, 3)) * 2
    tmp14 = np.copy(f.ov) * 0.5
    tmp14 += einsum(tmp13, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    del tmp13
    tmp98 = einsum(tmp97, (0, 1, 2, 3, 4, 5), t1, (2, 6), (0, 1, 3, 6, 4, 5))
    del tmp97
    tmp115 = einsum(t3, (0, 1, 2, 3, 4, 5), f.vv, (6, 5), (0, 2, 1, 6, 3, 4))
    tmp105 = np.copy(tmp102)
    del tmp102
    tmp105 += tmp104
    del tmp104
    tmp92 = einsum(t2, (0, 1, 2, 3), tmp91, (4, 5, 1, 6), (4, 5, 0, 2, 3, 6))
    del tmp91
    tmp112 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 1, 5, 6), (0, 4, 5, 2, 3, 6))
    tmp121 = einsum(tmp48, (0, 1, 2, 3), t2, (4, 2, 5, 6), (0, 4, 1, 5, 6, 3))
    del tmp48
    tmp116 = einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 6, 3), (0, 1, 4, 2, 5, 6))
    tmp128 = np.copy(f.vv)
    tmp128 += einsum(t1, (0, 1), f.ov, (0, 2), (2, 1)) * -1
    tmp118 = einsum(tmp117, (0, 1, 2, 3), t2, (4, 1, 5, 6), (0, 4, 2, 3, 5, 6))
    del tmp117
    tmp127 = einsum(t1, (0, 1), tmp126, (2, 3, 0, 4, 5, 6), (2, 3, 4, 1, 5, 6))
    del tmp126
    tmp100 = einsum(t1, (0, 1), tmp99, (2, 3, 4, 0, 5, 6), (2, 3, 4, 1, 5, 6))
    del tmp99
    tmp114 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp113, (2, 6), (0, 1, 6, 3, 5, 4)) * -1
    tmp120 = einsum(t1, (0, 1), tmp119, (0, 2, 3, 4, 5, 6), (2, 3, 4, 1, 5, 6))
    del tmp119
    tmp111 = np.copy(tmp108)
    del tmp108
    tmp111 += np.transpose(tmp110, (2, 1, 0, 5, 4, 3))
    del tmp110
    tmp125 = np.copy(tmp122)
    del tmp122
    tmp125 += tmp124
    del tmp124
    tmp83 = np.copy(tmp79)
    del tmp79
    tmp83 += np.transpose(tmp82, (1, 0, 3, 2))
    del tmp82
    tmp89 = np.copy(v.oovv) * -1
    tmp89 += einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 1, 5), (4, 0, 5, 3))
    tmp90 = np.copy(np.transpose(v.ovov, (0, 2, 1, 3))) * -1
    tmp90 += tmp16
    tmp84 = np.copy(np.transpose(v.ovov, (0, 2, 1, 3))) * 2
    tmp84 += v.oovv * -1
    tmp84 += tmp60 * 2
    del tmp60
    tmp85 = np.copy(v.oooo)
    tmp85 += einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp39 = np.copy(tmp26)
    del tmp26
    tmp39 += tmp27
    del tmp27
    tmp39 += tmp29
    del tmp29
    tmp39 += tmp31
    del tmp31
    tmp39 += np.transpose(tmp34, (1, 0, 2, 3))
    del tmp34
    tmp39 += np.transpose(tmp36, (0, 1, 3, 2)) * -1
    del tmp36
    tmp39 += np.transpose(tmp38, (0, 1, 3, 2))
    del tmp38
    tmp86 = np.copy(t2)
    tmp86 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp42 = einsum(tmp40, (0, 1, 2, 3), tmp41, (1, 4, 5, 2), (0, 4, 3, 5))
    del tmp40, tmp41
    tmp25 = np.copy(tmp18)
    del tmp18
    tmp25 += tmp20 * -1
    del tmp20
    tmp25 += tmp21
    del tmp21
    tmp25 += tmp22
    del tmp22
    tmp25 += tmp24
    del tmp24
    tmp77 = np.copy(np.transpose(tmp62, (1, 0, 3, 2)))
    del tmp62
    tmp77 += tmp65
    del tmp65
    tmp77 += np.transpose(tmp68, (1, 0, 2, 3))
    del tmp68
    tmp77 += tmp73 * -1
    del tmp73
    tmp77 += np.transpose(tmp76, (0, 1, 3, 2)) * -1
    del tmp76
    tmp88 = np.copy(np.transpose(v.ooov, (0, 2, 1, 3))) * -1
    tmp88 += tmp87
    del tmp87
    tmp58 = np.copy(tmp43)
    del tmp43
    tmp58 += tmp44
    del tmp44
    tmp58 += tmp45 * -1
    del tmp45
    tmp58 += np.transpose(tmp47, (1, 0, 2, 3))
    del tmp47
    tmp58 += tmp55
    del tmp55
    tmp58 += np.transpose(tmp57, (1, 0, 3, 2)) * -1
    del tmp57
    tmp10 = np.copy(f.vv) * 0.5
    tmp10 += einsum(t1, (0, 1), tmp9, (0, 1, 2, 3), (3, 2))
    del tmp9
    tmp1 = np.copy(v.ovvv)
    tmp1 += np.transpose(v.ovvv, (0, 2, 1, 3)) * -0.5
    tmp15 = np.copy(f.oo)
    tmp15 += einsum(tmp11, (0, 1, 2, 3), t2, (4, 0, 3, 2), (1, 4))
    del tmp11
    tmp15 += einsum(t1, (0, 1), tmp12, (0, 2, 3, 1), (3, 2)) * 2
    del tmp12
    tmp15 += einsum(tmp14, (0, 1), t1, (2, 1), (0, 2)) * 2
    del tmp14
    tmp8 = np.copy(np.transpose(v.ovov, (0, 2, 1, 3))) * 2
    tmp8 += v.oovv * -1
    tmp6 = np.copy(f.ov)
    tmp6 += tmp5
    del tmp5
    tmp7 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp7 += t2 * -1
    tmp3 = np.copy(v.ooov)
    tmp3 += np.transpose(v.ooov, (0, 2, 1, 3)) * -0.5
    tmp3 += tmp2 * -0.5
    tmp3 += np.transpose(tmp2, (0, 2, 1, 3))
    del tmp2
    tmp0 = np.copy(np.transpose(t3, (0, 2, 1, 3, 5, 4))) * -3
    tmp0 += np.transpose(t3, (0, 2, 1, 3, 4, 5))
    tmp0 += t3 * -1
    t3new = np.copy(np.transpose(tmp92, (0, 1, 2, 3, 5, 4)))
    t3new += np.transpose(tmp92, (0, 1, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp92, (0, 2, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp92, (0, 2, 1, 5, 3, 4))
    t3new += np.transpose(tmp92, (1, 0, 2, 3, 4, 5))
    t3new += np.transpose(tmp92, (1, 0, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp92, (2, 0, 1, 3, 4, 5)) * -1
    t3new += np.transpose(tmp92, (2, 0, 1, 5, 4, 3))
    t3new += np.transpose(tmp92, (1, 2, 0, 4, 3, 5))
    t3new += np.transpose(tmp92, (1, 2, 0, 5, 3, 4)) * -1
    t3new += np.transpose(tmp92, (2, 1, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp92, (2, 1, 0, 4, 5, 3))
    del tmp92
    t3new += tmp98 * -1
    t3new += np.transpose(tmp98, (0, 1, 2, 5, 4, 3))
    t3new += np.transpose(tmp98, (0, 2, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp98, (0, 2, 1, 5, 3, 4))
    t3new += np.transpose(tmp98, (1, 0, 2, 3, 5, 4)) * -1
    t3new += np.transpose(tmp98, (1, 0, 2, 4, 5, 3))
    t3new += np.transpose(tmp98, (2, 0, 1, 3, 5, 4))
    t3new += np.transpose(tmp98, (2, 0, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp98, (1, 2, 0, 4, 3, 5))
    t3new += np.transpose(tmp98, (1, 2, 0, 5, 3, 4)) * -1
    t3new += np.transpose(tmp98, (2, 1, 0, 3, 4, 5))
    t3new += np.transpose(tmp98, (2, 1, 0, 5, 4, 3)) * -1
    del tmp98
    t3new += tmp100 * -1
    t3new += np.transpose(tmp100, (0, 1, 2, 5, 4, 3))
    t3new += np.transpose(tmp100, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp100, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp100, (1, 0, 2, 4, 3, 5)) * -1
    t3new += np.transpose(tmp100, (1, 0, 2, 5, 3, 4))
    t3new += np.transpose(tmp100, (2, 0, 1, 4, 3, 5))
    t3new += np.transpose(tmp100, (2, 0, 1, 5, 3, 4)) * -1
    t3new += np.transpose(tmp100, (1, 2, 0, 3, 5, 4))
    t3new += np.transpose(tmp100, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp100, (2, 1, 0, 3, 4, 5))
    t3new += np.transpose(tmp100, (2, 1, 0, 5, 4, 3)) * -1
    del tmp100
    t3new += np.transpose(tmp105, (0, 1, 2, 4, 3, 5))
    t3new += np.transpose(tmp105, (0, 1, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp105, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp105, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp105, (1, 0, 2, 3, 4, 5))
    t3new += np.transpose(tmp105, (1, 0, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp105, (2, 0, 1, 3, 4, 5)) * -1
    t3new += np.transpose(tmp105, (2, 0, 1, 5, 4, 3))
    t3new += np.transpose(tmp105, (1, 2, 0, 3, 5, 4))
    t3new += np.transpose(tmp105, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp105, (2, 1, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp105, (2, 1, 0, 5, 3, 4))
    del tmp105
    t3new += np.transpose(tmp111, (0, 1, 2, 3, 5, 4))
    t3new += np.transpose(tmp111, (0, 1, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp111, (0, 2, 1, 3, 4, 5))
    t3new += np.transpose(tmp111, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp111, (1, 0, 2, 4, 3, 5)) * -1
    t3new += np.transpose(tmp111, (1, 0, 2, 5, 3, 4))
    t3new += np.transpose(tmp111, (2, 0, 1, 4, 3, 5))
    t3new += np.transpose(tmp111, (2, 0, 1, 5, 3, 4)) * -1
    t3new += np.transpose(tmp111, (1, 2, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp111, (1, 2, 0, 5, 4, 3))
    t3new += np.transpose(tmp111, (2, 1, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp111, (2, 1, 0, 4, 5, 3))
    del tmp111
    t3new += tmp112 * -1
    t3new += np.transpose(tmp112, (0, 1, 2, 5, 4, 3))
    t3new += np.transpose(tmp112, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp112, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp112, (1, 0, 2, 4, 3, 5)) * -1
    t3new += np.transpose(tmp112, (1, 0, 2, 5, 3, 4))
    t3new += np.transpose(tmp112, (2, 0, 1, 4, 3, 5))
    t3new += np.transpose(tmp112, (2, 0, 1, 5, 3, 4)) * -1
    t3new += np.transpose(tmp112, (1, 2, 0, 3, 5, 4))
    t3new += np.transpose(tmp112, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp112, (2, 1, 0, 3, 4, 5))
    t3new += np.transpose(tmp112, (2, 1, 0, 5, 4, 3)) * -1
    del tmp112
    t3new += np.transpose(tmp114, (2, 1, 0, 4, 5, 3))
    t3new += np.transpose(tmp114, (0, 1, 2, 4, 5, 3)) * -1
    del tmp114
    t3new += np.transpose(tmp115, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp115, (0, 2, 1, 4, 5, 3))
    del tmp115
    t3new += np.transpose(tmp116, (0, 1, 2, 3, 5, 4))
    t3new += np.transpose(tmp116, (0, 1, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp116, (0, 2, 1, 3, 4, 5))
    t3new += np.transpose(tmp116, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp116, (1, 0, 2, 4, 3, 5)) * -1
    t3new += np.transpose(tmp116, (1, 0, 2, 5, 3, 4))
    t3new += np.transpose(tmp116, (2, 0, 1, 4, 3, 5))
    t3new += np.transpose(tmp116, (2, 0, 1, 5, 3, 4)) * -1
    t3new += np.transpose(tmp116, (1, 2, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp116, (1, 2, 0, 5, 4, 3))
    t3new += np.transpose(tmp116, (2, 1, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp116, (2, 1, 0, 4, 5, 3))
    del tmp116
    t3new += tmp118
    t3new += np.transpose(tmp118, (0, 1, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp118, (0, 2, 1, 3, 5, 4))
    t3new += np.transpose(tmp118, (0, 2, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp118, (1, 0, 2, 4, 3, 5))
    t3new += np.transpose(tmp118, (1, 0, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp118, (2, 0, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp118, (2, 0, 1, 5, 3, 4))
    t3new += np.transpose(tmp118, (1, 2, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp118, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp118, (2, 1, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp118, (2, 1, 0, 5, 4, 3))
    del tmp118
    t3new += np.transpose(tmp120, (0, 2, 1, 3, 5, 4))
    t3new += np.transpose(tmp120, (0, 2, 1, 4, 5, 3)) * -1
    del tmp120
    t3new += np.transpose(tmp121, (0, 1, 2, 4, 3, 5))
    t3new += np.transpose(tmp121, (0, 1, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp121, (0, 2, 1, 3, 4, 5))
    t3new += np.transpose(tmp121, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp121, (1, 0, 2, 3, 5, 4)) * -1
    t3new += np.transpose(tmp121, (1, 0, 2, 4, 5, 3))
    t3new += np.transpose(tmp121, (2, 0, 1, 3, 5, 4))
    t3new += np.transpose(tmp121, (2, 0, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp121, (1, 2, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp121, (1, 2, 0, 5, 4, 3))
    t3new += np.transpose(tmp121, (2, 1, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp121, (2, 1, 0, 5, 3, 4))
    del tmp121
    t3new += np.transpose(tmp125, (0, 1, 2, 4, 3, 5)) * -1
    t3new += np.transpose(tmp125, (0, 1, 2, 5, 3, 4))
    t3new += np.transpose(tmp125, (0, 2, 1, 3, 5, 4))
    t3new += np.transpose(tmp125, (0, 2, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp125, (1, 0, 2, 3, 4, 5)) * -1
    t3new += np.transpose(tmp125, (1, 0, 2, 5, 4, 3))
    t3new += np.transpose(tmp125, (2, 0, 1, 3, 4, 5))
    t3new += np.transpose(tmp125, (2, 0, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp125, (1, 2, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp125, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp125, (2, 1, 0, 4, 3, 5))
    t3new += np.transpose(tmp125, (2, 1, 0, 5, 3, 4)) * -1
    del tmp125
    t3new += np.transpose(tmp127, (0, 1, 2, 3, 5, 4))
    t3new += np.transpose(tmp127, (0, 1, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp127, (0, 2, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp127, (0, 2, 1, 5, 3, 4))
    t3new += np.transpose(tmp127, (1, 0, 2, 3, 4, 5))
    t3new += np.transpose(tmp127, (1, 0, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp127, (2, 0, 1, 3, 4, 5)) * -1
    t3new += np.transpose(tmp127, (2, 0, 1, 5, 4, 3))
    t3new += np.transpose(tmp127, (1, 2, 0, 4, 3, 5))
    t3new += np.transpose(tmp127, (1, 2, 0, 5, 3, 4)) * -1
    t3new += np.transpose(tmp127, (2, 1, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp127, (2, 1, 0, 4, 5, 3))
    del tmp127
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), tmp128, (4, 6), (0, 1, 2, 3, 6, 5))
    del tmp128
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), tmp113, (1, 6), (0, 6, 2, 3, 4, 5)) * -1
    del tmp113
    t2new = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 2, 5)) * -1
    t2new += tmp16 * -1
    del tmp16
    t2new += einsum(v.oovv, (0, 1, 2, 3), t2, (4, 1, 3, 5), (4, 0, 2, 5)) * -1
    t2new += einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 5, 3), (0, 4, 1, 5)) * 2
    t2new += np.transpose(v.ovov, (0, 2, 1, 3))
    t2new += einsum(v.ovoo, (0, 1, 2, 3), t1, (3, 4), (0, 2, 1, 4)) * -1
    t2new += einsum(tmp17, (0, 1, 2, 3), t2, (2, 3, 4, 5), (1, 0, 5, 4))
    del tmp17
    t2new += np.transpose(tmp25, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp25, (1, 0, 2, 3)) * -1
    del tmp25
    t2new += tmp39 * -1
    t2new += np.transpose(tmp39, (1, 0, 3, 2)) * -1
    del tmp39
    t2new += np.transpose(tmp42, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp42, (1, 0, 2, 3)) * -1
    del tmp42
    t2new += np.transpose(tmp58, (0, 1, 3, 2))
    t2new += np.transpose(tmp58, (1, 0, 2, 3))
    del tmp58
    t2new += tmp77
    t2new += np.transpose(tmp77, (1, 0, 3, 2))
    del tmp77
    t2new += np.transpose(tmp83, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp83, (1, 0, 2, 3)) * -1
    del tmp83
    t2new += einsum(t2, (0, 1, 2, 3), tmp84, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp84
    t2new += einsum(tmp86, (0, 1, 2, 3), tmp85, (0, 4, 5, 1), (5, 4, 3, 2))
    del tmp85
    t2new += einsum(tmp86, (0, 1, 2, 3), v.vvvv, (4, 3, 5, 2), (1, 0, 4, 5))
    del tmp86
    t2new += einsum(t1, (0, 1), tmp88, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp88
    t2new += einsum(tmp89, (0, 1, 2, 3), t2, (4, 1, 3, 5), (0, 4, 5, 2))
    del tmp89
    t2new += einsum(tmp90, (0, 1, 2, 3), t2, (4, 1, 3, 5), (0, 4, 2, 5))
    del tmp90
    t1new = np.copy(f.ov)
    t1new += einsum(v.ovov, (0, 1, 2, 3), t3, (4, 2, 0, 5, 1, 3), (4, 5)) * -0.5
    t1new += einsum(tmp0, (0, 1, 2, 3, 4, 5), v.ovov, (0, 3, 2, 5), (1, 4)) * -0.5
    del tmp0
    t1new += einsum(t2, (0, 1, 2, 3), tmp1, (1, 3, 2, 4), (0, 4)) * 2
    del tmp1
    t1new += einsum(tmp3, (0, 1, 2, 3), t2, (2, 1, 3, 4), (0, 4)) * -2
    del tmp3
    t1new += einsum(tmp7, (0, 1, 2, 3), tmp6, (0, 3), (1, 2))
    del tmp7, tmp6
    t1new += einsum(t1, (0, 1), tmp8, (0, 2, 1, 3), (2, 3))
    del tmp8
    t1new += einsum(t1, (0, 1), tmp10, (1, 2), (0, 2)) * 2
    del tmp10
    t1new += einsum(t1, (0, 1), tmp15, (0, 2), (2, 1)) * -1
    del tmp15

    return {f"t1new": t1new, f"t2new": t2new, f"t3new": t3new}

