"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T15:31:16.748192
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:31:17.460418.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * -0.5
    tmp0 += np.transpose(v.ovov, (0, 2, 1, 3))
    tmp1 = np.copy(f.ov)
    tmp1 += einsum(t1, (0, 1), tmp0, (0, 2, 1, 3), (2, 3))
    del tmp0
    e_cc = einsum(v.ovov, (0, 1, 2, 3), t2, (0, 2, 1, 3), ()) * 2
    e_cc += einsum(v.ovov, (0, 1, 2, 3), t2, (0, 2, 3, 1), ()) * -1
    e_cc += einsum(t1, (0, 1), tmp1, (0, 1), ()) * 2
    del tmp1

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:31:34.060609.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    t1new : array
        Updated T1 residuals.
    t2new : array
        Updated T2 residuals.
    """

    tmp2 = einsum(t1, (0, 1), v.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp4 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * -1
    tmp4 += np.transpose(v.ovov, (0, 2, 1, 3)) * 2
    tmp43 = np.copy(tmp2) * -1
    tmp43 += np.transpose(tmp2, (0, 2, 1, 3)) * 2
    tmp5 = einsum(t1, (0, 1), tmp4, (0, 2, 1, 3), (2, 3))
    tmp25 = einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    tmp25 += np.transpose(t2, (0, 1, 3, 2)) * -2
    tmp25 += t2
    tmp9 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp42 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 1, 3, 5), (4, 0, 2, 5))
    tmp44 = einsum(t2, (0, 1, 2, 3), tmp43, (4, 5, 1, 3), (4, 5, 0, 2))
    del tmp43
    tmp47 = np.copy(v.ooov) * -1
    tmp47 += np.transpose(v.ovoo, (0, 2, 3, 1)) * 2
    tmp36 = einsum(tmp4, (0, 1, 2, 3), t2, (4, 0, 5, 2), (1, 4, 3, 5))
    del tmp4
    tmp35 = einsum(t1, (0, 1), tmp2, (2, 3, 0, 4), (2, 3, 1, 4))
    tmp39 = np.copy(v.ovvv) * -1
    tmp39 += np.transpose(v.ovvv, (0, 2, 1, 3)) * 2
    tmp22 = einsum(t1, (0, 1), v.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp27 = einsum(tmp5, (0, 1), t2, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp26 = einsum(v.ooov, (0, 1, 2, 3), tmp25, (2, 4, 5, 3), (0, 1, 4, 5))
    del tmp25
    tmp23 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp24 = einsum(t2, (0, 1, 2, 3), tmp2, (4, 5, 1, 2), (4, 0, 5, 3))
    tmp56 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1)))
    tmp56 += np.transpose(v.ovov, (0, 2, 1, 3)) * -0.5
    tmp53 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * -0.5
    tmp53 += np.transpose(v.ovov, (0, 2, 1, 3))
    tmp60 = einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp62 = np.copy(f.oo)
    tmp62 += tmp9
    tmp45 = np.copy(tmp2)
    tmp45 += tmp42 * -1
    del tmp42
    tmp45 += np.transpose(tmp44, (0, 2, 1, 3))
    del tmp44
    tmp48 = einsum(tmp47, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    del tmp47
    tmp37 = np.copy(tmp35)
    del tmp35
    tmp37 += np.transpose(tmp36, (1, 0, 3, 2)) * -1
    tmp40 = einsum(tmp39, (0, 1, 2, 3), t1, (0, 2), (1, 3))
    del tmp39
    tmp28 = np.copy(np.transpose(tmp22, (0, 2, 1, 3))) * -1
    del tmp22
    tmp28 += np.transpose(tmp23, (0, 2, 1, 3))
    del tmp23
    tmp28 += np.transpose(tmp24, (0, 2, 1, 3))
    del tmp24
    tmp28 += np.transpose(tmp26, (2, 1, 0, 3))
    del tmp26
    tmp28 += np.transpose(tmp27, (2, 0, 1, 3)) * -1
    del tmp27
    tmp20 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp20 += t2 * -1
    tmp17 = einsum(t1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp30 = einsum(t1, (0, 1), tmp5, (2, 1), (2, 0))
    tmp18 = einsum(t1, (0, 1), v.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp57 = einsum(tmp56, (0, 1, 2, 3), t2, (4, 0, 2, 3), (1, 4)) * 2
    del tmp56
    tmp54 = einsum(tmp53, (0, 1, 2, 3), t2, (0, 1, 2, 4), (3, 4))
    del tmp53
    tmp51 = einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp65 = einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp61 = einsum(t1, (0, 1), tmp60, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp60
    tmp63 = einsum(t2, (0, 1, 2, 3), tmp62, (1, 4), (4, 0, 3, 2))
    del tmp62
    tmp46 = einsum(t1, (0, 1), tmp45, (2, 3, 0, 4), (2, 3, 4, 1))
    del tmp45
    tmp49 = einsum(t2, (0, 1, 2, 3), tmp48, (4, 1), (4, 0, 3, 2))
    del tmp48
    tmp38 = einsum(tmp37, (0, 1, 2, 3), t2, (4, 1, 3, 5), (0, 4, 2, 5))
    del tmp37
    tmp41 = einsum(tmp40, (0, 1), t2, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp40
    tmp16 = einsum(t2, (0, 1, 2, 3), f.vv, (4, 3), (0, 1, 4, 2))
    tmp29 = einsum(t1, (0, 1), tmp28, (2, 0, 3, 4), (2, 3, 4, 1))
    del tmp28
    tmp21 = einsum(tmp20, (0, 1, 2, 3), tmp17, (4, 0, 3, 5), (1, 4, 2, 5))
    del tmp20
    tmp31 = einsum(t2, (0, 1, 2, 3), tmp30, (1, 4), (4, 0, 3, 2))
    del tmp30
    tmp19 = einsum(t2, (0, 1, 2, 3), tmp18, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp14 = einsum(t1, (0, 1), tmp2, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp33 = np.copy(t2)
    tmp33 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    tmp15 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 5, 1, 2), (0, 4, 3, 5))
    tmp58 = einsum(tmp57, (0, 1), t2, (2, 0, 3, 4), (1, 2, 4, 3))
    del tmp57
    tmp55 = einsum(tmp54, (0, 1), t2, (2, 3, 0, 4), (2, 3, 1, 4)) * 2
    del tmp54
    tmp52 = einsum(tmp51, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp51
    tmp11 = np.copy(v.ooov) * -0.5
    tmp11 += np.transpose(v.ovoo, (0, 2, 3, 1))
    tmp10 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * -1
    tmp10 += np.transpose(v.ovov, (0, 2, 1, 3)) * 2
    tmp0 = np.copy(t2)
    tmp0 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    tmp66 = einsum(t2, (0, 1, 2, 3), tmp65, (4, 5, 1, 0), (4, 5, 3, 2))
    del tmp65
    tmp64 = np.copy(tmp61)
    del tmp61
    tmp64 += np.transpose(tmp63, (0, 1, 3, 2))
    del tmp63
    tmp13 = einsum(t1, (0, 1), v.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp50 = np.copy(tmp38)
    del tmp38
    tmp50 += np.transpose(tmp41, (1, 0, 3, 2))
    del tmp41
    tmp50 += np.transpose(tmp46, (0, 1, 3, 2)) * -1
    del tmp46
    tmp50 += np.transpose(tmp49, (1, 0, 3, 2)) * -1
    del tmp49
    tmp67 = np.copy(np.transpose(v.ovov, (0, 2, 1, 3))) * 2
    tmp67 += v.oovv * -1
    tmp67 += np.transpose(tmp36, (1, 0, 3, 2)) * 2
    del tmp36
    tmp32 = np.copy(tmp16)
    del tmp16
    tmp32 += tmp17
    del tmp17
    tmp32 += tmp19 * -1
    del tmp19
    tmp32 += np.transpose(tmp21, (1, 0, 2, 3))
    del tmp21
    tmp32 += np.transpose(tmp29, (0, 1, 3, 2))
    del tmp29
    tmp32 += np.transpose(tmp31, (0, 1, 3, 2)) * -1
    del tmp31
    tmp69 = np.copy(np.transpose(v.ooov, (0, 2, 1, 3))) * -1
    tmp69 += einsum(tmp14, (0, 1, 2, 3), t1, (2, 4), (1, 0, 3, 4))
    tmp70 = np.copy(v.oovv) * -1
    tmp70 += einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp34 = einsum(tmp18, (0, 1, 2, 3), tmp33, (1, 4, 5, 2), (0, 4, 3, 5))
    del tmp18, tmp33
    tmp68 = np.copy(v.oooo)
    tmp68 += einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp71 = np.copy(np.transpose(v.ovov, (0, 2, 1, 3))) * -1
    tmp71 += tmp15
    tmp59 = np.copy(tmp52)
    del tmp52
    tmp59 += np.transpose(tmp55, (1, 0, 3, 2))
    del tmp55
    tmp59 += np.transpose(tmp58, (1, 0, 3, 2))
    del tmp58
    tmp12 = np.copy(f.oo)
    tmp12 += tmp9
    del tmp9
    tmp12 += einsum(tmp10, (0, 1, 2, 3), tmp0, (0, 4, 2, 3), (1, 4))
    del tmp10
    tmp12 += einsum(tmp11, (0, 1, 2, 3), t1, (0, 3), (2, 1)) * 2
    del tmp11
    tmp6 = np.copy(f.ov)
    tmp6 += tmp5
    del tmp5
    tmp1 = np.copy(v.ovvv) * -0.5
    tmp1 += np.transpose(v.ovvv, (0, 2, 1, 3))
    tmp3 = np.copy(v.ooov) * -0.5
    tmp3 += np.transpose(v.ooov, (0, 2, 1, 3))
    tmp3 += tmp2
    tmp3 += np.transpose(tmp2, (0, 2, 1, 3)) * -0.5
    del tmp2
    tmp8 = np.copy(np.transpose(v.ovov, (0, 2, 1, 3))) * 2
    tmp8 += v.oovv * -1
    tmp7 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp7 += t2 * 2
    t2new = einsum(t2, (0, 1, 2, 3), v.vvvv, (4, 2, 5, 3), (0, 1, 4, 5))
    t2new += einsum(t1, (0, 1), tmp13, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp13
    t2new += einsum(t1, (0, 1), v.ovoo, (2, 3, 4, 0), (2, 4, 3, 1)) * -1
    t2new += np.transpose(v.ovov, (0, 2, 1, 3))
    t2new += einsum(t2, (0, 1, 2, 3), tmp14, (4, 5, 0, 1), (5, 4, 3, 2))
    del tmp14
    t2new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 5, 3), (0, 4, 2, 5)) * -1
    t2new += tmp15 * -1
    del tmp15
    t2new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 5, 2), (4, 0, 3, 5)) * -1
    t2new += einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 5, 3), (4, 0, 5, 1)) * 2
    t2new += np.transpose(tmp32, (0, 1, 3, 2))
    t2new += np.transpose(tmp32, (1, 0, 2, 3))
    del tmp32
    t2new += np.transpose(tmp34, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp34, (1, 0, 2, 3)) * -1
    del tmp34
    t2new += tmp50
    t2new += np.transpose(tmp50, (1, 0, 3, 2))
    del tmp50
    t2new += tmp59 * -1
    t2new += np.transpose(tmp59, (1, 0, 3, 2)) * -1
    del tmp59
    t2new += np.transpose(tmp64, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp64, (1, 0, 2, 3)) * -1
    del tmp64
    t2new += np.transpose(tmp66, (0, 1, 3, 2))
    t2new += np.transpose(tmp66, (1, 0, 2, 3))
    del tmp66
    t2new += einsum(tmp67, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp67
    t2new += einsum(tmp68, (0, 1, 2, 3), tmp0, (0, 3, 4, 5), (2, 1, 5, 4))
    del tmp68
    t2new += einsum(t1, (0, 1), tmp69, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp69
    t2new += einsum(t2, (0, 1, 2, 3), tmp70, (4, 1, 5, 2), (0, 4, 5, 3))
    del tmp70
    t2new += einsum(t2, (0, 1, 2, 3), tmp71, (4, 1, 5, 2), (4, 0, 5, 3))
    del tmp71
    t1new = np.copy(f.ov)
    t1new += einsum(t1, (0, 1), f.vv, (2, 1), (0, 2))
    t1new += einsum(tmp0, (0, 1, 2, 3), tmp1, (0, 3, 2, 4), (1, 4)) * 2
    del tmp0, tmp1
    t1new += einsum(tmp3, (0, 1, 2, 3), t2, (1, 2, 3, 4), (0, 4)) * -2
    del tmp3
    t1new += einsum(tmp6, (0, 1), tmp7, (0, 2, 1, 3), (2, 3))
    del tmp6, tmp7
    t1new += einsum(t1, (0, 1), tmp8, (0, 2, 1, 3), (2, 3))
    del tmp8
    t1new += einsum(t1, (0, 1), tmp12, (0, 2), (2, 1)) * -1
    del tmp12

    return {f"t1new": t1new, f"t2new": t2new}

def update_lams(f=None, l1=None, l2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:32:31.373193.

    Parameters
    ----------
    f : array
        Fock matrix.
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    l1new : array
        Updated L1 residuals.
    l2new : array
        Updated L2 residuals.
    """

    tmp51 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * -1
    tmp51 += np.transpose(v.ovov, (0, 2, 1, 3)) * 2
    tmp5 = einsum(t1, (0, 1), v.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp20 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -0.5
    tmp20 += t2
    tmp46 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp46 += t2 * 2
    tmp82 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp82 += t2 * 2
    tmp92 = einsum(t1, (0, 1), tmp51, (0, 2, 1, 3), (2, 3))
    tmp6 = einsum(t1, (0, 1), tmp5, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp4 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp47 = einsum(t1, (0, 1), l1, (1, 2), (2, 0))
    tmp57 = einsum(tmp20, (0, 1, 2, 3), l2, (2, 3, 0, 4), (4, 1)) * 2
    tmp110 = einsum(tmp46, (0, 1, 2, 3), v.ovov, (4, 3, 0, 2), (4, 1)) * 0.5
    tmp109 = einsum(t1, (0, 1), v.ooov, (2, 3, 0, 1), (2, 3))
    tmp70 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp2 = einsum(t1, (0, 1), v.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp21 = einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp83 = einsum(tmp82, (0, 1, 2, 3), v.ovov, (4, 5, 0, 2), (4, 1, 5, 3))
    del tmp82
    tmp80 = einsum(t1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp81 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp93 = einsum(t1, (0, 1), tmp92, (2, 1), (0, 2))
    tmp91 = einsum(t1, (0, 1), v.ooov, (2, 0, 3, 1), (2, 3))
    tmp10 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * -0.5
    tmp10 += np.transpose(v.ovov, (0, 2, 1, 3))
    tmp7 = np.copy(np.transpose(tmp4, (1, 0, 3, 2)))
    del tmp4
    tmp7 += tmp6
    del tmp6
    tmp58 = np.copy(tmp47)
    tmp58 += tmp57
    del tmp57
    tmp102 = einsum(l2, (0, 1, 2, 3), tmp20, (3, 2, 1, 4), (0, 4)) * 2
    tmp107 = einsum(v.ovov, (0, 1, 2, 3), tmp46, (0, 2, 1, 4), (3, 4)) * 0.5
    tmp111 = np.copy(np.transpose(tmp109, (1, 0)))
    del tmp109
    tmp111 += np.transpose(tmp110, (1, 0))
    del tmp110
    tmp71 = np.copy(v.oovv)
    tmp71 += np.transpose(tmp2, (0, 1, 3, 2))
    tmp71 += tmp70 * -1
    del tmp70
    tmp87 = np.copy(tmp21) * -1
    tmp87 += np.transpose(tmp21, (1, 0, 2, 3)) * 2
    tmp79 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * -1
    tmp79 += np.transpose(l2, (2, 3, 0, 1)) * 2
    tmp84 = np.copy(np.transpose(v.ovov, (0, 2, 1, 3)))
    tmp84 += np.transpose(tmp80, (0, 1, 3, 2))
    del tmp80
    tmp84 += tmp81 * -1
    del tmp81
    tmp84 += np.transpose(tmp83, (1, 0, 3, 2))
    del tmp83
    tmp75 = einsum(t1, (0, 1), v.ovvv, (0, 1, 2, 3), (2, 3))
    tmp94 = np.copy(tmp91)
    del tmp91
    tmp94 += tmp93 * -1
    del tmp93
    tmp89 = np.copy(tmp5) * -1
    tmp89 += np.transpose(tmp5, (0, 2, 1, 3)) * 2
    tmp64 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp16 = einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp11 = einsum(t1, (0, 1), tmp10, (0, 2, 1, 3), (2, 3)) * 2
    tmp8 = einsum(tmp7, (0, 1, 2, 3), t1, (2, 4), (0, 1, 3, 4))
    tmp1 = einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp3 = einsum(t1, (0, 1), tmp2, (2, 3, 4, 1), (2, 0, 3, 4))
    del tmp2
    tmp36 = einsum(tmp21, (0, 1, 2, 3), t1, (4, 3), (1, 0, 2, 4))
    tmp48 = einsum(tmp20, (0, 1, 2, 3), l2, (2, 3, 0, 4), (4, 1))
    tmp39 = einsum(l2, (0, 1, 2, 3), t2, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp98 = einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 1), (2, 3))
    tmp101 = einsum(l1, (0, 1), tmp5, (1, 2, 3, 4), (2, 3, 0, 4))
    tmp104 = einsum(v.ovov, (0, 1, 2, 3), tmp58, (4, 2), (0, 4, 3, 1))
    tmp103 = einsum(tmp102, (0, 1), v.ovov, (2, 1, 3, 4), (2, 3, 4, 0))
    del tmp102
    tmp100 = einsum(l2, (0, 1, 2, 3), f.oo, (4, 3), (4, 2, 0, 1))
    tmp108 = einsum(tmp107, (0, 1), l2, (2, 1, 3, 4), (4, 3, 2, 0)) * 2
    del tmp107
    tmp106 = einsum(v.ooov, (0, 1, 2, 3), l1, (4, 1), (0, 2, 4, 3))
    tmp112 = einsum(tmp111, (0, 1), l2, (2, 3, 0, 4), (4, 1, 2, 3)) * 2
    del tmp111
    tmp74 = einsum(tmp21, (0, 1, 2, 3), v.ooov, (4, 1, 2, 5), (0, 4, 3, 5))
    tmp86 = einsum(l2, (0, 1, 2, 3), tmp71, (3, 4, 1, 5), (2, 4, 0, 5))
    tmp88 = einsum(v.ovoo, (0, 1, 2, 3), tmp87, (2, 4, 3, 5), (0, 4, 1, 5))
    del tmp87
    tmp78 = einsum(tmp5, (0, 1, 2, 3), tmp21, (0, 4, 2, 5), (4, 1, 5, 3))
    tmp85 = einsum(tmp79, (0, 1, 2, 3), tmp84, (0, 4, 2, 5), (1, 4, 3, 5))
    del tmp79, tmp84
    tmp76 = einsum(tmp75, (0, 1), l2, (2, 1, 3, 4), (3, 4, 2, 0))
    del tmp75
    tmp96 = einsum(tmp92, (0, 1), tmp21, (2, 3, 0, 4), (2, 3, 4, 1))
    tmp95 = einsum(tmp94, (0, 1), l2, (2, 3, 0, 4), (4, 1, 2, 3))
    del tmp94
    tmp90 = einsum(tmp21, (0, 1, 2, 3), tmp89, (1, 2, 4, 5), (0, 4, 3, 5))
    del tmp89
    tmp77 = einsum(tmp21, (0, 1, 2, 3), v.ovvv, (2, 4, 5, 3), (1, 0, 4, 5))
    tmp66 = einsum(tmp21, (0, 1, 2, 3), f.ov, (2, 4), (0, 1, 4, 3))
    tmp62 = einsum(l2, (0, 1, 2, 3), f.vv, (4, 1), (2, 3, 4, 0))
    tmp63 = einsum(l1, (0, 1), v.ovvv, (2, 3, 4, 0), (1, 2, 3, 4))
    tmp68 = einsum(v.ooov, (0, 1, 2, 3), tmp21, (1, 4, 2, 5), (4, 0, 5, 3))
    tmp65 = einsum(tmp64, (0, 1), l2, (2, 3, 4, 1), (0, 4, 2, 3))
    del tmp64
    tmp72 = einsum(tmp71, (0, 1, 2, 3), l2, (4, 2, 0, 5), (5, 1, 4, 3))
    del tmp71
    tmp67 = einsum(l2, (0, 1, 2, 3), tmp16, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp69 = einsum(tmp5, (0, 1, 2, 3), tmp21, (0, 4, 1, 5), (4, 2, 5, 3))
    tmp60 = np.copy(f.ov)
    tmp60 += tmp11
    tmp59 = np.copy(v.ooov) * -0.5
    tmp59 += np.transpose(v.ovoo, (0, 2, 3, 1))
    tmp12 = einsum(tmp11, (0, 1), t2, (2, 3, 1, 4), (2, 3, 0, 4)) * 0.5
    del tmp11
    tmp9 = np.copy(tmp1)
    del tmp1
    tmp9 += tmp3
    del tmp3
    tmp9 += np.transpose(tmp8, (1, 0, 2, 3)) * -1
    del tmp8
    tmp14 = np.copy(np.transpose(t2, (0, 1, 3, 2)))
    tmp14 += t2 * -0.5
    tmp17 = np.copy(np.transpose(v.oooo, (0, 2, 1, 3))) * -1
    tmp17 += v.oooo * 2
    tmp17 += np.transpose(tmp16, (2, 1, 0, 3)) * 2
    tmp17 += np.transpose(tmp16, (3, 2, 0, 1)) * -1
    tmp0 = einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp13 = np.copy(v.ooov)
    tmp13 += np.transpose(v.ooov, (0, 2, 1, 3)) * -0.5
    tmp13 += tmp5 * -0.5
    tmp13 += np.transpose(tmp5, (0, 2, 1, 3))
    tmp15 = np.copy(np.transpose(v.ovov, (0, 2, 1, 3))) * 2
    tmp15 += v.oovv * -1
    tmp26 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * -1
    tmp26 += np.transpose(l2, (2, 3, 0, 1)) * 2
    tmp33 = np.copy(tmp21) * 2
    tmp33 += np.transpose(tmp21, (1, 0, 2, 3)) * -1
    tmp35 = einsum(l1, (0, 1), t2, (2, 3, 4, 0), (1, 2, 3, 4))
    tmp37 = einsum(tmp36, (0, 1, 2, 3), t1, (0, 4), (1, 3, 2, 4))
    tmp49 = np.copy(tmp47) * 0.5
    del tmp47
    tmp49 += tmp48
    del tmp48
    tmp29 = np.copy(v.ooov) * -1
    tmp29 += np.transpose(v.ooov, (0, 2, 1, 3)) * 2
    tmp29 += tmp5 * 2
    tmp29 += np.transpose(tmp5, (0, 2, 1, 3)) * -1
    tmp28 = np.copy(v.ooov) * 2
    tmp28 += np.transpose(v.ooov, (0, 2, 1, 3)) * -1
    tmp28 += tmp5 * -1
    tmp28 += np.transpose(tmp5, (0, 2, 1, 3)) * 2
    del tmp5
    tmp31 = np.copy(np.transpose(tmp16, (0, 2, 1, 3))) * -1
    tmp31 += np.transpose(tmp16, (0, 3, 2, 1)) * 2
    del tmp16
    tmp30 = np.copy(np.transpose(v.ovov, (0, 2, 1, 3))) * -1
    tmp30 += v.oovv * 2
    tmp22 = np.copy(tmp21) * -0.5
    tmp22 += np.transpose(tmp21, (1, 0, 2, 3))
    tmp40 = einsum(tmp39, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    tmp19 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp19 += t2 * -1
    tmp54 = np.copy(v.ovvv) * -0.5
    tmp54 += np.transpose(v.ovvv, (0, 2, 1, 3))
    tmp99 = einsum(tmp98, (0, 1), l2, (2, 1, 3, 4), (3, 4, 2, 0))
    del tmp98
    tmp105 = np.copy(tmp100)
    del tmp100
    tmp105 += tmp101
    del tmp101
    tmp105 += np.transpose(tmp103, (1, 0, 3, 2))
    del tmp103
    tmp105 += np.transpose(tmp104, (1, 0, 3, 2))
    del tmp104
    tmp113 = np.copy(tmp106)
    del tmp106
    tmp113 += np.transpose(tmp108, (1, 0, 2, 3))
    del tmp108
    tmp113 += np.transpose(tmp112, (0, 1, 3, 2))
    del tmp112
    tmp97 = einsum(l1, (0, 1), f.ov, (2, 3), (2, 1, 3, 0))
    tmp97 += tmp74
    del tmp74
    tmp97 += tmp76 * 2
    del tmp76
    tmp97 += tmp77 * -1
    del tmp77
    tmp97 += tmp78
    del tmp78
    tmp97 += tmp85
    del tmp85
    tmp97 += tmp86 * -1
    del tmp86
    tmp97 += np.transpose(tmp88, (1, 0, 3, 2)) * -1
    del tmp88
    tmp97 += tmp90 * -1
    del tmp90
    tmp97 += np.transpose(tmp95, (0, 1, 3, 2))
    del tmp95
    tmp97 += tmp96 * -1
    del tmp96
    tmp97 += einsum(l1, (0, 1), tmp92, (2, 3), (1, 2, 0, 3))
    del tmp92
    tmp73 = np.copy(tmp62)
    del tmp62
    tmp73 += tmp63
    del tmp63
    tmp73 += tmp65 * -1
    del tmp65
    tmp73 += tmp66 * -1
    del tmp66
    tmp73 += tmp67
    del tmp67
    tmp73 += tmp68
    del tmp68
    tmp73 += tmp69
    del tmp69
    tmp73 += tmp72 * -1
    del tmp72
    tmp45 = np.copy(v.ovvv) * 2
    tmp45 += np.transpose(v.ovvv, (0, 2, 1, 3)) * -1
    tmp61 = np.copy(f.oo)
    tmp61 += einsum(tmp46, (0, 1, 2, 3), v.ovov, (4, 3, 0, 2), (1, 4))
    tmp61 += einsum(t1, (0, 1), tmp59, (0, 2, 3, 1), (2, 3)) * 2
    del tmp59
    tmp61 += einsum(tmp60, (0, 1), t1, (2, 1), (2, 0))
    del tmp60
    tmp53 = np.copy(np.transpose(v.ovov, (0, 2, 1, 3))) * 2
    tmp53 += v.oovv * -1
    tmp18 = np.copy(np.transpose(v.ooov, (0, 2, 1, 3))) * -1
    tmp18 += np.transpose(v.ovoo, (0, 2, 3, 1)) * 0.5
    tmp18 += np.transpose(tmp0, (1, 2, 0, 3)) * 0.5
    tmp18 += np.transpose(tmp0, (2, 1, 0, 3)) * -1
    del tmp0
    tmp18 += tmp9 * -1
    tmp18 += np.transpose(tmp9, (1, 0, 2, 3)) * 0.5
    del tmp9
    tmp18 += np.transpose(tmp12, (1, 0, 2, 3))
    tmp18 += tmp12 * -2
    del tmp12
    tmp18 += einsum(tmp13, (0, 1, 2, 3), tmp14, (2, 4, 5, 3), (0, 4, 1, 5)) * -2
    del tmp13
    tmp18 += einsum(t1, (0, 1), tmp15, (2, 3, 1, 4), (0, 3, 2, 4)) * -0.5
    del tmp15
    tmp18 += einsum(tmp17, (0, 1, 2, 3), t1, (0, 4), (2, 1, 3, 4)) * 0.5
    del tmp17
    tmp27 = np.copy(np.transpose(l2, (2, 3, 0, 1)))
    tmp27 += einsum(tmp26, (0, 1, 2, 3), tmp20, (0, 4, 2, 5), (1, 4, 3, 5))
    del tmp26
    tmp38 = np.copy(tmp35) * -0.5
    tmp38 += np.transpose(tmp35, (0, 2, 1, 3))
    del tmp35
    tmp38 += np.transpose(tmp21, (0, 2, 1, 3)) * -0.5
    tmp38 += np.transpose(tmp21, (1, 2, 0, 3))
    tmp38 += tmp37 * -1
    tmp38 += np.transpose(tmp37, (0, 2, 1, 3)) * 0.5
    del tmp37
    tmp38 += einsum(tmp20, (0, 1, 2, 3), tmp33, (0, 4, 5, 2), (4, 5, 1, 3))
    tmp42 = np.copy(tmp21) * 2
    tmp42 += np.transpose(tmp21, (1, 0, 2, 3)) * -1
    tmp50 = np.copy(t1) * -1
    tmp50 += einsum(tmp14, (0, 1, 2, 3), tmp21, (0, 1, 4, 3), (4, 2)) * 2
    del tmp21, tmp14
    tmp50 += einsum(tmp46, (0, 1, 2, 3), l1, (2, 0), (1, 3)) * -1
    del tmp46
    tmp50 += einsum(t1, (0, 1), tmp49, (0, 2), (2, 1)) * 2
    tmp52 = np.copy(v.ooov)
    tmp52 += np.transpose(v.ovoo, (0, 2, 3, 1)) * -0.5
    tmp32 = einsum(t2, (0, 1, 2, 3), tmp28, (4, 5, 1, 3), (4, 0, 5, 2))
    del tmp28
    tmp32 += einsum(tmp29, (0, 1, 2, 3), t2, (4, 2, 3, 5), (0, 4, 1, 5))
    del tmp29
    tmp32 += einsum(t1, (0, 1), tmp30, (2, 3, 1, 4), (0, 3, 2, 4)) * -1
    del tmp30
    tmp32 += einsum(tmp31, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    del tmp31
    tmp24 = einsum(t1, (0, 1), l2, (2, 3, 4, 0), (4, 2, 3, 1))
    tmp43 = np.copy(np.transpose(tmp39, (1, 0, 2, 3)))
    tmp43 += np.transpose(tmp39, (1, 0, 3, 2)) * -0.5
    tmp43 += np.transpose(tmp36, (2, 1, 3, 0))
    tmp43 += np.transpose(tmp36, (3, 1, 2, 0)) * -0.5
    tmp44 = einsum(t1, (0, 1), l1, (2, 0), (2, 1)) * 0.5
    tmp44 += einsum(l2, (0, 1, 2, 3), tmp20, (3, 2, 1, 4), (0, 4))
    tmp41 = np.copy(tmp40) * -1
    tmp41 += np.transpose(tmp40, (0, 2, 1, 3)) * 2
    del tmp40
    tmp41 += einsum(t2, (0, 1, 2, 3), tmp33, (1, 4, 5, 3), (4, 5, 0, 2))
    tmp41 += einsum(t2, (0, 1, 2, 3), tmp22, (1, 4, 5, 2), (4, 5, 0, 3)) * 2
    tmp56 = np.copy(f.ov) * 0.5
    tmp56 += einsum(t1, (0, 1), tmp10, (0, 2, 1, 3), (2, 3))
    del tmp10
    tmp23 = einsum(tmp19, (0, 1, 2, 3), l2, (4, 2, 0, 5), (5, 1, 4, 3))
    del tmp19
    tmp23 += einsum(l2, (0, 1, 2, 3), tmp20, (3, 4, 1, 5), (2, 4, 0, 5)) * 2
    del tmp20
    tmp23 += einsum(tmp22, (0, 1, 2, 3), t1, (1, 4), (0, 2, 4, 3)) * 2
    del tmp22
    tmp25 = np.copy(np.transpose(v.vvvv, (0, 2, 1, 3))) * -1
    tmp25 += v.vvvv * 2
    tmp34 = np.copy(np.transpose(l2, (3, 2, 0, 1)))
    tmp34 += einsum(t1, (0, 1), tmp33, (2, 0, 3, 4), (2, 3, 4, 1))
    del tmp33
    tmp55 = np.copy(f.vv)
    tmp55 += einsum(t1, (0, 1), tmp54, (0, 2, 1, 3), (3, 2)) * 2
    del tmp54
    l2new = einsum(v.oooo, (0, 1, 2, 3), l2, (4, 5, 1, 3), (4, 5, 0, 2))
    l2new += einsum(l2, (0, 1, 2, 3), v.vvvv, (4, 1, 5, 0), (4, 5, 3, 2))
    l2new += np.transpose(v.ovov, (1, 3, 0, 2))
    l2new += einsum(v.ovov, (0, 1, 2, 3), tmp39, (4, 5, 2, 0), (3, 1, 4, 5))
    del tmp39
    l2new += einsum(tmp36, (0, 1, 2, 3), v.ovov, (3, 4, 2, 5), (4, 5, 1, 0))
    del tmp36
    l2new += np.transpose(tmp73, (3, 2, 0, 1))
    l2new += np.transpose(tmp73, (2, 3, 1, 0))
    del tmp73
    l2new += np.transpose(tmp97, (2, 3, 0, 1))
    l2new += np.transpose(tmp97, (3, 2, 1, 0))
    del tmp97
    l2new += np.transpose(tmp99, (2, 3, 0, 1)) * -1
    l2new += np.transpose(tmp99, (3, 2, 1, 0)) * -1
    del tmp99
    l2new += np.transpose(tmp105, (3, 2, 0, 1)) * -1
    l2new += np.transpose(tmp105, (2, 3, 1, 0)) * -1
    del tmp105
    l2new += np.transpose(tmp113, (2, 3, 0, 1)) * -1
    l2new += np.transpose(tmp113, (3, 2, 1, 0)) * -1
    del tmp113
    l2new += einsum(l2, (0, 1, 2, 3), tmp7, (3, 2, 4, 5), (0, 1, 5, 4))
    del tmp7
    l1new = np.copy(np.transpose(f.ov, (1, 0)))
    l1new += einsum(l2, (0, 1, 2, 3), tmp18, (2, 3, 4, 1), (0, 4)) * 2
    del tmp18
    l1new += einsum(tmp23, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 2), (4, 0)) * -1
    del tmp23
    l1new += einsum(tmp24, (0, 1, 2, 3), tmp25, (2, 3, 4, 1), (4, 0))
    del tmp24, tmp25
    l1new += einsum(v.ovvv, (0, 1, 2, 3), tmp27, (4, 0, 3, 1), (2, 4)) * 2
    del tmp27
    l1new += einsum(tmp32, (0, 1, 2, 3), l2, (4, 3, 1, 0), (4, 2))
    del tmp32
    l1new += einsum(tmp34, (0, 1, 2, 3), v.ovvv, (1, 3, 4, 2), (4, 0)) * -1
    del tmp34
    l1new += einsum(tmp38, (0, 1, 2, 3), v.ovov, (2, 3, 1, 4), (4, 0)) * -2
    del tmp38
    l1new += einsum(v.ovov, (0, 1, 2, 3), tmp41, (4, 2, 0, 3), (1, 4))
    del tmp41
    l1new += einsum(tmp42, (0, 1, 2, 3), v.oovv, (1, 2, 4, 3), (4, 0)) * -1
    del tmp42
    l1new += einsum(tmp43, (0, 1, 2, 3), v.ooov, (3, 0, 2, 4), (4, 1)) * 2
    del tmp43
    l1new += einsum(tmp45, (0, 1, 2, 3), tmp44, (3, 2), (1, 0)) * 2
    del tmp45, tmp44
    l1new += einsum(tmp50, (0, 1), tmp51, (0, 2, 1, 3), (3, 2)) * -1
    del tmp51, tmp50
    l1new += einsum(tmp52, (0, 1, 2, 3), tmp49, (1, 0), (3, 2)) * -4
    del tmp49, tmp52
    l1new += einsum(tmp53, (0, 1, 2, 3), l1, (2, 0), (3, 1))
    del tmp53
    l1new += einsum(l1, (0, 1), tmp55, (0, 2), (2, 1))
    del tmp55
    l1new += einsum(tmp58, (0, 1), tmp56, (1, 2), (2, 0)) * -2
    del tmp58, tmp56
    l1new += einsum(tmp61, (0, 1), l1, (2, 0), (2, 1)) * -1
    del tmp61

    return {f"l1new": l1new, f"l2new": l2new}

def make_rdm1_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:32:32.938478.

    Parameters
    ----------
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.

    Returns
    -------
    rdm1 : array
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    delta = Namespace(
        oo=np.eye(t2.shape[0]),
        vv=np.eye(t2.shape[-1]),
    )
    tmp0 = einsum(t1, (0, 1), l1, (1, 2), (2, 0))
    tmp5 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -0.5
    tmp5 += t2
    tmp2 = einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp7 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * -1
    tmp7 += np.transpose(l2, (2, 3, 0, 1)) * 2
    tmp6 = np.copy(tmp0)
    tmp6 += einsum(tmp5, (0, 1, 2, 3), l2, (2, 3, 0, 4), (4, 1)) * 2
    del tmp5
    tmp4 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp4 += t2 * 2
    tmp3 = np.copy(tmp2) * -0.5
    tmp3 += np.transpose(tmp2, (1, 0, 2, 3))
    del tmp2
    tmp1 = np.copy(np.transpose(t2, (0, 1, 3, 2)))
    tmp1 += t2 * -0.5
    rdm1.vv = einsum(t1, (0, 1), l1, (2, 0), (2, 1)) * 2
    rdm1.vv += einsum(t2, (0, 1, 2, 3), tmp7, (0, 1, 2, 4), (4, 3)) * 2
    del tmp7
    rdm1.vo = np.copy(l1) * 2
    rdm1.ov = np.copy(t1) * 2
    rdm1.ov += einsum(t2, (0, 1, 2, 3), tmp3, (1, 0, 4, 2), (4, 3)) * -4
    del tmp3
    rdm1.ov += einsum(l1, (0, 1), tmp4, (1, 2, 0, 3), (2, 3)) * 2
    del tmp4
    rdm1.ov += einsum(t1, (0, 1), tmp6, (0, 2), (2, 1)) * -2
    del tmp6
    rdm1.oo = np.copy(delta.oo) * 2
    del delta
    rdm1.oo += np.transpose(tmp0, (1, 0)) * -2
    del tmp0
    rdm1.oo += einsum(tmp1, (0, 1, 2, 3), l2, (3, 2, 0, 4), (1, 4)) * -4
    del tmp1
    rdm1 = np.block([[rdm1.oo, rdm1.ov], [rdm1.vo, rdm1.vv]])

    return rdm1

def make_rdm2_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:33:45.706624.

    Parameters
    ----------
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.

    Returns
    -------
    rdm2 : array
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    delta = Namespace(
        oo=np.eye(t2.shape[0]),
        vv=np.eye(t2.shape[-1]),
    )
    tmp3 = einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp98 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp98 += t2
    tmp9 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp9 += t2 * 2
    tmp0 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -0.5
    tmp0 += t2
    tmp20 = np.copy(tmp3) * 2
    tmp20 += np.transpose(tmp3, (1, 0, 2, 3)) * -1
    tmp18 = np.copy(tmp3)
    tmp18 += np.transpose(tmp3, (1, 0, 2, 3)) * -1
    tmp45 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * -1
    tmp45 += np.transpose(l2, (2, 3, 0, 1)) * 2
    tmp62 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * 2
    tmp62 += np.transpose(l2, (2, 3, 0, 1)) * -1
    tmp99 = einsum(l2, (0, 1, 2, 3), tmp98, (2, 4, 1, 5), (4, 3, 5, 0))
    del tmp98
    tmp91 = einsum(tmp3, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    tmp97 = einsum(l2, (0, 1, 2, 3), tmp9, (3, 4, 1, 5), (4, 2, 5, 0))
    tmp107 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * -1
    tmp107 += np.transpose(l2, (2, 3, 0, 1)) * 2
    tmp12 = np.copy(tmp3) * 2
    tmp12 += np.transpose(tmp3, (1, 0, 2, 3)) * -1
    tmp1 = einsum(tmp0, (0, 1, 2, 3), l2, (2, 3, 0, 4), (4, 1)) * 2
    tmp21 = einsum(tmp20, (0, 1, 2, 3), t2, (4, 0, 5, 3), (1, 2, 4, 5))
    del tmp20
    tmp25 = einsum(t2, (0, 1, 2, 3), tmp3, (1, 4, 5, 2), (4, 5, 0, 3))
    tmp48 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * -1
    tmp48 += np.transpose(l2, (2, 3, 0, 1))
    tmp4 = einsum(t1, (0, 1), tmp3, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp6 = einsum(t1, (0, 1), l1, (1, 2), (2, 0))
    tmp16 = einsum(l1, (0, 1), t2, (2, 3, 4, 0), (1, 2, 3, 4))
    tmp19 = einsum(t2, (0, 1, 2, 3), tmp18, (1, 4, 5, 2), (4, 5, 0, 3))
    tmp26 = einsum(tmp3, (0, 1, 2, 3), t2, (4, 1, 3, 5), (0, 2, 4, 5))
    tmp33 = einsum(tmp0, (0, 1, 2, 3), l2, (2, 3, 0, 4), (4, 1))
    del tmp0
    tmp2 = einsum(t2, (0, 1, 2, 3), l2, (3, 2, 4, 5), (5, 4, 0, 1))
    tmp117 = einsum(t1, (0, 1), l2, (2, 3, 4, 0), (4, 2, 3, 1))
    tmp67 = einsum(t2, (0, 1, 2, 3), l2, (4, 2, 5, 1), (5, 0, 4, 3))
    tmp46 = einsum(tmp45, (0, 1, 2, 3), t2, (4, 0, 5, 2), (1, 4, 3, 5))
    tmp83 = einsum(t1, (0, 1), l1, (2, 0), (2, 1))
    tmp84 = einsum(t2, (0, 1, 2, 3), tmp62, (0, 1, 3, 4), (4, 2))
    tmp111 = np.copy(tmp91)
    tmp111 += np.transpose(tmp99, (1, 0, 3, 2))
    tmp111 += np.transpose(tmp97, (1, 0, 3, 2)) * -1
    tmp100 = np.copy(np.transpose(tmp97, (1, 0, 3, 2)))
    del tmp97
    tmp100 += np.transpose(tmp99, (1, 0, 3, 2)) * -1
    del tmp99
    tmp108 = einsum(tmp107, (0, 1, 2, 3), t2, (4, 0, 5, 2), (1, 4, 3, 5))
    del tmp107
    tmp13 = einsum(t2, (0, 1, 2, 3), tmp12, (0, 1, 4, 2), (4, 3)) * 0.5
    tmp14 = einsum(t1, (0, 1), tmp1, (0, 2), (2, 1)) * 0.5
    tmp63 = einsum(t2, (0, 1, 2, 3), tmp62, (0, 1, 3, 4), (4, 2)) * 0.5
    del tmp62
    tmp71 = np.copy(tmp25)
    tmp71 += tmp21 * -1
    tmp53 = einsum(tmp45, (0, 1, 2, 3), t2, (4, 0, 2, 5), (1, 4, 3, 5))
    del tmp45
    tmp59 = np.copy(t2)
    tmp59 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    tmp49 = einsum(t2, (0, 1, 2, 3), tmp48, (1, 4, 2, 5), (4, 0, 5, 3))
    tmp17 = einsum(tmp4, (0, 1, 2, 3), t1, (0, 4), (1, 3, 2, 4))
    tmp8 = einsum(t1, (0, 1), tmp6, (0, 2), (2, 1))
    tmp10 = einsum(l1, (0, 1), tmp9, (1, 2, 0, 3), (2, 3))
    del tmp9
    tmp55 = np.copy(tmp16)
    tmp55 += tmp19
    tmp55 += tmp21 * -1
    tmp74 = np.copy(tmp16)
    tmp74 += tmp26 * -1
    tmp34 = np.copy(tmp6) * 0.5
    tmp34 += tmp33
    del tmp33
    tmp31 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp31 += t2 * 2
    tmp5 = np.copy(np.transpose(tmp2, (1, 0, 3, 2)))
    tmp5 += tmp4
    tmp119 = einsum(tmp117, (0, 1, 2, 3), t1, (0, 4), (2, 1, 3, 4))
    tmp118 = einsum(l2, (0, 1, 2, 3), t2, (3, 2, 4, 5), (0, 1, 5, 4))
    tmp69 = einsum(l2, (0, 1, 2, 3), t2, (4, 2, 1, 5), (3, 4, 0, 5))
    tmp115 = np.copy(tmp67)
    tmp115 += tmp91
    tmp115 += tmp46 * -1
    tmp85 = np.copy(tmp83)
    tmp85 += tmp84
    del tmp84
    tmp103 = einsum(tmp3, (0, 1, 2, 3), t2, (0, 1, 4, 5), (2, 3, 4, 5))
    tmp96 = einsum(t2, (0, 1, 2, 3), l1, (4, 1), (0, 4, 2, 3))
    tmp112 = einsum(t1, (0, 1), tmp111, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp111
    tmp101 = einsum(tmp100, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp100
    tmp109 = np.copy(tmp67)
    tmp109 += tmp91
    tmp109 += tmp108 * -1
    del tmp108
    tmp87 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * 2
    tmp87 += np.transpose(l2, (2, 3, 0, 1)) * -1
    tmp92 = np.copy(tmp3) * -1
    tmp92 += np.transpose(tmp3, (1, 0, 2, 3))
    tmp80 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp80 += t2 * -1
    tmp78 = np.copy(np.transpose(t2, (0, 1, 3, 2)))
    tmp78 += t2 * -1
    tmp89 = np.copy(np.transpose(l2, (3, 2, 0, 1)))
    tmp89 += np.transpose(l2, (2, 3, 0, 1)) * -1
    tmp65 = einsum(t2, (0, 1, 2, 3), tmp1, (1, 4), (0, 4, 3, 2))
    tmp15 = np.copy(tmp13)
    tmp15 += tmp14
    del tmp14
    tmp64 = einsum(tmp63, (0, 1), t2, (2, 3, 0, 4), (2, 3, 1, 4)) * 2
    tmp72 = einsum(t1, (0, 1), tmp71, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp71
    tmp54 = einsum(tmp53, (0, 1, 2, 3), t2, (4, 0, 5, 2), (1, 4, 3, 5))
    del tmp53
    tmp58 = einsum(t2, (0, 1, 2, 3), tmp4, (0, 1, 4, 5), (5, 4, 3, 2))
    tmp60 = einsum(tmp59, (0, 1, 2, 3), tmp2, (0, 1, 4, 5), (4, 5, 2, 3))
    del tmp59
    tmp47 = einsum(tmp46, (0, 1, 2, 3), t2, (4, 0, 5, 2), (1, 4, 3, 5))
    del tmp46
    tmp50 = einsum(t2, (0, 1, 2, 3), tmp49, (1, 4, 2, 5), (4, 0, 5, 3))
    del tmp49
    tmp44 = einsum(tmp17, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3))
    tmp11 = np.copy(tmp8)
    tmp11 += tmp10 * -1
    tmp56 = einsum(t1, (0, 1), tmp55, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp55
    tmp52 = einsum(t2, (0, 1, 2, 3), tmp6, (1, 4), (4, 0, 2, 3))
    tmp75 = einsum(t1, (0, 1), tmp74, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp74
    tmp42 = einsum(t1, (0, 1), tmp34, (0, 2), (2, 1))
    tmp41 = einsum(tmp31, (0, 1, 2, 3), l1, (2, 0), (1, 3)) * 0.5
    tmp29 = einsum(tmp5, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    tmp35 = einsum(t1, (0, 1), tmp34, (0, 2), (2, 1)) * 2
    del tmp34
    tmp30 = einsum(t2, (0, 1, 2, 3), tmp12, (0, 1, 4, 2), (4, 3))
    del tmp12
    tmp27 = np.copy(tmp3) * -1
    tmp27 += np.transpose(tmp3, (1, 0, 2, 3)) * 2
    tmp32 = einsum(tmp31, (0, 1, 2, 3), l1, (2, 0), (1, 3))
    del tmp31
    tmp23 = einsum(tmp2, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    tmp120 = np.copy(np.transpose(tmp118, (1, 0, 3, 2)))
    tmp120 += np.transpose(tmp119, (1, 0, 3, 2))
    tmp106 = einsum(t1, (0, 1), tmp69, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp116 = einsum(t1, (0, 1), tmp115, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp115
    tmp114 = np.copy(tmp103)
    tmp114 += einsum(t1, (0, 1), tmp85, (2, 3), (0, 2, 1, 3))
    tmp95 = np.copy(tmp83) * 0.5
    tmp95 += tmp63
    tmp113 = np.copy(tmp96)
    tmp113 += np.transpose(tmp112, (0, 1, 3, 2))
    del tmp112
    tmp102 = np.copy(tmp96)
    tmp102 += einsum(t1, (0, 1), tmp83, (2, 3), (0, 2, 1, 3))
    del tmp83
    tmp102 += np.transpose(tmp101, (0, 1, 3, 2)) * -1
    del tmp101
    tmp104 = np.copy(tmp103)
    tmp104 += einsum(t1, (0, 1), tmp63, (2, 3), (0, 2, 1, 3)) * 2
    del tmp63
    tmp105 = einsum(t1, (0, 1), tmp91, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp110 = einsum(t1, (0, 1), tmp109, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp109
    tmp86 = einsum(t1, (0, 1), tmp3, (0, 2, 3, 4), (2, 3, 4, 1))
    tmp88 = einsum(tmp87, (0, 1, 2, 3), t2, (4, 0, 5, 3), (1, 4, 2, 5))
    del tmp87
    tmp94 = einsum(tmp48, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 4, 2, 5))
    del tmp48
    tmp93 = einsum(t1, (0, 1), tmp92, (2, 0, 3, 4), (2, 3, 4, 1))
    del tmp92
    tmp81 = einsum(l2, (0, 1, 2, 3), tmp80, (3, 4, 5, 1), (4, 2, 5, 0))
    del tmp80
    tmp79 = einsum(l2, (0, 1, 2, 3), tmp78, (2, 4, 5, 1), (4, 3, 5, 0))
    del tmp78
    tmp82 = einsum(tmp18, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    del tmp18
    tmp90 = einsum(tmp89, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 4, 2, 5))
    del tmp89
    tmp66 = np.copy(np.transpose(tmp64, (1, 0, 3, 2)))
    del tmp64
    tmp66 += np.transpose(tmp65, (0, 1, 3, 2))
    del tmp65
    tmp66 += einsum(t1, (0, 1), tmp15, (2, 3), (0, 2, 1, 3)) * 2
    tmp70 = einsum(t2, (0, 1, 2, 3), tmp69, (1, 4, 2, 5), (0, 4, 3, 5))
    tmp73 = np.copy(np.transpose(tmp54, (1, 0, 3, 2))) * -1
    tmp73 += np.transpose(tmp72, (0, 1, 3, 2))
    del tmp72
    tmp73 += einsum(t1, (0, 1), tmp10, (2, 3), (0, 2, 1, 3))
    tmp61 = np.copy(tmp58)
    tmp61 += np.transpose(tmp60, (1, 0, 3, 2))
    tmp68 = einsum(t2, (0, 1, 2, 3), tmp67, (1, 4, 2, 5), (0, 4, 3, 5))
    tmp51 = np.copy(tmp44)
    tmp51 += np.transpose(tmp47, (1, 0, 3, 2)) * 2
    tmp51 += tmp50
    del tmp50
    tmp57 = np.copy(tmp52)
    tmp57 += np.transpose(tmp54, (1, 0, 3, 2)) * -1
    del tmp54
    tmp57 += np.transpose(tmp56, (0, 1, 3, 2))
    del tmp56
    tmp57 += einsum(t1, (0, 1), tmp11, (2, 3), (0, 2, 1, 3)) * -1
    tmp76 = np.copy(tmp52)
    del tmp52
    tmp76 += np.transpose(tmp75, (0, 1, 3, 2))
    del tmp75
    tmp77 = np.copy(t1)
    tmp77 += tmp8 * -1
    tmp43 = np.copy(t1) * -0.5
    tmp43 += tmp13
    del tmp13
    tmp43 += tmp41 * -1
    del tmp41
    tmp43 += tmp42
    del tmp42
    tmp40 = np.copy(tmp16)
    tmp40 += np.transpose(tmp29, (0, 2, 1, 3))
    tmp40 += einsum(t1, (0, 1), tmp1, (2, 3), (2, 0, 3, 1))
    tmp39 = einsum(t1, (0, 1), tmp6, (2, 3), (2, 0, 3, 1))
    tmp39 += tmp19
    tmp39 += tmp21 * -1
    tmp38 = np.copy(tmp30)
    tmp38 += tmp35
    tmp37 = np.copy(tmp6)
    tmp37 += tmp1
    tmp22 = np.copy(tmp16)
    tmp22 += tmp17
    del tmp17
    tmp22 += tmp19
    del tmp19
    tmp22 += tmp21 * -1
    tmp28 = einsum(t2, (0, 1, 2, 3), tmp27, (4, 1, 5, 3), (4, 5, 0, 2))
    del tmp27
    tmp36 = np.copy(t1) * -1
    tmp36 += tmp30
    del tmp30
    tmp36 += tmp32 * -1
    del tmp32
    tmp36 += tmp35
    del tmp35
    tmp24 = np.copy(tmp23)
    del tmp23
    tmp24 += einsum(t1, (0, 1), tmp1, (2, 3), (2, 0, 3, 1))
    tmp7 = np.copy(delta.oo)
    tmp7 += tmp6 * -1
    rdm2.vvvv = np.copy(np.transpose(tmp120, (0, 1, 3, 2))) * -2
    rdm2.vvvv += tmp120 * 2
    del tmp120
    rdm2.vvvv += np.transpose(tmp118, (1, 0, 3, 2)) * 2
    del tmp118
    rdm2.vvvv += np.transpose(tmp119, (1, 0, 3, 2)) * 2
    del tmp119
    rdm2.vvvo = np.copy(np.transpose(tmp117, (1, 2, 3, 0))) * -2
    rdm2.vvvo += np.transpose(tmp117, (2, 1, 3, 0)) * 4
    rdm2.vvov = np.copy(np.transpose(tmp117, (1, 2, 0, 3))) * 4
    rdm2.vvov += np.transpose(tmp117, (2, 1, 0, 3)) * -2
    del tmp117
    rdm2.vovv = np.copy(np.transpose(tmp113, (1, 0, 2, 3))) * -2
    rdm2.vovv += np.transpose(tmp113, (1, 0, 3, 2)) * 2
    del tmp113
    rdm2.vovv += np.transpose(tmp114, (1, 0, 2, 3)) * -2
    rdm2.vovv += np.transpose(tmp114, (1, 0, 3, 2)) * 2
    del tmp114
    rdm2.vovv += np.transpose(tmp96, (1, 0, 3, 2)) * 2
    rdm2.vovv += np.transpose(tmp106, (1, 0, 3, 2)) * -2
    rdm2.vovv += np.transpose(tmp103, (1, 0, 2, 3)) * -2
    rdm2.vovv += np.transpose(tmp116, (1, 0, 3, 2)) * -2
    del tmp116
    rdm2.vovv += einsum(t1, (0, 1), tmp95, (2, 3), (2, 0, 3, 1)) * 4
    rdm2.ovvv = np.copy(tmp102) * 2
    rdm2.ovvv += np.transpose(tmp102, (0, 1, 3, 2)) * -2
    del tmp102
    rdm2.ovvv += tmp104 * 2
    rdm2.ovvv += np.transpose(tmp104, (0, 1, 3, 2)) * -2
    del tmp104
    rdm2.ovvv += tmp105 * 2
    rdm2.ovvv += np.transpose(tmp105, (0, 1, 3, 2)) * -2
    del tmp105
    rdm2.ovvv += tmp96 * 2
    del tmp96
    rdm2.ovvv += np.transpose(tmp103, (0, 1, 3, 2)) * -2
    del tmp103
    rdm2.ovvv += tmp106 * -2
    del tmp106
    rdm2.ovvv += tmp110 * -2
    del tmp110
    rdm2.ovvv += einsum(t1, (0, 1), tmp85, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.vvoo = np.copy(np.transpose(l2, (0, 1, 3, 2))) * -2
    rdm2.vvoo += l2 * 4
    rdm2.vovo = einsum(t1, (0, 1), l1, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.vovo += np.transpose(tmp88, (2, 1, 3, 0)) * -2
    rdm2.vovo += np.transpose(tmp94, (2, 1, 3, 0)) * -2
    del tmp94
    rdm2.vovo += np.transpose(tmp93, (2, 1, 3, 0)) * -2
    rdm2.vovo += einsum(delta.oo, (0, 1), tmp95, (2, 3), (2, 0, 3, 1)) * 8
    del tmp95
    rdm2.vovo += np.transpose(tmp69, (2, 1, 3, 0)) * -2
    rdm2.vovo += np.transpose(tmp86, (2, 1, 3, 0)) * -2
    rdm2.voov = einsum(t1, (0, 1), l1, (2, 3), (2, 0, 3, 1)) * 4
    rdm2.voov += np.transpose(tmp81, (3, 0, 1, 2)) * 2
    rdm2.voov += np.transpose(tmp79, (3, 0, 1, 2)) * -2
    rdm2.voov += np.transpose(tmp93, (2, 1, 0, 3)) * 2
    del tmp93
    rdm2.voov += einsum(tmp85, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.voov += np.transpose(tmp67, (2, 1, 0, 3)) * -2
    rdm2.voov += np.transpose(tmp91, (2, 1, 0, 3)) * -2
    rdm2.voov += np.transpose(tmp88, (2, 1, 0, 3)) * 2
    rdm2.ovvo = einsum(t1, (0, 1), l1, (2, 3), (0, 2, 1, 3)) * 4
    rdm2.ovvo += np.transpose(tmp88, (1, 2, 3, 0)) * 4
    del tmp88
    rdm2.ovvo += np.transpose(tmp90, (1, 2, 3, 0)) * -2
    del tmp90
    rdm2.ovvo += np.transpose(tmp82, (1, 2, 3, 0)) * -2
    rdm2.ovvo += einsum(tmp85, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.ovvo += np.transpose(tmp67, (1, 2, 3, 0)) * -2
    del tmp67
    rdm2.ovvo += np.transpose(tmp91, (1, 2, 3, 0)) * -2
    del tmp91
    rdm2.ovov = einsum(t1, (0, 1), l1, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.ovov += np.transpose(tmp79, (0, 3, 1, 2)) * 2
    del tmp79
    rdm2.ovov += np.transpose(tmp81, (0, 3, 1, 2)) * -2
    del tmp81
    rdm2.ovov += np.transpose(tmp82, (1, 2, 0, 3)) * 2
    del tmp82
    rdm2.ovov += einsum(tmp85, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * 4
    del tmp85
    rdm2.ovov += np.transpose(tmp69, (1, 2, 0, 3)) * -2
    del tmp69
    rdm2.ovov += np.transpose(tmp86, (1, 2, 0, 3)) * -2
    del tmp86
    rdm2.oovv = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -2
    rdm2.oovv += t2 * 4
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.oovv += tmp51 * 2
    rdm2.oovv += np.transpose(tmp51, (0, 1, 3, 2)) * -2
    del tmp51
    rdm2.oovv += tmp57 * 2
    rdm2.oovv += np.transpose(tmp57, (0, 1, 3, 2)) * -2
    rdm2.oovv += np.transpose(tmp57, (1, 0, 2, 3)) * -2
    rdm2.oovv += np.transpose(tmp57, (1, 0, 3, 2)) * 2
    del tmp57
    rdm2.oovv += tmp61 * 2
    rdm2.oovv += np.transpose(tmp61, (0, 1, 3, 2)) * -2
    del tmp61
    rdm2.oovv += tmp66 * -4
    rdm2.oovv += np.transpose(tmp66, (0, 1, 3, 2)) * 2
    rdm2.oovv += np.transpose(tmp66, (1, 0, 2, 3)) * 2
    rdm2.oovv += np.transpose(tmp66, (1, 0, 3, 2)) * -4
    del tmp66
    rdm2.oovv += tmp68 * 2
    del tmp68
    rdm2.oovv += np.transpose(tmp70, (0, 1, 3, 2)) * 2
    del tmp70
    rdm2.oovv += tmp58 * 2
    del tmp58
    rdm2.oovv += tmp44 * 2
    del tmp44
    rdm2.oovv += einsum(t1, (0, 1), tmp8, (2, 3), (0, 2, 1, 3)) * -2
    del tmp8
    rdm2.oovv += tmp73 * 2
    rdm2.oovv += np.transpose(tmp73, (1, 0, 3, 2)) * 2
    del tmp73
    rdm2.oovv += np.transpose(tmp76, (0, 1, 3, 2)) * -2
    rdm2.oovv += np.transpose(tmp76, (1, 0, 2, 3)) * -2
    del tmp76
    rdm2.oovv += tmp47 * 4
    del tmp47
    rdm2.oovv += np.transpose(tmp60, (1, 0, 3, 2)) * 2
    del tmp60
    rdm2.oovv += einsum(t1, (0, 1), tmp77, (2, 3), (2, 0, 3, 1)) * 2
    del tmp77
    rdm2.vooo = einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1)) * 4
    rdm2.vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.vooo += np.transpose(tmp3, (3, 2, 0, 1)) * -4
    rdm2.vooo += np.transpose(tmp3, (3, 2, 1, 0)) * 2
    rdm2.ovoo = einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 1, 3)) * 4
    rdm2.ovoo += np.transpose(tmp3, (2, 3, 0, 1)) * 2
    rdm2.ovoo += np.transpose(tmp3, (2, 3, 1, 0)) * -4
    del tmp3
    rdm2.oovo = einsum(delta.oo, (0, 1), tmp10, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp10, (2, 3), (0, 2, 3, 1)) * -2
    del tmp10
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp38, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp38, (2, 3), (0, 2, 3, 1)) * 2
    del tmp38
    rdm2.oovo += einsum(t1, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.oovo += einsum(t1, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.oovo += np.transpose(tmp39, (1, 2, 3, 0)) * -2
    rdm2.oovo += np.transpose(tmp39, (2, 1, 3, 0)) * 2
    del tmp39
    rdm2.oovo += np.transpose(tmp40, (1, 2, 3, 0)) * -2
    rdm2.oovo += np.transpose(tmp40, (2, 1, 3, 0)) * 2
    del tmp40
    rdm2.oovo += np.transpose(tmp26, (1, 2, 3, 0)) * 2
    rdm2.oovo += np.transpose(tmp25, (2, 1, 3, 0)) * 2
    rdm2.oovo += np.transpose(tmp16, (1, 2, 3, 0)) * -2
    rdm2.oovo += np.transpose(tmp21, (2, 1, 3, 0)) * -2
    del tmp21
    rdm2.oovo += np.transpose(tmp29, (1, 2, 3, 0)) * 2
    rdm2.oovo += einsum(tmp43, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * -4
    del tmp43
    rdm2.oovo += einsum(t1, (0, 1), tmp37, (2, 3), (0, 3, 1, 2)) * -2
    rdm2.ooov = einsum(tmp11, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * 2
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp11, (2, 3), (0, 2, 1, 3)) * -2
    del tmp11
    rdm2.ooov += einsum(t1, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.ooov += einsum(t1, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp15, (2, 3), (2, 0, 1, 3)) * 4
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp15, (2, 3), (0, 2, 1, 3)) * -4
    del tmp15
    rdm2.ooov += np.transpose(tmp22, (1, 2, 0, 3)) * 2
    rdm2.ooov += np.transpose(tmp22, (2, 1, 0, 3)) * -2
    del tmp22
    rdm2.ooov += np.transpose(tmp24, (1, 2, 0, 3)) * 2
    rdm2.ooov += np.transpose(tmp24, (2, 1, 0, 3)) * -2
    del tmp24
    rdm2.ooov += einsum(tmp6, (0, 1), t1, (2, 3), (2, 1, 0, 3)) * 2
    rdm2.ooov += einsum(t1, (0, 1), tmp6, (2, 3), (3, 0, 2, 1)) * -2
    rdm2.ooov += np.transpose(tmp25, (1, 2, 0, 3)) * 2
    del tmp25
    rdm2.ooov += np.transpose(tmp26, (2, 1, 0, 3)) * 2
    del tmp26
    rdm2.ooov += np.transpose(tmp16, (2, 1, 0, 3)) * -2
    del tmp16
    rdm2.ooov += np.transpose(tmp28, (1, 2, 0, 3)) * -2
    del tmp28
    rdm2.ooov += np.transpose(tmp29, (2, 1, 0, 3)) * 2
    del tmp29
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp36, (2, 3), (0, 2, 1, 3)) * -2
    del tmp36
    rdm2.ooov += einsum(t1, (0, 1), tmp37, (2, 3), (3, 0, 2, 1)) * -2
    del tmp37
    rdm2.oooo = einsum(tmp1, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3)) * -4
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp1, (2, 3), (0, 3, 2, 1)) * 2
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp1, (2, 3), (3, 0, 1, 2)) * 2
    rdm2.oooo += einsum(tmp1, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -4
    del tmp1
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.oooo += np.transpose(tmp5, (3, 2, 0, 1)) * -2
    rdm2.oooo += np.transpose(tmp5, (2, 3, 0, 1)) * 2
    del tmp5
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3)) * -2
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (2, 1, 0, 3)) * 2
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (1, 2, 3, 0)) * 2
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -4
    del tmp6
    rdm2.oooo += np.transpose(tmp2, (3, 2, 1, 0)) * 2
    del tmp2
    rdm2.oooo += np.transpose(tmp4, (3, 2, 1, 0)) * 2
    del tmp4
    rdm2.oooo += einsum(tmp7, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3)) * 2
    del delta, tmp7
    rdm2 = pack_2e(rdm2.oooo, rdm2.ooov, rdm2.oovo, rdm2.ovoo, rdm2.vooo, rdm2.oovv, rdm2.ovov, rdm2.ovvo, rdm2.voov, rdm2.vovo, rdm2.vvoo, rdm2.ovvv, rdm2.vovv, rdm2.vvov, rdm2.vvvo, rdm2.vvvv)
    rdm2 = np.transpose(rdm2, (0, 2, 1, 3))

    return rdm2

def hbar_matvec_ip_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:34:14.090594.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp0 : array
    tmp100 : array
    tmp101 : array
    tmp102 : array
    tmp103 : array
    tmp108 : array
    tmp109 : array
    tmp12 : array
    tmp14 : array
    tmp16 : array
    tmp17 : array
    tmp19 : array
    tmp21 : array
    tmp22 : array
    tmp23 : array
    tmp25 : array
    tmp27 : array
    tmp29 : array
    tmp3 : array
    tmp30 : array
    tmp34 : array
    tmp35 : array
    tmp36 : array
    tmp37 : array
    tmp39 : array
    tmp4 : array
    tmp40 : array
    tmp42 : array
    tmp45 : array
    tmp46 : array
    tmp48 : array
    tmp49 : array
    tmp5 : array
    tmp50 : array
    tmp51 : array
    tmp52 : array
    tmp54 : array
    tmp55 : array
    tmp56 : array
    tmp57 : array
    tmp58 : array
    tmp6 : array
    tmp60 : array
    tmp64 : array
    tmp65 : array
    tmp66 : array
    tmp67 : array
    tmp69 : array
    tmp75 : array
    tmp76 : array
    tmp77 : array
    tmp78 : array
    tmp82 : array
    tmp83 : array
    tmp85 : array
    tmp86 : array
    tmp87 : array
    tmp88 : array
    tmp89 : array
    tmp9 : array
    tmp90 : array
    tmp92 : array
    tmp93 : array
    tmp94 : array
    tmp98 : array
    tmp99 : array
    """

    tmp6 = einsum(t1, (0, 1), v.ovov, (2, 3, 0, 1), (2, 3))
    tmp5 = einsum(t1, (0, 1), v.ovov, (2, 1, 0, 3), (2, 3))
    tmp9 = einsum(t1, (0, 1), v.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp17 = einsum(t1, (0, 1), tmp6, (2, 1), (0, 2))
    tmp16 = einsum(tmp5, (0, 1), t1, (2, 1), (2, 0))
    tmp30 = einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp12 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 3, 1), (4, 0))
    tmp14 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 1, 3), (4, 0))
    tmp0 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp90 = einsum(t1, (0, 1), tmp9, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp83 = einsum(t1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp21 = einsum(v.ovvv, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    tmp19 = einsum(t1, (0, 1), v.ovvv, (0, 1, 2, 3), (2, 3))
    tmp4 = einsum(t1, (0, 1), v.ooov, (2, 3, 0, 1), (2, 3))
    tmp3 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp25 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp109 = einsum(t1, (0, 1), tmp17, (2, 0), (2, 1))
    tmp108 = einsum(t1, (0, 1), tmp16, (2, 0), (2, 1))
    tmp103 = einsum(tmp30, (0, 1, 2, 3), t1, (3, 4), (0, 2, 1, 4))
    tmp102 = einsum(t1, (0, 1), tmp12, (2, 0), (2, 1))
    tmp101 = einsum(t1, (0, 1), tmp14, (2, 0), (2, 1))
    tmp100 = einsum(t2, (0, 1, 2, 3), tmp9, (4, 5, 1, 2), (4, 0, 5, 3))
    tmp99 = einsum(t2, (0, 1, 2, 3), tmp9, (4, 1, 0, 2), (4, 3))
    tmp98 = einsum(t2, (0, 1, 2, 3), tmp9, (4, 0, 1, 2), (4, 3))
    tmp94 = einsum(t1, (0, 1), v.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp93 = einsum(t1, (0, 1), tmp0, (0, 2), (2, 1))
    tmp92 = einsum(tmp90, (0, 1, 2, 3), t1, (2, 4), (1, 0, 3, 4))
    tmp89 = einsum(t1, (0, 1), tmp83, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp88 = einsum(t1, (0, 1), tmp21, (1, 2), (0, 2))
    tmp87 = einsum(t1, (0, 1), tmp19, (2, 1), (0, 2))
    tmp86 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 2, 4, 3), (0, 4))
    tmp85 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 3, 4, 2), (0, 4))
    tmp82 = einsum(t1, (0, 1), f.vv, (2, 1), (0, 2))
    tmp78 = einsum(t1, (0, 1), tmp4, (2, 0), (2, 1))
    tmp77 = einsum(t1, (0, 1), tmp3, (2, 0), (2, 1))
    tmp76 = einsum(tmp6, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp75 = einsum(tmp5, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp69 = einsum(t2, (0, 1, 2, 3), v.ovov, (0, 2, 1, 4), (3, 4))
    tmp67 = einsum(t2, (0, 1, 2, 3), v.ovov, (0, 4, 1, 2), (3, 4))
    tmp66 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 1, 3, 5), (4, 0, 2, 5))
    tmp65 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 1, 0, 2), (4, 3))
    tmp64 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 0, 1, 2), (4, 3))
    tmp60 = einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp58 = einsum(t1, (0, 1), f.oo, (2, 0), (2, 1))
    tmp57 = einsum(tmp6, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp56 = einsum(tmp6, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp55 = einsum(tmp5, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp54 = einsum(tmp5, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp52 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp51 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 5, 1, 2), (0, 4, 3, 5))
    tmp50 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp49 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp48 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 1, 2), (0, 4, 5, 3))
    tmp46 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp45 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp42 = einsum(v.oooo, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    tmp40 = einsum(f.ov, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp39 = einsum(f.ov, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp37 = einsum(tmp30, (0, 1, 2, 3), t1, (2, 4), (0, 1, 3, 4))
    tmp36 = einsum(t2, (0, 1, 2, 3), tmp9, (4, 1, 5, 2), (4, 0, 5, 3))
    tmp35 = einsum(tmp9, (0, 1, 2, 3), t2, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp34 = einsum(t2, (0, 1, 2, 3), tmp9, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp29 = einsum(t1, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3))
    tmp27 = einsum(tmp25, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    tmp23 = einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp22 = einsum(t1, (0, 1), v.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))

    return {f"tmp0": tmp0, f"tmp100": tmp100, f"tmp101": tmp101, f"tmp102": tmp102, f"tmp103": tmp103, f"tmp108": tmp108, f"tmp109": tmp109, f"tmp12": tmp12, f"tmp14": tmp14, f"tmp16": tmp16, f"tmp17": tmp17, f"tmp19": tmp19, f"tmp21": tmp21, f"tmp22": tmp22, f"tmp23": tmp23, f"tmp25": tmp25, f"tmp27": tmp27, f"tmp29": tmp29, f"tmp3": tmp3, f"tmp30": tmp30, f"tmp34": tmp34, f"tmp35": tmp35, f"tmp36": tmp36, f"tmp37": tmp37, f"tmp39": tmp39, f"tmp4": tmp4, f"tmp40": tmp40, f"tmp42": tmp42, f"tmp45": tmp45, f"tmp46": tmp46, f"tmp48": tmp48, f"tmp49": tmp49, f"tmp5": tmp5, f"tmp50": tmp50, f"tmp51": tmp51, f"tmp52": tmp52, f"tmp54": tmp54, f"tmp55": tmp55, f"tmp56": tmp56, f"tmp57": tmp57, f"tmp58": tmp58, f"tmp6": tmp6, f"tmp60": tmp60, f"tmp64": tmp64, f"tmp65": tmp65, f"tmp66": tmp66, f"tmp67": tmp67, f"tmp69": tmp69, f"tmp75": tmp75, f"tmp76": tmp76, f"tmp77": tmp77, f"tmp78": tmp78, f"tmp82": tmp82, f"tmp83": tmp83, f"tmp85": tmp85, f"tmp86": tmp86, f"tmp87": tmp87, f"tmp88": tmp88, f"tmp89": tmp89, f"tmp9": tmp9, f"tmp90": tmp90, f"tmp92": tmp92, f"tmp93": tmp93, f"tmp94": tmp94, f"tmp98": tmp98, f"tmp99": tmp99}

def hbar_matvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:34:14.144384.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp1 = np.copy(f.ov) * 0.5
    tmp1 += ints.tmp6
    tmp1 += ints.tmp5 * -0.5
    tmp12 = np.copy(ints.tmp9)
    tmp12 += np.transpose(v.ooov, (0, 2, 1, 3))
    tmp2 = np.copy(r2) * 2
    tmp2 += np.transpose(r2, (1, 0, 2)) * -1
    tmp14 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1)))
    tmp14 += np.transpose(v.ovov, (0, 2, 1, 3)) * -0.5
    tmp16 = np.copy(ints.tmp101) * 2
    tmp16 += ints.tmp109 * 2
    tmp16 += ints.tmp29
    tmp16 += ints.tmp39
    tmp16 += ints.tmp55 * 2
    tmp16 += ints.tmp56 * 2
    tmp16 += ints.tmp58
    tmp16 += ints.tmp65 * 2
    tmp16 += ints.tmp78 * 2
    tmp16 += ints.tmp86
    tmp16 += ints.tmp88
    tmp16 += ints.tmp93
    tmp16 += ints.tmp98 * 2
    tmp16 += f.ov * -1
    tmp16 += ints.tmp102 * -1
    tmp16 += ints.tmp108 * -1
    tmp16 += ints.tmp40 * -2
    tmp16 += ints.tmp54 * -1
    tmp16 += ints.tmp57 * -4
    tmp16 += ints.tmp64 * -1
    tmp16 += ints.tmp6 * -2
    tmp16 += ints.tmp77 * -1
    tmp16 += ints.tmp82 * -1
    tmp16 += ints.tmp85 * -2
    tmp16 += ints.tmp87 * -2
    tmp16 += ints.tmp99 * -1
    tmp11 = np.copy(f.oo) * 0.5
    tmp11 += ints.tmp0 * 0.5
    tmp11 += np.transpose(ints.tmp14, (1, 0))
    tmp11 += np.transpose(ints.tmp17, (1, 0))
    tmp11 += np.transpose(ints.tmp4, (1, 0))
    tmp11 += np.transpose(ints.tmp12, (1, 0)) * -0.5
    tmp11 += np.transpose(ints.tmp16, (1, 0)) * -0.5
    tmp11 += np.transpose(ints.tmp3, (1, 0)) * -0.5
    tmp9 = np.copy(ints.tmp21)
    tmp9 += np.transpose(ints.tmp69, (1, 0)) * 2
    tmp9 += f.vv * -1
    tmp9 += np.transpose(ints.tmp19, (1, 0)) * -2
    tmp9 += np.transpose(ints.tmp67, (1, 0)) * -1
    tmp9 += einsum(t1, (0, 1), tmp1, (0, 2), (2, 1)) * 2
    tmp6 = np.copy(ints.tmp22)
    tmp6 += v.oovv
    tmp6 += ints.tmp49 * -1
    tmp10 = np.copy(ints.tmp100)
    tmp10 += np.transpose(ints.tmp103, (0, 2, 1, 3))
    tmp10 += np.transpose(ints.tmp27, (1, 0, 2, 3))
    tmp10 += np.transpose(ints.tmp35, (1, 0, 2, 3))
    tmp10 += np.transpose(ints.tmp36, (1, 0, 2, 3))
    tmp10 += np.transpose(ints.tmp37, (1, 0, 2, 3))
    tmp10 += np.transpose(ints.tmp42, (2, 0, 1, 3))
    tmp10 += ints.tmp45
    tmp10 += ints.tmp48
    tmp10 += np.transpose(ints.tmp66, (1, 0, 2, 3))
    tmp10 += ints.tmp75
    tmp10 += np.transpose(ints.tmp92, (1, 0, 2, 3))
    tmp10 += np.transpose(ints.tmp23, (1, 0, 2, 3)) * -1
    tmp10 += np.transpose(ints.tmp34, (1, 0, 2, 3)) * -2
    tmp10 += ints.tmp46 * -2
    tmp10 += np.transpose(ints.tmp60, (1, 2, 0, 3)) * -1
    tmp10 += ints.tmp76 * -2
    tmp10 += np.transpose(ints.tmp89, (1, 0, 2, 3)) * -1
    tmp10 += ints.tmp94 * -1
    tmp10 += np.transpose(ints.tmp9, (1, 0, 2, 3)) * -1
    tmp10 += np.transpose(v.ovoo, (0, 2, 3, 1)) * -1
    tmp4 = np.copy(r2)
    tmp4 += np.transpose(r2, (1, 0, 2)) * -0.5
    tmp8 = np.copy(ints.tmp30)
    tmp8 += np.transpose(ints.tmp90, (1, 0, 2, 3))
    tmp5 = np.copy(ints.tmp52) * 2
    tmp5 += np.transpose(ints.tmp83, (0, 1, 3, 2))
    tmp5 += np.transpose(v.ovov, (0, 2, 1, 3))
    tmp5 += ints.tmp50 * -1
    tmp5 += ints.tmp51 * -1
    tmp7 = np.copy(ints.tmp25)
    tmp7 += np.transpose(ints.tmp30, (1, 0, 2, 3))
    tmp7 += np.transpose(v.oooo, (0, 2, 1, 3))
    tmp13 = einsum(tmp12, (0, 1, 2, 3), tmp2, (1, 4, 3), (4, 2, 0)) * -1
    tmp13 += einsum(r2, (0, 1, 2), tmp12, (3, 4, 1, 2), (3, 4, 0))
    tmp13 += einsum(r2, (0, 1, 2), tmp12, (3, 4, 0, 2), (1, 4, 3))
    del tmp12
    tmp15 = einsum(tmp14, (0, 1, 2, 3), r2, (1, 0, 2), (3,))
    del tmp14
    tmp3 = np.copy(f.oo)
    tmp3 += ints.tmp0
    tmp3 += np.transpose(ints.tmp14, (1, 0)) * 2
    tmp3 += np.transpose(ints.tmp17, (1, 0)) * 2
    tmp3 += np.transpose(ints.tmp4, (1, 0)) * 2
    tmp3 += np.transpose(ints.tmp12, (1, 0)) * -1
    tmp3 += np.transpose(ints.tmp16, (1, 0)) * -1
    tmp3 += np.transpose(ints.tmp3, (1, 0)) * -1
    tmp0 = np.copy(ints.tmp9)
    tmp0 += v.ooov * -0.5
    tmp0 += np.transpose(v.ooov, (0, 2, 1, 3))
    r2new = einsum(tmp4, (0, 1, 2), tmp5, (3, 0, 4, 2), (3, 1, 4)) * 2
    del tmp4, tmp5
    r2new += einsum(r2, (0, 1, 2), tmp6, (3, 1, 4, 2), (0, 3, 4)) * -1
    r2new += einsum(tmp6, (0, 1, 2, 3), r2, (1, 4, 3), (0, 4, 2)) * -1
    del tmp6
    r2new += einsum(r2, (0, 1, 2), tmp7, (3, 4, 0, 1), (3, 4, 2))
    del tmp7
    r2new += einsum(r2, (0, 1, 2), tmp8, (3, 4, 1, 0), (3, 4, 2))
    del tmp8
    r2new += einsum(tmp9, (0, 1), r2, (2, 3, 0), (2, 3, 1)) * -1
    del tmp9
    r2new += einsum(r1, (0,), tmp10, (1, 2, 0, 3), (1, 2, 3)) * -1
    del tmp10
    r2new += einsum(r2, (0, 1, 2), tmp11, (0, 3), (3, 1, 2)) * -2
    r2new += einsum(r2, (0, 1, 2), tmp11, (1, 3), (0, 3, 2)) * -2
    del tmp11
    r2new += einsum(t1, (0, 1), tmp13, (2, 0, 3), (3, 2, 1))
    del tmp13
    r2new += einsum(tmp15, (0,), t2, (1, 2, 3, 0), (1, 2, 3)) * -2
    del tmp15
    r2new += einsum(r1, (0,), tmp16, (1, 2), (1, 0, 2))
    del tmp16
    r1new = einsum(r2, (0, 1, 2), ints.tmp9, (3, 1, 0, 2), (3,)) * -1
    r1new += einsum(tmp0, (0, 1, 2, 3), r2, (1, 2, 3), (0,)) * 2
    del tmp0
    r1new += einsum(tmp1, (0, 1), tmp2, (0, 2, 1), (2,)) * -2
    del tmp1, tmp2
    r1new += einsum(r1, (0,), tmp3, (0, 1), (1,)) * -1
    del tmp3

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_matvec_ea_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:34:44.744561.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp102 : array
    tmp103 : array
    tmp104 : array
    tmp106 : array
    tmp107 : array
    tmp108 : array
    tmp109 : array
    tmp14 : array
    tmp16 : array
    tmp25 : array
    tmp28 : array
    tmp3 : array
    tmp32 : array
    tmp33 : array
    tmp34 : array
    tmp36 : array
    tmp46 : array
    tmp47 : array
    tmp49 : array
    tmp5 : array
    tmp51 : array
    tmp52 : array
    tmp54 : array
    tmp55 : array
    tmp56 : array
    tmp58 : array
    tmp6 : array
    tmp60 : array
    tmp61 : array
    tmp63 : array
    tmp64 : array
    tmp66 : array
    tmp67 : array
    tmp7 : array
    tmp72 : array
    tmp73 : array
    tmp74 : array
    tmp75 : array
    tmp76 : array
    tmp81 : array
    tmp82 : array
    tmp83 : array
    tmp88 : array
    tmp89 : array
    tmp90 : array
    tmp91 : array
    tmp93 : array
    tmp94 : array
    tmp97 : array
    tmp98 : array
    tmp99 : array
    """

    tmp7 = einsum(t1, (0, 1), v.ovov, (2, 3, 0, 1), (2, 3))
    tmp6 = einsum(t1, (0, 1), v.ovov, (2, 1, 0, 3), (2, 3))
    tmp34 = einsum(t1, (0, 1), v.ooov, (2, 3, 0, 1), (2, 3))
    tmp33 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp67 = einsum(t1, (0, 1), tmp7, (2, 1), (0, 2))
    tmp66 = einsum(t1, (0, 1), tmp6, (2, 1), (0, 2))
    tmp56 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 3, 1, 2), (0, 4))
    tmp58 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 1, 3), (0, 4))
    tmp60 = einsum(t1, (0, 1), v.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp47 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp5 = einsum(v.ovvv, (0, 1, 2, 3), t1, (0, 3), (1, 2))
    tmp3 = einsum(t1, (0, 1), v.ovvv, (0, 1, 2, 3), (2, 3))
    tmp109 = einsum(tmp7, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp108 = einsum(tmp7, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp107 = einsum(tmp6, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp106 = einsum(tmp6, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp104 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp103 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 5, 1, 2), (0, 4, 3, 5))
    tmp102 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp99 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 2, 4, 5), (0, 3, 4, 5))
    tmp98 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 3), (0, 2, 4, 5))
    tmp97 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 3, 4, 5), (0, 2, 4, 5))
    tmp94 = einsum(f.ov, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp93 = einsum(f.ov, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp91 = einsum(t1, (0, 1), tmp34, (2, 0), (2, 1))
    tmp90 = einsum(t1, (0, 1), tmp33, (2, 0), (2, 1))
    tmp89 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 0, 1, 3), (4, 2))
    tmp88 = einsum(v.ooov, (0, 1, 2, 3), t2, (2, 1, 4, 3), (0, 4))
    tmp83 = einsum(t1, (0, 1), f.oo, (2, 0), (2, 1))
    tmp82 = einsum(t1, (0, 1), tmp67, (2, 0), (2, 1))
    tmp81 = einsum(t1, (0, 1), tmp66, (2, 0), (2, 1))
    tmp76 = einsum(t1, (0, 1), tmp56, (2, 0), (2, 1))
    tmp75 = einsum(t1, (0, 1), tmp58, (2, 0), (2, 1))
    tmp74 = einsum(tmp60, (0, 1, 2, 3), t2, (1, 2, 4, 3), (0, 4))
    tmp73 = einsum(t2, (0, 1, 2, 3), tmp60, (4, 1, 0, 3), (4, 2))
    tmp72 = einsum(t1, (0, 1), tmp47, (0, 2), (2, 1))
    tmp64 = einsum(t1, (0, 1), tmp5, (1, 2), (0, 2))
    tmp63 = einsum(tmp3, (0, 1), t1, (2, 1), (2, 0))
    tmp61 = einsum(tmp60, (0, 1, 2, 3), t2, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp55 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 2, 4, 3), (0, 4))
    tmp54 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 3, 4, 2), (0, 4))
    tmp52 = einsum(t1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp51 = einsum(t1, (0, 1), v.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp49 = einsum(v.vvvv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp46 = einsum(t1, (0, 1), f.vv, (2, 1), (0, 2))
    tmp36 = einsum(v.ooov, (0, 1, 2, 3), t2, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp32 = einsum(t1, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3))
    tmp28 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp25 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 2), (0, 3, 4, 5))
    tmp16 = einsum(t2, (0, 1, 2, 3), v.ovov, (0, 2, 1, 4), (3, 4))
    tmp14 = einsum(t2, (0, 1, 2, 3), v.ovov, (0, 4, 1, 2), (3, 4))

    return {f"tmp102": tmp102, f"tmp103": tmp103, f"tmp104": tmp104, f"tmp106": tmp106, f"tmp107": tmp107, f"tmp108": tmp108, f"tmp109": tmp109, f"tmp14": tmp14, f"tmp16": tmp16, f"tmp25": tmp25, f"tmp28": tmp28, f"tmp3": tmp3, f"tmp32": tmp32, f"tmp33": tmp33, f"tmp34": tmp34, f"tmp36": tmp36, f"tmp46": tmp46, f"tmp47": tmp47, f"tmp49": tmp49, f"tmp5": tmp5, f"tmp51": tmp51, f"tmp52": tmp52, f"tmp54": tmp54, f"tmp55": tmp55, f"tmp56": tmp56, f"tmp58": tmp58, f"tmp6": tmp6, f"tmp60": tmp60, f"tmp61": tmp61, f"tmp63": tmp63, f"tmp64": tmp64, f"tmp66": tmp66, f"tmp67": tmp67, f"tmp7": tmp7, f"tmp72": tmp72, f"tmp73": tmp73, f"tmp74": tmp74, f"tmp75": tmp75, f"tmp76": tmp76, f"tmp81": tmp81, f"tmp82": tmp82, f"tmp83": tmp83, f"tmp88": tmp88, f"tmp89": tmp89, f"tmp90": tmp90, f"tmp91": tmp91, f"tmp93": tmp93, f"tmp94": tmp94, f"tmp97": tmp97, f"tmp98": tmp98, f"tmp99": tmp99}

def hbar_matvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:34:44.788904.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp1 = np.copy(f.ov) * 0.5
    tmp1 += ints.tmp7
    tmp1 += ints.tmp6 * -0.5
    tmp4 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * 2
    tmp4 += np.transpose(v.ovov, (0, 2, 1, 3)) * -1
    tmp6 = np.copy(f.ov)
    tmp6 += ints.tmp7 * 2
    tmp6 += ints.tmp6 * -1
    tmp12 = np.copy(np.transpose(r2, (2, 0, 1)))
    tmp12 += einsum(t1, (0, 1), r1, (2,), (0, 1, 2)) * -1
    tmp9 = einsum(r2, (0, 1, 2), v.ovov, (3, 0, 4, 1), (2, 3, 4))
    tmp20 = np.copy(ints.tmp60)
    tmp20 += np.transpose(v.ooov, (0, 2, 1, 3))
    tmp16 = einsum(t1, (0, 1), tmp1, (0, 2), (1, 2)) * 2
    tmp5 = einsum(r2, (0, 1, 2), tmp4, (2, 3, 1, 0), (3,))
    del tmp4
    tmp7 = einsum(tmp6, (0, 1), r1, (1,), (0,))
    del tmp6
    tmp14 = np.copy(ints.tmp60) * -0.5
    tmp14 += np.transpose(ints.tmp60, (0, 2, 1, 3))
    tmp14 += v.ooov
    tmp14 += np.transpose(v.ooov, (0, 2, 1, 3)) * -0.5
    tmp11 = np.copy(ints.tmp104) * 2
    tmp11 += np.transpose(ints.tmp52, (0, 1, 3, 2))
    tmp11 += np.transpose(v.ovov, (0, 2, 1, 3))
    tmp11 += ints.tmp102 * -1
    tmp11 += ints.tmp103 * -1
    tmp21 = einsum(v.ovvv, (0, 1, 2, 3), r2, (1, 3, 4), (4, 0, 2)) * -1
    tmp21 += einsum(t1, (0, 1), tmp9, (2, 3, 0), (2, 3, 1))
    tmp21 += einsum(tmp20, (0, 1, 2, 3), tmp12, (1, 4, 3), (0, 2, 4))
    tmp10 = einsum(t1, (0, 1), r1, (2,), (0, 2, 1)) * 0.5
    tmp10 += np.transpose(r2, (2, 0, 1))
    tmp10 += np.transpose(r2, (2, 1, 0)) * -0.5
    tmp18 = np.copy(np.transpose(ints.tmp36, (0, 2, 3, 1)))
    tmp18 += ints.tmp49
    tmp18 += np.transpose(ints.tmp61, (0, 1, 3, 2))
    tmp18 += np.transpose(ints.tmp97, (0, 2, 3, 1)) * 2
    tmp18 += np.transpose(v.ovvv, (0, 2, 3, 1))
    tmp18 += ints.tmp25 * -1
    tmp18 += np.transpose(ints.tmp98, (0, 3, 2, 1)) * -1
    tmp18 += np.transpose(ints.tmp99, (0, 2, 3, 1)) * -1
    tmp17 = np.copy(np.transpose(ints.tmp16, (1, 0))) * 2
    tmp17 += ints.tmp5
    tmp17 += f.vv * -1
    tmp17 += np.transpose(ints.tmp14, (1, 0)) * -1
    tmp17 += np.transpose(ints.tmp3, (1, 0)) * -2
    tmp17 += np.transpose(tmp16, (1, 0))
    del tmp16
    tmp8 = np.copy(tmp5) * -1
    del tmp5
    tmp8 += tmp7
    del tmp7
    tmp23 = np.copy(ints.tmp107) * 2
    tmp23 += ints.tmp108 * 2
    tmp23 += ints.tmp32
    tmp23 += ints.tmp55
    tmp23 += ints.tmp64
    tmp23 += ints.tmp72
    tmp23 += ints.tmp73 * 2
    tmp23 += ints.tmp75 * 2
    tmp23 += ints.tmp82 * 2
    tmp23 += ints.tmp83
    tmp23 += ints.tmp89 * 2
    tmp23 += ints.tmp91 * 2
    tmp23 += ints.tmp93
    tmp23 += f.ov * -1
    tmp23 += ints.tmp106 * -1
    tmp23 += ints.tmp109 * -4
    tmp23 += ints.tmp46 * -1
    tmp23 += ints.tmp54 * -2
    tmp23 += ints.tmp63 * -2
    tmp23 += ints.tmp74 * -1
    tmp23 += ints.tmp76 * -1
    tmp23 += ints.tmp7 * -2
    tmp23 += ints.tmp81 * -1
    tmp23 += ints.tmp88 * -1
    tmp23 += ints.tmp90 * -1
    tmp23 += ints.tmp94 * -2
    tmp19 = np.copy(f.oo)
    tmp19 += np.transpose(ints.tmp34, (1, 0)) * 2
    tmp19 += ints.tmp47
    tmp19 += np.transpose(ints.tmp58, (1, 0)) * 2
    tmp19 += np.transpose(ints.tmp67, (1, 0)) * 2
    tmp19 += np.transpose(ints.tmp33, (1, 0)) * -1
    tmp19 += np.transpose(ints.tmp56, (1, 0)) * -1
    tmp19 += np.transpose(ints.tmp66, (1, 0)) * -1
    tmp13 = np.copy(ints.tmp51)
    tmp13 += v.oovv
    tmp13 += ints.tmp28 * -1
    tmp22 = einsum(v.ovvv, (0, 1, 2, 3), r2, (3, 1, 4), (4, 0, 2)) * -1
    tmp22 += einsum(r2, (0, 1, 2), tmp20, (3, 4, 2, 1), (3, 4, 0))
    del tmp20
    tmp15 = np.copy(ints.tmp51)
    tmp15 += v.oovv
    tmp15 += ints.tmp28 * -1
    tmp15 += einsum(t1, (0, 1), tmp14, (2, 0, 3, 4), (2, 3, 1, 4)) * 2
    del tmp14
    tmp3 = np.copy(f.vv)
    tmp3 += np.transpose(ints.tmp14, (1, 0))
    tmp3 += np.transpose(ints.tmp3, (1, 0)) * 2
    tmp3 += np.transpose(ints.tmp16, (1, 0)) * -2
    tmp3 += ints.tmp5 * -1
    tmp0 = np.copy(v.ovvv) * 2
    tmp0 += np.transpose(v.ovvv, (0, 2, 1, 3)) * -1
    tmp2 = np.copy(np.transpose(r2, (2, 0, 1))) * -1
    tmp2 += np.transpose(r2, (2, 1, 0)) * 2
    r2new = einsum(r2, (0, 1, 2), v.vvvv, (3, 0, 4, 1), (3, 4, 2))
    r2new += einsum(t2, (0, 1, 2, 3), tmp9, (4, 0, 1), (2, 3, 4))
    del tmp9
    r2new += einsum(tmp11, (0, 1, 2, 3), tmp10, (1, 3, 4), (2, 4, 0)) * 2
    del tmp11, tmp10
    r2new += einsum(tmp12, (0, 1, 2), tmp13, (3, 0, 4, 2), (1, 4, 3)) * -1
    del tmp12, tmp13
    r2new += einsum(tmp15, (0, 1, 2, 3), r2, (3, 4, 1), (2, 4, 0)) * -1
    del tmp15
    r2new += einsum(tmp17, (0, 1), r2, (0, 2, 3), (1, 2, 3)) * -1
    r2new += einsum(tmp17, (0, 1), r2, (2, 0, 3), (2, 1, 3)) * -1
    del tmp17
    r2new += einsum(tmp18, (0, 1, 2, 3), r1, (2,), (3, 1, 0)) * -1
    del tmp18
    r2new += einsum(tmp19, (0, 1), r2, (2, 3, 0), (2, 3, 1)) * -1
    del tmp19
    r2new += einsum(t1, (0, 1), tmp21, (2, 0, 3), (1, 3, 2))
    del tmp21
    r2new += einsum(tmp8, (0,), t2, (1, 0, 2, 3), (2, 3, 1))
    r2new += einsum(t1, (0, 1), tmp22, (2, 0, 3), (3, 1, 2))
    del tmp22
    r2new += einsum(tmp23, (0, 1), r1, (2,), (1, 2, 0))
    del tmp23
    r1new = einsum(r2, (0, 1, 2), tmp0, (2, 0, 1, 3), (3,)) * -1
    del tmp0
    r1new += einsum(tmp2, (0, 1, 2), tmp1, (0, 2), (1,)) * -2
    del tmp1, tmp2
    r1new += einsum(tmp3, (0, 1), r1, (0,), (1,))
    del tmp3
    r1new += einsum(t1, (0, 1), tmp8, (0,), (1,)) * -1
    del tmp8

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ip_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:35:36.831483.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp0 : array
    tmp1 : array
    tmp100 : array
    tmp103 : array
    tmp104 : array
    tmp107 : array
    tmp108 : array
    tmp112 : array
    tmp113 : array
    tmp114 : array
    tmp116 : array
    tmp117 : array
    tmp12 : array
    tmp13 : array
    tmp134 : array
    tmp136 : array
    tmp14 : array
    tmp17 : array
    tmp19 : array
    tmp2 : array
    tmp20 : array
    tmp21 : array
    tmp22 : array
    tmp24 : array
    tmp26 : array
    tmp29 : array
    tmp3 : array
    tmp32 : array
    tmp33 : array
    tmp35 : array
    tmp36 : array
    tmp38 : array
    tmp4 : array
    tmp41 : array
    tmp44 : array
    tmp47 : array
    tmp48 : array
    tmp49 : array
    tmp51 : array
    tmp54 : array
    tmp57 : array
    tmp6 : array
    tmp60 : array
    tmp63 : array
    tmp66 : array
    tmp69 : array
    tmp70 : array
    tmp72 : array
    tmp73 : array
    tmp75 : array
    tmp78 : array
    tmp81 : array
    tmp82 : array
    tmp85 : array
    tmp86 : array
    tmp87 : array
    tmp88 : array
    tmp9 : array
    tmp90 : array
    tmp91 : array
    tmp92 : array
    tmp93 : array
    tmp94 : array
    tmp97 : array
    tmp98 : array
    tmp99 : array
    """

    tmp20 = einsum(t1, (0, 1), v.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp17 = einsum(t1, (0, 1), v.ovov, (2, 3, 0, 1), (2, 3))
    tmp47 = einsum(t1, (0, 1), v.ovov, (2, 1, 0, 3), (2, 3))
    tmp107 = einsum(t1, (0, 1), tmp20, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp86 = einsum(t1, (0, 1), tmp17, (2, 1), (0, 2))
    tmp85 = einsum(tmp47, (0, 1), t1, (2, 1), (2, 0))
    tmp99 = einsum(t1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp97 = einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 1), (2, 3))
    tmp93 = einsum(t1, (0, 1), v.ovvv, (0, 1, 2, 3), (2, 3))
    tmp90 = einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp13 = einsum(t1, (0, 1), v.ooov, (2, 3, 0, 1), (2, 3))
    tmp12 = einsum(t1, (0, 1), v.ooov, (2, 0, 3, 1), (2, 3))
    tmp81 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp22 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 3, 1), (4, 0))
    tmp24 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 1, 3), (0, 4))
    tmp0 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp136 = einsum(t2, (0, 1, 2, 3), v.ovov, (0, 2, 1, 4), (3, 4))
    tmp134 = einsum(t2, (0, 1, 2, 3), v.ovov, (0, 4, 1, 2), (3, 4))
    tmp117 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp116 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 3, 5), (4, 0, 5, 1))
    tmp114 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp113 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp112 = einsum(t1, (0, 1), v.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp108 = einsum(tmp107, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    tmp104 = einsum(t1, (0, 1), tmp86, (2, 0), (2, 1))
    tmp103 = einsum(t1, (0, 1), tmp85, (2, 0), (2, 1))
    tmp100 = einsum(t1, (0, 1), tmp99, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp98 = einsum(tmp97, (0, 1), t1, (2, 0), (2, 1))
    tmp94 = einsum(t1, (0, 1), tmp93, (2, 1), (0, 2))
    tmp92 = einsum(tmp90, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    tmp91 = einsum(tmp90, (0, 1, 2, 3), t1, (2, 4), (0, 1, 3, 4))
    tmp88 = einsum(t1, (0, 1), tmp13, (2, 0), (2, 1))
    tmp87 = einsum(t1, (0, 1), tmp12, (2, 0), (2, 1))
    tmp82 = einsum(tmp81, (0, 1, 2, 3), t1, (2, 4), (1, 0, 3, 4))
    tmp78 = einsum(t1, (0, 1), tmp22, (2, 0), (2, 1))
    tmp75 = einsum(t1, (0, 1), tmp24, (2, 0), (2, 1))
    tmp73 = einsum(t2, (0, 1, 2, 3), tmp20, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp72 = einsum(t2, (0, 1, 2, 3), tmp20, (4, 5, 1, 2), (4, 0, 5, 3))
    tmp70 = einsum(t2, (0, 1, 2, 3), tmp20, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp69 = einsum(t2, (0, 1, 2, 3), tmp20, (4, 1, 5, 2), (4, 0, 5, 3))
    tmp66 = einsum(t2, (0, 1, 2, 3), tmp20, (4, 1, 0, 2), (4, 3))
    tmp63 = einsum(t2, (0, 1, 2, 3), tmp20, (4, 0, 1, 2), (4, 3))
    tmp60 = einsum(tmp17, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp57 = einsum(tmp47, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp54 = einsum(tmp17, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp51 = einsum(tmp17, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp49 = einsum(tmp47, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp48 = einsum(tmp47, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp44 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp41 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 2, 4, 3), (0, 4))
    tmp38 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 3, 4, 2), (0, 4))
    tmp36 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp35 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 2, 3, 5), (4, 0, 1, 5))
    tmp33 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp32 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 1, 3, 5), (4, 0, 2, 5))
    tmp29 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 1, 0, 2), (4, 3))
    tmp26 = einsum(v.ooov, (0, 1, 2, 3), t2, (2, 1, 4, 3), (0, 4))
    tmp21 = einsum(t1, (0, 1), v.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp19 = einsum(t1, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3))
    tmp14 = einsum(v.oooo, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    tmp9 = einsum(t1, (0, 1), tmp0, (0, 2), (2, 1))
    tmp6 = einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp4 = einsum(f.ov, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp3 = einsum(f.ov, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp2 = einsum(t1, (0, 1), f.vv, (2, 1), (0, 2))
    tmp1 = einsum(t1, (0, 1), f.oo, (2, 0), (2, 1))

    return {f"tmp0": tmp0, f"tmp1": tmp1, f"tmp100": tmp100, f"tmp103": tmp103, f"tmp104": tmp104, f"tmp107": tmp107, f"tmp108": tmp108, f"tmp112": tmp112, f"tmp113": tmp113, f"tmp114": tmp114, f"tmp116": tmp116, f"tmp117": tmp117, f"tmp12": tmp12, f"tmp13": tmp13, f"tmp134": tmp134, f"tmp136": tmp136, f"tmp14": tmp14, f"tmp17": tmp17, f"tmp19": tmp19, f"tmp2": tmp2, f"tmp20": tmp20, f"tmp21": tmp21, f"tmp22": tmp22, f"tmp24": tmp24, f"tmp26": tmp26, f"tmp29": tmp29, f"tmp3": tmp3, f"tmp32": tmp32, f"tmp33": tmp33, f"tmp35": tmp35, f"tmp36": tmp36, f"tmp38": tmp38, f"tmp4": tmp4, f"tmp41": tmp41, f"tmp44": tmp44, f"tmp47": tmp47, f"tmp48": tmp48, f"tmp49": tmp49, f"tmp51": tmp51, f"tmp54": tmp54, f"tmp57": tmp57, f"tmp6": tmp6, f"tmp60": tmp60, f"tmp63": tmp63, f"tmp66": tmp66, f"tmp69": tmp69, f"tmp70": tmp70, f"tmp72": tmp72, f"tmp73": tmp73, f"tmp75": tmp75, f"tmp78": tmp78, f"tmp81": tmp81, f"tmp82": tmp82, f"tmp85": tmp85, f"tmp86": tmp86, f"tmp87": tmp87, f"tmp88": tmp88, f"tmp9": tmp9, f"tmp90": tmp90, f"tmp91": tmp91, f"tmp92": tmp92, f"tmp93": tmp93, f"tmp94": tmp94, f"tmp97": tmp97, f"tmp98": tmp98, f"tmp99": tmp99}

def hbar_lmatvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:35:36.884762.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp10 = einsum(t1, (0, 1), r2, (2, 3, 1), (2, 3, 0))
    tmp16 = np.copy(f.ov)
    tmp16 += ints.tmp17 * 2
    tmp16 += ints.tmp47 * -1
    tmp19 = np.copy(np.transpose(t2, (0, 1, 3, 2)))
    tmp19 += t2 * -0.5
    tmp12 = np.copy(ints.tmp20)
    tmp12 += np.transpose(v.ooov, (0, 2, 1, 3))
    tmp11 = np.copy(tmp10)
    tmp11 += np.transpose(tmp10, (1, 0, 2)) * -0.5
    tmp9 = np.copy(ints.tmp112)
    tmp9 += v.oovv
    tmp9 += np.transpose(ints.tmp113, (0, 1, 3, 2)) * -1
    tmp14 = np.copy(ints.tmp81)
    tmp14 += np.transpose(ints.tmp90, (0, 1, 3, 2))
    tmp18 = np.copy(f.oo) * 0.5
    tmp18 += np.transpose(ints.tmp0, (1, 0)) * 0.5
    tmp18 += ints.tmp13
    tmp18 += ints.tmp24
    tmp18 += ints.tmp86
    tmp18 += ints.tmp12 * -0.5
    tmp18 += ints.tmp22 * -0.5
    tmp18 += ints.tmp85 * -0.5
    tmp17 = np.copy(ints.tmp136) * 2
    tmp17 += np.transpose(ints.tmp97, (1, 0))
    tmp17 += f.vv * -1
    tmp17 += ints.tmp134 * -1
    tmp17 += ints.tmp93 * -2
    tmp17 += einsum(t1, (0, 1), tmp16, (0, 2), (1, 2))
    tmp20 = einsum(tmp19, (0, 1, 2, 3), r2, (1, 0, 2), (3,))
    del tmp19
    tmp8 = np.copy(ints.tmp117) * 2
    tmp8 += np.transpose(ints.tmp99, (0, 1, 3, 2))
    tmp8 += np.transpose(v.ovov, (0, 2, 1, 3))
    tmp8 += ints.tmp114 * -1
    tmp8 += ints.tmp116 * -1
    tmp7 = np.copy(r2)
    tmp7 += np.transpose(r2, (1, 0, 2)) * -0.5
    tmp13 = np.copy(ints.tmp107)
    tmp13 += np.transpose(ints.tmp90, (0, 1, 3, 2))
    tmp13 += np.transpose(v.oooo, (0, 2, 1, 3))
    tmp15 = np.copy(ints.tmp20)
    tmp15 += np.transpose(v.ooov, (0, 2, 1, 3))
    tmp6 = np.copy(f.oo)
    tmp6 += np.transpose(ints.tmp0, (1, 0))
    tmp6 += np.transpose(ints.tmp13, (1, 0)) * 2
    tmp6 += ints.tmp24 * 2
    tmp6 += ints.tmp86 * 2
    tmp6 += ints.tmp12 * -1
    tmp6 += ints.tmp22 * -1
    tmp6 += ints.tmp85 * -1
    tmp1 = np.copy(ints.tmp108)
    tmp1 += np.transpose(ints.tmp14, (1, 2, 0, 3))
    tmp1 += ints.tmp32
    tmp1 += ints.tmp69
    tmp1 += ints.tmp73
    tmp1 += ints.tmp82
    tmp1 += ints.tmp91
    tmp1 += ints.tmp100 * -1
    tmp1 += ints.tmp20 * -1
    tmp1 += ints.tmp44 * -1
    tmp1 += ints.tmp70 * -2
    tmp4 = np.copy(v.ooov) * -0.5
    tmp4 += np.transpose(v.ovoo, (0, 2, 3, 1))
    tmp3 = np.copy(np.transpose(ints.tmp33, (0, 2, 1, 3)))
    tmp3 += ints.tmp35
    tmp3 += np.transpose(ints.tmp57, (0, 2, 1, 3))
    tmp3 += np.transpose(ints.tmp72, (0, 2, 1, 3))
    tmp3 += ints.tmp92
    tmp3 += ints.tmp21 * -1
    tmp3 += ints.tmp36 * -2
    tmp3 += np.transpose(ints.tmp60, (0, 2, 1, 3)) * -2
    tmp3 += np.transpose(ints.tmp6, (1, 0, 2, 3)) * -1
    tmp0 = np.copy(r2) * -0.5
    tmp0 += np.transpose(r2, (1, 0, 2))
    tmp5 = np.copy(ints.tmp104) * 2
    tmp5 += ints.tmp19
    tmp5 += ints.tmp1
    tmp5 += ints.tmp29 * 2
    tmp5 += ints.tmp3
    tmp5 += ints.tmp41
    tmp5 += ints.tmp49 * 2
    tmp5 += ints.tmp51 * 2
    tmp5 += ints.tmp63 * 2
    tmp5 += ints.tmp75 * 2
    tmp5 += ints.tmp88 * 2
    tmp5 += ints.tmp98
    tmp5 += ints.tmp9
    tmp5 += f.ov * -1
    tmp5 += ints.tmp103 * -1
    tmp5 += ints.tmp17 * -2
    tmp5 += ints.tmp26 * -1
    tmp5 += ints.tmp2 * -1
    tmp5 += ints.tmp38 * -2
    tmp5 += ints.tmp48 * -1
    tmp5 += ints.tmp4 * -2
    tmp5 += ints.tmp54 * -4
    tmp5 += ints.tmp66 * -1
    tmp5 += ints.tmp78 * -1
    tmp5 += ints.tmp87 * -1
    tmp5 += ints.tmp94 * -2
    tmp2 = np.copy(r2) * 2
    tmp2 += np.transpose(r2, (1, 0, 2)) * -1
    r2new = einsum(tmp8, (0, 1, 2, 3), tmp7, (0, 4, 2), (1, 4, 3)) * 2
    del tmp8, tmp7
    r2new += einsum(r2, (0, 1, 2), tmp9, (1, 3, 4, 2), (0, 3, 4)) * -1
    r2new += einsum(tmp9, (0, 1, 2, 3), r2, (0, 4, 3), (1, 4, 2)) * -1
    del tmp9
    r2new += einsum(tmp12, (0, 1, 2, 3), tmp11, (0, 4, 2), (1, 4, 3)) * -2
    del tmp12, tmp11
    r2new += einsum(r2, (0, 1, 2), tmp13, (0, 1, 3, 4), (3, 4, 2))
    del tmp13
    r2new += einsum(tmp14, (0, 1, 2, 3), r2, (1, 0, 4), (3, 2, 4))
    del tmp14
    r2new += einsum(tmp15, (0, 1, 2, 3), tmp10, (4, 0, 1), (4, 2, 3))
    r2new += einsum(tmp15, (0, 1, 2, 3), tmp10, (0, 4, 1), (2, 4, 3))
    del tmp10
    r2new += einsum(tmp17, (0, 1), r2, (2, 3, 0), (2, 3, 1)) * -1
    del tmp17
    r2new += einsum(r2, (0, 1, 2), tmp18, (0, 3), (3, 1, 2)) * -2
    r2new += einsum(r2, (0, 1, 2), tmp18, (1, 3), (0, 3, 2)) * -2
    del tmp18
    r2new += einsum(tmp20, (0,), v.ovov, (1, 2, 3, 0), (1, 3, 2)) * -2
    del tmp20
    r2new += einsum(tmp15, (0, 1, 2, 3), r1, (0,), (1, 2, 3))
    del tmp15
    r2new += einsum(r1, (0,), tmp16, (1, 2), (1, 0, 2)) * -1
    del tmp16
    r1new = einsum(tmp0, (0, 1, 2), tmp1, (0, 1, 3, 2), (3,)) * -2
    del tmp0, tmp1
    r1new += einsum(tmp2, (0, 1, 2), tmp3, (0, 3, 1, 2), (3,)) * -1
    del tmp3
    r1new += einsum(tmp4, (0, 1, 2, 3), r2, (0, 2, 3), (1,)) * 2
    del tmp4
    r1new += einsum(tmp5, (0, 1), tmp2, (0, 2, 1), (2,))
    del tmp2, tmp5
    r1new += einsum(r1, (0,), tmp6, (0, 1), (1,)) * -1
    del tmp6

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ea_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:36:34.240753.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp10 : array
    tmp103 : array
    tmp106 : array
    tmp107 : array
    tmp109 : array
    tmp11 : array
    tmp110 : array
    tmp111 : array
    tmp112 : array
    tmp113 : array
    tmp14 : array
    tmp16 : array
    tmp17 : array
    tmp19 : array
    tmp2 : array
    tmp24 : array
    tmp27 : array
    tmp29 : array
    tmp3 : array
    tmp31 : array
    tmp34 : array
    tmp37 : array
    tmp4 : array
    tmp40 : array
    tmp43 : array
    tmp46 : array
    tmp48 : array
    tmp51 : array
    tmp53 : array
    tmp55 : array
    tmp56 : array
    tmp57 : array
    tmp59 : array
    tmp62 : array
    tmp69 : array
    tmp70 : array
    tmp73 : array
    tmp76 : array
    tmp79 : array
    tmp80 : array
    tmp83 : array
    tmp84 : array
    tmp87 : array
    tmp88 : array
    tmp90 : array
    tmp92 : array
    tmp95 : array
    tmp96 : array
    tmp97 : array
    tmp98 : array
    """

    tmp17 = einsum(t1, (0, 1), v.ovov, (2, 3, 0, 1), (2, 3))
    tmp55 = einsum(t1, (0, 1), v.ovov, (2, 1, 0, 3), (2, 3))
    tmp112 = einsum(t1, (0, 1), tmp17, (2, 1), (0, 2))
    tmp110 = einsum(tmp55, (0, 1), t1, (2, 1), (2, 0))
    tmp16 = einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 1), (2, 3))
    tmp14 = einsum(t1, (0, 1), v.ovvv, (0, 1, 2, 3), (2, 3))
    tmp97 = einsum(t1, (0, 1), v.ooov, (2, 3, 0, 1), (2, 3))
    tmp95 = einsum(t1, (0, 1), v.ooov, (2, 0, 3, 1), (2, 3))
    tmp83 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 3, 1), (4, 0))
    tmp79 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 1, 3), (4, 0))
    tmp69 = einsum(t1, (0, 1), v.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp10 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp113 = einsum(t1, (0, 1), tmp112, (2, 0), (2, 1))
    tmp111 = einsum(t1, (0, 1), tmp110, (2, 0), (2, 1))
    tmp109 = einsum(t1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp107 = einsum(t1, (0, 1), v.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp106 = einsum(t1, (0, 1), tmp16, (1, 2), (0, 2))
    tmp103 = einsum(t1, (0, 1), tmp14, (2, 1), (0, 2))
    tmp98 = einsum(t1, (0, 1), tmp97, (2, 0), (2, 1))
    tmp96 = einsum(t1, (0, 1), tmp95, (2, 0), (2, 1))
    tmp92 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp90 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp88 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp87 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 3, 5), (4, 0, 5, 1))
    tmp84 = einsum(t1, (0, 1), tmp83, (2, 0), (2, 1))
    tmp80 = einsum(t1, (0, 1), tmp79, (2, 0), (2, 1))
    tmp76 = einsum(tmp69, (0, 1, 2, 3), t2, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp73 = einsum(t2, (0, 1, 2, 3), tmp69, (4, 0, 1, 3), (4, 2))
    tmp70 = einsum(t2, (0, 1, 2, 3), tmp69, (4, 1, 0, 3), (4, 2))
    tmp62 = einsum(tmp17, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp59 = einsum(tmp17, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp57 = einsum(tmp55, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp56 = einsum(tmp55, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp53 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 0, 5, 3), (4, 5, 1, 2))
    tmp51 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 0, 3, 5), (4, 5, 1, 2))
    tmp48 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 3, 4, 5), (0, 2, 4, 5))
    tmp46 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 2, 4, 5), (0, 3, 4, 5))
    tmp43 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 2, 4, 3), (0, 4))
    tmp40 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 3, 4, 2), (0, 4))
    tmp37 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp34 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 0, 1, 3), (4, 2))
    tmp31 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 0, 1, 2), (4, 3))
    tmp29 = einsum(t2, (0, 1, 2, 3), v.ovov, (0, 2, 1, 4), (3, 4))
    tmp27 = einsum(v.ovov, (0, 1, 2, 3), t2, (0, 2, 4, 1), (4, 3))
    tmp24 = einsum(v.vvvv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp19 = einsum(t1, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3))
    tmp11 = einsum(t1, (0, 1), tmp10, (0, 2), (2, 1))
    tmp4 = einsum(f.ov, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp3 = einsum(f.ov, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp2 = einsum(t1, (0, 1), f.vv, (2, 1), (0, 2))
    tmp1 = einsum(t1, (0, 1), f.oo, (2, 0), (2, 1))

    return {f"tmp1": tmp1, f"tmp10": tmp10, f"tmp103": tmp103, f"tmp106": tmp106, f"tmp107": tmp107, f"tmp109": tmp109, f"tmp11": tmp11, f"tmp110": tmp110, f"tmp111": tmp111, f"tmp112": tmp112, f"tmp113": tmp113, f"tmp14": tmp14, f"tmp16": tmp16, f"tmp17": tmp17, f"tmp19": tmp19, f"tmp2": tmp2, f"tmp24": tmp24, f"tmp27": tmp27, f"tmp29": tmp29, f"tmp3": tmp3, f"tmp31": tmp31, f"tmp34": tmp34, f"tmp37": tmp37, f"tmp4": tmp4, f"tmp40": tmp40, f"tmp43": tmp43, f"tmp46": tmp46, f"tmp48": tmp48, f"tmp51": tmp51, f"tmp53": tmp53, f"tmp55": tmp55, f"tmp56": tmp56, f"tmp57": tmp57, f"tmp59": tmp59, f"tmp62": tmp62, f"tmp69": tmp69, f"tmp70": tmp70, f"tmp73": tmp73, f"tmp76": tmp76, f"tmp79": tmp79, f"tmp80": tmp80, f"tmp83": tmp83, f"tmp84": tmp84, f"tmp87": tmp87, f"tmp88": tmp88, f"tmp90": tmp90, f"tmp92": tmp92, f"tmp95": tmp95, f"tmp96": tmp96, f"tmp97": tmp97, f"tmp98": tmp98}

def hbar_lmatvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:36:34.286597.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp16 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp16 += t2 * -1
    tmp19 = np.copy(f.ov)
    tmp19 += ints.tmp17 * 2
    tmp19 += ints.tmp55 * -1
    tmp21 = np.copy(ints.tmp69)
    tmp21 += np.transpose(v.ooov, (0, 2, 1, 3))
    tmp10 = einsum(t1, (0, 1), r2, (2, 1, 3), (3, 0, 2))
    tmp17 = einsum(r2, (0, 1, 2), tmp16, (2, 3, 1, 0), (3,))
    del tmp16
    tmp15 = einsum(t1, (0, 1), r1, (1,), (0,))
    tmp26 = einsum(t1, (0, 1), tmp19, (0, 2), (1, 2))
    tmp23 = einsum(t1, (0, 1), tmp21, (2, 0, 3, 4), (2, 3, 1, 4))
    tmp11 = einsum(t1, (0, 1), tmp10, (2, 3, 1), (2, 0, 3))
    tmp5 = np.copy(np.transpose(r2, (2, 0, 1)))
    tmp5 += np.transpose(r2, (2, 1, 0)) * -0.5
    tmp2 = np.copy(np.transpose(r2, (2, 0, 1))) * -0.5
    tmp2 += np.transpose(r2, (2, 1, 0))
    tmp22 = np.copy(np.transpose(ints.tmp87, (0, 1, 3, 2)))
    tmp22 += np.transpose(ints.tmp92, (0, 1, 3, 2))
    tmp22 += ints.tmp109 * -1
    tmp22 += np.transpose(ints.tmp88, (0, 1, 3, 2)) * -2
    tmp22 += np.transpose(v.ovov, (0, 2, 3, 1)) * -1
    tmp22 += einsum(t1, (0, 1), tmp21, (2, 3, 0, 4), (2, 3, 4, 1))
    del tmp21
    tmp28 = np.copy(f.oo)
    tmp28 += np.transpose(ints.tmp10, (1, 0))
    tmp28 += ints.tmp112 * 2
    tmp28 += ints.tmp79 * 2
    tmp28 += ints.tmp97 * 2
    tmp28 += ints.tmp110 * -1
    tmp28 += ints.tmp83 * -1
    tmp28 += ints.tmp95 * -1
    tmp18 = np.copy(tmp15)
    del tmp15
    tmp18 += tmp17 * -1
    del tmp17
    tmp27 = np.copy(np.transpose(ints.tmp16, (1, 0)))
    tmp27 += ints.tmp29 * 2
    tmp27 += f.vv * -1
    tmp27 += ints.tmp14 * -2
    tmp27 += ints.tmp27 * -1
    tmp27 += tmp26
    del tmp26
    tmp20 = einsum(t1, (0, 1), r2, (1, 2, 3), (3, 0, 2))
    tmp24 = np.copy(np.transpose(ints.tmp90, (0, 1, 3, 2)))
    tmp24 += ints.tmp107 * -1
    tmp24 += v.oovv * -1
    tmp24 += np.transpose(tmp23, (0, 1, 3, 2))
    del tmp23
    tmp25 = einsum(t2, (0, 1, 2, 3), r2, (2, 3, 4), (4, 0, 1))
    tmp25 += tmp11
    tmp12 = np.copy(tmp11) * -0.5
    tmp12 += np.transpose(tmp11, (0, 2, 1))
    tmp9 = np.copy(np.transpose(r2, (2, 0, 1))) * -1
    tmp9 += np.transpose(r2, (2, 1, 0)) * 2
    tmp6 = einsum(t1, (0, 1), tmp5, (2, 3, 1), (2, 0, 3)) * 2
    tmp14 = np.copy(f.vv)
    tmp14 += np.transpose(ints.tmp14, (1, 0)) * 2
    tmp14 += ints.tmp27
    tmp14 += np.transpose(ints.tmp16, (1, 0)) * -1
    tmp14 += ints.tmp29 * -2
    tmp1 = np.copy(ints.tmp24)
    tmp1 += np.transpose(ints.tmp46, (0, 2, 1, 3)) * 0.5
    tmp1 += np.transpose(ints.tmp53, (0, 2, 1, 3)) * 0.5
    tmp1 += np.transpose(ints.tmp76, (0, 3, 1, 2))
    tmp1 += np.transpose(ints.tmp37, (0, 3, 1, 2)) * -0.5
    tmp1 += np.transpose(ints.tmp48, (0, 2, 1, 3)) * -1
    tmp1 += np.transpose(ints.tmp51, (0, 2, 1, 3)) * -1
    tmp4 = np.copy(ints.tmp107)
    tmp4 += v.oovv
    tmp4 += np.transpose(ints.tmp90, (0, 1, 3, 2)) * -1
    tmp3 = einsum(t1, (0, 1), tmp2, (2, 3, 1), (2, 0, 3))
    del tmp2
    tmp0 = np.copy(ints.tmp24)
    tmp0 += np.transpose(ints.tmp46, (0, 2, 1, 3)) * 2
    tmp0 += np.transpose(ints.tmp53, (0, 2, 1, 3)) * 2
    tmp0 += np.transpose(ints.tmp76, (0, 3, 1, 2))
    tmp0 += np.transpose(ints.tmp37, (0, 3, 1, 2)) * -2
    tmp0 += np.transpose(ints.tmp48, (0, 2, 1, 3)) * -4
    tmp0 += np.transpose(ints.tmp51, (0, 2, 1, 3)) * -1
    tmp0 += np.transpose(v.ovvv, (0, 2, 1, 3)) * -2
    tmp0 += np.transpose(v.ovvv, (0, 2, 3, 1))
    tmp8 = np.copy(ints.tmp106) * 0.5
    tmp8 += ints.tmp113
    tmp8 += ints.tmp11 * 0.5
    tmp8 += ints.tmp19 * 0.5
    tmp8 += ints.tmp1 * 0.5
    tmp8 += ints.tmp34
    tmp8 += ints.tmp3 * 0.5
    tmp8 += ints.tmp43 * 0.5
    tmp8 += ints.tmp57
    tmp8 += ints.tmp59
    tmp8 += ints.tmp70
    tmp8 += ints.tmp80
    tmp8 += ints.tmp98
    tmp8 += f.ov * -0.5
    tmp8 += ints.tmp103 * -1
    tmp8 += ints.tmp111 * -0.5
    tmp8 += ints.tmp17 * -1
    tmp8 += ints.tmp2 * -0.5
    tmp8 += ints.tmp31 * -0.5
    tmp8 += ints.tmp40 * -1
    tmp8 += ints.tmp4 * -1
    tmp8 += ints.tmp56 * -0.5
    tmp8 += ints.tmp62 * -2
    tmp8 += ints.tmp73 * -0.5
    tmp8 += ints.tmp84 * -0.5
    tmp8 += ints.tmp96 * -0.5
    tmp7 = np.copy(ints.tmp109)
    tmp7 += np.transpose(ints.tmp88, (0, 1, 3, 2)) * 2
    tmp7 += np.transpose(v.ovov, (0, 2, 3, 1))
    tmp7 += np.transpose(ints.tmp87, (0, 1, 3, 2)) * -1
    tmp7 += np.transpose(ints.tmp92, (0, 1, 3, 2)) * -1
    tmp13 = np.copy(tmp11) * 2
    tmp13 += np.transpose(tmp11, (0, 2, 1)) * -1
    del tmp11
    r2new = einsum(v.ovvv, (0, 1, 2, 3), r1, (3,), (1, 2, 0)) * -1
    r2new += einsum(r2, (0, 1, 2), v.vvvv, (3, 0, 4, 1), (3, 4, 2))
    r2new += einsum(tmp20, (0, 1, 2), v.ovvv, (1, 3, 4, 2), (3, 4, 0)) * -1
    del tmp20
    r2new += einsum(v.ovvv, (0, 1, 2, 3), tmp10, (4, 0, 3), (2, 1, 4)) * -1
    del tmp10
    r2new += einsum(tmp22, (0, 1, 2, 3), tmp5, (0, 3, 4), (2, 4, 1)) * -2
    del tmp5, tmp22
    r2new += einsum(r2, (0, 1, 2), tmp24, (2, 3, 4, 1), (0, 4, 3))
    r2new += einsum(tmp24, (0, 1, 2, 3), r2, (3, 4, 0), (2, 4, 1))
    del tmp24
    r2new += einsum(tmp25, (0, 1, 2), v.ovov, (2, 3, 1, 4), (4, 3, 0))
    del tmp25
    r2new += einsum(tmp27, (0, 1), r2, (0, 2, 3), (1, 2, 3)) * -1
    r2new += einsum(tmp27, (0, 1), r2, (2, 0, 3), (2, 1, 3)) * -1
    del tmp27
    r2new += einsum(r2, (0, 1, 2), tmp28, (2, 3), (0, 1, 3)) * -1
    del tmp28
    r2new += einsum(tmp18, (0,), v.ovov, (1, 2, 0, 3), (2, 3, 1))
    r2new += einsum(r1, (0,), tmp19, (1, 2), (2, 0, 1)) * -1
    r1new = einsum(r2, (0, 1, 2), tmp0, (2, 3, 0, 1), (3,))
    del tmp0
    r1new += einsum(r2, (0, 1, 2), tmp1, (2, 3, 1, 0), (3,)) * -2
    del tmp1
    r1new += einsum(tmp4, (0, 1, 2, 3), tmp3, (0, 1, 3), (2,)) * 2
    del tmp4, tmp3
    r1new += einsum(tmp7, (0, 1, 2, 3), tmp6, (0, 1, 3), (2,))
    del tmp7, tmp6
    r1new += einsum(tmp9, (0, 1, 2), tmp8, (0, 2), (1,)) * 2
    del tmp9, tmp8
    r1new += einsum(ints.tmp69, (0, 1, 2, 3), tmp12, (0, 1, 2), (3,)) * -2
    del tmp12
    r1new += einsum(tmp13, (0, 1, 2), v.ooov, (0, 1, 2, 3), (3,)) * -1
    del tmp13
    r1new += einsum(r1, (0,), tmp14, (0, 1), (1,))
    del tmp14
    r1new += einsum(tmp18, (0,), tmp19, (0, 1), (1,)) * -1
    del tmp19, tmp18

    return {f"r1new": r1new, f"r2new": r2new}

