"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T17:16:22.166169
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace
from ebcc.backend import _inflate


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:16:22.869247.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1)))
    tmp0 += np.transpose(v.ovov, (0, 2, 1, 3)) * -0.5
    tmp1 = np.copy(f.ov)
    tmp1 += einsum(t1, (0, 1), tmp0, (0, 2, 3, 1), (2, 3))
    del tmp0
    e_cc = einsum(t2, (0, 1, 2, 3), v.ovov, (0, 2, 1, 3), ()) * 2
    e_cc += einsum(t2, (0, 1, 2, 3), v.ovov, (0, 3, 1, 2), ()) * -1
    e_cc += einsum(tmp1, (0, 1), t1, (0, 1), ()) * 2
    del tmp1

    return e_cc

def update_amps(f=None, t1=None, t2=None, t3=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:18:26.069150.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    t3 : array
        T3 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    t1new : array
        Updated T1 residuals.
    t2new : array
        Updated T2 residuals.
    t3new : array
        Updated T3 residuals.
    """

    space = kwargs["space"]
    t1new = Namespace()
    t2new = Namespace()
    t3new = Namespace()
    so = np.ones((t1.shape[0],), dtype=bool)
    sv = np.ones((t1.shape[1],), dtype=bool)
    sO = space.active[space.correlated][space.occupied[space.correlated]]
    sV = space.active[space.correlated][space.virtual[space.correlated]]
    t2_OoVv = np.copy(t2[np.ix_(sO, so, sV, sv)])
    t1_oV = np.copy(t1[np.ix_(so, sV)])
    t1_Ov = np.copy(t1[np.ix_(sO, sv)])
    t2_Oovv = np.copy(t2[np.ix_(sO, so, sv, sv)])
    t2_OOvv = np.copy(t2[np.ix_(sO, sO, sv, sv)])
    t2_OovV = np.copy(t2[np.ix_(sO, so, sv, sV)])
    t2_OoVV = np.copy(t2[np.ix_(sO, so, sV, sV)])
    t2_oovv = np.copy(t2[np.ix_(so, so, sv, sv)])
    t2_ooVV = np.copy(t2[np.ix_(so, so, sV, sV)])
    t2_ooVv = np.copy(t2[np.ix_(so, so, sV, sv)])
    t2_OOvV = np.copy(t2[np.ix_(sO, sO, sv, sV)])
    t1_ov = np.copy(t1[np.ix_(so, sv)])

    tmp173 = einsum(v.ovov, (0, 1, 2, 3), t1_Ov, (4, 3), (0, 2, 1, 4))
    tmp294 = einsum(v.Vvov, (0, 1, 2, 3), t1_Ov, (4, 1), (2, 3, 4, 0))
    tmp218 = einsum(v.ovov, (0, 1, 2, 3), t1_oV, (2, 4), (0, 1, 3, 4))
    tmp1 = einsum(t1, (0, 1), v.ovov, (2, 3, 0, 1), (2, 3))
    tmp187 = einsum(v.OvVo, (0, 1, 2, 3), t1_Ov, (4, 1), (3, 4, 0, 2))
    tmp148 = einsum(t1, (0, 1), v.Voov, (2, 0, 3, 1), (3, 2))
    tmp14 = einsum(v.ovov, (0, 1, 2, 3), t1, (2, 1), (0, 3))
    tmp154 = einsum(t1_oV, (0, 1), v.VoVo, (2, 3, 4, 0), (3, 1, 2, 4))
    tmp307 = einsum(tmp173, (0, 1, 2, 3), t1_Ov, (4, 2), (0, 1, 4, 3))
    tmp176 = einsum(t1_Ov, (0, 1), v.Ooov, (2, 3, 4, 1), (4, 3, 0, 2))
    tmp134 = einsum(t1_oV, (0, 1), v.Ooov, (2, 0, 3, 4), (3, 4, 2, 1))
    tmp184 = einsum(v.Ovov, (0, 1, 2, 3), t1, (2, 3), (1, 0))
    tmp297 = einsum(v.Vvov, (0, 1, 2, 3), t1_Ov, (4, 3), (2, 1, 4, 0))
    tmp181 = einsum(v.Ovov, (0, 1, 2, 3), t1, (2, 1), (3, 0))
    tmp193 = einsum(tmp173, (0, 1, 2, 3), t1_oV, (0, 4), (1, 2, 3, 4))
    tmp151 = einsum(t1, (0, 1), v.Voov, (2, 3, 0, 1), (3, 2))
    tmp190 = einsum(v.OVov, (0, 1, 2, 3), t1_Ov, (4, 3), (2, 4, 0, 1))
    tmp304 = einsum(v.OvOv, (0, 1, 2, 3), t1_Ov, (4, 3), (1, 4, 0, 2))
    tmp4 = einsum(v.ovov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 2, 1))
    tmp116 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp62 = einsum(v.ooov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp75 = einsum(t1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp122 = einsum(v.OoOo, (0, 1, 2, 3), t1_oV, (3, 4), (1, 0, 2, 4))
    tmp313 = einsum(tmp294, (0, 1, 2, 3), t1_Ov, (4, 1), (0, 4, 2, 3))
    tmp231 = einsum(tmp218, (0, 1, 2, 3), t2_OovV, (4, 0, 1, 5), (2, 4, 3, 5))
    tmp275 = einsum(t2_OoVv, (0, 1, 2, 3), tmp173, (1, 4, 3, 5), (4, 5, 0, 2))
    tmp216 = einsum(tmp1, (0, 1), t2_OOvV, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp188 = einsum(tmp187, (0, 1, 2, 3), t1_oV, (0, 4), (1, 2, 4, 3))
    del tmp187
    tmp260 = einsum(v.Vvov, (0, 1, 2, 3), t2_OoVv, (4, 2, 5, 1), (3, 4, 5, 0))
    tmp292 = einsum(t1_Ov, (0, 1), v.VvVv, (2, 3, 4, 1), (3, 0, 2, 4))
    tmp300 = einsum(v.OvOv, (0, 1, 2, 3), t2_OOvv, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp167 = einsum(v.OvOO, (0, 1, 2, 3), t1_Ov, (4, 1), (4, 0, 2, 3))
    tmp219 = einsum(tmp218, (0, 1, 2, 3), t2_OovV, (4, 0, 2, 5), (1, 4, 3, 5))
    tmp149 = einsum(t1_oV, (0, 1), tmp148, (0, 2), (1, 2))
    del tmp148
    tmp285 = einsum(t1_Ov, (0, 1), v.OvVV, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp53 = einsum(v.OVVo, (0, 1, 2, 3), t3, (4, 5, 0, 2, 6, 1), (3, 4, 5, 6))
    tmp203 = einsum(v.OvOV, (0, 1, 2, 3), t2_OOvV, (4, 5, 1, 6), (4, 5, 0, 2, 6, 3))
    tmp227 = einsum(t2_OoVv, (0, 1, 2, 3), tmp218, (1, 4, 3, 5), (4, 0, 5, 2))
    tmp161 = einsum(v.VoVv, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp214 = einsum(tmp14, (0, 1), t2_OOvV, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp281 = einsum(v.OoVv, (0, 1, 2, 3), t1_Ov, (4, 3), (1, 4, 0, 2))
    tmp223 = einsum(v.OVVo, (0, 1, 2, 3), t3, (4, 5, 0, 6, 1, 2), (3, 4, 5, 6))
    tmp201 = einsum(t2_OOvV, (0, 1, 2, 3), f.ov, (4, 2), (4, 0, 1, 3))
    tmp265 = einsum(t1_oV, (0, 1), v.VoVV, (2, 0, 3, 4), (1, 2, 3, 4))
    tmp239 = einsum(v.OvVo, (0, 1, 2, 3), t2_OovV, (4, 3, 1, 5), (4, 0, 5, 2))
    tmp142 = einsum(v.Voov, (0, 1, 2, 3), t2_ooVv, (2, 1, 4, 3), (4, 0))
    tmp155 = einsum(tmp154, (0, 1, 2, 3), t1_oV, (0, 4), (1, 4, 3, 2))
    del tmp154
    tmp165 = einsum(f.Ov, (0, 1), t1_Ov, (2, 1), (0, 2))
    tmp308 = einsum(t1_oV, (0, 1), tmp307, (0, 2, 3, 4), (2, 4, 3, 1))
    del tmp307
    tmp171 = einsum(t2_Oovv, (0, 1, 2, 3), v.Ovov, (4, 2, 1, 3), (0, 4))
    tmp252 = einsum(v.OVov, (0, 1, 2, 3), t2_OovV, (4, 2, 3, 5), (4, 0, 5, 1))
    tmp130 = einsum(t1_oV, (0, 1), v.OOVo, (2, 3, 4, 0), (2, 3, 1, 4))
    tmp128 = einsum(t1_oV, (0, 1), v.OoOV, (2, 0, 3, 4), (2, 3, 1, 4))
    tmp179 = einsum(t1_oV, (0, 1), tmp176, (0, 2, 3, 4), (2, 3, 4, 1))
    tmp279 = einsum(t2_OovV, (0, 1, 2, 3), tmp173, (1, 4, 2, 5), (4, 5, 0, 3))
    tmp126 = einsum(v.OOov, (0, 1, 2, 3), t1, (2, 3), (0, 1))
    tmp246 = einsum(t1_oV, (0, 1), v.OoVv, (2, 0, 3, 4), (4, 2, 1, 3))
    tmp254 = einsum(t2_OoVv, (0, 1, 2, 3), v.OVov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp283 = einsum(t2_OovV, (0, 1, 2, 3), tmp173, (4, 1, 2, 5), (4, 5, 0, 3))
    tmp229 = einsum(tmp218, (0, 1, 2, 3), t2_OoVv, (4, 0, 5, 1), (2, 4, 3, 5))
    tmp159 = einsum(v.VVov, (0, 1, 2, 3), t1, (2, 3), (0, 1))
    tmp55 = einsum(v.OVVo, (0, 1, 2, 3), t3, (4, 5, 0, 6, 2, 1), (3, 4, 5, 6))
    tmp144 = einsum(t2_ooVv, (0, 1, 2, 3), v.Voov, (4, 0, 1, 3), (2, 4))
    tmp146 = einsum(t2_ooVV, (0, 1, 2, 3), v.VoVo, (4, 1, 5, 0), (3, 2, 4, 5))
    tmp140 = einsum(f.Vo, (0, 1), t1_oV, (1, 2), (0, 2))
    tmp132 = einsum(t2_ooVV, (0, 1, 2, 3), v.Ooov, (4, 0, 1, 5), (5, 4, 3, 2))
    tmp244 = einsum(v.Vvov, (0, 1, 2, 3), t2_OovV, (4, 2, 1, 5), (3, 4, 5, 0))
    tmp295 = einsum(t1_oV, (0, 1), tmp294, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp294
    tmp135 = einsum(t1_oV, (0, 1), tmp134, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp134
    tmp302 = einsum(tmp218, (0, 1, 2, 3), t2_OOvv, (4, 5, 1, 2), (0, 4, 5, 3))
    del tmp218
    tmp242 = einsum(t1_oV, (0, 1), v.OVov, (2, 3, 0, 4), (4, 2, 1, 3))
    tmp185 = einsum(tmp184, (0, 1), t1_Ov, (2, 0), (2, 1))
    del tmp184
    tmp225 = einsum(v.OVVo, (0, 1, 2, 3), t3, (4, 0, 5, 6, 1, 2), (3, 4, 5, 6))
    tmp258 = einsum(v.Vvov, (0, 1, 2, 3), t2_OoVv, (4, 2, 5, 3), (1, 4, 5, 0))
    tmp298 = einsum(t1_oV, (0, 1), tmp297, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp297
    tmp182 = einsum(tmp181, (0, 1), t1_Ov, (2, 0), (2, 1))
    del tmp181
    tmp124 = einsum(v.OoOv, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp169 = einsum(t2_Oovv, (0, 1, 2, 3), v.Ovov, (4, 3, 1, 2), (0, 4))
    tmp289 = einsum(v.OVVv, (0, 1, 2, 3), t1_Ov, (4, 3), (4, 0, 2, 1))
    tmp177 = einsum(tmp176, (0, 1, 2, 3), t1_oV, (1, 4), (0, 2, 3, 4))
    del tmp176
    tmp174 = einsum(tmp173, (0, 1, 2, 3), t2_ooVV, (0, 1, 4, 5), (2, 3, 4, 5))
    tmp262 = einsum(v.Vvov, (0, 1, 2, 3), t2_OovV, (4, 2, 3, 5), (1, 4, 5, 0))
    tmp250 = einsum(v.OvVo, (0, 1, 2, 3), t2_OoVv, (4, 3, 5, 1), (4, 0, 5, 2))
    tmp277 = einsum(t2_OoVv, (0, 1, 2, 3), tmp173, (4, 1, 3, 5), (4, 5, 0, 2))
    del tmp173
    tmp194 = einsum(t1_oV, (0, 1), tmp193, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp193
    tmp152 = einsum(t1_oV, (0, 1), tmp151, (0, 2), (1, 2))
    del tmp151
    tmp311 = einsum(v.Vvov, (0, 1, 2, 3), t2_OOvv, (4, 5, 3, 1), (2, 4, 5, 0))
    tmp208 = einsum(t2_OoVv, (0, 1, 2, 3), v.Ooov, (4, 1, 5, 3), (5, 0, 4, 2))
    tmp191 = einsum(t1_oV, (0, 1), tmp190, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp305 = einsum(tmp304, (0, 1, 2, 3), t1_Ov, (4, 0), (1, 4, 3, 2))
    del tmp304
    tmp210 = einsum(t2_OoVv, (0, 1, 2, 3), v.Ooov, (4, 5, 1, 3), (5, 0, 4, 2))
    tmp221 = einsum(t2_OovV, (0, 1, 2, 3), v.Ooov, (4, 1, 5, 2), (5, 0, 4, 3))
    tmp212 = einsum(v.Ooov, (0, 1, 2, 3), t2_OovV, (4, 2, 3, 5), (1, 4, 0, 5))
    tmp64 = einsum(v.OvOV, (0, 1, 2, 3), t1, (4, 1), (4, 0, 2, 3))
    tmp38 = einsum(v.OVov, (0, 1, 2, 3), t1, (2, 3), (0, 1))
    tmp36 = einsum(v.OvVo, (0, 1, 2, 3), t1, (3, 1), (0, 2))
    tmp79 = einsum(t2, (0, 1, 2, 3), tmp4, (4, 5, 1, 2), (4, 0, 5, 3))
    tmp94 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp87 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp27 = einsum(v.ooov, (0, 1, 2, 3), t1, (2, 3), (0, 1))
    tmp83 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 1, 5, 2), (0, 4, 5, 3))
    tmp45 = einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp91 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 2, 3, 5), (4, 0, 1, 5))
    tmp118 = einsum(tmp116, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    tmp89 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp11 = einsum(t1, (0, 1), v.ovvv, (0, 1, 2, 3), (2, 3))
    tmp40 = einsum(v.ovov, (0, 1, 2, 3), t2, (0, 2, 4, 3), (4, 1))
    tmp109 = einsum(tmp4, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp13 = einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 1), (2, 3))
    tmp111 = einsum(t2, (0, 1, 2, 3), tmp4, (4, 1, 5, 2), (4, 0, 5, 3))
    tmp9 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 3, 1, 2), (0, 4))
    tmp15 = einsum(tmp14, (0, 1), t1, (2, 1), (2, 0))
    tmp0 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp76 = einsum(t1, (0, 1), v.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp47 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp48 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 5, 1, 2), (0, 4, 3, 5))
    tmp107 = einsum(tmp4, (0, 1, 2, 3), t2, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp57 = einsum(t2, (0, 1, 2, 3), tmp14, (4, 3), (0, 1, 4, 2))
    tmp7 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 1, 3), (0, 4))
    tmp16 = einsum(tmp1, (0, 1), t1, (2, 1), (2, 0))
    tmp26 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 3), (0, 2))
    tmp114 = einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp85 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp99 = einsum(t1, (0, 1), tmp4, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp73 = einsum(v.oovv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp71 = einsum(t1, (0, 1), tmp62, (2, 3, 4, 0), (2, 4, 3, 1))
    tmp59 = einsum(t2, (0, 1, 2, 3), tmp1, (4, 3), (0, 1, 4, 2))
    tmp101 = einsum(tmp75, (0, 1, 2, 3), t1, (4, 2), (4, 0, 1, 3))
    tmp42 = einsum(v.ovov, (0, 1, 2, 3), t2, (0, 2, 4, 1), (4, 3))
    tmp237 = einsum(t3, (0, 1, 2, 3, 4, 5), v.OOVV, (6, 2, 7, 4), (0, 1, 6, 3, 5, 7))
    tmp123 = einsum(t2_OoVV, (0, 1, 2, 3), tmp122, (1, 4, 5, 6), (0, 5, 4, 6, 3, 2))
    del tmp122
    tmp314 = einsum(t2_OoVV, (0, 1, 2, 3), tmp313, (1, 4, 5, 6), (4, 5, 0, 3, 2, 6))
    del tmp313
    tmp232 = einsum(t2_OOvV, (0, 1, 2, 3), tmp231, (2, 4, 5, 6), (4, 0, 1, 5, 6, 3))
    del tmp231
    tmp276 = einsum(t2_OoVV, (0, 1, 2, 3), tmp275, (1, 4, 5, 6), (4, 5, 0, 6, 3, 2))
    del tmp275
    tmp217 = einsum(t2_OoVV, (0, 1, 2, 3), tmp216, (1, 4, 5, 6), (0, 4, 5, 3, 2, 6))
    del tmp216
    tmp199 = einsum(tmp188, (0, 1, 2, 3), t3, (4, 1, 5, 6, 7, 3), (0, 4, 5, 2, 6, 7))
    tmp261 = einsum(tmp260, (0, 1, 2, 3), t2_OOvV, (4, 5, 0, 6), (1, 4, 5, 2, 6, 3))
    del tmp260
    tmp293 = einsum(t2_OOvV, (0, 1, 2, 3), tmp292, (2, 4, 5, 6), (4, 0, 1, 3, 6, 5))
    del tmp292
    tmp310 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp300, (6, 7, 0, 2), (7, 6, 1, 3, 5, 4)) * -1
    tmp168 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp167, (6, 2, 7, 0), (6, 1, 7, 3, 5, 4)) * -1
    tmp220 = einsum(t2_OOvV, (0, 1, 2, 3), tmp219, (2, 4, 5, 6), (4, 0, 1, 5, 6, 3))
    del tmp219
    tmp120 = einsum(t3, (0, 1, 2, 3, 4, 5), f.OO, (6, 2), (6, 0, 1, 3, 5, 4))
    tmp150 = einsum(tmp149, (0, 1), t3, (2, 3, 4, 5, 6, 1), (2, 4, 3, 0, 5, 6))
    tmp286 = einsum(tmp285, (0, 1, 2, 3), t3, (4, 5, 1, 6, 3, 7), (0, 4, 5, 6, 7, 2))
    tmp206 = einsum(tmp53, (0, 1, 2, 3), t2_OoVV, (4, 0, 5, 6), (4, 1, 2, 6, 5, 3))
    tmp205 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp203, (6, 7, 1, 2, 8, 5), (6, 7, 0, 8, 3, 4))
    tmp228 = einsum(t2_OOvV, (0, 1, 2, 3), tmp227, (2, 4, 5, 6), (4, 0, 1, 5, 6, 3))
    del tmp227
    tmp137 = einsum(v.OOOO, (0, 1, 2, 3), t3, (4, 3, 1, 5, 6, 7), (4, 0, 2, 5, 7, 6))
    tmp233 = einsum(v.OoOV, (0, 1, 2, 3), t2_OoVV, (4, 1, 5, 6), (4, 0, 2, 6, 5, 3))
    tmp162 = einsum(tmp161, (0, 1), t3, (2, 3, 4, 5, 6, 0), (2, 4, 3, 5, 6, 1))
    tmp215 = einsum(tmp214, (0, 1, 2, 3), t2_OoVV, (4, 0, 5, 6), (4, 1, 2, 6, 5, 3))
    del tmp214
    tmp157 = einsum(t3, (0, 1, 2, 3, 4, 5), f.VV, (6, 5), (0, 2, 1, 6, 3, 4))
    tmp282 = einsum(tmp281, (0, 1, 2, 3), t2_OoVV, (4, 0, 5, 6), (1, 4, 2, 6, 5, 3))
    del tmp281
    tmp158 = einsum(t3, (0, 1, 2, 3, 4, 5), v.OVOV, (6, 7, 2, 5), (0, 1, 6, 3, 4, 7))
    tmp224 = einsum(tmp223, (0, 1, 2, 3), t2_OoVV, (4, 0, 5, 6), (4, 1, 2, 6, 5, 3))
    del tmp223
    tmp202 = einsum(tmp201, (0, 1, 2, 3), t2_OoVV, (4, 0, 5, 6), (4, 1, 2, 6, 5, 3))
    del tmp201
    tmp266 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp265, (6, 5, 7, 3), (0, 2, 1, 6, 4, 7)) * -1
    tmp240 = einsum(tmp239, (0, 1, 2, 3), t3, (4, 5, 1, 6, 3, 7), (0, 4, 5, 2, 6, 7))
    tmp163 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp142, (6, 4), (0, 2, 1, 6, 3, 5))
    tmp268 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp155, (6, 7, 3, 5), (0, 2, 1, 6, 7, 4))
    tmp166 = einsum(tmp165, (0, 1), t3, (2, 3, 0, 4, 5, 6), (1, 2, 3, 4, 6, 5))
    tmp309 = einsum(t2_OoVV, (0, 1, 2, 3), tmp308, (1, 4, 5, 6), (5, 4, 0, 6, 3, 2))
    del tmp308
    tmp172 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp171, (6, 2), (6, 0, 1, 3, 5, 4))
    tmp253 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp252, (6, 2, 7, 5), (6, 0, 1, 7, 3, 4))
    tmp196 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp167, (6, 1, 7, 2), (6, 0, 7, 3, 5, 4))
    tmp257 = einsum(tmp239, (0, 1, 2, 3), t3, (4, 1, 5, 6, 7, 3), (0, 4, 5, 2, 6, 7))
    tmp131 = einsum(tmp130, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 3), (4, 5, 0, 2, 6, 7))
    tmp129 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp128, (6, 2, 7, 5), (0, 1, 6, 7, 3, 4))
    tmp180 = einsum(tmp179, (0, 1, 2, 3), t2_OoVV, (4, 0, 5, 6), (1, 4, 2, 3, 6, 5))
    del tmp179
    tmp236 = einsum(tmp203, (0, 1, 2, 3, 4, 5), t3, (6, 2, 3, 7, 5, 8), (0, 1, 6, 4, 7, 8))
    tmp280 = einsum(t2_OoVV, (0, 1, 2, 3), tmp279, (1, 4, 5, 6), (4, 5, 0, 6, 3, 2))
    del tmp279
    tmp270 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp265, (6, 5, 7, 4), (0, 2, 1, 6, 3, 7))
    tmp138 = einsum(tmp126, (0, 1), t3, (2, 1, 3, 4, 5, 6), (2, 3, 0, 4, 6, 5))
    tmp247 = einsum(tmp246, (0, 1, 2, 3), t2_OOvV, (4, 5, 0, 6), (4, 5, 1, 2, 6, 3))
    del tmp246
    tmp271 = einsum(tmp254, (0, 1, 2, 3), t3, (4, 5, 1, 6, 3, 7), (0, 4, 5, 2, 6, 7))
    tmp127 = einsum(tmp126, (0, 1), t3, (2, 3, 1, 4, 5, 6), (2, 3, 0, 4, 6, 5))
    del tmp126
    tmp284 = einsum(t2_OoVV, (0, 1, 2, 3), tmp283, (1, 4, 5, 6), (4, 5, 0, 6, 3, 2))
    del tmp283
    tmp139 = einsum(tmp130, (0, 1, 2, 3), t3, (4, 1, 5, 6, 7, 3), (4, 5, 0, 2, 6, 7))
    tmp230 = einsum(t2_OOvV, (0, 1, 2, 3), tmp229, (2, 4, 5, 6), (4, 0, 1, 5, 6, 3))
    del tmp229
    tmp143 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp142, (6, 5), (0, 2, 1, 6, 3, 4))
    del tmp142
    tmp160 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp159, (6, 5), (0, 2, 1, 3, 4, 6))
    tmp198 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp171, (6, 1), (6, 0, 2, 3, 5, 4))
    del tmp171
    tmp255 = einsum(tmp254, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 3), (0, 4, 5, 2, 6, 7))
    tmp207 = einsum(t2_OoVV, (0, 1, 2, 3), tmp55, (1, 4, 5, 6), (0, 4, 5, 3, 2, 6))
    tmp291 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp285, (6, 1, 7, 5), (6, 0, 2, 3, 4, 7))
    tmp200 = einsum(tmp167, (0, 1, 2, 3), t3, (4, 3, 1, 5, 6, 7), (0, 4, 2, 5, 7, 6))
    del tmp167
    tmp145 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp144, (6, 5), (0, 2, 1, 6, 3, 4))
    tmp267 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp146, (6, 7, 5, 3), (0, 2, 1, 7, 6, 4))
    tmp141 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp140, (5, 6), (0, 2, 1, 6, 3, 4))
    tmp133 = einsum(t2_OOvV, (0, 1, 2, 3), tmp132, (2, 4, 5, 6), (0, 1, 4, 5, 6, 3))
    del tmp132
    tmp164 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp144, (6, 4), (0, 2, 1, 6, 3, 5))
    del tmp144
    tmp301 = einsum(tmp300, (0, 1, 2, 3), t3, (4, 2, 3, 5, 6, 7), (1, 0, 4, 5, 7, 6))
    del tmp300
    tmp245 = einsum(t2_OOvV, (0, 1, 2, 3), tmp244, (2, 4, 5, 6), (4, 0, 1, 5, 3, 6))
    del tmp244
    tmp296 = einsum(t2_OOvV, (0, 1, 2, 3), tmp295, (2, 4, 5, 6), (4, 0, 1, 5, 3, 6))
    del tmp295
    tmp204 = einsum(tmp203, (0, 1, 2, 3, 4, 5), t3, (3, 6, 2, 7, 8, 5), (0, 1, 6, 4, 7, 8)) * -1
    tmp136 = einsum(t2_OOvV, (0, 1, 2, 3), tmp135, (2, 4, 5, 6), (0, 1, 4, 5, 6, 3))
    del tmp135
    tmp287 = einsum(tmp188, (0, 1, 2, 3), t3, (4, 5, 1, 6, 3, 7), (0, 4, 5, 2, 6, 7))
    tmp147 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp146, (6, 7, 5, 4), (0, 2, 1, 6, 7, 3))
    del tmp146
    tmp303 = einsum(t2_OoVV, (0, 1, 2, 3), tmp302, (1, 4, 5, 6), (5, 4, 0, 6, 3, 2))
    del tmp302
    tmp243 = einsum(tmp242, (0, 1, 2, 3), t2_OOvV, (4, 5, 0, 6), (4, 5, 1, 2, 6, 3))
    del tmp242
    tmp186 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp185, (6, 2), (6, 0, 1, 3, 5, 4))
    tmp226 = einsum(t2_OoVV, (0, 1, 2, 3), tmp225, (1, 4, 5, 6), (0, 5, 4, 3, 2, 6)) * -1
    del tmp225
    tmp259 = einsum(t2_OOvV, (0, 1, 2, 3), tmp258, (2, 4, 5, 6), (4, 0, 1, 5, 3, 6))
    del tmp258
    tmp299 = einsum(t2_OOvV, (0, 1, 2, 3), tmp298, (2, 4, 5, 6), (4, 0, 1, 5, 3, 6))
    del tmp298
    tmp183 = einsum(tmp182, (0, 1), t3, (2, 3, 1, 4, 5, 6), (0, 2, 3, 4, 6, 5))
    tmp121 = einsum(t3, (0, 1, 2, 3, 4, 5), v.OOOO, (6, 0, 7, 2), (1, 6, 7, 3, 5, 4))
    tmp241 = einsum(v.OVVv, (0, 1, 2, 3), t2_OOvV, (4, 5, 3, 6), (4, 5, 0, 6, 2, 1))
    tmp125 = einsum(tmp124, (0, 1), t3, (2, 3, 1, 4, 5, 6), (2, 3, 0, 4, 6, 5))
    tmp156 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp155, (6, 7, 4, 5), (0, 2, 1, 7, 6, 3))
    del tmp155
    tmp235 = einsum(tmp203, (0, 1, 2, 3, 4, 5), t3, (6, 3, 2, 7, 5, 8), (0, 1, 6, 4, 7, 8))
    tmp170 = einsum(tmp169, (0, 1), t3, (2, 3, 1, 4, 5, 6), (0, 2, 3, 4, 6, 5))
    tmp273 = einsum(tmp265, (0, 1, 2, 3), t3, (4, 5, 6, 7, 1, 3), (4, 6, 5, 0, 7, 2))
    del tmp265
    tmp238 = einsum(tmp130, (0, 1, 2, 3), t3, (4, 5, 1, 6, 3, 7), (4, 5, 0, 2, 6, 7))
    tmp256 = einsum(v.OOVV, (0, 1, 2, 3), t3, (4, 1, 5, 6, 7, 3), (4, 5, 0, 6, 7, 2))
    tmp269 = einsum(t3, (0, 1, 2, 3, 4, 5), v.VVVV, (6, 5, 7, 4), (0, 2, 1, 3, 6, 7))
    tmp274 = einsum(t2_OoVV, (0, 1, 2, 3), tmp190, (1, 4, 5, 6), (4, 0, 5, 3, 2, 6))
    del tmp190
    tmp264 = einsum(t3, (0, 1, 2, 3, 4, 5), v.VVVV, (6, 5, 7, 3), (0, 2, 1, 4, 6, 7)) * -1
    tmp290 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp289, (6, 2, 7, 5), (6, 0, 1, 3, 4, 7))
    tmp178 = einsum(t2_OoVV, (0, 1, 2, 3), tmp177, (1, 4, 5, 6), (4, 0, 5, 6, 3, 2))
    del tmp177
    tmp175 = einsum(tmp174, (0, 1, 2, 3), t2_OOvV, (4, 5, 0, 6), (1, 4, 5, 3, 2, 6))
    del tmp174
    tmp197 = einsum(tmp169, (0, 1), t3, (2, 1, 3, 4, 5, 6), (0, 2, 3, 4, 6, 5))
    del tmp169
    tmp263 = einsum(tmp262, (0, 1, 2, 3), t2_OOvV, (4, 5, 0, 6), (1, 4, 5, 2, 6, 3))
    del tmp262
    tmp251 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp250, (6, 2, 7, 5), (6, 0, 1, 7, 3, 4))
    tmp249 = einsum(tmp239, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 3), (0, 4, 5, 2, 6, 7))
    tmp272 = einsum(tmp254, (0, 1, 2, 3), t3, (4, 1, 5, 6, 3, 7), (0, 4, 5, 2, 6, 7))
    del tmp254
    tmp278 = einsum(t2_OoVV, (0, 1, 2, 3), tmp277, (1, 4, 5, 6), (4, 5, 0, 6, 3, 2))
    del tmp277
    tmp195 = einsum(tmp194, (0, 1, 2, 3), t2_OOvV, (4, 5, 0, 6), (1, 4, 5, 3, 2, 6))
    del tmp194
    tmp153 = einsum(tmp152, (0, 1), t3, (2, 3, 4, 5, 6, 1), (2, 4, 3, 0, 5, 6))
    tmp288 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp285, (6, 2, 7, 5), (6, 0, 1, 3, 4, 7))
    tmp312 = einsum(tmp311, (0, 1, 2, 3), t2_OoVV, (4, 0, 5, 6), (1, 2, 4, 6, 5, 3))
    del tmp311
    tmp209 = einsum(t2_OoVV, (0, 1, 2, 3), tmp208, (1, 4, 5, 6), (4, 0, 5, 6, 3, 2))
    del tmp208
    tmp192 = einsum(tmp191, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 3), (0, 4, 5, 2, 6, 7))
    tmp306 = einsum(tmp305, (0, 1, 2, 3), t3, (4, 2, 3, 5, 6, 7), (1, 0, 4, 5, 7, 6))
    tmp211 = einsum(tmp210, (0, 1, 2, 3), t2_OoVV, (4, 0, 5, 6), (1, 4, 2, 3, 6, 5))
    del tmp210
    tmp234 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp203, (6, 7, 2, 1, 8, 5), (6, 7, 0, 8, 3, 4))
    del tmp203
    tmp248 = einsum(v.OOVV, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 3), (4, 5, 0, 6, 7, 2))
    tmp222 = einsum(tmp221, (0, 1, 2, 3), t2_OoVV, (4, 0, 5, 6), (1, 4, 2, 3, 6, 5))
    del tmp221
    tmp213 = einsum(t2_OoVV, (0, 1, 2, 3), tmp212, (1, 4, 5, 6), (4, 0, 5, 6, 3, 2))
    del tmp212
    tmp189 = einsum(tmp188, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 3), (0, 4, 5, 2, 6, 7))
    tmp315 = einsum(tmp305, (0, 1, 2, 3), t3, (2, 4, 3, 5, 6, 7), (1, 0, 4, 5, 7, 6)) * -1
    del tmp305
    tmp50 = einsum(v.OVVv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 2, 1), (3, 4, 5, 6))
    tmp56 = einsum(tmp55, (0, 1, 2, 3), t1, (0, 4), (4, 1, 2, 3))
    del tmp55
    tmp54 = einsum(tmp53, (0, 1, 2, 3), t1, (0, 4), (4, 1, 2, 3))
    del tmp53
    tmp49 = einsum(v.OVVv, (0, 1, 2, 3), t3, (4, 5, 0, 2, 6, 1), (3, 4, 5, 6))
    tmp31 = einsum(v.OoOV, (0, 1, 2, 3), t3, (4, 0, 2, 5, 6, 3), (1, 4, 5, 6))
    tmp66 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp64, (6, 1, 2, 5), (6, 0, 3, 4))
    tmp30 = einsum(v.OVOo, (0, 1, 2, 3), t3, (0, 4, 2, 5, 6, 1), (3, 4, 5, 6)) * -1
    tmp65 = einsum(tmp64, (0, 1, 2, 3), t3, (2, 4, 1, 5, 6, 3), (0, 4, 5, 6)) * -1
    del tmp64
    tmp35 = einsum(f.OV, (0, 1), t3, (2, 3, 0, 4, 5, 1), (2, 3, 4, 5))
    tmp39 = einsum(t3, (0, 1, 2, 3, 4, 5), tmp38, (2, 5), (0, 1, 3, 4))
    del tmp38
    tmp37 = einsum(tmp36, (0, 1), t3, (2, 3, 0, 4, 5, 1), (2, 3, 4, 5))
    del tmp36
    tmp63 = einsum(t2, (0, 1, 2, 3), tmp62, (4, 5, 1, 0), (4, 5, 3, 2))
    del tmp62
    tmp80 = einsum(tmp79, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp79
    tmp81 = einsum(v.ooov, (0, 1, 2, 3), t1, (1, 4), (0, 2, 4, 3))
    tmp95 = einsum(tmp94, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp94
    tmp88 = einsum(tmp87, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp87
    tmp33 = einsum(t2, (0, 1, 2, 3), tmp27, (4, 1), (0, 4, 2, 3))
    tmp28 = einsum(t2, (0, 1, 2, 3), f.oo, (4, 1), (4, 0, 2, 3))
    tmp29 = einsum(v.oooo, (0, 1, 2, 3), t2, (3, 1, 4, 5), (0, 2, 5, 4))
    tmp84 = einsum(tmp83, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp83
    tmp46 = einsum(tmp45, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3))
    del tmp45
    tmp92 = einsum(tmp91, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp91
    tmp119 = einsum(tmp118, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp118
    tmp90 = einsum(tmp89, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp89
    tmp51 = einsum(t2, (0, 1, 2, 3), tmp11, (4, 3), (0, 1, 2, 4))
    tmp41 = einsum(t2, (0, 1, 2, 3), tmp40, (4, 3), (0, 1, 2, 4))
    del tmp40
    tmp110 = einsum(tmp109, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp109
    tmp52 = einsum(t2, (0, 1, 2, 3), tmp13, (3, 4), (0, 1, 2, 4))
    tmp112 = einsum(tmp111, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp111
    tmp105 = einsum(tmp75, (0, 1, 2, 3), t2, (4, 1, 5, 2), (0, 4, 5, 3))
    tmp67 = einsum(t2, (0, 1, 2, 3), tmp9, (4, 1), (0, 4, 2, 3))
    tmp69 = einsum(tmp15, (0, 1), t2, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp61 = einsum(tmp0, (0, 1), t2, (2, 0, 3, 4), (1, 2, 3, 4))
    tmp77 = einsum(t2, (0, 1, 2, 3), tmp76, (4, 1, 5, 2), (4, 0, 3, 5))
    tmp98 = einsum(v.vvvv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp97 = einsum(tmp47, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp78 = einsum(tmp4, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    tmp117 = einsum(tmp116, (0, 1, 2, 3), t2, (3, 2, 4, 5), (1, 0, 4, 5))
    del tmp116
    tmp96 = einsum(t2, (0, 1, 2, 3), tmp48, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp34 = einsum(v.oooo, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    tmp113 = einsum(v.vvvv, (0, 1, 2, 3), t2, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp108 = einsum(tmp107, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp107
    tmp58 = einsum(tmp57, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp57
    tmp68 = einsum(t2, (0, 1, 2, 3), tmp7, (4, 1), (0, 4, 2, 3))
    tmp70 = einsum(tmp16, (0, 1), t2, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp32 = einsum(tmp26, (0, 1), t2, (2, 1, 3, 4), (2, 0, 3, 4))
    tmp115 = einsum(tmp114, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp114
    tmp93 = einsum(t2, (0, 1, 2, 3), tmp85, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp100 = einsum(t2, (0, 1, 2, 3), tmp99, (4, 5, 0, 1), (5, 4, 3, 2))
    tmp74 = einsum(tmp73, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp73
    tmp44 = einsum(f.vv, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp103 = einsum(t1, (0, 1), tmp99, (2, 3, 0, 4), (3, 2, 4, 1))
    del tmp99
    tmp72 = einsum(tmp71, (0, 1, 2, 3), t1, (1, 4), (0, 2, 4, 3))
    del tmp71
    tmp60 = einsum(tmp59, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp59
    tmp102 = einsum(tmp101, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp101
    tmp106 = einsum(t2, (0, 1, 2, 3), tmp75, (4, 1, 2, 5), (4, 0, 3, 5))
    tmp82 = einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 5, 2), (0, 4, 3, 5))
    tmp104 = einsum(t2, (0, 1, 2, 3), tmp76, (4, 1, 5, 3), (4, 0, 2, 5))
    del tmp76
    tmp43 = einsum(tmp42, (0, 1), t2, (2, 3, 4, 1), (2, 3, 4, 0))
    del tmp42
    tmp86 = einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp21 = einsum(v.OVOV, (0, 1, 2, 3), t3, (4, 0, 2, 5, 3, 1), (4, 5))
    tmp20 = einsum(v.OVOV, (0, 1, 2, 3), t3, (4, 0, 2, 3, 5, 1), (4, 5))
    tmp22 = einsum(v.OVOV, (0, 1, 2, 3), t3, (4, 0, 2, 5, 1, 3), (4, 5))
    tmp23 = einsum(v.OVOV, (0, 1, 2, 3), t3, (0, 4, 2, 3, 5, 1), (4, 5)) * -1
    tmp2 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 3, 4, 2), (0, 4))
    tmp24 = einsum(t2, (0, 1, 2, 3), tmp1, (1, 2), (0, 3))
    tmp12 = einsum(tmp11, (0, 1), t1, (2, 1), (2, 0))
    del tmp11
    tmp10 = einsum(t1, (0, 1), tmp9, (2, 0), (2, 1))
    del tmp9
    tmp17 = einsum(t1, (0, 1), tmp16, (2, 0), (2, 1))
    del tmp16
    tmp8 = einsum(tmp7, (0, 1), t1, (1, 2), (0, 2))
    del tmp7
    tmp18 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 1, 0, 3), (4, 2))
    tmp6 = einsum(t2, (0, 1, 2, 3), tmp4, (4, 0, 1, 3), (4, 2))
    tmp19 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 0, 1, 3), (4, 2))
    tmp25 = einsum(t2, (0, 1, 2, 3), tmp1, (1, 3), (0, 2))
    tmp3 = einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 2, 4, 3), (0, 4))
    tmp5 = einsum(t2, (0, 1, 2, 3), tmp4, (4, 1, 0, 3), (4, 2))
    del tmp4
    t3new = np.copy(np.transpose(tmp120, (1, 2, 0, 4, 5, 3)))
    t3new += np.transpose(tmp121, (1, 0, 2, 4, 5, 3)) * -1
    del tmp121
    t3new += np.transpose(tmp123, (1, 0, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp125, (0, 1, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp127, (0, 1, 2, 4, 5, 3)) * 2
    t3new += np.transpose(tmp129, (0, 1, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp131, (0, 1, 2, 4, 5, 3))
    t3new += np.transpose(tmp129, (1, 0, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp133, (1, 0, 2, 5, 3, 4))
    t3new += np.transpose(tmp136, (1, 0, 2, 5, 3, 4))
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), f.OO, (6, 1), (0, 6, 2, 3, 4, 5)) * -1
    t3new += np.transpose(tmp137, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp123, (1, 2, 0, 5, 4, 3)) * -1
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), tmp124, (6, 1), (0, 6, 2, 3, 4, 5))
    del tmp124
    t3new += np.transpose(tmp138, (0, 2, 1, 4, 5, 3)) * 2
    del tmp138
    t3new += np.transpose(tmp139, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp133, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp133, (1, 2, 0, 5, 4, 3))
    t3new += np.transpose(tmp136, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp136, (1, 2, 0, 5, 4, 3))
    t3new += np.transpose(tmp120, (0, 2, 1, 4, 5, 3)) * -1
    del tmp120
    t3new += np.transpose(tmp141, (0, 2, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp125, (2, 1, 0, 4, 5, 3))
    del tmp125
    t3new += np.transpose(tmp127, (2, 1, 0, 4, 5, 3)) * -2
    del tmp127
    t3new += np.transpose(tmp129, (2, 1, 0, 4, 5, 3))
    t3new += np.transpose(tmp131, (2, 1, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp129, (2, 0, 1, 5, 4, 3))
    t3new += np.transpose(tmp143, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp145, (1, 2, 0, 4, 5, 3)) * 2
    t3new += np.transpose(tmp147, (1, 2, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp133, (2, 0, 1, 5, 3, 4)) * -1
    t3new += np.transpose(tmp136, (2, 0, 1, 5, 3, 4)) * -1
    t3new += np.transpose(tmp150, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp153, (1, 2, 0, 4, 5, 3)) * 2
    t3new += np.transpose(tmp156, (1, 2, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp123, (2, 0, 1, 4, 5, 3))
    t3new += np.transpose(tmp157, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp141, (0, 2, 1, 3, 5, 4))
    del tmp141
    t3new += np.transpose(tmp158, (2, 1, 0, 5, 4, 3))
    t3new += np.transpose(tmp158, (2, 0, 1, 5, 3, 4))
    t3new += np.transpose(tmp160, (0, 2, 1, 5, 4, 3)) * -2
    t3new += np.transpose(tmp162, (0, 2, 1, 5, 4, 3))
    t3new += np.transpose(tmp143, (1, 2, 0, 3, 5, 4))
    del tmp143
    t3new += np.transpose(tmp145, (1, 2, 0, 3, 5, 4)) * -2
    del tmp145
    t3new += np.transpose(tmp150, (1, 2, 0, 3, 5, 4))
    del tmp150
    t3new += np.transpose(tmp153, (1, 2, 0, 3, 5, 4)) * -2
    del tmp153
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), f.VV, (6, 4), (0, 1, 2, 3, 6, 5))
    t3new += einsum(tmp140, (0, 1), t3, (2, 3, 4, 5, 0, 6), (2, 3, 4, 5, 1, 6)) * -1
    del tmp140
    t3new += einsum(tmp159, (0, 1), t3, (2, 3, 4, 5, 1, 6), (2, 3, 4, 5, 0, 6)) * 2
    del tmp159
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), tmp161, (4, 6), (0, 1, 2, 3, 6, 5)) * -1
    del tmp161
    t3new += np.transpose(tmp163, (1, 2, 0, 4, 3, 5)) * -1
    del tmp163
    t3new += np.transpose(tmp164, (1, 2, 0, 4, 3, 5)) * 2
    del tmp164
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), tmp149, (6, 4), (0, 1, 2, 3, 6, 5))
    del tmp149
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), tmp152, (6, 4), (0, 1, 2, 3, 6, 5)) * -2
    del tmp152
    t3new += np.transpose(tmp157, (0, 2, 1, 4, 5, 3))
    del tmp157
    t3new += np.transpose(tmp158, (2, 1, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp158, (2, 0, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp160, (0, 2, 1, 3, 4, 5)) * 2
    del tmp160
    t3new += np.transpose(tmp162, (0, 2, 1, 3, 4, 5)) * -1
    del tmp162
    t3new += np.transpose(tmp166, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp168, (2, 1, 0, 4, 5, 3))
    t3new += np.transpose(tmp170, (1, 2, 0, 3, 5, 4))
    t3new += np.transpose(tmp172, (1, 2, 0, 3, 5, 4)) * -2
    t3new += np.transpose(tmp175, (2, 1, 0, 5, 4, 3))
    t3new += np.transpose(tmp178, (2, 1, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp180, (2, 1, 0, 4, 5, 3))
    t3new += np.transpose(tmp183, (1, 2, 0, 3, 5, 4))
    t3new += np.transpose(tmp186, (1, 2, 0, 3, 5, 4)) * -2
    t3new += np.transpose(tmp189, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp192, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp192, (2, 1, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp195, (2, 1, 0, 5, 4, 3))
    t3new += einsum(tmp165, (0, 1), t3, (2, 0, 3, 4, 5, 6), (2, 1, 3, 4, 5, 6)) * -1
    del tmp165
    t3new += np.transpose(tmp196, (2, 0, 1, 4, 5, 3))
    t3new += np.transpose(tmp197, (2, 0, 1, 3, 5, 4)) * -1
    del tmp197
    t3new += np.transpose(tmp198, (2, 0, 1, 3, 5, 4)) * 2
    del tmp198
    t3new += np.transpose(tmp175, (1, 0, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp175, (2, 0, 1, 5, 3, 4))
    t3new += np.transpose(tmp178, (2, 0, 1, 5, 4, 3)) * -1
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), tmp182, (6, 1), (0, 6, 2, 3, 4, 5))
    del tmp182
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), tmp185, (6, 1), (0, 6, 2, 3, 4, 5)) * -2
    del tmp185
    t3new += np.transpose(tmp199, (2, 0, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp195, (1, 0, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp195, (2, 0, 1, 5, 3, 4))
    t3new += np.transpose(tmp166, (0, 2, 1, 4, 5, 3)) * -1
    del tmp166
    t3new += np.transpose(tmp200, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp170, (0, 2, 1, 3, 5, 4)) * -1
    del tmp170
    t3new += np.transpose(tmp172, (0, 2, 1, 3, 5, 4)) * 2
    del tmp172
    t3new += np.transpose(tmp175, (0, 1, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp180, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp183, (0, 2, 1, 3, 5, 4)) * -1
    del tmp183
    t3new += np.transpose(tmp186, (0, 2, 1, 3, 5, 4)) * 2
    del tmp186
    t3new += np.transpose(tmp189, (0, 2, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp192, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp192, (0, 1, 2, 5, 4, 3))
    t3new += np.transpose(tmp195, (0, 1, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp168, (0, 1, 2, 4, 5, 3)) * -1
    del tmp168
    t3new += np.transpose(tmp178, (0, 1, 2, 4, 5, 3))
    t3new += np.transpose(tmp180, (0, 1, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp202, (0, 1, 2, 5, 3, 4))
    t3new += np.transpose(tmp123, (0, 2, 1, 3, 4, 5)) * -1
    t3new += np.transpose(tmp204, (2, 0, 1, 3, 4, 5))
    t3new += np.transpose(tmp205, (2, 0, 1, 3, 5, 4))
    t3new += np.transpose(tmp206, (0, 1, 2, 5, 3, 4))
    t3new += np.transpose(tmp207, (0, 2, 1, 5, 3, 4))
    t3new += np.transpose(tmp209, (1, 2, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp211, (1, 2, 0, 3, 4, 5)) * 2
    t3new += np.transpose(tmp213, (1, 2, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp215, (0, 1, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp217, (0, 1, 2, 5, 3, 4)) * 2
    t3new += np.transpose(tmp220, (0, 1, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp222, (1, 0, 2, 3, 4, 5)) * -1
    t3new += np.transpose(tmp202, (1, 0, 2, 5, 4, 3))
    t3new += np.transpose(tmp202, (2, 0, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp123, (2, 0, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp204, (0, 2, 1, 3, 5, 4))
    t3new += np.transpose(tmp204, (1, 2, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp205, (0, 2, 1, 3, 4, 5))
    t3new += np.transpose(tmp205, (1, 2, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp206, (1, 0, 2, 5, 4, 3))
    t3new += np.transpose(tmp224, (1, 0, 2, 5, 4, 3))
    t3new += np.transpose(tmp207, (1, 0, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp226, (2, 0, 1, 5, 4, 3))
    t3new += np.transpose(tmp222, (2, 1, 0, 3, 5, 4))
    t3new += np.transpose(tmp209, (2, 1, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp213, (2, 1, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp211, (2, 1, 0, 3, 5, 4)) * 2
    t3new += np.transpose(tmp215, (1, 0, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp215, (2, 0, 1, 5, 4, 3))
    t3new += np.transpose(tmp217, (1, 0, 2, 5, 4, 3)) * 2
    t3new += np.transpose(tmp217, (2, 0, 1, 5, 4, 3)) * -2
    t3new += np.transpose(tmp228, (1, 0, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp228, (2, 0, 1, 5, 4, 3))
    t3new += np.transpose(tmp230, (1, 0, 2, 5, 4, 3)) * 2
    t3new += np.transpose(tmp230, (2, 0, 1, 5, 4, 3)) * -2
    t3new += np.transpose(tmp232, (1, 0, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp232, (2, 0, 1, 5, 4, 3))
    t3new += np.transpose(tmp233, (1, 0, 2, 5, 4, 3))
    t3new += np.transpose(tmp123, (1, 0, 2, 3, 5, 4))
    t3new += np.transpose(tmp222, (0, 1, 2, 3, 5, 4)) * -1
    t3new += np.transpose(tmp209, (0, 1, 2, 3, 5, 4))
    t3new += np.transpose(tmp213, (0, 1, 2, 3, 5, 4))
    t3new += np.transpose(tmp211, (0, 1, 2, 3, 5, 4)) * -2
    t3new += np.transpose(tmp202, (0, 2, 1, 3, 5, 4))
    t3new += np.transpose(tmp202, (0, 2, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp234, (2, 1, 0, 5, 3, 4)) * -0.5
    t3new += np.transpose(tmp234, (2, 1, 0, 4, 3, 5)) * 0.5
    t3new += np.transpose(tmp235, (2, 1, 0, 5, 3, 4)) * 1.5
    t3new += np.transpose(tmp205, (2, 1, 0, 5, 3, 4)) * 0.5
    t3new += np.transpose(tmp205, (2, 1, 0, 4, 3, 5)) * -0.5
    t3new += np.transpose(tmp236, (2, 1, 0, 5, 3, 4)) * -0.5
    t3new += np.transpose(tmp222, (1, 2, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp222, (1, 2, 0, 5, 3, 4))
    t3new += np.transpose(tmp215, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp215, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp217, (0, 2, 1, 3, 5, 4)) * 2
    t3new += np.transpose(tmp217, (0, 2, 1, 4, 5, 3)) * -2
    t3new += np.transpose(tmp233, (0, 2, 1, 3, 5, 4))
    t3new += np.transpose(tmp233, (0, 2, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp123, (0, 1, 2, 4, 3, 5)) * -1
    t3new += np.transpose(tmp123, (0, 1, 2, 5, 3, 4))
    t3new += np.transpose(tmp209, (1, 0, 2, 4, 3, 5)) * -1
    t3new += np.transpose(tmp209, (1, 0, 2, 5, 3, 4))
    t3new += np.transpose(tmp211, (1, 0, 2, 4, 3, 5)) * 2
    t3new += np.transpose(tmp211, (1, 0, 2, 5, 3, 4)) * -2
    t3new += np.transpose(tmp213, (1, 0, 2, 4, 3, 5)) * -1
    t3new += np.transpose(tmp213, (1, 0, 2, 5, 3, 4))
    t3new += np.transpose(tmp202, (2, 1, 0, 5, 3, 4)) * -1
    t3new += np.transpose(tmp204, (1, 0, 2, 3, 4, 5)) * -1
    t3new += np.transpose(tmp205, (1, 0, 2, 3, 5, 4)) * -1
    t3new += np.transpose(tmp206, (2, 1, 0, 5, 3, 4)) * -1
    t3new += np.transpose(tmp207, (1, 2, 0, 5, 3, 4)) * -1
    t3new += np.transpose(tmp222, (2, 0, 1, 3, 4, 5))
    t3new += np.transpose(tmp215, (2, 1, 0, 5, 3, 4))
    t3new += np.transpose(tmp217, (2, 1, 0, 5, 3, 4)) * -2
    t3new += np.transpose(tmp220, (2, 1, 0, 5, 4, 3))
    t3new += np.transpose(tmp123, (1, 2, 0, 3, 4, 5))
    t3new += np.transpose(tmp209, (0, 2, 1, 3, 4, 5))
    t3new += np.transpose(tmp211, (0, 2, 1, 3, 4, 5)) * -2
    t3new += np.transpose(tmp213, (0, 2, 1, 3, 4, 5))
    t3new += np.transpose(tmp202, (1, 2, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp202, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp123, (2, 1, 0, 4, 3, 5))
    t3new += np.transpose(tmp123, (2, 1, 0, 5, 3, 4)) * -1
    t3new += np.transpose(tmp234, (0, 1, 2, 5, 3, 4)) * 0.5
    t3new += np.transpose(tmp234, (0, 1, 2, 4, 3, 5)) * -0.5
    del tmp234
    t3new += np.transpose(tmp235, (0, 1, 2, 5, 3, 4)) * -1.5
    del tmp235
    t3new += np.transpose(tmp205, (0, 1, 2, 5, 3, 4)) * -0.5
    t3new += np.transpose(tmp205, (0, 1, 2, 4, 3, 5)) * 0.5
    t3new += np.transpose(tmp236, (0, 1, 2, 5, 3, 4)) * 0.5
    del tmp236
    t3new += np.transpose(tmp209, (2, 0, 1, 4, 3, 5))
    t3new += np.transpose(tmp209, (2, 0, 1, 5, 3, 4)) * -1
    t3new += np.transpose(tmp211, (2, 0, 1, 4, 3, 5)) * -2
    t3new += np.transpose(tmp211, (2, 0, 1, 5, 3, 4)) * 2
    t3new += np.transpose(tmp213, (2, 0, 1, 4, 3, 5))
    t3new += np.transpose(tmp213, (2, 0, 1, 5, 3, 4)) * -1
    t3new += np.transpose(tmp215, (1, 2, 0, 3, 5, 4))
    t3new += np.transpose(tmp215, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp217, (1, 2, 0, 3, 5, 4)) * -2
    t3new += np.transpose(tmp217, (1, 2, 0, 4, 5, 3)) * 2
    t3new += np.transpose(tmp233, (1, 2, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp233, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp237, (2, 1, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp238, (2, 1, 0, 5, 3, 4))
    t3new += np.transpose(tmp240, (0, 2, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp202, (0, 1, 2, 4, 3, 5)) * -1
    t3new += np.transpose(tmp204, (2, 0, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp205, (2, 0, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp206, (0, 1, 2, 4, 3, 5)) * -1
    t3new += np.transpose(tmp207, (0, 2, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp133, (2, 0, 1, 4, 3, 5))
    t3new += np.transpose(tmp215, (0, 1, 2, 4, 3, 5))
    t3new += np.transpose(tmp217, (0, 1, 2, 4, 3, 5)) * -2
    t3new += np.transpose(tmp136, (2, 0, 1, 4, 3, 5))
    t3new += np.transpose(tmp241, (2, 0, 1, 5, 4, 3))
    t3new += np.transpose(tmp243, (2, 0, 1, 5, 3, 4)) * -1
    t3new += np.transpose(tmp245, (0, 1, 2, 5, 3, 4)) * -1
    t3new += tmp220
    t3new += np.transpose(tmp202, (1, 0, 2, 3, 4, 5)) * -1
    t3new += np.transpose(tmp202, (2, 0, 1, 3, 4, 5))
    t3new += np.transpose(tmp247, (0, 2, 1, 5, 3, 4)) * -1
    t3new += np.transpose(tmp247, (1, 2, 0, 5, 3, 4))
    t3new += np.transpose(tmp204, (0, 2, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp204, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp205, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp205, (1, 2, 0, 5, 4, 3))
    t3new += np.transpose(tmp206, (1, 0, 2, 3, 4, 5)) * -1
    t3new += np.transpose(tmp224, (1, 0, 2, 3, 4, 5)) * -1
    del tmp224
    t3new += np.transpose(tmp207, (1, 0, 2, 3, 4, 5))
    t3new += np.transpose(tmp226, (2, 0, 1, 3, 4, 5)) * -1
    del tmp226
    t3new += np.transpose(tmp133, (0, 2, 1, 3, 4, 5))
    t3new += np.transpose(tmp133, (1, 2, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp215, (1, 0, 2, 3, 4, 5))
    t3new += np.transpose(tmp215, (2, 0, 1, 3, 4, 5)) * -1
    t3new += np.transpose(tmp217, (1, 0, 2, 3, 4, 5)) * -2
    t3new += np.transpose(tmp217, (2, 0, 1, 3, 4, 5)) * 2
    t3new += np.transpose(tmp136, (0, 2, 1, 3, 4, 5))
    t3new += np.transpose(tmp136, (1, 2, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp202, (2, 1, 0, 4, 3, 5))
    del tmp202
    t3new += np.transpose(tmp204, (1, 0, 2, 5, 4, 3))
    del tmp204
    t3new += np.transpose(tmp205, (1, 0, 2, 4, 5, 3))
    del tmp205
    t3new += np.transpose(tmp206, (2, 1, 0, 4, 3, 5))
    t3new += np.transpose(tmp207, (1, 2, 0, 4, 3, 5))
    t3new += np.transpose(tmp133, (1, 0, 2, 4, 3, 5)) * -1
    t3new += np.transpose(tmp215, (2, 1, 0, 4, 3, 5)) * -1
    del tmp215
    t3new += np.transpose(tmp217, (2, 1, 0, 4, 3, 5)) * 2
    del tmp217
    t3new += np.transpose(tmp136, (1, 0, 2, 4, 3, 5)) * -1
    t3new += np.transpose(tmp241, (1, 0, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp243, (1, 0, 2, 5, 3, 4))
    t3new += np.transpose(tmp245, (2, 1, 0, 5, 3, 4))
    t3new += np.transpose(tmp220, (2, 1, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp233, (0, 1, 2, 5, 3, 4))
    t3new += np.transpose(tmp233, (2, 0, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp248, (0, 1, 2, 5, 4, 3))
    t3new += np.transpose(tmp129, (0, 1, 2, 3, 5, 4))
    t3new += np.transpose(tmp131, (0, 1, 2, 3, 5, 4)) * -1
    t3new += np.transpose(tmp129, (1, 0, 2, 3, 4, 5))
    t3new += np.transpose(tmp249, (1, 2, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp251, (1, 2, 0, 3, 5, 4))
    t3new += np.transpose(tmp253, (1, 2, 0, 3, 5, 4))
    t3new += np.transpose(tmp255, (1, 2, 0, 3, 5, 4)) * -2
    t3new += np.transpose(tmp251, (2, 1, 0, 3, 4, 5))
    t3new += np.transpose(tmp255, (2, 1, 0, 3, 4, 5)) * -2
    t3new += np.transpose(tmp253, (2, 1, 0, 3, 4, 5))
    t3new += np.transpose(tmp232, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp230, (1, 2, 0, 4, 5, 3)) * 2
    t3new += np.transpose(tmp220, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp228, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp248, (2, 1, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp129, (2, 1, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp131, (2, 1, 0, 3, 5, 4))
    del tmp131
    t3new += np.transpose(tmp129, (2, 0, 1, 3, 4, 5)) * -1
    t3new += np.transpose(tmp249, (0, 2, 1, 3, 5, 4))
    t3new += np.transpose(tmp251, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp253, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp255, (0, 2, 1, 3, 5, 4)) * 2
    t3new += tmp251 * -1
    t3new += tmp255 * 2
    t3new += tmp253 * -1
    t3new += np.transpose(tmp232, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp230, (0, 2, 1, 4, 5, 3)) * -2
    t3new += np.transpose(tmp220, (0, 2, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp228, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp233, (2, 1, 0, 5, 3, 4)) * -1
    t3new += np.transpose(tmp256, (0, 2, 1, 5, 4, 3))
    t3new += np.transpose(tmp139, (0, 2, 1, 3, 5, 4)) * -1
    del tmp139
    t3new += np.transpose(tmp257, (2, 0, 1, 3, 5, 4))
    t3new += np.transpose(tmp233, (0, 1, 2, 4, 3, 5)) * -1
    t3new += np.transpose(tmp233, (1, 0, 2, 3, 4, 5)) * -1
    t3new += np.transpose(tmp233, (2, 0, 1, 3, 4, 5))
    t3new += tmp248 * -1
    t3new += np.transpose(tmp248, (2, 1, 0, 3, 4, 5))
    del tmp248
    t3new += np.transpose(tmp233, (2, 1, 0, 4, 3, 5))
    del tmp233
    t3new += np.transpose(tmp256, (0, 2, 1, 3, 4, 5)) * -1
    del tmp256
    t3new += np.transpose(tmp241, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp241, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp259, (1, 0, 2, 5, 3, 4)) * 2
    t3new += np.transpose(tmp259, (2, 0, 1, 5, 3, 4)) * -2
    t3new += np.transpose(tmp261, (1, 0, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp261, (2, 0, 1, 5, 3, 4))
    t3new += np.transpose(tmp263, (1, 0, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp263, (2, 0, 1, 5, 3, 4))
    t3new += np.transpose(tmp230, (1, 0, 2, 3, 4, 5)) * -2
    t3new += np.transpose(tmp230, (2, 0, 1, 3, 4, 5)) * 2
    t3new += np.transpose(tmp228, (1, 0, 2, 3, 4, 5))
    t3new += np.transpose(tmp228, (2, 0, 1, 3, 4, 5)) * -1
    t3new += np.transpose(tmp232, (1, 0, 2, 3, 4, 5))
    t3new += np.transpose(tmp232, (2, 0, 1, 3, 4, 5)) * -1
    t3new += np.transpose(tmp241, (0, 1, 2, 4, 3, 5))
    t3new += tmp243 * -1
    t3new += np.transpose(tmp263, (1, 2, 0, 3, 4, 5))
    t3new += np.transpose(tmp259, (1, 2, 0, 3, 4, 5)) * -2
    t3new += np.transpose(tmp245, (1, 2, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp261, (1, 2, 0, 3, 4, 5))
    t3new += tmp247
    t3new += np.transpose(tmp241, (0, 1, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp243, (0, 1, 2, 5, 4, 3))
    t3new += np.transpose(tmp247, (0, 1, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp206, (1, 2, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp206, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp207, (2, 1, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp207, (2, 1, 0, 4, 5, 3))
    t3new += np.transpose(tmp136, (0, 1, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp136, (0, 1, 2, 3, 5, 4))
    t3new += np.transpose(tmp241, (2, 1, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp264, (0, 2, 1, 5, 3, 4)) * -1
    del tmp264
    t3new += np.transpose(tmp266, (0, 2, 1, 5, 4, 3))
    t3new += np.transpose(tmp267, (1, 2, 0, 3, 5, 4)) * -1
    del tmp267
    t3new += np.transpose(tmp268, (1, 2, 0, 3, 5, 4)) * -1
    del tmp268
    t3new += np.transpose(tmp243, (2, 1, 0, 3, 4, 5))
    t3new += np.transpose(tmp263, (0, 2, 1, 3, 4, 5)) * -1
    t3new += np.transpose(tmp259, (0, 2, 1, 3, 4, 5)) * 2
    t3new += np.transpose(tmp245, (0, 2, 1, 3, 4, 5))
    t3new += np.transpose(tmp261, (0, 2, 1, 3, 4, 5)) * -1
    t3new += np.transpose(tmp247, (2, 1, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp241, (2, 1, 0, 5, 3, 4))
    t3new += np.transpose(tmp243, (2, 1, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp247, (2, 1, 0, 5, 4, 3))
    t3new += np.transpose(tmp206, (0, 2, 1, 3, 5, 4))
    t3new += np.transpose(tmp206, (0, 2, 1, 4, 5, 3)) * -1
    del tmp206
    t3new += np.transpose(tmp207, (0, 1, 2, 3, 5, 4))
    t3new += np.transpose(tmp207, (0, 1, 2, 4, 5, 3)) * -1
    del tmp207
    t3new += np.transpose(tmp136, (2, 1, 0, 4, 5, 3))
    t3new += np.transpose(tmp136, (2, 1, 0, 3, 5, 4)) * -1
    del tmp136
    t3new += np.transpose(tmp241, (1, 0, 2, 3, 4, 5))
    t3new += np.transpose(tmp243, (1, 0, 2, 4, 3, 5)) * -1
    t3new += np.transpose(tmp241, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp241, (1, 2, 0, 3, 5, 4))
    t3new += np.transpose(tmp243, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp243, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp247, (0, 2, 1, 4, 3, 5))
    t3new += np.transpose(tmp247, (1, 2, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp241, (2, 0, 1, 3, 4, 5)) * -1
    del tmp241
    t3new += np.transpose(tmp269, (0, 2, 1, 3, 5, 4))
    t3new += np.transpose(tmp270, (0, 2, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp243, (2, 0, 1, 4, 3, 5))
    t3new += np.transpose(tmp137, (0, 2, 1, 4, 5, 3)) * -1
    del tmp137
    t3new += np.transpose(tmp123, (0, 2, 1, 5, 4, 3))
    del tmp123
    t3new += np.transpose(tmp158, (0, 1, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp158, (1, 0, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp237, (0, 1, 2, 4, 5, 3))
    del tmp237
    t3new += np.transpose(tmp238, (0, 1, 2, 5, 3, 4)) * -1
    del tmp238
    t3new += np.transpose(tmp240, (1, 2, 0, 4, 3, 5))
    del tmp240
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), v.OVOV, (6, 7, 1, 4), (0, 6, 2, 3, 7, 5))
    t3new += np.transpose(tmp158, (0, 2, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp158, (0, 2, 1, 3, 5, 4))
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), v.OVOV, (6, 7, 2, 4), (0, 6, 1, 3, 7, 5)) * -1
    t3new += einsum(v.OOVV, (0, 1, 2, 3), t3, (4, 1, 5, 6, 3, 7), (4, 0, 5, 6, 2, 7)) * -1
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), tmp128, (6, 1, 7, 4), (0, 6, 2, 3, 7, 5)) * -1
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), tmp130, (6, 1, 7, 4), (0, 6, 2, 3, 7, 5))
    del tmp130
    t3new += np.transpose(tmp129, (0, 2, 1, 5, 3, 4))
    t3new += np.transpose(tmp129, (0, 2, 1, 4, 3, 5)) * -1
    del tmp129
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), tmp128, (6, 2, 7, 4), (0, 6, 1, 3, 7, 5))
    del tmp128
    t3new += np.transpose(tmp251, (1, 0, 2, 5, 3, 4))
    t3new += np.transpose(tmp251, (1, 0, 2, 4, 3, 5)) * -1
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), tmp250, (6, 2, 7, 4), (0, 6, 1, 3, 7, 5))
    t3new += np.transpose(tmp255, (1, 0, 2, 5, 3, 4)) * -2
    t3new += np.transpose(tmp255, (1, 0, 2, 4, 3, 5)) * 2
    t3new += np.transpose(tmp271, (1, 0, 2, 4, 3, 5)) * -2
    del tmp271
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), tmp239, (6, 1, 7, 4), (0, 6, 2, 3, 7, 5))
    del tmp239
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), tmp250, (6, 1, 7, 4), (0, 6, 2, 3, 7, 5)) * -1
    del tmp250
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), tmp252, (6, 1, 7, 4), (0, 6, 2, 3, 7, 5)) * -1
    t3new += np.transpose(tmp272, (2, 0, 1, 4, 3, 5)) * -2
    del tmp272
    t3new += np.transpose(tmp253, (1, 0, 2, 5, 3, 4))
    t3new += np.transpose(tmp253, (1, 0, 2, 4, 3, 5)) * -1
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), tmp252, (6, 2, 7, 4), (0, 6, 1, 3, 7, 5))
    del tmp252
    t3new += tmp158
    t3new += np.transpose(tmp158, (1, 0, 2, 4, 3, 5))
    del tmp158
    t3new += np.transpose(tmp269, (0, 2, 1, 4, 5, 3)) * -1
    del tmp269
    t3new += np.transpose(tmp273, (0, 2, 1, 5, 3, 4))
    t3new += np.transpose(tmp147, (1, 2, 0, 3, 4, 5))
    del tmp147
    t3new += np.transpose(tmp156, (1, 2, 0, 3, 4, 5))
    del tmp156
    t3new += np.transpose(tmp274, (1, 0, 2, 5, 3, 4))
    t3new += np.transpose(tmp276, (2, 0, 1, 3, 4, 5)) * 2
    t3new += np.transpose(tmp278, (2, 0, 1, 3, 4, 5)) * -1
    t3new += np.transpose(tmp280, (2, 0, 1, 3, 4, 5)) * -1
    t3new += np.transpose(tmp178, (1, 0, 2, 3, 4, 5)) * -1
    t3new += np.transpose(tmp274, (0, 1, 2, 5, 4, 3))
    t3new += np.transpose(tmp282, (0, 1, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp280, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp276, (0, 2, 1, 3, 5, 4)) * 2
    t3new += np.transpose(tmp284, (0, 2, 1, 3, 5, 4))
    t3new += np.transpose(tmp278, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp178, (0, 1, 2, 3, 5, 4)) * -1
    t3new += np.transpose(tmp180, (0, 1, 2, 3, 5, 4))
    t3new += np.transpose(tmp282, (1, 0, 2, 3, 5, 4))
    t3new += np.transpose(tmp282, (1, 0, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp284, (2, 0, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp284, (2, 0, 1, 5, 3, 4))
    t3new += np.transpose(tmp180, (1, 0, 2, 4, 3, 5)) * -1
    t3new += np.transpose(tmp180, (1, 0, 2, 5, 3, 4))
    t3new += np.transpose(tmp282, (1, 2, 0, 5, 3, 4))
    t3new += np.transpose(tmp284, (2, 1, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp180, (1, 2, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp282, (0, 2, 1, 5, 3, 4)) * -1
    t3new += tmp284
    t3new += np.transpose(tmp180, (0, 2, 1, 3, 4, 5))
    t3new += np.transpose(tmp274, (1, 2, 0, 3, 5, 4))
    t3new += np.transpose(tmp274, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp276, (2, 1, 0, 4, 3, 5)) * 2
    t3new += np.transpose(tmp276, (2, 1, 0, 5, 3, 4)) * -2
    t3new += np.transpose(tmp278, (2, 1, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp278, (2, 1, 0, 5, 3, 4))
    t3new += np.transpose(tmp280, (2, 1, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp280, (2, 1, 0, 5, 3, 4))
    t3new += np.transpose(tmp178, (1, 2, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp178, (1, 2, 0, 5, 3, 4))
    t3new += np.transpose(tmp274, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp274, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp286, (0, 2, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp287, (0, 2, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp276, (0, 1, 2, 4, 3, 5)) * -2
    t3new += np.transpose(tmp276, (0, 1, 2, 5, 3, 4)) * 2
    t3new += np.transpose(tmp278, (0, 1, 2, 4, 3, 5))
    t3new += np.transpose(tmp278, (0, 1, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp280, (0, 1, 2, 4, 3, 5))
    t3new += np.transpose(tmp280, (0, 1, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp178, (0, 2, 1, 4, 3, 5))
    t3new += np.transpose(tmp178, (0, 2, 1, 5, 3, 4)) * -1
    t3new += np.transpose(tmp274, (2, 1, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp288, (1, 2, 0, 5, 4, 3))
    t3new += np.transpose(tmp290, (1, 2, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp290, (2, 1, 0, 5, 3, 4)) * -1
    t3new += np.transpose(tmp189, (1, 2, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp192, (1, 2, 0, 3, 5, 4))
    t3new += np.transpose(tmp192, (2, 1, 0, 3, 4, 5))
    t3new += np.transpose(tmp282, (2, 1, 0, 5, 4, 3))
    t3new += np.transpose(tmp280, (1, 2, 0, 3, 5, 4))
    t3new += np.transpose(tmp276, (1, 2, 0, 3, 5, 4)) * -2
    t3new += np.transpose(tmp284, (1, 2, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp278, (1, 2, 0, 3, 5, 4))
    t3new += np.transpose(tmp178, (2, 1, 0, 3, 5, 4))
    t3new += np.transpose(tmp180, (2, 1, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp274, (2, 0, 1, 5, 3, 4)) * -1
    t3new += np.transpose(tmp291, (1, 0, 2, 5, 4, 3))
    t3new += np.transpose(tmp199, (2, 0, 1, 3, 5, 4))
    del tmp199
    t3new += np.transpose(tmp276, (1, 0, 2, 3, 4, 5)) * -2
    t3new += np.transpose(tmp278, (1, 0, 2, 3, 4, 5))
    t3new += np.transpose(tmp280, (1, 0, 2, 3, 4, 5))
    t3new += np.transpose(tmp178, (2, 0, 1, 3, 4, 5))
    t3new += np.transpose(tmp282, (2, 0, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp282, (2, 0, 1, 4, 5, 3))
    t3new += np.transpose(tmp284, (1, 0, 2, 4, 3, 5))
    t3new += np.transpose(tmp284, (1, 0, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp180, (2, 0, 1, 4, 3, 5))
    t3new += np.transpose(tmp180, (2, 0, 1, 5, 3, 4)) * -1
    t3new += np.transpose(tmp247, (1, 0, 2, 3, 5, 4))
    t3new += np.transpose(tmp243, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp243, (1, 2, 0, 3, 5, 4))
    del tmp243
    t3new += np.transpose(tmp245, (1, 0, 2, 3, 5, 4)) * -1
    t3new += np.transpose(tmp245, (2, 0, 1, 3, 5, 4))
    t3new += np.transpose(tmp220, (1, 0, 2, 4, 3, 5))
    t3new += np.transpose(tmp220, (2, 0, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp247, (1, 0, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp247, (2, 0, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp247, (2, 0, 1, 4, 5, 3))
    del tmp247
    t3new += np.transpose(tmp274, (1, 0, 2, 4, 3, 5)) * -1
    t3new += tmp274 * -1
    t3new += tmp282
    t3new += np.transpose(tmp282, (1, 2, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp282, (0, 2, 1, 4, 3, 5))
    t3new += np.transpose(tmp274, (2, 1, 0, 3, 4, 5))
    t3new += np.transpose(tmp288, (1, 2, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp290, (1, 2, 0, 3, 4, 5))
    t3new += np.transpose(tmp290, (2, 1, 0, 4, 3, 5))
    t3new += np.transpose(tmp282, (2, 1, 0, 3, 4, 5)) * -1
    del tmp282
    t3new += np.transpose(tmp274, (2, 0, 1, 4, 3, 5))
    del tmp274
    t3new += np.transpose(tmp291, (1, 0, 2, 3, 4, 5)) * -1
    del tmp291
    t3new += np.transpose(tmp293, (2, 1, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp175, (2, 1, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp296, (2, 1, 0, 5, 3, 4))
    t3new += np.transpose(tmp195, (2, 1, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp293, (1, 0, 2, 5, 4, 3))
    t3new += np.transpose(tmp293, (2, 0, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp175, (1, 0, 2, 4, 3, 5))
    t3new += np.transpose(tmp175, (2, 0, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp299, (1, 0, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp299, (2, 0, 1, 5, 3, 4))
    t3new += np.transpose(tmp195, (1, 0, 2, 4, 3, 5))
    t3new += np.transpose(tmp195, (2, 0, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp293, (1, 2, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp293, (1, 2, 0, 5, 3, 4))
    t3new += np.transpose(tmp299, (1, 2, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp296, (1, 2, 0, 5, 4, 3))
    t3new += np.transpose(tmp195, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp195, (1, 2, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp293, (0, 1, 2, 4, 5, 3))
    t3new += tmp175
    t3new += np.transpose(tmp296, (0, 1, 2, 5, 3, 4)) * -1
    t3new += tmp195
    t3new += np.transpose(tmp293, (0, 2, 1, 4, 3, 5))
    t3new += np.transpose(tmp293, (0, 2, 1, 5, 3, 4)) * -1
    t3new += np.transpose(tmp299, (0, 2, 1, 5, 4, 3))
    t3new += np.transpose(tmp296, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp195, (0, 2, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp195, (0, 2, 1, 3, 5, 4))
    del tmp195
    t3new += np.transpose(tmp293, (2, 1, 0, 3, 5, 4))
    t3new += np.transpose(tmp299, (2, 1, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp296, (2, 1, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp293, (1, 0, 2, 3, 4, 5)) * -1
    t3new += np.transpose(tmp293, (2, 0, 1, 3, 4, 5))
    t3new += np.transpose(tmp296, (1, 0, 2, 4, 5, 3))
    t3new += np.transpose(tmp296, (2, 0, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp299, (1, 0, 2, 4, 3, 5))
    t3new += np.transpose(tmp299, (2, 0, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp293, (0, 1, 2, 3, 5, 4)) * -1
    del tmp293
    t3new += np.transpose(tmp299, (0, 1, 2, 4, 5, 3))
    t3new += np.transpose(tmp296, (0, 1, 2, 4, 3, 5))
    t3new += np.transpose(tmp196, (1, 0, 2, 4, 5, 3)) * -1
    del tmp196
    t3new += np.transpose(tmp178, (1, 0, 2, 5, 4, 3))
    del tmp178
    t3new += np.transpose(tmp200, (1, 2, 0, 4, 5, 3)) * -1
    del tmp200
    t3new += np.transpose(tmp180, (1, 2, 0, 5, 4, 3))
    del tmp180
    t3new += np.transpose(tmp286, (1, 2, 0, 4, 5, 3))
    del tmp286
    t3new += np.transpose(tmp287, (1, 2, 0, 4, 3, 5))
    del tmp287
    t3new += einsum(tmp285, (0, 1, 2, 3), t3, (4, 1, 5, 6, 3, 7), (4, 0, 5, 6, 2, 7)) * -1
    del tmp285
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), tmp289, (6, 1, 7, 4), (0, 6, 2, 3, 7, 5))
    t3new += np.transpose(tmp290, (1, 0, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp290, (1, 0, 2, 3, 5, 4))
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), tmp289, (6, 2, 7, 4), (0, 6, 1, 3, 7, 5)) * -1
    del tmp289
    t3new += einsum(t3, (0, 1, 2, 3, 4, 5), tmp188, (6, 1, 7, 4), (0, 6, 2, 3, 7, 5))
    del tmp188
    t3new += einsum(tmp191, (0, 1, 2, 3), t3, (4, 1, 5, 6, 3, 7), (4, 0, 5, 6, 2, 7)) * -1
    t3new += np.transpose(tmp192, (1, 0, 2, 5, 3, 4))
    t3new += np.transpose(tmp192, (1, 0, 2, 4, 3, 5)) * -1
    t3new += einsum(tmp191, (0, 1, 2, 3), t3, (4, 5, 1, 6, 3, 7), (4, 0, 5, 6, 2, 7))
    del tmp191
    t3new += np.transpose(tmp288, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp290, (0, 2, 1, 5, 4, 3))
    t3new += np.transpose(tmp290, (0, 1, 2, 5, 3, 4))
    t3new += np.transpose(tmp189, (0, 2, 1, 3, 5, 4))
    del tmp189
    t3new += np.transpose(tmp192, (0, 2, 1, 3, 5, 4)) * -1
    t3new += tmp192 * -1
    del tmp192
    t3new += np.transpose(tmp270, (0, 2, 1, 3, 5, 4))
    del tmp270
    t3new += np.transpose(tmp288, (0, 2, 1, 3, 4, 5))
    del tmp288
    t3new += np.transpose(tmp290, (0, 2, 1, 3, 4, 5)) * -1
    t3new += np.transpose(tmp290, (0, 1, 2, 4, 3, 5)) * -1
    del tmp290
    t3new += np.transpose(tmp266, (0, 2, 1, 3, 4, 5)) * -1
    del tmp266
    t3new += np.transpose(tmp273, (0, 2, 1, 4, 3, 5)) * -1
    del tmp273
    t3new += np.transpose(tmp301, (2, 1, 0, 3, 5, 4))
    t3new += np.transpose(tmp303, (2, 1, 0, 5, 4, 3))
    t3new += np.transpose(tmp306, (2, 1, 0, 3, 5, 4))
    t3new += np.transpose(tmp309, (2, 1, 0, 5, 4, 3))
    t3new += np.transpose(tmp310, (0, 2, 1, 3, 5, 4))
    del tmp310
    t3new += np.transpose(tmp303, (0, 2, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp303, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp301, (0, 1, 2, 3, 5, 4)) * -1
    del tmp301
    t3new += np.transpose(tmp303, (0, 1, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp249, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp251, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp253, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp255, (1, 2, 0, 4, 5, 3)) * 2
    t3new += np.transpose(tmp251, (2, 1, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp255, (2, 1, 0, 5, 4, 3)) * 2
    t3new += np.transpose(tmp253, (2, 1, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp222, (2, 1, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp209, (2, 1, 0, 4, 5, 3))
    t3new += np.transpose(tmp213, (2, 1, 0, 4, 5, 3))
    t3new += np.transpose(tmp211, (2, 1, 0, 4, 5, 3)) * -2
    t3new += np.transpose(tmp257, (2, 0, 1, 4, 5, 3)) * -1
    del tmp257
    t3new += np.transpose(tmp222, (2, 0, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp249, (0, 2, 1, 4, 5, 3)) * -1
    del tmp249
    t3new += np.transpose(tmp251, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp253, (0, 2, 1, 4, 5, 3))
    t3new += np.transpose(tmp255, (0, 2, 1, 4, 5, 3)) * -2
    t3new += np.transpose(tmp251, (0, 1, 2, 5, 4, 3))
    del tmp251
    t3new += np.transpose(tmp255, (0, 1, 2, 5, 4, 3)) * -2
    del tmp255
    t3new += np.transpose(tmp253, (0, 1, 2, 5, 4, 3))
    del tmp253
    t3new += np.transpose(tmp209, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp211, (0, 2, 1, 5, 4, 3)) * 2
    t3new += np.transpose(tmp213, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp222, (0, 1, 2, 4, 5, 3))
    t3new += np.transpose(tmp209, (0, 1, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp213, (0, 1, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp211, (0, 1, 2, 4, 5, 3)) * 2
    t3new += np.transpose(tmp133, (0, 1, 2, 3, 5, 4))
    t3new += np.transpose(tmp133, (0, 1, 2, 4, 5, 3)) * -1
    t3new += np.transpose(tmp222, (1, 0, 2, 5, 4, 3))
    t3new += np.transpose(tmp222, (0, 2, 1, 4, 3, 5))
    t3new += np.transpose(tmp222, (0, 2, 1, 5, 3, 4)) * -1
    del tmp222
    t3new += np.transpose(tmp209, (1, 2, 0, 5, 4, 3))
    del tmp209
    t3new += np.transpose(tmp211, (1, 2, 0, 5, 4, 3)) * -2
    del tmp211
    t3new += np.transpose(tmp213, (1, 2, 0, 5, 4, 3))
    del tmp213
    t3new += np.transpose(tmp133, (2, 1, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp133, (2, 1, 0, 4, 5, 3))
    del tmp133
    t3new += np.transpose(tmp312, (2, 0, 1, 5, 3, 4))
    t3new += np.transpose(tmp303, (2, 1, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp314, (2, 0, 1, 5, 3, 4))
    t3new += np.transpose(tmp309, (2, 1, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp312, (1, 2, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp312, (0, 2, 1, 5, 4, 3))
    t3new += np.transpose(tmp303, (0, 2, 1, 3, 5, 4))
    t3new += np.transpose(tmp303, (1, 2, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp312, (2, 1, 0, 3, 5, 4))
    t3new += np.transpose(tmp312, (2, 1, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp303, (2, 0, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp303, (2, 0, 1, 5, 3, 4))
    t3new += np.transpose(tmp314, (2, 1, 0, 3, 5, 4))
    t3new += np.transpose(tmp314, (2, 1, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp309, (2, 0, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp309, (2, 0, 1, 5, 3, 4))
    t3new += np.transpose(tmp312, (1, 0, 2, 5, 3, 4)) * -1
    t3new += tmp303
    t3new += np.transpose(tmp312, (0, 1, 2, 3, 5, 4)) * -1
    t3new += np.transpose(tmp312, (0, 1, 2, 4, 5, 3))
    t3new += np.transpose(tmp303, (1, 0, 2, 4, 3, 5))
    t3new += np.transpose(tmp303, (1, 0, 2, 5, 3, 4)) * -1
    del tmp303
    t3new += np.transpose(tmp259, (2, 1, 0, 3, 5, 4)) * -2
    t3new += np.transpose(tmp261, (2, 1, 0, 3, 5, 4))
    t3new += np.transpose(tmp263, (2, 1, 0, 3, 5, 4))
    t3new += np.transpose(tmp230, (2, 1, 0, 4, 3, 5)) * 2
    t3new += np.transpose(tmp228, (2, 1, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp232, (2, 1, 0, 4, 3, 5)) * -1
    t3new += np.transpose(tmp259, (0, 1, 2, 3, 5, 4)) * 2
    t3new += np.transpose(tmp261, (0, 1, 2, 3, 5, 4)) * -1
    t3new += np.transpose(tmp263, (0, 1, 2, 3, 5, 4)) * -1
    t3new += np.transpose(tmp230, (0, 1, 2, 4, 3, 5)) * -2
    t3new += np.transpose(tmp228, (0, 1, 2, 4, 3, 5))
    t3new += np.transpose(tmp232, (0, 1, 2, 4, 3, 5))
    t3new += np.transpose(tmp245, (0, 2, 1, 5, 4, 3)) * -1
    t3new += np.transpose(tmp261, (0, 2, 1, 5, 4, 3))
    t3new += np.transpose(tmp263, (0, 2, 1, 5, 4, 3))
    t3new += np.transpose(tmp259, (0, 2, 1, 5, 4, 3)) * -2
    t3new += np.transpose(tmp220, (0, 2, 1, 3, 5, 4))
    t3new += np.transpose(tmp228, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp232, (0, 2, 1, 3, 5, 4)) * -1
    t3new += np.transpose(tmp230, (0, 2, 1, 3, 5, 4)) * 2
    t3new += np.transpose(tmp261, (0, 1, 2, 4, 5, 3))
    t3new += np.transpose(tmp259, (0, 1, 2, 4, 5, 3)) * -2
    t3new += np.transpose(tmp263, (0, 1, 2, 4, 5, 3))
    t3new += np.transpose(tmp228, (0, 1, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp230, (0, 1, 2, 5, 3, 4)) * 2
    t3new += np.transpose(tmp232, (0, 1, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp245, (1, 0, 2, 4, 5, 3))
    t3new += np.transpose(tmp245, (2, 0, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp220, (1, 0, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp220, (2, 0, 1, 5, 3, 4))
    t3new += np.transpose(tmp245, (1, 2, 0, 5, 4, 3))
    t3new += np.transpose(tmp261, (1, 2, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp263, (1, 2, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp259, (1, 2, 0, 5, 4, 3)) * 2
    t3new += np.transpose(tmp220, (1, 2, 0, 3, 5, 4)) * -1
    del tmp220
    t3new += np.transpose(tmp228, (1, 2, 0, 3, 5, 4))
    t3new += np.transpose(tmp232, (1, 2, 0, 3, 5, 4))
    t3new += np.transpose(tmp230, (1, 2, 0, 3, 5, 4)) * -2
    t3new += np.transpose(tmp261, (2, 1, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp259, (2, 1, 0, 4, 5, 3)) * 2
    t3new += np.transpose(tmp263, (2, 1, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp228, (2, 1, 0, 5, 3, 4))
    del tmp228
    t3new += np.transpose(tmp230, (2, 1, 0, 5, 3, 4)) * -2
    del tmp230
    t3new += np.transpose(tmp232, (2, 1, 0, 5, 3, 4))
    del tmp232
    t3new += np.transpose(tmp312, (2, 0, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp314, (2, 0, 1, 4, 3, 5)) * -1
    t3new += np.transpose(tmp312, (1, 2, 0, 3, 4, 5))
    t3new += np.transpose(tmp312, (0, 2, 1, 3, 4, 5)) * -1
    t3new += np.transpose(tmp312, (1, 0, 2, 4, 3, 5))
    del tmp312
    t3new += np.transpose(tmp245, (0, 1, 2, 4, 3, 5))
    t3new += np.transpose(tmp261, (1, 0, 2, 4, 3, 5))
    t3new += np.transpose(tmp261, (2, 0, 1, 4, 3, 5)) * -1
    del tmp261
    t3new += np.transpose(tmp259, (1, 0, 2, 4, 3, 5)) * -2
    t3new += np.transpose(tmp259, (2, 0, 1, 4, 3, 5)) * 2
    del tmp259
    t3new += np.transpose(tmp263, (1, 0, 2, 4, 3, 5))
    t3new += np.transpose(tmp263, (2, 0, 1, 4, 3, 5)) * -1
    del tmp263
    t3new += np.transpose(tmp245, (2, 1, 0, 4, 3, 5)) * -1
    del tmp245
    t3new += np.transpose(tmp175, (1, 2, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp175, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp284, (2, 1, 0, 5, 4, 3))
    t3new += np.transpose(tmp280, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp276, (1, 2, 0, 4, 5, 3)) * 2
    t3new += np.transpose(tmp284, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp278, (1, 2, 0, 4, 5, 3)) * -1
    t3new += np.transpose(tmp276, (2, 0, 1, 5, 4, 3)) * -2
    t3new += np.transpose(tmp278, (2, 0, 1, 5, 4, 3))
    t3new += np.transpose(tmp280, (2, 0, 1, 5, 4, 3))
    t3new += np.transpose(tmp276, (1, 0, 2, 5, 4, 3)) * 2
    t3new += np.transpose(tmp278, (1, 0, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp280, (1, 0, 2, 5, 4, 3)) * -1
    t3new += np.transpose(tmp175, (0, 2, 1, 3, 5, 4))
    t3new += np.transpose(tmp175, (0, 2, 1, 4, 5, 3)) * -1
    del tmp175
    t3new += np.transpose(tmp280, (0, 2, 1, 4, 5, 3))
    del tmp280
    t3new += np.transpose(tmp276, (0, 2, 1, 4, 5, 3)) * -2
    del tmp276
    t3new += np.transpose(tmp284, (0, 2, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp278, (0, 2, 1, 4, 5, 3))
    del tmp278
    t3new += np.transpose(tmp284, (0, 1, 2, 5, 4, 3)) * -1
    del tmp284
    t3new += np.transpose(tmp314, (1, 2, 0, 5, 4, 3)) * -1
    t3new += np.transpose(tmp314, (0, 2, 1, 5, 4, 3))
    t3new += np.transpose(tmp309, (0, 2, 1, 3, 5, 4))
    t3new += np.transpose(tmp309, (1, 2, 0, 3, 5, 4)) * -1
    t3new += np.transpose(tmp314, (1, 0, 2, 5, 3, 4)) * -1
    t3new += tmp309
    t3new += np.transpose(tmp314, (0, 1, 2, 3, 5, 4)) * -1
    t3new += np.transpose(tmp314, (0, 1, 2, 4, 5, 3))
    t3new += np.transpose(tmp309, (1, 0, 2, 4, 3, 5))
    t3new += np.transpose(tmp309, (1, 0, 2, 5, 3, 4)) * -1
    t3new += np.transpose(tmp299, (2, 1, 0, 3, 5, 4))
    t3new += np.transpose(tmp296, (1, 0, 2, 3, 5, 4)) * -1
    t3new += np.transpose(tmp296, (2, 0, 1, 3, 5, 4))
    t3new += np.transpose(tmp299, (0, 1, 2, 3, 5, 4)) * -1
    t3new += np.transpose(tmp314, (1, 2, 0, 3, 4, 5))
    t3new += np.transpose(tmp314, (0, 2, 1, 3, 4, 5)) * -1
    t3new += np.transpose(tmp299, (1, 2, 0, 3, 4, 5))
    t3new += np.transpose(tmp296, (1, 2, 0, 3, 4, 5)) * -1
    t3new += np.transpose(tmp314, (1, 0, 2, 4, 3, 5))
    del tmp314
    t3new += np.transpose(tmp299, (0, 2, 1, 3, 4, 5)) * -1
    del tmp299
    t3new += np.transpose(tmp296, (0, 2, 1, 3, 4, 5))
    del tmp296
    t3new += np.transpose(tmp315, (0, 2, 1, 3, 5, 4))
    del tmp315
    t3new += np.transpose(tmp309, (0, 2, 1, 4, 5, 3)) * -1
    t3new += np.transpose(tmp309, (1, 2, 0, 4, 5, 3))
    t3new += np.transpose(tmp306, (0, 1, 2, 3, 5, 4)) * -1
    del tmp306
    t3new += np.transpose(tmp309, (0, 1, 2, 5, 4, 3)) * -1
    del tmp309
    t2new_OOVv = np.copy(np.transpose(tmp49, (2, 1, 3, 0)))
    t2new_OOVv += np.transpose(tmp50, (1, 2, 3, 0))
    t2new_OOVv += np.transpose(tmp54, (2, 1, 3, 0)) * -1
    t2new_OOVv += np.transpose(tmp56, (1, 2, 3, 0)) * -1
    t2new_OOvV = np.copy(np.transpose(tmp49, (1, 2, 0, 3)))
    del tmp49
    t2new_OOvV += np.transpose(tmp50, (2, 1, 0, 3))
    del tmp50
    t2new_OOvV += np.transpose(tmp54, (1, 2, 0, 3)) * -1
    del tmp54
    t2new_OOvV += np.transpose(tmp56, (2, 1, 0, 3)) * -1
    del tmp56
    t2new_oOVV = np.copy(tmp30) * -1
    t2new_oOVV += np.transpose(tmp31, (0, 1, 3, 2)) * -1
    t2new_oOVV += tmp65 * -1
    t2new_oOVV += np.transpose(tmp66, (0, 1, 3, 2)) * -1
    t2new_OOVV = np.copy(tmp35)
    t2new_OOVV += np.transpose(tmp35, (1, 0, 3, 2))
    del tmp35
    t2new_OOVV += tmp37 * -1
    t2new_OOVV += tmp39 * 2
    t2new_OOVV += np.transpose(tmp37, (1, 0, 3, 2)) * -1
    del tmp37
    t2new_OOVV += np.transpose(tmp39, (1, 0, 3, 2)) * 2
    del tmp39
    t2new_OoVV = np.copy(np.transpose(tmp30, (1, 0, 3, 2))) * -1
    del tmp30
    t2new_OoVV += np.transpose(tmp31, (1, 0, 2, 3)) * -1
    del tmp31
    t2new_OoVV += np.transpose(tmp65, (1, 0, 3, 2)) * -1
    del tmp65
    t2new_OoVV += np.transpose(tmp66, (1, 0, 2, 3)) * -1
    del tmp66
    t2new = np.copy(np.transpose(tmp28, (1, 0, 2, 3))) * -1
    t2new += np.transpose(tmp29, (1, 0, 3, 2))
    del tmp29
    t2new += tmp32
    t2new += tmp33 * -2
    t2new += einsum(tmp34, (0, 1, 2, 3), t1, (1, 4), (0, 2, 4, 3))
    del tmp34
    t2new += np.transpose(tmp28, (0, 1, 3, 2)) * -1
    del tmp28
    t2new += np.transpose(tmp32, (1, 0, 3, 2))
    del tmp32
    t2new += np.transpose(tmp33, (1, 0, 3, 2)) * -2
    del tmp33
    t2new += tmp41 * -2
    t2new += tmp43
    t2new += np.transpose(tmp44, (1, 0, 2, 3))
    t2new += np.transpose(tmp46, (1, 0, 2, 3)) * -1
    t2new += np.transpose(tmp47, (1, 0, 3, 2)) * 2
    t2new += np.transpose(tmp48, (1, 0, 3, 2)) * -1
    t2new += np.transpose(tmp51, (1, 0, 3, 2)) * 2
    t2new += np.transpose(tmp52, (1, 0, 3, 2)) * -1
    t2new += np.transpose(tmp43, (1, 0, 3, 2))
    del tmp43
    t2new += np.transpose(tmp41, (1, 0, 3, 2)) * -2
    del tmp41
    t2new += np.transpose(tmp58, (1, 0, 2, 3))
    t2new += np.transpose(tmp60, (1, 0, 2, 3)) * -2
    t2new += np.transpose(tmp44, (0, 1, 3, 2))
    del tmp44
    t2new += np.transpose(tmp46, (0, 1, 3, 2)) * -1
    del tmp46
    t2new += tmp51 * 2
    del tmp51
    t2new += tmp52 * -1
    del tmp52
    t2new += np.transpose(tmp58, (0, 1, 3, 2))
    del tmp58
    t2new += np.transpose(tmp60, (0, 1, 3, 2)) * -2
    del tmp60
    t2new += np.transpose(tmp61, (1, 0, 2, 3)) * -1
    t2new += np.transpose(tmp63, (1, 0, 2, 3))
    t2new += tmp67
    t2new += tmp68 * -2
    t2new += np.transpose(tmp69, (1, 0, 2, 3))
    t2new += np.transpose(tmp70, (1, 0, 2, 3)) * -2
    t2new += np.transpose(tmp72, (1, 0, 2, 3))
    t2new += np.transpose(tmp61, (0, 1, 3, 2)) * -1
    del tmp61
    t2new += np.transpose(tmp63, (0, 1, 3, 2))
    del tmp63
    t2new += np.transpose(tmp74, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp67, (1, 0, 3, 2))
    del tmp67
    t2new += np.transpose(tmp68, (1, 0, 3, 2)) * -2
    del tmp68
    t2new += np.transpose(tmp69, (0, 1, 3, 2))
    del tmp69
    t2new += np.transpose(tmp70, (0, 1, 3, 2)) * -2
    del tmp70
    t2new += np.transpose(tmp72, (0, 1, 3, 2))
    del tmp72
    t2new += np.transpose(v.ovov, (0, 2, 1, 3))
    t2new += np.transpose(tmp75, (1, 0, 2, 3))
    t2new += np.transpose(tmp77, (1, 0, 3, 2)) * -1
    t2new += np.transpose(tmp78, (1, 0, 3, 2)) * -1
    t2new += np.transpose(tmp80, (1, 0, 2, 3))
    t2new += np.transpose(tmp81, (1, 0, 3, 2)) * -1
    t2new += np.transpose(tmp82, (0, 1, 3, 2)) * -1
    t2new += tmp84
    t2new += einsum(t2, (0, 1, 2, 3), tmp85, (4, 1, 5, 2), (4, 0, 3, 5))
    del tmp85
    t2new += np.transpose(tmp86, (1, 0, 3, 2)) * -1
    t2new += np.transpose(tmp88, (1, 0, 2, 3)) * -2
    t2new += np.transpose(tmp90, (1, 0, 2, 3))
    t2new += np.transpose(tmp92, (1, 0, 2, 3))
    t2new += np.transpose(tmp93, (1, 0, 3, 2))
    t2new += tmp95 * -2
    del tmp95
    t2new += np.transpose(tmp96, (1, 0, 3, 2)) * -2
    t2new += tmp97 * 4
    del tmp97
    t2new += tmp93
    del tmp93
    t2new += tmp96 * -2
    del tmp96
    t2new += einsum(t2, (0, 1, 2, 3), tmp48, (4, 1, 5, 2), (4, 0, 5, 3))
    t2new += tmp81 * -1
    del tmp81
    t2new += np.transpose(tmp82, (1, 0, 2, 3)) * -1
    del tmp82
    t2new += np.transpose(tmp84, (1, 0, 3, 2))
    del tmp84
    t2new += np.transpose(tmp75, (0, 1, 3, 2))
    del tmp75
    t2new += einsum(t1, (0, 1), tmp98, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp98
    t2new += tmp100
    del tmp100
    t2new += np.transpose(tmp102, (1, 0, 3, 2)) * -1
    t2new += einsum(tmp103, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp103
    t2new += np.transpose(tmp104, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp105, (0, 1, 3, 2)) * 2
    t2new += np.transpose(tmp106, (0, 1, 3, 2)) * -1
    t2new += tmp108
    t2new += tmp110 * -2
    t2new += tmp112
    t2new += tmp47 * 2
    del tmp47
    t2new += tmp48 * -1
    del tmp48
    t2new += tmp86 * -1
    del tmp86
    t2new += np.transpose(tmp88, (0, 1, 3, 2)) * -2
    del tmp88
    t2new += np.transpose(tmp90, (0, 1, 3, 2))
    del tmp90
    t2new += np.transpose(tmp92, (0, 1, 3, 2))
    del tmp92
    t2new += np.transpose(tmp113, (1, 0, 3, 2))
    del tmp113
    t2new += np.transpose(tmp115, (1, 0, 3, 2)) * -1
    t2new += tmp117
    del tmp117
    t2new += tmp119
    del tmp119
    t2new += np.transpose(tmp104, (1, 0, 2, 3)) * -1
    del tmp104
    t2new += np.transpose(tmp105, (1, 0, 2, 3)) * 2
    del tmp105
    t2new += np.transpose(tmp106, (1, 0, 2, 3)) * -1
    del tmp106
    t2new += np.transpose(tmp108, (1, 0, 3, 2))
    del tmp108
    t2new += np.transpose(tmp110, (1, 0, 3, 2)) * -2
    del tmp110
    t2new += np.transpose(tmp112, (1, 0, 3, 2))
    del tmp112
    t2new += tmp77 * -1
    del tmp77
    t2new += tmp78 * -1
    del tmp78
    t2new += np.transpose(tmp80, (0, 1, 3, 2))
    del tmp80
    t2new += tmp115 * -1
    del tmp115
    t2new += np.transpose(tmp74, (1, 0, 2, 3)) * -1
    del tmp74
    t2new += tmp102 * -1
    del tmp102
    t1new_OV = np.copy(tmp20) * 0.5
    del tmp20
    t1new_OV += tmp21 * -0.5
    del tmp21
    t1new_OV += tmp22 * 1.5
    del tmp22
    t1new_OV += tmp23 * 0.5
    del tmp23
    t1new = np.copy(f.ov)
    t1new += einsum(t1, (0, 1), f.vv, (2, 1), (0, 2))
    t1new += einsum(t1, (0, 1), tmp0, (0, 2), (2, 1)) * -1
    del tmp0
    t1new += tmp1 * 2
    del tmp1
    t1new += tmp2 * 2
    del tmp2
    t1new += tmp3 * -1
    del tmp3
    t1new += tmp5 * -2
    del tmp5
    t1new += tmp6
    del tmp6
    t1new += tmp8 * -2
    del tmp8
    t1new += tmp10
    del tmp10
    t1new += tmp12 * 2
    del tmp12
    t1new += einsum(tmp13, (0, 1), t1, (2, 0), (2, 1)) * -1
    del tmp13
    t1new += einsum(t1, (0, 1), tmp15, (2, 0), (2, 1))
    del tmp15
    t1new += tmp17 * -2
    del tmp17
    t1new += einsum(t1, (0, 1), f.oo, (2, 0), (2, 1)) * -1
    t1new += einsum(f.ov, (0, 1), t2, (2, 0, 1, 3), (2, 3)) * -1
    t1new += einsum(t2, (0, 1, 2, 3), f.ov, (1, 3), (0, 2)) * 2
    t1new += einsum(t1, (0, 1), v.oovv, (2, 0, 3, 1), (2, 3)) * -1
    t1new += tmp18
    del tmp18
    t1new += tmp19 * -2
    del tmp19
    t1new += einsum(tmp14, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    t1new += einsum(t2, (0, 1, 2, 3), tmp14, (1, 3), (0, 2)) * -2
    del tmp14
    t1new += tmp24 * -2
    del tmp24
    t1new += tmp25 * 4
    del tmp25
    t1new += einsum(t1, (0, 1), tmp26, (2, 0), (2, 1))
    del tmp26
    t1new += einsum(tmp27, (0, 1), t1, (1, 2), (0, 2)) * -2
    del tmp27

    t2new += _inflate(t2new.shape, np.ix_(sO, sO, sV, sV), t2new_OOVV)
    t1new += _inflate(t1new.shape, np.ix_(sO, sV), t1new_OV)
    t2new += _inflate(t2new.shape, np.ix_(sO, sO, sV, sv), t2new_OOVv)
    t2new += _inflate(t2new.shape, np.ix_(sO, so, sV, sV), t2new_OoVV)
    t2new += _inflate(t2new.shape, np.ix_(sO, sO, sv, sV), t2new_OOvV)
    t2new += _inflate(t2new.shape, np.ix_(so, sO, sV, sV), t2new_oOVV)

    return {f"t1new": t1new, f"t2new": t2new, f"t3new": t3new}

