"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T17:07:48.913612
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:07:49.622767.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1)))
    tmp0 += np.transpose(v.ovov, (0, 2, 1, 3)) * -0.5
    tmp1 = np.copy(f.ov)
    tmp1 += einsum(t1, (0, 1), tmp0, (0, 2, 3, 1), (2, 3))
    del tmp0
    e_cc = einsum(t2, (0, 1, 2, 3), v.ovov, (0, 2, 1, 3), ()) * 2
    e_cc += einsum(t2, (0, 1, 2, 3), v.ovov, (0, 3, 1, 2), ()) * -1
    e_cc += einsum(t1, (0, 1), tmp1, (0, 1), ()) * 2
    del tmp1

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:08:05.693585.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    t1new : array
        Updated T1 residuals.
    t2new : array
        Updated T2 residuals.
    """

    tmp1 = einsum(t1, (0, 1), v.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp3 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * 2
    tmp3 += np.transpose(v.ovov, (0, 2, 1, 3)) * -1
    tmp44 = np.copy(tmp1) * 2
    tmp44 += np.transpose(tmp1, (0, 2, 1, 3)) * -1
    tmp31 = einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    tmp31 += np.transpose(t2, (0, 1, 3, 2)) * -2
    tmp31 += t2
    tmp4 = einsum(t1, (0, 1), tmp3, (0, 2, 3, 1), (2, 3))
    del tmp3
    tmp39 = np.copy(v.ovvv) * 2
    tmp39 += np.transpose(v.ovvv, (0, 2, 3, 1)) * -1
    tmp43 = einsum(t2, (0, 1, 2, 3), tmp1, (4, 1, 5, 2), (4, 0, 5, 3))
    tmp45 = einsum(t2, (0, 1, 2, 3), tmp44, (4, 1, 5, 3), (4, 5, 0, 2))
    del tmp44
    tmp42 = einsum(t2, (0, 1, 2, 3), v.ooov, (4, 1, 5, 2), (0, 4, 5, 3))
    tmp48 = np.copy(v.ooov) * 2
    tmp48 += np.transpose(v.ooov, (0, 2, 1, 3)) * -1
    tmp65 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp55 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * -0.5
    tmp55 += np.transpose(v.ovov, (0, 2, 1, 3))
    tmp32 = einsum(tmp31, (0, 1, 2, 3), v.ooov, (4, 5, 0, 3), (4, 5, 1, 2))
    del tmp31
    tmp30 = einsum(t2, (0, 1, 2, 3), tmp1, (4, 5, 1, 2), (4, 0, 5, 3))
    tmp33 = einsum(t2, (0, 1, 2, 3), tmp4, (4, 2), (4, 0, 1, 3))
    tmp28 = einsum(t1, (0, 1), v.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp29 = einsum(v.ooov, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp16 = einsum(t1, (0, 1), tmp1, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp40 = einsum(t1, (0, 1), tmp39, (0, 1, 2, 3), (2, 3))
    del tmp39
    tmp46 = np.copy(tmp1) * -1
    tmp46 += tmp42
    del tmp42
    tmp46 += tmp43
    del tmp43
    tmp46 += np.transpose(tmp45, (0, 2, 1, 3)) * -1
    del tmp45
    tmp49 = einsum(tmp48, (0, 1, 2, 3), t1, (2, 3), (0, 1))
    del tmp48
    tmp63 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp66 = np.copy(f.oo)
    tmp66 += tmp65
    del tmp65
    tmp17 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 5, 1, 2), (0, 4, 3, 5))
    tmp56 = einsum(tmp55, (0, 1, 2, 3), t2, (0, 1, 4, 3), (2, 4))
    tmp58 = einsum(t2, (0, 1, 2, 3), tmp55, (1, 4, 3, 2), (4, 0)) * 2
    del tmp55
    tmp52 = einsum(v.ovvv, (0, 1, 2, 3), t2, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp36 = einsum(tmp4, (0, 1), t1, (2, 1), (0, 2))
    tmp34 = np.copy(np.transpose(tmp28, (0, 2, 1, 3))) * -1
    del tmp28
    tmp34 += np.transpose(tmp29, (0, 2, 1, 3))
    del tmp29
    tmp34 += np.transpose(tmp30, (0, 2, 1, 3))
    del tmp30
    tmp34 += np.transpose(tmp32, (2, 1, 0, 3))
    del tmp32
    tmp34 += np.transpose(tmp33, (2, 0, 1, 3)) * -1
    del tmp33
    tmp26 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp26 += t2 * 2
    tmp23 = einsum(t1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp19 = einsum(t1, (0, 1), v.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp12 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1)))
    tmp12 += np.transpose(v.ovov, (0, 2, 1, 3)) * -0.5
    tmp69 = np.copy(v.oooo)
    tmp69 += einsum(v.ovov, (0, 1, 2, 3), t2, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp69 += np.transpose(tmp16, (3, 1, 0, 2))
    tmp41 = einsum(tmp40, (0, 1), t2, (2, 3, 1, 4), (2, 3, 0, 4))
    del tmp40
    tmp47 = einsum(tmp46, (0, 1, 2, 3), t1, (2, 4), (0, 1, 3, 4))
    del tmp46
    tmp50 = einsum(tmp49, (0, 1), t2, (2, 1, 3, 4), (0, 2, 4, 3))
    del tmp49
    tmp64 = einsum(t1, (0, 1), tmp63, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp63
    tmp67 = einsum(t2, (0, 1, 2, 3), tmp66, (1, 4), (4, 0, 3, 2))
    del tmp66
    tmp54 = einsum(tmp17, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp57 = einsum(tmp56, (0, 1), t2, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp56
    tmp59 = einsum(t2, (0, 1, 2, 3), tmp58, (1, 4), (4, 0, 3, 2)) * 0.5
    del tmp58
    tmp53 = einsum(t1, (0, 1), tmp52, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp52
    tmp18 = einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp61 = einsum(v.ooov, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp37 = einsum(tmp36, (0, 1), t2, (2, 0, 3, 4), (1, 2, 4, 3))
    del tmp36
    tmp35 = einsum(tmp34, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    del tmp34
    tmp27 = einsum(tmp23, (0, 1, 2, 3), tmp26, (1, 4, 2, 5), (4, 0, 5, 3))
    del tmp26
    tmp22 = einsum(f.vv, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp25 = einsum(t2, (0, 1, 2, 3), tmp19, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp24 = einsum(v.oovv, (0, 1, 2, 3), t2, (4, 1, 3, 5), (4, 0, 5, 2))
    tmp20 = np.copy(t2)
    tmp20 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    tmp8 = np.copy(v.ovvv)
    tmp8 += np.transpose(v.ovvv, (0, 2, 3, 1)) * -0.5
    tmp10 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * 2
    tmp10 += np.transpose(v.ovov, (0, 2, 1, 3)) * -1
    tmp13 = np.copy(f.ov) * 0.5
    tmp13 += einsum(t1, (0, 1), tmp12, (0, 2, 3, 1), (2, 3))
    del tmp12
    tmp11 = np.copy(v.ooov)
    tmp11 += np.transpose(v.ooov, (0, 2, 1, 3)) * -0.5
    tmp15 = einsum(t1, (0, 1), v.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp70 = np.copy(np.transpose(v.ooov, (0, 2, 1, 3))) * -1
    tmp70 += einsum(tmp69, (0, 1, 2, 3), t1, (0, 4), (2, 1, 3, 4))
    del tmp69
    tmp51 = np.copy(np.transpose(tmp41, (1, 0, 3, 2)))
    del tmp41
    tmp51 += np.transpose(tmp47, (0, 1, 3, 2))
    del tmp47
    tmp51 += np.transpose(tmp50, (1, 0, 3, 2)) * -1
    del tmp50
    tmp71 = np.copy(np.transpose(v.ovov, (0, 2, 1, 3))) * -1
    tmp71 += tmp17
    tmp68 = np.copy(tmp64)
    del tmp64
    tmp68 += np.transpose(tmp67, (0, 1, 3, 2))
    del tmp67
    tmp60 = np.copy(tmp53)
    del tmp53
    tmp60 += tmp54 * 2
    del tmp54
    tmp60 += np.transpose(tmp57, (1, 0, 3, 2))
    del tmp57
    tmp60 += np.transpose(tmp59, (1, 0, 3, 2))
    del tmp59
    tmp72 = np.copy(np.transpose(v.ovov, (0, 2, 1, 3))) * 0.5
    tmp72 += v.oovv * -0.25
    tmp72 += tmp18
    tmp62 = einsum(t2, (0, 1, 2, 3), tmp61, (4, 5, 0, 1), (4, 5, 2, 3))
    del tmp61
    tmp38 = np.copy(tmp22)
    del tmp22
    tmp38 += tmp23
    del tmp23
    tmp38 += tmp24 * -1
    del tmp24
    tmp38 += tmp25 * -1
    del tmp25
    tmp38 += np.transpose(tmp27, (1, 0, 2, 3))
    del tmp27
    tmp38 += np.transpose(tmp35, (0, 1, 3, 2))
    del tmp35
    tmp38 += np.transpose(tmp37, (0, 1, 3, 2)) * -1
    del tmp37
    tmp21 = einsum(tmp20, (0, 1, 2, 3), tmp19, (4, 0, 3, 5), (4, 1, 5, 2))
    del tmp19, tmp20
    tmp9 = np.copy(f.vv)
    tmp9 += einsum(t1, (0, 1), tmp8, (0, 1, 2, 3), (3, 2)) * 2
    del tmp8
    tmp0 = np.copy(v.ovvv) * -0.5
    tmp0 += np.transpose(v.ovvv, (0, 2, 1, 3))
    tmp6 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp6 += t2 * -1
    tmp7 = np.copy(np.transpose(v.ovov, (0, 2, 1, 3))) * 2
    tmp7 += v.oovv * -1
    tmp5 = np.copy(f.ov)
    tmp5 += tmp4
    del tmp4
    tmp14 = np.copy(f.oo)
    tmp14 += einsum(tmp10, (0, 1, 2, 3), t2, (4, 0, 2, 3), (1, 4))
    del tmp10
    tmp14 += einsum(t1, (0, 1), tmp11, (2, 3, 0, 1), (3, 2)) * 2
    del tmp11
    tmp14 += einsum(tmp13, (0, 1), t1, (2, 1), (0, 2)) * 2
    del tmp13
    tmp2 = np.copy(v.ooov)
    tmp2 += np.transpose(v.ooov, (0, 2, 1, 3)) * -0.5
    tmp2 += tmp1 * -0.5
    tmp2 += np.transpose(tmp1, (0, 2, 1, 3))
    del tmp1
    t2new = einsum(t2, (0, 1, 2, 3), v.vvvv, (4, 2, 5, 3), (0, 1, 4, 5))
    t2new += einsum(t1, (0, 1), tmp15, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp15
    t2new += np.transpose(v.ovov, (0, 2, 1, 3))
    t2new += einsum(t2, (0, 1, 2, 3), v.oooo, (4, 1, 5, 0), (4, 5, 3, 2))
    t2new += einsum(t2, (0, 1, 2, 3), tmp16, (4, 5, 1, 0), (5, 4, 2, 3))
    del tmp16
    t2new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 5, 3), (4, 0, 5, 2)) * -1
    t2new += tmp17 * -1
    del tmp17
    t2new += np.transpose(tmp18, (1, 0, 3, 2)) * 2
    del tmp18
    t2new += einsum(v.ovoo, (0, 1, 2, 3), t1, (3, 4), (0, 2, 1, 4)) * -1
    t2new += np.transpose(tmp21, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp21, (1, 0, 2, 3)) * -1
    del tmp21
    t2new += np.transpose(tmp38, (0, 1, 3, 2))
    t2new += np.transpose(tmp38, (1, 0, 2, 3))
    del tmp38
    t2new += tmp51
    t2new += np.transpose(tmp51, (1, 0, 3, 2))
    del tmp51
    t2new += tmp60 * -1
    t2new += np.transpose(tmp60, (1, 0, 3, 2)) * -1
    del tmp60
    t2new += np.transpose(tmp62, (0, 1, 3, 2))
    t2new += np.transpose(tmp62, (1, 0, 2, 3))
    del tmp62
    t2new += np.transpose(tmp68, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp68, (1, 0, 2, 3)) * -1
    del tmp68
    t2new += einsum(t1, (0, 1), tmp70, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp70
    t2new += einsum(t2, (0, 1, 2, 3), tmp71, (4, 1, 5, 2), (4, 0, 5, 3))
    del tmp71
    t2new += einsum(tmp72, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 5, 2)) * 4
    del tmp72
    t1new = np.copy(f.ov)
    t1new += einsum(tmp0, (0, 1, 2, 3), t2, (4, 0, 1, 2), (4, 3)) * 2
    del tmp0
    t1new += einsum(tmp2, (0, 1, 2, 3), t2, (1, 2, 4, 3), (0, 4)) * -2
    del tmp2
    t1new += einsum(tmp5, (0, 1), tmp6, (0, 2, 3, 1), (2, 3))
    del tmp5, tmp6
    t1new += einsum(t1, (0, 1), tmp7, (0, 2, 1, 3), (2, 3))
    del tmp7
    t1new += einsum(t1, (0, 1), tmp9, (1, 2), (0, 2))
    del tmp9
    t1new += einsum(t1, (0, 1), tmp14, (0, 2), (2, 1)) * -1
    del tmp14

    return {f"t1new": t1new, f"t2new": t2new}

