"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T16:47:36.491983
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:47:37.630643.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp3 = einsum(t1, (0, 1), v.xov, (2, 3, 1), (0, 3, 2))
    tmp1 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp1 += t2 * -1
    tmp0 = einsum(v.xov, (0, 1, 2), t1, (1, 2), (0,))
    tmp4 = np.copy(f.ov) * 2
    tmp4 += einsum(tmp3, (0, 1, 2), v.xov, (2, 0, 3), (1, 3)) * -1
    del tmp3
    tmp2 = einsum(t1, (0, 1), tmp0, (2,), (0, 1, 2))
    del tmp0
    tmp2 += einsum(v.xov, (0, 1, 2), tmp1, (1, 3, 4, 2), (3, 4, 0)) * 0.5
    del tmp1
    e_cc = einsum(v.xov, (0, 1, 2), tmp2, (1, 2, 0), ()) * 2
    del tmp2
    e_cc += einsum(tmp4, (0, 1), t1, (0, 1), ())
    del tmp4

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:47:46.694180.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    t1new : array
        Updated T1 residuals.
    t2new : array
        Updated T2 residuals.
    """

    tmp2 = einsum(t1, (0, 1), v.xov, (2, 3, 1), (0, 3, 2))
    tmp18 = einsum(v.xoo, (0, 1, 2), tmp2, (3, 4, 0), (3, 1, 2, 4))
    tmp6 = einsum(v.xoo, (0, 1, 2), t1, (2, 3), (1, 3, 0))
    tmp15 = einsum(v.xvv, (0, 1, 2), t1, (3, 2), (3, 1, 0))
    tmp28 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp26 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp31 = np.copy(np.transpose(v.xoo, (1, 2, 0)))
    tmp31 += np.transpose(tmp2, (1, 0, 2))
    tmp19 = einsum(tmp18, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    del tmp18
    tmp21 = np.copy(np.transpose(v.xov, (1, 2, 0))) * -1
    tmp21 += tmp6
    tmp9 = einsum(tmp2, (0, 1, 2), v.xov, (2, 0, 3), (1, 3))
    tmp0 = einsum(v.xov, (0, 1, 2), t1, (1, 2), (0,))
    tmp5 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp5 += t2 * -1
    tmp24 = einsum(tmp2, (0, 1, 2), tmp15, (3, 4, 2), (0, 3, 1, 4))
    tmp29 = einsum(t1, (0, 1), tmp28, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp28
    tmp27 = einsum(t2, (0, 1, 2, 3), tmp26, (1, 4), (4, 0, 2, 3))
    del tmp26
    tmp34 = einsum(v.xoo, (0, 1, 2), v.xoo, (0, 3, 4), (3, 1, 2, 4))
    tmp34 += einsum(tmp2, (0, 1, 2), tmp2, (3, 4, 2), (4, 0, 1, 3))
    tmp32 = einsum(tmp31, (0, 1, 2), v.xov, (2, 3, 4), (0, 1, 3, 4))
    del tmp31
    tmp20 = einsum(t1, (0, 1), tmp19, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp19
    tmp22 = einsum(tmp21, (0, 1, 2), tmp15, (3, 4, 2), (0, 3, 1, 4))
    del tmp21
    tmp17 = einsum(t2, (0, 1, 2, 3), f.vv, (4, 3), (0, 1, 4, 2))
    tmp7 = einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 0.5
    tmp7 += np.transpose(t2, (0, 1, 3, 2)) * -1
    tmp7 += t2 * 0.5
    tmp3 = np.copy(np.transpose(v.xoo, (1, 2, 0)))
    tmp3 += np.transpose(tmp2, (1, 0, 2))
    del tmp2
    tmp13 = np.copy(f.ov)
    tmp13 += tmp9 * -1
    tmp12 = np.copy(tmp6) * -1
    tmp12 += einsum(t1, (0, 1), tmp0, (2,), (0, 1, 2)) * 2
    tmp12 += einsum(v.xov, (0, 1, 2), tmp5, (1, 3, 4, 2), (3, 4, 0))
    tmp1 = einsum(v.xov, (0, 1, 2), tmp0, (0,), (1, 2))
    tmp25 = einsum(t1, (0, 1), tmp24, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp24
    tmp30 = np.copy(tmp27)
    del tmp27
    tmp30 += tmp29
    del tmp29
    tmp16 = einsum(t2, (0, 1, 2, 3), f.oo, (4, 1), (4, 0, 2, 3))
    tmp35 = einsum(t1, (0, 1), tmp34, (0, 2, 3, 4), (2, 4, 3, 1))
    del tmp34
    tmp33 = einsum(tmp32, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp32
    tmp23 = np.copy(tmp17)
    del tmp17
    tmp23 += tmp20
    del tmp20
    tmp23 += np.transpose(tmp22, (1, 0, 2, 3)) * -1
    del tmp22
    tmp8 = np.copy(tmp6) * 0.5
    del tmp6
    tmp8 += einsum(t1, (0, 1), tmp0, (2,), (0, 1, 2)) * -1
    tmp8 += einsum(v.xov, (0, 1, 2), tmp7, (1, 3, 4, 2), (3, 4, 0))
    del tmp7
    tmp4 = einsum(tmp3, (0, 1, 2), v.xov, (2, 3, 4), (1, 3, 0, 4))
    del tmp3
    tmp11 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp11 += t2 * -1
    tmp14 = np.copy(f.oo) * 0.5
    tmp14 += einsum(v.xoo, (0, 1, 2), tmp0, (0,), (1, 2))
    del tmp0
    tmp14 += einsum(v.xov, (0, 1, 2), tmp12, (3, 2, 0), (1, 3)) * 0.5
    del tmp12
    tmp14 += einsum(tmp13, (0, 1), t1, (2, 1), (0, 2)) * 0.5
    del tmp13
    tmp10 = np.copy(f.ov)
    tmp10 += tmp1 * 2
    tmp10 += tmp9 * -1
    del tmp9
    t2new = einsum(tmp15, (0, 1, 2), tmp15, (3, 4, 2), (3, 0, 4, 1))
    del tmp15
    t2new += einsum(v.xov, (0, 1, 2), v.xov, (0, 3, 4), (1, 3, 2, 4))
    t2new += np.transpose(tmp16, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp16, (1, 0, 2, 3)) * -1
    del tmp16
    t2new += np.transpose(tmp23, (0, 1, 3, 2))
    t2new += np.transpose(tmp23, (1, 0, 2, 3))
    del tmp23
    t2new += tmp25 * -1
    t2new += np.transpose(tmp25, (1, 0, 3, 2)) * -1
    del tmp25
    t2new += np.transpose(tmp30, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp30, (1, 0, 2, 3)) * -1
    del tmp30
    t2new += np.transpose(tmp33, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp33, (1, 0, 2, 3)) * -1
    del tmp33
    t2new += einsum(t1, (0, 1), tmp35, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp35
    t1new = np.copy(f.ov)
    t1new += tmp1 * 2
    del tmp1
    t1new += einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))
    t1new += einsum(tmp5, (0, 1, 2, 3), tmp4, (4, 0, 1, 3), (4, 2)) * -1
    del tmp5, tmp4
    t1new += einsum(tmp8, (0, 1, 2), v.xvv, (2, 3, 1), (0, 3)) * -2
    del tmp8
    t1new += einsum(tmp10, (0, 1), tmp11, (0, 2, 3, 1), (2, 3))
    del tmp10, tmp11
    t1new += einsum(tmp14, (0, 1), t1, (0, 2), (1, 2)) * -2
    del tmp14

    return {f"t1new": t1new, f"t2new": t2new}

def update_lams(f=None, l1=None, l2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:48:58.221724.

    Parameters
    ----------
    f : array
        Fock matrix.
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    l1new : array
        Updated L1 residuals.
    l2new : array
        Updated L2 residuals.
    """

    tmp13 = einsum(v.xov, (0, 1, 2), t1, (1, 2), (0,))
    tmp5 = einsum(t1, (0, 1), v.xov, (2, 3, 1), (0, 3, 2))
    tmp14 = einsum(tmp13, (0,), v.xov, (0, 1, 2), (1, 2))
    tmp15 = einsum(tmp5, (0, 1, 2), v.xov, (2, 0, 3), (1, 3))
    tmp33 = einsum(l2, (0, 1, 2, 3), t1, (4, 1), (2, 3, 4, 0))
    tmp0 = einsum(t1, (0, 1), v.xvv, (2, 3, 1), (0, 3, 2))
    tmp7 = einsum(v.xov, (0, 1, 2), v.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp97 = np.copy(tmp14) * 2
    tmp97 += tmp15 * -1
    tmp92 = np.copy(tmp33) * -1
    tmp92 += np.transpose(tmp33, (1, 0, 2, 3)) * 2
    tmp89 = np.copy(np.transpose(v.xov, (1, 2, 0)))
    tmp89 += tmp0
    tmp90 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * 2
    tmp90 += np.transpose(l2, (2, 3, 0, 1)) * -1
    tmp8 = einsum(tmp7, (0, 1, 2, 3), t2, (4, 5, 3, 2), (4, 5, 1, 0))
    tmp9 = einsum(tmp5, (0, 1, 2), tmp5, (3, 4, 2), (3, 0, 4, 1))
    tmp28 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -0.5
    tmp28 += t2
    tmp63 = einsum(v.xoo, (0, 1, 2), tmp5, (2, 3, 0), (1, 3))
    tmp98 = einsum(tmp97, (0, 1), t1, (2, 1), (2, 0))
    tmp93 = einsum(v.xoo, (0, 1, 2), tmp92, (1, 3, 2, 4), (3, 4, 0))
    tmp94 = einsum(tmp92, (0, 1, 2, 3), tmp5, (0, 2, 4), (1, 3, 4))
    del tmp92
    tmp91 = einsum(tmp90, (0, 1, 2, 3), tmp89, (0, 3, 4), (1, 2, 4))
    del tmp90, tmp89
    tmp80 = np.copy(np.transpose(v.xoo, (1, 2, 0)))
    tmp80 += np.transpose(tmp5, (1, 0, 2))
    tmp49 = einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    tmp21 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp21 += t2 * -1
    tmp3 = einsum(v.xvv, (0, 1, 2), v.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp10 = np.copy(tmp8)
    del tmp8
    tmp10 += tmp9
    tmp50 = einsum(tmp28, (0, 1, 2, 3), l2, (2, 3, 0, 4), (4, 1))
    tmp55 = einsum(tmp28, (0, 1, 2, 3), l2, (2, 3, 0, 4), (4, 1)) * 2
    tmp78 = einsum(tmp5, (0, 1, 2), v.xov, (2, 3, 4), (0, 3, 1, 4))
    tmp76 = einsum(v.xov, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp99 = np.copy(tmp63)
    tmp99 += tmp98 * -1
    del tmp98
    tmp65 = einsum(tmp13, (0,), v.xvv, (0, 1, 2), (1, 2))
    tmp95 = np.copy(tmp91)
    del tmp91
    tmp95 += tmp93 * -1
    del tmp93
    tmp95 += tmp94 * -1
    del tmp94
    tmp81 = einsum(v.xvv, (0, 1, 2), tmp80, (3, 4, 0), (3, 4, 1, 2))
    del tmp80
    tmp109 = einsum(v.xov, (0, 1, 2), tmp49, (3, 1), (3, 2, 0))
    tmp73 = einsum(v.xvv, (0, 1, 2), l1, (2, 3), (3, 1, 0))
    tmp25 = einsum(v.xoo, (0, 1, 2), tmp5, (3, 4, 0), (3, 1, 2, 4))
    tmp70 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp104 = einsum(v.xov, (0, 1, 2), tmp0, (1, 3, 0), (2, 3))
    tmp18 = np.copy(np.transpose(v.xoo, (1, 2, 0)))
    tmp18 += np.transpose(tmp5, (1, 0, 2))
    tmp16 = np.copy(tmp14) * 2
    tmp16 += tmp15 * -1
    tmp24 = einsum(v.xoo, (0, 1, 2), v.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp22 = einsum(v.xov, (0, 1, 2), tmp21, (1, 3, 4, 2), (3, 4, 0))
    tmp6 = einsum(tmp0, (0, 1, 2), tmp5, (3, 4, 2), (3, 0, 4, 1))
    tmp4 = einsum(t2, (0, 1, 2, 3), tmp3, (4, 3, 5, 2), (0, 1, 4, 5))
    tmp11 = einsum(tmp10, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4)) * 2
    del tmp10
    tmp20 = np.copy(np.transpose(t2, (0, 1, 3, 2)))
    tmp20 += t2 * -0.5
    tmp46 = einsum(tmp33, (0, 1, 2, 3), t1, (4, 3), (1, 0, 2, 4))
    tmp35 = np.copy(tmp33) * -0.5
    tmp35 += np.transpose(tmp33, (1, 0, 2, 3))
    tmp41 = einsum(t2, (0, 1, 2, 3), l1, (3, 4), (4, 0, 1, 2))
    tmp42 = np.copy(tmp33) * 2
    tmp42 += np.transpose(tmp33, (1, 0, 2, 3)) * -1
    tmp51 = np.copy(tmp49) * 0.5
    tmp51 += tmp50
    del tmp50
    tmp44 = einsum(t2, (0, 1, 2, 3), l2, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp58 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp58 += t2 * 2
    tmp56 = np.copy(tmp49)
    tmp56 += tmp55
    del tmp55
    tmp87 = einsum(tmp33, (0, 1, 2, 3), tmp78, (1, 2, 4, 5), (0, 4, 3, 5))
    tmp84 = einsum(tmp33, (0, 1, 2, 3), tmp76, (4, 1, 2, 5), (0, 4, 3, 5))
    tmp100 = einsum(tmp99, (0, 1), l2, (2, 3, 0, 4), (4, 1, 2, 3))
    del tmp99
    tmp101 = einsum(tmp33, (0, 1, 2, 3), tmp97, (2, 4), (0, 1, 3, 4))
    tmp85 = einsum(l2, (0, 1, 2, 3), tmp65, (4, 1), (2, 3, 0, 4))
    tmp96 = einsum(v.xov, (0, 1, 2), tmp95, (3, 4, 0), (1, 3, 2, 4))
    del tmp95
    tmp88 = einsum(tmp81, (0, 1, 2, 3), l2, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp86 = einsum(tmp33, (0, 1, 2, 3), tmp3, (2, 4, 3, 5), (1, 0, 5, 4))
    del tmp3
    tmp110 = einsum(tmp109, (0, 1, 2), v.xov, (2, 3, 4), (0, 3, 4, 1))
    del tmp109
    tmp108 = einsum(l1, (0, 1), tmp78, (1, 2, 3, 4), (2, 3, 0, 4))
    tmp62 = einsum(tmp13, (0,), v.xoo, (0, 1, 2), (1, 2))
    del tmp13
    tmp79 = einsum(tmp78, (0, 1, 2, 3), tmp33, (0, 4, 1, 5), (4, 2, 5, 3))
    del tmp78
    tmp77 = einsum(tmp76, (0, 1, 2, 3), tmp33, (1, 4, 2, 5), (4, 0, 5, 3))
    tmp74 = einsum(v.xov, (0, 1, 2), tmp73, (3, 4, 0), (3, 1, 2, 4))
    del tmp73
    tmp75 = einsum(l2, (0, 1, 2, 3), tmp25, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp69 = einsum(l2, (0, 1, 2, 3), f.vv, (4, 1), (2, 3, 4, 0))
    tmp72 = einsum(tmp33, (0, 1, 2, 3), f.ov, (2, 4), (0, 1, 4, 3))
    tmp82 = einsum(l2, (0, 1, 2, 3), tmp81, (4, 2, 5, 1), (3, 4, 0, 5))
    del tmp81
    tmp71 = einsum(tmp70, (0, 1), l2, (2, 3, 4, 1), (0, 4, 2, 3))
    del tmp70
    tmp105 = einsum(tmp104, (0, 1), l2, (2, 1, 3, 4), (3, 4, 2, 0))
    del tmp104
    tmp103 = einsum(l1, (0, 1), tmp76, (2, 1, 3, 4), (2, 3, 0, 4))
    del tmp76
    tmp19 = einsum(v.xov, (0, 1, 2), tmp18, (3, 4, 0), (1, 3, 4, 2))
    tmp17 = einsum(tmp16, (0, 1), t2, (2, 3, 1, 4), (2, 3, 0, 4))
    del tmp16
    tmp2 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp1 = einsum(v.xoo, (0, 1, 2), tmp0, (3, 4, 0), (3, 1, 2, 4))
    tmp26 = np.copy(np.transpose(tmp24, (3, 2, 1, 0)))
    tmp26 += np.transpose(tmp25, (1, 0, 3, 2))
    tmp26 += np.transpose(tmp25, (3, 0, 2, 1)) * -0.5
    tmp23 = np.copy(np.transpose(v.xov, (1, 2, 0)))
    tmp23 += tmp22
    tmp12 = np.copy(tmp4) * 2
    del tmp4
    tmp12 += tmp6 * 2
    del tmp6
    tmp12 += tmp11 * -1
    del tmp11
    tmp29 = np.copy(np.transpose(tmp24, (3, 2, 1, 0))) * 0.5
    tmp29 += np.transpose(tmp25, (1, 0, 3, 2)) * 0.5
    tmp29 += np.transpose(tmp25, (3, 0, 2, 1)) * -1
    del tmp25
    tmp61 = np.copy(f.ov)
    tmp61 += tmp14 * 2
    del tmp14
    tmp61 += tmp15 * -1
    del tmp15
    tmp34 = np.copy(tmp33) * -1
    tmp34 += np.transpose(tmp33, (1, 0, 2, 3)) * 2
    tmp37 = np.copy(np.transpose(v.xoo, (1, 2, 0)))
    tmp37 += tmp5
    tmp32 = np.copy(np.transpose(l2, (3, 2, 0, 1)))
    tmp32 += np.transpose(l2, (2, 3, 0, 1)) * -0.5
    tmp36 = einsum(l2, (0, 1, 2, 3), tmp20, (2, 3, 1, 4), (0, 4)) * 2
    tmp31 = np.copy(np.transpose(v.xov, (1, 2, 0)))
    tmp31 += tmp0
    tmp31 += tmp22
    tmp48 = np.copy(tmp46) * -0.5
    tmp48 += np.transpose(tmp46, (0, 1, 3, 2))
    tmp43 = np.copy(tmp41) * -1
    tmp43 += np.transpose(tmp41, (0, 2, 1, 3)) * 0.5
    del tmp41
    tmp43 += einsum(t2, (0, 1, 2, 3), tmp42, (1, 4, 5, 3), (4, 5, 0, 2)) * 0.5
    del tmp42
    tmp43 += einsum(tmp35, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 2, 4, 5))
    tmp39 = einsum(l2, (0, 1, 2, 3), tmp21, (2, 4, 1, 5), (3, 4, 0, 5))
    tmp39 += einsum(tmp28, (0, 1, 2, 3), l2, (4, 2, 5, 0), (5, 1, 4, 3)) * 2
    tmp52 = np.copy(t1) * -0.5
    tmp52 += einsum(tmp33, (0, 1, 2, 3), tmp20, (0, 1, 4, 3), (2, 4))
    tmp52 += einsum(l1, (0, 1), tmp21, (1, 2, 3, 0), (2, 3)) * -0.5
    tmp52 += einsum(tmp51, (0, 1), t1, (0, 2), (1, 2))
    tmp47 = np.copy(tmp46) * 2
    tmp47 += np.transpose(tmp46, (0, 1, 3, 2)) * -1
    tmp45 = np.copy(np.transpose(tmp44, (1, 0, 2, 3))) * -0.5
    tmp45 += np.transpose(tmp44, (1, 0, 3, 2))
    del tmp44
    tmp40 = np.copy(tmp33)
    tmp40 += np.transpose(tmp33, (1, 0, 2, 3)) * -0.5
    tmp54 = einsum(l1, (0, 1), t1, (1, 2), (0, 2)) * 0.5
    tmp54 += einsum(l2, (0, 1, 2, 3), tmp20, (2, 3, 1, 4), (0, 4))
    tmp59 = np.copy(tmp49)
    del tmp49
    tmp59 += einsum(l2, (0, 1, 2, 3), tmp58, (2, 4, 0, 1), (4, 3))
    del tmp58
    tmp57 = np.copy(np.transpose(l1, (1, 0)))
    tmp57 += t1
    tmp57 += einsum(tmp33, (0, 1, 2, 3), tmp21, (0, 1, 4, 3), (2, 4)) * -1
    del tmp33, tmp21
    tmp57 += einsum(l1, (0, 1), tmp20, (1, 2, 3, 0), (2, 3)) * 2
    tmp57 += einsum(tmp56, (0, 1), t1, (0, 2), (1, 2)) * -1
    tmp68 = einsum(l2, (0, 1, 2, 3), f.oo, (4, 3), (4, 2, 0, 1))
    tmp112 = np.copy(np.transpose(tmp24, (3, 2, 1, 0)))
    del tmp24
    tmp112 += np.transpose(tmp9, (0, 3, 1, 2))
    del tmp9
    tmp102 = einsum(l1, (0, 1), f.ov, (2, 3), (2, 1, 3, 0))
    tmp102 += tmp84
    del tmp84
    tmp102 += tmp85 * 2
    del tmp85
    tmp102 += tmp86 * -1
    del tmp86
    tmp102 += tmp87
    del tmp87
    tmp102 += tmp88 * -1
    del tmp88
    tmp102 += np.transpose(tmp96, (1, 0, 3, 2))
    del tmp96
    tmp102 += np.transpose(tmp100, (0, 1, 3, 2))
    del tmp100
    tmp102 += tmp101 * -1
    del tmp101
    tmp102 += einsum(l1, (0, 1), tmp97, (2, 3), (1, 2, 0, 3))
    del tmp97
    tmp67 = einsum(v.xvv, (0, 1, 2), v.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp111 = np.copy(tmp108)
    del tmp108
    tmp111 += tmp110
    del tmp110
    tmp107 = einsum(l2, (0, 1, 2, 3), tmp62, (4, 3), (2, 4, 0, 1))
    tmp83 = np.copy(tmp69)
    del tmp69
    tmp83 += tmp71 * -1
    del tmp71
    tmp83 += tmp72 * -1
    del tmp72
    tmp83 += tmp74
    del tmp74
    tmp83 += tmp75
    del tmp75
    tmp83 += tmp77
    del tmp77
    tmp83 += tmp79
    del tmp79
    tmp83 += tmp82 * -1
    del tmp82
    tmp106 = np.copy(tmp103)
    del tmp103
    tmp106 += tmp105
    del tmp105
    tmp66 = np.copy(f.vv)
    tmp66 += np.transpose(tmp65, (1, 0)) * 2
    del tmp65
    tmp27 = np.copy(np.transpose(tmp1, (0, 2, 1, 3)))
    tmp27 += np.transpose(tmp2, (1, 0, 2, 3))
    tmp27 += np.transpose(tmp2, (2, 0, 1, 3)) * -2
    del tmp2
    tmp27 += np.transpose(tmp12, (0, 2, 1, 3)) * -1
    tmp27 += np.transpose(tmp12, (1, 2, 0, 3)) * 0.5
    del tmp12
    tmp27 += np.transpose(tmp17, (1, 2, 0, 3))
    tmp27 += np.transpose(tmp17, (0, 2, 1, 3)) * -2
    del tmp17
    tmp27 += einsum(tmp19, (0, 1, 2, 3), tmp20, (1, 4, 5, 3), (2, 0, 4, 5)) * 2
    del tmp20
    tmp27 += einsum(tmp18, (0, 1, 2), tmp23, (3, 4, 2), (1, 0, 3, 4)) * -2
    tmp27 += einsum(tmp26, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4)) * 2
    del tmp26
    tmp30 = np.copy(np.transpose(tmp1, (0, 2, 1, 3))) * -1
    del tmp1
    tmp30 += einsum(tmp19, (0, 1, 2, 3), tmp28, (1, 4, 5, 3), (2, 0, 4, 5))
    del tmp28, tmp19
    tmp30 += einsum(tmp18, (0, 1, 2), tmp23, (3, 4, 2), (1, 0, 3, 4)) * 0.5
    del tmp23
    tmp30 += einsum(t1, (0, 1), tmp29, (0, 2, 3, 4), (2, 3, 4, 1)) * -1
    del tmp29
    tmp64 = np.copy(f.oo)
    tmp64 += np.transpose(tmp62, (1, 0)) * 2
    del tmp62
    tmp64 += tmp63 * -1
    del tmp63
    tmp64 += einsum(tmp22, (0, 1, 2), v.xov, (2, 3, 1), (0, 3))
    del tmp22
    tmp64 += einsum(t1, (0, 1), tmp61, (2, 1), (0, 2))
    tmp38 = einsum(tmp32, (0, 1, 2, 3), tmp31, (0, 3, 4), (1, 2, 4)) * -1
    del tmp32
    tmp38 += einsum(tmp34, (0, 1, 2, 3), v.xoo, (4, 0, 2), (1, 3, 4)) * 0.5
    del tmp34
    tmp38 += einsum(tmp5, (0, 1, 2), tmp35, (0, 3, 1, 4), (3, 4, 2))
    del tmp35
    tmp38 += einsum(v.xov, (0, 1, 2), tmp36, (3, 2), (1, 3, 0)) * 0.5
    del tmp36
    tmp38 += einsum(l1, (0, 1), tmp37, (1, 2, 3), (2, 0, 3)) * 0.5
    del tmp37
    tmp53 = einsum(l1, (0, 1), tmp0, (2, 0, 3), (2, 1, 3)) * -0.5
    del tmp0
    tmp53 += einsum(v.xvv, (0, 1, 2), tmp39, (3, 4, 2, 1), (4, 3, 0)) * -0.5
    del tmp39
    tmp53 += einsum(tmp31, (0, 1, 2), tmp40, (0, 3, 4, 1), (4, 3, 2)) * -1
    del tmp31, tmp40
    tmp53 += einsum(v.xov, (0, 1, 2), tmp43, (3, 1, 4, 2), (4, 3, 0))
    del tmp43
    tmp53 += einsum(tmp18, (0, 1, 2), tmp45, (1, 3, 0, 4), (4, 3, 2))
    del tmp18, tmp45
    tmp53 += einsum(tmp47, (0, 1, 2, 3), tmp5, (0, 2, 4), (3, 1, 4)) * 0.5
    del tmp5, tmp47
    tmp53 += einsum(tmp48, (0, 1, 2, 3), v.xoo, (4, 0, 3), (2, 1, 4))
    del tmp48
    tmp53 += einsum(tmp52, (0, 1), v.xov, (2, 3, 1), (0, 3, 2))
    del tmp52
    tmp53 += einsum(tmp51, (0, 1), v.xoo, (2, 3, 0), (1, 3, 2))
    del tmp51
    tmp60 = einsum(tmp54, (0, 1), v.xvv, (2, 1, 0), (2,)) * 2
    del tmp54
    tmp60 += einsum(v.xov, (0, 1, 2), tmp57, (1, 2), (0,))
    del tmp57
    tmp60 += einsum(tmp59, (0, 1), v.xoo, (2, 1, 0), (2,)) * -1
    del tmp59
    l2new = einsum(tmp67, (0, 1, 2, 3), l2, (3, 2, 4, 5), (0, 1, 4, 5))
    del tmp67
    l2new += einsum(tmp46, (0, 1, 2, 3), tmp7, (2, 3, 4, 5), (5, 4, 1, 0))
    del tmp46
    l2new += np.transpose(tmp7, (3, 2, 1, 0))
    del tmp7
    l2new += np.transpose(tmp68, (3, 2, 0, 1)) * -1
    l2new += np.transpose(tmp68, (2, 3, 1, 0)) * -1
    del tmp68
    l2new += np.transpose(tmp83, (3, 2, 0, 1))
    l2new += np.transpose(tmp83, (2, 3, 1, 0))
    del tmp83
    l2new += np.transpose(tmp102, (2, 3, 0, 1))
    l2new += np.transpose(tmp102, (3, 2, 1, 0))
    del tmp102
    l2new += np.transpose(tmp106, (2, 3, 0, 1)) * -1
    l2new += np.transpose(tmp106, (3, 2, 1, 0)) * -1
    del tmp106
    l2new += np.transpose(tmp107, (2, 3, 0, 1)) * -2
    l2new += np.transpose(tmp107, (3, 2, 1, 0)) * -2
    del tmp107
    l2new += np.transpose(tmp111, (3, 2, 0, 1)) * -1
    l2new += np.transpose(tmp111, (2, 3, 1, 0)) * -1
    del tmp111
    l2new += einsum(tmp112, (0, 1, 2, 3), l2, (4, 5, 2, 0), (4, 5, 1, 3))
    del tmp112
    l1new = np.copy(np.transpose(f.ov, (1, 0)))
    l1new += einsum(tmp27, (0, 1, 2, 3), l2, (4, 3, 0, 2), (4, 1))
    del tmp27
    l1new += einsum(l2, (0, 1, 2, 3), tmp30, (3, 4, 2, 1), (0, 4)) * 2
    del tmp30
    l1new += einsum(tmp38, (0, 1, 2), v.xvv, (2, 3, 1), (3, 0)) * -2
    del tmp38
    l1new += einsum(tmp53, (0, 1, 2), v.xov, (2, 0, 3), (3, 1)) * 2
    del tmp53
    l1new += einsum(v.xov, (0, 1, 2), tmp60, (0,), (2, 1)) * 2
    del tmp60
    l1new += einsum(tmp56, (0, 1), tmp61, (1, 2), (2, 0)) * -1
    del tmp56, tmp61
    l1new += einsum(tmp64, (0, 1), l1, (2, 0), (2, 1)) * -1
    del tmp64
    l1new += einsum(l1, (0, 1), tmp66, (0, 2), (2, 1))
    del tmp66

    return {f"l1new": l1new, f"l2new": l2new}

def make_rdm1_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:48:59.806842.

    Parameters
    ----------
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.

    Returns
    -------
    rdm1 : array
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    delta = Namespace(
        oo=np.eye(t2.shape[0]),
        vv=np.eye(t2.shape[-1]),
    )
    tmp2 = einsum(l2, (0, 1, 2, 3), t1, (4, 1), (2, 3, 4, 0))
    tmp1 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -0.5
    tmp1 += t2
    tmp0 = einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    tmp6 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * -1
    tmp6 += np.transpose(l2, (2, 3, 0, 1)) * 2
    tmp4 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp4 += t2 * -1
    tmp3 = np.copy(tmp2) * -0.5
    tmp3 += np.transpose(tmp2, (1, 0, 2, 3))
    del tmp2
    tmp5 = np.copy(tmp0)
    tmp5 += einsum(l2, (0, 1, 2, 3), tmp1, (2, 4, 0, 1), (3, 4)) * 2
    rdm1.vv = einsum(l1, (0, 1), t1, (1, 2), (0, 2)) * 2
    rdm1.vv += einsum(tmp6, (0, 1, 2, 3), t2, (0, 1, 2, 4), (3, 4)) * 2
    del tmp6
    rdm1.vo = np.copy(l1) * 2
    rdm1.ov = np.copy(t1) * 2
    rdm1.ov += einsum(tmp3, (0, 1, 2, 3), t2, (1, 0, 3, 4), (2, 4)) * -4
    del tmp3
    rdm1.ov += einsum(l1, (0, 1), tmp4, (1, 2, 3, 0), (2, 3)) * 2
    del tmp4
    rdm1.ov += einsum(tmp5, (0, 1), t1, (0, 2), (1, 2)) * -2
    del tmp5
    rdm1.oo = np.copy(np.transpose(tmp0, (1, 0))) * -2
    del tmp0
    rdm1.oo += delta.oo * 2
    del delta
    rdm1.oo += einsum(l2, (0, 1, 2, 3), tmp1, (2, 4, 0, 1), (4, 3)) * -4
    del tmp1
    rdm1 = np.block([[rdm1.oo, rdm1.ov], [rdm1.vo, rdm1.vv]])

    return rdm1

def make_rdm2_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:50:15.681589.

    Parameters
    ----------
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.

    Returns
    -------
    rdm2 : array
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    delta = Namespace(
        oo=np.eye(t2.shape[0]),
        vv=np.eye(t2.shape[-1]),
    )
    tmp4 = einsum(l2, (0, 1, 2, 3), t1, (4, 1), (2, 3, 4, 0))
    tmp80 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp80 += t2 * 2
    tmp78 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp78 += t2
    tmp14 = np.copy(tmp4)
    tmp14 += np.transpose(tmp4, (1, 0, 2, 3)) * -1
    tmp16 = np.copy(tmp4) * 2
    tmp16 += np.transpose(tmp4, (1, 0, 2, 3)) * -1
    tmp0 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -0.5
    tmp0 += t2
    tmp45 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * 2
    tmp45 += np.transpose(l2, (2, 3, 0, 1)) * -1
    tmp81 = einsum(l2, (0, 1, 2, 3), tmp80, (3, 4, 1, 5), (4, 2, 5, 0))
    del tmp80
    tmp87 = einsum(tmp4, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    tmp79 = einsum(l2, (0, 1, 2, 3), tmp78, (2, 4, 1, 5), (4, 3, 5, 0))
    del tmp78
    tmp61 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * -1
    tmp61 += np.transpose(l2, (2, 3, 0, 1)) * 2
    tmp101 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * 2
    tmp101 += np.transpose(l2, (2, 3, 0, 1)) * -1
    tmp15 = einsum(tmp14, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 2, 4, 5))
    tmp17 = einsum(tmp16, (0, 1, 2, 3), t2, (4, 0, 5, 3), (1, 2, 4, 5))
    del tmp16
    tmp12 = einsum(t2, (0, 1, 2, 3), l1, (3, 4), (4, 0, 1, 2))
    tmp2 = einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    tmp22 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp22 += t2 * -1
    tmp26 = einsum(tmp4, (0, 1, 2, 3), t2, (4, 1, 3, 5), (0, 2, 4, 5))
    tmp3 = einsum(l2, (0, 1, 2, 3), t2, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp5 = einsum(t1, (0, 1), tmp4, (2, 3, 4, 1), (3, 2, 4, 0))
    tmp8 = np.copy(tmp4) * -1
    tmp8 += np.transpose(tmp4, (1, 0, 2, 3)) * 2
    tmp1 = einsum(l2, (0, 1, 2, 3), tmp0, (2, 4, 0, 1), (3, 4)) * 2
    tmp54 = np.copy(np.transpose(l2, (3, 2, 0, 1)))
    tmp54 += np.transpose(l2, (2, 3, 0, 1)) * -1
    tmp25 = einsum(tmp4, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 2, 4, 5))
    tmp33 = einsum(l2, (0, 1, 2, 3), tmp0, (2, 4, 0, 1), (3, 4))
    del tmp0
    tmp111 = einsum(l2, (0, 1, 2, 3), t1, (3, 4), (2, 0, 1, 4))
    tmp66 = einsum(l2, (0, 1, 2, 3), t2, (4, 3, 1, 5), (2, 4, 0, 5))
    tmp52 = einsum(tmp45, (0, 1, 2, 3), t2, (4, 0, 5, 3), (1, 4, 2, 5))
    tmp105 = np.copy(tmp87)
    tmp105 += np.transpose(tmp79, (1, 0, 3, 2))
    tmp105 += np.transpose(tmp81, (1, 0, 3, 2)) * -1
    tmp89 = einsum(tmp61, (0, 1, 2, 3), t2, (0, 1, 2, 4), (3, 4))
    tmp84 = einsum(l1, (0, 1), t1, (1, 2), (0, 2))
    tmp94 = np.copy(np.transpose(tmp81, (1, 0, 3, 2)))
    tmp94 += np.transpose(tmp79, (1, 0, 3, 2)) * -1
    tmp102 = einsum(tmp101, (0, 1, 2, 3), t2, (4, 0, 5, 3), (1, 4, 2, 5))
    del tmp101
    tmp48 = np.copy(tmp12)
    tmp48 += tmp15
    tmp48 += tmp17 * -1
    tmp21 = einsum(tmp2, (0, 1), t1, (0, 2), (1, 2))
    tmp23 = einsum(l1, (0, 1), tmp22, (1, 2, 3, 0), (2, 3))
    del tmp22
    tmp46 = einsum(tmp45, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 4, 2, 5))
    del tmp45
    tmp73 = np.copy(tmp12)
    tmp73 += tmp26 * -1
    tmp6 = np.copy(np.transpose(tmp3, (1, 0, 3, 2)))
    tmp6 += tmp5
    tmp9 = einsum(tmp8, (0, 1, 2, 3), t2, (0, 1, 4, 3), (2, 4)) * 0.5
    tmp10 = einsum(tmp1, (0, 1), t1, (0, 2), (1, 2)) * 0.5
    tmp62 = einsum(tmp61, (0, 1, 2, 3), t2, (0, 1, 2, 4), (3, 4)) * 0.5
    del tmp61
    tmp19 = einsum(t1, (0, 1), tmp3, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp13 = einsum(t1, (0, 1), tmp5, (0, 2, 3, 4), (2, 4, 3, 1))
    tmp55 = einsum(tmp54, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 4, 2, 5))
    del tmp54
    tmp70 = np.copy(tmp25)
    tmp70 += tmp17 * -1
    tmp34 = np.copy(tmp2) * 0.5
    tmp34 += tmp33
    del tmp33
    tmp31 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp31 += t2 * -1
    tmp112 = einsum(l2, (0, 1, 2, 3), t2, (3, 2, 4, 5), (0, 1, 5, 4))
    tmp113 = einsum(t1, (0, 1), tmp111, (0, 2, 3, 4), (3, 2, 4, 1))
    tmp109 = np.copy(tmp66)
    tmp109 += tmp87
    tmp109 += tmp52 * -1
    tmp68 = einsum(l2, (0, 1, 2, 3), t2, (4, 2, 1, 5), (3, 4, 0, 5))
    tmp93 = einsum(t2, (0, 1, 2, 3), l1, (4, 1), (0, 4, 2, 3))
    tmp106 = einsum(tmp105, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp105
    tmp90 = np.copy(tmp84)
    tmp90 += tmp89
    del tmp89
    tmp97 = einsum(tmp4, (0, 1, 2, 3), t2, (0, 1, 4, 5), (2, 3, 4, 5))
    tmp95 = einsum(tmp94, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp94
    tmp103 = np.copy(tmp66)
    tmp103 += tmp87
    tmp103 += tmp102 * -1
    del tmp102
    tmp91 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * -1
    tmp91 += np.transpose(l2, (2, 3, 0, 1))
    tmp82 = np.copy(tmp4) * -1
    tmp82 += np.transpose(tmp4, (1, 0, 2, 3))
    tmp49 = einsum(tmp48, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp48
    tmp24 = np.copy(tmp21)
    tmp24 += tmp23 * -1
    tmp44 = einsum(t2, (0, 1, 2, 3), tmp2, (1, 4), (4, 0, 2, 3))
    tmp47 = einsum(tmp46, (0, 1, 2, 3), t2, (4, 0, 5, 2), (1, 4, 3, 5))
    del tmp46
    tmp74 = einsum(tmp73, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp73
    tmp29 = einsum(t1, (0, 1), tmp6, (0, 2, 3, 4), (2, 3, 4, 1))
    tmp11 = np.copy(tmp9)
    tmp11 += tmp10
    del tmp10
    tmp63 = einsum(tmp62, (0, 1), t2, (2, 3, 0, 4), (2, 3, 1, 4)) * 2
    tmp64 = einsum(t2, (0, 1, 2, 3), tmp1, (1, 4), (0, 4, 3, 2))
    tmp58 = einsum(t1, (0, 1), tmp19, (0, 2, 3, 4), (3, 2, 4, 1))
    tmp59 = einsum(t2, (0, 1, 2, 3), tmp6, (0, 1, 4, 5), (4, 5, 2, 3))
    tmp53 = einsum(tmp52, (0, 1, 2, 3), t2, (4, 0, 5, 2), (1, 4, 3, 5))
    tmp51 = einsum(t1, (0, 1), tmp13, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp56 = einsum(tmp55, (0, 1, 2, 3), t2, (4, 0, 2, 5), (1, 4, 3, 5))
    tmp71 = einsum(t1, (0, 1), tmp70, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp70
    tmp35 = einsum(tmp34, (0, 1), t1, (0, 2), (1, 2)) * 2
    tmp30 = einsum(tmp8, (0, 1, 2, 3), t2, (0, 1, 4, 3), (2, 4))
    del tmp8
    tmp41 = einsum(tmp34, (0, 1), t1, (0, 2), (1, 2))
    tmp40 = einsum(l1, (0, 1), tmp31, (1, 2, 3, 0), (2, 3)) * 0.5
    tmp32 = einsum(l1, (0, 1), tmp31, (1, 2, 3, 0), (2, 3))
    del tmp31
    tmp27 = np.copy(tmp4) * -1
    tmp27 += np.transpose(tmp4, (1, 0, 2, 3)) * 2
    tmp114 = np.copy(np.transpose(tmp112, (1, 0, 3, 2)))
    tmp114 += np.transpose(tmp113, (1, 0, 3, 2))
    tmp110 = einsum(tmp109, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp109
    tmp100 = einsum(t1, (0, 1), tmp68, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp107 = np.copy(tmp93)
    tmp107 += np.transpose(tmp106, (0, 1, 3, 2))
    del tmp106
    tmp108 = np.copy(tmp97)
    tmp108 += einsum(tmp90, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    tmp98 = np.copy(tmp97)
    tmp98 += einsum(tmp62, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    tmp85 = np.copy(tmp84) * 0.5
    tmp85 += tmp62
    del tmp62
    tmp99 = einsum(t1, (0, 1), tmp87, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp96 = np.copy(tmp93)
    tmp96 += einsum(t1, (0, 1), tmp84, (2, 3), (0, 2, 1, 3))
    del tmp84
    tmp96 += np.transpose(tmp95, (0, 1, 3, 2)) * -1
    del tmp95
    tmp104 = einsum(tmp103, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp103
    tmp92 = einsum(tmp91, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 4, 2, 5))
    del tmp91
    tmp88 = einsum(tmp14, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp14
    tmp86 = einsum(tmp4, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    tmp83 = einsum(t1, (0, 1), tmp82, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp82
    tmp50 = np.copy(tmp44)
    tmp50 += np.transpose(tmp47, (1, 0, 3, 2)) * -1
    tmp50 += np.transpose(tmp49, (0, 1, 3, 2))
    del tmp49
    tmp50 += einsum(tmp24, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * -1
    tmp77 = np.copy(t1)
    tmp77 += tmp21 * -1
    tmp67 = einsum(tmp66, (0, 1, 2, 3), t2, (4, 0, 2, 5), (1, 4, 3, 5))
    tmp75 = np.copy(tmp44)
    del tmp44
    tmp75 += np.transpose(tmp74, (0, 1, 3, 2))
    del tmp74
    tmp76 = einsum(tmp29, (0, 1, 2, 3), t1, (0, 4), (2, 1, 3, 4))
    tmp65 = np.copy(np.transpose(tmp63, (1, 0, 3, 2)))
    del tmp63
    tmp65 += np.transpose(tmp64, (0, 1, 3, 2))
    del tmp64
    tmp65 += einsum(t1, (0, 1), tmp11, (2, 3), (0, 2, 1, 3)) * 2
    tmp69 = einsum(tmp68, (0, 1, 2, 3), t2, (4, 0, 2, 5), (1, 4, 3, 5))
    tmp60 = np.copy(tmp58)
    del tmp58
    tmp60 += tmp59
    tmp57 = np.copy(tmp51)
    del tmp51
    tmp57 += tmp53 * 2
    tmp57 += np.transpose(tmp56, (1, 0, 3, 2))
    del tmp56
    tmp72 = np.copy(np.transpose(tmp47, (1, 0, 3, 2))) * -1
    del tmp47
    tmp72 += np.transpose(tmp71, (0, 1, 3, 2))
    del tmp71
    tmp72 += einsum(tmp23, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    tmp43 = np.copy(tmp2)
    tmp43 += tmp1
    tmp37 = np.copy(tmp30)
    tmp37 += tmp35
    tmp39 = np.copy(tmp12)
    tmp39 += np.transpose(tmp29, (0, 2, 1, 3))
    tmp39 += einsum(tmp1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp38 = einsum(tmp2, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp38 += tmp15
    tmp38 += tmp17 * -1
    tmp42 = np.copy(t1) * -0.5
    tmp42 += tmp9
    del tmp9
    tmp42 += tmp40 * -1
    del tmp40
    tmp42 += tmp41
    del tmp41
    tmp18 = np.copy(tmp12)
    tmp18 += tmp13
    del tmp13
    tmp18 += tmp15
    del tmp15
    tmp18 += tmp17 * -1
    tmp20 = np.copy(tmp19)
    del tmp19
    tmp20 += einsum(tmp1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp36 = np.copy(t1) * -1
    tmp36 += tmp30
    del tmp30
    tmp36 += tmp32 * -1
    del tmp32
    tmp36 += tmp35
    del tmp35
    tmp28 = einsum(tmp27, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 2, 4, 5))
    del tmp27
    tmp7 = np.copy(delta.oo)
    tmp7 += tmp2 * -1
    rdm2.vvvv = np.copy(np.transpose(tmp114, (0, 1, 3, 2))) * -2
    rdm2.vvvv += tmp114 * 2
    del tmp114
    rdm2.vvvv += np.transpose(tmp112, (1, 0, 3, 2)) * 2
    del tmp112
    rdm2.vvvv += np.transpose(tmp113, (1, 0, 3, 2)) * 2
    del tmp113
    rdm2.vvvo = np.copy(np.transpose(tmp111, (1, 2, 3, 0))) * -2
    rdm2.vvvo += np.transpose(tmp111, (2, 1, 3, 0)) * 4
    rdm2.vvov = np.copy(np.transpose(tmp111, (1, 2, 0, 3))) * 4
    rdm2.vvov += np.transpose(tmp111, (2, 1, 0, 3)) * -2
    del tmp111
    rdm2.vovv = np.copy(np.transpose(tmp107, (1, 0, 2, 3))) * -2
    rdm2.vovv += np.transpose(tmp107, (1, 0, 3, 2)) * 2
    del tmp107
    rdm2.vovv += np.transpose(tmp108, (1, 0, 2, 3)) * -2
    rdm2.vovv += np.transpose(tmp108, (1, 0, 3, 2)) * 2
    del tmp108
    rdm2.vovv += np.transpose(tmp100, (1, 0, 3, 2)) * -2
    rdm2.vovv += np.transpose(tmp97, (1, 0, 2, 3)) * -2
    rdm2.vovv += np.transpose(tmp93, (1, 0, 3, 2)) * 2
    rdm2.vovv += np.transpose(tmp110, (1, 0, 3, 2)) * -2
    del tmp110
    rdm2.vovv += einsum(t1, (0, 1), tmp90, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.ovvv = np.copy(tmp96) * 2
    rdm2.ovvv += np.transpose(tmp96, (0, 1, 3, 2)) * -2
    del tmp96
    rdm2.ovvv += tmp98 * 2
    rdm2.ovvv += np.transpose(tmp98, (0, 1, 3, 2)) * -2
    del tmp98
    rdm2.ovvv += tmp99 * 2
    rdm2.ovvv += np.transpose(tmp99, (0, 1, 3, 2)) * -2
    del tmp99
    rdm2.ovvv += np.transpose(tmp97, (0, 1, 3, 2)) * -2
    del tmp97
    rdm2.ovvv += tmp100 * -2
    del tmp100
    rdm2.ovvv += tmp93 * 2
    del tmp93
    rdm2.ovvv += tmp104 * -2
    del tmp104
    rdm2.ovvv += einsum(tmp85, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 4
    rdm2.vvoo = np.copy(np.transpose(l2, (0, 1, 3, 2))) * -2
    rdm2.vvoo += l2 * 4
    rdm2.vovo = einsum(l1, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.vovo += np.transpose(tmp52, (2, 1, 3, 0)) * -2
    rdm2.vovo += np.transpose(tmp92, (2, 1, 3, 0)) * -2
    del tmp92
    rdm2.vovo += np.transpose(tmp88, (2, 1, 3, 0)) * -2
    rdm2.vovo += einsum(tmp90, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * 4
    rdm2.vovo += np.transpose(tmp68, (2, 1, 3, 0)) * -2
    rdm2.vovo += np.transpose(tmp86, (2, 1, 3, 0)) * -2
    rdm2.voov = einsum(l1, (0, 1), t1, (2, 3), (0, 2, 1, 3)) * 4
    rdm2.voov += np.transpose(tmp81, (3, 0, 1, 2)) * 2
    rdm2.voov += np.transpose(tmp79, (3, 0, 1, 2)) * -2
    rdm2.voov += np.transpose(tmp88, (2, 1, 0, 3)) * 2
    del tmp88
    rdm2.voov += einsum(tmp90, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -2
    del tmp90
    rdm2.voov += np.transpose(tmp66, (2, 1, 0, 3)) * -2
    rdm2.voov += np.transpose(tmp87, (2, 1, 0, 3)) * -2
    rdm2.voov += np.transpose(tmp52, (2, 1, 0, 3)) * 2
    rdm2.ovvo = einsum(l1, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 4
    rdm2.ovvo += np.transpose(tmp52, (1, 2, 3, 0)) * 4
    del tmp52
    rdm2.ovvo += np.transpose(tmp55, (1, 2, 3, 0)) * -2
    del tmp55
    rdm2.ovvo += np.transpose(tmp83, (1, 2, 3, 0)) * -2
    rdm2.ovvo += einsum(delta.oo, (0, 1), tmp85, (2, 3), (0, 2, 3, 1)) * -4
    rdm2.ovvo += np.transpose(tmp66, (1, 2, 3, 0)) * -2
    del tmp66
    rdm2.ovvo += np.transpose(tmp87, (1, 2, 3, 0)) * -2
    del tmp87
    rdm2.ovov = einsum(l1, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.ovov += np.transpose(tmp79, (0, 3, 1, 2)) * 2
    del tmp79
    rdm2.ovov += np.transpose(tmp81, (0, 3, 1, 2)) * -2
    del tmp81
    rdm2.ovov += np.transpose(tmp83, (1, 2, 0, 3)) * 2
    del tmp83
    rdm2.ovov += einsum(delta.oo, (0, 1), tmp85, (2, 3), (0, 2, 1, 3)) * 8
    del tmp85
    rdm2.ovov += np.transpose(tmp68, (1, 2, 0, 3)) * -2
    del tmp68
    rdm2.ovov += np.transpose(tmp86, (1, 2, 0, 3)) * -2
    del tmp86
    rdm2.oovv = np.copy(tmp50) * 2
    rdm2.oovv += np.transpose(tmp50, (0, 1, 3, 2)) * -2
    rdm2.oovv += np.transpose(tmp50, (1, 0, 2, 3)) * -2
    rdm2.oovv += np.transpose(tmp50, (1, 0, 3, 2)) * 2
    del tmp50
    rdm2.oovv += np.transpose(t2, (0, 1, 3, 2)) * -2
    rdm2.oovv += t2 * 4
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.oovv += tmp57 * 2
    rdm2.oovv += np.transpose(tmp57, (0, 1, 3, 2)) * -2
    del tmp57
    rdm2.oovv += tmp60 * 2
    rdm2.oovv += np.transpose(tmp60, (0, 1, 3, 2)) * -2
    del tmp60
    rdm2.oovv += tmp65 * -4
    rdm2.oovv += np.transpose(tmp65, (0, 1, 3, 2)) * 2
    rdm2.oovv += np.transpose(tmp65, (1, 0, 2, 3)) * 2
    rdm2.oovv += np.transpose(tmp65, (1, 0, 3, 2)) * -4
    del tmp65
    rdm2.oovv += einsum(tmp21, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * -2
    del tmp21
    rdm2.oovv += tmp67 * 2
    del tmp67
    rdm2.oovv += np.transpose(tmp69, (0, 1, 3, 2)) * 2
    del tmp69
    rdm2.oovv += tmp72 * 2
    rdm2.oovv += np.transpose(tmp72, (1, 0, 3, 2)) * 2
    del tmp72
    rdm2.oovv += np.transpose(tmp75, (0, 1, 3, 2)) * -2
    rdm2.oovv += np.transpose(tmp75, (1, 0, 2, 3)) * -2
    del tmp75
    rdm2.oovv += tmp53 * 4
    del tmp53
    rdm2.oovv += tmp59 * 2
    del tmp59
    rdm2.oovv += np.transpose(tmp76, (0, 1, 3, 2)) * 2
    del tmp76
    rdm2.oovv += einsum(t1, (0, 1), tmp77, (2, 3), (2, 0, 3, 1)) * 2
    del tmp77
    rdm2.vooo = np.copy(np.transpose(tmp4, (3, 2, 0, 1))) * -4
    rdm2.vooo += np.transpose(tmp4, (3, 2, 1, 0)) * 2
    rdm2.vooo += einsum(l1, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * 4
    rdm2.vooo += einsum(l1, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.ovoo = np.copy(np.transpose(tmp4, (2, 3, 0, 1))) * 2
    rdm2.ovoo += np.transpose(tmp4, (2, 3, 1, 0)) * -4
    del tmp4
    rdm2.ovoo += einsum(l1, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.ovoo += einsum(l1, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * 4
    rdm2.oovo = einsum(tmp37, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp37, (2, 3), (0, 2, 3, 1)) * 2
    del tmp37
    rdm2.oovo += np.transpose(tmp38, (1, 2, 3, 0)) * -2
    rdm2.oovo += np.transpose(tmp38, (2, 1, 3, 0)) * 2
    del tmp38
    rdm2.oovo += np.transpose(tmp39, (1, 2, 3, 0)) * -2
    rdm2.oovo += np.transpose(tmp39, (2, 1, 3, 0)) * 2
    del tmp39
    rdm2.oovo += einsum(tmp23, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp23, (2, 3), (0, 2, 3, 1)) * -2
    del tmp23
    rdm2.oovo += einsum(t1, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.oovo += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.oovo += np.transpose(tmp26, (1, 2, 3, 0)) * 2
    rdm2.oovo += np.transpose(tmp25, (2, 1, 3, 0)) * 2
    rdm2.oovo += np.transpose(tmp12, (1, 2, 3, 0)) * -2
    rdm2.oovo += np.transpose(tmp17, (2, 1, 3, 0)) * -2
    del tmp17
    rdm2.oovo += np.transpose(tmp29, (1, 2, 3, 0)) * 2
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp42, (2, 3), (2, 0, 3, 1)) * -4
    del tmp42
    rdm2.oovo += einsum(tmp43, (0, 1), t1, (2, 3), (2, 1, 3, 0)) * -2
    del tmp43
    rdm2.ooov = einsum(tmp11, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * 4
    rdm2.ooov += einsum(delta.oo, (0, 1), tmp11, (2, 3), (0, 2, 1, 3)) * -4
    del tmp11
    rdm2.ooov += np.transpose(tmp18, (1, 2, 0, 3)) * 2
    rdm2.ooov += np.transpose(tmp18, (2, 1, 0, 3)) * -2
    del tmp18
    rdm2.ooov += np.transpose(tmp20, (1, 2, 0, 3)) * 2
    rdm2.ooov += np.transpose(tmp20, (2, 1, 0, 3)) * -2
    del tmp20
    rdm2.ooov += einsum(tmp24, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * 2
    rdm2.ooov += einsum(tmp24, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -2
    del tmp24
    rdm2.ooov += einsum(t1, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.ooov += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.ooov += einsum(t1, (0, 1), tmp2, (2, 3), (0, 3, 2, 1)) * 2
    rdm2.ooov += einsum(tmp2, (0, 1), t1, (2, 3), (1, 2, 0, 3)) * -2
    rdm2.ooov += np.transpose(tmp25, (1, 2, 0, 3)) * 2
    del tmp25
    rdm2.ooov += np.transpose(tmp26, (2, 1, 0, 3)) * 2
    del tmp26
    rdm2.ooov += np.transpose(tmp12, (2, 1, 0, 3)) * -2
    del tmp12
    rdm2.ooov += np.transpose(tmp28, (1, 2, 0, 3)) * -2
    del tmp28
    rdm2.ooov += np.transpose(tmp29, (2, 1, 0, 3)) * 2
    del tmp29
    rdm2.ooov += einsum(tmp36, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -2
    del tmp36
    rdm2.ooov += einsum(tmp34, (0, 1), t1, (2, 3), (1, 2, 0, 3)) * -4
    del tmp34
    rdm2.oooo = einsum(tmp1, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3)) * -4
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp1, (2, 3), (0, 3, 2, 1)) * 2
    rdm2.oooo += einsum(tmp1, (0, 1), delta.oo, (2, 3), (1, 2, 3, 0)) * 2
    rdm2.oooo += einsum(tmp1, (0, 1), delta.oo, (2, 3), (2, 1, 3, 0)) * -4
    del tmp1
    rdm2.oooo += einsum(tmp2, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3)) * -2
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp2, (2, 3), (0, 3, 2, 1)) * 2
    rdm2.oooo += einsum(tmp2, (0, 1), delta.oo, (2, 3), (1, 2, 3, 0)) * 2
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp2, (2, 3), (0, 3, 1, 2)) * -4
    del tmp2
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.oooo += np.transpose(tmp6, (3, 2, 0, 1)) * -2
    rdm2.oooo += np.transpose(tmp6, (2, 3, 0, 1)) * 2
    del tmp6
    rdm2.oooo += np.transpose(tmp3, (3, 2, 1, 0)) * 2
    del tmp3
    rdm2.oooo += np.transpose(tmp5, (3, 2, 1, 0)) * 2
    del tmp5
    rdm2.oooo += einsum(tmp7, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3)) * 2
    del delta, tmp7
    rdm2 = pack_2e(rdm2.oooo, rdm2.ooov, rdm2.oovo, rdm2.ovoo, rdm2.vooo, rdm2.oovv, rdm2.ovov, rdm2.ovvo, rdm2.voov, rdm2.vovo, rdm2.vvoo, rdm2.ovvv, rdm2.vovv, rdm2.vvov, rdm2.vvvo, rdm2.vvvv)
    rdm2 = np.transpose(rdm2, (0, 2, 1, 3))

    return rdm2

def hbar_matvec_ip_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:50:33.631023.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp0 : array
    tmp1 : array
    tmp11 : array
    tmp14 : array
    tmp17 : array
    tmp18 : array
    tmp20 : array
    tmp21 : array
    tmp23 : array
    tmp24 : array
    tmp30 : array
    tmp32 : array
    tmp33 : array
    tmp35 : array
    tmp38 : array
    tmp39 : array
    tmp40 : array
    tmp42 : array
    tmp43 : array
    tmp45 : array
    tmp46 : array
    tmp47 : array
    tmp5 : array
    tmp52 : array
    tmp54 : array
    tmp55 : array
    tmp56 : array
    tmp57 : array
    tmp58 : array
    tmp60 : array
    tmp66 : array
    tmp67 : array
    tmp68 : array
    tmp69 : array
    tmp7 : array
    tmp9 : array
    """

    tmp6 = einsum(v.xov, (0, 1, 2), t1, (1, 2), (0,))
    tmp4 = einsum(t1, (0, 1), v.xov, (2, 3, 1), (0, 3, 2))
    tmp0 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp17 = einsum(v.xov, (0, 1, 2), t2, (3, 1, 2, 4), (3, 4, 0))
    tmp20 = einsum(v.xov, (0, 1, 2), t2, (3, 1, 4, 2), (3, 4, 0))
    tmp1 = einsum(v.xov, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp32 = einsum(v.xov, (0, 1, 2), v.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp29 = einsum(v.xvv, (0, 1, 2), v.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp11 = einsum(tmp6, (0,), v.xov, (0, 1, 2), (1, 2))
    tmp9 = einsum(tmp4, (0, 1, 2), v.xov, (2, 0, 3), (1, 3))
    tmp69 = einsum(tmp0, (0, 1), t1, (0, 2), (1, 2))
    tmp68 = einsum(v.xvv, (0, 1, 2), tmp17, (3, 2, 0), (3, 1))
    tmp67 = einsum(tmp20, (0, 1, 2), v.xvv, (2, 3, 1), (0, 3))
    tmp66 = einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))
    tmp60 = einsum(v.xov, (0, 1, 2), tmp20, (1, 3, 0), (3, 2))
    tmp58 = einsum(v.xov, (0, 1, 2), tmp17, (1, 3, 0), (3, 2))
    tmp57 = einsum(tmp1, (0, 1, 2, 3), t2, (4, 1, 3, 5), (4, 0, 2, 5))
    tmp56 = einsum(tmp1, (0, 1, 2, 3), t2, (1, 2, 4, 3), (0, 4))
    tmp55 = einsum(t2, (0, 1, 2, 3), tmp1, (4, 0, 1, 2), (4, 3))
    tmp54 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp52 = einsum(f.oo, (0, 1), t1, (1, 2), (0, 2))
    tmp47 = einsum(tmp32, (0, 1, 2, 3), t2, (4, 0, 5, 3), (4, 1, 5, 2))
    tmp46 = einsum(t2, (0, 1, 2, 3), tmp32, (1, 4, 5, 2), (0, 4, 3, 5))
    tmp45 = einsum(tmp17, (0, 1, 2), v.xoo, (2, 3, 4), (0, 3, 4, 1))
    tmp43 = einsum(v.xoo, (0, 1, 2), tmp20, (3, 4, 0), (3, 1, 2, 4))
    tmp42 = einsum(tmp1, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp40 = einsum(v.xoo, (0, 1, 2), v.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp39 = einsum(f.ov, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp38 = einsum(f.ov, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp35 = einsum(v.xvv, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp33 = einsum(tmp32, (0, 1, 2, 3), t2, (4, 5, 2, 3), (4, 5, 0, 1))
    tmp30 = einsum(tmp29, (0, 1, 2, 3), t2, (4, 5, 3, 2), (4, 5, 0, 1))
    del tmp29
    tmp24 = einsum(t1, (0, 1), tmp11, (2, 1), (0, 2))
    tmp23 = einsum(t1, (0, 1), tmp9, (2, 1), (0, 2))
    tmp21 = einsum(v.xov, (0, 1, 2), tmp20, (3, 2, 0), (3, 1))
    tmp18 = einsum(tmp17, (0, 1, 2), v.xov, (2, 3, 1), (0, 3))
    tmp14 = einsum(v.xov, (0, 1, 2), tmp4, (3, 4, 0), (3, 1, 4, 2))
    tmp7 = einsum(tmp6, (0,), v.xoo, (0, 1, 2), (1, 2))
    del tmp6
    tmp5 = einsum(tmp4, (0, 1, 2), v.xoo, (2, 3, 0), (3, 1))
    del tmp4

    return {f"tmp0": tmp0, f"tmp1": tmp1, f"tmp11": tmp11, f"tmp14": tmp14, f"tmp17": tmp17, f"tmp18": tmp18, f"tmp20": tmp20, f"tmp21": tmp21, f"tmp23": tmp23, f"tmp24": tmp24, f"tmp30": tmp30, f"tmp32": tmp32, f"tmp33": tmp33, f"tmp35": tmp35, f"tmp38": tmp38, f"tmp39": tmp39, f"tmp40": tmp40, f"tmp42": tmp42, f"tmp43": tmp43, f"tmp45": tmp45, f"tmp46": tmp46, f"tmp47": tmp47, f"tmp5": tmp5, f"tmp52": tmp52, f"tmp54": tmp54, f"tmp55": tmp55, f"tmp56": tmp56, f"tmp57": tmp57, f"tmp58": tmp58, f"tmp60": tmp60, f"tmp66": tmp66, f"tmp67": tmp67, f"tmp68": tmp68, f"tmp69": tmp69, f"tmp7": tmp7, f"tmp9": tmp9}

def hbar_matvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:50:33.663660.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp3 = np.copy(r2) * 2
    tmp3 += np.transpose(r2, (1, 0, 2)) * -1
    tmp9 = np.copy(np.transpose(ints.tmp60, (1, 0))) * 2
    del ints.tmp60
    tmp9 += f.vv * -1
    tmp9 += np.transpose(ints.tmp58, (1, 0)) * -1
    del ints.tmp58
    tmp9 += einsum(f.ov, (0, 1), t1, (0, 2), (1, 2))
    tmp13 = np.copy(f.ov)
    tmp13 += ints.tmp39 * 2
    del ints.tmp39
    tmp13 += ints.tmp55
    del ints.tmp55
    tmp13 += ints.tmp66
    del ints.tmp66
    tmp13 += ints.tmp67 * 2
    del ints.tmp67
    tmp13 += ints.tmp38 * -1
    del ints.tmp38
    tmp13 += ints.tmp52 * -1
    del ints.tmp52
    tmp13 += ints.tmp56 * -2
    del ints.tmp56
    tmp13 += ints.tmp68 * -1
    del ints.tmp68
    tmp13 += ints.tmp69 * -1
    del ints.tmp69
    tmp6 = np.copy(ints.tmp35)
    tmp6 += ints.tmp46 * -1
    tmp8 = np.copy(ints.tmp20) * 2
    del ints.tmp20
    tmp8 += np.transpose(v.xov, (1, 2, 0))
    tmp8 += ints.tmp17 * -1
    del ints.tmp17
    tmp11 = np.copy(ints.tmp1)
    tmp11 += np.transpose(ints.tmp30, (0, 2, 1, 3))
    del ints.tmp30
    tmp11 += np.transpose(ints.tmp43, (2, 1, 0, 3)) * 2
    del ints.tmp43
    tmp11 += np.transpose(ints.tmp54, (2, 0, 1, 3))
    del ints.tmp54
    tmp11 += np.transpose(ints.tmp42, (1, 2, 0, 3)) * -1
    del ints.tmp42
    tmp11 += np.transpose(ints.tmp45, (2, 1, 0, 3)) * -1
    del ints.tmp45
    tmp11 += np.transpose(ints.tmp57, (0, 2, 1, 3)) * -1
    del ints.tmp57
    tmp7 = einsum(tmp3, (0, 1, 2), v.xov, (3, 0, 2), (1, 3)) * 0.5
    tmp5 = np.copy(ints.tmp35) * 0.5
    del ints.tmp35
    tmp5 += ints.tmp47
    tmp5 += ints.tmp46 * -0.5
    del ints.tmp46
    tmp12 = np.copy(f.oo)
    tmp12 += ints.tmp0
    tmp12 += np.transpose(ints.tmp21, (1, 0)) * 2
    tmp12 += np.transpose(ints.tmp18, (1, 0)) * -1
    tmp10 = einsum(ints.tmp32, (0, 1, 2, 3), tmp3, (0, 1, 2), (3,)) * 0.5
    del ints.tmp32
    tmp4 = np.copy(f.oo)
    tmp4 += ints.tmp0
    del ints.tmp0
    tmp4 += np.transpose(ints.tmp21, (1, 0)) * 2
    del ints.tmp21
    tmp4 += np.transpose(ints.tmp24, (1, 0)) * 2
    del ints.tmp24
    tmp4 += np.transpose(ints.tmp7, (1, 0)) * 2
    del ints.tmp7
    tmp4 += np.transpose(ints.tmp18, (1, 0)) * -1
    del ints.tmp18
    tmp4 += np.transpose(ints.tmp23, (1, 0)) * -1
    del ints.tmp23
    tmp4 += np.transpose(ints.tmp5, (1, 0)) * -1
    del ints.tmp5
    tmp2 = np.copy(f.ov) * 0.5
    tmp2 += ints.tmp11
    del ints.tmp11
    tmp2 += ints.tmp9 * -0.5
    del ints.tmp9
    tmp0 = np.copy(r2) * -1
    tmp0 += np.transpose(r2, (1, 0, 2)) * 2
    tmp1 = np.copy(r2)
    tmp1 += np.transpose(r2, (1, 0, 2)) * -0.5
    r2new = einsum(ints.tmp40, (0, 1, 2, 3), r2, (1, 3, 4), (2, 0, 4))
    del ints.tmp40
    r2new += einsum(ints.tmp33, (0, 1, 2, 3), r2, (3, 2, 4), (1, 0, 4))
    del ints.tmp33
    r2new += einsum(r2, (0, 1, 2), ints.tmp47, (3, 1, 4, 2), (3, 0, 4))
    del ints.tmp47
    r2new += einsum(r2, (0, 1, 2), tmp5, (3, 0, 4, 2), (3, 1, 4)) * -2
    del tmp5
    r2new += einsum(r2, (0, 1, 2), tmp6, (3, 1, 4, 2), (0, 3, 4)) * -1
    del tmp6
    r2new += einsum(tmp8, (0, 1, 2), tmp7, (3, 2), (0, 3, 1)) * 2
    del tmp8, tmp7
    r2new += einsum(tmp9, (0, 1), r2, (2, 3, 0), (2, 3, 1)) * -1
    del tmp9
    r2new += einsum(tmp10, (0,), t2, (1, 2, 3, 0), (1, 2, 3)) * -2
    del tmp10
    r2new += einsum(r1, (0,), tmp11, (1, 0, 2, 3), (2, 1, 3))
    del tmp11
    r2new += einsum(r2, (0, 1, 2), tmp12, (0, 3), (3, 1, 2)) * -1
    r2new += einsum(tmp12, (0, 1), r2, (2, 0, 3), (2, 1, 3)) * -1
    del tmp12
    r2new += einsum(r1, (0,), tmp13, (1, 2), (1, 0, 2)) * -1
    del tmp13
    r1new = einsum(ints.tmp14, (0, 1, 2, 3), tmp0, (2, 1, 3), (0,))
    del ints.tmp14, tmp0
    r1new += einsum(tmp1, (0, 1, 2), ints.tmp1, (3, 1, 0, 2), (3,)) * 2
    del ints.tmp1, tmp1
    r1new += einsum(tmp3, (0, 1, 2), tmp2, (0, 2), (1,)) * -2
    del tmp3, tmp2
    r1new += einsum(r1, (0,), tmp4, (0, 1), (1,)) * -1
    del tmp4

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_matvec_ea_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:50:51.681681.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp10 : array
    tmp12 : array
    tmp15 : array
    tmp20 : array
    tmp21 : array
    tmp23 : array
    tmp24 : array
    tmp33 : array
    tmp36 : array
    tmp37 : array
    tmp39 : array
    tmp45 : array
    tmp46 : array
    tmp47 : array
    tmp49 : array
    tmp5 : array
    tmp50 : array
    tmp51 : array
    tmp53 : array
    tmp55 : array
    tmp56 : array
    tmp57 : array
    tmp58 : array
    tmp60 : array
    tmp61 : array
    tmp62 : array
    tmp64 : array
    tmp65 : array
    tmp68 : array
    tmp8 : array
    """

    tmp15 = einsum(v.xov, (0, 1, 2), v.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp20 = einsum(v.xov, (0, 1, 2), t2, (3, 1, 2, 4), (3, 4, 0))
    tmp1 = einsum(v.xvv, (0, 1, 2), v.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp23 = einsum(v.xov, (0, 1, 2), t2, (3, 1, 4, 2), (3, 4, 0))
    tmp38 = einsum(v.xov, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp46 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp4 = einsum(v.xov, (0, 1, 2), t1, (1, 2), (0,))
    tmp9 = einsum(t1, (0, 1), v.xov, (2, 3, 1), (0, 3, 2))
    tmp7 = einsum(v.xvv, (0, 1, 2), t1, (3, 2), (3, 1, 0))
    tmp68 = einsum(tmp15, (0, 1, 2, 3), t2, (4, 0, 5, 3), (4, 1, 5, 2))
    tmp65 = einsum(v.xvv, (0, 1, 2), tmp20, (3, 4, 0), (3, 4, 1, 2))
    tmp64 = einsum(t2, (0, 1, 2, 3), tmp1, (1, 4, 3, 5), (0, 2, 5, 4))
    tmp62 = einsum(tmp23, (0, 1, 2), v.xvv, (2, 3, 4), (0, 1, 3, 4))
    tmp61 = einsum(f.ov, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp60 = einsum(f.ov, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp58 = einsum(tmp38, (0, 1, 2, 3), t2, (1, 2, 4, 3), (0, 4))
    tmp57 = einsum(t2, (0, 1, 2, 3), tmp38, (4, 0, 1, 2), (4, 3))
    tmp56 = einsum(f.oo, (0, 1), t1, (1, 2), (0, 2))
    tmp55 = einsum(tmp46, (0, 1), t1, (0, 2), (1, 2))
    tmp53 = einsum(tmp23, (0, 1, 2), v.xov, (2, 3, 1), (0, 3))
    tmp51 = einsum(v.xov, (0, 1, 2), tmp20, (3, 2, 0), (3, 1))
    tmp50 = einsum(tmp20, (0, 1, 2), v.xvv, (2, 3, 1), (0, 3))
    tmp49 = einsum(v.xvv, (0, 1, 2), tmp23, (3, 2, 0), (3, 1))
    tmp47 = einsum(v.xvv, (0, 1, 2), v.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp45 = einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))
    tmp39 = einsum(t2, (0, 1, 2, 3), tmp38, (4, 0, 1, 5), (4, 2, 3, 5))
    del tmp38
    tmp37 = einsum(v.xvv, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp36 = einsum(tmp15, (0, 1, 2, 3), t2, (4, 0, 3, 5), (4, 1, 5, 2))
    tmp33 = einsum(t2, (0, 1, 2, 3), tmp1, (1, 4, 2, 5), (0, 3, 5, 4))
    tmp24 = einsum(v.xov, (0, 1, 2), tmp23, (1, 3, 0), (3, 2))
    tmp21 = einsum(v.xov, (0, 1, 2), tmp20, (1, 3, 0), (3, 2))
    tmp12 = einsum(v.xov, (0, 1, 2), tmp4, (0,), (1, 2))
    tmp10 = einsum(tmp9, (0, 1, 2), v.xov, (2, 0, 3), (1, 3))
    del tmp9
    tmp8 = einsum(v.xov, (0, 1, 2), tmp7, (1, 3, 0), (2, 3))
    del tmp7
    tmp5 = einsum(v.xvv, (0, 1, 2), tmp4, (0,), (1, 2))
    del tmp4

    return {f"tmp1": tmp1, f"tmp10": tmp10, f"tmp12": tmp12, f"tmp15": tmp15, f"tmp20": tmp20, f"tmp21": tmp21, f"tmp23": tmp23, f"tmp24": tmp24, f"tmp33": tmp33, f"tmp36": tmp36, f"tmp37": tmp37, f"tmp39": tmp39, f"tmp45": tmp45, f"tmp46": tmp46, f"tmp47": tmp47, f"tmp49": tmp49, f"tmp5": tmp5, f"tmp50": tmp50, f"tmp51": tmp51, f"tmp53": tmp53, f"tmp55": tmp55, f"tmp56": tmp56, f"tmp57": tmp57, f"tmp58": tmp58, f"tmp60": tmp60, f"tmp61": tmp61, f"tmp62": tmp62, f"tmp64": tmp64, f"tmp65": tmp65, f"tmp68": tmp68, f"tmp8": tmp8}

def hbar_matvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:50:51.711912.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp0 = np.copy(np.transpose(r2, (2, 0, 1)))
    tmp0 += np.transpose(r2, (2, 1, 0)) * -0.5
    tmp2 = np.copy(np.transpose(r2, (2, 0, 1))) * -1
    tmp2 += np.transpose(r2, (2, 1, 0)) * 2
    tmp12 = einsum(f.ov, (0, 1), t1, (0, 2), (1, 2))
    tmp4 = einsum(tmp0, (0, 1, 2), ints.tmp15, (0, 3, 1, 2), (3,)) * 2
    tmp1 = np.copy(f.ov)
    tmp1 += ints.tmp12 * 2
    del ints.tmp12
    tmp1 += ints.tmp10 * -1
    del ints.tmp10
    tmp9 = einsum(v.xov, (0, 1, 2), tmp2, (1, 3, 2), (3, 0)) * 0.5
    tmp13 = np.copy(np.transpose(ints.tmp24, (1, 0))) * 2
    tmp13 += f.vv * -1
    tmp13 += np.transpose(ints.tmp21, (1, 0)) * -1
    tmp13 += tmp12
    del tmp12
    tmp15 = einsum(f.ov, (0, 1), r1, (1,), (0,))
    tmp15 += tmp4 * -1
    tmp6 = einsum(r2, (0, 1, 2), ints.tmp15, (3, 4, 1, 0), (3, 4, 2))
    del ints.tmp15
    tmp8 = np.copy(ints.tmp36)
    tmp8 += ints.tmp37 * -1
    tmp16 = np.copy(f.ov)
    tmp16 += ints.tmp45
    del ints.tmp45
    tmp16 += ints.tmp49 * 2
    del ints.tmp49
    tmp16 += ints.tmp57
    del ints.tmp57
    tmp16 += ints.tmp61 * 2
    del ints.tmp61
    tmp16 += ints.tmp50 * -1
    del ints.tmp50
    tmp16 += ints.tmp55 * -1
    del ints.tmp55
    tmp16 += ints.tmp56 * -1
    del ints.tmp56
    tmp16 += ints.tmp58 * -2
    del ints.tmp58
    tmp16 += ints.tmp60 * -1
    del ints.tmp60
    tmp11 = np.copy(ints.tmp1)
    tmp11 += np.transpose(ints.tmp39, (0, 2, 3, 1))
    del ints.tmp39
    tmp11 += np.transpose(ints.tmp62, (0, 3, 2, 1)) * 2
    del ints.tmp62
    tmp11 += ints.tmp33 * -1
    del ints.tmp33
    tmp11 += np.transpose(ints.tmp64, (0, 3, 2, 1)) * -1
    del ints.tmp64
    tmp11 += np.transpose(ints.tmp65, (0, 3, 2, 1)) * -1
    del ints.tmp65
    tmp7 = np.copy(ints.tmp37) * 0.5
    del ints.tmp37
    tmp7 += ints.tmp68
    tmp7 += ints.tmp36 * -0.5
    del ints.tmp36
    tmp14 = np.copy(f.oo)
    tmp14 += ints.tmp46
    del ints.tmp46
    tmp14 += np.transpose(ints.tmp53, (1, 0)) * 2
    del ints.tmp53
    tmp14 += np.transpose(ints.tmp51, (1, 0)) * -1
    del ints.tmp51
    tmp10 = np.copy(ints.tmp23) * 2
    del ints.tmp23
    tmp10 += np.transpose(v.xov, (1, 2, 0))
    tmp10 += ints.tmp20 * -1
    del ints.tmp20
    tmp3 = np.copy(f.vv)
    tmp3 += np.transpose(ints.tmp21, (1, 0))
    del ints.tmp21
    tmp3 += np.transpose(ints.tmp5, (1, 0)) * 2
    del ints.tmp5
    tmp3 += np.transpose(ints.tmp24, (1, 0)) * -2
    del ints.tmp24
    tmp3 += ints.tmp8 * -1
    del ints.tmp8
    tmp5 = np.copy(tmp4) * -1
    del tmp4
    tmp5 += einsum(tmp1, (0, 1), r1, (1,), (0,))
    r2new = einsum(ints.tmp68, (0, 1, 2, 3), r2, (4, 3, 1), (2, 4, 0))
    del ints.tmp68
    r2new += einsum(r2, (0, 1, 2), ints.tmp47, (3, 0, 4, 1), (4, 3, 2))
    del ints.tmp47
    r2new += einsum(t2, (0, 1, 2, 3), tmp6, (0, 1, 4), (3, 2, 4))
    del tmp6
    r2new += einsum(tmp7, (0, 1, 2, 3), r2, (3, 4, 1), (2, 4, 0)) * -2
    del tmp7
    r2new += einsum(r2, (0, 1, 2), tmp8, (3, 2, 4, 1), (0, 4, 3))
    del tmp8
    r2new += einsum(tmp10, (0, 1, 2), tmp9, (3, 2), (1, 3, 0)) * 2
    del tmp10, tmp9
    r2new += einsum(r1, (0,), tmp11, (1, 2, 0, 3), (3, 2, 1)) * -1
    del tmp11
    r2new += einsum(r2, (0, 1, 2), tmp13, (0, 3), (3, 1, 2)) * -1
    r2new += einsum(r2, (0, 1, 2), tmp13, (1, 3), (0, 3, 2)) * -1
    del tmp13
    r2new += einsum(r2, (0, 1, 2), tmp14, (2, 3), (0, 1, 3)) * -1
    del tmp14
    r2new += einsum(t2, (0, 1, 2, 3), tmp15, (1,), (2, 3, 0))
    del tmp15
    r2new += einsum(r1, (0,), tmp16, (1, 2), (2, 0, 1)) * -1
    del tmp16
    r1new = einsum(ints.tmp1, (0, 1, 2, 3), tmp0, (0, 3, 2), (1,)) * -2
    del tmp0, ints.tmp1
    r1new += einsum(tmp2, (0, 1, 2), tmp1, (0, 2), (1,)) * -1
    del tmp2, tmp1
    r1new += einsum(r1, (0,), tmp3, (0, 1), (1,))
    del tmp3
    r1new += einsum(tmp5, (0,), t1, (0, 1), (1,)) * -1
    del tmp5

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ip_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:52:04.166676.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp0 : array
    tmp1 : array
    tmp10 : array
    tmp101 : array
    tmp102 : array
    tmp103 : array
    tmp106 : array
    tmp107 : array
    tmp109 : array
    tmp111 : array
    tmp115 : array
    tmp117 : array
    tmp120 : array
    tmp123 : array
    tmp125 : array
    tmp128 : array
    tmp130 : array
    tmp134 : array
    tmp139 : array
    tmp14 : array
    tmp141 : array
    tmp142 : array
    tmp16 : array
    tmp161 : array
    tmp163 : array
    tmp18 : array
    tmp19 : array
    tmp2 : array
    tmp22 : array
    tmp26 : array
    tmp28 : array
    tmp3 : array
    tmp30 : array
    tmp32 : array
    tmp33 : array
    tmp35 : array
    tmp36 : array
    tmp38 : array
    tmp4 : array
    tmp41 : array
    tmp44 : array
    tmp46 : array
    tmp48 : array
    tmp50 : array
    tmp52 : array
    tmp55 : array
    tmp59 : array
    tmp6 : array
    tmp63 : array
    tmp65 : array
    tmp68 : array
    tmp71 : array
    tmp74 : array
    tmp77 : array
    tmp80 : array
    tmp83 : array
    tmp86 : array
    tmp88 : array
    tmp9 : array
    tmp91 : array
    tmp93 : array
    tmp95 : array
    tmp98 : array
    """

    tmp15 = einsum(v.xov, (0, 1, 2), t1, (1, 2), (0,))
    tmp13 = einsum(t1, (0, 1), v.xov, (2, 3, 1), (0, 3, 2))
    tmp22 = einsum(v.xov, (0, 1, 2), tmp15, (0,), (1, 2))
    tmp62 = einsum(v.xov, (0, 1, 2), tmp13, (1, 3, 0), (3, 2))
    tmp101 = einsum(v.xov, (0, 1, 2), v.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp32 = einsum(v.xov, (0, 1, 2), t2, (3, 1, 2, 4), (3, 4, 0))
    tmp35 = einsum(v.xov, (0, 1, 2), t2, (3, 1, 4, 2), (3, 4, 0))
    tmp133 = einsum(tmp13, (0, 1, 2), tmp13, (3, 4, 2), (0, 3, 1, 4))
    tmp107 = einsum(t1, (0, 1), tmp22, (2, 1), (0, 2))
    tmp106 = einsum(tmp62, (0, 1), t1, (2, 1), (2, 0))
    tmp25 = einsum(v.xvv, (0, 1, 2), t1, (3, 2), (3, 1, 0))
    tmp119 = einsum(v.xvv, (0, 1, 2), tmp15, (0,), (1, 2))
    tmp114 = einsum(v.xoo, (0, 1, 2), tmp13, (3, 4, 0), (3, 1, 2, 4))
    tmp16 = einsum(v.xoo, (0, 1, 2), tmp15, (0,), (1, 2))
    del tmp15
    tmp14 = einsum(v.xoo, (0, 1, 2), tmp13, (2, 3, 0), (1, 3))
    tmp102 = einsum(t2, (0, 1, 2, 3), tmp101, (4, 5, 3, 2), (0, 1, 5, 4))
    tmp33 = einsum(tmp32, (0, 1, 2), v.xov, (2, 3, 1), (0, 3))
    tmp36 = einsum(tmp35, (0, 1, 2), v.xov, (2, 3, 1), (0, 3))
    tmp28 = einsum(tmp13, (0, 1, 2), v.xov, (2, 3, 4), (0, 3, 1, 4))
    tmp58 = einsum(v.xvv, (0, 1, 2), v.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp10 = einsum(v.xov, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp18 = einsum(v.xoo, (0, 1, 2), v.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp0 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp163 = einsum(tmp35, (0, 1, 2), v.xov, (2, 0, 3), (1, 3))
    tmp161 = einsum(v.xov, (0, 1, 2), tmp32, (1, 3, 0), (3, 2))
    tmp142 = einsum(tmp101, (0, 1, 2, 3), t2, (4, 0, 5, 3), (4, 1, 5, 2))
    tmp141 = einsum(tmp101, (0, 1, 2, 3), t2, (4, 0, 3, 5), (4, 1, 5, 2))
    tmp139 = einsum(v.xvv, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp134 = einsum(tmp133, (0, 1, 2, 3), t1, (3, 4), (0, 1, 2, 4))
    del tmp133
    tmp130 = einsum(tmp107, (0, 1), t1, (1, 2), (0, 2))
    tmp128 = einsum(tmp106, (0, 1), t1, (1, 2), (0, 2))
    tmp125 = einsum(tmp25, (0, 1, 2), tmp13, (3, 4, 2), (3, 0, 4, 1))
    tmp123 = einsum(tmp13, (0, 1, 2), tmp25, (1, 3, 2), (0, 3))
    tmp120 = einsum(tmp119, (0, 1), t1, (2, 1), (2, 0))
    del tmp119
    tmp117 = einsum(t1, (0, 1), tmp114, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp115 = einsum(t1, (0, 1), tmp114, (2, 3, 0, 4), (2, 3, 4, 1))
    del tmp114
    tmp111 = einsum(tmp16, (0, 1), t1, (1, 2), (0, 2))
    tmp109 = einsum(tmp14, (0, 1), t1, (1, 2), (0, 2))
    tmp103 = einsum(tmp102, (0, 1, 2, 3), t1, (2, 4), (1, 0, 3, 4))
    tmp98 = einsum(tmp33, (0, 1), t1, (1, 2), (0, 2))
    tmp95 = einsum(tmp36, (0, 1), t1, (1, 2), (0, 2))
    tmp93 = einsum(tmp28, (0, 1, 2, 3), t2, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp91 = einsum(tmp28, (0, 1, 2, 3), t2, (4, 2, 3, 5), (0, 4, 1, 5))
    tmp88 = einsum(tmp35, (0, 1, 2), tmp13, (3, 4, 2), (3, 0, 4, 1))
    tmp86 = einsum(tmp13, (0, 1, 2), tmp32, (3, 4, 2), (0, 3, 1, 4))
    del tmp13
    tmp83 = einsum(t2, (0, 1, 2, 3), tmp28, (4, 1, 0, 2), (4, 3))
    tmp80 = einsum(t2, (0, 1, 2, 3), tmp28, (4, 1, 0, 3), (4, 2))
    tmp77 = einsum(tmp22, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp74 = einsum(t2, (0, 1, 2, 3), tmp62, (4, 3), (0, 1, 4, 2))
    tmp71 = einsum(t2, (0, 1, 2, 3), tmp22, (1, 3), (0, 2))
    tmp68 = einsum(t2, (0, 1, 2, 3), tmp22, (1, 2), (0, 3))
    tmp65 = einsum(tmp62, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp63 = einsum(t2, (0, 1, 2, 3), tmp62, (1, 2), (0, 3))
    del tmp62
    tmp59 = einsum(t2, (0, 1, 2, 3), tmp58, (4, 5, 3, 2), (0, 1, 4, 5))
    del tmp58
    tmp55 = einsum(v.xvv, (0, 1, 2), tmp32, (3, 2, 0), (3, 1))
    tmp52 = einsum(tmp35, (0, 1, 2), v.xvv, (2, 3, 1), (0, 3))
    tmp50 = einsum(tmp35, (0, 1, 2), v.xoo, (2, 3, 4), (0, 3, 4, 1))
    tmp48 = einsum(tmp32, (0, 1, 2), v.xoo, (2, 3, 4), (0, 3, 4, 1))
    tmp46 = einsum(tmp10, (0, 1, 2, 3), t2, (4, 0, 5, 3), (4, 1, 2, 5))
    tmp44 = einsum(tmp10, (0, 1, 2, 3), t2, (4, 0, 3, 5), (4, 1, 2, 5))
    tmp41 = einsum(t2, (0, 1, 2, 3), tmp10, (0, 4, 1, 3), (4, 2))
    tmp38 = einsum(t2, (0, 1, 2, 3), tmp10, (0, 4, 1, 2), (4, 3))
    tmp30 = einsum(tmp25, (0, 1, 2), v.xoo, (2, 3, 4), (0, 3, 4, 1))
    tmp26 = einsum(tmp25, (0, 1, 2), v.xoo, (2, 3, 0), (3, 1))
    del tmp25
    tmp19 = einsum(t1, (0, 1), tmp18, (2, 0, 3, 4), (4, 2, 3, 1))
    tmp9 = einsum(tmp0, (0, 1), t1, (0, 2), (1, 2))
    tmp6 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp4 = einsum(f.ov, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp3 = einsum(f.ov, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp2 = einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))
    tmp1 = einsum(f.oo, (0, 1), t1, (1, 2), (0, 2))

    return {f"tmp0": tmp0, f"tmp1": tmp1, f"tmp10": tmp10, f"tmp101": tmp101, f"tmp102": tmp102, f"tmp103": tmp103, f"tmp106": tmp106, f"tmp107": tmp107, f"tmp109": tmp109, f"tmp111": tmp111, f"tmp115": tmp115, f"tmp117": tmp117, f"tmp120": tmp120, f"tmp123": tmp123, f"tmp125": tmp125, f"tmp128": tmp128, f"tmp130": tmp130, f"tmp134": tmp134, f"tmp139": tmp139, f"tmp14": tmp14, f"tmp141": tmp141, f"tmp142": tmp142, f"tmp16": tmp16, f"tmp161": tmp161, f"tmp163": tmp163, f"tmp18": tmp18, f"tmp19": tmp19, f"tmp2": tmp2, f"tmp22": tmp22, f"tmp26": tmp26, f"tmp28": tmp28, f"tmp3": tmp3, f"tmp30": tmp30, f"tmp32": tmp32, f"tmp33": tmp33, f"tmp35": tmp35, f"tmp36": tmp36, f"tmp38": tmp38, f"tmp4": tmp4, f"tmp41": tmp41, f"tmp44": tmp44, f"tmp46": tmp46, f"tmp48": tmp48, f"tmp50": tmp50, f"tmp52": tmp52, f"tmp55": tmp55, f"tmp59": tmp59, f"tmp6": tmp6, f"tmp63": tmp63, f"tmp65": tmp65, f"tmp68": tmp68, f"tmp71": tmp71, f"tmp74": tmp74, f"tmp77": tmp77, f"tmp80": tmp80, f"tmp83": tmp83, f"tmp86": tmp86, f"tmp88": tmp88, f"tmp9": tmp9, f"tmp91": tmp91, f"tmp93": tmp93, f"tmp95": tmp95, f"tmp98": tmp98}

def hbar_lmatvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:52:04.221775.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp12 = np.copy(np.transpose(t2, (0, 1, 3, 2)))
    tmp12 += t2 * -0.5
    tmp9 = np.copy(ints.tmp35) * 2
    del ints.tmp35
    tmp9 += np.transpose(v.xov, (1, 2, 0))
    tmp9 += ints.tmp32 * -1
    del ints.tmp32
    tmp0 = np.copy(r2)
    tmp0 += np.transpose(r2, (1, 0, 2)) * -0.5
    tmp13 = einsum(r2, (0, 1, 2), tmp12, (0, 1, 3, 2), (3,))
    del tmp12
    tmp8 = np.copy(ints.tmp139)
    tmp8 += ints.tmp141 * -1
    tmp11 = np.copy(ints.tmp163) * 2
    del ints.tmp163
    tmp11 += f.vv * -1
    tmp11 += ints.tmp161 * -1
    del ints.tmp161
    tmp11 += einsum(t1, (0, 1), f.ov, (0, 2), (1, 2))
    tmp7 = np.copy(ints.tmp139) * 0.5
    del ints.tmp139
    tmp7 += ints.tmp142
    tmp7 += ints.tmp141 * -0.5
    del ints.tmp141
    tmp14 = np.copy(f.oo)
    tmp14 += np.transpose(ints.tmp0, (1, 0))
    tmp14 += ints.tmp36 * 2
    tmp14 += ints.tmp33 * -1
    tmp10 = einsum(tmp9, (0, 1, 2), tmp0, (0, 3, 1), (3, 2)) * 2
    del tmp9
    tmp6 = np.copy(f.oo)
    tmp6 += np.transpose(ints.tmp0, (1, 0))
    del ints.tmp0
    tmp6 += ints.tmp107 * 2
    del ints.tmp107
    tmp6 += np.transpose(ints.tmp16, (1, 0)) * 2
    del ints.tmp16
    tmp6 += ints.tmp36 * 2
    del ints.tmp36
    tmp6 += ints.tmp106 * -1
    del ints.tmp106
    tmp6 += ints.tmp14 * -1
    del ints.tmp14
    tmp6 += ints.tmp33 * -1
    del ints.tmp33
    tmp4 = np.copy(ints.tmp111) * 2
    del ints.tmp111
    tmp4 += ints.tmp123
    del ints.tmp123
    tmp4 += ints.tmp130 * 2
    del ints.tmp130
    tmp4 += ints.tmp1
    del ints.tmp1
    tmp4 += ints.tmp26
    del ints.tmp26
    tmp4 += ints.tmp3
    del ints.tmp3
    tmp4 += ints.tmp41 * 2
    del ints.tmp41
    tmp4 += ints.tmp55
    del ints.tmp55
    tmp4 += ints.tmp65 * 2
    del ints.tmp65
    tmp4 += ints.tmp68 * 2
    del ints.tmp68
    tmp4 += ints.tmp80 * 2
    del ints.tmp80
    tmp4 += ints.tmp95 * 2
    del ints.tmp95
    tmp4 += ints.tmp9
    del ints.tmp9
    tmp4 += f.ov * -1
    tmp4 += ints.tmp109 * -1
    del ints.tmp109
    tmp4 += ints.tmp120 * -2
    del ints.tmp120
    tmp4 += ints.tmp128 * -1
    del ints.tmp128
    tmp4 += ints.tmp22 * -2
    del ints.tmp22
    tmp4 += ints.tmp2 * -1
    del ints.tmp2
    tmp4 += ints.tmp38 * -1
    del ints.tmp38
    tmp4 += ints.tmp4 * -2
    del ints.tmp4
    tmp4 += ints.tmp52 * -2
    del ints.tmp52
    tmp4 += ints.tmp63 * -1
    del ints.tmp63
    tmp4 += ints.tmp71 * -4
    del ints.tmp71
    tmp4 += ints.tmp83 * -1
    del ints.tmp83
    tmp4 += ints.tmp98 * -1
    del ints.tmp98
    tmp2 = np.copy(r2) * -1
    tmp2 += np.transpose(r2, (1, 0, 2)) * 2
    tmp1 = np.copy(ints.tmp103)
    del ints.tmp103
    tmp1 += ints.tmp115
    del ints.tmp115
    tmp1 += ints.tmp134
    del ints.tmp134
    tmp1 += np.transpose(ints.tmp19, (0, 2, 1, 3))
    del ints.tmp19
    tmp1 += ints.tmp44
    del ints.tmp44
    tmp1 += ints.tmp86
    del ints.tmp86
    tmp1 += ints.tmp93
    del ints.tmp93
    tmp1 += np.transpose(ints.tmp10, (1, 2, 0, 3)) * -1
    tmp1 += ints.tmp125 * -1
    del ints.tmp125
    tmp1 += ints.tmp28 * -1
    del ints.tmp28
    tmp1 += ints.tmp59 * -1
    del ints.tmp59
    tmp1 += ints.tmp88 * -2
    del ints.tmp88
    tmp3 = np.copy(ints.tmp117)
    del ints.tmp117
    tmp3 += np.transpose(ints.tmp46, (0, 2, 1, 3))
    del ints.tmp46
    tmp3 += np.transpose(ints.tmp48, (0, 2, 1, 3))
    del ints.tmp48
    tmp3 += np.transpose(ints.tmp74, (0, 2, 1, 3))
    del ints.tmp74
    tmp3 += np.transpose(ints.tmp91, (0, 2, 1, 3))
    del ints.tmp91
    tmp3 += ints.tmp30 * -1
    del ints.tmp30
    tmp3 += np.transpose(ints.tmp50, (0, 2, 1, 3)) * -2
    del ints.tmp50
    tmp3 += np.transpose(ints.tmp6, (1, 0, 2, 3)) * -1
    del ints.tmp6
    tmp3 += np.transpose(ints.tmp77, (0, 2, 1, 3)) * -2
    del ints.tmp77
    tmp5 = np.copy(r2) * 2
    tmp5 += np.transpose(r2, (1, 0, 2)) * -1
    r2new = einsum(r1, (0,), ints.tmp10, (1, 0, 2, 3), (2, 1, 3))
    del ints.tmp10
    r2new += einsum(ints.tmp18, (0, 1, 2, 3), r2, (2, 3, 4), (1, 0, 4))
    del ints.tmp18
    r2new += einsum(ints.tmp102, (0, 1, 2, 3), r2, (1, 0, 4), (3, 2, 4))
    del ints.tmp102
    r2new += einsum(f.ov, (0, 1), r1, (2,), (0, 2, 1)) * -1
    r2new += einsum(r2, (0, 1, 2), ints.tmp142, (1, 3, 2, 4), (3, 0, 4))
    del ints.tmp142
    r2new += einsum(r2, (0, 1, 2), tmp7, (0, 3, 2, 4), (3, 1, 4)) * -2
    del tmp7
    r2new += einsum(tmp8, (0, 1, 2, 3), r2, (4, 0, 2), (4, 1, 3)) * -1
    del tmp8
    r2new += einsum(v.xov, (0, 1, 2), tmp10, (3, 0), (1, 3, 2))
    del tmp10
    r2new += einsum(r2, (0, 1, 2), tmp11, (2, 3), (0, 1, 3)) * -1
    del tmp11
    r2new += einsum(ints.tmp101, (0, 1, 2, 3), tmp13, (3,), (0, 1, 2)) * -2
    del ints.tmp101, tmp13
    r2new += einsum(r2, (0, 1, 2), tmp14, (0, 3), (3, 1, 2)) * -1
    r2new += einsum(r2, (0, 1, 2), tmp14, (1, 3), (0, 3, 2)) * -1
    del tmp14
    r1new = einsum(tmp0, (0, 1, 2), tmp1, (1, 0, 3, 2), (3,)) * -2
    del tmp0, tmp1
    r1new += einsum(tmp3, (0, 1, 2, 3), tmp2, (2, 0, 3), (1,)) * -1
    del tmp3, tmp2
    r1new += einsum(tmp5, (0, 1, 2), tmp4, (0, 2), (1,))
    del tmp5, tmp4
    r1new += einsum(tmp6, (0, 1), r1, (0,), (1,)) * -1
    del tmp6

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ea_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:53:19.551877.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp10 : array
    tmp100 : array
    tmp102 : array
    tmp105 : array
    tmp107 : array
    tmp11 : array
    tmp111 : array
    tmp114 : array
    tmp12 : array
    tmp120 : array
    tmp123 : array
    tmp125 : array
    tmp127 : array
    tmp130 : array
    tmp133 : array
    tmp152 : array
    tmp16 : array
    tmp19 : array
    tmp2 : array
    tmp20 : array
    tmp23 : array
    tmp25 : array
    tmp29 : array
    tmp3 : array
    tmp31 : array
    tmp34 : array
    tmp35 : array
    tmp37 : array
    tmp38 : array
    tmp4 : array
    tmp40 : array
    tmp41 : array
    tmp44 : array
    tmp47 : array
    tmp50 : array
    tmp53 : array
    tmp56 : array
    tmp58 : array
    tmp61 : array
    tmp63 : array
    tmp66 : array
    tmp67 : array
    tmp69 : array
    tmp72 : array
    tmp75 : array
    tmp82 : array
    tmp83 : array
    tmp86 : array
    tmp89 : array
    tmp92 : array
    tmp93 : array
    tmp96 : array
    tmp97 : array
    """

    tmp15 = einsum(v.xov, (0, 1, 2), t1, (1, 2), (0,))
    tmp65 = einsum(t1, (0, 1), v.xov, (2, 3, 1), (0, 3, 2))
    tmp20 = einsum(v.xov, (0, 1, 2), tmp15, (0,), (1, 2))
    tmp66 = einsum(tmp65, (0, 1, 2), v.xov, (2, 0, 3), (1, 3))
    tmp34 = einsum(v.xov, (0, 1, 2), t2, (3, 1, 2, 4), (3, 4, 0))
    tmp37 = einsum(v.xov, (0, 1, 2), t2, (3, 1, 4, 2), (3, 4, 0))
    tmp132 = einsum(tmp20, (0, 1), t1, (2, 1), (2, 0))
    tmp129 = einsum(tmp66, (0, 1), t1, (2, 1), (2, 0))
    tmp18 = einsum(t1, (0, 1), v.xvv, (2, 3, 1), (0, 3, 2))
    tmp16 = einsum(v.xvv, (0, 1, 2), tmp15, (0,), (1, 2))
    tmp113 = einsum(v.xoo, (0, 1, 2), tmp15, (0,), (1, 2))
    del tmp15
    tmp110 = einsum(tmp65, (0, 1, 2), v.xoo, (2, 3, 0), (3, 1))
    tmp25 = einsum(v.xov, (0, 1, 2), v.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp96 = einsum(tmp34, (0, 1, 2), v.xov, (2, 3, 1), (0, 3))
    tmp92 = einsum(tmp37, (0, 1, 2), v.xov, (2, 3, 1), (0, 3))
    tmp82 = einsum(tmp65, (0, 1, 2), v.xov, (2, 3, 4), (0, 3, 1, 4))
    tmp12 = einsum(v.xvv, (0, 1, 2), v.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp40 = einsum(v.xov, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp10 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp152 = einsum(v.xvv, (0, 1, 2), v.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp133 = einsum(tmp132, (0, 1), t1, (1, 2), (0, 2))
    del tmp132
    tmp130 = einsum(tmp129, (0, 1), t1, (1, 2), (0, 2))
    del tmp129
    tmp127 = einsum(tmp18, (0, 1, 2), v.xov, (2, 3, 4), (0, 3, 4, 1))
    tmp125 = einsum(v.xvv, (0, 1, 2), tmp65, (3, 4, 0), (3, 4, 1, 2))
    tmp123 = einsum(tmp18, (0, 1, 2), tmp65, (3, 0, 2), (3, 1))
    del tmp65
    tmp120 = einsum(tmp16, (0, 1), t1, (2, 1), (2, 0))
    tmp114 = einsum(tmp113, (0, 1), t1, (1, 2), (0, 2))
    del tmp113
    tmp111 = einsum(tmp110, (0, 1), t1, (1, 2), (0, 2))
    del tmp110
    tmp107 = einsum(t2, (0, 1, 2, 3), tmp25, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp105 = einsum(t2, (0, 1, 2, 3), tmp25, (1, 4, 5, 2), (0, 4, 3, 5))
    tmp102 = einsum(v.xov, (0, 1, 2), tmp37, (3, 4, 0), (3, 1, 4, 2))
    tmp100 = einsum(v.xov, (0, 1, 2), tmp34, (3, 4, 0), (3, 1, 4, 2))
    tmp97 = einsum(tmp96, (0, 1), t1, (1, 2), (0, 2))
    tmp93 = einsum(tmp92, (0, 1), t1, (1, 2), (0, 2))
    tmp89 = einsum(tmp82, (0, 1, 2, 3), t2, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp86 = einsum(t2, (0, 1, 2, 3), tmp82, (4, 1, 0, 2), (4, 3))
    tmp83 = einsum(tmp82, (0, 1, 2, 3), t2, (2, 1, 4, 3), (0, 4))
    tmp75 = einsum(tmp20, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp72 = einsum(t2, (0, 1, 2, 3), tmp20, (1, 2), (0, 3))
    tmp69 = einsum(tmp66, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp67 = einsum(tmp66, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp63 = einsum(t2, (0, 1, 2, 3), tmp12, (1, 3, 4, 5), (0, 2, 5, 4))
    tmp61 = einsum(t2, (0, 1, 2, 3), tmp12, (1, 2, 4, 5), (0, 3, 5, 4))
    tmp58 = einsum(tmp37, (0, 1, 2), v.xvv, (2, 3, 4), (0, 1, 3, 4))
    tmp56 = einsum(tmp34, (0, 1, 2), v.xvv, (2, 3, 4), (0, 1, 3, 4))
    tmp53 = einsum(tmp34, (0, 1, 2), v.xvv, (2, 3, 1), (0, 3))
    tmp50 = einsum(tmp37, (0, 1, 2), v.xvv, (2, 3, 1), (0, 3))
    tmp47 = einsum(tmp40, (0, 1, 2, 3), t2, (0, 2, 4, 5), (1, 4, 5, 3))
    tmp44 = einsum(tmp40, (0, 1, 2, 3), t2, (0, 2, 4, 3), (1, 4))
    tmp41 = einsum(t2, (0, 1, 2, 3), tmp40, (0, 4, 1, 2), (4, 3))
    tmp38 = einsum(v.xov, (0, 1, 2), tmp37, (1, 3, 0), (3, 2))
    tmp35 = einsum(v.xov, (0, 1, 2), tmp34, (1, 3, 0), (3, 2))
    tmp31 = einsum(tmp18, (0, 1, 2), v.xvv, (2, 3, 4), (0, 3, 4, 1))
    tmp29 = einsum(v.xvv, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp23 = einsum(tmp18, (0, 1, 2), v.xoo, (2, 3, 0), (3, 1))
    tmp19 = einsum(v.xov, (0, 1, 2), tmp18, (1, 3, 0), (2, 3))
    del tmp18
    tmp11 = einsum(tmp10, (0, 1), t1, (0, 2), (1, 2))
    tmp4 = einsum(f.ov, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp3 = einsum(f.ov, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp2 = einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))
    tmp1 = einsum(f.oo, (0, 1), t1, (1, 2), (0, 2))

    return {f"tmp1": tmp1, f"tmp10": tmp10, f"tmp100": tmp100, f"tmp102": tmp102, f"tmp105": tmp105, f"tmp107": tmp107, f"tmp11": tmp11, f"tmp111": tmp111, f"tmp114": tmp114, f"tmp12": tmp12, f"tmp120": tmp120, f"tmp123": tmp123, f"tmp125": tmp125, f"tmp127": tmp127, f"tmp130": tmp130, f"tmp133": tmp133, f"tmp152": tmp152, f"tmp16": tmp16, f"tmp19": tmp19, f"tmp2": tmp2, f"tmp20": tmp20, f"tmp23": tmp23, f"tmp25": tmp25, f"tmp29": tmp29, f"tmp3": tmp3, f"tmp31": tmp31, f"tmp34": tmp34, f"tmp35": tmp35, f"tmp37": tmp37, f"tmp38": tmp38, f"tmp4": tmp4, f"tmp40": tmp40, f"tmp41": tmp41, f"tmp44": tmp44, f"tmp47": tmp47, f"tmp50": tmp50, f"tmp53": tmp53, f"tmp56": tmp56, f"tmp58": tmp58, f"tmp61": tmp61, f"tmp63": tmp63, f"tmp66": tmp66, f"tmp67": tmp67, f"tmp69": tmp69, f"tmp72": tmp72, f"tmp75": tmp75, f"tmp82": tmp82, f"tmp83": tmp83, f"tmp86": tmp86, f"tmp89": tmp89, f"tmp92": tmp92, f"tmp93": tmp93, f"tmp96": tmp96, f"tmp97": tmp97}

def hbar_lmatvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:53:19.603416.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp10 = einsum(t1, (0, 1), r2, (2, 1, 3), (3, 0, 2))
    tmp4 = np.copy(np.transpose(r2, (2, 0, 1))) * -0.5
    tmp4 += np.transpose(r2, (2, 1, 0))
    tmp21 = np.copy(ints.tmp37) * 2
    del ints.tmp37
    tmp21 += np.transpose(v.xov, (1, 2, 0))
    tmp21 += ints.tmp34 * -1
    del ints.tmp34
    tmp26 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -0.5
    tmp26 += t2
    tmp23 = einsum(f.ov, (0, 1), t1, (0, 2), (1, 2))
    tmp11 = einsum(tmp10, (0, 1, 2), t1, (3, 2), (0, 3, 1))
    del tmp10
    tmp15 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp15 += t2 * 2
    tmp0 = np.copy(np.transpose(r2, (2, 0, 1)))
    tmp0 += np.transpose(r2, (2, 1, 0)) * -0.5
    tmp22 = einsum(tmp4, (0, 1, 2), tmp21, (0, 2, 3), (1, 3)) * 2
    del tmp21
    tmp19 = np.copy(ints.tmp107)
    tmp19 += ints.tmp29 * 0.5
    tmp19 += ints.tmp105 * -0.5
    tmp27 = einsum(r2, (0, 1, 2), tmp26, (2, 3, 0, 1), (3,))
    del tmp26
    tmp24 = np.copy(ints.tmp38) * 2
    tmp24 += f.vv * -1
    tmp24 += ints.tmp35 * -1
    tmp24 += np.transpose(tmp23, (1, 0))
    del tmp23
    tmp18 = einsum(t2, (0, 1, 2, 3), r2, (2, 3, 4), (4, 0, 1))
    tmp20 = np.copy(ints.tmp105)
    tmp20 += ints.tmp29 * -1
    tmp25 = np.copy(f.oo)
    tmp25 += np.transpose(ints.tmp10, (1, 0))
    del ints.tmp10
    tmp25 += ints.tmp92 * 2
    del ints.tmp92
    tmp25 += ints.tmp96 * -1
    del ints.tmp96
    tmp9 = np.copy(ints.tmp114) * 2
    del ints.tmp114
    tmp9 += ints.tmp11
    del ints.tmp11
    tmp9 += ints.tmp123
    del ints.tmp123
    tmp9 += ints.tmp133 * 2
    del ints.tmp133
    tmp9 += ints.tmp1
    del ints.tmp1
    tmp9 += ints.tmp23
    del ints.tmp23
    tmp9 += ints.tmp3
    del ints.tmp3
    tmp9 += ints.tmp44 * 2
    del ints.tmp44
    tmp9 += ints.tmp53
    del ints.tmp53
    tmp9 += ints.tmp69 * 2
    del ints.tmp69
    tmp9 += ints.tmp72 * 2
    del ints.tmp72
    tmp9 += ints.tmp83 * 2
    del ints.tmp83
    tmp9 += ints.tmp93 * 2
    del ints.tmp93
    tmp9 += f.ov * -1
    tmp9 += ints.tmp111 * -1
    del ints.tmp111
    tmp9 += ints.tmp120 * -2
    del ints.tmp120
    tmp9 += ints.tmp130 * -1
    del ints.tmp130
    tmp9 += ints.tmp20 * -2
    tmp9 += ints.tmp2 * -1
    del ints.tmp2
    tmp9 += ints.tmp41 * -1
    del ints.tmp41
    tmp9 += ints.tmp4 * -2
    del ints.tmp4
    tmp9 += ints.tmp50 * -2
    del ints.tmp50
    tmp9 += ints.tmp67 * -1
    del ints.tmp67
    tmp9 += ints.tmp75 * -4
    del ints.tmp75
    tmp9 += ints.tmp86 * -1
    del ints.tmp86
    tmp9 += ints.tmp97 * -1
    del ints.tmp97
    tmp13 = np.copy(tmp11) * -1
    tmp13 += np.transpose(tmp11, (0, 2, 1)) * 2
    tmp17 = np.copy(f.ov)
    tmp17 += ints.tmp20 * 2
    del ints.tmp20
    tmp17 += ints.tmp66 * -1
    del ints.tmp66
    tmp6 = np.copy(np.transpose(ints.tmp125, (0, 1, 3, 2)))
    del ints.tmp125
    tmp6 += np.transpose(ints.tmp29, (0, 1, 3, 2))
    del ints.tmp29
    tmp6 += ints.tmp105 * -1
    del ints.tmp105
    tmp8 = np.copy(ints.tmp102) * 2
    del ints.tmp102
    tmp8 += np.transpose(ints.tmp127, (0, 1, 3, 2))
    del ints.tmp127
    tmp8 += ints.tmp25
    tmp8 += ints.tmp100 * -1
    del ints.tmp100
    tmp8 += ints.tmp107 * -1
    tmp16 = einsum(r1, (0,), t1, (1, 0), (1,))
    tmp16 += einsum(tmp15, (0, 1, 2, 3), r2, (2, 3, 0), (1,)) * -1
    del tmp15
    tmp2 = np.copy(np.transpose(r2, (2, 0, 1))) * -1
    tmp2 += np.transpose(r2, (2, 1, 0)) * 2
    tmp1 = np.copy(ints.tmp12)
    tmp1 += ints.tmp31
    del ints.tmp31
    tmp1 += np.transpose(ints.tmp89, (0, 3, 1, 2))
    del ints.tmp89
    tmp1 += np.transpose(ints.tmp61, (0, 2, 1, 3)) * -1
    del ints.tmp61
    tmp7 = einsum(t1, (0, 1), tmp0, (2, 3, 1), (2, 0, 3)) * 2
    tmp3 = np.copy(ints.tmp47)
    del ints.tmp47
    tmp3 += ints.tmp58 * 2
    del ints.tmp58
    tmp3 += ints.tmp56 * -1
    del ints.tmp56
    tmp3 += np.transpose(ints.tmp63, (0, 1, 3, 2)) * -1
    del ints.tmp63
    tmp5 = einsum(t1, (0, 1), tmp4, (2, 3, 1), (2, 0, 3))
    del tmp4
    tmp14 = np.copy(f.vv)
    tmp14 += np.transpose(ints.tmp16, (1, 0)) * 2
    del ints.tmp16
    tmp14 += ints.tmp35
    del ints.tmp35
    tmp14 += np.transpose(ints.tmp19, (1, 0)) * -1
    del ints.tmp19
    tmp14 += ints.tmp38 * -2
    del ints.tmp38
    tmp12 = np.copy(tmp11)
    tmp12 += np.transpose(tmp11, (0, 2, 1)) * -0.5
    del tmp11
    r2new = einsum(ints.tmp107, (0, 1, 2, 3), r2, (4, 2, 0), (3, 4, 1))
    del ints.tmp107
    r2new += einsum(f.ov, (0, 1), r1, (2,), (1, 2, 0)) * -1
    r2new += einsum(ints.tmp12, (0, 1, 2, 3), r1, (2,), (3, 1, 0)) * -1
    del ints.tmp12
    r2new += einsum(r2, (0, 1, 2), ints.tmp152, (3, 4, 0, 1), (4, 3, 2))
    del ints.tmp152
    r2new += einsum(ints.tmp25, (0, 1, 2, 3), tmp18, (4, 1, 0), (3, 2, 4))
    del tmp18
    r2new += einsum(tmp19, (0, 1, 2, 3), r2, (2, 4, 0), (3, 4, 1)) * -2
    del tmp19
    r2new += einsum(r2, (0, 1, 2), tmp20, (2, 3, 1, 4), (0, 4, 3))
    del tmp20
    r2new += einsum(v.xov, (0, 1, 2), tmp22, (3, 0), (2, 3, 1))
    del tmp22
    r2new += einsum(r2, (0, 1, 2), tmp24, (0, 3), (3, 1, 2)) * -1
    r2new += einsum(tmp24, (0, 1), r2, (2, 0, 3), (2, 1, 3)) * -1
    del tmp24
    r2new += einsum(r2, (0, 1, 2), tmp25, (2, 3), (0, 1, 3)) * -1
    del tmp25
    r2new += einsum(tmp27, (0,), ints.tmp25, (0, 1, 2, 3), (3, 2, 1)) * -2
    del ints.tmp25, tmp27
    r1new = einsum(tmp0, (0, 1, 2), tmp1, (0, 3, 2, 1), (3,)) * -2
    del tmp0, tmp1
    r1new += einsum(tmp2, (0, 1, 2), tmp3, (0, 2, 1, 3), (3,)) * -1
    del tmp3
    r1new += einsum(tmp6, (0, 1, 2, 3), tmp5, (0, 1, 2), (3,)) * 2
    del tmp6, tmp5
    r1new += einsum(tmp7, (0, 1, 2), tmp8, (0, 1, 2, 3), (3,))
    del tmp7, tmp8
    r1new += einsum(tmp2, (0, 1, 2), tmp9, (0, 2), (1,))
    del tmp2, tmp9
    r1new += einsum(ints.tmp82, (0, 1, 2, 3), tmp12, (0, 2, 1), (3,)) * -2
    del ints.tmp82, tmp12
    r1new += einsum(ints.tmp40, (0, 1, 2, 3), tmp13, (0, 2, 1), (3,)) * -1
    del ints.tmp40, tmp13
    r1new += einsum(tmp14, (0, 1), r1, (0,), (1,))
    del tmp14
    r1new += einsum(tmp16, (0,), tmp17, (0, 1), (1,)) * -1
    del tmp16, tmp17

    return {f"r1new": r1new, f"r2new": r2new}

