"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T15:58:14.102514
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:58:15.239579.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp3 = einsum(v.xov, (0, 1, 2), t1, (3, 2), (3, 1, 0))
    tmp0 = einsum(t1, (0, 1), v.xov, (2, 0, 1), (2,))
    tmp1 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp1 += t2 * -1
    tmp4 = np.copy(f.ov) * 2
    tmp4 += einsum(v.xov, (0, 1, 2), tmp3, (1, 3, 0), (3, 2)) * -1
    del tmp3
    tmp2 = einsum(tmp0, (0,), t1, (1, 2), (1, 2, 0))
    del tmp0
    tmp2 += einsum(tmp1, (0, 1, 2, 3), v.xov, (4, 0, 3), (1, 2, 4)) * 0.5
    del tmp1
    e_cc = einsum(tmp2, (0, 1, 2), v.xov, (2, 0, 1), ()) * 2
    del tmp2
    e_cc += einsum(tmp4, (0, 1), t1, (0, 1), ())
    del tmp4

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:58:52.991307.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    t1new : array
        Updated T1 residuals.
    t2new : array
        Updated T2 residuals.
    """

    tmp2 = einsum(v.xov, (0, 1, 2), t1, (3, 2), (3, 1, 0))
    tmp0 = einsum(t1, (0, 1), v.xov, (2, 0, 1), (2,))
    tmp17 = einsum(t2, (0, 1, 2, 3), v.xov, (4, 1, 2), (0, 3, 4))
    tmp37 = einsum(v.xov, (0, 1, 2), tmp2, (3, 4, 0), (3, 1, 4, 2))
    tmp44 = np.copy(t2)
    tmp44 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    tmp9 = einsum(v.xov, (0, 1, 2), tmp2, (1, 3, 0), (3, 2))
    tmp1 = einsum(tmp0, (0,), v.xov, (0, 1, 2), (1, 2))
    tmp39 = einsum(v.xov, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp18 = einsum(v.xov, (0, 1, 2), v.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp52 = np.copy(np.transpose(v.xov, (1, 2, 0)))
    tmp52 += tmp17 * -1
    tmp21 = einsum(t1, (0, 1), v.xvv, (2, 3, 1), (0, 3, 2))
    tmp64 = np.copy(tmp37) * 2
    tmp64 += np.transpose(tmp37, (0, 2, 1, 3)) * -1
    tmp5 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp5 += t2 * -1
    tmp45 = einsum(tmp44, (0, 1, 2, 3), v.xov, (4, 0, 3), (1, 2, 4))
    del tmp44
    tmp42 = np.copy(tmp1) * 2
    tmp42 += tmp9 * -1
    tmp40 = np.copy(np.transpose(tmp39, (1, 0, 2, 3))) * 2
    tmp40 += np.transpose(tmp39, (1, 2, 0, 3)) * -1
    tmp11 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp11 += t2 * -1
    tmp30 = einsum(v.xvv, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp19 = einsum(tmp18, (0, 1, 2, 3), t2, (4, 0, 3, 5), (4, 1, 5, 2))
    tmp53 = einsum(tmp52, (0, 1, 2), v.xov, (2, 3, 4), (0, 3, 1, 4))
    del tmp52
    tmp58 = einsum(tmp0, (0,), v.xvv, (0, 1, 2), (1, 2))
    tmp59 = einsum(tmp21, (0, 1, 2), v.xov, (2, 0, 3), (3, 1))
    tmp68 = einsum(v.xoo, (0, 1, 2), tmp2, (2, 3, 0), (1, 3))
    tmp12 = einsum(tmp0, (0,), v.xoo, (0, 1, 2), (1, 2))
    tmp63 = einsum(tmp17, (0, 1, 2), tmp2, (3, 4, 2), (3, 0, 4, 1))
    tmp65 = einsum(t2, (0, 1, 2, 3), tmp64, (4, 1, 5, 3), (4, 5, 0, 2))
    del tmp64
    tmp62 = einsum(tmp39, (0, 1, 2, 3), t2, (4, 1, 3, 5), (4, 0, 2, 5))
    del tmp39
    tmp6 = einsum(v.xoo, (0, 1, 2), t1, (2, 3), (1, 3, 0))
    tmp72 = einsum(v.xov, (0, 1, 2), v.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp13 = einsum(tmp5, (0, 1, 2, 3), v.xov, (4, 0, 3), (1, 2, 4))
    tmp38 = einsum(tmp37, (0, 1, 2, 3), t2, (4, 2, 3, 5), (0, 4, 1, 5))
    del tmp37
    tmp46 = einsum(tmp45, (0, 1, 2), v.xoo, (2, 3, 4), (0, 3, 4, 1))
    tmp43 = einsum(t2, (0, 1, 2, 3), tmp42, (4, 2), (4, 0, 1, 3))
    tmp41 = einsum(tmp40, (0, 1, 2, 3), t2, (4, 2, 5, 3), (0, 1, 4, 5))
    del tmp40
    tmp34 = einsum(v.xov, (0, 1, 2), tmp11, (1, 3, 4, 2), (3, 4, 0))
    tmp54 = np.copy(np.transpose(tmp30, (1, 0, 3, 2)))
    tmp54 += tmp19 * -1
    tmp54 += tmp53 * -2
    del tmp53
    tmp60 = np.copy(np.transpose(tmp58, (1, 0))) * 2
    del tmp58
    tmp60 += tmp59 * -1
    del tmp59
    tmp69 = np.copy(np.transpose(tmp68, (1, 0))) * -1
    del tmp68
    tmp69 += np.transpose(tmp12, (1, 0)) * 2
    tmp66 = np.copy(tmp62)
    del tmp62
    tmp66 += tmp63
    del tmp63
    tmp66 += np.transpose(tmp65, (0, 2, 1, 3)) * -1
    del tmp65
    tmp56 = np.copy(tmp6)
    tmp56 += tmp45
    del tmp45
    tmp73 = einsum(tmp72, (0, 1, 2, 3), t2, (4, 5, 3, 2), (4, 5, 0, 1))
    del tmp72
    tmp77 = einsum(v.xov, (0, 1, 2), tmp13, (3, 2, 0), (3, 1))
    tmp75 = einsum(v.xov, (0, 1, 2), tmp13, (1, 3, 0), (3, 2)) * 0.5
    tmp47 = np.copy(np.transpose(tmp38, (0, 2, 1, 3)))
    del tmp38
    tmp47 += np.transpose(tmp41, (2, 1, 0, 3)) * -1
    del tmp41
    tmp47 += np.transpose(tmp43, (2, 0, 1, 3)) * -1
    del tmp43
    tmp47 += np.transpose(tmp46, (0, 2, 1, 3))
    del tmp46
    tmp35 = np.copy(np.transpose(v.xov, (1, 2, 0)))
    tmp35 += tmp6 * -1
    tmp35 += tmp34
    del tmp34
    tmp32 = einsum(v.xvv, (0, 1, 2), tmp2, (3, 4, 0), (3, 4, 1, 2))
    tmp49 = einsum(tmp42, (0, 1), t1, (2, 1), (0, 2))
    del tmp42
    tmp82 = einsum(tmp21, (0, 1, 2), tmp2, (3, 4, 2), (3, 0, 4, 1))
    tmp26 = einsum(v.xoo, (0, 1, 2), tmp2, (3, 4, 0), (3, 1, 2, 4))
    tmp22 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp24 = einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp55 = einsum(tmp54, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp54
    tmp61 = einsum(t2, (0, 1, 2, 3), tmp60, (2, 4), (0, 1, 4, 3))
    del tmp60
    tmp70 = einsum(t2, (0, 1, 2, 3), tmp69, (1, 4), (4, 0, 3, 2))
    del tmp69
    tmp67 = einsum(tmp66, (0, 1, 2, 3), t1, (2, 4), (0, 1, 3, 4))
    del tmp66
    tmp57 = einsum(tmp56, (0, 1, 2), v.xov, (2, 3, 4), (0, 3, 1, 4))
    del tmp56
    tmp74 = einsum(t1, (0, 1), tmp73, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp73
    tmp78 = einsum(tmp77, (0, 1), t2, (2, 1, 3, 4), (0, 2, 4, 3))
    del tmp77
    tmp76 = einsum(tmp75, (0, 1), t2, (2, 3, 1, 4), (2, 3, 0, 4)) * 2
    del tmp75
    tmp48 = einsum(tmp47, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    del tmp47
    tmp36 = einsum(tmp21, (0, 1, 2), tmp35, (3, 4, 2), (0, 3, 1, 4))
    del tmp35
    tmp33 = einsum(t2, (0, 1, 2, 3), tmp32, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp29 = einsum(f.vv, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp50 = einsum(t2, (0, 1, 2, 3), tmp49, (1, 4), (4, 0, 3, 2))
    del tmp49
    tmp31 = einsum(tmp30, (0, 1, 2, 3), t2, (4, 1, 3, 5), (4, 0, 5, 2))
    del tmp30
    tmp81 = einsum(tmp32, (0, 1, 2, 3), t2, (4, 1, 3, 5), (0, 4, 5, 2))
    del tmp32
    tmp83 = einsum(t1, (0, 1), tmp82, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp82
    tmp27 = einsum(tmp26, (0, 1, 2, 3), t2, (1, 3, 4, 5), (0, 2, 4, 5))
    del tmp26
    tmp23 = einsum(t2, (0, 1, 2, 3), tmp22, (1, 4), (4, 0, 2, 3))
    del tmp22
    tmp25 = einsum(t1, (0, 1), tmp24, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp24
    tmp87 = einsum(tmp18, (0, 1, 2, 3), t1, (1, 4), (0, 4, 2, 3))
    tmp89 = np.copy(np.transpose(tmp18, (1, 0, 2, 3))) * -1
    tmp89 += np.transpose(tmp18, (1, 0, 3, 2)) * 2
    tmp3 = np.copy(np.transpose(v.xoo, (1, 2, 0)))
    tmp3 += np.transpose(tmp2, (1, 0, 2))
    tmp7 = einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 0.5
    tmp7 += np.transpose(t2, (0, 1, 3, 2)) * -1
    tmp7 += t2 * 0.5
    tmp15 = np.copy(f.ov)
    tmp15 += tmp9 * -1
    tmp14 = np.copy(tmp6) * -1
    tmp14 += einsum(tmp0, (0,), t1, (1, 2), (1, 2, 0)) * 2
    tmp14 += tmp13
    del tmp13
    tmp71 = np.copy(np.transpose(tmp55, (1, 0, 3, 2)))
    del tmp55
    tmp71 += tmp57
    del tmp57
    tmp71 += np.transpose(tmp61, (1, 0, 3, 2)) * -1
    del tmp61
    tmp71 += np.transpose(tmp67, (0, 1, 3, 2)) * -1
    del tmp67
    tmp71 += np.transpose(tmp70, (1, 0, 3, 2))
    del tmp70
    tmp79 = np.copy(tmp74)
    del tmp74
    tmp79 += np.transpose(tmp76, (1, 0, 3, 2))
    del tmp76
    tmp79 += np.transpose(tmp78, (1, 0, 3, 2))
    del tmp78
    tmp51 = np.copy(tmp29)
    del tmp29
    tmp51 += tmp31 * -1
    del tmp31
    tmp51 += tmp33 * -1
    del tmp33
    tmp51 += np.transpose(tmp36, (0, 1, 3, 2))
    del tmp36
    tmp51 += np.transpose(tmp48, (0, 1, 3, 2))
    del tmp48
    tmp51 += np.transpose(tmp50, (0, 1, 3, 2)) * -1
    del tmp50
    tmp84 = np.copy(tmp81)
    del tmp81
    tmp84 += tmp83
    del tmp83
    tmp28 = np.copy(tmp23)
    del tmp23
    tmp28 += tmp25
    del tmp25
    tmp28 += tmp27 * -1
    del tmp27
    tmp88 = einsum(v.xvv, (0, 1, 2), v.xvv, (0, 3, 4), (3, 1, 2, 4))
    tmp88 += einsum(t1, (0, 1), tmp87, (0, 2, 3, 4), (4, 1, 3, 2))
    del tmp87
    tmp90 = einsum(t2, (0, 1, 2, 3), tmp89, (1, 4, 3, 5), (0, 4, 2, 5))
    del tmp89
    tmp80 = einsum(t2, (0, 1, 2, 3), f.oo, (4, 1), (4, 0, 2, 3))
    tmp20 = einsum(t2, (0, 1, 2, 3), tmp18, (4, 5, 3, 2), (0, 1, 5, 4))
    tmp86 = np.copy(t2)
    tmp86 += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    tmp85 = einsum(v.xoo, (0, 1, 2), v.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp85 += einsum(tmp2, (0, 1, 2), tmp2, (3, 4, 2), (4, 0, 1, 3))
    del tmp2
    tmp4 = einsum(v.xov, (0, 1, 2), tmp3, (3, 4, 0), (4, 1, 3, 2))
    del tmp3
    tmp10 = np.copy(f.ov)
    tmp10 += tmp1 * 2
    tmp10 += tmp9 * -1
    del tmp9
    tmp8 = np.copy(tmp6)
    del tmp6
    tmp8 += einsum(tmp0, (0,), t1, (1, 2), (1, 2, 0)) * -2
    del tmp0
    tmp8 += einsum(v.xov, (0, 1, 2), tmp7, (1, 3, 4, 2), (3, 4, 0)) * 2
    del tmp7
    tmp16 = np.copy(f.oo)
    tmp16 += np.transpose(tmp12, (1, 0)) * 2
    del tmp12
    tmp16 += einsum(tmp14, (0, 1, 2), v.xov, (2, 3, 1), (3, 0))
    del tmp14
    tmp16 += einsum(tmp15, (0, 1), t1, (2, 1), (0, 2))
    del tmp15
    t2new = einsum(tmp17, (0, 1, 2), tmp17, (3, 4, 2), (0, 3, 1, 4))
    del tmp17
    t2new += einsum(tmp19, (0, 1, 2, 3), t2, (4, 1, 3, 5), (4, 0, 2, 5))
    del tmp19
    t2new += einsum(t2, (0, 1, 2, 3), tmp20, (4, 5, 0, 1), (5, 4, 3, 2))
    del tmp20
    t2new += np.transpose(tmp18, (1, 0, 3, 2))
    del tmp18
    t2new += einsum(tmp21, (0, 1, 2), tmp21, (3, 4, 2), (0, 3, 1, 4))
    del tmp21
    t2new += np.transpose(tmp28, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp28, (1, 0, 2, 3)) * -1
    del tmp28
    t2new += np.transpose(tmp51, (0, 1, 3, 2))
    t2new += np.transpose(tmp51, (1, 0, 2, 3))
    del tmp51
    t2new += tmp71 * -1
    t2new += np.transpose(tmp71, (1, 0, 3, 2)) * -1
    del tmp71
    t2new += tmp79 * -1
    t2new += np.transpose(tmp79, (1, 0, 3, 2)) * -1
    del tmp79
    t2new += np.transpose(tmp80, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp80, (1, 0, 2, 3)) * -1
    del tmp80
    t2new += tmp84 * -1
    t2new += np.transpose(tmp84, (1, 0, 3, 2)) * -1
    del tmp84
    t2new += einsum(tmp85, (0, 1, 2, 3), tmp86, (0, 2, 4, 5), (1, 3, 5, 4))
    del tmp85, tmp86
    t2new += einsum(tmp88, (0, 1, 2, 3), t2, (4, 5, 2, 0), (4, 5, 1, 3))
    del tmp88
    t2new += einsum(tmp90, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 2, 5)) * 2
    del tmp90
    t1new = np.copy(f.ov)
    t1new += tmp1 * 2
    del tmp1
    t1new += einsum(t1, (0, 1), f.vv, (2, 1), (0, 2))
    t1new += einsum(tmp4, (0, 1, 2, 3), tmp5, (1, 2, 4, 3), (0, 4)) * -1
    del tmp5, tmp4
    t1new += einsum(v.xvv, (0, 1, 2), tmp8, (3, 2, 0), (3, 1)) * -1
    del tmp8
    t1new += einsum(tmp10, (0, 1), tmp11, (0, 2, 3, 1), (2, 3))
    del tmp11, tmp10
    t1new += einsum(tmp16, (0, 1), t1, (0, 2), (1, 2)) * -1
    del tmp16

    return {f"t1new": t1new, f"t2new": t2new}

def update_lams(f=None, l1=None, l2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:00:11.425062.

    Parameters
    ----------
    f : array
        Fock matrix.
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    l1new : array
        Updated L1 residuals.
    l2new : array
        Updated L2 residuals.
    """

    tmp9 = einsum(t1, (0, 1), v.xov, (2, 0, 1), (2,))
    tmp11 = einsum(v.xov, (0, 1, 2), t1, (3, 2), (3, 1, 0))
    tmp89 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp89 += t2 * -1
    tmp17 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -0.5
    tmp17 += t2
    tmp10 = einsum(tmp9, (0,), v.xov, (0, 1, 2), (1, 2))
    tmp12 = einsum(tmp11, (0, 1, 2), v.xov, (2, 0, 3), (1, 3))
    tmp34 = einsum(l2, (0, 1, 2, 3), t1, (4, 1), (2, 3, 4, 0))
    tmp93 = einsum(tmp89, (0, 1, 2, 3), v.xov, (4, 0, 3), (1, 2, 4))
    tmp0 = einsum(t1, (0, 1), v.xvv, (2, 3, 1), (0, 3, 2))
    tmp18 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp18 += t2 * -1
    tmp5 = einsum(v.xov, (0, 1, 2), v.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp78 = np.copy(np.transpose(v.xoo, (1, 2, 0)))
    tmp78 += np.transpose(tmp11, (1, 0, 2))
    tmp48 = einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    tmp49 = einsum(tmp17, (0, 1, 2, 3), l2, (2, 3, 0, 4), (4, 1))
    tmp103 = np.copy(tmp10) * 2
    tmp103 += tmp12 * -1
    tmp97 = np.copy(tmp34) * -1
    tmp97 += np.transpose(tmp34, (1, 0, 2, 3)) * 2
    tmp99 = np.copy(tmp34) * 2
    tmp99 += np.transpose(tmp34, (1, 0, 2, 3)) * -1
    tmp95 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * 2
    tmp95 += np.transpose(l2, (2, 3, 0, 1)) * -1
    tmp94 = np.copy(np.transpose(v.xov, (1, 2, 0)))
    tmp94 += tmp0
    tmp94 += tmp93
    del tmp93
    tmp19 = einsum(v.xov, (0, 1, 2), tmp18, (1, 3, 4, 2), (3, 4, 0))
    tmp77 = einsum(tmp5, (0, 1, 2, 3), t2, (4, 1, 2, 5), (4, 0, 5, 3))
    tmp79 = einsum(tmp78, (0, 1, 2), v.xvv, (2, 3, 4), (0, 1, 3, 4))
    del tmp78
    tmp37 = einsum(tmp17, (0, 1, 2, 3), l2, (4, 2, 1, 0), (4, 3)) * 2
    tmp50 = np.copy(tmp48) * 0.5
    tmp50 += tmp49
    del tmp49
    tmp90 = einsum(tmp5, (0, 1, 2, 3), tmp89, (0, 4, 5, 3), (1, 4, 2, 5))
    del tmp89
    tmp61 = einsum(v.xoo, (0, 1, 2), tmp11, (2, 3, 0), (1, 3))
    tmp104 = einsum(t1, (0, 1), tmp103, (2, 1), (0, 2))
    tmp98 = einsum(v.xoo, (0, 1, 2), tmp97, (1, 3, 2, 4), (3, 4, 0))
    del tmp97
    tmp100 = einsum(tmp99, (0, 1, 2, 3), tmp11, (1, 2, 4), (0, 3, 4))
    del tmp99
    tmp96 = einsum(tmp94, (0, 1, 2), tmp95, (0, 3, 4, 1), (3, 4, 2))
    del tmp94, tmp95
    tmp60 = einsum(tmp9, (0,), v.xoo, (0, 1, 2), (1, 2))
    tmp117 = einsum(tmp19, (0, 1, 2), v.xov, (2, 3, 1), (3, 0)) * 0.5
    tmp6 = einsum(tmp5, (0, 1, 2, 3), t2, (4, 5, 2, 3), (4, 5, 0, 1))
    tmp3 = einsum(v.xov, (0, 1, 2), v.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp26 = einsum(tmp11, (0, 1, 2), tmp11, (3, 4, 2), (0, 3, 1, 4))
    tmp73 = einsum(v.xov, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp123 = einsum(tmp0, (0, 1, 2), v.xov, (2, 0, 3), (3, 1))
    tmp70 = einsum(v.xvv, (0, 1, 2), l1, (2, 3), (3, 1, 0))
    tmp75 = einsum(v.xov, (0, 1, 2), tmp11, (3, 4, 0), (3, 1, 4, 2))
    tmp67 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp80 = np.copy(tmp77) * -1
    del tmp77
    tmp80 += np.transpose(tmp79, (1, 0, 3, 2))
    tmp22 = einsum(v.xoo, (0, 1, 2), tmp11, (3, 4, 0), (3, 1, 2, 4))
    tmp112 = einsum(v.xov, (0, 1, 2), tmp37, (3, 2), (1, 3, 0)) * 0.5
    tmp110 = einsum(tmp50, (0, 1), v.xov, (2, 1, 3), (0, 3, 2)) * 2
    tmp91 = np.copy(np.transpose(tmp90, (1, 0, 3, 2)))
    del tmp90
    tmp91 += np.transpose(tmp79, (1, 0, 3, 2))
    del tmp79
    tmp105 = np.copy(tmp61)
    tmp105 += tmp104 * -1
    del tmp104
    tmp63 = einsum(tmp9, (0,), v.xvv, (0, 1, 2), (1, 2))
    del tmp9
    tmp86 = einsum(t2, (0, 1, 2, 3), l2, (4, 3, 1, 5), (5, 0, 4, 2))
    tmp101 = np.copy(tmp96) * -1
    del tmp96
    tmp101 += tmp98
    del tmp98
    tmp101 += tmp100
    del tmp100
    tmp118 = np.copy(np.transpose(tmp60, (1, 0)))
    tmp118 += np.transpose(tmp117, (1, 0))
    del tmp117
    tmp115 = einsum(tmp19, (0, 1, 2), v.xov, (2, 0, 3), (3, 1)) * 0.5
    tmp7 = einsum(t1, (0, 1), tmp6, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp4 = einsum(t2, (0, 1, 2, 3), tmp3, (4, 3, 5, 2), (0, 1, 4, 5))
    tmp13 = np.copy(tmp10) * 2
    tmp13 += tmp12 * -1
    tmp21 = einsum(v.xoo, (0, 1, 2), v.xoo, (0, 3, 4), (3, 1, 2, 4))
    tmp15 = np.copy(np.transpose(v.xoo, (1, 2, 0)))
    tmp15 += np.transpose(tmp11, (1, 0, 2))
    tmp55 = np.copy(tmp48)
    tmp55 += einsum(tmp17, (0, 1, 2, 3), l2, (2, 3, 0, 4), (4, 1)) * 2
    tmp54 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp54 += t2 * 2
    tmp29 = np.copy(np.transpose(t2, (0, 1, 3, 2)))
    tmp29 += t2 * -0.5
    tmp45 = einsum(l2, (0, 1, 2, 3), t2, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp46 = einsum(tmp34, (0, 1, 2, 3), t1, (4, 3), (1, 0, 2, 4))
    tmp43 = np.copy(tmp34) * 2
    tmp43 += np.transpose(tmp34, (1, 0, 2, 3)) * -1
    tmp41 = np.copy(tmp34) * -0.5
    tmp41 += np.transpose(tmp34, (1, 0, 2, 3))
    tmp42 = einsum(t2, (0, 1, 2, 3), l1, (3, 4), (4, 0, 1, 2))
    tmp27 = einsum(t1, (0, 1), tmp26, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp25 = einsum(tmp0, (0, 1, 2), tmp11, (3, 4, 2), (3, 0, 4, 1))
    tmp122 = einsum(tmp73, (0, 1, 2, 3), l1, (4, 1), (0, 2, 4, 3))
    tmp124 = einsum(tmp123, (0, 1), l2, (2, 1, 3, 4), (3, 4, 2, 0))
    del tmp123
    tmp74 = einsum(tmp34, (0, 1, 2, 3), tmp73, (4, 0, 2, 5), (1, 4, 3, 5))
    tmp71 = einsum(v.xov, (0, 1, 2), tmp70, (3, 4, 0), (3, 1, 2, 4))
    del tmp70
    tmp66 = einsum(f.vv, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp76 = einsum(tmp75, (0, 1, 2, 3), tmp34, (0, 4, 1, 5), (4, 2, 5, 3))
    tmp68 = einsum(l2, (0, 1, 2, 3), tmp67, (4, 3), (4, 2, 0, 1))
    del tmp67
    tmp81 = einsum(tmp80, (0, 1, 2, 3), l2, (4, 2, 0, 5), (5, 1, 4, 3))
    del tmp80
    tmp72 = einsum(l2, (0, 1, 2, 3), tmp22, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp69 = einsum(tmp34, (0, 1, 2, 3), f.ov, (2, 4), (0, 1, 4, 3))
    tmp113 = einsum(v.xov, (0, 1, 2), tmp112, (3, 4, 0), (1, 3, 2, 4)) * 2
    del tmp112
    tmp109 = einsum(l1, (0, 1), tmp75, (1, 2, 3, 4), (2, 3, 0, 4))
    tmp111 = einsum(tmp110, (0, 1, 2), v.xov, (2, 3, 4), (3, 0, 4, 1))
    del tmp110
    tmp107 = einsum(tmp34, (0, 1, 2, 3), tmp103, (2, 4), (0, 1, 3, 4))
    tmp85 = einsum(tmp34, (0, 1, 2, 3), tmp3, (2, 4, 3, 5), (1, 0, 5, 4))
    del tmp3
    tmp92 = einsum(l2, (0, 1, 2, 3), tmp91, (3, 4, 1, 5), (2, 4, 0, 5))
    del tmp91
    tmp106 = einsum(l2, (0, 1, 2, 3), tmp105, (2, 4), (3, 4, 0, 1))
    del tmp105
    tmp88 = einsum(tmp34, (0, 1, 2, 3), tmp75, (1, 2, 4, 5), (0, 4, 3, 5))
    del tmp75
    tmp84 = einsum(l2, (0, 1, 2, 3), tmp63, (4, 1), (2, 3, 0, 4))
    tmp87 = einsum(tmp5, (0, 1, 2, 3), tmp86, (4, 0, 5, 3), (4, 1, 5, 2))
    del tmp86
    tmp102 = einsum(tmp101, (0, 1, 2), v.xov, (2, 3, 4), (3, 0, 4, 1))
    del tmp101
    tmp83 = einsum(tmp34, (0, 1, 2, 3), tmp73, (4, 1, 2, 5), (0, 4, 3, 5))
    del tmp73
    tmp119 = einsum(l2, (0, 1, 2, 3), tmp118, (2, 4), (3, 4, 0, 1)) * 2
    del tmp118
    tmp116 = einsum(l2, (0, 1, 2, 3), tmp115, (4, 1), (3, 2, 0, 4)) * 2
    del tmp115
    tmp59 = np.copy(f.ov)
    tmp59 += tmp10 * 2
    del tmp10
    tmp59 += tmp12 * -1
    del tmp12
    tmp35 = np.copy(tmp34) * -1
    tmp35 += np.transpose(tmp34, (1, 0, 2, 3)) * 2
    tmp32 = np.copy(np.transpose(v.xov, (1, 2, 0)))
    tmp32 += tmp0
    tmp32 += tmp19
    tmp36 = np.copy(tmp34)
    tmp36 += np.transpose(tmp34, (1, 0, 2, 3)) * -0.5
    tmp33 = np.copy(np.transpose(l2, (3, 2, 0, 1)))
    tmp33 += np.transpose(l2, (2, 3, 0, 1)) * -0.5
    tmp38 = np.copy(np.transpose(v.xoo, (1, 2, 0)))
    tmp38 += tmp11
    tmp8 = np.copy(tmp4)
    del tmp4
    tmp8 += tmp7 * -1
    del tmp7
    tmp2 = einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp1 = einsum(v.xoo, (0, 1, 2), tmp0, (3, 4, 0), (3, 1, 2, 4))
    tmp14 = einsum(t2, (0, 1, 2, 3), tmp13, (4, 2), (0, 1, 4, 3)) * 2
    del tmp13
    tmp23 = np.copy(np.transpose(tmp21, (3, 2, 1, 0)))
    tmp23 += np.transpose(tmp22, (1, 0, 3, 2))
    tmp23 += np.transpose(tmp22, (3, 0, 2, 1)) * -2
    tmp20 = np.copy(np.transpose(v.xov, (1, 2, 0)))
    tmp20 += tmp19
    tmp16 = einsum(tmp15, (0, 1, 2), v.xov, (2, 3, 4), (3, 0, 1, 4))
    tmp56 = np.copy(np.transpose(l1, (1, 0)))
    tmp56 += t1
    tmp56 += einsum(tmp54, (0, 1, 2, 3), tmp34, (1, 0, 4, 3), (4, 2)) * -1
    tmp56 += einsum(l1, (0, 1), tmp29, (1, 2, 3, 0), (2, 3)) * 2
    tmp56 += einsum(tmp55, (0, 1), t1, (0, 2), (1, 2)) * -1
    del tmp55
    tmp57 = np.copy(tmp48)
    del tmp48
    tmp57 += einsum(l2, (0, 1, 2, 3), tmp54, (2, 4, 0, 1), (4, 3))
    del tmp54
    tmp53 = einsum(t1, (0, 1), l1, (2, 0), (2, 1)) * 0.5
    tmp53 += einsum(tmp17, (0, 1, 2, 3), l2, (4, 2, 1, 0), (4, 3))
    tmp47 = np.copy(np.transpose(tmp45, (1, 0, 2, 3))) * 2
    tmp47 += np.transpose(tmp45, (1, 0, 3, 2)) * -1
    tmp47 += tmp46 * -1
    tmp47 += np.transpose(tmp46, (0, 1, 3, 2)) * 2
    tmp51 = np.copy(t1) * -0.5
    tmp51 += einsum(tmp17, (0, 1, 2, 3), tmp34, (1, 0, 4, 3), (4, 2))
    del tmp34
    tmp51 += einsum(l1, (0, 1), tmp18, (1, 2, 3, 0), (2, 3)) * -0.5
    tmp51 += einsum(t1, (0, 1), tmp50, (0, 2), (2, 1))
    tmp44 = np.copy(tmp42) * -1
    tmp44 += np.transpose(tmp42, (0, 2, 1, 3)) * 0.5
    del tmp42
    tmp44 += einsum(t2, (0, 1, 2, 3), tmp43, (1, 4, 5, 3), (4, 5, 0, 2)) * 0.5
    del tmp43
    tmp44 += einsum(t2, (0, 1, 2, 3), tmp41, (1, 4, 5, 2), (4, 5, 0, 3))
    tmp40 = einsum(tmp18, (0, 1, 2, 3), l2, (4, 2, 0, 5), (5, 1, 4, 3))
    del tmp18
    tmp40 += einsum(l2, (0, 1, 2, 3), tmp17, (3, 4, 1, 5), (2, 4, 0, 5)) * 2
    tmp30 = np.copy(np.transpose(tmp21, (3, 2, 1, 0)))
    tmp30 += np.transpose(tmp22, (1, 0, 3, 2))
    tmp30 += np.transpose(tmp22, (3, 0, 2, 1)) * -0.5
    del tmp22
    tmp28 = np.copy(tmp25) * 2
    del tmp25
    tmp28 += tmp27 * -2
    del tmp27
    tmp126 = np.copy(np.transpose(tmp21, (3, 2, 1, 0)))
    del tmp21
    tmp126 += np.transpose(tmp6, (0, 3, 1, 2))
    del tmp6
    tmp126 += np.transpose(tmp26, (0, 3, 1, 2))
    del tmp26
    tmp125 = np.copy(tmp122)
    del tmp122
    tmp125 += tmp124
    del tmp124
    tmp127 = np.copy(np.transpose(tmp45, (1, 0, 3, 2)))
    del tmp45
    tmp127 += tmp46
    del tmp46
    tmp82 = np.copy(tmp66)
    del tmp66
    tmp82 += tmp68 * -1
    del tmp68
    tmp82 += tmp69 * -1
    del tmp69
    tmp82 += tmp71
    del tmp71
    tmp82 += tmp72
    del tmp72
    tmp82 += tmp74
    del tmp74
    tmp82 += tmp76
    del tmp76
    tmp82 += tmp81 * -1
    del tmp81
    tmp114 = np.copy(tmp109)
    del tmp109
    tmp114 += np.transpose(tmp111, (1, 0, 2, 3))
    del tmp111
    tmp114 += np.transpose(tmp113, (0, 1, 3, 2))
    del tmp113
    tmp108 = einsum(l1, (0, 1), f.ov, (2, 3), (2, 1, 3, 0))
    tmp108 += tmp83
    del tmp83
    tmp108 += tmp84 * 2
    del tmp84
    tmp108 += tmp85 * -1
    del tmp85
    tmp108 += tmp87
    del tmp87
    tmp108 += tmp88
    del tmp88
    tmp108 += tmp92 * -1
    del tmp92
    tmp108 += np.transpose(tmp102, (1, 0, 3, 2)) * -1
    del tmp102
    tmp108 += np.transpose(tmp106, (0, 1, 3, 2))
    del tmp106
    tmp108 += tmp107 * -1
    del tmp107
    tmp108 += einsum(l1, (0, 1), tmp103, (2, 3), (1, 2, 0, 3))
    del tmp103
    tmp65 = einsum(v.xvv, (0, 1, 2), v.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp121 = einsum(l2, (0, 1, 2, 3), f.oo, (4, 3), (4, 2, 0, 1))
    tmp120 = np.copy(np.transpose(tmp116, (1, 0, 2, 3)))
    del tmp116
    tmp120 += np.transpose(tmp119, (0, 1, 3, 2))
    del tmp119
    tmp62 = np.copy(f.oo)
    tmp62 += np.transpose(tmp60, (1, 0)) * 2
    del tmp60
    tmp62 += tmp61 * -1
    del tmp61
    tmp62 += einsum(v.xov, (0, 1, 2), tmp19, (3, 2, 0), (3, 1))
    del tmp19
    tmp62 += einsum(tmp59, (0, 1), t1, (2, 1), (2, 0))
    tmp39 = einsum(tmp32, (0, 1, 2), tmp33, (0, 3, 4, 1), (3, 4, 2)) * -2
    del tmp33
    tmp39 += einsum(tmp35, (0, 1, 2, 3), v.xoo, (4, 0, 2), (1, 3, 4))
    del tmp35
    tmp39 += einsum(tmp36, (0, 1, 2, 3), tmp11, (1, 2, 4), (0, 3, 4)) * 2
    del tmp36
    tmp39 += einsum(v.xov, (0, 1, 2), tmp37, (3, 2), (1, 3, 0))
    del tmp37
    tmp39 += einsum(tmp38, (0, 1, 2), l1, (3, 0), (1, 3, 2))
    del tmp38
    tmp24 = np.copy(np.transpose(tmp1, (0, 2, 1, 3))) * -2
    tmp24 += np.transpose(tmp2, (1, 0, 2, 3)) * -2
    tmp24 += np.transpose(tmp2, (2, 0, 1, 3))
    del tmp2
    tmp24 += np.transpose(tmp8, (0, 2, 1, 3))
    tmp24 += np.transpose(tmp8, (1, 2, 0, 3)) * -2
    del tmp8
    tmp24 += np.transpose(tmp14, (1, 2, 0, 3)) * -1
    tmp24 += np.transpose(tmp14, (0, 2, 1, 3)) * 0.5
    del tmp14
    tmp24 += einsum(tmp17, (0, 1, 2, 3), tmp16, (4, 0, 5, 3), (5, 4, 1, 2)) * 2
    del tmp17
    tmp24 += einsum(tmp15, (0, 1, 2), tmp20, (3, 4, 2), (1, 0, 3, 4))
    tmp24 += einsum(t1, (0, 1), tmp23, (0, 2, 3, 4), (2, 3, 4, 1)) * -1
    del tmp23
    tmp64 = np.copy(f.vv)
    tmp64 += np.transpose(tmp63, (1, 0)) * 2
    del tmp63
    tmp58 = einsum(tmp53, (0, 1), v.xvv, (2, 1, 0), (2,)) * 2
    del tmp53
    tmp58 += einsum(tmp56, (0, 1), v.xov, (2, 0, 1), (2,))
    del tmp56
    tmp58 += einsum(tmp57, (0, 1), v.xoo, (2, 1, 0), (2,)) * -1
    del tmp57
    tmp52 = einsum(tmp0, (0, 1, 2), l1, (1, 3), (0, 3, 2)) * -1
    del tmp0
    tmp52 += einsum(v.xvv, (0, 1, 2), tmp40, (3, 4, 2, 1), (4, 3, 0)) * -1
    del tmp40
    tmp52 += einsum(tmp32, (0, 1, 2), tmp41, (3, 0, 4, 1), (4, 3, 2)) * -2
    del tmp41, tmp32
    tmp52 += einsum(tmp44, (0, 1, 2, 3), v.xov, (4, 1, 3), (2, 0, 4)) * 2
    del tmp44
    tmp52 += einsum(tmp47, (0, 1, 2, 3), tmp11, (0, 3, 4), (2, 1, 4))
    del tmp11
    tmp52 += einsum(tmp47, (0, 1, 2, 3), v.xoo, (4, 0, 3), (2, 1, 4))
    del tmp47
    tmp52 += einsum(v.xov, (0, 1, 2), tmp51, (3, 2), (3, 1, 0)) * 2
    del tmp51
    tmp52 += einsum(tmp50, (0, 1), v.xoo, (2, 3, 0), (1, 3, 2)) * 2
    tmp31 = np.copy(np.transpose(tmp1, (0, 2, 1, 3)))
    del tmp1
    tmp31 += np.transpose(tmp28, (0, 2, 1, 3)) * -1
    tmp31 += np.transpose(tmp28, (1, 2, 0, 3)) * 0.5
    del tmp28
    tmp31 += einsum(tmp16, (0, 1, 2, 3), tmp29, (1, 4, 5, 3), (2, 0, 4, 5)) * 2
    del tmp29, tmp16
    tmp31 += einsum(tmp15, (0, 1, 2), tmp20, (3, 4, 2), (1, 0, 3, 4)) * -2
    del tmp15, tmp20
    tmp31 += einsum(t1, (0, 1), tmp30, (0, 2, 3, 4), (2, 3, 4, 1)) * 2
    del tmp30
    l2new = np.copy(np.transpose(tmp5, (3, 2, 1, 0)))
    l2new += einsum(tmp65, (0, 1, 2, 3), l2, (3, 2, 4, 5), (0, 1, 4, 5))
    del tmp65
    l2new += np.transpose(tmp82, (3, 2, 0, 1))
    l2new += np.transpose(tmp82, (2, 3, 1, 0))
    del tmp82
    l2new += np.transpose(tmp108, (2, 3, 0, 1))
    l2new += np.transpose(tmp108, (3, 2, 1, 0))
    del tmp108
    l2new += np.transpose(tmp114, (3, 2, 0, 1)) * -1
    l2new += np.transpose(tmp114, (2, 3, 1, 0)) * -1
    del tmp114
    l2new += np.transpose(tmp120, (2, 3, 0, 1)) * -1
    l2new += np.transpose(tmp120, (3, 2, 1, 0)) * -1
    del tmp120
    l2new += np.transpose(tmp121, (3, 2, 0, 1)) * -1
    l2new += np.transpose(tmp121, (2, 3, 1, 0)) * -1
    del tmp121
    l2new += np.transpose(tmp125, (2, 3, 0, 1)) * -1
    l2new += np.transpose(tmp125, (3, 2, 1, 0)) * -1
    del tmp125
    l2new += einsum(tmp126, (0, 1, 2, 3), l2, (4, 5, 2, 0), (4, 5, 1, 3))
    del tmp126
    l2new += einsum(tmp5, (0, 1, 2, 3), tmp127, (4, 5, 0, 1), (3, 2, 5, 4))
    del tmp5, tmp127
    l1new = np.copy(np.transpose(f.ov, (1, 0)))
    l1new += einsum(l2, (0, 1, 2, 3), tmp24, (3, 4, 2, 1), (0, 4))
    del tmp24
    l1new += einsum(l2, (0, 1, 2, 3), tmp31, (2, 4, 3, 1), (0, 4))
    del tmp31
    l1new += einsum(v.xvv, (0, 1, 2), tmp39, (3, 2, 0), (1, 3)) * -1
    del tmp39
    l1new += einsum(tmp52, (0, 1, 2), v.xov, (2, 0, 3), (3, 1))
    del tmp52
    l1new += einsum(tmp58, (0,), v.xov, (0, 1, 2), (2, 1)) * 2
    del tmp58
    l1new += einsum(tmp59, (0, 1), tmp50, (2, 0), (1, 2)) * -2
    del tmp50, tmp59
    l1new += einsum(tmp62, (0, 1), l1, (2, 0), (2, 1)) * -1
    del tmp62
    l1new += einsum(tmp64, (0, 1), l1, (0, 2), (1, 2))
    del tmp64

    return {f"l1new": l1new, f"l2new": l2new}

def make_rdm1_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:00:13.203824.

    Parameters
    ----------
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.

    Returns
    -------
    rdm1 : array
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    delta = Namespace(
        oo=np.eye(t2.shape[0]),
        vv=np.eye(t2.shape[-1]),
    )
    tmp2 = einsum(l2, (0, 1, 2, 3), t1, (4, 1), (2, 3, 4, 0))
    tmp0 = einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    tmp1 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -0.5
    tmp1 += t2
    tmp6 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * -1
    tmp6 += np.transpose(l2, (2, 3, 0, 1)) * 2
    tmp4 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp4 += t2 * -1
    tmp3 = np.copy(tmp2)
    tmp3 += np.transpose(tmp2, (1, 0, 2, 3)) * -0.5
    del tmp2
    tmp5 = np.copy(tmp0)
    tmp5 += einsum(l2, (0, 1, 2, 3), tmp1, (2, 4, 0, 1), (3, 4)) * 2
    rdm1.vv = einsum(t1, (0, 1), l1, (2, 0), (2, 1)) * 2
    rdm1.vv += einsum(tmp6, (0, 1, 2, 3), t2, (0, 1, 4, 3), (2, 4)) * 2
    del tmp6
    rdm1.vo = np.copy(l1) * 2
    rdm1.ov = np.copy(t1) * 2
    rdm1.ov += einsum(t2, (0, 1, 2, 3), tmp3, (1, 0, 4, 3), (4, 2)) * -4
    del tmp3
    rdm1.ov += einsum(tmp4, (0, 1, 2, 3), l1, (3, 0), (1, 2)) * 2
    del tmp4
    rdm1.ov += einsum(tmp5, (0, 1), t1, (0, 2), (1, 2)) * -2
    del tmp5
    rdm1.oo = np.copy(delta.oo) * 2
    del delta
    rdm1.oo += np.transpose(tmp0, (1, 0)) * -2
    del tmp0
    rdm1.oo += einsum(l2, (0, 1, 2, 3), tmp1, (2, 4, 0, 1), (4, 3)) * -4
    del tmp1
    rdm1 = np.block([[rdm1.oo, rdm1.ov], [rdm1.vo, rdm1.vv]])

    return rdm1

def make_rdm2_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:01:27.859431.

    Parameters
    ----------
    l1 : array
        L1 amplitudes.
    l2 : array
        L2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.

    Returns
    -------
    rdm2 : array
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    delta = Namespace(
        oo=np.eye(t2.shape[0]),
        vv=np.eye(t2.shape[-1]),
    )
    tmp1 = einsum(l2, (0, 1, 2, 3), t1, (4, 1), (2, 3, 4, 0))
    tmp13 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp13 += t2 * -1
    tmp75 = np.copy(np.transpose(t2, (0, 1, 3, 2)))
    tmp75 += t2 * -1
    tmp4 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -0.5
    tmp4 += t2
    tmp20 = np.copy(tmp1) * 2
    tmp20 += np.transpose(tmp1, (1, 0, 2, 3)) * -1
    tmp18 = np.copy(tmp1)
    tmp18 += np.transpose(tmp1, (1, 0, 2, 3)) * -1
    tmp42 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * 2
    tmp42 += np.transpose(l2, (2, 3, 0, 1)) * -1
    tmp58 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * -1
    tmp58 += np.transpose(l2, (2, 3, 0, 1)) * 2
    tmp77 = einsum(l2, (0, 1, 2, 3), tmp13, (3, 4, 5, 1), (4, 2, 5, 0))
    tmp83 = einsum(tmp1, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    tmp76 = einsum(tmp75, (0, 1, 2, 3), l2, (4, 3, 0, 5), (1, 5, 2, 4))
    del tmp75
    tmp96 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * 2
    tmp96 += np.transpose(l2, (2, 3, 0, 1)) * -1
    tmp0 = einsum(t2, (0, 1, 2, 3), l2, (3, 2, 4, 5), (5, 4, 0, 1))
    tmp2 = einsum(t1, (0, 1), tmp1, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp45 = np.copy(np.transpose(l2, (3, 2, 0, 1)))
    tmp45 += np.transpose(l2, (2, 3, 0, 1)) * -1
    tmp5 = einsum(tmp4, (0, 1, 2, 3), l2, (2, 3, 0, 4), (4, 1)) * 2
    tmp8 = np.copy(tmp1) * 2
    tmp8 += np.transpose(tmp1, (1, 0, 2, 3)) * -1
    tmp26 = einsum(tmp1, (0, 1, 2, 3), t2, (4, 1, 3, 5), (0, 2, 4, 5))
    tmp16 = einsum(t2, (0, 1, 2, 3), l1, (3, 4), (4, 0, 1, 2))
    tmp21 = einsum(t2, (0, 1, 2, 3), tmp20, (1, 4, 5, 3), (4, 5, 0, 2))
    del tmp20
    tmp25 = einsum(tmp1, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 2, 4, 5))
    tmp6 = einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    tmp19 = einsum(tmp18, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 2, 4, 5))
    tmp33 = einsum(tmp4, (0, 1, 2, 3), l2, (2, 3, 0, 4), (4, 1))
    del tmp4
    tmp106 = einsum(t1, (0, 1), l2, (2, 3, 4, 0), (4, 2, 3, 1))
    tmp43 = einsum(t2, (0, 1, 2, 3), tmp42, (1, 4, 5, 3), (4, 0, 5, 2))
    del tmp42
    tmp63 = einsum(l2, (0, 1, 2, 3), t2, (4, 3, 1, 5), (2, 4, 0, 5))
    tmp80 = einsum(tmp58, (0, 1, 2, 3), t2, (0, 1, 4, 3), (2, 4))
    tmp79 = einsum(t1, (0, 1), l1, (2, 0), (2, 1))
    tmp100 = np.copy(tmp83)
    tmp100 += np.transpose(tmp76, (1, 0, 3, 2))
    tmp100 += np.transpose(tmp77, (1, 0, 3, 2)) * -1
    tmp97 = einsum(tmp96, (0, 1, 2, 3), t2, (4, 0, 5, 3), (1, 4, 2, 5))
    del tmp96
    tmp89 = np.copy(np.transpose(tmp77, (1, 0, 3, 2)))
    tmp89 += np.transpose(tmp76, (1, 0, 3, 2)) * -1
    tmp3 = np.copy(np.transpose(tmp0, (1, 0, 3, 2)))
    tmp3 += tmp2
    tmp46 = einsum(tmp45, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 4, 2, 5))
    del tmp45
    tmp17 = einsum(tmp2, (0, 1, 2, 3), t1, (0, 4), (1, 3, 2, 4))
    tmp59 = einsum(tmp58, (0, 1, 2, 3), t2, (0, 1, 4, 3), (2, 4)) * 0.5
    del tmp58
    tmp10 = einsum(tmp5, (0, 1), t1, (0, 2), (1, 2)) * 0.5
    tmp9 = einsum(tmp8, (0, 1, 2, 3), t2, (0, 1, 3, 4), (2, 4)) * 0.5
    tmp70 = np.copy(tmp16)
    tmp70 += tmp26 * -1
    tmp23 = einsum(tmp0, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    tmp67 = np.copy(tmp25)
    tmp67 += tmp21 * -1
    tmp12 = einsum(tmp6, (0, 1), t1, (0, 2), (1, 2))
    tmp14 = einsum(tmp13, (0, 1, 2, 3), l1, (3, 0), (1, 2))
    del tmp13
    tmp51 = np.copy(tmp16)
    tmp51 += tmp19
    tmp51 += tmp21 * -1
    tmp34 = np.copy(tmp6) * 0.5
    tmp34 += tmp33
    del tmp33
    tmp31 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp31 += t2 * -1
    tmp107 = einsum(l2, (0, 1, 2, 3), t2, (3, 2, 4, 5), (0, 1, 5, 4))
    tmp108 = einsum(t1, (0, 1), tmp106, (0, 2, 3, 4), (3, 2, 4, 1))
    tmp104 = np.copy(tmp63)
    tmp104 += tmp83
    tmp104 += tmp43 * -1
    tmp92 = einsum(tmp1, (0, 1, 2, 3), t2, (1, 0, 4, 5), (2, 3, 5, 4))
    tmp81 = np.copy(tmp79)
    tmp81 += tmp80
    del tmp80
    tmp65 = einsum(t2, (0, 1, 2, 3), l2, (4, 2, 1, 5), (5, 0, 4, 3))
    tmp101 = einsum(t1, (0, 1), tmp100, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp100
    tmp88 = einsum(t2, (0, 1, 2, 3), l1, (4, 1), (0, 4, 2, 3))
    tmp98 = np.copy(tmp63)
    tmp98 += tmp83
    tmp98 += tmp97 * -1
    del tmp97
    tmp90 = einsum(t1, (0, 1), tmp89, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp89
    tmp85 = np.copy(np.transpose(l2, (3, 2, 0, 1))) * -1
    tmp85 += np.transpose(l2, (2, 3, 0, 1))
    tmp29 = einsum(tmp3, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    tmp47 = einsum(t2, (0, 1, 2, 3), tmp46, (1, 4, 2, 5), (4, 0, 5, 3))
    tmp41 = einsum(tmp17, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3))
    tmp44 = einsum(t2, (0, 1, 2, 3), tmp43, (1, 4, 3, 5), (4, 0, 5, 2))
    tmp60 = einsum(tmp59, (0, 1), t2, (2, 3, 0, 4), (2, 3, 1, 4)) * 2
    tmp61 = einsum(t2, (0, 1, 2, 3), tmp5, (1, 4), (0, 4, 3, 2))
    tmp11 = np.copy(tmp9)
    del tmp9
    tmp11 += tmp10
    del tmp10
    tmp49 = einsum(t2, (0, 1, 2, 3), tmp6, (1, 4), (4, 0, 2, 3))
    tmp71 = einsum(tmp70, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp70
    tmp56 = einsum(t1, (0, 1), tmp23, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp54 = einsum(t2, (0, 1, 2, 3), tmp0, (1, 0, 4, 5), (4, 5, 3, 2))
    tmp55 = einsum(tmp2, (0, 1, 2, 3), t2, (0, 1, 4, 5), (2, 3, 4, 5))
    tmp68 = einsum(t1, (0, 1), tmp67, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp67
    tmp50 = einsum(t2, (0, 1, 2, 3), tmp43, (1, 4, 2, 5), (4, 0, 5, 3))
    tmp15 = np.copy(tmp12)
    tmp15 += tmp14 * -1
    tmp52 = einsum(tmp51, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    del tmp51
    tmp35 = einsum(t1, (0, 1), tmp34, (0, 2), (2, 1)) * 2
    del tmp34
    tmp32 = einsum(tmp31, (0, 1, 2, 3), l1, (3, 0), (1, 2))
    del tmp31
    tmp30 = einsum(tmp8, (0, 1, 2, 3), t2, (0, 1, 3, 4), (2, 4))
    del tmp8
    tmp27 = np.copy(tmp1) * -1
    tmp27 += np.transpose(tmp1, (1, 0, 2, 3)) * 2
    tmp109 = np.copy(np.transpose(tmp107, (1, 0, 3, 2)))
    tmp109 += np.transpose(tmp108, (1, 0, 3, 2))
    tmp105 = einsum(t1, (0, 1), tmp104, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp104
    tmp103 = np.copy(tmp92)
    tmp103 += einsum(t1, (0, 1), tmp81, (2, 3), (0, 2, 1, 3))
    tmp95 = einsum(tmp65, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3))
    tmp102 = np.copy(tmp88)
    tmp102 += np.transpose(tmp101, (0, 1, 3, 2))
    del tmp101
    tmp99 = einsum(t1, (0, 1), tmp98, (0, 2, 3, 4), (2, 3, 4, 1))
    del tmp98
    tmp91 = np.copy(tmp88)
    tmp91 += einsum(t1, (0, 1), tmp79, (2, 3), (0, 2, 1, 3))
    tmp91 += np.transpose(tmp90, (0, 1, 3, 2)) * -1
    del tmp90
    tmp93 = np.copy(tmp92)
    tmp93 += einsum(t1, (0, 1), tmp59, (2, 3), (0, 2, 1, 3)) * 2
    tmp87 = np.copy(tmp79) * 0.5
    del tmp79
    tmp87 += tmp59
    del tmp59
    tmp94 = einsum(tmp83, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3))
    tmp82 = einsum(tmp1, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    tmp84 = einsum(tmp18, (0, 1, 2, 3), t1, (0, 4), (1, 2, 3, 4))
    tmp86 = einsum(tmp85, (0, 1, 2, 3), t2, (4, 0, 3, 5), (1, 4, 2, 5))
    del tmp85
    tmp78 = einsum(tmp18, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    del tmp18
    tmp74 = np.copy(t1)
    tmp74 += tmp12 * -1
    tmp73 = einsum(tmp29, (0, 1, 2, 3), t1, (0, 4), (2, 1, 3, 4))
    tmp66 = einsum(t2, (0, 1, 2, 3), tmp65, (1, 4, 2, 5), (4, 0, 5, 3))
    tmp48 = np.copy(tmp41)
    del tmp41
    tmp48 += tmp44 * 2
    tmp48 += np.transpose(tmp47, (1, 0, 3, 2))
    del tmp47
    tmp62 = np.copy(np.transpose(tmp60, (1, 0, 3, 2)))
    del tmp60
    tmp62 += np.transpose(tmp61, (0, 1, 3, 2))
    del tmp61
    tmp62 += einsum(tmp11, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    tmp64 = einsum(tmp63, (0, 1, 2, 3), t2, (4, 0, 2, 5), (1, 4, 3, 5))
    tmp72 = np.copy(tmp49)
    tmp72 += np.transpose(tmp71, (0, 1, 3, 2))
    del tmp71
    tmp57 = np.copy(tmp54)
    tmp57 += tmp55
    tmp57 += tmp56
    del tmp56
    tmp69 = np.copy(tmp50) * -1
    tmp69 += np.transpose(tmp68, (0, 1, 3, 2))
    del tmp68
    tmp69 += einsum(tmp14, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    tmp53 = np.copy(tmp49)
    del tmp49
    tmp53 += tmp50 * -1
    del tmp50
    tmp53 += np.transpose(tmp52, (0, 1, 3, 2))
    del tmp52
    tmp53 += einsum(tmp15, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * -1
    tmp40 = einsum(tmp6, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp40 += tmp19
    tmp40 += tmp21 * -1
    tmp36 = np.copy(t1) * -1
    tmp36 += tmp30
    tmp36 += tmp32 * -1
    del tmp32
    tmp36 += tmp35
    tmp39 = np.copy(tmp16)
    tmp39 += np.transpose(tmp29, (0, 2, 1, 3))
    tmp39 += einsum(tmp5, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp28 = einsum(t2, (0, 1, 2, 3), tmp27, (4, 1, 5, 3), (4, 5, 0, 2))
    del tmp27
    tmp38 = np.copy(tmp30)
    del tmp30
    tmp38 += tmp35
    del tmp35
    tmp37 = np.copy(tmp6)
    tmp37 += tmp5
    tmp24 = np.copy(tmp23)
    del tmp23
    tmp24 += einsum(tmp5, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp22 = np.copy(tmp16)
    tmp22 += tmp17
    del tmp17
    tmp22 += tmp19
    del tmp19
    tmp22 += tmp21 * -1
    del tmp21
    tmp7 = np.copy(delta.oo)
    tmp7 += tmp6 * -1
    rdm2.vvvv = np.copy(np.transpose(tmp109, (0, 1, 3, 2))) * -2
    rdm2.vvvv += tmp109 * 2
    del tmp109
    rdm2.vvvv += np.transpose(tmp107, (1, 0, 3, 2)) * 2
    del tmp107
    rdm2.vvvv += np.transpose(tmp108, (1, 0, 3, 2)) * 2
    del tmp108
    rdm2.vvvo = np.copy(np.transpose(tmp106, (1, 2, 3, 0))) * -2
    rdm2.vvvo += np.transpose(tmp106, (2, 1, 3, 0)) * 4
    rdm2.vvov = np.copy(np.transpose(tmp106, (1, 2, 0, 3))) * 4
    rdm2.vvov += np.transpose(tmp106, (2, 1, 0, 3)) * -2
    del tmp106
    rdm2.vovv = np.copy(np.transpose(tmp102, (1, 0, 2, 3))) * -2
    rdm2.vovv += np.transpose(tmp102, (1, 0, 3, 2)) * 2
    del tmp102
    rdm2.vovv += np.transpose(tmp103, (1, 0, 2, 3)) * -2
    rdm2.vovv += np.transpose(tmp103, (1, 0, 3, 2)) * 2
    del tmp103
    rdm2.vovv += np.transpose(tmp95, (1, 0, 3, 2)) * -2
    rdm2.vovv += np.transpose(tmp92, (1, 0, 2, 3)) * -2
    rdm2.vovv += np.transpose(tmp88, (1, 0, 3, 2)) * 2
    rdm2.vovv += np.transpose(tmp105, (1, 0, 3, 2)) * -2
    del tmp105
    rdm2.vovv += einsum(tmp81, (0, 1), t1, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.ovvv = np.copy(tmp91) * 2
    rdm2.ovvv += np.transpose(tmp91, (0, 1, 3, 2)) * -2
    del tmp91
    rdm2.ovvv += tmp93 * 2
    rdm2.ovvv += np.transpose(tmp93, (0, 1, 3, 2)) * -2
    del tmp93
    rdm2.ovvv += tmp94 * 2
    rdm2.ovvv += np.transpose(tmp94, (0, 1, 3, 2)) * -2
    del tmp94
    rdm2.ovvv += np.transpose(tmp92, (0, 1, 3, 2)) * -2
    del tmp92
    rdm2.ovvv += tmp95 * -2
    del tmp95
    rdm2.ovvv += tmp88 * 2
    del tmp88
    rdm2.ovvv += tmp99 * -2
    del tmp99
    rdm2.ovvv += einsum(t1, (0, 1), tmp87, (2, 3), (0, 2, 1, 3)) * 4
    rdm2.vvoo = np.copy(np.transpose(l2, (0, 1, 3, 2))) * -2
    rdm2.vvoo += l2 * 4
    rdm2.vovo = einsum(t1, (0, 1), l1, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.vovo += np.transpose(tmp43, (2, 1, 3, 0)) * -2
    rdm2.vovo += np.transpose(tmp86, (2, 1, 3, 0)) * -2
    del tmp86
    rdm2.vovo += np.transpose(tmp84, (2, 1, 3, 0)) * -2
    rdm2.vovo += einsum(tmp87, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * 8
    del tmp87
    rdm2.vovo += np.transpose(tmp65, (2, 1, 3, 0)) * -2
    rdm2.vovo += np.transpose(tmp82, (2, 1, 3, 0)) * -2
    rdm2.voov = einsum(t1, (0, 1), l1, (2, 3), (2, 0, 3, 1)) * 4
    rdm2.voov += np.transpose(tmp77, (3, 0, 1, 2)) * 2
    rdm2.voov += np.transpose(tmp76, (3, 0, 1, 2)) * -2
    rdm2.voov += np.transpose(tmp84, (2, 1, 0, 3)) * 2
    del tmp84
    rdm2.voov += einsum(delta.oo, (0, 1), tmp81, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.voov += np.transpose(tmp63, (2, 1, 0, 3)) * -2
    rdm2.voov += np.transpose(tmp83, (2, 1, 0, 3)) * -2
    rdm2.voov += np.transpose(tmp43, (2, 1, 0, 3)) * 2
    rdm2.ovvo = einsum(t1, (0, 1), l1, (2, 3), (0, 2, 1, 3)) * 4
    rdm2.ovvo += np.transpose(tmp43, (1, 2, 3, 0)) * 4
    del tmp43
    rdm2.ovvo += np.transpose(tmp46, (1, 2, 3, 0)) * -2
    del tmp46
    rdm2.ovvo += np.transpose(tmp78, (1, 2, 3, 0)) * -2
    rdm2.ovvo += einsum(delta.oo, (0, 1), tmp81, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.ovvo += np.transpose(tmp63, (1, 2, 3, 0)) * -2
    del tmp63
    rdm2.ovvo += np.transpose(tmp83, (1, 2, 3, 0)) * -2
    del tmp83
    rdm2.ovov = einsum(t1, (0, 1), l1, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.ovov += np.transpose(tmp76, (0, 3, 1, 2)) * 2
    del tmp76
    rdm2.ovov += np.transpose(tmp77, (0, 3, 1, 2)) * -2
    del tmp77
    rdm2.ovov += np.transpose(tmp78, (1, 2, 0, 3)) * 2
    del tmp78
    rdm2.ovov += einsum(delta.oo, (0, 1), tmp81, (2, 3), (0, 2, 1, 3)) * 4
    del tmp81
    rdm2.ovov += np.transpose(tmp65, (1, 2, 0, 3)) * -2
    del tmp65
    rdm2.ovov += np.transpose(tmp82, (1, 2, 0, 3)) * -2
    del tmp82
    rdm2.oovv = np.copy(tmp48) * 2
    rdm2.oovv += np.transpose(tmp48, (0, 1, 3, 2)) * -2
    del tmp48
    rdm2.oovv += tmp53 * 2
    rdm2.oovv += np.transpose(tmp53, (0, 1, 3, 2)) * -2
    rdm2.oovv += np.transpose(tmp53, (1, 0, 2, 3)) * -2
    rdm2.oovv += np.transpose(tmp53, (1, 0, 3, 2)) * 2
    del tmp53
    rdm2.oovv += tmp57 * 2
    rdm2.oovv += np.transpose(tmp57, (0, 1, 3, 2)) * -2
    del tmp57
    rdm2.oovv += tmp62 * -4
    rdm2.oovv += np.transpose(tmp62, (0, 1, 3, 2)) * 2
    rdm2.oovv += np.transpose(tmp62, (1, 0, 2, 3)) * 2
    rdm2.oovv += np.transpose(tmp62, (1, 0, 3, 2)) * -4
    del tmp62
    rdm2.oovv += np.transpose(t2, (0, 1, 3, 2)) * -2
    rdm2.oovv += t2 * 4
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.oovv += einsum(t1, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.oovv += tmp64 * 2
    del tmp64
    rdm2.oovv += np.transpose(tmp66, (0, 1, 3, 2)) * 2
    del tmp66
    rdm2.oovv += tmp54 * 2
    del tmp54
    rdm2.oovv += tmp55 * 2
    del tmp55
    rdm2.oovv += einsum(tmp12, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * -2
    del tmp12
    rdm2.oovv += tmp69 * 2
    rdm2.oovv += np.transpose(tmp69, (1, 0, 3, 2)) * 2
    del tmp69
    rdm2.oovv += np.transpose(tmp72, (0, 1, 3, 2)) * -2
    rdm2.oovv += np.transpose(tmp72, (1, 0, 2, 3)) * -2
    del tmp72
    rdm2.oovv += np.transpose(tmp44, (1, 0, 3, 2)) * 4
    del tmp44
    rdm2.oovv += np.transpose(tmp73, (0, 1, 3, 2)) * 2
    del tmp73
    rdm2.oovv += einsum(tmp74, (0, 1), t1, (2, 3), (0, 2, 1, 3)) * 2
    del tmp74
    rdm2.vooo = einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1)) * 4
    rdm2.vooo += einsum(l1, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.vooo += np.transpose(tmp1, (3, 2, 0, 1)) * -4
    rdm2.vooo += np.transpose(tmp1, (3, 2, 1, 0)) * 2
    rdm2.ovoo = einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.ovoo += einsum(l1, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * 4
    rdm2.ovoo += np.transpose(tmp1, (2, 3, 0, 1)) * 2
    rdm2.ovoo += np.transpose(tmp1, (2, 3, 1, 0)) * -4
    del tmp1
    rdm2.oovo = einsum(delta.oo, (0, 1), tmp38, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.oovo += einsum(tmp38, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * 2
    del tmp38
    rdm2.oovo += einsum(tmp14, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.oovo += einsum(tmp14, (0, 1), delta.oo, (2, 3), (2, 0, 1, 3)) * -2
    del tmp14
    rdm2.oovo += einsum(delta.oo, (0, 1), t1, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.oovo += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.oovo += np.transpose(tmp39, (1, 2, 3, 0)) * -2
    rdm2.oovo += np.transpose(tmp39, (2, 1, 3, 0)) * 2
    del tmp39
    rdm2.oovo += np.transpose(tmp40, (1, 2, 3, 0)) * -2
    rdm2.oovo += np.transpose(tmp40, (2, 1, 3, 0)) * 2
    del tmp40
    rdm2.oovo += np.transpose(tmp16, (1, 2, 3, 0)) * -2
    rdm2.oovo += np.transpose(tmp26, (1, 2, 3, 0)) * 2
    rdm2.oovo += np.transpose(tmp25, (2, 1, 3, 0)) * 2
    rdm2.oovo += np.transpose(tmp28, (2, 1, 3, 0)) * -2
    rdm2.oovo += np.transpose(tmp29, (1, 2, 3, 0)) * 2
    rdm2.oovo += einsum(delta.oo, (0, 1), tmp36, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.oovo += einsum(tmp37, (0, 1), t1, (2, 3), (2, 1, 3, 0)) * -2
    rdm2.ooov = einsum(delta.oo, (0, 1), tmp11, (2, 3), (2, 0, 1, 3)) * 4
    rdm2.ooov += einsum(tmp11, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -4
    del tmp11
    rdm2.ooov += einsum(tmp15, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * 2
    rdm2.ooov += einsum(tmp15, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -2
    del tmp15
    rdm2.ooov += einsum(delta.oo, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.ooov += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.ooov += np.transpose(tmp22, (1, 2, 0, 3)) * 2
    rdm2.ooov += np.transpose(tmp22, (2, 1, 0, 3)) * -2
    del tmp22
    rdm2.ooov += einsum(tmp6, (0, 1), t1, (2, 3), (2, 1, 0, 3)) * 2
    rdm2.ooov += einsum(tmp6, (0, 1), t1, (2, 3), (1, 2, 0, 3)) * -2
    rdm2.ooov += np.transpose(tmp24, (1, 2, 0, 3)) * 2
    rdm2.ooov += np.transpose(tmp24, (2, 1, 0, 3)) * -2
    del tmp24
    rdm2.ooov += np.transpose(tmp16, (2, 1, 0, 3)) * -2
    del tmp16
    rdm2.ooov += np.transpose(tmp25, (1, 2, 0, 3)) * 2
    del tmp25
    rdm2.ooov += np.transpose(tmp26, (2, 1, 0, 3)) * 2
    del tmp26
    rdm2.ooov += np.transpose(tmp28, (1, 2, 0, 3)) * -2
    del tmp28
    rdm2.ooov += np.transpose(tmp29, (2, 1, 0, 3)) * 2
    del tmp29
    rdm2.ooov += einsum(tmp36, (0, 1), delta.oo, (2, 3), (2, 0, 3, 1)) * -2
    del tmp36
    rdm2.ooov += einsum(tmp37, (0, 1), t1, (2, 3), (1, 2, 0, 3)) * -2
    del tmp37
    rdm2.oooo = np.copy(np.transpose(tmp3, (3, 2, 0, 1))) * -2
    rdm2.oooo += np.transpose(tmp3, (2, 3, 0, 1)) * 2
    del tmp3
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.oooo += einsum(tmp5, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3)) * -4
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp5, (2, 3), (0, 3, 2, 1)) * 2
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp5, (2, 3), (3, 0, 1, 2)) * 2
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp5, (2, 3), (0, 3, 1, 2)) * -4
    del tmp5
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3)) * -2
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (0, 3, 2, 1)) * 2
    rdm2.oooo += einsum(tmp6, (0, 1), delta.oo, (2, 3), (1, 2, 3, 0)) * 2
    rdm2.oooo += einsum(delta.oo, (0, 1), tmp6, (2, 3), (0, 3, 1, 2)) * -4
    del tmp6
    rdm2.oooo += np.transpose(tmp0, (3, 2, 1, 0)) * 2
    del tmp0
    rdm2.oooo += np.transpose(tmp2, (3, 2, 1, 0)) * 2
    del tmp2
    rdm2.oooo += einsum(tmp7, (0, 1), delta.oo, (2, 3), (1, 2, 0, 3)) * 2
    del delta, tmp7
    rdm2 = pack_2e(rdm2.oooo, rdm2.ooov, rdm2.oovo, rdm2.ovoo, rdm2.vooo, rdm2.oovv, rdm2.ovov, rdm2.ovvo, rdm2.voov, rdm2.vovo, rdm2.vvoo, rdm2.ovvv, rdm2.vovv, rdm2.vvov, rdm2.vvvo, rdm2.vvvv)
    rdm2 = np.transpose(rdm2, (0, 2, 1, 3))

    return rdm2

def hbar_matvec_ip_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:02:10.422849.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp0 : array
    tmp1 : array
    tmp103 : array
    tmp105 : array
    tmp106 : array
    tmp107 : array
    tmp108 : array
    tmp109 : array
    tmp11 : array
    tmp110 : array
    tmp112 : array
    tmp113 : array
    tmp114 : array
    tmp118 : array
    tmp119 : array
    tmp120 : array
    tmp121 : array
    tmp122 : array
    tmp123 : array
    tmp129 : array
    tmp130 : array
    tmp14 : array
    tmp17 : array
    tmp18 : array
    tmp20 : array
    tmp21 : array
    tmp23 : array
    tmp24 : array
    tmp29 : array
    tmp31 : array
    tmp32 : array
    tmp33 : array
    tmp35 : array
    tmp37 : array
    tmp38 : array
    tmp4 : array
    tmp40 : array
    tmp42 : array
    tmp43 : array
    tmp44 : array
    tmp48 : array
    tmp5 : array
    tmp50 : array
    tmp51 : array
    tmp52 : array
    tmp55 : array
    tmp56 : array
    tmp57 : array
    tmp59 : array
    tmp62 : array
    tmp63 : array
    tmp65 : array
    tmp66 : array
    tmp67 : array
    tmp7 : array
    tmp72 : array
    tmp73 : array
    tmp74 : array
    tmp75 : array
    tmp76 : array
    tmp78 : array
    tmp84 : array
    tmp85 : array
    tmp86 : array
    tmp87 : array
    tmp89 : array
    tmp9 : array
    tmp95 : array
    tmp96 : array
    tmp98 : array
    tmp99 : array
    """

    tmp6 = einsum(t1, (0, 1), v.xov, (2, 0, 1), (2,))
    tmp4 = einsum(v.xov, (0, 1, 2), t1, (3, 2), (3, 1, 0))
    tmp11 = einsum(tmp6, (0,), v.xov, (0, 1, 2), (1, 2))
    tmp9 = einsum(v.xov, (0, 1, 2), tmp4, (1, 3, 0), (3, 2))
    tmp17 = einsum(t2, (0, 1, 2, 3), v.xov, (4, 1, 2), (0, 3, 4))
    tmp20 = einsum(t2, (0, 1, 2, 3), v.xov, (4, 1, 3), (0, 2, 4))
    tmp37 = einsum(v.xov, (0, 1, 2), v.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp24 = einsum(tmp11, (0, 1), t1, (2, 1), (2, 0))
    tmp23 = einsum(tmp9, (0, 1), t1, (2, 1), (2, 0))
    tmp44 = einsum(v.xoo, (0, 1, 2), tmp4, (3, 4, 0), (3, 1, 2, 4))
    tmp18 = einsum(v.xov, (0, 1, 2), tmp17, (3, 2, 0), (3, 1))
    tmp21 = einsum(v.xov, (0, 1, 2), tmp20, (3, 2, 0), (3, 1))
    tmp14 = einsum(v.xov, (0, 1, 2), tmp4, (3, 4, 0), (3, 1, 4, 2))
    tmp31 = einsum(t1, (0, 1), v.xvv, (2, 3, 1), (0, 3, 2))
    tmp0 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp110 = einsum(tmp4, (0, 1, 2), tmp4, (3, 4, 2), (3, 0, 4, 1))
    tmp29 = einsum(v.xvv, (0, 1, 2), tmp6, (0,), (1, 2))
    tmp7 = einsum(tmp6, (0,), v.xoo, (0, 1, 2), (1, 2))
    del tmp6
    tmp5 = einsum(v.xoo, (0, 1, 2), tmp4, (2, 3, 0), (1, 3))
    tmp1 = einsum(v.xov, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp57 = einsum(v.xoo, (0, 1, 2), v.xoo, (0, 3, 4), (3, 1, 2, 4))
    tmp38 = einsum(t2, (0, 1, 2, 3), tmp37, (4, 5, 3, 2), (0, 1, 5, 4))
    tmp34 = einsum(v.xov, (0, 1, 2), v.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp130 = einsum(tmp24, (0, 1), t1, (1, 2), (0, 2))
    tmp129 = einsum(t1, (0, 1), tmp23, (2, 0), (2, 1))
    tmp123 = einsum(t1, (0, 1), tmp44, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp122 = einsum(tmp18, (0, 1), t1, (1, 2), (0, 2))
    tmp121 = einsum(tmp21, (0, 1), t1, (1, 2), (0, 2))
    tmp120 = einsum(tmp14, (0, 1, 2, 3), t2, (4, 2, 3, 5), (0, 4, 1, 5))
    tmp119 = einsum(tmp14, (0, 1, 2, 3), t2, (2, 1, 3, 4), (0, 4))
    tmp118 = einsum(tmp14, (0, 1, 2, 3), t2, (2, 1, 4, 3), (0, 4))
    tmp114 = einsum(v.xoo, (0, 1, 2), tmp31, (3, 4, 0), (3, 1, 2, 4))
    tmp113 = einsum(tmp0, (0, 1), t1, (0, 2), (1, 2))
    tmp112 = einsum(tmp110, (0, 1, 2, 3), t1, (2, 4), (1, 0, 3, 4))
    tmp109 = einsum(tmp4, (0, 1, 2), tmp31, (3, 4, 2), (0, 3, 1, 4))
    tmp108 = einsum(tmp4, (0, 1, 2), tmp31, (1, 3, 2), (0, 3))
    tmp107 = einsum(t1, (0, 1), tmp29, (2, 1), (0, 2))
    tmp106 = einsum(v.xvv, (0, 1, 2), tmp17, (3, 2, 0), (3, 1))
    tmp105 = einsum(tmp20, (0, 1, 2), v.xvv, (2, 3, 1), (0, 3))
    tmp103 = einsum(t1, (0, 1), f.vv, (2, 1), (0, 2))
    tmp99 = einsum(tmp7, (0, 1), t1, (1, 2), (0, 2))
    tmp98 = einsum(tmp5, (0, 1), t1, (1, 2), (0, 2))
    tmp96 = einsum(t2, (0, 1, 2, 3), tmp11, (4, 3), (0, 1, 4, 2))
    tmp95 = einsum(tmp9, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp89 = einsum(tmp20, (0, 1, 2), v.xov, (2, 0, 3), (1, 3))
    tmp87 = einsum(tmp17, (0, 1, 2), v.xov, (2, 0, 3), (1, 3))
    tmp86 = einsum(tmp1, (0, 1, 2, 3), t2, (4, 1, 3, 5), (4, 0, 2, 5))
    tmp85 = einsum(t2, (0, 1, 2, 3), tmp1, (4, 0, 1, 3), (4, 2))
    tmp84 = einsum(t2, (0, 1, 2, 3), tmp1, (4, 0, 1, 2), (4, 3))
    tmp78 = einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp76 = einsum(f.oo, (0, 1), t1, (1, 2), (0, 2))
    tmp75 = einsum(t2, (0, 1, 2, 3), tmp11, (1, 3), (0, 2))
    tmp74 = einsum(t2, (0, 1, 2, 3), tmp11, (1, 2), (0, 3))
    tmp73 = einsum(t2, (0, 1, 2, 3), tmp9, (1, 3), (0, 2))
    tmp72 = einsum(t2, (0, 1, 2, 3), tmp9, (1, 2), (0, 3))
    tmp67 = einsum(t2, (0, 1, 2, 3), tmp37, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp66 = einsum(tmp37, (0, 1, 2, 3), t2, (4, 0, 3, 5), (4, 1, 5, 2))
    tmp65 = einsum(v.xoo, (0, 1, 2), tmp17, (3, 4, 0), (3, 1, 2, 4))
    tmp63 = einsum(v.xoo, (0, 1, 2), tmp20, (3, 4, 0), (3, 1, 2, 4))
    tmp62 = einsum(t2, (0, 1, 2, 3), tmp1, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp59 = einsum(t1, (0, 1), tmp57, (2, 3, 4, 0), (3, 4, 2, 1))
    tmp56 = einsum(f.ov, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp55 = einsum(f.ov, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp52 = einsum(t1, (0, 1), tmp44, (2, 3, 0, 4), (2, 3, 4, 1))
    tmp51 = einsum(tmp17, (0, 1, 2), tmp4, (3, 4, 2), (3, 0, 4, 1))
    tmp50 = einsum(tmp14, (0, 1, 2, 3), t2, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp48 = einsum(tmp20, (0, 1, 2), tmp4, (3, 4, 2), (3, 0, 4, 1))
    tmp43 = einsum(v.xoo, (0, 1, 2), tmp31, (2, 3, 0), (1, 3))
    tmp42 = einsum(v.xvv, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp40 = einsum(t1, (0, 1), tmp38, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp35 = einsum(tmp34, (0, 1, 2, 3), t2, (4, 5, 3, 2), (4, 5, 0, 1))
    del tmp34
    tmp33 = einsum(tmp4, (0, 1, 2), v.xvv, (2, 3, 4), (0, 1, 3, 4))
    tmp32 = einsum(tmp31, (0, 1, 2), v.xov, (2, 0, 3), (3, 1))

    return {f"tmp0": tmp0, f"tmp1": tmp1, f"tmp103": tmp103, f"tmp105": tmp105, f"tmp106": tmp106, f"tmp107": tmp107, f"tmp108": tmp108, f"tmp109": tmp109, f"tmp11": tmp11, f"tmp110": tmp110, f"tmp112": tmp112, f"tmp113": tmp113, f"tmp114": tmp114, f"tmp118": tmp118, f"tmp119": tmp119, f"tmp120": tmp120, f"tmp121": tmp121, f"tmp122": tmp122, f"tmp123": tmp123, f"tmp129": tmp129, f"tmp130": tmp130, f"tmp14": tmp14, f"tmp17": tmp17, f"tmp18": tmp18, f"tmp20": tmp20, f"tmp21": tmp21, f"tmp23": tmp23, f"tmp24": tmp24, f"tmp29": tmp29, f"tmp31": tmp31, f"tmp32": tmp32, f"tmp33": tmp33, f"tmp35": tmp35, f"tmp37": tmp37, f"tmp38": tmp38, f"tmp4": tmp4, f"tmp40": tmp40, f"tmp42": tmp42, f"tmp43": tmp43, f"tmp44": tmp44, f"tmp48": tmp48, f"tmp5": tmp5, f"tmp50": tmp50, f"tmp51": tmp51, f"tmp52": tmp52, f"tmp55": tmp55, f"tmp56": tmp56, f"tmp57": tmp57, f"tmp59": tmp59, f"tmp62": tmp62, f"tmp63": tmp63, f"tmp65": tmp65, f"tmp66": tmp66, f"tmp67": tmp67, f"tmp7": tmp7, f"tmp72": tmp72, f"tmp73": tmp73, f"tmp74": tmp74, f"tmp75": tmp75, f"tmp76": tmp76, f"tmp78": tmp78, f"tmp84": tmp84, f"tmp85": tmp85, f"tmp86": tmp86, f"tmp87": tmp87, f"tmp89": tmp89, f"tmp9": tmp9, f"tmp95": tmp95, f"tmp96": tmp96, f"tmp98": tmp98, f"tmp99": tmp99}

def hbar_matvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:02:10.481108.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp3 = np.copy(r2) * 2
    tmp3 += np.transpose(r2, (1, 0, 2)) * -1
    tmp2 = np.copy(f.ov) * 0.5
    tmp2 += ints.tmp11
    tmp2 += ints.tmp9 * -0.5
    del ints.tmp9
    tmp15 = np.copy(ints.tmp4)
    del ints.tmp4
    tmp15 += np.transpose(v.xoo, (1, 2, 0))
    tmp9 = einsum(v.xov, (0, 1, 2), tmp3, (1, 3, 2), (3, 0)) * 0.5
    tmp14 = np.copy(ints.tmp14)
    tmp14 += np.transpose(ints.tmp1, (0, 2, 1, 3))
    tmp8 = np.copy(ints.tmp110)
    del ints.tmp110
    tmp8 += np.transpose(ints.tmp44, (2, 0, 1, 3))
    tmp12 = np.copy(ints.tmp112)
    del ints.tmp112
    tmp12 += np.transpose(ints.tmp120, (1, 0, 2, 3))
    del ints.tmp120
    tmp12 += np.transpose(ints.tmp123, (2, 0, 1, 3))
    del ints.tmp123
    tmp12 += ints.tmp40
    del ints.tmp40
    tmp12 += ints.tmp50
    del ints.tmp50
    tmp12 += ints.tmp51
    del ints.tmp51
    tmp12 += ints.tmp52
    del ints.tmp52
    tmp12 += np.transpose(ints.tmp59, (1, 2, 0, 3))
    del ints.tmp59
    tmp12 += np.transpose(ints.tmp62, (1, 0, 2, 3))
    del ints.tmp62
    tmp12 += np.transpose(ints.tmp65, (2, 0, 1, 3))
    del ints.tmp65
    tmp12 += ints.tmp86
    del ints.tmp86
    tmp12 += np.transpose(ints.tmp95, (1, 0, 2, 3))
    del ints.tmp95
    tmp12 += ints.tmp109 * -1
    del ints.tmp109
    tmp12 += np.transpose(ints.tmp114, (2, 0, 1, 3)) * -1
    del ints.tmp114
    tmp12 += ints.tmp14 * -1
    tmp12 += np.transpose(ints.tmp1, (0, 2, 1, 3)) * -1
    tmp12 += ints.tmp35 * -1
    del ints.tmp35
    tmp12 += ints.tmp48 * -2
    del ints.tmp48
    tmp12 += np.transpose(ints.tmp63, (2, 0, 1, 3)) * -2
    del ints.tmp63
    tmp12 += np.transpose(ints.tmp78, (2, 1, 0, 3)) * -1
    del ints.tmp78
    tmp12 += np.transpose(ints.tmp96, (1, 0, 2, 3)) * -2
    del ints.tmp96
    tmp10 = np.copy(ints.tmp20) * 2
    del ints.tmp20
    tmp10 += ints.tmp31
    del ints.tmp31
    tmp10 += np.transpose(v.xov, (1, 2, 0))
    tmp10 += ints.tmp17 * -1
    del ints.tmp17
    tmp6 = np.copy(ints.tmp33)
    tmp6 += ints.tmp42
    tmp6 += ints.tmp66 * -1
    tmp18 = np.copy(ints.tmp106)
    del ints.tmp106
    tmp18 += ints.tmp108
    del ints.tmp108
    tmp18 += ints.tmp113
    del ints.tmp113
    tmp18 += ints.tmp118 * 2
    del ints.tmp118
    tmp18 += ints.tmp121 * 2
    del ints.tmp121
    tmp18 += ints.tmp130 * 2
    del ints.tmp130
    tmp18 += ints.tmp43
    del ints.tmp43
    tmp18 += ints.tmp55
    del ints.tmp55
    tmp18 += ints.tmp73 * 2
    del ints.tmp73
    tmp18 += ints.tmp74 * 2
    del ints.tmp74
    tmp18 += ints.tmp76
    del ints.tmp76
    tmp18 += ints.tmp85 * 2
    del ints.tmp85
    tmp18 += ints.tmp99 * 2
    del ints.tmp99
    tmp18 += f.ov * -1
    tmp18 += ints.tmp103 * -1
    del ints.tmp103
    tmp18 += ints.tmp105 * -2
    del ints.tmp105
    tmp18 += ints.tmp107 * -2
    del ints.tmp107
    tmp18 += ints.tmp119 * -1
    del ints.tmp119
    tmp18 += ints.tmp11 * -2
    del ints.tmp11
    tmp18 += ints.tmp122 * -1
    del ints.tmp122
    tmp18 += ints.tmp129 * -1
    del ints.tmp129
    tmp18 += ints.tmp56 * -2
    del ints.tmp56
    tmp18 += ints.tmp72 * -1
    del ints.tmp72
    tmp18 += ints.tmp75 * -4
    del ints.tmp75
    tmp18 += ints.tmp84 * -1
    del ints.tmp84
    tmp18 += ints.tmp98 * -1
    del ints.tmp98
    tmp17 = einsum(tmp3, (0, 1, 2), ints.tmp37, (0, 1, 2, 3), (3,)) * 0.5
    del ints.tmp37
    tmp7 = np.copy(ints.tmp38)
    del ints.tmp38
    tmp7 += np.transpose(ints.tmp44, (2, 0, 1, 3))
    del ints.tmp44
    tmp7 += np.transpose(ints.tmp57, (2, 0, 1, 3))
    del ints.tmp57
    tmp5 = np.copy(ints.tmp33) * 0.5
    del ints.tmp33
    tmp5 += ints.tmp42 * 0.5
    del ints.tmp42
    tmp5 += ints.tmp67
    tmp5 += ints.tmp66 * -0.5
    del ints.tmp66
    tmp13 = np.copy(f.oo) * 0.5
    tmp13 += ints.tmp0 * 0.5
    tmp13 += np.transpose(ints.tmp21, (1, 0))
    tmp13 += np.transpose(ints.tmp24, (1, 0))
    tmp13 += np.transpose(ints.tmp7, (1, 0))
    tmp13 += np.transpose(ints.tmp18, (1, 0)) * -0.5
    tmp13 += np.transpose(ints.tmp23, (1, 0)) * -0.5
    tmp13 += np.transpose(ints.tmp5, (1, 0)) * -0.5
    tmp11 = np.copy(ints.tmp32)
    del ints.tmp32
    tmp11 += np.transpose(ints.tmp89, (1, 0)) * 2
    del ints.tmp89
    tmp11 += f.vv * -1
    tmp11 += np.transpose(ints.tmp29, (1, 0)) * -2
    del ints.tmp29
    tmp11 += np.transpose(ints.tmp87, (1, 0)) * -1
    del ints.tmp87
    tmp11 += einsum(t1, (0, 1), tmp2, (0, 2), (2, 1)) * 2
    tmp16 = einsum(r2, (0, 1, 2), tmp14, (3, 4, 1, 2), (3, 4, 0))
    tmp16 += einsum(tmp14, (0, 1, 2, 3), r2, (2, 4, 3), (4, 1, 0))
    del tmp14
    tmp16 += einsum(tmp15, (0, 1, 2), tmp9, (3, 2), (3, 1, 0)) * -2
    del tmp15
    tmp4 = np.copy(f.oo)
    tmp4 += ints.tmp0
    del ints.tmp0
    tmp4 += np.transpose(ints.tmp21, (1, 0)) * 2
    del ints.tmp21
    tmp4 += np.transpose(ints.tmp24, (1, 0)) * 2
    del ints.tmp24
    tmp4 += np.transpose(ints.tmp7, (1, 0)) * 2
    del ints.tmp7
    tmp4 += np.transpose(ints.tmp18, (1, 0)) * -1
    del ints.tmp18
    tmp4 += np.transpose(ints.tmp23, (1, 0)) * -1
    del ints.tmp23
    tmp4 += np.transpose(ints.tmp5, (1, 0)) * -1
    del ints.tmp5
    tmp1 = np.copy(r2)
    tmp1 += np.transpose(r2, (1, 0, 2)) * -0.5
    tmp0 = np.copy(r2) * -1
    tmp0 += np.transpose(r2, (1, 0, 2)) * 2
    r2new = einsum(ints.tmp67, (0, 1, 2, 3), r2, (4, 1, 3), (0, 4, 2))
    del ints.tmp67
    r2new += einsum(r2, (0, 1, 2), tmp5, (3, 0, 4, 2), (3, 1, 4)) * -2
    del tmp5
    r2new += einsum(r2, (0, 1, 2), tmp6, (3, 1, 4, 2), (0, 3, 4)) * -1
    del tmp6
    r2new += einsum(r2, (0, 1, 2), tmp7, (3, 4, 0, 1), (3, 4, 2))
    del tmp7
    r2new += einsum(r2, (0, 1, 2), tmp8, (3, 4, 1, 0), (4, 3, 2))
    del tmp8
    r2new += einsum(tmp9, (0, 1), tmp10, (2, 3, 1), (2, 0, 3)) * 2
    del tmp9, tmp10
    r2new += einsum(r2, (0, 1, 2), tmp11, (2, 3), (0, 1, 3)) * -1
    del tmp11
    r2new += einsum(r1, (0,), tmp12, (1, 2, 0, 3), (2, 1, 3)) * -1
    del tmp12
    r2new += einsum(tmp13, (0, 1), r2, (0, 2, 3), (1, 2, 3)) * -2
    r2new += einsum(r2, (0, 1, 2), tmp13, (1, 3), (0, 3, 2)) * -2
    del tmp13
    r2new += einsum(t1, (0, 1), tmp16, (2, 0, 3), (3, 2, 1))
    del tmp16
    r2new += einsum(t2, (0, 1, 2, 3), tmp17, (3,), (0, 1, 2)) * -2
    del tmp17
    r2new += einsum(r1, (0,), tmp18, (1, 2), (1, 0, 2))
    del tmp18
    r1new = einsum(ints.tmp14, (0, 1, 2, 3), tmp0, (2, 1, 3), (0,))
    del ints.tmp14, tmp0
    r1new += einsum(tmp1, (0, 1, 2), ints.tmp1, (3, 1, 0, 2), (3,)) * 2
    del ints.tmp1, tmp1
    r1new += einsum(tmp3, (0, 1, 2), tmp2, (0, 2), (1,)) * -2
    del tmp3, tmp2
    r1new += einsum(r1, (0,), tmp4, (0, 1), (1,)) * -1
    del tmp4

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_matvec_ea_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:02:54.892046.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp10 : array
    tmp100 : array
    tmp101 : array
    tmp102 : array
    tmp108 : array
    tmp109 : array
    tmp110 : array
    tmp111 : array
    tmp113 : array
    tmp114 : array
    tmp117 : array
    tmp119 : array
    tmp12 : array
    tmp120 : array
    tmp123 : array
    tmp128 : array
    tmp129 : array
    tmp130 : array
    tmp131 : array
    tmp132 : array
    tmp136 : array
    tmp15 : array
    tmp20 : array
    tmp21 : array
    tmp23 : array
    tmp24 : array
    tmp36 : array
    tmp39 : array
    tmp44 : array
    tmp45 : array
    tmp46 : array
    tmp47 : array
    tmp49 : array
    tmp5 : array
    tmp51 : array
    tmp62 : array
    tmp63 : array
    tmp64 : array
    tmp66 : array
    tmp68 : array
    tmp7 : array
    tmp70 : array
    tmp71 : array
    tmp72 : array
    tmp74 : array
    tmp76 : array
    tmp77 : array
    tmp79 : array
    tmp8 : array
    tmp80 : array
    tmp81 : array
    tmp83 : array
    tmp84 : array
    tmp89 : array
    tmp9 : array
    tmp91 : array
    tmp92 : array
    tmp93 : array
    tmp94 : array
    """

    tmp4 = einsum(t1, (0, 1), v.xov, (2, 0, 1), (2,))
    tmp9 = einsum(v.xov, (0, 1, 2), t1, (3, 2), (3, 1, 0))
    tmp12 = einsum(tmp4, (0,), v.xov, (0, 1, 2), (1, 2))
    tmp10 = einsum(v.xov, (0, 1, 2), tmp9, (1, 3, 0), (3, 2))
    tmp20 = einsum(t2, (0, 1, 2, 3), v.xov, (4, 1, 2), (0, 3, 4))
    tmp23 = einsum(t2, (0, 1, 2, 3), v.xov, (4, 1, 3), (0, 2, 4))
    tmp15 = einsum(v.xov, (0, 1, 2), v.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp1 = einsum(v.xov, (0, 1, 2), v.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp47 = einsum(tmp4, (0,), v.xoo, (0, 1, 2), (1, 2))
    tmp46 = einsum(v.xoo, (0, 1, 2), tmp9, (2, 3, 0), (1, 3))
    tmp49 = einsum(v.xov, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp84 = einsum(tmp12, (0, 1), t1, (2, 1), (2, 0))
    tmp83 = einsum(tmp10, (0, 1), t1, (2, 1), (2, 0))
    tmp72 = einsum(v.xov, (0, 1, 2), tmp20, (3, 2, 0), (3, 1))
    tmp74 = einsum(v.xov, (0, 1, 2), tmp23, (3, 2, 0), (3, 1))
    tmp76 = einsum(v.xov, (0, 1, 2), tmp9, (3, 4, 0), (3, 1, 4, 2))
    tmp63 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp7 = einsum(t1, (0, 1), v.xvv, (2, 3, 1), (0, 3, 2))
    tmp5 = einsum(tmp4, (0,), v.xvv, (0, 1, 2), (1, 2))
    del tmp4
    tmp136 = einsum(tmp20, (0, 1, 2), v.xov, (2, 3, 4), (0, 3, 1, 4))
    tmp132 = einsum(tmp23, (0, 1, 2), v.xov, (2, 3, 4), (0, 3, 1, 4))
    tmp131 = einsum(t2, (0, 1, 2, 3), tmp12, (1, 3), (0, 2))
    tmp130 = einsum(t2, (0, 1, 2, 3), tmp12, (1, 2), (0, 3))
    tmp129 = einsum(tmp10, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp128 = einsum(tmp10, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp123 = einsum(tmp15, (0, 1, 2, 3), t2, (4, 0, 5, 3), (4, 1, 5, 2))
    tmp120 = einsum(tmp20, (0, 1, 2), v.xvv, (2, 3, 4), (0, 1, 3, 4))
    tmp119 = einsum(t2, (0, 1, 2, 3), tmp1, (1, 4, 3, 5), (0, 2, 5, 4))
    tmp117 = einsum(tmp23, (0, 1, 2), v.xvv, (2, 3, 4), (0, 1, 3, 4))
    tmp114 = einsum(f.ov, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp113 = einsum(f.ov, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp111 = einsum(tmp47, (0, 1), t1, (1, 2), (0, 2))
    tmp110 = einsum(tmp46, (0, 1), t1, (1, 2), (0, 2))
    tmp109 = einsum(t2, (0, 1, 2, 3), tmp49, (4, 0, 1, 3), (4, 2))
    tmp108 = einsum(t2, (0, 1, 2, 3), tmp49, (4, 0, 1, 2), (4, 3))
    tmp102 = einsum(f.oo, (0, 1), t1, (1, 2), (0, 2))
    tmp101 = einsum(tmp84, (0, 1), t1, (1, 2), (0, 2))
    tmp100 = einsum(tmp83, (0, 1), t1, (1, 2), (0, 2))
    tmp94 = einsum(tmp72, (0, 1), t1, (1, 2), (0, 2))
    tmp93 = einsum(tmp74, (0, 1), t1, (1, 2), (0, 2))
    tmp92 = einsum(tmp76, (0, 1, 2, 3), t2, (2, 1, 3, 4), (0, 4))
    tmp91 = einsum(tmp76, (0, 1, 2, 3), t2, (2, 1, 4, 3), (0, 4))
    tmp89 = einsum(tmp63, (0, 1), t1, (0, 2), (1, 2))
    tmp81 = einsum(v.xov, (0, 1, 2), tmp7, (3, 4, 0), (3, 1, 2, 4))
    tmp80 = einsum(tmp7, (0, 1, 2), tmp9, (3, 0, 2), (3, 1))
    tmp79 = einsum(t1, (0, 1), tmp5, (2, 1), (0, 2))
    tmp77 = einsum(tmp76, (0, 1, 2, 3), t2, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp71 = einsum(tmp20, (0, 1, 2), v.xvv, (2, 3, 1), (0, 3))
    tmp70 = einsum(tmp23, (0, 1, 2), v.xvv, (2, 3, 1), (0, 3))
    tmp68 = einsum(v.xvv, (0, 1, 2), tmp9, (3, 4, 0), (3, 4, 1, 2))
    tmp66 = einsum(tmp7, (0, 1, 2), v.xvv, (2, 3, 4), (0, 3, 4, 1))
    tmp64 = einsum(v.xvv, (0, 1, 2), v.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp62 = einsum(t1, (0, 1), f.vv, (2, 1), (0, 2))
    tmp51 = einsum(tmp49, (0, 1, 2, 3), t2, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp45 = einsum(tmp7, (0, 1, 2), v.xoo, (2, 3, 0), (3, 1))
    tmp44 = einsum(v.xvv, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp39 = einsum(tmp15, (0, 1, 2, 3), t2, (4, 0, 3, 5), (4, 1, 5, 2))
    tmp36 = einsum(tmp1, (0, 1, 2, 3), t2, (4, 0, 2, 5), (4, 5, 3, 1))
    tmp24 = einsum(tmp23, (0, 1, 2), v.xov, (2, 0, 3), (1, 3))
    tmp21 = einsum(tmp20, (0, 1, 2), v.xov, (2, 0, 3), (1, 3))
    tmp8 = einsum(tmp7, (0, 1, 2), v.xov, (2, 0, 3), (3, 1))

    return {f"tmp1": tmp1, f"tmp10": tmp10, f"tmp100": tmp100, f"tmp101": tmp101, f"tmp102": tmp102, f"tmp108": tmp108, f"tmp109": tmp109, f"tmp110": tmp110, f"tmp111": tmp111, f"tmp113": tmp113, f"tmp114": tmp114, f"tmp117": tmp117, f"tmp119": tmp119, f"tmp12": tmp12, f"tmp120": tmp120, f"tmp123": tmp123, f"tmp128": tmp128, f"tmp129": tmp129, f"tmp130": tmp130, f"tmp131": tmp131, f"tmp132": tmp132, f"tmp136": tmp136, f"tmp15": tmp15, f"tmp20": tmp20, f"tmp21": tmp21, f"tmp23": tmp23, f"tmp24": tmp24, f"tmp36": tmp36, f"tmp39": tmp39, f"tmp44": tmp44, f"tmp45": tmp45, f"tmp46": tmp46, f"tmp47": tmp47, f"tmp49": tmp49, f"tmp5": tmp5, f"tmp51": tmp51, f"tmp62": tmp62, f"tmp63": tmp63, f"tmp64": tmp64, f"tmp66": tmp66, f"tmp68": tmp68, f"tmp7": tmp7, f"tmp70": tmp70, f"tmp71": tmp71, f"tmp72": tmp72, f"tmp74": tmp74, f"tmp76": tmp76, f"tmp77": tmp77, f"tmp79": tmp79, f"tmp8": tmp8, f"tmp80": tmp80, f"tmp81": tmp81, f"tmp83": tmp83, f"tmp84": tmp84, f"tmp89": tmp89, f"tmp9": tmp9, f"tmp91": tmp91, f"tmp92": tmp92, f"tmp93": tmp93, f"tmp94": tmp94}

def hbar_matvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:02:54.944078.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp14 = np.copy(f.ov) * 0.5
    tmp14 += ints.tmp12
    tmp14 += ints.tmp10 * -0.5
    tmp7 = np.copy(ints.tmp49)
    del ints.tmp49
    tmp7 += np.transpose(ints.tmp76, (0, 2, 1, 3))
    del ints.tmp76
    tmp0 = np.copy(np.transpose(r2, (2, 0, 1)))
    tmp0 += np.transpose(r2, (2, 1, 0)) * -0.5
    tmp1 = np.copy(f.ov)
    tmp1 += ints.tmp12 * 2
    tmp1 += ints.tmp10 * -1
    del ints.tmp10
    tmp6 = einsum(ints.tmp15, (0, 1, 2, 3), r2, (3, 2, 4), (0, 1, 4))
    tmp18 = np.copy(ints.tmp132)
    del ints.tmp132
    tmp18 += ints.tmp15 * 0.5
    tmp18 += np.transpose(ints.tmp81, (0, 1, 3, 2)) * 0.5
    del ints.tmp81
    tmp18 += ints.tmp123 * -0.5
    tmp18 += ints.tmp136 * -0.5
    del ints.tmp136
    tmp9 = np.copy(np.transpose(r2, (2, 0, 1)))
    tmp9 += einsum(t1, (0, 1), r1, (2,), (0, 1, 2)) * -1
    tmp12 = np.copy(ints.tmp9)
    del ints.tmp9
    tmp12 += np.transpose(v.xoo, (1, 2, 0))
    tmp2 = np.copy(np.transpose(r2, (2, 0, 1))) * -1
    tmp2 += np.transpose(r2, (2, 1, 0)) * 2
    tmp15 = einsum(t1, (0, 1), tmp14, (0, 2), (1, 2)) * 2
    del tmp14
    tmp17 = np.copy(ints.tmp117) * 2
    del ints.tmp117
    tmp17 += np.transpose(ints.tmp1, (0, 3, 2, 1))
    tmp17 += np.transpose(ints.tmp51, (0, 1, 3, 2))
    del ints.tmp51
    tmp17 += np.transpose(ints.tmp66, (0, 3, 1, 2))
    del ints.tmp66
    tmp17 += np.transpose(ints.tmp77, (0, 2, 3, 1))
    del ints.tmp77
    tmp17 += ints.tmp119 * -1
    del ints.tmp119
    tmp17 += ints.tmp120 * -1
    del ints.tmp120
    tmp17 += np.transpose(ints.tmp36, (0, 3, 2, 1)) * -1
    del ints.tmp36
    tmp5 = einsum(ints.tmp1, (0, 1, 2, 3), r2, (3, 2, 4), (0, 4, 1))
    tmp20 = np.copy(f.oo)
    tmp20 += np.transpose(ints.tmp47, (1, 0)) * 2
    del ints.tmp47
    tmp20 += ints.tmp63
    del ints.tmp63
    tmp20 += np.transpose(ints.tmp74, (1, 0)) * 2
    del ints.tmp74
    tmp20 += np.transpose(ints.tmp84, (1, 0)) * 2
    del ints.tmp84
    tmp20 += np.transpose(ints.tmp46, (1, 0)) * -1
    del ints.tmp46
    tmp20 += np.transpose(ints.tmp72, (1, 0)) * -1
    del ints.tmp72
    tmp20 += np.transpose(ints.tmp83, (1, 0)) * -1
    del ints.tmp83
    tmp8 = np.copy(ints.tmp123)
    tmp8 += ints.tmp44 * 0.5
    tmp8 += ints.tmp68 * 0.5
    tmp8 += ints.tmp39 * -0.5
    tmp8 += einsum(tmp7, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3)) * -0.5
    tmp21 = einsum(tmp0, (0, 1, 2), ints.tmp15, (0, 3, 1, 2), (3,)) * -2
    tmp21 += einsum(r1, (0,), tmp1, (1, 0), (1,))
    tmp10 = np.copy(ints.tmp44)
    del ints.tmp44
    tmp10 += ints.tmp68
    del ints.tmp68
    tmp10 += ints.tmp39 * -1
    del ints.tmp39
    tmp19 = einsum(ints.tmp1, (0, 1, 2, 3), r2, (2, 3, 4), (4, 0, 1)) * -1
    tmp19 += einsum(t1, (0, 1), tmp6, (2, 0, 3), (3, 2, 1))
    tmp19 += einsum(tmp9, (0, 1, 2), tmp7, (3, 0, 4, 2), (3, 4, 1))
    del tmp7
    tmp19 += einsum(tmp18, (0, 1, 2, 3), r1, (3,), (0, 1, 2)) * 2
    del tmp18
    tmp22 = np.copy(ints.tmp101) * 2
    del ints.tmp101
    tmp22 += ints.tmp102
    del ints.tmp102
    tmp22 += ints.tmp109 * 2
    del ints.tmp109
    tmp22 += ints.tmp111 * 2
    del ints.tmp111
    tmp22 += ints.tmp113
    del ints.tmp113
    tmp22 += ints.tmp129 * 2
    del ints.tmp129
    tmp22 += ints.tmp130 * 2
    del ints.tmp130
    tmp22 += ints.tmp45
    del ints.tmp45
    tmp22 += ints.tmp71
    del ints.tmp71
    tmp22 += ints.tmp80
    del ints.tmp80
    tmp22 += ints.tmp89
    del ints.tmp89
    tmp22 += ints.tmp91 * 2
    del ints.tmp91
    tmp22 += ints.tmp93 * 2
    del ints.tmp93
    tmp22 += f.ov * -1
    tmp22 += ints.tmp100 * -1
    del ints.tmp100
    tmp22 += ints.tmp108 * -1
    del ints.tmp108
    tmp22 += ints.tmp110 * -1
    del ints.tmp110
    tmp22 += ints.tmp114 * -2
    del ints.tmp114
    tmp22 += ints.tmp128 * -1
    del ints.tmp128
    tmp22 += ints.tmp12 * -2
    del ints.tmp12
    tmp22 += ints.tmp131 * -4
    del ints.tmp131
    tmp22 += ints.tmp62 * -1
    del ints.tmp62
    tmp22 += ints.tmp70 * -2
    del ints.tmp70
    tmp22 += ints.tmp79 * -2
    del ints.tmp79
    tmp22 += ints.tmp92 * -1
    del ints.tmp92
    tmp22 += ints.tmp94 * -1
    del ints.tmp94
    tmp13 = np.copy(ints.tmp23) * 2
    del ints.tmp23
    tmp13 += ints.tmp7
    del ints.tmp7
    tmp13 += np.transpose(v.xov, (1, 2, 0))
    tmp13 += ints.tmp20 * -1
    del ints.tmp20
    tmp13 += einsum(tmp12, (0, 1, 2), t1, (1, 3), (0, 3, 2)) * -1
    del tmp12
    tmp11 = einsum(tmp2, (0, 1, 2), v.xov, (3, 0, 2), (1, 3)) * 0.5
    tmp16 = np.copy(np.transpose(ints.tmp24, (1, 0))) * 2
    tmp16 += ints.tmp8
    tmp16 += f.vv * -1
    tmp16 += np.transpose(ints.tmp21, (1, 0)) * -1
    tmp16 += np.transpose(ints.tmp5, (1, 0)) * -2
    tmp16 += np.transpose(tmp15, (1, 0))
    del tmp15
    tmp4 = einsum(tmp0, (0, 1, 2), ints.tmp15, (0, 3, 1, 2), (3,)) * -1
    del ints.tmp15
    tmp4 += einsum(r1, (0,), tmp1, (1, 0), (1,)) * 0.5
    tmp3 = np.copy(f.vv)
    tmp3 += np.transpose(ints.tmp21, (1, 0))
    del ints.tmp21
    tmp3 += np.transpose(ints.tmp5, (1, 0)) * 2
    del ints.tmp5
    tmp3 += np.transpose(ints.tmp24, (1, 0)) * -2
    del ints.tmp24
    tmp3 += ints.tmp8 * -1
    del ints.tmp8
    r2new = einsum(r2, (0, 1, 2), ints.tmp123, (3, 2, 4, 1), (4, 0, 3))
    del ints.tmp123
    r2new += einsum(t1, (0, 1), tmp5, (0, 2, 3), (1, 3, 2)) * -1
    del tmp5
    r2new += einsum(ints.tmp64, (0, 1, 2, 3), r2, (1, 3, 4), (2, 0, 4))
    del ints.tmp64
    r2new += einsum(tmp6, (0, 1, 2), t2, (1, 0, 3, 4), (3, 4, 2))
    del tmp6
    r2new += einsum(tmp8, (0, 1, 2, 3), r2, (3, 4, 1), (2, 4, 0)) * -2
    del tmp8
    r2new += einsum(tmp10, (0, 1, 2, 3), tmp9, (1, 4, 3), (4, 2, 0)) * -1
    del tmp9, tmp10
    r2new += einsum(tmp11, (0, 1), tmp13, (2, 3, 1), (3, 0, 2)) * 2
    del tmp11, tmp13
    r2new += einsum(r2, (0, 1, 2), tmp16, (0, 3), (3, 1, 2)) * -1
    r2new += einsum(tmp16, (0, 1), r2, (2, 0, 3), (2, 1, 3)) * -1
    del tmp16
    r2new += einsum(r1, (0,), tmp17, (1, 2, 0, 3), (2, 3, 1)) * -1
    del tmp17
    r2new += einsum(tmp19, (0, 1, 2), t1, (1, 3), (2, 3, 0))
    del tmp19
    r2new += einsum(r2, (0, 1, 2), tmp20, (2, 3), (0, 1, 3)) * -1
    del tmp20
    r2new += einsum(t2, (0, 1, 2, 3), tmp21, (1,), (2, 3, 0))
    del tmp21
    r2new += einsum(tmp22, (0, 1), r1, (2,), (1, 2, 0))
    del tmp22
    r1new = einsum(tmp0, (0, 1, 2), ints.tmp1, (0, 3, 2, 1), (3,)) * -2
    del ints.tmp1, tmp0
    r1new += einsum(tmp1, (0, 1), tmp2, (0, 2, 1), (2,)) * -1
    del tmp1, tmp2
    r1new += einsum(tmp3, (0, 1), r1, (0,), (1,))
    del tmp3
    r1new += einsum(tmp4, (0,), t1, (0, 1), (1,)) * -2
    del tmp4

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ip_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:04:15.547381.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp0 : array
    tmp1 : array
    tmp10 : array
    tmp101 : array
    tmp102 : array
    tmp103 : array
    tmp106 : array
    tmp107 : array
    tmp109 : array
    tmp111 : array
    tmp114 : array
    tmp115 : array
    tmp117 : array
    tmp119 : array
    tmp120 : array
    tmp123 : array
    tmp125 : array
    tmp128 : array
    tmp13 : array
    tmp130 : array
    tmp133 : array
    tmp134 : array
    tmp139 : array
    tmp14 : array
    tmp145 : array
    tmp149 : array
    tmp150 : array
    tmp16 : array
    tmp177 : array
    tmp178 : array
    tmp18 : array
    tmp180 : array
    tmp19 : array
    tmp2 : array
    tmp22 : array
    tmp25 : array
    tmp26 : array
    tmp28 : array
    tmp3 : array
    tmp30 : array
    tmp32 : array
    tmp33 : array
    tmp35 : array
    tmp36 : array
    tmp38 : array
    tmp4 : array
    tmp41 : array
    tmp44 : array
    tmp46 : array
    tmp48 : array
    tmp50 : array
    tmp52 : array
    tmp55 : array
    tmp59 : array
    tmp6 : array
    tmp62 : array
    tmp63 : array
    tmp65 : array
    tmp68 : array
    tmp71 : array
    tmp74 : array
    tmp77 : array
    tmp80 : array
    tmp83 : array
    tmp86 : array
    tmp88 : array
    tmp9 : array
    tmp91 : array
    tmp93 : array
    tmp95 : array
    tmp98 : array
    """

    tmp15 = einsum(t1, (0, 1), v.xov, (2, 0, 1), (2,))
    tmp13 = einsum(v.xov, (0, 1, 2), t1, (3, 2), (3, 1, 0))
    tmp22 = einsum(tmp15, (0,), v.xov, (0, 1, 2), (1, 2))
    tmp62 = einsum(v.xov, (0, 1, 2), tmp13, (1, 3, 0), (3, 2))
    tmp101 = einsum(v.xov, (0, 1, 2), v.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp32 = einsum(t2, (0, 1, 2, 3), v.xov, (4, 1, 2), (0, 3, 4))
    tmp35 = einsum(t2, (0, 1, 2, 3), v.xov, (4, 1, 3), (0, 2, 4))
    tmp25 = einsum(t1, (0, 1), v.xvv, (2, 3, 1), (0, 3, 2))
    tmp133 = einsum(tmp13, (0, 1, 2), tmp13, (3, 4, 2), (0, 3, 1, 4))
    tmp107 = einsum(tmp22, (0, 1), t1, (2, 1), (2, 0))
    tmp106 = einsum(t1, (0, 1), tmp62, (2, 1), (0, 2))
    tmp119 = einsum(v.xvv, (0, 1, 2), tmp15, (0,), (1, 2))
    tmp114 = einsum(v.xoo, (0, 1, 2), tmp13, (3, 4, 0), (3, 1, 2, 4))
    tmp16 = einsum(tmp15, (0,), v.xoo, (0, 1, 2), (1, 2))
    del tmp15
    tmp14 = einsum(v.xoo, (0, 1, 2), tmp13, (2, 3, 0), (1, 3))
    tmp102 = einsum(t2, (0, 1, 2, 3), tmp101, (4, 5, 2, 3), (0, 1, 4, 5))
    tmp33 = einsum(tmp32, (0, 1, 2), v.xov, (2, 3, 1), (0, 3))
    tmp36 = einsum(v.xov, (0, 1, 2), tmp35, (3, 2, 0), (3, 1))
    tmp28 = einsum(v.xov, (0, 1, 2), tmp13, (3, 4, 0), (3, 1, 4, 2))
    tmp58 = einsum(v.xov, (0, 1, 2), v.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp10 = einsum(v.xov, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp18 = einsum(v.xoo, (0, 1, 2), v.xoo, (0, 3, 4), (3, 1, 2, 4))
    tmp0 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp180 = einsum(v.xov, (0, 1, 2), tmp35, (1, 3, 0), (3, 2))
    tmp178 = einsum(tmp32, (0, 1, 2), v.xov, (2, 0, 3), (1, 3))
    tmp177 = einsum(tmp25, (0, 1, 2), v.xov, (2, 0, 3), (3, 1))
    tmp150 = einsum(tmp101, (0, 1, 2, 3), t2, (4, 0, 5, 3), (4, 1, 5, 2))
    tmp149 = einsum(tmp101, (0, 1, 2, 3), t2, (4, 0, 3, 5), (4, 1, 5, 2))
    tmp145 = einsum(tmp13, (0, 1, 2), v.xvv, (2, 3, 4), (0, 1, 3, 4))
    tmp139 = einsum(v.xvv, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp134 = einsum(t1, (0, 1), tmp133, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp130 = einsum(tmp107, (0, 1), t1, (1, 2), (0, 2))
    tmp128 = einsum(t1, (0, 1), tmp106, (2, 0), (2, 1))
    tmp125 = einsum(tmp25, (0, 1, 2), tmp13, (3, 4, 2), (3, 0, 4, 1))
    tmp123 = einsum(tmp25, (0, 1, 2), tmp13, (3, 0, 2), (3, 1))
    tmp120 = einsum(t1, (0, 1), tmp119, (2, 1), (0, 2))
    tmp117 = einsum(t1, (0, 1), tmp114, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp115 = einsum(t1, (0, 1), tmp114, (2, 3, 0, 4), (2, 3, 4, 1))
    tmp111 = einsum(tmp16, (0, 1), t1, (1, 2), (0, 2))
    tmp109 = einsum(t1, (0, 1), tmp14, (2, 0), (2, 1))
    tmp103 = einsum(t1, (0, 1), tmp102, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp98 = einsum(tmp33, (0, 1), t1, (1, 2), (0, 2))
    tmp95 = einsum(tmp36, (0, 1), t1, (1, 2), (0, 2))
    tmp93 = einsum(t2, (0, 1, 2, 3), tmp28, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp91 = einsum(t2, (0, 1, 2, 3), tmp28, (4, 5, 1, 2), (4, 0, 5, 3))
    tmp88 = einsum(tmp35, (0, 1, 2), tmp13, (3, 4, 2), (3, 0, 4, 1))
    tmp86 = einsum(tmp32, (0, 1, 2), tmp13, (3, 4, 2), (3, 0, 4, 1))
    tmp83 = einsum(t2, (0, 1, 2, 3), tmp28, (4, 1, 0, 2), (4, 3))
    tmp80 = einsum(t2, (0, 1, 2, 3), tmp28, (4, 1, 0, 3), (4, 2))
    tmp77 = einsum(t2, (0, 1, 2, 3), tmp22, (4, 3), (0, 1, 4, 2))
    tmp74 = einsum(t2, (0, 1, 2, 3), tmp62, (4, 3), (0, 1, 4, 2))
    tmp71 = einsum(t2, (0, 1, 2, 3), tmp22, (1, 3), (0, 2))
    tmp68 = einsum(tmp22, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp65 = einsum(tmp62, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp63 = einsum(tmp62, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp59 = einsum(tmp58, (0, 1, 2, 3), t2, (4, 5, 3, 1), (4, 5, 0, 2))
    del tmp58
    tmp55 = einsum(v.xvv, (0, 1, 2), tmp32, (3, 2, 0), (3, 1))
    tmp52 = einsum(v.xvv, (0, 1, 2), tmp35, (3, 2, 0), (3, 1))
    tmp50 = einsum(v.xoo, (0, 1, 2), tmp35, (3, 4, 0), (3, 1, 2, 4))
    tmp48 = einsum(tmp32, (0, 1, 2), v.xoo, (2, 3, 4), (0, 3, 4, 1))
    tmp46 = einsum(t2, (0, 1, 2, 3), tmp10, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp44 = einsum(t2, (0, 1, 2, 3), tmp10, (4, 1, 5, 2), (0, 4, 5, 3))
    tmp41 = einsum(tmp10, (0, 1, 2, 3), t2, (1, 2, 4, 3), (0, 4))
    tmp38 = einsum(tmp10, (0, 1, 2, 3), t2, (1, 2, 3, 4), (0, 4))
    tmp30 = einsum(tmp25, (0, 1, 2), v.xoo, (2, 3, 4), (0, 3, 4, 1))
    tmp26 = einsum(tmp25, (0, 1, 2), v.xoo, (2, 3, 0), (3, 1))
    tmp19 = einsum(t1, (0, 1), tmp18, (2, 0, 3, 4), (4, 2, 3, 1))
    tmp9 = einsum(tmp0, (0, 1), t1, (0, 2), (1, 2))
    tmp6 = einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp4 = einsum(f.ov, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp3 = einsum(f.ov, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp2 = einsum(t1, (0, 1), f.vv, (2, 1), (0, 2))
    tmp1 = einsum(f.oo, (0, 1), t1, (1, 2), (0, 2))

    return {f"tmp0": tmp0, f"tmp1": tmp1, f"tmp10": tmp10, f"tmp101": tmp101, f"tmp102": tmp102, f"tmp103": tmp103, f"tmp106": tmp106, f"tmp107": tmp107, f"tmp109": tmp109, f"tmp111": tmp111, f"tmp114": tmp114, f"tmp115": tmp115, f"tmp117": tmp117, f"tmp119": tmp119, f"tmp120": tmp120, f"tmp123": tmp123, f"tmp125": tmp125, f"tmp128": tmp128, f"tmp13": tmp13, f"tmp130": tmp130, f"tmp133": tmp133, f"tmp134": tmp134, f"tmp139": tmp139, f"tmp14": tmp14, f"tmp145": tmp145, f"tmp149": tmp149, f"tmp150": tmp150, f"tmp16": tmp16, f"tmp177": tmp177, f"tmp178": tmp178, f"tmp18": tmp18, f"tmp180": tmp180, f"tmp19": tmp19, f"tmp2": tmp2, f"tmp22": tmp22, f"tmp25": tmp25, f"tmp26": tmp26, f"tmp28": tmp28, f"tmp3": tmp3, f"tmp30": tmp30, f"tmp32": tmp32, f"tmp33": tmp33, f"tmp35": tmp35, f"tmp36": tmp36, f"tmp38": tmp38, f"tmp4": tmp4, f"tmp41": tmp41, f"tmp44": tmp44, f"tmp46": tmp46, f"tmp48": tmp48, f"tmp50": tmp50, f"tmp52": tmp52, f"tmp55": tmp55, f"tmp59": tmp59, f"tmp6": tmp6, f"tmp62": tmp62, f"tmp63": tmp63, f"tmp65": tmp65, f"tmp68": tmp68, f"tmp71": tmp71, f"tmp74": tmp74, f"tmp77": tmp77, f"tmp80": tmp80, f"tmp83": tmp83, f"tmp86": tmp86, f"tmp88": tmp88, f"tmp9": tmp9, f"tmp91": tmp91, f"tmp93": tmp93, f"tmp95": tmp95, f"tmp98": tmp98}

def hbar_lmatvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:04:15.604810.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp10 = einsum(r2, (0, 1, 2), t1, (3, 2), (0, 1, 3))
    tmp13 = np.copy(tmp10) * -1
    tmp13 += np.transpose(tmp10, (1, 0, 2)) * 2
    tmp0 = np.copy(r2)
    tmp0 += np.transpose(r2, (1, 0, 2)) * -0.5
    tmp12 = np.copy(ints.tmp25)
    del ints.tmp25
    tmp12 += ints.tmp35 * 2
    del ints.tmp35
    tmp12 += np.transpose(v.xov, (1, 2, 0))
    tmp12 += ints.tmp32 * -1
    del ints.tmp32
    tmp14 = np.copy(ints.tmp13)
    del ints.tmp13
    tmp14 += np.transpose(v.xoo, (1, 2, 0))
    tmp16 = np.copy(f.ov)
    tmp16 += ints.tmp22 * 2
    tmp16 += ints.tmp62 * -1
    del ints.tmp62
    tmp19 = np.copy(np.transpose(t2, (0, 1, 3, 2)))
    tmp19 += t2 * -0.5
    tmp8 = np.copy(ints.tmp139)
    tmp8 += ints.tmp145
    tmp8 += ints.tmp149 * -1
    tmp21 = np.copy(ints.tmp10)
    tmp21 += np.transpose(ints.tmp28, (2, 0, 1, 3))
    tmp15 = einsum(tmp12, (0, 1, 2), tmp0, (0, 3, 1), (3, 2)) * -1
    del tmp12
    tmp15 += einsum(tmp13, (0, 1, 2), tmp14, (1, 2, 3), (0, 3)) * 0.5
    del tmp13, tmp14
    tmp18 = np.copy(f.oo) * 0.5
    tmp18 += np.transpose(ints.tmp0, (1, 0)) * 0.5
    tmp18 += ints.tmp107
    tmp18 += ints.tmp16
    tmp18 += ints.tmp36
    tmp18 += ints.tmp106 * -0.5
    tmp18 += ints.tmp14 * -0.5
    tmp18 += ints.tmp33 * -0.5
    tmp17 = np.copy(np.transpose(ints.tmp177, (1, 0)))
    del ints.tmp177
    tmp17 += ints.tmp180 * 2
    del ints.tmp180
    tmp17 += f.vv * -1
    tmp17 += ints.tmp119 * -2
    del ints.tmp119
    tmp17 += ints.tmp178 * -1
    del ints.tmp178
    tmp17 += einsum(tmp16, (0, 1), t1, (0, 2), (2, 1))
    tmp7 = np.copy(ints.tmp139) * 0.5
    del ints.tmp139
    tmp7 += ints.tmp145 * 0.5
    del ints.tmp145
    tmp7 += ints.tmp150
    tmp7 += ints.tmp149 * -0.5
    del ints.tmp149
    tmp20 = einsum(r2, (0, 1, 2), tmp19, (0, 1, 3, 2), (3,))
    del tmp19
    tmp9 = np.copy(ints.tmp102)
    del ints.tmp102
    tmp9 += np.transpose(ints.tmp114, (0, 1, 3, 2))
    tmp9 += ints.tmp133
    del ints.tmp133
    tmp9 += np.transpose(ints.tmp18, (2, 3, 1, 0))
    del ints.tmp18
    tmp11 = np.copy(ints.tmp10)
    tmp11 += np.transpose(ints.tmp28, (0, 2, 1, 3))
    tmp4 = np.copy(ints.tmp111) * 2
    del ints.tmp111
    tmp4 += ints.tmp123
    del ints.tmp123
    tmp4 += ints.tmp130 * 2
    del ints.tmp130
    tmp4 += ints.tmp1
    del ints.tmp1
    tmp4 += ints.tmp26
    del ints.tmp26
    tmp4 += ints.tmp3
    del ints.tmp3
    tmp4 += ints.tmp41 * 2
    del ints.tmp41
    tmp4 += ints.tmp55
    del ints.tmp55
    tmp4 += ints.tmp65 * 2
    del ints.tmp65
    tmp4 += ints.tmp68 * 2
    del ints.tmp68
    tmp4 += ints.tmp80 * 2
    del ints.tmp80
    tmp4 += ints.tmp95 * 2
    del ints.tmp95
    tmp4 += ints.tmp9
    del ints.tmp9
    tmp4 += f.ov * -1
    tmp4 += ints.tmp109 * -1
    del ints.tmp109
    tmp4 += ints.tmp120 * -2
    del ints.tmp120
    tmp4 += ints.tmp128 * -1
    del ints.tmp128
    tmp4 += ints.tmp22 * -2
    del ints.tmp22
    tmp4 += ints.tmp2 * -1
    del ints.tmp2
    tmp4 += ints.tmp38 * -1
    del ints.tmp38
    tmp4 += ints.tmp4 * -2
    del ints.tmp4
    tmp4 += ints.tmp52 * -2
    del ints.tmp52
    tmp4 += ints.tmp63 * -1
    del ints.tmp63
    tmp4 += ints.tmp71 * -4
    del ints.tmp71
    tmp4 += ints.tmp83 * -1
    del ints.tmp83
    tmp4 += ints.tmp98 * -1
    del ints.tmp98
    tmp6 = np.copy(f.oo)
    tmp6 += np.transpose(ints.tmp0, (1, 0))
    del ints.tmp0
    tmp6 += ints.tmp107 * 2
    del ints.tmp107
    tmp6 += np.transpose(ints.tmp16, (1, 0)) * 2
    del ints.tmp16
    tmp6 += ints.tmp36 * 2
    del ints.tmp36
    tmp6 += ints.tmp106 * -1
    del ints.tmp106
    tmp6 += ints.tmp14 * -1
    del ints.tmp14
    tmp6 += ints.tmp33 * -1
    del ints.tmp33
    tmp2 = np.copy(r2) * -1
    tmp2 += np.transpose(r2, (1, 0, 2)) * 2
    tmp3 = np.copy(ints.tmp117)
    del ints.tmp117
    tmp3 += np.transpose(ints.tmp46, (0, 2, 1, 3))
    del ints.tmp46
    tmp3 += np.transpose(ints.tmp48, (0, 2, 1, 3))
    del ints.tmp48
    tmp3 += np.transpose(ints.tmp74, (0, 2, 1, 3))
    del ints.tmp74
    tmp3 += np.transpose(ints.tmp91, (0, 2, 1, 3))
    del ints.tmp91
    tmp3 += ints.tmp30 * -1
    del ints.tmp30
    tmp3 += np.transpose(ints.tmp50, (0, 2, 1, 3)) * -2
    del ints.tmp50
    tmp3 += np.transpose(ints.tmp6, (1, 0, 2, 3)) * -1
    del ints.tmp6
    tmp3 += np.transpose(ints.tmp77, (0, 2, 1, 3)) * -2
    del ints.tmp77
    tmp1 = np.copy(ints.tmp103)
    del ints.tmp103
    tmp1 += ints.tmp115
    del ints.tmp115
    tmp1 += ints.tmp134
    del ints.tmp134
    tmp1 += np.transpose(ints.tmp19, (0, 2, 1, 3))
    del ints.tmp19
    tmp1 += ints.tmp44
    del ints.tmp44
    tmp1 += ints.tmp86
    del ints.tmp86
    tmp1 += ints.tmp93
    del ints.tmp93
    tmp1 += np.transpose(ints.tmp10, (1, 2, 0, 3)) * -1
    del ints.tmp10
    tmp1 += ints.tmp125 * -1
    del ints.tmp125
    tmp1 += ints.tmp28 * -1
    del ints.tmp28
    tmp1 += ints.tmp59 * -1
    del ints.tmp59
    tmp1 += ints.tmp88 * -2
    del ints.tmp88
    tmp5 = np.copy(r2) * 2
    tmp5 += np.transpose(r2, (1, 0, 2)) * -1
    r2new = einsum(r2, (0, 1, 2), ints.tmp114, (1, 0, 3, 4), (3, 4, 2))
    del ints.tmp114
    r2new += einsum(ints.tmp150, (0, 1, 2, 3), r2, (4, 0, 2), (1, 4, 3))
    del ints.tmp150
    r2new += einsum(r2, (0, 1, 2), tmp7, (0, 3, 2, 4), (3, 1, 4)) * -2
    del tmp7
    r2new += einsum(r2, (0, 1, 2), tmp8, (1, 3, 2, 4), (0, 3, 4)) * -1
    del tmp8
    r2new += einsum(tmp9, (0, 1, 2, 3), r2, (0, 1, 4), (2, 3, 4))
    del tmp9
    r2new += einsum(tmp11, (0, 1, 2, 3), tmp10, (0, 4, 2), (1, 4, 3))
    r2new += einsum(tmp10, (0, 1, 2), tmp11, (1, 3, 2, 4), (0, 3, 4))
    del tmp10, tmp11
    r2new += einsum(tmp15, (0, 1), v.xov, (1, 2, 3), (2, 0, 3)) * -2
    del tmp15
    r2new += einsum(r2, (0, 1, 2), tmp17, (2, 3), (0, 1, 3)) * -1
    del tmp17
    r2new += einsum(tmp18, (0, 1), r2, (0, 2, 3), (1, 2, 3)) * -2
    r2new += einsum(r2, (0, 1, 2), tmp18, (1, 3), (0, 3, 2)) * -2
    del tmp18
    r2new += einsum(tmp20, (0,), ints.tmp101, (1, 2, 3, 0), (1, 2, 3)) * -2
    del tmp20, ints.tmp101
    r2new += einsum(r1, (0,), tmp21, (1, 0, 2, 3), (2, 1, 3))
    del tmp21
    r2new += einsum(r1, (0,), tmp16, (1, 2), (1, 0, 2)) * -1
    del tmp16
    r1new = einsum(tmp0, (0, 1, 2), tmp1, (1, 0, 3, 2), (3,)) * -2
    del tmp0, tmp1
    r1new += einsum(tmp2, (0, 1, 2), tmp3, (1, 3, 0, 2), (3,)) * -1
    del tmp2, tmp3
    r1new += einsum(tmp4, (0, 1), tmp5, (0, 2, 1), (2,))
    del tmp4, tmp5
    r1new += einsum(r1, (0,), tmp6, (0, 1), (1,)) * -1
    del tmp6

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ea_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:05:39.663415.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp10 : array
    tmp100 : array
    tmp102 : array
    tmp105 : array
    tmp107 : array
    tmp11 : array
    tmp110 : array
    tmp111 : array
    tmp113 : array
    tmp114 : array
    tmp12 : array
    tmp120 : array
    tmp123 : array
    tmp125 : array
    tmp127 : array
    tmp129 : array
    tmp130 : array
    tmp132 : array
    tmp133 : array
    tmp16 : array
    tmp163 : array
    tmp18 : array
    tmp19 : array
    tmp2 : array
    tmp20 : array
    tmp23 : array
    tmp25 : array
    tmp29 : array
    tmp3 : array
    tmp31 : array
    tmp34 : array
    tmp35 : array
    tmp37 : array
    tmp38 : array
    tmp4 : array
    tmp40 : array
    tmp41 : array
    tmp44 : array
    tmp47 : array
    tmp50 : array
    tmp53 : array
    tmp56 : array
    tmp58 : array
    tmp61 : array
    tmp63 : array
    tmp65 : array
    tmp66 : array
    tmp67 : array
    tmp69 : array
    tmp72 : array
    tmp75 : array
    tmp82 : array
    tmp83 : array
    tmp86 : array
    tmp89 : array
    tmp92 : array
    tmp93 : array
    tmp96 : array
    tmp97 : array
    """

    tmp15 = einsum(t1, (0, 1), v.xov, (2, 0, 1), (2,))
    tmp65 = einsum(v.xov, (0, 1, 2), t1, (3, 2), (3, 1, 0))
    tmp20 = einsum(tmp15, (0,), v.xov, (0, 1, 2), (1, 2))
    tmp66 = einsum(tmp65, (0, 1, 2), v.xov, (2, 0, 3), (1, 3))
    tmp34 = einsum(t2, (0, 1, 2, 3), v.xov, (4, 1, 2), (0, 3, 4))
    tmp37 = einsum(t2, (0, 1, 2, 3), v.xov, (4, 1, 3), (0, 2, 4))
    tmp132 = einsum(t1, (0, 1), tmp20, (2, 1), (0, 2))
    tmp129 = einsum(t1, (0, 1), tmp66, (2, 1), (0, 2))
    tmp18 = einsum(t1, (0, 1), v.xvv, (2, 3, 1), (0, 3, 2))
    tmp16 = einsum(v.xvv, (0, 1, 2), tmp15, (0,), (1, 2))
    tmp113 = einsum(tmp15, (0,), v.xoo, (0, 1, 2), (1, 2))
    del tmp15
    tmp110 = einsum(v.xoo, (0, 1, 2), tmp65, (2, 3, 0), (1, 3))
    tmp25 = einsum(v.xov, (0, 1, 2), v.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp96 = einsum(v.xov, (0, 1, 2), tmp34, (3, 2, 0), (3, 1))
    tmp92 = einsum(v.xov, (0, 1, 2), tmp37, (3, 2, 0), (3, 1))
    tmp82 = einsum(tmp65, (0, 1, 2), v.xov, (2, 3, 4), (0, 3, 1, 4))
    tmp12 = einsum(v.xov, (0, 1, 2), v.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp40 = einsum(v.xov, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp10 = einsum(t1, (0, 1), f.ov, (2, 1), (2, 0))
    tmp163 = einsum(v.xvv, (0, 1, 2), v.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp133 = einsum(tmp132, (0, 1), t1, (1, 2), (0, 2))
    tmp130 = einsum(tmp129, (0, 1), t1, (1, 2), (0, 2))
    tmp127 = einsum(v.xov, (0, 1, 2), tmp18, (3, 4, 0), (3, 1, 2, 4))
    tmp125 = einsum(v.xvv, (0, 1, 2), tmp65, (3, 4, 0), (3, 4, 1, 2))
    tmp123 = einsum(tmp18, (0, 1, 2), tmp65, (3, 0, 2), (3, 1))
    tmp120 = einsum(t1, (0, 1), tmp16, (2, 1), (0, 2))
    tmp114 = einsum(t1, (0, 1), tmp113, (2, 0), (2, 1))
    tmp111 = einsum(tmp110, (0, 1), t1, (1, 2), (0, 2))
    tmp107 = einsum(t2, (0, 1, 2, 3), tmp25, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp105 = einsum(tmp25, (0, 1, 2, 3), t2, (4, 0, 3, 5), (4, 1, 5, 2))
    tmp102 = einsum(tmp37, (0, 1, 2), v.xov, (2, 3, 4), (0, 3, 1, 4))
    tmp100 = einsum(tmp34, (0, 1, 2), v.xov, (2, 3, 4), (0, 3, 1, 4))
    tmp97 = einsum(tmp96, (0, 1), t1, (1, 2), (0, 2))
    tmp93 = einsum(tmp92, (0, 1), t1, (1, 2), (0, 2))
    tmp89 = einsum(tmp82, (0, 1, 2, 3), t2, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp86 = einsum(t2, (0, 1, 2, 3), tmp82, (4, 1, 0, 2), (4, 3))
    tmp83 = einsum(t2, (0, 1, 2, 3), tmp82, (4, 1, 0, 3), (4, 2))
    tmp75 = einsum(t2, (0, 1, 2, 3), tmp20, (1, 3), (0, 2))
    tmp72 = einsum(tmp20, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp69 = einsum(t2, (0, 1, 2, 3), tmp66, (1, 3), (0, 2))
    tmp67 = einsum(tmp66, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp63 = einsum(t2, (0, 1, 2, 3), tmp12, (1, 3, 4, 5), (0, 2, 5, 4))
    tmp61 = einsum(tmp12, (0, 1, 2, 3), t2, (4, 0, 1, 5), (4, 5, 3, 2))
    tmp58 = einsum(v.xvv, (0, 1, 2), tmp37, (3, 4, 0), (3, 4, 1, 2))
    tmp56 = einsum(tmp34, (0, 1, 2), v.xvv, (2, 3, 4), (0, 1, 3, 4))
    tmp53 = einsum(v.xvv, (0, 1, 2), tmp34, (3, 2, 0), (3, 1))
    tmp50 = einsum(tmp37, (0, 1, 2), v.xvv, (2, 3, 1), (0, 3))
    tmp47 = einsum(t2, (0, 1, 2, 3), tmp40, (0, 4, 1, 5), (4, 2, 3, 5))
    tmp44 = einsum(tmp40, (0, 1, 2, 3), t2, (0, 2, 4, 3), (1, 4))
    tmp41 = einsum(tmp40, (0, 1, 2, 3), t2, (0, 2, 3, 4), (1, 4))
    tmp38 = einsum(v.xov, (0, 1, 2), tmp37, (1, 3, 0), (3, 2))
    tmp35 = einsum(tmp34, (0, 1, 2), v.xov, (2, 0, 3), (1, 3))
    tmp31 = einsum(tmp18, (0, 1, 2), v.xvv, (2, 3, 4), (0, 3, 4, 1))
    tmp29 = einsum(v.xvv, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp23 = einsum(tmp18, (0, 1, 2), v.xoo, (2, 3, 0), (3, 1))
    tmp19 = einsum(tmp18, (0, 1, 2), v.xov, (2, 0, 3), (3, 1))
    tmp11 = einsum(tmp10, (0, 1), t1, (0, 2), (1, 2))
    tmp4 = einsum(f.ov, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    tmp3 = einsum(f.ov, (0, 1), t2, (2, 0, 1, 3), (2, 3))
    tmp2 = einsum(t1, (0, 1), f.vv, (2, 1), (0, 2))
    tmp1 = einsum(f.oo, (0, 1), t1, (1, 2), (0, 2))

    return {f"tmp1": tmp1, f"tmp10": tmp10, f"tmp100": tmp100, f"tmp102": tmp102, f"tmp105": tmp105, f"tmp107": tmp107, f"tmp11": tmp11, f"tmp110": tmp110, f"tmp111": tmp111, f"tmp113": tmp113, f"tmp114": tmp114, f"tmp12": tmp12, f"tmp120": tmp120, f"tmp123": tmp123, f"tmp125": tmp125, f"tmp127": tmp127, f"tmp129": tmp129, f"tmp130": tmp130, f"tmp132": tmp132, f"tmp133": tmp133, f"tmp16": tmp16, f"tmp163": tmp163, f"tmp18": tmp18, f"tmp19": tmp19, f"tmp2": tmp2, f"tmp20": tmp20, f"tmp23": tmp23, f"tmp25": tmp25, f"tmp29": tmp29, f"tmp3": tmp3, f"tmp31": tmp31, f"tmp34": tmp34, f"tmp35": tmp35, f"tmp37": tmp37, f"tmp38": tmp38, f"tmp4": tmp4, f"tmp40": tmp40, f"tmp41": tmp41, f"tmp44": tmp44, f"tmp47": tmp47, f"tmp50": tmp50, f"tmp53": tmp53, f"tmp56": tmp56, f"tmp58": tmp58, f"tmp61": tmp61, f"tmp63": tmp63, f"tmp65": tmp65, f"tmp66": tmp66, f"tmp67": tmp67, f"tmp69": tmp69, f"tmp72": tmp72, f"tmp75": tmp75, f"tmp82": tmp82, f"tmp83": tmp83, f"tmp86": tmp86, f"tmp89": tmp89, f"tmp92": tmp92, f"tmp93": tmp93, f"tmp96": tmp96, f"tmp97": tmp97}

def hbar_lmatvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:05:39.714441.

    Parameters
    ----------
    f : array
        Fock matrix.
    r1 : array
        R1 amplitudes.
    r2 : array
        R2 amplitudes.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    r1new : array
        Updated R1 residuals.
    r2new : array
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    tmp25 = np.copy(ints.tmp65)
    del ints.tmp65
    tmp25 += np.transpose(v.xoo, (1, 2, 0))
    tmp16 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp16 += t2 * 2
    tmp19 = np.copy(f.ov)
    tmp19 += ints.tmp20 * 2
    tmp19 += ints.tmp66 * -1
    del ints.tmp66
    tmp10 = einsum(r2, (0, 1, 2), t1, (3, 1), (2, 3, 0))
    tmp4 = np.copy(np.transpose(r2, (2, 0, 1))) * -0.5
    tmp4 += np.transpose(r2, (2, 1, 0))
    tmp26 = np.copy(ints.tmp18)
    del ints.tmp18
    tmp26 += ints.tmp37 * 2
    del ints.tmp37
    tmp26 += np.transpose(v.xov, (1, 2, 0))
    tmp26 += ints.tmp34 * -1
    del ints.tmp34
    tmp26 += einsum(tmp25, (0, 1, 2), t1, (1, 3), (0, 3, 2)) * -1
    del tmp25
    tmp22 = np.copy(ints.tmp40)
    tmp22 += np.transpose(ints.tmp82, (0, 2, 1, 3))
    tmp17 = einsum(r2, (0, 1, 2), tmp16, (2, 3, 0, 1), (3,))
    del tmp16
    tmp15 = einsum(r1, (0,), t1, (1, 0), (1,))
    tmp28 = einsum(tmp19, (0, 1), t1, (0, 2), (2, 1))
    tmp11 = einsum(tmp10, (0, 1, 2), t1, (3, 2), (0, 3, 1))
    tmp0 = np.copy(np.transpose(r2, (2, 0, 1)))
    tmp0 += np.transpose(r2, (2, 1, 0)) * -0.5
    tmp21 = einsum(t2, (0, 1, 2, 3), r2, (2, 3, 4), (4, 0, 1))
    tmp30 = np.copy(f.oo)
    tmp30 += np.transpose(ints.tmp10, (1, 0))
    del ints.tmp10
    tmp30 += ints.tmp113 * 2
    del ints.tmp113
    tmp30 += ints.tmp132 * 2
    del ints.tmp132
    tmp30 += ints.tmp92 * 2
    del ints.tmp92
    tmp30 += ints.tmp110 * -1
    del ints.tmp110
    tmp30 += ints.tmp129 * -1
    del ints.tmp129
    tmp30 += ints.tmp96 * -1
    del ints.tmp96
    tmp27 = einsum(tmp4, (0, 1, 2), tmp26, (0, 2, 3), (1, 3)) * -1
    del tmp26
    tmp24 = np.copy(ints.tmp105)
    tmp24 += ints.tmp125 * -1
    tmp24 += ints.tmp29 * -1
    tmp24 += einsum(t1, (0, 1), tmp22, (2, 3, 0, 4), (2, 3, 1, 4))
    tmp18 = np.copy(tmp15)
    del tmp15
    tmp18 += tmp17 * -1
    del tmp17
    tmp29 = np.copy(np.transpose(ints.tmp19, (1, 0)))
    tmp29 += ints.tmp38 * 2
    tmp29 += f.vv * -1
    tmp29 += ints.tmp16 * -2
    tmp29 += ints.tmp35 * -1
    tmp29 += tmp28
    del tmp28
    tmp23 = np.copy(ints.tmp107)
    tmp23 += ints.tmp125 * 0.5
    tmp23 += ints.tmp29 * 0.5
    tmp23 += ints.tmp105 * -0.5
    tmp23 += einsum(t1, (0, 1), tmp22, (2, 3, 0, 4), (2, 3, 1, 4)) * -0.5
    del tmp22
    tmp20 = einsum(t1, (0, 1), r2, (1, 2, 3), (3, 0, 2))
    tmp8 = np.copy(ints.tmp102) * 2
    del ints.tmp102
    tmp8 += np.transpose(ints.tmp127, (0, 1, 3, 2))
    del ints.tmp127
    tmp8 += ints.tmp25
    tmp8 += ints.tmp100 * -1
    del ints.tmp100
    tmp8 += ints.tmp107 * -1
    tmp12 = np.copy(tmp11)
    tmp12 += np.transpose(tmp11, (0, 2, 1)) * -0.5
    tmp6 = np.copy(np.transpose(ints.tmp125, (0, 1, 3, 2)))
    del ints.tmp125
    tmp6 += np.transpose(ints.tmp29, (0, 1, 3, 2))
    del ints.tmp29
    tmp6 += ints.tmp105 * -1
    del ints.tmp105
    tmp2 = np.copy(np.transpose(r2, (2, 0, 1))) * -1
    tmp2 += np.transpose(r2, (2, 1, 0)) * 2
    tmp3 = np.copy(ints.tmp47)
    del ints.tmp47
    tmp3 += ints.tmp58 * 2
    del ints.tmp58
    tmp3 += ints.tmp56 * -1
    del ints.tmp56
    tmp3 += np.transpose(ints.tmp63, (0, 1, 3, 2)) * -1
    del ints.tmp63
    tmp1 = np.copy(ints.tmp12)
    tmp1 += ints.tmp31
    del ints.tmp31
    tmp1 += np.transpose(ints.tmp89, (0, 3, 1, 2))
    del ints.tmp89
    tmp1 += np.transpose(ints.tmp61, (0, 2, 1, 3)) * -1
    del ints.tmp61
    tmp14 = np.copy(f.vv)
    tmp14 += np.transpose(ints.tmp16, (1, 0)) * 2
    del ints.tmp16
    tmp14 += ints.tmp35
    del ints.tmp35
    tmp14 += np.transpose(ints.tmp19, (1, 0)) * -1
    del ints.tmp19
    tmp14 += ints.tmp38 * -2
    del ints.tmp38
    tmp7 = einsum(tmp0, (0, 1, 2), t1, (3, 2), (0, 3, 1)) * 2
    tmp5 = einsum(tmp4, (0, 1, 2), t1, (3, 2), (0, 3, 1))
    del tmp4
    tmp9 = np.copy(ints.tmp114) * 2
    del ints.tmp114
    tmp9 += ints.tmp11
    del ints.tmp11
    tmp9 += ints.tmp123
    del ints.tmp123
    tmp9 += ints.tmp133 * 2
    del ints.tmp133
    tmp9 += ints.tmp1
    del ints.tmp1
    tmp9 += ints.tmp23
    del ints.tmp23
    tmp9 += ints.tmp3
    del ints.tmp3
    tmp9 += ints.tmp44 * 2
    del ints.tmp44
    tmp9 += ints.tmp53
    del ints.tmp53
    tmp9 += ints.tmp69 * 2
    del ints.tmp69
    tmp9 += ints.tmp72 * 2
    del ints.tmp72
    tmp9 += ints.tmp83 * 2
    del ints.tmp83
    tmp9 += ints.tmp93 * 2
    del ints.tmp93
    tmp9 += f.ov * -1
    tmp9 += ints.tmp111 * -1
    del ints.tmp111
    tmp9 += ints.tmp120 * -2
    del ints.tmp120
    tmp9 += ints.tmp130 * -1
    del ints.tmp130
    tmp9 += ints.tmp20 * -2
    del ints.tmp20
    tmp9 += ints.tmp2 * -1
    del ints.tmp2
    tmp9 += ints.tmp41 * -1
    del ints.tmp41
    tmp9 += ints.tmp4 * -2
    del ints.tmp4
    tmp9 += ints.tmp50 * -2
    del ints.tmp50
    tmp9 += ints.tmp67 * -1
    del ints.tmp67
    tmp9 += ints.tmp75 * -4
    del ints.tmp75
    tmp9 += ints.tmp86 * -1
    del ints.tmp86
    tmp9 += ints.tmp97 * -1
    del ints.tmp97
    tmp13 = np.copy(tmp11) * -1
    tmp13 += np.transpose(tmp11, (0, 2, 1)) * 2
    r2new = einsum(ints.tmp107, (0, 1, 2, 3), r2, (4, 2, 0), (3, 4, 1))
    del ints.tmp107
    r2new += einsum(tmp10, (0, 1, 2), ints.tmp12, (1, 3, 2, 4), (3, 4, 0)) * -1
    del tmp10
    r2new += einsum(tmp20, (0, 1, 2), ints.tmp12, (1, 3, 2, 4), (4, 3, 0)) * -1
    del tmp20
    r2new += einsum(ints.tmp12, (0, 1, 2, 3), r1, (2,), (3, 1, 0)) * -1
    del ints.tmp12
    r2new += einsum(ints.tmp163, (0, 1, 2, 3), r2, (2, 3, 4), (1, 0, 4))
    del ints.tmp163
    r2new += einsum(ints.tmp25, (0, 1, 2, 3), tmp21, (4, 1, 0), (3, 2, 4))
    del tmp21
    r2new += einsum(tmp11, (0, 1, 2), ints.tmp25, (2, 1, 3, 4), (4, 3, 0))
    del tmp11
    r2new += einsum(r2, (0, 1, 2), tmp23, (2, 3, 0, 4), (4, 1, 3)) * -2
    del tmp23
    r2new += einsum(tmp24, (0, 1, 2, 3), r2, (4, 2, 0), (4, 3, 1))
    del tmp24
    r2new += einsum(v.xov, (0, 1, 2), tmp27, (3, 0), (2, 3, 1)) * -2
    del tmp27
    r2new += einsum(tmp29, (0, 1), r2, (0, 2, 3), (1, 2, 3)) * -1
    r2new += einsum(tmp29, (0, 1), r2, (2, 0, 3), (2, 1, 3)) * -1
    del tmp29
    r2new += einsum(r2, (0, 1, 2), tmp30, (2, 3), (0, 1, 3)) * -1
    del tmp30
    r2new += einsum(tmp18, (0,), ints.tmp25, (0, 1, 2, 3), (3, 2, 1))
    del ints.tmp25
    r2new += einsum(tmp19, (0, 1), r1, (2,), (1, 2, 0)) * -1
    r1new = einsum(tmp1, (0, 1, 2, 3), tmp0, (0, 3, 2), (1,)) * -2
    del tmp0, tmp1
    r1new += einsum(tmp3, (0, 1, 2, 3), tmp2, (0, 2, 1), (3,)) * -1
    del tmp3
    r1new += einsum(tmp5, (0, 1, 2), tmp6, (0, 1, 2, 3), (3,)) * 2
    del tmp5, tmp6
    r1new += einsum(tmp7, (0, 1, 2), tmp8, (0, 1, 2, 3), (3,))
    del tmp7, tmp8
    r1new += einsum(tmp2, (0, 1, 2), tmp9, (0, 2), (1,))
    del tmp2, tmp9
    r1new += einsum(tmp12, (0, 1, 2), ints.tmp82, (0, 2, 1, 3), (3,)) * -2
    del ints.tmp82, tmp12
    r1new += einsum(tmp13, (0, 1, 2), ints.tmp40, (0, 2, 1, 3), (3,)) * -1
    del ints.tmp40, tmp13
    r1new += einsum(tmp14, (0, 1), r1, (0,), (1,))
    del tmp14
    r1new += einsum(tmp18, (0,), tmp19, (0, 1), (1,)) * -1
    del tmp19, tmp18

    return {f"r1new": r1new, f"r2new": r2new}

