"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T17:07:22.125856
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:07:22.686275.

    Parameters
    ----------
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp0 += t2 * 2
    tmp1 = einsum(tmp0, (0, 1, 2, 3), v.xov, (4, 0, 2), (1, 3, 4)) * 0.5
    del tmp0
    e_cc = einsum(tmp1, (0, 1, 2), v.xov, (2, 0, 1), ()) * 2
    del tmp1

    return e_cc

def update_amps(f=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:07:27.111378.

    Parameters
    ----------
    f : array
        Fock matrix.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    t2new : array
        Updated T2 residuals.
    """

    tmp6 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp6 += t2 * 2
    tmp7 = einsum(tmp6, (0, 1, 2, 3), v.xov, (4, 0, 2), (1, 3, 4))
    del tmp6
    tmp18 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp18 += t2 * 2
    tmp10 = einsum(v.xov, (0, 1, 2), tmp7, (3, 2, 0), (1, 3))
    tmp8 = einsum(v.xov, (0, 1, 2), tmp7, (1, 3, 0), (2, 3)) * 0.5
    del tmp7
    tmp1 = einsum(t2, (0, 1, 2, 3), v.xov, (4, 1, 2), (0, 3, 4))
    tmp2 = einsum(t2, (0, 1, 2, 3), v.xov, (4, 1, 3), (0, 2, 4))
    tmp14 = einsum(v.xvv, (0, 1, 2), v.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp19 = einsum(v.xov, (0, 1, 2), tmp18, (1, 3, 2, 4), (3, 4, 0))
    del tmp18
    tmp11 = einsum(t2, (0, 1, 2, 3), tmp10, (1, 4), (0, 4, 3, 2)) * 0.5
    del tmp10
    tmp9 = einsum(tmp8, (0, 1), t2, (2, 3, 0, 4), (2, 3, 4, 1))
    del tmp8
    tmp5 = einsum(tmp2, (0, 1, 2), tmp1, (3, 4, 2), (0, 3, 1, 4))
    tmp17 = einsum(t2, (0, 1, 2, 3), tmp14, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp20 = einsum(v.xov, (0, 1, 2), tmp19, (3, 4, 0), (1, 3, 2, 4))
    del tmp19
    tmp15 = einsum(t2, (0, 1, 2, 3), tmp14, (4, 1, 5, 2), (0, 4, 3, 5))
    del tmp14
    tmp13 = einsum(f.vv, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp4 = einsum(f.oo, (0, 1), t2, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp0 = einsum(v.xoo, (0, 1, 2), v.xoo, (0, 3, 4), (3, 1, 2, 4))
    tmp3 = einsum(v.xvv, (0, 1, 2), v.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp12 = np.copy(tmp5) * 2
    del tmp5
    tmp12 += np.transpose(tmp9, (1, 0, 2, 3))
    del tmp9
    tmp12 += np.transpose(tmp11, (0, 1, 3, 2))
    del tmp11
    tmp21 = np.copy(tmp17)
    del tmp17
    tmp21 += np.transpose(tmp20, (1, 0, 3, 2)) * -1
    del tmp20
    tmp16 = np.copy(tmp13)
    del tmp13
    tmp16 += tmp15 * -1
    del tmp15
    t2new = einsum(v.xov, (0, 1, 2), v.xov, (0, 3, 4), (1, 3, 2, 4))
    t2new += einsum(tmp0, (0, 1, 2, 3), t2, (1, 3, 4, 5), (2, 0, 4, 5))
    del tmp0
    t2new += einsum(tmp1, (0, 1, 2), tmp1, (3, 4, 2), (0, 3, 1, 4))
    del tmp1
    t2new += einsum(tmp2, (0, 1, 2), tmp2, (3, 4, 2), (0, 3, 1, 4)) * 4
    del tmp2
    t2new += einsum(tmp3, (0, 1, 2, 3), t2, (4, 5, 1, 3), (4, 5, 2, 0))
    del tmp3
    t2new += np.transpose(tmp4, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp4, (1, 0, 2, 3)) * -1
    del tmp4
    t2new += tmp12 * -1
    t2new += np.transpose(tmp12, (1, 0, 3, 2)) * -1
    del tmp12
    t2new += np.transpose(tmp16, (0, 1, 3, 2))
    t2new += np.transpose(tmp16, (1, 0, 2, 3))
    del tmp16
    t2new += tmp21 * -1
    t2new += np.transpose(tmp21, (1, 0, 3, 2)) * -1
    del tmp21

    return {f"t2new": t2new}

