"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T17:09:16.673466
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:09:17.810863.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp3 = einsum(v.xov, (0, 1, 2), t1, (3, 2), (3, 1, 0))
    tmp0 = einsum(t1, (0, 1), v.xov, (2, 0, 1), (2,))
    tmp1 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp1 += t2 * 2
    tmp4 = np.copy(f.ov) * 2
    tmp4 += einsum(v.xov, (0, 1, 2), tmp3, (1, 3, 0), (3, 2)) * -1
    del tmp3
    tmp2 = einsum(tmp0, (0,), t1, (1, 2), (1, 2, 0))
    del tmp0
    tmp2 += einsum(v.xov, (0, 1, 2), tmp1, (1, 3, 2, 4), (3, 4, 0)) * 0.5
    del tmp1
    e_cc = einsum(tmp2, (0, 1, 2), v.xov, (2, 0, 1), ()) * 2
    del tmp2
    e_cc += einsum(t1, (0, 1), tmp4, (0, 1), ())
    del tmp4

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:09:49.145269.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    t1new : array
        Updated T1 residuals.
    t2new : array
        Updated T2 residuals.
    """

    tmp2 = einsum(v.xov, (0, 1, 2), t1, (3, 2), (3, 1, 0))
    tmp0 = einsum(t1, (0, 1), v.xov, (2, 0, 1), (2,))
    tmp29 = einsum(v.xov, (0, 1, 2), tmp2, (3, 4, 0), (3, 1, 4, 2))
    tmp31 = einsum(v.xoo, (0, 1, 2), v.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp1 = einsum(tmp0, (0,), v.xov, (0, 1, 2), (1, 2))
    tmp9 = einsum(v.xov, (0, 1, 2), tmp2, (1, 3, 0), (3, 2))
    tmp36 = np.copy(t2)
    tmp36 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp18 = einsum(v.xov, (0, 1, 2), t2, (3, 1, 2, 4), (3, 4, 0))
    tmp59 = np.copy(tmp29) * -1
    tmp59 += np.transpose(tmp29, (0, 2, 1, 3)) * 2
    tmp49 = einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp49 += np.transpose(t2, (0, 1, 3, 2)) * -2
    tmp49 += t2
    tmp17 = einsum(t1, (0, 1), v.xvv, (2, 3, 1), (0, 3, 2))
    tmp11 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp11 += t2 * 2
    tmp32 = np.copy(np.transpose(tmp31, (1, 0, 2, 3))) * -1
    tmp32 += np.transpose(tmp31, (2, 1, 0, 3)) * 2
    tmp34 = np.copy(tmp1) * 2
    tmp34 += tmp9 * -1
    tmp37 = einsum(v.xov, (0, 1, 2), tmp36, (1, 3, 4, 2), (3, 4, 0))
    del tmp36
    tmp5 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * -1
    tmp5 += t2 * 2
    tmp57 = einsum(t2, (0, 1, 2, 3), tmp31, (4, 1, 5, 2), (0, 4, 5, 3))
    del tmp31
    tmp58 = einsum(tmp2, (0, 1, 2), tmp18, (3, 4, 2), (0, 3, 1, 4))
    tmp60 = einsum(tmp59, (0, 1, 2, 3), t2, (4, 2, 5, 3), (0, 1, 4, 5))
    del tmp59
    tmp50 = einsum(v.xov, (0, 1, 2), tmp49, (1, 3, 4, 2), (3, 4, 0))
    del tmp49
    tmp6 = einsum(v.xoo, (0, 1, 2), t1, (2, 3), (1, 3, 0))
    tmp12 = einsum(v.xoo, (0, 1, 2), tmp0, (0,), (1, 2))
    tmp63 = einsum(tmp2, (0, 1, 2), v.xoo, (2, 3, 0), (3, 1))
    tmp54 = einsum(tmp17, (0, 1, 2), v.xov, (2, 0, 3), (3, 1))
    tmp53 = einsum(tmp0, (0,), v.xvv, (0, 1, 2), (1, 2))
    tmp26 = einsum(v.xov, (0, 1, 2), tmp11, (1, 3, 2, 4), (3, 4, 0))
    tmp33 = einsum(t2, (0, 1, 2, 3), tmp32, (1, 4, 5, 3), (4, 5, 0, 2))
    del tmp32
    tmp35 = einsum(t2, (0, 1, 2, 3), tmp34, (4, 2), (4, 0, 1, 3))
    tmp30 = einsum(t2, (0, 1, 2, 3), tmp29, (4, 5, 1, 2), (4, 0, 5, 3))
    del tmp29
    tmp38 = einsum(v.xoo, (0, 1, 2), tmp37, (3, 4, 0), (1, 2, 3, 4))
    del tmp37
    tmp67 = einsum(v.xov, (0, 1, 2), v.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp13 = einsum(v.xov, (0, 1, 2), tmp5, (1, 3, 2, 4), (3, 4, 0))
    tmp22 = einsum(v.xoo, (0, 1, 2), v.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp61 = np.copy(tmp57)
    del tmp57
    tmp61 += tmp58
    del tmp58
    tmp61 += np.transpose(tmp60, (0, 2, 1, 3)) * -1
    del tmp60
    tmp51 = np.copy(tmp6)
    tmp51 += tmp50
    del tmp50
    tmp64 = np.copy(np.transpose(tmp63, (1, 0))) * -1
    del tmp63
    tmp64 += np.transpose(tmp12, (1, 0)) * 2
    tmp55 = np.copy(np.transpose(tmp53, (1, 0))) * 2
    del tmp53
    tmp55 += tmp54 * -1
    del tmp54
    tmp20 = einsum(v.xov, (0, 1, 2), v.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp45 = einsum(tmp17, (0, 1, 2), tmp2, (3, 4, 2), (3, 0, 4, 1))
    tmp24 = einsum(tmp2, (0, 1, 2), v.xvv, (2, 3, 4), (0, 1, 3, 4))
    tmp27 = np.copy(np.transpose(v.xov, (1, 2, 0)))
    tmp27 += tmp6 * -1
    tmp27 += tmp26
    del tmp26
    tmp41 = einsum(tmp34, (0, 1), t1, (2, 1), (0, 2))
    del tmp34
    tmp39 = np.copy(np.transpose(tmp30, (0, 2, 1, 3)))
    del tmp30
    tmp39 += np.transpose(tmp33, (2, 1, 0, 3)) * -1
    del tmp33
    tmp39 += np.transpose(tmp35, (2, 0, 1, 3)) * -1
    del tmp35
    tmp39 += np.transpose(tmp38, (2, 1, 0, 3))
    del tmp38
    tmp68 = einsum(t2, (0, 1, 2, 3), tmp67, (4, 5, 3, 2), (0, 1, 4, 5))
    del tmp67
    tmp71 = einsum(v.xov, (0, 1, 2), tmp13, (1, 3, 0), (3, 2)) * 0.5
    tmp73 = einsum(v.xov, (0, 1, 2), tmp13, (3, 2, 0), (3, 1))
    tmp19 = einsum(v.xov, (0, 1, 2), t2, (3, 1, 4, 2), (3, 4, 0))
    tmp80 = einsum(v.xoo, (0, 1, 2), tmp2, (3, 4, 0), (3, 1, 2, 4))
    tmp76 = einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    tmp78 = einsum(t2, (0, 1, 2, 3), f.ov, (4, 3), (4, 0, 1, 2))
    tmp48 = einsum(tmp22, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp62 = einsum(t1, (0, 1), tmp61, (2, 3, 0, 4), (2, 3, 4, 1))
    del tmp61
    tmp52 = einsum(v.xov, (0, 1, 2), tmp51, (3, 4, 0), (3, 1, 4, 2))
    del tmp51
    tmp65 = einsum(t2, (0, 1, 2, 3), tmp64, (1, 4), (4, 0, 3, 2))
    del tmp64
    tmp56 = einsum(t2, (0, 1, 2, 3), tmp55, (2, 4), (0, 1, 4, 3))
    del tmp55
    tmp86 = einsum(tmp20, (0, 1, 2, 3), t1, (1, 4), (0, 4, 2, 3))
    tmp46 = einsum(t1, (0, 1), tmp45, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp45
    tmp44 = einsum(t2, (0, 1, 2, 3), tmp24, (4, 1, 5, 2), (4, 0, 3, 5))
    tmp28 = einsum(tmp27, (0, 1, 2), tmp17, (3, 4, 2), (3, 0, 4, 1))
    del tmp27
    tmp23 = einsum(t2, (0, 1, 2, 3), tmp22, (4, 1, 5, 2), (0, 4, 3, 5))
    del tmp22
    tmp21 = einsum(t2, (0, 1, 2, 3), f.vv, (4, 3), (0, 1, 4, 2))
    tmp42 = einsum(tmp41, (0, 1), t2, (2, 0, 3, 4), (1, 2, 4, 3))
    del tmp41
    tmp40 = einsum(tmp39, (0, 1, 2, 3), t1, (1, 4), (0, 2, 3, 4))
    del tmp39
    tmp25 = einsum(tmp24, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 5, 2))
    del tmp24
    tmp69 = einsum(tmp68, (0, 1, 2, 3), t1, (2, 4), (0, 1, 4, 3))
    del tmp68
    tmp72 = einsum(tmp71, (0, 1), t2, (2, 3, 1, 4), (2, 3, 0, 4))
    del tmp71
    tmp74 = einsum(t2, (0, 1, 2, 3), tmp73, (4, 1), (4, 0, 3, 2)) * 0.5
    del tmp73
    tmp70 = einsum(tmp18, (0, 1, 2), tmp19, (3, 4, 2), (3, 0, 4, 1))
    tmp81 = einsum(t2, (0, 1, 2, 3), tmp80, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp80
    tmp77 = einsum(t2, (0, 1, 2, 3), tmp76, (1, 4), (4, 0, 2, 3))
    del tmp76
    tmp79 = einsum(tmp78, (0, 1, 2, 3), t1, (0, 4), (1, 2, 4, 3))
    del tmp78
    tmp7 = einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3)) * 0.5
    tmp7 += np.transpose(t2, (0, 1, 3, 2)) * -1
    tmp7 += t2 * 0.5
    tmp14 = np.copy(tmp6) * -1
    tmp14 += einsum(tmp0, (0,), t1, (1, 2), (1, 2, 0)) * 2
    tmp14 += tmp13
    del tmp13
    tmp15 = np.copy(f.ov)
    tmp15 += tmp9 * -1
    tmp3 = np.copy(np.transpose(v.xoo, (1, 2, 0)))
    tmp3 += np.transpose(tmp2, (1, 0, 2))
    tmp84 = einsum(v.xoo, (0, 1, 2), v.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp84 += einsum(tmp2, (0, 1, 2), tmp2, (3, 4, 2), (1, 3, 4, 0))
    del tmp2
    tmp66 = np.copy(tmp48)
    del tmp48
    tmp66 += tmp52
    del tmp52
    tmp66 += np.transpose(tmp56, (1, 0, 3, 2)) * -1
    del tmp56
    tmp66 += np.transpose(tmp62, (0, 1, 3, 2)) * -1
    del tmp62
    tmp66 += np.transpose(tmp65, (1, 0, 3, 2))
    del tmp65
    tmp87 = einsum(v.xvv, (0, 1, 2), v.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp87 += einsum(t1, (0, 1), tmp86, (0, 2, 3, 4), (4, 3, 1, 2))
    del tmp86
    tmp85 = np.copy(t2)
    tmp85 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    tmp47 = np.copy(tmp44)
    del tmp44
    tmp47 += tmp46
    del tmp46
    tmp83 = einsum(t2, (0, 1, 2, 3), f.oo, (4, 1), (4, 0, 2, 3))
    tmp43 = np.copy(tmp21)
    del tmp21
    tmp43 += tmp23 * -1
    del tmp23
    tmp43 += tmp25 * -1
    del tmp25
    tmp43 += np.transpose(tmp28, (0, 1, 3, 2))
    del tmp28
    tmp43 += np.transpose(tmp40, (0, 1, 3, 2))
    del tmp40
    tmp43 += np.transpose(tmp42, (0, 1, 3, 2)) * -1
    del tmp42
    tmp75 = np.copy(tmp69)
    del tmp69
    tmp75 += tmp70 * 2
    del tmp70
    tmp75 += np.transpose(tmp72, (1, 0, 3, 2))
    del tmp72
    tmp75 += np.transpose(tmp74, (1, 0, 3, 2))
    del tmp74
    tmp82 = np.copy(tmp77)
    del tmp77
    tmp82 += tmp79
    del tmp79
    tmp82 += tmp81 * -1
    del tmp81
    tmp8 = np.copy(tmp6) * 0.5
    del tmp6
    tmp8 += einsum(tmp0, (0,), t1, (1, 2), (1, 2, 0)) * -1
    del tmp0
    tmp8 += einsum(v.xov, (0, 1, 2), tmp7, (1, 3, 4, 2), (3, 4, 0))
    del tmp7
    tmp16 = np.copy(f.oo) * 0.5
    tmp16 += np.transpose(tmp12, (1, 0))
    del tmp12
    tmp16 += einsum(tmp14, (0, 1, 2), v.xov, (2, 3, 1), (3, 0)) * 0.5
    del tmp14
    tmp16 += einsum(tmp15, (0, 1), t1, (2, 1), (0, 2)) * 0.5
    del tmp15
    tmp10 = np.copy(f.ov)
    tmp10 += tmp1 * 2
    tmp10 += tmp9 * -1
    del tmp9
    tmp4 = einsum(v.xov, (0, 1, 2), tmp3, (3, 4, 0), (4, 1, 3, 2))
    del tmp3
    t2new = einsum(tmp17, (0, 1, 2), tmp17, (3, 4, 2), (3, 0, 4, 1))
    del tmp17
    t2new += einsum(tmp18, (0, 1, 2), tmp18, (3, 4, 2), (3, 0, 4, 1))
    del tmp18
    t2new += einsum(tmp19, (0, 1, 2), tmp19, (3, 4, 2), (3, 0, 4, 1)) * 4
    del tmp19
    t2new += np.transpose(tmp20, (1, 0, 3, 2))
    del tmp20
    t2new += np.transpose(tmp43, (0, 1, 3, 2))
    t2new += np.transpose(tmp43, (1, 0, 2, 3))
    del tmp43
    t2new += tmp47 * -1
    t2new += np.transpose(tmp47, (1, 0, 3, 2)) * -1
    del tmp47
    t2new += tmp66 * -1
    t2new += np.transpose(tmp66, (1, 0, 3, 2)) * -1
    del tmp66
    t2new += tmp75 * -1
    t2new += np.transpose(tmp75, (1, 0, 3, 2)) * -1
    del tmp75
    t2new += np.transpose(tmp82, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp82, (1, 0, 2, 3)) * -1
    del tmp82
    t2new += np.transpose(tmp83, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp83, (1, 0, 2, 3)) * -1
    del tmp83
    t2new += einsum(tmp85, (0, 1, 2, 3), tmp84, (0, 4, 1, 5), (4, 5, 3, 2))
    del tmp85, tmp84
    t2new += einsum(tmp87, (0, 1, 2, 3), t2, (4, 5, 0, 1), (4, 5, 3, 2))
    del tmp87
    t1new = np.copy(tmp1) * 2
    del tmp1
    t1new += einsum(t1, (0, 1), f.vv, (2, 1), (0, 2))
    t1new += f.ov
    t1new += einsum(tmp5, (0, 1, 2, 3), tmp4, (4, 0, 1, 2), (4, 3)) * -1
    del tmp5, tmp4
    t1new += einsum(v.xvv, (0, 1, 2), tmp8, (3, 2, 0), (3, 1)) * -2
    del tmp8
    t1new += einsum(tmp11, (0, 1, 2, 3), tmp10, (0, 2), (1, 3))
    del tmp11, tmp10
    t1new += einsum(tmp16, (0, 1), t1, (0, 2), (1, 2)) * -2
    del tmp16

    return {f"t1new": t1new, f"t2new": t2new}

