"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T16:29:33.609917
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:29:33.870947.

    Parameters
    ----------
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    e_cc = einsum(t2, (0, 1, 2, 3), v.ovov, (0, 2, 1, 3), ()) * 2
    e_cc += einsum(t2, (0, 1, 2, 3), v.ovov, (0, 3, 1, 2), ()) * -1

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:29:39.660584.

    Parameters
    ----------
    f : array
        Fock matrix.
    t1 : array
        T1 amplitudes.
    t2 : array
        T2 amplitudes.
    v : array
        Electron repulsion integrals.

    Returns
    -------
    t1new : array
        Updated T1 residuals.
    t2new : array
        Updated T2 residuals.
    """

    tmp19 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1)))
    tmp19 += np.transpose(v.ovov, (0, 2, 1, 3)) * -0.5
    tmp12 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * -1
    tmp12 += np.transpose(v.ovov, (0, 2, 1, 3)) * 2
    tmp20 = einsum(t2, (0, 1, 2, 3), tmp19, (0, 1, 4, 2), (3, 4))
    tmp22 = einsum(t2, (0, 1, 2, 3), tmp19, (1, 4, 2, 3), (0, 4)) * 2
    del tmp19
    tmp13 = einsum(tmp12, (0, 1, 2, 3), t2, (4, 0, 5, 2), (4, 1, 5, 3))
    del tmp12
    tmp17 = einsum(v.ovvv, (0, 1, 2, 3), t1, (4, 3), (4, 0, 1, 2))
    tmp16 = einsum(f.vv, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp21 = einsum(tmp20, (0, 1), t2, (2, 3, 1, 4), (2, 3, 4, 0)) * 2
    del tmp20
    tmp23 = einsum(t2, (0, 1, 2, 3), tmp22, (4, 1), (0, 4, 3, 2))
    del tmp22
    tmp9 = einsum(t2, (0, 1, 2, 3), v.ovov, (4, 5, 1, 2), (0, 4, 3, 5))
    tmp14 = einsum(t2, (0, 1, 2, 3), tmp13, (4, 1, 5, 2), (0, 4, 3, 5))
    tmp11 = einsum(t1, (0, 1), v.ooov, (2, 0, 3, 4), (2, 3, 1, 4))
    tmp3 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * 2
    tmp3 += np.transpose(v.ovov, (0, 2, 1, 3)) * -1
    tmp1 = einsum(t1, (0, 1), v.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp7 = np.copy(np.transpose(v.ovov, (0, 2, 3, 1))) * 2
    tmp7 += np.transpose(v.ovov, (0, 2, 1, 3)) * -1
    tmp18 = np.copy(tmp16)
    del tmp16
    tmp18 += tmp17
    del tmp17
    tmp24 = np.copy(np.transpose(tmp21, (1, 0, 2, 3)))
    del tmp21
    tmp24 += np.transpose(tmp23, (0, 1, 3, 2))
    del tmp23
    tmp27 = np.copy(np.transpose(v.ovov, (0, 2, 1, 3))) * -1
    tmp27 += tmp9
    tmp10 = einsum(t2, (0, 1, 2, 3), f.oo, (4, 1), (4, 0, 2, 3))
    tmp25 = np.copy(np.transpose(v.ovov, (0, 2, 1, 3))) * 2
    tmp25 += v.oovv * -1
    tmp25 += tmp13 * 2
    del tmp13
    tmp15 = np.copy(tmp11)
    del tmp11
    tmp15 += np.transpose(tmp14, (1, 0, 3, 2))
    del tmp14
    tmp28 = np.copy(v.oovv) * -1
    tmp28 += einsum(v.ovov, (0, 1, 2, 3), t2, (4, 2, 1, 5), (4, 0, 5, 3))
    tmp26 = np.copy(v.oooo)
    tmp26 += einsum(v.ovov, (0, 1, 2, 3), t2, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp0 = np.copy(v.ovvv)
    tmp0 += np.transpose(v.ovvv, (0, 2, 1, 3)) * -0.5
    tmp5 = np.copy(np.transpose(t2, (0, 1, 3, 2))) * 2
    tmp5 += t2 * -1
    tmp4 = np.copy(f.ov)
    tmp4 += einsum(t1, (0, 1), tmp3, (0, 2, 3, 1), (2, 3))
    del tmp3
    tmp6 = np.copy(np.transpose(v.ovov, (0, 2, 1, 3))) * 2
    tmp6 += v.oovv * -1
    tmp2 = np.copy(v.ooov) * -0.5
    tmp2 += np.transpose(v.ooov, (0, 2, 1, 3))
    tmp2 += tmp1
    tmp2 += np.transpose(tmp1, (0, 2, 1, 3)) * -0.5
    del tmp1
    tmp8 = np.copy(f.oo)
    tmp8 += einsum(t2, (0, 1, 2, 3), tmp7, (1, 4, 2, 3), (4, 0))
    del tmp7
    t2new = np.copy(np.transpose(v.ovov, (0, 2, 1, 3)))
    t2new += einsum(v.oovv, (0, 1, 2, 3), t2, (4, 1, 5, 3), (0, 4, 2, 5)) * -1
    t2new += np.transpose(tmp9, (1, 0, 3, 2)) * -1
    del tmp9
    t2new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 5, 2), (0, 4, 5, 3)) * -1
    t2new += einsum(t2, (0, 1, 2, 3), v.ovov, (4, 5, 1, 3), (4, 0, 5, 2)) * 2
    t2new += einsum(v.vvvv, (0, 1, 2, 3), t2, (4, 5, 1, 3), (4, 5, 0, 2))
    t2new += np.transpose(tmp10, (0, 1, 3, 2)) * -1
    t2new += np.transpose(tmp10, (1, 0, 2, 3)) * -1
    del tmp10
    t2new += tmp15 * -1
    t2new += np.transpose(tmp15, (1, 0, 3, 2)) * -1
    del tmp15
    t2new += np.transpose(tmp18, (0, 1, 3, 2))
    t2new += np.transpose(tmp18, (1, 0, 2, 3))
    del tmp18
    t2new += tmp24 * -1
    t2new += np.transpose(tmp24, (1, 0, 3, 2)) * -1
    del tmp24
    t2new += einsum(tmp25, (0, 1, 2, 3), t2, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp25
    t2new += einsum(tmp26, (0, 1, 2, 3), t2, (0, 3, 4, 5), (2, 1, 5, 4))
    del tmp26
    t2new += einsum(tmp27, (0, 1, 2, 3), t2, (4, 1, 3, 5), (4, 0, 5, 2))
    del tmp27
    t2new += einsum(tmp28, (0, 1, 2, 3), t2, (4, 1, 3, 5), (0, 4, 5, 2))
    del tmp28
    t1new = einsum(t1, (0, 1), f.vv, (2, 1), (0, 2))
    t1new += einsum(tmp0, (0, 1, 2, 3), t2, (4, 0, 2, 1), (4, 3)) * 2
    del tmp0
    t1new += einsum(t2, (0, 1, 2, 3), tmp2, (4, 0, 1, 2), (4, 3)) * -2
    del tmp2
    t1new += einsum(tmp4, (0, 1), tmp5, (0, 2, 3, 1), (2, 3))
    del tmp4, tmp5
    t1new += einsum(tmp6, (0, 1, 2, 3), t1, (0, 2), (1, 3))
    del tmp6
    t1new += einsum(t1, (0, 1), tmp8, (0, 2), (2, 1)) * -1
    del tmp8

    return {f"t1new": t1new, f"t2new": t2new}

