"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T17:07:04.134849
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:07:04.663406.

    Parameters
    ----------
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    e_cc = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 1, 3), ())
    e_cc += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 3), ())
    e_cc += einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 3, 1, 2), ()) * -1

    return e_cc

def update_amps(f=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:07:17.771827.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    t2new : Namespace of arrays
        Updated T2 residuals.
    """

    t1new = Namespace()
    t2new = Namespace()
    tmp22 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp23 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 1, 3), (4, 0))
    tmp35 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 4, 1, 5))
    tmp33 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp9 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (4, 1))
    tmp8 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (0, 3, 1, 4), (2, 4)) * -1
    tmp0 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 1, 3), (4, 0))
    tmp1 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp14 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp17 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp27 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 4), (3, 4))
    tmp28 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 3, 1, 4), (2, 4)) * -1
    tmp36 = einsum(t2.bbbb, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp38 = np.copy(f.bb.oo)
    tmp38 += tmp22 * 0.5
    tmp38 += tmp23
    tmp45 = np.copy(np.transpose(v.aabb.ovov, (0, 2, 1, 3))) * 2
    tmp45 += tmp35
    tmp47 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 1, 3)))
    tmp47 += tmp33
    tmp12 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp10 = np.copy(f.aa.vv) * -1
    tmp10 += tmp8
    tmp10 += tmp9 * 0.5
    tmp5 = np.copy(f.aa.oo)
    tmp5 += tmp0
    tmp5 += tmp1 * 0.5
    tmp15 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 1, 3)))
    tmp15 += tmp14
    tmp18 = np.copy(np.transpose(v.aabb.ovov, (0, 2, 1, 3))) * 2
    tmp18 += tmp17
    tmp2 = np.copy(f.aa.oo) * 2
    tmp2 += tmp0 * 2
    tmp2 += tmp1
    tmp42 = np.copy(f.bb.vv) * -1
    tmp42 += tmp27 * 0.5
    tmp42 += tmp28
    tmp44 = einsum(t2.abab, (0, 1, 2, 3), tmp36, (0, 4, 2, 5), (1, 4, 3, 5))
    tmp39 = einsum(tmp38, (0, 1), t2.bbbb, (2, 1, 3, 4), (0, 2, 3, 4)) * -1
    del tmp38
    tmp46 = einsum(tmp45, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5)) * 0.5
    del tmp45
    tmp49 = einsum(v.bbbb.vvvv, (0, 1, 2, 3), t2.bbbb, (4, 5, 3, 1), (4, 5, 0, 2)) * -1
    tmp41 = einsum(v.bbbb.oovv, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp48 = einsum(t2.bbbb, (0, 1, 2, 3), tmp47, (4, 1, 5, 3), (4, 0, 5, 2)) * 2
    del tmp47
    tmp43 = np.copy(f.bb.vv) * -2
    tmp43 += tmp27
    tmp43 += tmp28 * 2
    tmp40 = einsum(v.bbbb.oooo, (0, 1, 2, 3), t2.bbbb, (3, 1, 4, 5), (0, 2, 4, 5)) * -1
    tmp26 = np.copy(f.aa.vv) * -1
    tmp26 += np.transpose(tmp8, (1, 0))
    del tmp8
    tmp26 += np.transpose(tmp9, (1, 0)) * 0.5
    del tmp9
    tmp32 = einsum(v.aabb.vvvv, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp34 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 1, 3)))
    tmp34 += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 5), (4, 1, 5, 3)) * 0.5
    tmp34 += np.transpose(tmp33, (1, 0, 3, 2))
    del tmp33
    tmp30 = np.copy(np.transpose(v.aabb.ovov, (0, 2, 1, 3))) * 2
    tmp30 += einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovov, (1, 3, 4, 5), (0, 4, 2, 5)) * 2
    tmp30 += tmp17
    tmp25 = np.copy(f.aa.oo)
    tmp25 += np.transpose(tmp0, (1, 0))
    del tmp0
    tmp25 += np.transpose(tmp1, (1, 0)) * 0.5
    del tmp1
    tmp24 = np.copy(f.bb.oo)
    tmp24 += np.transpose(tmp22, (1, 0)) * 0.5
    del tmp22
    tmp24 += np.transpose(tmp23, (1, 0))
    del tmp23
    tmp31 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 1, 3)))
    tmp31 += np.transpose(tmp14, (1, 0, 3, 2))
    del tmp14
    tmp31 += np.transpose(tmp12, (1, 0, 3, 2)) * 0.5
    tmp29 = np.copy(f.bb.vv) * -1
    tmp29 += np.transpose(tmp27, (1, 0)) * 0.5
    del tmp27
    tmp29 += np.transpose(tmp28, (1, 0))
    del tmp28
    tmp37 = np.copy(np.transpose(v.aabb.ovov, (0, 2, 1, 3)))
    tmp37 += tmp35 * 0.5
    del tmp35
    tmp37 += tmp36
    del tmp36
    tmp21 = einsum(v.aaaa.vvvv, (0, 1, 2, 3), t2.aaaa, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp11 = einsum(tmp10, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 4, 0)) * -2
    del tmp10
    tmp6 = einsum(tmp5, (0, 1), t2.aaaa, (2, 1, 3, 4), (2, 0, 3, 4)) * -1
    del tmp5
    tmp13 = einsum(tmp12, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp12
    tmp20 = np.copy(np.transpose(v.aabb.ovov, (0, 2, 1, 3)))
    tmp20 += tmp17 * 0.5
    del tmp17
    tmp16 = einsum(t2.aaaa, (0, 1, 2, 3), tmp15, (4, 1, 5, 3), (0, 4, 2, 5)) * 2
    del tmp15
    tmp19 = einsum(t2.abab, (0, 1, 2, 3), tmp18, (4, 1, 5, 3), (0, 4, 2, 5)) * 0.5
    del tmp18
    tmp4 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.oooo, (4, 0, 5, 1), (4, 5, 2, 3))
    tmp7 = einsum(v.aaaa.oovv, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp3 = einsum(tmp2, (0, 1), t2.aaaa, (2, 1, 3, 4), (2, 0, 3, 4)) * -0.5
    del tmp2
    t2new.bbbb = np.copy(np.transpose(tmp39, (1, 0, 3, 2))) * -2
    t2new.bbbb += np.transpose(tmp40, (1, 0, 3, 2)) * 2
    del tmp40
    t2new.bbbb += np.transpose(tmp39, (0, 1, 3, 2)) * 2
    del tmp39
    t2new.bbbb += np.transpose(tmp41, (1, 0, 3, 2)) * -2
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp42, (4, 3), (0, 1, 4, 2)) * 2
    del tmp42
    t2new.bbbb += np.transpose(tmp41, (1, 0, 2, 3)) * 2
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp43, (4, 3), (0, 1, 2, 4)) * -1
    del tmp43
    t2new.bbbb += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    t2new.bbbb += tmp44 * 2
    t2new.bbbb += np.transpose(tmp44, (1, 0, 3, 2)) * 2
    t2new.bbbb += tmp46
    t2new.bbbb += tmp48
    t2new.bbbb += np.transpose(v.bbbb.ovov, (0, 2, 3, 1)) * -1
    t2new.bbbb += np.transpose(tmp44, (0, 1, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp44, (1, 0, 2, 3)) * -2
    del tmp44
    t2new.bbbb += np.transpose(tmp46, (0, 1, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp48, (0, 1, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp49, (1, 0, 3, 2)) * 2
    del tmp49
    t2new.bbbb += np.transpose(tmp46, (1, 0, 3, 2))
    t2new.bbbb += np.transpose(tmp48, (1, 0, 3, 2))
    t2new.bbbb += tmp41 * -2
    t2new.bbbb += np.transpose(tmp46, (1, 0, 2, 3)) * -1
    del tmp46
    t2new.bbbb += np.transpose(tmp48, (1, 0, 2, 3)) * -1
    del tmp48
    t2new.bbbb += np.transpose(tmp41, (0, 1, 3, 2)) * 2
    del tmp41
    t2new.abab = einsum(t2.abab, (0, 1, 2, 3), tmp24, (1, 4), (0, 4, 2, 3)) * -1
    del tmp24
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), v.aabb.oooo, (4, 0, 5, 1), (4, 5, 2, 3))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp25, (0, 4), (4, 1, 2, 3)) * -1
    del tmp25
    t2new.abab += einsum(v.aaaa.oovv, (0, 1, 2, 3), t2.abab, (1, 4, 3, 5), (0, 4, 2, 5)) * -1
    t2new.abab += einsum(tmp26, (0, 1), t2.abab, (2, 3, 0, 4), (2, 3, 1, 4)) * -1
    del tmp26
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), v.aabb.oovv, (4, 0, 5, 3), (4, 1, 2, 5)) * -1
    t2new.abab += einsum(tmp29, (0, 1), t2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -1
    del tmp29
    t2new.abab += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    t2new.abab += einsum(tmp30, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp30
    t2new.abab += einsum(tmp31, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5))
    del tmp31
    t2new.abab += tmp32
    del tmp32
    t2new.abab += einsum(tmp34, (0, 1, 2, 3), t2.abab, (4, 0, 5, 2), (4, 1, 5, 3))
    del tmp34
    t2new.abab += einsum(tmp37, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (4, 1, 5, 3)) * 2
    del tmp37
    t2new.abab += einsum(v.bbbb.oovv, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 5, 2)) * -1
    t2new.abab += einsum(v.aabb.vvoo, (0, 1, 2, 3), t2.abab, (4, 3, 1, 5), (4, 2, 0, 5)) * -1
    t2new.aaaa = np.copy(np.transpose(tmp3, (0, 1, 3, 2))) * -2
    del tmp3
    t2new.aaaa += np.transpose(tmp4, (1, 0, 3, 2)) * 2
    del tmp4
    t2new.aaaa += np.transpose(tmp6, (1, 0, 3, 2)) * 2
    del tmp6
    t2new.aaaa += np.transpose(tmp7, (1, 0, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp11, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp7, (1, 0, 2, 3)) * 2
    t2new.aaaa += np.transpose(tmp11, (1, 0, 2, 3)) * -1
    del tmp11
    t2new.aaaa += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    t2new.aaaa += tmp13 * 2
    t2new.aaaa += np.transpose(tmp13, (1, 0, 3, 2)) * 2
    t2new.aaaa += np.transpose(tmp16, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp19, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(v.aaaa.ovov, (0, 2, 3, 1)) * -1
    t2new.aaaa += np.transpose(tmp13, (0, 1, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp13, (1, 0, 2, 3)) * -2
    del tmp13
    t2new.aaaa += np.transpose(tmp16, (1, 0, 2, 3)) * -1
    t2new.aaaa += einsum(tmp20, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (0, 4, 5, 2)) * -1
    del tmp20
    t2new.aaaa += np.transpose(tmp21, (1, 0, 3, 2)) * 2
    del tmp21
    t2new.aaaa += tmp16
    t2new.aaaa += tmp19
    t2new.aaaa += tmp7 * -2
    t2new.aaaa += np.transpose(tmp16, (0, 1, 3, 2)) * -1
    del tmp16
    t2new.aaaa += np.transpose(tmp19, (0, 1, 3, 2)) * -1
    del tmp19
    t2new.aaaa += np.transpose(tmp7, (0, 1, 3, 2)) * 2
    del tmp7

    return {f"t2new": t2new}

