"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T17:08:07.327242
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:08:08.616131.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1)))
    tmp0 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3)) * -1
    tmp2 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1))) * -1
    tmp2 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp1 = np.copy(f.bb.ov)
    tmp1 += einsum(t1.aa, (0, 1), v.aabb.ovov, (0, 1, 2, 3), (2, 3))
    tmp1 += einsum(tmp0, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3)) * -0.5
    del tmp0
    tmp3 = np.copy(f.aa.ov) * 2
    tmp3 += einsum(tmp2, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2)) * -1
    del tmp2
    e_cc = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 2, 1, 3), ())
    e_cc += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 3), ())
    e_cc += einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 3, 1), ()) * -1
    e_cc += einsum(tmp1, (0, 1), t1.bb, (0, 1), ())
    del tmp1
    e_cc += einsum(t1.aa, (0, 1), tmp3, (0, 1), ()) * 0.5
    del tmp3

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:09:04.805710.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    t1new : Namespace of arrays
        Updated T1 residuals.
    t2new : Namespace of arrays
        Updated T2 residuals.
    """

    t1new = Namespace()
    t2new = Namespace()
    tmp14 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1)))
    tmp14 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3)) * -1
    tmp7 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1))) * -1
    tmp7 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp22 = einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp15 = einsum(tmp14, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3))
    del tmp14
    tmp13 = einsum(t1.aa, (0, 1), v.aabb.ovov, (0, 1, 2, 3), (2, 3))
    tmp152 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1)))
    tmp152 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3)) * -1
    tmp8 = einsum(tmp7, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    del tmp7
    tmp2 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp0 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp53 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1))) * -1
    tmp53 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp173 = np.copy(v.bbbb.ooov)
    tmp173 += np.transpose(v.bbbb.ovoo, (0, 2, 3, 1)) * -1
    tmp21 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 2, 1))
    tmp164 = np.copy(v.bbbb.ovvv)
    tmp164 += np.transpose(v.bbbb.ovvv, (0, 2, 1, 3)) * -1
    tmp166 = np.copy(tmp22) * -1
    tmp166 += np.transpose(tmp22, (0, 2, 1, 3))
    tmp103 = np.copy(v.bbbb.ovvv)
    tmp103 += np.transpose(v.bbbb.ovvv, (0, 2, 3, 1)) * -1
    tmp16 = np.copy(f.bb.ov)
    tmp16 += tmp13
    tmp16 += tmp15 * -1
    del tmp15
    tmp153 = einsum(tmp152, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3))
    del tmp152
    tmp29 = np.copy(v.bbbb.ooov) * -1
    tmp29 += np.transpose(v.bbbb.ooov, (0, 2, 1, 3))
    tmp18 = np.copy(v.aaaa.ooov)
    tmp18 += np.transpose(v.aaaa.ovoo, (0, 2, 3, 1)) * -1
    tmp42 = np.copy(v.aaaa.ovvv)
    tmp42 += np.transpose(v.aaaa.ovvv, (0, 2, 3, 1)) * -1
    tmp9 = np.copy(f.aa.ov)
    tmp9 += tmp2
    tmp9 += tmp8 * -1
    del tmp8
    tmp69 = np.copy(tmp0)
    tmp69 += np.transpose(tmp0, (0, 2, 1, 3)) * -1
    tmp67 = np.copy(v.aaaa.ovvv) * -1
    tmp67 += np.transpose(v.aaaa.ovvv, (0, 2, 1, 3))
    tmp1 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp54 = einsum(t1.aa, (0, 1), tmp53, (0, 2, 3, 1), (2, 3))
    del tmp53
    tmp126 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp174 = einsum(tmp173, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3))
    del tmp173
    tmp111 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 1, 2))
    tmp112 = einsum(tmp21, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 3, 4))
    tmp165 = einsum(tmp164, (0, 1, 2, 3), t1.bb, (4, 2), (4, 0, 1, 3))
    del tmp164
    tmp167 = einsum(tmp166, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3))
    del tmp166
    tmp115 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t1.bb, (3, 4), (0, 2, 1, 4))
    tmp98 = einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 0, 2), (4, 1, 5, 3))
    tmp104 = einsum(tmp103, (0, 1, 2, 3), t1.bb, (0, 1), (2, 3))
    del tmp103
    tmp105 = einsum(tmp16, (0, 1), t1.bb, (0, 2), (2, 1))
    tmp102 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 4, 1, 3), (2, 4))
    tmp101 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 4), (3, 4))
    tmp100 = einsum(t1.aa, (0, 1), v.aabb.ovvv, (0, 1, 2, 3), (2, 3))
    tmp179 = einsum(tmp22, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 2, 1))
    tmp154 = np.copy(f.bb.ov)
    tmp154 += tmp13
    tmp154 += tmp153 * -1
    del tmp153
    tmp157 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp30 = einsum(t1.bb, (0, 1), tmp29, (2, 3, 0, 1), (2, 3))
    del tmp29
    tmp28 = einsum(t1.aa, (0, 1), v.aabb.ovoo, (0, 1, 2, 3), (2, 3))
    tmp25 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp24 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 3), (1, 4))
    tmp148 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp6 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp5 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp19 = einsum(t1.aa, (0, 1), tmp18, (0, 2, 3, 1), (2, 3))
    tmp17 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp40 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 4, 3), (4, 1))
    tmp39 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp43 = einsum(t1.aa, (0, 1), tmp42, (0, 1, 2, 3), (2, 3))
    del tmp42
    tmp41 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 1, 3), (2, 4))
    tmp44 = einsum(t1.aa, (0, 1), tmp9, (0, 2), (1, 2))
    tmp70 = einsum(t1.aa, (0, 1), tmp69, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp69
    tmp68 = einsum(tmp67, (0, 1, 2, 3), t1.aa, (4, 1), (4, 0, 2, 3))
    tmp81 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp80 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    tmp49 = einsum(t1.aa, (0, 1), v.aaaa.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp63 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.aa, (4, 1), (4, 2, 0, 3))
    tmp64 = einsum(tmp1, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    tmp55 = np.copy(f.aa.ov)
    tmp55 += tmp2
    tmp55 += tmp54 * -1
    del tmp54
    tmp85 = einsum(tmp0, (0, 1, 2, 3), t1.aa, (4, 3), (0, 4, 2, 1))
    tmp58 = einsum(t1.aa, (0, 1), v.aaaa.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp77 = einsum(tmp18, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    del tmp18
    tmp37 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp175 = np.copy(v.bbbb.oovv) * -1
    tmp175 += tmp126
    tmp175 += tmp174 * -1
    del tmp174
    tmp181 = einsum(t1.bb, (0, 1), v.bbbb.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp159 = np.copy(v.bbbb.ovvv)
    tmp159 += np.transpose(v.bbbb.ovvv, (0, 2, 1, 3)) * -1
    tmp160 = np.copy(tmp22) * -1
    tmp160 += np.transpose(tmp22, (0, 2, 1, 3))
    tmp136 = np.copy(tmp111)
    tmp136 += tmp112 * -1
    tmp187 = np.copy(v.bbbb.ovvv)
    tmp187 += einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 4), (0, 3, 1, 4))
    tmp168 = np.copy(np.transpose(tmp165, (0, 1, 3, 2))) * -1
    del tmp165
    tmp168 += tmp167 * -1
    del tmp167
    tmp177 = np.copy(tmp115)
    tmp177 += tmp98 * -0.5
    tmp106 = np.copy(f.bb.vv) * -1
    tmp106 += np.transpose(tmp100, (1, 0)) * -1
    del tmp100
    tmp106 += np.transpose(tmp101, (1, 0)) * 0.5
    del tmp101
    tmp106 += np.transpose(tmp102, (1, 0))
    del tmp102
    tmp106 += np.transpose(tmp104, (1, 0)) * -1
    del tmp104
    tmp106 += np.transpose(tmp105, (1, 0))
    del tmp105
    tmp162 = np.copy(tmp111) * -1
    tmp162 += tmp112
    tmp183 = einsum(t1.bb, (0, 1), tmp179, (2, 3, 0, 4), (3, 2, 4, 1))
    tmp146 = einsum(v.bbbb.oovv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp155 = einsum(tmp154, (0, 1), t1.bb, (2, 1), (2, 0))
    del tmp154
    tmp185 = einsum(tmp157, (0, 1, 2, 3), t1.bb, (4, 2), (4, 0, 1, 3))
    tmp96 = np.copy(f.bb.oo)
    tmp96 += np.transpose(tmp28, (1, 0))
    tmp96 += np.transpose(tmp24, (1, 0)) * 0.5
    tmp96 += np.transpose(tmp25, (1, 0))
    tmp96 += np.transpose(tmp30, (1, 0)) * -1
    tmp99 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp150 = einsum(t1.bb, (0, 1), tmp148, (2, 3, 4, 0), (2, 4, 3, 1))
    tmp123 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovov, (1, 3, 4, 5), (0, 4, 2, 5))
    tmp113 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 2, 0, 1))
    tmp121 = np.copy(v.aaaa.ooov)
    tmp121 += np.transpose(v.aaaa.ooov, (0, 2, 1, 3)) * -1
    tmp38 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp130 = np.copy(np.transpose(v.aabb.vvov, (2, 0, 1, 3)))
    tmp130 += einsum(t1.aa, (0, 1), v.aabb.ovov, (0, 2, 3, 4), (3, 1, 2, 4)) * -1
    tmp127 = np.copy(v.bbbb.ooov)
    tmp127 += np.transpose(v.bbbb.ooov, (0, 2, 1, 3)) * -1
    tmp125 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 5), (1, 4, 3, 5))
    tmp133 = np.copy(v.bbbb.ovvv) * -1
    tmp133 += np.transpose(v.bbbb.ovvv, (0, 2, 1, 3))
    tmp134 = np.copy(tmp22)
    tmp134 += np.transpose(tmp22, (0, 2, 1, 3)) * -1
    tmp35 = np.copy(f.aa.oo)
    tmp35 += np.transpose(tmp17, (1, 0))
    tmp35 += np.transpose(tmp5, (1, 0))
    tmp35 += np.transpose(tmp6, (1, 0)) * 0.5
    tmp35 += np.transpose(tmp19, (1, 0)) * -1
    tmp45 = np.copy(f.aa.vv) * -1
    tmp45 += np.transpose(tmp39, (1, 0)) * -1
    del tmp39
    tmp45 += np.transpose(tmp40, (1, 0))
    del tmp40
    tmp45 += np.transpose(tmp41, (1, 0)) * 0.5
    del tmp41
    tmp45 += np.transpose(tmp43, (1, 0)) * -1
    del tmp43
    tmp45 += np.transpose(tmp44, (1, 0))
    del tmp44
    tmp71 = np.copy(np.transpose(tmp68, (0, 1, 3, 2))) * -1
    del tmp68
    tmp71 += tmp70 * -1
    tmp83 = np.copy(tmp80) * 2
    tmp83 += tmp81 * -1
    tmp33 = einsum(v.aaaa.oooo, (0, 1, 2, 3), t1.aa, (3, 4), (0, 1, 2, 4))
    tmp51 = einsum(t1.aa, (0, 1), tmp49, (2, 3, 4, 0), (2, 4, 3, 1))
    tmp93 = np.copy(v.aaaa.ovvv)
    tmp93 += einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 3, 0, 4), (2, 4, 1, 3))
    tmp73 = np.copy(tmp63)
    tmp73 += tmp64 * -1
    tmp56 = einsum(t1.aa, (0, 1), tmp55, (2, 1), (0, 2))
    del tmp55
    tmp87 = einsum(tmp85, (0, 1, 2, 3), t1.aa, (2, 4), (1, 0, 3, 4))
    tmp89 = einsum(t1.aa, (0, 1), tmp58, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp91 = einsum(v.aaaa.vvvv, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp60 = np.copy(v.aaaa.ovvv) * -1
    tmp60 += np.transpose(v.aaaa.ovvv, (0, 2, 1, 3))
    tmp61 = np.copy(tmp0)
    tmp61 += np.transpose(tmp0, (0, 2, 1, 3)) * -1
    tmp47 = einsum(t1.aa, (0, 1), v.aaaa.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp78 = np.copy(v.aaaa.oovv) * -1
    tmp78 += tmp37
    tmp78 += tmp77 * -1
    del tmp77
    tmp65 = np.copy(tmp63) * -1
    del tmp63
    tmp65 += tmp64
    tmp10 = einsum(t1.aa, (0, 1), tmp9, (2, 1), (0, 2))
    tmp176 = einsum(tmp175, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (4, 0, 5, 2)) * 2
    del tmp175
    tmp182 = einsum(tmp181, (0, 1, 2, 3), t1.bb, (4, 2), (4, 0, 1, 3))
    del tmp181
    tmp161 = einsum(tmp159, (0, 1, 2, 3), t1.bb, (4, 2), (4, 0, 3, 1)) * -1
    del tmp159
    tmp161 += einsum(tmp160, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3)) * -1
    del tmp160
    tmp170 = einsum(t2.abab, (0, 1, 2, 3), tmp136, (0, 4, 2, 5), (1, 4, 3, 5))
    tmp188 = np.copy(v.bbbb.vvvv) * -1
    tmp188 += einsum(t1.bb, (0, 1), tmp187, (0, 2, 3, 4), (2, 1, 4, 3))
    del tmp187
    tmp158 = einsum(tmp22, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3))
    tmp171 = einsum(t1.bb, (0, 1), v.bbbb.ooov, (2, 0, 3, 4), (2, 3, 1, 4))
    tmp169 = einsum(tmp168, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp168
    tmp178 = einsum(t2.abab, (0, 1, 2, 3), tmp177, (0, 4, 2, 5), (1, 4, 3, 5))
    del tmp177
    tmp145 = einsum(t2.bbbb, (0, 1, 2, 3), tmp106, (3, 4), (0, 1, 2, 4)) * -2
    tmp143 = einsum(v.bbbb.oooo, (0, 1, 2, 3), t2.bbbb, (3, 1, 4, 5), (0, 2, 4, 5)) * -1
    tmp180 = einsum(tmp179, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 5), (1, 0, 4, 5)) * -1
    del tmp179
    tmp163 = einsum(t2.abab, (0, 1, 2, 3), tmp162, (0, 4, 2, 5), (1, 4, 3, 5))
    del tmp162
    tmp184 = einsum(t1.bb, (0, 1), tmp183, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp183
    tmp147 = einsum(tmp146, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3))
    del tmp146
    tmp156 = einsum(t2.bbbb, (0, 1, 2, 3), tmp155, (4, 1), (0, 4, 2, 3)) * -1
    del tmp155
    tmp149 = einsum(tmp148, (0, 1, 2, 3), t2.bbbb, (3, 2, 4, 5), (0, 1, 4, 5)) * -1
    del tmp148
    tmp142 = np.copy(t2.bbbb)
    tmp142 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1)) * 2
    tmp144 = einsum(t1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * 2
    tmp144 += t2.bbbb * -1
    tmp186 = einsum(t1.bb, (0, 1), tmp185, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp185
    tmp189 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.bbbb, (4, 5, 3, 1), (4, 5, 0, 2)) * -1
    tmp107 = einsum(tmp16, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp141 = einsum(t2.bbbb, (0, 1, 2, 3), tmp96, (1, 4), (0, 4, 2, 3)) * -1
    tmp172 = einsum(t2.abab, (0, 1, 2, 3), tmp99, (0, 4, 2, 5), (1, 4, 3, 5))
    tmp151 = einsum(tmp150, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 4, 3))
    del tmp150
    tmp124 = np.copy(tmp80) * -1
    tmp124 += tmp123
    tmp124 += tmp81 * 0.5
    tmp129 = np.copy(tmp115) * -1
    tmp129 += tmp98 * 0.5
    tmp129 += tmp99
    tmp118 = einsum(t1.aa, (0, 1), tmp113, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp114 = np.copy(np.transpose(tmp113, (0, 1, 3, 2)))
    del tmp113
    tmp114 += einsum(tmp21, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 3, 4)) * -1
    tmp132 = einsum(tmp67, (0, 1, 2, 3), t1.aa, (4, 2), (4, 0, 1, 3)) * -1
    del tmp67
    tmp132 += np.transpose(tmp70, (0, 1, 3, 2))
    del tmp70
    tmp97 = np.copy(t2.abab)
    tmp97 += einsum(t1.aa, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3)) * 2
    tmp3 = np.copy(t2.abab)
    tmp3 += einsum(t1.aa, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    tmp122 = np.copy(v.aaaa.oovv) * -1
    tmp122 += np.transpose(tmp37, (1, 0, 3, 2))
    tmp122 += np.transpose(tmp38, (1, 0, 3, 2)) * 0.5
    tmp122 += einsum(tmp121, (0, 1, 2, 3), t1.aa, (2, 4), (1, 0, 3, 4))
    del tmp121
    tmp120 = einsum(t1.aa, (0, 1), tmp21, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp109 = einsum(t1.aa, (0, 1), v.aabb.vvoo, (2, 1, 3, 4), (0, 3, 4, 2))
    tmp137 = einsum(t1.aa, (0, 1), v.aabb.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp137 += einsum(tmp1, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 3, 4)) * -1
    tmp139 = einsum(v.aabb.oovv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp131 = np.copy(v.aabb.vvvv)
    tmp131 += einsum(tmp130, (0, 1, 2, 3), t1.bb, (0, 4), (2, 1, 3, 4)) * -1
    del tmp130
    tmp108 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp117 = np.copy(v.aabb.oovv)
    tmp117 += einsum(t1.bb, (0, 1), v.aabb.ooov, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    tmp119 = np.copy(np.transpose(v.aabb.vvov, (2, 0, 1, 3)))
    tmp119 += einsum(t1.bb, (0, 1), v.aabb.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp128 = np.copy(v.bbbb.oovv) * -2
    tmp128 += np.transpose(tmp125, (1, 0, 3, 2))
    tmp128 += np.transpose(tmp126, (1, 0, 3, 2)) * 2
    tmp128 += einsum(tmp127, (0, 1, 2, 3), t1.bb, (2, 4), (1, 0, 3, 4)) * 2
    del tmp127
    tmp140 = einsum(t1.aa, (0, 1), tmp111, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp138 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp116 = np.copy(np.transpose(v.aabb.vvoo, (2, 3, 0, 1)))
    tmp116 += einsum(v.aabb.ovoo, (0, 1, 2, 3), t1.aa, (0, 4), (2, 3, 1, 4)) * -1
    tmp110 = einsum(t1.aa, (0, 1), v.aabb.ovoo, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp135 = einsum(tmp133, (0, 1, 2, 3), t1.bb, (4, 2), (4, 0, 1, 3)) * -1
    del tmp133
    tmp135 += einsum(tmp134, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4))
    del tmp134
    tmp36 = einsum(tmp35, (0, 1), t2.aaaa, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    tmp46 = einsum(t2.aaaa, (0, 1, 2, 3), tmp45, (3, 4), (0, 1, 2, 4)) * -2
    tmp76 = einsum(t2.aaaa, (0, 1, 2, 3), tmp38, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp72 = einsum(t2.aaaa, (0, 1, 2, 3), tmp71, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp71
    tmp84 = einsum(t2.abab, (0, 1, 2, 3), tmp83, (4, 1, 5, 3), (0, 4, 2, 5)) * 0.5
    del tmp83
    tmp34 = einsum(tmp33, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    del tmp33
    tmp82 = np.copy(tmp80)
    tmp82 += tmp81 * -0.5
    tmp75 = einsum(t1.aa, (0, 1), v.aaaa.ooov, (2, 0, 3, 4), (2, 3, 1, 4))
    tmp52 = einsum(tmp51, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    del tmp51
    tmp50 = einsum(t2.aaaa, (0, 1, 2, 3), tmp49, (4, 5, 0, 1), (4, 5, 2, 3))
    del tmp49
    tmp32 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.oooo, (4, 0, 5, 1), (4, 5, 2, 3))
    tmp95 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp94 = np.copy(v.aaaa.vvvv)
    tmp94 += einsum(tmp93, (0, 1, 2, 3), t1.aa, (0, 4), (3, 4, 2, 1))
    del tmp93
    tmp86 = einsum(t2.aaaa, (0, 1, 2, 3), tmp85, (4, 5, 1, 0), (5, 4, 2, 3))
    del tmp85
    tmp74 = einsum(t2.abab, (0, 1, 2, 3), tmp73, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp57 = einsum(t2.aaaa, (0, 1, 2, 3), tmp56, (4, 1), (0, 4, 2, 3)) * -1
    tmp88 = einsum(tmp87, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp87
    tmp90 = einsum(t1.aa, (0, 1), tmp89, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp89
    tmp92 = einsum(t1.aa, (0, 1), tmp91, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp91
    tmp62 = einsum(t1.aa, (0, 1), tmp60, (2, 1, 3, 4), (0, 2, 4, 3)) * -1
    del tmp60
    tmp62 += einsum(tmp61, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3)) * -1
    del tmp61
    tmp59 = einsum(t1.aa, (0, 1), tmp0, (2, 3, 0, 4), (2, 3, 1, 4))
    tmp48 = einsum(t1.aa, (0, 1), tmp47, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp47
    tmp79 = einsum(t2.aaaa, (0, 1, 2, 3), tmp78, (4, 1, 5, 3), (0, 4, 2, 5)) * 2
    del tmp78
    tmp66 = einsum(t2.abab, (0, 1, 2, 3), tmp65, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp65
    tmp23 = np.copy(t2.bbbb) * 2
    tmp23 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1))
    tmp27 = np.copy(f.bb.vv)
    tmp27 += einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (0, 3), (1, 2)) * -1
    tmp26 = np.copy(np.transpose(tmp24, (1, 0))) * 0.5
    del tmp24
    tmp26 += np.transpose(tmp25, (1, 0))
    del tmp25
    tmp26 += einsum(tmp16, (0, 1), t1.bb, (2, 1), (0, 2)) * 0.5
    tmp31 = np.copy(f.bb.oo)
    tmp31 += np.transpose(tmp28, (1, 0))
    del tmp28
    tmp31 += np.transpose(tmp30, (1, 0)) * -1
    del tmp30
    tmp12 = np.copy(f.aa.vv)
    tmp12 += einsum(t1.aa, (0, 1), v.aaaa.ovvv, (0, 2, 3, 1), (2, 3)) * -1
    tmp11 = np.copy(np.transpose(tmp5, (1, 0))) * 2
    del tmp5
    tmp11 += np.transpose(tmp6, (1, 0))
    del tmp6
    tmp11 += np.transpose(tmp10, (1, 0))
    tmp20 = np.copy(f.aa.oo)
    tmp20 += np.transpose(tmp17, (1, 0))
    del tmp17
    tmp20 += np.transpose(tmp19, (1, 0)) * -1
    del tmp19
    tmp4 = np.copy(t2.aaaa) * 2
    tmp4 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3))
    t2new.bbbb = np.copy(np.transpose(tmp141, (0, 1, 3, 2))) * -2
    t2new.bbbb += einsum(v.bbbb.oooo, (0, 1, 2, 3), tmp142, (3, 1, 4, 5), (0, 2, 5, 4)) * 0.5
    del tmp142
    t2new.bbbb += np.transpose(tmp143, (1, 0, 3, 2))
    del tmp143
    t2new.bbbb += np.transpose(tmp141, (1, 0, 3, 2)) * 2
    del tmp141
    t2new.bbbb += einsum(v.bbbb.oooo, (0, 1, 2, 3), tmp144, (3, 1, 4, 5), (0, 2, 5, 4)) * -0.5
    del tmp144
    t2new.bbbb += np.transpose(tmp126, (1, 0, 3, 2)) * 2
    t2new.bbbb += np.transpose(tmp125, (1, 0, 3, 2))
    t2new.bbbb += np.transpose(tmp145, (1, 0, 3, 2))
    t2new.bbbb += np.transpose(tmp126, (1, 0, 2, 3)) * -2
    t2new.bbbb += np.transpose(tmp125, (1, 0, 2, 3)) * -1
    t2new.bbbb += np.transpose(tmp145, (1, 0, 2, 3)) * -1
    del tmp145
    t2new.bbbb += np.transpose(tmp147, (1, 0, 3, 2))
    t2new.bbbb += np.transpose(tmp149, (1, 0, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp151, (1, 0, 2, 3))
    t2new.bbbb += np.transpose(tmp151, (1, 0, 3, 2)) * -1
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp107, (4, 1), (0, 4, 2, 3)) * -1
    t2new.bbbb += np.transpose(tmp147, (1, 0, 2, 3)) * -1
    t2new.bbbb += np.transpose(tmp156, (0, 1, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp147, (0, 1, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp149, (0, 1, 3, 2)) * 2
    del tmp149
    t2new.bbbb += tmp151 * -1
    t2new.bbbb += np.transpose(tmp151, (0, 1, 3, 2))
    del tmp151
    t2new.bbbb += np.transpose(tmp156, (1, 0, 3, 2)) * 2
    del tmp156
    t2new.bbbb += tmp147
    del tmp147
    t2new.bbbb += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    t2new.bbbb += np.transpose(tmp157, (1, 0, 2, 3))
    t2new.bbbb += np.transpose(tmp158, (1, 0, 3, 2)) * -1
    t2new.bbbb += einsum(tmp161, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (4, 0, 2, 5)) * 2
    del tmp161
    t2new.bbbb += np.transpose(tmp163, (0, 1, 3, 2))
    t2new.bbbb += np.transpose(v.bbbb.ovov, (0, 2, 3, 1)) * -1
    t2new.bbbb += tmp157 * -1
    t2new.bbbb += np.transpose(tmp158, (0, 1, 3, 2))
    t2new.bbbb += np.transpose(tmp169, (1, 0, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp170, (1, 0, 3, 2))
    t2new.bbbb += np.transpose(tmp171, (0, 1, 3, 2))
    t2new.bbbb += tmp172 * 2
    t2new.bbbb += np.transpose(tmp172, (1, 0, 3, 2)) * 2
    t2new.bbbb += np.transpose(tmp176, (1, 0, 3, 2))
    t2new.bbbb += np.transpose(tmp178, (1, 0, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp171, (1, 0, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp172, (0, 1, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp172, (1, 0, 2, 3)) * -2
    del tmp172
    t2new.bbbb += np.transpose(tmp176, (0, 1, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp178, (0, 1, 3, 2))
    t2new.bbbb += tmp171 * -1
    t2new.bbbb += np.transpose(tmp176, (1, 0, 2, 3)) * -1
    t2new.bbbb += np.transpose(tmp178, (1, 0, 2, 3))
    t2new.bbbb += np.transpose(tmp171, (1, 0, 2, 3))
    del tmp171
    t2new.bbbb += tmp176
    del tmp176
    t2new.bbbb += tmp178 * -1
    del tmp178
    t2new.bbbb += np.transpose(tmp157, (0, 1, 3, 2))
    t2new.bbbb += np.transpose(tmp180, (0, 1, 3, 2)) * -2
    del tmp180
    t2new.bbbb += tmp182
    t2new.bbbb += np.transpose(tmp182, (0, 1, 3, 2)) * -1
    del tmp182
    t2new.bbbb += tmp184
    t2new.bbbb += np.transpose(tmp184, (0, 1, 3, 2)) * -1
    del tmp184
    t2new.bbbb += np.transpose(tmp186, (0, 1, 3, 2))
    t2new.bbbb += np.transpose(tmp186, (1, 0, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp157, (1, 0, 3, 2)) * -1
    del tmp157
    t2new.bbbb += einsum(tmp188, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 3), (4, 5, 2, 1)) * 2
    del tmp188
    t2new.bbbb += np.transpose(tmp126, (0, 1, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp125, (0, 1, 3, 2)) * -1
    t2new.bbbb += tmp126 * 2
    del tmp126
    t2new.bbbb += tmp125
    del tmp125
    t2new.bbbb += np.transpose(tmp158, (1, 0, 2, 3))
    t2new.bbbb += tmp169 * -2
    t2new.bbbb += tmp163 * -1
    del tmp163
    t2new.bbbb += tmp158 * -1
    del tmp158
    t2new.bbbb += np.transpose(tmp169, (1, 0, 2, 3)) * 2
    del tmp169
    t2new.bbbb += np.transpose(tmp170, (1, 0, 2, 3)) * -1
    del tmp170
    t2new.bbbb += einsum(t1.bb, (0, 1), tmp189, (2, 3, 0, 4), (2, 3, 1, 4)) * -2
    del tmp189
    t2new.bbbb += tmp186 * -1
    t2new.bbbb += np.transpose(tmp186, (1, 0, 2, 3))
    del tmp186
    t2new.abab = einsum(t2.abab, (0, 1, 2, 3), tmp96, (1, 4), (0, 4, 2, 3)) * -1
    del tmp96
    t2new.abab += einsum(tmp97, (0, 1, 2, 3), v.aabb.oooo, (4, 0, 5, 1), (4, 5, 2, 3)) * 0.5
    del tmp97
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), v.aabb.oooo, (4, 0, 5, 1), (4, 5, 2, 3)) * 0.5
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp35, (0, 4), (4, 1, 2, 3)) * -1
    del tmp35
    t2new.abab += tmp98
    del tmp98
    t2new.abab += tmp99 * 2
    del tmp99
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp45, (2, 4), (0, 1, 4, 3)) * -1
    del tmp45
    t2new.abab += einsum(tmp106, (0, 1), t2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -1
    del tmp106
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp107, (4, 1), (0, 4, 2, 3)) * -1
    del tmp107
    t2new.abab += einsum(tmp3, (0, 1, 2, 3), tmp108, (0, 4, 5, 1), (4, 5, 2, 3))
    del tmp108
    t2new.abab += einsum(t1.bb, (0, 1), tmp109, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    del tmp109
    t2new.abab += einsum(tmp56, (0, 1), t2.abab, (1, 2, 3, 4), (0, 2, 3, 4)) * -1
    del tmp56
    t2new.abab += einsum(tmp3, (0, 1, 2, 3), tmp110, (4, 0, 1, 5), (4, 5, 2, 3))
    del tmp110
    t2new.abab += tmp111
    del tmp111
    t2new.abab += tmp112 * -1
    del tmp112
    t2new.abab += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp114, (4, 1, 2, 5), (0, 4, 5, 3)) * -1
    del tmp114
    t2new.abab += tmp115 * -1
    del tmp115
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp116, (1, 4, 2, 5), (0, 4, 5, 3)) * -1
    del tmp116
    t2new.abab += tmp80 * -1
    del tmp80
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp117, (0, 4, 3, 5), (4, 1, 2, 5)) * -1
    del tmp117
    t2new.abab += einsum(t1.bb, (0, 1), tmp118, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    del tmp118
    t2new.abab += einsum(t1.aa, (0, 1), tmp119, (2, 1, 3, 4), (0, 2, 3, 4))
    del tmp119
    t2new.abab += einsum(tmp120, (0, 1, 2, 3), tmp3, (1, 3, 4, 5), (0, 2, 4, 5))
    del tmp120
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp122, (0, 4, 2, 5), (4, 1, 5, 3))
    del tmp122
    t2new.abab += einsum(t2.bbbb, (0, 1, 2, 3), tmp124, (4, 1, 5, 3), (4, 0, 5, 2)) * 2
    del tmp124
    t2new.abab += tmp81
    del tmp81
    t2new.abab += tmp123 * 2
    del tmp123
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp128, (1, 4, 3, 5), (0, 4, 2, 5)) * 0.5
    del tmp128
    t2new.abab += einsum(tmp129, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (4, 1, 5, 3)) * 2
    del tmp129
    t2new.abab += einsum(tmp131, (0, 1, 2, 3), t2.abab, (4, 5, 0, 2), (4, 5, 1, 3))
    del tmp131
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp132, (4, 0, 2, 5), (4, 1, 5, 3))
    del tmp132
    t2new.abab += einsum(t2.bbbb, (0, 1, 2, 3), tmp73, (4, 1, 5, 3), (4, 0, 5, 2)) * 2
    del tmp73
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp135, (4, 1, 3, 5), (0, 4, 2, 5))
    del tmp135
    t2new.abab += einsum(tmp136, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (4, 1, 5, 3)) * 2
    del tmp136
    t2new.abab += tmp64 * -1
    del tmp64
    t2new.abab += einsum(tmp137, (0, 1, 2, 3), t2.abab, (1, 4, 5, 2), (0, 4, 5, 3)) * -1
    del tmp137
    t2new.abab += einsum(tmp138, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3)) * -1
    del tmp138
    t2new.abab += einsum(t1.aa, (0, 1), tmp139, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp139
    t2new.abab += einsum(t1.aa, (0, 1), tmp140, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp140
    t2new.aaaa = np.copy(np.transpose(tmp32, (1, 0, 3, 2))) * 2
    del tmp32
    t2new.aaaa += tmp34
    t2new.aaaa += np.transpose(tmp36, (0, 1, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp34, (0, 1, 3, 2)) * -1
    del tmp34
    t2new.aaaa += np.transpose(tmp36, (1, 0, 3, 2)) * 2
    del tmp36
    t2new.aaaa += np.transpose(tmp37, (1, 0, 3, 2)) * 2
    t2new.aaaa += np.transpose(tmp38, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp46, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp37, (1, 0, 2, 3)) * -2
    t2new.aaaa += np.transpose(tmp38, (1, 0, 2, 3)) * -1
    t2new.aaaa += np.transpose(tmp46, (1, 0, 2, 3)) * -1
    del tmp46
    t2new.aaaa += np.transpose(tmp48, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp50, (1, 0, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp52, (1, 0, 2, 3))
    t2new.aaaa += np.transpose(tmp52, (1, 0, 3, 2)) * -1
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp10, (4, 1), (0, 4, 2, 3)) * -1
    del tmp10
    t2new.aaaa += np.transpose(tmp48, (1, 0, 2, 3)) * -1
    t2new.aaaa += np.transpose(tmp57, (0, 1, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp48, (0, 1, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp50, (0, 1, 3, 2)) * 2
    del tmp50
    t2new.aaaa += tmp52 * -1
    t2new.aaaa += np.transpose(tmp52, (0, 1, 3, 2))
    del tmp52
    t2new.aaaa += np.transpose(tmp57, (1, 0, 3, 2)) * 2
    del tmp57
    t2new.aaaa += tmp48
    del tmp48
    t2new.aaaa += np.transpose(tmp58, (1, 0, 2, 3))
    t2new.aaaa += np.transpose(tmp59, (1, 0, 3, 2)) * -1
    t2new.aaaa += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    t2new.aaaa += einsum(tmp62, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 2, 5)) * 2
    del tmp62
    t2new.aaaa += np.transpose(tmp66, (0, 1, 3, 2))
    t2new.aaaa += tmp58 * -1
    t2new.aaaa += np.transpose(tmp59, (0, 1, 3, 2))
    t2new.aaaa += np.transpose(v.aaaa.ovov, (0, 2, 3, 1)) * -1
    t2new.aaaa += np.transpose(tmp72, (1, 0, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp74, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp75, (0, 1, 3, 2))
    t2new.aaaa += tmp76 * 2
    t2new.aaaa += np.transpose(tmp76, (1, 0, 3, 2)) * 2
    t2new.aaaa += np.transpose(tmp79, (1, 0, 3, 2))
    t2new.aaaa += einsum(tmp82, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (0, 4, 2, 5)) * -1
    del tmp82
    t2new.aaaa += np.transpose(tmp75, (1, 0, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp76, (0, 1, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp76, (1, 0, 2, 3)) * -2
    del tmp76
    t2new.aaaa += np.transpose(tmp79, (0, 1, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp84, (0, 1, 3, 2))
    t2new.aaaa += tmp75 * -1
    t2new.aaaa += np.transpose(tmp79, (1, 0, 2, 3)) * -1
    t2new.aaaa += np.transpose(tmp84, (1, 0, 2, 3))
    t2new.aaaa += np.transpose(tmp75, (1, 0, 2, 3))
    del tmp75
    t2new.aaaa += tmp79
    del tmp79
    t2new.aaaa += tmp84 * -1
    del tmp84
    t2new.aaaa += np.transpose(tmp86, (0, 1, 3, 2)) * -2
    del tmp86
    t2new.aaaa += np.transpose(tmp58, (0, 1, 3, 2))
    t2new.aaaa += tmp88
    t2new.aaaa += np.transpose(tmp88, (0, 1, 3, 2)) * -1
    del tmp88
    t2new.aaaa += np.transpose(tmp90, (0, 1, 3, 2))
    t2new.aaaa += np.transpose(tmp90, (1, 0, 3, 2)) * -1
    t2new.aaaa += tmp92
    t2new.aaaa += np.transpose(tmp92, (0, 1, 3, 2)) * -1
    del tmp92
    t2new.aaaa += np.transpose(tmp58, (1, 0, 3, 2)) * -1
    del tmp58
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp94, (2, 4, 5, 3), (0, 1, 5, 4)) * -2
    del tmp94
    t2new.aaaa += np.transpose(tmp38, (0, 1, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp37, (0, 1, 3, 2)) * -2
    t2new.aaaa += tmp38
    del tmp38
    t2new.aaaa += tmp37 * 2
    del tmp37
    t2new.aaaa += np.transpose(tmp59, (1, 0, 2, 3))
    t2new.aaaa += tmp72 * -2
    t2new.aaaa += tmp66 * -1
    del tmp66
    t2new.aaaa += tmp59 * -1
    del tmp59
    t2new.aaaa += np.transpose(tmp72, (1, 0, 2, 3)) * 2
    del tmp72
    t2new.aaaa += np.transpose(tmp74, (1, 0, 2, 3)) * -1
    del tmp74
    t2new.aaaa += einsum(tmp95, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3)) * -2
    del tmp95
    t2new.aaaa += tmp90 * -1
    t2new.aaaa += np.transpose(tmp90, (1, 0, 2, 3))
    del tmp90
    t1new.bb = einsum(tmp21, (0, 1, 2, 3), t2.abab, (0, 2, 3, 4), (1, 4)) * -1
    del tmp21
    t1new.bb += einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    t1new.bb += f.bb.ov
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), tmp22, (4, 1, 0, 3), (4, 2)) * -2
    del tmp22
    t1new.bb += tmp13
    del tmp13
    t1new.bb += einsum(v.aabb.ovvv, (0, 1, 2, 3), tmp3, (0, 4, 1, 3), (4, 2))
    t1new.bb += einsum(v.bbbb.ovvv, (0, 1, 2, 3), tmp23, (0, 4, 1, 3), (4, 2))
    del tmp23
    t1new.bb += einsum(t1.bb, (0, 1), tmp26, (0, 2), (2, 1)) * -2
    del tmp26
    t1new.bb += einsum(t1.bb, (0, 1), tmp27, (1, 2), (0, 2))
    del tmp27
    t1new.bb += einsum(v.bbbb.oovv, (0, 1, 2, 3), t1.bb, (1, 3), (0, 2)) * -1
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 0, 1, 3), (4, 2)) * -2
    t1new.bb += einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 3, 1, 4), (2, 4)) * -1
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), tmp9, (0, 2), (1, 3))
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), tmp16, (1, 3), (0, 2)) * 2
    t1new.bb += einsum(t1.bb, (0, 1), tmp31, (0, 2), (2, 1)) * -1
    del tmp31
    t1new.aa = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    t1new.aa += einsum(t2.aaaa, (0, 1, 2, 3), tmp0, (4, 1, 0, 3), (4, 2)) * -2
    del tmp0
    t1new.aa += f.aa.ov
    t1new.aa += einsum(tmp1, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4)) * -1
    del tmp1
    t1new.aa += tmp2
    del tmp2
    t1new.aa += einsum(v.aabb.vvov, (0, 1, 2, 3), tmp3, (4, 2, 1, 3), (4, 0))
    del tmp3
    t1new.aa += einsum(v.aaaa.ovvv, (0, 1, 2, 3), tmp4, (0, 4, 1, 3), (4, 2))
    del tmp4
    t1new.aa += einsum(t1.aa, (0, 1), tmp11, (0, 2), (2, 1)) * -1
    del tmp11
    t1new.aa += einsum(tmp12, (0, 1), t1.aa, (2, 0), (2, 1))
    del tmp12
    t1new.aa += einsum(v.aaaa.oovv, (0, 1, 2, 3), t1.aa, (1, 3), (0, 2)) * -1
    t1new.aa += einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4)) * -1
    t1new.aa += einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 0, 1, 3), (4, 2)) * -2
    t1new.aa += einsum(t2.aaaa, (0, 1, 2, 3), tmp9, (1, 3), (0, 2)) * 2
    del tmp9
    t1new.aa += einsum(tmp16, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    del tmp16
    t1new.aa += einsum(tmp20, (0, 1), t1.aa, (0, 2), (1, 2)) * -1
    del tmp20

    return {f"t1new": t1new, f"t2new": t2new}

