"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T17:07:28.615411
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:07:29.335246.

    Parameters
    ----------
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp1 = einsum(t2.aaaa, (0, 1, 2, 3), v.baa.xov, (4, 1, 3), (4, 0, 2))
    tmp1 += einsum(v.bbb.xov, (0, 1, 2), t2.abab, (3, 1, 4, 2), (0, 3, 4))
    tmp0 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (0, 3, 4))
    e_cc = einsum(v.bbb.xov, (0, 1, 2), tmp0, (0, 1, 2), ())
    del tmp0
    e_cc += einsum(tmp1, (0, 1, 2), v.baa.xov, (0, 1, 2), ())
    del tmp1

    return e_cc

def update_amps(f=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:07:47.224275.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    t2new : Namespace of arrays
        Updated T2 residuals.
    """

    t1new = Namespace()
    t2new = Namespace()
    tmp22 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (4, 1, 3))
    tmp23 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (0, 3, 4))
    tmp1 = einsum(v.bbb.xov, (0, 1, 2), t2.abab, (3, 1, 4, 2), (0, 3, 4))
    tmp0 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp38 = np.copy(tmp22) * 0.5
    tmp38 += tmp23
    tmp2 = np.copy(tmp0) * 2
    tmp2 += tmp1
    tmp39 = einsum(v.bbb.xov, (0, 1, 2), tmp38, (0, 3, 2), (3, 1))
    tmp3 = einsum(tmp2, (0, 1, 2), v.baa.xov, (0, 3, 2), (3, 1)) * 0.5
    tmp56 = np.copy(v.bbb.xov) * 2
    tmp56 += tmp22
    tmp40 = np.copy(f.bb.oo)
    tmp40 += tmp39
    del tmp39
    tmp52 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp50 = np.copy(v.bbb.xov)
    tmp50 += tmp22
    tmp50 += tmp23 * 2
    tmp36 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp42 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 1, 2, 4))
    tmp54 = np.copy(v.bbb.xov)
    tmp54 += tmp23
    tmp27 = np.copy(tmp0)
    tmp27 += tmp1 * 0.5
    tmp24 = np.copy(tmp22)
    tmp24 += tmp23 * 2
    tmp33 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp6 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp8 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp4 = np.copy(f.aa.oo)
    tmp4 += np.transpose(tmp3, (1, 0))
    del tmp3
    tmp20 = np.copy(v.baa.xov)
    tmp20 += tmp0
    tmp18 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xvv, (0, 3, 4), (3, 1, 2, 4))
    tmp15 = np.copy(v.baa.xov) * 2
    tmp15 += tmp1
    tmp48 = einsum(tmp22, (0, 1, 2), tmp22, (0, 3, 4), (1, 3, 2, 4))
    tmp57 = einsum(tmp22, (0, 1, 2), tmp56, (0, 3, 4), (1, 3, 2, 4)) * 0.5
    del tmp56
    tmp41 = einsum(t2.bbbb, (0, 1, 2, 3), tmp40, (4, 1), (0, 4, 2, 3)) * -1
    del tmp40
    tmp46 = np.copy(f.bb.vv) * -1
    tmp46 += einsum(tmp38, (0, 1, 2), v.bbb.xov, (0, 1, 3), (2, 3))
    tmp49 = einsum(tmp22, (0, 1, 2), tmp23, (0, 3, 4), (1, 3, 2, 4))
    tmp45 = np.copy(f.bb.vv) * -2
    tmp45 += einsum(tmp38, (0, 1, 2), v.bbb.xov, (0, 1, 3), (2, 3)) * 2
    del tmp38
    tmp53 = einsum(t2.bbbb, (0, 1, 2, 3), tmp52, (4, 2, 5, 3), (0, 1, 5, 4))
    del tmp52
    tmp51 = einsum(v.bbb.xov, (0, 1, 2), tmp50, (0, 3, 4), (3, 1, 4, 2))
    del tmp50
    tmp44 = einsum(t2.bbbb, (0, 1, 2, 3), tmp36, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp43 = einsum(t2.bbbb, (0, 1, 2, 3), tmp42, (4, 0, 5, 1), (5, 4, 2, 3))
    del tmp42
    tmp55 = einsum(tmp23, (0, 1, 2), tmp54, (0, 3, 4), (1, 3, 2, 4)) * 2
    del tmp54
    tmp47 = einsum(tmp23, (0, 1, 2), tmp23, (0, 3, 4), (1, 3, 2, 4))
    tmp26 = einsum(v.baa.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 2, 3, 4))
    tmp29 = np.copy(f.aa.vv) * -1
    tmp29 += einsum(tmp27, (0, 1, 2), v.baa.xov, (0, 1, 3), (3, 2))
    tmp28 = np.copy(f.aa.oo)
    tmp28 += einsum(tmp27, (0, 1, 2), v.baa.xov, (0, 3, 2), (3, 1))
    tmp31 = np.copy(f.bb.vv) * -1
    tmp31 += einsum(v.bbb.xov, (0, 1, 2), tmp24, (0, 1, 3), (2, 3)) * 0.5
    tmp34 = einsum(t2.abab, (0, 1, 2, 3), tmp33, (4, 2, 5, 3), (0, 1, 4, 5))
    del tmp33
    tmp35 = np.copy(v.bbb.xov) * 2
    tmp35 += tmp22
    del tmp22
    tmp35 += tmp23 * 2
    del tmp23
    tmp25 = np.copy(f.bb.oo)
    tmp25 += einsum(tmp24, (0, 1, 2), v.bbb.xov, (0, 3, 2), (3, 1)) * 0.5
    tmp37 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp32 = np.copy(v.baa.xov) * 2
    tmp32 += tmp0 * 2
    tmp32 += tmp1
    tmp30 = einsum(v.baa.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp14 = np.copy(v.baa.xov)
    tmp14 += tmp0 * 2
    tmp14 += tmp1
    tmp13 = einsum(tmp0, (0, 1, 2), tmp1, (0, 3, 4), (1, 3, 2, 4))
    tmp17 = np.copy(v.baa.xov)
    tmp17 += tmp0 * 2
    tmp7 = einsum(tmp6, (0, 1, 2, 3), t2.aaaa, (1, 3, 4, 5), (2, 0, 4, 5))
    del tmp6
    tmp12 = einsum(tmp0, (0, 1, 2), tmp0, (0, 3, 4), (1, 3, 2, 4))
    tmp9 = einsum(t2.aaaa, (0, 1, 2, 3), tmp8, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp11 = np.copy(f.aa.vv) * -1
    tmp11 += einsum(v.baa.xov, (0, 1, 2), tmp2, (0, 1, 3), (3, 2)) * 0.5
    tmp5 = einsum(tmp4, (0, 1), t2.aaaa, (2, 1, 3, 4), (2, 0, 3, 4)) * -1
    del tmp4
    tmp10 = np.copy(f.aa.vv) * -2
    tmp10 += einsum(v.baa.xov, (0, 1, 2), tmp2, (0, 1, 3), (3, 2))
    del tmp2
    tmp21 = einsum(tmp20, (0, 1, 2), tmp0, (0, 3, 4), (1, 3, 2, 4)) * 2
    del tmp0, tmp20
    tmp19 = einsum(tmp18, (0, 1, 2, 3), t2.aaaa, (4, 5, 1, 3), (4, 5, 2, 0))
    del tmp18
    tmp16 = einsum(tmp15, (0, 1, 2), tmp1, (0, 3, 4), (1, 3, 2, 4)) * 0.5
    del tmp15
    t2new.bbbb = np.copy(np.transpose(tmp41, (0, 1, 3, 2))) * -2
    t2new.bbbb += np.transpose(tmp43, (0, 1, 3, 2)) * -2
    del tmp43
    t2new.bbbb += np.transpose(tmp41, (1, 0, 3, 2)) * 2
    del tmp41
    t2new.bbbb += np.transpose(tmp44, (1, 0, 3, 2)) * -2
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp45, (4, 3), (0, 1, 4, 2))
    del tmp45
    t2new.bbbb += np.transpose(tmp44, (1, 0, 2, 3)) * 2
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp46, (4, 3), (0, 1, 2, 4)) * -2
    del tmp46
    t2new.bbbb += tmp47 * 2
    t2new.bbbb += tmp48 * 0.5
    t2new.bbbb += tmp49 * 2
    t2new.bbbb += np.transpose(tmp49, (1, 0, 3, 2)) * 2
    t2new.bbbb += np.transpose(tmp51, (1, 0, 3, 2))
    t2new.bbbb += np.transpose(tmp47, (0, 1, 3, 2)) * -2
    del tmp47
    t2new.bbbb += np.transpose(tmp48, (1, 0, 2, 3)) * -0.5
    del tmp48
    t2new.bbbb += np.transpose(tmp49, (0, 1, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp49, (1, 0, 2, 3)) * -2
    del tmp49
    t2new.bbbb += np.transpose(tmp51, (1, 0, 2, 3)) * -1
    del tmp51
    t2new.bbbb += np.transpose(tmp53, (0, 1, 3, 2)) * -2
    del tmp53
    t2new.bbbb += tmp55
    t2new.bbbb += tmp57
    t2new.bbbb += tmp44 * -2
    t2new.bbbb += np.transpose(tmp57, (0, 1, 3, 2)) * -1
    del tmp57
    t2new.bbbb += np.transpose(tmp55, (0, 1, 3, 2)) * -1
    del tmp55
    t2new.bbbb += np.transpose(tmp44, (0, 1, 3, 2)) * 2
    del tmp44
    t2new.abab = einsum(tmp25, (0, 1), t2.abab, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    del tmp25
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp26, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp26
    t2new.abab += einsum(tmp28, (0, 1), t2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -1
    del tmp28
    t2new.abab += einsum(tmp8, (0, 1, 2, 3), t2.abab, (1, 4, 3, 5), (0, 4, 2, 5)) * -1
    del tmp8
    t2new.abab += einsum(tmp29, (0, 1), t2.abab, (2, 3, 0, 4), (2, 3, 1, 4)) * -1
    del tmp29
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp30, (4, 0, 5, 3), (4, 1, 2, 5)) * -1
    del tmp30
    t2new.abab += einsum(tmp31, (0, 1), t2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -1
    del tmp31
    t2new.abab += einsum(v.bbb.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    t2new.abab += einsum(tmp32, (0, 1, 2), tmp24, (0, 3, 4), (1, 3, 2, 4)) * 0.5
    del tmp24, tmp32
    t2new.abab += tmp34
    del tmp34
    t2new.abab += einsum(tmp35, (0, 1, 2), tmp27, (0, 3, 4), (3, 1, 4, 2))
    del tmp27, tmp35
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp36, (4, 1, 5, 3), (0, 4, 2, 5)) * -1
    del tmp36
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp37, (4, 1, 5, 2), (0, 4, 5, 3)) * -1
    del tmp37
    t2new.aaaa = np.copy(np.transpose(tmp5, (0, 1, 3, 2))) * -2
    t2new.aaaa += np.transpose(tmp7, (0, 1, 3, 2)) * -2
    del tmp7
    t2new.aaaa += np.transpose(tmp5, (1, 0, 3, 2)) * 2
    del tmp5
    t2new.aaaa += np.transpose(tmp9, (1, 0, 3, 2)) * -2
    t2new.aaaa += einsum(tmp10, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 0, 4))
    del tmp10
    t2new.aaaa += np.transpose(tmp9, (1, 0, 2, 3)) * 2
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp11, (4, 3), (0, 1, 2, 4)) * -2
    del tmp11
    t2new.aaaa += tmp12 * 2
    t2new.aaaa += einsum(tmp1, (0, 1, 2), tmp1, (0, 3, 4), (1, 3, 2, 4)) * 0.5
    del tmp1
    t2new.aaaa += tmp13 * 2
    t2new.aaaa += np.transpose(tmp13, (1, 0, 3, 2)) * 2
    t2new.aaaa += einsum(tmp14, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    del tmp14
    t2new.aaaa += np.transpose(tmp12, (0, 1, 3, 2)) * -2
    del tmp12
    t2new.aaaa += np.transpose(tmp13, (0, 1, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp13, (1, 0, 2, 3)) * -2
    del tmp13
    t2new.aaaa += np.transpose(tmp16, (0, 1, 3, 2)) * -1
    t2new.aaaa += einsum(v.baa.xov, (0, 1, 2), tmp17, (0, 3, 4), (1, 3, 4, 2)) * -1
    del tmp17
    t2new.aaaa += np.transpose(tmp19, (0, 1, 3, 2)) * -2
    del tmp19
    t2new.aaaa += np.transpose(tmp21, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp16, (1, 0, 3, 2))
    t2new.aaaa += tmp9 * -2
    t2new.aaaa += np.transpose(tmp16, (1, 0, 2, 3)) * -1
    del tmp16
    t2new.aaaa += np.transpose(tmp21, (1, 0, 2, 3)) * -1
    del tmp21
    t2new.aaaa += np.transpose(tmp9, (0, 1, 3, 2)) * 2
    del tmp9

    return {f"t2new": t2new}

