"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T16:29:41.188806
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:29:41.714102.

    Parameters
    ----------
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    e_cc = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 1, 3), ())
    e_cc += einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (0, 2, 1, 3), ())
    e_cc += einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 1, 3), ())

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:30:00.249875.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    t1new : Namespace of arrays
        Updated T1 residuals.
    t2new : Namespace of arrays
        Updated T2 residuals.
    """

    t1new = Namespace()
    t2new = Namespace()
    tmp26 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1))) * -1
    tmp26 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    tmp22 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1))) * -1
    tmp22 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp56 = einsum(tmp26, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 2), (4, 1, 5, 3))
    tmp16 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 1, 3), (4, 0))
    tmp15 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp23 = einsum(t2.aaaa, (0, 1, 2, 3), tmp22, (1, 4, 3, 5), (0, 4, 2, 5))
    tmp10 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 1, 3), (0, 4))
    tmp11 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp1 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1)))
    tmp1 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3)) * -1
    tmp5 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1))) * -1
    tmp5 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    tmp59 = einsum(t2.abab, (0, 1, 2, 3), tmp22, (0, 4, 2, 5), (4, 1, 5, 3))
    del tmp22
    tmp44 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 3, 1, 4), (2, 4)) * -1
    tmp43 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 1, 4), (4, 3))
    tmp46 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp57 = np.copy(v.bbbb.oovv)
    tmp57 += tmp56 * -2
    del tmp56
    tmp70 = np.copy(tmp15)
    tmp70 += tmp16 * 2
    tmp62 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    tmp34 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (0, 4, 1, 3), (2, 4))
    tmp35 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 1, 3), (2, 4))
    tmp50 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovov, (1, 3, 4, 5), (0, 4, 2, 5))
    tmp27 = einsum(t2.abab, (0, 1, 2, 3), tmp26, (1, 4, 5, 3), (0, 4, 2, 5))
    del tmp26
    tmp48 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1)))
    tmp48 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3)) * -1
    tmp20 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp24 = np.copy(v.aaaa.oovv)
    tmp24 += tmp23 * -2
    del tmp23
    tmp39 = np.copy(tmp10) * 2
    tmp39 += tmp11
    tmp30 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp2 = einsum(t1.aa, (0, 1), tmp1, (0, 2, 1, 3), (2, 3))
    del tmp1
    tmp0 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp6 = einsum(tmp5, (0, 1, 2, 3), t1.bb, (0, 3), (1, 2))
    del tmp5
    tmp4 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp60 = einsum(t2.abab, (0, 1, 2, 3), tmp59, (0, 4, 2, 5), (1, 4, 3, 5))
    del tmp59
    tmp69 = np.copy(f.bb.vv) * -1
    tmp69 += tmp43
    tmp69 += tmp44 * 2
    tmp68 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp55 = einsum(tmp46, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (4, 1, 5, 3))
    tmp67 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 5), (4, 2, 5, 3))
    tmp58 = einsum(t2.bbbb, (0, 1, 2, 3), tmp57, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp57
    tmp65 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.oo, (4, 1), (4, 0, 2, 3))
    tmp61 = einsum(v.bbbb.oovv, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp53 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp66 = np.copy(tmp43) * 0.5
    tmp66 += tmp44
    tmp71 = einsum(tmp70, (0, 1), t2.bbbb, (2, 1, 3, 4), (2, 0, 3, 4)) * -1
    del tmp70
    tmp64 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.oooo, (4, 1, 5, 0), (4, 5, 2, 3)) * -1
    tmp54 = einsum(t1.bb, (0, 1), v.bbbb.ooov, (2, 0, 3, 4), (2, 3, 1, 4))
    tmp63 = einsum(tmp62, (0, 1, 2, 3), t2.bbbb, (3, 2, 4, 5), (1, 0, 4, 5))
    del tmp62
    tmp45 = np.copy(tmp43)
    del tmp43
    tmp45 += tmp44 * 2
    del tmp44
    tmp41 = np.copy(np.transpose(v.aabb.vvoo, (2, 3, 0, 1)))
    tmp41 += einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (2, 4, 1, 5)) * -1
    tmp47 = np.copy(f.aa.vv) * -1
    tmp47 += np.transpose(tmp34, (1, 0)) * 2
    tmp47 += np.transpose(tmp35, (1, 0))
    tmp51 = np.copy(tmp50) * 2
    tmp51 += tmp27 * -1
    tmp42 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.oooo, (4, 0, 5, 1), (4, 5, 2, 3))
    tmp49 = np.copy(v.aaaa.oovv)
    tmp49 += np.transpose(tmp20, (1, 0, 3, 2)) * -1
    tmp49 += einsum(t2.aaaa, (0, 1, 2, 3), tmp48, (1, 4, 3, 5), (4, 0, 5, 2)) * 2
    del tmp48
    tmp17 = np.copy(tmp15) * 0.5
    del tmp15
    tmp17 += tmp16
    del tmp16
    tmp52 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp33 = einsum(f.aa.oo, (0, 1), t2.aaaa, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp21 = einsum(t2.aaaa, (0, 1, 2, 3), tmp20, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp38 = np.copy(f.aa.vv) * -1
    tmp38 += tmp34 * 2
    tmp38 += tmp35
    tmp29 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.oovv, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp18 = einsum(t1.aa, (0, 1), v.aaaa.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp25 = einsum(tmp24, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp24
    tmp36 = np.copy(tmp34)
    del tmp34
    tmp36 += tmp35 * 0.5
    del tmp35
    tmp40 = einsum(t2.aaaa, (0, 1, 2, 3), tmp39, (4, 1), (0, 4, 2, 3)) * -1
    tmp19 = einsum(t1.aa, (0, 1), v.aaaa.ooov, (2, 0, 3, 4), (2, 3, 1, 4))
    tmp37 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp28 = einsum(tmp27, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 5, 2)) * -1
    del tmp27
    tmp32 = einsum(v.aaaa.oooo, (0, 1, 2, 3), t2.aaaa, (3, 1, 4, 5), (0, 2, 4, 5)) * -1
    tmp31 = einsum(tmp30, (0, 1, 2, 3), t2.aaaa, (3, 2, 4, 5), (1, 0, 4, 5))
    del tmp30
    tmp3 = np.copy(f.aa.ov)
    tmp3 += tmp0
    tmp3 += tmp2 * -1
    del tmp2
    tmp7 = np.copy(f.bb.ov)
    tmp7 += tmp4
    tmp7 += tmp6 * -1
    del tmp6
    tmp14 = einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp13 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 2, 1))
    tmp9 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 2, 1))
    tmp8 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp12 = np.copy(tmp10)
    del tmp10
    tmp12 += tmp11 * 0.5
    del tmp11
    t2new.bbbb = np.copy(np.transpose(tmp53, (1, 0, 2, 3)))
    t2new.bbbb += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    t2new.bbbb += tmp53 * -1
    t2new.bbbb += np.transpose(v.bbbb.ovov, (0, 2, 3, 1)) * -1
    t2new.bbbb += np.transpose(tmp54, (0, 1, 3, 2))
    t2new.bbbb += tmp55 * 2
    t2new.bbbb += np.transpose(tmp55, (1, 0, 3, 2)) * 2
    t2new.bbbb += np.transpose(tmp58, (1, 0, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp60, (1, 0, 3, 2))
    t2new.bbbb += np.transpose(tmp54, (1, 0, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp55, (0, 1, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp55, (1, 0, 2, 3)) * -2
    del tmp55
    t2new.bbbb += np.transpose(tmp58, (0, 1, 3, 2)) * 2
    del tmp58
    t2new.bbbb += np.transpose(tmp60, (0, 1, 3, 2)) * -1
    del tmp60
    t2new.bbbb += tmp54 * -1
    t2new.bbbb += np.transpose(tmp61, (1, 0, 2, 3)) * 2
    t2new.bbbb += np.transpose(tmp54, (1, 0, 2, 3))
    del tmp54
    t2new.bbbb += tmp61 * -2
    del tmp61
    t2new.bbbb += np.transpose(tmp53, (0, 1, 3, 2))
    t2new.bbbb += einsum(v.bbbb.vvvv, (0, 1, 2, 3), t2.bbbb, (4, 5, 3, 1), (4, 5, 0, 2)) * -2
    t2new.bbbb += np.transpose(tmp53, (1, 0, 3, 2)) * -1
    del tmp53
    t2new.bbbb += np.transpose(tmp63, (0, 1, 3, 2)) * -2
    del tmp63
    t2new.bbbb += np.transpose(tmp64, (1, 0, 3, 2)) * 2
    del tmp64
    t2new.bbbb += np.transpose(tmp65, (1, 0, 3, 2)) * 2
    t2new.bbbb += np.transpose(tmp65, (0, 1, 3, 2)) * -2
    del tmp65
    t2new.bbbb += einsum(tmp66, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 4, 0)) * -4
    del tmp66
    t2new.bbbb += np.transpose(tmp67, (1, 0, 3, 2))
    t2new.bbbb += np.transpose(tmp68, (1, 0, 3, 2)) * 2
    t2new.bbbb += einsum(tmp69, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 0, 4)) * 2
    del tmp69
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), f.bb.vv, (4, 3), (0, 1, 2, 4)) * 2
    t2new.bbbb += np.transpose(tmp67, (1, 0, 2, 3)) * -1
    t2new.bbbb += np.transpose(tmp68, (1, 0, 2, 3)) * -2
    t2new.bbbb += np.transpose(tmp67, (0, 1, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp68, (0, 1, 3, 2)) * -2
    t2new.bbbb += tmp67
    del tmp67
    t2new.bbbb += tmp68 * 2
    del tmp68
    t2new.bbbb += np.transpose(tmp71, (0, 1, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp71, (1, 0, 3, 2)) * 2
    del tmp71
    t2new.abab = np.copy(np.transpose(v.aabb.ovov, (0, 2, 1, 3)))
    t2new.abab += einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 1, 2))
    t2new.abab += einsum(t1.bb, (0, 1), v.aabb.ovoo, (2, 3, 4, 0), (2, 4, 3, 1)) * -1
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp41, (1, 4, 2, 5), (0, 4, 5, 3)) * -1
    del tmp41
    t2new.abab += einsum(v.aabb.oovv, (0, 1, 2, 3), t2.abab, (1, 4, 5, 3), (0, 4, 5, 2)) * -1
    t2new.abab += einsum(t1.aa, (0, 1), v.aabb.ooov, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    t2new.abab += einsum(t1.aa, (0, 1), v.aabb.vvov, (2, 1, 3, 4), (0, 3, 2, 4))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), f.bb.oo, (4, 1), (0, 4, 2, 3)) * -1
    t2new.abab += tmp42
    del tmp42
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), f.aa.oo, (4, 0), (4, 1, 2, 3)) * -1
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp45, (4, 3), (0, 1, 2, 4)) * -1
    del tmp45
    t2new.abab += tmp46 * 2
    del tmp46
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 0, 2), (4, 1, 5, 3))
    t2new.abab += einsum(tmp47, (0, 1), t2.abab, (2, 3, 0, 4), (2, 3, 1, 4)) * -1
    del tmp47
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), f.bb.vv, (4, 3), (0, 1, 2, 4))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp49, (0, 4, 2, 5), (4, 1, 5, 3)) * -1
    del tmp49
    t2new.abab += einsum(tmp51, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5)) * 2
    del tmp51
    t2new.abab += tmp50 * 2
    del tmp50
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    t2new.abab += einsum(v.bbbb.oovv, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 5, 2)) * -1
    t2new.abab += einsum(v.aabb.vvvv, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 5, 0, 2))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp52, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp52
    t2new.abab += einsum(tmp17, (0, 1), t2.abab, (2, 1, 3, 4), (2, 0, 3, 4)) * -2
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp39, (4, 0), (4, 1, 2, 3)) * -1
    del tmp39
    t2new.aaaa = np.copy(np.transpose(tmp18, (1, 0, 2, 3)))
    t2new.aaaa += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    t2new.aaaa += tmp18 * -1
    t2new.aaaa += np.transpose(v.aaaa.ovov, (0, 2, 3, 1)) * -1
    t2new.aaaa += np.transpose(tmp19, (0, 1, 3, 2))
    t2new.aaaa += tmp21 * 2
    t2new.aaaa += np.transpose(tmp21, (1, 0, 3, 2)) * 2
    t2new.aaaa += np.transpose(tmp25, (1, 0, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp28, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp19, (1, 0, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp21, (0, 1, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp21, (1, 0, 2, 3)) * -2
    del tmp21
    t2new.aaaa += np.transpose(tmp25, (0, 1, 3, 2)) * 2
    del tmp25
    t2new.aaaa += np.transpose(tmp28, (1, 0, 2, 3)) * -1
    del tmp28
    t2new.aaaa += np.transpose(tmp29, (1, 0, 2, 3)) * 2
    t2new.aaaa += tmp19 * -1
    t2new.aaaa += tmp29 * -2
    del tmp29
    t2new.aaaa += np.transpose(tmp19, (1, 0, 2, 3))
    del tmp19
    t2new.aaaa += np.transpose(tmp18, (0, 1, 3, 2))
    t2new.aaaa += np.transpose(tmp31, (0, 1, 3, 2)) * -2
    del tmp31
    t2new.aaaa += np.transpose(tmp18, (1, 0, 3, 2)) * -1
    del tmp18
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.vvvv, (4, 3, 5, 2), (0, 1, 4, 5)) * -2
    t2new.aaaa += np.transpose(tmp32, (1, 0, 3, 2)) * 2
    del tmp32
    t2new.aaaa += np.transpose(tmp33, (1, 0, 3, 2)) * 2
    t2new.aaaa += np.transpose(tmp33, (0, 1, 3, 2)) * -2
    del tmp33
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp36, (4, 3), (0, 1, 2, 4)) * -4
    del tmp36
    t2new.aaaa += np.transpose(tmp37, (1, 0, 3, 2)) * 2
    t2new.aaaa += np.transpose(tmp20, (1, 0, 3, 2))
    t2new.aaaa += einsum(tmp38, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 0, 4)) * 2
    del tmp38
    t2new.aaaa += np.transpose(tmp37, (1, 0, 2, 3)) * -2
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), f.aa.vv, (4, 3), (0, 1, 2, 4)) * 2
    t2new.aaaa += np.transpose(tmp20, (1, 0, 2, 3)) * -1
    t2new.aaaa += np.transpose(tmp37, (0, 1, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp20, (0, 1, 3, 2)) * -1
    t2new.aaaa += tmp37 * 2
    del tmp37
    t2new.aaaa += tmp20
    del tmp20
    t2new.aaaa += np.transpose(tmp40, (0, 1, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp40, (1, 0, 3, 2)) * 2
    del tmp40
    t1new.bb = einsum(v.bbbb.ooov, (0, 1, 2, 3), t2.bbbb, (2, 1, 4, 3), (0, 4)) * 2
    t1new.bb += einsum(v.bbbb.oovv, (0, 1, 2, 3), t1.bb, (1, 3), (0, 2)) * -1
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovoo, (0, 2, 4, 1), (4, 3)) * -1
    t1new.bb += einsum(t1.bb, (0, 1), f.bb.oo, (2, 0), (2, 1)) * -1
    t1new.bb += einsum(tmp3, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    t1new.bb += einsum(tmp7, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3)) * 2
    t1new.bb += einsum(tmp13, (0, 1, 2, 3), t2.abab, (0, 2, 3, 4), (1, 4)) * -1
    del tmp13
    t1new.bb += einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    t1new.bb += tmp4
    del tmp4
    t1new.bb += einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.bbbb, (4, 0, 1, 3), (4, 2)) * -2
    t1new.bb += einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    t1new.bb += einsum(t1.bb, (0, 1), f.bb.vv, (2, 1), (0, 2))
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), tmp14, (4, 0, 1, 3), (4, 2)) * 2
    del tmp14
    t1new.bb += einsum(tmp17, (0, 1), t1.bb, (1, 2), (0, 2)) * -2
    del tmp17
    t1new.aa = einsum(f.aa.oo, (0, 1), t1.aa, (1, 2), (0, 2)) * -1
    t1new.aa += einsum(t1.aa, (0, 1), v.aaaa.oovv, (2, 0, 3, 1), (2, 3)) * -1
    t1new.aa += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 0, 1, 3), (4, 2)) * -1
    t1new.aa += einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 3), (0, 4)) * -2
    t1new.aa += einsum(tmp3, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3)) * 2
    del tmp3
    t1new.aa += einsum(tmp7, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    del tmp7
    t1new.aa += einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 3, 0, 1), (2, 3))
    t1new.aa += einsum(f.aa.vv, (0, 1), t1.aa, (2, 1), (2, 0))
    t1new.aa += einsum(t2.abab, (0, 1, 2, 3), tmp8, (4, 0, 1, 3), (4, 2)) * -1
    del tmp8
    t1new.aa += tmp0
    del tmp0
    t1new.aa += einsum(tmp9, (0, 1, 2, 3), t2.aaaa, (2, 1, 4, 3), (0, 4)) * -2
    del tmp9
    t1new.aa += einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 1, 3), (4, 2)) * -2
    t1new.aa += einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 1, 3), (0, 4))
    t1new.aa += einsum(t1.aa, (0, 1), tmp12, (2, 0), (2, 1)) * -2
    del tmp12

    return {f"t1new": t1new, f"t2new": t2new}

