"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T16:35:03.729014
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:35:05.012635.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp2 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1)))
    tmp2 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3)) * -1
    tmp0 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1)))
    tmp0 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3)) * -1
    tmp3 = np.copy(f.aa.ov) * 2
    tmp3 += einsum(tmp2, (0, 1, 2, 3), t1.aa, (0, 2), (1, 3)) * -1
    del tmp2
    tmp1 = np.copy(f.bb.ov)
    tmp1 += einsum(t1.aa, (0, 1), v.aabb.ovov, (0, 1, 2, 3), (2, 3))
    tmp1 += einsum(tmp0, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3)) * -0.5
    del tmp0
    e_cc = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (0, 2, 3, 1), ()) * -1
    e_cc += einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 3, 1), ()) * -1
    e_cc += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 3), ())
    e_cc += einsum(tmp1, (0, 1), t1.bb, (0, 1), ())
    del tmp1
    e_cc += einsum(t1.aa, (0, 1), tmp3, (0, 1), ()) * 0.5
    del tmp3

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:35:21.407192.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    t1new : Namespace of arrays
        Updated T1 residuals.
    t2new : Namespace of arrays
        Updated T2 residuals.
    """

    t1new = Namespace()
    t2new = Namespace()
    tmp16 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 2, 1))
    tmp2 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 2, 1))
    tmp11 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1)))
    tmp11 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3)) * -1
    tmp5 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1)))
    tmp5 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3)) * -1
    tmp78 = einsum(tmp16, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 2, 1))
    tmp72 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp68 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp17 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 2, 1))
    tmp39 = einsum(t1.aa, (0, 1), tmp2, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp33 = einsum(t1.aa, (0, 1), v.aaaa.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp36 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp12 = einsum(tmp11, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3))
    del tmp11
    tmp10 = einsum(t1.aa, (0, 1), v.aabb.ovov, (0, 1, 2, 3), (2, 3))
    tmp6 = einsum(tmp5, (0, 1, 2, 3), t1.aa, (0, 2), (1, 3))
    del tmp5
    tmp0 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp61 = einsum(t1.bb, (0, 1), v.bbbb.oooo, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp79 = einsum(t1.bb, (0, 1), tmp78, (2, 3, 0, 4), (3, 2, 4, 1))
    del tmp78
    tmp65 = einsum(v.bbbb.oovv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp74 = einsum(t1.bb, (0, 1), v.bbbb.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp76 = einsum(tmp72, (0, 1, 2, 3), t1.bb, (4, 2), (4, 0, 1, 3))
    tmp47 = einsum(t1.bb, (0, 1), f.bb.ov, (0, 2), (2, 1))
    tmp69 = einsum(tmp68, (0, 1, 2, 3), t1.bb, (3, 4), (0, 2, 1, 4))
    del tmp68
    tmp51 = einsum(t1.bb, (0, 1), f.bb.ov, (2, 1), (2, 0))
    tmp56 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 2, 0, 1))
    tmp57 = einsum(t1.aa, (0, 1), tmp17, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp54 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 1, 2))
    tmp49 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp52 = einsum(t1.aa, (0, 1), v.aabb.ovoo, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp26 = einsum(t1.aa, (0, 1), f.aa.ov, (0, 2), (2, 1))
    tmp31 = einsum(t1.aa, (0, 1), f.aa.ov, (2, 1), (2, 0))
    tmp40 = einsum(tmp39, (0, 1, 2, 3), t1.aa, (2, 4), (1, 0, 3, 4))
    del tmp39
    tmp34 = einsum(tmp33, (0, 1, 2, 3), t1.aa, (3, 4), (0, 2, 1, 4))
    del tmp33
    tmp29 = einsum(t1.aa, (0, 1), v.aaaa.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp23 = einsum(v.aaaa.oooo, (0, 1, 2, 3), t1.aa, (3, 4), (0, 1, 2, 4))
    tmp44 = einsum(v.aaaa.vvvv, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp42 = einsum(tmp36, (0, 1, 2, 3), t1.aa, (4, 2), (4, 0, 1, 3))
    tmp21 = np.copy(v.bbbb.ooov)
    tmp21 += np.transpose(v.bbbb.ovoo, (0, 2, 3, 1)) * -1
    tmp13 = np.copy(f.bb.ov)
    tmp13 += tmp10
    tmp13 += tmp12 * -1
    del tmp12
    tmp14 = np.copy(v.aaaa.ooov) * -1
    tmp14 += np.transpose(v.aaaa.ooov, (0, 2, 1, 3))
    tmp7 = np.copy(f.aa.ov)
    tmp7 += tmp0
    tmp7 += tmp6 * -1
    del tmp6
    tmp62 = einsum(t1.bb, (0, 1), tmp61, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp61
    tmp80 = einsum(tmp79, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3))
    del tmp79
    tmp63 = einsum(f.bb.oo, (0, 1), t2.bbbb, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp73 = einsum(t1.bb, (0, 1), v.bbbb.ooov, (2, 0, 3, 4), (2, 3, 1, 4))
    tmp66 = einsum(t1.bb, (0, 1), tmp65, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp65
    tmp75 = einsum(tmp74, (0, 1, 2, 3), t1.bb, (4, 2), (4, 0, 1, 3))
    del tmp74
    tmp77 = einsum(t1.bb, (0, 1), tmp76, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp76
    tmp71 = einsum(tmp16, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3))
    tmp48 = np.copy(f.bb.vv)
    tmp48 += tmp47 * -1
    tmp64 = np.copy(f.bb.vv)
    tmp64 += tmp47 * -1
    del tmp47
    tmp70 = einsum(t1.bb, (0, 1), tmp69, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp69
    tmp67 = einsum(t2.bbbb, (0, 1, 2, 3), tmp51, (1, 4), (4, 0, 2, 3))
    tmp58 = einsum(t1.aa, (0, 1), tmp56, (2, 3, 4, 1), (0, 2, 3, 4))
    del tmp56
    tmp58 += einsum(t1.aa, (0, 1), tmp57, (2, 0, 3, 4), (2, 3, 4, 1)) * -1
    del tmp57
    tmp60 = einsum(t1.aa, (0, 1), tmp54, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp50 = einsum(tmp49, (0, 1, 2, 3), t1.bb, (3, 4), (1, 0, 2, 4))
    del tmp49
    tmp55 = np.copy(np.transpose(v.aabb.vvov, (2, 0, 1, 3)))
    tmp55 += einsum(v.aabb.vvvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp53 = einsum(t1.aa, (0, 1), v.aabb.vvoo, (2, 1, 3, 4), (0, 3, 4, 2))
    tmp53 += einsum(t1.aa, (0, 1), tmp52, (2, 0, 3, 4), (2, 3, 4, 1)) * -1
    del tmp52
    tmp46 = einsum(v.aabb.oooo, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp27 = np.copy(f.aa.vv)
    tmp27 += tmp26 * -1
    tmp59 = einsum(v.aabb.oovv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp1 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp25 = einsum(f.aa.oo, (0, 1), t2.aaaa, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp32 = einsum(tmp31, (0, 1), t2.aaaa, (2, 0, 3, 4), (1, 2, 3, 4))
    tmp41 = einsum(tmp40, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp40
    tmp38 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    tmp35 = einsum(t1.aa, (0, 1), tmp34, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp34
    tmp30 = einsum(tmp29, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp29
    tmp37 = einsum(tmp2, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    tmp28 = np.copy(f.aa.vv)
    tmp28 += tmp26 * -1
    del tmp26
    tmp24 = einsum(tmp23, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    del tmp23
    tmp45 = einsum(tmp44, (0, 1, 2, 3), t1.aa, (4, 2), (4, 0, 1, 3))
    del tmp44
    tmp43 = einsum(tmp42, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp42
    tmp22 = np.copy(f.bb.oo)
    tmp22 += einsum(t1.aa, (0, 1), v.aabb.ovoo, (0, 1, 2, 3), (2, 3))
    tmp22 += einsum(t1.bb, (0, 1), tmp21, (0, 2, 3, 1), (3, 2)) * -1
    del tmp21
    tmp18 = np.copy(t2.bbbb) * 2
    tmp18 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1))
    tmp19 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (2, 4))
    tmp19 += einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 2), (4, 0)) * -2
    tmp19 += einsum(tmp13, (0, 1), t1.bb, (2, 1), (0, 2))
    tmp3 = np.copy(t2.abab)
    tmp3 += einsum(t1.aa, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    tmp20 = np.copy(f.bb.vv)
    tmp20 += einsum(t1.bb, (0, 1), v.bbbb.ovvv, (0, 2, 3, 1), (2, 3)) * -1
    tmp4 = np.copy(t2.aaaa) * 2
    tmp4 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3))
    tmp9 = np.copy(f.aa.vv)
    tmp9 += einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2)) * -1
    tmp15 = np.copy(f.aa.oo)
    tmp15 += einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp15 += einsum(tmp14, (0, 1, 2, 3), t1.aa, (2, 3), (1, 0)) * -1
    del tmp14
    tmp8 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 3, 1), (0, 4)) * -2
    tmp8 += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (4, 0))
    tmp8 += einsum(t1.aa, (0, 1), tmp7, (2, 1), (2, 0))
    t2new.bbbb = np.copy(tmp62)
    t2new.bbbb += np.transpose(tmp63, (1, 0, 3, 2)) * 2
    t2new.bbbb += np.transpose(tmp62, (0, 1, 3, 2)) * -1
    del tmp62
    t2new.bbbb += np.transpose(tmp63, (0, 1, 3, 2)) * -2
    del tmp63
    t2new.bbbb += einsum(tmp64, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 1, 4)) * -2
    del tmp64
    t2new.bbbb += einsum(tmp48, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 4, 1)) * 2
    t2new.bbbb += np.transpose(tmp66, (1, 0, 3, 2))
    t2new.bbbb += np.transpose(tmp67, (1, 0, 3, 2)) * 2
    t2new.bbbb += np.transpose(tmp70, (1, 0, 2, 3))
    t2new.bbbb += np.transpose(tmp70, (1, 0, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp66, (1, 0, 2, 3)) * -1
    t2new.bbbb += np.transpose(tmp67, (0, 1, 3, 2)) * -2
    del tmp67
    t2new.bbbb += np.transpose(tmp66, (0, 1, 3, 2)) * -1
    t2new.bbbb += tmp70 * -1
    t2new.bbbb += np.transpose(tmp70, (0, 1, 3, 2))
    del tmp70
    t2new.bbbb += tmp66
    del tmp66
    t2new.bbbb += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    t2new.bbbb += np.transpose(tmp71, (1, 0, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp72, (1, 0, 2, 3))
    t2new.bbbb += np.transpose(v.bbbb.ovov, (0, 2, 3, 1)) * -1
    t2new.bbbb += np.transpose(tmp71, (0, 1, 3, 2))
    t2new.bbbb += tmp72 * -1
    t2new.bbbb += np.transpose(tmp73, (0, 1, 3, 2))
    t2new.bbbb += np.transpose(tmp73, (1, 0, 3, 2)) * -1
    t2new.bbbb += tmp73 * -1
    t2new.bbbb += np.transpose(tmp73, (1, 0, 2, 3))
    del tmp73
    t2new.bbbb += np.transpose(tmp72, (0, 1, 3, 2))
    t2new.bbbb += tmp75
    t2new.bbbb += np.transpose(tmp75, (0, 1, 3, 2)) * -1
    del tmp75
    t2new.bbbb += np.transpose(tmp77, (0, 1, 3, 2))
    t2new.bbbb += np.transpose(tmp77, (1, 0, 3, 2)) * -1
    t2new.bbbb += tmp80
    t2new.bbbb += np.transpose(tmp80, (0, 1, 3, 2)) * -1
    del tmp80
    t2new.bbbb += np.transpose(tmp72, (1, 0, 3, 2)) * -1
    del tmp72
    t2new.bbbb += tmp71 * -1
    t2new.bbbb += np.transpose(tmp71, (1, 0, 2, 3))
    del tmp71
    t2new.bbbb += tmp77 * -1
    t2new.bbbb += np.transpose(tmp77, (1, 0, 2, 3))
    del tmp77
    t2new.abab = einsum(t2.abab, (0, 1, 2, 3), f.bb.oo, (4, 1), (0, 4, 2, 3)) * -1
    t2new.abab += einsum(tmp46, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    del tmp46
    t2new.abab += einsum(f.aa.oo, (0, 1), t2.abab, (1, 2, 3, 4), (0, 2, 3, 4)) * -1
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp27, (2, 4), (0, 1, 4, 3))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp48, (3, 4), (0, 1, 2, 4))
    del tmp48
    t2new.abab += einsum(tmp50, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    del tmp50
    t2new.abab += einsum(tmp51, (0, 1), t2.abab, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    del tmp51
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp31, (0, 4), (4, 1, 2, 3)) * -1
    del tmp31
    t2new.abab += einsum(tmp53, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4)) * -1
    del tmp53
    t2new.abab += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    t2new.abab += einsum(tmp17, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 3, 4)) * -1
    t2new.abab += tmp54
    del tmp54
    t2new.abab += einsum(v.aabb.ovoo, (0, 1, 2, 3), t1.bb, (3, 4), (0, 2, 1, 4)) * -1
    t2new.abab += einsum(t1.aa, (0, 1), v.aabb.ooov, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    t2new.abab += einsum(t1.aa, (0, 1), tmp55, (2, 1, 3, 4), (0, 2, 3, 4))
    del tmp55
    t2new.abab += einsum(tmp58, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 3, 4)) * -1
    del tmp58
    t2new.abab += einsum(t1.aa, (0, 1), tmp1, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    t2new.abab += einsum(t1.aa, (0, 1), tmp59, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp59
    t2new.abab += einsum(t1.aa, (0, 1), tmp60, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp60
    t2new.aaaa = np.copy(tmp24)
    t2new.aaaa += np.transpose(tmp25, (1, 0, 3, 2)) * 2
    t2new.aaaa += np.transpose(tmp24, (0, 1, 3, 2)) * -1
    del tmp24
    t2new.aaaa += np.transpose(tmp25, (0, 1, 3, 2)) * -2
    del tmp25
    t2new.aaaa += einsum(tmp27, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 1, 4)) * -2
    del tmp27
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp28, (3, 4), (0, 1, 2, 4)) * 2
    del tmp28
    t2new.aaaa += np.transpose(tmp30, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp32, (1, 0, 3, 2)) * 2
    t2new.aaaa += np.transpose(tmp35, (1, 0, 2, 3))
    t2new.aaaa += np.transpose(tmp35, (1, 0, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp30, (1, 0, 2, 3)) * -1
    t2new.aaaa += np.transpose(tmp32, (0, 1, 3, 2)) * -2
    del tmp32
    t2new.aaaa += np.transpose(tmp30, (0, 1, 3, 2)) * -1
    t2new.aaaa += tmp35 * -1
    t2new.aaaa += np.transpose(tmp35, (0, 1, 3, 2))
    del tmp35
    t2new.aaaa += tmp30
    del tmp30
    t2new.aaaa += np.transpose(tmp36, (1, 0, 2, 3))
    t2new.aaaa += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    t2new.aaaa += np.transpose(tmp37, (1, 0, 3, 2)) * -1
    t2new.aaaa += tmp36 * -1
    t2new.aaaa += np.transpose(v.aaaa.ovov, (0, 2, 3, 1)) * -1
    t2new.aaaa += np.transpose(tmp37, (0, 1, 3, 2))
    t2new.aaaa += np.transpose(tmp38, (0, 1, 3, 2))
    t2new.aaaa += np.transpose(tmp38, (1, 0, 3, 2)) * -1
    t2new.aaaa += tmp38 * -1
    t2new.aaaa += np.transpose(tmp38, (1, 0, 2, 3))
    del tmp38
    t2new.aaaa += np.transpose(tmp36, (0, 1, 3, 2))
    t2new.aaaa += tmp41
    t2new.aaaa += np.transpose(tmp41, (0, 1, 3, 2)) * -1
    del tmp41
    t2new.aaaa += np.transpose(tmp43, (0, 1, 3, 2))
    t2new.aaaa += np.transpose(tmp43, (1, 0, 3, 2)) * -1
    t2new.aaaa += tmp45
    t2new.aaaa += np.transpose(tmp45, (0, 1, 3, 2)) * -1
    del tmp45
    t2new.aaaa += np.transpose(tmp36, (1, 0, 3, 2)) * -1
    del tmp36
    t2new.aaaa += tmp37 * -1
    t2new.aaaa += np.transpose(tmp37, (1, 0, 2, 3))
    del tmp37
    t2new.aaaa += tmp43 * -1
    t2new.aaaa += np.transpose(tmp43, (1, 0, 2, 3))
    del tmp43
    t1new.bb = einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 3, 0, 1), (2, 3))
    t1new.bb += f.bb.ov
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), tmp16, (4, 1, 0, 3), (4, 2)) * -2
    del tmp16
    t1new.bb += tmp10
    del tmp10
    t1new.bb += einsum(tmp17, (0, 1, 2, 3), t2.abab, (0, 2, 3, 4), (1, 4)) * -1
    del tmp17
    t1new.bb += einsum(tmp3, (0, 1, 2, 3), v.aabb.ovvv, (0, 2, 4, 3), (1, 4))
    t1new.bb += einsum(tmp18, (0, 1, 2, 3), v.bbbb.ovvv, (0, 2, 4, 3), (1, 4))
    del tmp18
    t1new.bb += einsum(tmp19, (0, 1), t1.bb, (0, 2), (1, 2)) * -1
    del tmp19
    t1new.bb += einsum(tmp20, (0, 1), t1.bb, (2, 0), (2, 1))
    del tmp20
    t1new.bb += einsum(v.bbbb.oovv, (0, 1, 2, 3), t1.bb, (1, 3), (0, 2)) * -1
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 0, 1, 3), (4, 2)) * -2
    t1new.bb += einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 3, 1, 4), (2, 4)) * -1
    t1new.bb += einsum(tmp13, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3)) * 2
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), tmp7, (0, 2), (1, 3))
    t1new.bb += einsum(tmp22, (0, 1), t1.bb, (0, 2), (1, 2)) * -1
    del tmp22
    t1new.aa = np.copy(tmp0)
    del tmp0
    t1new.aa += einsum(t2.abab, (0, 1, 2, 3), tmp1, (4, 0, 1, 3), (4, 2)) * -1
    del tmp1
    t1new.aa += einsum(tmp2, (0, 1, 2, 3), t2.aaaa, (2, 1, 4, 3), (0, 4)) * -2
    del tmp2
    t1new.aa += f.aa.ov
    t1new.aa += einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    t1new.aa += einsum(tmp3, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 1, 3), (0, 4))
    del tmp3
    t1new.aa += einsum(v.aaaa.ovvv, (0, 1, 2, 3), tmp4, (0, 4, 1, 3), (4, 2))
    del tmp4
    t1new.aa += einsum(t1.aa, (0, 1), tmp8, (0, 2), (2, 1)) * -1
    del tmp8
    t1new.aa += einsum(t1.aa, (0, 1), tmp9, (1, 2), (0, 2))
    del tmp9
    t1new.aa += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 0, 1, 3), (4, 2)) * -1
    t1new.aa += einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 3), (0, 4)) * -2
    t1new.aa += einsum(v.aaaa.oovv, (0, 1, 2, 3), t1.aa, (1, 3), (0, 2)) * -1
    t1new.aa += einsum(t2.abab, (0, 1, 2, 3), tmp13, (1, 3), (0, 2))
    del tmp13
    t1new.aa += einsum(tmp7, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3)) * 2
    del tmp7
    t1new.aa += einsum(tmp15, (0, 1), t1.aa, (0, 2), (1, 2)) * -1
    del tmp15

    return {f"t1new": t1new, f"t2new": t2new}

def update_lams(f=None, l1=None, l2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:37:08.579466.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    l1new : Namespace of arrays
        Updated L1 residuals.
    l2new : Namespace of arrays
        Updated L2 residuals.
    """

    l1new = Namespace()
    l2new = Namespace()
    tmp92 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1)))
    tmp92 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3)) * -1
    tmp150 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1)))
    tmp150 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3)) * -1
    tmp7 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1)))
    tmp7 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3)) * -1
    tmp2 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 2, 1))
    tmp186 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1)))
    tmp186 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3)) * -1
    tmp204 = np.copy(v.bbbb.ovvv)
    tmp204 += np.transpose(v.bbbb.ovvv, (0, 2, 3, 1)) * -1
    tmp217 = np.copy(v.bbbb.ovvv) * -1
    tmp217 += np.transpose(v.bbbb.ovvv, (0, 2, 3, 1))
    tmp91 = einsum(t1.aa, (0, 1), v.aabb.ovov, (0, 1, 2, 3), (2, 3))
    tmp93 = einsum(tmp92, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3))
    del tmp92
    tmp6 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp151 = einsum(tmp150, (0, 1, 2, 3), t1.aa, (0, 2), (1, 3))
    del tmp150
    tmp161 = np.copy(v.aaaa.ovvv)
    tmp161 += np.transpose(v.aaaa.ovvv, (0, 2, 1, 3)) * -1
    tmp142 = np.copy(v.aaaa.ovvv)
    tmp142 += np.transpose(v.aaaa.ovvv, (0, 2, 3, 1)) * -1
    tmp8 = einsum(tmp7, (0, 1, 2, 3), t1.aa, (0, 2), (1, 3))
    del tmp7
    tmp52 = einsum(l1.bb, (0, 1), t1.bb, (2, 0), (1, 2))
    tmp53 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 0, 4), (4, 1))
    tmp54 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    tmp89 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 2, 1))
    tmp42 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 1), (4, 0))
    tmp40 = einsum(t1.aa, (0, 1), l1.aa, (1, 2), (2, 0))
    tmp41 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (2, 4))
    tmp48 = einsum(l2.abab, (0, 1, 2, 3), t1.bb, (4, 1), (2, 3, 4, 0))
    tmp14 = np.copy(np.transpose(v.aabb.ovoo, (0, 2, 3, 1)))
    tmp14 += tmp2
    tmp0 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp36 = einsum(t1.aa, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp187 = einsum(t1.bb, (0, 1), tmp186, (0, 2, 1, 3), (2, 3))
    del tmp186
    tmp205 = einsum(tmp204, (0, 1, 2, 3), t1.bb, (4, 1), (0, 4, 2, 3))
    del tmp204
    tmp50 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp127 = einsum(t1.aa, (0, 1), v.aabb.ovvv, (0, 1, 2, 3), (2, 3))
    tmp218 = einsum(tmp217, (0, 1, 2, 3), t1.bb, (0, 1), (2, 3))
    del tmp217
    tmp175 = einsum(t1.aa, (0, 1), v.aabb.vvov, (2, 1, 3, 4), (0, 3, 2, 4))
    tmp106 = np.copy(v.bbbb.ooov)
    tmp106 += np.transpose(v.bbbb.ovoo, (0, 2, 3, 1)) * -1
    tmp94 = np.copy(f.bb.ov)
    tmp94 += tmp91
    tmp94 += tmp93 * -1
    del tmp93
    tmp85 = np.copy(v.aaaa.ovvv)
    tmp85 += np.transpose(v.aaaa.ovvv, (0, 2, 1, 3)) * -1
    tmp148 = np.copy(v.aaaa.ooov) * -1
    tmp148 += np.transpose(v.aaaa.ovoo, (0, 2, 3, 1))
    tmp152 = np.copy(f.aa.ov)
    tmp152 += tmp6
    tmp152 += tmp151 * -1
    del tmp151
    tmp84 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp162 = einsum(tmp161, (0, 1, 2, 3), t1.aa, (0, 2), (1, 3))
    del tmp161
    tmp143 = einsum(t1.aa, (0, 1), tmp142, (2, 1, 3, 4), (2, 0, 3, 4))
    del tmp142
    tmp10 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 1, 2))
    tmp9 = np.copy(f.aa.ov)
    tmp9 += tmp6
    tmp9 += tmp8 * -1
    del tmp8
    tmp60 = np.copy(v.aaaa.ooov) * -1
    tmp60 += np.transpose(v.aaaa.ovoo, (0, 2, 3, 1))
    tmp55 = np.copy(tmp52)
    tmp55 += tmp53
    tmp55 += tmp54 * 2
    tmp101 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp100 = einsum(tmp89, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp38 = einsum(t1.aa, (0, 1), l2.abab, (1, 2, 3, 4), (3, 0, 4, 2))
    tmp43 = np.copy(tmp40) * 0.5
    tmp43 += tmp41
    tmp43 += tmp42 * 0.5
    tmp70 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 5), (4, 0, 5, 1))
    tmp71 = einsum(tmp48, (0, 1, 2, 3), t1.aa, (4, 3), (0, 4, 1, 2))
    tmp12 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp13 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp15 = einsum(t1.aa, (0, 1), tmp14, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp4 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp95 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 2, 0, 1))
    tmp21 = einsum(t1.aa, (0, 1), tmp0, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp22 = einsum(t1.aa, (0, 1), v.aaaa.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp66 = einsum(tmp36, (0, 1, 2, 3), t1.aa, (4, 3), (1, 0, 2, 4))
    tmp65 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp105 = einsum(t1.aa, (0, 1), v.aabb.ovoo, (0, 1, 2, 3), (2, 3))
    tmp188 = np.copy(f.bb.ov)
    tmp188 += tmp91
    tmp188 += tmp187 * -1
    del tmp187
    tmp209 = np.copy(v.bbbb.ooov)
    tmp209 += np.transpose(v.bbbb.ovoo, (0, 2, 3, 1)) * -1
    tmp214 = np.copy(v.bbbb.ovvv) * -1
    tmp214 += np.transpose(v.bbbb.ovvv, (0, 2, 3, 1))
    tmp206 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1)))
    tmp206 += v.bbbb.oovv * -1
    tmp206 += np.transpose(tmp205, (1, 0, 3, 2)) * -1
    del tmp205
    tmp104 = np.copy(v.bbbb.ovvv)
    tmp104 += np.transpose(v.bbbb.ovvv, (0, 2, 3, 1)) * -1
    tmp120 = einsum(t1.bb, (0, 1), tmp50, (2, 3, 4, 1), (3, 2, 4, 0))
    tmp219 = np.copy(f.bb.vv)
    tmp219 += np.transpose(tmp127, (1, 0))
    tmp219 += np.transpose(tmp218, (1, 0)) * -1
    del tmp218
    tmp177 = einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 3, 0, 1), (2, 3))
    tmp176 = np.copy(np.transpose(v.aabb.ovov, (0, 2, 1, 3)))
    tmp176 += tmp175
    tmp194 = np.copy(np.transpose(v.bbbb.ooov, (0, 2, 1, 3)))
    tmp194 += tmp89
    tmp180 = einsum(t1.bb, (0, 1), tmp106, (0, 2, 3, 1), (2, 3))
    tmp181 = einsum(tmp94, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp29 = np.copy(v.aaaa.ovvv) * -1
    tmp29 += np.transpose(v.aaaa.ovvv, (0, 2, 1, 3))
    tmp140 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    tmp86 = einsum(t1.aa, (0, 1), tmp85, (0, 2, 1, 3), (2, 3))
    del tmp85
    tmp173 = np.copy(v.bbbb.ovvv) * -1
    tmp173 += np.transpose(v.bbbb.ovvv, (0, 2, 1, 3))
    tmp149 = einsum(tmp148, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    del tmp148
    tmp153 = einsum(t1.aa, (0, 1), tmp152, (2, 1), (2, 0))
    tmp59 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp3 = np.copy(np.transpose(v.aabb.ovoo, (0, 2, 3, 1)))
    tmp3 += np.transpose(tmp2, (0, 2, 1, 3))
    tmp163 = np.copy(f.aa.vv)
    tmp163 += np.transpose(tmp84, (1, 0))
    tmp163 += tmp162 * -1
    del tmp162
    tmp144 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1)))
    tmp144 += v.aaaa.oovv * -1
    tmp144 += np.transpose(tmp143, (1, 0, 3, 2)) * -1
    del tmp143
    tmp146 = np.copy(np.transpose(v.aabb.ovov, (0, 2, 1, 3)))
    tmp146 += tmp10
    tmp62 = einsum(t1.aa, (0, 1), tmp9, (2, 1), (0, 2))
    tmp61 = einsum(tmp60, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    del tmp60
    tmp68 = np.copy(v.aaaa.ovvv)
    tmp68 += np.transpose(v.aaaa.ovvv, (0, 2, 3, 1)) * -1
    tmp131 = np.copy(np.transpose(v.aaaa.ooov, (0, 2, 1, 3)))
    tmp131 += tmp0
    tmp31 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 1), (4, 3))
    tmp30 = einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp32 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 1), (0, 4))
    tmp51 = einsum(t2.bbbb, (0, 1, 2, 3), tmp50, (1, 0, 4, 3), (4, 2))
    tmp46 = einsum(t2.abab, (0, 1, 2, 3), l1.aa, (2, 0), (1, 3))
    tmp56 = einsum(tmp55, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp49 = einsum(tmp48, (0, 1, 2, 3), t2.abab, (0, 1, 3, 4), (2, 4))
    tmp47 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2))
    tmp128 = np.copy(v.bbbb.ovvv) * -1
    tmp128 += np.transpose(v.bbbb.ovvv, (0, 2, 1, 3))
    tmp112 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (5, 1, 4, 3))
    tmp113 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp102 = np.copy(v.bbbb.oooo)
    tmp102 += einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 5, 2), (4, 0, 5, 1)) * -1
    tmp102 += np.transpose(tmp100, (3, 1, 2, 0))
    tmp102 += np.transpose(tmp101, (2, 1, 3, 0))
    tmp102 += np.transpose(tmp101, (3, 2, 1, 0)) * -1
    tmp99 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 1, 3)))
    tmp99 += v.bbbb.oovv * -1
    tmp99 += einsum(t1.bb, (0, 1), v.bbbb.ovvv, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp98 = np.copy(v.bbbb.ooov) * -1
    tmp98 += np.transpose(v.bbbb.ooov, (0, 2, 1, 3))
    tmp98 += tmp89
    tmp98 += np.transpose(tmp89, (0, 2, 1, 3)) * -1
    tmp119 = einsum(t2.bbbb, (0, 1, 2, 3), tmp50, (4, 1, 5, 3), (4, 5, 0, 2)) * -1
    tmp118 = einsum(tmp48, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (1, 2, 4, 5))
    tmp27 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 1), (4, 2))
    tmp25 = einsum(l1.aa, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp26 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 0, 1), (4, 2))
    tmp39 = einsum(t2.abab, (0, 1, 2, 3), tmp38, (0, 4, 1, 3), (4, 2))
    tmp35 = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2))
    tmp44 = einsum(tmp43, (0, 1), t1.aa, (0, 2), (1, 2)) * 2
    tmp34 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 1), (0, 2))
    tmp37 = einsum(tmp36, (0, 1, 2, 3), t2.aaaa, (1, 0, 4, 3), (2, 4))
    tmp122 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp72 = np.copy(tmp70)
    tmp72 += tmp71
    tmp16 = np.copy(v.aabb.oooo)
    tmp16 += np.transpose(tmp12, (1, 0, 3, 2))
    tmp16 += np.transpose(tmp13, (1, 0, 3, 2))
    del tmp13
    tmp16 += np.transpose(tmp15, (1, 0, 3, 2))
    del tmp15
    tmp5 = np.copy(v.aabb.ooov)
    tmp5 += np.transpose(tmp4, (1, 0, 2, 3))
    tmp96 = np.copy(np.transpose(v.aabb.vvoo, (2, 3, 0, 1)))
    tmp96 += np.transpose(tmp95, (1, 0, 3, 2))
    tmp90 = np.copy(v.bbbb.ooov)
    tmp90 += np.transpose(v.bbbb.ovoo, (0, 2, 3, 1)) * -1
    tmp90 += np.transpose(tmp89, (1, 0, 2, 3)) * -1
    tmp90 += np.transpose(tmp89, (2, 0, 1, 3))
    tmp74 = einsum(t2.aaaa, (0, 1, 2, 3), tmp36, (4, 1, 5, 3), (4, 5, 0, 2)) * -1
    tmp75 = einsum(t2.abab, (0, 1, 2, 3), tmp38, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp11 = np.copy(np.transpose(v.aabb.ovov, (0, 2, 1, 3)))
    tmp11 += tmp10
    del tmp10
    tmp1 = np.copy(v.aaaa.ooov)
    tmp1 += np.transpose(v.aaaa.ovoo, (0, 2, 3, 1)) * -1
    tmp1 += np.transpose(tmp0, (1, 0, 2, 3)) * -1
    tmp1 += np.transpose(tmp0, (2, 0, 1, 3))
    tmp23 = np.copy(v.aaaa.oooo)
    tmp23 += einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 5, 3, 1), (0, 4, 2, 5)) * -1
    tmp23 += np.transpose(tmp21, (3, 1, 2, 0))
    tmp23 += np.transpose(tmp22, (2, 1, 3, 0))
    tmp23 += np.transpose(tmp22, (3, 2, 1, 0)) * -1
    tmp18 = np.copy(v.aaaa.ooov) * -1
    tmp18 += np.transpose(v.aaaa.ooov, (0, 2, 1, 3))
    tmp18 += tmp0
    tmp18 += np.transpose(tmp0, (0, 2, 1, 3)) * -1
    tmp20 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 1, 3)))
    tmp20 += v.aaaa.oovv * -1
    tmp20 += einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 2, 1))
    tmp19 = np.copy(v.aabb.ooov)
    tmp19 += tmp4
    tmp76 = np.copy(np.transpose(tmp65, (1, 0, 3, 2)))
    tmp76 += np.transpose(tmp66, (0, 1, 3, 2)) * -1
    tmp222 = np.copy(v.bbbb.oooo)
    tmp222 += np.transpose(tmp100, (0, 3, 1, 2)) * -1
    del tmp100
    tmp198 = einsum(tmp4, (0, 1, 2, 3), tmp38, (0, 1, 4, 5), (4, 2, 5, 3))
    tmp225 = einsum(tmp50, (0, 1, 2, 3), tmp89, (1, 2, 4, 5), (0, 4, 3, 5))
    tmp210 = np.copy(f.bb.oo)
    tmp210 += np.transpose(tmp105, (1, 0))
    tmp210 += einsum(t1.bb, (0, 1), tmp209, (0, 2, 3, 1), (2, 3)) * -1
    del tmp209
    tmp210 += einsum(tmp188, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp213 = einsum(tmp50, (0, 1, 2, 3), v.bbbb.ovvv, (2, 4, 5, 3), (1, 0, 4, 5))
    tmp215 = np.copy(f.bb.vv)
    tmp215 += np.transpose(tmp127, (1, 0))
    tmp215 += einsum(tmp214, (0, 1, 2, 3), t1.bb, (0, 1), (3, 2)) * -1
    del tmp214
    tmp207 = einsum(l2.bbbb, (0, 1, 2, 3), tmp206, (3, 4, 5, 1), (4, 2, 5, 0))
    del tmp206
    tmp212 = einsum(l2.bbbb, (0, 1, 2, 3), v.bbbb.vvvv, (4, 1, 5, 0), (2, 3, 4, 5)) * -1
    tmp201 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1)))
    tmp201 += v.bbbb.oovv * -1
    tmp201 += einsum(t1.bb, (0, 1), tmp104, (2, 1, 3, 4), (0, 2, 4, 3)) * -1
    tmp224 = einsum(v.bbbb.ooov, (0, 1, 2, 3), tmp50, (1, 4, 2, 5), (4, 0, 5, 3)) * -1
    tmp211 = einsum(tmp120, (0, 1, 2, 3), v.bbbb.ovov, (3, 4, 2, 5), (0, 1, 5, 4))
    tmp199 = einsum(v.bbbb.ovoo, (0, 1, 2, 3), tmp50, (3, 4, 2, 5), (4, 0, 5, 1)) * -1
    tmp220 = einsum(tmp219, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2)) * -1
    del tmp219
    tmp203 = np.copy(f.bb.ov)
    tmp203 += tmp91
    tmp203 += tmp177
    tmp208 = einsum(tmp176, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (1, 5, 3, 4))
    tmp202 = np.copy(np.transpose(v.aabb.ovov, (0, 2, 1, 3)))
    tmp202 += tmp175
    del tmp175
    tmp223 = np.copy(v.bbbb.ooov)
    tmp223 += np.transpose(tmp89, (0, 2, 1, 3))
    tmp221 = einsum(tmp101, (0, 1, 2, 3), l2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    del tmp101
    tmp197 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), l1.bb, (3, 4), (4, 0, 1, 2))
    tmp216 = einsum(tmp188, (0, 1), tmp50, (2, 3, 0, 4), (2, 3, 1, 4))
    tmp226 = einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp52, (4, 2), (4, 0, 1, 3))
    tmp178 = np.copy(f.bb.ov)
    tmp178 += tmp91
    del tmp91
    tmp178 += tmp177
    del tmp177
    tmp195 = einsum(l1.bb, (0, 1), tmp194, (1, 2, 3, 4), (2, 3, 4, 0))
    del tmp194
    tmp182 = np.copy(f.bb.oo)
    tmp182 += np.transpose(tmp105, (1, 0))
    tmp182 += tmp180 * -1
    del tmp180
    tmp182 += tmp181
    del tmp181
    tmp193 = np.copy(v.bbbb.ooov)
    tmp193 += np.transpose(tmp89, (0, 2, 1, 3))
    tmp196 = einsum(tmp89, (0, 1, 2, 3), tmp50, (0, 4, 2, 5), (4, 1, 5, 3)) * -1
    tmp200 = einsum(tmp38, (0, 1, 2, 3), v.aabb.ooov, (1, 0, 4, 5), (2, 4, 3, 5))
    tmp192 = einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 1, 0, 3), (2, 3))
    tmp168 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 1), (0, 3))
    tmp172 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 1, 3)))
    tmp172 += v.aaaa.oovv * -1
    tmp172 += einsum(tmp29, (0, 1, 2, 3), t1.aa, (4, 2), (4, 0, 3, 1)) * -1
    tmp179 = np.copy(np.transpose(v.aabb.vvoo, (2, 3, 0, 1)))
    tmp179 += np.transpose(tmp95, (0, 1, 3, 2))
    del tmp95
    tmp155 = np.copy(f.aa.ov)
    tmp155 += tmp140
    tmp155 += tmp6
    tmp87 = np.copy(f.aa.vv)
    tmp87 += np.transpose(tmp84, (1, 0))
    tmp87 += np.transpose(tmp86, (1, 0)) * -1
    tmp183 = einsum(v.aabb.ovov, (0, 1, 2, 3), tmp71, (4, 0, 5, 2), (4, 5, 1, 3))
    tmp185 = np.copy(f.bb.vv)
    tmp185 += np.transpose(tmp127, (1, 0))
    tmp185 += einsum(tmp173, (0, 1, 2, 3), t1.bb, (0, 1), (3, 2)) * -1
    tmp174 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 1, 3)))
    tmp174 += v.bbbb.oovv * -1
    tmp174 += einsum(tmp173, (0, 1, 2, 3), t1.bb, (4, 2), (4, 0, 3, 1)) * -1
    del tmp173
    tmp191 = np.copy(v.aabb.oovv)
    tmp191 += einsum(t1.aa, (0, 1), v.aabb.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp154 = np.copy(f.aa.oo)
    tmp154 += np.transpose(tmp59, (1, 0))
    tmp154 += np.transpose(tmp149, (1, 0)) * -1
    del tmp149
    tmp154 += np.transpose(tmp153, (1, 0))
    del tmp153
    tmp184 = einsum(l2.abab, (0, 1, 2, 3), v.aabb.vvvv, (4, 0, 5, 1), (2, 3, 4, 5))
    tmp190 = np.copy(v.aabb.oooo)
    tmp190 += np.transpose(tmp12, (1, 0, 2, 3))
    del tmp12
    tmp190 += einsum(t1.aa, (0, 1), tmp3, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp189 = np.copy(v.aabb.ooov)
    tmp189 += tmp4
    tmp164 = einsum(tmp163, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2)) * -1
    del tmp163
    tmp145 = einsum(l2.aaaa, (0, 1, 2, 3), tmp144, (3, 4, 5, 1), (4, 2, 5, 0))
    del tmp144
    tmp147 = einsum(l2.abab, (0, 1, 2, 3), tmp146, (4, 3, 5, 1), (4, 2, 5, 0))
    tmp139 = np.copy(f.aa.oo)
    tmp139 += np.transpose(tmp59, (1, 0))
    tmp139 += np.transpose(tmp61, (1, 0)) * -1
    tmp139 += tmp62
    tmp130 = np.copy(v.aaaa.ooov)
    tmp130 += np.transpose(tmp0, (0, 2, 1, 3))
    tmp166 = np.copy(v.aaaa.oooo)
    tmp166 += np.transpose(tmp21, (0, 3, 1, 2)) * -1
    del tmp21
    tmp135 = einsum(v.aabb.ovoo, (0, 1, 2, 3), tmp48, (4, 3, 2, 5), (4, 0, 5, 1))
    tmp138 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1)))
    tmp138 += v.aaaa.oovv * -1
    tmp138 += einsum(t1.aa, (0, 1), tmp68, (2, 1, 3, 4), (0, 2, 4, 3)) * -1
    tmp136 = einsum(l1.aa, (0, 1), v.aaaa.ovvv, (2, 3, 4, 0), (1, 2, 3, 4))
    tmp169 = einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp40, (4, 2), (4, 0, 1, 3))
    tmp134 = einsum(tmp48, (0, 1, 2, 3), tmp2, (4, 1, 2, 5), (0, 4, 3, 5))
    tmp167 = np.copy(v.aaaa.ooov)
    tmp167 += np.transpose(tmp0, (0, 2, 1, 3))
    tmp159 = np.copy(f.aa.vv)
    tmp159 += np.transpose(tmp84, (1, 0))
    del tmp84
    tmp159 += tmp86 * -1
    del tmp86
    tmp158 = einsum(l2.aaaa, (0, 1, 2, 3), v.aaaa.vvvv, (4, 1, 5, 0), (2, 3, 4, 5)) * -1
    tmp157 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), tmp36, (4, 5, 0, 3), (5, 4, 1, 2))
    tmp133 = einsum(tmp36, (0, 1, 2, 3), tmp0, (0, 4, 2, 5), (1, 4, 3, 5)) * -1
    tmp170 = einsum(tmp0, (0, 1, 2, 3), tmp36, (4, 0, 1, 5), (4, 2, 5, 3))
    tmp165 = einsum(l2.aaaa, (0, 1, 2, 3), tmp22, (2, 3, 4, 5), (4, 5, 0, 1))
    del tmp22
    tmp137 = einsum(v.aaaa.ovoo, (0, 1, 2, 3), tmp36, (3, 4, 2, 5), (4, 0, 5, 1)) * -1
    tmp132 = einsum(tmp131, (0, 1, 2, 3), l1.aa, (4, 0), (1, 2, 3, 4))
    del tmp131
    tmp171 = einsum(v.aaaa.ooov, (0, 1, 2, 3), tmp36, (1, 4, 2, 5), (4, 0, 5, 3)) * -1
    tmp141 = np.copy(f.aa.ov)
    tmp141 += tmp140
    del tmp140
    tmp141 += tmp6
    del tmp6
    tmp156 = einsum(tmp66, (0, 1, 2, 3), v.aaaa.ovov, (3, 4, 2, 5), (0, 1, 5, 4))
    tmp160 = einsum(tmp152, (0, 1), tmp36, (2, 3, 0, 4), (2, 3, 1, 4))
    tmp109 = einsum(v.aabb.vvvv, (0, 1, 2, 3), t1.aa, (4, 1), (4, 0, 2, 3))
    tmp33 = np.copy(tmp30)
    del tmp30
    tmp33 += tmp31
    del tmp31
    tmp33 += tmp32 * 2
    del tmp32
    tmp88 = np.copy(tmp40)
    tmp88 += tmp41 * 2
    del tmp41
    tmp88 += tmp42
    del tmp42
    tmp126 = np.copy(t1.bb) * -1
    tmp126 += tmp46 * -1
    tmp126 += tmp47 * -2
    tmp126 += tmp49
    tmp126 += tmp51 * 2
    tmp126 += tmp56
    tmp108 = einsum(t1.bb, (0, 1), v.bbbb.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp110 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (4, 1), (4, 0, 2, 3))
    tmp129 = np.copy(f.bb.vv)
    tmp129 += np.transpose(tmp127, (1, 0))
    del tmp127
    tmp129 += einsum(tmp128, (0, 1, 2, 3), t1.bb, (0, 1), (3, 2)) * -1
    del tmp128
    tmp115 = np.copy(tmp112)
    tmp115 += tmp113 * 4
    tmp115 += einsum(tmp50, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3)) * 2
    tmp117 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 5), (5, 1, 4, 2))
    tmp117 += einsum(t1.aa, (0, 1), tmp48, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp111 = np.copy(np.transpose(l2.abab, (2, 3, 0, 1))) * 0.5
    tmp111 += einsum(l2.abab, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 0), (4, 3, 5, 1))
    tmp111 += einsum(tmp38, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -0.5
    tmp111 += einsum(l2.bbbb, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (4, 2, 5, 0))
    tmp103 = np.copy(np.transpose(v.bbbb.ooov, (0, 2, 1, 3)))
    tmp103 += einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (4, 2, 5, 3), (4, 0, 1, 5)) * -1
    tmp103 += einsum(t2.bbbb, (0, 1, 2, 3), tmp98, (4, 1, 5, 3), (5, 0, 4, 2)) * 2
    del tmp98
    tmp103 += einsum(tmp14, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (2, 4, 1, 5))
    tmp103 += einsum(t2.bbbb, (0, 1, 2, 3), tmp94, (4, 3), (4, 0, 1, 2))
    tmp103 += einsum(tmp99, (0, 1, 2, 3), t1.bb, (4, 3), (1, 0, 4, 2))
    del tmp99
    tmp103 += einsum(t1.bb, (0, 1), tmp102, (0, 2, 3, 4), (3, 2, 4, 1)) * -1
    del tmp102
    tmp121 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 4), (4, 0, 1, 2))
    tmp121 += np.transpose(tmp50, (1, 0, 2, 3))
    tmp121 += np.transpose(tmp118, (0, 2, 1, 3)) * 0.5
    tmp121 += np.transpose(tmp119, (0, 2, 1, 3)) * 2
    tmp121 += einsum(t1.bb, (0, 1), tmp120, (0, 2, 3, 4), (2, 3, 4, 1)) * -1
    tmp28 = np.copy(tmp25)
    del tmp25
    tmp28 += tmp26 * 2
    del tmp26
    tmp28 += tmp27
    del tmp27
    tmp45 = np.copy(np.transpose(l1.aa, (1, 0))) * -1
    tmp45 += t1.aa * -1
    tmp45 += tmp34 * -2
    tmp45 += tmp35 * -1
    tmp45 += tmp37 * 2
    tmp45 += tmp39
    tmp45 += tmp44
    del tmp44
    tmp125 = np.copy(np.transpose(tmp122, (1, 0, 3, 2)))
    tmp125 += np.transpose(tmp120, (2, 1, 0, 3))
    del tmp120
    tmp124 = np.copy(tmp70)
    tmp124 += np.transpose(tmp71, (1, 0, 2, 3))
    tmp114 = np.copy(np.transpose(l2.bbbb, (2, 3, 0, 1)))
    tmp114 += tmp112 * 0.5
    del tmp112
    tmp114 += tmp113 * 2
    del tmp113
    tmp116 = einsum(l1.bb, (0, 1), t2.abab, (2, 3, 4, 0), (2, 1, 3, 4))
    tmp116 += tmp48
    tmp116 += einsum(tmp48, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 1, 2, 5)) * 2
    tmp116 += einsum(tmp38, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (1, 2, 4, 5)) * -1
    tmp116 += einsum(t2.abab, (0, 1, 2, 3), tmp50, (4, 1, 5, 3), (0, 4, 5, 2)) * -2
    tmp116 += einsum(t1.aa, (0, 1), tmp72, (0, 2, 3, 4), (2, 3, 4, 1)) * -1
    tmp107 = np.copy(f.bb.oo) * 0.5
    tmp107 += np.transpose(tmp105, (1, 0)) * 0.5
    del tmp105
    tmp107 += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 3), (1, 4)) * 0.5
    tmp107 += einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp107 += einsum(t1.bb, (0, 1), tmp106, (0, 2, 3, 1), (2, 3)) * -0.5
    del tmp106
    tmp107 += einsum(tmp94, (0, 1), t1.bb, (2, 1), (2, 0)) * 0.5
    tmp123 = np.copy(tmp118)
    del tmp118
    tmp123 += tmp119 * 4
    del tmp119
    tmp123 += einsum(t1.bb, (0, 1), tmp122, (2, 0, 3, 4), (2, 4, 3, 1)) * 2
    del tmp122
    tmp57 = np.copy(np.transpose(l1.bb, (1, 0))) * -1
    tmp57 += t1.bb * -1
    tmp57 += tmp46 * -1
    del tmp46
    tmp57 += tmp47 * -2
    del tmp47
    tmp57 += tmp49
    del tmp49
    tmp57 += tmp51 * 2
    del tmp51
    tmp57 += tmp56
    del tmp56
    tmp97 = np.copy(np.transpose(v.aabb.ovoo, (0, 2, 3, 1)))
    tmp97 += tmp2
    tmp97 += einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 5, 3), (0, 1, 5, 4))
    tmp97 += einsum(tmp90, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 1, 0, 5))
    del tmp90
    tmp97 += einsum(tmp3, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 2, 1, 5)) * 2
    tmp97 += einsum(t2.abab, (0, 1, 2, 3), tmp5, (0, 4, 5, 3), (4, 1, 5, 2)) * -1
    tmp97 += einsum(t2.abab, (0, 1, 2, 3), tmp94, (4, 3), (0, 1, 4, 2))
    tmp97 += einsum(t1.aa, (0, 1), tmp96, (2, 3, 1, 4), (0, 3, 2, 4))
    del tmp96
    tmp97 += einsum(t1.aa, (0, 1), tmp16, (0, 2, 3, 4), (2, 4, 3, 1)) * -1
    tmp81 = np.copy(tmp74) * 4
    tmp81 += tmp75
    tmp82 = np.copy(tmp70)
    del tmp70
    tmp82 += np.transpose(tmp71, (0, 1, 3, 2))
    del tmp71
    tmp63 = np.copy(f.aa.oo)
    tmp63 += np.transpose(tmp59, (1, 0))
    del tmp59
    tmp63 += einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 3, 1), (4, 0)) * -2
    tmp63 += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp63 += np.transpose(tmp61, (1, 0)) * -1
    del tmp61
    tmp63 += tmp62
    del tmp62
    tmp80 = einsum(t1.aa, (0, 1), tmp36, (0, 2, 3, 4), (2, 3, 4, 1)) * -1
    tmp73 = einsum(t2.abab, (0, 1, 2, 3), l1.aa, (2, 4), (4, 0, 1, 3))
    tmp73 += tmp38
    tmp73 += einsum(t2.abab, (0, 1, 2, 3), tmp36, (4, 0, 5, 2), (4, 5, 1, 3)) * -2
    tmp73 += einsum(t2.bbbb, (0, 1, 2, 3), tmp38, (4, 5, 1, 3), (4, 5, 0, 2)) * 2
    tmp73 += einsum(tmp48, (0, 1, 2, 3), t2.abab, (4, 1, 3, 5), (0, 4, 2, 5)) * -1
    tmp73 += einsum(tmp72, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 3, 4)) * -1
    del tmp72
    tmp17 = np.copy(v.aabb.ooov)
    tmp17 += einsum(v.aabb.oovv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp17 += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovvv, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp17 += einsum(t2.abab, (0, 1, 2, 3), tmp1, (4, 5, 0, 2), (5, 4, 1, 3))
    del tmp1
    tmp17 += einsum(tmp3, (0, 1, 2, 3), t2.abab, (4, 1, 3, 5), (4, 0, 2, 5)) * -1
    del tmp3
    tmp17 += einsum(tmp5, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (1, 0, 4, 5)) * 2
    del tmp5
    tmp17 += einsum(t2.abab, (0, 1, 2, 3), tmp9, (4, 2), (0, 4, 1, 3))
    tmp17 += einsum(t1.aa, (0, 1), tmp11, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp17 += einsum(tmp16, (0, 1, 2, 3), t1.bb, (2, 4), (1, 0, 3, 4)) * -1
    del tmp16
    tmp24 = np.copy(np.transpose(v.aaaa.ooov, (0, 2, 1, 3)))
    tmp24 += einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 5, 1, 3), (0, 4, 5, 2)) * -1
    tmp24 += einsum(tmp18, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (2, 4, 0, 5)) * 2
    del tmp18
    tmp24 += einsum(t2.abab, (0, 1, 2, 3), tmp19, (4, 5, 1, 3), (5, 0, 4, 2))
    del tmp19
    tmp24 += einsum(tmp9, (0, 1), t2.aaaa, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp24 += einsum(t1.aa, (0, 1), tmp20, (2, 3, 4, 1), (3, 2, 0, 4))
    del tmp20
    tmp24 += einsum(tmp23, (0, 1, 2, 3), t1.aa, (0, 4), (2, 1, 3, 4)) * -1
    del tmp23
    tmp64 = einsum(v.aabb.vvvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp58 = np.copy(tmp52) * 0.5
    tmp58 += tmp53 * 0.5
    del tmp53
    tmp58 += tmp54
    del tmp54
    tmp78 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 5, 1), (5, 0, 4, 3))
    tmp78 += einsum(tmp38, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3))
    tmp69 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 5, 1), (5, 0, 4, 2)) * 4
    tmp69 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp83 = np.copy(t1.aa) * -0.5
    tmp83 += tmp34 * -1
    del tmp34
    tmp83 += tmp35 * -0.5
    del tmp35
    tmp83 += tmp37
    del tmp37
    tmp83 += tmp39 * 0.5
    del tmp39
    tmp83 += einsum(tmp43, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp79 = np.copy(v.aaaa.ovvv)
    tmp79 += einsum(v.aaaa.vvvv, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 2, 1)) * -1
    tmp77 = einsum(l1.aa, (0, 1), t2.aaaa, (2, 3, 4, 0), (1, 2, 3, 4))
    tmp77 += np.transpose(tmp36, (1, 0, 2, 3))
    tmp77 += np.transpose(tmp74, (0, 2, 1, 3)) * 2
    del tmp74
    tmp77 += np.transpose(tmp75, (0, 2, 1, 3)) * 0.5
    del tmp75
    tmp77 += einsum(tmp76, (0, 1, 2, 3), t1.aa, (0, 4), (1, 3, 2, 4))
    del tmp76
    tmp67 = np.copy(np.transpose(l2.abab, (2, 3, 0, 1))) * 0.5
    tmp67 += einsum(l2.aaaa, (0, 1, 2, 3), t2.abab, (3, 4, 1, 5), (2, 4, 0, 5))
    tmp67 += einsum(t2.bbbb, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp67 += einsum(tmp48, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4)) * -0.5
    l2new.bbbb = np.copy(np.transpose(v.bbbb.ovov, (1, 3, 0, 2)))
    l2new.bbbb += einsum(tmp193, (0, 1, 2, 3), l1.bb, (4, 0), (3, 4, 2, 1)) * -1
    del tmp193
    l2new.bbbb += np.transpose(v.bbbb.ovov, (3, 1, 0, 2)) * -1
    l2new.bbbb += np.transpose(tmp195, (3, 2, 0, 1))
    l2new.bbbb += np.transpose(tmp196, (3, 2, 0, 1)) * 2
    l2new.bbbb += np.transpose(tmp197, (2, 3, 0, 1)) * -1
    l2new.bbbb += np.transpose(tmp198, (3, 2, 0, 1))
    l2new.bbbb += np.transpose(tmp199, (3, 2, 0, 1)) * 2
    l2new.bbbb += np.transpose(tmp200, (3, 2, 0, 1))
    l2new.bbbb += einsum(tmp201, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 0), (2, 4, 5, 1)) * -2
    del tmp201
    l2new.bbbb += einsum(l2.abab, (0, 1, 2, 3), tmp202, (2, 4, 0, 5), (5, 1, 3, 4)) * -1
    del tmp202
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp182, (3, 4), (0, 1, 2, 4)) * -2
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp203, (2, 3), (3, 0, 1, 2)) * -1
    del tmp203
    l2new.bbbb += np.transpose(tmp196, (3, 2, 1, 0)) * -2
    l2new.bbbb += np.transpose(tmp197, (2, 3, 1, 0))
    l2new.bbbb += np.transpose(tmp198, (3, 2, 1, 0)) * -1
    l2new.bbbb += np.transpose(tmp199, (3, 2, 1, 0)) * -2
    l2new.bbbb += np.transpose(tmp200, (3, 2, 1, 0)) * -1
    l2new.bbbb += np.transpose(tmp207, (2, 3, 0, 1)) * 2
    l2new.bbbb += np.transpose(tmp208, (2, 3, 0, 1))
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp210, (3, 4), (0, 1, 4, 2)) * 2
    del tmp210
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp178, (2, 3), (3, 0, 2, 1))
    l2new.bbbb += np.transpose(tmp196, (2, 3, 0, 1)) * -2
    l2new.bbbb += np.transpose(tmp197, (3, 2, 0, 1))
    l2new.bbbb += np.transpose(tmp198, (2, 3, 0, 1)) * -1
    l2new.bbbb += np.transpose(tmp199, (2, 3, 0, 1)) * -2
    l2new.bbbb += np.transpose(tmp200, (2, 3, 0, 1)) * -1
    l2new.bbbb += np.transpose(tmp207, (3, 2, 1, 0)) * 2
    l2new.bbbb += np.transpose(tmp208, (3, 2, 1, 0))
    l2new.bbbb += einsum(tmp178, (0, 1), l1.bb, (2, 3), (2, 1, 3, 0))
    l2new.bbbb += np.transpose(tmp196, (2, 3, 1, 0)) * 2
    del tmp196
    l2new.bbbb += np.transpose(tmp197, (3, 2, 1, 0)) * -1
    del tmp197
    l2new.bbbb += np.transpose(tmp198, (2, 3, 1, 0))
    del tmp198
    l2new.bbbb += np.transpose(tmp199, (2, 3, 1, 0)) * 2
    del tmp199
    l2new.bbbb += np.transpose(tmp200, (2, 3, 1, 0))
    del tmp200
    l2new.bbbb += np.transpose(tmp207, (3, 2, 0, 1)) * -2
    del tmp207
    l2new.bbbb += np.transpose(tmp208, (3, 2, 0, 1)) * -1
    del tmp208
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp178, (2, 3), (0, 3, 2, 1)) * -1
    l2new.bbbb += np.transpose(tmp211, (3, 2, 1, 0)) * 2
    del tmp211
    l2new.bbbb += np.transpose(tmp212, (3, 2, 1, 0)) * 2
    del tmp212
    l2new.bbbb += np.transpose(tmp213, (2, 3, 1, 0)) * 2
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp215, (4, 1), (4, 0, 2, 3)) * -1
    del tmp215
    l2new.bbbb += np.transpose(tmp216, (2, 3, 1, 0)) * -2
    l2new.bbbb += np.transpose(tmp220, (2, 3, 1, 0)) * -1
    l2new.bbbb += np.transpose(tmp213, (3, 2, 1, 0)) * -2
    del tmp213
    l2new.bbbb += np.transpose(tmp220, (3, 2, 1, 0)) * 2
    del tmp220
    l2new.bbbb += np.transpose(tmp216, (3, 2, 1, 0)) * 2
    del tmp216
    l2new.bbbb += np.transpose(tmp221, (2, 3, 0, 1)) * -2
    l2new.bbbb += np.transpose(tmp221, (2, 3, 1, 0)) * 2
    del tmp221
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp222, (2, 4, 3, 5), (0, 1, 4, 5)) * 2
    del tmp222
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp223, (1, 2, 3, 4), (4, 0, 2, 3))
    del tmp223
    l2new.bbbb += np.transpose(tmp195, (3, 2, 1, 0)) * -1
    del tmp195
    l2new.bbbb += np.transpose(tmp224, (3, 2, 0, 1)) * -2
    l2new.bbbb += np.transpose(tmp225, (3, 2, 0, 1)) * -2
    l2new.bbbb += einsum(tmp192, (0, 1), l1.bb, (2, 3), (1, 2, 3, 0))
    l2new.bbbb += np.transpose(tmp226, (3, 2, 0, 1)) * -1
    l2new.bbbb += np.transpose(tmp224, (2, 3, 0, 1)) * 2
    l2new.bbbb += np.transpose(tmp225, (2, 3, 0, 1)) * 2
    l2new.bbbb += np.transpose(tmp226, (2, 3, 0, 1))
    l2new.bbbb += einsum(tmp192, (0, 1), l1.bb, (2, 3), (2, 1, 3, 0)) * -1
    l2new.bbbb += np.transpose(tmp224, (3, 2, 1, 0)) * 2
    l2new.bbbb += np.transpose(tmp225, (3, 2, 1, 0)) * 2
    l2new.bbbb += np.transpose(tmp226, (3, 2, 1, 0))
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp192, (2, 3), (3, 0, 2, 1)) * -1
    l2new.bbbb += np.transpose(tmp224, (2, 3, 1, 0)) * -2
    del tmp224
    l2new.bbbb += np.transpose(tmp225, (2, 3, 1, 0)) * -2
    del tmp225
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp192, (2, 3), (0, 3, 2, 1))
    l2new.bbbb += np.transpose(tmp226, (2, 3, 1, 0)) * -1
    del tmp226
    l2new.abab = np.copy(np.transpose(v.aabb.ovov, (1, 3, 0, 2)))
    l2new.abab += einsum(l1.bb, (0, 1), tmp14, (2, 1, 3, 4), (4, 0, 2, 3)) * -1
    l2new.abab += einsum(tmp2, (0, 1, 2, 3), tmp50, (4, 1, 2, 5), (3, 5, 0, 4)) * -2
    del tmp2
    l2new.abab += einsum(tmp0, (0, 1, 2, 3), tmp38, (0, 2, 4, 5), (3, 5, 1, 4)) * -1
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), v.aabb.ovoo, (4, 5, 2, 1), (5, 3, 4, 0)) * -2
    l2new.abab += einsum(v.aaaa.ovoo, (0, 1, 2, 3), tmp38, (3, 2, 4, 5), (1, 5, 0, 4)) * -1
    l2new.abab += einsum(v.aabb.ovvv, (0, 1, 2, 3), l1.bb, (3, 4), (1, 2, 0, 4))
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp172, (2, 4, 0, 5), (5, 1, 4, 3))
    del tmp172
    l2new.abab += einsum(l2.bbbb, (0, 1, 2, 3), tmp146, (4, 3, 5, 1), (5, 0, 4, 2)) * 2
    del tmp146
    l2new.abab += einsum(tmp154, (0, 1), l2.abab, (2, 3, 0, 4), (2, 3, 1, 4)) * -1
    l2new.abab += einsum(l1.bb, (0, 1), tmp155, (2, 3), (3, 0, 2, 1))
    l2new.abab += einsum(l1.aa, (0, 1), v.aabb.vvov, (2, 0, 3, 4), (2, 4, 1, 3))
    l2new.abab += einsum(tmp89, (0, 1, 2, 3), tmp48, (4, 0, 2, 5), (5, 3, 4, 1)) * -1
    l2new.abab += einsum(tmp4, (0, 1, 2, 3), tmp36, (4, 0, 1, 5), (5, 3, 4, 2)) * -2
    del tmp4
    l2new.abab += einsum(v.bbbb.ovoo, (0, 1, 2, 3), tmp48, (4, 3, 2, 5), (5, 1, 4, 0)) * -1
    l2new.abab += einsum(tmp36, (0, 1, 2, 3), v.aabb.ooov, (2, 1, 4, 5), (3, 5, 0, 4)) * -2
    l2new.abab += einsum(tmp174, (0, 1, 2, 3), l2.abab, (4, 2, 5, 0), (4, 3, 5, 1))
    del tmp174
    l2new.abab += einsum(tmp176, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 0), (4, 3, 5, 1)) * 2
    del tmp176
    l2new.abab += einsum(l1.aa, (0, 1), tmp178, (2, 3), (0, 3, 1, 2))
    del tmp178
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp179, (3, 4, 0, 5), (5, 1, 2, 4)) * -1
    del tmp179
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp182, (3, 4), (0, 1, 2, 4)) * -1
    del tmp182
    l2new.abab += einsum(tmp38, (0, 1, 2, 3), v.aabb.ovvv, (1, 4, 5, 3), (4, 5, 0, 2)) * -1
    l2new.abab += np.transpose(tmp183, (2, 3, 0, 1))
    del tmp183
    l2new.abab += np.transpose(tmp184, (2, 3, 0, 1))
    del tmp184
    l2new.abab += einsum(tmp87, (0, 1), l2.abab, (0, 2, 3, 4), (1, 2, 3, 4))
    l2new.abab += einsum(tmp152, (0, 1), tmp38, (2, 0, 3, 4), (1, 4, 2, 3)) * -1
    del tmp152
    l2new.abab += einsum(tmp48, (0, 1, 2, 3), v.aabb.vvov, (4, 3, 2, 5), (4, 5, 0, 1)) * -1
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp185, (1, 4), (0, 4, 2, 3))
    del tmp185
    l2new.abab += einsum(tmp188, (0, 1), tmp48, (2, 3, 0, 4), (4, 1, 2, 3)) * -1
    del tmp188
    l2new.abab += einsum(tmp189, (0, 1, 2, 3), l1.aa, (4, 0), (4, 3, 1, 2)) * -1
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp190, (2, 4, 3, 5), (0, 1, 4, 5))
    del tmp190
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp191, (2, 4, 1, 5), (0, 5, 4, 3)) * -1
    del tmp191
    l2new.abab += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp40, (4, 0), (1, 3, 4, 2)) * -1
    del tmp40
    l2new.abab += einsum(tmp14, (0, 1, 2, 3), tmp38, (4, 0, 1, 5), (3, 5, 4, 2))
    del tmp14
    l2new.abab += einsum(tmp52, (0, 1), v.aabb.ovov, (2, 3, 1, 4), (3, 4, 2, 0)) * -1
    del tmp52
    l2new.abab += einsum(tmp189, (0, 1, 2, 3), tmp48, (0, 4, 2, 5), (5, 3, 1, 4))
    del tmp189
    l2new.abab += einsum(v.aaaa.ooov, (0, 1, 2, 3), tmp38, (1, 2, 4, 5), (3, 5, 0, 4))
    l2new.abab += einsum(tmp168, (0, 1), l1.bb, (2, 3), (1, 2, 0, 3)) * -1
    l2new.abab += einsum(tmp38, (0, 1, 2, 3), tmp0, (0, 1, 4, 5), (5, 3, 4, 2))
    del tmp0
    l2new.abab += einsum(v.bbbb.ooov, (0, 1, 2, 3), tmp48, (4, 1, 2, 5), (5, 3, 4, 0))
    l2new.abab += einsum(l1.aa, (0, 1), tmp192, (2, 3), (0, 3, 1, 2)) * -1
    del tmp192
    l2new.abab += einsum(tmp48, (0, 1, 2, 3), tmp89, (1, 2, 4, 5), (3, 5, 0, 4))
    del tmp89
    l2new.aaaa = np.copy(np.transpose(v.aaaa.ovov, (1, 3, 0, 2)))
    l2new.aaaa += einsum(tmp130, (0, 1, 2, 3), l1.aa, (4, 0), (3, 4, 2, 1)) * -1
    del tmp130
    l2new.aaaa += np.transpose(v.aaaa.ovov, (3, 1, 0, 2)) * -1
    l2new.aaaa += np.transpose(tmp132, (3, 2, 0, 1))
    l2new.aaaa += np.transpose(tmp133, (3, 2, 0, 1)) * 2
    l2new.aaaa += np.transpose(tmp134, (3, 2, 0, 1))
    l2new.aaaa += np.transpose(tmp135, (3, 2, 0, 1))
    l2new.aaaa += np.transpose(tmp136, (2, 3, 0, 1)) * -1
    l2new.aaaa += np.transpose(tmp137, (3, 2, 0, 1)) * 2
    l2new.aaaa += einsum(tmp138, (0, 1, 2, 3), l2.aaaa, (4, 3, 5, 0), (2, 4, 5, 1)) * -2
    del tmp138
    l2new.aaaa += einsum(tmp11, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (2, 4, 5, 0)) * -1
    del tmp11
    l2new.aaaa += einsum(l2.aaaa, (0, 1, 2, 3), tmp139, (3, 4), (0, 1, 2, 4)) * -2
    del tmp139
    l2new.aaaa += einsum(tmp141, (0, 1), l1.aa, (2, 3), (1, 2, 3, 0)) * -1
    del tmp141
    l2new.aaaa += np.transpose(tmp133, (3, 2, 1, 0)) * -2
    l2new.aaaa += np.transpose(tmp134, (3, 2, 1, 0)) * -1
    l2new.aaaa += np.transpose(tmp135, (3, 2, 1, 0)) * -1
    l2new.aaaa += np.transpose(tmp136, (2, 3, 1, 0))
    l2new.aaaa += np.transpose(tmp137, (3, 2, 1, 0)) * -2
    l2new.aaaa += np.transpose(tmp145, (2, 3, 0, 1)) * 2
    l2new.aaaa += np.transpose(tmp147, (2, 3, 0, 1))
    l2new.aaaa += einsum(tmp154, (0, 1), l2.aaaa, (2, 3, 4, 0), (2, 3, 1, 4)) * 2
    del tmp154
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp155, (2, 3), (3, 0, 2, 1))
    l2new.aaaa += np.transpose(tmp134, (2, 3, 0, 1)) * -1
    l2new.aaaa += np.transpose(tmp133, (2, 3, 0, 1)) * -2
    l2new.aaaa += np.transpose(tmp135, (2, 3, 0, 1)) * -1
    l2new.aaaa += np.transpose(tmp136, (3, 2, 0, 1))
    l2new.aaaa += np.transpose(tmp137, (2, 3, 0, 1)) * -2
    l2new.aaaa += np.transpose(tmp145, (3, 2, 1, 0)) * 2
    l2new.aaaa += np.transpose(tmp147, (3, 2, 1, 0))
    l2new.aaaa += einsum(tmp155, (0, 1), l1.aa, (2, 3), (2, 1, 3, 0))
    l2new.aaaa += np.transpose(tmp134, (2, 3, 1, 0))
    del tmp134
    l2new.aaaa += np.transpose(tmp133, (2, 3, 1, 0)) * 2
    del tmp133
    l2new.aaaa += np.transpose(tmp135, (2, 3, 1, 0))
    del tmp135
    l2new.aaaa += np.transpose(tmp136, (3, 2, 1, 0)) * -1
    del tmp136
    l2new.aaaa += np.transpose(tmp137, (2, 3, 1, 0)) * 2
    del tmp137
    l2new.aaaa += np.transpose(tmp145, (3, 2, 0, 1)) * -2
    del tmp145
    l2new.aaaa += np.transpose(tmp147, (3, 2, 0, 1)) * -1
    del tmp147
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp155, (2, 3), (0, 3, 2, 1)) * -1
    del tmp155
    l2new.aaaa += np.transpose(tmp156, (3, 2, 1, 0)) * 2
    del tmp156
    l2new.aaaa += np.transpose(tmp157, (2, 3, 1, 0)) * 2
    l2new.aaaa += np.transpose(tmp158, (3, 2, 1, 0)) * 2
    del tmp158
    l2new.aaaa += einsum(tmp159, (0, 1), l2.aaaa, (2, 1, 3, 4), (0, 2, 3, 4)) * -1
    del tmp159
    l2new.aaaa += np.transpose(tmp160, (2, 3, 1, 0)) * -2
    l2new.aaaa += np.transpose(tmp164, (2, 3, 1, 0)) * -1
    l2new.aaaa += np.transpose(tmp157, (3, 2, 1, 0)) * -2
    del tmp157
    l2new.aaaa += np.transpose(tmp164, (3, 2, 1, 0)) * 2
    del tmp164
    l2new.aaaa += np.transpose(tmp160, (3, 2, 1, 0)) * 2
    del tmp160
    l2new.aaaa += np.transpose(tmp165, (2, 3, 0, 1)) * -2
    l2new.aaaa += np.transpose(tmp165, (2, 3, 1, 0)) * 2
    del tmp165
    l2new.aaaa += einsum(l2.aaaa, (0, 1, 2, 3), tmp166, (2, 4, 3, 5), (0, 1, 4, 5)) * 2
    del tmp166
    l2new.aaaa += einsum(tmp167, (0, 1, 2, 3), l1.aa, (4, 0), (3, 4, 1, 2))
    del tmp167
    l2new.aaaa += np.transpose(tmp132, (3, 2, 1, 0)) * -1
    del tmp132
    l2new.aaaa += einsum(tmp168, (0, 1), l1.aa, (2, 3), (1, 2, 3, 0))
    l2new.aaaa += np.transpose(tmp169, (3, 2, 0, 1)) * -1
    l2new.aaaa += np.transpose(tmp170, (3, 2, 0, 1)) * -2
    l2new.aaaa += np.transpose(tmp171, (3, 2, 0, 1)) * -2
    l2new.aaaa += np.transpose(tmp169, (2, 3, 0, 1))
    l2new.aaaa += einsum(tmp168, (0, 1), l1.aa, (2, 3), (2, 1, 3, 0)) * -1
    l2new.aaaa += np.transpose(tmp170, (2, 3, 0, 1)) * 2
    l2new.aaaa += np.transpose(tmp171, (2, 3, 0, 1)) * 2
    l2new.aaaa += np.transpose(tmp169, (3, 2, 1, 0))
    l2new.aaaa += einsum(tmp168, (0, 1), l1.aa, (2, 3), (1, 2, 0, 3)) * -1
    l2new.aaaa += np.transpose(tmp170, (3, 2, 1, 0)) * 2
    l2new.aaaa += np.transpose(tmp171, (3, 2, 1, 0)) * 2
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp168, (2, 3), (0, 3, 2, 1))
    del tmp168
    l2new.aaaa += np.transpose(tmp169, (2, 3, 1, 0)) * -1
    del tmp169
    l2new.aaaa += np.transpose(tmp170, (2, 3, 1, 0)) * -2
    del tmp170
    l2new.aaaa += np.transpose(tmp171, (2, 3, 1, 0)) * -2
    del tmp171
    l1new.bb = np.copy(np.transpose(f.bb.ov, (1, 0)))
    l1new.bb += einsum(l1.bb, (0, 1), v.bbbb.oovv, (2, 1, 3, 0), (3, 2)) * -1
    l1new.bb += einsum(l2.abab, (0, 1, 2, 3), tmp97, (2, 3, 4, 0), (1, 4)) * -1
    del tmp97
    l1new.bb += einsum(l2.bbbb, (0, 1, 2, 3), tmp103, (4, 2, 3, 1), (0, 4)) * 2
    del tmp103
    l1new.bb += einsum(tmp104, (0, 1, 2, 3), tmp33, (2, 1), (3, 0)) * -1
    del tmp104
    l1new.bb += einsum(v.aabb.vvov, (0, 1, 2, 3), tmp28, (0, 1), (3, 2))
    l1new.bb += einsum(tmp45, (0, 1), v.aabb.ovov, (0, 1, 2, 3), (3, 2)) * -1
    l1new.bb += einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp57, (2, 3), (1, 0)) * -1
    l1new.bb += einsum(tmp55, (0, 1), v.bbbb.ovoo, (2, 3, 0, 1), (3, 2)) * -1
    l1new.bb += einsum(v.aabb.ooov, (0, 1, 2, 3), tmp88, (1, 0), (3, 2)) * -1
    l1new.bb += einsum(l1.bb, (0, 1), tmp107, (1, 2), (0, 2)) * -2
    del tmp107
    l1new.bb += einsum(v.bbbb.oovv, (0, 1, 2, 3), tmp50, (4, 1, 0, 3), (2, 4)) * -2
    l1new.bb += einsum(tmp108, (0, 1, 2, 3), l2.bbbb, (3, 2, 4, 0), (1, 4)) * -2
    del tmp108
    l1new.bb += einsum(v.aabb.oovv, (0, 1, 2, 3), tmp38, (1, 0, 4, 3), (2, 4)) * -1
    del tmp38
    l1new.bb += einsum(l2.abab, (0, 1, 2, 3), tmp109, (2, 0, 4, 1), (4, 3))
    del tmp109
    l1new.bb += einsum(tmp110, (0, 1, 2, 3), tmp50, (4, 0, 1, 3), (2, 4)) * -2
    del tmp50, tmp110
    l1new.bb += einsum(tmp111, (0, 1, 2, 3), v.aabb.ovvv, (0, 2, 4, 3), (4, 1)) * 2
    del tmp111
    l1new.bb += einsum(tmp114, (0, 1, 2, 3), v.bbbb.ovvv, (1, 3, 4, 2), (4, 0)) * 2
    del tmp114
    l1new.bb += einsum(tmp115, (0, 1, 2, 3), v.bbbb.ovvv, (1, 4, 3, 2), (4, 0)) * -1
    del tmp115
    l1new.bb += einsum(tmp116, (0, 1, 2, 3), v.aabb.ovov, (0, 3, 2, 4), (4, 1)) * -1
    del tmp116
    l1new.bb += einsum(tmp117, (0, 1, 2, 3), v.aabb.vvov, (3, 2, 1, 4), (4, 0)) * -1
    del tmp117
    l1new.bb += einsum(tmp121, (0, 1, 2, 3), v.bbbb.ovov, (1, 3, 2, 4), (4, 0)) * -2
    del tmp121
    l1new.bb += einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp123, (4, 2, 0, 3), (1, 4))
    del tmp123
    l1new.bb += einsum(v.aabb.ooov, (0, 1, 2, 3), tmp124, (1, 0, 4, 2), (3, 4))
    del tmp124
    l1new.bb += einsum(v.bbbb.ooov, (0, 1, 2, 3), tmp125, (1, 4, 0, 2), (3, 4)) * 2
    del tmp125
    l1new.bb += einsum(tmp126, (0, 1), v.bbbb.ovov, (2, 1, 0, 3), (3, 2))
    del tmp126
    l1new.bb += einsum(tmp55, (0, 1), v.bbbb.ooov, (2, 0, 1, 3), (3, 2))
    l1new.bb += einsum(tmp129, (0, 1), l1.bb, (0, 2), (1, 2))
    del tmp129
    l1new.bb += einsum(tmp94, (0, 1), tmp55, (2, 0), (1, 2)) * -1
    del tmp94, tmp55
    l1new.aa = einsum(v.aaaa.oovv, (0, 1, 2, 3), l1.aa, (3, 1), (2, 0)) * -1
    l1new.aa += np.transpose(f.aa.ov, (1, 0))
    l1new.aa += einsum(tmp17, (0, 1, 2, 3), l2.abab, (4, 3, 0, 2), (4, 1)) * -1
    del tmp17
    l1new.aa += einsum(tmp24, (0, 1, 2, 3), l2.aaaa, (4, 3, 1, 2), (4, 0)) * 2
    del tmp24
    l1new.aa += einsum(tmp28, (0, 1), tmp29, (2, 3, 1, 0), (3, 2)) * -1
    del tmp29, tmp28
    l1new.aa += einsum(v.aabb.ovvv, (0, 1, 2, 3), tmp33, (3, 2), (1, 0))
    del tmp33
    l1new.aa += einsum(tmp45, (0, 1), v.aaaa.ovov, (2, 3, 0, 1), (3, 2)) * -1
    del tmp45
    l1new.aa += einsum(tmp57, (0, 1), v.aabb.ovov, (2, 3, 0, 1), (3, 2)) * -1
    del tmp57
    l1new.aa += einsum(tmp43, (0, 1), v.aaaa.ovoo, (2, 3, 1, 0), (3, 2)) * -2
    l1new.aa += einsum(tmp58, (0, 1), v.aabb.ovoo, (2, 3, 1, 0), (3, 2)) * -2
    del tmp58
    l1new.aa += einsum(l1.aa, (0, 1), tmp63, (1, 2), (0, 2)) * -1
    del tmp63
    l1new.aa += einsum(tmp64, (0, 1, 2, 3), l2.abab, (2, 3, 4, 0), (1, 4))
    del tmp64
    l1new.aa += einsum(tmp48, (0, 1, 2, 3), v.aabb.vvoo, (4, 3, 2, 1), (4, 0)) * -1
    del tmp48
    l1new.aa += einsum(v.aaaa.oovv, (0, 1, 2, 3), tmp36, (4, 1, 0, 3), (2, 4)) * -2
    del tmp36
    l1new.aa += einsum(tmp65, (0, 1, 2, 3), v.aaaa.ooov, (1, 3, 2, 4), (4, 0)) * 2
    del tmp65
    l1new.aa += einsum(v.aaaa.ooov, (0, 1, 2, 3), tmp66, (4, 1, 0, 2), (3, 4)) * -2
    del tmp66
    l1new.aa += einsum(tmp67, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 1, 3), (4, 0)) * 2
    del tmp67
    l1new.aa += einsum(tmp69, (0, 1, 2, 3), tmp68, (1, 3, 2, 4), (4, 0))
    del tmp69
    l1new.aa += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp73, (4, 0, 2, 3), (1, 4)) * -1
    del tmp73
    l1new.aa += einsum(tmp77, (0, 1, 2, 3), v.aaaa.ovov, (1, 3, 2, 4), (4, 0)) * -2
    del tmp77
    l1new.aa += einsum(tmp78, (0, 1, 2, 3), v.aabb.ovvv, (1, 4, 3, 2), (4, 0)) * -1
    del tmp78
    l1new.aa += einsum(tmp79, (0, 1, 2, 3), l2.aaaa, (1, 2, 4, 0), (3, 4)) * -2
    del tmp79
    l1new.aa += einsum(tmp68, (0, 1, 2, 3), tmp80, (4, 0, 2, 1), (3, 4)) * -2
    del tmp68, tmp80
    l1new.aa += einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp81, (4, 2, 0, 3), (1, 4))
    del tmp81
    l1new.aa += einsum(v.aabb.ovoo, (0, 1, 2, 3), tmp82, (4, 0, 3, 2), (1, 4))
    del tmp82
    l1new.aa += einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp83, (2, 1), (3, 0)) * 2
    del tmp83
    l1new.aa += einsum(v.aaaa.ooov, (0, 1, 2, 3), tmp43, (1, 2), (3, 0)) * 2
    del tmp43
    l1new.aa += einsum(tmp87, (0, 1), l1.aa, (0, 2), (1, 2))
    del tmp87
    l1new.aa += einsum(tmp88, (0, 1), tmp9, (1, 2), (2, 0)) * -1
    del tmp9, tmp88

    return {f"l1new": l1new, f"l2new": l2new}

def make_rdm1_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:37:11.881813.

    Parameters
    ----------
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm1 : Namespace of arrays
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    rdm1.aa = Namespace()
    rdm1.bb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    tmp4 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 0, 4), (4, 1))
    tmp3 = einsum(l1.bb, (0, 1), t1.bb, (2, 0), (1, 2))
    tmp5 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    tmp2 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 1), (4, 0))
    tmp0 = einsum(t1.aa, (0, 1), l1.aa, (1, 2), (2, 0))
    tmp1 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 1), (4, 0))
    tmp11 = np.copy(tmp3)
    tmp11 += tmp4
    tmp11 += tmp5 * 2
    tmp9 = einsum(l2.abab, (0, 1, 2, 3), t1.bb, (4, 1), (2, 3, 4, 0))
    tmp10 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp7 = einsum(t1.aa, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp6 = einsum(t1.aa, (0, 1), l2.abab, (1, 2, 3, 4), (3, 0, 4, 2))
    tmp8 = np.copy(tmp0)
    tmp8 += tmp1 * 2
    tmp8 += tmp2
    rdm1.bb.vv = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 1), (0, 4)) * 2
    rdm1.bb.vv += einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 1), (4, 3))
    rdm1.bb.vv += einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    rdm1.aa.vv = einsum(l1.aa, (0, 1), t1.aa, (1, 2), (0, 2))
    rdm1.aa.vv += einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 1), (4, 2))
    rdm1.aa.vv += einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 0, 1), (4, 2)) * 2
    rdm1.bb.vo = np.copy(l1.bb)
    rdm1.aa.vo = np.copy(l1.aa)
    rdm1.bb.ov = np.copy(t1.bb)
    rdm1.bb.ov += einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2)) * 2
    rdm1.bb.ov += einsum(t2.abab, (0, 1, 2, 3), l1.aa, (2, 0), (1, 3))
    rdm1.bb.ov += einsum(tmp9, (0, 1, 2, 3), t2.abab, (0, 1, 3, 4), (2, 4)) * -1
    del tmp9
    rdm1.bb.ov += einsum(t2.bbbb, (0, 1, 2, 3), tmp10, (1, 0, 4, 3), (4, 2)) * -2
    del tmp10
    rdm1.bb.ov += einsum(tmp11, (0, 1), t1.bb, (0, 2), (1, 2)) * -1
    del tmp11
    rdm1.aa.ov = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2))
    rdm1.aa.ov += einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 1), (0, 2)) * 2
    rdm1.aa.ov += t1.aa
    rdm1.aa.ov += einsum(t2.abab, (0, 1, 2, 3), tmp6, (0, 4, 1, 3), (4, 2)) * -1
    del tmp6
    rdm1.aa.ov += einsum(tmp7, (0, 1, 2, 3), t2.aaaa, (1, 0, 4, 3), (2, 4)) * -2
    del tmp7
    rdm1.aa.ov += einsum(t1.aa, (0, 1), tmp8, (0, 2), (2, 1)) * -1
    del tmp8
    rdm1.bb.oo = np.copy(np.transpose(tmp3, (1, 0))) * -1
    del tmp3
    rdm1.bb.oo += np.transpose(tmp4, (1, 0)) * -1
    del tmp4
    rdm1.bb.oo += np.transpose(tmp5, (1, 0)) * -2
    del tmp5
    rdm1.bb.oo += delta.bb.oo
    rdm1.aa.oo = np.copy(np.transpose(tmp0, (1, 0))) * -1
    del tmp0
    rdm1.aa.oo += np.transpose(tmp1, (1, 0)) * -2
    del tmp1
    rdm1.aa.oo += delta.aa.oo
    del delta
    rdm1.aa.oo += np.transpose(tmp2, (1, 0)) * -1
    del tmp2
    rdm1.aa = np.block([[rdm1.aa.oo, rdm1.aa.ov], [rdm1.aa.vo, rdm1.aa.vv]])
    rdm1.bb = np.block([[rdm1.bb.oo, rdm1.bb.ov], [rdm1.bb.vo, rdm1.bb.vv]])

    return rdm1

def make_rdm2_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:38:15.176887.

    Parameters
    ----------
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm2 : Namespace of arrays
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    rdm2.aaaa = Namespace()
    rdm2.abab = Namespace()
    rdm2.bbbb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    tmp18 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp9 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 0, 4), (4, 1))
    tmp8 = einsum(l1.bb, (0, 1), t1.bb, (2, 0), (1, 2))
    tmp10 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    tmp13 = einsum(l2.abab, (0, 1, 2, 3), t1.bb, (4, 1), (2, 3, 4, 0))
    tmp2 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 1), (4, 0))
    tmp0 = einsum(t1.aa, (0, 1), l1.aa, (1, 2), (2, 0))
    tmp1 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 1), (4, 0))
    tmp6 = einsum(t1.aa, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp26 = einsum(t1.aa, (0, 1), l2.abab, (1, 2, 3, 4), (3, 0, 4, 2))
    tmp88 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp87 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (5, 1, 4, 3))
    tmp69 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp71 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp17 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp19 = einsum(t1.bb, (0, 1), tmp18, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp15 = np.copy(tmp8)
    tmp15 += tmp9
    tmp15 += tmp10 * 2
    tmp51 = einsum(t2.abab, (0, 1, 2, 3), tmp13, (0, 4, 5, 2), (4, 5, 1, 3))
    tmp50 = einsum(tmp18, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 2, 4, 5)) * -1
    tmp4 = np.copy(tmp0) * 0.5
    tmp4 += tmp1
    tmp4 += tmp2 * 0.5
    tmp12 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 5), (4, 0, 5, 1))
    tmp14 = einsum(t1.aa, (0, 1), tmp13, (2, 3, 4, 1), (2, 0, 3, 4))
    tmp7 = einsum(tmp6, (0, 1, 2, 3), t1.aa, (4, 3), (0, 1, 4, 2))
    tmp5 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp31 = einsum(tmp6, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (0, 2, 4, 5)) * -1
    tmp30 = einsum(t2.abab, (0, 1, 2, 3), tmp26, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp82 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 1), (0, 4))
    tmp107 = einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp81 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 1), (4, 3))
    tmp110 = einsum(tmp18, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4))
    tmp89 = np.copy(tmp87)
    tmp89 += tmp88 * 4
    tmp104 = einsum(l1.aa, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp64 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 0, 1), (4, 2))
    tmp65 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 1), (4, 2))
    tmp84 = einsum(l2.aaaa, (0, 1, 2, 3), t2.abab, (3, 4, 1, 5), (2, 4, 0, 5))
    tmp85 = einsum(t2.bbbb, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp106 = einsum(t1.aa, (0, 1), tmp6, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp118 = np.copy(tmp69) * 4
    tmp118 += tmp71
    tmp112 = einsum(l2.abab, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 0), (4, 3, 5, 1))
    tmp67 = einsum(t2.abab, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (0, 5, 2, 4))
    tmp52 = np.copy(np.transpose(tmp17, (1, 0, 3, 2)))
    tmp52 += np.transpose(tmp19, (0, 1, 3, 2)) * -1
    tmp39 = einsum(tmp13, (0, 1, 2, 3), t2.abab, (0, 1, 3, 4), (2, 4))
    tmp40 = einsum(t2.bbbb, (0, 1, 2, 3), tmp18, (1, 0, 4, 3), (4, 2))
    tmp41 = einsum(tmp15, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp62 = einsum(tmp15, (0, 1), t1.bb, (0, 2), (1, 2)) * 0.5
    tmp102 = np.copy(tmp51)
    tmp102 += tmp50 * 4
    tmp35 = einsum(t2.abab, (0, 1, 2, 3), l1.aa, (2, 0), (1, 3))
    tmp36 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2))
    tmp49 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 4), (4, 0, 1, 2))
    tmp21 = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2))
    tmp20 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 1), (0, 2))
    tmp58 = einsum(tmp13, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 1, 2, 5))
    tmp59 = einsum(t2.abab, (0, 1, 2, 3), tmp18, (4, 1, 5, 3), (0, 4, 5, 2)) * -1
    tmp27 = einsum(t2.abab, (0, 1, 2, 3), tmp26, (0, 4, 1, 3), (4, 2))
    tmp25 = einsum(tmp6, (0, 1, 2, 3), t2.aaaa, (1, 0, 4, 3), (2, 4))
    tmp28 = einsum(t1.aa, (0, 1), tmp4, (0, 2), (2, 1)) * 2
    tmp45 = np.copy(tmp12)
    tmp45 += tmp14
    tmp44 = einsum(t2.abab, (0, 1, 2, 3), tmp6, (4, 0, 5, 2), (4, 5, 1, 3)) * -1
    tmp43 = einsum(t2.bbbb, (0, 1, 2, 3), tmp26, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp33 = np.copy(np.transpose(tmp5, (1, 0, 3, 2)))
    tmp33 += np.transpose(tmp7, (0, 1, 3, 2)) * -1
    tmp24 = einsum(l1.aa, (0, 1), t2.aaaa, (2, 3, 4, 0), (1, 2, 3, 4))
    tmp79 = np.copy(tmp31) * 4
    tmp79 += tmp30
    tmp55 = einsum(t1.aa, (0, 1), tmp4, (0, 2), (2, 1))
    tmp132 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 5, 0, 1), (4, 5, 2, 3))
    tmp130 = einsum(l2.bbbb, (0, 1, 2, 3), t1.bb, (3, 4), (2, 0, 1, 4))
    tmp129 = einsum(l2.abab, (0, 1, 2, 3), t1.bb, (3, 4), (2, 0, 1, 4))
    tmp128 = einsum(t1.aa, (0, 1), l2.aaaa, (2, 3, 4, 0), (4, 2, 3, 1))
    tmp131 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 5, 0, 1), (4, 5, 2, 3))
    tmp114 = np.copy(tmp107)
    tmp114 += tmp81
    tmp114 += tmp82 * 2
    tmp127 = einsum(tmp110, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 3, 4)) * -1
    tmp126 = einsum(t2.bbbb, (0, 1, 2, 3), tmp18, (1, 0, 4, 5), (4, 5, 2, 3)) * -1
    tmp123 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (4, 1), (0, 4, 2, 3))
    tmp108 = np.copy(tmp107) * 0.5
    del tmp107
    tmp108 += tmp81 * 0.5
    tmp108 += tmp82
    tmp125 = einsum(tmp89, (0, 1, 2, 3), t1.bb, (0, 4), (1, 4, 2, 3))
    tmp105 = np.copy(tmp104)
    tmp105 += tmp64 * 2
    tmp105 += tmp65
    tmp90 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 0, 5), (5, 1, 4, 2))
    tmp86 = np.copy(tmp84)
    tmp86 += tmp85
    tmp115 = einsum(tmp13, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4))
    tmp120 = einsum(tmp6, (0, 1, 2, 3), t2.aaaa, (1, 0, 4, 5), (2, 3, 4, 5)) * -1
    tmp116 = einsum(l1.aa, (0, 1), t2.aaaa, (2, 1, 3, 4), (2, 0, 3, 4))
    tmp121 = einsum(t1.aa, (0, 1), tmp106, (0, 2, 3, 4), (2, 3, 4, 1)) * -1
    tmp119 = einsum(t1.aa, (0, 1), tmp118, (0, 2, 3, 4), (2, 1, 3, 4))
    del tmp118
    tmp124 = np.copy(tmp87) * 0.25
    tmp124 += tmp88
    tmp109 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 5, 1), (5, 0, 4, 3))
    tmp122 = np.copy(tmp112)
    tmp122 += tmp67
    tmp113 = einsum(t1.aa, (0, 1), tmp26, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp117 = np.copy(tmp69) * 4
    tmp117 += tmp71
    tmp111 = np.copy(tmp104) * 0.5
    del tmp104
    tmp111 += tmp64
    tmp111 += tmp65 * 0.5
    tmp101 = einsum(t1.bb, (0, 1), tmp52, (0, 2, 3, 4), (2, 4, 3, 1))
    tmp94 = einsum(t2.bbbb, (0, 1, 2, 3), tmp88, (1, 4, 3, 5), (0, 4, 2, 5))
    tmp42 = np.copy(tmp39)
    tmp42 += tmp40 * 2
    tmp42 += tmp41
    del tmp41
    tmp63 = np.copy(tmp39) * 0.5
    del tmp39
    tmp63 += tmp40
    del tmp40
    tmp63 += tmp62
    del tmp62
    tmp103 = einsum(t1.bb, (0, 1), tmp102, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp102
    tmp96 = einsum(t2.abab, (0, 1, 2, 3), tmp85, (0, 4, 2, 5), (1, 4, 3, 5))
    tmp100 = einsum(tmp52, (0, 1, 2, 3), t2.bbbb, (0, 1, 4, 5), (2, 3, 4, 5))
    tmp93 = np.copy(tmp81) * 0.5
    tmp93 += tmp82
    tmp83 = np.copy(tmp81)
    del tmp81
    tmp83 += tmp82 * 2
    del tmp82
    tmp99 = einsum(tmp15, (0, 1), t2.bbbb, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    tmp37 = np.copy(t1.bb)
    tmp37 += tmp35
    tmp37 += tmp36 * 2
    tmp98 = einsum(tmp49, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3))
    tmp95 = einsum(tmp84, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5))
    tmp48 = np.copy(t1.bb) * 0.5
    tmp48 += tmp35 * 0.5
    tmp48 += tmp36
    tmp97 = np.copy(tmp35)
    tmp97 += tmp36 * 2
    tmp73 = np.copy(tmp20) * 2
    tmp73 += tmp21
    tmp47 = einsum(tmp13, (0, 1, 2, 3), t2.abab, (4, 1, 3, 5), (0, 4, 2, 5))
    tmp60 = einsum(tmp26, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (1, 2, 4, 5))
    tmp38 = einsum(t2.abab, (0, 1, 2, 3), l1.aa, (2, 4), (4, 0, 1, 3))
    tmp92 = np.copy(tmp58)
    tmp92 += tmp59
    tmp29 = np.copy(tmp25) * 2
    tmp29 += tmp27
    tmp29 += tmp28
    del tmp28
    tmp46 = einsum(tmp45, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 3, 4))
    tmp91 = np.copy(tmp44)
    tmp91 += tmp43
    tmp57 = einsum(l1.bb, (0, 1), t2.abab, (2, 3, 4, 0), (2, 1, 3, 4))
    tmp75 = np.copy(tmp64) * 2
    tmp75 += tmp65
    tmp23 = np.copy(t1.aa)
    tmp23 += tmp20 * 2
    tmp23 += tmp21
    tmp22 = np.copy(t1.aa)
    tmp22 += tmp20 * 2
    tmp22 += tmp21
    tmp78 = einsum(tmp33, (0, 1, 2, 3), t1.aa, (0, 4), (1, 3, 2, 4))
    tmp74 = einsum(tmp24, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    tmp80 = einsum(tmp79, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    del tmp79
    tmp76 = einsum(tmp4, (0, 1), t2.aaaa, (2, 0, 3, 4), (1, 2, 3, 4)) * -2
    tmp66 = np.copy(tmp64)
    del tmp64
    tmp66 += tmp65 * 0.5
    del tmp65
    tmp77 = einsum(tmp33, (0, 1, 2, 3), t2.aaaa, (0, 1, 4, 5), (2, 3, 4, 5))
    tmp70 = einsum(t2.aaaa, (0, 1, 2, 3), tmp69, (1, 4, 3, 5), (4, 0, 5, 2))
    tmp72 = einsum(tmp71, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (4, 1, 5, 3))
    tmp68 = einsum(t2.abab, (0, 1, 2, 3), tmp67, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp53 = einsum(t1.bb, (0, 1), tmp52, (0, 2, 3, 4), (2, 3, 4, 1)) * 2
    del tmp52
    tmp16 = np.copy(tmp8) * 0.5
    tmp16 += tmp9 * 0.5
    tmp16 += tmp10
    tmp61 = np.copy(t1.bb)
    tmp61 += tmp35
    del tmp35
    tmp61 += tmp36 * 2
    del tmp36
    tmp56 = np.copy(tmp25)
    del tmp25
    tmp56 += tmp27 * 0.5
    del tmp27
    tmp56 += tmp55
    del tmp55
    tmp32 = np.copy(tmp0)
    tmp32 += tmp1 * 2
    tmp32 += tmp2
    tmp54 = np.copy(t1.aa) * 0.5
    tmp54 += tmp20
    del tmp20
    tmp54 += tmp21 * 0.5
    del tmp21
    tmp34 = einsum(t1.aa, (0, 1), tmp33, (0, 2, 3, 4), (2, 3, 4, 1)) * 2
    del tmp33
    tmp11 = np.copy(delta.bb.oo) * -1
    tmp11 += tmp8
    del tmp8
    tmp11 += tmp9
    del tmp9
    tmp11 += tmp10 * 2
    del tmp10
    tmp3 = np.copy(delta.aa.oo) * -1
    tmp3 += tmp0
    del tmp0
    tmp3 += tmp1 * 2
    del tmp1
    tmp3 += tmp2
    del tmp2
    rdm2.bbbb.vvvv = np.copy(np.transpose(tmp132, (1, 0, 3, 2))) * 2
    del tmp132
    rdm2.bbbb.vvvv += einsum(tmp130, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3)) * 2
    rdm2.abab.vvvv = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 5, 0, 1), (4, 5, 2, 3))
    rdm2.abab.vvvv += einsum(t1.aa, (0, 1), tmp129, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.aaaa.vvvv = np.copy(np.transpose(tmp131, (1, 0, 3, 2))) * 2
    del tmp131
    rdm2.aaaa.vvvv += einsum(tmp128, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * 2
    rdm2.bbbb.vvvo = np.copy(np.transpose(tmp130, (2, 1, 3, 0))) * 2
    rdm2.abab.vvvo = einsum(t1.aa, (0, 1), l2.abab, (2, 3, 0, 4), (2, 3, 1, 4))
    rdm2.aaaa.vvvo = np.copy(np.transpose(tmp128, (2, 1, 3, 0))) * 2
    rdm2.bbbb.vvov = np.copy(np.transpose(tmp130, (2, 1, 0, 3))) * -2
    del tmp130
    rdm2.abab.vvov = np.copy(np.transpose(tmp129, (1, 2, 0, 3)))
    del tmp129
    rdm2.aaaa.vvov = np.copy(np.transpose(tmp128, (2, 1, 0, 3))) * -2
    del tmp128
    rdm2.bbbb.vovv = np.copy(np.transpose(tmp123, (1, 0, 3, 2))) * 2
    rdm2.bbbb.vovv += einsum(tmp108, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.bbbb.vovv += einsum(tmp114, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.vovv += np.transpose(tmp125, (2, 0, 1, 3))
    rdm2.bbbb.vovv += np.transpose(tmp125, (2, 0, 3, 1)) * -1
    rdm2.bbbb.vovv += np.transpose(tmp126, (1, 0, 3, 2)) * 2
    rdm2.bbbb.vovv += np.transpose(tmp127, (1, 0, 3, 2)) * 2
    rdm2.abab.vovv = einsum(t2.abab, (0, 1, 2, 3), l1.aa, (4, 0), (4, 1, 2, 3))
    rdm2.abab.vovv += einsum(tmp105, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.abab.vovv += einsum(tmp86, (0, 1, 2, 3), t1.aa, (0, 4), (2, 1, 4, 3)) * 2
    rdm2.abab.vovv += einsum(tmp90, (0, 1, 2, 3), t1.bb, (0, 4), (2, 1, 3, 4)) * -1
    rdm2.abab.vovv += einsum(tmp13, (0, 1, 2, 3), t2.abab, (0, 1, 4, 5), (3, 2, 4, 5)) * -1
    rdm2.abab.vovv += einsum(t1.aa, (0, 1), tmp115, (0, 2, 3, 4), (3, 2, 1, 4)) * -1
    rdm2.aaaa.vovv = np.copy(np.transpose(tmp116, (1, 0, 3, 2))) * 2
    rdm2.aaaa.vovv += einsum(t1.aa, (0, 1), tmp105, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.vovv += einsum(tmp105, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.vovv += np.transpose(tmp119, (2, 0, 1, 3))
    rdm2.aaaa.vovv += np.transpose(tmp119, (2, 0, 3, 1)) * -1
    rdm2.aaaa.vovv += np.transpose(tmp120, (1, 0, 3, 2)) * 2
    rdm2.aaaa.vovv += np.transpose(tmp121, (1, 0, 3, 2)) * 2
    rdm2.bbbb.ovvv = np.copy(np.transpose(tmp123, (0, 1, 3, 2))) * -2
    del tmp123
    rdm2.bbbb.ovvv += einsum(tmp108, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.bbbb.ovvv += einsum(tmp114, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.ovvv += einsum(tmp124, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3)) * -4
    del tmp124
    rdm2.bbbb.ovvv += np.transpose(tmp125, (0, 2, 3, 1))
    del tmp125
    rdm2.bbbb.ovvv += np.transpose(tmp126, (0, 1, 3, 2)) * -2
    del tmp126
    rdm2.bbbb.ovvv += np.transpose(tmp127, (0, 1, 3, 2)) * -2
    del tmp127
    rdm2.abab.ovvv = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (4, 1), (0, 4, 2, 3))
    rdm2.abab.ovvv += einsum(t1.aa, (0, 1), tmp108, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.abab.ovvv += einsum(t1.aa, (0, 1), tmp109, (0, 2, 3, 4), (2, 3, 1, 4)) * -1
    rdm2.abab.ovvv += einsum(tmp122, (0, 1, 2, 3), t1.bb, (1, 4), (0, 3, 2, 4)) * 2
    del tmp122
    rdm2.abab.ovvv += einsum(t2.abab, (0, 1, 2, 3), tmp26, (0, 4, 1, 5), (4, 5, 2, 3)) * -1
    rdm2.abab.ovvv += einsum(tmp113, (0, 1, 2, 3), t1.bb, (1, 4), (0, 3, 2, 4)) * -1
    rdm2.aaaa.ovvv = np.copy(np.transpose(tmp116, (0, 1, 3, 2))) * -2
    del tmp116
    rdm2.aaaa.ovvv += einsum(t1.aa, (0, 1), tmp105, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.ovvv += einsum(tmp105, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ovvv += einsum(tmp117, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -1
    del tmp117
    rdm2.aaaa.ovvv += np.transpose(tmp119, (0, 2, 3, 1))
    del tmp119
    rdm2.aaaa.ovvv += np.transpose(tmp120, (0, 1, 3, 2)) * -2
    del tmp120
    rdm2.aaaa.ovvv += np.transpose(tmp121, (0, 1, 3, 2)) * -2
    del tmp121
    rdm2.bbbb.vvoo = np.copy(l2.bbbb) * 2
    rdm2.abab.vvoo = np.copy(l2.abab)
    rdm2.aaaa.vvoo = np.copy(l2.aaaa) * 2
    rdm2.bbbb.vovo = einsum(tmp114, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.vovo += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.vovo += np.transpose(tmp88, (2, 1, 3, 0)) * -4
    rdm2.bbbb.vovo += np.transpose(tmp87, (2, 1, 3, 0)) * -1
    rdm2.bbbb.vovo += np.transpose(tmp110, (2, 1, 3, 0)) * 2
    rdm2.abab.vovo = einsum(delta.bb.oo, (0, 1), tmp105, (2, 3), (2, 0, 3, 1))
    rdm2.abab.vovo += np.transpose(tmp90, (2, 1, 3, 0)) * -1
    rdm2.abab.vovo += einsum(tmp13, (0, 1, 2, 3), t1.aa, (0, 4), (3, 2, 4, 1)) * -1
    rdm2.aaaa.vovo = einsum(delta.aa.oo, (0, 1), tmp105, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.vovo += np.transpose(tmp71, (2, 1, 3, 0)) * -1
    rdm2.aaaa.vovo += np.transpose(tmp69, (2, 1, 3, 0)) * -4
    rdm2.aaaa.vovo += einsum(t1.aa, (0, 1), l1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.vovo += np.transpose(tmp106, (2, 1, 3, 0)) * 2
    rdm2.bbbb.voov = einsum(delta.bb.oo, (0, 1), tmp108, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.bbbb.voov += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.voov += np.transpose(tmp88, (2, 1, 0, 3)) * 4
    rdm2.bbbb.voov += np.transpose(tmp87, (2, 1, 0, 3))
    rdm2.bbbb.voov += np.transpose(tmp110, (2, 1, 0, 3)) * -2
    rdm2.abab.voov = np.copy(np.transpose(tmp84, (2, 1, 0, 3))) * 2
    del tmp84
    rdm2.abab.voov += einsum(l1.aa, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.abab.voov += np.transpose(tmp85, (2, 1, 0, 3)) * 2
    del tmp85
    rdm2.abab.voov += np.transpose(tmp115, (2, 1, 0, 3)) * -1
    del tmp115
    rdm2.aaaa.voov = einsum(delta.aa.oo, (0, 1), tmp105, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.voov += np.transpose(tmp71, (2, 1, 0, 3))
    rdm2.aaaa.voov += np.transpose(tmp69, (2, 1, 0, 3)) * 4
    rdm2.aaaa.voov += einsum(t1.aa, (0, 1), l1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.voov += np.transpose(tmp106, (2, 1, 0, 3)) * -2
    rdm2.bbbb.ovvo = einsum(tmp114, (0, 1), delta.bb.oo, (2, 3), (2, 0, 1, 3)) * -1
    del tmp114
    rdm2.bbbb.ovvo += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.ovvo += np.transpose(tmp88, (1, 2, 3, 0)) * 4
    rdm2.bbbb.ovvo += np.transpose(tmp87, (1, 2, 3, 0))
    rdm2.bbbb.ovvo += np.transpose(tmp110, (1, 2, 3, 0)) * -2
    rdm2.abab.ovvo = np.copy(np.transpose(tmp112, (0, 3, 2, 1))) * 2
    del tmp112
    rdm2.abab.ovvo += einsum(t1.aa, (0, 1), l1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.abab.ovvo += np.transpose(tmp67, (0, 3, 2, 1)) * 2
    del tmp67
    rdm2.abab.ovvo += np.transpose(tmp113, (0, 3, 2, 1)) * -1
    del tmp113
    rdm2.aaaa.ovvo = einsum(delta.aa.oo, (0, 1), tmp111, (2, 3), (0, 2, 3, 1)) * -2
    del tmp111
    rdm2.aaaa.ovvo += np.transpose(tmp71, (1, 2, 3, 0))
    rdm2.aaaa.ovvo += np.transpose(tmp69, (1, 2, 3, 0)) * 4
    rdm2.aaaa.ovvo += einsum(t1.aa, (0, 1), l1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.ovvo += np.transpose(tmp106, (1, 2, 3, 0)) * -2
    rdm2.bbbb.ovov = einsum(delta.bb.oo, (0, 1), tmp108, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.bbbb.ovov += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.ovov += np.transpose(tmp88, (1, 2, 0, 3)) * -4
    del tmp88
    rdm2.bbbb.ovov += np.transpose(tmp87, (1, 2, 0, 3)) * -1
    del tmp87
    rdm2.bbbb.ovov += np.transpose(tmp110, (1, 2, 0, 3)) * 2
    del tmp110
    rdm2.abab.ovov = einsum(delta.aa.oo, (0, 1), tmp108, (2, 3), (0, 2, 1, 3)) * 2
    del tmp108
    rdm2.abab.ovov += np.transpose(tmp109, (1, 2, 0, 3)) * -1
    del tmp109
    rdm2.abab.ovov += einsum(tmp26, (0, 1, 2, 3), t1.bb, (2, 4), (1, 3, 0, 4)) * -1
    rdm2.aaaa.ovov = einsum(delta.aa.oo, (0, 1), tmp105, (2, 3), (0, 2, 1, 3))
    del tmp105
    rdm2.aaaa.ovov += np.transpose(tmp71, (1, 2, 0, 3)) * -1
    del tmp71
    rdm2.aaaa.ovov += np.transpose(tmp69, (1, 2, 0, 3)) * -4
    del tmp69
    rdm2.aaaa.ovov += einsum(t1.aa, (0, 1), l1.aa, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.ovov += np.transpose(tmp106, (1, 2, 0, 3)) * 2
    del tmp106
    rdm2.bbbb.oovv = np.copy(t2.bbbb) * 2
    rdm2.bbbb.oovv += einsum(tmp93, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 4, 1)) * -4
    del tmp93
    rdm2.bbbb.oovv += np.transpose(tmp94, (0, 1, 3, 2)) * -8
    rdm2.bbbb.oovv += np.transpose(tmp95, (0, 1, 3, 2)) * -2
    rdm2.bbbb.oovv += np.transpose(tmp96, (0, 1, 3, 2)) * -2
    rdm2.bbbb.oovv += np.transpose(tmp96, (1, 0, 2, 3)) * -2
    rdm2.bbbb.oovv += einsum(tmp48, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.bbbb.oovv += tmp94 * 8
    del tmp94
    rdm2.bbbb.oovv += np.transpose(tmp95, (1, 0, 3, 2)) * 2
    del tmp95
    rdm2.bbbb.oovv += tmp96 * 2
    rdm2.bbbb.oovv += np.transpose(tmp96, (1, 0, 3, 2)) * 2
    del tmp96
    rdm2.bbbb.oovv += einsum(tmp37, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.oovv += einsum(tmp97, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.oovv += einsum(tmp97, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -1
    del tmp97
    rdm2.bbbb.oovv += tmp98 * 2
    rdm2.bbbb.oovv += einsum(tmp83, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 1, 4)) * 2
    rdm2.bbbb.oovv += np.transpose(tmp98, (0, 1, 3, 2)) * -2
    del tmp98
    rdm2.bbbb.oovv += np.transpose(tmp99, (0, 1, 3, 2)) * -2
    rdm2.bbbb.oovv += einsum(tmp63, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.bbbb.oovv += einsum(tmp42, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3))
    rdm2.bbbb.oovv += np.transpose(tmp99, (1, 0, 3, 2)) * 2
    del tmp99
    rdm2.bbbb.oovv += einsum(tmp63, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * 2
    rdm2.bbbb.oovv += einsum(tmp42, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.bbbb.oovv += np.transpose(tmp100, (1, 0, 3, 2)) * 2
    del tmp100
    rdm2.bbbb.oovv += einsum(tmp101, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3)) * 2
    del tmp101
    rdm2.bbbb.oovv += np.transpose(tmp103, (1, 0, 2, 3))
    rdm2.bbbb.oovv += tmp103 * -1
    rdm2.bbbb.oovv += np.transpose(tmp103, (1, 0, 3, 2)) * -1
    rdm2.bbbb.oovv += np.transpose(tmp103, (0, 1, 3, 2))
    del tmp103
    rdm2.abab.oovv = np.copy(t2.abab)
    rdm2.abab.oovv += einsum(tmp83, (0, 1), t2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -1
    del tmp83
    rdm2.abab.oovv += einsum(tmp86, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (4, 1, 5, 3)) * 4
    del tmp86
    rdm2.abab.oovv += einsum(tmp89, (0, 1, 2, 3), t2.abab, (4, 0, 5, 2), (4, 1, 5, 3))
    del tmp89
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp37, (2, 3), (0, 2, 1, 3))
    rdm2.abab.oovv += einsum(tmp73, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.abab.oovv += einsum(tmp38, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -1
    rdm2.abab.oovv += einsum(tmp75, (0, 1), t2.abab, (2, 3, 0, 4), (2, 3, 1, 4)) * -1
    rdm2.abab.oovv += einsum(tmp57, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4)) * -1
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp15, (1, 4), (0, 4, 2, 3)) * -1
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp42, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp4, (0, 4), (4, 1, 2, 3)) * -2
    rdm2.abab.oovv += einsum(tmp45, (0, 1, 2, 3), t2.abab, (0, 2, 4, 5), (1, 3, 4, 5))
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp46, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp90, (1, 4, 2, 5), (0, 4, 5, 3))
    del tmp90
    rdm2.abab.oovv += einsum(tmp29, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.abab.oovv += einsum(tmp47, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp91, (0, 2, 3, 4), (2, 3, 1, 4)) * -2
    del tmp91
    rdm2.abab.oovv += einsum(tmp92, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4)) * -2
    del tmp92
    rdm2.abab.oovv += einsum(tmp60, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4))
    rdm2.aaaa.oovv = np.copy(t2.aaaa) * 2
    rdm2.aaaa.oovv += einsum(tmp66, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 4, 1)) * -4
    del tmp66
    rdm2.aaaa.oovv += np.transpose(tmp68, (0, 1, 3, 2)) * -2
    rdm2.aaaa.oovv += np.transpose(tmp70, (0, 1, 3, 2)) * -8
    rdm2.aaaa.oovv += np.transpose(tmp72, (0, 1, 3, 2)) * -2
    rdm2.aaaa.oovv += np.transpose(tmp72, (1, 0, 2, 3)) * -2
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp22, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.oovv += tmp68 * 2
    del tmp68
    rdm2.aaaa.oovv += tmp70 * 8
    del tmp70
    rdm2.aaaa.oovv += tmp72 * 2
    rdm2.aaaa.oovv += np.transpose(tmp72, (1, 0, 3, 2)) * 2
    del tmp72
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp23, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.oovv += einsum(tmp73, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp73, (2, 3), (0, 2, 3, 1)) * -1
    del tmp73
    rdm2.aaaa.oovv += tmp74 * 2
    rdm2.aaaa.oovv += einsum(t2.aaaa, (0, 1, 2, 3), tmp75, (3, 4), (0, 1, 4, 2)) * 2
    del tmp75
    rdm2.aaaa.oovv += np.transpose(tmp74, (0, 1, 3, 2)) * -2
    del tmp74
    rdm2.aaaa.oovv += np.transpose(tmp76, (1, 0, 3, 2)) * -2
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp29, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.aaaa.oovv += einsum(tmp29, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3))
    rdm2.aaaa.oovv += np.transpose(tmp76, (0, 1, 3, 2)) * 2
    del tmp76
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp29, (2, 3), (2, 0, 1, 3))
    rdm2.aaaa.oovv += einsum(tmp29, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.aaaa.oovv += np.transpose(tmp77, (1, 0, 3, 2)) * 2
    del tmp77
    rdm2.aaaa.oovv += einsum(tmp78, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * 2
    del tmp78
    rdm2.aaaa.oovv += np.transpose(tmp80, (1, 0, 2, 3))
    rdm2.aaaa.oovv += tmp80 * -1
    rdm2.aaaa.oovv += np.transpose(tmp80, (1, 0, 3, 2)) * -1
    rdm2.aaaa.oovv += np.transpose(tmp80, (0, 1, 3, 2))
    del tmp80
    rdm2.bbbb.vooo = einsum(l1.bb, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.vooo += einsum(delta.bb.oo, (0, 1), l1.bb, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.vooo += np.transpose(tmp18, (3, 2, 1, 0)) * 2
    rdm2.abab.vooo = einsum(delta.bb.oo, (0, 1), l1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.abab.vooo += np.transpose(tmp13, (3, 2, 0, 1)) * -1
    del tmp13
    rdm2.aaaa.vooo = einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.vooo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.vooo += np.transpose(tmp6, (3, 2, 1, 0)) * 2
    rdm2.bbbb.ovoo = einsum(l1.bb, (0, 1), delta.bb.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.ovoo += einsum(delta.bb.oo, (0, 1), l1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.ovoo += np.transpose(tmp18, (2, 3, 1, 0)) * -2
    del tmp18
    rdm2.abab.ovoo = einsum(delta.aa.oo, (0, 1), l1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.abab.ovoo += np.transpose(tmp26, (1, 3, 0, 2)) * -1
    del tmp26
    rdm2.aaaa.ovoo = einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.ovoo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.ovoo += np.transpose(tmp6, (2, 3, 1, 0)) * -2
    del tmp6
    rdm2.bbbb.oovo = einsum(delta.bb.oo, (0, 1), tmp61, (2, 3), (2, 0, 3, 1))
    del tmp61
    rdm2.bbbb.oovo += einsum(tmp37, (0, 1), delta.bb.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.oovo += np.transpose(tmp49, (2, 1, 3, 0)) * 2
    rdm2.bbbb.oovo += einsum(delta.bb.oo, (0, 1), tmp63, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.bbbb.oovo += einsum(tmp63, (0, 1), delta.bb.oo, (2, 3), (2, 0, 1, 3)) * 2
    del tmp63
    rdm2.bbbb.oovo += np.transpose(tmp50, (1, 2, 3, 0)) * 4
    rdm2.bbbb.oovo += np.transpose(tmp51, (1, 2, 3, 0))
    rdm2.bbbb.oovo += einsum(tmp16, (0, 1), t1.bb, (2, 3), (1, 2, 3, 0)) * 2
    rdm2.bbbb.oovo += np.transpose(tmp50, (2, 1, 3, 0)) * -4
    rdm2.bbbb.oovo += np.transpose(tmp51, (2, 1, 3, 0)) * -1
    rdm2.bbbb.oovo += einsum(tmp16, (0, 1), t1.bb, (2, 3), (2, 1, 3, 0)) * -2
    rdm2.bbbb.oovo += np.transpose(tmp53, (2, 1, 3, 0)) * -1
    rdm2.abab.oovo = einsum(delta.bb.oo, (0, 1), tmp22, (2, 3), (2, 0, 3, 1))
    rdm2.abab.oovo += np.transpose(tmp57, (0, 2, 3, 1)) * -1
    del tmp57
    rdm2.abab.oovo += einsum(delta.bb.oo, (0, 1), tmp56, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.abab.oovo += np.transpose(tmp58, (0, 2, 3, 1)) * -2
    del tmp58
    rdm2.abab.oovo += np.transpose(tmp59, (0, 2, 3, 1)) * -2
    del tmp59
    rdm2.abab.oovo += einsum(t1.aa, (0, 1), tmp15, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.abab.oovo += einsum(t1.aa, (0, 1), tmp45, (0, 2, 3, 4), (2, 4, 1, 3))
    del tmp45
    rdm2.abab.oovo += np.transpose(tmp60, (0, 2, 3, 1))
    del tmp60
    rdm2.aaaa.oovo = einsum(tmp54, (0, 1), delta.aa.oo, (2, 3), (0, 2, 1, 3)) * 2
    del tmp54
    rdm2.aaaa.oovo += einsum(tmp23, (0, 1), delta.aa.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.oovo += np.transpose(tmp24, (2, 1, 3, 0)) * 2
    rdm2.aaaa.oovo += einsum(tmp56, (0, 1), delta.aa.oo, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.aaaa.oovo += einsum(tmp56, (0, 1), delta.aa.oo, (2, 3), (2, 0, 1, 3)) * 2
    del tmp56
    rdm2.aaaa.oovo += np.transpose(tmp30, (1, 2, 3, 0))
    rdm2.aaaa.oovo += np.transpose(tmp31, (1, 2, 3, 0)) * 4
    rdm2.aaaa.oovo += einsum(tmp32, (0, 1), t1.aa, (2, 3), (1, 2, 3, 0))
    rdm2.aaaa.oovo += np.transpose(tmp30, (2, 1, 3, 0)) * -1
    rdm2.aaaa.oovo += np.transpose(tmp31, (2, 1, 3, 0)) * -4
    rdm2.aaaa.oovo += einsum(t1.aa, (0, 1), tmp32, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.aaaa.oovo += np.transpose(tmp34, (2, 1, 3, 0)) * -1
    rdm2.bbbb.ooov = einsum(delta.bb.oo, (0, 1), tmp48, (2, 3), (2, 0, 1, 3)) * -2
    del tmp48
    rdm2.bbbb.ooov += einsum(tmp37, (0, 1), delta.bb.oo, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.ooov += np.transpose(tmp49, (2, 1, 0, 3)) * -2
    del tmp49
    rdm2.bbbb.ooov += einsum(delta.bb.oo, (0, 1), tmp42, (2, 3), (2, 0, 1, 3))
    rdm2.bbbb.ooov += einsum(tmp42, (0, 1), delta.bb.oo, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.bbbb.ooov += np.transpose(tmp50, (1, 2, 0, 3)) * -4
    rdm2.bbbb.ooov += np.transpose(tmp51, (1, 2, 0, 3)) * -1
    rdm2.bbbb.ooov += einsum(tmp15, (0, 1), t1.bb, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.bbbb.ooov += np.transpose(tmp50, (2, 1, 0, 3)) * 4
    del tmp50
    rdm2.bbbb.ooov += np.transpose(tmp51, (2, 1, 0, 3))
    del tmp51
    rdm2.bbbb.ooov += einsum(tmp15, (0, 1), t1.bb, (2, 3), (2, 1, 0, 3))
    rdm2.bbbb.ooov += np.transpose(tmp53, (2, 1, 0, 3))
    del tmp53
    rdm2.abab.ooov = einsum(tmp37, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    del tmp37
    rdm2.abab.ooov += np.transpose(tmp38, (1, 2, 0, 3)) * -1
    del tmp38
    rdm2.abab.ooov += einsum(delta.aa.oo, (0, 1), tmp42, (2, 3), (0, 2, 1, 3)) * -1
    del tmp42
    rdm2.abab.ooov += np.transpose(tmp43, (1, 2, 0, 3)) * -2
    del tmp43
    rdm2.abab.ooov += np.transpose(tmp44, (1, 2, 0, 3)) * -2
    del tmp44
    rdm2.abab.ooov += einsum(tmp32, (0, 1), t1.bb, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.abab.ooov += np.transpose(tmp46, (1, 2, 0, 3))
    del tmp46
    rdm2.abab.ooov += np.transpose(tmp47, (1, 2, 0, 3))
    del tmp47
    rdm2.aaaa.ooov = einsum(delta.aa.oo, (0, 1), tmp22, (2, 3), (2, 0, 1, 3)) * -1
    del tmp22
    rdm2.aaaa.ooov += einsum(tmp23, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    del tmp23
    rdm2.aaaa.ooov += np.transpose(tmp24, (2, 1, 0, 3)) * -2
    del tmp24
    rdm2.aaaa.ooov += einsum(tmp29, (0, 1), delta.aa.oo, (2, 3), (0, 2, 3, 1))
    rdm2.aaaa.ooov += einsum(tmp29, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1)) * -1
    del tmp29
    rdm2.aaaa.ooov += np.transpose(tmp30, (1, 2, 0, 3)) * -1
    rdm2.aaaa.ooov += np.transpose(tmp31, (1, 2, 0, 3)) * -4
    rdm2.aaaa.ooov += einsum(tmp32, (0, 1), t1.aa, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.aaaa.ooov += np.transpose(tmp30, (2, 1, 0, 3))
    del tmp30
    rdm2.aaaa.ooov += np.transpose(tmp31, (2, 1, 0, 3)) * 4
    del tmp31
    rdm2.aaaa.ooov += einsum(t1.aa, (0, 1), tmp32, (2, 3), (0, 3, 2, 1))
    del tmp32
    rdm2.aaaa.ooov += np.transpose(tmp34, (2, 1, 0, 3))
    del tmp34
    rdm2.bbbb.oooo = einsum(tmp11, (0, 1), delta.bb.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.bbbb.oooo += einsum(tmp11, (0, 1), delta.bb.oo, (2, 3), (1, 2, 3, 0))
    rdm2.bbbb.oooo += einsum(delta.bb.oo, (0, 1), tmp15, (2, 3), (3, 0, 2, 1)) * -1
    del tmp15
    rdm2.bbbb.oooo += einsum(tmp16, (0, 1), delta.bb.oo, (2, 3), (2, 1, 0, 3)) * 2
    del tmp16
    rdm2.bbbb.oooo += np.transpose(tmp17, (3, 2, 1, 0)) * 2
    del tmp17
    rdm2.bbbb.oooo += np.transpose(tmp19, (2, 3, 1, 0)) * -2
    del tmp19
    rdm2.abab.oooo = einsum(delta.aa.oo, (0, 1), tmp11, (2, 3), (0, 3, 1, 2)) * -1
    del tmp11
    rdm2.abab.oooo += einsum(delta.bb.oo, (0, 1), tmp4, (2, 3), (3, 0, 2, 1)) * -2
    rdm2.abab.oooo += np.transpose(tmp12, (1, 3, 0, 2))
    del tmp12
    rdm2.abab.oooo += np.transpose(tmp14, (1, 3, 0, 2))
    del tmp14
    rdm2.aaaa.oooo = einsum(delta.aa.oo, (0, 1), tmp3, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp3, (2, 3), (3, 0, 1, 2))
    del tmp3
    rdm2.aaaa.oooo += einsum(tmp4, (0, 1), delta.aa.oo, (2, 3), (1, 2, 0, 3)) * -2
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp4, (2, 3), (0, 3, 2, 1)) * 2
    del tmp4, delta
    rdm2.aaaa.oooo += np.transpose(tmp5, (3, 2, 1, 0)) * 2
    del tmp5
    rdm2.aaaa.oooo += np.transpose(tmp7, (2, 3, 1, 0)) * -2
    del tmp7
    rdm2.aaaa = pack_2e(rdm2.aaaa.oooo, rdm2.aaaa.ooov, rdm2.aaaa.oovo, rdm2.aaaa.ovoo, rdm2.aaaa.vooo, rdm2.aaaa.oovv, rdm2.aaaa.ovov, rdm2.aaaa.ovvo, rdm2.aaaa.voov, rdm2.aaaa.vovo, rdm2.aaaa.vvoo, rdm2.aaaa.ovvv, rdm2.aaaa.vovv, rdm2.aaaa.vvov, rdm2.aaaa.vvvo, rdm2.aaaa.vvvv)
    rdm2.abab = pack_2e(rdm2.abab.oooo, rdm2.abab.ooov, rdm2.abab.oovo, rdm2.abab.ovoo, rdm2.abab.vooo, rdm2.abab.oovv, rdm2.abab.ovov, rdm2.abab.ovvo, rdm2.abab.voov, rdm2.abab.vovo, rdm2.abab.vvoo, rdm2.abab.ovvv, rdm2.abab.vovv, rdm2.abab.vvov, rdm2.abab.vvvo, rdm2.abab.vvvv)
    rdm2.bbbb = pack_2e(rdm2.bbbb.oooo, rdm2.bbbb.ooov, rdm2.bbbb.oovo, rdm2.bbbb.ovoo, rdm2.bbbb.vooo, rdm2.bbbb.oovv, rdm2.bbbb.ovov, rdm2.bbbb.ovvo, rdm2.bbbb.voov, rdm2.bbbb.vovo, rdm2.bbbb.vvoo, rdm2.bbbb.ovvv, rdm2.bbbb.vovv, rdm2.bbbb.vvov, rdm2.bbbb.vvvo, rdm2.bbbb.vvvv)
    rdm2 = Namespace(
        aaaa=np.transpose(rdm2.aaaa, (0, 2, 1, 3)),
        aabb=np.transpose(rdm2.abab, (0, 2, 1, 3)),
        bbbb=np.transpose(rdm2.bbbb, (0, 2, 1, 3)),
    )

    return rdm2

def hbar_matvec_ip_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:39:25.611137.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp102 : array
    tmp104 : array
    tmp107 : array
    tmp108 : array
    tmp109 : array
    tmp11 : array
    tmp117 : array
    tmp118 : array
    tmp12 : array
    tmp121 : array
    tmp13 : array
    tmp131 : array
    tmp134 : array
    tmp135 : array
    tmp137 : array
    tmp138 : array
    tmp139 : array
    tmp141 : array
    tmp143 : array
    tmp145 : array
    tmp147 : array
    tmp149 : array
    tmp15 : array
    tmp151 : array
    tmp152 : array
    tmp154 : array
    tmp155 : array
    tmp156 : array
    tmp157 : array
    tmp158 : array
    tmp16 : array
    tmp160 : array
    tmp162 : array
    tmp165 : array
    tmp166 : array
    tmp167 : array
    tmp170 : array
    tmp176 : array
    tmp178 : array
    tmp18 : array
    tmp184 : array
    tmp186 : array
    tmp188 : array
    tmp198 : array
    tmp20 : array
    tmp22 : array
    tmp24 : array
    tmp25 : array
    tmp26 : array
    tmp28 : array
    tmp31 : array
    tmp32 : array
    tmp33 : array
    tmp37 : array
    tmp39 : array
    tmp4 : array
    tmp41 : array
    tmp43 : array
    tmp45 : array
    tmp46 : array
    tmp47 : array
    tmp49 : array
    tmp5 : array
    tmp52 : array
    tmp53 : array
    tmp54 : array
    tmp56 : array
    tmp59 : array
    tmp6 : array
    tmp62 : array
    tmp63 : array
    tmp65 : array
    tmp66 : array
    tmp67 : array
    tmp69 : array
    tmp7 : array
    tmp71 : array
    tmp73 : array
    tmp75 : array
    tmp77 : array
    tmp79 : array
    tmp81 : array
    tmp83 : array
    tmp85 : array
    tmp87 : array
    tmp89 : array
    tmp9 : array
    tmp96 : array
    """

    tmp28 = einsum(t1.bb, (0, 1), f.bb.ov, (2, 1), (2, 0))
    tmp1 = einsum(t1.aa, (0, 1), f.aa.ov, (2, 1), (2, 0))
    tmp15 = einsum(t1.aa, (0, 1), v.aabb.ovov, (0, 1, 2, 3), (2, 3))
    tmp12 = einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 3, 0, 1), (2, 3))
    tmp11 = einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 1, 0, 3), (2, 3))
    tmp13 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp9 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    tmp7 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 1), (0, 3))
    tmp198 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp188 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovoo, (0, 2, 4, 5), (1, 4, 5, 3))
    tmp186 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp184 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp178 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    tmp176 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.bbbb, (4, 5, 3, 1), (4, 5, 0, 2)) * -1
    tmp170 = einsum(tmp28, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp167 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovvv, (0, 2, 4, 3), (1, 4))
    tmp166 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.bbbb, (4, 0, 3, 1), (4, 2)) * -1
    tmp165 = einsum(f.bb.vv, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp162 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp160 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 4), (3, 4))
    tmp158 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (0, 2, 4, 3), (4, 1))
    tmp157 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (4, 3, 1, 5), (4, 0, 2, 5))
    tmp156 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 3, 1, 4), (2, 4))
    tmp155 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 0, 1, 3), (4, 2))
    tmp154 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (4, 2), (4, 0, 1, 3))
    tmp152 = einsum(t1.bb, (0, 1), f.bb.oo, (2, 0), (2, 1))
    tmp151 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 5), (1, 4, 3, 5))
    tmp149 = einsum(t2.bbbb, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp147 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp145 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp143 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 4, 1, 5))
    tmp141 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 1, 5), (0, 4, 3, 5))
    tmp139 = einsum(t2.bbbb, (0, 1, 2, 3), v.aabb.ooov, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp138 = einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ooov, (4, 5, 0, 2), (4, 5, 1, 3))
    tmp137 = einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ooov, (4, 0, 5, 2), (4, 5, 1, 3))
    tmp135 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp134 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (0, 2), (1, 3))
    tmp131 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovvv, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp121 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 5, 3), (1, 5, 2, 4))
    tmp118 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 0, 5, 3), (4, 1, 5, 2))
    tmp117 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (4, 3), (0, 4, 1, 2))
    tmp109 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 2, 3, 5))
    tmp108 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ooov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp107 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp104 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp102 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 5, 3), (0, 1, 5, 4))
    tmp96 = einsum(t1.aa, (0, 1), tmp1, (0, 2), (2, 1))
    tmp89 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp87 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 2, 5, 3))
    tmp85 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp83 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp81 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp79 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp77 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp75 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 1, 3), (2, 4))
    tmp73 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 4, 3), (4, 1))
    tmp71 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp69 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp67 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp66 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 0, 1, 3), (4, 2))
    tmp65 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 3), (0, 4))
    tmp63 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp62 = einsum(t2.aaaa, (0, 1, 2, 3), f.aa.ov, (1, 3), (0, 2))
    tmp59 = einsum(f.aa.oo, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp56 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp54 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 5, 3, 1), (4, 5, 0, 2)) * -1
    tmp53 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 1, 3), (0, 4))
    tmp52 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 3, 1), (4, 2)) * -1
    tmp49 = einsum(f.aa.vv, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp47 = einsum(tmp15, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp46 = einsum(tmp12, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp45 = einsum(tmp11, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp43 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 3), (1, 4))
    tmp41 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 1, 3), (4, 0))
    tmp39 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 2, 1))
    tmp37 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 2, 1))
    tmp33 = einsum(t1.aa, (0, 1), v.aabb.ovoo, (0, 1, 2, 3), (2, 3))
    tmp32 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp31 = einsum(t1.bb, (0, 1), v.bbbb.ooov, (2, 0, 3, 1), (2, 3))
    tmp26 = einsum(t1.aa, (0, 1), tmp13, (2, 1), (0, 2))
    tmp25 = einsum(t1.aa, (0, 1), tmp9, (2, 1), (0, 2))
    tmp24 = einsum(t1.aa, (0, 1), tmp7, (2, 1), (0, 2))
    tmp22 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp20 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 1, 3), (0, 4))
    tmp18 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp16 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp6 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp5 = einsum(t1.aa, (0, 1), v.aaaa.ooov, (2, 3, 0, 1), (2, 3))
    tmp4 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t1.aa, (1, 3), (0, 2))

    return {f"tmp1": tmp1, f"tmp102": tmp102, f"tmp104": tmp104, f"tmp107": tmp107, f"tmp108": tmp108, f"tmp109": tmp109, f"tmp11": tmp11, f"tmp117": tmp117, f"tmp118": tmp118, f"tmp12": tmp12, f"tmp121": tmp121, f"tmp13": tmp13, f"tmp131": tmp131, f"tmp134": tmp134, f"tmp135": tmp135, f"tmp137": tmp137, f"tmp138": tmp138, f"tmp139": tmp139, f"tmp141": tmp141, f"tmp143": tmp143, f"tmp145": tmp145, f"tmp147": tmp147, f"tmp149": tmp149, f"tmp15": tmp15, f"tmp151": tmp151, f"tmp152": tmp152, f"tmp154": tmp154, f"tmp155": tmp155, f"tmp156": tmp156, f"tmp157": tmp157, f"tmp158": tmp158, f"tmp16": tmp16, f"tmp160": tmp160, f"tmp162": tmp162, f"tmp165": tmp165, f"tmp166": tmp166, f"tmp167": tmp167, f"tmp170": tmp170, f"tmp176": tmp176, f"tmp178": tmp178, f"tmp18": tmp18, f"tmp184": tmp184, f"tmp186": tmp186, f"tmp188": tmp188, f"tmp198": tmp198, f"tmp20": tmp20, f"tmp22": tmp22, f"tmp24": tmp24, f"tmp25": tmp25, f"tmp26": tmp26, f"tmp28": tmp28, f"tmp31": tmp31, f"tmp32": tmp32, f"tmp33": tmp33, f"tmp37": tmp37, f"tmp39": tmp39, f"tmp4": tmp4, f"tmp41": tmp41, f"tmp43": tmp43, f"tmp45": tmp45, f"tmp46": tmp46, f"tmp47": tmp47, f"tmp49": tmp49, f"tmp5": tmp5, f"tmp52": tmp52, f"tmp53": tmp53, f"tmp54": tmp54, f"tmp56": tmp56, f"tmp59": tmp59, f"tmp6": tmp6, f"tmp62": tmp62, f"tmp63": tmp63, f"tmp65": tmp65, f"tmp66": tmp66, f"tmp67": tmp67, f"tmp69": tmp69, f"tmp7": tmp7, f"tmp71": tmp71, f"tmp73": tmp73, f"tmp75": tmp75, f"tmp77": tmp77, f"tmp79": tmp79, f"tmp81": tmp81, f"tmp83": tmp83, f"tmp85": tmp85, f"tmp87": tmp87, f"tmp89": tmp89, f"tmp9": tmp9, f"tmp96": tmp96}

def hbar_matvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:39:25.711584.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp58 = np.copy(f.bb.oo)
    tmp58 += ints.tmp28
    tmp56 = np.copy(ints.tmp143)
    tmp56 += ints.tmp149 * 2
    tmp60 = np.copy(ints.tmp188)
    del ints.tmp188
    tmp60 += ints.tmp186 * 2
    del ints.tmp186
    tmp68 = np.copy(ints.tmp41) * 2
    tmp68 += ints.tmp43
    tmp70 = np.copy(ints.tmp184)
    del ints.tmp184
    tmp70 += np.transpose(v.bbbb.ooov, (0, 2, 1, 3)) * 0.5
    tmp66 = np.copy(ints.tmp147)
    tmp66 += ints.tmp151 * 0.5
    tmp15 = np.copy(ints.tmp67)
    del ints.tmp67
    tmp15 += np.transpose(v.aaaa.ooov, (0, 2, 1, 3)) * 0.5
    tmp11 = np.copy(ints.tmp83)
    tmp11 += ints.tmp87 * 2
    tmp13 = np.copy(ints.tmp20) * 2
    tmp13 += ints.tmp22
    tmp9 = np.copy(ints.tmp79)
    tmp9 += ints.tmp85 * 0.5
    tmp22 = np.copy(f.aa.oo)
    tmp22 += ints.tmp1
    tmp24 = np.copy(ints.tmp71)
    del ints.tmp71
    tmp24 += ints.tmp69 * 2
    del ints.tmp69
    tmp54 = einsum(ints.tmp145, (0, 1, 2, 3), r2.bbb, (4, 1, 3), (0, 4, 2))
    tmp59 = einsum(tmp58, (0, 1), r2.bbb, (2, 0, 3), (2, 1, 3)) * -1
    del tmp58
    tmp55 = einsum(r2.bbb, (0, 1, 2), v.bbbb.ovov, (3, 4, 1, 2), (0, 3, 4))
    tmp57 = einsum(r2.aba, (0, 1, 2), tmp56, (0, 3, 2, 4), (1, 3, 4))
    del tmp56
    tmp61 = einsum(r1.b, (0,), tmp60, (1, 2, 0, 3), (1, 2, 3))
    del tmp60
    tmp49 = einsum(t1.bb, (0, 1), f.bb.ov, (0, 2), (2, 1))
    tmp39 = einsum(r2.aba, (0, 1, 2), v.aabb.ovov, (0, 2, 1, 3), (3,))
    tmp40 = einsum(r2.bbb, (0, 1, 2), v.bbbb.ovov, (0, 2, 1, 3), (3,)) * -1
    tmp69 = einsum(tmp68, (0, 1), r2.bbb, (2, 1, 3), (2, 0, 3)) * -2
    del tmp68
    tmp63 = einsum(r2.aba, (0, 1, 2), ints.tmp141, (0, 3, 2, 4), (3, 1, 4))
    tmp65 = einsum(r2.bbb, (0, 1, 2), v.bbbb.oovv, (3, 1, 4, 2), (0, 3, 4))
    tmp64 = einsum(r2.aba, (0, 1, 2), v.aabb.ovov, (0, 2, 3, 4), (1, 3, 4))
    tmp71 = einsum(tmp70, (0, 1, 2, 3), r1.b, (2,), (0, 1, 3)) * 2
    del tmp70
    tmp67 = einsum(r2.bbb, (0, 1, 2), tmp66, (3, 1, 4, 2), (0, 3, 4)) * -4
    del tmp66
    tmp31 = einsum(r2.bab, (0, 1, 2), v.aabb.ovov, (1, 3, 0, 2), (3,)) * -1
    tmp30 = einsum(r2.aaa, (0, 1, 2), v.aaaa.ovov, (0, 3, 1, 2), (3,))
    tmp28 = einsum(t1.aa, (0, 1), f.aa.ov, (0, 2), (2, 1))
    tmp16 = einsum(r1.a, (0,), tmp15, (1, 2, 0, 3), (1, 2, 3)) * 2
    del tmp15
    tmp12 = einsum(tmp11, (0, 1, 2, 3), r2.bab, (1, 4, 3), (4, 0, 2)) * -1
    del tmp11
    tmp8 = einsum(r2.aaa, (0, 1, 2), v.aaaa.oovv, (3, 1, 4, 2), (0, 3, 4))
    tmp14 = einsum(tmp13, (0, 1), r2.aaa, (2, 1, 3), (2, 0, 3)) * -2
    del tmp13
    tmp10 = einsum(tmp9, (0, 1, 2, 3), r2.aaa, (4, 1, 3), (4, 0, 2)) * -4
    del tmp9
    tmp21 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.bab, (2, 4, 3), (4, 0, 1)) * -1
    tmp23 = einsum(tmp22, (0, 1), r2.aaa, (2, 0, 3), (2, 1, 3)) * -1
    del tmp22
    tmp25 = einsum(r1.a, (0,), tmp24, (1, 2, 0, 3), (1, 2, 3))
    del tmp24
    tmp18 = einsum(ints.tmp77, (0, 1, 2, 3), r2.aaa, (4, 1, 3), (0, 4, 2))
    tmp20 = einsum(r2.bab, (0, 1, 2), ints.tmp81, (3, 0, 4, 2), (3, 1, 4)) * -1
    tmp19 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r2.aaa, (4, 2, 3), (4, 0, 1))
    tmp53 = np.copy(ints.tmp152)
    del ints.tmp152
    tmp53 += ints.tmp155 * 2
    del ints.tmp155
    tmp53 += ints.tmp156
    del ints.tmp156
    tmp53 += ints.tmp166 * 2
    del ints.tmp166
    tmp53 += ints.tmp170
    del ints.tmp170
    tmp53 += f.bb.ov * -1
    tmp53 += ints.tmp134 * -1
    del ints.tmp134
    tmp53 += ints.tmp135 * -2
    del ints.tmp135
    tmp53 += ints.tmp165 * -1
    del ints.tmp165
    tmp53 += ints.tmp167 * -1
    del ints.tmp167
    tmp62 = np.copy(tmp54) * 4
    del tmp54
    tmp62 += tmp55 * 2
    del tmp55
    tmp62 += np.transpose(tmp57, (1, 0, 2))
    del tmp57
    tmp62 += np.transpose(tmp59, (1, 0, 2)) * -2
    del tmp59
    tmp62 += tmp61
    del tmp61
    tmp50 = np.copy(np.transpose(ints.tmp158, (1, 0))) * 2
    del ints.tmp158
    tmp50 += np.transpose(ints.tmp160, (1, 0))
    del ints.tmp160
    tmp50 += f.bb.vv * -1
    tmp50 += tmp49
    del tmp49
    tmp74 = np.copy(tmp39) * -0.5
    tmp74 += tmp40
    tmp73 = np.copy(ints.tmp178)
    del ints.tmp178
    tmp73 += np.transpose(v.bbbb.oooo, (0, 2, 3, 1)) * -1
    tmp75 = np.copy(ints.tmp176)
    del ints.tmp176
    tmp75 += np.transpose(ints.tmp198, (1, 2, 0, 3)) * -1
    del ints.tmp198
    tmp72 = np.copy(tmp63)
    del tmp63
    tmp72 += tmp64
    del tmp64
    tmp72 += tmp65 * 2
    del tmp65
    tmp72 += np.transpose(tmp67, (1, 0, 2)) * -1
    del tmp67
    tmp72 += np.transpose(tmp69, (1, 0, 2))
    del tmp69
    tmp72 += tmp71
    del tmp71
    tmp51 = np.copy(tmp30)
    tmp51 += tmp31 * 0.5
    tmp46 = np.copy(ints.tmp143)
    del ints.tmp143
    tmp46 += ints.tmp149 * 2
    del ints.tmp149
    tmp46 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp46 += ints.tmp141 * -1
    del ints.tmp141
    tmp52 = np.copy(ints.tmp131)
    del ints.tmp131
    tmp52 += ints.tmp138
    del ints.tmp138
    tmp52 += ints.tmp139 * 2
    del ints.tmp139
    tmp52 += np.transpose(ints.tmp154, (1, 0, 2, 3))
    del ints.tmp154
    tmp52 += v.aabb.ooov
    tmp52 += ints.tmp137 * -1
    del ints.tmp137
    tmp52 += ints.tmp157 * -1
    del ints.tmp157
    tmp44 = np.copy(f.bb.oo)
    tmp44 += ints.tmp28
    tmp44 += np.transpose(ints.tmp41, (1, 0)) * 2
    tmp44 += np.transpose(ints.tmp43, (1, 0))
    tmp47 = np.copy(ints.tmp162)
    del ints.tmp162
    tmp47 += v.aabb.oovv * -1
    tmp45 = np.copy(ints.tmp147) * 2
    del ints.tmp147
    tmp45 += ints.tmp151
    del ints.tmp151
    tmp45 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    tmp45 += ints.tmp145 * -2
    del ints.tmp145
    tmp45 += v.bbbb.oovv * -1
    tmp48 = np.copy(ints.tmp104)
    tmp48 += v.aabb.oooo
    tmp43 = np.copy(f.aa.oo)
    tmp43 += ints.tmp1
    tmp43 += np.transpose(ints.tmp20, (1, 0)) * 2
    tmp43 += np.transpose(ints.tmp22, (1, 0))
    tmp36 = np.copy(ints.tmp83)
    del ints.tmp83
    tmp36 += ints.tmp87 * 2
    del ints.tmp87
    tmp36 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp36 += ints.tmp81 * -1
    del ints.tmp81
    tmp41 = np.copy(tmp39) * -1
    del tmp39
    tmp41 += tmp40 * 2
    del tmp40
    tmp42 = np.copy(ints.tmp102)
    del ints.tmp102
    tmp42 += ints.tmp108
    del ints.tmp108
    tmp42 += ints.tmp109 * 2
    del ints.tmp109
    tmp42 += np.transpose(ints.tmp117, (0, 2, 1, 3))
    del ints.tmp117
    tmp42 += np.transpose(v.aabb.ovoo, (0, 2, 3, 1))
    tmp42 += ints.tmp107 * -1
    del ints.tmp107
    tmp42 += ints.tmp118 * -1
    del ints.tmp118
    tmp38 = np.copy(ints.tmp104)
    del ints.tmp104
    tmp38 += v.aabb.oooo
    tmp35 = np.copy(ints.tmp79) * 2
    del ints.tmp79
    tmp35 += ints.tmp85
    del ints.tmp85
    tmp35 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp35 += ints.tmp77 * -2
    del ints.tmp77
    tmp35 += v.aaaa.oovv * -1
    tmp34 = np.copy(ints.tmp52) * 2
    del ints.tmp52
    tmp34 += ints.tmp59
    del ints.tmp59
    tmp34 += ints.tmp65 * 2
    del ints.tmp65
    tmp34 += ints.tmp66
    del ints.tmp66
    tmp34 += ints.tmp96
    del ints.tmp96
    tmp34 += f.aa.ov * -1
    tmp34 += ints.tmp49 * -1
    del ints.tmp49
    tmp34 += ints.tmp53 * -1
    del ints.tmp53
    tmp34 += ints.tmp62 * -2
    del ints.tmp62
    tmp34 += ints.tmp63 * -1
    del ints.tmp63
    tmp37 = np.copy(ints.tmp121)
    del ints.tmp121
    tmp37 += np.transpose(v.aabb.vvoo, (2, 3, 0, 1)) * -1
    tmp29 = np.copy(np.transpose(ints.tmp73, (1, 0))) * 2
    del ints.tmp73
    tmp29 += np.transpose(ints.tmp75, (1, 0))
    del ints.tmp75
    tmp29 += f.aa.vv * -1
    tmp29 += tmp28
    del tmp28
    tmp32 = np.copy(tmp30) * 2
    del tmp30
    tmp32 += tmp31
    del tmp31
    tmp27 = np.copy(ints.tmp56)
    del ints.tmp56
    tmp27 += np.transpose(v.aaaa.oooo, (0, 2, 3, 1)) * -1
    tmp17 = np.copy(tmp8) * 2
    del tmp8
    tmp17 += np.transpose(tmp10, (1, 0, 2)) * -1
    del tmp10
    tmp17 += np.transpose(tmp12, (1, 0, 2))
    del tmp12
    tmp17 += np.transpose(tmp14, (1, 0, 2))
    del tmp14
    tmp17 += tmp16
    del tmp16
    tmp33 = np.copy(ints.tmp54)
    del ints.tmp54
    tmp33 += np.transpose(ints.tmp89, (1, 2, 0, 3)) * -1
    del ints.tmp89
    tmp26 = np.copy(tmp18) * 4
    del tmp18
    tmp26 += tmp19 * 2
    del tmp19
    tmp26 += tmp20
    del tmp20
    tmp26 += tmp21
    del tmp21
    tmp26 += np.transpose(tmp23, (1, 0, 2)) * -2
    del tmp23
    tmp26 += tmp25
    del tmp25
    tmp7 = np.copy(f.bb.oo)
    tmp7 += ints.tmp28
    del ints.tmp28
    tmp7 += np.transpose(ints.tmp32, (1, 0))
    del ints.tmp32
    tmp7 += np.transpose(ints.tmp33, (1, 0))
    del ints.tmp33
    tmp7 += np.transpose(ints.tmp41, (1, 0)) * 2
    del ints.tmp41
    tmp7 += np.transpose(ints.tmp43, (1, 0))
    del ints.tmp43
    tmp7 += np.transpose(ints.tmp46, (1, 0))
    del ints.tmp46
    tmp7 += np.transpose(ints.tmp47, (1, 0))
    del ints.tmp47
    tmp7 += np.transpose(ints.tmp31, (1, 0)) * -1
    del ints.tmp31
    tmp7 += np.transpose(ints.tmp45, (1, 0)) * -1
    del ints.tmp45
    tmp3 = np.copy(f.aa.ov)
    tmp3 += ints.tmp13
    del ints.tmp13
    tmp3 += ints.tmp9
    del ints.tmp9
    tmp3 += ints.tmp7 * -1
    del ints.tmp7
    tmp5 = np.copy(ints.tmp39)
    del ints.tmp39
    tmp5 += np.transpose(v.aabb.ovoo, (0, 2, 3, 1))
    tmp2 = np.copy(f.bb.ov)
    tmp2 += ints.tmp12
    del ints.tmp12
    tmp2 += ints.tmp15
    del ints.tmp15
    tmp2 += ints.tmp11 * -1
    del ints.tmp11
    tmp6 = np.copy(ints.tmp37)
    del ints.tmp37
    tmp6 += v.bbbb.ooov * -1
    tmp4 = np.copy(f.aa.oo)
    tmp4 += ints.tmp1
    del ints.tmp1
    tmp4 += np.transpose(ints.tmp20, (1, 0)) * 2
    del ints.tmp20
    tmp4 += np.transpose(ints.tmp22, (1, 0))
    del ints.tmp22
    tmp4 += np.transpose(ints.tmp25, (1, 0))
    del ints.tmp25
    tmp4 += np.transpose(ints.tmp26, (1, 0))
    del ints.tmp26
    tmp4 += np.transpose(ints.tmp5, (1, 0))
    del ints.tmp5
    tmp4 += np.transpose(ints.tmp6, (1, 0))
    del ints.tmp6
    tmp4 += np.transpose(ints.tmp24, (1, 0)) * -1
    del ints.tmp24
    tmp4 += np.transpose(ints.tmp4, (1, 0)) * -1
    del ints.tmp4
    tmp0 = np.copy(ints.tmp16)
    del ints.tmp16
    tmp0 += v.aaaa.ooov * -1
    tmp1 = np.copy(ints.tmp18)
    del ints.tmp18
    tmp1 += v.aabb.ooov
    r2new.bbb = np.copy(tmp62)
    r2new.bbb += np.transpose(tmp62, (1, 0, 2)) * -1
    del tmp62
    r2new.bbb += tmp72 * -1
    r2new.bbb += np.transpose(tmp72, (1, 0, 2))
    del tmp72
    r2new.bbb += einsum(tmp73, (0, 1, 2, 3), r2.bbb, (2, 3, 4), (0, 1, 4)) * 2
    del tmp73
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp50, (2, 3), (0, 1, 3)) * -2
    r2new.bbb += einsum(tmp74, (0,), t2.bbbb, (1, 2, 3, 0), (1, 2, 3)) * 4
    del tmp74
    r2new.bbb += einsum(tmp75, (0, 1, 2, 3), r1.b, (2,), (1, 0, 3)) * 2
    del tmp75
    r2new.bbb += einsum(r1.b, (0,), tmp53, (1, 2), (0, 1, 2)) * -1
    r2new.bbb += einsum(tmp53, (0, 1), r1.b, (2,), (0, 2, 1))
    r2new.bab = einsum(r2.bab, (0, 1, 2), tmp45, (3, 0, 4, 2), (3, 1, 4))
    del tmp45
    r2new.bab += einsum(r2.aaa, (0, 1, 2), tmp46, (1, 3, 2, 4), (3, 0, 4)) * -2
    del tmp46
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp47, (3, 1, 4, 2), (0, 3, 4))
    del tmp47
    r2new.bab += einsum(tmp48, (0, 1, 2, 3), r2.bab, (3, 1, 4), (2, 0, 4))
    del tmp48
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp50, (2, 3), (0, 1, 3)) * -1
    del tmp50
    r2new.bab += einsum(t2.abab, (0, 1, 2, 3), tmp51, (2,), (1, 0, 3)) * 2
    del tmp51
    r2new.bab += einsum(r1.a, (0,), tmp52, (1, 0, 2, 3), (2, 1, 3))
    del tmp52
    r2new.bab += einsum(tmp43, (0, 1), r2.bab, (2, 0, 3), (2, 1, 3)) * -1
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp44, (0, 3), (3, 1, 2)) * -1
    r2new.bab += einsum(tmp53, (0, 1), r1.a, (2,), (0, 2, 1))
    del tmp53
    r2new.aba = einsum(r2.aba, (0, 1, 2), tmp35, (3, 0, 4, 2), (3, 1, 4))
    del tmp35
    r2new.aba += einsum(r2.bbb, (0, 1, 2), tmp36, (3, 1, 4, 2), (3, 0, 4)) * -2
    del tmp36
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp37, (3, 1, 4, 2), (0, 3, 4))
    del tmp37
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp38, (3, 0, 4, 1), (3, 4, 2))
    del tmp38
    r2new.aba += einsum(tmp29, (0, 1), r2.aba, (2, 3, 0), (2, 3, 1)) * -1
    r2new.aba += einsum(t2.abab, (0, 1, 2, 3), tmp41, (3,), (0, 1, 2))
    del tmp41
    r2new.aba += einsum(tmp42, (0, 1, 2, 3), r1.b, (2,), (0, 1, 3))
    del tmp42
    r2new.aba += einsum(tmp43, (0, 1), r2.aba, (0, 2, 3), (1, 2, 3)) * -1
    del tmp43
    r2new.aba += einsum(tmp44, (0, 1), r2.aba, (2, 0, 3), (2, 1, 3)) * -1
    del tmp44
    r2new.aba += einsum(r1.b, (0,), tmp34, (1, 2), (1, 0, 2))
    r2new.aaa = np.copy(tmp17) * -1
    r2new.aaa += np.transpose(tmp17, (1, 0, 2))
    del tmp17
    r2new.aaa += tmp26
    r2new.aaa += np.transpose(tmp26, (1, 0, 2)) * -1
    del tmp26
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp27, (3, 4, 0, 1), (3, 4, 2)) * 2
    del tmp27
    r2new.aaa += einsum(tmp29, (0, 1), r2.aaa, (2, 3, 0), (2, 3, 1)) * -2
    del tmp29
    r2new.aaa += einsum(tmp32, (0,), t2.aaaa, (1, 2, 3, 0), (1, 2, 3)) * 2
    del tmp32
    r2new.aaa += einsum(r1.a, (0,), tmp33, (1, 2, 0, 3), (2, 1, 3)) * 2
    del tmp33
    r2new.aaa += einsum(tmp34, (0, 1), r1.a, (2,), (2, 0, 1)) * -1
    r2new.aaa += einsum(r1.a, (0,), tmp34, (1, 2), (1, 0, 2))
    del tmp34
    r1new.b = einsum(r2.aba, (0, 1, 2), tmp5, (0, 3, 1, 2), (3,))
    del tmp5
    r1new.b += einsum(tmp6, (0, 1, 2, 3), r2.bbb, (2, 1, 3), (0,)) * -2
    del tmp6
    r1new.b += einsum(r2.aba, (0, 1, 2), tmp3, (0, 2), (1,)) * -1
    r1new.b += einsum(r2.bbb, (0, 1, 2), tmp2, (1, 2), (0,)) * 2
    r1new.b += einsum(r1.b, (0,), tmp7, (0, 1), (1,)) * -1
    del tmp7
    r1new.a = einsum(tmp0, (0, 1, 2, 3), r2.aaa, (2, 1, 3), (0,)) * -2
    del tmp0
    r1new.a += einsum(r2.bab, (0, 1, 2), tmp1, (3, 1, 0, 2), (3,))
    del tmp1
    r1new.a += einsum(r2.bab, (0, 1, 2), tmp2, (0, 2), (1,)) * -1
    del tmp2
    r1new.a += einsum(r2.aaa, (0, 1, 2), tmp3, (1, 2), (0,)) * 2
    del tmp3
    r1new.a += einsum(r1.a, (0,), tmp4, (0, 1), (1,)) * -1
    del tmp4

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_matvec_ea_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:40:37.234664.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp101 : array
    tmp104 : array
    tmp105 : array
    tmp11 : array
    tmp115 : array
    tmp116 : array
    tmp117 : array
    tmp12 : array
    tmp128 : array
    tmp13 : array
    tmp131 : array
    tmp132 : array
    tmp138 : array
    tmp139 : array
    tmp141 : array
    tmp142 : array
    tmp143 : array
    tmp145 : array
    tmp147 : array
    tmp148 : array
    tmp149 : array
    tmp15 : array
    tmp150 : array
    tmp152 : array
    tmp153 : array
    tmp154 : array
    tmp155 : array
    tmp156 : array
    tmp160 : array
    tmp162 : array
    tmp164 : array
    tmp166 : array
    tmp168 : array
    tmp170 : array
    tmp176 : array
    tmp178 : array
    tmp180 : array
    tmp193 : array
    tmp20 : array
    tmp22 : array
    tmp31 : array
    tmp32 : array
    tmp33 : array
    tmp4 : array
    tmp41 : array
    tmp43 : array
    tmp5 : array
    tmp50 : array
    tmp51 : array
    tmp55 : array
    tmp57 : array
    tmp59 : array
    tmp6 : array
    tmp63 : array
    tmp65 : array
    tmp67 : array
    tmp69 : array
    tmp7 : array
    tmp71 : array
    tmp73 : array
    tmp76 : array
    tmp79 : array
    tmp80 : array
    tmp81 : array
    tmp88 : array
    tmp89 : array
    tmp9 : array
    tmp91 : array
    tmp93 : array
    tmp94 : array
    tmp95 : array
    tmp97 : array
    """

    tmp139 = einsum(t1.bb, (0, 1), f.bb.ov, (2, 1), (2, 0))
    tmp89 = einsum(t1.aa, (0, 1), f.aa.ov, (2, 1), (2, 0))
    tmp193 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp180 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovvv, (0, 2, 4, 5), (1, 3, 4, 5))
    tmp178 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (1, 4, 5, 3), (0, 2, 4, 5))
    tmp176 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (1, 3, 4, 5), (0, 2, 4, 5))
    tmp170 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 5), (1, 4, 3, 5))
    tmp168 = einsum(t2.bbbb, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp166 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp164 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp162 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 4, 1, 5))
    tmp160 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 1, 5), (0, 4, 3, 5))
    tmp156 = einsum(t2.bbbb, (0, 1, 2, 3), v.aabb.vvov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp155 = einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ovvv, (0, 4, 5, 2), (1, 4, 5, 3))
    tmp154 = einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ovvv, (0, 2, 4, 5), (1, 4, 5, 3))
    tmp153 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp152 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (0, 2), (1, 3))
    tmp150 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 3, 1, 4), (2, 4))
    tmp149 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 0, 1, 3), (4, 2))
    tmp148 = einsum(t1.bb, (0, 1), f.bb.oo, (2, 0), (2, 1))
    tmp147 = einsum(tmp139, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp145 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 3), (1, 4))
    tmp143 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 3, 1), (4, 0)) * -1
    tmp142 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovvv, (0, 2, 4, 3), (1, 4))
    tmp141 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.bbbb, (4, 0, 3, 1), (4, 2)) * -1
    tmp138 = einsum(f.bb.vv, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp132 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 3, 4, 5), (2, 4, 1, 5))
    tmp131 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 5, 3), (1, 5, 2, 4))
    tmp128 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovvv, (0, 4, 5, 3), (1, 2, 4, 5))
    tmp117 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 5, 2, 3))
    tmp116 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ovvv, (1, 4, 5, 3), (0, 2, 4, 5))
    tmp115 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.abab, (4, 0, 5, 1), (4, 5, 2, 3))
    tmp105 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp104 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp101 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp97 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp95 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 1, 3), (0, 4))
    tmp94 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 1, 3), (0, 4))
    tmp93 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovvv, (1, 2, 4, 3), (0, 4))
    tmp91 = einsum(t1.aa, (0, 1), tmp89, (0, 2), (2, 1))
    tmp88 = einsum(f.aa.vv, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp81 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp80 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 0, 1, 3), (4, 2))
    tmp79 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 3), (0, 4))
    tmp76 = einsum(f.aa.oo, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp73 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 2, 5, 3))
    tmp71 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp69 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp67 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp65 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp63 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp59 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 5, 1, 3), (0, 2, 4, 5))
    tmp57 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 5, 1, 2))
    tmp55 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovvv, (1, 3, 4, 5), (0, 2, 4, 5))
    tmp51 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp50 = einsum(t2.aaaa, (0, 1, 2, 3), f.aa.ov, (1, 3), (0, 2))
    tmp43 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 4), (3, 4))
    tmp41 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (0, 2, 4, 1), (4, 3)) * -1
    tmp33 = einsum(t1.aa, (0, 1), v.aabb.ovvv, (0, 1, 2, 3), (2, 3))
    tmp32 = einsum(t1.bb, (0, 1), v.bbbb.ovvv, (0, 2, 3, 1), (2, 3))
    tmp31 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (0, 1), (2, 3))
    tmp22 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 1, 3), (2, 4))
    tmp20 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (0, 3, 1, 4), (2, 4)) * -1
    tmp15 = einsum(t1.aa, (0, 1), v.aabb.ovov, (0, 1, 2, 3), (2, 3))
    tmp13 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp12 = einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 3, 0, 1), (2, 3))
    tmp11 = einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 1, 0, 3), (2, 3))
    tmp9 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    tmp7 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 1), (0, 3))
    tmp6 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp5 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    tmp4 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))

    return {f"tmp101": tmp101, f"tmp104": tmp104, f"tmp105": tmp105, f"tmp11": tmp11, f"tmp115": tmp115, f"tmp116": tmp116, f"tmp117": tmp117, f"tmp12": tmp12, f"tmp128": tmp128, f"tmp13": tmp13, f"tmp131": tmp131, f"tmp132": tmp132, f"tmp138": tmp138, f"tmp139": tmp139, f"tmp141": tmp141, f"tmp142": tmp142, f"tmp143": tmp143, f"tmp145": tmp145, f"tmp147": tmp147, f"tmp148": tmp148, f"tmp149": tmp149, f"tmp15": tmp15, f"tmp150": tmp150, f"tmp152": tmp152, f"tmp153": tmp153, f"tmp154": tmp154, f"tmp155": tmp155, f"tmp156": tmp156, f"tmp160": tmp160, f"tmp162": tmp162, f"tmp164": tmp164, f"tmp166": tmp166, f"tmp168": tmp168, f"tmp170": tmp170, f"tmp176": tmp176, f"tmp178": tmp178, f"tmp180": tmp180, f"tmp193": tmp193, f"tmp20": tmp20, f"tmp22": tmp22, f"tmp31": tmp31, f"tmp32": tmp32, f"tmp33": tmp33, f"tmp4": tmp4, f"tmp41": tmp41, f"tmp43": tmp43, f"tmp5": tmp5, f"tmp50": tmp50, f"tmp51": tmp51, f"tmp55": tmp55, f"tmp57": tmp57, f"tmp59": tmp59, f"tmp6": tmp6, f"tmp63": tmp63, f"tmp65": tmp65, f"tmp67": tmp67, f"tmp69": tmp69, f"tmp7": tmp7, f"tmp71": tmp71, f"tmp73": tmp73, f"tmp76": tmp76, f"tmp79": tmp79, f"tmp80": tmp80, f"tmp81": tmp81, f"tmp88": tmp88, f"tmp89": tmp89, f"tmp9": tmp9, f"tmp91": tmp91, f"tmp93": tmp93, f"tmp94": tmp94, f"tmp95": tmp95, f"tmp97": tmp97}

def hbar_matvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:40:37.325915.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp67 = np.copy(ints.tmp162)
    tmp67 += ints.tmp168 * 2
    tmp57 = np.copy(ints.tmp166) * 2
    tmp57 += ints.tmp170
    tmp61 = np.copy(ints.tmp176)
    del ints.tmp176
    tmp61 += ints.tmp180 * 0.5
    del ints.tmp180
    tmp61 += v.bbbb.ovvv * 0.5
    tmp55 = einsum(f.bb.ov, (0, 1), r2.bbb, (2, 1, 3), (0, 3, 2))
    tmp59 = np.copy(np.transpose(ints.tmp41, (1, 0)))
    tmp59 += np.transpose(ints.tmp43, (1, 0)) * 0.5
    tmp59 += f.bb.vv * -0.5
    tmp20 = np.copy(ints.tmp55)
    del ints.tmp55
    tmp20 += ints.tmp59 * 0.5
    del ints.tmp59
    tmp20 += v.aaaa.ovvv * 0.5
    tmp12 = einsum(f.aa.ov, (0, 1), r2.aaa, (2, 1, 3), (0, 3, 2))
    tmp14 = np.copy(ints.tmp65) * 2
    tmp14 += ints.tmp71
    tmp16 = np.copy(ints.tmp69) * 0.5
    tmp16 += ints.tmp73
    tmp18 = np.copy(np.transpose(ints.tmp20, (1, 0)))
    tmp18 += np.transpose(ints.tmp22, (1, 0)) * 0.5
    tmp18 += f.aa.vv * -0.5
    tmp66 = einsum(r2.bbb, (0, 1, 2), v.bbbb.ovov, (3, 4, 2, 1), (3, 0, 4))
    tmp64 = einsum(r1.b, (0,), ints.tmp178, (1, 2, 0, 3), (1, 2, 3))
    del ints.tmp178
    tmp65 = einsum(ints.tmp164, (0, 1, 2, 3), r2.bbb, (4, 3, 1), (0, 2, 4))
    tmp68 = einsum(tmp67, (0, 1, 2, 3), r2.aba, (2, 4, 0), (1, 4, 3))
    del tmp67
    tmp53 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.aba, (1, 4, 0), (2, 4, 3))
    tmp54 = einsum(r2.bbb, (0, 1, 2), v.bbbb.oovv, (3, 2, 4, 1), (3, 0, 4))
    tmp58 = einsum(r2.bbb, (0, 1, 2), tmp57, (3, 2, 4, 1), (3, 0, 4)) * -2
    del tmp57
    tmp62 = einsum(r1.b, (0,), tmp61, (1, 2, 3, 0), (1, 2, 3)) * 2
    del tmp61
    tmp56 = einsum(tmp55, (0, 1, 2), t1.bb, (0, 3), (1, 2, 3))
    del tmp55
    tmp52 = einsum(r2.aba, (0, 1, 2), ints.tmp160, (2, 3, 0, 4), (3, 4, 1))
    tmp60 = einsum(r2.bbb, (0, 1, 2), tmp59, (1, 3), (2, 0, 3)) * -4
    del tmp59
    tmp7 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.aba, (1, 3, 0), (2,))
    tmp42 = einsum(r1.b, (0,), f.bb.ov, (1, 0), (1,))
    tmp8 = einsum(r2.bbb, (0, 1, 2), v.bbbb.ovov, (3, 0, 2, 1), (3,))
    tmp38 = einsum(t1.aa, (0, 1), f.aa.ov, (0, 2), (2, 1))
    tmp40 = einsum(t1.bb, (0, 1), f.bb.ov, (0, 2), (2, 1))
    tmp30 = einsum(r1.a, (0,), f.aa.ov, (1, 0), (1,))
    tmp3 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r2.aaa, (1, 3, 2), (0,))
    tmp4 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.bab, (3, 1, 2), (0,)) * -1
    tmp21 = einsum(tmp20, (0, 1, 2, 3), r1.a, (3,), (0, 1, 2)) * 2
    del tmp20
    tmp13 = einsum(tmp12, (0, 1, 2), t1.aa, (0, 3), (1, 2, 3))
    del tmp12
    tmp11 = einsum(v.aaaa.oovv, (0, 1, 2, 3), r2.aaa, (4, 3, 1), (0, 4, 2))
    tmp15 = einsum(r2.aaa, (0, 1, 2), tmp14, (3, 2, 4, 1), (3, 0, 4)) * -2
    del tmp14
    tmp17 = einsum(tmp16, (0, 1, 2, 3), r2.bab, (3, 4, 1), (0, 4, 2)) * -2
    del tmp16
    tmp19 = einsum(r2.aaa, (0, 1, 2), tmp18, (1, 3), (2, 0, 3)) * -4
    del tmp18
    tmp23 = einsum(ints.tmp57, (0, 1, 2, 3), r1.a, (2,), (0, 1, 3))
    del ints.tmp57
    tmp25 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r2.aaa, (4, 3, 2), (0, 4, 1))
    tmp27 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.bab, (3, 4, 2), (0, 4, 1)) * -1
    tmp24 = einsum(ints.tmp63, (0, 1, 2, 3), r2.aaa, (4, 3, 1), (0, 2, 4))
    tmp26 = einsum(r2.bab, (0, 1, 2), ints.tmp67, (3, 2, 4, 0), (3, 4, 1)) * -1
    tmp0 = np.copy(f.bb.ov)
    tmp0 += ints.tmp12
    del ints.tmp12
    tmp0 += ints.tmp15
    del ints.tmp15
    tmp0 += ints.tmp11 * -1
    del ints.tmp11
    tmp1 = np.copy(f.aa.ov)
    tmp1 += ints.tmp13
    del ints.tmp13
    tmp1 += ints.tmp9
    del ints.tmp9
    tmp1 += ints.tmp7 * -1
    del ints.tmp7
    tmp51 = einsum(v.bbbb.ovov, (0, 1, 2, 3), r2.bbb, (3, 1, 4), (4, 0, 2)) * -1
    tmp50 = np.copy(ints.tmp141) * 2
    del ints.tmp141
    tmp50 += ints.tmp147
    del ints.tmp147
    tmp50 += ints.tmp148
    del ints.tmp148
    tmp50 += ints.tmp149 * 2
    del ints.tmp149
    tmp50 += ints.tmp150
    del ints.tmp150
    tmp50 += f.bb.ov * -1
    tmp50 += ints.tmp138 * -1
    del ints.tmp138
    tmp50 += ints.tmp142 * -1
    del ints.tmp142
    tmp50 += ints.tmp152 * -1
    del ints.tmp152
    tmp50 += ints.tmp153 * -2
    del ints.tmp153
    tmp69 = np.copy(tmp64) * 2
    del tmp64
    tmp69 += tmp65 * 4
    del tmp65
    tmp69 += tmp66 * 2
    del tmp66
    tmp69 += np.transpose(tmp68, (0, 2, 1))
    del tmp68
    tmp49 = np.copy(f.bb.oo)
    tmp49 += ints.tmp139
    del ints.tmp139
    tmp49 += np.transpose(ints.tmp143, (1, 0)) * 2
    del ints.tmp143
    tmp49 += np.transpose(ints.tmp145, (1, 0))
    del ints.tmp145
    tmp63 = np.copy(tmp52)
    del tmp52
    tmp63 += tmp53
    del tmp53
    tmp63 += tmp54 * 2
    del tmp54
    tmp63 += tmp56 * 2
    del tmp56
    tmp63 += np.transpose(tmp58, (0, 2, 1)) * -1
    del tmp58
    tmp63 += np.transpose(tmp60, (0, 2, 1))
    del tmp60
    tmp63 += tmp62
    del tmp62
    tmp43 = np.copy(tmp42) * 0.5
    del tmp42
    tmp43 += tmp7 * -0.5
    tmp43 += tmp8
    tmp39 = np.copy(np.transpose(ints.tmp20, (1, 0))) * 2
    tmp39 += np.transpose(ints.tmp22, (1, 0))
    tmp39 += f.aa.vv * -1
    tmp39 += tmp38
    del tmp38
    tmp46 = np.copy(ints.tmp162)
    del ints.tmp162
    tmp46 += ints.tmp168 * 2
    del ints.tmp168
    tmp46 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp46 += ints.tmp160 * -1
    del ints.tmp160
    tmp41 = np.copy(np.transpose(ints.tmp41, (1, 0))) * 2
    tmp41 += np.transpose(ints.tmp43, (1, 0))
    tmp41 += f.bb.vv * -1
    tmp41 += tmp40
    del tmp40
    tmp31 = np.copy(tmp30)
    del tmp30
    tmp31 += tmp3 * 2
    tmp31 += tmp4
    tmp44 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.bab, (3, 1, 4), (0, 4, 2)) * -1
    tmp47 = np.copy(ints.tmp131)
    del ints.tmp131
    tmp47 += np.transpose(v.aabb.vvoo, (2, 3, 0, 1)) * -1
    tmp45 = np.copy(ints.tmp166) * 2
    del ints.tmp166
    tmp45 += ints.tmp170
    del ints.tmp170
    tmp45 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    tmp45 += ints.tmp164 * -2
    del ints.tmp164
    tmp45 += v.bbbb.oovv * -1
    tmp48 = np.copy(ints.tmp132)
    del ints.tmp132
    tmp48 += ints.tmp154
    del ints.tmp154
    tmp48 += ints.tmp156 * 2
    del ints.tmp156
    tmp48 += np.transpose(v.aabb.vvov, (2, 0, 1, 3))
    tmp48 += ints.tmp128 * -1
    del ints.tmp128
    tmp48 += np.transpose(ints.tmp155, (0, 2, 1, 3)) * -1
    del ints.tmp155
    tmp36 = np.copy(ints.tmp104)
    del ints.tmp104
    tmp36 += v.aabb.oovv * -1
    tmp33 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.aba, (1, 3, 4), (4, 0, 2))
    tmp32 = np.copy(ints.tmp76)
    del ints.tmp76
    tmp32 += ints.tmp79 * 2
    del ints.tmp79
    tmp32 += ints.tmp80
    del ints.tmp80
    tmp32 += ints.tmp91
    del ints.tmp91
    tmp32 += ints.tmp93 * 2
    del ints.tmp93
    tmp32 += f.aa.ov * -1
    tmp32 += ints.tmp50 * -2
    del ints.tmp50
    tmp32 += ints.tmp51 * -1
    del ints.tmp51
    tmp32 += ints.tmp88 * -1
    del ints.tmp88
    tmp32 += ints.tmp94 * -1
    del ints.tmp94
    tmp35 = np.copy(ints.tmp69)
    del ints.tmp69
    tmp35 += ints.tmp73 * 2
    del ints.tmp73
    tmp35 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp35 += ints.tmp67 * -1
    del ints.tmp67
    tmp34 = np.copy(ints.tmp65) * 2
    del ints.tmp65
    tmp34 += ints.tmp71
    del ints.tmp71
    tmp34 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp34 += ints.tmp63 * -2
    del ints.tmp63
    tmp34 += v.aaaa.oovv * -1
    tmp37 = np.copy(ints.tmp105)
    del ints.tmp105
    tmp37 += ints.tmp115
    del ints.tmp115
    tmp37 += ints.tmp117 * 2
    del ints.tmp117
    tmp37 += v.aabb.ovvv
    tmp37 += ints.tmp101 * -1
    del ints.tmp101
    tmp37 += np.transpose(ints.tmp116, (0, 1, 3, 2)) * -1
    del ints.tmp116
    tmp29 = np.copy(f.aa.oo)
    tmp29 += ints.tmp89
    del ints.tmp89
    tmp29 += np.transpose(ints.tmp95, (1, 0)) * 2
    del ints.tmp95
    tmp29 += np.transpose(ints.tmp97, (1, 0))
    del ints.tmp97
    tmp22 = np.copy(tmp11) * 2
    del tmp11
    tmp22 += tmp13 * 2
    del tmp13
    tmp22 += np.transpose(tmp15, (0, 2, 1)) * -1
    del tmp15
    tmp22 += np.transpose(tmp17, (0, 2, 1))
    del tmp17
    tmp22 += np.transpose(tmp19, (0, 2, 1))
    del tmp19
    tmp22 += tmp21
    del tmp21
    tmp28 = np.copy(tmp23) * 2
    del tmp23
    tmp28 += tmp24 * 4
    del tmp24
    tmp28 += tmp25 * 2
    del tmp25
    tmp28 += tmp26
    del tmp26
    tmp28 += tmp27
    del tmp27
    tmp10 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r2.aaa, (1, 3, 4), (4, 0, 2))
    tmp6 = np.copy(ints.tmp32)
    del ints.tmp32
    tmp6 += np.transpose(ints.tmp41, (1, 0)) * 2
    del ints.tmp41
    tmp6 += np.transpose(ints.tmp43, (1, 0))
    del ints.tmp43
    tmp6 += f.bb.vv * -1
    tmp6 += np.transpose(ints.tmp31, (1, 0)) * -1
    del ints.tmp31
    tmp6 += np.transpose(ints.tmp33, (1, 0)) * -1
    del ints.tmp33
    tmp9 = np.copy(tmp7) * -1
    del tmp7
    tmp9 += tmp8 * 2
    del tmp8
    tmp9 += einsum(tmp0, (0, 1), r1.b, (1,), (0,))
    tmp5 = np.copy(tmp3) * 2
    del tmp3
    tmp5 += tmp4
    del tmp4
    tmp5 += einsum(tmp1, (0, 1), r1.a, (1,), (0,))
    tmp2 = np.copy(np.transpose(ints.tmp20, (1, 0))) * 2
    del ints.tmp20
    tmp2 += np.transpose(ints.tmp22, (1, 0))
    del ints.tmp22
    tmp2 += ints.tmp5
    del ints.tmp5
    tmp2 += f.aa.vv * -1
    tmp2 += np.transpose(ints.tmp4, (1, 0)) * -1
    del ints.tmp4
    tmp2 += np.transpose(ints.tmp6, (1, 0)) * -1
    del ints.tmp6
    r2new.bbb = einsum(ints.tmp193, (0, 1, 2, 3), r1.b, (3,), (2, 1, 0)) * 2
    del ints.tmp193
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), v.bbbb.vvvv, (3, 0, 4, 1), (3, 4, 2)) * 2
    r2new.bbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp51, (4, 1, 0), (2, 3, 4)) * -2
    del tmp51
    r2new.bbb += np.transpose(tmp63, (1, 2, 0)) * -1
    r2new.bbb += np.transpose(tmp63, (2, 1, 0))
    del tmp63
    r2new.bbb += np.transpose(tmp69, (1, 2, 0))
    r2new.bbb += np.transpose(tmp69, (2, 1, 0)) * -1
    del tmp69
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp49, (2, 3), (0, 1, 3)) * -2
    r2new.bbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp43, (1,), (2, 3, 0)) * 4
    r2new.bbb += einsum(r1.b, (0,), tmp50, (1, 2), (0, 2, 1)) * -1
    r2new.bbb += einsum(r1.b, (0,), tmp50, (1, 2), (2, 0, 1))
    r2new.bab = einsum(r2.bab, (0, 1, 2), v.aabb.vvvv, (3, 1, 4, 0), (4, 3, 2))
    r2new.bab += einsum(t2.abab, (0, 1, 2, 3), tmp44, (0, 4, 1), (3, 2, 4)) * -1
    del tmp44
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp45, (3, 2, 4, 0), (4, 1, 3))
    del tmp45
    r2new.bab += einsum(tmp46, (0, 1, 2, 3), r2.aaa, (4, 2, 0), (3, 4, 1)) * -2
    del tmp46
    r2new.bab += einsum(tmp47, (0, 1, 2, 3), r2.bab, (4, 3, 1), (4, 2, 0))
    del tmp47
    r2new.bab += einsum(r1.a, (0,), tmp48, (1, 2, 0, 3), (3, 2, 1)) * -1
    del tmp48
    r2new.bab += einsum(tmp41, (0, 1), r2.bab, (0, 2, 3), (1, 2, 3)) * -1
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp39, (1, 3), (0, 3, 2)) * -1
    r2new.bab += einsum(tmp49, (0, 1), r2.bab, (2, 3, 0), (2, 3, 1)) * -1
    del tmp49
    r2new.bab += einsum(t2.abab, (0, 1, 2, 3), tmp31, (0,), (3, 2, 1))
    r2new.bab += einsum(r1.a, (0,), tmp50, (1, 2), (2, 0, 1))
    del tmp50
    r2new.aba = einsum(t2.abab, (0, 1, 2, 3), tmp33, (4, 0, 1), (2, 3, 4))
    del tmp33
    r2new.aba += einsum(v.aabb.vvvv, (0, 1, 2, 3), r2.aba, (1, 3, 4), (0, 2, 4))
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp34, (3, 2, 4, 0), (4, 1, 3))
    del tmp34
    r2new.aba += einsum(r2.bbb, (0, 1, 2), tmp35, (3, 2, 4, 1), (4, 0, 3)) * -2
    del tmp35
    r2new.aba += einsum(tmp36, (0, 1, 2, 3), r2.aba, (4, 3, 1), (4, 2, 0))
    del tmp36
    r2new.aba += einsum(r1.b, (0,), tmp37, (1, 2, 3, 0), (2, 3, 1)) * -1
    del tmp37
    r2new.aba += einsum(tmp39, (0, 1), r2.aba, (0, 2, 3), (1, 2, 3)) * -1
    del tmp39
    r2new.aba += einsum(tmp41, (0, 1), r2.aba, (2, 0, 3), (2, 1, 3)) * -1
    del tmp41
    r2new.aba += einsum(tmp29, (0, 1), r2.aba, (2, 3, 0), (2, 3, 1)) * -1
    r2new.aba += einsum(t2.abab, (0, 1, 2, 3), tmp43, (1,), (2, 3, 0)) * 2
    del tmp43
    r2new.aba += einsum(tmp32, (0, 1), r1.b, (2,), (1, 2, 0))
    r2new.aaa = einsum(tmp10, (0, 1, 2), t2.aaaa, (2, 1, 3, 4), (3, 4, 0)) * -2
    del tmp10
    r2new.aaa += einsum(ints.tmp81, (0, 1, 2, 3), r1.a, (3,), (2, 1, 0)) * 2
    del ints.tmp81
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), v.aaaa.vvvv, (3, 1, 4, 0), (3, 4, 2)) * -2
    r2new.aaa += np.transpose(tmp22, (1, 2, 0)) * -1
    r2new.aaa += np.transpose(tmp22, (2, 1, 0))
    del tmp22
    r2new.aaa += np.transpose(tmp28, (1, 2, 0))
    r2new.aaa += np.transpose(tmp28, (2, 1, 0)) * -1
    del tmp28
    r2new.aaa += einsum(tmp29, (0, 1), r2.aaa, (2, 3, 0), (2, 3, 1)) * -2
    del tmp29
    r2new.aaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp31, (1,), (2, 3, 0)) * 2
    del tmp31
    r2new.aaa += einsum(tmp32, (0, 1), r1.a, (2,), (2, 1, 0)) * -1
    r2new.aaa += einsum(tmp32, (0, 1), r1.a, (2,), (1, 2, 0))
    del tmp32
    r1new.b = einsum(v.aabb.ovvv, (0, 1, 2, 3), r2.aba, (1, 3, 0), (2,)) * -1
    r1new.b += einsum(r2.bbb, (0, 1, 2), v.bbbb.ovvv, (2, 1, 3, 0), (3,)) * 2
    r1new.b += einsum(tmp1, (0, 1), r2.aba, (1, 2, 0), (2,)) * -1
    r1new.b += einsum(tmp0, (0, 1), r2.bbb, (2, 1, 0), (2,)) * 2
    r1new.b += einsum(tmp6, (0, 1), r1.b, (0,), (1,)) * -1
    del tmp6
    r1new.b += einsum(tmp9, (0,), t1.bb, (0, 1), (1,)) * -1
    del tmp9
    r1new.a = einsum(r2.bab, (0, 1, 2), v.aabb.vvov, (3, 1, 2, 0), (3,)) * -1
    r1new.a += einsum(v.aaaa.ovvv, (0, 1, 2, 3), r2.aaa, (3, 1, 0), (2,)) * 2
    r1new.a += einsum(tmp0, (0, 1), r2.bab, (1, 2, 0), (2,)) * -1
    del tmp0
    r1new.a += einsum(tmp1, (0, 1), r2.aaa, (2, 1, 0), (2,)) * 2
    del tmp1
    r1new.a += einsum(tmp2, (0, 1), r1.a, (0,), (1,)) * -1
    del tmp2
    r1new.a += einsum(t1.aa, (0, 1), tmp5, (0,), (1,)) * -1
    del tmp5

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ip_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:43:17.462508.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp10 : array
    tmp100 : array
    tmp101 : array
    tmp103 : array
    tmp105 : array
    tmp107 : array
    tmp109 : array
    tmp11 : array
    tmp111 : array
    tmp113 : array
    tmp115 : array
    tmp117 : array
    tmp119 : array
    tmp120 : array
    tmp122 : array
    tmp124 : array
    tmp125 : array
    tmp127 : array
    tmp129 : array
    tmp13 : array
    tmp130 : array
    tmp132 : array
    tmp133 : array
    tmp135 : array
    tmp137 : array
    tmp138 : array
    tmp140 : array
    tmp141 : array
    tmp143 : array
    tmp144 : array
    tmp146 : array
    tmp148 : array
    tmp149 : array
    tmp15 : array
    tmp151 : array
    tmp152 : array
    tmp154 : array
    tmp155 : array
    tmp156 : array
    tmp157 : array
    tmp159 : array
    tmp161 : array
    tmp162 : array
    tmp163 : array
    tmp164 : array
    tmp165 : array
    tmp167 : array
    tmp168 : array
    tmp17 : array
    tmp170 : array
    tmp172 : array
    tmp175 : array
    tmp177 : array
    tmp179 : array
    tmp182 : array
    tmp185 : array
    tmp187 : array
    tmp189 : array
    tmp19 : array
    tmp191 : array
    tmp194 : array
    tmp197 : array
    tmp199 : array
    tmp2 : array
    tmp201 : array
    tmp203 : array
    tmp204 : array
    tmp205 : array
    tmp206 : array
    tmp207 : array
    tmp209 : array
    tmp21 : array
    tmp210 : array
    tmp212 : array
    tmp215 : array
    tmp22 : array
    tmp223 : array
    tmp225 : array
    tmp230 : array
    tmp232 : array
    tmp238 : array
    tmp240 : array
    tmp247 : array
    tmp248 : array
    tmp25 : array
    tmp250 : array
    tmp251 : array
    tmp253 : array
    tmp254 : array
    tmp256 : array
    tmp26 : array
    tmp262 : array
    tmp264 : array
    tmp27 : array
    tmp275 : array
    tmp277 : array
    tmp279 : array
    tmp28 : array
    tmp281 : array
    tmp283 : array
    tmp285 : array
    tmp291 : array
    tmp292 : array
    tmp294 : array
    tmp295 : array
    tmp297 : array
    tmp299 : array
    tmp30 : array
    tmp301 : array
    tmp306 : array
    tmp307 : array
    tmp309 : array
    tmp315 : array
    tmp317 : array
    tmp319 : array
    tmp32 : array
    tmp320 : array
    tmp325 : array
    tmp328 : array
    tmp334 : array
    tmp336 : array
    tmp34 : array
    tmp341 : array
    tmp343 : array
    tmp345 : array
    tmp347 : array
    tmp349 : array
    tmp351 : array
    tmp36 : array
    tmp367 : array
    tmp369 : array
    tmp37 : array
    tmp38 : array
    tmp39 : array
    tmp390 : array
    tmp392 : array
    tmp394 : array
    tmp396 : array
    tmp398 : array
    tmp4 : array
    tmp400 : array
    tmp402 : array
    tmp41 : array
    tmp412 : array
    tmp414 : array
    tmp416 : array
    tmp43 : array
    tmp45 : array
    tmp46 : array
    tmp47 : array
    tmp49 : array
    tmp5 : array
    tmp51 : array
    tmp53 : array
    tmp55 : array
    tmp57 : array
    tmp59 : array
    tmp61 : array
    tmp62 : array
    tmp64 : array
    tmp65 : array
    tmp66 : array
    tmp68 : array
    tmp7 : array
    tmp70 : array
    tmp72 : array
    tmp74 : array
    tmp76 : array
    tmp78 : array
    tmp8 : array
    tmp80 : array
    tmp83 : array
    tmp85 : array
    tmp86 : array
    tmp88 : array
    tmp90 : array
    tmp92 : array
    tmp94 : array
    tmp96 : array
    tmp98 : array
    """

    tmp45 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp119 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 2, 1))
    tmp41 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp38 = einsum(t1.aa, (0, 1), v.aabb.ovov, (0, 1, 2, 3), (2, 3))
    tmp39 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp36 = einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 3, 0, 1), (2, 3))
    tmp89 = einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 1, 0, 3), (2, 3))
    tmp32 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    tmp82 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 1), (0, 3))
    tmp214 = einsum(tmp45, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp333 = einsum(tmp119, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp327 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 2, 0, 1))
    tmp324 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp174 = einsum(t1.aa, (0, 1), v.aabb.ovoo, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp176 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp314 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp151 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp306 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    tmp124 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 2, 1))
    tmp211 = einsum(t1.aa, (0, 1), tmp41, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp209 = einsum(tmp38, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp156 = einsum(t1.aa, (0, 1), tmp39, (2, 1), (0, 2))
    tmp205 = einsum(tmp36, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp203 = einsum(tmp89, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp155 = einsum(t1.aa, (0, 1), tmp32, (2, 1), (0, 2))
    tmp154 = einsum(t1.aa, (0, 1), tmp82, (2, 1), (0, 2))
    tmp196 = einsum(t1.aa, (0, 1), v.aabb.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp193 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp190 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp188 = einsum(t1.aa, (0, 1), v.aabb.ovvv, (0, 1, 2, 3), (2, 3))
    tmp186 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (0, 3), (1, 2))
    tmp184 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (0, 1), (2, 3))
    tmp181 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    tmp178 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp169 = einsum(t1.aa, (0, 1), v.aaaa.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp167 = einsum(t1.aa, (0, 1), v.aabb.ovoo, (0, 1, 2, 3), (2, 3))
    tmp27 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp163 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp161 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t1.bb, (1, 3), (0, 2))
    tmp26 = einsum(t1.aa, (0, 1), v.aaaa.ooov, (2, 3, 0, 1), (2, 3))
    tmp25 = einsum(t1.aa, (0, 1), v.aaaa.ooov, (2, 0, 3, 1), (2, 3))
    tmp148 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    tmp49 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp143 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 3), (1, 4))
    tmp140 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp47 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 1, 3), (4, 0))
    tmp21 = einsum(t1.bb, (0, 1), f.bb.ov, (2, 1), (2, 0))
    tmp1 = einsum(t1.aa, (0, 1), f.aa.ov, (2, 1), (2, 0))
    tmp416 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp414 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 4), (3, 4))
    tmp412 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (0, 2, 4, 3), (4, 1))
    tmp402 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 5), (1, 4, 3, 5))
    tmp400 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 2, 5, 3))
    tmp398 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp396 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp394 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp392 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp390 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 5, 3), (1, 5, 2, 4))
    tmp369 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 1, 3), (2, 4))
    tmp367 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 4, 3), (4, 1))
    tmp351 = einsum(t2.bbbb, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp349 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp347 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 4, 1, 5))
    tmp345 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp343 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 1, 5), (0, 4, 3, 5))
    tmp341 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp336 = einsum(tmp214, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 3, 4))
    tmp334 = einsum(tmp333, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    del tmp333
    tmp328 = einsum(t1.aa, (0, 1), tmp327, (2, 3, 4, 1), (0, 2, 3, 4))
    del tmp327
    tmp325 = einsum(tmp324, (0, 1, 2, 3), t1.bb, (4, 2), (4, 0, 1, 3))
    del tmp324
    tmp320 = einsum(t1.aa, (0, 1), tmp174, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp319 = einsum(t1.aa, (0, 1), tmp176, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp317 = einsum(t1.bb, (0, 1), tmp314, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp315 = einsum(tmp314, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 3, 4))
    del tmp314
    tmp309 = einsum(t1.aa, (0, 1), tmp151, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp307 = einsum(tmp306, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp301 = einsum(t2.abab, (0, 1, 2, 3), tmp45, (4, 0, 5, 3), (4, 1, 5, 2))
    tmp299 = einsum(tmp124, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (1, 4, 2, 5))
    tmp297 = einsum(tmp124, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 1, 2, 5))
    tmp295 = einsum(t2.bbbb, (0, 1, 2, 3), tmp119, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp294 = einsum(t2.abab, (0, 1, 2, 3), tmp119, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp292 = einsum(tmp119, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp291 = einsum(tmp119, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp285 = einsum(tmp38, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp283 = einsum(t2.abab, (0, 1, 2, 3), tmp38, (4, 3), (0, 1, 4, 2))
    tmp281 = einsum(t2.bbbb, (0, 1, 2, 3), tmp36, (4, 3), (0, 1, 4, 2))
    tmp279 = einsum(t2.abab, (0, 1, 2, 3), tmp36, (4, 3), (0, 1, 4, 2))
    tmp277 = einsum(t2.bbbb, (0, 1, 2, 3), tmp89, (4, 3), (0, 1, 4, 2))
    tmp275 = einsum(t2.abab, (0, 1, 2, 3), tmp89, (4, 3), (0, 1, 4, 2))
    tmp264 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 5, 3), (0, 1, 5, 4))
    tmp262 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    tmp256 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovoo, (0, 2, 4, 5), (1, 4, 5, 3))
    tmp254 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 2, 3, 5))
    tmp253 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 0, 5, 3), (4, 1, 5, 2))
    tmp251 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp250 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ooov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp248 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp247 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp240 = einsum(t1.aa, (0, 1), v.aabb.vvoo, (2, 1, 3, 4), (0, 3, 4, 2))
    tmp238 = einsum(v.bbbb.oovv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp232 = einsum(t1.aa, (0, 1), v.aabb.oooo, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp230 = einsum(t1.bb, (0, 1), v.bbbb.oooo, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp225 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp223 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (4, 3), (0, 4, 1, 2))
    tmp215 = einsum(tmp214, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    del tmp214
    tmp212 = einsum(tmp211, (0, 1, 2, 3), t1.aa, (3, 4), (0, 1, 2, 4))
    del tmp211
    tmp210 = einsum(tmp209, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp207 = einsum(tmp156, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp206 = einsum(tmp205, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp204 = einsum(tmp203, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp201 = einsum(t1.aa, (0, 1), tmp155, (2, 0), (2, 1))
    tmp199 = einsum(t1.aa, (0, 1), tmp154, (2, 0), (2, 1))
    tmp197 = einsum(tmp196, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    del tmp196
    tmp194 = einsum(t1.aa, (0, 1), tmp193, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp193
    tmp191 = einsum(tmp190, (0, 1), t1.aa, (2, 1), (2, 0))
    del tmp190
    tmp189 = einsum(tmp188, (0, 1), t1.bb, (2, 1), (2, 0))
    del tmp188
    tmp187 = einsum(tmp186, (0, 1), t1.bb, (2, 0), (2, 1))
    del tmp186
    tmp185 = einsum(tmp184, (0, 1), t1.bb, (2, 1), (2, 0))
    del tmp184
    tmp182 = einsum(t1.aa, (0, 1), tmp181, (1, 2), (0, 2))
    del tmp181
    tmp179 = einsum(t1.aa, (0, 1), tmp178, (2, 1), (0, 2))
    del tmp178
    tmp177 = einsum(tmp176, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    del tmp176
    tmp175 = einsum(tmp174, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    del tmp174
    tmp172 = einsum(tmp169, (0, 1, 2, 3), t1.aa, (3, 4), (0, 1, 2, 4))
    tmp170 = einsum(tmp169, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 3, 4))
    del tmp169
    tmp168 = einsum(tmp167, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp165 = einsum(t1.aa, (0, 1), tmp27, (2, 0), (2, 1))
    tmp164 = einsum(tmp163, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp162 = einsum(tmp161, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp159 = einsum(t1.aa, (0, 1), tmp26, (2, 0), (2, 1))
    tmp157 = einsum(t1.aa, (0, 1), tmp25, (2, 0), (2, 1))
    tmp152 = einsum(tmp151, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp149 = einsum(tmp148, (0, 1, 2, 3), t1.aa, (3, 4), (0, 1, 2, 4))
    tmp146 = einsum(t1.aa, (0, 1), tmp49, (2, 0), (2, 1))
    tmp144 = einsum(tmp143, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp141 = einsum(tmp140, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp138 = einsum(tmp47, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp137 = einsum(tmp124, (0, 1, 2, 3), t2.abab, (4, 2, 3, 5), (4, 0, 1, 5))
    tmp135 = einsum(t2.bbbb, (0, 1, 2, 3), tmp45, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp133 = einsum(t2.abab, (0, 1, 2, 3), tmp45, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp132 = einsum(t2.abab, (0, 1, 2, 3), tmp41, (4, 5, 0, 2), (4, 5, 1, 3))
    tmp130 = einsum(tmp41, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp129 = einsum(t2.abab, (0, 1, 2, 3), tmp41, (4, 0, 5, 2), (4, 5, 1, 3))
    tmp127 = einsum(tmp41, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp125 = einsum(tmp124, (0, 1, 2, 3), t2.abab, (0, 2, 3, 4), (1, 4))
    tmp122 = einsum(t2.abab, (0, 1, 2, 3), tmp45, (4, 0, 1, 3), (4, 2))
    tmp120 = einsum(t2.bbbb, (0, 1, 2, 3), tmp119, (4, 1, 0, 3), (4, 2))
    tmp117 = einsum(tmp41, (0, 1, 2, 3), t2.aaaa, (2, 1, 4, 3), (0, 4))
    tmp115 = einsum(t2.abab, (0, 1, 2, 3), tmp39, (4, 2), (0, 4, 1, 3))
    tmp113 = einsum(t2.aaaa, (0, 1, 2, 3), tmp39, (4, 3), (0, 1, 4, 2))
    tmp111 = einsum(t2.abab, (0, 1, 2, 3), tmp32, (4, 2), (0, 4, 1, 3))
    tmp109 = einsum(tmp32, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp107 = einsum(tmp82, (0, 1), t2.abab, (2, 3, 1, 4), (2, 0, 3, 4))
    tmp105 = einsum(t2.aaaa, (0, 1, 2, 3), tmp82, (4, 3), (0, 1, 4, 2))
    tmp103 = einsum(tmp38, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp101 = einsum(t2.abab, (0, 1, 2, 3), tmp38, (1, 3), (0, 2))
    tmp100 = einsum(t2.abab, (0, 1, 2, 3), tmp39, (0, 2), (1, 3))
    tmp98 = einsum(tmp39, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp96 = einsum(tmp36, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp94 = einsum(t2.abab, (0, 1, 2, 3), tmp36, (1, 3), (0, 2))
    tmp92 = einsum(tmp89, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp90 = einsum(t2.abab, (0, 1, 2, 3), tmp89, (1, 3), (0, 2))
    del tmp89
    tmp88 = einsum(t2.abab, (0, 1, 2, 3), tmp32, (0, 2), (1, 3))
    tmp86 = einsum(t2.aaaa, (0, 1, 2, 3), tmp32, (1, 3), (0, 2))
    tmp85 = einsum(t2.abab, (0, 1, 2, 3), tmp82, (0, 2), (1, 3))
    tmp83 = einsum(tmp82, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    del tmp82
    tmp80 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovvv, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp78 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 5, 3, 1), (4, 5, 0, 2)) * -1
    tmp76 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 1, 3), (0, 4))
    tmp74 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovvv, (0, 2, 4, 3), (1, 4))
    tmp72 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.bbbb, (4, 0, 3, 1), (4, 2)) * -1
    tmp70 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovvv, (1, 3, 4, 2), (0, 4)) * -1
    tmp68 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp66 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp65 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (4, 3, 1, 5), (4, 0, 2, 5))
    tmp64 = einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ooov, (4, 5, 0, 2), (4, 5, 1, 3))
    tmp62 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp61 = einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ooov, (4, 0, 5, 2), (4, 5, 1, 3))
    tmp59 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp57 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 0, 1, 3), (4, 2))
    tmp55 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 3, 1, 4), (2, 4))
    tmp53 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 0, 1, 3), (4, 2))
    tmp51 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 0, 1, 3), (4, 2))
    tmp46 = einsum(v.aabb.oovv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp43 = einsum(t1.aa, (0, 1), v.aaaa.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp37 = einsum(v.bbbb.oovv, (0, 1, 2, 3), t1.bb, (1, 3), (0, 2))
    tmp34 = einsum(v.aaaa.oovv, (0, 1, 2, 3), t1.aa, (1, 3), (0, 2))
    tmp30 = einsum(v.aabb.oooo, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp28 = einsum(v.aaaa.oooo, (0, 1, 2, 3), t1.aa, (3, 4), (0, 1, 2, 4))
    tmp22 = einsum(tmp21, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp19 = einsum(t1.aa, (0, 1), tmp1, (0, 2), (2, 1))
    tmp17 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (4, 2), (4, 0, 1, 3))
    tmp15 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp13 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp11 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp10 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (0, 2), (1, 3))
    tmp8 = einsum(t2.aaaa, (0, 1, 2, 3), f.aa.ov, (1, 3), (0, 2))
    tmp7 = einsum(f.bb.vv, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp5 = einsum(t1.aa, (0, 1), f.aa.vv, (2, 1), (0, 2))
    tmp4 = einsum(t1.bb, (0, 1), f.bb.oo, (2, 0), (2, 1))
    tmp2 = einsum(f.aa.oo, (0, 1), t1.aa, (1, 2), (0, 2))

    return {f"tmp1": tmp1, f"tmp10": tmp10, f"tmp100": tmp100, f"tmp101": tmp101, f"tmp103": tmp103, f"tmp105": tmp105, f"tmp107": tmp107, f"tmp109": tmp109, f"tmp11": tmp11, f"tmp111": tmp111, f"tmp113": tmp113, f"tmp115": tmp115, f"tmp117": tmp117, f"tmp119": tmp119, f"tmp120": tmp120, f"tmp122": tmp122, f"tmp124": tmp124, f"tmp125": tmp125, f"tmp127": tmp127, f"tmp129": tmp129, f"tmp13": tmp13, f"tmp130": tmp130, f"tmp132": tmp132, f"tmp133": tmp133, f"tmp135": tmp135, f"tmp137": tmp137, f"tmp138": tmp138, f"tmp140": tmp140, f"tmp141": tmp141, f"tmp143": tmp143, f"tmp144": tmp144, f"tmp146": tmp146, f"tmp148": tmp148, f"tmp149": tmp149, f"tmp15": tmp15, f"tmp151": tmp151, f"tmp152": tmp152, f"tmp154": tmp154, f"tmp155": tmp155, f"tmp156": tmp156, f"tmp157": tmp157, f"tmp159": tmp159, f"tmp161": tmp161, f"tmp162": tmp162, f"tmp163": tmp163, f"tmp164": tmp164, f"tmp165": tmp165, f"tmp167": tmp167, f"tmp168": tmp168, f"tmp17": tmp17, f"tmp170": tmp170, f"tmp172": tmp172, f"tmp175": tmp175, f"tmp177": tmp177, f"tmp179": tmp179, f"tmp182": tmp182, f"tmp185": tmp185, f"tmp187": tmp187, f"tmp189": tmp189, f"tmp19": tmp19, f"tmp191": tmp191, f"tmp194": tmp194, f"tmp197": tmp197, f"tmp199": tmp199, f"tmp2": tmp2, f"tmp201": tmp201, f"tmp203": tmp203, f"tmp204": tmp204, f"tmp205": tmp205, f"tmp206": tmp206, f"tmp207": tmp207, f"tmp209": tmp209, f"tmp21": tmp21, f"tmp210": tmp210, f"tmp212": tmp212, f"tmp215": tmp215, f"tmp22": tmp22, f"tmp223": tmp223, f"tmp225": tmp225, f"tmp230": tmp230, f"tmp232": tmp232, f"tmp238": tmp238, f"tmp240": tmp240, f"tmp247": tmp247, f"tmp248": tmp248, f"tmp25": tmp25, f"tmp250": tmp250, f"tmp251": tmp251, f"tmp253": tmp253, f"tmp254": tmp254, f"tmp256": tmp256, f"tmp26": tmp26, f"tmp262": tmp262, f"tmp264": tmp264, f"tmp27": tmp27, f"tmp275": tmp275, f"tmp277": tmp277, f"tmp279": tmp279, f"tmp28": tmp28, f"tmp281": tmp281, f"tmp283": tmp283, f"tmp285": tmp285, f"tmp291": tmp291, f"tmp292": tmp292, f"tmp294": tmp294, f"tmp295": tmp295, f"tmp297": tmp297, f"tmp299": tmp299, f"tmp30": tmp30, f"tmp301": tmp301, f"tmp306": tmp306, f"tmp307": tmp307, f"tmp309": tmp309, f"tmp315": tmp315, f"tmp317": tmp317, f"tmp319": tmp319, f"tmp32": tmp32, f"tmp320": tmp320, f"tmp325": tmp325, f"tmp328": tmp328, f"tmp334": tmp334, f"tmp336": tmp336, f"tmp34": tmp34, f"tmp341": tmp341, f"tmp343": tmp343, f"tmp345": tmp345, f"tmp347": tmp347, f"tmp349": tmp349, f"tmp351": tmp351, f"tmp36": tmp36, f"tmp367": tmp367, f"tmp369": tmp369, f"tmp37": tmp37, f"tmp38": tmp38, f"tmp39": tmp39, f"tmp390": tmp390, f"tmp392": tmp392, f"tmp394": tmp394, f"tmp396": tmp396, f"tmp398": tmp398, f"tmp4": tmp4, f"tmp400": tmp400, f"tmp402": tmp402, f"tmp41": tmp41, f"tmp412": tmp412, f"tmp414": tmp414, f"tmp416": tmp416, f"tmp43": tmp43, f"tmp45": tmp45, f"tmp46": tmp46, f"tmp47": tmp47, f"tmp49": tmp49, f"tmp5": tmp5, f"tmp51": tmp51, f"tmp53": tmp53, f"tmp55": tmp55, f"tmp57": tmp57, f"tmp59": tmp59, f"tmp61": tmp61, f"tmp62": tmp62, f"tmp64": tmp64, f"tmp65": tmp65, f"tmp66": tmp66, f"tmp68": tmp68, f"tmp7": tmp7, f"tmp70": tmp70, f"tmp72": tmp72, f"tmp74": tmp74, f"tmp76": tmp76, f"tmp78": tmp78, f"tmp8": tmp8, f"tmp80": tmp80, f"tmp83": tmp83, f"tmp85": tmp85, f"tmp86": tmp86, f"tmp88": tmp88, f"tmp90": tmp90, f"tmp92": tmp92, f"tmp94": tmp94, f"tmp96": tmp96, f"tmp98": tmp98}

def hbar_lmatvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:43:17.655000.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp35 = einsum(r2.aba, (0, 1, 2), t2.abab, (0, 1, 2, 3), (3,))
    tmp36 = einsum(r2.bbb, (0, 1, 2), t2.bbbb, (0, 1, 3, 2), (3,))
    tmp53 = np.copy(tmp35) * -0.5
    tmp53 += tmp36
    tmp55 = np.copy(ints.tmp140) * 2
    tmp55 += ints.tmp143
    tmp51 = np.copy(ints.tmp398)
    tmp51 += ints.tmp402 * 0.5
    tmp60 = np.copy(ints.tmp396)
    tmp60 += ints.tmp400 * 2
    tmp62 = np.copy(f.bb.oo)
    tmp62 += np.transpose(ints.tmp21, (1, 0))
    tmp23 = einsum(t2.abab, (0, 1, 2, 3), r2.bab, (1, 0, 3), (2,)) * -1
    tmp25 = np.copy(f.aa.oo)
    tmp25 += np.transpose(ints.tmp1, (1, 0))
    tmp12 = np.copy(ints.tmp345)
    tmp12 += ints.tmp349 * 0.5
    tmp10 = einsum(r2.aaa, (0, 1, 2), t2.aaaa, (0, 1, 3, 2), (3,))
    tmp14 = np.copy(ints.tmp347)
    tmp14 += ints.tmp351 * 2
    tmp16 = np.copy(ints.tmp47) * 2
    tmp16 += ints.tmp49
    tmp54 = einsum(tmp53, (0,), v.bbbb.ovov, (1, 0, 2, 3), (1, 2, 3)) * 2
    del tmp53
    tmp56 = einsum(r2.bbb, (0, 1, 2), tmp55, (1, 3), (0, 3, 2)) * -2
    del tmp55
    tmp50 = einsum(r2.bbb, (0, 1, 2), v.bbbb.oovv, (3, 1, 4, 2), (0, 3, 4))
    tmp49 = einsum(r2.aba, (0, 1, 2), v.aabb.ovov, (0, 2, 3, 4), (1, 3, 4))
    tmp52 = einsum(r2.bbb, (0, 1, 2), tmp51, (1, 3, 2, 4), (0, 3, 4)) * -4
    del tmp51
    tmp47 = einsum(v.bbbb.ooov, (0, 1, 2, 3), r1.b, (1,), (0, 2, 3))
    tmp48 = einsum(r2.aba, (0, 1, 2), ints.tmp392, (0, 3, 2, 4), (3, 1, 4))
    tmp44 = einsum(t1.bb, (0, 1), f.bb.ov, (0, 2), (2, 1))
    tmp58 = einsum(ints.tmp394, (0, 1, 2, 3), r2.bbb, (4, 0, 2), (1, 4, 3))
    tmp61 = einsum(r2.aba, (0, 1, 2), tmp60, (0, 3, 2, 4), (1, 3, 4))
    del tmp60
    tmp63 = einsum(tmp62, (0, 1), r2.bbb, (2, 0, 3), (2, 1, 3)) * -1
    del tmp62
    tmp59 = einsum(r2.bbb, (0, 1, 2), v.bbbb.ovov, (3, 4, 1, 2), (0, 3, 4))
    tmp29 = einsum(t1.aa, (0, 1), f.aa.ov, (0, 2), (2, 1))
    tmp21 = einsum(r2.bab, (0, 1, 2), ints.tmp343, (3, 0, 4, 2), (3, 1, 4)) * -1
    tmp22 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.bab, (2, 4, 3), (4, 0, 1)) * -1
    tmp24 = einsum(tmp23, (0,), v.aaaa.ovov, (1, 2, 3, 0), (1, 3, 2))
    tmp20 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r2.aaa, (4, 2, 3), (4, 0, 1))
    tmp19 = einsum(r2.aaa, (0, 1, 2), ints.tmp341, (1, 3, 2, 4), (3, 0, 4))
    tmp26 = einsum(tmp25, (0, 1), r2.aaa, (2, 0, 3), (2, 1, 3)) * -1
    del tmp25
    tmp13 = einsum(tmp12, (0, 1, 2, 3), r2.aaa, (4, 0, 2), (4, 1, 3)) * -4
    del tmp12
    tmp11 = einsum(tmp10, (0,), v.aaaa.ovov, (1, 2, 3, 0), (1, 3, 2)) * -1
    tmp15 = einsum(r2.bab, (0, 1, 2), tmp14, (3, 0, 4, 2), (1, 3, 4)) * -1
    del tmp14
    tmp17 = einsum(r2.aaa, (0, 1, 2), tmp16, (1, 3), (0, 3, 2)) * -2
    del tmp16
    tmp9 = einsum(r2.aaa, (0, 1, 2), v.aaaa.oovv, (3, 1, 4, 2), (0, 3, 4))
    tmp8 = einsum(r1.a, (0,), v.aaaa.ooov, (1, 0, 2, 3), (1, 2, 3))
    tmp65 = np.copy(ints.tmp306)
    del ints.tmp306
    tmp65 += np.transpose(v.bbbb.oooo, (0, 2, 3, 1)) * -1
    tmp57 = einsum(r1.b, (0,), f.bb.ov, (1, 2), (1, 0, 2))
    tmp57 += tmp47
    del tmp47
    tmp57 += tmp48
    del tmp48
    tmp57 += tmp49
    del tmp49
    tmp57 += tmp50 * 2
    del tmp50
    tmp57 += np.transpose(tmp52, (1, 0, 2)) * -1
    del tmp52
    tmp57 += np.transpose(tmp54, (1, 0, 2)) * -1
    del tmp54
    tmp57 += np.transpose(tmp56, (1, 0, 2))
    del tmp56
    tmp45 = np.copy(ints.tmp412) * 2
    del ints.tmp412
    tmp45 += ints.tmp414
    del ints.tmp414
    tmp45 += f.bb.vv * -1
    tmp45 += np.transpose(tmp44, (1, 0))
    del tmp44
    tmp64 = np.copy(tmp58) * 4
    del tmp58
    tmp64 += tmp59 * 2
    del tmp59
    tmp64 += np.transpose(tmp61, (1, 0, 2))
    del tmp61
    tmp64 += np.transpose(tmp63, (1, 0, 2)) * -2
    del tmp63
    tmp39 = np.copy(f.bb.oo)
    tmp39 += ints.tmp140 * 2
    tmp39 += ints.tmp143
    tmp39 += np.transpose(ints.tmp21, (1, 0))
    tmp41 = np.copy(ints.tmp396)
    del ints.tmp396
    tmp41 += ints.tmp400 * 2
    del ints.tmp400
    tmp41 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp41 += ints.tmp392 * -1
    del ints.tmp392
    tmp42 = np.copy(ints.tmp416)
    del ints.tmp416
    tmp42 += v.aabb.oovv * -1
    tmp38 = np.copy(f.aa.oo)
    tmp38 += np.transpose(ints.tmp1, (1, 0))
    tmp38 += ints.tmp47 * 2
    tmp38 += ints.tmp49
    tmp46 = np.copy(tmp10)
    del tmp10
    tmp46 += tmp23 * 0.5
    del tmp23
    tmp40 = np.copy(ints.tmp398) * 2
    del ints.tmp398
    tmp40 += ints.tmp402
    del ints.tmp402
    tmp40 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    tmp40 += ints.tmp394 * -2
    del ints.tmp394
    tmp40 += v.bbbb.oovv * -1
    tmp43 = np.copy(ints.tmp151)
    tmp43 += v.aabb.oooo
    tmp32 = np.copy(ints.tmp347)
    del ints.tmp347
    tmp32 += ints.tmp351 * 2
    del ints.tmp351
    tmp32 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp32 += ints.tmp343 * -1
    del ints.tmp343
    tmp33 = np.copy(ints.tmp390)
    del ints.tmp390
    tmp33 += np.transpose(v.aabb.vvoo, (2, 3, 0, 1)) * -1
    tmp31 = np.copy(ints.tmp345) * 2
    del ints.tmp345
    tmp31 += ints.tmp349
    del ints.tmp349
    tmp31 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp31 += ints.tmp341 * -2
    del ints.tmp341
    tmp31 += v.aaaa.oovv * -1
    tmp30 = np.copy(ints.tmp367) * 2
    del ints.tmp367
    tmp30 += ints.tmp369
    del ints.tmp369
    tmp30 += f.aa.vv * -1
    tmp30 += np.transpose(tmp29, (1, 0))
    del tmp29
    tmp34 = np.copy(ints.tmp151)
    del ints.tmp151
    tmp34 += v.aabb.oooo
    tmp37 = np.copy(tmp35) * -1
    del tmp35
    tmp37 += tmp36 * 2
    del tmp36
    tmp27 = np.copy(tmp19) * 4
    del tmp19
    tmp27 += tmp20 * 2
    del tmp20
    tmp27 += tmp21
    del tmp21
    tmp27 += tmp22
    del tmp22
    tmp27 += tmp24
    del tmp24
    tmp27 += np.transpose(tmp26, (1, 0, 2)) * -2
    del tmp26
    tmp18 = einsum(r1.a, (0,), f.aa.ov, (1, 2), (1, 0, 2))
    tmp18 += tmp8
    del tmp8
    tmp18 += tmp9 * 2
    del tmp9
    tmp18 += tmp11 * 2
    del tmp11
    tmp18 += np.transpose(tmp13, (1, 0, 2)) * -1
    del tmp13
    tmp18 += np.transpose(tmp15, (1, 0, 2))
    del tmp15
    tmp18 += np.transpose(tmp17, (1, 0, 2))
    del tmp17
    tmp28 = np.copy(ints.tmp148)
    del ints.tmp148
    tmp28 += np.transpose(v.aaaa.oooo, (0, 2, 3, 1)) * -1
    tmp7 = np.copy(f.bb.oo)
    tmp7 += ints.tmp140 * 2
    del ints.tmp140
    tmp7 += ints.tmp143
    del ints.tmp143
    tmp7 += np.transpose(ints.tmp163, (1, 0))
    del ints.tmp163
    tmp7 += np.transpose(ints.tmp167, (1, 0))
    del ints.tmp167
    tmp7 += ints.tmp205
    del ints.tmp205
    tmp7 += ints.tmp209
    del ints.tmp209
    tmp7 += np.transpose(ints.tmp21, (1, 0))
    del ints.tmp21
    tmp7 += ints.tmp161 * -1
    del ints.tmp161
    tmp7 += ints.tmp203 * -1
    del ints.tmp203
    tmp3 = np.copy(ints.tmp117)
    del ints.tmp117
    tmp3 += ints.tmp122 * 0.5
    del ints.tmp122
    tmp3 += ints.tmp138
    del ints.tmp138
    tmp3 += ints.tmp146 * 0.5
    del ints.tmp146
    tmp3 += ints.tmp159 * 0.5
    del ints.tmp159
    tmp3 += ints.tmp165 * 0.5
    del ints.tmp165
    tmp3 += ints.tmp182 * 0.5
    del ints.tmp182
    tmp3 += ints.tmp19 * 0.5
    del ints.tmp19
    tmp3 += ints.tmp201 * 0.5
    del ints.tmp201
    tmp3 += ints.tmp207 * 0.5
    del ints.tmp207
    tmp3 += ints.tmp2 * 0.5
    del ints.tmp2
    tmp3 += ints.tmp34 * 0.5
    del ints.tmp34
    tmp3 += ints.tmp51
    del ints.tmp51
    tmp3 += ints.tmp57 * 0.5
    del ints.tmp57
    tmp3 += ints.tmp70
    del ints.tmp70
    tmp3 += ints.tmp83
    del ints.tmp83
    tmp3 += ints.tmp90 * 0.5
    del ints.tmp90
    tmp3 += f.aa.ov * -0.5
    tmp3 += ints.tmp101 * -0.5
    del ints.tmp101
    tmp3 += ints.tmp11 * -0.5
    del ints.tmp11
    tmp3 += ints.tmp157 * -0.5
    del ints.tmp157
    tmp3 += ints.tmp179 * -0.5
    del ints.tmp179
    tmp3 += ints.tmp191 * -0.5
    del ints.tmp191
    tmp3 += ints.tmp199 * -0.5
    del ints.tmp199
    tmp3 += ints.tmp32 * -0.5
    del ints.tmp32
    tmp3 += ints.tmp39 * -0.5
    del ints.tmp39
    tmp3 += ints.tmp5 * -0.5
    del ints.tmp5
    tmp3 += ints.tmp76 * -0.5
    del ints.tmp76
    tmp3 += ints.tmp86 * -1
    del ints.tmp86
    tmp3 += ints.tmp8 * -1
    del ints.tmp8
    tmp3 += ints.tmp94 * -0.5
    del ints.tmp94
    tmp3 += ints.tmp98 * -1
    del ints.tmp98
    tmp5 = np.copy(ints.tmp124)
    del ints.tmp124
    tmp5 += np.transpose(ints.tmp223, (0, 2, 1, 3))
    del ints.tmp223
    tmp5 += np.transpose(ints.tmp240, (0, 2, 1, 3))
    del ints.tmp240
    tmp5 += np.transpose(ints.tmp250, (0, 2, 1, 3))
    del ints.tmp250
    tmp5 += np.transpose(ints.tmp254, (0, 2, 1, 3)) * 2
    del ints.tmp254
    tmp5 += ints.tmp264
    del ints.tmp264
    tmp5 += ints.tmp279
    del ints.tmp279
    tmp5 += ints.tmp283
    del ints.tmp283
    tmp5 += ints.tmp291
    del ints.tmp291
    tmp5 += ints.tmp297 * 2
    del ints.tmp297
    tmp5 += ints.tmp328
    del ints.tmp328
    tmp5 += np.transpose(v.aabb.ovoo, (0, 2, 3, 1))
    tmp5 += np.transpose(ints.tmp232, (0, 2, 1, 3)) * -1
    del ints.tmp232
    tmp5 += ints.tmp247 * -1
    del ints.tmp247
    tmp5 += ints.tmp253 * -1
    del ints.tmp253
    tmp5 += ints.tmp275 * -1
    del ints.tmp275
    tmp5 += ints.tmp294 * -1
    del ints.tmp294
    tmp5 += ints.tmp301 * -1
    del ints.tmp301
    tmp5 += ints.tmp309 * -1
    del ints.tmp309
    tmp5 += ints.tmp319 * -1
    del ints.tmp319
    tmp5 += np.transpose(ints.tmp320, (0, 2, 1, 3)) * -1
    del ints.tmp320
    tmp5 += ints.tmp336 * -1
    del ints.tmp336
    tmp2 = np.copy(ints.tmp120)
    del ints.tmp120
    tmp2 += ints.tmp125 * 0.5
    del ints.tmp125
    tmp2 += ints.tmp141
    del ints.tmp141
    tmp2 += ints.tmp144 * 0.5
    del ints.tmp144
    tmp2 += ints.tmp164 * 0.5
    del ints.tmp164
    tmp2 += ints.tmp168 * 0.5
    del ints.tmp168
    tmp2 += ints.tmp187 * 0.5
    del ints.tmp187
    tmp2 += ints.tmp206 * 0.5
    del ints.tmp206
    tmp2 += ints.tmp210 * 0.5
    del ints.tmp210
    tmp2 += ints.tmp22 * 0.5
    del ints.tmp22
    tmp2 += ints.tmp37 * 0.5
    del ints.tmp37
    tmp2 += ints.tmp4 * 0.5
    del ints.tmp4
    tmp2 += ints.tmp53
    del ints.tmp53
    tmp2 += ints.tmp55 * 0.5
    del ints.tmp55
    tmp2 += ints.tmp72
    del ints.tmp72
    tmp2 += ints.tmp85 * 0.5
    del ints.tmp85
    tmp2 += ints.tmp92
    del ints.tmp92
    tmp2 += f.bb.ov * -0.5
    tmp2 += ints.tmp100 * -0.5
    del ints.tmp100
    tmp2 += ints.tmp103 * -1
    del ints.tmp103
    tmp2 += ints.tmp10 * -0.5
    del ints.tmp10
    tmp2 += ints.tmp13 * -1
    del ints.tmp13
    tmp2 += ints.tmp162 * -0.5
    del ints.tmp162
    tmp2 += ints.tmp185 * -0.5
    del ints.tmp185
    tmp2 += ints.tmp189 * -0.5
    del ints.tmp189
    tmp2 += ints.tmp204 * -0.5
    del ints.tmp204
    tmp2 += ints.tmp36 * -0.5
    del ints.tmp36
    tmp2 += ints.tmp38 * -0.5
    del ints.tmp38
    tmp2 += ints.tmp74 * -0.5
    del ints.tmp74
    tmp2 += ints.tmp7 * -0.5
    del ints.tmp7
    tmp2 += ints.tmp88 * -0.5
    del ints.tmp88
    tmp2 += ints.tmp96 * -1
    del ints.tmp96
    tmp6 = np.copy(np.transpose(ints.tmp225, (1, 2, 0, 3)))
    del ints.tmp225
    tmp6 += np.transpose(ints.tmp230, (1, 2, 0, 3))
    del ints.tmp230
    tmp6 += np.transpose(ints.tmp238, (0, 2, 1, 3))
    del ints.tmp238
    tmp6 += np.transpose(ints.tmp251, (0, 2, 1, 3)) * 2
    del ints.tmp251
    tmp6 += np.transpose(ints.tmp256, (0, 2, 1, 3))
    del ints.tmp256
    tmp6 += ints.tmp281
    del ints.tmp281
    tmp6 += ints.tmp285
    del ints.tmp285
    tmp6 += ints.tmp295 * 2
    del ints.tmp295
    tmp6 += ints.tmp307
    del ints.tmp307
    tmp6 += ints.tmp315
    del ints.tmp315
    tmp6 += ints.tmp334
    del ints.tmp334
    tmp6 += ints.tmp119 * -1
    del ints.tmp119
    tmp6 += ints.tmp248 * -2
    del ints.tmp248
    tmp6 += ints.tmp262 * -1
    del ints.tmp262
    tmp6 += ints.tmp277 * -1
    del ints.tmp277
    tmp6 += ints.tmp292 * -2
    del ints.tmp292
    tmp6 += ints.tmp299 * -1
    del ints.tmp299
    tmp6 += np.transpose(ints.tmp317, (0, 2, 1, 3)) * -1
    del ints.tmp317
    tmp6 += ints.tmp325 * -1
    del ints.tmp325
    tmp6 += np.transpose(v.bbbb.ooov, (0, 2, 1, 3)) * -1
    tmp4 = np.copy(f.aa.oo)
    tmp4 += ints.tmp155
    del ints.tmp155
    tmp4 += ints.tmp156
    del ints.tmp156
    tmp4 += np.transpose(ints.tmp1, (1, 0))
    del ints.tmp1
    tmp4 += np.transpose(ints.tmp26, (1, 0))
    del ints.tmp26
    tmp4 += np.transpose(ints.tmp27, (1, 0))
    del ints.tmp27
    tmp4 += ints.tmp47 * 2
    del ints.tmp47
    tmp4 += ints.tmp49
    del ints.tmp49
    tmp4 += ints.tmp154 * -1
    del ints.tmp154
    tmp4 += ints.tmp25 * -1
    del ints.tmp25
    tmp0 = np.copy(ints.tmp111)
    del ints.tmp111
    tmp0 += ints.tmp115
    del ints.tmp115
    tmp0 += ints.tmp129
    del ints.tmp129
    tmp0 += ints.tmp135 * 2
    del ints.tmp135
    tmp0 += np.transpose(ints.tmp17, (1, 0, 2, 3))
    del ints.tmp17
    tmp0 += ints.tmp197
    del ints.tmp197
    tmp0 += ints.tmp45
    del ints.tmp45
    tmp0 += np.transpose(ints.tmp46, (1, 0, 2, 3))
    del ints.tmp46
    tmp0 += np.transpose(ints.tmp64, (1, 0, 2, 3))
    del ints.tmp64
    tmp0 += np.transpose(ints.tmp68, (1, 0, 2, 3)) * 2
    del ints.tmp68
    tmp0 += ints.tmp80
    del ints.tmp80
    tmp0 += v.aabb.ooov
    tmp0 += ints.tmp107 * -1
    del ints.tmp107
    tmp0 += ints.tmp132 * -1
    del ints.tmp132
    tmp0 += ints.tmp137 * -1
    del ints.tmp137
    tmp0 += ints.tmp152 * -1
    del ints.tmp152
    tmp0 += ints.tmp175 * -1
    del ints.tmp175
    tmp0 += np.transpose(ints.tmp177, (1, 0, 2, 3)) * -1
    del ints.tmp177
    tmp0 += ints.tmp215 * -1
    del ints.tmp215
    tmp0 += np.transpose(ints.tmp30, (1, 0, 2, 3)) * -1
    del ints.tmp30
    tmp0 += ints.tmp61 * -1
    del ints.tmp61
    tmp0 += ints.tmp65 * -1
    del ints.tmp65
    tmp1 = np.copy(ints.tmp109)
    del ints.tmp109
    tmp1 += ints.tmp113
    del ints.tmp113
    tmp1 += ints.tmp130 * 2
    del ints.tmp130
    tmp1 += ints.tmp149
    del ints.tmp149
    tmp1 += np.transpose(ints.tmp15, (1, 2, 0, 3))
    del ints.tmp15
    tmp1 += ints.tmp170
    del ints.tmp170
    tmp1 += ints.tmp212
    del ints.tmp212
    tmp1 += np.transpose(ints.tmp28, (1, 2, 0, 3))
    del ints.tmp28
    tmp1 += np.transpose(ints.tmp43, (0, 2, 1, 3))
    del ints.tmp43
    tmp1 += np.transpose(ints.tmp62, (0, 2, 1, 3)) * 2
    del ints.tmp62
    tmp1 += np.transpose(ints.tmp66, (0, 2, 1, 3))
    del ints.tmp66
    tmp1 += ints.tmp105 * -1
    del ints.tmp105
    tmp1 += ints.tmp127 * -2
    del ints.tmp127
    tmp1 += ints.tmp133 * -1
    del ints.tmp133
    tmp1 += np.transpose(ints.tmp172, (0, 2, 1, 3)) * -1
    del ints.tmp172
    tmp1 += ints.tmp194 * -1
    del ints.tmp194
    tmp1 += ints.tmp41 * -1
    del ints.tmp41
    tmp1 += ints.tmp59 * -2
    del ints.tmp59
    tmp1 += ints.tmp78 * -1
    del ints.tmp78
    tmp1 += np.transpose(v.aaaa.ooov, (0, 2, 1, 3)) * -1
    r2new.bbb = np.copy(tmp57) * -1
    r2new.bbb += np.transpose(tmp57, (1, 0, 2))
    del tmp57
    r2new.bbb += tmp64
    r2new.bbb += np.transpose(tmp64, (1, 0, 2)) * -1
    del tmp64
    r2new.bbb += einsum(tmp65, (0, 1, 2, 3), r2.bbb, (0, 1, 4), (2, 3, 4)) * 2
    del tmp65
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp45, (2, 3), (0, 1, 3)) * -2
    r2new.bab = einsum(f.bb.ov, (0, 1), r1.a, (2,), (0, 2, 1)) * -1
    r2new.bab += einsum(r1.a, (0,), v.aabb.ooov, (1, 0, 2, 3), (2, 1, 3))
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp40, (0, 3, 2, 4), (3, 1, 4))
    del tmp40
    r2new.bab += einsum(r2.aaa, (0, 1, 2), tmp41, (1, 3, 2, 4), (3, 0, 4)) * -2
    del tmp41
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp42, (1, 3, 2, 4), (0, 3, 4))
    del tmp42
    r2new.bab += einsum(tmp43, (0, 1, 2, 3), r2.bab, (2, 0, 4), (3, 1, 4))
    del tmp43
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp45, (2, 3), (0, 1, 3)) * -1
    del tmp45
    r2new.bab += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp46, (1,), (2, 0, 3)) * 2
    del tmp46
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp38, (1, 3), (0, 3, 2)) * -1
    r2new.bab += einsum(tmp39, (0, 1), r2.bab, (0, 2, 3), (1, 2, 3)) * -1
    r2new.aba = einsum(r1.b, (0,), f.aa.ov, (1, 2), (1, 0, 2)) * -1
    r2new.aba += einsum(r1.b, (0,), v.aabb.ovoo, (1, 2, 3, 0), (1, 3, 2))
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp31, (0, 3, 2, 4), (3, 1, 4))
    del tmp31
    r2new.aba += einsum(r2.bbb, (0, 1, 2), tmp32, (3, 1, 4, 2), (3, 0, 4)) * -2
    del tmp32
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp33, (1, 3, 2, 4), (0, 3, 4))
    del tmp33
    r2new.aba += einsum(tmp34, (0, 1, 2, 3), r2.aba, (0, 2, 4), (1, 3, 4))
    del tmp34
    r2new.aba += einsum(tmp30, (0, 1), r2.aba, (2, 3, 0), (2, 3, 1)) * -1
    r2new.aba += einsum(tmp37, (0,), v.aabb.ovov, (1, 2, 3, 0), (1, 3, 2))
    del tmp37
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp38, (0, 3), (3, 1, 2)) * -1
    del tmp38
    r2new.aba += einsum(tmp39, (0, 1), r2.aba, (2, 0, 3), (2, 1, 3)) * -1
    del tmp39
    r2new.aaa = np.copy(tmp18) * -1
    r2new.aaa += np.transpose(tmp18, (1, 0, 2))
    del tmp18
    r2new.aaa += tmp27
    r2new.aaa += np.transpose(tmp27, (1, 0, 2)) * -1
    del tmp27
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp28, (0, 1, 3, 4), (3, 4, 2)) * 2
    del tmp28
    r2new.aaa += einsum(tmp30, (0, 1), r2.aaa, (2, 3, 0), (2, 3, 1)) * -2
    del tmp30
    r1new.b = einsum(tmp5, (0, 1, 2, 3), r2.aba, (0, 1, 3), (2,))
    del tmp5
    r1new.b += einsum(r2.bbb, (0, 1, 2), tmp6, (1, 0, 3, 2), (3,)) * -2
    del tmp6
    r1new.b += einsum(r2.aba, (0, 1, 2), tmp3, (0, 2), (1,)) * 2
    r1new.b += einsum(r2.bbb, (0, 1, 2), tmp2, (1, 2), (0,)) * -4
    r1new.b += einsum(r1.b, (0,), tmp7, (0, 1), (1,)) * -1
    del tmp7
    r1new.a = einsum(tmp0, (0, 1, 2, 3), r2.bab, (2, 0, 3), (1,))
    del tmp0
    r1new.a += einsum(tmp1, (0, 1, 2, 3), r2.aaa, (1, 0, 3), (2,)) * -2
    del tmp1
    r1new.a += einsum(r2.bab, (0, 1, 2), tmp2, (0, 2), (1,)) * 2
    del tmp2
    r1new.a += einsum(r2.aaa, (0, 1, 2), tmp3, (1, 2), (0,)) * -4
    del tmp3
    r1new.a += einsum(r1.a, (0,), tmp4, (0, 1), (1,)) * -1
    del tmp4

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ea_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:46:05.771922.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp10 : array
    tmp100 : array
    tmp101 : array
    tmp103 : array
    tmp11 : array
    tmp111 : array
    tmp112 : array
    tmp114 : array
    tmp115 : array
    tmp117 : array
    tmp118 : array
    tmp120 : array
    tmp121 : array
    tmp123 : array
    tmp125 : array
    tmp127 : array
    tmp128 : array
    tmp13 : array
    tmp130 : array
    tmp131 : array
    tmp133 : array
    tmp134 : array
    tmp136 : array
    tmp137 : array
    tmp139 : array
    tmp141 : array
    tmp142 : array
    tmp144 : array
    tmp145 : array
    tmp147 : array
    tmp149 : array
    tmp151 : array
    tmp154 : array
    tmp157 : array
    tmp159 : array
    tmp161 : array
    tmp164 : array
    tmp169 : array
    tmp171 : array
    tmp173 : array
    tmp174 : array
    tmp175 : array
    tmp176 : array
    tmp177 : array
    tmp178 : array
    tmp179 : array
    tmp181 : array
    tmp183 : array
    tmp185 : array
    tmp186 : array
    tmp188 : array
    tmp19 : array
    tmp191 : array
    tmp194 : array
    tmp196 : array
    tmp198 : array
    tmp2 : array
    tmp20 : array
    tmp201 : array
    tmp22 : array
    tmp226 : array
    tmp228 : array
    tmp23 : array
    tmp230 : array
    tmp232 : array
    tmp238 : array
    tmp240 : array
    tmp246 : array
    tmp247 : array
    tmp249 : array
    tmp250 : array
    tmp252 : array
    tmp254 : array
    tmp256 : array
    tmp26 : array
    tmp27 : array
    tmp276 : array
    tmp278 : array
    tmp28 : array
    tmp284 : array
    tmp285 : array
    tmp287 : array
    tmp288 : array
    tmp29 : array
    tmp290 : array
    tmp292 : array
    tmp294 : array
    tmp305 : array
    tmp307 : array
    tmp309 : array
    tmp31 : array
    tmp310 : array
    tmp33 : array
    tmp34 : array
    tmp35 : array
    tmp36 : array
    tmp4 : array
    tmp43 : array
    tmp45 : array
    tmp47 : array
    tmp49 : array
    tmp5 : array
    tmp51 : array
    tmp53 : array
    tmp55 : array
    tmp57 : array
    tmp59 : array
    tmp61 : array
    tmp63 : array
    tmp65 : array
    tmp67 : array
    tmp69 : array
    tmp7 : array
    tmp71 : array
    tmp73 : array
    tmp74 : array
    tmp76 : array
    tmp77 : array
    tmp79 : array
    tmp8 : array
    tmp81 : array
    tmp82 : array
    tmp83 : array
    tmp85 : array
    tmp86 : array
    tmp88 : array
    tmp89 : array
    tmp90 : array
    tmp92 : array
    tmp94 : array
    tmp96 : array
    tmp98 : array
    """

    tmp35 = einsum(t1.aa, (0, 1), v.aabb.ovov, (0, 1, 2, 3), (2, 3))
    tmp36 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp33 = einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 3, 0, 1), (2, 3))
    tmp89 = einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 1, 0, 3), (2, 3))
    tmp29 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    tmp82 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 1), (0, 3))
    tmp117 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp114 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 2, 1))
    tmp200 = einsum(tmp35, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp197 = einsum(t1.aa, (0, 1), tmp36, (2, 1), (0, 2))
    tmp195 = einsum(tmp33, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp193 = einsum(tmp89, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp190 = einsum(t1.aa, (0, 1), tmp29, (2, 1), (0, 2))
    tmp187 = einsum(t1.aa, (0, 1), tmp82, (2, 1), (0, 2))
    tmp28 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp177 = einsum(t1.aa, (0, 1), v.aabb.ovvv, (0, 1, 2, 3), (2, 3))
    tmp175 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (0, 3), (1, 2))
    tmp173 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (0, 1), (2, 3))
    tmp27 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    tmp26 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp163 = einsum(t1.aa, (0, 1), v.aabb.ovoo, (0, 1, 2, 3), (2, 3))
    tmp160 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp158 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp156 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t1.bb, (1, 3), (0, 2))
    tmp153 = einsum(t1.aa, (0, 1), v.aaaa.ooov, (2, 3, 0, 1), (2, 3))
    tmp150 = einsum(t1.aa, (0, 1), v.aaaa.ooov, (2, 0, 3, 1), (2, 3))
    tmp136 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp133 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 3), (1, 4))
    tmp130 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp127 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 1, 3), (4, 0))
    tmp120 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 2, 1))
    tmp111 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 2, 1))
    tmp22 = einsum(t1.bb, (0, 1), f.bb.ov, (2, 1), (2, 0))
    tmp19 = einsum(t1.aa, (0, 1), f.aa.ov, (2, 1), (2, 0))
    tmp310 = einsum(t1.aa, (0, 1), v.aabb.vvov, (2, 1, 3, 4), (0, 3, 2, 4))
    tmp309 = einsum(t1.aa, (0, 1), v.aabb.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp307 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp305 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (4, 1), (4, 0, 2, 3))
    tmp294 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp292 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 5), (1, 4, 3, 5))
    tmp290 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 2, 5, 3))
    tmp288 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp287 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp285 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp284 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp278 = einsum(t2.abab, (0, 1, 2, 3), tmp117, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp276 = einsum(t2.bbbb, (0, 1, 2, 3), tmp114, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp256 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp254 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovvv, (0, 2, 4, 5), (1, 3, 4, 5))
    tmp252 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 5, 2, 3))
    tmp250 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (1, 4, 5, 3), (0, 2, 4, 5))
    tmp249 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.abab, (4, 0, 5, 3), (4, 5, 1, 2))
    tmp247 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (1, 3, 4, 5), (0, 2, 4, 5))
    tmp246 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.abab, (4, 0, 5, 1), (4, 5, 2, 3))
    tmp240 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp238 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp232 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 4), (3, 4))
    tmp230 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (0, 2, 4, 3), (4, 1))
    tmp228 = einsum(v.aabb.vvvv, (0, 1, 2, 3), t1.aa, (4, 1), (4, 0, 2, 3))
    tmp226 = einsum(t1.bb, (0, 1), v.bbbb.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp201 = einsum(tmp200, (0, 1), t1.bb, (1, 2), (0, 2))
    del tmp200
    tmp198 = einsum(t1.aa, (0, 1), tmp197, (2, 0), (2, 1))
    del tmp197
    tmp196 = einsum(tmp195, (0, 1), t1.bb, (1, 2), (0, 2))
    del tmp195
    tmp194 = einsum(tmp193, (0, 1), t1.bb, (1, 2), (0, 2))
    del tmp193
    tmp191 = einsum(t1.aa, (0, 1), tmp190, (2, 0), (2, 1))
    del tmp190
    tmp188 = einsum(t1.aa, (0, 1), tmp187, (2, 0), (2, 1))
    del tmp187
    tmp186 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 1, 2))
    tmp185 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 2, 0, 1))
    tmp183 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp181 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (4, 1), (4, 0, 2, 3))
    tmp179 = einsum(t1.aa, (0, 1), tmp28, (2, 1), (0, 2))
    tmp178 = einsum(tmp177, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp176 = einsum(tmp175, (0, 1), t1.bb, (2, 0), (2, 1))
    tmp174 = einsum(tmp173, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp171 = einsum(t1.aa, (0, 1), tmp27, (1, 2), (0, 2))
    tmp169 = einsum(tmp26, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp164 = einsum(tmp163, (0, 1), t1.bb, (1, 2), (0, 2))
    del tmp163
    tmp161 = einsum(t1.aa, (0, 1), tmp160, (2, 0), (2, 1))
    del tmp160
    tmp159 = einsum(tmp158, (0, 1), t1.bb, (1, 2), (0, 2))
    del tmp158
    tmp157 = einsum(tmp156, (0, 1), t1.bb, (1, 2), (0, 2))
    del tmp156
    tmp154 = einsum(t1.aa, (0, 1), tmp153, (2, 0), (2, 1))
    del tmp153
    tmp151 = einsum(t1.aa, (0, 1), tmp150, (2, 0), (2, 1))
    del tmp150
    tmp149 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 5, 3), (1, 5, 2, 4))
    tmp147 = einsum(t2.bbbb, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp145 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp144 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 1, 5), (0, 4, 3, 5))
    tmp142 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp141 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 4, 1, 5))
    tmp139 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp137 = einsum(tmp136, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp134 = einsum(tmp133, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp131 = einsum(tmp130, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp128 = einsum(t1.aa, (0, 1), tmp127, (2, 0), (2, 1))
    tmp125 = einsum(tmp120, (0, 1, 2, 3), t2.abab, (0, 2, 4, 5), (1, 4, 3, 5))
    tmp123 = einsum(tmp111, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp121 = einsum(tmp120, (0, 1, 2, 3), t2.abab, (0, 2, 3, 4), (1, 4))
    tmp118 = einsum(t2.abab, (0, 1, 2, 3), tmp117, (4, 0, 1, 3), (4, 2))
    tmp115 = einsum(t2.bbbb, (0, 1, 2, 3), tmp114, (4, 1, 0, 3), (4, 2))
    tmp112 = einsum(tmp111, (0, 1, 2, 3), t2.aaaa, (2, 1, 4, 3), (0, 4))
    tmp103 = einsum(t2.bbbb, (0, 1, 2, 3), tmp35, (1, 3), (0, 2))
    tmp101 = einsum(t2.abab, (0, 1, 2, 3), tmp35, (1, 3), (0, 2))
    tmp100 = einsum(t2.abab, (0, 1, 2, 3), tmp36, (0, 2), (1, 3))
    tmp98 = einsum(tmp36, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp96 = einsum(t2.bbbb, (0, 1, 2, 3), tmp33, (1, 3), (0, 2))
    tmp94 = einsum(t2.abab, (0, 1, 2, 3), tmp33, (1, 3), (0, 2))
    tmp92 = einsum(tmp89, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp90 = einsum(t2.abab, (0, 1, 2, 3), tmp89, (1, 3), (0, 2))
    tmp88 = einsum(t2.abab, (0, 1, 2, 3), tmp29, (0, 2), (1, 3))
    tmp86 = einsum(tmp29, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp85 = einsum(t2.abab, (0, 1, 2, 3), tmp82, (0, 2), (1, 3))
    tmp83 = einsum(tmp82, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp81 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovvv, (0, 4, 5, 3), (1, 2, 4, 5))
    tmp79 = einsum(v.aabb.vvov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp77 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 5, 1, 3), (0, 2, 4, 5))
    tmp76 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (4, 1, 2, 5))
    tmp74 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 5, 1, 2))
    tmp73 = einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ovvv, (0, 2, 4, 5), (1, 4, 5, 3))
    tmp71 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 5, 2, 3))
    tmp69 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 1, 3), (0, 4))
    tmp67 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovvv, (0, 2, 4, 3), (1, 4))
    tmp65 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.bbbb, (4, 0, 3, 1), (4, 2)) * -1
    tmp63 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 1, 3), (4, 2))
    tmp61 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 3, 4, 5), (2, 4, 1, 5))
    tmp59 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp57 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 0, 1, 3), (4, 2))
    tmp55 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 3, 1, 4), (2, 4))
    tmp53 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 0, 1, 3), (4, 2))
    tmp51 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 0, 1, 3), (4, 2))
    tmp49 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 1, 3), (2, 4))
    tmp47 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 4, 1), (4, 3)) * -1
    tmp45 = einsum(v.aabb.vvvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp43 = einsum(v.aaaa.vvvv, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp34 = einsum(v.bbbb.oovv, (0, 1, 2, 3), t1.bb, (1, 3), (0, 2))
    tmp31 = einsum(v.aaaa.oovv, (0, 1, 2, 3), t1.aa, (1, 3), (0, 2))
    tmp23 = einsum(tmp22, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp20 = einsum(t1.aa, (0, 1), tmp19, (0, 2), (2, 1))
    tmp13 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp11 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp10 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (0, 2), (1, 3))
    tmp8 = einsum(t2.aaaa, (0, 1, 2, 3), f.aa.ov, (1, 3), (0, 2))
    tmp7 = einsum(f.bb.vv, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp5 = einsum(f.aa.vv, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp4 = einsum(t1.bb, (0, 1), f.bb.oo, (2, 0), (2, 1))
    tmp2 = einsum(f.aa.oo, (0, 1), t1.aa, (1, 2), (0, 2))

    return {f"tmp10": tmp10, f"tmp100": tmp100, f"tmp101": tmp101, f"tmp103": tmp103, f"tmp11": tmp11, f"tmp111": tmp111, f"tmp112": tmp112, f"tmp114": tmp114, f"tmp115": tmp115, f"tmp117": tmp117, f"tmp118": tmp118, f"tmp120": tmp120, f"tmp121": tmp121, f"tmp123": tmp123, f"tmp125": tmp125, f"tmp127": tmp127, f"tmp128": tmp128, f"tmp13": tmp13, f"tmp130": tmp130, f"tmp131": tmp131, f"tmp133": tmp133, f"tmp134": tmp134, f"tmp136": tmp136, f"tmp137": tmp137, f"tmp139": tmp139, f"tmp141": tmp141, f"tmp142": tmp142, f"tmp144": tmp144, f"tmp145": tmp145, f"tmp147": tmp147, f"tmp149": tmp149, f"tmp151": tmp151, f"tmp154": tmp154, f"tmp157": tmp157, f"tmp159": tmp159, f"tmp161": tmp161, f"tmp164": tmp164, f"tmp169": tmp169, f"tmp171": tmp171, f"tmp173": tmp173, f"tmp174": tmp174, f"tmp175": tmp175, f"tmp176": tmp176, f"tmp177": tmp177, f"tmp178": tmp178, f"tmp179": tmp179, f"tmp181": tmp181, f"tmp183": tmp183, f"tmp185": tmp185, f"tmp186": tmp186, f"tmp188": tmp188, f"tmp19": tmp19, f"tmp191": tmp191, f"tmp194": tmp194, f"tmp196": tmp196, f"tmp198": tmp198, f"tmp2": tmp2, f"tmp20": tmp20, f"tmp201": tmp201, f"tmp22": tmp22, f"tmp226": tmp226, f"tmp228": tmp228, f"tmp23": tmp23, f"tmp230": tmp230, f"tmp232": tmp232, f"tmp238": tmp238, f"tmp240": tmp240, f"tmp246": tmp246, f"tmp247": tmp247, f"tmp249": tmp249, f"tmp250": tmp250, f"tmp252": tmp252, f"tmp254": tmp254, f"tmp256": tmp256, f"tmp26": tmp26, f"tmp27": tmp27, f"tmp276": tmp276, f"tmp278": tmp278, f"tmp28": tmp28, f"tmp284": tmp284, f"tmp285": tmp285, f"tmp287": tmp287, f"tmp288": tmp288, f"tmp29": tmp29, f"tmp290": tmp290, f"tmp292": tmp292, f"tmp294": tmp294, f"tmp305": tmp305, f"tmp307": tmp307, f"tmp309": tmp309, f"tmp31": tmp31, f"tmp310": tmp310, f"tmp33": tmp33, f"tmp34": tmp34, f"tmp35": tmp35, f"tmp36": tmp36, f"tmp4": tmp4, f"tmp43": tmp43, f"tmp45": tmp45, f"tmp47": tmp47, f"tmp49": tmp49, f"tmp5": tmp5, f"tmp51": tmp51, f"tmp53": tmp53, f"tmp55": tmp55, f"tmp57": tmp57, f"tmp59": tmp59, f"tmp61": tmp61, f"tmp63": tmp63, f"tmp65": tmp65, f"tmp67": tmp67, f"tmp69": tmp69, f"tmp7": tmp7, f"tmp71": tmp71, f"tmp73": tmp73, f"tmp74": tmp74, f"tmp76": tmp76, f"tmp77": tmp77, f"tmp79": tmp79, f"tmp8": tmp8, f"tmp81": tmp81, f"tmp82": tmp82, f"tmp83": tmp83, f"tmp85": tmp85, f"tmp86": tmp86, f"tmp88": tmp88, f"tmp89": tmp89, f"tmp90": tmp90, f"tmp92": tmp92, f"tmp94": tmp94, f"tmp96": tmp96, f"tmp98": tmp98}

def hbar_lmatvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:46:05.926554.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp34 = einsum(r2.bbb, (0, 1, 2), t2.bbbb, (3, 2, 0, 1), (3,))
    tmp33 = einsum(t2.abab, (0, 1, 2, 3), r2.aba, (2, 3, 0), (1,))
    tmp21 = einsum(r2.bbb, (0, 1, 2), t1.bb, (3, 1), (2, 3, 0))
    tmp85 = np.copy(ints.tmp284)
    tmp85 += ints.tmp290 * 2
    tmp64 = np.copy(tmp33) * -0.5
    tmp64 += tmp34
    tmp78 = np.copy(ints.tmp230)
    tmp78 += ints.tmp232 * 0.5
    tmp78 += f.bb.vv * -0.5
    tmp76 = np.copy(ints.tmp285) * 2
    tmp76 += ints.tmp292
    tmp16 = einsum(t2.abab, (0, 1, 2, 3), r2.bab, (3, 2, 1), (0,)) * -1
    tmp2 = einsum(r2.aaa, (0, 1, 2), t1.aa, (3, 1), (2, 3, 0))
    tmp45 = np.copy(ints.tmp47)
    tmp45 += ints.tmp49 * 0.5
    tmp45 += f.aa.vv * -0.5
    tmp41 = np.copy(ints.tmp139) * 2
    tmp41 += ints.tmp145
    tmp43 = np.copy(ints.tmp141) * 0.5
    tmp43 += ints.tmp147
    tmp15 = einsum(t2.aaaa, (0, 1, 2, 3), r2.aaa, (2, 3, 1), (0,))
    tmp82 = einsum(ints.tmp288, (0, 1, 2, 3), r2.bbb, (4, 2, 0), (1, 3, 4))
    tmp84 = einsum(f.bb.ov, (0, 1), tmp21, (2, 0, 3), (2, 1, 3))
    tmp83 = einsum(v.bbbb.ovov, (0, 1, 2, 3), r2.bbb, (4, 3, 2), (0, 4, 1))
    tmp86 = einsum(tmp85, (0, 1, 2, 3), r2.aba, (2, 4, 0), (1, 4, 3))
    del tmp85
    tmp74 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.aba, (1, 4, 0), (2, 4, 3))
    tmp80 = einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp64, (2,), (0, 3, 1)) * 2
    tmp73 = einsum(ints.tmp287, (0, 1, 2, 3), r2.aba, (2, 4, 0), (1, 3, 4))
    tmp79 = einsum(r2.bbb, (0, 1, 2), tmp78, (1, 3), (2, 0, 3)) * -4
    del tmp78
    tmp75 = einsum(r2.bbb, (0, 1, 2), v.bbbb.oovv, (3, 2, 4, 1), (3, 0, 4))
    tmp77 = einsum(r2.bbb, (0, 1, 2), tmp76, (2, 3, 1, 4), (3, 0, 4)) * -2
    del tmp76
    tmp72 = einsum(r1.b, (0,), v.bbbb.ovvv, (1, 2, 3, 0), (1, 2, 3))
    tmp62 = einsum(t1.bb, (0, 1), f.bb.ov, (0, 2), (2, 1))
    tmp60 = einsum(t1.aa, (0, 1), f.aa.ov, (0, 2), (2, 1))
    tmp51 = einsum(r2.bab, (0, 1, 2), ints.tmp144, (3, 2, 4, 0), (3, 4, 1)) * -1
    tmp53 = einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp16, (2,), (0, 1, 3))
    tmp50 = einsum(tmp2, (0, 1, 2), f.aa.ov, (1, 3), (0, 3, 2))
    tmp49 = einsum(r2.aaa, (0, 1, 2), v.aaaa.ovov, (3, 4, 2, 1), (3, 0, 4))
    tmp52 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.bab, (3, 4, 2), (0, 4, 1)) * -1
    tmp48 = einsum(ints.tmp142, (0, 1, 2, 3), r2.aaa, (4, 2, 0), (1, 3, 4))
    tmp39 = einsum(v.aaaa.oovv, (0, 1, 2, 3), r2.aaa, (4, 3, 1), (0, 4, 2))
    tmp46 = einsum(tmp45, (0, 1), r2.aaa, (2, 0, 3), (3, 2, 1)) * -4
    del tmp45
    tmp42 = einsum(r2.aaa, (0, 1, 2), tmp41, (2, 3, 1, 4), (3, 0, 4)) * -2
    del tmp41
    tmp38 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), r1.a, (3,), (0, 1, 2))
    tmp44 = einsum(tmp43, (0, 1, 2, 3), r2.bab, (3, 4, 1), (0, 4, 2)) * -2
    del tmp43
    tmp40 = einsum(tmp15, (0,), v.aaaa.ovov, (1, 2, 0, 3), (1, 2, 3)) * -1
    tmp25 = einsum(t1.aa, (0, 1), r2.aba, (1, 2, 3), (3, 0, 2))
    tmp6 = einsum(r2.bab, (0, 1, 2), t1.bb, (3, 0), (2, 3, 1)) * -1
    tmp69 = np.copy(f.bb.oo)
    tmp69 += ints.tmp130 * 2
    del ints.tmp130
    tmp69 += ints.tmp133
    del ints.tmp133
    tmp69 += np.transpose(ints.tmp22, (1, 0))
    del ints.tmp22
    tmp87 = np.copy(tmp82) * 4
    del tmp82
    tmp87 += tmp83 * 2
    del tmp83
    tmp87 += tmp84 * 2
    del tmp84
    tmp87 += np.transpose(tmp86, (0, 2, 1))
    del tmp86
    tmp81 = einsum(r1.b, (0,), f.bb.ov, (1, 2), (1, 2, 0))
    tmp81 += tmp72
    del tmp72
    tmp81 += tmp73
    del tmp73
    tmp81 += tmp74
    del tmp74
    tmp81 += tmp75 * 2
    del tmp75
    tmp81 += np.transpose(tmp77, (0, 2, 1)) * -1
    del tmp77
    tmp81 += np.transpose(tmp79, (0, 2, 1))
    del tmp79
    tmp81 += np.transpose(tmp80, (0, 2, 1)) * -1
    del tmp80
    tmp71 = einsum(t2.bbbb, (0, 1, 2, 3), r2.bbb, (2, 3, 4), (4, 0, 1))
    tmp63 = np.copy(ints.tmp230) * 2
    tmp63 += ints.tmp232
    tmp63 += f.bb.vv * -1
    tmp63 += np.transpose(tmp62, (1, 0))
    del tmp62
    tmp66 = np.copy(ints.tmp285) * 2
    tmp66 += ints.tmp292
    tmp66 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    tmp66 += ints.tmp288 * -2
    tmp66 += v.bbbb.oovv * -1
    tmp65 = einsum(t2.abab, (0, 1, 2, 3), r2.bab, (3, 2, 4), (0, 4, 1)) * -1
    tmp61 = np.copy(ints.tmp47) * 2
    tmp61 += ints.tmp49
    tmp61 += f.aa.vv * -1
    tmp61 += np.transpose(tmp60, (1, 0))
    del tmp60
    tmp70 = np.copy(tmp15)
    tmp70 += tmp16 * 0.5
    tmp67 = np.copy(ints.tmp284)
    tmp67 += ints.tmp290 * 2
    tmp67 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp67 += ints.tmp287 * -1
    tmp68 = np.copy(ints.tmp149)
    tmp68 += np.transpose(v.aabb.vvoo, (2, 3, 0, 1)) * -1
    tmp56 = einsum(t2.abab, (0, 1, 2, 3), r2.aba, (2, 3, 4), (4, 0, 1))
    tmp59 = np.copy(ints.tmp294)
    tmp59 += v.aabb.oovv * -1
    tmp55 = np.copy(f.aa.oo)
    tmp55 += ints.tmp127 * 2
    del ints.tmp127
    tmp55 += ints.tmp136
    del ints.tmp136
    tmp55 += np.transpose(ints.tmp19, (1, 0))
    del ints.tmp19
    tmp58 = np.copy(ints.tmp141)
    tmp58 += ints.tmp147 * 2
    tmp58 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp58 += ints.tmp144 * -1
    tmp57 = np.copy(ints.tmp139) * 2
    tmp57 += ints.tmp145
    tmp57 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp57 += ints.tmp142 * -2
    tmp57 += v.aaaa.oovv * -1
    tmp54 = np.copy(tmp48) * 4
    del tmp48
    tmp54 += tmp49 * 2
    del tmp49
    tmp54 += tmp50 * 2
    del tmp50
    tmp54 += tmp51
    del tmp51
    tmp54 += tmp52
    del tmp52
    tmp54 += tmp53
    del tmp53
    tmp47 = einsum(f.aa.ov, (0, 1), r1.a, (2,), (0, 1, 2))
    tmp47 += tmp38
    del tmp38
    tmp47 += tmp39 * 2
    del tmp39
    tmp47 += tmp40 * 2
    del tmp40
    tmp47 += np.transpose(tmp42, (0, 2, 1)) * -1
    del tmp42
    tmp47 += np.transpose(tmp44, (0, 2, 1))
    del tmp44
    tmp47 += np.transpose(tmp46, (0, 2, 1))
    del tmp46
    tmp37 = einsum(t2.aaaa, (0, 1, 2, 3), r2.aaa, (2, 3, 4), (4, 0, 1))
    tmp22 = np.copy(ints.tmp285) * 2
    del ints.tmp285
    tmp22 += ints.tmp292
    del ints.tmp292
    tmp22 += np.transpose(ints.tmp307, (0, 1, 3, 2))
    del ints.tmp307
    tmp22 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    tmp22 += ints.tmp288 * -2
    del ints.tmp288
    tmp22 += np.transpose(ints.tmp305, (0, 1, 3, 2)) * -1
    del ints.tmp305
    tmp22 += v.bbbb.oovv * -1
    tmp36 = np.copy(f.bb.ov)
    tmp36 += ints.tmp33
    tmp36 += ints.tmp35
    tmp36 += ints.tmp89 * -1
    del ints.tmp89
    tmp24 = np.copy(ints.tmp284)
    del ints.tmp284
    tmp24 += ints.tmp290 * 2
    del ints.tmp290
    tmp24 += ints.tmp310
    del ints.tmp310
    tmp24 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp24 += ints.tmp287 * -1
    del ints.tmp287
    tmp23 = einsum(r2.aba, (0, 1, 2), t1.bb, (3, 1), (2, 3, 0))
    tmp32 = np.copy(np.transpose(ints.tmp175, (1, 0)))
    del ints.tmp175
    tmp32 += ints.tmp230 * 2
    del ints.tmp230
    tmp32 += ints.tmp232
    del ints.tmp232
    tmp32 += f.bb.vv * -1
    tmp32 += np.transpose(ints.tmp173, (1, 0)) * -1
    del ints.tmp173
    tmp32 += np.transpose(ints.tmp177, (1, 0)) * -1
    del ints.tmp177
    tmp35 = einsum(r1.b, (0,), t1.bb, (1, 0), (1,))
    tmp35 += tmp33 * -1
    del tmp33
    tmp35 += tmp34 * 2
    del tmp34
    tmp9 = np.copy(ints.tmp112)
    del ints.tmp112
    tmp9 += ints.tmp118 * 0.5
    del ints.tmp118
    tmp9 += ints.tmp128
    del ints.tmp128
    tmp9 += ints.tmp137 * 0.5
    del ints.tmp137
    tmp9 += ints.tmp154 * 0.5
    del ints.tmp154
    tmp9 += ints.tmp161 * 0.5
    del ints.tmp161
    tmp9 += ints.tmp171 * 0.5
    del ints.tmp171
    tmp9 += ints.tmp191 * 0.5
    del ints.tmp191
    tmp9 += ints.tmp198 * 0.5
    del ints.tmp198
    tmp9 += ints.tmp20 * 0.5
    del ints.tmp20
    tmp9 += ints.tmp2 * 0.5
    del ints.tmp2
    tmp9 += ints.tmp31 * 0.5
    del ints.tmp31
    tmp9 += ints.tmp51
    del ints.tmp51
    tmp9 += ints.tmp57 * 0.5
    del ints.tmp57
    tmp9 += ints.tmp63
    del ints.tmp63
    tmp9 += ints.tmp83
    del ints.tmp83
    tmp9 += ints.tmp90 * 0.5
    del ints.tmp90
    tmp9 += f.aa.ov * -0.5
    tmp9 += ints.tmp101 * -0.5
    del ints.tmp101
    tmp9 += ints.tmp11 * -0.5
    del ints.tmp11
    tmp9 += ints.tmp151 * -0.5
    del ints.tmp151
    tmp9 += ints.tmp169 * -0.5
    del ints.tmp169
    tmp9 += ints.tmp179 * -0.5
    del ints.tmp179
    tmp9 += ints.tmp188 * -0.5
    del ints.tmp188
    tmp9 += ints.tmp29 * -0.5
    tmp9 += ints.tmp36 * -0.5
    tmp9 += ints.tmp5 * -0.5
    del ints.tmp5
    tmp9 += ints.tmp69 * -0.5
    del ints.tmp69
    tmp9 += ints.tmp86 * -1
    del ints.tmp86
    tmp9 += ints.tmp8 * -1
    del ints.tmp8
    tmp9 += ints.tmp94 * -0.5
    del ints.tmp94
    tmp9 += ints.tmp98 * -1
    del ints.tmp98
    tmp19 = np.copy(ints.tmp228)
    del ints.tmp228
    tmp19 += np.transpose(ints.tmp240, (0, 1, 3, 2))
    del ints.tmp240
    tmp19 += ints.tmp246
    del ints.tmp246
    tmp19 += ints.tmp252 * 2
    del ints.tmp252
    tmp19 += np.transpose(ints.tmp278, (0, 1, 3, 2))
    del ints.tmp278
    tmp19 += v.aabb.ovvv
    tmp19 += ints.tmp249 * -1
    del ints.tmp249
    tmp19 += np.transpose(ints.tmp256, (0, 1, 3, 2)) * -1
    del ints.tmp256
    tmp31 = np.copy(ints.tmp117)
    del ints.tmp117
    tmp31 += v.aabb.ooov
    tmp30 = einsum(tmp25, (0, 1, 2), t1.bb, (3, 2), (0, 1, 3))
    tmp28 = einsum(t1.bb, (0, 1), tmp21, (2, 3, 1), (2, 3, 0)) * -1
    tmp29 = np.copy(ints.tmp114)
    del ints.tmp114
    tmp29 += v.bbbb.ooov * -1
    tmp27 = np.copy(ints.tmp115) * 2
    tmp27 += ints.tmp121
    tmp27 += ints.tmp131 * 2
    tmp27 += ints.tmp134
    tmp27 += ints.tmp159
    tmp27 += ints.tmp164
    tmp27 += ints.tmp176
    tmp27 += ints.tmp196
    tmp27 += ints.tmp201
    tmp27 += ints.tmp23
    tmp27 += ints.tmp34
    tmp27 += ints.tmp4
    tmp27 += ints.tmp53 * 2
    tmp27 += ints.tmp55
    tmp27 += ints.tmp65 * 2
    tmp27 += ints.tmp85
    tmp27 += ints.tmp92 * 2
    tmp27 += f.bb.ov * -1
    tmp27 += ints.tmp100 * -1
    tmp27 += ints.tmp103 * -2
    tmp27 += ints.tmp10 * -1
    tmp27 += ints.tmp13 * -2
    tmp27 += ints.tmp157 * -1
    tmp27 += ints.tmp174 * -1
    tmp27 += ints.tmp178 * -1
    tmp27 += ints.tmp194 * -1
    tmp27 += ints.tmp33 * -1
    tmp27 += ints.tmp35 * -1
    tmp27 += ints.tmp67 * -1
    tmp27 += ints.tmp7 * -1
    tmp27 += ints.tmp88 * -1
    tmp27 += ints.tmp96 * -2
    tmp20 = np.copy(np.transpose(ints.tmp238, (0, 3, 1, 2))) * 0.5
    del ints.tmp238
    tmp20 += np.transpose(ints.tmp247, (0, 2, 1, 3))
    del ints.tmp247
    tmp20 += np.transpose(ints.tmp254, (0, 2, 1, 3)) * 0.5
    del ints.tmp254
    tmp20 += np.transpose(v.bbbb.ovvv, (0, 2, 1, 3)) * 0.5
    tmp20 += ints.tmp226 * -0.5
    del ints.tmp226
    tmp20 += np.transpose(ints.tmp250, (0, 2, 1, 3)) * -1
    del ints.tmp250
    tmp20 += np.transpose(ints.tmp276, (0, 3, 1, 2)) * -0.5
    del ints.tmp276
    tmp26 = np.copy(np.transpose(ints.tmp309, (0, 1, 3, 2)))
    del ints.tmp309
    tmp26 += v.aabb.oovv
    tmp26 += ints.tmp294 * -1
    del ints.tmp294
    tmp17 = einsum(t1.aa, (0, 1), r1.a, (1,), (0,)) * 0.5
    tmp17 += tmp15
    del tmp15
    tmp17 += tmp16 * 0.5
    del tmp16
    tmp4 = einsum(t1.aa, (0, 1), r2.bab, (2, 1, 3), (0, 3, 2)) * -1
    tmp14 = np.copy(np.transpose(ints.tmp27, (1, 0)))
    del ints.tmp27
    tmp14 += ints.tmp47 * 2
    del ints.tmp47
    tmp14 += ints.tmp49
    del ints.tmp49
    tmp14 += f.aa.vv * -1
    tmp14 += np.transpose(ints.tmp26, (1, 0)) * -1
    del ints.tmp26
    tmp14 += np.transpose(ints.tmp28, (1, 0)) * -1
    del ints.tmp28
    tmp11 = np.copy(ints.tmp111)
    del ints.tmp111
    tmp11 += v.aaaa.ooov * -1
    tmp5 = np.copy(ints.tmp141)
    del ints.tmp141
    tmp5 += ints.tmp147 * 2
    del ints.tmp147
    tmp5 += ints.tmp186
    del ints.tmp186
    tmp5 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp5 += ints.tmp144 * -1
    del ints.tmp144
    tmp18 = np.copy(f.aa.ov)
    tmp18 += ints.tmp29
    del ints.tmp29
    tmp18 += ints.tmp36
    del ints.tmp36
    tmp18 += ints.tmp82 * -1
    del ints.tmp82
    tmp12 = einsum(t1.aa, (0, 1), tmp6, (2, 3, 1), (0, 2, 3))
    tmp10 = einsum(t1.aa, (0, 1), tmp2, (2, 3, 1), (2, 3, 0)) * -1
    tmp7 = np.copy(np.transpose(ints.tmp185, (0, 1, 3, 2)))
    del ints.tmp185
    tmp7 += np.transpose(v.aabb.vvoo, (2, 3, 0, 1))
    tmp7 += ints.tmp149 * -1
    del ints.tmp149
    tmp13 = np.copy(ints.tmp120)
    del ints.tmp120
    tmp13 += np.transpose(v.aabb.ovoo, (0, 2, 3, 1))
    tmp3 = np.copy(ints.tmp139) * 2
    del ints.tmp139
    tmp3 += ints.tmp145
    del ints.tmp145
    tmp3 += np.transpose(ints.tmp183, (0, 1, 3, 2))
    del ints.tmp183
    tmp3 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp3 += ints.tmp142 * -2
    del ints.tmp142
    tmp3 += np.transpose(ints.tmp181, (0, 1, 3, 2)) * -1
    del ints.tmp181
    tmp3 += v.aaaa.oovv * -1
    tmp0 = np.copy(ints.tmp125)
    del ints.tmp125
    tmp0 += np.transpose(ints.tmp45, (0, 2, 1, 3))
    del ints.tmp45
    tmp0 += ints.tmp61
    del ints.tmp61
    tmp0 += np.transpose(ints.tmp73, (0, 2, 1, 3))
    del ints.tmp73
    tmp0 += np.transpose(ints.tmp79, (0, 2, 1, 3)) * 2
    del ints.tmp79
    tmp0 += np.transpose(v.aabb.vvov, (2, 0, 1, 3))
    tmp0 += np.transpose(ints.tmp76, (0, 2, 1, 3)) * -1
    del ints.tmp76
    tmp0 += ints.tmp81 * -1
    del ints.tmp81
    tmp8 = np.copy(ints.tmp115)
    del ints.tmp115
    tmp8 += ints.tmp121 * 0.5
    del ints.tmp121
    tmp8 += ints.tmp131
    del ints.tmp131
    tmp8 += ints.tmp134 * 0.5
    del ints.tmp134
    tmp8 += ints.tmp159 * 0.5
    del ints.tmp159
    tmp8 += ints.tmp164 * 0.5
    del ints.tmp164
    tmp8 += ints.tmp176 * 0.5
    del ints.tmp176
    tmp8 += ints.tmp196 * 0.5
    del ints.tmp196
    tmp8 += ints.tmp201 * 0.5
    del ints.tmp201
    tmp8 += ints.tmp23 * 0.5
    del ints.tmp23
    tmp8 += ints.tmp34 * 0.5
    del ints.tmp34
    tmp8 += ints.tmp4 * 0.5
    del ints.tmp4
    tmp8 += ints.tmp53
    del ints.tmp53
    tmp8 += ints.tmp55 * 0.5
    del ints.tmp55
    tmp8 += ints.tmp65
    del ints.tmp65
    tmp8 += ints.tmp85 * 0.5
    del ints.tmp85
    tmp8 += ints.tmp92
    del ints.tmp92
    tmp8 += f.bb.ov * -0.5
    tmp8 += ints.tmp100 * -0.5
    del ints.tmp100
    tmp8 += ints.tmp103 * -1
    del ints.tmp103
    tmp8 += ints.tmp10 * -0.5
    del ints.tmp10
    tmp8 += ints.tmp13 * -1
    del ints.tmp13
    tmp8 += ints.tmp157 * -0.5
    del ints.tmp157
    tmp8 += ints.tmp174 * -0.5
    del ints.tmp174
    tmp8 += ints.tmp178 * -0.5
    del ints.tmp178
    tmp8 += ints.tmp194 * -0.5
    del ints.tmp194
    tmp8 += ints.tmp33 * -0.5
    del ints.tmp33
    tmp8 += ints.tmp35 * -0.5
    del ints.tmp35
    tmp8 += ints.tmp67 * -0.5
    del ints.tmp67
    tmp8 += ints.tmp7 * -0.5
    del ints.tmp7
    tmp8 += ints.tmp88 * -0.5
    del ints.tmp88
    tmp8 += ints.tmp96 * -1
    del ints.tmp96
    tmp1 = np.copy(ints.tmp59) * 0.5
    del ints.tmp59
    tmp1 += np.transpose(ints.tmp71, (0, 1, 3, 2))
    del ints.tmp71
    tmp1 += np.transpose(ints.tmp77, (0, 1, 3, 2)) * 0.5
    del ints.tmp77
    tmp1 += v.aaaa.ovvv * 0.5
    tmp1 += ints.tmp123 * -0.5
    del ints.tmp123
    tmp1 += np.transpose(ints.tmp43, (0, 2, 3, 1)) * -0.5
    del ints.tmp43
    tmp1 += np.transpose(ints.tmp74, (0, 1, 3, 2)) * -1
    del ints.tmp74
    r2new.bbb = einsum(r2.bbb, (0, 1, 2), v.bbbb.vvvv, (3, 0, 4, 1), (3, 4, 2)) * 2
    r2new.bbb += einsum(tmp71, (0, 1, 2), v.bbbb.ovov, (2, 3, 1, 4), (3, 4, 0)) * -2
    del tmp71
    r2new.bbb += np.transpose(tmp81, (1, 2, 0)) * -1
    r2new.bbb += np.transpose(tmp81, (2, 1, 0))
    del tmp81
    r2new.bbb += np.transpose(tmp87, (1, 2, 0))
    r2new.bbb += np.transpose(tmp87, (2, 1, 0)) * -1
    del tmp87
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp69, (2, 3), (0, 1, 3)) * -2
    r2new.bab = einsum(r1.a, (0,), v.aabb.vvov, (1, 0, 2, 3), (3, 1, 2)) * -1
    r2new.bab += einsum(r1.a, (0,), f.bb.ov, (1, 2), (2, 0, 1)) * -1
    r2new.bab += einsum(r2.bab, (0, 1, 2), v.aabb.vvvv, (3, 1, 4, 0), (4, 3, 2))
    r2new.bab += einsum(tmp65, (0, 1, 2), v.aabb.ovov, (0, 3, 2, 4), (4, 3, 1)) * -1
    del tmp65
    r2new.bab += einsum(tmp66, (0, 1, 2, 3), r2.bab, (2, 4, 0), (3, 4, 1))
    del tmp66
    r2new.bab += einsum(tmp67, (0, 1, 2, 3), r2.aaa, (4, 2, 0), (3, 4, 1)) * -2
    del tmp67
    r2new.bab += einsum(tmp68, (0, 1, 2, 3), r2.bab, (4, 2, 0), (4, 3, 1))
    del tmp68
    r2new.bab += einsum(tmp63, (0, 1), r2.bab, (0, 2, 3), (1, 2, 3)) * -1
    r2new.bab += einsum(tmp61, (0, 1), r2.bab, (2, 0, 3), (2, 1, 3)) * -1
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp69, (2, 3), (0, 1, 3)) * -1
    del tmp69
    r2new.bab += einsum(tmp70, (0,), v.aabb.ovov, (0, 1, 2, 3), (3, 1, 2)) * 2
    del tmp70
    r2new.aba = einsum(v.aabb.vvvv, (0, 1, 2, 3), r2.aba, (1, 3, 4), (0, 2, 4))
    r2new.aba += einsum(tmp56, (0, 1, 2), v.aabb.ovov, (1, 3, 2, 4), (3, 4, 0))
    del tmp56
    r2new.aba += einsum(f.aa.ov, (0, 1), r1.b, (2,), (1, 2, 0)) * -1
    r2new.aba += einsum(v.aabb.ovvv, (0, 1, 2, 3), r1.b, (3,), (1, 2, 0)) * -1
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp57, (2, 3, 0, 4), (4, 1, 3))
    del tmp57
    r2new.aba += einsum(r2.bbb, (0, 1, 2), tmp58, (3, 2, 4, 1), (4, 0, 3)) * -2
    del tmp58
    r2new.aba += einsum(tmp59, (0, 1, 2, 3), r2.aba, (4, 2, 0), (4, 3, 1))
    del tmp59
    r2new.aba += einsum(tmp61, (0, 1), r2.aba, (0, 2, 3), (1, 2, 3)) * -1
    del tmp61
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp63, (1, 3), (0, 3, 2)) * -1
    del tmp63
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp55, (2, 3), (0, 1, 3)) * -1
    r2new.aba += einsum(tmp64, (0,), v.aabb.ovov, (1, 2, 0, 3), (2, 3, 1)) * 2
    del tmp64
    r2new.aaa = einsum(tmp37, (0, 1, 2), v.aaaa.ovov, (2, 3, 1, 4), (3, 4, 0)) * -2
    del tmp37
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), v.aaaa.vvvv, (3, 1, 4, 0), (3, 4, 2)) * -2
    r2new.aaa += np.transpose(tmp47, (1, 2, 0)) * -1
    r2new.aaa += np.transpose(tmp47, (2, 1, 0))
    del tmp47
    r2new.aaa += np.transpose(tmp54, (1, 2, 0))
    r2new.aaa += np.transpose(tmp54, (2, 1, 0)) * -1
    del tmp54
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp55, (2, 3), (0, 1, 3)) * -2
    del tmp55
    r1new.b = einsum(r2.aba, (0, 1, 2), tmp19, (2, 0, 3, 1), (3,)) * -1
    del tmp19
    r1new.b += einsum(r2.bbb, (0, 1, 2), tmp20, (2, 3, 0, 1), (3,)) * -4
    del tmp20
    r1new.b += einsum(tmp22, (0, 1, 2, 3), tmp21, (0, 1, 2), (3,)) * 2
    del tmp21, tmp22
    r1new.b += einsum(tmp23, (0, 1, 2), tmp24, (0, 1, 2, 3), (3,))
    del tmp23, tmp24
    r1new.b += einsum(tmp26, (0, 1, 2, 3), tmp25, (0, 1, 2), (3,))
    del tmp25, tmp26
    r1new.b += einsum(tmp27, (0, 1), r2.bbb, (2, 1, 0), (2,)) * -2
    del tmp27
    r1new.b += einsum(tmp9, (0, 1), r2.aba, (1, 2, 0), (2,)) * 2
    r1new.b += einsum(tmp28, (0, 1, 2), tmp29, (0, 2, 1, 3), (3,)) * -2
    del tmp28, tmp29
    r1new.b += einsum(tmp30, (0, 1, 2), tmp31, (0, 1, 2, 3), (3,)) * -1
    del tmp30, tmp31
    r1new.b += einsum(tmp32, (0, 1), r1.b, (0,), (1,)) * -1
    del tmp32
    r1new.b += einsum(tmp35, (0,), tmp36, (0, 1), (1,)) * -1
    del tmp35, tmp36
    r1new.a = einsum(r2.bab, (0, 1, 2), tmp0, (2, 1, 3, 0), (3,)) * -1
    del tmp0
    r1new.a += einsum(r2.aaa, (0, 1, 2), tmp1, (2, 0, 1, 3), (3,)) * -4
    del tmp1
    r1new.a += einsum(tmp2, (0, 1, 2), tmp3, (0, 1, 2, 3), (3,)) * 2
    del tmp2, tmp3
    r1new.a += einsum(tmp5, (0, 1, 2, 3), tmp4, (0, 1, 3), (2,)) * -1
    del tmp5, tmp4
    r1new.a += einsum(tmp7, (0, 1, 2, 3), tmp6, (0, 1, 2), (3,)) * -1
    del tmp6, tmp7
    r1new.a += einsum(r2.bab, (0, 1, 2), tmp8, (2, 0), (1,)) * 2
    del tmp8
    r1new.a += einsum(tmp9, (0, 1), r2.aaa, (2, 1, 0), (2,)) * -4
    del tmp9
    r1new.a += einsum(tmp10, (0, 1, 2), tmp11, (0, 2, 1, 3), (3,)) * -2
    del tmp10, tmp11
    r1new.a += einsum(tmp13, (0, 1, 2, 3), tmp12, (0, 1, 2), (3,))
    del tmp13, tmp12
    r1new.a += einsum(r1.a, (0,), tmp14, (0, 1), (1,)) * -1
    del tmp14
    r1new.a += einsum(tmp17, (0,), tmp18, (0, 1), (1,)) * -2
    del tmp17, tmp18

    return {f"r1new": r1new, f"r2new": r2new}

