"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T17:12:15.129824
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:12:16.407354.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1)))
    tmp0 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3)) * -1
    tmp2 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1)))
    tmp2 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3)) * -1
    tmp1 = np.copy(f.bb.ov)
    tmp1 += einsum(t1.aa, (0, 1), v.aabb.ovov, (0, 1, 2, 3), (2, 3))
    tmp1 += einsum(t1.bb, (0, 1), tmp0, (0, 2, 1, 3), (2, 3)) * -0.5
    del tmp0
    tmp3 = np.copy(f.aa.ov)
    tmp3 += einsum(tmp2, (0, 1, 2, 3), t1.aa, (0, 2), (1, 3)) * -0.5
    del tmp2
    e_cc = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 3), ())
    e_cc += einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 2, 1, 3), ())
    e_cc += einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 3, 1), ()) * -1
    e_cc += einsum(t1.bb, (0, 1), tmp1, (0, 1), ())
    del tmp1
    e_cc += einsum(t1.aa, (0, 1), tmp3, (0, 1), ())
    del tmp3

    return e_cc

def update_amps(f=None, t1=None, t2=None, t3=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:15:44.767599.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    t3 : Namespace of arrays
        T3 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    t1new : Namespace of arrays
        Updated T1 residuals.
    t2new : Namespace of arrays
        Updated T2 residuals.
    t3new : Namespace of arrays
        Updated T3 residuals.
    """

    t1new = Namespace()
    t2new = Namespace()
    t3new = Namespace()
    tmp14 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1)))
    tmp14 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3)) * -1
    tmp7 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1)))
    tmp7 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3)) * -1
    tmp197 = einsum(t1.bb, (0, 1), v.bbbb.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp22 = einsum(t1.bb, (0, 1), v.aabb.ovov, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp21 = einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp2 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 2, 1))
    tmp1 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp64 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp15 = einsum(t1.bb, (0, 1), tmp14, (0, 2, 1, 3), (2, 3))
    del tmp14
    tmp13 = einsum(t1.aa, (0, 1), v.aabb.ovov, (0, 1, 2, 3), (2, 3))
    tmp0 = einsum(t1.bb, (0, 1), v.aabb.ovov, (2, 3, 0, 1), (2, 3))
    tmp8 = einsum(t1.aa, (0, 1), tmp7, (0, 2, 1, 3), (2, 3))
    tmp557 = np.copy(v.bbbb.ovvv)
    tmp557 += np.transpose(v.bbbb.ovvv, (0, 2, 3, 1)) * -1
    tmp454 = np.copy(np.transpose(tmp197, (0, 2, 1, 3))) * -1
    tmp454 += np.transpose(tmp197, (0, 2, 3, 1))
    tmp543 = np.copy(np.transpose(tmp197, (0, 2, 1, 3))) * -1
    tmp543 += np.transpose(tmp197, (0, 3, 2, 1))
    tmp164 = np.copy(v.bbbb.ovvv)
    tmp164 += np.transpose(v.bbbb.ovvv, (0, 2, 3, 1)) * -1
    tmp139 = einsum(tmp22, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 3, 4))
    tmp140 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 1, 2))
    tmp206 = einsum(tmp21, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3))
    tmp152 = einsum(t1.aa, (0, 1), tmp22, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp141 = einsum(t1.bb, (0, 1), v.aabb.vvov, (2, 3, 4, 1), (0, 4, 2, 3))
    tmp138 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t1.aa, (4, 1), (4, 0, 2, 3))
    tmp81 = np.copy(v.aaaa.ovvv) * -1
    tmp81 += np.transpose(v.aaaa.ovvv, (0, 2, 1, 3))
    tmp73 = einsum(t1.aa, (0, 1), tmp2, (2, 3, 0, 4), (2, 3, 1, 4))
    tmp77 = einsum(t1.aa, (0, 1), v.aabb.vvov, (2, 1, 3, 4), (0, 3, 2, 4))
    tmp78 = einsum(tmp1, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    tmp135 = einsum(t1.bb, (0, 1), v.aabb.ooov, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp264 = np.copy(np.transpose(tmp64, (0, 2, 1, 3)))
    tmp264 += np.transpose(tmp64, (0, 3, 2, 1)) * -1
    tmp58 = np.copy(v.aaaa.ovvv) * -1
    tmp58 += np.transpose(v.aaaa.ovvv, (0, 2, 1, 3))
    tmp267 = np.copy(np.transpose(tmp64, (0, 2, 1, 3))) * -1
    tmp267 += np.transpose(tmp64, (0, 3, 2, 1))
    tmp157 = np.copy(v.bbbb.ooov)
    tmp157 += np.transpose(v.bbbb.ovoo, (0, 2, 3, 1)) * -1
    tmp211 = np.copy(v.bbbb.ovvv) * -1
    tmp211 += np.transpose(v.bbbb.ovvv, (0, 2, 1, 3))
    tmp213 = np.copy(tmp21)
    tmp213 += np.transpose(tmp21, (0, 2, 1, 3)) * -1
    tmp220 = np.copy(v.bbbb.ooov) * -1
    tmp220 += np.transpose(v.bbbb.ovoo, (0, 2, 3, 1))
    tmp16 = np.copy(f.bb.ov)
    tmp16 += tmp13
    tmp16 += tmp15 * -1
    del tmp15
    tmp46 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1)))
    tmp46 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3)) * -1
    tmp9 = np.copy(f.aa.ov)
    tmp9 += tmp0
    tmp9 += tmp8 * -1
    del tmp8
    tmp92 = np.copy(v.aaaa.ooov) * -1
    tmp92 += np.transpose(v.aaaa.ovoo, (0, 2, 3, 1))
    tmp83 = np.copy(tmp2)
    tmp83 += np.transpose(tmp2, (0, 2, 1, 3)) * -1
    tmp37 = np.copy(v.aaaa.ooov)
    tmp37 += np.transpose(v.aaaa.ovoo, (0, 2, 3, 1)) * -1
    tmp558 = einsum(t1.bb, (0, 1), tmp557, (2, 1, 3, 4), (2, 0, 3, 4))
    del tmp557
    tmp524 = np.copy(np.transpose(tmp197, (0, 2, 1, 3)))
    tmp524 += np.transpose(tmp197, (0, 3, 2, 1)) * -1
    tmp514 = einsum(t3.bbbbbb, (0, 1, 2, 3, 4, 5), f.bb.ov, (6, 5), (6, 0, 1, 2, 3, 4))
    tmp513 = einsum(v.bbbb.oooo, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 6), (4, 0, 1, 2, 5, 6))
    tmp316 = einsum(f.bb.ov, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp510 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 5, 6, 3), (0, 1, 4, 5, 6, 2))
    tmp199 = einsum(v.bbbb.oovv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp455 = einsum(t1.bb, (0, 1), tmp454, (2, 3, 4, 0), (2, 3, 4, 1))
    del tmp454
    tmp127 = einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 3, 0, 4), (2, 1, 3, 4))
    tmp544 = einsum(t1.bb, (0, 1), tmp543, (2, 3, 4, 0), (2, 3, 4, 1))
    del tmp543
    tmp491 = np.copy(np.transpose(tmp197, (0, 2, 1, 3)))
    tmp491 += np.transpose(tmp197, (0, 2, 3, 1)) * -1
    tmp231 = einsum(t1.bb, (0, 1), tmp21, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp431 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp176 = einsum(t1.bb, (0, 1), v.bbbb.oooo, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp205 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp521 = einsum(tmp21, (0, 1, 2, 3), t2.bbbb, (4, 5, 6, 3), (0, 4, 5, 2, 1, 6))
    tmp165 = einsum(tmp164, (0, 1, 2, 3), t1.bb, (4, 1), (4, 0, 2, 3))
    del tmp164
    tmp422 = einsum(t2.abab, (0, 1, 2, 3), tmp22, (4, 5, 6, 2), (0, 4, 5, 1, 6, 3))
    tmp168 = np.copy(tmp140)
    tmp168 += tmp139 * -1
    tmp412 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovoo, (4, 2, 5, 6), (0, 4, 1, 5, 6, 3))
    tmp233 = einsum(t1.bb, (0, 1), v.bbbb.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp480 = einsum(t1.bb, (0, 1), tmp206, (2, 0, 3, 4), (2, 1, 3, 4))
    tmp147 = einsum(t1.bb, (0, 1), v.aabb.ooov, (2, 3, 0, 4), (2, 3, 1, 4))
    tmp253 = einsum(t1.aa, (0, 1), f.aa.ov, (0, 2), (2, 1))
    tmp329 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (4, 3), (0, 4, 1, 2))
    tmp328 = einsum(v.aabb.oooo, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 3, 4))
    tmp169 = einsum(t1.aa, (0, 1), v.aabb.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp170 = einsum(t1.bb, (0, 1), tmp1, (2, 3, 0, 4), (2, 3, 1, 4))
    tmp54 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.aa, (0, 4), (2, 4, 1, 3))
    tmp395 = einsum(tmp152, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 3, 4))
    tmp149 = einsum(t1.aa, (0, 1), tmp141, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp461 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ooov, (4, 5, 6, 3), (0, 1, 4, 5, 6, 2))
    tmp362 = einsum(tmp138, (0, 1, 2, 3), t1.aa, (1, 4), (0, 3, 2, 4))
    tmp136 = einsum(v.aabb.vvoo, (0, 1, 2, 3), t1.aa, (4, 1), (4, 2, 3, 0))
    tmp145 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t1.aa, (0, 4), (2, 3, 4, 1))
    tmp399 = einsum(tmp152, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp174 = einsum(tmp140, (0, 1, 2, 3), t1.aa, (4, 2), (4, 0, 1, 3))
    tmp162 = einsum(t1.aa, (0, 1), tmp81, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp359 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.abab, (4, 5, 3, 6), (4, 0, 1, 2, 5, 6))
    tmp142 = einsum(tmp22, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    tmp74 = einsum(t1.aa, (0, 1), v.aaaa.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp309 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 5, 6, 3), (0, 4, 5, 1, 6, 2))
    tmp381 = einsum(t1.aa, (0, 1), tmp73, (2, 0, 3, 4), (2, 1, 3, 4))
    tmp110 = einsum(t1.aa, (0, 1), v.aaaa.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp331 = einsum(f.aa.ov, (0, 1), t2.abab, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp334 = einsum(v.aabb.oooo, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp320 = einsum(tmp1, (0, 1, 2, 3), t2.abab, (4, 5, 6, 3), (0, 4, 1, 5, 2, 6))
    tmp87 = np.copy(tmp77)
    tmp87 += tmp78 * -1
    tmp106 = einsum(tmp2, (0, 1, 2, 3), t1.aa, (4, 3), (0, 4, 2, 1))
    tmp173 = einsum(v.aabb.oovv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp354 = einsum(t1.bb, (0, 1), tmp135, (2, 3, 4, 0), (3, 2, 4, 1))
    tmp287 = einsum(t1.aa, (0, 1), tmp264, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp66 = einsum(v.aaaa.oovv, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp129 = einsum(t1.bb, (0, 1), v.aabb.ovov, (2, 3, 0, 4), (2, 3, 1, 4))
    tmp51 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 3, 0, 4), (2, 1, 3, 4))
    tmp244 = einsum(t1.aa, (0, 1), v.aaaa.oooo, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp270 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp261 = einsum(t2.aaaa, (0, 1, 2, 3), tmp2, (4, 5, 6, 3), (4, 0, 1, 6, 5, 2))
    tmp305 = einsum(t1.aa, (0, 1), tmp58, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp249 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.oooo, (4, 5, 6, 1), (0, 4, 5, 6, 2, 3))
    tmp250 = einsum(t3.aaaaaa, (0, 1, 2, 3, 4, 5), f.aa.ov, (6, 5), (6, 0, 1, 2, 3, 4))
    tmp246 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 5, 6, 3), (0, 1, 4, 5, 6, 2))
    tmp292 = einsum(tmp267, (0, 1, 2, 3), t1.aa, (3, 4), (0, 1, 2, 4))
    tmp180 = einsum(tmp157, (0, 1, 2, 3), t1.bb, (0, 3), (1, 2))
    tmp29 = einsum(t1.aa, (0, 1), v.aabb.ovoo, (0, 1, 2, 3), (2, 3))
    tmp212 = einsum(t1.bb, (0, 1), tmp211, (2, 1, 3, 4), (2, 0, 3, 4))
    del tmp211
    tmp214 = einsum(tmp213, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4))
    del tmp213
    tmp190 = np.copy(v.bbbb.ovvv) * -1
    tmp190 += np.transpose(v.bbbb.ovvv, (0, 2, 1, 3))
    tmp30 = np.copy(v.bbbb.ooov)
    tmp30 += np.transpose(v.bbbb.ovoo, (0, 2, 3, 1)) * -1
    tmp221 = einsum(tmp220, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 3, 4))
    del tmp220
    tmp24 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp26 = einsum(t1.bb, (0, 1), tmp16, (2, 1), (0, 2))
    tmp25 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 2, 1, 3), (0, 4))
    tmp47 = einsum(t1.bb, (0, 1), tmp46, (0, 2, 1, 3), (2, 3))
    tmp6 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp10 = einsum(tmp9, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp5 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 3, 1), (4, 0)) * -1
    tmp93 = einsum(tmp92, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    del tmp92
    tmp18 = np.copy(v.aaaa.ooov)
    tmp18 += np.transpose(v.aaaa.ovoo, (0, 2, 3, 1)) * -1
    tmp82 = einsum(t1.aa, (0, 1), tmp81, (2, 1, 3, 4), (0, 2, 3, 4))
    del tmp81
    tmp84 = einsum(t1.aa, (0, 1), tmp83, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp83
    tmp38 = einsum(t1.aa, (0, 1), tmp37, (0, 2, 3, 1), (2, 3))
    tmp17 = einsum(t1.bb, (0, 1), v.aabb.ooov, (2, 3, 0, 1), (2, 3))
    tmp559 = einsum(t2.bbbb, (0, 1, 2, 3), tmp558, (4, 5, 6, 3), (5, 4, 0, 1, 6, 2))
    del tmp558
    tmp525 = einsum(tmp524, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    del tmp524
    tmp515 = np.copy(np.transpose(tmp513, (0, 2, 1, 3, 5, 4)))
    del tmp513
    tmp515 += np.transpose(tmp514, (1, 0, 2, 3, 5, 4)) * 3
    del tmp514
    tmp317 = np.copy(f.bb.vv)
    tmp317 += tmp316 * -1
    tmp511 = einsum(t1.bb, (0, 1), tmp510, (2, 3, 4, 5, 0, 6), (2, 3, 4, 5, 1, 6))
    del tmp510
    tmp456 = np.copy(np.transpose(tmp199, (0, 2, 1, 3)))
    tmp456 += np.transpose(tmp455, (0, 2, 1, 3))
    del tmp455
    tmp532 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.oovv, (4, 5, 6, 3), (0, 1, 4, 5, 2, 6))
    tmp536 = np.copy(v.bbbb.ovvv)
    tmp536 += np.transpose(tmp127, (0, 2, 3, 1)) * -1
    tmp419 = np.copy(f.bb.vv)
    tmp419 += tmp316 * -1
    del tmp316
    tmp553 = np.copy(np.transpose(tmp197, (0, 2, 1, 3)))
    tmp553 += np.transpose(tmp197, (0, 3, 2, 1)) * -1
    tmp545 = np.copy(np.transpose(tmp199, (0, 2, 1, 3)))
    tmp545 += np.transpose(tmp544, (0, 2, 1, 3))
    del tmp544
    tmp446 = np.copy(v.bbbb.ovvv)
    tmp446 += np.transpose(tmp127, (0, 2, 3, 1)) * -1
    tmp445 = np.copy(np.transpose(v.bbbb.ovvv, (0, 2, 1, 3))) * -1
    tmp445 += tmp127
    tmp323 = einsum(f.bb.ov, (0, 1), t1.bb, (2, 1), (0, 2))
    tmp492 = einsum(t1.bb, (0, 1), tmp491, (2, 3, 4, 0), (2, 3, 4, 1))
    del tmp491
    tmp235 = einsum(t1.bb, (0, 1), tmp231, (2, 3, 0, 4), (3, 2, 4, 1))
    tmp547 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 6, 3), (0, 1, 4, 6, 2, 5))
    tmp528 = np.copy(np.transpose(tmp176, (1, 0, 2, 3))) * -1
    tmp528 += np.transpose(tmp431, (0, 2, 1, 3)) * 2
    tmp237 = einsum(tmp205, (0, 1, 2, 3), t1.bb, (4, 2), (4, 0, 1, 3))
    tmp424 = np.copy(np.transpose(tmp197, (0, 2, 1, 3))) * -1
    tmp424 += np.transpose(tmp197, (0, 3, 2, 1))
    tmp522 = einsum(t1.bb, (0, 1), tmp521, (2, 3, 4, 5, 0, 6), (2, 3, 4, 5, 1, 6))
    del tmp521
    tmp551 = einsum(tmp165, (0, 1, 2, 3), t2.bbbb, (4, 5, 6, 3), (0, 1, 4, 5, 2, 6))
    tmp432 = np.copy(np.transpose(tmp176, (1, 0, 2, 3))) * -1
    tmp432 += np.transpose(tmp431, (0, 2, 1, 3)) * 2
    tmp423 = einsum(t1.aa, (0, 1), tmp422, (2, 0, 3, 4, 5, 6), (2, 3, 4, 5, 1, 6))
    del tmp422
    tmp376 = einsum(t1.aa, (0, 1), v.aabb.vvvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp459 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.oovv, (4, 5, 6, 3), (0, 1, 4, 5, 2, 6))
    tmp472 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 5, 1, 6), (4, 0, 5, 2, 6, 3))
    tmp483 = einsum(tmp165, (0, 1, 2, 3), t2.abab, (4, 5, 6, 3), (4, 0, 1, 5, 6, 2)) * -1
    tmp150 = einsum(v.aabb.vvvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp476 = einsum(tmp168, (0, 1, 2, 3), t1.aa, (0, 4), (1, 4, 2, 3))
    tmp393 = einsum(tmp138, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp413 = einsum(tmp412, (0, 1, 2, 3, 4, 5), t1.aa, (1, 6), (0, 2, 4, 3, 6, 5))
    tmp470 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 6, 3), (0, 1, 4, 6, 2, 5))
    tmp481 = np.copy(np.transpose(tmp233, (0, 2, 1, 3)))
    tmp481 += np.transpose(tmp480, (0, 3, 1, 2))
    del tmp480
    tmp148 = np.copy(v.aabb.oovv)
    tmp148 += np.transpose(tmp147, (1, 0, 3, 2)) * -1
    del tmp147
    tmp256 = np.copy(f.aa.vv)
    tmp256 += tmp253 * -1
    tmp435 = np.copy(np.transpose(tmp328, (0, 2, 1, 3)))
    tmp435 += tmp329 * -1
    tmp427 = einsum(t2.bbbb, (0, 1, 2, 3), tmp1, (4, 5, 6, 3), (4, 5, 0, 1, 6, 2))
    tmp478 = np.copy(np.transpose(tmp169, (0, 1, 3, 2)))
    tmp478 += tmp170 * -1
    tmp55 = np.copy(np.transpose(v.aabb.vvov, (2, 0, 1, 3)))
    tmp55 += np.transpose(tmp54, (0, 2, 1, 3)) * -1
    tmp416 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.bbbb, (4, 5, 6, 3), (0, 1, 4, 5, 2, 6))
    tmp504 = einsum(t2.abab, (0, 1, 2, 3), tmp140, (4, 5, 2, 6), (0, 4, 5, 1, 3, 6))
    tmp497 = np.copy(tmp149)
    tmp497 += tmp395 * -1
    tmp462 = einsum(tmp461, (0, 1, 2, 3, 4, 5), t1.bb, (4, 6), (0, 1, 2, 3, 5, 6))
    del tmp461
    tmp486 = einsum(t1.bb, (0, 1), tmp141, (2, 0, 3, 4), (2, 4, 3, 1))
    tmp466 = einsum(v.aabb.vvoo, (0, 1, 2, 3), t2.abab, (4, 5, 1, 6), (4, 5, 2, 3, 0, 6))
    tmp364 = np.copy(np.transpose(tmp136, (0, 2, 1, 3)))
    tmp364 += np.transpose(tmp362, (0, 2, 1, 3)) * -1
    tmp500 = einsum(tmp141, (0, 1, 2, 3), t2.abab, (4, 5, 3, 6), (4, 0, 5, 1, 2, 6))
    tmp391 = einsum(t1.aa, (0, 1), tmp135, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp437 = einsum(tmp412, (0, 1, 2, 3, 4, 5), t1.bb, (4, 6), (0, 1, 2, 3, 6, 5))
    del tmp412
    tmp259 = einsum(t1.aa, (0, 1), f.aa.ov, (2, 1), (2, 0))
    tmp339 = np.copy(np.transpose(v.aabb.vvoo, (2, 3, 0, 1)))
    tmp339 += np.transpose(tmp145, (1, 0, 3, 2)) * -1
    tmp400 = np.copy(tmp174)
    tmp400 += tmp399 * -1
    tmp387 = einsum(t1.aa, (0, 1), tmp169, (2, 0, 3, 4), (2, 1, 4, 3))
    tmp366 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.oovv, (4, 5, 6, 3), (0, 4, 5, 1, 2, 6))
    tmp384 = einsum(tmp162, (0, 1, 2, 3), t2.abab, (4, 5, 2, 6), (0, 1, 4, 5, 3, 6)) * -1
    tmp360 = einsum(t1.aa, (0, 1), tmp359, (2, 3, 4, 0, 5, 6), (2, 3, 4, 5, 1, 6))
    del tmp359
    tmp370 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (4, 5, 3, 6), (4, 0, 2, 5, 1, 6))
    tmp403 = einsum(tmp169, (0, 1, 2, 3), t2.abab, (4, 5, 6, 3), (0, 4, 1, 5, 6, 2))
    tmp379 = np.copy(np.transpose(tmp141, (0, 1, 3, 2)))
    tmp379 += tmp142 * -1
    tmp112 = einsum(tmp74, (0, 1, 2, 3), t1.aa, (4, 2), (4, 0, 1, 3))
    tmp325 = einsum(t2.aaaa, (0, 1, 2, 3), tmp22, (4, 5, 6, 3), (0, 1, 4, 5, 6, 2))
    tmp357 = einsum(v.aaaa.oovv, (0, 1, 2, 3), t2.abab, (4, 5, 3, 6), (4, 0, 1, 5, 2, 6))
    tmp310 = einsum(t1.bb, (0, 1), tmp309, (2, 3, 4, 5, 0, 6), (2, 4, 3, 5, 6, 1))
    tmp382 = np.copy(np.transpose(tmp110, (0, 2, 1, 3)))
    tmp382 += np.transpose(tmp381, (0, 3, 1, 2))
    del tmp381
    tmp335 = np.copy(np.transpose(tmp334, (1, 0, 2, 3)))
    tmp335 += tmp331 * -1
    tmp337 = einsum(t1.aa, (0, 1), tmp309, (2, 3, 0, 4, 5, 6), (2, 3, 4, 5, 1, 6))
    del tmp309
    tmp321 = einsum(tmp320, (0, 1, 2, 3, 4, 5), t1.bb, (4, 6), (0, 1, 2, 3, 5, 6))
    del tmp320
    tmp377 = einsum(t1.bb, (0, 1), tmp87, (2, 0, 3, 4), (2, 3, 1, 4))
    tmp407 = einsum(tmp77, (0, 1, 2, 3), t2.abab, (4, 5, 6, 3), (0, 4, 5, 1, 6, 2))
    tmp108 = einsum(t1.aa, (0, 1), tmp106, (2, 3, 0, 4), (3, 2, 4, 1))
    tmp355 = np.copy(np.transpose(tmp173, (1, 0, 2, 3)))
    tmp355 += tmp354 * -1
    tmp288 = np.copy(np.transpose(tmp66, (0, 2, 1, 3)))
    tmp288 += np.transpose(tmp287, (0, 2, 1, 3))
    del tmp287
    tmp130 = np.copy(v.aabb.ovvv)
    tmp130 += np.transpose(tmp129, (0, 1, 3, 2)) * -1
    tmp372 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 5, 6, 3), (4, 0, 5, 2, 6, 1))
    tmp313 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovoo, (4, 3, 5, 6), (0, 1, 4, 5, 6, 2))
    tmp290 = np.copy(np.transpose(tmp64, (0, 2, 1, 3))) * -1
    tmp290 += np.transpose(tmp64, (0, 3, 2, 1))
    tmp284 = np.copy(v.aaaa.ovvv)
    tmp284 += np.transpose(tmp51, (0, 2, 3, 1)) * -1
    tmp276 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.oovv, (4, 5, 6, 3), (0, 1, 4, 5, 2, 6))
    tmp271 = np.copy(np.transpose(tmp244, (1, 0, 2, 3))) * -0.5
    tmp271 += np.transpose(tmp270, (0, 2, 1, 3))
    tmp268 = einsum(t1.aa, (0, 1), tmp267, (2, 0, 3, 4), (2, 3, 4, 1))
    del tmp267
    tmp254 = np.copy(f.aa.vv)
    tmp254 += tmp253 * -1
    del tmp253
    tmp299 = einsum(t2.aaaa, (0, 1, 2, 3), tmp162, (4, 5, 3, 6), (4, 5, 0, 1, 6, 2))
    tmp262 = einsum(t1.aa, (0, 1), tmp261, (2, 3, 4, 5, 0, 6), (2, 3, 4, 5, 1, 6))
    del tmp261
    tmp301 = np.copy(np.transpose(tmp64, (0, 2, 1, 3)))
    tmp301 += np.transpose(tmp64, (0, 3, 2, 1)) * -1
    tmp265 = einsum(t1.aa, (0, 1), tmp264, (2, 3, 4, 0), (2, 3, 4, 1))
    del tmp264
    tmp280 = np.copy(v.aaaa.ovvv)
    tmp280 += np.transpose(tmp51, (0, 2, 3, 1)) * -1
    tmp306 = einsum(t2.aaaa, (0, 1, 2, 3), tmp305, (4, 5, 3, 6), (4, 5, 0, 1, 6, 2))
    del tmp305
    tmp282 = np.copy(np.transpose(v.aaaa.ovvv, (0, 2, 1, 3))) * -1
    tmp282 += tmp51
    tmp273 = np.copy(np.transpose(tmp244, (1, 0, 2, 3))) * -1
    tmp273 += np.transpose(tmp270, (0, 2, 1, 3)) * 2
    tmp295 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 6, 3), (0, 1, 4, 6, 2, 5))
    tmp251 = np.copy(np.transpose(tmp249, (0, 2, 1, 3, 5, 4)))
    del tmp249
    tmp251 += np.transpose(tmp250, (1, 0, 2, 3, 5, 4)) * 3
    del tmp250
    tmp247 = einsum(t1.aa, (0, 1), tmp246, (2, 3, 4, 5, 0, 6), (2, 3, 4, 5, 1, 6))
    del tmp246
    tmp293 = np.copy(np.transpose(tmp66, (0, 2, 1, 3)))
    tmp293 += np.transpose(tmp292, (0, 2, 1, 3))
    del tmp292
    tmp239 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp100 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1))) * -1
    tmp100 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    tmp224 = np.copy(v.bbbb.ooov) * -1
    tmp224 += np.transpose(v.bbbb.ovoo, (0, 2, 3, 1))
    tmp181 = np.copy(f.bb.oo)
    tmp181 += np.transpose(tmp29, (1, 0))
    tmp181 += np.transpose(tmp180, (1, 0)) * -1
    del tmp180
    tmp201 = einsum(tmp197, (0, 1, 2, 3), t1.bb, (3, 4), (0, 2, 1, 4))
    tmp187 = np.copy(v.bbbb.ovvv)
    tmp187 += np.transpose(tmp127, (0, 3, 2, 1))
    tmp122 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 4), (3, 4))
    tmp123 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 3, 1, 4), (2, 4)) * -1
    tmp91 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1)))
    tmp91 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3)) * -1
    tmp144 = einsum(t1.bb, (0, 1), v.aabb.ovoo, (2, 3, 4, 0), (2, 4, 3, 1))
    tmp207 = np.copy(tmp21)
    tmp207 += np.transpose(tmp21, (0, 2, 1, 3)) * -1
    tmp215 = np.copy(np.transpose(tmp212, (1, 0, 3, 2))) * -1
    del tmp212
    tmp215 += np.transpose(tmp214, (0, 1, 3, 2)) * -1
    del tmp214
    tmp191 = einsum(tmp190, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3))
    tmp131 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp192 = einsum(t1.bb, (0, 1), tmp16, (0, 2), (1, 2))
    tmp31 = einsum(tmp30, (0, 1, 2, 3), t1.bb, (0, 3), (1, 2))
    del tmp30
    tmp96 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1))) * -1
    tmp96 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    tmp227 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 4, 1, 5), (4, 2, 3, 5))
    tmp229 = np.copy(v.bbbb.oovv)
    tmp229 += np.transpose(tmp221, (1, 0, 3, 2)) * -1
    tmp125 = einsum(t2.bbbb, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp209 = np.copy(tmp140) * -1
    tmp209 += tmp139
    tmp203 = np.copy(tmp24)
    tmp203 += tmp25 * 2
    tmp203 += tmp26
    tmp160 = np.copy(np.transpose(v.aabb.vvov, (2, 0, 1, 3)))
    tmp160 += tmp54 * -1
    tmp95 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    tmp154 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovov, (1, 3, 4, 5), (0, 4, 2, 5))
    tmp48 = np.copy(f.bb.ov)
    tmp48 += tmp13
    tmp48 += tmp47 * -1
    del tmp47
    tmp132 = np.copy(v.bbbb.ovvv)
    tmp132 += np.transpose(v.bbbb.ovvv, (0, 2, 1, 3)) * -1
    tmp49 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp166 = np.copy(tmp21) * -1
    tmp166 += np.transpose(tmp21, (0, 2, 1, 3))
    tmp57 = einsum(t1.bb, (0, 1), v.aabb.vvov, (2, 3, 0, 1), (2, 3))
    tmp43 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (4, 1))
    tmp60 = einsum(tmp9, (0, 1), t1.aa, (0, 2), (2, 1))
    tmp59 = einsum(t1.aa, (0, 1), tmp58, (0, 2, 1, 3), (2, 3))
    tmp42 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (0, 4, 1, 3), (2, 4))
    tmp71 = np.copy(tmp5) * 2
    tmp71 += tmp6
    tmp71 += tmp10
    tmp98 = np.copy(v.aaaa.ooov) * -1
    tmp98 += np.transpose(v.aaaa.ovoo, (0, 2, 3, 1))
    tmp104 = np.copy(v.aaaa.oovv)
    tmp104 += np.transpose(tmp93, (1, 0, 2, 3)) * -1
    tmp52 = np.copy(v.aaaa.ovvv)
    tmp52 += np.transpose(tmp51, (0, 3, 2, 1))
    tmp69 = einsum(t1.aa, (0, 1), tmp64, (2, 3, 4, 0), (2, 4, 3, 1))
    tmp79 = np.copy(tmp77) * -1
    tmp79 += tmp78
    tmp19 = einsum(tmp18, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    del tmp18
    tmp85 = np.copy(np.transpose(tmp82, (0, 1, 3, 2))) * -1
    del tmp82
    tmp85 += tmp84 * -1
    tmp114 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp102 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp75 = np.copy(tmp2)
    tmp75 += np.transpose(tmp2, (0, 2, 1, 3)) * -1
    tmp39 = np.copy(f.aa.oo)
    tmp39 += np.transpose(tmp17, (1, 0))
    tmp39 += np.transpose(tmp38, (1, 0)) * -1
    del tmp38
    tmp116 = np.copy(v.aaaa.ovvv)
    tmp116 += np.transpose(tmp51, (0, 3, 1, 2))
    tmp535 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.bbbb, (4, 5, 6, 3), (4, 5, 0, 6, 1, 2))
    tmp549 = einsum(tmp199, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 6), (0, 4, 1, 5, 6, 3))
    tmp560 = einsum(t1.bb, (0, 1), tmp559, (2, 0, 3, 4, 5, 6), (2, 4, 3, 6, 5, 1)) * -2
    del tmp559
    tmp550 = einsum(tmp233, (0, 1, 2, 3), t2.bbbb, (4, 5, 6, 2), (0, 4, 5, 6, 3, 1))
    tmp526 = einsum(tmp525, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 6), (0, 2, 4, 3, 5, 6)) * -1
    del tmp525
    tmp519 = einsum(t3.bbbbbb, (0, 1, 2, 3, 4, 5), f.bb.vv, (6, 5), (0, 1, 2, 6, 3, 4))
    tmp534 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 6), (4, 0, 2, 5, 6, 3))
    tmp516 = einsum(t1.bb, (0, 1), tmp515, (2, 0, 3, 4, 5, 6), (2, 3, 4, 5, 6, 1))
    del tmp515
    tmp518 = einsum(tmp317, (0, 1), t3.bbbbbb, (2, 3, 4, 5, 6, 0), (2, 3, 4, 1, 5, 6))
    tmp512 = einsum(t1.bb, (0, 1), tmp511, (2, 3, 0, 4, 5, 6), (2, 3, 4, 1, 5, 6))
    del tmp511
    tmp541 = einsum(tmp456, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 6), (0, 2, 4, 3, 5, 6)) * -1
    tmp540 = einsum(tmp21, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 6), (0, 4, 1, 5, 6, 3))
    tmp533 = einsum(t1.bb, (0, 1), tmp532, (2, 3, 0, 4, 5, 6), (2, 3, 4, 1, 5, 6))
    del tmp532
    tmp537 = einsum(t2.bbbb, (0, 1, 2, 3), tmp536, (4, 5, 3, 6), (4, 0, 1, 5, 6, 2)) * -2
    del tmp536
    tmp517 = einsum(t3.bbbbbb, (0, 1, 2, 3, 4, 5), tmp419, (5, 6), (0, 1, 2, 6, 3, 4)) * 3
    tmp554 = einsum(t1.bb, (0, 1), tmp553, (2, 3, 4, 0), (2, 4, 3, 1))
    del tmp553
    tmp546 = einsum(t2.bbbb, (0, 1, 2, 3), tmp545, (4, 5, 1, 6), (4, 5, 0, 6, 2, 3)) * -1
    del tmp545
    tmp539 = einsum(tmp446, (0, 1, 2, 3), t2.bbbb, (4, 5, 6, 2), (0, 4, 5, 1, 3, 6)) * -1
    tmp538 = einsum(tmp445, (0, 1, 2, 3), t2.bbbb, (4, 5, 6, 3), (0, 4, 5, 1, 2, 6)) * -1
    tmp520 = einsum(tmp323, (0, 1), t3.bbbbbb, (2, 3, 0, 4, 5, 6), (1, 2, 3, 4, 5, 6))
    tmp527 = einsum(tmp492, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 6), (0, 1, 4, 3, 5, 6)) * -1
    tmp555 = einsum(tmp235, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 6), (1, 0, 4, 3, 5, 6))
    tmp548 = einsum(t1.bb, (0, 1), tmp547, (2, 3, 4, 0, 5, 6), (2, 3, 4, 1, 5, 6))
    del tmp547
    tmp529 = einsum(tmp528, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 6), (1, 2, 4, 3, 5, 6)) * -1
    del tmp528
    tmp556 = einsum(tmp237, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 6), (0, 1, 4, 5, 6, 3))
    tmp531 = einsum(tmp431, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 6), (2, 1, 4, 3, 5, 6)) * -1
    tmp509 = einsum(f.bb.oo, (0, 1), t3.bbbbbb, (2, 3, 1, 4, 5, 6), (0, 2, 3, 4, 5, 6))
    tmp542 = np.copy(np.transpose(tmp199, (0, 2, 1, 3)))
    tmp542 += einsum(t1.bb, (0, 1), tmp424, (2, 3, 4, 0), (2, 4, 3, 1))
    tmp523 = einsum(tmp522, (0, 1, 2, 3, 4, 5), t1.bb, (3, 6), (0, 1, 2, 6, 4, 5))
    del tmp522
    tmp508 = einsum(tmp176, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 6), (4, 2, 0, 3, 5, 6))
    tmp552 = einsum(t1.bb, (0, 1), tmp551, (2, 0, 3, 4, 5, 6), (2, 4, 3, 6, 5, 1)) * -1
    del tmp551
    tmp530 = einsum(tmp432, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 6), (1, 2, 4, 3, 5, 6)) * -1
    tmp496 = einsum(t2.abab, (0, 1, 2, 3), tmp237, (4, 5, 1, 6), (0, 4, 5, 2, 3, 6))
    tmp507 = einsum(t2.abab, (0, 1, 2, 3), tmp399, (4, 0, 5, 6), (4, 5, 1, 2, 6, 3))
    tmp452 = einsum(tmp1, (0, 1, 2, 3), t2.abab, (1, 4, 5, 6), (0, 4, 2, 5, 6, 3))
    tmp425 = np.copy(tmp423)
    tmp425 += einsum(t2.abab, (0, 1, 2, 3), tmp424, (4, 5, 6, 1), (0, 4, 6, 5, 2, 3))
    del tmp424
    tmp488 = np.copy(np.transpose(tmp376, (0, 1, 3, 2)))
    tmp488 += einsum(t1.bb, (0, 1), tmp77, (2, 0, 3, 4), (2, 3, 4, 1)) * -1
    tmp460 = einsum(tmp459, (0, 1, 2, 3, 4, 5), t1.bb, (2, 6), (0, 1, 3, 4, 6, 5))
    del tmp459
    tmp444 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.abab, (4, 5, 6, 3), (4, 5, 0, 6, 1, 2))
    tmp473 = einsum(tmp472, (0, 1, 2, 3, 4, 5), t1.aa, (1, 6), (0, 2, 3, 6, 4, 5))
    del tmp472
    tmp484 = einsum(t1.bb, (0, 1), tmp483, (2, 3, 0, 4, 5, 6), (2, 3, 4, 5, 6, 1)) * -1
    del tmp483
    tmp485 = np.copy(np.transpose(tmp150, (0, 2, 1, 3)))
    tmp485 += np.transpose(tmp476, (0, 2, 1, 3)) * -1
    tmp464 = np.copy(np.transpose(tmp173, (1, 0, 2, 3))) * -1
    tmp464 += tmp354
    tmp441 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 5, 6), (0, 4, 5, 2, 3, 6))
    tmp495 = einsum(t2.abab, (0, 1, 2, 3), tmp235, (4, 5, 1, 6), (0, 5, 4, 2, 6, 3))
    tmp434 = einsum(tmp331, (0, 1, 2, 3), t2.abab, (0, 4, 5, 6), (1, 2, 4, 5, 3, 6))
    tmp503 = einsum(t2.abab, (0, 1, 2, 3), tmp174, (4, 0, 5, 6), (4, 5, 1, 2, 3, 6))
    tmp465 = einsum(tmp22, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 6), (0, 1, 4, 3, 5, 6))
    tmp457 = einsum(t2.abab, (0, 1, 2, 3), tmp456, (4, 1, 5, 6), (0, 4, 5, 2, 6, 3))
    del tmp456
    tmp430 = np.copy(np.transpose(tmp334, (1, 0, 2, 3)))
    tmp430 += tmp331 * -1
    tmp502 = einsum(tmp77, (0, 1, 2, 3), t2.bbbb, (4, 5, 6, 3), (0, 4, 5, 1, 2, 6))
    del tmp77
    tmp490 = einsum(tmp393, (0, 1, 2, 3), t2.abab, (1, 4, 5, 6), (0, 4, 2, 5, 3, 6))
    tmp418 = einsum(t3.babbab, (0, 1, 2, 3, 4, 5), f.bb.ov, (6, 5), (1, 6, 0, 2, 4, 3)) * 2
    tmp418 += np.transpose(tmp413, (0, 3, 2, 1, 4, 5))
    tmp471 = einsum(tmp470, (0, 1, 2, 3, 4, 5), t1.bb, (3, 6), (0, 1, 2, 4, 6, 5))
    del tmp470
    tmp482 = einsum(tmp481, (0, 1, 2, 3), t2.abab, (4, 5, 6, 1), (4, 0, 5, 6, 2, 3))
    del tmp481
    tmp439 = einsum(t2.bbbb, (0, 1, 2, 3), tmp148, (4, 5, 3, 6), (5, 4, 0, 1, 2, 6))
    tmp475 = einsum(tmp173, (0, 1, 2, 3), t2.abab, (1, 4, 5, 6), (0, 2, 4, 5, 6, 3))
    tmp420 = einsum(t3.babbab, (0, 1, 2, 3, 4, 5), tmp256, (4, 6), (1, 0, 2, 6, 3, 5))
    tmp453 = einsum(t2.abab, (0, 1, 2, 3), tmp21, (4, 5, 1, 6), (0, 4, 5, 2, 3, 6))
    tmp436 = einsum(t2.bbbb, (0, 1, 2, 3), tmp435, (4, 1, 5, 6), (4, 5, 0, 6, 2, 3)) * -1
    del tmp435
    tmp428 = einsum(tmp138, (0, 1, 2, 3), t2.abab, (1, 4, 5, 6), (0, 4, 2, 3, 5, 6)) * -1
    tmp428 += einsum(t1.aa, (0, 1), tmp427, (2, 0, 3, 4, 5, 6), (2, 4, 3, 5, 1, 6)) * 2
    del tmp427
    tmp448 = np.copy(v.aabb.ovvv)
    tmp448 += np.transpose(tmp129, (0, 1, 3, 2)) * -1
    del tmp129
    tmp479 = np.copy(np.transpose(tmp376, (0, 1, 3, 2)))
    tmp479 += einsum(tmp478, (0, 1, 2, 3), t1.aa, (1, 4), (0, 4, 3, 2)) * -1
    del tmp478
    tmp443 = einsum(tmp55, (0, 1, 2, 3), t2.abab, (4, 5, 1, 6), (4, 5, 0, 2, 6, 3))
    tmp447 = einsum(v.aabb.vvov, (0, 1, 2, 3), t2.abab, (4, 5, 1, 6), (4, 5, 2, 0, 6, 3))
    tmp433 = einsum(t2.bbbb, (0, 1, 2, 3), tmp329, (4, 1, 5, 6), (4, 0, 5, 6, 2, 3))
    tmp417 = einsum(v.aabb.oooo, (0, 1, 2, 3), t2.abab, (1, 4, 5, 6), (0, 4, 2, 3, 5, 6)) * -1
    tmp417 += einsum(t1.aa, (0, 1), tmp416, (0, 2, 3, 4, 5, 6), (2, 4, 3, 5, 1, 6)) * 2
    del tmp416
    tmp469 = einsum(t2.abab, (0, 1, 2, 3), tmp199, (4, 5, 1, 6), (0, 4, 5, 2, 3, 6))
    tmp411 = einsum(f.bb.oo, (0, 1), t3.babbab, (2, 3, 1, 4, 5, 6), (3, 0, 2, 5, 4, 6))
    tmp415 = einsum(f.aa.oo, (0, 1), t3.babbab, (2, 1, 3, 4, 5, 6), (0, 2, 3, 5, 4, 6))
    tmp451 = einsum(tmp334, (0, 1, 2, 3), t2.abab, (1, 4, 5, 6), (0, 4, 2, 5, 3, 6))
    tmp440 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 4, 5, 6), (0, 4, 2, 5, 6, 3))
    tmp505 = einsum(tmp504, (0, 1, 2, 3, 4, 5), t1.aa, (1, 6), (0, 2, 3, 6, 4, 5))
    del tmp504
    tmp498 = einsum(tmp497, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 6), (0, 1, 4, 3, 5, 6)) * -1
    del tmp497
    tmp421 = einsum(tmp323, (0, 1), t3.babbab, (2, 3, 0, 4, 5, 6), (3, 1, 2, 5, 4, 6))
    tmp463 = einsum(tmp462, (0, 1, 2, 3, 4, 5), t1.bb, (2, 6), (0, 1, 3, 4, 6, 5))
    del tmp462
    tmp414 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.oooo, (4, 5, 6, 1), (0, 4, 5, 6, 2, 3))
    tmp414 += np.transpose(tmp413, (0, 1, 3, 2, 4, 5)) * -1
    del tmp413
    tmp487 = np.copy(np.transpose(tmp150, (0, 2, 1, 3))) * -1
    tmp487 += np.transpose(tmp486, (0, 2, 1, 3))
    tmp450 = einsum(t2.bbbb, (0, 1, 2, 3), tmp328, (4, 5, 1, 6), (4, 0, 5, 6, 2, 3))
    tmp474 = einsum(t2.bbbb, (0, 1, 2, 3), v.aabb.oovv, (4, 5, 6, 3), (4, 5, 0, 1, 2, 6))
    tmp449 = einsum(t2.abab, (0, 1, 2, 3), tmp176, (4, 1, 5, 6), (0, 5, 4, 2, 6, 3))
    tmp467 = einsum(tmp466, (0, 1, 2, 3, 4, 5), t1.bb, (2, 6), (0, 1, 3, 4, 6, 5))
    del tmp466
    tmp458 = einsum(tmp364, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 6), (0, 2, 4, 3, 5, 6)) * -1
    tmp477 = np.copy(np.transpose(tmp150, (0, 2, 1, 3)))
    tmp477 += tmp476 * -1
    del tmp476
    tmp501 = einsum(tmp500, (0, 1, 2, 3, 4, 5), t1.bb, (3, 6), (0, 1, 2, 4, 6, 5))
    del tmp500
    tmp442 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 6), (0, 4, 2, 1, 5, 6))
    tmp506 = einsum(t2.bbbb, (0, 1, 2, 3), tmp169, (4, 5, 6, 3), (4, 5, 0, 1, 2, 6))
    tmp429 = einsum(t2.abab, (0, 1, 2, 3), tmp135, (4, 0, 5, 6), (4, 5, 1, 6, 2, 3))
    tmp429 += tmp423
    del tmp423
    tmp493 = einsum(tmp391, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 6), (0, 1, 4, 3, 5, 6))
    tmp438 = einsum(tmp437, (0, 1, 2, 3, 4, 5), t1.aa, (1, 6), (0, 2, 3, 6, 4, 5))
    del tmp437
    tmp494 = np.copy(tmp174) * -1
    tmp494 += tmp399
    tmp489 = np.copy(np.transpose(tmp150, (0, 2, 1, 3)))
    tmp489 += np.transpose(tmp486, (0, 2, 1, 3)) * -1
    del tmp486
    tmp426 = einsum(tmp259, (0, 1), t3.babbab, (2, 0, 3, 4, 5, 6), (1, 2, 3, 5, 4, 6))
    tmp499 = np.copy(tmp174)
    tmp499 += tmp399 * -1
    del tmp399
    tmp468 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 5, 6, 3), (0, 4, 5, 2, 1, 6))
    tmp340 = einsum(tmp339, (0, 1, 2, 3), t2.aaaa, (4, 5, 6, 2), (4, 5, 1, 0, 6, 3))
    del tmp339
    tmp401 = einsum(tmp400, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 6), (0, 4, 2, 5, 6, 3)) * -1
    del tmp400
    tmp375 = einsum(t2.abab, (0, 1, 2, 3), tmp136, (4, 5, 1, 6), (4, 0, 5, 2, 6, 3))
    tmp405 = einsum(t2.aaaa, (0, 1, 2, 3), tmp140, (4, 5, 3, 6), (0, 1, 4, 5, 2, 6))
    tmp318 = einsum(tmp317, (0, 1), t3.abaaba, (2, 3, 4, 5, 0, 6), (2, 4, 3, 5, 6, 1))
    tmp388 = np.copy(np.transpose(tmp376, (0, 1, 3, 2))) * -1
    tmp388 += np.transpose(tmp387, (0, 1, 3, 2))
    tmp402 = np.copy(tmp149)
    tmp402 += tmp395 * -1
    tmp367 = einsum(tmp366, (0, 1, 2, 3, 4, 5), t1.aa, (1, 6), (0, 2, 3, 6, 4, 5))
    del tmp366
    tmp385 = einsum(t1.aa, (0, 1), tmp384, (2, 0, 3, 4, 5, 6), (2, 3, 4, 5, 1, 6)) * -1
    del tmp384
    tmp361 = einsum(tmp360, (0, 1, 2, 3, 4, 5), t1.aa, (1, 6), (0, 2, 3, 6, 4, 5))
    del tmp360
    tmp371 = einsum(t1.aa, (0, 1), tmp370, (2, 3, 0, 4, 5, 6), (2, 3, 4, 1, 5, 6))
    del tmp370
    tmp324 = einsum(t3.abaaba, (0, 1, 2, 3, 4, 5), tmp323, (1, 6), (0, 2, 6, 3, 5, 4))
    del tmp323
    tmp319 = einsum(tmp259, (0, 1), t3.abaaba, (2, 3, 0, 4, 5, 6), (1, 2, 3, 4, 6, 5))
    tmp404 = einsum(t1.aa, (0, 1), tmp403, (2, 3, 0, 4, 5, 6), (2, 3, 4, 1, 5, 6))
    del tmp403
    tmp349 = einsum(t2.aaaa, (0, 1, 2, 3), tmp334, (4, 1, 5, 6), (0, 4, 5, 2, 3, 6))
    del tmp334
    tmp346 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovvv, (4, 5, 6, 3), (0, 4, 1, 2, 5, 6))
    tmp380 = np.copy(np.transpose(tmp150, (0, 2, 1, 3)))
    tmp380 += einsum(tmp379, (0, 1, 2, 3), t1.bb, (1, 4), (0, 3, 2, 4)) * -1
    del tmp379
    tmp398 = einsum(t2.abab, (0, 1, 2, 3), tmp112, (4, 5, 0, 6), (4, 5, 1, 2, 6, 3))
    tmp326 = einsum(tmp135, (0, 1, 2, 3), t2.abab, (4, 3, 5, 6), (4, 0, 1, 2, 5, 6)) * -1
    tmp326 += einsum(tmp325, (0, 1, 2, 3, 4, 5), t1.bb, (4, 6), (0, 1, 2, 3, 5, 6)) * -2
    del tmp325
    tmp396 = np.copy(tmp149) * -1
    tmp396 += tmp395
    tmp358 = einsum(tmp357, (0, 1, 2, 3, 4, 5), t1.aa, (1, 6), (0, 2, 3, 6, 4, 5))
    del tmp357
    tmp311 = einsum(v.aaaa.oooo, (0, 1, 2, 3), t2.abab, (3, 4, 5, 6), (0, 1, 2, 4, 5, 6))
    tmp311 += np.transpose(tmp310, (0, 2, 1, 3, 4, 5)) * -1
    tmp383 = einsum(t2.abab, (0, 1, 2, 3), tmp382, (4, 2, 5, 6), (4, 0, 1, 5, 6, 3))
    del tmp382
    tmp336 = einsum(tmp335, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 6), (1, 4, 2, 5, 6, 3)) * -1
    del tmp335
    tmp338 = einsum(tmp337, (0, 1, 2, 3, 4, 5), t1.bb, (3, 6), (0, 1, 2, 4, 5, 6))
    del tmp337
    tmp390 = np.copy(np.transpose(tmp376, (0, 1, 3, 2)))
    tmp390 += np.transpose(tmp387, (0, 1, 3, 2)) * -1
    del tmp387
    tmp330 = np.copy(np.transpose(tmp328, (0, 2, 1, 3)))
    tmp330 += tmp329 * -1
    tmp327 = einsum(t2.abab, (0, 1, 2, 3), tmp138, (4, 5, 6, 1), (4, 0, 5, 6, 2, 3))
    tmp327 += tmp321
    tmp386 = np.copy(np.transpose(tmp376, (0, 1, 3, 2)))
    tmp386 += np.transpose(tmp377, (0, 1, 3, 2)) * -1
    tmp348 = einsum(tmp244, (0, 1, 2, 3), t2.abab, (1, 4, 5, 6), (2, 0, 4, 3, 5, 6))
    tmp351 = einsum(t2.abab, (0, 1, 2, 3), tmp22, (4, 5, 1, 6), (0, 4, 5, 2, 6, 3))
    tmp312 = einsum(f.bb.oo, (0, 1), t3.abaaba, (2, 1, 3, 4, 5, 6), (2, 3, 0, 4, 6, 5))
    tmp352 = einsum(t2.abab, (0, 1, 2, 3), tmp2, (4, 5, 0, 6), (4, 5, 1, 2, 6, 3))
    tmp347 = np.copy(np.transpose(v.aabb.vvov, (2, 0, 1, 3)))
    tmp347 += np.transpose(tmp54, (0, 2, 1, 3)) * -1
    del tmp54
    tmp406 = einsum(t2.abab, (0, 1, 2, 3), tmp149, (4, 5, 1, 6), (4, 0, 5, 2, 6, 3))
    tmp363 = np.copy(np.transpose(tmp136, (0, 2, 1, 3))) * -1
    tmp363 += np.transpose(tmp362, (0, 2, 1, 3))
    tmp332 = einsum(t2.aaaa, (0, 1, 2, 3), tmp331, (1, 4, 5, 6), (0, 4, 5, 2, 3, 6))
    del tmp331
    tmp409 = einsum(t2.aaaa, (0, 1, 2, 3), tmp141, (4, 5, 6, 3), (0, 1, 4, 5, 2, 6))
    tmp392 = einsum(t2.abab, (0, 1, 2, 3), tmp391, (4, 5, 1, 6), (0, 4, 5, 6, 2, 3))
    del tmp391
    tmp350 = einsum(tmp328, (0, 1, 2, 3), t2.abab, (4, 2, 5, 6), (4, 0, 1, 3, 5, 6))
    del tmp328
    tmp345 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.abab, (4, 5, 3, 6), (4, 0, 5, 1, 2, 6))
    tmp342 = einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ooov, (4, 0, 5, 6), (4, 5, 1, 2, 6, 3))
    tmp315 = einsum(f.aa.ov, (0, 1), t3.abaaba, (2, 3, 4, 5, 6, 1), (0, 2, 4, 3, 5, 6)) * 2
    tmp315 += np.transpose(tmp310, (1, 2, 0, 3, 4, 5))
    del tmp310
    tmp369 = einsum(t2.abab, (0, 1, 2, 3), tmp66, (4, 5, 0, 6), (4, 5, 1, 2, 6, 3))
    tmp408 = einsum(t1.bb, (0, 1), tmp407, (2, 3, 4, 0, 5, 6), (2, 3, 4, 5, 6, 1))
    del tmp407
    tmp397 = einsum(tmp108, (0, 1, 2, 3), t2.abab, (2, 4, 5, 6), (1, 0, 4, 3, 5, 6))
    tmp365 = einsum(tmp1, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 6), (0, 4, 2, 5, 6, 3))
    tmp356 = einsum(tmp355, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 6), (1, 4, 2, 5, 6, 3)) * -1
    tmp389 = np.copy(np.transpose(tmp150, (0, 2, 1, 3)))
    tmp389 += einsum(t1.aa, (0, 1), tmp140, (0, 2, 3, 4), (2, 3, 1, 4)) * -1
    tmp353 = einsum(tmp288, (0, 1, 2, 3), t2.abab, (1, 4, 5, 6), (0, 2, 4, 3, 5, 6))
    tmp344 = einsum(t2.abab, (0, 1, 2, 3), tmp130, (4, 5, 3, 6), (0, 4, 1, 2, 5, 6))
    tmp374 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.vvoo, (4, 3, 5, 6), (0, 1, 5, 6, 2, 4))
    tmp373 = einsum(t1.bb, (0, 1), tmp372, (2, 3, 4, 0, 5, 6), (2, 3, 4, 5, 6, 1))
    del tmp372
    tmp314 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.oooo, (4, 5, 6, 1), (0, 4, 5, 6, 2, 3)) * -1
    tmp314 += einsum(t1.bb, (0, 1), tmp313, (2, 3, 4, 0, 5, 6), (2, 3, 4, 5, 6, 1)) * -2
    del tmp313
    tmp343 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ooov, (4, 1, 5, 6), (0, 4, 5, 2, 3, 6))
    tmp378 = np.copy(np.transpose(tmp376, (0, 1, 3, 2)))
    del tmp376
    tmp378 += tmp377 * -1
    del tmp377
    tmp410 = einsum(tmp395, (0, 1, 2, 3), t2.abab, (4, 2, 5, 6), (0, 4, 1, 3, 5, 6))
    del tmp395
    tmp341 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (4, 3, 5, 6), (4, 0, 2, 5, 1, 6))
    tmp308 = einsum(t3.abaaba, (0, 1, 2, 3, 4, 5), f.aa.oo, (6, 2), (6, 0, 1, 3, 5, 4))
    tmp333 = einsum(tmp329, (0, 1, 2, 3), t2.abab, (4, 1, 5, 6), (0, 4, 2, 3, 5, 6))
    del tmp329
    tmp322 = np.copy(tmp321)
    del tmp321
    tmp322 += einsum(t2.abab, (0, 1, 2, 3), tmp290, (4, 5, 6, 0), (4, 6, 5, 1, 2, 3))
    tmp368 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovov, (4, 3, 5, 6), (0, 1, 4, 5, 2, 6))
    tmp394 = einsum(tmp393, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 6), (0, 4, 2, 5, 6, 3))
    del tmp393
    tmp285 = einsum(tmp284, (0, 1, 2, 3), t2.aaaa, (4, 5, 6, 2), (0, 4, 5, 1, 3, 6)) * -1
    tmp277 = einsum(t1.aa, (0, 1), tmp276, (2, 3, 0, 4, 5, 6), (2, 3, 4, 1, 5, 6))
    del tmp276
    tmp258 = einsum(f.aa.vv, (0, 1), t3.aaaaaa, (2, 3, 4, 5, 6, 1), (2, 3, 4, 0, 5, 6))
    tmp272 = einsum(t2.aaaa, (0, 1, 2, 3), tmp271, (1, 4, 5, 6), (4, 5, 0, 6, 2, 3)) * -2
    del tmp271
    tmp269 = einsum(t2.aaaa, (0, 1, 2, 3), tmp268, (4, 5, 1, 6), (4, 5, 0, 6, 2, 3)) * -1
    tmp255 = einsum(t3.aaaaaa, (0, 1, 2, 3, 4, 5), tmp254, (5, 6), (0, 1, 2, 6, 3, 4)) * 3
    tmp300 = einsum(t1.aa, (0, 1), tmp299, (2, 0, 3, 4, 5, 6), (2, 4, 3, 6, 5, 1)) * -1
    del tmp299
    tmp286 = einsum(tmp2, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 6), (0, 4, 1, 5, 6, 3))
    tmp263 = einsum(t1.aa, (0, 1), tmp262, (2, 3, 4, 0, 5, 6), (2, 3, 4, 1, 5, 6))
    del tmp262
    tmp291 = np.copy(np.transpose(tmp66, (0, 2, 1, 3)))
    tmp291 += einsum(t1.aa, (0, 1), tmp290, (2, 3, 4, 0), (2, 4, 3, 1))
    del tmp290
    tmp302 = einsum(t1.aa, (0, 1), tmp301, (2, 3, 4, 0), (2, 4, 3, 1))
    del tmp301
    tmp257 = einsum(t3.aaaaaa, (0, 1, 2, 3, 4, 5), tmp256, (5, 6), (0, 1, 2, 6, 3, 4))
    tmp303 = einsum(tmp108, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 6), (1, 0, 4, 3, 5, 6))
    tmp279 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 5, 6, 3), (4, 5, 0, 6, 1, 2))
    tmp245 = einsum(tmp244, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 6), (4, 2, 0, 3, 5, 6))
    del tmp244
    tmp298 = einsum(tmp110, (0, 1, 2, 3), t2.aaaa, (4, 5, 6, 2), (0, 4, 5, 6, 3, 1))
    tmp289 = einsum(t2.aaaa, (0, 1, 2, 3), tmp288, (4, 1, 5, 6), (4, 5, 0, 6, 2, 3)) * -1
    del tmp288
    tmp266 = einsum(t2.aaaa, (0, 1, 2, 3), tmp265, (4, 1, 5, 6), (4, 5, 0, 6, 2, 3)) * -1
    del tmp265
    tmp243 = einsum(f.aa.oo, (0, 1), t3.aaaaaa, (2, 3, 1, 4, 5, 6), (0, 2, 3, 4, 5, 6))
    tmp281 = einsum(tmp280, (0, 1, 2, 3), t2.aaaa, (4, 5, 6, 2), (0, 4, 5, 1, 3, 6)) * -2
    del tmp280
    tmp297 = einsum(tmp66, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 6), (0, 4, 1, 5, 6, 3))
    tmp307 = einsum(t1.aa, (0, 1), tmp306, (2, 0, 3, 4, 5, 6), (2, 4, 3, 6, 5, 1)) * -2
    del tmp306
    tmp283 = einsum(tmp282, (0, 1, 2, 3), t2.aaaa, (4, 5, 6, 3), (0, 4, 5, 1, 2, 6)) * -1
    tmp274 = einsum(t2.aaaa, (0, 1, 2, 3), tmp273, (1, 4, 5, 6), (4, 5, 0, 6, 2, 3)) * -1
    tmp304 = einsum(t2.aaaa, (0, 1, 2, 3), tmp112, (4, 5, 1, 6), (4, 5, 0, 2, 3, 6))
    tmp275 = einsum(tmp270, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 6), (2, 1, 4, 3, 5, 6)) * -1
    tmp296 = einsum(t1.aa, (0, 1), tmp295, (2, 3, 4, 0, 5, 6), (2, 3, 4, 1, 5, 6))
    del tmp295
    tmp278 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 1, 5, 6), (0, 4, 5, 2, 3, 6))
    tmp260 = einsum(tmp259, (0, 1), t3.aaaaaa, (2, 3, 0, 4, 5, 6), (1, 2, 3, 4, 5, 6))
    del tmp259
    tmp252 = einsum(t1.aa, (0, 1), tmp251, (2, 0, 3, 4, 5, 6), (2, 3, 4, 5, 6, 1))
    del tmp251
    tmp248 = einsum(t1.aa, (0, 1), tmp247, (2, 3, 0, 4, 5, 6), (2, 3, 4, 1, 5, 6))
    del tmp247
    tmp294 = einsum(t2.aaaa, (0, 1, 2, 3), tmp293, (4, 5, 1, 6), (4, 5, 0, 6, 2, 3)) * -1
    del tmp293
    tmp240 = einsum(t2.bbbb, (0, 1, 2, 3), tmp239, (4, 5, 1, 0), (5, 4, 2, 3))
    del tmp239
    tmp225 = np.copy(v.bbbb.oovv)
    tmp225 += einsum(tmp100, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 2), (4, 1, 5, 3)) * -2
    tmp225 += einsum(tmp224, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3)) * -1
    del tmp224
    tmp182 = einsum(t2.bbbb, (0, 1, 2, 3), tmp181, (1, 4), (0, 4, 2, 3)) * -1
    del tmp181
    tmp218 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 4, 3))
    tmp202 = einsum(tmp201, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 4, 3))
    del tmp201
    tmp186 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 5), (1, 4, 3, 5))
    tmp236 = einsum(tmp235, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3))
    del tmp235
    tmp198 = einsum(t2.bbbb, (0, 1, 2, 3), tmp197, (4, 5, 0, 1), (4, 5, 2, 3))
    del tmp197
    tmp188 = einsum(t3.bbbbbb, (0, 1, 2, 3, 4, 5), tmp187, (2, 4, 5, 6), (0, 1, 6, 3)) * -6
    tmp124 = np.copy(tmp122) * 0.5
    tmp124 += tmp123
    tmp177 = einsum(tmp176, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 4, 3))
    del tmp176
    tmp195 = einsum(tmp22, (0, 1, 2, 3), t3.babbab, (4, 0, 2, 5, 3, 6), (1, 4, 5, 6))
    tmp238 = einsum(t1.bb, (0, 1), tmp237, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp237
    tmp223 = np.copy(tmp144)
    tmp223 += einsum(tmp91, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5))
    tmp175 = einsum(v.bbbb.oooo, (0, 1, 2, 3), t2.bbbb, (1, 3, 4, 5), (0, 2, 4, 5))
    tmp234 = einsum(tmp233, (0, 1, 2, 3), t1.bb, (4, 2), (4, 0, 1, 3))
    del tmp233
    tmp179 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t3.babbab, (4, 0, 3, 5, 1, 6), (4, 2, 5, 6))
    tmp200 = einsum(t1.bb, (0, 1), tmp199, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp199
    tmp178 = einsum(t3.bbbbbb, (0, 1, 2, 3, 4, 5), v.bbbb.ooov, (6, 1, 2, 5), (0, 6, 3, 4))
    tmp242 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    tmp189 = einsum(t3.babbab, (0, 1, 2, 3, 4, 5), tmp130, (1, 4, 5, 6), (0, 2, 3, 6)) * -2
    tmp226 = np.copy(tmp144)
    tmp226 += einsum(t2.abab, (0, 1, 2, 3), tmp7, (0, 4, 2, 5), (4, 1, 5, 3))
    tmp208 = einsum(t1.bb, (0, 1), tmp190, (2, 1, 3, 4), (0, 2, 4, 3)) * -1
    del tmp190
    tmp208 += einsum(tmp207, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 4, 3)) * -1
    del tmp207
    tmp216 = einsum(t2.bbbb, (0, 1, 2, 3), tmp215, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp215
    tmp193 = np.copy(f.bb.vv) * -1
    tmp193 += np.transpose(tmp131, (1, 0)) * -1
    tmp193 += np.transpose(tmp122, (1, 0))
    del tmp122
    tmp193 += np.transpose(tmp123, (1, 0)) * 2
    del tmp123
    tmp193 += tmp191 * -1
    tmp193 += np.transpose(tmp192, (1, 0))
    tmp194 = np.copy(f.bb.vv) * -1
    tmp194 += np.transpose(tmp131, (1, 0)) * -1
    tmp194 += tmp191 * -1
    del tmp191
    tmp194 += np.transpose(tmp192, (1, 0))
    del tmp192
    tmp185 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp32 = np.copy(f.bb.oo)
    tmp32 += np.transpose(tmp29, (1, 0))
    del tmp29
    tmp32 += np.transpose(tmp31, (1, 0)) * -1
    del tmp31
    tmp241 = np.copy(v.bbbb.vvvv) * -1
    tmp241 += einsum(tmp187, (0, 1, 2, 3), t1.bb, (0, 4), (1, 4, 3, 2))
    del tmp187
    tmp196 = einsum(t3.bbbbbb, (0, 1, 2, 3, 4, 5), tmp21, (6, 2, 1, 5), (6, 0, 3, 4))
    tmp222 = np.copy(v.bbbb.oovv)
    tmp222 += einsum(t2.bbbb, (0, 1, 2, 3), tmp96, (1, 4, 3, 5), (0, 4, 2, 5)) * -2
    tmp222 += np.transpose(tmp221, (0, 1, 3, 2)) * -1
    del tmp221
    tmp217 = einsum(t2.abab, (0, 1, 2, 3), tmp168, (0, 4, 2, 5), (1, 4, 3, 5))
    tmp228 = einsum(t1.bb, (0, 1), tmp227, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp227
    tmp183 = einsum(tmp16, (0, 1), t3.bbbbbb, (2, 3, 0, 4, 5, 1), (2, 3, 4, 5)) * 3
    tmp230 = einsum(t2.bbbb, (0, 1, 2, 3), tmp229, (1, 4, 5, 3), (4, 0, 5, 2))
    del tmp229
    tmp219 = einsum(t2.abab, (0, 1, 2, 3), tmp125, (0, 4, 2, 5), (1, 4, 3, 5))
    tmp210 = einsum(tmp209, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5))
    del tmp209
    tmp184 = np.copy(f.aa.ov)
    tmp184 += tmp0
    tmp184 += einsum(tmp91, (0, 1, 2, 3), t1.aa, (0, 2), (1, 3)) * -1
    tmp232 = einsum(t2.bbbb, (0, 1, 2, 3), tmp231, (4, 5, 1, 0), (5, 4, 2, 3))
    del tmp231
    tmp204 = einsum(t2.bbbb, (0, 1, 2, 3), tmp203, (4, 1), (4, 0, 2, 3)) * -1
    del tmp203
    tmp126 = np.copy(np.transpose(v.aaaa.ovvv, (0, 2, 3, 1)))
    tmp126 += tmp51
    del tmp51
    tmp3 = np.copy(t2.abab)
    tmp3 += einsum(t1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    tmp171 = np.copy(np.transpose(tmp169, (0, 1, 3, 2)))
    del tmp169
    tmp171 += np.transpose(tmp170, (0, 1, 3, 2)) * -1
    del tmp170
    tmp158 = np.copy(v.bbbb.oovv)
    tmp158 += einsum(tmp157, (0, 1, 2, 3), t1.bb, (0, 4), (2, 1, 3, 4))
    del tmp157
    tmp159 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp120 = np.copy(t2.abab)
    tmp120 += einsum(t1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1)) * 2
    tmp146 = np.copy(np.transpose(v.aabb.vvoo, (2, 3, 0, 1))) * -1
    tmp146 += np.transpose(tmp145, (1, 0, 3, 2))
    del tmp145
    tmp146 += einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (2, 4, 1, 5))
    tmp128 = np.copy(np.transpose(v.bbbb.ovvv, (0, 2, 3, 1)))
    tmp128 += tmp127
    del tmp127
    tmp172 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovvv, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp161 = np.copy(v.aabb.vvvv)
    tmp161 += einsum(tmp160, (0, 1, 2, 3), t1.bb, (0, 4), (2, 1, 3, 4)) * -1
    del tmp160
    tmp155 = np.copy(tmp95) * -1
    tmp155 += tmp154 * 2
    tmp155 += einsum(t2.abab, (0, 1, 2, 3), tmp46, (1, 4, 3, 5), (0, 4, 2, 5)) * -1
    del tmp46
    tmp151 = np.copy(np.transpose(v.aabb.vvov, (2, 0, 1, 3)))
    tmp151 += np.transpose(tmp150, (0, 2, 1, 3))
    del tmp150
    tmp133 = np.copy(f.bb.vv)
    tmp133 += np.transpose(tmp131, (1, 0))
    del tmp131
    tmp133 += einsum(tmp132, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3)) * -1
    del tmp132
    tmp133 += einsum(tmp48, (0, 1), t1.bb, (0, 2), (1, 2)) * -1
    tmp156 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 2, 3, 5))
    tmp153 = np.copy(v.aaaa.oovv)
    tmp153 += np.transpose(tmp49, (1, 0, 3, 2)) * -1
    tmp153 += einsum(t2.aaaa, (0, 1, 2, 3), tmp91, (1, 4, 3, 5), (4, 0, 5, 2)) * 2
    tmp153 += einsum(tmp37, (0, 1, 2, 3), t1.aa, (0, 4), (2, 1, 3, 4))
    del tmp37
    tmp27 = np.copy(np.transpose(tmp24, (1, 0)))
    del tmp24
    tmp27 += np.transpose(tmp25, (1, 0)) * 2
    del tmp25
    tmp27 += np.transpose(tmp26, (1, 0))
    del tmp26
    tmp167 = np.copy(np.transpose(tmp165, (0, 1, 3, 2))) * -1
    del tmp165
    tmp167 += einsum(tmp166, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 3, 4))
    del tmp166
    tmp61 = np.copy(f.aa.vv) * -1
    tmp61 += np.transpose(tmp57, (1, 0)) * -1
    tmp61 += np.transpose(tmp42, (1, 0)) * 2
    tmp61 += np.transpose(tmp43, (1, 0))
    tmp61 += tmp59 * -1
    tmp61 += np.transpose(tmp60, (1, 0))
    tmp137 = einsum(tmp1, (0, 1, 2, 3), t3.babbab, (4, 1, 2, 5, 6, 3), (0, 4, 6, 5))
    tmp143 = np.copy(np.transpose(tmp141, (0, 1, 3, 2)))
    del tmp141
    tmp143 += np.transpose(tmp142, (0, 1, 3, 2)) * -1
    del tmp142
    tmp134 = einsum(t3.babbab, (0, 1, 2, 3, 4, 5), tmp21, (6, 0, 2, 5), (1, 6, 4, 3)) * -1
    tmp119 = einsum(t3.babbab, (0, 1, 2, 3, 4, 5), v.bbbb.ooov, (6, 2, 0, 5), (1, 6, 4, 3)) * -1
    tmp11 = np.copy(np.transpose(tmp5, (1, 0))) * 2
    del tmp5
    tmp11 += np.transpose(tmp6, (1, 0))
    del tmp6
    tmp11 += np.transpose(tmp10, (1, 0))
    del tmp10
    tmp121 = einsum(v.aabb.ooov, (0, 1, 2, 3), t3.babbab, (4, 1, 2, 5, 6, 3), (0, 4, 6, 5))
    tmp163 = np.copy(tmp162) * -1
    del tmp162
    tmp163 += np.transpose(tmp84, (0, 1, 3, 2))
    del tmp84
    tmp89 = einsum(t1.aa, (0, 1), v.aaaa.ooov, (2, 0, 3, 4), (2, 3, 1, 4))
    tmp94 = np.copy(v.aaaa.oovv)
    tmp94 += einsum(t2.aaaa, (0, 1, 2, 3), tmp91, (1, 4, 5, 3), (0, 4, 2, 5)) * -2
    del tmp91
    tmp94 += tmp93 * -1
    del tmp93
    tmp67 = einsum(tmp66, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp66
    tmp65 = einsum(tmp64, (0, 1, 2, 3), t2.aaaa, (3, 2, 4, 5), (0, 1, 4, 5)) * -1
    del tmp64
    tmp34 = einsum(v.aabb.ooov, (0, 1, 2, 3), t3.abaaba, (4, 2, 1, 5, 3, 6), (4, 0, 5, 6))
    tmp36 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.oooo, (4, 1, 5, 0), (4, 5, 2, 3)) * -1
    tmp72 = einsum(t2.aaaa, (0, 1, 2, 3), tmp71, (4, 1), (0, 4, 2, 3)) * -1
    del tmp71
    tmp99 = np.copy(v.aaaa.oovv) * 0.5
    tmp99 += einsum(tmp7, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 1, 5, 2)) * -1
    del tmp7
    tmp99 += einsum(tmp98, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -0.5
    del tmp98
    tmp62 = np.copy(f.aa.vv) * -1
    tmp62 += np.transpose(tmp57, (1, 0)) * -1
    del tmp57
    tmp62 += tmp59 * -1
    del tmp59
    tmp62 += np.transpose(tmp60, (1, 0))
    del tmp60
    tmp68 = einsum(tmp1, (0, 1, 2, 3), t3.abaaba, (4, 2, 1, 5, 3, 6), (0, 4, 5, 6))
    tmp35 = np.copy(t2.aaaa)
    tmp35 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1)) * 2
    tmp50 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp105 = einsum(t2.aaaa, (0, 1, 2, 3), tmp104, (1, 4, 5, 3), (0, 4, 2, 5))
    del tmp104
    tmp53 = einsum(tmp52, (0, 1, 2, 3), t3.aaaaaa, (4, 5, 0, 6, 2, 1), (4, 5, 6, 3)) * -6
    del tmp52
    tmp63 = einsum(t3.aaaaaa, (0, 1, 2, 3, 4, 5), tmp2, (6, 1, 2, 5), (6, 0, 3, 4)) * -1
    tmp113 = einsum(tmp112, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp112
    tmp101 = np.copy(tmp95)
    tmp101 += einsum(t2.abab, (0, 1, 2, 3), tmp100, (1, 4, 3, 5), (0, 4, 2, 5)) * -1
    del tmp100
    tmp70 = einsum(tmp69, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    del tmp69
    tmp41 = einsum(t3.aaaaaa, (0, 1, 2, 3, 4, 5), tmp9, (2, 5), (0, 1, 3, 4)) * 3
    tmp109 = einsum(tmp108, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp108
    tmp107 = einsum(tmp106, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 5), (1, 0, 4, 5)) * -1
    del tmp106
    tmp90 = einsum(t2.aaaa, (0, 1, 2, 3), tmp49, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp80 = einsum(t2.abab, (0, 1, 2, 3), tmp79, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp79
    tmp97 = np.copy(tmp95)
    tmp97 += einsum(t2.abab, (0, 1, 2, 3), tmp96, (1, 4, 3, 5), (0, 4, 2, 5)) * -1
    del tmp96
    tmp44 = np.copy(tmp42) * 2
    del tmp42
    tmp44 += tmp43
    del tmp43
    tmp20 = np.copy(f.aa.oo)
    tmp20 += np.transpose(tmp17, (1, 0))
    del tmp17
    tmp20 += np.transpose(tmp19, (1, 0)) * -1
    del tmp19
    tmp86 = einsum(t2.aaaa, (0, 1, 2, 3), tmp85, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp85
    tmp115 = einsum(t2.aaaa, (0, 1, 2, 3), tmp114, (4, 5, 1, 0), (5, 4, 2, 3))
    del tmp114
    tmp111 = einsum(t1.aa, (0, 1), tmp110, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp110
    tmp33 = einsum(t3.aaaaaa, (0, 1, 2, 3, 4, 5), v.aaaa.ooov, (6, 2, 1, 5), (0, 6, 3, 4)) * -1
    tmp103 = einsum(tmp102, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp102
    tmp76 = einsum(t1.aa, (0, 1), tmp58, (2, 1, 3, 4), (0, 2, 4, 3)) * -1
    del tmp58
    tmp76 += einsum(tmp75, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3)) * -1
    del tmp75
    tmp118 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp88 = einsum(tmp87, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp40 = einsum(t2.aaaa, (0, 1, 2, 3), tmp39, (1, 4), (0, 4, 2, 3)) * -1
    tmp117 = np.copy(v.aaaa.vvvv)
    tmp117 += einsum(tmp116, (0, 1, 2, 3), t1.aa, (0, 4), (3, 4, 2, 1))
    del tmp116
    tmp56 = einsum(t3.abaaba, (0, 1, 2, 3, 4, 5), tmp55, (1, 5, 6, 4), (0, 2, 3, 6)) * -2
    tmp45 = einsum(t1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1)) * 2
    tmp45 += t2.aaaa * -1
    tmp28 = np.copy(f.bb.vv)
    tmp28 += einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (0, 1), (2, 3))
    tmp23 = np.copy(t2.bbbb) * 2
    tmp23 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    tmp12 = np.copy(f.aa.vv)
    tmp12 += einsum(t1.aa, (0, 1), v.aaaa.ovvv, (0, 2, 3, 1), (2, 3)) * -1
    tmp4 = np.copy(t2.aaaa) * 2
    tmp4 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    t3new.bbbbbb = np.copy(np.transpose(tmp508, (1, 0, 2, 5, 4, 3))) * -2
    t3new.bbbbbb += np.transpose(tmp509, (1, 2, 0, 4, 5, 3)) * -6
    t3new.bbbbbb += np.transpose(tmp512, (0, 1, 2, 5, 3, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp512, (0, 1, 2, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp508, (1, 2, 0, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp509, (1, 0, 2, 4, 5, 3)) * 6
    t3new.bbbbbb += np.transpose(tmp512, (0, 2, 1, 5, 3, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp512, (0, 2, 1, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp509, (0, 2, 1, 4, 5, 3)) * 6
    del tmp509
    t3new.bbbbbb += np.transpose(tmp512, (2, 1, 0, 5, 3, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp512, (2, 1, 0, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp516, (2, 1, 0, 4, 3, 5)) * 2
    del tmp516
    t3new.bbbbbb += np.transpose(tmp517, (1, 2, 0, 3, 4, 5)) * 2
    del tmp517
    t3new.bbbbbb += np.transpose(tmp518, (1, 2, 0, 4, 3, 5)) * -6
    del tmp518
    t3new.bbbbbb += np.transpose(tmp519, (0, 1, 2, 5, 4, 3)) * -6
    del tmp519
    t3new.bbbbbb += np.transpose(tmp520, (1, 2, 0, 4, 5, 3)) * -6
    t3new.bbbbbb += np.transpose(tmp523, (1, 2, 0, 5, 3, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp523, (1, 2, 0, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp526, (1, 2, 0, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp520, (1, 0, 2, 4, 5, 3)) * 6
    t3new.bbbbbb += np.transpose(tmp523, (1, 0, 2, 5, 3, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp523, (1, 0, 2, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp526, (1, 0, 2, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp520, (0, 2, 1, 4, 5, 3)) * 6
    del tmp520
    t3new.bbbbbb += np.transpose(tmp523, (0, 2, 1, 5, 3, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp523, (0, 2, 1, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp527, (0, 1, 2, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp529, (2, 0, 1, 3, 5, 4)) * -1
    t3new.bbbbbb += np.transpose(tmp530, (2, 0, 1, 3, 5, 4)) * -1
    t3new.bbbbbb += np.transpose(tmp530, (0, 2, 1, 3, 5, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp530, (2, 0, 1, 5, 3, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp530, (0, 2, 1, 5, 3, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp529, (0, 1, 2, 3, 5, 4)) * -1
    del tmp529
    t3new.bbbbbb += np.transpose(tmp530, (0, 1, 2, 3, 5, 4)) * -1
    t3new.bbbbbb += np.transpose(tmp530, (0, 1, 2, 5, 3, 4)) * 2
    del tmp530
    t3new.bbbbbb += np.transpose(tmp531, (2, 1, 0, 5, 4, 3)) * 4
    t3new.bbbbbb += np.transpose(tmp533, (2, 1, 0, 5, 3, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp512, (2, 1, 0, 3, 4, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp512, (2, 1, 0, 4, 3, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp533, (2, 1, 0, 3, 5, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp531, (0, 2, 1, 5, 4, 3)) * 4
    t3new.bbbbbb += np.transpose(tmp533, (0, 2, 1, 5, 3, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp512, (0, 2, 1, 3, 4, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp512, (0, 2, 1, 4, 3, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp533, (0, 2, 1, 3, 5, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp531, (0, 1, 2, 5, 4, 3)) * -4
    del tmp531
    t3new.bbbbbb += np.transpose(tmp533, (0, 1, 2, 5, 3, 4)) * -2
    t3new.bbbbbb += tmp512 * -2
    t3new.bbbbbb += np.transpose(tmp512, (0, 1, 2, 4, 3, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp533, (0, 1, 2, 3, 5, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp534, (0, 1, 2, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp534, (0, 2, 1, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp534, (1, 0, 2, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp534, (2, 0, 1, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp534, (0, 1, 2, 4, 5, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp534, (0, 2, 1, 4, 5, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp534, (1, 0, 2, 4, 5, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp534, (2, 0, 1, 4, 5, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp534, (1, 2, 0, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp534, (2, 1, 0, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp534, (1, 2, 0, 4, 5, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp534, (2, 1, 0, 4, 5, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp534, (0, 1, 2, 4, 3, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp534, (0, 2, 1, 4, 3, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp534, (1, 0, 2, 4, 3, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp534, (2, 0, 1, 4, 3, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp534, (1, 2, 0, 4, 3, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp534, (2, 1, 0, 4, 3, 5)) * -2
    del tmp534
    t3new.bbbbbb += np.transpose(tmp535, (0, 1, 2, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp537, (2, 1, 0, 3, 4, 5)) * -1
    t3new.bbbbbb += np.transpose(tmp535, (0, 2, 1, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp538, (2, 0, 1, 4, 3, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp535, (0, 1, 2, 5, 3, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp539, (2, 1, 0, 3, 5, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp535, (0, 2, 1, 5, 3, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp538, (2, 0, 1, 4, 5, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp535, (2, 1, 0, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp537, (0, 2, 1, 3, 4, 5)) * -1
    del tmp537
    t3new.bbbbbb += np.transpose(tmp535, (2, 1, 0, 5, 3, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp539, (0, 2, 1, 3, 5, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp535, (0, 1, 2, 3, 5, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp539, (2, 1, 0, 5, 3, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp535, (0, 2, 1, 3, 5, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp538, (2, 0, 1, 5, 4, 3)) * -2
    del tmp538
    t3new.bbbbbb += np.transpose(tmp535, (2, 1, 0, 3, 5, 4)) * -2
    del tmp535
    t3new.bbbbbb += np.transpose(tmp539, (0, 2, 1, 5, 3, 4)) * -2
    del tmp539
    t3new.bbbbbb += np.transpose(tmp508, (0, 1, 2, 3, 5, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp508, (1, 0, 2, 3, 5, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp508, (0, 1, 2, 5, 3, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp508, (1, 0, 2, 5, 3, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp508, (0, 2, 1, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp508, (0, 1, 2, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp508, (2, 0, 1, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp508, (1, 2, 0, 3, 5, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp508, (1, 2, 0, 5, 3, 4)) * -2
    del tmp508
    t3new.bbbbbb += np.transpose(tmp540, (1, 0, 2, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp541, (2, 0, 1, 3, 5, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp540, (0, 1, 2, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp541, (0, 2, 1, 3, 5, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp540, (1, 0, 2, 4, 5, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp541, (2, 0, 1, 5, 3, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp540, (0, 1, 2, 4, 5, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp541, (0, 2, 1, 5, 3, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp533, (0, 1, 2, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp512, (0, 1, 2, 3, 5, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp512, (0, 1, 2, 4, 5, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp533, (0, 2, 1, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp512, (0, 2, 1, 3, 5, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp512, (0, 2, 1, 4, 5, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp540, (1, 2, 0, 5, 4, 3)) * -2
    t3new.bbbbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp542, (4, 5, 1, 6), (0, 5, 4, 6, 2, 3)) * -1
    del tmp542
    t3new.bbbbbb += np.transpose(tmp546, (2, 1, 0, 3, 5, 4)) * -1
    t3new.bbbbbb += np.transpose(tmp540, (0, 2, 1, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp541, (0, 1, 2, 3, 5, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp540, (1, 2, 0, 4, 5, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp546, (2, 1, 0, 5, 3, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp540, (0, 2, 1, 4, 5, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp541, (0, 1, 2, 5, 3, 4)) * -2
    del tmp541
    t3new.bbbbbb += np.transpose(tmp540, (2, 1, 0, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp546, (1, 2, 0, 3, 5, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp540, (2, 0, 1, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp546, (1, 0, 2, 3, 5, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp540, (2, 1, 0, 4, 5, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp546, (1, 2, 0, 5, 3, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp540, (2, 0, 1, 4, 5, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp546, (1, 0, 2, 5, 3, 4)) * 2
    del tmp546
    t3new.bbbbbb += np.transpose(tmp533, (2, 1, 0, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp512, (2, 1, 0, 3, 5, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp512, (2, 1, 0, 4, 5, 3)) * 2
    del tmp512
    t3new.bbbbbb += np.transpose(tmp548, (0, 1, 2, 3, 5, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp548, (0, 2, 1, 3, 5, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp533, (0, 1, 2, 4, 5, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp533, (0, 2, 1, 4, 5, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp548, (2, 1, 0, 3, 5, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp533, (2, 1, 0, 4, 5, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp540, (1, 0, 2, 4, 3, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp549, (1, 0, 2, 4, 3, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp540, (0, 1, 2, 4, 3, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp549, (0, 1, 2, 4, 3, 5)) * 2
    t3new.bbbbbb += tmp548 * 2
    t3new.bbbbbb += tmp533 * -2
    t3new.bbbbbb += np.transpose(tmp548, (0, 2, 1, 3, 4, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp533, (0, 2, 1, 3, 4, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp548, (0, 1, 2, 4, 3, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp533, (0, 1, 2, 4, 3, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp548, (0, 2, 1, 4, 3, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp533, (0, 2, 1, 4, 3, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp540, (1, 2, 0, 4, 3, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp549, (1, 2, 0, 4, 3, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp540, (0, 2, 1, 4, 3, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp549, (0, 2, 1, 4, 3, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp540, (2, 1, 0, 4, 3, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp549, (2, 1, 0, 4, 3, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp540, (2, 0, 1, 4, 3, 5)) * -2
    del tmp540
    t3new.bbbbbb += np.transpose(tmp549, (2, 0, 1, 4, 3, 5)) * 2
    del tmp549
    t3new.bbbbbb += np.transpose(tmp548, (2, 1, 0, 3, 4, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp533, (2, 1, 0, 3, 4, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp548, (2, 1, 0, 4, 3, 5)) * 2
    del tmp548
    t3new.bbbbbb += np.transpose(tmp533, (2, 1, 0, 4, 3, 5)) * -2
    del tmp533
    t3new.bbbbbb += np.transpose(tmp523, (1, 2, 0, 3, 4, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp523, (1, 2, 0, 4, 3, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp550, (1, 2, 0, 4, 5, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp550, (1, 2, 0, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp552, (1, 2, 0, 4, 5, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp523, (1, 0, 2, 3, 4, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp523, (1, 0, 2, 4, 3, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp550, (1, 0, 2, 4, 5, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp550, (1, 0, 2, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp552, (1, 0, 2, 4, 5, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp523, (1, 2, 0, 3, 5, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp523, (1, 2, 0, 4, 5, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp550, (1, 2, 0, 4, 3, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp550, (1, 2, 0, 5, 3, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp552, (1, 2, 0, 4, 3, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp523, (1, 0, 2, 3, 5, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp523, (1, 0, 2, 4, 5, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp550, (1, 0, 2, 4, 3, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp550, (1, 0, 2, 5, 3, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp552, (1, 0, 2, 4, 3, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp523, (0, 2, 1, 3, 4, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp523, (0, 2, 1, 4, 3, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp550, (0, 2, 1, 4, 5, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp550, (0, 2, 1, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp552, (0, 2, 1, 4, 5, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp523, (0, 2, 1, 3, 5, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp523, (0, 2, 1, 4, 5, 3)) * 2
    del tmp523
    t3new.bbbbbb += np.transpose(tmp550, (0, 2, 1, 4, 3, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp550, (0, 2, 1, 5, 3, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp552, (0, 2, 1, 4, 3, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp550, (1, 2, 0, 3, 4, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp550, (1, 2, 0, 3, 5, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp552, (1, 2, 0, 3, 4, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp550, (1, 0, 2, 3, 4, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp550, (1, 0, 2, 3, 5, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp552, (1, 0, 2, 3, 4, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp550, (0, 2, 1, 3, 4, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp550, (0, 2, 1, 3, 5, 4)) * -2
    del tmp550
    t3new.bbbbbb += np.transpose(tmp552, (0, 2, 1, 3, 4, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp527, (2, 0, 1, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp527, (0, 2, 1, 5, 4, 3)) * 2
    del tmp527
    t3new.bbbbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp554, (4, 5, 1, 6), (0, 5, 4, 2, 3, 6))
    del tmp554
    t3new.bbbbbb += np.transpose(tmp526, (2, 1, 0, 5, 4, 3))
    del tmp526
    t3new.bbbbbb += np.transpose(tmp555, (2, 0, 1, 3, 5, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp555, (2, 1, 0, 3, 5, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp556, (2, 0, 1, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp556, (2, 1, 0, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp555, (0, 2, 1, 3, 5, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp555, (1, 2, 0, 3, 5, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp556, (0, 2, 1, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp556, (1, 2, 0, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp555, (2, 0, 1, 5, 3, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp555, (2, 1, 0, 5, 3, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp556, (2, 0, 1, 4, 5, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp556, (2, 1, 0, 4, 5, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp555, (0, 2, 1, 5, 3, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp555, (1, 2, 0, 5, 3, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp556, (0, 2, 1, 4, 5, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp556, (1, 2, 0, 4, 5, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp555, (0, 1, 2, 3, 5, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp555, (1, 0, 2, 3, 5, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp556, (0, 1, 2, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp556, (1, 0, 2, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp555, (0, 1, 2, 5, 3, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp555, (1, 0, 2, 5, 3, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp556, (0, 1, 2, 4, 5, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp556, (1, 0, 2, 4, 5, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp560, (1, 2, 0, 5, 4, 3))
    t3new.bbbbbb += np.transpose(tmp552, (1, 0, 2, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp560, (0, 2, 1, 5, 4, 3)) * -1
    del tmp560
    t3new.bbbbbb += np.transpose(tmp556, (2, 0, 1, 4, 3, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp556, (2, 1, 0, 4, 3, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp556, (0, 2, 1, 4, 3, 5)) * -2
    t3new.bbbbbb += np.transpose(tmp556, (1, 2, 0, 4, 3, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp552, (1, 2, 0, 5, 3, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp552, (1, 0, 2, 5, 3, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp552, (1, 2, 0, 3, 5, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp552, (1, 0, 2, 3, 5, 4)) * -2
    t3new.bbbbbb += np.transpose(tmp556, (0, 1, 2, 4, 3, 5)) * 2
    t3new.bbbbbb += np.transpose(tmp556, (1, 0, 2, 4, 3, 5)) * -2
    del tmp556
    t3new.bbbbbb += np.transpose(tmp552, (0, 2, 1, 5, 3, 4)) * 2
    t3new.bbbbbb += np.transpose(tmp552, (0, 2, 1, 3, 5, 4)) * -2
    del tmp552
    t3new.bbbbbb += np.transpose(tmp555, (2, 0, 1, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp555, (2, 1, 0, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp555, (0, 2, 1, 5, 4, 3)) * -2
    t3new.bbbbbb += np.transpose(tmp555, (1, 2, 0, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp555, (0, 1, 2, 5, 4, 3)) * 2
    t3new.bbbbbb += np.transpose(tmp555, (1, 0, 2, 5, 4, 3)) * -2
    del tmp555
    t3new.babbab = np.copy(np.transpose(tmp411, (2, 0, 1, 5, 3, 4))) * 2
    t3new.babbab += einsum(tmp414, (0, 1, 2, 3, 4, 5), t1.bb, (2, 6), (1, 0, 3, 5, 4, 6)) * -1
    del tmp414
    t3new.babbab += np.transpose(tmp415, (1, 0, 2, 5, 3, 4)) * 2
    del tmp415
    t3new.babbab += einsum(tmp417, (0, 1, 2, 3, 4, 5), t1.bb, (3, 6), (2, 0, 1, 5, 4, 6))
    del tmp417
    t3new.babbab += np.transpose(tmp411, (1, 0, 2, 5, 3, 4)) * -2
    del tmp411
    t3new.babbab += einsum(tmp418, (0, 1, 2, 3, 4, 5), t1.bb, (1, 6), (2, 0, 3, 5, 4, 6)) * -1
    del tmp418
    t3new.babbab += einsum(t3.babbab, (0, 1, 2, 3, 4, 5), tmp419, (5, 6), (0, 1, 2, 6, 4, 3)) * -1
    del tmp419
    t3new.babbab += einsum(tmp317, (0, 1), t3.babbab, (2, 3, 4, 5, 6, 0), (2, 3, 4, 1, 6, 5)) * -1
    del tmp317
    t3new.babbab += np.transpose(tmp420, (2, 0, 1, 5, 3, 4)) * 2
    del tmp420
    t3new.babbab += einsum(t3.babbab, (0, 1, 2, 3, 4, 5), f.bb.vv, (6, 5), (0, 1, 2, 3, 4, 6)) * 2
    t3new.babbab += np.transpose(tmp421, (2, 0, 1, 5, 3, 4)) * 2
    t3new.babbab += einsum(tmp425, (0, 1, 2, 3, 4, 5), t1.bb, (3, 6), (2, 0, 1, 5, 4, 6))
    del tmp425
    t3new.babbab += np.transpose(tmp426, (1, 0, 2, 5, 3, 4)) * 2
    del tmp426
    t3new.babbab += einsum(t1.bb, (0, 1), tmp428, (2, 3, 4, 0, 5, 6), (4, 2, 3, 6, 5, 1))
    del tmp428
    t3new.babbab += np.transpose(tmp421, (1, 0, 2, 5, 3, 4)) * -2
    del tmp421
    t3new.babbab += einsum(t1.bb, (0, 1), tmp429, (2, 3, 4, 0, 5, 6), (3, 2, 4, 6, 5, 1)) * -1
    del tmp429
    t3new.babbab += einsum(tmp430, (0, 1, 2, 3), t2.abab, (0, 4, 5, 6), (4, 1, 2, 3, 5, 6)) * -1
    del tmp430
    t3new.babbab += einsum(t2.abab, (0, 1, 2, 3), tmp432, (1, 4, 5, 6), (4, 0, 5, 6, 2, 3))
    del tmp432
    t3new.babbab += np.transpose(tmp433, (1, 0, 2, 5, 3, 4)) * 2
    del tmp433
    t3new.babbab += np.transpose(tmp434, (1, 0, 2, 4, 3, 5)) * -1
    t3new.babbab += np.transpose(tmp436, (1, 0, 2, 5, 3, 4)) * -2
    del tmp436
    t3new.babbab += np.transpose(tmp434, (2, 0, 1, 5, 3, 4)) * -1
    t3new.babbab += np.transpose(tmp438, (2, 0, 1, 4, 3, 5))
    t3new.babbab += einsum(t2.abab, (0, 1, 2, 3), tmp431, (1, 4, 5, 6), (5, 0, 4, 3, 2, 6)) * -2
    del tmp431
    t3new.babbab += einsum(t1.aa, (0, 1), tmp439, (0, 2, 3, 4, 5, 6), (3, 2, 4, 6, 1, 5)) * 2
    del tmp439
    t3new.babbab += np.transpose(tmp434, (1, 0, 2, 5, 3, 4))
    del tmp434
    t3new.babbab += np.transpose(tmp438, (1, 0, 2, 4, 3, 5)) * -1
    del tmp438
    t3new.babbab += np.transpose(tmp440, (1, 0, 2, 5, 3, 4))
    t3new.babbab += np.transpose(tmp441, (1, 0, 2, 5, 3, 4))
    t3new.babbab += np.transpose(tmp441, (2, 0, 1, 5, 3, 4)) * -1
    t3new.babbab += np.transpose(tmp442, (1, 0, 2, 5, 3, 4)) * 2
    t3new.babbab += np.transpose(tmp440, (2, 0, 1, 5, 3, 4)) * -1
    t3new.babbab += np.transpose(tmp442, (2, 0, 1, 5, 3, 4)) * -2
    del tmp442
    t3new.babbab += np.transpose(tmp440, (1, 0, 2, 4, 3, 5)) * -1
    t3new.babbab += np.transpose(tmp441, (1, 0, 2, 4, 3, 5)) * -1
    t3new.babbab += np.transpose(tmp441, (2, 0, 1, 4, 3, 5))
    del tmp441
    t3new.babbab += np.transpose(tmp440, (2, 0, 1, 4, 3, 5))
    del tmp440
    t3new.babbab += np.transpose(tmp443, (1, 0, 2, 5, 3, 4)) * -1
    t3new.babbab += einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.bbbb, (4, 5, 6, 3), (4, 0, 5, 2, 1, 6)) * -2
    t3new.babbab += np.transpose(tmp444, (1, 0, 2, 5, 3, 4))
    t3new.babbab += einsum(tmp445, (0, 1, 2, 3), t2.abab, (4, 5, 6, 3), (5, 4, 0, 2, 6, 1))
    del tmp445
    t3new.babbab += np.transpose(tmp443, (2, 0, 1, 5, 3, 4))
    del tmp443
    t3new.babbab += np.transpose(tmp444, (2, 0, 1, 5, 3, 4)) * -1
    del tmp444
    t3new.babbab += einsum(tmp446, (0, 1, 2, 3), t2.abab, (4, 5, 6, 2), (0, 4, 5, 1, 6, 3))
    del tmp446
    t3new.babbab += np.transpose(tmp447, (1, 0, 2, 4, 3, 5))
    t3new.babbab += einsum(tmp448, (0, 1, 2, 3), t2.bbbb, (4, 5, 6, 2), (4, 0, 5, 6, 1, 3)) * 2
    del tmp448
    t3new.babbab += np.transpose(tmp447, (2, 0, 1, 4, 3, 5)) * -1
    del tmp447
    t3new.babbab += np.transpose(tmp449, (1, 0, 2, 4, 3, 5))
    t3new.babbab += np.transpose(tmp450, (1, 0, 2, 5, 3, 4)) * -2
    del tmp450
    t3new.babbab += np.transpose(tmp451, (1, 0, 2, 5, 3, 4))
    t3new.babbab += np.transpose(tmp449, (2, 0, 1, 5, 3, 4))
    del tmp449
    t3new.babbab += np.transpose(tmp451, (2, 0, 1, 4, 3, 5))
    del tmp451
    t3new.babbab += np.transpose(tmp452, (1, 0, 2, 5, 3, 4))
    t3new.babbab += np.transpose(tmp453, (1, 0, 2, 5, 3, 4))
    t3new.babbab += np.transpose(tmp457, (1, 0, 2, 4, 3, 5)) * -1
    t3new.babbab += np.transpose(tmp458, (2, 0, 1, 5, 3, 4)) * -2
    t3new.babbab += np.transpose(tmp460, (1, 0, 2, 5, 3, 4)) * -1
    t3new.babbab += np.transpose(tmp463, (1, 0, 2, 4, 3, 5)) * -1
    t3new.babbab += np.transpose(tmp463, (1, 0, 2, 5, 3, 4))
    t3new.babbab += einsum(tmp464, (0, 1, 2, 3), t2.abab, (1, 4, 5, 6), (4, 0, 2, 3, 5, 6)) * -1
    del tmp464
    t3new.babbab += einsum(tmp355, (0, 1, 2, 3), t2.abab, (0, 4, 5, 6), (2, 1, 4, 3, 5, 6)) * -1
    del tmp355
    t3new.babbab += np.transpose(tmp465, (2, 0, 1, 5, 3, 4)) * 2
    t3new.babbab += np.transpose(tmp465, (1, 0, 2, 5, 3, 4)) * -2
    del tmp465
    t3new.babbab += np.transpose(tmp453, (2, 0, 1, 5, 3, 4)) * -1
    t3new.babbab += np.transpose(tmp457, (2, 0, 1, 4, 3, 5))
    del tmp457
    t3new.babbab += np.transpose(tmp452, (2, 0, 1, 5, 3, 4)) * -1
    t3new.babbab += np.transpose(tmp458, (1, 0, 2, 5, 3, 4)) * 2
    del tmp458
    t3new.babbab += np.transpose(tmp460, (2, 0, 1, 5, 3, 4))
    t3new.babbab += np.transpose(tmp463, (2, 0, 1, 4, 3, 5))
    t3new.babbab += np.transpose(tmp463, (2, 0, 1, 5, 3, 4)) * -1
    del tmp463
    t3new.babbab += np.transpose(tmp467, (1, 0, 2, 4, 3, 5))
    t3new.babbab += einsum(tmp468, (0, 1, 2, 3, 4, 5), t1.bb, (3, 6), (1, 0, 2, 6, 4, 5)) * 2
    del tmp468
    t3new.babbab += np.transpose(tmp467, (1, 0, 2, 5, 3, 4)) * -1
    t3new.babbab += np.transpose(tmp467, (2, 0, 1, 4, 3, 5)) * -1
    t3new.babbab += np.transpose(tmp467, (2, 0, 1, 5, 3, 4))
    del tmp467
    t3new.babbab += np.transpose(tmp452, (1, 0, 2, 4, 3, 5)) * -1
    t3new.babbab += np.transpose(tmp453, (1, 0, 2, 4, 3, 5)) * -1
    t3new.babbab += np.transpose(tmp469, (1, 0, 2, 4, 3, 5))
    t3new.babbab += np.transpose(tmp471, (1, 0, 2, 4, 3, 5)) * -1
    t3new.babbab += np.transpose(tmp460, (1, 0, 2, 4, 3, 5))
    t3new.babbab += np.transpose(tmp473, (1, 0, 2, 4, 3, 5)) * -1
    t3new.babbab += einsum(t1.aa, (0, 1), tmp474, (0, 2, 3, 4, 5, 6), (3, 2, 4, 5, 1, 6)) * -2
    del tmp474
    t3new.babbab += np.transpose(tmp475, (2, 0, 1, 4, 3, 5)) * -1
    t3new.babbab += np.transpose(tmp475, (1, 0, 2, 4, 3, 5))
    del tmp475
    t3new.babbab += np.transpose(tmp453, (2, 0, 1, 4, 3, 5))
    del tmp453
    t3new.babbab += np.transpose(tmp469, (2, 0, 1, 4, 3, 5)) * -1
    del tmp469
    t3new.babbab += np.transpose(tmp452, (2, 0, 1, 4, 3, 5))
    del tmp452
    t3new.babbab += np.transpose(tmp471, (2, 0, 1, 4, 3, 5))
    del tmp471
    t3new.babbab += np.transpose(tmp460, (2, 0, 1, 4, 3, 5)) * -1
    del tmp460
    t3new.babbab += np.transpose(tmp473, (2, 0, 1, 4, 3, 5))
    del tmp473
    t3new.babbab += einsum(t2.abab, (0, 1, 2, 3), tmp477, (4, 5, 2, 6), (1, 0, 4, 6, 5, 3)) * -1
    del tmp477
    t3new.babbab += einsum(t2.bbbb, (0, 1, 2, 3), tmp479, (4, 5, 3, 6), (0, 4, 1, 6, 5, 2)) * -2
    del tmp479
    t3new.babbab += np.transpose(tmp482, (2, 0, 1, 5, 3, 4)) * -1
    t3new.babbab += np.transpose(tmp482, (2, 0, 1, 4, 3, 5))
    t3new.babbab += np.transpose(tmp484, (2, 0, 1, 4, 3, 5)) * -1
    t3new.babbab += einsum(t2.abab, (0, 1, 2, 3), tmp485, (4, 2, 5, 6), (4, 0, 1, 6, 5, 3))
    del tmp485
    t3new.babbab += np.transpose(tmp482, (1, 0, 2, 5, 3, 4))
    t3new.babbab += np.transpose(tmp482, (1, 0, 2, 4, 3, 5)) * -1
    del tmp482
    t3new.babbab += np.transpose(tmp484, (1, 0, 2, 4, 3, 5))
    t3new.babbab += einsum(tmp487, (0, 1, 2, 3), t2.abab, (4, 5, 1, 6), (5, 4, 0, 6, 2, 3)) * -1
    del tmp487
    t3new.babbab += einsum(t2.bbbb, (0, 1, 2, 3), tmp488, (4, 5, 3, 6), (0, 4, 1, 2, 5, 6)) * 2
    del tmp488
    t3new.babbab += einsum(tmp489, (0, 1, 2, 3), t2.abab, (4, 5, 1, 6), (0, 4, 5, 6, 2, 3)) * -1
    del tmp489
    t3new.babbab += np.transpose(tmp490, (1, 0, 2, 4, 3, 5)) * -1
    t3new.babbab += np.transpose(tmp490, (1, 0, 2, 5, 3, 4))
    t3new.babbab += einsum(t2.abab, (0, 1, 2, 3), tmp492, (4, 5, 1, 6), (4, 0, 5, 3, 2, 6)) * -1
    del tmp492
    t3new.babbab += np.transpose(tmp493, (2, 0, 1, 5, 3, 4)) * -2
    t3new.babbab += np.transpose(tmp493, (1, 0, 2, 5, 3, 4)) * 2
    del tmp493
    t3new.babbab += einsum(tmp354, (0, 1, 2, 3), t2.abab, (0, 4, 5, 6), (4, 1, 2, 6, 5, 3))
    del tmp354
    t3new.babbab += np.transpose(tmp490, (2, 0, 1, 4, 3, 5))
    del tmp490
    t3new.babbab += einsum(tmp494, (0, 1, 2, 3), t2.abab, (1, 4, 5, 6), (4, 0, 2, 3, 5, 6)) * -1
    del tmp494
    t3new.babbab += np.transpose(tmp495, (1, 0, 2, 4, 3, 5))
    t3new.babbab += np.transpose(tmp495, (2, 0, 1, 4, 3, 5)) * -1
    t3new.babbab += np.transpose(tmp496, (1, 0, 2, 5, 3, 4))
    t3new.babbab += np.transpose(tmp496, (2, 0, 1, 5, 3, 4)) * -1
    t3new.babbab += np.transpose(tmp498, (2, 0, 1, 5, 3, 4)) * -2
    t3new.babbab += einsum(tmp499, (0, 1, 2, 3), t2.abab, (1, 4, 5, 6), (2, 0, 4, 3, 5, 6)) * -1
    del tmp499
    t3new.babbab += np.transpose(tmp498, (1, 0, 2, 5, 3, 4)) * 2
    del tmp498
    t3new.babbab += np.transpose(tmp501, (2, 0, 1, 4, 3, 5))
    t3new.babbab += einsum(tmp502, (0, 1, 2, 3, 4, 5), t1.bb, (3, 6), (1, 0, 2, 6, 4, 5)) * 2
    del tmp502
    t3new.babbab += np.transpose(tmp501, (1, 0, 2, 4, 3, 5)) * -1
    del tmp501
    t3new.babbab += np.transpose(tmp503, (2, 0, 1, 4, 3, 5)) * -1
    t3new.babbab += np.transpose(tmp496, (1, 0, 2, 4, 3, 5)) * -1
    t3new.babbab += np.transpose(tmp496, (2, 0, 1, 4, 3, 5))
    del tmp496
    t3new.babbab += np.transpose(tmp484, (2, 0, 1, 5, 3, 4))
    t3new.babbab += np.transpose(tmp505, (2, 0, 1, 4, 3, 5)) * -1
    t3new.babbab += einsum(tmp506, (0, 1, 2, 3, 4, 5), t1.aa, (1, 6), (2, 0, 3, 4, 6, 5)) * -2
    del tmp506
    t3new.babbab += np.transpose(tmp503, (1, 0, 2, 4, 3, 5))
    del tmp503
    t3new.babbab += np.transpose(tmp484, (1, 0, 2, 5, 3, 4)) * -1
    del tmp484
    t3new.babbab += np.transpose(tmp505, (1, 0, 2, 4, 3, 5))
    del tmp505
    t3new.babbab += np.transpose(tmp507, (2, 0, 1, 5, 3, 4))
    t3new.babbab += np.transpose(tmp495, (1, 0, 2, 5, 3, 4)) * -1
    t3new.babbab += np.transpose(tmp495, (2, 0, 1, 5, 3, 4))
    del tmp495
    t3new.babbab += np.transpose(tmp507, (1, 0, 2, 5, 3, 4)) * -1
    del tmp507
    t3new.abaaba = np.copy(np.transpose(tmp308, (1, 2, 0, 4, 5, 3))) * 2
    t3new.abaaba += einsum(t1.aa, (0, 1), tmp311, (2, 0, 3, 4, 5, 6), (2, 4, 3, 5, 6, 1)) * -1
    del tmp311
    t3new.abaaba += np.transpose(tmp312, (0, 2, 1, 4, 5, 3)) * 2
    del tmp312
    t3new.abaaba += einsum(tmp314, (0, 1, 2, 3, 4, 5), t1.aa, (2, 6), (1, 3, 0, 4, 5, 6))
    del tmp314
    t3new.abaaba += np.transpose(tmp308, (0, 2, 1, 4, 5, 3)) * -2
    del tmp308
    t3new.abaaba += einsum(t1.aa, (0, 1), tmp315, (0, 2, 3, 4, 5, 6), (2, 4, 3, 5, 6, 1)) * -1
    del tmp315
    t3new.abaaba += einsum(tmp254, (0, 1), t3.abaaba, (2, 3, 4, 5, 6, 0), (2, 3, 4, 1, 6, 5)) * -1
    del tmp254
    t3new.abaaba += einsum(tmp256, (0, 1), t3.abaaba, (2, 3, 4, 5, 6, 0), (2, 3, 4, 1, 6, 5)) * -1
    del tmp256
    t3new.abaaba += np.transpose(tmp318, (1, 2, 0, 4, 5, 3)) * 2
    del tmp318
    t3new.abaaba += einsum(f.aa.vv, (0, 1), t3.abaaba, (2, 3, 4, 5, 6, 1), (2, 3, 4, 5, 6, 0)) * 2
    t3new.abaaba += np.transpose(tmp319, (1, 2, 0, 4, 5, 3)) * 2
    t3new.abaaba += einsum(tmp322, (0, 1, 2, 3, 4, 5), t1.aa, (2, 6), (1, 3, 0, 4, 5, 6))
    del tmp322
    t3new.abaaba += np.transpose(tmp324, (0, 2, 1, 4, 5, 3)) * 2
    del tmp324
    t3new.abaaba += einsum(tmp326, (0, 1, 2, 3, 4, 5), t1.aa, (2, 6), (1, 3, 0, 4, 5, 6))
    del tmp326
    t3new.abaaba += np.transpose(tmp319, (0, 2, 1, 4, 5, 3)) * -2
    del tmp319
    t3new.abaaba += einsum(t1.aa, (0, 1), tmp327, (2, 3, 0, 4, 5, 6), (2, 4, 3, 5, 6, 1)) * -1
    del tmp327
    t3new.abaaba += einsum(tmp330, (0, 1, 2, 3), t2.abab, (4, 1, 5, 6), (4, 2, 0, 3, 6, 5)) * -1
    del tmp330
    t3new.abaaba += einsum(tmp273, (0, 1, 2, 3), t2.abab, (0, 4, 5, 6), (1, 4, 2, 3, 6, 5))
    del tmp273
    t3new.abaaba += np.transpose(tmp332, (0, 2, 1, 4, 5, 3)) * 2
    del tmp332
    t3new.abaaba += np.transpose(tmp333, (0, 2, 1, 3, 5, 4)) * -1
    t3new.abaaba += np.transpose(tmp336, (0, 2, 1, 4, 5, 3)) * -2
    del tmp336
    t3new.abaaba += np.transpose(tmp338, (1, 2, 0, 3, 5, 4))
    t3new.abaaba += np.transpose(tmp333, (1, 2, 0, 4, 5, 3)) * -1
    t3new.abaaba += einsum(t2.abab, (0, 1, 2, 3), tmp270, (0, 4, 5, 6), (5, 1, 4, 2, 3, 6)) * -2
    del tmp270
    t3new.abaaba += einsum(tmp340, (0, 1, 2, 3, 4, 5), t1.bb, (2, 6), (0, 3, 1, 5, 6, 4)) * 2
    del tmp340
    t3new.abaaba += np.transpose(tmp338, (0, 2, 1, 3, 5, 4)) * -1
    del tmp338
    t3new.abaaba += np.transpose(tmp333, (0, 2, 1, 4, 5, 3))
    del tmp333
    t3new.abaaba += np.transpose(tmp341, (0, 2, 1, 4, 5, 3))
    t3new.abaaba += np.transpose(tmp342, (0, 2, 1, 4, 5, 3))
    t3new.abaaba += np.transpose(tmp342, (1, 2, 0, 4, 5, 3)) * -1
    t3new.abaaba += np.transpose(tmp343, (0, 2, 1, 4, 5, 3)) * 2
    t3new.abaaba += np.transpose(tmp341, (1, 2, 0, 4, 5, 3)) * -1
    t3new.abaaba += np.transpose(tmp343, (1, 2, 0, 4, 5, 3)) * -2
    del tmp343
    t3new.abaaba += np.transpose(tmp341, (0, 2, 1, 3, 5, 4)) * -1
    t3new.abaaba += np.transpose(tmp342, (0, 2, 1, 3, 5, 4)) * -1
    t3new.abaaba += np.transpose(tmp342, (1, 2, 0, 3, 5, 4))
    del tmp342
    t3new.abaaba += np.transpose(tmp341, (1, 2, 0, 3, 5, 4))
    del tmp341
    t3new.abaaba += np.transpose(tmp344, (0, 2, 1, 4, 5, 3)) * -1
    t3new.abaaba += einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.vvov, (4, 3, 5, 6), (0, 5, 1, 4, 6, 2)) * -2
    t3new.abaaba += np.transpose(tmp345, (0, 2, 1, 4, 5, 3))
    t3new.abaaba += einsum(tmp282, (0, 1, 2, 3), t2.abab, (4, 5, 3, 6), (4, 5, 0, 2, 6, 1))
    del tmp282
    t3new.abaaba += np.transpose(tmp344, (1, 2, 0, 4, 5, 3))
    del tmp344
    t3new.abaaba += np.transpose(tmp345, (1, 2, 0, 4, 5, 3)) * -1
    del tmp345
    t3new.abaaba += einsum(tmp284, (0, 1, 2, 3), t2.abab, (4, 5, 2, 6), (0, 5, 4, 1, 6, 3))
    del tmp284
    t3new.abaaba += np.transpose(tmp346, (0, 2, 1, 3, 5, 4))
    t3new.abaaba += einsum(tmp347, (0, 1, 2, 3), t2.aaaa, (4, 5, 6, 1), (4, 0, 5, 6, 3, 2)) * 2
    del tmp347
    t3new.abaaba += np.transpose(tmp346, (1, 2, 0, 3, 5, 4)) * -1
    del tmp346
    t3new.abaaba += np.transpose(tmp348, (0, 2, 1, 3, 5, 4))
    t3new.abaaba += np.transpose(tmp349, (0, 2, 1, 4, 5, 3)) * -2
    del tmp349
    t3new.abaaba += np.transpose(tmp350, (0, 2, 1, 4, 5, 3))
    t3new.abaaba += np.transpose(tmp348, (1, 2, 0, 4, 5, 3))
    del tmp348
    t3new.abaaba += np.transpose(tmp350, (1, 2, 0, 3, 5, 4))
    del tmp350
    t3new.abaaba += np.transpose(tmp351, (0, 2, 1, 4, 5, 3))
    t3new.abaaba += np.transpose(tmp352, (0, 2, 1, 4, 5, 3))
    t3new.abaaba += np.transpose(tmp353, (0, 2, 1, 3, 5, 4)) * -1
    t3new.abaaba += np.transpose(tmp356, (1, 2, 0, 4, 5, 3)) * -2
    t3new.abaaba += np.transpose(tmp358, (0, 2, 1, 4, 5, 3)) * -1
    t3new.abaaba += np.transpose(tmp361, (0, 2, 1, 3, 5, 4)) * -1
    t3new.abaaba += np.transpose(tmp361, (0, 2, 1, 4, 5, 3))
    t3new.abaaba += einsum(t2.abab, (0, 1, 2, 3), tmp363, (4, 5, 1, 6), (0, 5, 4, 6, 3, 2)) * -1
    del tmp363
    t3new.abaaba += einsum(tmp364, (0, 1, 2, 3), t2.abab, (4, 1, 5, 6), (0, 2, 4, 3, 6, 5)) * -1
    del tmp364
    t3new.abaaba += np.transpose(tmp365, (1, 2, 0, 4, 5, 3)) * 2
    t3new.abaaba += np.transpose(tmp365, (0, 2, 1, 4, 5, 3)) * -2
    del tmp365
    t3new.abaaba += np.transpose(tmp352, (1, 2, 0, 4, 5, 3)) * -1
    t3new.abaaba += np.transpose(tmp353, (1, 2, 0, 3, 5, 4))
    del tmp353
    t3new.abaaba += np.transpose(tmp351, (1, 2, 0, 4, 5, 3)) * -1
    t3new.abaaba += np.transpose(tmp356, (0, 2, 1, 4, 5, 3)) * 2
    del tmp356
    t3new.abaaba += np.transpose(tmp358, (1, 2, 0, 4, 5, 3))
    t3new.abaaba += np.transpose(tmp361, (1, 2, 0, 3, 5, 4))
    t3new.abaaba += np.transpose(tmp361, (1, 2, 0, 4, 5, 3)) * -1
    del tmp361
    t3new.abaaba += np.transpose(tmp367, (0, 2, 1, 3, 5, 4))
    t3new.abaaba += einsum(tmp368, (0, 1, 2, 3, 4, 5), t1.aa, (2, 6), (0, 3, 1, 6, 5, 4)) * 2
    del tmp368
    t3new.abaaba += np.transpose(tmp367, (0, 2, 1, 4, 5, 3)) * -1
    t3new.abaaba += np.transpose(tmp367, (1, 2, 0, 3, 5, 4)) * -1
    t3new.abaaba += np.transpose(tmp367, (1, 2, 0, 4, 5, 3))
    del tmp367
    t3new.abaaba += np.transpose(tmp351, (0, 2, 1, 3, 5, 4)) * -1
    t3new.abaaba += np.transpose(tmp352, (0, 2, 1, 3, 5, 4)) * -1
    t3new.abaaba += np.transpose(tmp369, (0, 2, 1, 3, 5, 4))
    t3new.abaaba += np.transpose(tmp371, (0, 2, 1, 3, 5, 4)) * -1
    t3new.abaaba += np.transpose(tmp358, (0, 2, 1, 3, 5, 4))
    t3new.abaaba += np.transpose(tmp373, (0, 2, 1, 3, 5, 4)) * -1
    t3new.abaaba += einsum(tmp374, (0, 1, 2, 3, 4, 5), t1.bb, (2, 6), (0, 3, 1, 4, 6, 5)) * -2
    del tmp374
    t3new.abaaba += np.transpose(tmp375, (1, 2, 0, 3, 5, 4)) * -1
    t3new.abaaba += np.transpose(tmp375, (0, 2, 1, 3, 5, 4))
    del tmp375
    t3new.abaaba += np.transpose(tmp352, (1, 2, 0, 3, 5, 4))
    del tmp352
    t3new.abaaba += np.transpose(tmp369, (1, 2, 0, 3, 5, 4)) * -1
    del tmp369
    t3new.abaaba += np.transpose(tmp351, (1, 2, 0, 3, 5, 4))
    del tmp351
    t3new.abaaba += np.transpose(tmp371, (1, 2, 0, 3, 5, 4))
    del tmp371
    t3new.abaaba += np.transpose(tmp358, (1, 2, 0, 3, 5, 4)) * -1
    del tmp358
    t3new.abaaba += np.transpose(tmp373, (1, 2, 0, 3, 5, 4))
    del tmp373
    t3new.abaaba += einsum(tmp378, (0, 1, 2, 3), t2.abab, (4, 5, 6, 3), (4, 5, 0, 1, 2, 6)) * -1
    del tmp378
    t3new.abaaba += einsum(tmp380, (0, 1, 2, 3), t2.aaaa, (4, 5, 6, 1), (4, 0, 5, 2, 3, 6)) * -2
    del tmp380
    t3new.abaaba += np.transpose(tmp383, (1, 2, 0, 4, 5, 3)) * -1
    t3new.abaaba += np.transpose(tmp383, (1, 2, 0, 3, 5, 4))
    t3new.abaaba += np.transpose(tmp385, (1, 2, 0, 3, 5, 4)) * -1
    t3new.abaaba += einsum(tmp386, (0, 1, 2, 3), t2.abab, (4, 5, 6, 2), (0, 5, 4, 1, 3, 6))
    del tmp386
    t3new.abaaba += np.transpose(tmp383, (0, 2, 1, 4, 5, 3))
    t3new.abaaba += np.transpose(tmp383, (0, 2, 1, 3, 5, 4)) * -1
    del tmp383
    t3new.abaaba += np.transpose(tmp385, (0, 2, 1, 3, 5, 4))
    t3new.abaaba += einsum(t2.abab, (0, 1, 2, 3), tmp388, (4, 5, 3, 6), (0, 1, 4, 2, 6, 5)) * -1
    del tmp388
    t3new.abaaba += einsum(tmp389, (0, 1, 2, 3), t2.aaaa, (4, 5, 6, 1), (4, 0, 5, 6, 3, 2)) * 2
    del tmp389
    t3new.abaaba += einsum(tmp390, (0, 1, 2, 3), t2.abab, (4, 5, 6, 2), (0, 5, 4, 6, 3, 1)) * -1
    del tmp390
    t3new.abaaba += np.transpose(tmp392, (0, 2, 1, 3, 5, 4)) * -1
    t3new.abaaba += np.transpose(tmp392, (0, 2, 1, 4, 5, 3))
    t3new.abaaba += einsum(t2.abab, (0, 1, 2, 3), tmp268, (4, 5, 0, 6), (4, 1, 5, 2, 3, 6)) * -1
    del tmp268
    t3new.abaaba += np.transpose(tmp394, (1, 2, 0, 4, 5, 3)) * -2
    t3new.abaaba += np.transpose(tmp394, (0, 2, 1, 4, 5, 3)) * 2
    del tmp394
    t3new.abaaba += einsum(t2.abab, (0, 1, 2, 3), tmp362, (4, 1, 5, 6), (0, 5, 4, 2, 3, 6))
    del tmp362
    t3new.abaaba += np.transpose(tmp392, (1, 2, 0, 3, 5, 4))
    del tmp392
    t3new.abaaba += einsum(tmp396, (0, 1, 2, 3), t2.abab, (4, 2, 5, 6), (4, 1, 0, 3, 6, 5)) * -1
    del tmp396
    t3new.abaaba += np.transpose(tmp397, (0, 2, 1, 3, 5, 4))
    t3new.abaaba += np.transpose(tmp397, (1, 2, 0, 3, 5, 4)) * -1
    t3new.abaaba += np.transpose(tmp398, (0, 2, 1, 4, 5, 3))
    t3new.abaaba += np.transpose(tmp398, (1, 2, 0, 4, 5, 3)) * -1
    t3new.abaaba += np.transpose(tmp401, (1, 2, 0, 4, 5, 3)) * -2
    t3new.abaaba += einsum(t2.abab, (0, 1, 2, 3), tmp402, (4, 5, 1, 6), (4, 5, 0, 6, 3, 2)) * -1
    del tmp402
    t3new.abaaba += np.transpose(tmp401, (0, 2, 1, 4, 5, 3)) * 2
    del tmp401
    t3new.abaaba += np.transpose(tmp404, (1, 2, 0, 3, 5, 4))
    t3new.abaaba += einsum(t1.aa, (0, 1), tmp405, (2, 3, 0, 4, 5, 6), (2, 4, 3, 1, 6, 5)) * 2
    del tmp405
    t3new.abaaba += np.transpose(tmp404, (0, 2, 1, 3, 5, 4)) * -1
    del tmp404
    t3new.abaaba += np.transpose(tmp406, (1, 2, 0, 3, 5, 4)) * -1
    t3new.abaaba += np.transpose(tmp398, (0, 2, 1, 3, 5, 4)) * -1
    t3new.abaaba += np.transpose(tmp398, (1, 2, 0, 3, 5, 4))
    del tmp398
    t3new.abaaba += np.transpose(tmp385, (1, 2, 0, 4, 5, 3))
    t3new.abaaba += np.transpose(tmp408, (1, 2, 0, 3, 5, 4)) * -1
    t3new.abaaba += einsum(tmp409, (0, 1, 2, 3, 4, 5), t1.bb, (3, 6), (0, 2, 1, 4, 6, 5)) * -2
    del tmp409
    t3new.abaaba += np.transpose(tmp406, (0, 2, 1, 3, 5, 4))
    del tmp406
    t3new.abaaba += np.transpose(tmp385, (0, 2, 1, 4, 5, 3)) * -1
    del tmp385
    t3new.abaaba += np.transpose(tmp408, (0, 2, 1, 3, 5, 4))
    del tmp408
    t3new.abaaba += np.transpose(tmp410, (1, 2, 0, 4, 5, 3))
    t3new.abaaba += np.transpose(tmp397, (0, 2, 1, 4, 5, 3)) * -1
    t3new.abaaba += np.transpose(tmp397, (1, 2, 0, 4, 5, 3))
    del tmp397
    t3new.abaaba += np.transpose(tmp410, (0, 2, 1, 4, 5, 3)) * -1
    del tmp410
    t3new.aaaaaa = np.copy(np.transpose(tmp243, (1, 2, 0, 4, 5, 3))) * -6
    t3new.aaaaaa += np.transpose(tmp245, (1, 0, 2, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp248, (0, 1, 2, 5, 3, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp248, (0, 1, 2, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp243, (1, 0, 2, 4, 5, 3)) * 6
    t3new.aaaaaa += np.transpose(tmp245, (1, 2, 0, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp248, (0, 2, 1, 5, 3, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp248, (0, 2, 1, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp243, (0, 2, 1, 4, 5, 3)) * 6
    del tmp243
    t3new.aaaaaa += np.transpose(tmp248, (2, 1, 0, 5, 3, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp248, (2, 1, 0, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp252, (2, 1, 0, 4, 3, 5)) * 2
    del tmp252
    t3new.aaaaaa += np.transpose(tmp255, (1, 2, 0, 3, 4, 5)) * 2
    del tmp255
    t3new.aaaaaa += np.transpose(tmp257, (1, 2, 0, 4, 3, 5)) * -6
    del tmp257
    t3new.aaaaaa += np.transpose(tmp258, (0, 1, 2, 5, 4, 3)) * -6
    del tmp258
    t3new.aaaaaa += np.transpose(tmp260, (1, 2, 0, 4, 5, 3)) * -6
    t3new.aaaaaa += np.transpose(tmp263, (1, 2, 0, 5, 3, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp263, (1, 2, 0, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp266, (1, 2, 0, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp260, (1, 0, 2, 4, 5, 3)) * 6
    t3new.aaaaaa += np.transpose(tmp263, (1, 0, 2, 5, 3, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp263, (1, 0, 2, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp266, (1, 0, 2, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp260, (0, 2, 1, 4, 5, 3)) * 6
    del tmp260
    t3new.aaaaaa += np.transpose(tmp263, (0, 2, 1, 5, 3, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp263, (0, 2, 1, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp269, (0, 1, 2, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp272, (2, 0, 1, 3, 5, 4)) * -1
    t3new.aaaaaa += np.transpose(tmp274, (2, 0, 1, 3, 5, 4)) * -1
    t3new.aaaaaa += np.transpose(tmp274, (0, 2, 1, 3, 5, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp274, (2, 0, 1, 5, 3, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp274, (0, 2, 1, 5, 3, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp272, (0, 1, 2, 3, 5, 4)) * -1
    del tmp272
    t3new.aaaaaa += np.transpose(tmp274, (0, 1, 2, 3, 5, 4)) * -1
    t3new.aaaaaa += np.transpose(tmp274, (0, 1, 2, 5, 3, 4)) * 2
    del tmp274
    t3new.aaaaaa += np.transpose(tmp275, (2, 1, 0, 5, 4, 3)) * 4
    t3new.aaaaaa += np.transpose(tmp277, (2, 1, 0, 5, 3, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp248, (2, 1, 0, 3, 4, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp248, (2, 1, 0, 4, 3, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp277, (2, 1, 0, 3, 5, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp275, (0, 2, 1, 5, 4, 3)) * 4
    t3new.aaaaaa += np.transpose(tmp277, (0, 2, 1, 5, 3, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp248, (0, 2, 1, 3, 4, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp248, (0, 2, 1, 4, 3, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp277, (0, 2, 1, 3, 5, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp275, (0, 1, 2, 5, 4, 3)) * -4
    del tmp275
    t3new.aaaaaa += np.transpose(tmp277, (0, 1, 2, 5, 3, 4)) * -2
    t3new.aaaaaa += tmp248 * -2
    t3new.aaaaaa += np.transpose(tmp248, (0, 1, 2, 4, 3, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp277, (0, 1, 2, 3, 5, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp278, (0, 1, 2, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp278, (0, 2, 1, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp278, (1, 0, 2, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp278, (2, 0, 1, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp278, (0, 1, 2, 4, 5, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp278, (0, 2, 1, 4, 5, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp278, (1, 0, 2, 4, 5, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp278, (2, 0, 1, 4, 5, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp278, (1, 2, 0, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp278, (2, 1, 0, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp278, (1, 2, 0, 4, 5, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp278, (2, 1, 0, 4, 5, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp278, (0, 1, 2, 4, 3, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp278, (0, 2, 1, 4, 3, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp278, (1, 0, 2, 4, 3, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp278, (2, 0, 1, 4, 3, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp278, (1, 2, 0, 4, 3, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp278, (2, 1, 0, 4, 3, 5)) * -2
    del tmp278
    t3new.aaaaaa += np.transpose(tmp279, (0, 1, 2, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp281, (2, 1, 0, 3, 4, 5)) * -1
    t3new.aaaaaa += np.transpose(tmp279, (0, 2, 1, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp283, (2, 0, 1, 4, 3, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp279, (0, 1, 2, 5, 3, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp285, (2, 1, 0, 3, 5, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp279, (0, 2, 1, 5, 3, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp283, (2, 0, 1, 4, 5, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp279, (2, 1, 0, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp281, (0, 2, 1, 3, 4, 5)) * -1
    del tmp281
    t3new.aaaaaa += np.transpose(tmp279, (2, 1, 0, 5, 3, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp285, (0, 2, 1, 3, 5, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp279, (0, 1, 2, 3, 5, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp285, (2, 1, 0, 5, 3, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp279, (0, 2, 1, 3, 5, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp283, (2, 0, 1, 5, 4, 3)) * -2
    del tmp283
    t3new.aaaaaa += np.transpose(tmp279, (2, 1, 0, 3, 5, 4)) * -2
    del tmp279
    t3new.aaaaaa += np.transpose(tmp285, (0, 2, 1, 5, 3, 4)) * -2
    del tmp285
    t3new.aaaaaa += np.transpose(tmp245, (0, 1, 2, 3, 5, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp245, (1, 0, 2, 3, 5, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp245, (0, 1, 2, 5, 3, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp245, (1, 0, 2, 5, 3, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp245, (0, 2, 1, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp245, (0, 1, 2, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp245, (2, 0, 1, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp245, (1, 2, 0, 3, 5, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp245, (1, 2, 0, 5, 3, 4)) * -2
    del tmp245
    t3new.aaaaaa += np.transpose(tmp286, (1, 0, 2, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp289, (2, 0, 1, 3, 5, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp286, (0, 1, 2, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp289, (0, 2, 1, 3, 5, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp286, (1, 0, 2, 4, 5, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp289, (2, 0, 1, 5, 3, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp286, (0, 1, 2, 4, 5, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp289, (0, 2, 1, 5, 3, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp277, (0, 1, 2, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp248, (0, 1, 2, 3, 5, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp248, (0, 1, 2, 4, 5, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp277, (0, 2, 1, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp248, (0, 2, 1, 3, 5, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp248, (0, 2, 1, 4, 5, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp286, (1, 2, 0, 5, 4, 3)) * -2
    t3new.aaaaaa += einsum(tmp291, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 6), (4, 1, 0, 3, 5, 6)) * -1
    del tmp291
    t3new.aaaaaa += np.transpose(tmp294, (2, 1, 0, 3, 5, 4)) * -1
    t3new.aaaaaa += np.transpose(tmp286, (0, 2, 1, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp289, (0, 1, 2, 3, 5, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp286, (1, 2, 0, 4, 5, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp294, (2, 1, 0, 5, 3, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp286, (0, 2, 1, 4, 5, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp289, (0, 1, 2, 5, 3, 4)) * -2
    del tmp289
    t3new.aaaaaa += np.transpose(tmp286, (2, 1, 0, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp294, (1, 2, 0, 3, 5, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp286, (2, 0, 1, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp294, (1, 0, 2, 3, 5, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp286, (2, 1, 0, 4, 5, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp294, (1, 2, 0, 5, 3, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp286, (2, 0, 1, 4, 5, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp294, (1, 0, 2, 5, 3, 4)) * 2
    del tmp294
    t3new.aaaaaa += np.transpose(tmp277, (2, 1, 0, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp248, (2, 1, 0, 3, 5, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp248, (2, 1, 0, 4, 5, 3)) * 2
    del tmp248
    t3new.aaaaaa += np.transpose(tmp296, (0, 1, 2, 3, 5, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp296, (0, 2, 1, 3, 5, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp277, (0, 1, 2, 4, 5, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp277, (0, 2, 1, 4, 5, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp296, (2, 1, 0, 3, 5, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp277, (2, 1, 0, 4, 5, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp286, (1, 0, 2, 4, 3, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp297, (1, 0, 2, 4, 3, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp286, (0, 1, 2, 4, 3, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp297, (0, 1, 2, 4, 3, 5)) * 2
    t3new.aaaaaa += tmp296 * 2
    t3new.aaaaaa += tmp277 * -2
    t3new.aaaaaa += np.transpose(tmp296, (0, 2, 1, 3, 4, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp277, (0, 2, 1, 3, 4, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp296, (0, 1, 2, 4, 3, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp277, (0, 1, 2, 4, 3, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp296, (0, 2, 1, 4, 3, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp277, (0, 2, 1, 4, 3, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp286, (1, 2, 0, 4, 3, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp297, (1, 2, 0, 4, 3, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp286, (0, 2, 1, 4, 3, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp297, (0, 2, 1, 4, 3, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp286, (2, 1, 0, 4, 3, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp297, (2, 1, 0, 4, 3, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp286, (2, 0, 1, 4, 3, 5)) * -2
    del tmp286
    t3new.aaaaaa += np.transpose(tmp297, (2, 0, 1, 4, 3, 5)) * 2
    del tmp297
    t3new.aaaaaa += np.transpose(tmp296, (2, 1, 0, 3, 4, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp277, (2, 1, 0, 3, 4, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp296, (2, 1, 0, 4, 3, 5)) * 2
    del tmp296
    t3new.aaaaaa += np.transpose(tmp277, (2, 1, 0, 4, 3, 5)) * -2
    del tmp277
    t3new.aaaaaa += np.transpose(tmp263, (1, 2, 0, 3, 4, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp263, (1, 2, 0, 4, 3, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp298, (1, 2, 0, 4, 5, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp298, (1, 2, 0, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp300, (1, 2, 0, 4, 5, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp263, (1, 0, 2, 3, 4, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp263, (1, 0, 2, 4, 3, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp298, (1, 0, 2, 4, 5, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp298, (1, 0, 2, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp300, (1, 0, 2, 4, 5, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp263, (1, 2, 0, 3, 5, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp263, (1, 2, 0, 4, 5, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp298, (1, 2, 0, 4, 3, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp298, (1, 2, 0, 5, 3, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp300, (1, 2, 0, 4, 3, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp263, (1, 0, 2, 3, 5, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp263, (1, 0, 2, 4, 5, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp298, (1, 0, 2, 4, 3, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp298, (1, 0, 2, 5, 3, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp300, (1, 0, 2, 4, 3, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp263, (0, 2, 1, 3, 4, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp263, (0, 2, 1, 4, 3, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp298, (0, 2, 1, 4, 5, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp298, (0, 2, 1, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp300, (0, 2, 1, 4, 5, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp263, (0, 2, 1, 3, 5, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp263, (0, 2, 1, 4, 5, 3)) * 2
    del tmp263
    t3new.aaaaaa += np.transpose(tmp298, (0, 2, 1, 4, 3, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp298, (0, 2, 1, 5, 3, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp300, (0, 2, 1, 4, 3, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp298, (1, 2, 0, 3, 4, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp298, (1, 2, 0, 3, 5, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp300, (1, 2, 0, 3, 4, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp298, (1, 0, 2, 3, 4, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp298, (1, 0, 2, 3, 5, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp300, (1, 0, 2, 3, 4, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp298, (0, 2, 1, 3, 4, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp298, (0, 2, 1, 3, 5, 4)) * -2
    del tmp298
    t3new.aaaaaa += np.transpose(tmp300, (0, 2, 1, 3, 4, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp269, (2, 0, 1, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp269, (0, 2, 1, 5, 4, 3)) * 2
    del tmp269
    t3new.aaaaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp302, (4, 5, 1, 6), (0, 5, 4, 2, 3, 6))
    del tmp302
    t3new.aaaaaa += np.transpose(tmp266, (2, 1, 0, 5, 4, 3))
    del tmp266
    t3new.aaaaaa += np.transpose(tmp303, (2, 0, 1, 3, 5, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp303, (2, 1, 0, 3, 5, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp304, (2, 0, 1, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp304, (2, 1, 0, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp303, (0, 2, 1, 3, 5, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp303, (1, 2, 0, 3, 5, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp304, (0, 2, 1, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp304, (1, 2, 0, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp303, (2, 0, 1, 5, 3, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp303, (2, 1, 0, 5, 3, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp304, (2, 0, 1, 4, 5, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp304, (2, 1, 0, 4, 5, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp303, (0, 2, 1, 5, 3, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp303, (1, 2, 0, 5, 3, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp304, (0, 2, 1, 4, 5, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp304, (1, 2, 0, 4, 5, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp303, (0, 1, 2, 3, 5, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp303, (1, 0, 2, 3, 5, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp304, (0, 1, 2, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp304, (1, 0, 2, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp303, (0, 1, 2, 5, 3, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp303, (1, 0, 2, 5, 3, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp304, (0, 1, 2, 4, 5, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp304, (1, 0, 2, 4, 5, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp307, (1, 2, 0, 5, 4, 3))
    t3new.aaaaaa += np.transpose(tmp300, (1, 0, 2, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp307, (0, 2, 1, 5, 4, 3)) * -1
    del tmp307
    t3new.aaaaaa += np.transpose(tmp304, (2, 0, 1, 4, 3, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp304, (2, 1, 0, 4, 3, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp304, (0, 2, 1, 4, 3, 5)) * -2
    t3new.aaaaaa += np.transpose(tmp304, (1, 2, 0, 4, 3, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp300, (1, 2, 0, 5, 3, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp300, (1, 0, 2, 5, 3, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp300, (1, 2, 0, 3, 5, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp300, (1, 0, 2, 3, 5, 4)) * -2
    t3new.aaaaaa += np.transpose(tmp304, (0, 1, 2, 4, 3, 5)) * 2
    t3new.aaaaaa += np.transpose(tmp304, (1, 0, 2, 4, 3, 5)) * -2
    del tmp304
    t3new.aaaaaa += np.transpose(tmp300, (0, 2, 1, 5, 3, 4)) * 2
    t3new.aaaaaa += np.transpose(tmp300, (0, 2, 1, 3, 5, 4)) * -2
    del tmp300
    t3new.aaaaaa += np.transpose(tmp303, (2, 0, 1, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp303, (2, 1, 0, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp303, (0, 2, 1, 5, 4, 3)) * -2
    t3new.aaaaaa += np.transpose(tmp303, (1, 2, 0, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp303, (0, 1, 2, 5, 4, 3)) * 2
    t3new.aaaaaa += np.transpose(tmp303, (1, 0, 2, 5, 4, 3)) * -2
    del tmp303
    t2new.bbbb = np.copy(np.transpose(tmp175, (1, 0, 3, 2))) * 2
    del tmp175
    t2new.bbbb += tmp177
    t2new.bbbb += np.transpose(tmp178, (0, 1, 3, 2)) * 6
    t2new.bbbb += np.transpose(tmp179, (0, 1, 3, 2)) * 2
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp32, (1, 4), (0, 4, 2, 3)) * -1
    t2new.bbbb += np.transpose(tmp182, (0, 1, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp177, (0, 1, 3, 2)) * -1
    del tmp177
    t2new.bbbb += np.transpose(tmp178, (1, 0, 3, 2)) * -6
    del tmp178
    t2new.bbbb += np.transpose(tmp179, (1, 0, 3, 2)) * -2
    del tmp179
    t2new.bbbb += tmp183 * 2
    del tmp183
    t2new.bbbb += einsum(tmp9, (0, 1), t3.babbab, (2, 0, 3, 4, 1, 5), (2, 3, 4, 5))
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp124, (4, 3), (0, 1, 2, 4)) * -4
    t2new.bbbb += np.transpose(tmp182, (1, 0, 3, 2)) * 2
    del tmp182
    t2new.bbbb += einsum(tmp184, (0, 1), t3.babbab, (2, 0, 3, 4, 1, 5), (2, 3, 4, 5))
    del tmp184
    t2new.bbbb += np.transpose(tmp185, (1, 0, 3, 2)) * 2
    t2new.bbbb += np.transpose(tmp186, (1, 0, 3, 2))
    t2new.bbbb += tmp188 * -1
    t2new.bbbb += np.transpose(tmp189, (1, 0, 3, 2)) * -1
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp193, (3, 4), (0, 1, 4, 2)) * 2
    del tmp193
    t2new.bbbb += np.transpose(tmp185, (1, 0, 2, 3)) * -2
    t2new.bbbb += np.transpose(tmp186, (1, 0, 2, 3)) * -1
    t2new.bbbb += np.transpose(tmp188, (0, 1, 3, 2))
    del tmp188
    t2new.bbbb += np.transpose(tmp189, (1, 0, 2, 3))
    del tmp189
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp194, (3, 4), (0, 1, 2, 4)) * -2
    del tmp194
    t2new.bbbb += np.transpose(tmp195, (1, 0, 3, 2)) * 2
    t2new.bbbb += np.transpose(tmp196, (1, 0, 3, 2)) * 6
    t2new.bbbb += np.transpose(tmp198, (1, 0, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp200, (1, 0, 3, 2))
    t2new.bbbb += np.transpose(tmp202, (1, 0, 2, 3))
    t2new.bbbb += np.transpose(tmp202, (1, 0, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp204, (1, 0, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp200, (1, 0, 2, 3)) * -1
    t2new.bbbb += np.transpose(tmp195, (0, 1, 3, 2)) * -2
    del tmp195
    t2new.bbbb += np.transpose(tmp196, (0, 1, 3, 2)) * -6
    del tmp196
    t2new.bbbb += np.transpose(tmp198, (0, 1, 3, 2)) * 2
    del tmp198
    t2new.bbbb += np.transpose(tmp200, (0, 1, 3, 2)) * -1
    t2new.bbbb += tmp202 * -1
    t2new.bbbb += np.transpose(tmp202, (0, 1, 3, 2))
    del tmp202
    t2new.bbbb += np.transpose(tmp204, (0, 1, 3, 2)) * 2
    del tmp204
    t2new.bbbb += tmp200
    del tmp200
    t2new.bbbb += np.transpose(tmp205, (1, 0, 2, 3))
    t2new.bbbb += np.transpose(tmp206, (1, 0, 3, 2)) * -1
    t2new.bbbb += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp208, (4, 1, 5, 3), (0, 4, 5, 2)) * 2
    del tmp208
    t2new.bbbb += np.transpose(tmp210, (1, 0, 2, 3))
    t2new.bbbb += tmp205 * -1
    t2new.bbbb += np.transpose(tmp206, (0, 1, 3, 2))
    t2new.bbbb += np.transpose(v.bbbb.ovov, (0, 2, 3, 1)) * -1
    t2new.bbbb += tmp216 * -2
    t2new.bbbb += np.transpose(tmp217, (1, 0, 3, 2))
    t2new.bbbb += np.transpose(tmp218, (0, 1, 3, 2))
    t2new.bbbb += tmp219 * 2
    t2new.bbbb += np.transpose(tmp219, (1, 0, 3, 2)) * 2
    t2new.bbbb += einsum(tmp222, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5)) * -2
    del tmp222
    t2new.bbbb += einsum(tmp223, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5)) * -1
    del tmp223
    t2new.bbbb += np.transpose(tmp218, (1, 0, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp219, (0, 1, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp219, (1, 0, 2, 3)) * -2
    del tmp219
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp225, (4, 1, 5, 3), (0, 4, 5, 2)) * 2
    del tmp225
    t2new.bbbb += einsum(t2.abab, (0, 1, 2, 3), tmp226, (0, 4, 2, 5), (1, 4, 5, 3))
    del tmp226
    t2new.bbbb += tmp218 * -1
    t2new.bbbb += np.transpose(tmp228, (1, 0, 3, 2))
    t2new.bbbb += np.transpose(tmp230, (0, 1, 3, 2)) * 2
    t2new.bbbb += np.transpose(tmp218, (1, 0, 2, 3))
    del tmp218
    t2new.bbbb += np.transpose(tmp228, (0, 1, 3, 2)) * -1
    del tmp228
    t2new.bbbb += np.transpose(tmp230, (1, 0, 3, 2)) * -2
    del tmp230
    t2new.bbbb += np.transpose(tmp232, (0, 1, 3, 2)) * -2
    del tmp232
    t2new.bbbb += np.transpose(tmp205, (0, 1, 3, 2))
    t2new.bbbb += tmp234
    t2new.bbbb += np.transpose(tmp234, (0, 1, 3, 2)) * -1
    del tmp234
    t2new.bbbb += tmp236
    t2new.bbbb += np.transpose(tmp236, (0, 1, 3, 2)) * -1
    del tmp236
    t2new.bbbb += np.transpose(tmp238, (0, 1, 3, 2))
    t2new.bbbb += np.transpose(tmp238, (1, 0, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp240, (0, 1, 3, 2)) * -2
    del tmp240
    t2new.bbbb += np.transpose(tmp205, (1, 0, 3, 2)) * -1
    del tmp205
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp241, (2, 4, 5, 3), (0, 1, 5, 4)) * 2
    del tmp241
    t2new.bbbb += np.transpose(tmp186, (0, 1, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp185, (0, 1, 3, 2)) * -2
    t2new.bbbb += tmp186
    del tmp186
    t2new.bbbb += tmp185 * 2
    del tmp185
    t2new.bbbb += np.transpose(tmp206, (1, 0, 2, 3))
    t2new.bbbb += np.transpose(tmp216, (1, 0, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp210, (1, 0, 3, 2)) * -1
    del tmp210
    t2new.bbbb += tmp206 * -1
    del tmp206
    t2new.bbbb += np.transpose(tmp216, (0, 1, 3, 2)) * 2
    del tmp216
    t2new.bbbb += np.transpose(tmp217, (1, 0, 2, 3)) * -1
    del tmp217
    t2new.bbbb += einsum(t1.bb, (0, 1), tmp242, (2, 3, 0, 4), (2, 3, 1, 4)) * -2
    del tmp242
    t2new.bbbb += tmp238 * -1
    t2new.bbbb += np.transpose(tmp238, (1, 0, 2, 3))
    del tmp238
    t2new.abab = einsum(v.aabb.ovoo, (0, 1, 2, 3), t3.abaaba, (4, 3, 0, 5, 6, 1), (4, 2, 5, 6)) * -2
    t2new.abab += tmp119 * -2
    del tmp119
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp32, (1, 4), (0, 4, 2, 3)) * -1
    t2new.abab += einsum(v.aabb.oooo, (0, 1, 2, 3), tmp120, (1, 3, 4, 5), (0, 2, 4, 5)) * 0.5
    del tmp120
    t2new.abab += tmp121 * -2
    del tmp121
    t2new.abab += einsum(v.aaaa.ooov, (0, 1, 2, 3), t3.abaaba, (1, 4, 2, 5, 6, 3), (0, 4, 5, 6)) * -2
    t2new.abab += einsum(v.aabb.oooo, (0, 1, 2, 3), t2.abab, (1, 3, 4, 5), (0, 2, 4, 5)) * 0.5
    t2new.abab += einsum(t3.babbab, (0, 1, 2, 3, 4, 5), tmp16, (2, 5), (1, 0, 4, 3))
    t2new.abab += einsum(tmp9, (0, 1), t3.abaaba, (2, 3, 0, 4, 5, 1), (2, 3, 4, 5)) * 2
    t2new.abab += einsum(tmp124, (0, 1), t2.abab, (2, 3, 4, 1), (2, 3, 4, 0)) * -2
    del tmp124
    t2new.abab += einsum(tmp39, (0, 1), t2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -1
    del tmp39
    t2new.abab += tmp125 * 2
    del tmp125
    t2new.abab += einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 4, 1, 5))
    t2new.abab += einsum(t3.abaaba, (0, 1, 2, 3, 4, 5), tmp126, (2, 6, 5, 3), (0, 1, 6, 4)) * -2
    del tmp126
    t2new.abab += einsum(tmp55, (0, 1, 2, 3), t3.babbab, (4, 5, 0, 6, 1, 3), (5, 4, 2, 6)) * 2
    del tmp55
    t2new.abab += einsum(tmp61, (0, 1), t2.abab, (2, 3, 0, 4), (2, 3, 1, 4)) * -1
    t2new.abab += einsum(t3.babbab, (0, 1, 2, 3, 4, 5), tmp128, (2, 6, 3, 5), (1, 0, 4, 6)) * 2
    del tmp128
    t2new.abab += einsum(t3.abaaba, (0, 1, 2, 3, 4, 5), tmp130, (2, 5, 4, 6), (0, 1, 3, 6)) * 2
    del tmp130
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp133, (3, 4), (0, 1, 2, 4))
    del tmp133
    t2new.abab += einsum(tmp48, (0, 1), t3.babbab, (2, 3, 0, 4, 5, 1), (3, 2, 5, 4))
    t2new.abab += tmp134 * -2
    del tmp134
    t2new.abab += einsum(tmp22, (0, 1, 2, 3), t3.abaaba, (4, 2, 0, 5, 6, 3), (4, 1, 5, 6)) * -2
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp27, (1, 4), (0, 4, 2, 3)) * -1
    t2new.abab += einsum(tmp3, (0, 1, 2, 3), tmp135, (0, 4, 5, 1), (4, 5, 2, 3))
    del tmp135
    t2new.abab += einsum(tmp2, (0, 1, 2, 3), t3.abaaba, (2, 4, 1, 5, 6, 3), (0, 4, 5, 6)) * -2
    t2new.abab += einsum(t1.bb, (0, 1), tmp136, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    del tmp136
    t2new.abab += tmp137 * -2
    del tmp137
    t2new.abab += einsum(tmp11, (0, 1), t2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -1
    t2new.abab += einsum(tmp3, (0, 1, 2, 3), tmp138, (4, 0, 1, 5), (4, 5, 2, 3))
    del tmp138
    t2new.abab += tmp139 * -1
    del tmp139
    t2new.abab += tmp140
    del tmp140
    t2new.abab += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    t2new.abab += einsum(tmp143, (0, 1, 2, 3), t2.abab, (4, 1, 2, 5), (4, 0, 3, 5)) * -1
    del tmp143
    t2new.abab += tmp144 * -1
    del tmp144
    t2new.abab += einsum(tmp146, (0, 1, 2, 3), t2.abab, (4, 0, 2, 5), (4, 1, 3, 5))
    del tmp146
    t2new.abab += tmp95 * -1
    del tmp95
    t2new.abab += einsum(tmp148, (0, 1, 2, 3), t2.abab, (0, 4, 5, 2), (1, 4, 5, 3)) * -1
    del tmp148
    t2new.abab += einsum(t1.bb, (0, 1), tmp149, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    del tmp149
    t2new.abab += einsum(tmp151, (0, 1, 2, 3), t1.aa, (4, 1), (4, 0, 2, 3))
    del tmp151
    t2new.abab += einsum(tmp3, (0, 1, 2, 3), tmp152, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp152
    t2new.abab += einsum(tmp153, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5)) * -1
    del tmp153
    t2new.abab += einsum(tmp155, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5)) * 2
    del tmp155
    t2new.abab += tmp154 * 2
    del tmp154
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    t2new.abab += einsum(t1.bb, (0, 1), tmp156, (2, 3, 0, 4), (2, 3, 4, 1)) * -2
    del tmp156
    t2new.abab += einsum(tmp158, (0, 1, 2, 3), t2.abab, (4, 0, 5, 2), (4, 1, 5, 3)) * -1
    del tmp158
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp159, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp159
    t2new.abab += einsum(tmp161, (0, 1, 2, 3), t2.abab, (4, 5, 0, 2), (4, 5, 1, 3))
    del tmp161
    t2new.abab += einsum(tmp163, (0, 1, 2, 3), t2.abab, (1, 4, 2, 5), (0, 4, 3, 5))
    del tmp163
    t2new.abab += einsum(tmp87, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5)) * 2
    del tmp87
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp167, (4, 1, 3, 5), (0, 4, 2, 5))
    del tmp167
    t2new.abab += einsum(t2.aaaa, (0, 1, 2, 3), tmp168, (1, 4, 3, 5), (0, 4, 2, 5)) * 2
    del tmp168
    t2new.abab += tmp78 * -1
    del tmp78
    t2new.abab += einsum(tmp171, (0, 1, 2, 3), t2.abab, (1, 4, 5, 2), (0, 4, 5, 3)) * -1
    del tmp171
    t2new.abab += einsum(tmp172, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3)) * -1
    del tmp172
    t2new.abab += einsum(tmp173, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3)) * -1
    del tmp173
    t2new.abab += einsum(t1.aa, (0, 1), tmp174, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp174
    t2new.aaaa = np.copy(np.transpose(tmp33, (0, 1, 3, 2))) * 6
    t2new.aaaa += np.transpose(tmp34, (0, 1, 3, 2)) * 2
    t2new.aaaa += einsum(tmp20, (0, 1), t2.aaaa, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    t2new.aaaa += einsum(tmp35, (0, 1, 2, 3), v.aaaa.oooo, (4, 1, 5, 0), (4, 5, 3, 2)) * 0.5
    del tmp35
    t2new.aaaa += np.transpose(tmp36, (1, 0, 3, 2))
    del tmp36
    t2new.aaaa += np.transpose(tmp40, (0, 1, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp33, (1, 0, 3, 2)) * -6
    del tmp33
    t2new.aaaa += np.transpose(tmp34, (1, 0, 3, 2)) * -2
    del tmp34
    t2new.aaaa += einsum(tmp16, (0, 1), t3.abaaba, (2, 0, 3, 4, 1, 5), (2, 3, 4, 5))
    t2new.aaaa += tmp41 * 2
    del tmp41
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp44, (4, 3), (0, 1, 2, 4)) * -2
    del tmp44
    t2new.aaaa += np.transpose(tmp40, (1, 0, 3, 2)) * 2
    del tmp40
    t2new.aaaa += einsum(v.aaaa.oooo, (0, 1, 2, 3), tmp45, (3, 1, 4, 5), (0, 2, 5, 4)) * -0.5
    del tmp45
    t2new.aaaa += einsum(tmp48, (0, 1), t3.abaaba, (2, 0, 3, 4, 1, 5), (2, 3, 4, 5))
    del tmp48
    t2new.aaaa += np.transpose(tmp49, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp50, (1, 0, 3, 2)) * 2
    t2new.aaaa += np.transpose(tmp53, (0, 1, 3, 2))
    t2new.aaaa += np.transpose(tmp56, (1, 0, 3, 2)) * -1
    t2new.aaaa += einsum(tmp61, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 1, 4)) * 2
    del tmp61
    t2new.aaaa += np.transpose(tmp49, (1, 0, 2, 3)) * -1
    t2new.aaaa += np.transpose(tmp50, (1, 0, 2, 3)) * -2
    t2new.aaaa += tmp53 * -1
    del tmp53
    t2new.aaaa += np.transpose(tmp56, (1, 0, 2, 3))
    del tmp56
    t2new.aaaa += einsum(tmp62, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    del tmp62
    t2new.aaaa += np.transpose(tmp63, (1, 0, 3, 2)) * 6
    t2new.aaaa += np.transpose(tmp65, (1, 0, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp67, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp68, (1, 0, 3, 2)) * 2
    t2new.aaaa += np.transpose(tmp70, (1, 0, 2, 3))
    t2new.aaaa += np.transpose(tmp70, (1, 0, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp72, (0, 1, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp67, (1, 0, 2, 3)) * -1
    t2new.aaaa += np.transpose(tmp63, (0, 1, 3, 2)) * -6
    del tmp63
    t2new.aaaa += np.transpose(tmp65, (0, 1, 3, 2)) * 2
    del tmp65
    t2new.aaaa += np.transpose(tmp67, (0, 1, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp68, (0, 1, 3, 2)) * -2
    del tmp68
    t2new.aaaa += tmp70 * -1
    t2new.aaaa += np.transpose(tmp70, (0, 1, 3, 2))
    del tmp70
    t2new.aaaa += np.transpose(tmp72, (1, 0, 3, 2)) * 2
    del tmp72
    t2new.aaaa += tmp67
    del tmp67
    t2new.aaaa += np.transpose(tmp73, (1, 0, 3, 2)) * -1
    t2new.aaaa += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    t2new.aaaa += np.transpose(tmp74, (1, 0, 2, 3))
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp76, (4, 1, 5, 3), (0, 4, 5, 2)) * 2
    del tmp76
    t2new.aaaa += np.transpose(tmp80, (0, 1, 3, 2))
    t2new.aaaa += np.transpose(tmp73, (0, 1, 3, 2))
    t2new.aaaa += np.transpose(v.aaaa.ovov, (0, 2, 3, 1)) * -1
    t2new.aaaa += tmp74 * -1
    t2new.aaaa += np.transpose(tmp86, (1, 0, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp88, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp89, (0, 1, 3, 2))
    t2new.aaaa += tmp90 * 2
    t2new.aaaa += np.transpose(tmp90, (1, 0, 3, 2)) * 2
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp94, (4, 1, 5, 3), (4, 0, 5, 2)) * -2
    del tmp94
    t2new.aaaa += einsum(t2.abab, (0, 1, 2, 3), tmp97, (4, 1, 5, 3), (4, 0, 5, 2)) * -1
    del tmp97
    t2new.aaaa += np.transpose(tmp89, (1, 0, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp90, (0, 1, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp90, (1, 0, 2, 3)) * -2
    del tmp90
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp99, (4, 1, 5, 3), (0, 4, 5, 2)) * 4
    del tmp99
    t2new.aaaa += einsum(tmp101, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 2, 5))
    del tmp101
    t2new.aaaa += tmp89 * -1
    t2new.aaaa += np.transpose(tmp103, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp105, (1, 0, 2, 3)) * 2
    t2new.aaaa += np.transpose(tmp89, (1, 0, 2, 3))
    del tmp89
    t2new.aaaa += np.transpose(tmp103, (0, 1, 3, 2)) * -1
    del tmp103
    t2new.aaaa += tmp105 * -2
    del tmp105
    t2new.aaaa += np.transpose(tmp107, (0, 1, 3, 2)) * -2
    del tmp107
    t2new.aaaa += np.transpose(tmp74, (0, 1, 3, 2))
    t2new.aaaa += tmp109
    t2new.aaaa += np.transpose(tmp109, (0, 1, 3, 2)) * -1
    del tmp109
    t2new.aaaa += tmp111
    t2new.aaaa += np.transpose(tmp111, (0, 1, 3, 2)) * -1
    del tmp111
    t2new.aaaa += np.transpose(tmp113, (0, 1, 3, 2))
    t2new.aaaa += np.transpose(tmp113, (1, 0, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp115, (0, 1, 3, 2)) * -2
    del tmp115
    t2new.aaaa += np.transpose(tmp74, (1, 0, 3, 2)) * -1
    del tmp74
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp117, (2, 4, 5, 3), (0, 1, 5, 4)) * -2
    del tmp117
    t2new.aaaa += np.transpose(tmp49, (0, 1, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp50, (0, 1, 3, 2)) * -2
    t2new.aaaa += tmp49
    del tmp49
    t2new.aaaa += tmp50 * 2
    del tmp50
    t2new.aaaa += np.transpose(tmp73, (1, 0, 2, 3))
    t2new.aaaa += tmp86 * -2
    t2new.aaaa += tmp80 * -1
    del tmp80
    t2new.aaaa += tmp73 * -1
    del tmp73
    t2new.aaaa += np.transpose(tmp86, (1, 0, 2, 3)) * 2
    del tmp86
    t2new.aaaa += np.transpose(tmp88, (1, 0, 2, 3)) * -1
    del tmp88
    t2new.aaaa += einsum(tmp118, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3)) * -2
    del tmp118
    t2new.aaaa += tmp113 * -1
    t2new.aaaa += np.transpose(tmp113, (1, 0, 2, 3))
    del tmp113
    t1new.bb = einsum(t1.bb, (0, 1), v.bbbb.ovov, (2, 3, 0, 1), (2, 3))
    t1new.bb += einsum(tmp21, (0, 1, 2, 3), t2.bbbb, (1, 2, 4, 3), (0, 4)) * 2
    del tmp21
    t1new.bb += f.bb.ov
    t1new.bb += tmp13
    del tmp13
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), tmp22, (0, 4, 1, 2), (4, 3)) * -1
    del tmp22
    t1new.bb += einsum(v.bbbb.ovvv, (0, 1, 2, 3), tmp23, (0, 4, 3, 1), (4, 2)) * -1
    del tmp23
    t1new.bb += einsum(v.aabb.ovvv, (0, 1, 2, 3), tmp3, (0, 4, 1, 3), (4, 2))
    t1new.bb += einsum(t1.bb, (0, 1), tmp27, (0, 2), (2, 1)) * -1
    del tmp27
    t1new.bb += einsum(tmp28, (0, 1), t1.bb, (2, 0), (2, 1))
    del tmp28
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovoo, (0, 2, 4, 1), (4, 3)) * -1
    t1new.bb += einsum(t1.bb, (0, 1), v.bbbb.oovv, (2, 0, 3, 1), (2, 3)) * -1
    t1new.bb += einsum(t3.bbbbbb, (0, 1, 2, 3, 4, 5), v.bbbb.ovov, (1, 5, 2, 4), (0, 3)) * -3
    t1new.bb += einsum(v.aaaa.ovov, (0, 1, 2, 3), t3.abaaba, (0, 4, 2, 3, 5, 1), (4, 5)) * -1
    t1new.bb += einsum(v.bbbb.ooov, (0, 1, 2, 3), t2.bbbb, (2, 1, 4, 3), (0, 4)) * 2
    t1new.bb += einsum(t3.babbab, (0, 1, 2, 3, 4, 5), v.aabb.ovov, (1, 4, 2, 5), (0, 3)) * 2
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), tmp9, (0, 2), (1, 3))
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), tmp16, (1, 3), (0, 2)) * 2
    t1new.bb += einsum(t1.bb, (0, 1), tmp32, (0, 2), (2, 1)) * -1
    del tmp32
    t1new.aa = np.copy(tmp0)
    del tmp0
    t1new.aa += einsum(tmp1, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4)) * -1
    del tmp1
    t1new.aa += einsum(tmp2, (0, 1, 2, 3), t2.aaaa, (2, 1, 4, 3), (0, 4)) * -2
    del tmp2
    t1new.aa += f.aa.ov
    t1new.aa += einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    t1new.aa += einsum(tmp3, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 1, 3), (0, 4))
    del tmp3
    t1new.aa += einsum(tmp4, (0, 1, 2, 3), v.aaaa.ovvv, (0, 2, 4, 3), (1, 4))
    del tmp4
    t1new.aa += einsum(tmp11, (0, 1), t1.aa, (0, 2), (1, 2)) * -1
    del tmp11
    t1new.aa += einsum(tmp12, (0, 1), t1.aa, (2, 0), (2, 1))
    del tmp12
    t1new.aa += einsum(t3.abaaba, (0, 1, 2, 3, 4, 5), v.aabb.ovov, (2, 5, 1, 4), (0, 3)) * 2
    t1new.aa += einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4)) * -1
    t1new.aa += einsum(t3.aaaaaa, (0, 1, 2, 3, 4, 5), v.aaaa.ovov, (1, 5, 2, 4), (0, 3)) * -3
    t1new.aa += einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 3), (0, 4)) * -2
    t1new.aa += einsum(t3.babbab, (0, 1, 2, 3, 4, 5), v.bbbb.ovov, (0, 3, 2, 5), (1, 4))
    t1new.aa += einsum(v.aaaa.oovv, (0, 1, 2, 3), t1.aa, (1, 3), (0, 2)) * -1
    t1new.aa += einsum(t2.abab, (0, 1, 2, 3), tmp16, (1, 3), (0, 2))
    del tmp16
    t1new.aa += einsum(tmp9, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3)) * 2
    del tmp9
    t1new.aa += einsum(tmp20, (0, 1), t1.aa, (0, 2), (1, 2)) * -1
    del tmp20

    return {f"t1new": t1new, f"t2new": t2new, f"t3new": t3new}

