"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T15:18:30.727919
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:18:31.257437.

    Parameters
    ----------
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    e_cc = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (0, 2, 3, 1), ()) * -1
    e_cc += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 1, 3), ())
    e_cc += einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 3, 1), ()) * -1

    return e_cc

def update_amps(f=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:18:44.278899.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    t2new : Namespace of arrays
        Updated T2 residuals.
    """

    t2new = Namespace()
    tmp13 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1)))
    tmp13 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3)) * -1
    tmp9 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1)))
    tmp9 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3)) * -1
    tmp35 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 1, 3), (4, 0))
    tmp34 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 3), (1, 4))
    tmp44 = einsum(t2.bbbb, (0, 1, 2, 3), tmp13, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp10 = einsum(t2.aaaa, (0, 1, 2, 3), tmp9, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp19 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp20 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp36 = np.copy(tmp34)
    del tmp34
    tmp36 += tmp35 * 2
    del tmp35
    tmp50 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    tmp24 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 1, 4), (4, 3))
    tmp25 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 4, 1, 3), (2, 4))
    tmp45 = np.copy(v.bbbb.oovv)
    tmp45 += tmp44 * -2
    del tmp44
    tmp27 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp47 = einsum(t2.abab, (0, 1, 2, 3), tmp9, (0, 4, 5, 2), (4, 1, 5, 3))
    tmp2 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 4, 1), (4, 3)) * -1
    tmp3 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 1, 3), (2, 4))
    tmp31 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 2, 5, 3))
    tmp14 = einsum(tmp13, (0, 1, 2, 3), t2.abab, (4, 0, 5, 2), (4, 1, 5, 3))
    del tmp13
    tmp6 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp17 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 5, 3, 1), (4, 5, 0, 2)) * -1
    tmp11 = np.copy(v.aaaa.oovv)
    tmp11 += tmp10 * -2
    del tmp10
    tmp21 = np.copy(tmp19) * 2
    tmp21 += tmp20
    tmp40 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 5), (1, 4, 3, 5))
    tmp41 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp52 = einsum(tmp36, (0, 1), t2.bbbb, (2, 1, 3, 4), (2, 0, 3, 4)) * -1
    tmp51 = einsum(tmp50, (0, 1, 2, 3), t2.bbbb, (3, 2, 4, 5), (1, 0, 4, 5))
    del tmp50
    tmp49 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.oovv, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp26 = np.copy(tmp24) * 0.5
    tmp26 += tmp25
    tmp46 = einsum(t2.bbbb, (0, 1, 2, 3), tmp45, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp45
    tmp38 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.oo, (4, 1), (4, 0, 2, 3))
    tmp43 = einsum(t2.abab, (0, 1, 2, 3), tmp27, (0, 4, 2, 5), (1, 4, 3, 5))
    tmp42 = np.copy(f.bb.vv) * -1
    tmp42 += tmp24
    del tmp24
    tmp42 += tmp25 * 2
    del tmp25
    tmp39 = einsum(v.bbbb.oooo, (0, 1, 2, 3), t2.bbbb, (3, 1, 4, 5), (0, 2, 4, 5)) * -1
    tmp48 = einsum(tmp47, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5))
    del tmp47
    tmp28 = np.copy(f.aa.vv) * -1
    tmp28 += np.transpose(tmp2, (1, 0)) * 2
    tmp28 += np.transpose(tmp3, (1, 0))
    tmp33 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp29 = np.copy(np.transpose(v.aabb.vvoo, (2, 3, 0, 1)))
    tmp29 += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 5, 3), (5, 1, 4, 2)) * -1
    tmp32 = np.copy(tmp31) * 2
    tmp32 += tmp14 * -1
    tmp30 = np.copy(v.aaaa.oovv)
    tmp30 += np.transpose(tmp6, (1, 0, 3, 2)) * -1
    tmp30 += einsum(tmp9, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (1, 4, 3, 5)) * 2
    del tmp9
    tmp23 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.oooo, (4, 0, 5, 1), (4, 5, 2, 3))
    tmp37 = np.copy(tmp19)
    del tmp19
    tmp37 += tmp20 * 0.5
    del tmp20
    tmp5 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp18 = einsum(t2.aaaa, (0, 1, 2, 3), tmp17, (4, 5, 1, 0), (5, 4, 2, 3))
    del tmp17
    tmp15 = einsum(tmp14, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 5, 2)) * -1
    del tmp14
    tmp4 = np.copy(tmp2)
    tmp4 += tmp3 * 0.5
    tmp12 = einsum(tmp11, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp11
    tmp1 = einsum(v.aaaa.oooo, (0, 1, 2, 3), t2.aaaa, (1, 3, 4, 5), (0, 2, 4, 5))
    tmp16 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.oovv, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp0 = einsum(f.aa.oo, (0, 1), t2.aaaa, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp7 = np.copy(f.aa.vv) * -1
    tmp7 += tmp2 * 2
    del tmp2
    tmp7 += tmp3
    del tmp3
    tmp8 = einsum(t2.aaaa, (0, 1, 2, 3), tmp6, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp22 = einsum(tmp21, (0, 1), t2.aaaa, (2, 1, 3, 4), (0, 2, 3, 4)) * -1
    del tmp21
    t2new.bbbb = np.copy(np.transpose(tmp38, (1, 0, 3, 2))) * 2
    t2new.bbbb += np.transpose(tmp39, (1, 0, 3, 2)) * 2
    del tmp39
    t2new.bbbb += np.transpose(tmp38, (0, 1, 3, 2)) * -2
    del tmp38
    t2new.bbbb += einsum(tmp26, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 4, 0)) * -4
    t2new.bbbb += np.transpose(tmp40, (1, 0, 3, 2))
    t2new.bbbb += np.transpose(tmp41, (1, 0, 3, 2)) * 2
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp42, (4, 3), (0, 1, 4, 2)) * 2
    del tmp42
    t2new.bbbb += np.transpose(tmp40, (1, 0, 2, 3)) * -1
    t2new.bbbb += einsum(f.bb.vv, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 4, 0)) * 2
    t2new.bbbb += np.transpose(tmp41, (1, 0, 2, 3)) * -2
    t2new.bbbb += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    t2new.bbbb += np.transpose(v.bbbb.ovov, (0, 2, 3, 1)) * -1
    t2new.bbbb += np.transpose(tmp40, (0, 1, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp41, (0, 1, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp43, (0, 1, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp43, (1, 0, 2, 3)) * -2
    t2new.bbbb += np.transpose(tmp46, (0, 1, 3, 2)) * 2
    t2new.bbbb += np.transpose(tmp48, (1, 0, 2, 3)) * -1
    t2new.bbbb += tmp43 * 2
    t2new.bbbb += np.transpose(tmp43, (1, 0, 3, 2)) * 2
    del tmp43
    t2new.bbbb += np.transpose(tmp46, (1, 0, 3, 2)) * -2
    del tmp46
    t2new.bbbb += tmp48
    del tmp48
    t2new.bbbb += tmp40
    del tmp40
    t2new.bbbb += tmp41 * 2
    del tmp41
    t2new.bbbb += tmp49 * -2
    t2new.bbbb += np.transpose(tmp49, (1, 0, 2, 3)) * 2
    del tmp49
    t2new.bbbb += einsum(v.bbbb.vvvv, (0, 1, 2, 3), t2.bbbb, (4, 5, 3, 1), (4, 5, 0, 2)) * -2
    t2new.bbbb += np.transpose(tmp51, (0, 1, 3, 2)) * -2
    del tmp51
    t2new.bbbb += np.transpose(tmp52, (0, 1, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp52, (1, 0, 3, 2)) * 2
    del tmp52
    t2new.abab = einsum(f.bb.oo, (0, 1), t2.abab, (2, 1, 3, 4), (2, 0, 3, 4)) * -1
    t2new.abab += tmp23
    del tmp23
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), f.aa.oo, (4, 0), (4, 1, 2, 3)) * -1
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp26, (4, 3), (0, 1, 2, 4)) * -2
    del tmp26
    t2new.abab += tmp27 * 2
    del tmp27
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 0, 2), (4, 1, 5, 3))
    t2new.abab += einsum(tmp28, (0, 1), t2.abab, (2, 3, 0, 4), (2, 3, 1, 4)) * -1
    del tmp28
    t2new.abab += einsum(f.bb.vv, (0, 1), t2.abab, (2, 3, 4, 1), (2, 3, 4, 0))
    t2new.abab += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp29, (1, 4, 2, 5), (0, 4, 5, 3)) * -1
    del tmp29
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp30, (0, 4, 2, 5), (4, 1, 5, 3)) * -1
    del tmp30
    t2new.abab += einsum(t2.bbbb, (0, 1, 2, 3), tmp32, (4, 1, 5, 3), (4, 0, 5, 2)) * 2
    del tmp32
    t2new.abab += tmp31 * 2
    del tmp31
    t2new.abab += einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    t2new.abab += einsum(v.bbbb.oovv, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 5, 2)) * -1
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), v.aabb.oovv, (4, 0, 5, 3), (4, 1, 2, 5)) * -1
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvvv, (4, 2, 5, 3), (0, 1, 4, 5))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp33, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp33
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp36, (4, 1), (0, 4, 2, 3)) * -1
    del tmp36
    t2new.abab += einsum(tmp37, (0, 1), t2.abab, (1, 2, 3, 4), (0, 2, 3, 4)) * -2
    del tmp37
    t2new.aaaa = np.copy(np.transpose(tmp0, (1, 0, 3, 2))) * 2
    t2new.aaaa += np.transpose(tmp1, (1, 0, 3, 2)) * 2
    del tmp1
    t2new.aaaa += np.transpose(tmp0, (0, 1, 3, 2)) * -2
    del tmp0
    t2new.aaaa += einsum(tmp4, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 4, 0)) * -4
    del tmp4
    t2new.aaaa += np.transpose(tmp5, (1, 0, 3, 2)) * 2
    t2new.aaaa += np.transpose(tmp6, (1, 0, 3, 2))
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp7, (4, 3), (0, 1, 4, 2)) * 2
    del tmp7
    t2new.aaaa += np.transpose(tmp5, (1, 0, 2, 3)) * -2
    t2new.aaaa += einsum(f.aa.vv, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 4, 0)) * 2
    t2new.aaaa += np.transpose(tmp6, (1, 0, 2, 3)) * -1
    t2new.aaaa += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    t2new.aaaa += np.transpose(v.aaaa.ovov, (0, 2, 3, 1)) * -1
    t2new.aaaa += np.transpose(tmp5, (0, 1, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp6, (0, 1, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp8, (0, 1, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp8, (1, 0, 2, 3)) * -2
    t2new.aaaa += np.transpose(tmp12, (0, 1, 3, 2)) * 2
    t2new.aaaa += np.transpose(tmp15, (1, 0, 2, 3)) * -1
    t2new.aaaa += tmp8 * 2
    t2new.aaaa += np.transpose(tmp8, (1, 0, 3, 2)) * 2
    del tmp8
    t2new.aaaa += np.transpose(tmp12, (1, 0, 3, 2)) * -2
    del tmp12
    t2new.aaaa += np.transpose(tmp15, (1, 0, 3, 2))
    del tmp15
    t2new.aaaa += tmp5 * 2
    del tmp5
    t2new.aaaa += tmp6
    del tmp6
    t2new.aaaa += tmp16 * -2
    t2new.aaaa += np.transpose(tmp16, (1, 0, 2, 3)) * 2
    del tmp16
    t2new.aaaa += einsum(v.aaaa.vvvv, (0, 1, 2, 3), t2.aaaa, (4, 5, 1, 3), (4, 5, 0, 2)) * 2
    t2new.aaaa += np.transpose(tmp18, (0, 1, 3, 2)) * -2
    del tmp18
    t2new.aaaa += np.transpose(tmp22, (1, 0, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp22, (0, 1, 3, 2)) * 2
    del tmp22

    return {f"t2new": t2new}

def update_lams(f=None, l2=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:19:07.584968.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    l2 : Namespace of arrays
        L2 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    l2new : Namespace of arrays
        Updated L2 residuals.
    """

    l2new = Namespace()
    tmp38 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 0, 1), (4, 2))
    tmp37 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    tmp47 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (0, 2, 4, 1), (4, 3)) * -1
    tmp46 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 1, 4), (4, 3))
    tmp77 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 5), (3, 4, 1, 5))
    tmp78 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp54 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp53 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovov, (1, 3, 4, 5), (0, 4, 2, 5))
    tmp58 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    tmp59 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    tmp51 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp50 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 5), (1, 4, 3, 5))
    tmp41 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp40 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 3), (1, 4))
    tmp19 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 4, 3), (4, 1))
    tmp20 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 1, 3), (2, 4))
    tmp7 = einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 0, 2), (4, 1, 5, 3))
    tmp8 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp5 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp4 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp31 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 1), (4, 0))
    tmp32 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    tmp27 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp28 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp0 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4))
    tmp1 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    tmp39 = np.copy(tmp37)
    del tmp37
    tmp39 += tmp38 * 2
    del tmp38
    tmp48 = np.copy(f.bb.vv) * -1
    tmp48 += tmp46
    del tmp46
    tmp48 += tmp47 * 2
    del tmp47
    tmp79 = np.copy(tmp77)
    del tmp77
    tmp79 += tmp78 * 4
    del tmp78
    tmp55 = np.copy(np.transpose(v.aabb.ovov, (0, 2, 1, 3)))
    tmp55 += tmp53 * 2
    del tmp53
    tmp55 += tmp54
    del tmp54
    tmp71 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp60 = np.copy(tmp58) * 0.5
    tmp60 += tmp59
    tmp65 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 1, 3)))
    tmp65 += v.bbbb.oovv * -1
    tmp65 += tmp50
    tmp65 += tmp51 * 2
    tmp68 = np.copy(f.bb.oo)
    tmp68 += tmp40
    tmp68 += tmp41 * 2
    tmp81 = np.copy(tmp58)
    del tmp58
    tmp81 += tmp59 * 2
    del tmp59
    tmp52 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 1, 3)))
    tmp52 += v.bbbb.oovv * -1
    tmp52 += tmp50
    del tmp50
    tmp52 += tmp51 * 2
    del tmp51
    tmp12 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp11 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 1, 3), (0, 4))
    tmp44 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 5), (4, 0, 5, 1))
    tmp21 = np.copy(f.aa.vv) * -1
    tmp21 += tmp19 * 2
    del tmp19
    tmp21 += tmp20
    del tmp20
    tmp17 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp9 = np.copy(np.transpose(v.aabb.ovov, (0, 2, 1, 3)))
    tmp9 += tmp7
    del tmp7
    tmp9 += tmp8 * 2
    del tmp8
    tmp25 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 1, 3)))
    tmp25 += v.aaaa.oovv * -1
    tmp25 += tmp4 * 2
    tmp25 += tmp5
    tmp35 = np.copy(tmp31)
    tmp35 += tmp32 * 0.5
    tmp33 = np.copy(tmp31) * 2
    del tmp31
    tmp33 += tmp32
    del tmp32
    tmp29 = np.copy(tmp27) * 4
    del tmp27
    tmp29 += tmp28
    del tmp28
    tmp2 = np.copy(tmp0) * 2
    tmp2 += tmp1
    tmp75 = einsum(tmp39, (0, 1), v.bbbb.ovov, (2, 3, 4, 1), (2, 4, 0, 3))
    tmp64 = einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp39, (4, 1), (0, 2, 4, 3))
    tmp73 = einsum(tmp48, (0, 1), l2.bbbb, (2, 0, 3, 4), (3, 4, 2, 1)) * -1
    tmp80 = einsum(tmp79, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    del tmp79
    tmp74 = np.copy(v.bbbb.oooo)
    tmp74 += einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 2, 5, 3), (0, 4, 5, 1))
    tmp67 = einsum(tmp55, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (1, 5, 3, 4))
    tmp72 = einsum(tmp71, (0, 1, 2, 3), v.bbbb.ovov, (3, 4, 2, 5), (1, 0, 5, 4)) * -1
    del tmp71
    tmp83 = einsum(tmp60, (0, 1), v.bbbb.ovov, (2, 3, 1, 4), (0, 2, 4, 3)) * 2
    tmp70 = einsum(l2.bbbb, (0, 1, 2, 3), v.bbbb.vvvv, (4, 0, 5, 1), (2, 3, 4, 5))
    tmp66 = einsum(tmp65, (0, 1, 2, 3), l2.bbbb, (4, 2, 5, 0), (5, 1, 4, 3)) * 2
    del tmp65
    tmp69 = einsum(l2.bbbb, (0, 1, 2, 3), tmp68, (3, 4), (2, 4, 0, 1)) * -2
    del tmp68
    tmp82 = einsum(tmp81, (0, 1), v.bbbb.ovov, (2, 3, 1, 4), (0, 2, 4, 3))
    del tmp81
    tmp76 = einsum(tmp52, (0, 1, 2, 3), l2.bbbb, (4, 2, 5, 0), (5, 1, 4, 3))
    tmp15 = np.copy(f.aa.oo)
    tmp15 += tmp11 * 2
    tmp15 += tmp12
    tmp57 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp62 = einsum(l2.abab, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 0), (4, 3, 5, 1))
    tmp62 += einsum(l2.bbbb, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (4, 2, 5, 0))
    tmp45 = einsum(tmp44, (0, 1, 2, 3), v.aabb.ovov, (1, 4, 3, 5), (0, 2, 4, 5))
    del tmp44
    tmp49 = np.copy(v.aabb.oooo)
    tmp49 += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp43 = einsum(v.aabb.vvvv, (0, 1, 2, 3), l2.abab, (1, 3, 4, 5), (4, 5, 0, 2))
    tmp61 = np.copy(tmp0)
    del tmp0
    tmp61 += tmp1 * 0.5
    del tmp1
    tmp63 = einsum(t2.abab, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 0), (5, 1, 4, 3))
    tmp63 += einsum(t2.bbbb, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp42 = np.copy(f.bb.oo) * 0.5
    tmp42 += tmp40 * 0.5
    del tmp40
    tmp42 += tmp41
    del tmp41
    tmp14 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 1, 3)))
    tmp14 += v.aaaa.oovv * -1
    tmp14 += tmp4 * 2
    tmp14 += tmp5
    tmp56 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 5, 3), (1, 5, 2, 4))
    tmp22 = einsum(tmp21, (0, 1), l2.aaaa, (2, 0, 3, 4), (3, 4, 1, 2)) * -1
    tmp6 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 1, 3))) * 0.5
    tmp6 += v.aaaa.oovv * -0.5
    tmp6 += tmp4
    del tmp4
    tmp6 += tmp5 * 0.5
    del tmp5
    tmp13 = np.copy(f.aa.oo) * 0.5
    tmp13 += tmp11
    del tmp11
    tmp13 += tmp12 * 0.5
    del tmp12
    tmp18 = einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp17, (4, 5, 2, 0), (5, 4, 3, 1)) * -1
    del tmp17
    tmp10 = einsum(tmp9, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (0, 5, 2, 4))
    tmp26 = einsum(l2.aaaa, (0, 1, 2, 3), tmp25, (3, 4, 1, 5), (4, 2, 5, 0))
    del tmp25
    tmp36 = einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp35, (4, 2), (0, 4, 3, 1)) * 2
    tmp16 = einsum(v.aaaa.vvvv, (0, 1, 2, 3), l2.aaaa, (3, 1, 4, 5), (4, 5, 0, 2)) * -1
    tmp34 = einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp33, (4, 2), (0, 4, 3, 1))
    del tmp33
    tmp30 = einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp29, (4, 2, 5, 1), (0, 4, 3, 5))
    del tmp29
    tmp24 = einsum(tmp2, (0, 1), v.aaaa.ovov, (2, 3, 4, 1), (2, 4, 3, 0))
    tmp3 = einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp2, (4, 1), (0, 2, 3, 4))
    del tmp2
    tmp23 = np.copy(v.aaaa.oooo)
    tmp23 += einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 3, 5, 2), (0, 4, 1, 5)) * -1
    l2new.bbbb = np.copy(np.transpose(v.bbbb.ovov, (1, 3, 0, 2)))
    l2new.bbbb += np.transpose(tmp64, (3, 2, 1, 0)) * -1
    l2new.bbbb += np.transpose(v.bbbb.ovov, (3, 1, 0, 2)) * -1
    l2new.bbbb += np.transpose(tmp64, (2, 3, 1, 0))
    del tmp64
    l2new.bbbb += np.transpose(tmp66, (3, 2, 0, 1)) * -1
    l2new.bbbb += np.transpose(tmp67, (2, 3, 1, 0)) * -1
    l2new.bbbb += np.transpose(tmp69, (3, 2, 0, 1)) * -1
    l2new.bbbb += np.transpose(tmp66, (3, 2, 1, 0))
    del tmp66
    l2new.bbbb += np.transpose(tmp67, (2, 3, 0, 1))
    l2new.bbbb += np.transpose(tmp69, (3, 2, 1, 0))
    del tmp69
    l2new.bbbb += np.transpose(tmp70, (3, 2, 1, 0)) * 2
    del tmp70
    l2new.bbbb += np.transpose(tmp72, (3, 2, 1, 0)) * 2
    del tmp72
    l2new.bbbb += np.transpose(tmp73, (3, 2, 1, 0)) * 2
    l2new.bbbb += np.transpose(tmp73, (2, 3, 1, 0)) * -2
    del tmp73
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp74, (2, 4, 5, 3), (0, 1, 5, 4)) * -2
    del tmp74
    l2new.bbbb += np.transpose(tmp75, (3, 2, 1, 0))
    l2new.bbbb += np.transpose(tmp76, (2, 3, 0, 1)) * 2
    l2new.bbbb += np.transpose(tmp67, (3, 2, 1, 0))
    l2new.bbbb += np.transpose(tmp76, (2, 3, 1, 0)) * -2
    del tmp76
    l2new.bbbb += np.transpose(tmp67, (3, 2, 0, 1)) * -1
    del tmp67
    l2new.bbbb += np.transpose(tmp80, (3, 2, 0, 1))
    l2new.bbbb += np.transpose(tmp82, (2, 3, 0, 1)) * -1
    l2new.bbbb += np.transpose(tmp80, (2, 3, 0, 1)) * -1
    l2new.bbbb += np.transpose(tmp82, (3, 2, 0, 1))
    del tmp82
    l2new.bbbb += np.transpose(tmp80, (3, 2, 1, 0)) * -1
    l2new.bbbb += np.transpose(tmp83, (2, 3, 1, 0))
    l2new.bbbb += np.transpose(tmp80, (2, 3, 1, 0))
    del tmp80
    l2new.bbbb += np.transpose(tmp83, (3, 2, 1, 0)) * -1
    del tmp83
    l2new.bbbb += np.transpose(tmp75, (2, 3, 1, 0)) * -1
    del tmp75
    l2new.abab = np.copy(np.transpose(v.aabb.ovov, (1, 3, 0, 2)))
    l2new.abab += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp39, (4, 3), (1, 4, 0, 2)) * -1
    del tmp39
    l2new.abab += einsum(v.aabb.vvoo, (0, 1, 2, 3), l2.abab, (1, 4, 5, 3), (0, 4, 5, 2)) * -1
    l2new.abab += einsum(tmp42, (0, 1), l2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    del tmp42
    l2new.abab += einsum(tmp14, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (3, 4, 1, 5))
    l2new.abab += einsum(l2.bbbb, (0, 1, 2, 3), tmp9, (4, 3, 5, 1), (5, 0, 4, 2)) * 2
    del tmp9
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp15, (2, 4), (0, 1, 4, 3)) * -1
    l2new.abab += np.transpose(tmp43, (2, 3, 0, 1))
    del tmp43
    l2new.abab += np.transpose(tmp45, (2, 3, 0, 1))
    del tmp45
    l2new.abab += einsum(tmp21, (0, 1), l2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -1
    del tmp21
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp48, (1, 4), (0, 4, 2, 3)) * -1
    del tmp48
    l2new.abab += einsum(tmp49, (0, 1, 2, 3), l2.abab, (4, 5, 0, 2), (4, 5, 1, 3))
    del tmp49
    l2new.abab += einsum(tmp52, (0, 1, 2, 3), l2.abab, (4, 2, 5, 0), (4, 3, 5, 1))
    del tmp52
    l2new.abab += einsum(l2.aaaa, (0, 1, 2, 3), tmp55, (3, 4, 1, 5), (0, 5, 2, 4)) * 2
    del tmp55
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), v.aabb.oovv, (4, 2, 5, 1), (0, 5, 4, 3)) * -1
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp56, (3, 4, 0, 5), (5, 1, 2, 4))
    del tmp56
    l2new.abab += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp35, (4, 0), (1, 3, 4, 2)) * -2
    del tmp35
    l2new.abab += einsum(tmp57, (0, 1, 2, 3), l2.abab, (4, 2, 0, 5), (4, 3, 1, 5))
    del tmp57
    l2new.abab += einsum(tmp60, (0, 1), v.aabb.ovov, (2, 3, 1, 4), (3, 4, 2, 0)) * -2
    del tmp60
    l2new.abab += einsum(tmp61, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 4, 2, 3)) * -2
    del tmp61
    l2new.abab += einsum(tmp62, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 0, 5), (5, 3, 4, 1)) * -2
    del tmp62
    l2new.abab += einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp63, (4, 2, 5, 1), (5, 3, 4, 0)) * -2
    del tmp63
    l2new.aaaa = np.copy(np.transpose(v.aaaa.ovov, (1, 3, 0, 2)))
    l2new.aaaa += np.transpose(tmp3, (2, 3, 1, 0)) * -1
    l2new.aaaa += np.transpose(v.aaaa.ovov, (3, 1, 0, 2)) * -1
    l2new.aaaa += np.transpose(tmp3, (3, 2, 1, 0))
    del tmp3
    l2new.aaaa += einsum(l2.aaaa, (0, 1, 2, 3), tmp6, (3, 4, 1, 5), (5, 0, 2, 4)) * -4
    del tmp6
    l2new.aaaa += np.transpose(tmp10, (2, 3, 1, 0)) * -1
    l2new.aaaa += einsum(l2.aaaa, (0, 1, 2, 3), tmp13, (3, 4), (0, 1, 2, 4)) * -4
    del tmp13
    l2new.aaaa += einsum(l2.aaaa, (0, 1, 2, 3), tmp14, (3, 4, 1, 5), (5, 0, 4, 2)) * 2
    del tmp14
    l2new.aaaa += np.transpose(tmp10, (2, 3, 0, 1))
    l2new.aaaa += einsum(tmp15, (0, 1), l2.aaaa, (2, 3, 4, 0), (2, 3, 1, 4)) * 2
    del tmp15
    l2new.aaaa += np.transpose(tmp16, (3, 2, 1, 0)) * 2
    del tmp16
    l2new.aaaa += np.transpose(tmp18, (3, 2, 1, 0)) * 2
    del tmp18
    l2new.aaaa += np.transpose(tmp22, (2, 3, 1, 0)) * 2
    l2new.aaaa += np.transpose(tmp22, (3, 2, 1, 0)) * -2
    del tmp22
    l2new.aaaa += einsum(tmp23, (0, 1, 2, 3), l2.aaaa, (4, 5, 0, 2), (4, 5, 1, 3)) * 2
    del tmp23
    l2new.aaaa += np.transpose(tmp24, (2, 3, 1, 0))
    l2new.aaaa += np.transpose(tmp26, (3, 2, 1, 0)) * 2
    l2new.aaaa += np.transpose(tmp10, (3, 2, 1, 0))
    l2new.aaaa += np.transpose(tmp26, (3, 2, 0, 1)) * -2
    del tmp26
    l2new.aaaa += np.transpose(tmp10, (3, 2, 0, 1)) * -1
    del tmp10
    l2new.aaaa += np.transpose(tmp30, (2, 3, 1, 0))
    l2new.aaaa += np.transpose(tmp34, (2, 3, 1, 0)) * -1
    l2new.aaaa += np.transpose(tmp30, (3, 2, 1, 0)) * -1
    l2new.aaaa += np.transpose(tmp34, (3, 2, 1, 0))
    del tmp34
    l2new.aaaa += np.transpose(tmp30, (2, 3, 0, 1)) * -1
    l2new.aaaa += np.transpose(tmp36, (2, 3, 0, 1))
    l2new.aaaa += np.transpose(tmp30, (3, 2, 0, 1))
    del tmp30
    l2new.aaaa += np.transpose(tmp36, (3, 2, 0, 1)) * -1
    del tmp36
    l2new.aaaa += np.transpose(tmp24, (3, 2, 1, 0)) * -1
    del tmp24

    return {f"l2new": l2new}

def make_rdm1_f(l2=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:19:08.557834.

    Parameters
    ----------
    l2 : Namespace of arrays
        L2 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm1 : Namespace of arrays
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    rdm1.aa = Namespace()
    rdm1.bb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    rdm1.bb.vv = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    rdm1.bb.vv += einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 0, 1), (4, 2)) * 2
    rdm1.aa.vv = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4)) * 2
    rdm1.aa.vv += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    rdm1.bb.oo = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 0, 4), (1, 4)) * -1
    rdm1.bb.oo += einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 0, 1), (4, 2)) * -2
    rdm1.bb.oo += delta.bb.oo
    rdm1.aa.oo = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 1), (0, 4)) * -2
    rdm1.aa.oo += delta.aa.oo
    del delta
    rdm1.aa.oo += einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 1), (0, 4)) * -1
    rdm1.aa.ov = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[-1]))
    rdm1.aa.vo = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[0]))
    rdm1.bb.ov = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[-1]))
    rdm1.bb.vo = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[0]))
    rdm1.aa = np.block([[rdm1.aa.oo, rdm1.aa.ov], [rdm1.aa.vo, rdm1.aa.vv]])
    rdm1.bb = np.block([[rdm1.bb.oo, rdm1.bb.ov], [rdm1.bb.vo, rdm1.bb.vv]])

    return rdm1

def make_rdm2_f(l2=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:19:23.605919.

    Parameters
    ----------
    l2 : Namespace of arrays
        L2 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm2 : Namespace of arrays
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    rdm2.aaaa = Namespace()
    rdm2.abab = Namespace()
    rdm2.bbbb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    tmp5 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    tmp6 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 0, 1), (2, 4))
    tmp0 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 1), (4, 0))
    tmp1 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    tmp27 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 0, 1), (4, 2))
    tmp26 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    tmp14 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 0, 1), (4, 2))
    tmp15 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    tmp34 = einsum(t2.bbbb, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp11 = np.copy(tmp5)
    tmp11 += tmp6 * 2
    tmp13 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp31 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp33 = einsum(t2.abab, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 0), (5, 1, 4, 3))
    tmp30 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 5), (3, 4, 1, 5))
    tmp4 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp23 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp21 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp8 = np.copy(tmp0) * 2
    tmp8 += tmp1
    tmp19 = einsum(l2.bbbb, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (4, 2, 5, 0))
    tmp43 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 5), (0, 1, 4, 5))
    tmp42 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 5), (0, 1, 4, 5))
    tmp41 = np.copy(tmp26)
    tmp41 += tmp27 * 2
    tmp25 = np.copy(tmp14) * 2
    tmp25 += tmp15
    tmp28 = np.copy(tmp26) * 0.5
    del tmp26
    tmp28 += tmp27
    del tmp27
    tmp16 = np.copy(tmp14)
    del tmp14
    tmp16 += tmp15 * 0.5
    del tmp15
    tmp29 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 5, 1), (5, 0, 4, 3))
    tmp40 = einsum(t2.abab, (0, 1, 2, 3), tmp34, (0, 4, 2, 5), (1, 4, 3, 5))
    tmp36 = einsum(tmp11, (0, 1), t2.bbbb, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    tmp37 = einsum(tmp13, (0, 1, 2, 3), t2.bbbb, (1, 0, 4, 5), (3, 2, 4, 5))
    tmp38 = einsum(t2.bbbb, (0, 1, 2, 3), tmp31, (1, 4, 3, 5), (0, 4, 2, 5))
    tmp39 = einsum(tmp33, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5))
    tmp32 = np.copy(tmp30)
    tmp32 += tmp31 * 4
    tmp3 = np.copy(tmp0)
    tmp3 += tmp1 * 0.5
    tmp35 = np.copy(tmp33)
    tmp35 += tmp34
    tmp9 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 5), (4, 0, 5, 1))
    tmp18 = einsum(t2.aaaa, (0, 1, 2, 3), tmp4, (1, 0, 4, 5), (5, 4, 2, 3))
    tmp24 = einsum(t2.aaaa, (0, 1, 2, 3), tmp23, (1, 4, 3, 5), (0, 4, 2, 5))
    tmp22 = einsum(tmp21, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (4, 1, 5, 3))
    tmp17 = einsum(tmp8, (0, 1), t2.aaaa, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    tmp20 = einsum(tmp19, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp10 = np.copy(delta.bb.oo) * -1
    tmp10 += tmp5
    tmp10 += tmp6 * 2
    tmp12 = np.copy(tmp5) * 0.5
    tmp12 += tmp6
    tmp7 = np.copy(delta.bb.oo) * -0.5
    tmp7 += tmp5 * 0.5
    del tmp5
    tmp7 += tmp6
    del tmp6
    tmp2 = np.copy(delta.aa.oo) * -1
    tmp2 += tmp0 * 2
    del tmp0
    tmp2 += tmp1
    del tmp1
    rdm2.bbbb.vvvv = np.copy(np.transpose(tmp43, (1, 0, 3, 2))) * 2
    del tmp43
    rdm2.abab.vvvv = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 5, 0, 1), (4, 5, 2, 3))
    rdm2.aaaa.vvvv = np.copy(np.transpose(tmp42, (1, 0, 3, 2))) * 2
    del tmp42
    rdm2.bbbb.vvoo = np.copy(l2.bbbb) * 2
    rdm2.abab.vvoo = np.copy(l2.abab)
    rdm2.aaaa.vvoo = np.copy(l2.aaaa) * 2
    rdm2.bbbb.vovo = einsum(tmp41, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.vovo += np.transpose(tmp30, (2, 1, 3, 0)) * -1
    rdm2.bbbb.vovo += np.transpose(tmp31, (2, 1, 3, 0)) * -4
    rdm2.abab.vovo = einsum(tmp25, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.abab.vovo += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 5, 1), (0, 4, 5, 3)) * -1
    rdm2.aaaa.vovo = einsum(delta.aa.oo, (0, 1), tmp25, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.vovo += np.transpose(tmp21, (2, 1, 3, 0)) * -4
    rdm2.aaaa.vovo += np.transpose(tmp23, (2, 1, 3, 0)) * -1
    rdm2.bbbb.voov = einsum(tmp28, (0, 1), delta.bb.oo, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.bbbb.voov += np.transpose(tmp30, (2, 1, 0, 3))
    rdm2.bbbb.voov += np.transpose(tmp31, (2, 1, 0, 3)) * 4
    rdm2.abab.voov = np.copy(np.transpose(tmp33, (2, 1, 0, 3))) * 2
    del tmp33
    rdm2.abab.voov += np.transpose(tmp34, (2, 1, 0, 3)) * 2
    del tmp34
    rdm2.aaaa.voov = einsum(delta.aa.oo, (0, 1), tmp16, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.aaaa.voov += np.transpose(tmp21, (2, 1, 0, 3)) * 4
    rdm2.aaaa.voov += np.transpose(tmp23, (2, 1, 0, 3))
    rdm2.bbbb.ovvo = einsum(tmp41, (0, 1), delta.bb.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.ovvo += np.transpose(tmp30, (1, 2, 3, 0))
    rdm2.bbbb.ovvo += np.transpose(tmp31, (1, 2, 3, 0)) * 4
    rdm2.abab.ovvo = einsum(l2.abab, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 0), (4, 1, 5, 3)) * 2
    rdm2.abab.ovvo += np.transpose(tmp19, (0, 3, 2, 1)) * 2
    del tmp19
    rdm2.aaaa.ovvo = einsum(delta.aa.oo, (0, 1), tmp25, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.ovvo += np.transpose(tmp21, (1, 2, 3, 0)) * 4
    rdm2.aaaa.ovvo += np.transpose(tmp23, (1, 2, 3, 0))
    rdm2.bbbb.ovov = einsum(tmp28, (0, 1), delta.bb.oo, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.bbbb.ovov += np.transpose(tmp30, (1, 2, 0, 3)) * -1
    del tmp30
    rdm2.bbbb.ovov += np.transpose(tmp31, (1, 2, 0, 3)) * -4
    del tmp31
    rdm2.abab.ovov = einsum(delta.aa.oo, (0, 1), tmp28, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.abab.ovov += np.transpose(tmp29, (1, 2, 0, 3)) * -1
    rdm2.aaaa.ovov = einsum(delta.aa.oo, (0, 1), tmp16, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.aaaa.ovov += np.transpose(tmp21, (1, 2, 0, 3)) * -4
    del tmp21
    rdm2.aaaa.ovov += np.transpose(tmp23, (1, 2, 0, 3)) * -1
    del tmp23
    rdm2.bbbb.oovv = np.copy(t2.bbbb) * 2
    rdm2.bbbb.oovv += einsum(tmp28, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 4, 1)) * -4
    rdm2.bbbb.oovv += np.transpose(tmp36, (1, 0, 3, 2)) * 2
    rdm2.bbbb.oovv += np.transpose(tmp36, (0, 1, 3, 2)) * -2
    del tmp36
    rdm2.bbbb.oovv += np.transpose(tmp37, (0, 1, 3, 2)) * -2
    del tmp37
    rdm2.bbbb.oovv += np.transpose(tmp38, (0, 1, 3, 2)) * -8
    rdm2.bbbb.oovv += np.transpose(tmp39, (0, 1, 3, 2)) * -2
    rdm2.bbbb.oovv += np.transpose(tmp40, (0, 1, 3, 2)) * -2
    rdm2.bbbb.oovv += np.transpose(tmp40, (1, 0, 2, 3)) * -2
    rdm2.bbbb.oovv += tmp38 * 8
    del tmp38
    rdm2.bbbb.oovv += np.transpose(tmp39, (1, 0, 3, 2)) * 2
    del tmp39
    rdm2.bbbb.oovv += tmp40 * 2
    rdm2.bbbb.oovv += np.transpose(tmp40, (1, 0, 3, 2)) * 2
    del tmp40
    rdm2.bbbb.oovv += einsum(t2.bbbb, (0, 1, 2, 3), tmp41, (3, 4), (0, 1, 4, 2)) * 2
    del tmp41
    rdm2.abab.oovv = np.copy(t2.abab)
    rdm2.abab.oovv += einsum(tmp28, (0, 1), t2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    del tmp28
    rdm2.abab.oovv += einsum(tmp3, (0, 1), t2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -2
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp11, (1, 4), (0, 4, 2, 3)) * -1
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp9, (0, 4, 1, 5), (4, 5, 2, 3))
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp29, (0, 4, 3, 5), (4, 1, 2, 5))
    del tmp29
    rdm2.abab.oovv += einsum(tmp32, (0, 1, 2, 3), t2.abab, (4, 0, 5, 2), (4, 1, 5, 3))
    del tmp32
    rdm2.abab.oovv += einsum(t2.aaaa, (0, 1, 2, 3), tmp35, (1, 4, 3, 5), (0, 4, 2, 5)) * 4
    del tmp35
    rdm2.abab.oovv += einsum(tmp16, (0, 1), t2.abab, (2, 3, 0, 4), (2, 3, 1, 4)) * -2
    rdm2.aaaa.oovv = np.copy(t2.aaaa) * 2
    rdm2.aaaa.oovv += einsum(tmp16, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 4, 1)) * -4
    del tmp16
    rdm2.aaaa.oovv += np.transpose(tmp17, (1, 0, 3, 2)) * 2
    rdm2.aaaa.oovv += np.transpose(tmp17, (0, 1, 3, 2)) * -2
    del tmp17
    rdm2.aaaa.oovv += np.transpose(tmp18, (0, 1, 3, 2)) * -2
    del tmp18
    rdm2.aaaa.oovv += np.transpose(tmp20, (0, 1, 3, 2)) * -2
    rdm2.aaaa.oovv += np.transpose(tmp22, (0, 1, 3, 2)) * -8
    rdm2.aaaa.oovv += np.transpose(tmp24, (0, 1, 3, 2)) * -2
    rdm2.aaaa.oovv += np.transpose(tmp24, (1, 0, 2, 3)) * -2
    rdm2.aaaa.oovv += tmp20 * 2
    del tmp20
    rdm2.aaaa.oovv += tmp22 * 8
    del tmp22
    rdm2.aaaa.oovv += tmp24 * 2
    rdm2.aaaa.oovv += np.transpose(tmp24, (1, 0, 3, 2)) * 2
    del tmp24
    rdm2.aaaa.oovv += einsum(tmp25, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 1, 4)) * 2
    del tmp25
    rdm2.bbbb.oooo = einsum(delta.bb.oo, (0, 1), tmp7, (2, 3), (0, 3, 1, 2)) * -2
    rdm2.bbbb.oooo += einsum(tmp10, (0, 1), delta.bb.oo, (2, 3), (1, 2, 3, 0))
    del tmp10
    rdm2.bbbb.oooo += einsum(delta.bb.oo, (0, 1), tmp11, (2, 3), (3, 0, 2, 1)) * -1
    del tmp11
    rdm2.bbbb.oooo += einsum(tmp12, (0, 1), delta.bb.oo, (2, 3), (2, 1, 0, 3)) * 2
    del tmp12
    rdm2.bbbb.oooo += np.transpose(tmp13, (3, 2, 1, 0)) * 2
    del tmp13
    rdm2.abab.oooo = einsum(delta.aa.oo, (0, 1), tmp7, (2, 3), (0, 3, 1, 2)) * -2
    del tmp7
    rdm2.abab.oooo += einsum(delta.bb.oo, (0, 1), tmp8, (2, 3), (3, 0, 2, 1)) * -1
    del tmp8
    rdm2.abab.oooo += np.transpose(tmp9, (1, 3, 0, 2))
    del tmp9
    rdm2.aaaa.oooo = einsum(tmp2, (0, 1), delta.aa.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.aaaa.oooo += einsum(tmp2, (0, 1), delta.aa.oo, (2, 3), (1, 2, 3, 0))
    del tmp2
    rdm2.aaaa.oooo += einsum(tmp3, (0, 1), delta.aa.oo, (2, 3), (1, 2, 0, 3)) * -2
    rdm2.aaaa.oooo += einsum(tmp3, (0, 1), delta.aa.oo, (2, 3), (2, 1, 0, 3)) * 2
    del delta, tmp3
    rdm2.aaaa.oooo += np.transpose(tmp4, (3, 2, 1, 0)) * 2
    del tmp4
    rdm2.aaaa.ooov = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[0], t2.aaaa.shape[0], t2.aaaa.shape[-1]))
    rdm2.aaaa.oovo = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[0], t2.aaaa.shape[-1], t2.aaaa.shape[0]))
    rdm2.aaaa.ovoo = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[-1], t2.aaaa.shape[0], t2.aaaa.shape[0]))
    rdm2.aaaa.vooo = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[0], t2.aaaa.shape[0], t2.aaaa.shape[0]))
    rdm2.aaaa.ovvv = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[-1], t2.aaaa.shape[-1], t2.aaaa.shape[-1]))
    rdm2.aaaa.vovv = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[0], t2.aaaa.shape[-1], t2.aaaa.shape[-1]))
    rdm2.aaaa.vvov = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[-1], t2.aaaa.shape[0], t2.aaaa.shape[-1]))
    rdm2.aaaa.vvvo = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[-1], t2.aaaa.shape[-1], t2.aaaa.shape[0]))
    rdm2.abab.ooov = np.zeros((t2.aaaa.shape[0], t2.bbbb.shape[0], t2.aaaa.shape[0], t2.bbbb.shape[-1]))
    rdm2.abab.oovo = np.zeros((t2.aaaa.shape[0], t2.bbbb.shape[0], t2.aaaa.shape[-1], t2.bbbb.shape[0]))
    rdm2.abab.ovoo = np.zeros((t2.aaaa.shape[0], t2.bbbb.shape[-1], t2.aaaa.shape[0], t2.bbbb.shape[0]))
    rdm2.abab.vooo = np.zeros((t2.aaaa.shape[-1], t2.bbbb.shape[0], t2.aaaa.shape[0], t2.bbbb.shape[0]))
    rdm2.abab.ovvv = np.zeros((t2.aaaa.shape[0], t2.bbbb.shape[-1], t2.aaaa.shape[-1], t2.bbbb.shape[-1]))
    rdm2.abab.vovv = np.zeros((t2.aaaa.shape[-1], t2.bbbb.shape[0], t2.aaaa.shape[-1], t2.bbbb.shape[-1]))
    rdm2.abab.vvov = np.zeros((t2.aaaa.shape[-1], t2.bbbb.shape[-1], t2.aaaa.shape[0], t2.bbbb.shape[-1]))
    rdm2.abab.vvvo = np.zeros((t2.aaaa.shape[-1], t2.bbbb.shape[-1], t2.aaaa.shape[-1], t2.bbbb.shape[0]))
    rdm2.bbbb.ooov = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[0], t2.bbbb.shape[0], t2.bbbb.shape[-1]))
    rdm2.bbbb.oovo = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[0], t2.bbbb.shape[-1], t2.bbbb.shape[0]))
    rdm2.bbbb.ovoo = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[-1], t2.bbbb.shape[0], t2.bbbb.shape[0]))
    rdm2.bbbb.vooo = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[0], t2.bbbb.shape[0], t2.bbbb.shape[0]))
    rdm2.bbbb.ovvv = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[-1], t2.bbbb.shape[-1], t2.bbbb.shape[-1]))
    rdm2.bbbb.vovv = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[0], t2.bbbb.shape[-1], t2.bbbb.shape[-1]))
    rdm2.bbbb.vvov = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[-1], t2.bbbb.shape[0], t2.bbbb.shape[-1]))
    rdm2.bbbb.vvvo = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[-1], t2.bbbb.shape[-1], t2.bbbb.shape[0]))
    rdm2.aaaa = pack_2e(rdm2.aaaa.oooo, rdm2.aaaa.ooov, rdm2.aaaa.oovo, rdm2.aaaa.ovoo, rdm2.aaaa.vooo, rdm2.aaaa.oovv, rdm2.aaaa.ovov, rdm2.aaaa.ovvo, rdm2.aaaa.voov, rdm2.aaaa.vovo, rdm2.aaaa.vvoo, rdm2.aaaa.ovvv, rdm2.aaaa.vovv, rdm2.aaaa.vvov, rdm2.aaaa.vvvo, rdm2.aaaa.vvvv)
    rdm2.abab = pack_2e(rdm2.abab.oooo, rdm2.abab.ooov, rdm2.abab.oovo, rdm2.abab.ovoo, rdm2.abab.vooo, rdm2.abab.oovv, rdm2.abab.ovov, rdm2.abab.ovvo, rdm2.abab.voov, rdm2.abab.vovo, rdm2.abab.vvoo, rdm2.abab.ovvv, rdm2.abab.vovv, rdm2.abab.vvov, rdm2.abab.vvvo, rdm2.abab.vvvv)
    rdm2.bbbb = pack_2e(rdm2.bbbb.oooo, rdm2.bbbb.ooov, rdm2.bbbb.oovo, rdm2.bbbb.ovoo, rdm2.bbbb.vooo, rdm2.bbbb.oovv, rdm2.bbbb.ovov, rdm2.bbbb.ovvo, rdm2.bbbb.voov, rdm2.bbbb.vovo, rdm2.bbbb.vvoo, rdm2.bbbb.ovvv, rdm2.bbbb.vovv, rdm2.bbbb.vvov, rdm2.bbbb.vvvo, rdm2.bbbb.vvvv)
    rdm2 = Namespace(
        aaaa=np.transpose(rdm2.aaaa, (0, 2, 1, 3)),
        aabb=np.transpose(rdm2.abab, (0, 2, 1, 3)),
        bbbb=np.transpose(rdm2.bbbb, (0, 2, 1, 3)),
    )

    return rdm2

def hbar_matvec_ip_intermediates(f=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:20:17.907683.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp10 : array
    tmp100 : array
    tmp102 : array
    tmp104 : array
    tmp106 : array
    tmp108 : array
    tmp110 : array
    tmp111 : array
    tmp112 : array
    tmp113 : array
    tmp114 : array
    tmp115 : array
    tmp117 : array
    tmp119 : array
    tmp12 : array
    tmp126 : array
    tmp127 : array
    tmp131 : array
    tmp133 : array
    tmp137 : array
    tmp139 : array
    tmp141 : array
    tmp151 : array
    tmp17 : array
    tmp18 : array
    tmp19 : array
    tmp21 : array
    tmp24 : array
    tmp25 : array
    tmp27 : array
    tmp28 : array
    tmp29 : array
    tmp3 : array
    tmp31 : array
    tmp33 : array
    tmp35 : array
    tmp37 : array
    tmp39 : array
    tmp41 : array
    tmp43 : array
    tmp45 : array
    tmp47 : array
    tmp49 : array
    tmp5 : array
    tmp51 : array
    tmp62 : array
    tmp64 : array
    tmp67 : array
    tmp68 : array
    tmp69 : array
    tmp76 : array
    tmp77 : array
    tmp80 : array
    tmp90 : array
    tmp93 : array
    tmp94 : array
    tmp96 : array
    tmp97 : array
    tmp98 : array
    """

    tmp151 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.ov, (4, 3), (4, 0, 1, 2))
    tmp141 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovoo, (0, 2, 4, 5), (1, 4, 5, 3))
    tmp139 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp137 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp133 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp131 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    tmp127 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovvv, (0, 2, 4, 3), (1, 4))
    tmp126 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (1, 3, 4, 2), (0, 4)) * -1
    tmp119 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp117 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 1, 4), (4, 3))
    tmp115 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (0, 2, 4, 1), (4, 3)) * -1
    tmp114 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (4, 3, 1, 5), (4, 0, 2, 5))
    tmp113 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 3, 1, 4), (2, 4))
    tmp112 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 0, 3), (4, 2)) * -1
    tmp111 = einsum(f.aa.ov, (0, 1), t2.abab, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp110 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 5), (1, 4, 3, 5))
    tmp108 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp106 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp104 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp102 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 4, 1, 5))
    tmp100 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 1, 5), (0, 4, 3, 5))
    tmp98 = einsum(t2.bbbb, (0, 1, 2, 3), v.aabb.ooov, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp97 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 1, 4, 5))
    tmp96 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.abab, (1, 4, 3, 5), (0, 2, 4, 5))
    tmp94 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp93 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (0, 2), (1, 3))
    tmp90 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovvv, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp80 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 5, 3), (1, 5, 2, 4))
    tmp77 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp76 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (4, 3), (0, 4, 1, 2))
    tmp69 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 2, 3, 5))
    tmp68 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp67 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp64 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp62 = einsum(v.aabb.vvov, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 5, 2, 0))
    tmp51 = einsum(t2.aaaa, (0, 1, 2, 3), f.aa.ov, (4, 3), (4, 0, 1, 2))
    tmp49 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 2, 5, 3))
    tmp47 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp45 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp43 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp41 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp39 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp37 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 1, 3), (2, 4))
    tmp35 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 4, 3), (4, 1))
    tmp33 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp31 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp29 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp28 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    tmp27 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 3), (0, 4))
    tmp25 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp24 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp21 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp19 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 5, 3, 1), (4, 5, 0, 2)) * -1
    tmp18 = einsum(v.aabb.vvov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 3), (4, 0))
    tmp17 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 3, 1), (4, 2)) * -1
    tmp12 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 3), (1, 4))
    tmp10 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp5 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp3 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 1, 3), (4, 0))

    return {f"tmp10": tmp10, f"tmp100": tmp100, f"tmp102": tmp102, f"tmp104": tmp104, f"tmp106": tmp106, f"tmp108": tmp108, f"tmp110": tmp110, f"tmp111": tmp111, f"tmp112": tmp112, f"tmp113": tmp113, f"tmp114": tmp114, f"tmp115": tmp115, f"tmp117": tmp117, f"tmp119": tmp119, f"tmp12": tmp12, f"tmp126": tmp126, f"tmp127": tmp127, f"tmp131": tmp131, f"tmp133": tmp133, f"tmp137": tmp137, f"tmp139": tmp139, f"tmp141": tmp141, f"tmp151": tmp151, f"tmp17": tmp17, f"tmp18": tmp18, f"tmp19": tmp19, f"tmp21": tmp21, f"tmp24": tmp24, f"tmp25": tmp25, f"tmp27": tmp27, f"tmp28": tmp28, f"tmp29": tmp29, f"tmp3": tmp3, f"tmp31": tmp31, f"tmp33": tmp33, f"tmp35": tmp35, f"tmp37": tmp37, f"tmp39": tmp39, f"tmp41": tmp41, f"tmp43": tmp43, f"tmp45": tmp45, f"tmp47": tmp47, f"tmp49": tmp49, f"tmp5": tmp5, f"tmp51": tmp51, f"tmp62": tmp62, f"tmp64": tmp64, f"tmp67": tmp67, f"tmp68": tmp68, f"tmp69": tmp69, f"tmp76": tmp76, f"tmp77": tmp77, f"tmp80": tmp80, f"tmp90": tmp90, f"tmp93": tmp93, f"tmp94": tmp94, f"tmp96": tmp96, f"tmp97": tmp97, f"tmp98": tmp98}

def hbar_matvec_ip(f=None, r1=None, r2=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:20:17.985850.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp50 = np.copy(ints.tmp137)
    del ints.tmp137
    tmp50 += np.transpose(v.bbbb.ooov, (0, 2, 1, 3)) * 0.5
    tmp48 = np.copy(ints.tmp10) * 2
    tmp48 += ints.tmp12
    tmp46 = np.copy(ints.tmp106)
    tmp46 += ints.tmp110 * 0.5
    tmp58 = np.copy(ints.tmp141)
    del ints.tmp141
    tmp58 += ints.tmp139 * 2
    del ints.tmp139
    tmp56 = np.copy(ints.tmp102)
    tmp56 += ints.tmp108 * 2
    tmp7 = np.copy(ints.tmp33)
    del ints.tmp33
    tmp7 += ints.tmp31 * 2
    del ints.tmp31
    tmp17 = np.copy(ints.tmp29)
    del ints.tmp29
    tmp17 += np.transpose(v.aaaa.ooov, (0, 2, 1, 3)) * 0.5
    tmp11 = np.copy(ints.tmp41)
    tmp11 += ints.tmp47 * 0.5
    tmp15 = np.copy(ints.tmp3) * 2
    tmp15 += ints.tmp5
    tmp13 = np.copy(ints.tmp45)
    tmp13 += ints.tmp49 * 2
    tmp44 = einsum(r2.aba, (0, 1, 2), v.aabb.ovov, (0, 2, 3, 4), (1, 3, 4))
    tmp51 = einsum(r1.b, (0,), tmp50, (1, 2, 0, 3), (1, 2, 3)) * 2
    del tmp50
    tmp45 = einsum(r2.bbb, (0, 1, 2), v.bbbb.oovv, (3, 1, 4, 2), (0, 3, 4))
    tmp49 = einsum(tmp48, (0, 1), r2.bbb, (2, 1, 3), (2, 0, 3)) * -2
    del tmp48
    tmp43 = einsum(r2.aba, (0, 1, 2), ints.tmp100, (0, 3, 2, 4), (3, 1, 4))
    tmp47 = einsum(r2.bbb, (0, 1, 2), tmp46, (3, 1, 4, 2), (0, 3, 4)) * -4
    del tmp46
    tmp31 = einsum(r2.aba, (0, 1, 2), v.aabb.ovov, (0, 2, 1, 3), (3,))
    tmp32 = einsum(r2.bbb, (0, 1, 2), v.bbbb.ovov, (0, 3, 1, 2), (3,))
    tmp55 = einsum(r2.bbb, (0, 1, 2), v.bbbb.ovov, (3, 4, 1, 2), (0, 3, 4))
    tmp59 = einsum(r1.b, (0,), tmp58, (1, 2, 0, 3), (1, 2, 3))
    del tmp58
    tmp53 = einsum(r2.bbb, (0, 1, 2), f.bb.oo, (3, 1), (3, 0, 2))
    tmp57 = einsum(r2.aba, (0, 1, 2), tmp56, (0, 3, 2, 4), (1, 3, 4))
    del tmp56
    tmp54 = einsum(ints.tmp104, (0, 1, 2, 3), r2.bbb, (4, 1, 3), (0, 4, 2))
    tmp23 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.bab, (2, 0, 3), (1,)) * -1
    tmp22 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r2.aaa, (0, 2, 1), (3,)) * -1
    tmp5 = einsum(r2.bab, (0, 1, 2), ints.tmp43, (3, 0, 4, 2), (3, 1, 4)) * -1
    tmp6 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.bab, (2, 4, 3), (4, 0, 1)) * -1
    tmp4 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r2.aaa, (4, 2, 3), (4, 0, 1))
    tmp2 = einsum(f.aa.oo, (0, 1), r2.aaa, (2, 1, 3), (0, 2, 3))
    tmp3 = einsum(r2.aaa, (0, 1, 2), ints.tmp39, (3, 1, 4, 2), (3, 0, 4))
    tmp8 = einsum(r1.a, (0,), tmp7, (1, 2, 0, 3), (1, 2, 3))
    del tmp7
    tmp18 = einsum(r1.a, (0,), tmp17, (1, 2, 0, 3), (1, 2, 3)) * 2
    del tmp17
    tmp10 = einsum(v.aaaa.oovv, (0, 1, 2, 3), r2.aaa, (4, 1, 3), (4, 0, 2))
    tmp12 = einsum(r2.aaa, (0, 1, 2), tmp11, (3, 1, 4, 2), (0, 3, 4)) * -4
    del tmp11
    tmp16 = einsum(tmp15, (0, 1), r2.aaa, (2, 1, 3), (2, 0, 3)) * -2
    del tmp15
    tmp14 = einsum(tmp13, (0, 1, 2, 3), r2.bab, (1, 4, 3), (4, 0, 2)) * -1
    del tmp13
    tmp52 = np.copy(tmp43)
    del tmp43
    tmp52 += tmp44
    del tmp44
    tmp52 += tmp45 * 2
    del tmp45
    tmp52 += np.transpose(tmp47, (1, 0, 2)) * -1
    del tmp47
    tmp52 += np.transpose(tmp49, (1, 0, 2))
    del tmp49
    tmp52 += tmp51
    del tmp51
    tmp33 = np.copy(tmp31) * -0.5
    del tmp31
    tmp33 += tmp32
    del tmp32
    tmp62 = np.copy(ints.tmp131)
    del ints.tmp131
    tmp62 += np.transpose(ints.tmp151, (1, 2, 0, 3)) * -1
    del ints.tmp151
    tmp61 = np.copy(ints.tmp133)
    del ints.tmp133
    tmp61 += np.transpose(v.bbbb.oooo, (0, 2, 1, 3))
    tmp42 = np.copy(f.bb.ov)
    tmp42 += ints.tmp127
    del ints.tmp127
    tmp42 += ints.tmp93
    del ints.tmp93
    tmp42 += ints.tmp94 * 2
    del ints.tmp94
    tmp42 += ints.tmp112 * -2
    del ints.tmp112
    tmp42 += ints.tmp113 * -1
    del ints.tmp113
    tmp42 += ints.tmp126 * -2
    del ints.tmp126
    tmp60 = np.copy(tmp53) * 2
    del tmp53
    tmp60 += tmp54 * 4
    del tmp54
    tmp60 += tmp55 * 2
    del tmp55
    tmp60 += np.transpose(tmp57, (1, 0, 2))
    del tmp57
    tmp60 += tmp59
    del tmp59
    tmp39 = np.copy(np.transpose(ints.tmp115, (1, 0))) * 2
    del ints.tmp115
    tmp39 += np.transpose(ints.tmp117, (1, 0))
    del ints.tmp117
    tmp39 += f.bb.vv * -1
    tmp40 = np.copy(tmp22) * 2
    tmp40 += tmp23
    tmp41 = np.copy(ints.tmp111)
    del ints.tmp111
    tmp41 += np.transpose(ints.tmp90, (1, 0, 2, 3))
    del ints.tmp90
    tmp41 += np.transpose(ints.tmp97, (1, 0, 2, 3))
    del ints.tmp97
    tmp41 += np.transpose(ints.tmp98, (1, 0, 2, 3)) * 2
    del ints.tmp98
    tmp41 += v.aabb.ooov
    tmp41 += np.transpose(ints.tmp114, (1, 0, 2, 3)) * -1
    del ints.tmp114
    tmp41 += np.transpose(ints.tmp96, (1, 0, 2, 3)) * -1
    del ints.tmp96
    tmp36 = np.copy(ints.tmp102)
    del ints.tmp102
    tmp36 += ints.tmp108 * 2
    del ints.tmp108
    tmp36 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp36 += ints.tmp100 * -1
    del ints.tmp100
    tmp37 = np.copy(ints.tmp119)
    del ints.tmp119
    tmp37 += v.aabb.oovv * -1
    tmp1 = np.copy(f.bb.oo)
    tmp1 += np.transpose(ints.tmp10, (1, 0)) * 2
    del ints.tmp10
    tmp1 += np.transpose(ints.tmp12, (1, 0))
    del ints.tmp12
    tmp38 = np.copy(ints.tmp64)
    tmp38 += v.aabb.oooo
    tmp0 = np.copy(f.aa.oo)
    tmp0 += np.transpose(ints.tmp3, (1, 0)) * 2
    del ints.tmp3
    tmp0 += np.transpose(ints.tmp5, (1, 0))
    del ints.tmp5
    tmp35 = np.copy(ints.tmp106) * 2
    del ints.tmp106
    tmp35 += ints.tmp110
    del ints.tmp110
    tmp35 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    tmp35 += ints.tmp104 * -2
    del ints.tmp104
    tmp35 += v.bbbb.oovv * -1
    tmp34 = np.copy(ints.tmp62)
    del ints.tmp62
    tmp34 += ints.tmp68
    del ints.tmp68
    tmp34 += ints.tmp69 * 2
    del ints.tmp69
    tmp34 += np.transpose(ints.tmp76, (0, 2, 1, 3))
    del ints.tmp76
    tmp34 += np.transpose(v.aabb.ovoo, (0, 2, 3, 1))
    tmp34 += ints.tmp67 * -1
    del ints.tmp67
    tmp34 += ints.tmp77 * -1
    del ints.tmp77
    tmp21 = np.copy(np.transpose(ints.tmp35, (1, 0))) * 2
    del ints.tmp35
    tmp21 += np.transpose(ints.tmp37, (1, 0))
    del ints.tmp37
    tmp21 += f.aa.vv * -1
    tmp28 = np.copy(ints.tmp45)
    del ints.tmp45
    tmp28 += ints.tmp49 * 2
    del ints.tmp49
    tmp28 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp28 += ints.tmp43 * -1
    del ints.tmp43
    tmp27 = np.copy(ints.tmp41) * 2
    del ints.tmp41
    tmp27 += ints.tmp47
    del ints.tmp47
    tmp27 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp27 += ints.tmp39 * -2
    del ints.tmp39
    tmp27 += v.aaaa.oovv * -1
    tmp26 = np.copy(f.aa.ov)
    tmp26 += ints.tmp18
    del ints.tmp18
    tmp26 += ints.tmp24 * 2
    del ints.tmp24
    tmp26 += ints.tmp25
    del ints.tmp25
    tmp26 += ints.tmp17 * -2
    del ints.tmp17
    tmp26 += ints.tmp27 * -2
    del ints.tmp27
    tmp26 += ints.tmp28 * -1
    del ints.tmp28
    tmp30 = np.copy(ints.tmp64)
    del ints.tmp64
    tmp30 += v.aabb.oooo
    tmp29 = np.copy(ints.tmp80)
    del ints.tmp80
    tmp29 += np.transpose(v.aabb.vvoo, (2, 3, 0, 1)) * -1
    tmp20 = np.copy(ints.tmp21)
    del ints.tmp21
    tmp20 += np.transpose(v.aaaa.oooo, (0, 2, 3, 1)) * -1
    tmp9 = np.copy(tmp2) * 2
    del tmp2
    tmp9 += tmp3 * 4
    del tmp3
    tmp9 += tmp4 * 2
    del tmp4
    tmp9 += tmp5
    del tmp5
    tmp9 += tmp6
    del tmp6
    tmp9 += tmp8
    del tmp8
    tmp25 = np.copy(ints.tmp19)
    del ints.tmp19
    tmp25 += np.transpose(ints.tmp51, (1, 2, 0, 3)) * -1
    del ints.tmp51
    tmp24 = np.copy(tmp22)
    del tmp22
    tmp24 += tmp23 * 0.5
    del tmp23
    tmp19 = np.copy(tmp10) * 2
    del tmp10
    tmp19 += np.transpose(tmp12, (1, 0, 2)) * -1
    del tmp12
    tmp19 += np.transpose(tmp14, (1, 0, 2))
    del tmp14
    tmp19 += np.transpose(tmp16, (1, 0, 2))
    del tmp16
    tmp19 += tmp18
    del tmp18
    r2new.bbb = np.copy(tmp52) * -1
    r2new.bbb += np.transpose(tmp52, (1, 0, 2))
    del tmp52
    r2new.bbb += tmp60
    r2new.bbb += np.transpose(tmp60, (1, 0, 2)) * -1
    del tmp60
    r2new.bbb += einsum(tmp61, (0, 1, 2, 3), r2.bbb, (3, 2, 4), (0, 1, 4)) * -2
    del tmp61
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp39, (2, 3), (0, 1, 3)) * -2
    r2new.bbb += einsum(tmp33, (0,), t2.bbbb, (1, 2, 3, 0), (1, 2, 3)) * 4
    r2new.bbb += einsum(r1.b, (0,), tmp62, (1, 2, 0, 3), (2, 1, 3)) * 2
    del tmp62
    r2new.bbb += einsum(tmp42, (0, 1), r1.b, (2,), (2, 0, 1))
    r2new.bbb += einsum(tmp42, (0, 1), r1.b, (2,), (0, 2, 1)) * -1
    r2new.bab = einsum(r2.bab, (0, 1, 2), tmp35, (3, 0, 4, 2), (3, 1, 4))
    del tmp35
    r2new.bab += einsum(tmp36, (0, 1, 2, 3), r2.aaa, (4, 0, 2), (1, 4, 3)) * -2
    del tmp36
    r2new.bab += einsum(tmp37, (0, 1, 2, 3), r2.bab, (4, 1, 3), (4, 0, 2))
    del tmp37
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp38, (3, 1, 4, 0), (4, 3, 2))
    del tmp38
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp39, (2, 3), (0, 1, 3)) * -1
    del tmp39
    r2new.bab += einsum(tmp40, (0,), t2.abab, (1, 2, 0, 3), (2, 1, 3))
    del tmp40
    r2new.bab += einsum(r1.a, (0,), tmp41, (0, 1, 2, 3), (2, 1, 3))
    del tmp41
    r2new.bab += einsum(tmp1, (0, 1), r2.bab, (0, 2, 3), (1, 2, 3)) * -1
    r2new.bab += einsum(tmp0, (0, 1), r2.bab, (2, 0, 3), (2, 1, 3)) * -1
    r2new.bab += einsum(tmp42, (0, 1), r1.a, (2,), (0, 2, 1)) * -1
    del tmp42
    r2new.aba = einsum(tmp27, (0, 1, 2, 3), r2.aba, (1, 4, 3), (0, 4, 2))
    del tmp27
    r2new.aba += einsum(tmp28, (0, 1, 2, 3), r2.bbb, (4, 1, 3), (0, 4, 2)) * -2
    del tmp28
    r2new.aba += einsum(tmp29, (0, 1, 2, 3), r2.aba, (4, 1, 3), (4, 0, 2))
    del tmp29
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp30, (3, 0, 4, 1), (3, 4, 2))
    del tmp30
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp21, (2, 3), (0, 1, 3)) * -1
    r2new.aba += einsum(tmp33, (0,), t2.abab, (1, 2, 3, 0), (1, 2, 3)) * 2
    del tmp33
    r2new.aba += einsum(r1.b, (0,), tmp34, (1, 2, 0, 3), (1, 2, 3))
    del tmp34
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp1, (1, 3), (0, 3, 2)) * -1
    r2new.aba += einsum(tmp0, (0, 1), r2.aba, (0, 2, 3), (1, 2, 3)) * -1
    r2new.aba += einsum(tmp26, (0, 1), r1.b, (2,), (0, 2, 1)) * -1
    r2new.aaa = np.copy(tmp9)
    r2new.aaa += np.transpose(tmp9, (1, 0, 2)) * -1
    del tmp9
    r2new.aaa += tmp19 * -1
    r2new.aaa += np.transpose(tmp19, (1, 0, 2))
    del tmp19
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp20, (3, 4, 1, 0), (3, 4, 2)) * -2
    del tmp20
    r2new.aaa += einsum(tmp21, (0, 1), r2.aaa, (2, 3, 0), (2, 3, 1)) * -2
    del tmp21
    r2new.aaa += einsum(tmp24, (0,), t2.aaaa, (1, 2, 3, 0), (1, 2, 3)) * 4
    del tmp24
    r2new.aaa += einsum(r1.a, (0,), tmp25, (1, 2, 0, 3), (2, 1, 3)) * 2
    del tmp25
    r2new.aaa += einsum(tmp26, (0, 1), r1.a, (2,), (2, 0, 1))
    r2new.aaa += einsum(tmp26, (0, 1), r1.a, (2,), (0, 2, 1)) * -1
    del tmp26
    r1new.b = einsum(r2.aba, (0, 1, 2), f.aa.ov, (0, 2), (1,)) * -1
    r1new.b += einsum(r2.aba, (0, 1, 2), v.aabb.ovoo, (0, 2, 3, 1), (3,))
    r1new.b += einsum(r2.bbb, (0, 1, 2), f.bb.ov, (1, 2), (0,)) * 2
    r1new.b += einsum(v.bbbb.ooov, (0, 1, 2, 3), r2.bbb, (2, 1, 3), (0,)) * 2
    r1new.b += einsum(r1.b, (0,), tmp1, (0, 1), (1,)) * -1
    del tmp1
    r1new.a = einsum(v.aabb.ooov, (0, 1, 2, 3), r2.bab, (2, 1, 3), (0,))
    r1new.a += einsum(f.bb.ov, (0, 1), r2.bab, (0, 2, 1), (2,)) * -1
    r1new.a += einsum(r2.aaa, (0, 1, 2), v.aaaa.ooov, (3, 1, 0, 2), (3,)) * 2
    r1new.a += einsum(f.aa.ov, (0, 1), r2.aaa, (2, 0, 1), (2,)) * 2
    r1new.a += einsum(tmp0, (0, 1), r1.a, (0,), (1,)) * -1
    del tmp0

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_matvec_ea_intermediates(f=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:21:12.705101.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp10 : array
    tmp101 : array
    tmp102 : array
    tmp103 : array
    tmp105 : array
    tmp107 : array
    tmp108 : array
    tmp109 : array
    tmp110 : array
    tmp111 : array
    tmp115 : array
    tmp117 : array
    tmp119 : array
    tmp12 : array
    tmp121 : array
    tmp123 : array
    tmp125 : array
    tmp126 : array
    tmp127 : array
    tmp131 : array
    tmp133 : array
    tmp135 : array
    tmp14 : array
    tmp148 : array
    tmp15 : array
    tmp19 : array
    tmp21 : array
    tmp23 : array
    tmp27 : array
    tmp29 : array
    tmp3 : array
    tmp31 : array
    tmp33 : array
    tmp35 : array
    tmp37 : array
    tmp43 : array
    tmp44 : array
    tmp45 : array
    tmp5 : array
    tmp55 : array
    tmp56 : array
    tmp57 : array
    tmp59 : array
    tmp62 : array
    tmp65 : array
    tmp67 : array
    tmp78 : array
    tmp79 : array
    tmp80 : array
    tmp90 : array
    tmp93 : array
    tmp94 : array
    """

    tmp148 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 0, 5), (4, 2, 3, 5)) * -1
    tmp135 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (0, 4, 1, 5), (4, 5, 2, 3))
    tmp133 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (1, 4, 5, 3), (0, 2, 4, 5))
    tmp131 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (1, 3, 4, 5), (0, 2, 4, 5))
    tmp127 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 3, 1, 4), (2, 4))
    tmp126 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 0, 3), (4, 2)) * -1
    tmp125 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 5), (1, 4, 3, 5))
    tmp123 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp121 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp119 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp117 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 4, 1, 5))
    tmp115 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 1, 5), (0, 4, 3, 5))
    tmp111 = einsum(v.aabb.vvov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp110 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (4, 1, 2, 5))
    tmp109 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.abab, (0, 4, 1, 5), (4, 2, 3, 5))
    tmp108 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp107 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (0, 2), (1, 3))
    tmp105 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 3), (1, 4))
    tmp103 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp102 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovvv, (0, 2, 4, 3), (1, 4))
    tmp101 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (1, 3, 4, 2), (0, 4)) * -1
    tmp94 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 3, 4, 5), (2, 4, 1, 5))
    tmp93 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 5, 3), (1, 5, 2, 4))
    tmp90 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovvv, (0, 4, 5, 3), (1, 2, 4, 5))
    tmp80 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 5, 2, 3))
    tmp79 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.abab, (4, 0, 5, 3), (4, 5, 1, 2))
    tmp78 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.abab, (4, 0, 5, 1), (4, 5, 2, 3))
    tmp67 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp65 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp62 = einsum(v.aabb.vvov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 5), (4, 0, 5, 3))
    tmp59 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp57 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 1, 3), (4, 0))
    tmp56 = einsum(v.aabb.vvov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 3), (4, 0))
    tmp55 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 1, 3), (4, 2))
    tmp45 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp44 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    tmp43 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 3), (0, 4))
    tmp37 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 2, 5, 3))
    tmp35 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp33 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp31 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp29 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp27 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp23 = einsum(v.aabb.vvov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 5, 0, 1))
    tmp21 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 5, 1, 2))
    tmp19 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 5, 2, 3))
    tmp15 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp14 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp12 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 1, 4), (4, 3))
    tmp10 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 4, 1, 3), (2, 4))
    tmp5 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 1, 3), (2, 4))
    tmp3 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 4, 1), (4, 3)) * -1

    return {f"tmp10": tmp10, f"tmp101": tmp101, f"tmp102": tmp102, f"tmp103": tmp103, f"tmp105": tmp105, f"tmp107": tmp107, f"tmp108": tmp108, f"tmp109": tmp109, f"tmp110": tmp110, f"tmp111": tmp111, f"tmp115": tmp115, f"tmp117": tmp117, f"tmp119": tmp119, f"tmp12": tmp12, f"tmp121": tmp121, f"tmp123": tmp123, f"tmp125": tmp125, f"tmp126": tmp126, f"tmp127": tmp127, f"tmp131": tmp131, f"tmp133": tmp133, f"tmp135": tmp135, f"tmp14": tmp14, f"tmp148": tmp148, f"tmp15": tmp15, f"tmp19": tmp19, f"tmp21": tmp21, f"tmp23": tmp23, f"tmp27": tmp27, f"tmp29": tmp29, f"tmp3": tmp3, f"tmp31": tmp31, f"tmp33": tmp33, f"tmp35": tmp35, f"tmp37": tmp37, f"tmp43": tmp43, f"tmp44": tmp44, f"tmp45": tmp45, f"tmp5": tmp5, f"tmp55": tmp55, f"tmp56": tmp56, f"tmp57": tmp57, f"tmp59": tmp59, f"tmp62": tmp62, f"tmp65": tmp65, f"tmp67": tmp67, f"tmp78": tmp78, f"tmp79": tmp79, f"tmp80": tmp80, f"tmp90": tmp90, f"tmp93": tmp93, f"tmp94": tmp94}

def hbar_matvec_ea(f=None, r1=None, r2=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:21:12.778715.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp50 = np.copy(ints.tmp131)
    del ints.tmp131
    tmp50 += ints.tmp135 * 0.5
    del ints.tmp135
    tmp50 += v.bbbb.ovvv * 0.5
    tmp39 = np.copy(np.transpose(ints.tmp10, (1, 0)))
    tmp39 += np.transpose(ints.tmp12, (1, 0)) * 0.5
    tmp39 += f.bb.vv * -0.5
    tmp47 = np.copy(ints.tmp121) * 2
    tmp47 += ints.tmp125
    tmp56 = np.copy(ints.tmp117)
    tmp56 += ints.tmp123 * 2
    tmp4 = np.copy(ints.tmp29) * 2
    tmp4 += ints.tmp35
    tmp10 = np.copy(ints.tmp19)
    del ints.tmp19
    tmp10 += ints.tmp23 * 0.5
    del ints.tmp23
    tmp10 += v.aaaa.ovvv * 0.5
    tmp6 = np.copy(ints.tmp33) * 0.5
    tmp6 += ints.tmp37
    tmp8 = np.copy(np.transpose(ints.tmp3, (1, 0)))
    tmp8 += np.transpose(ints.tmp5, (1, 0)) * 0.5
    tmp8 += f.aa.vv * -0.5
    tmp31 = einsum(r2.aba, (0, 1, 2), v.aabb.ovov, (2, 0, 3, 1), (3,))
    tmp32 = einsum(v.bbbb.ovov, (0, 1, 2, 3), r2.bbb, (3, 1, 2), (0,)) * -1
    tmp30 = einsum(r1.b, (0,), f.bb.ov, (1, 0), (1,))
    tmp44 = einsum(r2.aba, (0, 1, 2), ints.tmp115, (2, 3, 0, 4), (3, 4, 1))
    tmp51 = einsum(r1.b, (0,), tmp50, (1, 2, 3, 0), (1, 2, 3)) * 2
    del tmp50
    tmp45 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.aba, (1, 4, 0), (2, 4, 3))
    tmp46 = einsum(r2.bbb, (0, 1, 2), v.bbbb.oovv, (3, 2, 4, 1), (3, 0, 4))
    tmp49 = einsum(tmp39, (0, 1), r2.bbb, (2, 0, 3), (3, 2, 1)) * -4
    tmp48 = einsum(r2.bbb, (0, 1, 2), tmp47, (3, 2, 4, 1), (3, 0, 4)) * -2
    del tmp47
    tmp55 = einsum(r2.bbb, (0, 1, 2), v.bbbb.ovov, (3, 4, 2, 1), (3, 0, 4))
    tmp54 = einsum(ints.tmp119, (0, 1, 2, 3), r2.bbb, (4, 3, 1), (0, 2, 4))
    tmp53 = einsum(r1.b, (0,), ints.tmp133, (1, 2, 0, 3), (1, 2, 3))
    del ints.tmp133
    tmp57 = einsum(tmp56, (0, 1, 2, 3), r2.aba, (2, 4, 0), (1, 4, 3))
    del tmp56
    tmp19 = einsum(f.aa.ov, (0, 1), r1.a, (1,), (0,))
    tmp21 = einsum(r2.bab, (0, 1, 2), v.aabb.ovov, (3, 1, 2, 0), (3,)) * -1
    tmp20 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r2.aaa, (1, 3, 2), (0,))
    tmp5 = einsum(tmp4, (0, 1, 2, 3), r2.aaa, (4, 3, 1), (0, 4, 2)) * -2
    del tmp4
    tmp3 = einsum(r2.aaa, (0, 1, 2), v.aaaa.oovv, (3, 2, 4, 1), (3, 0, 4))
    tmp11 = einsum(tmp10, (0, 1, 2, 3), r1.a, (3,), (0, 1, 2)) * 2
    del tmp10
    tmp7 = einsum(r2.bab, (0, 1, 2), tmp6, (3, 2, 4, 0), (3, 1, 4)) * -2
    del tmp6
    tmp9 = einsum(tmp8, (0, 1), r2.aaa, (2, 0, 3), (3, 2, 1)) * -4
    del tmp8
    tmp13 = einsum(ints.tmp21, (0, 1, 2, 3), r1.a, (2,), (0, 1, 3))
    del ints.tmp21
    tmp15 = einsum(r2.aaa, (0, 1, 2), v.aaaa.ovov, (3, 4, 2, 1), (3, 0, 4))
    tmp17 = einsum(r2.bab, (0, 1, 2), v.aabb.ovov, (3, 4, 2, 0), (3, 1, 4)) * -1
    tmp16 = einsum(ints.tmp31, (0, 1, 2, 3), r2.bab, (3, 4, 1), (0, 2, 4)) * -1
    tmp14 = einsum(r2.aaa, (0, 1, 2), ints.tmp27, (3, 2, 4, 1), (3, 4, 0))
    tmp41 = np.copy(f.bb.oo)
    tmp41 += np.transpose(ints.tmp103, (1, 0)) * 2
    del ints.tmp103
    tmp41 += np.transpose(ints.tmp105, (1, 0))
    del ints.tmp105
    tmp59 = np.copy(tmp30) * 0.5
    tmp59 += tmp31 * -0.5
    tmp59 += tmp32
    tmp52 = np.copy(tmp44)
    del tmp44
    tmp52 += tmp45
    del tmp45
    tmp52 += tmp46 * 2
    del tmp46
    tmp52 += np.transpose(tmp48, (0, 2, 1)) * -1
    del tmp48
    tmp52 += np.transpose(tmp49, (0, 2, 1))
    del tmp49
    tmp52 += tmp51
    del tmp51
    tmp58 = np.copy(tmp53) * 2
    del tmp53
    tmp58 += tmp54 * 4
    del tmp54
    tmp58 += tmp55 * 2
    del tmp55
    tmp58 += np.transpose(tmp57, (0, 2, 1))
    del tmp57
    tmp43 = einsum(r2.bbb, (0, 1, 2), v.bbbb.ovov, (3, 0, 4, 1), (2, 3, 4))
    tmp42 = np.copy(f.bb.ov)
    tmp42 += ints.tmp102
    del ints.tmp102
    tmp42 += ints.tmp107
    del ints.tmp107
    tmp42 += ints.tmp108 * 2
    del ints.tmp108
    tmp42 += ints.tmp101 * -2
    del ints.tmp101
    tmp42 += ints.tmp126 * -2
    del ints.tmp126
    tmp42 += ints.tmp127 * -1
    del ints.tmp127
    tmp34 = einsum(r2.bab, (0, 1, 2), v.aabb.ovov, (3, 1, 4, 0), (3, 2, 4)) * -1
    tmp36 = np.copy(ints.tmp117)
    del ints.tmp117
    tmp36 += ints.tmp123 * 2
    del ints.tmp123
    tmp36 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp36 += ints.tmp115 * -1
    del ints.tmp115
    tmp40 = np.copy(tmp19)
    tmp40 += tmp20 * 2
    tmp40 += tmp21
    tmp37 = np.copy(ints.tmp93)
    del ints.tmp93
    tmp37 += np.transpose(v.aabb.vvoo, (2, 3, 0, 1)) * -1
    tmp38 = np.copy(ints.tmp109)
    del ints.tmp109
    tmp38 += ints.tmp111 * 2
    del ints.tmp111
    tmp38 += ints.tmp94
    del ints.tmp94
    tmp38 += np.transpose(v.aabb.vvov, (2, 0, 1, 3))
    tmp38 += np.transpose(ints.tmp110, (0, 2, 1, 3)) * -1
    del ints.tmp110
    tmp38 += ints.tmp90 * -1
    del ints.tmp90
    tmp0 = np.copy(np.transpose(ints.tmp3, (1, 0))) * 2
    del ints.tmp3
    tmp0 += np.transpose(ints.tmp5, (1, 0))
    del ints.tmp5
    tmp0 += f.aa.vv * -1
    tmp35 = np.copy(ints.tmp121) * 2
    del ints.tmp121
    tmp35 += ints.tmp125
    del ints.tmp125
    tmp35 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    tmp35 += ints.tmp119 * -2
    del ints.tmp119
    tmp35 += v.bbbb.oovv * -1
    tmp24 = np.copy(f.aa.ov)
    tmp24 += ints.tmp14 * 2
    del ints.tmp14
    tmp24 += ints.tmp15
    del ints.tmp15
    tmp24 += ints.tmp56
    del ints.tmp56
    tmp24 += ints.tmp43 * -2
    del ints.tmp43
    tmp24 += ints.tmp44 * -1
    del ints.tmp44
    tmp24 += ints.tmp55 * -2
    del ints.tmp55
    tmp28 = np.copy(ints.tmp65)
    del ints.tmp65
    tmp28 += v.aabb.oovv * -1
    tmp27 = np.copy(ints.tmp33)
    del ints.tmp33
    tmp27 += ints.tmp37 * 2
    del ints.tmp37
    tmp27 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp27 += ints.tmp31 * -1
    del ints.tmp31
    tmp33 = np.copy(tmp30)
    del tmp30
    tmp33 += tmp31 * -1
    del tmp31
    tmp33 += tmp32 * 2
    del tmp32
    tmp26 = np.copy(ints.tmp29) * 2
    del ints.tmp29
    tmp26 += ints.tmp35
    del ints.tmp35
    tmp26 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp26 += ints.tmp27 * -2
    del ints.tmp27
    tmp26 += v.aaaa.oovv * -1
    tmp1 = np.copy(np.transpose(ints.tmp10, (1, 0))) * 2
    del ints.tmp10
    tmp1 += np.transpose(ints.tmp12, (1, 0))
    del ints.tmp12
    tmp1 += f.bb.vv * -1
    tmp25 = einsum(r2.aba, (0, 1, 2), v.aabb.ovov, (3, 0, 4, 1), (2, 3, 4))
    tmp29 = np.copy(ints.tmp67)
    del ints.tmp67
    tmp29 += ints.tmp78
    del ints.tmp78
    tmp29 += ints.tmp80 * 2
    del ints.tmp80
    tmp29 += v.aabb.ovvv
    tmp29 += ints.tmp62 * -1
    del ints.tmp62
    tmp29 += np.transpose(ints.tmp79, (0, 1, 3, 2)) * -1
    del ints.tmp79
    tmp23 = np.copy(f.aa.oo)
    tmp23 += np.transpose(ints.tmp57, (1, 0)) * 2
    del ints.tmp57
    tmp23 += np.transpose(ints.tmp59, (1, 0))
    del ints.tmp59
    tmp22 = np.copy(tmp19) * 0.5
    del tmp19
    tmp22 += tmp20
    del tmp20
    tmp22 += tmp21 * 0.5
    del tmp21
    tmp2 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r2.aaa, (1, 3, 4), (4, 0, 2))
    tmp12 = np.copy(tmp3) * 2
    del tmp3
    tmp12 += np.transpose(tmp5, (0, 2, 1)) * -1
    del tmp5
    tmp12 += np.transpose(tmp7, (0, 2, 1))
    del tmp7
    tmp12 += np.transpose(tmp9, (0, 2, 1))
    del tmp9
    tmp12 += tmp11
    del tmp11
    tmp18 = np.copy(tmp13) * 2
    del tmp13
    tmp18 += tmp14 * 4
    del tmp14
    tmp18 += tmp15 * 2
    del tmp15
    tmp18 += tmp16
    del tmp16
    tmp18 += tmp17
    del tmp17
    r2new.bbb = einsum(r2.bbb, (0, 1, 2), v.bbbb.vvvv, (3, 1, 4, 0), (3, 4, 2)) * -2
    r2new.bbb += einsum(tmp43, (0, 1, 2), t2.bbbb, (2, 1, 3, 4), (3, 4, 0)) * -2
    del tmp43
    r2new.bbb += einsum(r1.b, (0,), ints.tmp148, (1, 2, 3, 0), (3, 2, 1)) * 2
    del ints.tmp148
    r2new.bbb += np.transpose(tmp52, (1, 2, 0)) * -1
    r2new.bbb += np.transpose(tmp52, (2, 1, 0))
    del tmp52
    r2new.bbb += np.transpose(tmp58, (1, 2, 0))
    r2new.bbb += np.transpose(tmp58, (2, 1, 0)) * -1
    del tmp58
    r2new.bbb += einsum(tmp59, (0,), t2.bbbb, (1, 0, 2, 3), (2, 3, 1)) * 4
    del tmp59
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp41, (2, 3), (0, 1, 3)) * -2
    r2new.bbb += einsum(tmp42, (0, 1), r1.b, (2,), (2, 1, 0))
    r2new.bbb += einsum(r1.b, (0,), tmp42, (1, 2), (2, 0, 1)) * -1
    r2new.bab = einsum(r2.bab, (0, 1, 2), v.aabb.vvvv, (3, 1, 4, 0), (4, 3, 2))
    r2new.bab += einsum(t2.abab, (0, 1, 2, 3), tmp34, (0, 4, 1), (3, 2, 4)) * -1
    del tmp34
    r2new.bab += einsum(tmp35, (0, 1, 2, 3), r2.bab, (3, 4, 1), (2, 4, 0))
    del tmp35
    r2new.bab += einsum(r2.aaa, (0, 1, 2), tmp36, (2, 3, 1, 4), (4, 0, 3)) * -2
    del tmp36
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp37, (3, 2, 4, 1), (0, 4, 3))
    del tmp37
    r2new.bab += einsum(tmp38, (0, 1, 2, 3), r1.a, (2,), (3, 1, 0)) * -1
    del tmp38
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp0, (1, 3), (0, 3, 2)) * -1
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp39, (0, 3), (3, 1, 2)) * -2
    del tmp39
    r2new.bab += einsum(t2.abab, (0, 1, 2, 3), tmp40, (0,), (3, 2, 1))
    del tmp40
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp41, (2, 3), (0, 1, 3)) * -1
    del tmp41
    r2new.bab += einsum(tmp42, (0, 1), r1.a, (2,), (1, 2, 0)) * -1
    del tmp42
    r2new.aba = einsum(r2.aba, (0, 1, 2), v.aabb.vvvv, (3, 0, 4, 1), (3, 4, 2))
    r2new.aba += einsum(tmp25, (0, 1, 2), t2.abab, (1, 2, 3, 4), (3, 4, 0))
    del tmp25
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp26, (3, 2, 4, 0), (4, 1, 3))
    del tmp26
    r2new.aba += einsum(r2.bbb, (0, 1, 2), tmp27, (3, 2, 4, 1), (4, 0, 3)) * -2
    del tmp27
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp28, (3, 2, 4, 1), (0, 4, 3))
    del tmp28
    r2new.aba += einsum(r1.b, (0,), tmp29, (1, 2, 3, 0), (2, 3, 1)) * -1
    del tmp29
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp1, (1, 3), (0, 3, 2)) * -1
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp0, (0, 3), (3, 1, 2)) * -1
    r2new.aba += einsum(tmp33, (0,), t2.abab, (1, 0, 2, 3), (2, 3, 1))
    del tmp33
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp23, (2, 3), (0, 1, 3)) * -1
    r2new.aba += einsum(tmp24, (0, 1), r1.b, (2,), (1, 2, 0)) * -1
    r2new.aaa = einsum(ints.tmp45, (0, 1, 2, 3), r1.a, (3,), (2, 1, 0)) * 2
    del ints.tmp45
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), v.aaaa.vvvv, (3, 1, 4, 0), (3, 4, 2)) * -2
    r2new.aaa += einsum(tmp2, (0, 1, 2), t2.aaaa, (2, 1, 3, 4), (3, 4, 0)) * -2
    del tmp2
    r2new.aaa += np.transpose(tmp12, (1, 2, 0)) * -1
    r2new.aaa += np.transpose(tmp12, (2, 1, 0))
    del tmp12
    r2new.aaa += np.transpose(tmp18, (1, 2, 0))
    r2new.aaa += np.transpose(tmp18, (2, 1, 0)) * -1
    del tmp18
    r2new.aaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp22, (1,), (2, 3, 0)) * 4
    del tmp22
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp23, (2, 3), (0, 1, 3)) * -2
    del tmp23
    r2new.aaa += einsum(tmp24, (0, 1), r1.a, (2,), (2, 1, 0))
    r2new.aaa += einsum(tmp24, (0, 1), r1.a, (2,), (1, 2, 0)) * -1
    del tmp24
    r1new.b = einsum(f.aa.ov, (0, 1), r2.aba, (1, 2, 0), (2,)) * -1
    r1new.b += einsum(f.bb.ov, (0, 1), r2.bbb, (2, 1, 0), (2,)) * 2
    r1new.b += einsum(r2.aba, (0, 1, 2), v.aabb.ovvv, (2, 0, 3, 1), (3,)) * -1
    r1new.b += einsum(r2.bbb, (0, 1, 2), v.bbbb.ovvv, (2, 0, 3, 1), (3,)) * -2
    r1new.b += einsum(r1.b, (0,), tmp1, (0, 1), (1,)) * -1
    del tmp1
    r1new.a = einsum(r2.aaa, (0, 1, 2), v.aaaa.ovvv, (2, 1, 3, 0), (3,)) * 2
    r1new.a += einsum(r2.bab, (0, 1, 2), f.bb.ov, (2, 0), (1,)) * -1
    r1new.a += einsum(f.aa.ov, (0, 1), r2.aaa, (2, 1, 0), (2,)) * 2
    r1new.a += einsum(r2.bab, (0, 1, 2), v.aabb.vvov, (3, 1, 2, 0), (3,)) * -1
    r1new.a += einsum(r1.a, (0,), tmp0, (0, 1), (1,)) * -1
    del tmp0

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ip_intermediates(f=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:22:07.852007.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp10 : array
    tmp110 : array
    tmp113 : array
    tmp115 : array
    tmp132 : array
    tmp136 : array
    tmp138 : array
    tmp14 : array
    tmp140 : array
    tmp142 : array
    tmp144 : array
    tmp146 : array
    tmp148 : array
    tmp157 : array
    tmp159 : array
    tmp16 : array
    tmp161 : array
    tmp178 : array
    tmp18 : array
    tmp20 : array
    tmp22 : array
    tmp24 : array
    tmp26 : array
    tmp28 : array
    tmp29 : array
    tmp3 : array
    tmp31 : array
    tmp32 : array
    tmp33 : array
    tmp35 : array
    tmp37 : array
    tmp39 : array
    tmp4 : array
    tmp41 : array
    tmp43 : array
    tmp45 : array
    tmp47 : array
    tmp53 : array
    tmp55 : array
    tmp59 : array
    tmp6 : array
    tmp61 : array
    tmp67 : array
    tmp68 : array
    tmp70 : array
    tmp71 : array
    tmp73 : array
    tmp74 : array
    tmp76 : array
    tmp8 : array
    tmp82 : array
    tmp84 : array
    tmp89 : array
    tmp91 : array
    tmp93 : array
    tmp95 : array
    tmp97 : array
    tmp99 : array
    """

    tmp178 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp161 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp159 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 1, 4), (4, 3))
    tmp157 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (0, 2, 4, 1), (4, 3)) * -1
    tmp148 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 5), (1, 4, 3, 5))
    tmp146 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovov, (1, 3, 4, 5), (0, 4, 2, 5))
    tmp144 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp142 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp140 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp138 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp136 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 5, 3), (1, 5, 2, 4))
    tmp132 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp115 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 1, 3), (2, 4))
    tmp113 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 4, 3), (4, 1))
    tmp110 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 5, 3, 1), (4, 5, 0, 2)) * -1
    tmp99 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp97 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp95 = einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 0, 2), (4, 1, 5, 3))
    tmp93 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp91 = einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 0, 5), (4, 1, 5, 3))
    tmp89 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp84 = einsum(v.aabb.vvov, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 5, 2, 0))
    tmp82 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    tmp76 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovoo, (0, 2, 4, 5), (1, 4, 5, 3))
    tmp74 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 2, 3, 5))
    tmp73 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp71 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp70 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp68 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp67 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp61 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 3), (1, 4))
    tmp59 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp55 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.ov, (4, 3), (4, 0, 1, 2))
    tmp53 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (4, 3), (0, 4, 1, 2))
    tmp47 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp45 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 5, 3, 1), (4, 5, 0, 2)) * -1
    tmp43 = einsum(v.aabb.vvov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 3), (4, 0))
    tmp41 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp39 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (1, 3, 4, 2), (0, 4)) * -1
    tmp37 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 3, 1), (4, 2)) * -1
    tmp35 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp33 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp32 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (4, 3, 1, 5), (4, 0, 2, 5))
    tmp31 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 1, 4, 5))
    tmp29 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp28 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.abab, (1, 4, 3, 5), (0, 2, 4, 5))
    tmp26 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp24 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    tmp22 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovoo, (0, 2, 4, 1), (4, 3))
    tmp20 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 0, 3), (4, 2)) * -1
    tmp18 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 0, 1, 3), (4, 2))
    tmp16 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp14 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 1, 3), (0, 4))
    tmp10 = einsum(f.aa.ov, (0, 1), t2.abab, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp8 = einsum(t2.aaaa, (0, 1, 2, 3), f.aa.ov, (4, 3), (4, 0, 1, 2))
    tmp6 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp4 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp3 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (0, 2), (1, 3))
    tmp1 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))

    return {f"tmp1": tmp1, f"tmp10": tmp10, f"tmp110": tmp110, f"tmp113": tmp113, f"tmp115": tmp115, f"tmp132": tmp132, f"tmp136": tmp136, f"tmp138": tmp138, f"tmp14": tmp14, f"tmp140": tmp140, f"tmp142": tmp142, f"tmp144": tmp144, f"tmp146": tmp146, f"tmp148": tmp148, f"tmp157": tmp157, f"tmp159": tmp159, f"tmp16": tmp16, f"tmp161": tmp161, f"tmp178": tmp178, f"tmp18": tmp18, f"tmp20": tmp20, f"tmp22": tmp22, f"tmp24": tmp24, f"tmp26": tmp26, f"tmp28": tmp28, f"tmp29": tmp29, f"tmp3": tmp3, f"tmp31": tmp31, f"tmp32": tmp32, f"tmp33": tmp33, f"tmp35": tmp35, f"tmp37": tmp37, f"tmp39": tmp39, f"tmp4": tmp4, f"tmp41": tmp41, f"tmp43": tmp43, f"tmp45": tmp45, f"tmp47": tmp47, f"tmp53": tmp53, f"tmp55": tmp55, f"tmp59": tmp59, f"tmp6": tmp6, f"tmp61": tmp61, f"tmp67": tmp67, f"tmp68": tmp68, f"tmp70": tmp70, f"tmp71": tmp71, f"tmp73": tmp73, f"tmp74": tmp74, f"tmp76": tmp76, f"tmp8": tmp8, f"tmp82": tmp82, f"tmp84": tmp84, f"tmp89": tmp89, f"tmp91": tmp91, f"tmp93": tmp93, f"tmp95": tmp95, f"tmp97": tmp97, f"tmp99": tmp99}

def hbar_lmatvec_ip(f=None, r1=None, r2=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:22:07.929124.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp35 = einsum(r2.aba, (0, 1, 2), t2.abab, (0, 1, 2, 3), (3,))
    tmp36 = einsum(r2.bbb, (0, 1, 2), t2.bbbb, (0, 1, 3, 2), (3,))
    tmp57 = np.copy(ints.tmp142)
    tmp57 += ints.tmp146 * 2
    tmp51 = np.copy(ints.tmp59) * 2
    tmp51 += ints.tmp61
    tmp48 = np.copy(ints.tmp144)
    tmp48 += ints.tmp148 * 0.5
    tmp37 = np.copy(tmp35) * -0.5
    del tmp35
    tmp37 += tmp36
    del tmp36
    tmp26 = einsum(t2.abab, (0, 1, 2, 3), r2.bab, (1, 0, 3), (2,)) * -1
    tmp12 = einsum(r2.aaa, (0, 1, 2), t2.aaaa, (0, 1, 3, 2), (3,))
    tmp14 = np.copy(ints.tmp93)
    tmp14 += ints.tmp97 * 0.5
    tmp16 = np.copy(ints.tmp95)
    tmp16 += ints.tmp99 * 2
    tmp18 = np.copy(ints.tmp14) * 2
    tmp18 += ints.tmp16
    tmp55 = einsum(ints.tmp140, (0, 1, 2, 3), r2.bbb, (4, 0, 2), (1, 4, 3))
    tmp54 = einsum(r2.bbb, (0, 1, 2), f.bb.oo, (3, 1), (3, 0, 2))
    tmp56 = einsum(r2.bbb, (0, 1, 2), v.bbbb.ovov, (3, 4, 1, 2), (0, 3, 4))
    tmp58 = einsum(r2.aba, (0, 1, 2), tmp57, (0, 3, 2, 4), (1, 3, 4))
    del tmp57
    tmp44 = einsum(r1.b, (0,), v.bbbb.ooov, (1, 0, 2, 3), (1, 2, 3))
    tmp52 = einsum(tmp51, (0, 1), r2.bbb, (2, 0, 3), (2, 1, 3)) * -2
    del tmp51
    tmp45 = einsum(r2.aba, (0, 1, 2), ints.tmp138, (0, 3, 2, 4), (3, 1, 4))
    tmp49 = einsum(r2.bbb, (0, 1, 2), tmp48, (1, 3, 2, 4), (0, 3, 4)) * -4
    del tmp48
    tmp46 = einsum(r2.aba, (0, 1, 2), v.aabb.ovov, (0, 2, 3, 4), (1, 3, 4))
    tmp47 = einsum(r2.bbb, (0, 1, 2), v.bbbb.oovv, (3, 1, 4, 2), (0, 3, 4))
    tmp50 = einsum(tmp37, (0,), v.bbbb.ovov, (1, 0, 2, 3), (1, 2, 3)) * 2
    tmp21 = einsum(f.aa.oo, (0, 1), r2.aaa, (2, 1, 3), (0, 2, 3))
    tmp22 = einsum(r2.aaa, (0, 1, 2), ints.tmp89, (1, 3, 2, 4), (3, 0, 4))
    tmp27 = einsum(tmp26, (0,), v.aaaa.ovov, (1, 2, 3, 0), (1, 3, 2))
    tmp25 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.bab, (2, 4, 3), (4, 0, 1)) * -1
    tmp24 = einsum(ints.tmp91, (0, 1, 2, 3), r2.bab, (1, 4, 3), (0, 4, 2)) * -1
    tmp23 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r2.aaa, (4, 2, 3), (4, 0, 1))
    tmp13 = einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp12, (3,), (0, 2, 1)) * -1
    tmp10 = einsum(v.aaaa.ooov, (0, 1, 2, 3), r1.a, (1,), (0, 2, 3))
    tmp15 = einsum(r2.aaa, (0, 1, 2), tmp14, (1, 3, 2, 4), (0, 3, 4)) * -4
    del tmp14
    tmp17 = einsum(tmp16, (0, 1, 2, 3), r2.bab, (1, 4, 3), (4, 0, 2)) * -1
    del tmp16
    tmp11 = einsum(v.aaaa.oovv, (0, 1, 2, 3), r2.aaa, (4, 1, 3), (4, 0, 2))
    tmp19 = einsum(tmp18, (0, 1), r2.aaa, (2, 0, 3), (2, 1, 3)) * -2
    del tmp18
    tmp59 = np.copy(tmp54) * 2
    del tmp54
    tmp59 += tmp55 * 4
    del tmp55
    tmp59 += tmp56 * 2
    del tmp56
    tmp59 += np.transpose(tmp58, (1, 0, 2))
    del tmp58
    tmp53 = einsum(r1.b, (0,), f.bb.ov, (1, 2), (1, 0, 2))
    tmp53 += tmp44
    del tmp44
    tmp53 += tmp45
    del tmp45
    tmp53 += tmp46
    del tmp46
    tmp53 += tmp47 * 2
    del tmp47
    tmp53 += np.transpose(tmp49, (1, 0, 2)) * -1
    del tmp49
    tmp53 += np.transpose(tmp50, (1, 0, 2)) * -1
    del tmp50
    tmp53 += np.transpose(tmp52, (1, 0, 2))
    del tmp52
    tmp42 = np.copy(ints.tmp157) * 2
    del ints.tmp157
    tmp42 += ints.tmp159
    del ints.tmp159
    tmp42 += f.bb.vv * -1
    tmp60 = np.copy(ints.tmp178)
    del ints.tmp178
    tmp60 += np.transpose(v.bbbb.oooo, (0, 2, 1, 3))
    tmp40 = np.copy(ints.tmp161)
    del ints.tmp161
    tmp40 += v.aabb.oovv * -1
    tmp41 = np.copy(ints.tmp132)
    tmp41 += v.aabb.oooo
    tmp4 = np.copy(f.aa.oo)
    tmp4 += ints.tmp14 * 2
    del ints.tmp14
    tmp4 += ints.tmp16
    del ints.tmp16
    tmp38 = np.copy(ints.tmp144) * 2
    del ints.tmp144
    tmp38 += ints.tmp148
    del ints.tmp148
    tmp38 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    tmp38 += ints.tmp140 * -2
    del ints.tmp140
    tmp38 += v.bbbb.oovv * -1
    tmp43 = np.copy(tmp12) * 2
    del tmp12
    tmp43 += tmp26
    del tmp26
    tmp9 = np.copy(f.bb.oo)
    tmp9 += ints.tmp59 * 2
    del ints.tmp59
    tmp9 += ints.tmp61
    del ints.tmp61
    tmp39 = np.copy(ints.tmp142)
    del ints.tmp142
    tmp39 += ints.tmp146 * 2
    del ints.tmp146
    tmp39 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp39 += ints.tmp138 * -1
    del ints.tmp138
    tmp32 = np.copy(ints.tmp95)
    del ints.tmp95
    tmp32 += ints.tmp99 * 2
    del ints.tmp99
    tmp32 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp32 += ints.tmp91 * -1
    del ints.tmp91
    tmp34 = np.copy(ints.tmp132)
    del ints.tmp132
    tmp34 += v.aabb.oooo
    tmp31 = np.copy(ints.tmp93) * 2
    del ints.tmp93
    tmp31 += ints.tmp97
    del ints.tmp97
    tmp31 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp31 += ints.tmp89 * -2
    del ints.tmp89
    tmp31 += v.aaaa.oovv * -1
    tmp33 = np.copy(ints.tmp136)
    del ints.tmp136
    tmp33 += np.transpose(v.aabb.vvoo, (2, 3, 0, 1)) * -1
    tmp30 = np.copy(ints.tmp113) * 2
    del ints.tmp113
    tmp30 += ints.tmp115
    del ints.tmp115
    tmp30 += f.aa.vv * -1
    tmp28 = np.copy(tmp21) * 2
    del tmp21
    tmp28 += tmp22 * 4
    del tmp22
    tmp28 += tmp23 * 2
    del tmp23
    tmp28 += tmp24
    del tmp24
    tmp28 += tmp25
    del tmp25
    tmp28 += tmp27
    del tmp27
    tmp20 = einsum(f.aa.ov, (0, 1), r1.a, (2,), (0, 2, 1))
    tmp20 += tmp10
    del tmp10
    tmp20 += tmp11 * 2
    del tmp11
    tmp20 += tmp13 * 2
    del tmp13
    tmp20 += np.transpose(tmp15, (1, 0, 2)) * -1
    del tmp15
    tmp20 += np.transpose(tmp17, (1, 0, 2))
    del tmp17
    tmp20 += np.transpose(tmp19, (1, 0, 2))
    del tmp19
    tmp29 = np.copy(ints.tmp110)
    del ints.tmp110
    tmp29 += np.transpose(v.aaaa.oooo, (0, 2, 3, 1)) * -1
    tmp5 = np.copy(ints.tmp53)
    del ints.tmp53
    tmp5 += ints.tmp70
    del ints.tmp70
    tmp5 += ints.tmp74 * 2
    del ints.tmp74
    tmp5 += np.transpose(ints.tmp84, (0, 2, 1, 3))
    del ints.tmp84
    tmp5 += np.transpose(v.aabb.ovoo, (0, 2, 3, 1))
    tmp5 += np.transpose(ints.tmp67, (0, 2, 1, 3)) * -1
    del ints.tmp67
    tmp5 += np.transpose(ints.tmp73, (0, 2, 1, 3)) * -1
    del ints.tmp73
    tmp6 = np.copy(ints.tmp55)
    del ints.tmp55
    tmp6 += np.transpose(ints.tmp71, (1, 0, 2, 3)) * 2
    del ints.tmp71
    tmp6 += np.transpose(ints.tmp76, (1, 0, 2, 3))
    del ints.tmp76
    tmp6 += np.transpose(ints.tmp68, (2, 0, 1, 3)) * -2
    del ints.tmp68
    tmp6 += np.transpose(ints.tmp82, (2, 0, 1, 3)) * -1
    del ints.tmp82
    tmp6 += v.bbbb.ooov * -1
    tmp7 = np.copy(f.aa.ov) * 0.5
    tmp7 += ints.tmp1
    tmp7 += ints.tmp43 * 0.5
    tmp7 += ints.tmp4 * 0.5
    tmp7 += ints.tmp18 * -1
    tmp7 += ints.tmp24 * -0.5
    tmp7 += ints.tmp37 * -1
    tmp8 = np.copy(f.bb.ov)
    tmp8 += ints.tmp3
    tmp8 += ints.tmp41
    tmp8 += ints.tmp6 * 2
    tmp8 += ints.tmp20 * -2
    tmp8 += ints.tmp22 * -1
    tmp8 += ints.tmp39 * -2
    tmp3 = np.copy(f.aa.ov)
    tmp3 += ints.tmp1 * 2
    del ints.tmp1
    tmp3 += ints.tmp43
    del ints.tmp43
    tmp3 += ints.tmp4
    del ints.tmp4
    tmp3 += ints.tmp18 * -2
    del ints.tmp18
    tmp3 += ints.tmp24 * -1
    del ints.tmp24
    tmp3 += ints.tmp37 * -2
    del ints.tmp37
    tmp2 = np.copy(f.bb.ov) * 0.5
    tmp2 += ints.tmp3 * 0.5
    del ints.tmp3
    tmp2 += ints.tmp41 * 0.5
    del ints.tmp41
    tmp2 += ints.tmp6
    del ints.tmp6
    tmp2 += ints.tmp20 * -1
    del ints.tmp20
    tmp2 += ints.tmp22 * -0.5
    del ints.tmp22
    tmp2 += ints.tmp39 * -1
    del ints.tmp39
    tmp1 = np.copy(ints.tmp26) * 2
    del ints.tmp26
    tmp1 += ints.tmp45
    del ints.tmp45
    tmp1 += np.transpose(v.aaaa.ooov, (0, 2, 1, 3))
    tmp1 += np.transpose(ints.tmp29, (0, 2, 1, 3)) * -2
    del ints.tmp29
    tmp1 += np.transpose(ints.tmp33, (0, 2, 1, 3)) * -1
    del ints.tmp33
    tmp1 += np.transpose(ints.tmp8, (1, 2, 0, 3)) * -1
    del ints.tmp8
    tmp0 = np.copy(ints.tmp10)
    del ints.tmp10
    tmp0 += ints.tmp31
    del ints.tmp31
    tmp0 += ints.tmp35 * 2
    del ints.tmp35
    tmp0 += np.transpose(ints.tmp47, (1, 0, 2, 3))
    del ints.tmp47
    tmp0 += v.aabb.ooov
    tmp0 += np.transpose(ints.tmp28, (1, 0, 2, 3)) * -1
    del ints.tmp28
    tmp0 += np.transpose(ints.tmp32, (1, 0, 2, 3)) * -1
    del ints.tmp32
    r2new.bbb = np.copy(tmp53) * -1
    r2new.bbb += np.transpose(tmp53, (1, 0, 2))
    del tmp53
    r2new.bbb += tmp59
    r2new.bbb += np.transpose(tmp59, (1, 0, 2)) * -1
    del tmp59
    r2new.bbb += einsum(tmp60, (0, 1, 2, 3), r2.bbb, (1, 0, 4), (2, 3, 4)) * -2
    del tmp60
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp42, (2, 3), (0, 1, 3)) * -2
    r2new.bab = einsum(r1.a, (0,), f.bb.ov, (1, 2), (1, 0, 2)) * -1
    r2new.bab += einsum(v.aabb.ooov, (0, 1, 2, 3), r1.a, (1,), (2, 0, 3))
    r2new.bab += einsum(tmp38, (0, 1, 2, 3), r2.bab, (0, 4, 2), (1, 4, 3))
    del tmp38
    r2new.bab += einsum(r2.aaa, (0, 1, 2), tmp39, (1, 3, 2, 4), (3, 0, 4)) * -2
    del tmp39
    r2new.bab += einsum(tmp40, (0, 1, 2, 3), r2.bab, (4, 0, 2), (4, 1, 3))
    del tmp40
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp41, (1, 3, 0, 4), (4, 3, 2))
    del tmp41
    r2new.bab += einsum(tmp42, (0, 1), r2.bab, (2, 3, 0), (2, 3, 1)) * -1
    del tmp42
    r2new.bab += einsum(tmp43, (0,), v.aabb.ovov, (1, 0, 2, 3), (2, 1, 3))
    del tmp43
    r2new.bab += einsum(tmp9, (0, 1), r2.bab, (0, 2, 3), (1, 2, 3)) * -1
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp4, (1, 3), (0, 3, 2)) * -1
    r2new.aba = einsum(r1.b, (0,), v.aabb.ovoo, (1, 2, 3, 0), (1, 3, 2))
    r2new.aba += einsum(f.aa.ov, (0, 1), r1.b, (2,), (0, 2, 1)) * -1
    r2new.aba += einsum(tmp31, (0, 1, 2, 3), r2.aba, (0, 4, 2), (1, 4, 3))
    del tmp31
    r2new.aba += einsum(tmp32, (0, 1, 2, 3), r2.bbb, (4, 1, 3), (0, 4, 2)) * -2
    del tmp32
    r2new.aba += einsum(tmp33, (0, 1, 2, 3), r2.aba, (4, 0, 2), (4, 1, 3))
    del tmp33
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp34, (0, 3, 1, 4), (3, 4, 2))
    del tmp34
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp30, (2, 3), (0, 1, 3)) * -1
    r2new.aba += einsum(tmp37, (0,), v.aabb.ovov, (1, 2, 3, 0), (1, 3, 2)) * 2
    del tmp37
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp9, (1, 3), (0, 3, 2)) * -1
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp4, (0, 3), (3, 1, 2)) * -1
    r2new.aaa = np.copy(tmp20) * -1
    r2new.aaa += np.transpose(tmp20, (1, 0, 2))
    del tmp20
    r2new.aaa += tmp28
    r2new.aaa += np.transpose(tmp28, (1, 0, 2)) * -1
    del tmp28
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp29, (1, 0, 3, 4), (3, 4, 2)) * -2
    del tmp29
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp30, (2, 3), (0, 1, 3)) * -2
    del tmp30
    r1new.b = einsum(r2.aba, (0, 1, 2), tmp5, (0, 3, 1, 2), (3,))
    del tmp5
    r1new.b += einsum(r2.bbb, (0, 1, 2), tmp6, (3, 0, 1, 2), (3,)) * 2
    del tmp6
    r1new.b += einsum(tmp7, (0, 1), r2.aba, (0, 2, 1), (2,)) * -2
    del tmp7
    r1new.b += einsum(tmp8, (0, 1), r2.bbb, (2, 0, 1), (2,)) * 2
    del tmp8
    r1new.b += einsum(r1.b, (0,), tmp9, (0, 1), (1,)) * -1
    del tmp9
    r1new.a = einsum(tmp0, (0, 1, 2, 3), r2.bab, (2, 1, 3), (0,))
    del tmp0
    r1new.a += einsum(tmp1, (0, 1, 2, 3), r2.aaa, (0, 1, 3), (2,)) * -2
    del tmp1
    r1new.a += einsum(tmp2, (0, 1), r2.bab, (0, 2, 1), (2,)) * -2
    del tmp2
    r1new.a += einsum(tmp3, (0, 1), r2.aaa, (2, 0, 1), (2,)) * 2
    del tmp3
    r1new.a += einsum(r1.a, (0,), tmp4, (0, 1), (1,)) * -1
    del tmp4

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ea_intermediates(f=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:23:03.783640.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp101 : array
    tmp103 : array
    tmp105 : array
    tmp132 : array
    tmp134 : array
    tmp136 : array
    tmp138 : array
    tmp14 : array
    tmp140 : array
    tmp142 : array
    tmp144 : array
    tmp146 : array
    tmp148 : array
    tmp158 : array
    tmp16 : array
    tmp18 : array
    tmp20 : array
    tmp22 : array
    tmp24 : array
    tmp26 : array
    tmp28 : array
    tmp3 : array
    tmp30 : array
    tmp32 : array
    tmp34 : array
    tmp36 : array
    tmp38 : array
    tmp4 : array
    tmp40 : array
    tmp41 : array
    tmp43 : array
    tmp44 : array
    tmp46 : array
    tmp48 : array
    tmp59 : array
    tmp6 : array
    tmp61 : array
    tmp67 : array
    tmp69 : array
    tmp75 : array
    tmp76 : array
    tmp78 : array
    tmp79 : array
    tmp81 : array
    tmp83 : array
    tmp85 : array
    tmp91 : array
    tmp93 : array
    tmp95 : array
    tmp97 : array
    tmp99 : array
    """

    tmp158 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 5, 3), (1, 5, 2, 4))
    tmp148 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 5), (1, 4, 3, 5))
    tmp146 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovov, (1, 3, 4, 5), (0, 4, 2, 5))
    tmp144 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp142 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp140 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp138 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp136 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 2, 4, 3), (1, 4))
    tmp134 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp132 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp105 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp103 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp101 = einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ovov, (4, 5, 0, 2), (4, 1, 5, 3))
    tmp99 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp97 = einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 0, 5), (4, 1, 5, 3))
    tmp95 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp93 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (4, 2, 1, 3), (0, 4))
    tmp91 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 1, 3), (0, 4))
    tmp85 = einsum(v.aabb.vvov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 5), (4, 0, 5, 3))
    tmp83 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (0, 4, 1, 5), (4, 5, 2, 3))
    tmp81 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 5, 2, 3))
    tmp79 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (1, 4, 5, 3), (0, 2, 4, 5))
    tmp78 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.abab, (4, 0, 5, 3), (4, 5, 1, 2))
    tmp76 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (1, 3, 4, 5), (0, 2, 4, 5))
    tmp75 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.abab, (4, 0, 5, 1), (4, 5, 2, 3))
    tmp69 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp67 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 0, 5), (4, 2, 3, 5)) * -1
    tmp61 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 1, 4), (4, 3))
    tmp59 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 4, 1, 3), (2, 4))
    tmp48 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (4, 5, 1, 2))
    tmp46 = einsum(v.aabb.vvov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp44 = einsum(v.aabb.vvov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 5, 0, 1))
    tmp43 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (4, 1, 2, 5))
    tmp41 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 5, 1, 2))
    tmp40 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.abab, (0, 4, 1, 5), (4, 2, 3, 5))
    tmp38 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 5, 2, 3))
    tmp36 = einsum(v.aabb.vvov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 3), (4, 0))
    tmp34 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp32 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (1, 3, 4, 2), (0, 4)) * -1
    tmp30 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 1, 3), (4, 2))
    tmp28 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 3, 4, 5), (2, 4, 1, 5))
    tmp26 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp24 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    tmp22 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovoo, (0, 2, 4, 1), (4, 3))
    tmp20 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 0, 3), (4, 2)) * -1
    tmp18 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 0, 1, 3), (4, 2))
    tmp16 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovov, (0, 4, 1, 3), (2, 4))
    tmp14 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 4, 1), (4, 3)) * -1
    tmp6 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp4 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp3 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (0, 2), (1, 3))
    tmp1 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))

    return {f"tmp1": tmp1, f"tmp101": tmp101, f"tmp103": tmp103, f"tmp105": tmp105, f"tmp132": tmp132, f"tmp134": tmp134, f"tmp136": tmp136, f"tmp138": tmp138, f"tmp14": tmp14, f"tmp140": tmp140, f"tmp142": tmp142, f"tmp144": tmp144, f"tmp146": tmp146, f"tmp148": tmp148, f"tmp158": tmp158, f"tmp16": tmp16, f"tmp18": tmp18, f"tmp20": tmp20, f"tmp22": tmp22, f"tmp24": tmp24, f"tmp26": tmp26, f"tmp28": tmp28, f"tmp3": tmp3, f"tmp30": tmp30, f"tmp32": tmp32, f"tmp34": tmp34, f"tmp36": tmp36, f"tmp38": tmp38, f"tmp4": tmp4, f"tmp40": tmp40, f"tmp41": tmp41, f"tmp43": tmp43, f"tmp44": tmp44, f"tmp46": tmp46, f"tmp48": tmp48, f"tmp59": tmp59, f"tmp6": tmp6, f"tmp61": tmp61, f"tmp67": tmp67, f"tmp69": tmp69, f"tmp75": tmp75, f"tmp76": tmp76, f"tmp78": tmp78, f"tmp79": tmp79, f"tmp81": tmp81, f"tmp83": tmp83, f"tmp85": tmp85, f"tmp91": tmp91, f"tmp93": tmp93, f"tmp95": tmp95, f"tmp97": tmp97, f"tmp99": tmp99}

def hbar_lmatvec_ea(f=None, r1=None, r2=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:23:03.856510.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp12 = einsum(t2.bbbb, (0, 1, 2, 3), r2.bbb, (2, 3, 1), (0,))
    tmp11 = einsum(t2.abab, (0, 1, 2, 3), r2.aba, (2, 3, 0), (1,))
    tmp51 = np.copy(tmp11) * -0.5
    tmp51 += tmp12
    tmp48 = np.copy(ints.tmp144) * 2
    tmp48 += ints.tmp148
    tmp40 = np.copy(ints.tmp59)
    tmp40 += ints.tmp61 * 0.5
    tmp40 += f.bb.vv * -0.5
    tmp56 = np.copy(ints.tmp142)
    tmp56 += ints.tmp146 * 2
    tmp20 = np.copy(ints.tmp101) * 0.5
    tmp20 += ints.tmp105
    tmp5 = einsum(t2.aaaa, (0, 1, 2, 3), r2.aaa, (2, 3, 1), (0,))
    tmp18 = np.copy(ints.tmp103) * 0.5
    tmp18 += ints.tmp99
    tmp22 = np.copy(ints.tmp14)
    tmp22 += ints.tmp16 * 0.5
    tmp22 += f.aa.vv * -0.5
    tmp6 = einsum(t2.abab, (0, 1, 2, 3), r2.bab, (3, 2, 1), (0,)) * -1
    tmp44 = einsum(r1.b, (0,), v.bbbb.ovvv, (1, 2, 3, 0), (1, 2, 3))
    tmp52 = einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp51, (2,), (0, 3, 1)) * 2
    del tmp51
    tmp45 = einsum(r2.aba, (0, 1, 2), ints.tmp138, (2, 3, 0, 4), (3, 4, 1))
    tmp49 = einsum(r2.bbb, (0, 1, 2), tmp48, (2, 3, 1, 4), (3, 0, 4)) * -2
    del tmp48
    tmp46 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.aba, (1, 4, 0), (2, 4, 3))
    tmp47 = einsum(r2.bbb, (0, 1, 2), v.bbbb.oovv, (3, 2, 4, 1), (3, 0, 4))
    tmp50 = einsum(tmp40, (0, 1), r2.bbb, (2, 0, 3), (3, 2, 1)) * -4
    tmp55 = einsum(r2.bbb, (0, 1, 2), v.bbbb.ovov, (3, 4, 2, 1), (3, 0, 4))
    tmp54 = einsum(ints.tmp140, (0, 1, 2, 3), r2.bbb, (4, 2, 0), (1, 3, 4))
    tmp57 = einsum(tmp56, (0, 1, 2, 3), r2.aba, (2, 4, 0), (1, 4, 3))
    del tmp56
    tmp21 = einsum(r2.bab, (0, 1, 2), tmp20, (3, 2, 4, 0), (3, 1, 4)) * -2
    del tmp20
    tmp15 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), r1.a, (3,), (0, 1, 2))
    tmp17 = einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp5, (2,), (0, 1, 3)) * -1
    tmp16 = einsum(r2.aaa, (0, 1, 2), v.aaaa.oovv, (3, 2, 4, 1), (3, 0, 4))
    tmp19 = einsum(tmp18, (0, 1, 2, 3), r2.aaa, (4, 2, 0), (1, 4, 3)) * -4
    del tmp18
    tmp23 = einsum(tmp22, (0, 1), r2.aaa, (2, 0, 3), (3, 2, 1)) * -4
    del tmp22
    tmp28 = einsum(r2.bab, (0, 1, 2), v.aabb.ovov, (3, 4, 2, 0), (3, 1, 4)) * -1
    tmp27 = einsum(r2.bab, (0, 1, 2), ints.tmp97, (3, 2, 4, 0), (3, 4, 1)) * -1
    tmp26 = einsum(r2.aaa, (0, 1, 2), v.aaaa.ovov, (3, 4, 2, 1), (3, 0, 4))
    tmp25 = einsum(r2.aaa, (0, 1, 2), ints.tmp95, (2, 3, 1, 4), (3, 4, 0))
    tmp29 = einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp6, (2,), (0, 1, 3))
    tmp41 = np.copy(f.bb.oo)
    tmp41 += ints.tmp134 * 2
    del ints.tmp134
    tmp41 += ints.tmp136
    del ints.tmp136
    tmp53 = einsum(r1.b, (0,), f.bb.ov, (1, 2), (1, 2, 0))
    tmp53 += tmp44
    del tmp44
    tmp53 += tmp45
    del tmp45
    tmp53 += tmp46
    del tmp46
    tmp53 += tmp47 * 2
    del tmp47
    tmp53 += np.transpose(tmp49, (0, 2, 1)) * -1
    del tmp49
    tmp53 += np.transpose(tmp50, (0, 2, 1))
    del tmp50
    tmp53 += np.transpose(tmp52, (0, 2, 1)) * -1
    del tmp52
    tmp58 = np.copy(tmp54) * 4
    del tmp54
    tmp58 += tmp55 * 2
    del tmp55
    tmp58 += np.transpose(tmp57, (0, 2, 1))
    del tmp57
    tmp43 = einsum(r2.bbb, (0, 1, 2), t2.bbbb, (3, 4, 0, 1), (2, 3, 4))
    tmp36 = einsum(r2.bab, (0, 1, 2), t2.abab, (3, 4, 1, 0), (3, 2, 4)) * -1
    tmp4 = np.copy(ints.tmp14) * 2
    del ints.tmp14
    tmp4 += ints.tmp16
    del ints.tmp16
    tmp4 += f.aa.vv * -1
    tmp37 = np.copy(ints.tmp144) * 2
    del ints.tmp144
    tmp37 += ints.tmp148
    del ints.tmp148
    tmp37 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    tmp37 += ints.tmp140 * -2
    del ints.tmp140
    tmp37 += v.bbbb.oovv * -1
    tmp38 = np.copy(ints.tmp142)
    del ints.tmp142
    tmp38 += ints.tmp146 * 2
    del ints.tmp146
    tmp38 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp38 += ints.tmp138 * -1
    del ints.tmp138
    tmp42 = np.copy(tmp5) * 2
    tmp42 += tmp6
    tmp39 = np.copy(ints.tmp158)
    del ints.tmp158
    tmp39 += np.transpose(v.aabb.vvoo, (2, 3, 0, 1)) * -1
    tmp32 = einsum(r2.aba, (0, 1, 2), t2.abab, (3, 4, 0, 1), (2, 3, 4))
    tmp34 = np.copy(ints.tmp101)
    del ints.tmp101
    tmp34 += ints.tmp105 * 2
    del ints.tmp105
    tmp34 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp34 += ints.tmp97 * -1
    del ints.tmp97
    tmp31 = np.copy(f.aa.oo)
    tmp31 += ints.tmp91 * 2
    del ints.tmp91
    tmp31 += ints.tmp93
    del ints.tmp93
    tmp13 = np.copy(tmp11) * -1
    del tmp11
    tmp13 += tmp12 * 2
    del tmp12
    tmp33 = np.copy(ints.tmp103)
    del ints.tmp103
    tmp33 += ints.tmp99 * 2
    del ints.tmp99
    tmp33 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp33 += ints.tmp95 * -2
    del ints.tmp95
    tmp33 += v.aaaa.oovv * -1
    tmp35 = np.copy(ints.tmp132)
    del ints.tmp132
    tmp35 += v.aabb.oovv * -1
    tmp10 = np.copy(ints.tmp59) * 2
    del ints.tmp59
    tmp10 += ints.tmp61
    del ints.tmp61
    tmp10 += f.bb.vv * -1
    tmp24 = einsum(f.aa.ov, (0, 1), r1.a, (2,), (0, 1, 2))
    tmp24 += tmp15
    del tmp15
    tmp24 += tmp16 * 2
    del tmp16
    tmp24 += tmp17 * 2
    del tmp17
    tmp24 += np.transpose(tmp19, (0, 2, 1)) * -1
    del tmp19
    tmp24 += np.transpose(tmp21, (0, 2, 1))
    del tmp21
    tmp24 += np.transpose(tmp23, (0, 2, 1))
    del tmp23
    tmp30 = np.copy(tmp25) * 4
    del tmp25
    tmp30 += tmp26 * 2
    del tmp26
    tmp30 += tmp27
    del tmp27
    tmp30 += tmp28
    del tmp28
    tmp30 += tmp29
    del tmp29
    tmp14 = einsum(t2.aaaa, (0, 1, 2, 3), r2.aaa, (2, 3, 4), (4, 0, 1))
    tmp3 = np.copy(f.aa.ov) * 0.5
    tmp3 += ints.tmp1
    del ints.tmp1
    tmp3 += ints.tmp36 * 0.5
    del ints.tmp36
    tmp3 += ints.tmp4 * 0.5
    del ints.tmp4
    tmp3 += ints.tmp18 * -1
    del ints.tmp18
    tmp3 += ints.tmp24 * -0.5
    del ints.tmp24
    tmp3 += ints.tmp30 * -1
    del ints.tmp30
    tmp2 = np.copy(f.bb.ov) * 0.5
    tmp2 += ints.tmp34 * 0.5
    del ints.tmp34
    tmp2 += ints.tmp3 * 0.5
    del ints.tmp3
    tmp2 += ints.tmp6
    del ints.tmp6
    tmp2 += ints.tmp20 * -1
    del ints.tmp20
    tmp2 += ints.tmp22 * -0.5
    del ints.tmp22
    tmp2 += ints.tmp32 * -1
    del ints.tmp32
    tmp9 = np.copy(ints.tmp67) * 0.5
    del ints.tmp67
    tmp9 += np.transpose(ints.tmp76, (0, 1, 3, 2))
    del ints.tmp76
    tmp9 += np.transpose(ints.tmp83, (0, 1, 3, 2)) * 0.5
    del ints.tmp83
    tmp9 += v.bbbb.ovvv * 0.5
    tmp9 += np.transpose(ints.tmp79, (0, 1, 3, 2)) * -1
    del ints.tmp79
    tmp8 = np.copy(ints.tmp69)
    del ints.tmp69
    tmp8 += np.transpose(ints.tmp75, (0, 1, 3, 2))
    del ints.tmp75
    tmp8 += np.transpose(ints.tmp81, (0, 1, 3, 2)) * 2
    del ints.tmp81
    tmp8 += v.aabb.ovvv
    tmp8 += np.transpose(ints.tmp78, (0, 1, 3, 2)) * -1
    del ints.tmp78
    tmp8 += ints.tmp85 * -1
    del ints.tmp85
    tmp1 = np.copy(ints.tmp26) * 0.5
    del ints.tmp26
    tmp1 += np.transpose(ints.tmp38, (0, 1, 3, 2))
    del ints.tmp38
    tmp1 += np.transpose(ints.tmp44, (0, 1, 3, 2)) * 0.5
    del ints.tmp44
    tmp1 += v.aaaa.ovvv * 0.5
    tmp1 += np.transpose(ints.tmp41, (0, 1, 3, 2)) * -1
    del ints.tmp41
    tmp0 = np.copy(ints.tmp28)
    del ints.tmp28
    tmp0 += np.transpose(ints.tmp40, (0, 2, 1, 3))
    del ints.tmp40
    tmp0 += np.transpose(ints.tmp46, (0, 2, 1, 3)) * 2
    del ints.tmp46
    tmp0 += np.transpose(v.aabb.vvov, (2, 0, 1, 3))
    tmp0 += np.transpose(ints.tmp43, (0, 2, 1, 3)) * -1
    del ints.tmp43
    tmp0 += ints.tmp48 * -1
    del ints.tmp48
    tmp7 = np.copy(tmp5)
    del tmp5
    tmp7 += tmp6 * 0.5
    del tmp6
    r2new.bbb = einsum(r2.bbb, (0, 1, 2), v.bbbb.vvvv, (3, 1, 4, 0), (3, 4, 2)) * -2
    r2new.bbb += einsum(tmp43, (0, 1, 2), v.bbbb.ovov, (2, 3, 1, 4), (3, 4, 0)) * -2
    del tmp43
    r2new.bbb += np.transpose(tmp53, (1, 2, 0)) * -1
    r2new.bbb += np.transpose(tmp53, (2, 1, 0))
    del tmp53
    r2new.bbb += np.transpose(tmp58, (1, 2, 0))
    r2new.bbb += np.transpose(tmp58, (2, 1, 0)) * -1
    del tmp58
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp41, (2, 3), (0, 1, 3)) * -2
    r2new.bab = einsum(f.bb.ov, (0, 1), r1.a, (2,), (1, 2, 0)) * -1
    r2new.bab += einsum(r1.a, (0,), v.aabb.vvov, (1, 0, 2, 3), (3, 1, 2)) * -1
    r2new.bab += einsum(r2.bab, (0, 1, 2), v.aabb.vvvv, (3, 1, 4, 0), (4, 3, 2))
    r2new.bab += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp36, (0, 4, 2), (3, 1, 4)) * -1
    del tmp36
    r2new.bab += einsum(tmp37, (0, 1, 2, 3), r2.bab, (2, 4, 0), (3, 4, 1))
    del tmp37
    r2new.bab += einsum(tmp38, (0, 1, 2, 3), r2.aaa, (4, 2, 0), (3, 4, 1)) * -2
    del tmp38
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp39, (2, 3, 1, 4), (0, 4, 3))
    del tmp39
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp4, (1, 3), (0, 3, 2)) * -1
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp40, (0, 3), (3, 1, 2)) * -2
    del tmp40
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp41, (2, 3), (0, 1, 3)) * -1
    del tmp41
    r2new.bab += einsum(tmp42, (0,), v.aabb.ovov, (0, 1, 2, 3), (3, 1, 2))
    del tmp42
    r2new.aba = einsum(f.aa.ov, (0, 1), r1.b, (2,), (1, 2, 0)) * -1
    r2new.aba += einsum(r1.b, (0,), v.aabb.ovvv, (1, 2, 3, 0), (2, 3, 1)) * -1
    r2new.aba += einsum(r2.aba, (0, 1, 2), v.aabb.vvvv, (3, 0, 4, 1), (3, 4, 2))
    r2new.aba += einsum(tmp32, (0, 1, 2), v.aabb.ovov, (1, 3, 2, 4), (3, 4, 0))
    del tmp32
    r2new.aba += einsum(tmp33, (0, 1, 2, 3), r2.aba, (2, 4, 0), (3, 4, 1))
    del tmp33
    r2new.aba += einsum(r2.bbb, (0, 1, 2), tmp34, (3, 2, 4, 1), (4, 0, 3)) * -2
    del tmp34
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp35, (2, 3, 1, 4), (0, 4, 3))
    del tmp35
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp10, (1, 3), (0, 3, 2)) * -1
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp4, (0, 3), (3, 1, 2)) * -1
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp31, (2, 3), (0, 1, 3)) * -1
    r2new.aba += einsum(tmp13, (0,), v.aabb.ovov, (1, 2, 0, 3), (2, 3, 1))
    r2new.aaa = einsum(r2.aaa, (0, 1, 2), v.aaaa.vvvv, (3, 1, 4, 0), (3, 4, 2)) * -2
    r2new.aaa += einsum(tmp14, (0, 1, 2), v.aaaa.ovov, (2, 3, 1, 4), (3, 4, 0)) * -2
    del tmp14
    r2new.aaa += np.transpose(tmp24, (1, 2, 0)) * -1
    r2new.aaa += np.transpose(tmp24, (2, 1, 0))
    del tmp24
    r2new.aaa += np.transpose(tmp30, (1, 2, 0))
    r2new.aaa += np.transpose(tmp30, (2, 1, 0)) * -1
    del tmp30
    r2new.aaa += einsum(tmp31, (0, 1), r2.aaa, (2, 3, 0), (2, 3, 1)) * -2
    del tmp31
    r1new.b = einsum(r2.aba, (0, 1, 2), tmp8, (2, 0, 1, 3), (3,)) * -1
    del tmp8
    r1new.b += einsum(r2.bbb, (0, 1, 2), tmp9, (2, 1, 0, 3), (3,)) * 4
    del tmp9
    r1new.b += einsum(tmp3, (0, 1), r2.aba, (1, 2, 0), (2,)) * -2
    r1new.b += einsum(r2.bbb, (0, 1, 2), tmp2, (2, 1), (0,)) * 4
    r1new.b += einsum(r1.b, (0,), tmp10, (0, 1), (1,)) * -1
    del tmp10
    r1new.b += einsum(tmp13, (0,), f.bb.ov, (0, 1), (1,)) * -1
    del tmp13
    r1new.a = einsum(tmp0, (0, 1, 2, 3), r2.bab, (3, 1, 0), (2,)) * -1
    del tmp0
    r1new.a += einsum(tmp1, (0, 1, 2, 3), r2.aaa, (1, 2, 0), (3,)) * -4
    del tmp1
    r1new.a += einsum(r2.bab, (0, 1, 2), tmp2, (2, 0), (1,)) * -2
    del tmp2
    r1new.a += einsum(tmp3, (0, 1), r2.aaa, (2, 1, 0), (2,)) * 4
    del tmp3
    r1new.a += einsum(tmp4, (0, 1), r1.a, (0,), (1,)) * -1
    del tmp4
    r1new.a += einsum(tmp7, (0,), f.aa.ov, (0, 1), (1,)) * -2
    del tmp7

    return {f"r1new": r1new, f"r2new": r2new}

