"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T15:36:36.850065
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:36:38.137258.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1)))
    tmp0 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3)) * -1
    tmp2 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1))) * -1
    tmp2 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp1 = np.copy(f.bb.ov) * 2
    tmp1 += einsum(v.aabb.ovov, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3)) * 2
    tmp1 += einsum(tmp0, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3)) * -1
    del tmp0
    tmp3 = np.copy(f.aa.ov)
    tmp3 += einsum(t1.aa, (0, 1), tmp2, (0, 2, 3, 1), (2, 3)) * -0.5
    del tmp2
    e_cc = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (0, 2, 1, 3), ())
    e_cc += einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (0, 2, 3, 1), ()) * -1
    e_cc += einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 1, 3), ())
    e_cc += einsum(tmp1, (0, 1), t1.bb, (0, 1), ()) * 0.5
    del tmp1
    e_cc += einsum(tmp3, (0, 1), t1.aa, (0, 1), ())
    del tmp3

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:37:34.726865.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    t1new : Namespace of arrays
        Updated T1 residuals.
    t2new : Namespace of arrays
        Updated T2 residuals.
    """

    t1new = Namespace()
    t2new = Namespace()
    tmp14 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1)))
    tmp14 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3)) * -1
    tmp7 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1))) * -1
    tmp7 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp117 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1)))
    tmp117 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3)) * -1
    tmp13 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp15 = einsum(tmp14, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3))
    tmp22 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 2, 1))
    tmp1 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 2, 1))
    tmp8 = einsum(t1.aa, (0, 1), tmp7, (0, 2, 3, 1), (2, 3))
    tmp2 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp21 = einsum(t1.bb, (0, 1), v.aabb.ovov, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp118 = einsum(tmp117, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3))
    tmp197 = np.copy(v.bbbb.ooov)
    tmp197 += np.transpose(v.bbbb.ooov, (0, 2, 1, 3)) * -1
    tmp16 = np.copy(f.bb.ov)
    tmp16 += tmp13
    tmp16 += tmp15 * -1
    del tmp15
    tmp184 = np.copy(tmp22)
    tmp184 += np.transpose(tmp22, (0, 2, 1, 3)) * -1
    tmp149 = np.copy(v.bbbb.ovvv) * -1
    tmp149 += np.transpose(v.bbbb.ovvv, (0, 2, 1, 3))
    tmp141 = np.copy(v.bbbb.ooov)
    tmp141 += np.transpose(v.bbbb.ovoo, (0, 2, 3, 1)) * -1
    tmp0 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp71 = np.copy(v.aaaa.ovvv)
    tmp71 += np.transpose(v.aaaa.ovvv, (0, 2, 1, 3)) * -1
    tmp73 = np.copy(tmp1) * -1
    tmp73 += np.transpose(tmp1, (0, 2, 1, 3))
    tmp82 = np.copy(v.aaaa.ooov) * -1
    tmp82 += np.transpose(v.aaaa.ovoo, (0, 2, 3, 1))
    tmp34 = np.copy(v.aaaa.ooov)
    tmp34 += np.transpose(v.aaaa.ovoo, (0, 2, 3, 1)) * -1
    tmp9 = np.copy(f.aa.ov)
    tmp9 += tmp2
    tmp9 += tmp8 * -1
    del tmp8
    tmp127 = einsum(t1.bb, (0, 1), tmp21, (2, 3, 0, 4), (2, 3, 4, 1))
    tmp128 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 1, 2))
    tmp29 = np.copy(v.bbbb.ooov)
    tmp29 += np.transpose(v.bbbb.ovoo, (0, 2, 3, 1)) * -1
    tmp178 = einsum(t1.bb, (0, 1), v.bbbb.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp171 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp119 = np.copy(f.bb.ov)
    tmp119 += tmp13
    tmp119 += tmp118 * -1
    del tmp118
    tmp201 = einsum(t1.bb, (0, 1), tmp22, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp198 = einsum(t1.bb, (0, 1), tmp197, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp197
    tmp24 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp122 = einsum(t1.bb, (0, 1), tmp16, (2, 1), (0, 2))
    tmp25 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp185 = einsum(t1.bb, (0, 1), tmp184, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp184
    tmp183 = einsum(t1.bb, (0, 1), tmp149, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp28 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp159 = einsum(t1.bb, (0, 1), tmp141, (0, 2, 3, 1), (2, 3))
    tmp45 = np.copy(v.aaaa.ovvv)
    tmp45 += np.transpose(v.aaaa.ovvv, (0, 2, 3, 1)) * -1
    tmp97 = einsum(tmp1, (0, 1, 2, 3), t1.aa, (4, 3), (0, 4, 2, 1))
    tmp53 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp68 = einsum(t1.aa, (0, 1), tmp0, (2, 0, 3, 4), (2, 3, 1, 4))
    tmp67 = einsum(t1.aa, (0, 1), v.aabb.vvov, (2, 1, 3, 4), (0, 3, 2, 4))
    tmp72 = einsum(tmp71, (0, 1, 2, 3), t1.aa, (4, 2), (4, 0, 1, 3))
    del tmp71
    tmp74 = einsum(t1.aa, (0, 1), tmp73, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp73
    tmp50 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1))) * -1
    tmp50 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp83 = einsum(t1.aa, (0, 1), tmp82, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp82
    tmp62 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp17 = einsum(t1.bb, (0, 1), v.aabb.ooov, (2, 3, 0, 1), (2, 3))
    tmp35 = einsum(t1.aa, (0, 1), tmp34, (0, 2, 3, 1), (2, 3))
    tmp6 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 3), (4, 0))
    tmp5 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 1, 3), (4, 0))
    tmp59 = einsum(tmp9, (0, 1), t1.aa, (2, 1), (2, 0)) * 0.5
    tmp18 = np.copy(v.aaaa.ooov)
    tmp18 += np.transpose(v.aaaa.ovoo, (0, 2, 3, 1)) * -1
    tmp131 = einsum(t1.bb, (0, 1), v.aabb.ovoo, (2, 3, 4, 0), (2, 4, 3, 1))
    tmp181 = np.copy(tmp128) * -1
    tmp181 += tmp127
    tmp114 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp30 = einsum(t1.bb, (0, 1), tmp29, (0, 2, 3, 1), (2, 3))
    tmp205 = einsum(tmp178, (0, 1, 2, 3), t1.bb, (4, 2), (4, 0, 1, 3))
    tmp211 = np.copy(v.bbbb.ovvv)
    tmp211 += einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 4), (0, 3, 4, 1))
    tmp195 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 4, 1, 5), (4, 2, 3, 5))
    tmp173 = einsum(t1.bb, (0, 1), tmp171, (2, 3, 4, 0), (2, 4, 3, 1))
    tmp120 = einsum(t1.bb, (0, 1), tmp119, (0, 2), (1, 2))
    del tmp119
    tmp115 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp203 = einsum(t1.bb, (0, 1), tmp201, (2, 3, 0, 4), (3, 2, 4, 1))
    tmp112 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (0, 2, 4, 3), (4, 1))
    tmp111 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 1, 4), (4, 3))
    tmp207 = einsum(v.bbbb.vvvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp152 = np.copy(tmp128)
    tmp152 += tmp127 * -1
    tmp199 = np.copy(v.bbbb.oovv)
    tmp199 += np.transpose(tmp198, (1, 0, 2, 3)) * -1
    del tmp198
    tmp175 = np.copy(tmp24)
    tmp175 += tmp25 * 2
    tmp175 += tmp122
    tmp186 = np.copy(np.transpose(tmp183, (0, 1, 3, 2))) * -1
    del tmp183
    tmp186 += tmp185 * -1
    del tmp185
    tmp179 = np.copy(tmp22)
    tmp179 += np.transpose(tmp22, (0, 2, 1, 3)) * -1
    tmp166 = np.copy(v.bbbb.ovvv) * -1
    tmp166 += np.transpose(v.bbbb.ovvv, (0, 2, 1, 3))
    tmp160 = np.copy(f.bb.oo)
    tmp160 += np.transpose(tmp28, (1, 0))
    tmp160 += np.transpose(tmp159, (1, 0)) * -1
    del tmp159
    tmp169 = einsum(t1.bb, (0, 1), v.bbbb.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp209 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp116 = np.copy(v.bbbb.ovvv) * -1
    tmp116 += np.transpose(v.bbbb.ovvv, (0, 2, 3, 1))
    tmp46 = einsum(tmp45, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    del tmp45
    tmp39 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (4, 1))
    tmp38 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (0, 4, 1, 3), (2, 4))
    tmp44 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp47 = einsum(t1.aa, (0, 1), tmp9, (0, 2), (1, 2))
    tmp129 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 2, 0, 1))
    tmp144 = np.copy(np.transpose(v.aabb.vvov, (2, 0, 1, 3)))
    tmp144 += einsum(v.aabb.ovov, (0, 1, 2, 3), t1.aa, (0, 4), (2, 4, 1, 3)) * -1
    tmp138 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovov, (1, 3, 4, 5), (0, 4, 2, 5))
    tmp85 = einsum(t1.aa, (0, 1), v.aabb.ooov, (2, 0, 3, 4), (2, 3, 1, 4))
    tmp147 = np.copy(tmp1)
    tmp147 += np.transpose(tmp1, (0, 2, 1, 3)) * -1
    tmp146 = np.copy(v.aaaa.ovvv) * -1
    tmp146 += np.transpose(v.aaaa.ovvv, (0, 2, 1, 3))
    tmp42 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp81 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1)))
    tmp81 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3)) * -1
    tmp10 = einsum(tmp9, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp150 = np.copy(tmp22) * -1
    tmp150 += np.transpose(tmp22, (0, 2, 1, 3))
    tmp107 = np.copy(v.aaaa.ovvv)
    tmp107 += einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (2, 4), (0, 3, 1, 4))
    tmp101 = einsum(t1.aa, (0, 1), tmp97, (2, 3, 0, 4), (3, 2, 4, 1))
    tmp64 = np.copy(v.aaaa.ovvv)
    tmp64 += np.transpose(v.aaaa.ovvv, (0, 2, 1, 3)) * -1
    tmp65 = np.copy(tmp1) * -1
    tmp65 += np.transpose(tmp1, (0, 2, 1, 3))
    tmp57 = einsum(t1.aa, (0, 1), tmp53, (2, 3, 4, 0), (2, 4, 3, 1))
    tmp69 = np.copy(tmp67) * -1
    tmp69 += tmp68
    tmp75 = np.copy(np.transpose(tmp72, (0, 1, 3, 2))) * -1
    del tmp72
    tmp75 += tmp74 * -1
    del tmp74
    tmp103 = einsum(t1.aa, (0, 1), v.aaaa.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp91 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1))) * -1
    tmp91 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    tmp51 = np.copy(f.aa.ov)
    tmp51 += tmp2
    tmp51 += einsum(tmp50, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2)) * -1
    tmp49 = np.copy(v.aaaa.ovvv)
    tmp49 += np.transpose(v.aaaa.ovvv, (0, 2, 3, 1)) * -1
    tmp95 = np.copy(v.aaaa.oovv)
    tmp95 += np.transpose(tmp83, (1, 0, 2, 3)) * -1
    tmp88 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1)))
    tmp88 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3)) * -1
    tmp89 = np.copy(v.aaaa.ooov) * -1
    tmp89 += np.transpose(v.aaaa.ovoo, (0, 2, 3, 1))
    tmp105 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    tmp77 = np.copy(tmp67)
    del tmp67
    tmp77 += tmp68 * -1
    tmp99 = einsum(t1.aa, (0, 1), tmp62, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp36 = np.copy(f.aa.oo)
    tmp36 += np.transpose(tmp17, (1, 0))
    tmp36 += np.transpose(tmp35, (1, 0)) * -1
    del tmp35
    tmp93 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp60 = np.copy(tmp5)
    tmp60 += tmp6 * 0.5
    tmp60 += tmp59
    del tmp59
    tmp19 = einsum(tmp18, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    del tmp18
    tmp86 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1))) * -1
    tmp86 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    tmp55 = einsum(t1.aa, (0, 1), v.aaaa.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp192 = np.copy(tmp131)
    tmp192 += einsum(tmp50, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (1, 4, 2, 5))
    del tmp50
    tmp182 = einsum(tmp181, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (4, 1, 5, 3))
    del tmp181
    tmp164 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp190 = einsum(tmp114, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (4, 1, 5, 3))
    tmp31 = np.copy(f.bb.oo)
    tmp31 += np.transpose(tmp28, (1, 0))
    del tmp28
    tmp31 += np.transpose(tmp30, (1, 0)) * -1
    del tmp30
    tmp165 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 5), (4, 2, 5, 3))
    tmp206 = einsum(t1.bb, (0, 1), tmp205, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp205
    tmp158 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.oooo, (4, 1, 5, 0), (4, 5, 2, 3)) * -1
    tmp212 = np.copy(v.bbbb.vvvv) * -1
    tmp212 += einsum(tmp211, (0, 1, 2, 3), t1.bb, (0, 4), (3, 2, 1, 4))
    del tmp211
    tmp177 = einsum(t1.bb, (0, 1), tmp22, (2, 3, 0, 4), (2, 3, 1, 4))
    tmp213 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.bbbb, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp196 = einsum(t1.bb, (0, 1), tmp195, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp195
    tmp157 = np.copy(t2.bbbb)
    tmp157 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3)) * 2
    tmp174 = einsum(t1.bb, (0, 1), tmp173, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp173
    tmp168 = np.copy(f.bb.vv) * -1
    tmp168 += np.transpose(tmp115, (1, 0)) * -1
    tmp168 += einsum(tmp149, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3)) * -1
    tmp168 += np.transpose(tmp120, (1, 0))
    tmp204 = einsum(t1.bb, (0, 1), tmp203, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp203
    tmp172 = einsum(t2.bbbb, (0, 1, 2, 3), tmp171, (4, 5, 1, 0), (4, 5, 2, 3)) * -1
    del tmp171
    tmp162 = np.copy(tmp111) * 0.5
    tmp162 += tmp112
    tmp208 = einsum(tmp207, (0, 1, 2, 3), t1.bb, (4, 2), (4, 0, 1, 3))
    del tmp207
    tmp202 = einsum(t2.bbbb, (0, 1, 2, 3), tmp201, (4, 5, 0, 1), (5, 4, 2, 3)) * -1
    del tmp201
    tmp188 = einsum(tmp152, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (4, 1, 5, 3))
    tmp200 = einsum(t2.bbbb, (0, 1, 2, 3), tmp199, (1, 4, 5, 3), (0, 4, 2, 5))
    del tmp199
    tmp176 = einsum(t2.bbbb, (0, 1, 2, 3), tmp175, (4, 1), (0, 4, 2, 3)) * -1
    del tmp175
    tmp187 = einsum(t2.bbbb, (0, 1, 2, 3), tmp186, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp186
    tmp180 = einsum(tmp166, (0, 1, 2, 3), t1.bb, (4, 1), (4, 0, 3, 2)) * -1
    tmp180 += einsum(t1.bb, (0, 1), tmp179, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp179
    tmp167 = np.copy(f.bb.vv) * -1
    tmp167 += np.transpose(tmp115, (1, 0)) * -1
    tmp167 += np.transpose(tmp111, (1, 0))
    tmp167 += np.transpose(tmp112, (1, 0)) * 2
    tmp167 += einsum(tmp166, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3)) * -1
    del tmp166
    tmp167 += einsum(tmp16, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp193 = np.copy(v.bbbb.oovv)
    tmp193 += einsum(t2.bbbb, (0, 1, 2, 3), tmp14, (1, 4, 5, 3), (0, 4, 2, 5)) * -2
    del tmp14
    tmp193 += einsum(t1.bb, (0, 1), tmp29, (2, 3, 0, 4), (3, 2, 1, 4)) * -1
    del tmp29
    tmp161 = einsum(tmp160, (0, 1), t2.bbbb, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    del tmp160
    tmp191 = np.copy(v.bbbb.oovv)
    tmp191 += einsum(t2.bbbb, (0, 1, 2, 3), tmp117, (1, 4, 5, 3), (0, 4, 2, 5)) * -2
    tmp191 += einsum(t1.bb, (0, 1), tmp141, (2, 3, 0, 4), (3, 2, 1, 4)) * -1
    tmp170 = einsum(t1.bb, (0, 1), tmp169, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp169
    tmp210 = einsum(t2.bbbb, (0, 1, 2, 3), tmp209, (4, 5, 1, 0), (5, 4, 2, 3))
    del tmp209
    tmp189 = einsum(t1.bb, (0, 1), v.bbbb.ooov, (2, 0, 3, 4), (2, 3, 1, 4))
    tmp163 = einsum(t1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * 2
    tmp163 += t2.bbbb * -1
    tmp194 = np.copy(tmp131)
    tmp194 += einsum(tmp7, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (1, 4, 2, 5))
    del tmp7
    tmp121 = np.copy(f.bb.vv)
    tmp121 += np.transpose(tmp115, (1, 0))
    del tmp115
    tmp121 += einsum(tmp116, (0, 1, 2, 3), t1.bb, (0, 1), (3, 2)) * -1
    del tmp116
    tmp121 += np.transpose(tmp120, (1, 0)) * -1
    del tmp120
    tmp135 = np.copy(np.transpose(v.aabb.vvov, (2, 0, 1, 3)))
    tmp135 += einsum(v.aabb.vvvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp140 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovoo, (1, 3, 4, 5), (0, 4, 5, 2))
    tmp3 = np.copy(t2.abab)
    tmp3 += einsum(t1.aa, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    tmp48 = np.copy(f.aa.vv) * -1
    tmp48 += np.transpose(tmp44, (1, 0)) * -1
    tmp48 += np.transpose(tmp38, (1, 0)) * 2
    tmp48 += np.transpose(tmp39, (1, 0))
    tmp48 += np.transpose(tmp46, (1, 0)) * -1
    del tmp46
    tmp48 += np.transpose(tmp47, (1, 0))
    del tmp47
    tmp126 = einsum(t1.aa, (0, 1), v.aabb.ovoo, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp134 = einsum(t1.aa, (0, 1), tmp129, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp145 = np.copy(v.aabb.vvvv)
    tmp145 += einsum(tmp144, (0, 1, 2, 3), t1.bb, (0, 4), (2, 1, 3, 4)) * -1
    del tmp144
    tmp124 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp125 = einsum(t1.aa, (0, 1), v.aabb.vvoo, (2, 1, 3, 4), (0, 3, 4, 2))
    tmp142 = np.copy(v.bbbb.oovv)
    tmp142 += einsum(t1.bb, (0, 1), tmp141, (0, 2, 3, 4), (3, 2, 4, 1))
    del tmp141
    tmp143 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp154 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp136 = einsum(tmp21, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp132 = np.copy(np.transpose(v.aabb.vvoo, (2, 3, 0, 1))) * -1
    tmp132 += einsum(t1.aa, (0, 1), v.aabb.ovoo, (0, 2, 3, 4), (3, 4, 2, 1))
    tmp132 += einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (2, 4, 1, 5))
    tmp110 = np.copy(t2.abab)
    tmp110 += einsum(t1.aa, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3)) * 2
    tmp139 = np.copy(tmp85) * -1
    tmp139 += tmp138 * 2
    tmp139 += einsum(tmp117, (0, 1, 2, 3), t2.abab, (4, 0, 5, 2), (4, 1, 5, 3)) * -1
    del tmp117
    tmp123 = np.copy(np.transpose(tmp24, (1, 0)))
    tmp123 += np.transpose(tmp25, (1, 0)) * 2
    tmp123 += np.transpose(tmp122, (1, 0))
    del tmp122
    tmp113 = np.copy(tmp111)
    del tmp111
    tmp113 += tmp112 * 2
    del tmp112
    tmp155 = einsum(v.aabb.oovv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp148 = einsum(tmp146, (0, 1, 2, 3), t1.aa, (4, 2), (4, 0, 1, 3)) * -1
    del tmp146
    tmp148 += einsum(t1.aa, (0, 1), tmp147, (2, 0, 3, 4), (2, 3, 4, 1))
    del tmp147
    tmp137 = np.copy(v.aaaa.oovv)
    tmp137 += np.transpose(tmp42, (1, 0, 3, 2)) * -1
    tmp137 += einsum(tmp81, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (1, 4, 3, 5)) * 2
    tmp137 += einsum(t1.aa, (0, 1), tmp34, (0, 2, 3, 4), (3, 2, 4, 1))
    del tmp34
    tmp11 = np.copy(np.transpose(tmp5, (1, 0))) * 2
    del tmp5
    tmp11 += np.transpose(tmp6, (1, 0))
    del tmp6
    tmp11 += np.transpose(tmp10, (1, 0))
    del tmp10
    tmp151 = einsum(tmp149, (0, 1, 2, 3), t1.bb, (4, 2), (4, 0, 1, 3)) * -1
    del tmp149
    tmp151 += einsum(t1.bb, (0, 1), tmp150, (2, 3, 0, 4), (2, 3, 4, 1))
    del tmp150
    tmp156 = einsum(tmp128, (0, 1, 2, 3), t1.aa, (4, 2), (4, 0, 1, 3))
    tmp130 = np.copy(np.transpose(tmp129, (0, 1, 3, 2)))
    del tmp129
    tmp130 += einsum(t1.aa, (0, 1), tmp21, (0, 2, 3, 4), (2, 3, 4, 1)) * -1
    tmp153 = einsum(t1.aa, (0, 1), v.aabb.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp153 += einsum(t1.bb, (0, 1), tmp0, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    tmp133 = np.copy(v.aabb.oovv)
    tmp133 += einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 3, 4)) * -1
    tmp41 = einsum(t1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1)) * 2
    tmp41 += t2.aaaa * -1
    tmp33 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.oooo, (4, 1, 5, 0), (4, 5, 2, 3)) * -1
    tmp108 = np.copy(v.aaaa.vvvv)
    tmp108 += einsum(tmp107, (0, 1, 2, 3), t1.aa, (0, 4), (1, 3, 2, 4))
    del tmp107
    tmp80 = einsum(t2.aaaa, (0, 1, 2, 3), tmp42, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp102 = einsum(tmp101, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp101
    tmp66 = einsum(tmp64, (0, 1, 2, 3), t1.aa, (4, 2), (4, 0, 3, 1)) * -1
    del tmp64
    tmp66 += einsum(tmp65, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3)) * -1
    del tmp65
    tmp58 = einsum(tmp57, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    del tmp57
    tmp70 = einsum(tmp69, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp69
    tmp76 = einsum(tmp75, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp75
    tmp104 = einsum(tmp103, (0, 1, 2, 3), t1.aa, (4, 2), (4, 0, 1, 3))
    del tmp103
    tmp92 = np.copy(tmp85)
    tmp92 += einsum(tmp91, (0, 1, 2, 3), t2.abab, (4, 0, 5, 2), (4, 1, 5, 3)) * -1
    del tmp91
    tmp40 = np.copy(tmp38) * 2
    del tmp38
    tmp40 += tmp39
    del tmp39
    tmp54 = einsum(t2.aaaa, (0, 1, 2, 3), tmp53, (4, 5, 1, 0), (4, 5, 2, 3)) * -1
    del tmp53
    tmp52 = np.copy(f.aa.vv) * -1
    tmp52 += np.transpose(tmp44, (1, 0)) * -1
    del tmp44
    tmp52 += einsum(tmp49, (0, 1, 2, 3), t1.aa, (0, 1), (3, 2)) * -1
    del tmp49
    tmp52 += einsum(t1.aa, (0, 1), tmp51, (0, 2), (2, 1))
    del tmp51
    tmp96 = einsum(tmp95, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 1, 5, 2))
    del tmp95
    tmp109 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 5, 3, 1), (4, 5, 0, 2)) * -1
    tmp90 = np.copy(v.aaaa.oovv)
    tmp90 += einsum(tmp88, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 1, 5, 2)) * -2
    del tmp88
    tmp90 += einsum(tmp89, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -1
    del tmp89
    tmp98 = einsum(t2.aaaa, (0, 1, 2, 3), tmp97, (4, 5, 0, 1), (5, 4, 2, 3)) * -1
    del tmp97
    tmp106 = einsum(t2.aaaa, (0, 1, 2, 3), tmp105, (4, 5, 1, 0), (5, 4, 2, 3))
    del tmp105
    tmp84 = np.copy(v.aaaa.oovv)
    tmp84 += einsum(tmp81, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 1, 5, 2)) * -2
    del tmp81
    tmp84 += tmp83 * -1
    del tmp83
    tmp78 = einsum(tmp77, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp100 = einsum(tmp99, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp99
    tmp37 = einsum(t2.aaaa, (0, 1, 2, 3), tmp36, (1, 4), (0, 4, 2, 3)) * -1
    tmp94 = einsum(tmp93, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp93
    tmp32 = np.copy(t2.aaaa)
    tmp32 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1)) * 2
    tmp79 = einsum(t1.aa, (0, 1), v.aaaa.ooov, (2, 0, 3, 4), (2, 3, 1, 4))
    tmp43 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp63 = einsum(t1.aa, (0, 1), tmp1, (2, 3, 0, 4), (2, 3, 1, 4))
    tmp61 = einsum(t2.aaaa, (0, 1, 2, 3), tmp60, (4, 1), (0, 4, 2, 3)) * -2
    del tmp60
    tmp20 = np.copy(f.aa.oo)
    tmp20 += np.transpose(tmp17, (1, 0))
    del tmp17
    tmp20 += np.transpose(tmp19, (1, 0)) * -1
    del tmp19
    tmp87 = np.copy(tmp85)
    tmp87 += einsum(tmp86, (0, 1, 2, 3), t2.abab, (4, 0, 5, 2), (4, 1, 5, 3)) * -1
    del tmp86
    tmp56 = einsum(t1.aa, (0, 1), tmp55, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp55
    tmp26 = np.copy(np.transpose(tmp24, (1, 0))) * 0.5
    del tmp24
    tmp26 += np.transpose(tmp25, (1, 0))
    del tmp25
    tmp26 += einsum(t1.bb, (0, 1), tmp16, (2, 1), (2, 0)) * 0.5
    tmp23 = np.copy(t2.bbbb) * 2
    tmp23 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    tmp27 = np.copy(f.bb.vv)
    tmp27 += einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (0, 3), (1, 2)) * -1
    tmp4 = np.copy(t2.aaaa) * 2
    tmp4 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    tmp12 = np.copy(f.aa.vv)
    tmp12 += einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    t2new.bbbb = einsum(t2.bbbb, (0, 1, 2, 3), tmp31, (1, 4), (0, 4, 2, 3)) * -1
    t2new.bbbb += einsum(v.bbbb.oooo, (0, 1, 2, 3), tmp157, (3, 1, 4, 5), (0, 2, 5, 4)) * 0.5
    del tmp157
    t2new.bbbb += np.transpose(tmp158, (1, 0, 3, 2))
    del tmp158
    t2new.bbbb += np.transpose(tmp161, (0, 1, 3, 2)) * -1
    t2new.bbbb += einsum(tmp162, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 4, 0)) * -4
    del tmp162
    t2new.bbbb += np.transpose(tmp161, (1, 0, 3, 2)) * 2
    del tmp161
    t2new.bbbb += einsum(v.bbbb.oooo, (0, 1, 2, 3), tmp163, (3, 1, 4, 5), (0, 2, 5, 4)) * -0.5
    del tmp163
    t2new.bbbb += np.transpose(tmp164, (1, 0, 3, 2)) * 2
    t2new.bbbb += np.transpose(tmp165, (1, 0, 3, 2))
    t2new.bbbb += einsum(tmp167, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 1, 4)) * 2
    del tmp167
    t2new.bbbb += np.transpose(tmp164, (1, 0, 2, 3)) * -2
    t2new.bbbb += np.transpose(tmp165, (1, 0, 2, 3)) * -1
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp168, (3, 4), (0, 1, 2, 4)) * -2
    del tmp168
    t2new.bbbb += np.transpose(tmp170, (1, 0, 3, 2))
    t2new.bbbb += np.transpose(tmp172, (1, 0, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp174, (1, 0, 2, 3))
    t2new.bbbb += np.transpose(tmp174, (1, 0, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp176, (0, 1, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp170, (1, 0, 2, 3)) * -1
    t2new.bbbb += np.transpose(tmp170, (0, 1, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp172, (0, 1, 3, 2)) * 2
    del tmp172
    t2new.bbbb += tmp174 * -1
    t2new.bbbb += np.transpose(tmp174, (0, 1, 3, 2))
    del tmp174
    t2new.bbbb += np.transpose(tmp176, (1, 0, 3, 2)) * 2
    del tmp176
    t2new.bbbb += tmp170
    del tmp170
    t2new.bbbb += np.transpose(tmp177, (1, 0, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp178, (1, 0, 2, 3))
    t2new.bbbb += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    t2new.bbbb += einsum(tmp180, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (4, 0, 2, 5)) * 2
    del tmp180
    t2new.bbbb += np.transpose(tmp182, (0, 1, 3, 2))
    t2new.bbbb += np.transpose(tmp177, (0, 1, 3, 2))
    t2new.bbbb += tmp178 * -1
    t2new.bbbb += np.transpose(v.bbbb.ovov, (0, 2, 3, 1)) * -1
    t2new.bbbb += np.transpose(tmp187, (1, 0, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp188, (1, 0, 3, 2))
    t2new.bbbb += np.transpose(tmp189, (0, 1, 3, 2))
    t2new.bbbb += tmp190 * 2
    t2new.bbbb += np.transpose(tmp190, (1, 0, 3, 2)) * 2
    t2new.bbbb += einsum(tmp191, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5)) * -2
    del tmp191
    t2new.bbbb += einsum(tmp192, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5)) * -1
    del tmp192
    t2new.bbbb += np.transpose(tmp189, (1, 0, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp190, (0, 1, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp190, (1, 0, 2, 3)) * -2
    del tmp190
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp193, (4, 1, 5, 3), (0, 4, 5, 2)) * 2
    del tmp193
    t2new.bbbb += einsum(tmp194, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (4, 1, 3, 5))
    del tmp194
    t2new.bbbb += np.transpose(tmp196, (1, 0, 3, 2))
    t2new.bbbb += tmp189 * -1
    t2new.bbbb += np.transpose(tmp200, (1, 0, 2, 3)) * 2
    t2new.bbbb += np.transpose(tmp196, (0, 1, 3, 2)) * -1
    del tmp196
    t2new.bbbb += np.transpose(tmp189, (1, 0, 2, 3))
    del tmp189
    t2new.bbbb += tmp200 * -2
    del tmp200
    t2new.bbbb += np.transpose(tmp202, (0, 1, 3, 2)) * -2
    del tmp202
    t2new.bbbb += np.transpose(tmp178, (0, 1, 3, 2))
    t2new.bbbb += tmp204
    t2new.bbbb += np.transpose(tmp204, (0, 1, 3, 2)) * -1
    del tmp204
    t2new.bbbb += np.transpose(tmp206, (0, 1, 3, 2))
    t2new.bbbb += np.transpose(tmp206, (1, 0, 3, 2)) * -1
    t2new.bbbb += tmp208
    t2new.bbbb += np.transpose(tmp208, (0, 1, 3, 2)) * -1
    del tmp208
    t2new.bbbb += np.transpose(tmp210, (0, 1, 3, 2)) * -2
    del tmp210
    t2new.bbbb += np.transpose(tmp178, (1, 0, 3, 2)) * -1
    del tmp178
    t2new.bbbb += einsum(tmp212, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 2), (4, 5, 1, 3)) * -2
    del tmp212
    t2new.bbbb += np.transpose(tmp164, (0, 1, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp165, (0, 1, 3, 2)) * -1
    t2new.bbbb += tmp164 * 2
    del tmp164
    t2new.bbbb += tmp165
    del tmp165
    t2new.bbbb += np.transpose(tmp177, (1, 0, 2, 3))
    t2new.bbbb += tmp187 * -2
    t2new.bbbb += tmp182 * -1
    del tmp182
    t2new.bbbb += tmp177 * -1
    del tmp177
    t2new.bbbb += np.transpose(tmp187, (1, 0, 2, 3)) * 2
    del tmp187
    t2new.bbbb += np.transpose(tmp188, (1, 0, 2, 3)) * -1
    del tmp188
    t2new.bbbb += einsum(t1.bb, (0, 1), tmp213, (2, 3, 0, 4), (2, 3, 1, 4)) * -2
    del tmp213
    t2new.bbbb += tmp206 * -1
    t2new.bbbb += np.transpose(tmp206, (1, 0, 2, 3))
    del tmp206
    t2new.abab = einsum(tmp31, (0, 1), t2.abab, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    t2new.abab += einsum(tmp110, (0, 1, 2, 3), v.aabb.oooo, (4, 0, 5, 1), (4, 5, 2, 3)) * 0.5
    del tmp110
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), v.aabb.oooo, (4, 0, 5, 1), (4, 5, 2, 3)) * 0.5
    t2new.abab += einsum(tmp113, (0, 1), t2.abab, (2, 3, 4, 1), (2, 3, 4, 0)) * -1
    del tmp113
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp36, (0, 4), (4, 1, 2, 3)) * -1
    del tmp36
    t2new.abab += tmp114 * 2
    del tmp114
    t2new.abab += einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 4, 1, 5))
    t2new.abab += einsum(tmp48, (0, 1), t2.abab, (2, 3, 0, 4), (2, 3, 1, 4)) * -1
    t2new.abab += einsum(tmp121, (0, 1), t2.abab, (2, 3, 4, 0), (2, 3, 4, 1))
    del tmp121
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp123, (1, 4), (0, 4, 2, 3)) * -1
    del tmp123
    t2new.abab += einsum(tmp124, (0, 1, 2, 3), tmp3, (0, 3, 4, 5), (1, 2, 4, 5))
    del tmp124
    t2new.abab += einsum(t1.bb, (0, 1), tmp125, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    del tmp125
    t2new.abab += einsum(tmp11, (0, 1), t2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -1
    t2new.abab += einsum(tmp126, (0, 1, 2, 3), tmp3, (1, 2, 4, 5), (0, 3, 4, 5))
    del tmp126
    t2new.abab += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    t2new.abab += tmp127 * -1
    del tmp127
    t2new.abab += tmp128
    del tmp128
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp130, (4, 1, 2, 5), (0, 4, 5, 3)) * -1
    del tmp130
    t2new.abab += tmp131 * -1
    del tmp131
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp132, (1, 4, 2, 5), (0, 4, 5, 3))
    del tmp132
    t2new.abab += tmp85 * -1
    del tmp85
    t2new.abab += einsum(tmp133, (0, 1, 2, 3), t2.abab, (0, 4, 5, 2), (1, 4, 5, 3)) * -1
    del tmp133
    t2new.abab += einsum(t1.bb, (0, 1), tmp134, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    del tmp134
    t2new.abab += einsum(t1.aa, (0, 1), tmp135, (2, 1, 3, 4), (0, 2, 3, 4))
    del tmp135
    t2new.abab += einsum(tmp136, (0, 1, 2, 3), tmp3, (1, 3, 4, 5), (0, 2, 4, 5))
    del tmp136
    t2new.abab += einsum(tmp137, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5)) * -1
    del tmp137
    t2new.abab += einsum(tmp139, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5)) * 2
    del tmp139
    t2new.abab += einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    t2new.abab += tmp138 * 2
    del tmp138
    t2new.abab += einsum(t1.bb, (0, 1), tmp140, (2, 3, 0, 4), (2, 3, 4, 1)) * -2
    del tmp140
    t2new.abab += einsum(tmp142, (0, 1, 2, 3), t2.abab, (4, 0, 5, 2), (4, 1, 5, 3)) * -1
    del tmp142
    t2new.abab += einsum(tmp143, (0, 1, 2, 3), t2.abab, (1, 3, 4, 5), (0, 2, 4, 5))
    del tmp143
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp145, (2, 4, 3, 5), (0, 1, 4, 5))
    del tmp145
    t2new.abab += einsum(tmp148, (0, 1, 2, 3), t2.abab, (1, 4, 2, 5), (0, 4, 3, 5))
    del tmp148
    t2new.abab += einsum(t2.bbbb, (0, 1, 2, 3), tmp77, (4, 1, 5, 3), (4, 0, 5, 2)) * 2
    del tmp77
    t2new.abab += einsum(tmp151, (0, 1, 2, 3), t2.abab, (4, 1, 5, 2), (4, 0, 5, 3))
    del tmp151
    t2new.abab += einsum(tmp152, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (4, 1, 5, 3)) * 2
    del tmp152
    t2new.abab += tmp68 * -1
    del tmp68
    t2new.abab += einsum(tmp153, (0, 1, 2, 3), t2.abab, (1, 4, 5, 2), (0, 4, 5, 3)) * -1
    del tmp153
    t2new.abab += einsum(t1.aa, (0, 1), tmp154, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp154
    t2new.abab += einsum(t1.aa, (0, 1), tmp155, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp155
    t2new.abab += einsum(t1.aa, (0, 1), tmp156, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp156
    t2new.aaaa = einsum(t2.aaaa, (0, 1, 2, 3), tmp20, (1, 4), (0, 4, 2, 3)) * -1
    t2new.aaaa += einsum(tmp32, (0, 1, 2, 3), v.aaaa.oooo, (4, 1, 5, 0), (4, 5, 3, 2)) * 0.5
    del tmp32
    t2new.aaaa += np.transpose(tmp33, (1, 0, 3, 2))
    del tmp33
    t2new.aaaa += np.transpose(tmp37, (0, 1, 3, 2)) * -1
    t2new.aaaa += einsum(tmp40, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 4, 0)) * -2
    del tmp40
    t2new.aaaa += np.transpose(tmp37, (1, 0, 3, 2)) * 2
    del tmp37
    t2new.aaaa += einsum(v.aaaa.oooo, (0, 1, 2, 3), tmp41, (3, 1, 4, 5), (0, 2, 5, 4)) * -0.5
    del tmp41
    t2new.aaaa += np.transpose(tmp42, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp43, (1, 0, 3, 2)) * 2
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp48, (3, 4), (0, 1, 4, 2)) * 2
    del tmp48
    t2new.aaaa += np.transpose(tmp42, (1, 0, 2, 3)) * -1
    t2new.aaaa += np.transpose(tmp43, (1, 0, 2, 3)) * -2
    t2new.aaaa += einsum(tmp52, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    del tmp52
    t2new.aaaa += np.transpose(tmp54, (1, 0, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp56, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp58, (1, 0, 2, 3))
    t2new.aaaa += np.transpose(tmp58, (1, 0, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp61, (0, 1, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp56, (1, 0, 2, 3)) * -1
    t2new.aaaa += np.transpose(tmp54, (0, 1, 3, 2)) * 2
    del tmp54
    t2new.aaaa += np.transpose(tmp56, (0, 1, 3, 2)) * -1
    t2new.aaaa += tmp58 * -1
    t2new.aaaa += np.transpose(tmp58, (0, 1, 3, 2))
    del tmp58
    t2new.aaaa += np.transpose(tmp61, (1, 0, 3, 2)) * 2
    del tmp61
    t2new.aaaa += tmp56
    del tmp56
    t2new.aaaa += np.transpose(tmp62, (1, 0, 2, 3))
    t2new.aaaa += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    t2new.aaaa += np.transpose(tmp63, (1, 0, 3, 2)) * -1
    t2new.aaaa += einsum(tmp66, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 2, 5)) * 2
    del tmp66
    t2new.aaaa += np.transpose(tmp70, (0, 1, 3, 2))
    t2new.aaaa += tmp62 * -1
    t2new.aaaa += np.transpose(v.aaaa.ovov, (0, 2, 3, 1)) * -1
    t2new.aaaa += np.transpose(tmp63, (0, 1, 3, 2))
    t2new.aaaa += np.transpose(tmp76, (1, 0, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp78, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp79, (0, 1, 3, 2))
    t2new.aaaa += tmp80 * 2
    t2new.aaaa += np.transpose(tmp80, (1, 0, 3, 2)) * 2
    t2new.aaaa += einsum(tmp84, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (0, 4, 2, 5)) * -2
    del tmp84
    t2new.aaaa += einsum(tmp87, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (0, 4, 2, 5)) * -1
    del tmp87
    t2new.aaaa += np.transpose(tmp79, (1, 0, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp80, (0, 1, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp80, (1, 0, 2, 3)) * -2
    del tmp80
    t2new.aaaa += einsum(tmp90, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 2, 5)) * 2
    del tmp90
    t2new.aaaa += einsum(t2.abab, (0, 1, 2, 3), tmp92, (4, 1, 5, 3), (0, 4, 5, 2))
    del tmp92
    t2new.aaaa += tmp79 * -1
    t2new.aaaa += np.transpose(tmp94, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp96, (1, 0, 2, 3)) * 2
    t2new.aaaa += np.transpose(tmp79, (1, 0, 2, 3))
    del tmp79
    t2new.aaaa += np.transpose(tmp94, (0, 1, 3, 2)) * -1
    del tmp94
    t2new.aaaa += tmp96 * -2
    del tmp96
    t2new.aaaa += np.transpose(tmp62, (0, 1, 3, 2))
    t2new.aaaa += np.transpose(tmp98, (0, 1, 3, 2)) * -2
    del tmp98
    t2new.aaaa += np.transpose(tmp100, (0, 1, 3, 2))
    t2new.aaaa += np.transpose(tmp100, (1, 0, 3, 2)) * -1
    t2new.aaaa += tmp102
    t2new.aaaa += np.transpose(tmp102, (0, 1, 3, 2)) * -1
    del tmp102
    t2new.aaaa += tmp104
    t2new.aaaa += np.transpose(tmp104, (0, 1, 3, 2)) * -1
    del tmp104
    t2new.aaaa += np.transpose(tmp62, (1, 0, 3, 2)) * -1
    del tmp62
    t2new.aaaa += np.transpose(tmp106, (0, 1, 3, 2)) * -2
    del tmp106
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp108, (2, 4, 3, 5), (0, 1, 4, 5)) * 2
    del tmp108
    t2new.aaaa += np.transpose(tmp42, (0, 1, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp43, (0, 1, 3, 2)) * -2
    t2new.aaaa += tmp42
    del tmp42
    t2new.aaaa += tmp43 * 2
    del tmp43
    t2new.aaaa += np.transpose(tmp63, (1, 0, 2, 3))
    t2new.aaaa += tmp76 * -2
    t2new.aaaa += tmp70 * -1
    del tmp70
    t2new.aaaa += tmp63 * -1
    del tmp63
    t2new.aaaa += np.transpose(tmp76, (1, 0, 2, 3)) * 2
    del tmp76
    t2new.aaaa += np.transpose(tmp78, (1, 0, 2, 3)) * -1
    del tmp78
    t2new.aaaa += einsum(tmp109, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3)) * -2
    del tmp109
    t2new.aaaa += tmp100 * -1
    t2new.aaaa += np.transpose(tmp100, (1, 0, 2, 3))
    del tmp100
    t1new.bb = einsum(tmp21, (0, 1, 2, 3), t2.abab, (0, 2, 3, 4), (1, 4)) * -1
    del tmp21
    t1new.bb += f.bb.ov
    t1new.bb += tmp13
    del tmp13
    t1new.bb += einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), tmp22, (4, 1, 0, 3), (4, 2)) * -2
    del tmp22
    t1new.bb += einsum(tmp3, (0, 1, 2, 3), v.aabb.ovvv, (0, 2, 4, 3), (1, 4))
    t1new.bb += einsum(v.bbbb.ovvv, (0, 1, 2, 3), tmp23, (0, 4, 1, 3), (4, 2))
    del tmp23
    t1new.bb += einsum(t1.bb, (0, 1), tmp26, (0, 2), (2, 1)) * -2
    del tmp26
    t1new.bb += einsum(t1.bb, (0, 1), tmp27, (1, 2), (0, 2))
    del tmp27
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 0, 1, 3), (4, 2)) * -2
    t1new.bb += einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 3, 1, 4), (2, 4)) * -1
    t1new.bb += einsum(v.bbbb.oovv, (0, 1, 2, 3), t1.bb, (1, 3), (0, 2)) * -1
    t1new.bb += einsum(tmp9, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), tmp16, (1, 3), (0, 2)) * 2
    t1new.bb += einsum(t1.bb, (0, 1), tmp31, (0, 2), (2, 1)) * -1
    del tmp31
    t1new.aa = einsum(t2.abab, (0, 1, 2, 3), tmp0, (4, 0, 1, 3), (4, 2)) * -1
    del tmp0
    t1new.aa += einsum(tmp1, (0, 1, 2, 3), t2.aaaa, (2, 1, 4, 3), (0, 4)) * -2
    del tmp1
    t1new.aa += tmp2
    del tmp2
    t1new.aa += f.aa.ov
    t1new.aa += einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 3, 0, 1), (2, 3))
    t1new.aa += einsum(tmp3, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 1, 3), (0, 4))
    del tmp3
    t1new.aa += einsum(v.aaaa.ovvv, (0, 1, 2, 3), tmp4, (0, 4, 3, 1), (4, 2)) * -1
    del tmp4
    t1new.aa += einsum(tmp11, (0, 1), t1.aa, (0, 2), (1, 2)) * -1
    del tmp11
    t1new.aa += einsum(t1.aa, (0, 1), tmp12, (1, 2), (0, 2))
    del tmp12
    t1new.aa += einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 0, 1, 3), (4, 2)) * -2
    t1new.aa += einsum(t1.aa, (0, 1), v.aaaa.oovv, (2, 0, 3, 1), (2, 3)) * -1
    t1new.aa += einsum(t2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 0, 1, 3), (4, 2)) * -1
    t1new.aa += einsum(tmp16, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    del tmp16
    t1new.aa += einsum(t2.aaaa, (0, 1, 2, 3), tmp9, (1, 3), (0, 2)) * 2
    del tmp9
    t1new.aa += einsum(t1.aa, (0, 1), tmp20, (0, 2), (2, 1)) * -1
    del tmp20

    return {f"t1new": t1new, f"t2new": t2new}

def update_lams(f=None, l1=None, l2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:39:42.275145.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    l1new : Namespace of arrays
        Updated L1 residuals.
    l2new : Namespace of arrays
        Updated L2 residuals.
    """

    l1new = Namespace()
    l2new = Namespace()
    tmp98 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1)))
    tmp98 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3)) * -1
    tmp7 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1))) * -1
    tmp7 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp97 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp99 = einsum(tmp98, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3))
    del tmp98
    tmp8 = einsum(t1.aa, (0, 1), tmp7, (0, 2, 3, 1), (2, 3))
    del tmp7
    tmp6 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp2 = einsum(t1.bb, (0, 1), v.aabb.ovov, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp100 = np.copy(f.bb.ov)
    tmp100 += tmp97
    tmp100 += tmp99 * -1
    del tmp99
    tmp117 = np.copy(v.bbbb.ooov)
    tmp117 += np.transpose(v.bbbb.ovoo, (0, 2, 3, 1)) * -1
    tmp111 = np.copy(v.bbbb.ovvv) * -1
    tmp111 += np.transpose(v.bbbb.ovvv, (0, 2, 1, 3))
    tmp52 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp196 = np.copy(v.bbbb.ovvv)
    tmp196 += np.transpose(v.bbbb.ovvv, (0, 2, 1, 3)) * -1
    tmp212 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 3, 1)))
    tmp212 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3)) * -1
    tmp50 = einsum(t1.bb, (0, 1), l2.abab, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp31 = np.copy(v.aaaa.ovvv)
    tmp31 += np.transpose(v.aaaa.ovvv, (0, 2, 3, 1)) * -1
    tmp38 = einsum(l2.aaaa, (0, 1, 2, 3), t1.aa, (4, 1), (2, 3, 4, 0))
    tmp180 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 3, 1))) * -1
    tmp180 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp164 = np.copy(v.aaaa.ovvv) * -1
    tmp164 += np.transpose(v.aaaa.ovvv, (0, 2, 1, 3))
    tmp63 = np.copy(v.aaaa.ooov) * -1
    tmp63 += np.transpose(v.aaaa.ovoo, (0, 2, 3, 1))
    tmp9 = np.copy(f.aa.ov)
    tmp9 += tmp6
    tmp9 += tmp8 * -1
    del tmp8
    tmp14 = np.copy(np.transpose(v.aabb.ovoo, (0, 2, 3, 1)))
    tmp14 += tmp2
    tmp95 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 2, 1))
    tmp55 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    tmp56 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 0, 1), (2, 4))
    tmp54 = einsum(t1.bb, (0, 1), l1.bb, (1, 2), (2, 0))
    tmp0 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 2, 1))
    tmp43 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (2, 4))
    tmp42 = einsum(l1.aa, (0, 1), t1.aa, (2, 0), (1, 2))
    tmp44 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    tmp115 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp114 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp116 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 3, 1), (4, 0)) * -1
    tmp119 = einsum(tmp100, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp118 = einsum(t1.bb, (0, 1), tmp117, (0, 2, 3, 1), (2, 3))
    del tmp117
    tmp125 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 5), (3, 4, 1, 5))
    tmp126 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp142 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp210 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 4, 1, 3), (2, 4))
    tmp245 = einsum(t1.bb, (0, 1), tmp111, (0, 2, 1, 3), (2, 3))
    tmp209 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 1, 4), (4, 3))
    tmp137 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp135 = einsum(t1.bb, (0, 1), tmp52, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp33 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    tmp34 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 1), (0, 4))
    tmp197 = einsum(t1.bb, (0, 1), tmp196, (2, 1, 3, 4), (2, 0, 3, 4))
    del tmp196
    tmp195 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp194 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 5), (4, 2, 5, 3))
    tmp201 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp199 = einsum(t1.aa, (0, 1), v.aabb.vvov, (2, 1, 3, 4), (0, 3, 2, 4))
    tmp200 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovov, (1, 3, 4, 5), (0, 4, 2, 5))
    tmp213 = einsum(tmp212, (0, 1, 2, 3), t1.bb, (0, 2), (1, 3))
    del tmp212
    tmp77 = einsum(t1.aa, (0, 1), tmp50, (2, 3, 4, 1), (2, 0, 3, 4))
    tmp76 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 5, 0, 1), (2, 4, 3, 5))
    tmp28 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4))
    tmp29 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    tmp176 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (4, 1))
    tmp177 = einsum(tmp31, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp91 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp175 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (0, 4, 1, 3), (2, 4))
    tmp83 = einsum(t1.aa, (0, 1), tmp38, (2, 3, 4, 1), (3, 2, 4, 0))
    tmp86 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp181 = einsum(t1.aa, (0, 1), tmp180, (0, 2, 3, 1), (2, 3))
    del tmp180
    tmp10 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 1, 2))
    tmp158 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 4, 1, 5))
    tmp159 = einsum(t2.bbbb, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp156 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp155 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp165 = einsum(tmp164, (0, 1, 2, 3), t1.aa, (4, 2), (0, 4, 1, 3))
    del tmp164
    tmp62 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 3), (4, 0))
    tmp61 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 1, 3), (4, 0))
    tmp64 = einsum(tmp63, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    del tmp63
    tmp60 = einsum(t1.bb, (0, 1), v.aabb.ooov, (2, 3, 0, 1), (2, 3))
    tmp65 = einsum(tmp9, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp73 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp74 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp101 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 2, 0, 1))
    tmp13 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp12 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp15 = einsum(tmp14, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp4 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp107 = einsum(t1.bb, (0, 1), tmp95, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp108 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp106 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp40 = einsum(l2.abab, (0, 1, 2, 3), t1.aa, (4, 0), (2, 4, 3, 1))
    tmp57 = np.copy(tmp54)
    tmp57 += tmp55
    tmp57 += tmp56 * 2
    tmp24 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp23 = einsum(t1.aa, (0, 1), tmp0, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp22 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    tmp20 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp45 = np.copy(tmp42) * 0.5
    tmp45 += tmp43
    tmp45 += tmp44 * 0.5
    tmp120 = np.copy(f.bb.oo)
    tmp120 += np.transpose(tmp114, (1, 0))
    del tmp114
    tmp120 += tmp115
    del tmp115
    tmp120 += tmp116 * 2
    del tmp116
    tmp120 += tmp118 * -1
    del tmp118
    tmp120 += tmp119
    del tmp119
    tmp228 = np.copy(np.transpose(v.bbbb.ooov, (0, 2, 1, 3)))
    tmp228 += tmp95
    tmp255 = np.copy(tmp125)
    tmp255 += tmp126 * 4
    tmp203 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp246 = np.copy(f.bb.vv) * -1
    tmp246 += np.transpose(tmp142, (1, 0)) * -1
    tmp246 += np.transpose(tmp209, (1, 0))
    tmp246 += np.transpose(tmp210, (1, 0)) * 2
    tmp246 += tmp245 * -1
    del tmp245
    tmp243 = np.copy(np.transpose(tmp137, (1, 0, 3, 2)))
    tmp243 += np.transpose(tmp135, (0, 1, 3, 2)) * -1
    tmp225 = np.copy(tmp33)
    tmp225 += tmp34 * 2
    tmp198 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 1, 3)))
    tmp198 += v.bbbb.oovv * -1
    tmp198 += tmp194
    tmp198 += tmp195 * 2
    tmp198 += np.transpose(tmp197, (1, 0, 3, 2)) * -1
    del tmp197
    tmp202 = np.copy(np.transpose(v.aabb.ovov, (0, 2, 1, 3)))
    tmp202 += tmp199
    tmp202 += tmp200 * 2
    tmp202 += tmp201
    tmp221 = np.copy(tmp54) * 0.5
    del tmp54
    tmp221 += tmp55 * 0.5
    del tmp55
    tmp221 += tmp56
    del tmp56
    tmp214 = np.copy(f.bb.ov)
    tmp214 += tmp97
    tmp214 += tmp213 * -1
    del tmp213
    tmp143 = np.copy(v.bbbb.ovvv)
    tmp143 += np.transpose(v.bbbb.ovvv, (0, 2, 1, 3)) * -1
    tmp70 = einsum(t2.bbbb, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp69 = einsum(l2.aaaa, (0, 1, 2, 3), t2.abab, (3, 4, 1, 5), (2, 4, 0, 5))
    tmp78 = np.copy(tmp76)
    tmp78 += tmp77
    tmp72 = np.copy(v.aaaa.ovvv)
    tmp72 += np.transpose(v.aaaa.ovvv, (0, 2, 1, 3)) * -1
    tmp123 = einsum(t2.abab, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (0, 5, 2, 4))
    tmp122 = einsum(l2.abab, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 0), (4, 3, 5, 1))
    tmp162 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 3, 0, 1), (2, 3))
    tmp3 = np.copy(np.transpose(v.aabb.ovoo, (0, 2, 3, 1)))
    tmp3 += np.transpose(tmp2, (0, 2, 1, 3))
    tmp94 = np.copy(tmp42)
    del tmp42
    tmp94 += tmp43 * 2
    del tmp43
    tmp94 += tmp44
    del tmp44
    tmp145 = np.copy(tmp28)
    tmp145 += tmp29 * 0.5
    tmp178 = np.copy(f.aa.vv) * -1
    tmp178 += np.transpose(tmp91, (1, 0)) * -1
    tmp178 += np.transpose(tmp175, (1, 0)) * 2
    tmp178 += np.transpose(tmp176, (1, 0))
    tmp178 += np.transpose(tmp177, (1, 0)) * -1
    del tmp177
    tmp92 = np.copy(v.aaaa.ovvv) * -1
    tmp92 += np.transpose(v.aaaa.ovvv, (0, 2, 1, 3))
    tmp173 = np.copy(np.transpose(tmp86, (1, 0, 3, 2)))
    tmp173 += np.transpose(tmp83, (0, 1, 3, 2)) * -1
    tmp182 = np.copy(f.aa.ov)
    tmp182 += tmp6
    tmp182 += tmp181 * -1
    del tmp181
    tmp148 = np.copy(np.transpose(v.aaaa.ooov, (0, 2, 1, 3)))
    tmp148 += tmp0
    tmp168 = np.copy(np.transpose(v.aabb.ovov, (0, 2, 1, 3)))
    tmp168 += tmp10
    tmp168 += tmp158
    tmp168 += tmp159 * 2
    tmp166 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 1, 3)))
    tmp166 += v.aaaa.oovv * -1
    tmp166 += tmp155 * 2
    tmp166 += tmp156
    tmp166 += np.transpose(tmp165, (1, 0, 3, 2)) * -1
    del tmp165
    tmp66 = np.copy(f.aa.oo)
    tmp66 += np.transpose(tmp60, (1, 0))
    del tmp60
    tmp66 += tmp61 * 2
    del tmp61
    tmp66 += tmp62
    del tmp62
    tmp66 += np.transpose(tmp64, (1, 0)) * -1
    del tmp64
    tmp66 += tmp65
    del tmp65
    tmp75 = np.copy(tmp73) * 4
    del tmp73
    tmp75 += tmp74
    del tmp74
    tmp51 = einsum(tmp50, (0, 1, 2, 3), t2.abab, (0, 1, 3, 4), (2, 4))
    tmp49 = einsum(l1.bb, (0, 1), t2.bbbb, (2, 1, 3, 0), (2, 3))
    tmp53 = einsum(tmp52, (0, 1, 2, 3), t2.bbbb, (1, 0, 4, 3), (2, 4))
    tmp48 = einsum(l1.aa, (0, 1), t2.abab, (1, 2, 0, 3), (2, 3))
    tmp27 = einsum(l1.aa, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp102 = np.copy(np.transpose(v.aabb.vvoo, (2, 3, 0, 1)))
    tmp102 += np.transpose(tmp101, (1, 0, 3, 2))
    tmp96 = np.copy(v.bbbb.ooov) * -1
    tmp96 += np.transpose(v.bbbb.ovoo, (0, 2, 3, 1))
    tmp96 += np.transpose(tmp95, (1, 0, 2, 3))
    tmp96 += np.transpose(tmp95, (2, 0, 1, 3)) * -1
    tmp16 = np.copy(v.aabb.oooo)
    tmp16 += np.transpose(tmp12, (1, 0, 3, 2))
    tmp16 += np.transpose(tmp13, (1, 0, 3, 2))
    tmp16 += np.transpose(tmp15, (1, 0, 3, 2))
    del tmp15
    tmp5 = np.copy(v.aabb.ooov)
    tmp5 += np.transpose(tmp4, (1, 0, 2, 3))
    tmp32 = einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp133 = einsum(t2.abab, (0, 1, 2, 3), tmp50, (0, 4, 5, 2), (4, 5, 1, 3))
    tmp134 = einsum(t2.bbbb, (0, 1, 2, 3), tmp52, (4, 1, 5, 3), (4, 5, 0, 2)) * -1
    tmp105 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 1, 3)))
    tmp105 += v.bbbb.oovv * -1
    tmp105 += einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 2, 1))
    tmp104 = np.copy(v.bbbb.ooov) * -1
    tmp104 += np.transpose(v.bbbb.ooov, (0, 2, 1, 3))
    tmp104 += tmp95
    tmp104 += np.transpose(tmp95, (0, 2, 1, 3)) * -1
    tmp109 = np.copy(v.bbbb.oooo)
    tmp109 += np.transpose(tmp106, (3, 1, 2, 0))
    tmp109 += np.transpose(tmp107, (3, 1, 2, 0))
    tmp109 += np.transpose(tmp108, (2, 1, 3, 0))
    tmp109 += np.transpose(tmp108, (3, 2, 1, 0)) * -1
    tmp37 = einsum(l1.bb, (0, 1), t2.abab, (2, 1, 3, 0), (2, 3))
    tmp41 = einsum(tmp40, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (1, 4))
    tmp39 = einsum(t2.aaaa, (0, 1, 2, 3), tmp38, (1, 0, 4, 3), (4, 2))
    tmp36 = einsum(l1.aa, (0, 1), t2.aaaa, (2, 1, 3, 0), (2, 3))
    tmp58 = einsum(t1.bb, (0, 1), tmp57, (0, 2), (2, 1))
    tmp82 = einsum(tmp38, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (0, 2, 4, 5)) * -1
    tmp84 = einsum(tmp40, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp25 = np.copy(v.aaaa.oooo)
    tmp25 += np.transpose(tmp22, (3, 1, 2, 0))
    tmp25 += np.transpose(tmp23, (3, 1, 2, 0))
    tmp25 += np.transpose(tmp24, (2, 1, 3, 0))
    tmp25 += np.transpose(tmp24, (3, 2, 1, 0)) * -1
    tmp21 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 1, 3)))
    tmp21 += v.aaaa.oovv * -1
    tmp21 += np.transpose(tmp20, (0, 1, 3, 2))
    tmp18 = np.copy(v.aaaa.ooov) * -1
    tmp18 += np.transpose(v.aaaa.ooov, (0, 2, 1, 3))
    tmp18 += tmp0
    tmp18 += np.transpose(tmp0, (0, 2, 1, 3)) * -1
    tmp19 = np.copy(v.aabb.ooov)
    tmp19 += tmp4
    tmp46 = einsum(tmp45, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp11 = np.copy(np.transpose(v.aabb.ovov, (0, 2, 1, 3)))
    tmp11 += tmp10
    tmp1 = np.copy(v.aaaa.ooov) * -1
    tmp1 += np.transpose(v.aaaa.ovoo, (0, 2, 3, 1))
    tmp1 += np.transpose(tmp0, (1, 0, 2, 3))
    tmp1 += np.transpose(tmp0, (2, 0, 1, 3)) * -1
    tmp241 = einsum(v.bbbb.vvvv, (0, 1, 2, 3), l2.bbbb, (3, 1, 4, 5), (4, 5, 0, 2)) * -1
    tmp234 = einsum(tmp40, (0, 1, 2, 3), v.aabb.ooov, (1, 0, 4, 5), (2, 4, 3, 5))
    tmp249 = einsum(tmp108, (0, 1, 2, 3), l2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    del tmp108
    tmp223 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 1), (0, 3))
    tmp236 = np.copy(np.transpose(v.aabb.ovov, (0, 2, 1, 3)))
    tmp236 += tmp199
    del tmp199
    tmp236 += tmp200 * 2
    del tmp200
    tmp236 += tmp201
    del tmp201
    tmp231 = einsum(tmp95, (0, 1, 2, 3), tmp52, (0, 4, 2, 5), (4, 1, 5, 3)) * -1
    tmp237 = einsum(tmp120, (0, 1), l2.bbbb, (2, 3, 4, 0), (4, 1, 2, 3)) * -2
    tmp229 = einsum(l1.bb, (0, 1), tmp228, (1, 2, 3, 4), (2, 3, 4, 0))
    del tmp228
    tmp233 = einsum(tmp40, (0, 1, 2, 3), tmp4, (0, 1, 4, 5), (2, 4, 3, 5))
    tmp256 = einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp255, (4, 2, 5, 1), (4, 0, 5, 3))
    del tmp255
    tmp238 = np.copy(f.bb.ov)
    tmp238 += tmp97
    tmp238 += tmp203
    tmp204 = np.copy(f.bb.ov)
    tmp204 += tmp97
    del tmp97
    tmp204 += tmp203
    del tmp203
    tmp247 = einsum(l2.bbbb, (0, 1, 2, 3), tmp246, (4, 1), (2, 3, 4, 0)) * -1
    del tmp246
    tmp244 = einsum(tmp243, (0, 1, 2, 3), v.bbbb.ovov, (2, 4, 3, 5), (0, 1, 4, 5)) * 0.5
    del tmp243
    tmp226 = einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp225, (4, 1), (0, 2, 4, 3))
    tmp251 = einsum(tmp225, (0, 1), v.bbbb.ovov, (2, 3, 4, 1), (2, 4, 0, 3))
    del tmp225
    tmp239 = einsum(l2.bbbb, (0, 1, 2, 3), tmp198, (3, 4, 1, 5), (4, 2, 5, 0))
    tmp240 = einsum(tmp202, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (1, 5, 3, 4))
    tmp253 = einsum(tmp52, (0, 1, 2, 3), tmp95, (1, 2, 4, 5), (0, 4, 3, 5))
    tmp258 = einsum(tmp221, (0, 1), v.bbbb.ovov, (2, 3, 1, 4), (0, 2, 4, 3)) * 2
    tmp230 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), l1.bb, (3, 4), (4, 0, 1, 2))
    tmp242 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), tmp52, (4, 5, 0, 3), (5, 4, 1, 2))
    tmp248 = einsum(tmp214, (0, 1), tmp52, (2, 3, 0, 4), (2, 3, 1, 4))
    tmp232 = einsum(v.bbbb.ovoo, (0, 1, 2, 3), tmp52, (3, 4, 2, 5), (4, 0, 5, 1)) * -1
    tmp254 = einsum(v.bbbb.ooov, (0, 1, 2, 3), tmp52, (1, 4, 2, 5), (4, 0, 5, 3)) * -1
    tmp235 = np.copy(np.transpose(v.bbbb.ovov, (0, 2, 1, 3)))
    tmp235 += v.bbbb.oovv * -1
    tmp235 += tmp194
    del tmp194
    tmp235 += tmp195 * 2
    del tmp195
    tmp235 += einsum(tmp143, (0, 1, 2, 3), t1.bb, (4, 1), (4, 0, 3, 2)) * -1
    tmp227 = np.copy(v.bbbb.ooov)
    tmp227 += np.transpose(tmp95, (0, 2, 1, 3))
    tmp252 = np.copy(v.bbbb.ooov)
    tmp252 += np.transpose(tmp95, (0, 2, 1, 3))
    tmp250 = np.copy(v.bbbb.oooo) * -1
    tmp250 += np.transpose(tmp106, (1, 3, 0, 2)) * -1
    del tmp106
    tmp250 += np.transpose(tmp107, (0, 3, 1, 2))
    del tmp107
    tmp257 = einsum(tmp57, (0, 1), v.bbbb.ovov, (2, 3, 1, 4), (2, 0, 4, 3))
    tmp218 = np.copy(v.aabb.oovv)
    tmp218 += einsum(t1.aa, (0, 1), v.aabb.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp216 = np.copy(v.aabb.ooov)
    tmp216 += tmp4
    tmp206 = einsum(l2.abab, (0, 1, 2, 3), v.aabb.vvvv, (4, 0, 5, 1), (2, 3, 4, 5))
    tmp224 = np.copy(tmp69)
    tmp224 += tmp70
    tmp219 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (4, 2, 5, 1))
    tmp205 = np.copy(np.transpose(v.aabb.vvoo, (2, 3, 0, 1)))
    tmp205 += np.transpose(tmp101, (0, 1, 3, 2))
    del tmp101
    tmp207 = einsum(v.aabb.ovov, (0, 1, 2, 3), tmp78, (4, 0, 5, 2), (4, 5, 1, 3)) * 0.5
    tmp208 = np.copy(f.aa.vv) * -1
    tmp208 += np.transpose(tmp91, (1, 0)) * -1
    tmp208 += tmp175 * 2
    del tmp175
    tmp208 += tmp176
    del tmp176
    tmp208 += einsum(tmp72, (0, 1, 2, 3), t1.aa, (0, 1), (3, 2)) * -1
    tmp222 = np.copy(tmp122)
    tmp222 += tmp123
    tmp193 = np.copy(tmp33) * 0.5
    tmp193 += tmp34
    tmp211 = np.copy(f.bb.vv) * -0.5
    tmp211 += np.transpose(tmp142, (1, 0)) * -0.5
    tmp211 += tmp209 * 0.5
    del tmp209
    tmp211 += tmp210
    del tmp210
    tmp211 += einsum(tmp111, (0, 1, 2, 3), t1.bb, (0, 2), (3, 1)) * -0.5
    tmp170 = np.copy(f.aa.ov)
    tmp170 += tmp162
    tmp170 += tmp6
    tmp217 = np.copy(v.aabb.oooo)
    tmp217 += np.transpose(tmp12, (1, 0, 2, 3))
    del tmp12
    tmp217 += tmp13
    del tmp13
    tmp217 += einsum(tmp3, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 2, 1))
    tmp189 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 1, 0, 3), (2, 3))
    tmp220 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 5), (4, 0, 5, 3))
    tmp215 = np.copy(tmp28) * 2
    tmp215 += tmp29
    tmp192 = einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp94, (4, 2), (0, 4, 3, 1))
    tmp186 = einsum(tmp145, (0, 1), v.aaaa.ovov, (2, 3, 4, 1), (2, 4, 0, 3)) * 2
    tmp146 = einsum(tmp145, (0, 1), v.aaaa.ovov, (2, 1, 3, 4), (2, 3, 0, 4)) * 2
    del tmp145
    tmp184 = einsum(l2.aaaa, (0, 1, 2, 3), tmp24, (2, 3, 4, 5), (4, 5, 0, 1))
    del tmp24
    tmp171 = einsum(l2.aaaa, (0, 1, 2, 3), v.aaaa.vvvv, (4, 0, 5, 1), (2, 3, 4, 5))
    tmp185 = np.copy(v.aaaa.oooo) * -1
    tmp185 += np.transpose(tmp22, (1, 3, 0, 2)) * -1
    del tmp22
    tmp185 += np.transpose(tmp23, (0, 3, 1, 2))
    del tmp23
    tmp190 = einsum(tmp0, (0, 1, 2, 3), tmp38, (4, 0, 1, 5), (4, 2, 5, 3))
    tmp179 = einsum(l2.aaaa, (0, 1, 2, 3), tmp178, (4, 1), (2, 3, 4, 0)) * -1
    del tmp178
    tmp150 = einsum(l1.aa, (0, 1), v.aaaa.ovvv, (2, 3, 4, 0), (1, 2, 3, 4))
    tmp152 = einsum(tmp50, (0, 1, 2, 3), v.aabb.ovoo, (4, 5, 2, 1), (0, 4, 3, 5))
    tmp157 = np.copy(np.transpose(v.aaaa.ovov, (0, 2, 1, 3)))
    tmp157 += v.aaaa.oovv * -1
    tmp157 += tmp155 * 2
    del tmp155
    tmp157 += tmp156
    del tmp156
    tmp157 += einsum(tmp92, (0, 1, 2, 3), t1.aa, (4, 2), (4, 0, 3, 1)) * -1
    tmp174 = einsum(tmp173, (0, 1, 2, 3), v.aaaa.ovov, (2, 4, 3, 5), (0, 1, 4, 5)) * 0.5
    del tmp173
    tmp160 = np.copy(np.transpose(v.aabb.ovov, (0, 2, 1, 3)))
    tmp160 += tmp10
    del tmp10
    tmp160 += tmp158
    del tmp158
    tmp160 += tmp159 * 2
    del tmp159
    tmp183 = einsum(tmp38, (0, 1, 2, 3), tmp182, (2, 4), (0, 1, 4, 3))
    tmp154 = einsum(tmp38, (0, 1, 2, 3), v.aaaa.ovoo, (4, 5, 2, 0), (1, 4, 3, 5)) * -1
    tmp172 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), tmp38, (4, 5, 0, 3), (5, 4, 1, 2))
    tmp188 = einsum(tmp38, (0, 1, 2, 3), v.aaaa.ooov, (4, 0, 2, 5), (1, 4, 3, 5)) * -1
    tmp149 = einsum(l1.aa, (0, 1), tmp148, (1, 2, 3, 4), (2, 3, 4, 0))
    del tmp148
    tmp151 = einsum(tmp2, (0, 1, 2, 3), tmp50, (4, 1, 2, 5), (4, 0, 5, 3))
    tmp187 = np.copy(v.aaaa.ooov)
    tmp187 += np.transpose(tmp0, (0, 2, 1, 3))
    tmp169 = einsum(l2.abab, (0, 1, 2, 3), tmp168, (4, 3, 5, 1), (4, 2, 5, 0))
    tmp167 = einsum(l2.aaaa, (0, 1, 2, 3), tmp166, (3, 4, 1, 5), (4, 2, 5, 0))
    tmp147 = np.copy(v.aaaa.ooov)
    tmp147 += np.transpose(tmp0, (0, 2, 1, 3))
    tmp161 = einsum(tmp66, (0, 1), l2.aaaa, (2, 3, 4, 0), (4, 1, 2, 3)) * -2
    tmp191 = einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp75, (4, 2, 5, 1), (0, 4, 3, 5))
    tmp153 = einsum(tmp0, (0, 1, 2, 3), tmp38, (0, 4, 2, 5), (4, 1, 5, 3)) * -1
    tmp163 = np.copy(f.aa.ov)
    tmp163 += tmp162
    del tmp162
    tmp163 += tmp6
    del tmp6
    tmp121 = einsum(t1.aa, (0, 1), v.aabb.vvvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp128 = einsum(l1.bb, (0, 1), t2.abab, (2, 3, 4, 0), (2, 1, 3, 4))
    tmp128 += tmp50
    tmp128 += einsum(t2.aaaa, (0, 1, 2, 3), tmp50, (1, 4, 5, 3), (0, 4, 5, 2)) * 2
    tmp128 += einsum(tmp40, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (1, 2, 4, 5)) * -1
    tmp128 += einsum(tmp52, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 2, 5)) * -2
    tmp128 += einsum(t1.aa, (0, 1), tmp78, (0, 2, 3, 4), (2, 3, 4, 1)) * -1
    tmp141 = np.copy(t1.bb) * -0.5
    tmp141 += tmp48 * -0.5
    tmp141 += tmp49 * -1
    tmp141 += tmp51 * 0.5
    tmp141 += tmp53
    tmp141 += einsum(t1.bb, (0, 1), tmp57, (0, 2), (2, 1)) * 0.5
    tmp112 = np.copy(tmp27) * 0.5
    tmp112 += tmp28
    tmp112 += tmp29 * 0.5
    tmp140 = np.copy(tmp76)
    tmp140 += np.transpose(tmp77, (1, 0, 2, 3))
    tmp124 = np.copy(np.transpose(l2.abab, (2, 3, 0, 1)))
    tmp124 += tmp122 * 2
    del tmp122
    tmp124 += einsum(tmp40, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -1
    tmp124 += tmp123 * 2
    del tmp123
    tmp103 = np.copy(np.transpose(v.aabb.ovoo, (0, 2, 3, 1)))
    tmp103 += tmp2
    tmp103 += einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 5, 3), (0, 1, 5, 4))
    tmp103 += einsum(tmp96, (0, 1, 2, 3), t2.abab, (4, 0, 5, 3), (4, 1, 2, 5))
    del tmp96
    tmp103 += einsum(tmp3, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 2, 1, 5)) * 2
    tmp103 += einsum(tmp5, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (1, 4, 2, 5)) * -1
    tmp103 += einsum(tmp100, (0, 1), t2.abab, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp103 += einsum(tmp102, (0, 1, 2, 3), t1.aa, (4, 2), (4, 1, 0, 3))
    del tmp102
    tmp103 += einsum(t1.aa, (0, 1), tmp16, (0, 2, 3, 4), (2, 4, 3, 1)) * -1
    tmp144 = np.copy(f.bb.vv)
    tmp144 += np.transpose(tmp142, (1, 0))
    del tmp142
    tmp144 += einsum(tmp143, (0, 1, 2, 3), t1.bb, (0, 2), (3, 1)) * -1
    del tmp143
    tmp35 = np.copy(tmp32)
    del tmp32
    tmp35 += tmp33
    del tmp33
    tmp35 += tmp34 * 2
    del tmp34
    tmp136 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 4), (4, 0, 1, 2)) * 0.5
    tmp136 += np.transpose(tmp52, (1, 0, 2, 3)) * 0.5
    tmp136 += np.transpose(tmp133, (0, 2, 1, 3)) * 0.25
    tmp136 += np.transpose(tmp134, (0, 2, 1, 3))
    tmp136 += einsum(t1.bb, (0, 1), tmp135, (0, 2, 3, 4), (2, 3, 4, 1)) * -0.5
    tmp132 = einsum(t1.bb, (0, 1), tmp52, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp110 = np.copy(np.transpose(v.bbbb.ooov, (0, 2, 1, 3))) * 0.5
    tmp110 += einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.bbbb, (4, 5, 1, 3), (0, 4, 5, 2)) * -0.5
    tmp110 += einsum(tmp104, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (2, 4, 0, 5))
    del tmp104
    tmp110 += einsum(tmp14, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (2, 4, 1, 5)) * 0.5
    tmp110 += einsum(tmp100, (0, 1), t2.bbbb, (2, 3, 4, 1), (0, 2, 3, 4)) * 0.5
    tmp110 += einsum(t1.bb, (0, 1), tmp105, (2, 3, 4, 1), (3, 2, 0, 4)) * 0.5
    del tmp105
    tmp110 += einsum(tmp109, (0, 1, 2, 3), t1.bb, (0, 4), (2, 1, 3, 4)) * -0.5
    del tmp109
    tmp129 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 5, 1), (3, 4, 0, 5))
    tmp129 += einsum(t1.aa, (0, 1), tmp50, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp139 = np.copy(np.transpose(tmp137, (1, 0, 3, 2)))
    tmp139 += np.transpose(tmp135, (2, 1, 0, 3))
    del tmp135
    tmp113 = np.copy(np.transpose(l1.aa, (1, 0))) * -1
    tmp113 += t1.aa * -1
    tmp113 += tmp36 * -2
    tmp113 += tmp37 * -1
    tmp113 += tmp39 * 2
    tmp113 += tmp41
    tmp113 += einsum(tmp45, (0, 1), t1.aa, (0, 2), (1, 2)) * 2
    tmp127 = np.copy(tmp125)
    del tmp125
    tmp127 += tmp126 * 4
    del tmp126
    tmp131 = np.copy(v.bbbb.ovvv) * -1
    tmp131 += np.transpose(v.bbbb.ovvv, (0, 2, 3, 1))
    tmp130 = np.copy(v.bbbb.ovvv)
    tmp130 += einsum(v.bbbb.vvvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 2, 1)) * -1
    tmp138 = np.copy(tmp133) * 0.25
    del tmp133
    tmp138 += tmp134
    del tmp134
    tmp138 += einsum(tmp137, (0, 1, 2, 3), t1.bb, (1, 4), (0, 3, 2, 4)) * 0.5
    del tmp137
    tmp59 = np.copy(np.transpose(l1.bb, (1, 0))) * -1
    tmp59 += t1.bb * -1
    tmp59 += tmp48 * -1
    del tmp48
    tmp59 += tmp49 * -2
    del tmp49
    tmp59 += tmp51
    del tmp51
    tmp59 += tmp53 * 2
    del tmp53
    tmp59 += tmp58
    del tmp58
    tmp93 = np.copy(f.aa.vv)
    tmp93 += np.transpose(tmp91, (1, 0))
    del tmp91
    tmp93 += einsum(tmp92, (0, 1, 2, 3), t1.aa, (0, 1), (3, 2)) * -1
    del tmp92
    tmp80 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 5), (2, 4, 1, 5))
    tmp80 += einsum(tmp40, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3))
    tmp85 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 4), (4, 0, 1, 2)) * 2
    tmp85 += np.transpose(tmp38, (1, 0, 2, 3)) * 2
    tmp85 += np.transpose(tmp82, (0, 2, 1, 3)) * 4
    tmp85 += einsum(t1.aa, (0, 1), tmp83, (0, 2, 3, 4), (2, 3, 4, 1)) * -2
    tmp85 += np.transpose(tmp84, (0, 2, 1, 3))
    tmp71 = np.copy(np.transpose(l2.abab, (2, 3, 0, 1)))
    tmp71 += tmp69 * 2
    del tmp69
    tmp71 += tmp70 * 2
    del tmp70
    tmp71 += einsum(t1.bb, (0, 1), tmp50, (2, 0, 3, 4), (2, 3, 4, 1)) * -1
    tmp30 = np.copy(tmp27)
    del tmp27
    tmp30 += tmp28 * 2
    del tmp28
    tmp30 += tmp29
    del tmp29
    tmp81 = np.copy(np.transpose(l2.aaaa, (2, 3, 0, 1))) * -1
    tmp81 += einsum(tmp38, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 3, 4)) * -1
    tmp26 = np.copy(np.transpose(v.aaaa.ooov, (0, 2, 1, 3)))
    tmp26 += einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 5, 3, 1), (0, 4, 5, 2))
    tmp26 += einsum(t2.aaaa, (0, 1, 2, 3), tmp18, (4, 1, 5, 3), (5, 0, 4, 2)) * 2
    del tmp18
    tmp26 += einsum(t2.abab, (0, 1, 2, 3), tmp19, (4, 5, 1, 3), (5, 0, 4, 2))
    del tmp19
    tmp26 += einsum(t2.aaaa, (0, 1, 2, 3), tmp9, (4, 3), (4, 0, 1, 2))
    tmp26 += einsum(tmp21, (0, 1, 2, 3), t1.aa, (4, 3), (1, 0, 4, 2))
    del tmp21
    tmp26 += einsum(t1.aa, (0, 1), tmp25, (0, 2, 3, 4), (3, 2, 4, 1)) * -1
    del tmp25
    tmp89 = np.copy(tmp76)
    del tmp76
    tmp89 += np.transpose(tmp77, (0, 1, 3, 2))
    del tmp77
    tmp90 = np.copy(t1.aa) * -0.5
    tmp90 += tmp36 * -1
    tmp90 += tmp37 * -0.5
    tmp90 += tmp39
    tmp90 += tmp41 * 0.5
    tmp90 += tmp46
    tmp88 = np.copy(np.transpose(tmp86, (1, 0, 3, 2)))
    tmp88 += np.transpose(tmp83, (2, 1, 0, 3))
    del tmp83
    tmp17 = np.copy(v.aabb.ooov)
    tmp17 += einsum(v.aabb.oovv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp17 += einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp17 += einsum(tmp1, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (1, 2, 4, 5))
    del tmp1
    tmp17 += einsum(tmp3, (0, 1, 2, 3), t2.abab, (4, 1, 3, 5), (4, 0, 2, 5)) * -1
    del tmp3
    tmp17 += einsum(t2.bbbb, (0, 1, 2, 3), tmp5, (4, 5, 1, 3), (5, 4, 0, 2)) * 2
    del tmp5
    tmp17 += einsum(tmp9, (0, 1), t2.abab, (2, 3, 1, 4), (2, 0, 3, 4))
    tmp17 += einsum(t1.aa, (0, 1), tmp11, (2, 3, 1, 4), (0, 2, 3, 4))
    del tmp11
    tmp17 += einsum(t1.bb, (0, 1), tmp16, (2, 3, 0, 4), (3, 2, 4, 1)) * -1
    del tmp16
    tmp47 = np.copy(np.transpose(l1.aa, (1, 0))) * -0.5
    tmp47 += t1.aa * -0.5
    tmp47 += tmp36 * -1
    del tmp36
    tmp47 += tmp37 * -0.5
    del tmp37
    tmp47 += tmp39
    del tmp39
    tmp47 += tmp41 * 0.5
    del tmp41
    tmp47 += tmp46
    del tmp46
    tmp68 = einsum(t1.aa, (0, 1), v.aaaa.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp79 = einsum(l1.aa, (0, 1), t2.abab, (2, 3, 0, 4), (1, 2, 3, 4)) * 0.5
    tmp79 += tmp40 * 0.5
    tmp79 += einsum(tmp38, (0, 1, 2, 3), t2.abab, (1, 4, 3, 5), (0, 2, 4, 5)) * -1
    tmp79 += einsum(tmp40, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp79 += einsum(tmp50, (0, 1, 2, 3), t2.abab, (4, 1, 3, 5), (0, 4, 2, 5)) * -0.5
    tmp79 += einsum(t1.bb, (0, 1), tmp78, (2, 3, 0, 4), (2, 3, 4, 1)) * -0.5
    del tmp78
    tmp67 = einsum(t1.bb, (0, 1), v.aabb.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp87 = np.copy(tmp82) * 4
    del tmp82
    tmp87 += einsum(t1.aa, (0, 1), tmp86, (2, 0, 3, 4), (2, 4, 3, 1)) * 2
    del tmp86
    tmp87 += tmp84
    del tmp84
    l2new.bbbb = np.copy(np.transpose(v.bbbb.ovov, (1, 3, 0, 2)))
    l2new.bbbb += np.transpose(tmp226, (3, 2, 1, 0)) * -1
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp227, (1, 2, 3, 4), (4, 0, 3, 2)) * -1
    del tmp227
    l2new.bbbb += np.transpose(v.bbbb.ovov, (3, 1, 0, 2)) * -1
    l2new.bbbb += np.transpose(tmp226, (2, 3, 1, 0))
    del tmp226
    l2new.bbbb += np.transpose(tmp229, (3, 2, 0, 1))
    l2new.bbbb += np.transpose(tmp230, (2, 3, 0, 1)) * -1
    l2new.bbbb += np.transpose(tmp231, (3, 2, 0, 1)) * 2
    l2new.bbbb += np.transpose(tmp232, (3, 2, 0, 1)) * 2
    l2new.bbbb += np.transpose(tmp233, (3, 2, 0, 1))
    l2new.bbbb += np.transpose(tmp234, (3, 2, 0, 1))
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp235, (3, 4, 1, 5), (5, 0, 2, 4)) * -2
    del tmp235
    l2new.bbbb += einsum(tmp236, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (3, 4, 5, 1)) * -1
    del tmp236
    l2new.bbbb += np.transpose(tmp237, (3, 2, 0, 1)) * -1
    l2new.bbbb += einsum(tmp238, (0, 1), l1.bb, (2, 3), (1, 2, 3, 0)) * -1
    del tmp238
    l2new.bbbb += np.transpose(tmp230, (2, 3, 1, 0))
    l2new.bbbb += np.transpose(tmp231, (3, 2, 1, 0)) * -2
    l2new.bbbb += np.transpose(tmp232, (3, 2, 1, 0)) * -2
    l2new.bbbb += np.transpose(tmp233, (3, 2, 1, 0)) * -1
    l2new.bbbb += np.transpose(tmp234, (3, 2, 1, 0)) * -1
    l2new.bbbb += np.transpose(tmp239, (2, 3, 0, 1)) * 2
    l2new.bbbb += np.transpose(tmp240, (2, 3, 0, 1))
    l2new.bbbb += np.transpose(tmp237, (3, 2, 1, 0))
    del tmp237
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp204, (2, 3), (3, 0, 2, 1))
    l2new.bbbb += np.transpose(tmp230, (3, 2, 0, 1))
    l2new.bbbb += np.transpose(tmp231, (2, 3, 0, 1)) * -2
    l2new.bbbb += np.transpose(tmp232, (2, 3, 0, 1)) * -2
    l2new.bbbb += np.transpose(tmp233, (2, 3, 0, 1)) * -1
    l2new.bbbb += np.transpose(tmp234, (2, 3, 0, 1)) * -1
    l2new.bbbb += np.transpose(tmp239, (3, 2, 1, 0)) * 2
    l2new.bbbb += np.transpose(tmp240, (3, 2, 1, 0))
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp204, (2, 3), (0, 3, 1, 2))
    l2new.bbbb += np.transpose(tmp230, (3, 2, 1, 0)) * -1
    del tmp230
    l2new.bbbb += np.transpose(tmp231, (2, 3, 1, 0)) * 2
    del tmp231
    l2new.bbbb += np.transpose(tmp232, (2, 3, 1, 0)) * 2
    del tmp232
    l2new.bbbb += np.transpose(tmp233, (2, 3, 1, 0))
    del tmp233
    l2new.bbbb += np.transpose(tmp234, (2, 3, 1, 0))
    del tmp234
    l2new.bbbb += np.transpose(tmp239, (3, 2, 0, 1)) * -2
    del tmp239
    l2new.bbbb += np.transpose(tmp240, (3, 2, 0, 1)) * -1
    del tmp240
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp204, (2, 3), (0, 3, 2, 1)) * -1
    l2new.bbbb += np.transpose(tmp241, (3, 2, 1, 0)) * 2
    del tmp241
    l2new.bbbb += np.transpose(tmp242, (2, 3, 1, 0)) * 2
    l2new.bbbb += np.transpose(tmp244, (3, 2, 1, 0)) * 4
    del tmp244
    l2new.bbbb += np.transpose(tmp247, (2, 3, 1, 0)) * 2
    l2new.bbbb += np.transpose(tmp248, (2, 3, 1, 0)) * -2
    l2new.bbbb += np.transpose(tmp242, (3, 2, 1, 0)) * -2
    del tmp242
    l2new.bbbb += np.transpose(tmp247, (3, 2, 1, 0)) * -2
    del tmp247
    l2new.bbbb += np.transpose(tmp248, (3, 2, 1, 0)) * 2
    del tmp248
    l2new.bbbb += np.transpose(tmp249, (2, 3, 0, 1)) * -2
    l2new.bbbb += np.transpose(tmp249, (2, 3, 1, 0)) * 2
    del tmp249
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp250, (2, 4, 3, 5), (0, 1, 4, 5)) * -2
    del tmp250
    l2new.bbbb += np.transpose(tmp251, (3, 2, 1, 0))
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp252, (1, 2, 3, 4), (4, 0, 2, 3))
    del tmp252
    l2new.bbbb += np.transpose(tmp251, (2, 3, 1, 0)) * -1
    del tmp251
    l2new.bbbb += np.transpose(tmp229, (3, 2, 1, 0)) * -1
    del tmp229
    l2new.bbbb += np.transpose(tmp253, (3, 2, 0, 1)) * -2
    l2new.bbbb += einsum(tmp223, (0, 1), l1.bb, (2, 3), (1, 2, 3, 0))
    l2new.bbbb += np.transpose(tmp254, (3, 2, 0, 1)) * -2
    l2new.bbbb += np.transpose(tmp256, (3, 2, 0, 1))
    l2new.bbbb += np.transpose(tmp257, (2, 3, 1, 0)) * -1
    l2new.bbbb += np.transpose(tmp253, (2, 3, 0, 1)) * 2
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp223, (2, 3), (0, 3, 1, 2)) * -1
    l2new.bbbb += np.transpose(tmp254, (2, 3, 0, 1)) * 2
    l2new.bbbb += np.transpose(tmp256, (2, 3, 0, 1)) * -1
    l2new.bbbb += np.transpose(tmp257, (3, 2, 1, 0))
    del tmp257
    l2new.bbbb += np.transpose(tmp253, (3, 2, 1, 0)) * 2
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp223, (2, 3), (3, 0, 2, 1)) * -1
    l2new.bbbb += np.transpose(tmp254, (3, 2, 1, 0)) * 2
    l2new.bbbb += np.transpose(tmp256, (3, 2, 1, 0)) * -1
    l2new.bbbb += np.transpose(tmp258, (2, 3, 1, 0))
    l2new.bbbb += np.transpose(tmp253, (2, 3, 1, 0)) * -2
    del tmp253
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp223, (2, 3), (0, 3, 2, 1))
    l2new.bbbb += np.transpose(tmp254, (2, 3, 1, 0)) * -2
    del tmp254
    l2new.bbbb += np.transpose(tmp256, (2, 3, 1, 0))
    del tmp256
    l2new.bbbb += np.transpose(tmp258, (3, 2, 1, 0)) * -1
    del tmp258
    l2new.abab = np.copy(np.transpose(v.aabb.ovov, (1, 3, 0, 2)))
    l2new.abab += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp193, (4, 3), (1, 4, 0, 2)) * -2
    del tmp193
    l2new.abab += einsum(tmp14, (0, 1, 2, 3), l1.bb, (4, 1), (3, 4, 0, 2)) * -1
    l2new.abab += einsum(v.aabb.ovvv, (0, 1, 2, 3), l1.bb, (3, 4), (1, 2, 0, 4))
    l2new.abab += einsum(tmp40, (0, 1, 2, 3), v.aaaa.ovoo, (4, 5, 1, 0), (5, 3, 4, 2)) * -1
    l2new.abab += einsum(tmp40, (0, 1, 2, 3), tmp0, (0, 4, 1, 5), (5, 3, 4, 2)) * -1
    l2new.abab += einsum(tmp2, (0, 1, 2, 3), tmp52, (4, 1, 2, 5), (3, 5, 0, 4)) * -2
    del tmp2
    l2new.abab += einsum(tmp52, (0, 1, 2, 3), v.aabb.ovoo, (4, 5, 2, 1), (5, 3, 4, 0)) * -2
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp166, (2, 4, 0, 5), (5, 1, 4, 3))
    del tmp166
    l2new.abab += einsum(l2.bbbb, (0, 1, 2, 3), tmp168, (4, 3, 5, 1), (5, 0, 4, 2)) * 2
    del tmp168
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp66, (2, 4), (0, 1, 4, 3)) * -1
    l2new.abab += einsum(l1.bb, (0, 1), tmp170, (2, 3), (3, 0, 2, 1))
    l2new.abab += einsum(tmp38, (0, 1, 2, 3), v.aabb.ooov, (2, 1, 4, 5), (3, 5, 0, 4)) * -2
    l2new.abab += einsum(tmp4, (0, 1, 2, 3), tmp38, (4, 0, 1, 5), (5, 3, 4, 2)) * -2
    del tmp4
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), tmp95, (1, 4, 2, 5), (3, 5, 0, 4)) * -1
    l2new.abab += einsum(v.aabb.vvov, (0, 1, 2, 3), l1.aa, (1, 4), (0, 3, 4, 2))
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), v.bbbb.ovoo, (4, 5, 2, 1), (3, 5, 0, 4)) * -1
    l2new.abab += einsum(tmp198, (0, 1, 2, 3), l2.abab, (4, 2, 5, 0), (4, 3, 5, 1))
    del tmp198
    l2new.abab += einsum(tmp202, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 0), (4, 3, 5, 1)) * 2
    del tmp202
    l2new.abab += einsum(l1.aa, (0, 1), tmp204, (2, 3), (0, 3, 1, 2))
    del tmp204
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp205, (3, 4, 0, 5), (5, 1, 2, 4)) * -1
    del tmp205
    l2new.abab += einsum(tmp120, (0, 1), l2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -1
    l2new.abab += np.transpose(tmp206, (2, 3, 0, 1))
    del tmp206
    l2new.abab += einsum(tmp40, (0, 1, 2, 3), v.aabb.ovvv, (1, 4, 5, 3), (4, 5, 0, 2)) * -1
    l2new.abab += np.transpose(tmp207, (2, 3, 0, 1)) * 2
    del tmp207
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp208, (0, 4), (4, 1, 2, 3)) * -1
    del tmp208
    l2new.abab += einsum(tmp182, (0, 1), tmp40, (2, 0, 3, 4), (1, 4, 2, 3)) * -1
    del tmp182
    l2new.abab += einsum(v.aabb.vvov, (0, 1, 2, 3), tmp50, (4, 5, 2, 1), (0, 3, 4, 5)) * -1
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp211, (1, 4), (0, 4, 2, 3)) * -2
    del tmp211
    l2new.abab += einsum(tmp214, (0, 1), tmp50, (2, 3, 0, 4), (4, 1, 2, 3)) * -1
    del tmp214
    l2new.abab += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp215, (4, 1), (4, 3, 0, 2)) * -1
    del tmp215
    l2new.abab += einsum(tmp216, (0, 1, 2, 3), l1.aa, (4, 0), (4, 3, 1, 2)) * -1
    l2new.abab += einsum(tmp217, (0, 1, 2, 3), l2.abab, (4, 5, 0, 2), (4, 5, 1, 3))
    del tmp217
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp218, (2, 4, 1, 5), (0, 5, 4, 3)) * -1
    del tmp218
    l2new.abab += einsum(tmp219, (0, 1, 2, 3), l2.abab, (2, 4, 5, 0), (3, 4, 5, 1))
    del tmp219
    l2new.abab += einsum(tmp14, (0, 1, 2, 3), tmp40, (4, 0, 1, 5), (3, 5, 4, 2))
    del tmp14
    l2new.abab += einsum(tmp94, (0, 1), v.aabb.ovov, (1, 2, 3, 4), (2, 4, 0, 3)) * -1
    l2new.abab += einsum(tmp220, (0, 1, 2, 3), l2.abab, (4, 2, 0, 5), (4, 3, 1, 5))
    del tmp220
    l2new.abab += einsum(tmp216, (0, 1, 2, 3), tmp50, (0, 4, 2, 5), (5, 3, 1, 4))
    del tmp216
    l2new.abab += einsum(tmp221, (0, 1), v.aabb.ovov, (2, 3, 1, 4), (3, 4, 2, 0)) * -2
    del tmp221
    l2new.abab += einsum(tmp40, (0, 1, 2, 3), tmp0, (0, 1, 4, 5), (5, 3, 4, 2))
    del tmp0
    l2new.abab += einsum(tmp40, (0, 1, 2, 3), v.aaaa.ooov, (4, 0, 1, 5), (5, 3, 4, 2))
    l2new.abab += einsum(l1.bb, (0, 1), tmp189, (2, 3), (3, 0, 2, 1)) * -1
    l2new.abab += einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp222, (2, 4, 1, 5), (3, 5, 0, 4)) * -2
    del tmp222
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 2, 5), (3, 5, 0, 4))
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), tmp95, (1, 2, 4, 5), (3, 5, 0, 4))
    del tmp95
    l2new.abab += einsum(l1.aa, (0, 1), tmp223, (2, 3), (0, 3, 1, 2)) * -1
    del tmp223
    l2new.abab += einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp224, (4, 2, 5, 1), (5, 3, 4, 0)) * -2
    del tmp224
    l2new.aaaa = np.copy(np.transpose(v.aaaa.ovov, (1, 3, 0, 2)))
    l2new.aaaa += np.transpose(tmp146, (3, 2, 1, 0)) * -1
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp147, (1, 2, 3, 4), (4, 0, 3, 2)) * -1
    del tmp147
    l2new.aaaa += np.transpose(v.aaaa.ovov, (3, 1, 0, 2)) * -1
    l2new.aaaa += np.transpose(tmp146, (2, 3, 1, 0))
    del tmp146
    l2new.aaaa += np.transpose(tmp149, (3, 2, 0, 1))
    l2new.aaaa += np.transpose(tmp150, (2, 3, 0, 1)) * -1
    l2new.aaaa += np.transpose(tmp151, (3, 2, 0, 1))
    l2new.aaaa += np.transpose(tmp152, (3, 2, 0, 1))
    l2new.aaaa += np.transpose(tmp153, (3, 2, 0, 1)) * 2
    l2new.aaaa += np.transpose(tmp154, (3, 2, 0, 1)) * 2
    l2new.aaaa += einsum(l2.aaaa, (0, 1, 2, 3), tmp157, (3, 4, 1, 5), (5, 0, 2, 4)) * -2
    del tmp157
    l2new.aaaa += einsum(l2.abab, (0, 1, 2, 3), tmp160, (4, 3, 5, 1), (5, 0, 2, 4)) * -1
    del tmp160
    l2new.aaaa += np.transpose(tmp161, (3, 2, 0, 1)) * -1
    l2new.aaaa += einsum(tmp163, (0, 1), l1.aa, (2, 3), (1, 2, 3, 0)) * -1
    del tmp163
    l2new.aaaa += np.transpose(tmp150, (2, 3, 1, 0))
    l2new.aaaa += np.transpose(tmp151, (3, 2, 1, 0)) * -1
    l2new.aaaa += np.transpose(tmp152, (3, 2, 1, 0)) * -1
    l2new.aaaa += np.transpose(tmp153, (3, 2, 1, 0)) * -2
    l2new.aaaa += np.transpose(tmp154, (3, 2, 1, 0)) * -2
    l2new.aaaa += np.transpose(tmp167, (2, 3, 0, 1)) * 2
    l2new.aaaa += np.transpose(tmp169, (2, 3, 0, 1))
    l2new.aaaa += np.transpose(tmp161, (3, 2, 1, 0))
    del tmp161
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp170, (2, 3), (3, 0, 2, 1))
    l2new.aaaa += np.transpose(tmp150, (3, 2, 0, 1))
    l2new.aaaa += np.transpose(tmp151, (2, 3, 0, 1)) * -1
    l2new.aaaa += np.transpose(tmp152, (2, 3, 0, 1)) * -1
    l2new.aaaa += np.transpose(tmp153, (2, 3, 0, 1)) * -2
    l2new.aaaa += np.transpose(tmp154, (2, 3, 0, 1)) * -2
    l2new.aaaa += np.transpose(tmp167, (3, 2, 1, 0)) * 2
    l2new.aaaa += np.transpose(tmp169, (3, 2, 1, 0))
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp170, (2, 3), (0, 3, 1, 2))
    l2new.aaaa += np.transpose(tmp150, (3, 2, 1, 0)) * -1
    del tmp150
    l2new.aaaa += np.transpose(tmp151, (2, 3, 1, 0))
    del tmp151
    l2new.aaaa += np.transpose(tmp152, (2, 3, 1, 0))
    del tmp152
    l2new.aaaa += np.transpose(tmp153, (2, 3, 1, 0)) * 2
    del tmp153
    l2new.aaaa += np.transpose(tmp154, (2, 3, 1, 0)) * 2
    del tmp154
    l2new.aaaa += np.transpose(tmp167, (3, 2, 0, 1)) * -2
    del tmp167
    l2new.aaaa += np.transpose(tmp169, (3, 2, 0, 1)) * -1
    del tmp169
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp170, (2, 3), (0, 3, 2, 1)) * -1
    del tmp170
    l2new.aaaa += np.transpose(tmp171, (3, 2, 1, 0)) * 2
    del tmp171
    l2new.aaaa += np.transpose(tmp172, (2, 3, 1, 0)) * 2
    l2new.aaaa += np.transpose(tmp174, (3, 2, 1, 0)) * 4
    del tmp174
    l2new.aaaa += np.transpose(tmp179, (2, 3, 1, 0)) * 2
    l2new.aaaa += np.transpose(tmp183, (2, 3, 1, 0)) * -2
    l2new.aaaa += np.transpose(tmp172, (3, 2, 1, 0)) * -2
    del tmp172
    l2new.aaaa += np.transpose(tmp179, (3, 2, 1, 0)) * -2
    del tmp179
    l2new.aaaa += np.transpose(tmp183, (3, 2, 1, 0)) * 2
    del tmp183
    l2new.aaaa += np.transpose(tmp184, (2, 3, 0, 1)) * -2
    l2new.aaaa += np.transpose(tmp184, (2, 3, 1, 0)) * 2
    del tmp184
    l2new.aaaa += einsum(l2.aaaa, (0, 1, 2, 3), tmp185, (2, 4, 3, 5), (0, 1, 4, 5)) * -2
    del tmp185
    l2new.aaaa += np.transpose(tmp186, (3, 2, 1, 0))
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp187, (1, 2, 3, 4), (4, 0, 2, 3))
    del tmp187
    l2new.aaaa += np.transpose(tmp186, (2, 3, 1, 0)) * -1
    del tmp186
    l2new.aaaa += np.transpose(tmp149, (3, 2, 1, 0)) * -1
    del tmp149
    l2new.aaaa += np.transpose(tmp188, (3, 2, 0, 1)) * -2
    l2new.aaaa += einsum(tmp189, (0, 1), l1.aa, (2, 3), (1, 2, 3, 0))
    l2new.aaaa += np.transpose(tmp190, (3, 2, 0, 1)) * -2
    l2new.aaaa += np.transpose(tmp191, (2, 3, 1, 0))
    l2new.aaaa += np.transpose(tmp192, (2, 3, 1, 0)) * -1
    l2new.aaaa += np.transpose(tmp188, (2, 3, 0, 1)) * 2
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp189, (2, 3), (0, 3, 1, 2)) * -1
    l2new.aaaa += np.transpose(tmp190, (2, 3, 0, 1)) * 2
    l2new.aaaa += np.transpose(tmp191, (3, 2, 1, 0)) * -1
    l2new.aaaa += np.transpose(tmp192, (3, 2, 1, 0))
    l2new.aaaa += np.transpose(tmp188, (3, 2, 1, 0)) * 2
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp189, (2, 3), (3, 0, 2, 1)) * -1
    l2new.aaaa += np.transpose(tmp190, (3, 2, 1, 0)) * 2
    l2new.aaaa += np.transpose(tmp191, (2, 3, 0, 1)) * -1
    l2new.aaaa += np.transpose(tmp192, (2, 3, 0, 1))
    l2new.aaaa += np.transpose(tmp188, (2, 3, 1, 0)) * -2
    del tmp188
    l2new.aaaa += einsum(tmp189, (0, 1), l1.aa, (2, 3), (2, 1, 0, 3))
    del tmp189
    l2new.aaaa += np.transpose(tmp190, (2, 3, 1, 0)) * -2
    del tmp190
    l2new.aaaa += np.transpose(tmp191, (3, 2, 0, 1))
    del tmp191
    l2new.aaaa += np.transpose(tmp192, (3, 2, 0, 1)) * -1
    del tmp192
    l1new.bb = einsum(v.bbbb.oovv, (0, 1, 2, 3), l1.bb, (3, 1), (2, 0)) * -1
    l1new.bb += np.transpose(f.bb.ov, (1, 0))
    l1new.bb += einsum(l2.abab, (0, 1, 2, 3), tmp103, (2, 3, 4, 0), (1, 4)) * -1
    del tmp103
    l1new.bb += einsum(tmp110, (0, 1, 2, 3), l2.bbbb, (4, 3, 1, 2), (4, 0)) * 4
    del tmp110
    l1new.bb += einsum(tmp111, (0, 1, 2, 3), tmp35, (3, 2), (1, 0)) * -1
    l1new.bb += einsum(v.aabb.vvov, (0, 1, 2, 3), tmp112, (1, 0), (3, 2)) * 2
    del tmp112
    l1new.bb += einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp59, (2, 3), (1, 0)) * -1
    l1new.bb += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp113, (0, 1), (3, 2)) * -1
    del tmp113
    l1new.bb += einsum(tmp57, (0, 1), v.bbbb.ovoo, (2, 3, 0, 1), (3, 2)) * -1
    l1new.bb += einsum(tmp45, (0, 1), v.aabb.ooov, (1, 0, 2, 3), (3, 2)) * -2
    l1new.bb += einsum(l1.bb, (0, 1), tmp120, (1, 2), (0, 2)) * -1
    del tmp120
    l1new.bb += einsum(tmp121, (0, 1, 2, 3), l2.abab, (1, 3, 0, 4), (2, 4))
    del tmp121
    l1new.bb += einsum(tmp52, (0, 1, 2, 3), v.bbbb.oovv, (2, 1, 4, 3), (4, 0)) * -2
    del tmp52
    l1new.bb += einsum(tmp40, (0, 1, 2, 3), v.aabb.oovv, (1, 0, 4, 3), (4, 2)) * -1
    del tmp40
    l1new.bb += einsum(v.aabb.ovvv, (0, 1, 2, 3), tmp124, (0, 4, 1, 3), (2, 4))
    del tmp124
    l1new.bb += einsum(tmp111, (0, 1, 2, 3), tmp127, (4, 0, 3, 2), (1, 4))
    del tmp111, tmp127
    l1new.bb += einsum(tmp128, (0, 1, 2, 3), v.aabb.ovov, (0, 3, 2, 4), (4, 1)) * -1
    del tmp128
    l1new.bb += einsum(tmp129, (0, 1, 2, 3), v.aabb.vvov, (2, 3, 1, 4), (4, 0)) * -1
    del tmp129
    l1new.bb += einsum(l2.bbbb, (0, 1, 2, 3), tmp130, (3, 0, 1, 4), (4, 2)) * -2
    del tmp130
    l1new.bb += einsum(tmp132, (0, 1, 2, 3), tmp131, (1, 4, 2, 3), (4, 0)) * -2
    del tmp132, tmp131
    l1new.bb += einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp136, (4, 0, 2, 1), (3, 4)) * -4
    del tmp136
    l1new.bb += einsum(tmp138, (0, 1, 2, 3), v.bbbb.ovov, (1, 3, 2, 4), (4, 0)) * 4
    del tmp138
    l1new.bb += einsum(tmp139, (0, 1, 2, 3), v.bbbb.ooov, (0, 2, 3, 4), (4, 1)) * 2
    del tmp139
    l1new.bb += einsum(v.aabb.ooov, (0, 1, 2, 3), tmp140, (0, 1, 4, 2), (3, 4))
    del tmp140
    l1new.bb += einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp141, (2, 1), (3, 0)) * 2
    del tmp141
    l1new.bb += einsum(tmp57, (0, 1), v.bbbb.ooov, (2, 0, 1, 3), (3, 2))
    l1new.bb += einsum(tmp144, (0, 1), l1.bb, (0, 2), (1, 2))
    del tmp144
    l1new.bb += einsum(tmp100, (0, 1), tmp57, (2, 0), (1, 2)) * -1
    del tmp100
    l1new.aa = einsum(l1.aa, (0, 1), v.aaaa.oovv, (2, 1, 3, 0), (3, 2)) * -1
    l1new.aa += np.transpose(f.aa.ov, (1, 0))
    l1new.aa += einsum(l2.abab, (0, 1, 2, 3), tmp17, (2, 4, 3, 1), (0, 4)) * -1
    del tmp17
    l1new.aa += einsum(tmp26, (0, 1, 2, 3), l2.aaaa, (4, 3, 1, 2), (4, 0)) * 2
    del tmp26
    l1new.aa += einsum(tmp30, (0, 1), tmp31, (2, 1, 0, 3), (3, 2)) * -1
    del tmp31, tmp30
    l1new.aa += einsum(v.aabb.ovvv, (0, 1, 2, 3), tmp35, (3, 2), (1, 0))
    del tmp35
    l1new.aa += einsum(tmp47, (0, 1), v.aaaa.ovov, (2, 3, 0, 1), (3, 2)) * -2
    del tmp47
    l1new.aa += einsum(tmp59, (0, 1), v.aabb.ovov, (2, 3, 0, 1), (3, 2)) * -1
    del tmp59
    l1new.aa += einsum(v.aabb.ovoo, (0, 1, 2, 3), tmp57, (3, 2), (1, 0)) * -1
    del tmp57
    l1new.aa += einsum(tmp45, (0, 1), v.aaaa.ovoo, (2, 3, 1, 0), (3, 2)) * -2
    l1new.aa += einsum(tmp66, (0, 1), l1.aa, (2, 0), (2, 1)) * -1
    del tmp66
    l1new.aa += einsum(v.aabb.vvoo, (0, 1, 2, 3), tmp50, (4, 3, 2, 1), (0, 4)) * -1
    del tmp50
    l1new.aa += einsum(l2.abab, (0, 1, 2, 3), tmp67, (3, 4, 0, 1), (4, 2))
    del tmp67
    l1new.aa += einsum(l2.aaaa, (0, 1, 2, 3), tmp68, (3, 4, 0, 1), (4, 2)) * 2
    del tmp68
    l1new.aa += einsum(v.aaaa.oovv, (0, 1, 2, 3), tmp38, (4, 1, 0, 3), (2, 4)) * -2
    l1new.aa += einsum(tmp20, (0, 1, 2, 3), tmp38, (4, 0, 1, 3), (2, 4)) * 2
    del tmp38, tmp20
    l1new.aa += einsum(v.aabb.vvov, (0, 1, 2, 3), tmp71, (4, 2, 1, 3), (0, 4))
    del tmp71
    l1new.aa += einsum(tmp75, (0, 1, 2, 3), tmp72, (1, 4, 3, 2), (4, 0)) * -1
    del tmp72, tmp75
    l1new.aa += einsum(tmp79, (0, 1, 2, 3), v.aabb.ovov, (1, 4, 2, 3), (4, 0)) * -2
    del tmp79
    l1new.aa += einsum(tmp80, (0, 1, 2, 3), v.aabb.ovvv, (1, 4, 3, 2), (4, 0)) * -1
    del tmp80
    l1new.aa += einsum(v.aaaa.ovvv, (0, 1, 2, 3), tmp81, (4, 0, 3, 1), (2, 4)) * -2
    del tmp81
    l1new.aa += einsum(tmp85, (0, 1, 2, 3), v.aaaa.ovov, (1, 3, 2, 4), (4, 0)) * -1
    del tmp85
    l1new.aa += einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp87, (4, 2, 0, 3), (1, 4))
    del tmp87
    l1new.aa += einsum(v.aaaa.ooov, (0, 1, 2, 3), tmp88, (1, 4, 0, 2), (3, 4)) * 2
    del tmp88
    l1new.aa += einsum(tmp89, (0, 1, 2, 3), v.aabb.ovoo, (1, 4, 3, 2), (4, 0))
    del tmp89
    l1new.aa += einsum(tmp90, (0, 1), v.aaaa.ovov, (2, 1, 0, 3), (3, 2)) * 2
    del tmp90
    l1new.aa += einsum(tmp45, (0, 1), v.aaaa.ooov, (2, 0, 1, 3), (3, 2)) * 2
    del tmp45
    l1new.aa += einsum(tmp93, (0, 1), l1.aa, (0, 2), (1, 2))
    del tmp93
    l1new.aa += einsum(tmp9, (0, 1), tmp94, (2, 0), (1, 2)) * -1
    del tmp9, tmp94

    return {f"l1new": l1new, f"l2new": l2new}

def make_rdm1_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:39:45.577279.

    Parameters
    ----------
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm1 : Namespace of arrays
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    rdm1.aa = Namespace()
    rdm1.bb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    tmp4 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    tmp3 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    tmp5 = einsum(t1.bb, (0, 1), l1.bb, (1, 2), (2, 0))
    tmp0 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    tmp2 = einsum(l1.aa, (0, 1), t1.aa, (2, 0), (1, 2))
    tmp1 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (2, 4))
    tmp11 = np.copy(tmp5) * 0.5
    tmp11 += tmp3 * 0.5
    tmp11 += tmp4
    tmp10 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp9 = einsum(t1.bb, (0, 1), l2.abab, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp8 = np.copy(tmp2)
    tmp8 += tmp1 * 2
    tmp8 += tmp0
    tmp6 = einsum(l2.aaaa, (0, 1, 2, 3), t1.aa, (4, 1), (2, 3, 4, 0))
    tmp7 = einsum(l2.abab, (0, 1, 2, 3), t1.aa, (4, 0), (2, 4, 3, 1))
    rdm1.bb.vv = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    rdm1.bb.vv += einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    rdm1.bb.vv += einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 1), (0, 4)) * 2
    rdm1.aa.vv = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4)) * 2
    rdm1.aa.vv += einsum(l1.aa, (0, 1), t1.aa, (1, 2), (0, 2))
    rdm1.aa.vv += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    rdm1.bb.vo = np.copy(l1.bb)
    rdm1.aa.vo = np.copy(l1.aa)
    rdm1.bb.ov = einsum(l1.bb, (0, 1), t2.bbbb, (2, 1, 3, 0), (2, 3)) * 2
    rdm1.bb.ov += t1.bb
    rdm1.bb.ov += einsum(l1.aa, (0, 1), t2.abab, (1, 2, 0, 3), (2, 3))
    rdm1.bb.ov += einsum(tmp9, (0, 1, 2, 3), t2.abab, (0, 1, 3, 4), (2, 4)) * -1
    del tmp9
    rdm1.bb.ov += einsum(t2.bbbb, (0, 1, 2, 3), tmp10, (1, 0, 4, 3), (4, 2)) * -2
    del tmp10
    rdm1.bb.ov += einsum(t1.bb, (0, 1), tmp11, (0, 2), (2, 1)) * -2
    del tmp11
    rdm1.aa.ov = einsum(l1.bb, (0, 1), t2.abab, (2, 1, 3, 0), (2, 3))
    rdm1.aa.ov += t1.aa
    rdm1.aa.ov += einsum(l1.aa, (0, 1), t2.aaaa, (2, 1, 3, 0), (2, 3)) * 2
    rdm1.aa.ov += einsum(t2.aaaa, (0, 1, 2, 3), tmp6, (1, 0, 4, 3), (4, 2)) * -2
    del tmp6
    rdm1.aa.ov += einsum(tmp7, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (1, 4)) * -1
    del tmp7
    rdm1.aa.ov += einsum(t1.aa, (0, 1), tmp8, (0, 2), (2, 1)) * -1
    del tmp8
    rdm1.bb.oo = np.copy(np.transpose(tmp3, (1, 0))) * -1
    del tmp3
    rdm1.bb.oo += np.transpose(tmp4, (1, 0)) * -2
    del tmp4
    rdm1.bb.oo += delta.bb.oo
    rdm1.bb.oo += np.transpose(tmp5, (1, 0)) * -1
    del tmp5
    rdm1.aa.oo = np.copy(np.transpose(tmp0, (1, 0))) * -1
    del tmp0
    rdm1.aa.oo += delta.aa.oo
    del delta
    rdm1.aa.oo += np.transpose(tmp1, (1, 0)) * -2
    del tmp1
    rdm1.aa.oo += np.transpose(tmp2, (1, 0)) * -1
    del tmp2
    rdm1.aa = np.block([[rdm1.aa.oo, rdm1.aa.ov], [rdm1.aa.vo, rdm1.aa.vv]])
    rdm1.bb = np.block([[rdm1.bb.oo, rdm1.bb.ov], [rdm1.bb.vo, rdm1.bb.vv]])

    return rdm1

def make_rdm2_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:40:48.674383.

    Parameters
    ----------
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm2 : Namespace of arrays
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    rdm2.aaaa = Namespace()
    rdm2.abab = Namespace()
    rdm2.bbbb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    tmp10 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    tmp8 = einsum(t1.bb, (0, 1), l1.bb, (1, 2), (2, 0))
    tmp9 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    tmp18 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp13 = einsum(t1.bb, (0, 1), l2.abab, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp2 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    tmp1 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (2, 4))
    tmp0 = einsum(l1.aa, (0, 1), t1.aa, (2, 0), (1, 2))
    tmp6 = einsum(l2.aaaa, (0, 1, 2, 3), t1.aa, (4, 1), (2, 3, 4, 0))
    tmp26 = einsum(l2.abab, (0, 1, 2, 3), t1.aa, (4, 0), (2, 4, 3, 1))
    tmp95 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 5), (3, 4, 1, 5))
    tmp91 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp68 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp70 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp41 = np.copy(tmp8)
    tmp41 += tmp9
    tmp41 += tmp10 * 2
    tmp51 = einsum(t2.bbbb, (0, 1, 2, 3), tmp18, (4, 1, 5, 3), (4, 5, 0, 2)) * -1
    tmp52 = einsum(tmp13, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (1, 2, 4, 5))
    tmp17 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp19 = einsum(t1.bb, (0, 1), tmp18, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp28 = np.copy(tmp0) * 0.5
    tmp28 += tmp1
    tmp28 += tmp2 * 0.5
    tmp14 = einsum(t1.aa, (0, 1), tmp13, (2, 3, 4, 1), (2, 0, 3, 4))
    tmp12 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 5, 0, 1), (2, 4, 3, 5))
    tmp5 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp7 = einsum(tmp6, (0, 1, 2, 3), t1.aa, (4, 3), (0, 1, 4, 2))
    tmp32 = einsum(tmp26, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp31 = einsum(tmp6, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (0, 2, 4, 5)) * -1
    tmp111 = einsum(t1.bb, (0, 1), tmp18, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp124 = np.copy(tmp95)
    tmp124 += tmp91 * 4
    tmp80 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    tmp108 = einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp81 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 1), (0, 4))
    tmp64 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    tmp63 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4))
    tmp105 = einsum(l1.aa, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp93 = einsum(t2.abab, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 0), (5, 1, 4, 3))
    tmp113 = einsum(t2.bbbb, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp107 = einsum(tmp6, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 3, 4))
    tmp83 = np.copy(tmp68) * 4
    tmp83 += tmp70
    tmp66 = einsum(l2.bbbb, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (4, 2, 5, 0))
    tmp84 = einsum(l2.abab, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 0), (4, 3, 5, 1))
    tmp36 = einsum(l1.bb, (0, 1), t2.bbbb, (2, 1, 3, 0), (2, 3))
    tmp35 = einsum(l1.aa, (0, 1), t2.abab, (1, 2, 0, 3), (2, 3))
    tmp50 = einsum(l1.bb, (0, 1), t2.bbbb, (2, 3, 4, 0), (1, 2, 3, 4))
    tmp40 = einsum(t2.bbbb, (0, 1, 2, 3), tmp18, (1, 0, 4, 3), (4, 2))
    tmp42 = einsum(t1.bb, (0, 1), tmp41, (0, 2), (2, 1))
    tmp39 = einsum(tmp13, (0, 1, 2, 3), t2.abab, (0, 1, 3, 4), (2, 4))
    tmp103 = np.copy(tmp52)
    tmp103 += tmp51 * 4
    tmp53 = np.copy(np.transpose(tmp17, (1, 0, 3, 2)))
    tmp53 += np.transpose(tmp19, (0, 1, 3, 2)) * -1
    tmp86 = einsum(t1.bb, (0, 1), tmp41, (0, 2), (2, 1)) * 0.5
    tmp27 = einsum(tmp26, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (1, 4))
    tmp29 = einsum(tmp28, (0, 1), t1.aa, (0, 2), (1, 2)) * 2
    tmp25 = einsum(t2.aaaa, (0, 1, 2, 3), tmp6, (1, 0, 4, 3), (4, 2))
    tmp45 = einsum(tmp26, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp44 = einsum(tmp6, (0, 1, 2, 3), t2.abab, (1, 4, 3, 5), (0, 2, 4, 5)) * -1
    tmp60 = einsum(tmp13, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 1, 2, 5))
    tmp59 = einsum(tmp18, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 2, 5)) * -1
    tmp46 = np.copy(tmp12)
    tmp46 += tmp14
    tmp21 = einsum(l1.bb, (0, 1), t2.abab, (2, 1, 3, 0), (2, 3))
    tmp20 = einsum(l1.aa, (0, 1), t2.aaaa, (2, 1, 3, 0), (2, 3))
    tmp33 = np.copy(np.transpose(tmp5, (1, 0, 3, 2)))
    tmp33 += np.transpose(tmp7, (0, 1, 3, 2)) * -1
    tmp24 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 4), (4, 0, 1, 2))
    tmp78 = np.copy(tmp31) * 4
    tmp78 += tmp32
    tmp56 = einsum(tmp28, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp4 = np.copy(tmp0)
    tmp4 += tmp1 * 2
    tmp4 += tmp2
    tmp131 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 3, 4, 0), (4, 2, 3, 1))
    tmp133 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 5, 0, 1), (4, 5, 2, 3))
    tmp130 = einsum(l2.abab, (0, 1, 2, 3), t1.bb, (3, 4), (2, 0, 1, 4))
    tmp132 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 5), (0, 1, 4, 5))
    tmp129 = einsum(l2.aaaa, (0, 1, 2, 3), t1.aa, (3, 4), (2, 0, 1, 4))
    tmp122 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (4, 1), (0, 4, 2, 3))
    tmp127 = einsum(t1.bb, (0, 1), tmp111, (0, 2, 3, 4), (2, 3, 4, 1)) * -1
    tmp125 = einsum(t1.bb, (0, 1), tmp124, (0, 2, 3, 4), (2, 1, 3, 4))
    del tmp124
    tmp109 = np.copy(tmp108)
    tmp109 += tmp80
    tmp109 += tmp81 * 2
    tmp126 = einsum(tmp18, (0, 1, 2, 3), t2.bbbb, (1, 0, 4, 5), (2, 3, 4, 5)) * -1
    tmp106 = np.copy(tmp105)
    tmp106 += tmp63 * 2
    tmp106 += tmp64
    tmp115 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 5, 1), (3, 4, 0, 5))
    tmp128 = np.copy(tmp93)
    tmp128 += tmp113
    tmp114 = einsum(t1.bb, (0, 1), tmp13, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp120 = einsum(t2.aaaa, (0, 1, 2, 3), tmp6, (1, 0, 4, 5), (4, 5, 2, 3)) * -1
    tmp117 = np.copy(tmp105) * 0.5
    del tmp105
    tmp117 += tmp63
    tmp117 += tmp64 * 0.5
    tmp116 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (4, 1), (0, 4, 2, 3))
    tmp121 = einsum(tmp107, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 3, 4)) * -1
    tmp119 = einsum(tmp83, (0, 1, 2, 3), t1.aa, (0, 4), (1, 4, 2, 3))
    tmp123 = np.copy(tmp95)
    tmp123 += tmp91 * 4
    tmp88 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 5), (2, 4, 1, 5))
    tmp112 = einsum(tmp26, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    tmp85 = np.copy(tmp84)
    tmp85 += tmp66
    tmp118 = np.copy(tmp68)
    tmp118 += tmp70 * 0.25
    tmp110 = np.copy(tmp108) * 0.5
    del tmp108
    tmp110 += tmp80 * 0.5
    tmp110 += tmp81
    tmp37 = np.copy(t1.bb)
    tmp37 += tmp35
    tmp37 += tmp36 * 2
    tmp98 = einsum(t1.bb, (0, 1), tmp50, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp94 = einsum(tmp93, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5))
    tmp49 = np.copy(t1.bb) * 0.5
    tmp49 += tmp35 * 0.5
    tmp49 += tmp36
    tmp43 = np.copy(tmp39)
    tmp43 += tmp40 * 2
    tmp43 += tmp42
    del tmp42
    tmp82 = np.copy(tmp80) * 0.5
    tmp82 += tmp81
    tmp104 = einsum(t1.bb, (0, 1), tmp103, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp103
    tmp92 = einsum(tmp91, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 2), (1, 4, 3, 5))
    tmp101 = einsum(t2.bbbb, (0, 1, 2, 3), tmp53, (0, 1, 4, 5), (4, 5, 2, 3))
    tmp100 = einsum(t2.bbbb, (0, 1, 2, 3), tmp41, (1, 4), (0, 4, 2, 3)) * -1
    tmp97 = np.copy(tmp35)
    tmp97 += tmp36 * 2
    tmp102 = einsum(t1.bb, (0, 1), tmp53, (0, 2, 3, 4), (2, 4, 3, 1))
    tmp96 = einsum(tmp95, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 2), (1, 4, 3, 5))
    tmp99 = np.copy(tmp80)
    del tmp80
    tmp99 += tmp81 * 2
    del tmp81
    tmp87 = np.copy(tmp39) * 0.5
    del tmp39
    tmp87 += tmp40
    del tmp40
    tmp87 += tmp86
    del tmp86
    tmp38 = einsum(l1.aa, (0, 1), t2.abab, (2, 3, 0, 4), (1, 2, 3, 4))
    tmp30 = np.copy(tmp25) * 2
    tmp30 += tmp27
    tmp30 += tmp29
    del tmp29
    tmp48 = einsum(t2.abab, (0, 1, 2, 3), tmp13, (4, 1, 5, 2), (4, 0, 5, 3))
    tmp58 = einsum(l1.bb, (0, 1), t2.abab, (2, 3, 4, 0), (2, 1, 3, 4))
    tmp89 = np.copy(tmp44)
    tmp89 += tmp45
    tmp90 = np.copy(tmp60)
    tmp90 += tmp59
    tmp65 = np.copy(tmp63) * 2
    tmp65 += tmp64
    tmp47 = einsum(t1.bb, (0, 1), tmp46, (2, 3, 0, 4), (2, 3, 4, 1))
    tmp72 = np.copy(tmp20) * 2
    tmp72 += tmp21
    tmp61 = einsum(tmp26, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (1, 2, 4, 5))
    tmp77 = einsum(tmp33, (0, 1, 2, 3), t1.aa, (0, 4), (1, 3, 2, 4))
    tmp76 = einsum(tmp33, (0, 1, 2, 3), t2.aaaa, (0, 1, 4, 5), (2, 3, 4, 5))
    tmp73 = einsum(t1.aa, (0, 1), tmp24, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp79 = einsum(tmp78, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    del tmp78
    tmp23 = np.copy(t1.aa)
    tmp23 += tmp20 * 2
    tmp23 += tmp21
    tmp67 = einsum(tmp66, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp55 = np.copy(t1.aa)
    tmp55 += tmp20 * 2
    tmp55 += tmp21
    tmp71 = einsum(t2.aaaa, (0, 1, 2, 3), tmp70, (1, 4, 3, 5), (0, 4, 2, 5))
    tmp74 = np.copy(tmp63)
    del tmp63
    tmp74 += tmp64 * 0.5
    del tmp64
    tmp57 = np.copy(tmp25)
    del tmp25
    tmp57 += tmp27 * 0.5
    del tmp27
    tmp57 += tmp56
    del tmp56
    tmp75 = einsum(t2.aaaa, (0, 1, 2, 3), tmp4, (1, 4), (4, 0, 2, 3)) * -1
    tmp69 = einsum(t2.aaaa, (0, 1, 2, 3), tmp68, (1, 4, 3, 5), (0, 4, 2, 5))
    tmp54 = einsum(t1.bb, (0, 1), tmp53, (0, 2, 3, 4), (2, 3, 4, 1)) * 2
    del tmp53
    tmp62 = np.copy(t1.bb)
    tmp62 += tmp35
    del tmp35
    tmp62 += tmp36 * 2
    del tmp36
    tmp16 = np.copy(tmp8) * 0.5
    tmp16 += tmp9 * 0.5
    tmp16 += tmp10
    tmp34 = einsum(tmp33, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 3, 4)) * 2
    del tmp33
    tmp22 = np.copy(t1.aa) * 0.5
    tmp22 += tmp20
    del tmp20
    tmp22 += tmp21 * 0.5
    del tmp21
    tmp15 = np.copy(delta.bb.oo) * -1
    tmp15 += tmp8
    tmp15 += tmp9
    tmp15 += tmp10 * 2
    tmp11 = np.copy(delta.bb.oo) * -0.5
    tmp11 += tmp8 * 0.5
    del tmp8
    tmp11 += tmp9 * 0.5
    del tmp9
    tmp11 += tmp10
    del tmp10
    tmp3 = np.copy(delta.aa.oo) * -1
    tmp3 += tmp0
    del tmp0
    tmp3 += tmp1 * 2
    del tmp1
    tmp3 += tmp2
    del tmp2
    rdm2.bbbb.vvvv = np.copy(np.transpose(tmp133, (1, 0, 3, 2))) * 2
    del tmp133
    rdm2.bbbb.vvvv += einsum(tmp131, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3)) * 2
    rdm2.abab.vvvv = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 5), (0, 1, 4, 5))
    rdm2.abab.vvvv += einsum(t1.aa, (0, 1), tmp130, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.aaaa.vvvv = np.copy(np.transpose(tmp132, (1, 0, 3, 2))) * 2
    del tmp132
    rdm2.aaaa.vvvv += einsum(tmp129, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * 2
    rdm2.bbbb.vvvo = np.copy(np.transpose(tmp131, (2, 1, 3, 0))) * 2
    rdm2.abab.vvvo = einsum(t1.aa, (0, 1), l2.abab, (2, 3, 0, 4), (2, 3, 1, 4))
    rdm2.aaaa.vvvo = np.copy(np.transpose(tmp129, (2, 1, 3, 0))) * 2
    rdm2.bbbb.vvov = np.copy(np.transpose(tmp131, (2, 1, 0, 3))) * -2
    del tmp131
    rdm2.abab.vvov = np.copy(np.transpose(tmp130, (1, 2, 0, 3)))
    del tmp130
    rdm2.aaaa.vvov = np.copy(np.transpose(tmp129, (2, 1, 0, 3))) * -2
    del tmp129
    rdm2.bbbb.vovv = np.copy(np.transpose(tmp122, (1, 0, 3, 2))) * 2
    rdm2.bbbb.vovv += einsum(t1.bb, (0, 1), tmp109, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.vovv += einsum(tmp109, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.vovv += np.transpose(tmp125, (2, 0, 1, 3))
    rdm2.bbbb.vovv += np.transpose(tmp125, (2, 0, 3, 1)) * -1
    rdm2.bbbb.vovv += np.transpose(tmp126, (1, 0, 3, 2)) * 2
    rdm2.bbbb.vovv += np.transpose(tmp127, (1, 0, 3, 2)) * 2
    rdm2.abab.vovv = einsum(l1.aa, (0, 1), t2.abab, (1, 2, 3, 4), (0, 2, 3, 4))
    rdm2.abab.vovv += einsum(tmp106, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.abab.vovv += einsum(t1.aa, (0, 1), tmp128, (0, 2, 3, 4), (3, 2, 1, 4)) * 2
    del tmp128
    rdm2.abab.vovv += einsum(t1.bb, (0, 1), tmp115, (0, 2, 3, 4), (3, 2, 4, 1)) * -1
    rdm2.abab.vovv += einsum(t2.abab, (0, 1, 2, 3), tmp13, (0, 1, 4, 5), (5, 4, 2, 3)) * -1
    rdm2.abab.vovv += einsum(t1.aa, (0, 1), tmp114, (0, 2, 3, 4), (3, 2, 1, 4)) * -1
    rdm2.aaaa.vovv = np.copy(np.transpose(tmp116, (1, 0, 3, 2))) * 2
    rdm2.aaaa.vovv += einsum(t1.aa, (0, 1), tmp117, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.aaaa.vovv += einsum(tmp106, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.vovv += np.transpose(tmp119, (2, 0, 1, 3))
    rdm2.aaaa.vovv += np.transpose(tmp119, (2, 0, 3, 1)) * -1
    rdm2.aaaa.vovv += np.transpose(tmp120, (1, 0, 3, 2)) * 2
    rdm2.aaaa.vovv += np.transpose(tmp121, (1, 0, 3, 2)) * 2
    rdm2.bbbb.ovvv = np.copy(np.transpose(tmp122, (0, 1, 3, 2))) * -2
    del tmp122
    rdm2.bbbb.ovvv += einsum(t1.bb, (0, 1), tmp109, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.ovvv += einsum(tmp109, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.ovvv += einsum(tmp123, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3)) * -1
    del tmp123
    rdm2.bbbb.ovvv += np.transpose(tmp125, (0, 2, 3, 1))
    del tmp125
    rdm2.bbbb.ovvv += np.transpose(tmp126, (0, 1, 3, 2)) * -2
    del tmp126
    rdm2.bbbb.ovvv += np.transpose(tmp127, (0, 1, 3, 2)) * -2
    del tmp127
    rdm2.abab.ovvv = einsum(l1.bb, (0, 1), t2.abab, (2, 1, 3, 4), (2, 0, 3, 4))
    rdm2.abab.ovvv += einsum(t1.aa, (0, 1), tmp109, (2, 3), (0, 2, 1, 3))
    rdm2.abab.ovvv += einsum(t1.aa, (0, 1), tmp88, (0, 2, 3, 4), (2, 3, 1, 4)) * -1
    rdm2.abab.ovvv += einsum(t1.bb, (0, 1), tmp85, (2, 0, 3, 4), (2, 4, 3, 1)) * 2
    rdm2.abab.ovvv += einsum(tmp26, (0, 1, 2, 3), t2.abab, (0, 2, 4, 5), (1, 3, 4, 5)) * -1
    rdm2.abab.ovvv += einsum(tmp112, (0, 1, 2, 3), t1.bb, (1, 4), (0, 3, 2, 4)) * -1
    rdm2.aaaa.ovvv = np.copy(np.transpose(tmp116, (0, 1, 3, 2))) * -2
    del tmp116
    rdm2.aaaa.ovvv += einsum(t1.aa, (0, 1), tmp117, (2, 3), (0, 2, 1, 3)) * 2
    del tmp117
    rdm2.aaaa.ovvv += einsum(tmp106, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ovvv += einsum(t1.aa, (0, 1), tmp118, (0, 2, 3, 4), (2, 3, 1, 4)) * -4
    del tmp118
    rdm2.aaaa.ovvv += np.transpose(tmp119, (0, 2, 3, 1))
    del tmp119
    rdm2.aaaa.ovvv += np.transpose(tmp120, (0, 1, 3, 2)) * -2
    del tmp120
    rdm2.aaaa.ovvv += np.transpose(tmp121, (0, 1, 3, 2)) * -2
    del tmp121
    rdm2.bbbb.vvoo = np.copy(l2.bbbb) * 2
    rdm2.abab.vvoo = np.copy(l2.abab)
    rdm2.aaaa.vvoo = np.copy(l2.aaaa) * 2
    rdm2.bbbb.vovo = einsum(tmp109, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.vovo += np.transpose(tmp91, (2, 1, 3, 0)) * -4
    rdm2.bbbb.vovo += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.vovo += np.transpose(tmp95, (2, 1, 3, 0)) * -1
    rdm2.bbbb.vovo += np.transpose(tmp111, (2, 1, 3, 0)) * 2
    rdm2.abab.vovo = einsum(tmp106, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.abab.vovo += np.transpose(tmp115, (2, 1, 3, 0)) * -1
    del tmp115
    rdm2.abab.vovo += einsum(t1.aa, (0, 1), tmp13, (0, 2, 3, 4), (4, 3, 1, 2)) * -1
    rdm2.aaaa.vovo = einsum(tmp106, (0, 1), delta.aa.oo, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.vovo += np.transpose(tmp70, (2, 1, 3, 0)) * -1
    rdm2.aaaa.vovo += einsum(t1.aa, (0, 1), l1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.vovo += np.transpose(tmp68, (2, 1, 3, 0)) * -4
    rdm2.aaaa.vovo += np.transpose(tmp107, (2, 1, 3, 0)) * 2
    rdm2.bbbb.voov = einsum(tmp110, (0, 1), delta.bb.oo, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.bbbb.voov += np.transpose(tmp91, (2, 1, 0, 3)) * 4
    rdm2.bbbb.voov += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.voov += np.transpose(tmp95, (2, 1, 0, 3))
    rdm2.bbbb.voov += np.transpose(tmp111, (2, 1, 0, 3)) * -2
    rdm2.abab.voov = einsum(l1.aa, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.abab.voov += np.transpose(tmp113, (2, 1, 0, 3)) * 2
    del tmp113
    rdm2.abab.voov += np.transpose(tmp93, (2, 1, 0, 3)) * 2
    del tmp93
    rdm2.abab.voov += np.transpose(tmp114, (2, 1, 0, 3)) * -1
    del tmp114
    rdm2.aaaa.voov = einsum(tmp106, (0, 1), delta.aa.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.voov += np.transpose(tmp70, (2, 1, 0, 3))
    rdm2.aaaa.voov += einsum(t1.aa, (0, 1), l1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.voov += np.transpose(tmp68, (2, 1, 0, 3)) * 4
    rdm2.aaaa.voov += np.transpose(tmp107, (2, 1, 0, 3)) * -2
    rdm2.bbbb.ovvo = einsum(tmp109, (0, 1), delta.bb.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.ovvo += np.transpose(tmp91, (1, 2, 3, 0)) * 4
    rdm2.bbbb.ovvo += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.ovvo += np.transpose(tmp95, (1, 2, 3, 0))
    rdm2.bbbb.ovvo += np.transpose(tmp111, (1, 2, 3, 0)) * -2
    rdm2.abab.ovvo = np.copy(np.transpose(tmp66, (0, 3, 2, 1))) * 2
    del tmp66
    rdm2.abab.ovvo += einsum(l1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.abab.ovvo += np.transpose(tmp84, (0, 3, 2, 1)) * 2
    del tmp84
    rdm2.abab.ovvo += np.transpose(tmp112, (0, 3, 2, 1)) * -1
    del tmp112
    rdm2.aaaa.ovvo = einsum(tmp106, (0, 1), delta.aa.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ovvo += np.transpose(tmp70, (1, 2, 3, 0))
    rdm2.aaaa.ovvo += einsum(t1.aa, (0, 1), l1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.ovvo += np.transpose(tmp68, (1, 2, 3, 0)) * 4
    rdm2.aaaa.ovvo += np.transpose(tmp107, (1, 2, 3, 0)) * -2
    rdm2.bbbb.ovov = einsum(tmp110, (0, 1), delta.bb.oo, (2, 3), (2, 0, 3, 1)) * 2
    del tmp110
    rdm2.bbbb.ovov += np.transpose(tmp91, (1, 2, 0, 3)) * -4
    del tmp91
    rdm2.bbbb.ovov += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.ovov += np.transpose(tmp95, (1, 2, 0, 3)) * -1
    del tmp95
    rdm2.bbbb.ovov += np.transpose(tmp111, (1, 2, 0, 3)) * 2
    del tmp111
    rdm2.abab.ovov = einsum(tmp109, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    del tmp109
    rdm2.abab.ovov += np.transpose(tmp88, (1, 2, 0, 3)) * -1
    rdm2.abab.ovov += einsum(tmp26, (0, 1, 2, 3), t1.bb, (2, 4), (1, 3, 0, 4)) * -1
    rdm2.aaaa.ovov = einsum(tmp106, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    del tmp106
    rdm2.aaaa.ovov += np.transpose(tmp70, (1, 2, 0, 3)) * -1
    del tmp70
    rdm2.aaaa.ovov += einsum(t1.aa, (0, 1), l1.aa, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.ovov += np.transpose(tmp68, (1, 2, 0, 3)) * -4
    del tmp68
    rdm2.aaaa.ovov += np.transpose(tmp107, (1, 2, 0, 3)) * 2
    del tmp107
    rdm2.bbbb.oovv = np.copy(t2.bbbb) * 2
    rdm2.bbbb.oovv += einsum(tmp82, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 4, 1)) * -4
    rdm2.bbbb.oovv += np.transpose(tmp92, (0, 1, 3, 2)) * -8
    rdm2.bbbb.oovv += np.transpose(tmp94, (0, 1, 3, 2)) * -2
    rdm2.bbbb.oovv += np.transpose(tmp96, (0, 1, 3, 2)) * -2
    rdm2.bbbb.oovv += np.transpose(tmp96, (1, 0, 2, 3)) * -2
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp49, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.bbbb.oovv += tmp92 * 8
    del tmp92
    rdm2.bbbb.oovv += np.transpose(tmp94, (1, 0, 3, 2)) * 2
    del tmp94
    rdm2.bbbb.oovv += tmp96 * 2
    rdm2.bbbb.oovv += np.transpose(tmp96, (1, 0, 3, 2)) * 2
    del tmp96
    rdm2.bbbb.oovv += einsum(tmp37, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.oovv += einsum(tmp97, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp97, (2, 3), (0, 2, 3, 1)) * -1
    del tmp97
    rdm2.bbbb.oovv += tmp98 * 2
    rdm2.bbbb.oovv += einsum(tmp99, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 1, 4)) * 2
    del tmp99
    rdm2.bbbb.oovv += np.transpose(tmp98, (0, 1, 3, 2)) * -2
    del tmp98
    rdm2.bbbb.oovv += np.transpose(tmp100, (0, 1, 3, 2)) * -2
    rdm2.bbbb.oovv += einsum(tmp87, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp43, (2, 3), (0, 2, 3, 1))
    rdm2.bbbb.oovv += np.transpose(tmp100, (1, 0, 3, 2)) * 2
    del tmp100
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp87, (2, 3), (2, 0, 1, 3)) * 2
    rdm2.bbbb.oovv += einsum(tmp43, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.bbbb.oovv += np.transpose(tmp101, (1, 0, 3, 2)) * 2
    del tmp101
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp102, (0, 2, 3, 4), (2, 3, 1, 4)) * 2
    del tmp102
    rdm2.bbbb.oovv += np.transpose(tmp104, (1, 0, 2, 3))
    rdm2.bbbb.oovv += tmp104 * -1
    rdm2.bbbb.oovv += np.transpose(tmp104, (1, 0, 3, 2)) * -1
    rdm2.bbbb.oovv += np.transpose(tmp104, (0, 1, 3, 2))
    del tmp104
    rdm2.abab.oovv = np.copy(t2.abab)
    rdm2.abab.oovv += einsum(tmp82, (0, 1), t2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    del tmp82
    rdm2.abab.oovv += einsum(tmp83, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5))
    del tmp83
    rdm2.abab.oovv += einsum(t2.bbbb, (0, 1, 2, 3), tmp85, (4, 1, 5, 3), (4, 0, 5, 2)) * 4
    del tmp85
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp37, (2, 3), (0, 2, 1, 3))
    rdm2.abab.oovv += einsum(tmp72, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp38, (0, 2, 3, 4), (2, 3, 1, 4)) * -1
    rdm2.abab.oovv += einsum(tmp65, (0, 1), t2.abab, (2, 3, 0, 4), (2, 3, 1, 4)) * -1
    rdm2.abab.oovv += einsum(t1.bb, (0, 1), tmp58, (2, 0, 3, 4), (2, 3, 4, 1)) * -1
    rdm2.abab.oovv += einsum(tmp41, (0, 1), t2.abab, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp87, (2, 3), (0, 2, 1, 3)) * -2
    del tmp87
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp4, (0, 4), (4, 1, 2, 3)) * -1
    rdm2.abab.oovv += einsum(tmp46, (0, 1, 2, 3), t2.abab, (0, 2, 4, 5), (1, 3, 4, 5))
    rdm2.abab.oovv += einsum(tmp47, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp88, (0, 4, 3, 5), (4, 1, 2, 5))
    del tmp88
    rdm2.abab.oovv += einsum(t1.bb, (0, 1), tmp30, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.abab.oovv += einsum(tmp48, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    rdm2.abab.oovv += einsum(tmp89, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -2
    del tmp89
    rdm2.abab.oovv += einsum(t1.bb, (0, 1), tmp90, (2, 0, 3, 4), (2, 3, 4, 1)) * -2
    del tmp90
    rdm2.abab.oovv += einsum(t1.bb, (0, 1), tmp61, (2, 0, 3, 4), (2, 3, 4, 1))
    rdm2.aaaa.oovv = np.copy(t2.aaaa) * 2
    rdm2.aaaa.oovv += einsum(tmp65, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    del tmp65
    rdm2.aaaa.oovv += np.transpose(tmp67, (0, 1, 3, 2)) * -2
    rdm2.aaaa.oovv += np.transpose(tmp69, (0, 1, 3, 2)) * -8
    rdm2.aaaa.oovv += np.transpose(tmp71, (0, 1, 3, 2)) * -2
    rdm2.aaaa.oovv += np.transpose(tmp71, (1, 0, 2, 3)) * -2
    rdm2.aaaa.oovv += einsum(tmp55, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.oovv += tmp67 * 2
    del tmp67
    rdm2.aaaa.oovv += tmp69 * 8
    del tmp69
    rdm2.aaaa.oovv += tmp71 * 2
    rdm2.aaaa.oovv += np.transpose(tmp71, (1, 0, 3, 2)) * 2
    del tmp71
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp23, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.oovv += einsum(tmp72, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.oovv += einsum(tmp72, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -1
    del tmp72
    rdm2.aaaa.oovv += tmp73 * 2
    rdm2.aaaa.oovv += einsum(t2.aaaa, (0, 1, 2, 3), tmp74, (3, 4), (0, 1, 4, 2)) * 4
    del tmp74
    rdm2.aaaa.oovv += np.transpose(tmp73, (0, 1, 3, 2)) * -2
    del tmp73
    rdm2.aaaa.oovv += np.transpose(tmp75, (1, 0, 3, 2)) * -2
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp30, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.aaaa.oovv += einsum(tmp57, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * 2
    rdm2.aaaa.oovv += np.transpose(tmp75, (0, 1, 3, 2)) * 2
    del tmp75
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp30, (2, 3), (2, 0, 1, 3))
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp57, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.aaaa.oovv += np.transpose(tmp76, (1, 0, 3, 2)) * 2
    del tmp76
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp77, (0, 2, 3, 4), (2, 3, 1, 4)) * 2
    del tmp77
    rdm2.aaaa.oovv += np.transpose(tmp79, (1, 0, 2, 3))
    rdm2.aaaa.oovv += tmp79 * -1
    rdm2.aaaa.oovv += np.transpose(tmp79, (1, 0, 3, 2)) * -1
    rdm2.aaaa.oovv += np.transpose(tmp79, (0, 1, 3, 2))
    del tmp79
    rdm2.bbbb.vooo = einsum(delta.bb.oo, (0, 1), l1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.vooo += einsum(l1.bb, (0, 1), delta.bb.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.vooo += np.transpose(tmp18, (3, 2, 1, 0)) * 2
    rdm2.abab.vooo = einsum(l1.aa, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.abab.vooo += np.transpose(tmp13, (3, 2, 0, 1)) * -1
    del tmp13
    rdm2.aaaa.vooo = einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.vooo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.vooo += np.transpose(tmp6, (3, 2, 1, 0)) * 2
    rdm2.bbbb.ovoo = einsum(delta.bb.oo, (0, 1), l1.bb, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.ovoo += einsum(l1.bb, (0, 1), delta.bb.oo, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.ovoo += np.transpose(tmp18, (2, 3, 1, 0)) * -2
    del tmp18
    rdm2.abab.ovoo = einsum(l1.bb, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    rdm2.abab.ovoo += np.transpose(tmp26, (1, 3, 0, 2)) * -1
    del tmp26
    rdm2.aaaa.ovoo = einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.ovoo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.ovoo += np.transpose(tmp6, (2, 3, 1, 0)) * -2
    del tmp6
    rdm2.bbbb.oovo = einsum(delta.bb.oo, (0, 1), tmp62, (2, 3), (2, 0, 3, 1))
    del tmp62
    rdm2.bbbb.oovo += einsum(delta.bb.oo, (0, 1), tmp37, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.oovo += np.transpose(tmp50, (2, 1, 3, 0)) * 2
    rdm2.bbbb.oovo += einsum(tmp43, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.bbbb.oovo += einsum(delta.bb.oo, (0, 1), tmp43, (2, 3), (0, 2, 3, 1))
    rdm2.bbbb.oovo += np.transpose(tmp51, (1, 2, 3, 0)) * 4
    rdm2.bbbb.oovo += np.transpose(tmp52, (1, 2, 3, 0))
    rdm2.bbbb.oovo += einsum(t1.bb, (0, 1), tmp16, (2, 3), (3, 0, 1, 2)) * 2
    rdm2.bbbb.oovo += np.transpose(tmp51, (2, 1, 3, 0)) * -4
    rdm2.bbbb.oovo += np.transpose(tmp52, (2, 1, 3, 0)) * -1
    rdm2.bbbb.oovo += einsum(tmp16, (0, 1), t1.bb, (2, 3), (2, 1, 3, 0)) * -2
    rdm2.bbbb.oovo += np.transpose(tmp54, (2, 1, 3, 0)) * -1
    rdm2.abab.oovo = einsum(tmp55, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.abab.oovo += np.transpose(tmp58, (0, 2, 3, 1)) * -1
    del tmp58
    rdm2.abab.oovo += einsum(tmp30, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.abab.oovo += np.transpose(tmp59, (0, 2, 3, 1)) * -2
    del tmp59
    rdm2.abab.oovo += np.transpose(tmp60, (0, 2, 3, 1)) * -2
    del tmp60
    rdm2.abab.oovo += einsum(t1.aa, (0, 1), tmp16, (2, 3), (0, 3, 1, 2)) * -2
    rdm2.abab.oovo += einsum(t1.aa, (0, 1), tmp46, (0, 2, 3, 4), (2, 4, 1, 3))
    del tmp46
    rdm2.abab.oovo += np.transpose(tmp61, (0, 2, 3, 1))
    del tmp61
    rdm2.aaaa.oovo = einsum(tmp55, (0, 1), delta.aa.oo, (2, 3), (0, 2, 1, 3))
    del tmp55
    rdm2.aaaa.oovo += einsum(tmp23, (0, 1), delta.aa.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.oovo += np.transpose(tmp24, (2, 1, 3, 0)) * 2
    rdm2.aaaa.oovo += einsum(tmp30, (0, 1), delta.aa.oo, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.aaaa.oovo += einsum(tmp57, (0, 1), delta.aa.oo, (2, 3), (2, 0, 1, 3)) * 2
    del tmp57
    rdm2.aaaa.oovo += np.transpose(tmp31, (1, 2, 3, 0)) * 4
    rdm2.aaaa.oovo += np.transpose(tmp32, (1, 2, 3, 0))
    rdm2.aaaa.oovo += einsum(t1.aa, (0, 1), tmp28, (2, 3), (3, 0, 1, 2)) * 2
    rdm2.aaaa.oovo += np.transpose(tmp31, (2, 1, 3, 0)) * -4
    rdm2.aaaa.oovo += np.transpose(tmp32, (2, 1, 3, 0)) * -1
    rdm2.aaaa.oovo += einsum(t1.aa, (0, 1), tmp28, (2, 3), (0, 3, 1, 2)) * -2
    del tmp28
    rdm2.aaaa.oovo += np.transpose(tmp34, (2, 1, 3, 0)) * -1
    rdm2.bbbb.ooov = einsum(tmp49, (0, 1), delta.bb.oo, (2, 3), (0, 2, 3, 1)) * -2
    del tmp49
    rdm2.bbbb.ooov += einsum(delta.bb.oo, (0, 1), tmp37, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.ooov += np.transpose(tmp50, (2, 1, 0, 3)) * -2
    del tmp50
    rdm2.bbbb.ooov += einsum(tmp43, (0, 1), delta.bb.oo, (2, 3), (0, 2, 3, 1))
    rdm2.bbbb.ooov += einsum(delta.bb.oo, (0, 1), tmp43, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.bbbb.ooov += np.transpose(tmp51, (1, 2, 0, 3)) * -4
    rdm2.bbbb.ooov += np.transpose(tmp52, (1, 2, 0, 3)) * -1
    rdm2.bbbb.ooov += einsum(t1.bb, (0, 1), tmp41, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.bbbb.ooov += np.transpose(tmp51, (2, 1, 0, 3)) * 4
    del tmp51
    rdm2.bbbb.ooov += np.transpose(tmp52, (2, 1, 0, 3))
    del tmp52
    rdm2.bbbb.ooov += einsum(t1.bb, (0, 1), tmp41, (2, 3), (0, 3, 2, 1))
    del tmp41
    rdm2.bbbb.ooov += np.transpose(tmp54, (2, 1, 0, 3))
    del tmp54
    rdm2.abab.ooov = einsum(tmp37, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    del tmp37
    rdm2.abab.ooov += np.transpose(tmp38, (1, 2, 0, 3)) * -1
    del tmp38
    rdm2.abab.ooov += einsum(tmp43, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1)) * -1
    del tmp43
    rdm2.abab.ooov += np.transpose(tmp44, (1, 2, 0, 3)) * -2
    del tmp44
    rdm2.abab.ooov += np.transpose(tmp45, (1, 2, 0, 3)) * -2
    del tmp45
    rdm2.abab.ooov += einsum(tmp4, (0, 1), t1.bb, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.abab.ooov += np.transpose(tmp47, (1, 2, 0, 3))
    del tmp47
    rdm2.abab.ooov += np.transpose(tmp48, (1, 2, 0, 3))
    del tmp48
    rdm2.aaaa.ooov = einsum(delta.aa.oo, (0, 1), tmp22, (2, 3), (2, 0, 1, 3)) * -2
    del tmp22
    rdm2.aaaa.ooov += einsum(tmp23, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    del tmp23
    rdm2.aaaa.ooov += np.transpose(tmp24, (2, 1, 0, 3)) * -2
    del tmp24
    rdm2.aaaa.ooov += einsum(tmp30, (0, 1), delta.aa.oo, (2, 3), (0, 2, 3, 1))
    rdm2.aaaa.ooov += einsum(delta.aa.oo, (0, 1), tmp30, (2, 3), (0, 2, 1, 3)) * -1
    del tmp30
    rdm2.aaaa.ooov += np.transpose(tmp31, (1, 2, 0, 3)) * -4
    rdm2.aaaa.ooov += np.transpose(tmp32, (1, 2, 0, 3)) * -1
    rdm2.aaaa.ooov += einsum(t1.aa, (0, 1), tmp4, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.aaaa.ooov += np.transpose(tmp31, (2, 1, 0, 3)) * 4
    del tmp31
    rdm2.aaaa.ooov += np.transpose(tmp32, (2, 1, 0, 3))
    del tmp32
    rdm2.aaaa.ooov += einsum(tmp4, (0, 1), t1.aa, (2, 3), (2, 1, 0, 3))
    rdm2.aaaa.ooov += np.transpose(tmp34, (2, 1, 0, 3))
    del tmp34
    rdm2.bbbb.oooo = einsum(tmp15, (0, 1), delta.bb.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.bbbb.oooo += einsum(tmp15, (0, 1), delta.bb.oo, (2, 3), (1, 2, 3, 0))
    del tmp15
    rdm2.bbbb.oooo += einsum(tmp16, (0, 1), delta.bb.oo, (2, 3), (1, 2, 0, 3)) * -2
    rdm2.bbbb.oooo += einsum(tmp16, (0, 1), delta.bb.oo, (2, 3), (2, 1, 0, 3)) * 2
    del tmp16
    rdm2.bbbb.oooo += np.transpose(tmp17, (3, 2, 1, 0)) * 2
    del tmp17
    rdm2.bbbb.oooo += np.transpose(tmp19, (2, 3, 1, 0)) * -2
    del tmp19
    rdm2.abab.oooo = einsum(tmp11, (0, 1), delta.aa.oo, (2, 3), (2, 1, 3, 0)) * -2
    del tmp11
    rdm2.abab.oooo += einsum(tmp4, (0, 1), delta.bb.oo, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.abab.oooo += np.transpose(tmp12, (1, 3, 0, 2))
    del tmp12
    rdm2.abab.oooo += np.transpose(tmp14, (1, 3, 0, 2))
    del tmp14
    rdm2.aaaa.oooo = einsum(delta.aa.oo, (0, 1), tmp3, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp3, (2, 3), (3, 0, 1, 2))
    del tmp3
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp4, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.aaaa.oooo += einsum(tmp4, (0, 1), delta.aa.oo, (2, 3), (2, 1, 0, 3))
    del tmp4, delta
    rdm2.aaaa.oooo += np.transpose(tmp5, (3, 2, 1, 0)) * 2
    del tmp5
    rdm2.aaaa.oooo += np.transpose(tmp7, (2, 3, 1, 0)) * -2
    del tmp7
    rdm2.aaaa = pack_2e(rdm2.aaaa.oooo, rdm2.aaaa.ooov, rdm2.aaaa.oovo, rdm2.aaaa.ovoo, rdm2.aaaa.vooo, rdm2.aaaa.oovv, rdm2.aaaa.ovov, rdm2.aaaa.ovvo, rdm2.aaaa.voov, rdm2.aaaa.vovo, rdm2.aaaa.vvoo, rdm2.aaaa.ovvv, rdm2.aaaa.vovv, rdm2.aaaa.vvov, rdm2.aaaa.vvvo, rdm2.aaaa.vvvv)
    rdm2.abab = pack_2e(rdm2.abab.oooo, rdm2.abab.ooov, rdm2.abab.oovo, rdm2.abab.ovoo, rdm2.abab.vooo, rdm2.abab.oovv, rdm2.abab.ovov, rdm2.abab.ovvo, rdm2.abab.voov, rdm2.abab.vovo, rdm2.abab.vvoo, rdm2.abab.ovvv, rdm2.abab.vovv, rdm2.abab.vvov, rdm2.abab.vvvo, rdm2.abab.vvvv)
    rdm2.bbbb = pack_2e(rdm2.bbbb.oooo, rdm2.bbbb.ooov, rdm2.bbbb.oovo, rdm2.bbbb.ovoo, rdm2.bbbb.vooo, rdm2.bbbb.oovv, rdm2.bbbb.ovov, rdm2.bbbb.ovvo, rdm2.bbbb.voov, rdm2.bbbb.vovo, rdm2.bbbb.vvoo, rdm2.bbbb.ovvv, rdm2.bbbb.vovv, rdm2.bbbb.vvov, rdm2.bbbb.vvvo, rdm2.bbbb.vvvv)
    rdm2 = Namespace(
        aaaa=np.transpose(rdm2.aaaa, (0, 2, 1, 3)),
        aabb=np.transpose(rdm2.abab, (0, 2, 1, 3)),
        bbbb=np.transpose(rdm2.bbbb, (0, 2, 1, 3)),
    )

    return rdm2

def hbar_matvec_ip_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:44:26.195611.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp100 : array
    tmp101 : array
    tmp102 : array
    tmp104 : array
    tmp106 : array
    tmp108 : array
    tmp11 : array
    tmp110 : array
    tmp112 : array
    tmp114 : array
    tmp116 : array
    tmp118 : array
    tmp12 : array
    tmp120 : array
    tmp122 : array
    tmp124 : array
    tmp125 : array
    tmp126 : array
    tmp127 : array
    tmp128 : array
    tmp129 : array
    tmp13 : array
    tmp130 : array
    tmp131 : array
    tmp132 : array
    tmp139 : array
    tmp145 : array
    tmp147 : array
    tmp149 : array
    tmp15 : array
    tmp152 : array
    tmp155 : array
    tmp156 : array
    tmp158 : array
    tmp16 : array
    tmp162 : array
    tmp163 : array
    tmp164 : array
    tmp166 : array
    tmp168 : array
    tmp170 : array
    tmp171 : array
    tmp172 : array
    tmp174 : array
    tmp18 : array
    tmp185 : array
    tmp186 : array
    tmp187 : array
    tmp189 : array
    tmp190 : array
    tmp192 : array
    tmp194 : array
    tmp197 : array
    tmp199 : array
    tmp20 : array
    tmp200 : array
    tmp201 : array
    tmp209 : array
    tmp214 : array
    tmp217 : array
    tmp22 : array
    tmp222 : array
    tmp223 : array
    tmp224 : array
    tmp229 : array
    tmp230 : array
    tmp232 : array
    tmp233 : array
    tmp237 : array
    tmp238 : array
    tmp239 : array
    tmp24 : array
    tmp241 : array
    tmp243 : array
    tmp244 : array
    tmp248 : array
    tmp249 : array
    tmp25 : array
    tmp255 : array
    tmp256 : array
    tmp257 : array
    tmp258 : array
    tmp259 : array
    tmp26 : array
    tmp262 : array
    tmp264 : array
    tmp265 : array
    tmp267 : array
    tmp269 : array
    tmp270 : array
    tmp271 : array
    tmp273 : array
    tmp275 : array
    tmp277 : array
    tmp279 : array
    tmp28 : array
    tmp281 : array
    tmp283 : array
    tmp284 : array
    tmp285 : array
    tmp286 : array
    tmp287 : array
    tmp288 : array
    tmp289 : array
    tmp290 : array
    tmp292 : array
    tmp297 : array
    tmp298 : array
    tmp299 : array
    tmp300 : array
    tmp302 : array
    tmp304 : array
    tmp307 : array
    tmp308 : array
    tmp309 : array
    tmp31 : array
    tmp310 : array
    tmp311 : array
    tmp312 : array
    tmp316 : array
    tmp317 : array
    tmp318 : array
    tmp319 : array
    tmp32 : array
    tmp321 : array
    tmp322 : array
    tmp323 : array
    tmp324 : array
    tmp325 : array
    tmp326 : array
    tmp328 : array
    tmp329 : array
    tmp33 : array
    tmp333 : array
    tmp334 : array
    tmp335 : array
    tmp337 : array
    tmp339 : array
    tmp340 : array
    tmp344 : array
    tmp345 : array
    tmp346 : array
    tmp347 : array
    tmp348 : array
    tmp349 : array
    tmp354 : array
    tmp355 : array
    tmp356 : array
    tmp367 : array
    tmp369 : array
    tmp37 : array
    tmp371 : array
    tmp373 : array
    tmp375 : array
    tmp377 : array
    tmp383 : array
    tmp39 : array
    tmp394 : array
    tmp396 : array
    tmp398 : array
    tmp4 : array
    tmp41 : array
    tmp414 : array
    tmp418 : array
    tmp420 : array
    tmp422 : array
    tmp427 : array
    tmp429 : array
    tmp43 : array
    tmp433 : array
    tmp435 : array
    tmp437 : array
    tmp439 : array
    tmp441 : array
    tmp45 : array
    tmp46 : array
    tmp47 : array
    tmp49 : array
    tmp5 : array
    tmp53 : array
    tmp55 : array
    tmp57 : array
    tmp59 : array
    tmp6 : array
    tmp61 : array
    tmp63 : array
    tmp65 : array
    tmp66 : array
    tmp67 : array
    tmp68 : array
    tmp69 : array
    tmp7 : array
    tmp70 : array
    tmp72 : array
    tmp74 : array
    tmp76 : array
    tmp78 : array
    tmp80 : array
    tmp83 : array
    tmp86 : array
    tmp87 : array
    tmp89 : array
    tmp9 : array
    """

    tmp37 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 2, 1))
    tmp15 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp12 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp11 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 1), (0, 3))
    tmp39 = einsum(t1.bb, (0, 1), v.aabb.ovov, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp13 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp9 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 3, 0, 1), (2, 3))
    tmp7 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 1, 0, 3), (2, 3))
    tmp16 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp429 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp375 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    tmp369 = einsum(t1.bb, (0, 1), tmp37, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp318 = einsum(t1.bb, (0, 1), v.bbbb.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp47 = einsum(tmp15, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp46 = einsum(tmp12, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp45 = einsum(t1.bb, (0, 1), tmp11, (2, 1), (0, 2))
    tmp233 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp43 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp41 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp28 = einsum(t1.bb, (0, 1), f.bb.ov, (2, 1), (2, 0))
    tmp244 = einsum(t1.aa, (0, 1), v.aabb.ovoo, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp18 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp230 = einsum(tmp39, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp319 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 1, 2))
    tmp257 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp256 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (0, 3), (1, 2))
    tmp255 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (0, 1), (2, 3))
    tmp33 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp32 = einsum(t1.bb, (0, 1), v.bbbb.ooov, (2, 3, 0, 1), (2, 3))
    tmp31 = einsum(t1.bb, (0, 1), v.bbbb.ooov, (2, 0, 3, 1), (2, 3))
    tmp192 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp189 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 2, 0, 1))
    tmp26 = einsum(t1.aa, (0, 1), tmp13, (2, 1), (0, 2))
    tmp25 = einsum(tmp9, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp24 = einsum(tmp7, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp158 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp22 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 3), (4, 0))
    tmp20 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 1, 3), (4, 0))
    tmp1 = einsum(t1.aa, (0, 1), f.aa.ov, (2, 1), (2, 0))
    tmp6 = einsum(t1.bb, (0, 1), v.aabb.ooov, (2, 3, 0, 1), (2, 3))
    tmp5 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    tmp4 = einsum(t1.aa, (0, 1), v.aaaa.ooov, (2, 0, 3, 1), (2, 3))
    tmp78 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp72 = einsum(t1.aa, (0, 1), tmp16, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp61 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp57 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp55 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    tmp53 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp441 = einsum(tmp429, (0, 1, 2, 3), t1.bb, (3, 4), (0, 2, 1, 4))
    tmp439 = einsum(t1.bb, (0, 1), tmp429, (2, 3, 0, 4), (2, 3, 4, 1))
    tmp437 = einsum(tmp39, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (1, 4, 2, 5))
    tmp435 = einsum(tmp37, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp433 = einsum(t2.bbbb, (0, 1, 2, 3), tmp37, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp427 = einsum(t1.bb, (0, 1), v.bbbb.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp422 = einsum(tmp15, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp420 = einsum(tmp12, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp418 = einsum(tmp11, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp414 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp398 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 4, 1, 5), (4, 2, 3, 5))
    tmp396 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp394 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp383 = einsum(t1.bb, (0, 1), v.bbbb.oooo, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp377 = einsum(t1.bb, (0, 1), tmp375, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    tmp373 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.bbbb, (4, 5, 3, 1), (4, 5, 0, 2)) * -1
    tmp371 = einsum(t1.bb, (0, 1), tmp369, (2, 3, 0, 4), (3, 2, 4, 1))
    tmp367 = einsum(t1.bb, (0, 1), tmp318, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp356 = einsum(t1.bb, (0, 1), tmp47, (2, 0), (2, 1))
    tmp355 = einsum(t1.bb, (0, 1), tmp46, (2, 0), (2, 1))
    tmp354 = einsum(t1.bb, (0, 1), tmp45, (2, 0), (2, 1))
    tmp349 = einsum(t1.bb, (0, 1), tmp233, (2, 3, 4, 0), (3, 2, 4, 1))
    tmp348 = einsum(t1.bb, (0, 1), tmp43, (2, 0), (2, 1))
    tmp347 = einsum(t1.bb, (0, 1), tmp41, (2, 0), (2, 1))
    tmp346 = einsum(tmp39, (0, 1, 2, 3), t2.abab, (4, 2, 3, 5), (4, 0, 1, 5))
    tmp345 = einsum(tmp39, (0, 1, 2, 3), t2.abab, (0, 2, 3, 4), (1, 4))
    tmp344 = einsum(t2.bbbb, (0, 1, 2, 3), tmp37, (4, 1, 0, 3), (4, 2))
    tmp340 = einsum(v.aabb.oovv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp339 = einsum(t1.bb, (0, 1), tmp28, (0, 2), (2, 1))
    tmp337 = einsum(t1.bb, (0, 1), tmp244, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp335 = einsum(tmp18, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp334 = einsum(t2.abab, (0, 1, 2, 3), tmp16, (4, 5, 0, 2), (4, 5, 1, 3))
    tmp333 = einsum(t2.abab, (0, 1, 2, 3), tmp16, (4, 0, 5, 2), (4, 5, 1, 3))
    tmp329 = einsum(v.bbbb.oovv, (0, 1, 2, 3), t1.bb, (1, 3), (0, 2))
    tmp328 = einsum(t1.bb, (0, 1), tmp230, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp326 = einsum(t1.aa, (0, 1), tmp319, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp325 = einsum(tmp257, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp324 = einsum(t1.bb, (0, 1), tmp256, (1, 2), (0, 2))
    tmp323 = einsum(tmp255, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp322 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp321 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.bbbb, (4, 0, 3, 1), (4, 2)) * -1
    tmp317 = einsum(t1.bb, (0, 1), v.bbbb.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp316 = einsum(t1.bb, (0, 1), f.bb.vv, (2, 1), (0, 2))
    tmp312 = einsum(t1.bb, (0, 1), tmp33, (2, 0), (2, 1))
    tmp311 = einsum(t1.bb, (0, 1), tmp32, (2, 0), (2, 1))
    tmp310 = einsum(t1.bb, (0, 1), tmp31, (2, 0), (2, 1))
    tmp309 = einsum(tmp13, (0, 1), t2.abab, (2, 3, 1, 4), (2, 0, 3, 4))
    tmp308 = einsum(tmp9, (0, 1), t2.abab, (2, 3, 1, 4), (2, 0, 3, 4))
    tmp307 = einsum(tmp7, (0, 1), t2.abab, (2, 3, 1, 4), (2, 0, 3, 4))
    tmp304 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 5), (4, 0, 5, 3))
    tmp302 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 1, 4), (4, 3))
    tmp300 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (0, 2, 4, 3), (4, 1))
    tmp299 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (4, 3, 1, 5), (4, 0, 2, 5))
    tmp298 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 3, 1, 4), (2, 4))
    tmp297 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 0, 1, 3), (4, 2))
    tmp292 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (4, 2), (4, 0, 1, 3))
    tmp290 = einsum(t1.bb, (0, 1), f.bb.oo, (2, 0), (2, 1))
    tmp289 = einsum(tmp15, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp288 = einsum(tmp13, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp287 = einsum(tmp12, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp286 = einsum(tmp11, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp285 = einsum(tmp9, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp284 = einsum(tmp7, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp283 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 5), (4, 2, 5, 3))
    tmp281 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp279 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp277 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp275 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 4, 1, 5))
    tmp273 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 1, 5), (0, 4, 3, 5))
    tmp271 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp270 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 1, 4, 5))
    tmp269 = einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ooov, (4, 0, 5, 2), (4, 5, 1, 3))
    tmp267 = einsum(t1.bb, (0, 1), v.aabb.oooo, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp265 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp264 = einsum(f.aa.ov, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp262 = einsum(t1.bb, (0, 1), tmp192, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp259 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp258 = einsum(t1.aa, (0, 1), v.aabb.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp249 = einsum(t1.aa, (0, 1), tmp244, (2, 0, 3, 4), (2, 4, 3, 1))
    tmp248 = einsum(t2.abab, (0, 1, 2, 3), tmp18, (4, 0, 5, 3), (4, 1, 5, 2))
    tmp243 = einsum(t1.aa, (0, 1), v.aabb.vvoo, (2, 1, 3, 4), (0, 3, 4, 2))
    tmp241 = einsum(t1.aa, (0, 1), tmp233, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp239 = einsum(tmp39, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 1, 2, 5))
    tmp238 = einsum(tmp37, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp237 = einsum(t2.abab, (0, 1, 2, 3), tmp37, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp232 = einsum(t1.aa, (0, 1), tmp230, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp229 = einsum(t1.aa, (0, 1), tmp189, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp224 = einsum(tmp15, (0, 1), t2.abab, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp223 = einsum(tmp12, (0, 1), t2.abab, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp222 = einsum(tmp11, (0, 1), t2.abab, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp217 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (4, 2, 5, 1))
    tmp214 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp209 = einsum(f.bb.ov, (0, 1), t2.abab, (2, 3, 4, 1), (2, 0, 3, 4))
    tmp201 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovoo, (1, 3, 4, 5), (0, 4, 5, 2))
    tmp200 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ooov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp199 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp197 = einsum(t1.aa, (0, 1), v.aabb.oooo, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp194 = einsum(t1.aa, (0, 1), tmp192, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp190 = einsum(v.aabb.vvov, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 5, 2, 0))
    tmp187 = einsum(t1.aa, (0, 1), tmp26, (2, 0), (2, 1))
    tmp186 = einsum(tmp25, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp185 = einsum(t1.aa, (0, 1), tmp24, (2, 0), (2, 1))
    tmp174 = einsum(t1.aa, (0, 1), tmp158, (2, 3, 4, 0), (2, 4, 3, 1))
    tmp172 = einsum(t1.aa, (0, 1), tmp158, (2, 3, 0, 4), (2, 3, 4, 1))
    tmp171 = einsum(t1.aa, (0, 1), tmp22, (2, 0), (2, 1))
    tmp170 = einsum(t1.aa, (0, 1), tmp20, (2, 0), (2, 1))
    tmp168 = einsum(tmp18, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp166 = einsum(t2.aaaa, (0, 1, 2, 3), tmp16, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp164 = einsum(t2.aaaa, (0, 1, 2, 3), tmp16, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp163 = einsum(t2.abab, (0, 1, 2, 3), tmp18, (4, 0, 1, 3), (4, 2))
    tmp162 = einsum(t2.aaaa, (0, 1, 2, 3), tmp16, (4, 0, 1, 3), (4, 2)) * -1
    tmp156 = einsum(t1.aa, (0, 1), v.aaaa.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp155 = einsum(t1.aa, (0, 1), v.aaaa.oovv, (2, 0, 3, 1), (2, 3))
    tmp152 = einsum(t1.aa, (0, 1), tmp1, (0, 2), (2, 1))
    tmp149 = einsum(tmp13, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp147 = einsum(tmp9, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp145 = einsum(tmp7, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp139 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp132 = einsum(t1.aa, (0, 1), tmp6, (2, 0), (2, 1))
    tmp131 = einsum(t1.aa, (0, 1), tmp5, (2, 0), (2, 1))
    tmp130 = einsum(t1.aa, (0, 1), tmp4, (2, 0), (2, 1))
    tmp129 = einsum(tmp15, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp128 = einsum(tmp13, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp127 = einsum(tmp12, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp126 = einsum(tmp11, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp125 = einsum(t2.aaaa, (0, 1, 2, 3), tmp9, (1, 3), (0, 2))
    tmp124 = einsum(tmp7, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp122 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovov, (1, 3, 4, 5), (0, 4, 2, 5))
    tmp120 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp118 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp116 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp114 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp112 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp110 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (4, 1))
    tmp108 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (0, 3, 1, 4), (2, 4)) * -1
    tmp106 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp104 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp102 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp101 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 0, 1, 3), (4, 2))
    tmp100 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 1, 0, 3), (4, 2)) * -1
    tmp89 = einsum(t1.aa, (0, 1), v.aaaa.oooo, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp87 = einsum(f.bb.ov, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp86 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp83 = einsum(t1.aa, (0, 1), f.aa.oo, (2, 0), (2, 1))
    tmp80 = einsum(t1.aa, (0, 1), tmp78, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    tmp76 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp74 = einsum(tmp72, (0, 1, 2, 3), t1.aa, (2, 4), (1, 0, 3, 4))
    tmp70 = einsum(t1.aa, (0, 1), tmp61, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp69 = einsum(t1.aa, (0, 1), tmp57, (2, 1), (0, 2))
    tmp68 = einsum(tmp55, (0, 1), t1.aa, (2, 0), (2, 1))
    tmp67 = einsum(t1.aa, (0, 1), tmp53, (2, 1), (0, 2))
    tmp66 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 1, 3), (0, 4))
    tmp65 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 1, 3), (4, 2))
    tmp63 = einsum(t1.aa, (0, 1), v.aabb.vvov, (2, 1, 3, 4), (0, 3, 2, 4))
    tmp59 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (4, 1), (4, 0, 2, 3))
    tmp49 = einsum(t1.aa, (0, 1), f.aa.vv, (2, 1), (0, 2))

    return {f"tmp1": tmp1, f"tmp100": tmp100, f"tmp101": tmp101, f"tmp102": tmp102, f"tmp104": tmp104, f"tmp106": tmp106, f"tmp108": tmp108, f"tmp11": tmp11, f"tmp110": tmp110, f"tmp112": tmp112, f"tmp114": tmp114, f"tmp116": tmp116, f"tmp118": tmp118, f"tmp12": tmp12, f"tmp120": tmp120, f"tmp122": tmp122, f"tmp124": tmp124, f"tmp125": tmp125, f"tmp126": tmp126, f"tmp127": tmp127, f"tmp128": tmp128, f"tmp129": tmp129, f"tmp13": tmp13, f"tmp130": tmp130, f"tmp131": tmp131, f"tmp132": tmp132, f"tmp139": tmp139, f"tmp145": tmp145, f"tmp147": tmp147, f"tmp149": tmp149, f"tmp15": tmp15, f"tmp152": tmp152, f"tmp155": tmp155, f"tmp156": tmp156, f"tmp158": tmp158, f"tmp16": tmp16, f"tmp162": tmp162, f"tmp163": tmp163, f"tmp164": tmp164, f"tmp166": tmp166, f"tmp168": tmp168, f"tmp170": tmp170, f"tmp171": tmp171, f"tmp172": tmp172, f"tmp174": tmp174, f"tmp18": tmp18, f"tmp185": tmp185, f"tmp186": tmp186, f"tmp187": tmp187, f"tmp189": tmp189, f"tmp190": tmp190, f"tmp192": tmp192, f"tmp194": tmp194, f"tmp197": tmp197, f"tmp199": tmp199, f"tmp20": tmp20, f"tmp200": tmp200, f"tmp201": tmp201, f"tmp209": tmp209, f"tmp214": tmp214, f"tmp217": tmp217, f"tmp22": tmp22, f"tmp222": tmp222, f"tmp223": tmp223, f"tmp224": tmp224, f"tmp229": tmp229, f"tmp230": tmp230, f"tmp232": tmp232, f"tmp233": tmp233, f"tmp237": tmp237, f"tmp238": tmp238, f"tmp239": tmp239, f"tmp24": tmp24, f"tmp241": tmp241, f"tmp243": tmp243, f"tmp244": tmp244, f"tmp248": tmp248, f"tmp249": tmp249, f"tmp25": tmp25, f"tmp255": tmp255, f"tmp256": tmp256, f"tmp257": tmp257, f"tmp258": tmp258, f"tmp259": tmp259, f"tmp26": tmp26, f"tmp262": tmp262, f"tmp264": tmp264, f"tmp265": tmp265, f"tmp267": tmp267, f"tmp269": tmp269, f"tmp270": tmp270, f"tmp271": tmp271, f"tmp273": tmp273, f"tmp275": tmp275, f"tmp277": tmp277, f"tmp279": tmp279, f"tmp28": tmp28, f"tmp281": tmp281, f"tmp283": tmp283, f"tmp284": tmp284, f"tmp285": tmp285, f"tmp286": tmp286, f"tmp287": tmp287, f"tmp288": tmp288, f"tmp289": tmp289, f"tmp290": tmp290, f"tmp292": tmp292, f"tmp297": tmp297, f"tmp298": tmp298, f"tmp299": tmp299, f"tmp300": tmp300, f"tmp302": tmp302, f"tmp304": tmp304, f"tmp307": tmp307, f"tmp308": tmp308, f"tmp309": tmp309, f"tmp31": tmp31, f"tmp310": tmp310, f"tmp311": tmp311, f"tmp312": tmp312, f"tmp316": tmp316, f"tmp317": tmp317, f"tmp318": tmp318, f"tmp319": tmp319, f"tmp32": tmp32, f"tmp321": tmp321, f"tmp322": tmp322, f"tmp323": tmp323, f"tmp324": tmp324, f"tmp325": tmp325, f"tmp326": tmp326, f"tmp328": tmp328, f"tmp329": tmp329, f"tmp33": tmp33, f"tmp333": tmp333, f"tmp334": tmp334, f"tmp335": tmp335, f"tmp337": tmp337, f"tmp339": tmp339, f"tmp340": tmp340, f"tmp344": tmp344, f"tmp345": tmp345, f"tmp346": tmp346, f"tmp347": tmp347, f"tmp348": tmp348, f"tmp349": tmp349, f"tmp354": tmp354, f"tmp355": tmp355, f"tmp356": tmp356, f"tmp367": tmp367, f"tmp369": tmp369, f"tmp37": tmp37, f"tmp371": tmp371, f"tmp373": tmp373, f"tmp375": tmp375, f"tmp377": tmp377, f"tmp383": tmp383, f"tmp39": tmp39, f"tmp394": tmp394, f"tmp396": tmp396, f"tmp398": tmp398, f"tmp4": tmp4, f"tmp41": tmp41, f"tmp414": tmp414, f"tmp418": tmp418, f"tmp420": tmp420, f"tmp422": tmp422, f"tmp427": tmp427, f"tmp429": tmp429, f"tmp43": tmp43, f"tmp433": tmp433, f"tmp435": tmp435, f"tmp437": tmp437, f"tmp439": tmp439, f"tmp441": tmp441, f"tmp45": tmp45, f"tmp46": tmp46, f"tmp47": tmp47, f"tmp49": tmp49, f"tmp5": tmp5, f"tmp53": tmp53, f"tmp55": tmp55, f"tmp57": tmp57, f"tmp59": tmp59, f"tmp6": tmp6, f"tmp61": tmp61, f"tmp63": tmp63, f"tmp65": tmp65, f"tmp66": tmp66, f"tmp67": tmp67, f"tmp68": tmp68, f"tmp69": tmp69, f"tmp7": tmp7, f"tmp70": tmp70, f"tmp72": tmp72, f"tmp74": tmp74, f"tmp76": tmp76, f"tmp78": tmp78, f"tmp80": tmp80, f"tmp83": tmp83, f"tmp86": tmp86, f"tmp87": tmp87, f"tmp89": tmp89, f"tmp9": tmp9}

def hbar_matvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:44:26.398992.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp75 = np.copy(ints.tmp37)
    tmp75 += np.transpose(ints.tmp37, (0, 2, 1, 3)) * -1
    tmp77 = np.copy(v.bbbb.ooov)
    tmp77 += np.transpose(v.bbbb.ovoo, (0, 2, 3, 1)) * -1
    tmp16 = np.copy(ints.tmp16)
    tmp16 += np.transpose(ints.tmp16, (0, 2, 1, 3)) * -1
    tmp18 = np.copy(v.aaaa.ooov) * -1
    tmp18 += np.transpose(v.aaaa.ooov, (0, 2, 1, 3))
    tmp73 = einsum(r2.aba, (0, 1, 2), ints.tmp39, (0, 3, 4, 2), (3, 4, 1))
    tmp74 = einsum(v.aabb.ovoo, (0, 1, 2, 3), r2.aba, (0, 4, 1), (4, 2, 3))
    tmp76 = einsum(tmp75, (0, 1, 2, 3), r2.bbb, (4, 2, 3), (4, 0, 1)) * -1
    del tmp75
    tmp78 = einsum(r2.bbb, (0, 1, 2), tmp77, (1, 3, 4, 2), (0, 3, 4)) * -1
    del tmp77
    tmp17 = einsum(tmp16, (0, 1, 2, 3), r2.aaa, (4, 2, 3), (4, 0, 1)) * -1
    del tmp16
    tmp14 = einsum(v.aabb.ooov, (0, 1, 2, 3), r2.bab, (2, 4, 3), (4, 0, 1)) * -1
    tmp15 = einsum(ints.tmp18, (0, 1, 2, 3), r2.bab, (2, 4, 3), (0, 1, 4)) * -1
    tmp19 = einsum(r2.aaa, (0, 1, 2), tmp18, (3, 4, 1, 2), (0, 3, 4)) * -1
    del tmp18
    tmp2 = np.copy(f.bb.ov)
    tmp2 += ints.tmp12
    tmp2 += ints.tmp15
    tmp2 += ints.tmp11 * -1
    tmp81 = np.copy(ints.tmp367)
    tmp81 += ints.tmp37
    tmp81 += ints.tmp394 * 2
    tmp81 += ints.tmp433 * 2
    tmp81 += ints.tmp437
    tmp81 += np.transpose(ints.tmp441, (0, 2, 1, 3))
    tmp81 += np.transpose(v.bbbb.ooov, (0, 2, 1, 3))
    tmp79 = np.copy(tmp73) * 0.5
    del tmp73
    tmp79 += np.transpose(tmp74, (0, 2, 1)) * -0.5
    del tmp74
    tmp79 += np.transpose(tmp76, (1, 2, 0)) * -1
    del tmp76
    tmp79 += np.transpose(tmp78, (0, 2, 1))
    del tmp78
    tmp83 = np.copy(ints.tmp41) * 2
    tmp83 += ints.tmp43
    tmp83 += ints.tmp31 * -1
    tmp83 += ints.tmp45 * -1
    tmp71 = np.copy(ints.tmp279)
    tmp71 += ints.tmp283 * 0.5
    tmp71 += np.transpose(ints.tmp318, (0, 1, 3, 2)) * 0.5
    tmp93 = np.copy(ints.tmp371)
    tmp93 += np.transpose(ints.tmp383, (0, 2, 1, 3))
    tmp93 += ints.tmp398
    tmp93 += ints.tmp427
    tmp93 += ints.tmp439
    tmp93 += ints.tmp396 * 2
    tmp93 += ints.tmp435 * 2
    tmp87 = np.copy(ints.tmp275)
    tmp87 += ints.tmp319
    tmp87 += ints.tmp281 * 2
    tmp91 = np.copy(f.bb.oo)
    tmp91 += ints.tmp28
    tmp91 += np.transpose(ints.tmp32, (1, 0))
    tmp91 += np.transpose(ints.tmp33, (1, 0))
    tmp91 += np.transpose(ints.tmp46, (1, 0))
    tmp91 += np.transpose(ints.tmp47, (1, 0))
    tmp89 = np.copy(ints.tmp317)
    tmp89 += ints.tmp277 * 2
    tmp3 = np.copy(f.aa.ov)
    tmp3 += ints.tmp13
    tmp3 += ints.tmp9
    tmp3 += ints.tmp7 * -1
    tmp32 = np.copy(f.aa.oo)
    tmp32 += ints.tmp1
    tmp32 += np.transpose(ints.tmp25, (1, 0))
    tmp32 += np.transpose(ints.tmp26, (1, 0))
    tmp32 += np.transpose(ints.tmp5, (1, 0))
    tmp32 += np.transpose(ints.tmp6, (1, 0))
    tmp30 = np.copy(ints.tmp59)
    tmp30 += ints.tmp112 * 2
    tmp34 = np.copy(ints.tmp106)
    tmp34 += ints.tmp156
    tmp34 += ints.tmp172
    tmp34 += ints.tmp74
    tmp34 += np.transpose(ints.tmp89, (0, 2, 1, 3))
    tmp34 += ints.tmp104 * 2
    tmp34 += ints.tmp166 * 2
    tmp10 = np.copy(ints.tmp114)
    tmp10 += ints.tmp120 * 0.5
    tmp10 += np.transpose(ints.tmp61, (0, 1, 3, 2)) * 0.5
    tmp12 = np.copy(ints.tmp118)
    tmp12 += ints.tmp122 * 2
    tmp12 += ints.tmp63
    tmp24 = np.copy(ints.tmp20) * 2
    tmp24 += ints.tmp22
    tmp24 += ints.tmp24 * -1
    tmp24 += ints.tmp4 * -1
    tmp20 = np.copy(np.transpose(tmp14, (0, 2, 1))) * 0.5
    del tmp14
    tmp20 += tmp15 * -0.5
    del tmp15
    tmp20 += np.transpose(tmp17, (1, 2, 0)) * -1
    del tmp17
    tmp20 += np.transpose(tmp19, (0, 2, 1))
    del tmp19
    tmp22 = np.copy(ints.tmp102)
    tmp22 += ints.tmp164
    tmp22 += ints.tmp168 * 0.5
    tmp22 += ints.tmp16 * 0.5
    tmp22 += np.transpose(ints.tmp174, (0, 2, 1, 3)) * 0.5
    tmp22 += ints.tmp70 * 0.5
    tmp22 += np.transpose(v.aaaa.ooov, (0, 2, 1, 3)) * 0.5
    tmp60 = einsum(t1.bb, (0, 1), tmp2, (0, 2), (2, 1))
    tmp68 = einsum(r2.aba, (0, 1, 2), v.aabb.ovov, (0, 2, 3, 4), (1, 3, 4))
    tmp70 = einsum(r2.bbb, (0, 1, 2), v.bbbb.oovv, (3, 1, 4, 2), (0, 3, 4))
    tmp82 = einsum(r1.b, (0,), tmp81, (1, 2, 0, 3), (1, 2, 3))
    del tmp81
    tmp80 = einsum(t1.bb, (0, 1), tmp79, (2, 0, 3), (2, 3, 1)) * 2
    del tmp79
    tmp84 = einsum(tmp83, (0, 1), r2.bbb, (2, 1, 3), (2, 0, 3)) * -2
    del tmp83
    tmp67 = einsum(ints.tmp273, (0, 1, 2, 3), r2.aba, (0, 4, 2), (1, 4, 3))
    tmp72 = einsum(tmp71, (0, 1, 2, 3), r2.bbb, (4, 1, 3), (4, 0, 2)) * -4
    del tmp71
    tmp69 = einsum(ints.tmp429, (0, 1, 2, 3), r2.bbb, (3, 2, 4), (0, 1, 4)) * -1
    tmp53 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.aba, (0, 2, 1), (3,))
    tmp54 = einsum(v.bbbb.ovov, (0, 1, 2, 3), r2.bbb, (0, 2, 1), (3,)) * -1
    tmp94 = einsum(tmp93, (0, 1, 2, 3), r1.b, (2,), (0, 1, 3))
    del tmp93
    tmp88 = einsum(r2.aba, (0, 1, 2), tmp87, (0, 3, 2, 4), (1, 3, 4))
    del tmp87
    tmp92 = einsum(tmp91, (0, 1), r2.bbb, (2, 0, 3), (2, 1, 3)) * -1
    del tmp91
    tmp86 = einsum(v.bbbb.ovov, (0, 1, 2, 3), r2.bbb, (4, 2, 3), (4, 0, 1))
    tmp90 = einsum(r2.bbb, (0, 1, 2), tmp89, (3, 1, 4, 2), (0, 3, 4)) * -1
    del tmp89
    tmp51 = np.copy(ints.tmp39)
    tmp51 += np.transpose(v.aabb.ovoo, (0, 2, 3, 1))
    tmp1 = np.copy(ints.tmp18)
    tmp1 += v.aabb.ooov
    tmp63 = np.copy(ints.tmp37)
    tmp63 += np.transpose(ints.tmp37, (0, 2, 1, 3)) * -1
    tmp63 += v.bbbb.ooov * -1
    tmp63 += np.transpose(v.bbbb.ooov, (0, 2, 1, 3))
    tmp41 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.bab, (2, 0, 3), (1,)) * -1
    tmp40 = einsum(r2.aaa, (0, 1, 2), v.aaaa.ovov, (0, 2, 1, 3), (3,)) * -1
    tmp38 = einsum(tmp3, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp50 = np.copy(ints.tmp16)
    tmp50 += np.transpose(ints.tmp16, (0, 2, 1, 3)) * -1
    tmp50 += v.aaaa.ooov * -1
    tmp50 += np.transpose(v.aaaa.ooov, (0, 2, 1, 3))
    tmp33 = einsum(tmp32, (0, 1), r2.aaa, (2, 0, 3), (2, 1, 3)) * -1
    del tmp32
    tmp29 = einsum(r2.bab, (0, 1, 2), v.aabb.ovov, (3, 4, 0, 2), (1, 3, 4)) * -1
    tmp28 = einsum(ints.tmp116, (0, 1, 2, 3), r2.bab, (1, 4, 3), (0, 4, 2)) * -1
    tmp31 = einsum(r2.aaa, (0, 1, 2), tmp30, (3, 1, 4, 2), (0, 3, 4)) * -1
    del tmp30
    tmp35 = einsum(tmp34, (0, 1, 2, 3), r1.a, (2,), (0, 1, 3))
    del tmp34
    tmp27 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r2.aaa, (4, 2, 3), (4, 0, 1))
    tmp11 = einsum(r2.aaa, (0, 1, 2), tmp10, (3, 1, 4, 2), (0, 3, 4)) * -4
    del tmp10
    tmp13 = einsum(tmp12, (0, 1, 2, 3), r2.bab, (1, 4, 3), (4, 0, 2)) * -1
    del tmp12
    tmp25 = einsum(tmp24, (0, 1), r2.aaa, (2, 1, 3), (2, 0, 3)) * -2
    del tmp24
    tmp21 = einsum(tmp20, (0, 1, 2), t1.aa, (1, 3), (0, 2, 3)) * 2
    del tmp20
    tmp8 = einsum(ints.tmp158, (0, 1, 2, 3), r2.aaa, (2, 3, 4), (0, 1, 4))
    tmp23 = einsum(r1.a, (0,), tmp22, (1, 2, 0, 3), (1, 2, 3)) * 2
    del tmp22
    tmp9 = einsum(r2.aaa, (0, 1, 2), v.aaaa.oovv, (3, 1, 4, 2), (0, 3, 4))
    tmp97 = np.copy(ints.tmp377)
    tmp97 += np.transpose(ints.tmp414, (1, 2, 0, 3))
    tmp97 += ints.tmp420
    tmp97 += ints.tmp422
    tmp97 += ints.tmp373 * -1
    tmp97 += ints.tmp418 * -1
    tmp61 = np.copy(ints.tmp256)
    tmp61 += np.transpose(ints.tmp300, (1, 0)) * 2
    tmp61 += np.transpose(ints.tmp302, (1, 0))
    tmp61 += f.bb.vv * -1
    tmp61 += np.transpose(ints.tmp255, (1, 0)) * -1
    tmp61 += np.transpose(ints.tmp257, (1, 0)) * -1
    tmp61 += tmp60
    del tmp60
    tmp85 = np.copy(tmp67)
    del tmp67
    tmp85 += tmp68
    del tmp68
    tmp85 += tmp69 * 2
    del tmp69
    tmp85 += tmp70 * 2
    del tmp70
    tmp85 += np.transpose(tmp72, (1, 0, 2)) * -1
    del tmp72
    tmp85 += tmp80
    del tmp80
    tmp85 += tmp82
    del tmp82
    tmp85 += np.transpose(tmp84, (1, 0, 2))
    del tmp84
    tmp55 = np.copy(tmp53) * -0.5
    del tmp53
    tmp55 += tmp54
    del tmp54
    tmp96 = np.copy(ints.tmp369)
    tmp96 += ints.tmp375
    tmp96 += np.transpose(v.bbbb.oooo, (0, 2, 3, 1)) * -1
    tmp66 = np.copy(ints.tmp284)
    tmp66 += ints.tmp286 * 2
    tmp66 += ints.tmp290
    tmp66 += ints.tmp297 * 2
    tmp66 += ints.tmp298
    tmp66 += ints.tmp311
    tmp66 += ints.tmp312
    tmp66 += ints.tmp321 * 2
    tmp66 += ints.tmp324
    tmp66 += ints.tmp329
    tmp66 += ints.tmp339
    tmp66 += ints.tmp344 * 2
    tmp66 += ints.tmp345
    tmp66 += ints.tmp347 * 2
    tmp66 += ints.tmp348
    tmp66 += ints.tmp355
    tmp66 += ints.tmp356
    tmp66 += f.bb.ov * -1
    tmp66 += ints.tmp12 * -1
    tmp66 += ints.tmp15 * -1
    tmp66 += ints.tmp264 * -1
    tmp66 += ints.tmp265 * -2
    tmp66 += ints.tmp285 * -1
    tmp66 += ints.tmp287 * -2
    tmp66 += ints.tmp288 * -1
    tmp66 += ints.tmp289 * -2
    tmp66 += ints.tmp310 * -1
    tmp66 += ints.tmp316 * -1
    tmp66 += ints.tmp322 * -1
    tmp66 += ints.tmp323 * -1
    tmp66 += ints.tmp325 * -1
    tmp66 += ints.tmp354 * -1
    tmp95 = np.copy(tmp86) * 2
    del tmp86
    tmp95 += np.transpose(tmp88, (1, 0, 2))
    del tmp88
    tmp95 += np.transpose(tmp90, (1, 0, 2)) * -2
    del tmp90
    tmp95 += np.transpose(tmp92, (1, 0, 2)) * -2
    del tmp92
    tmp95 += tmp94
    del tmp94
    tmp58 = np.copy(ints.tmp258)
    tmp58 += v.aabb.oovv
    tmp58 += ints.tmp304 * -1
    tmp4 = np.copy(f.aa.oo)
    tmp4 += ints.tmp1
    tmp4 += np.transpose(ints.tmp20, (1, 0)) * 2
    tmp4 += np.transpose(ints.tmp22, (1, 0))
    tmp4 += np.transpose(ints.tmp25, (1, 0))
    tmp4 += np.transpose(ints.tmp26, (1, 0))
    tmp4 += np.transpose(ints.tmp5, (1, 0))
    tmp4 += np.transpose(ints.tmp6, (1, 0))
    tmp4 += np.transpose(ints.tmp24, (1, 0)) * -1
    tmp4 += np.transpose(ints.tmp4, (1, 0)) * -1
    tmp62 = np.copy(ints.tmp18)
    tmp62 += ints.tmp259
    tmp62 += ints.tmp270
    tmp62 += ints.tmp271 * 2
    tmp62 += np.transpose(ints.tmp292, (1, 0, 2, 3))
    tmp62 += ints.tmp308
    tmp62 += ints.tmp309
    tmp62 += ints.tmp326
    tmp62 += ints.tmp333
    tmp62 += ints.tmp335 * 2
    tmp62 += ints.tmp340
    tmp62 += v.aabb.ooov
    tmp62 += ints.tmp262 * -1
    tmp62 += ints.tmp267 * -1
    tmp62 += ints.tmp269 * -1
    tmp62 += ints.tmp299 * -1
    tmp62 += ints.tmp307 * -1
    tmp62 += ints.tmp328 * -1
    tmp62 += ints.tmp334 * -1
    tmp62 += ints.tmp337 * -1
    tmp62 += ints.tmp346 * -1
    tmp62 += np.transpose(ints.tmp349, (1, 0, 2, 3)) * -1
    tmp64 = einsum(r2.bab, (0, 1, 2), tmp63, (3, 4, 0, 2), (1, 3, 4))
    del tmp63
    tmp64 += einsum(tmp51, (0, 1, 2, 3), r2.aaa, (4, 0, 3), (4, 1, 2)) * 2
    tmp64 += einsum(r2.bab, (0, 1, 2), tmp1, (3, 1, 4, 2), (3, 0, 4))
    tmp59 = np.copy(ints.tmp192)
    tmp59 += ints.tmp230
    tmp59 += ints.tmp233
    tmp59 += ints.tmp244
    tmp59 += v.aabb.oooo
    tmp57 = np.copy(ints.tmp275)
    tmp57 += ints.tmp281 * 2
    tmp57 += ints.tmp319
    tmp57 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp57 += ints.tmp273 * -1
    tmp56 = np.copy(ints.tmp279) * 2
    tmp56 += ints.tmp283
    tmp56 += np.transpose(ints.tmp318, (0, 1, 3, 2))
    tmp56 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    tmp56 += ints.tmp277 * -2
    tmp56 += ints.tmp317 * -1
    tmp56 += v.bbbb.oovv * -1
    tmp65 = np.copy(tmp40)
    tmp65 += tmp41 * 0.5
    tmp7 = np.copy(f.bb.oo)
    tmp7 += ints.tmp28
    tmp7 += np.transpose(ints.tmp32, (1, 0))
    tmp7 += np.transpose(ints.tmp33, (1, 0))
    tmp7 += np.transpose(ints.tmp41, (1, 0)) * 2
    tmp7 += np.transpose(ints.tmp43, (1, 0))
    tmp7 += np.transpose(ints.tmp46, (1, 0))
    tmp7 += np.transpose(ints.tmp47, (1, 0))
    tmp7 += np.transpose(ints.tmp31, (1, 0)) * -1
    tmp7 += np.transpose(ints.tmp45, (1, 0)) * -1
    tmp46 = np.copy(ints.tmp118)
    tmp46 += ints.tmp122 * 2
    tmp46 += ints.tmp63
    tmp46 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp46 += ints.tmp116 * -1
    tmp39 = np.copy(np.transpose(ints.tmp108, (1, 0))) * 2
    tmp39 += np.transpose(ints.tmp110, (1, 0))
    tmp39 += ints.tmp55
    tmp39 += f.aa.vv * -1
    tmp39 += np.transpose(ints.tmp53, (1, 0)) * -1
    tmp39 += np.transpose(ints.tmp57, (1, 0)) * -1
    tmp39 += tmp38
    del tmp38
    tmp45 = np.copy(ints.tmp114) * 2
    tmp45 += ints.tmp120
    tmp45 += np.transpose(ints.tmp61, (0, 1, 3, 2))
    tmp45 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp45 += ints.tmp112 * -2
    tmp45 += ints.tmp59 * -1
    tmp45 += v.aaaa.oovv * -1
    tmp44 = np.copy(ints.tmp100) * 2
    tmp44 += ints.tmp101
    tmp44 += ints.tmp124 * 2
    tmp44 += ints.tmp126
    tmp44 += ints.tmp131
    tmp44 += ints.tmp132
    tmp44 += ints.tmp152
    tmp44 += ints.tmp155
    tmp44 += ints.tmp162 * 2
    tmp44 += ints.tmp163
    tmp44 += ints.tmp170 * 2
    tmp44 += ints.tmp171
    tmp44 += ints.tmp186
    tmp44 += ints.tmp187
    tmp44 += ints.tmp65 * 2
    tmp44 += ints.tmp68
    tmp44 += ints.tmp83
    tmp44 += f.aa.ov * -1
    tmp44 += ints.tmp125 * -2
    tmp44 += ints.tmp127 * -1
    tmp44 += ints.tmp128 * -2
    tmp44 += ints.tmp129 * -1
    tmp44 += ints.tmp130 * -1
    tmp44 += ints.tmp13 * -1
    tmp44 += ints.tmp185 * -1
    tmp44 += ints.tmp49 * -1
    tmp44 += ints.tmp66 * -1
    tmp44 += ints.tmp67 * -1
    tmp44 += ints.tmp69 * -1
    tmp44 += ints.tmp86 * -2
    tmp44 += ints.tmp87 * -1
    tmp44 += ints.tmp9 * -1
    tmp52 = einsum(tmp50, (0, 1, 2, 3), r2.aba, (1, 4, 3), (0, 2, 4)) * -1
    del tmp50
    tmp52 += einsum(tmp51, (0, 1, 2, 3), r2.aba, (4, 2, 3), (4, 0, 1))
    del tmp51
    tmp52 += einsum(r2.bbb, (0, 1, 2), tmp1, (3, 4, 1, 2), (3, 4, 0)) * 2
    tmp49 = np.copy(ints.tmp190)
    tmp49 += ints.tmp200
    tmp49 += ints.tmp201 * 2
    tmp49 += np.transpose(ints.tmp209, (0, 2, 1, 3))
    tmp49 += ints.tmp223
    tmp49 += ints.tmp224
    tmp49 += ints.tmp229
    tmp49 += ints.tmp237
    tmp49 += ints.tmp239 * 2
    tmp49 += ints.tmp243
    tmp49 += ints.tmp39
    tmp49 += np.transpose(v.aabb.ovoo, (0, 2, 3, 1))
    tmp49 += ints.tmp194 * -1
    tmp49 += ints.tmp197 * -1
    tmp49 += ints.tmp199 * -1
    tmp49 += ints.tmp214 * -1
    tmp49 += ints.tmp222 * -1
    tmp49 += ints.tmp232 * -1
    tmp49 += ints.tmp238 * -1
    tmp49 += ints.tmp241 * -1
    tmp49 += ints.tmp248 * -1
    tmp49 += np.transpose(ints.tmp249, (0, 2, 1, 3)) * -1
    tmp47 = np.copy(ints.tmp189)
    tmp47 += np.transpose(v.aabb.vvoo, (2, 3, 0, 1))
    tmp47 += ints.tmp217 * -1
    tmp48 = np.copy(ints.tmp192)
    tmp48 += ints.tmp230
    tmp48 += ints.tmp233
    tmp48 += ints.tmp244
    tmp48 += v.aabb.oooo
    tmp37 = np.copy(ints.tmp72)
    tmp37 += ints.tmp78
    tmp37 += np.transpose(v.aaaa.oooo, (0, 2, 3, 1)) * -1
    tmp43 = np.copy(ints.tmp139)
    tmp43 += np.transpose(ints.tmp147, (2, 0, 1, 3))
    tmp43 += np.transpose(ints.tmp149, (2, 0, 1, 3))
    tmp43 += np.transpose(ints.tmp80, (2, 0, 1, 3))
    tmp43 += np.transpose(ints.tmp145, (2, 0, 1, 3)) * -1
    tmp43 += np.transpose(ints.tmp76, (2, 0, 1, 3)) * -1
    tmp36 = np.copy(tmp27) * 2
    del tmp27
    tmp36 += tmp28
    del tmp28
    tmp36 += tmp29
    del tmp29
    tmp36 += np.transpose(tmp31, (1, 0, 2)) * -2
    del tmp31
    tmp36 += np.transpose(tmp33, (1, 0, 2)) * -2
    del tmp33
    tmp36 += tmp35
    del tmp35
    tmp42 = np.copy(tmp40) * 2
    del tmp40
    tmp42 += tmp41
    del tmp41
    tmp26 = np.copy(tmp8) * 2
    del tmp8
    tmp26 += tmp9 * 2
    del tmp9
    tmp26 += np.transpose(tmp11, (1, 0, 2)) * -1
    del tmp11
    tmp26 += np.transpose(tmp13, (1, 0, 2))
    del tmp13
    tmp26 += tmp21
    del tmp21
    tmp26 += tmp23
    del tmp23
    tmp26 += np.transpose(tmp25, (1, 0, 2))
    del tmp25
    tmp6 = np.copy(ints.tmp37)
    tmp6 += v.bbbb.ooov * -1
    tmp5 = np.copy(ints.tmp39)
    tmp5 += np.transpose(v.aabb.ovoo, (0, 2, 3, 1))
    tmp0 = np.copy(ints.tmp16)
    tmp0 += v.aaaa.ooov * -1
    r2new.bbb = np.copy(tmp85) * -1
    r2new.bbb += np.transpose(tmp85, (1, 0, 2))
    del tmp85
    r2new.bbb += tmp95
    r2new.bbb += np.transpose(tmp95, (1, 0, 2)) * -1
    del tmp95
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp96, (3, 4, 0, 1), (3, 4, 2)) * 2
    del tmp96
    r2new.bbb += einsum(tmp61, (0, 1), r2.bbb, (2, 3, 0), (2, 3, 1)) * -2
    r2new.bbb += einsum(tmp55, (0,), t2.bbbb, (1, 2, 3, 0), (1, 2, 3)) * 4
    r2new.bbb += einsum(r1.b, (0,), tmp97, (1, 2, 0, 3), (2, 1, 3)) * -2
    del tmp97
    r2new.bbb += einsum(tmp66, (0, 1), r1.b, (2,), (2, 0, 1)) * -1
    r2new.bbb += einsum(r1.b, (0,), tmp66, (1, 2), (1, 0, 2))
    r2new.bab = einsum(tmp56, (0, 1, 2, 3), r2.bab, (1, 4, 3), (0, 4, 2))
    del tmp56
    r2new.bab += einsum(r2.aaa, (0, 1, 2), tmp57, (1, 3, 2, 4), (3, 0, 4)) * -2
    del tmp57
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp58, (3, 1, 4, 2), (0, 3, 4)) * -1
    del tmp58
    r2new.bab += einsum(tmp59, (0, 1, 2, 3), r2.bab, (3, 1, 4), (2, 0, 4))
    del tmp59
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp61, (2, 3), (0, 1, 3)) * -1
    del tmp61
    r2new.bab += einsum(r1.a, (0,), tmp62, (1, 0, 2, 3), (2, 1, 3))
    del tmp62
    r2new.bab += einsum(tmp7, (0, 1), r2.bab, (0, 2, 3), (1, 2, 3)) * -1
    r2new.bab += einsum(tmp4, (0, 1), r2.bab, (2, 0, 3), (2, 1, 3)) * -1
    r2new.bab += einsum(t1.bb, (0, 1), tmp64, (2, 3, 0), (3, 2, 1))
    del tmp64
    r2new.bab += einsum(tmp65, (0,), t2.abab, (1, 2, 0, 3), (2, 1, 3)) * 2
    del tmp65
    r2new.bab += einsum(tmp66, (0, 1), r1.a, (2,), (0, 2, 1))
    del tmp66
    r2new.aba = einsum(tmp45, (0, 1, 2, 3), r2.aba, (1, 4, 3), (0, 4, 2))
    del tmp45
    r2new.aba += einsum(tmp46, (0, 1, 2, 3), r2.bbb, (4, 1, 3), (0, 4, 2)) * -2
    del tmp46
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp47, (3, 1, 4, 2), (0, 3, 4)) * -1
    del tmp47
    r2new.aba += einsum(tmp48, (0, 1, 2, 3), r2.aba, (1, 3, 4), (0, 2, 4))
    del tmp48
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp39, (2, 3), (0, 1, 3)) * -1
    r2new.aba += einsum(r1.b, (0,), tmp49, (1, 2, 0, 3), (1, 2, 3))
    del tmp49
    r2new.aba += einsum(tmp7, (0, 1), r2.aba, (2, 0, 3), (2, 1, 3)) * -1
    r2new.aba += einsum(tmp4, (0, 1), r2.aba, (0, 2, 3), (1, 2, 3)) * -1
    r2new.aba += einsum(tmp52, (0, 1, 2), t1.aa, (1, 3), (0, 2, 3))
    del tmp52
    r2new.aba += einsum(tmp55, (0,), t2.abab, (1, 2, 3, 0), (1, 2, 3)) * 2
    del tmp55
    r2new.aba += einsum(tmp44, (0, 1), r1.b, (2,), (0, 2, 1))
    r2new.aaa = np.copy(tmp26) * -1
    r2new.aaa += np.transpose(tmp26, (1, 0, 2))
    del tmp26
    r2new.aaa += tmp36
    r2new.aaa += np.transpose(tmp36, (1, 0, 2)) * -1
    del tmp36
    r2new.aaa += einsum(tmp37, (0, 1, 2, 3), r2.aaa, (3, 2, 4), (0, 1, 4)) * -2
    del tmp37
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp39, (2, 3), (0, 1, 3)) * -2
    del tmp39
    r2new.aaa += einsum(tmp42, (0,), t2.aaaa, (1, 2, 3, 0), (1, 2, 3)) * 2
    del tmp42
    r2new.aaa += einsum(r1.a, (0,), tmp43, (0, 1, 2, 3), (2, 1, 3)) * -2
    del tmp43
    r2new.aaa += einsum(tmp44, (0, 1), r1.a, (2,), (2, 0, 1)) * -1
    r2new.aaa += einsum(r1.a, (0,), tmp44, (1, 2), (1, 0, 2))
    del tmp44
    r1new.b = einsum(tmp5, (0, 1, 2, 3), r2.aba, (0, 2, 3), (1,))
    del tmp5
    r1new.b += einsum(r2.bbb, (0, 1, 2), tmp6, (3, 1, 0, 2), (3,)) * -2
    del tmp6
    r1new.b += einsum(tmp3, (0, 1), r2.aba, (0, 2, 1), (2,)) * -1
    r1new.b += einsum(tmp2, (0, 1), r2.bbb, (2, 0, 1), (2,)) * 2
    r1new.b += einsum(r1.b, (0,), tmp7, (0, 1), (1,)) * -1
    del tmp7
    r1new.a = einsum(tmp0, (0, 1, 2, 3), r2.aaa, (2, 1, 3), (0,)) * -2
    del tmp0
    r1new.a += einsum(r2.bab, (0, 1, 2), tmp1, (3, 1, 0, 2), (3,))
    del tmp1
    r1new.a += einsum(r2.bab, (0, 1, 2), tmp2, (0, 2), (1,)) * -1
    del tmp2
    r1new.a += einsum(tmp3, (0, 1), r2.aaa, (2, 0, 1), (2,)) * 2
    del tmp3
    r1new.a += einsum(r1.a, (0,), tmp4, (0, 1), (1,)) * -1
    del tmp4

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_matvec_ea_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:48:26.993715.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp101 : array
    tmp104 : array
    tmp106 : array
    tmp108 : array
    tmp11 : array
    tmp116 : array
    tmp117 : array
    tmp118 : array
    tmp12 : array
    tmp127 : array
    tmp128 : array
    tmp129 : array
    tmp13 : array
    tmp136 : array
    tmp137 : array
    tmp139 : array
    tmp141 : array
    tmp146 : array
    tmp148 : array
    tmp15 : array
    tmp150 : array
    tmp152 : array
    tmp153 : array
    tmp154 : array
    tmp156 : array
    tmp158 : array
    tmp159 : array
    tmp160 : array
    tmp161 : array
    tmp162 : array
    tmp164 : array
    tmp165 : array
    tmp166 : array
    tmp167 : array
    tmp168 : array
    tmp173 : array
    tmp175 : array
    tmp177 : array
    tmp185 : array
    tmp186 : array
    tmp187 : array
    tmp196 : array
    tmp199 : array
    tmp20 : array
    tmp205 : array
    tmp216 : array
    tmp22 : array
    tmp220 : array
    tmp226 : array
    tmp240 : array
    tmp241 : array
    tmp242 : array
    tmp263 : array
    tmp266 : array
    tmp271 : array
    tmp272 : array
    tmp273 : array
    tmp274 : array
    tmp276 : array
    tmp286 : array
    tmp287 : array
    tmp289 : array
    tmp290 : array
    tmp291 : array
    tmp292 : array
    tmp294 : array
    tmp295 : array
    tmp296 : array
    tmp298 : array
    tmp300 : array
    tmp301 : array
    tmp303 : array
    tmp304 : array
    tmp305 : array
    tmp307 : array
    tmp308 : array
    tmp309 : array
    tmp31 : array
    tmp313 : array
    tmp314 : array
    tmp315 : array
    tmp316 : array
    tmp317 : array
    tmp318 : array
    tmp319 : array
    tmp32 : array
    tmp325 : array
    tmp326 : array
    tmp327 : array
    tmp328 : array
    tmp33 : array
    tmp334 : array
    tmp335 : array
    tmp336 : array
    tmp337 : array
    tmp338 : array
    tmp340 : array
    tmp341 : array
    tmp344 : array
    tmp345 : array
    tmp346 : array
    tmp350 : array
    tmp352 : array
    tmp354 : array
    tmp356 : array
    tmp358 : array
    tmp360 : array
    tmp361 : array
    tmp362 : array
    tmp363 : array
    tmp364 : array
    tmp365 : array
    tmp366 : array
    tmp383 : array
    tmp385 : array
    tmp387 : array
    tmp4 : array
    tmp41 : array
    tmp423 : array
    tmp43 : array
    tmp440 : array
    tmp450 : array
    tmp5 : array
    tmp50 : array
    tmp51 : array
    tmp59 : array
    tmp6 : array
    tmp61 : array
    tmp63 : array
    tmp67 : array
    tmp69 : array
    tmp7 : array
    tmp71 : array
    tmp73 : array
    tmp75 : array
    tmp77 : array
    tmp79 : array
    tmp80 : array
    tmp81 : array
    tmp82 : array
    tmp83 : array
    tmp84 : array
    tmp9 : array
    tmp98 : array
    """

    tmp15 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp12 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp11 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 1), (0, 3))
    tmp13 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp9 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 3, 0, 1), (2, 3))
    tmp7 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 1, 0, 3), (2, 3))
    tmp315 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 2, 1))
    tmp274 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp273 = einsum(t1.bb, (0, 1), v.bbbb.ooov, (2, 3, 0, 1), (2, 3))
    tmp272 = einsum(t1.bb, (0, 1), v.bbbb.ooov, (2, 0, 3, 1), (2, 3))
    tmp309 = einsum(tmp15, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp308 = einsum(tmp12, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp307 = einsum(t1.bb, (0, 1), tmp11, (2, 1), (0, 2))
    tmp298 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp296 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp300 = einsum(t1.bb, (0, 1), v.aabb.ovov, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp287 = einsum(t1.bb, (0, 1), f.bb.ov, (2, 1), (2, 0))
    tmp33 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp32 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (0, 3), (1, 2))
    tmp31 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (0, 1), (2, 3))
    tmp160 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp177 = einsum(t1.aa, (0, 1), tmp13, (2, 1), (0, 2))
    tmp175 = einsum(tmp9, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp173 = einsum(tmp7, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp6 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp5 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    tmp4 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp156 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 3), (4, 0))
    tmp154 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 3, 1), (4, 0)) * -1
    tmp158 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 2, 1))
    tmp137 = einsum(t1.aa, (0, 1), f.aa.ov, (2, 1), (2, 0))
    tmp108 = einsum(t1.bb, (0, 1), v.aabb.ooov, (2, 3, 0, 1), (2, 3))
    tmp106 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    tmp104 = einsum(t1.aa, (0, 1), v.aaaa.ooov, (2, 0, 3, 1), (2, 3))
    tmp450 = einsum(t2.bbbb, (0, 1, 2, 3), tmp315, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp440 = einsum(v.bbbb.vvvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp423 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp387 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (0, 4, 1, 5), (4, 5, 2, 3))
    tmp385 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (1, 4, 5, 3), (0, 2, 4, 5))
    tmp383 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (1, 3, 4, 5), (0, 2, 4, 5))
    tmp366 = einsum(tmp15, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp365 = einsum(tmp13, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp364 = einsum(tmp12, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp363 = einsum(tmp11, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp362 = einsum(tmp9, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp361 = einsum(tmp7, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp360 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 5), (4, 2, 5, 3))
    tmp358 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp356 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp354 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp352 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 4, 1, 5))
    tmp350 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 1, 5), (0, 4, 3, 5))
    tmp346 = einsum(v.aabb.vvov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp345 = einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ovvv, (0, 4, 5, 2), (1, 4, 5, 3))
    tmp344 = einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ovvv, (0, 2, 4, 5), (1, 4, 5, 3))
    tmp341 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp340 = einsum(f.aa.ov, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp338 = einsum(t1.bb, (0, 1), tmp274, (2, 0), (2, 1))
    tmp337 = einsum(t1.bb, (0, 1), tmp273, (2, 0), (2, 1))
    tmp336 = einsum(t1.bb, (0, 1), tmp272, (2, 0), (2, 1))
    tmp335 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 3, 1, 4), (2, 4))
    tmp334 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 0, 1, 3), (4, 2))
    tmp328 = einsum(t1.bb, (0, 1), f.bb.oo, (2, 0), (2, 1))
    tmp327 = einsum(t1.bb, (0, 1), tmp309, (2, 0), (2, 1))
    tmp326 = einsum(t1.bb, (0, 1), tmp308, (2, 0), (2, 1))
    tmp325 = einsum(t1.bb, (0, 1), tmp307, (2, 0), (2, 1))
    tmp319 = einsum(t1.bb, (0, 1), tmp298, (2, 0), (2, 1))
    tmp318 = einsum(t1.bb, (0, 1), tmp296, (2, 0), (2, 1))
    tmp317 = einsum(tmp300, (0, 1, 2, 3), t2.abab, (0, 2, 3, 4), (1, 4))
    tmp316 = einsum(t2.bbbb, (0, 1, 2, 3), tmp315, (4, 1, 0, 3), (4, 2))
    tmp314 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 2, 0, 1))
    tmp313 = einsum(t1.bb, (0, 1), tmp287, (0, 2), (2, 1))
    tmp305 = einsum(tmp33, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp304 = einsum(t1.bb, (0, 1), tmp32, (1, 2), (0, 2))
    tmp303 = einsum(t1.bb, (0, 1), tmp31, (2, 1), (0, 2))
    tmp301 = einsum(tmp300, (0, 1, 2, 3), t2.abab, (0, 2, 4, 5), (1, 4, 3, 5))
    tmp295 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp294 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.bbbb, (4, 0, 3, 1), (4, 2)) * -1
    tmp292 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 1, 2))
    tmp291 = einsum(t1.bb, (0, 1), v.bbbb.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp290 = einsum(t1.bb, (0, 1), v.bbbb.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp289 = einsum(t1.bb, (0, 1), v.aabb.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp286 = einsum(t1.bb, (0, 1), f.bb.vv, (2, 1), (0, 2))
    tmp276 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 3, 4, 5), (2, 4, 1, 5))
    tmp271 = einsum(v.bbbb.oovv, (0, 1, 2, 3), t1.bb, (1, 3), (0, 2))
    tmp266 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (4, 2, 5, 1))
    tmp263 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (4, 5, 1, 2))
    tmp242 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 5, 2, 3))
    tmp241 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ovvv, (1, 4, 5, 3), (0, 2, 4, 5))
    tmp240 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ovvv, (1, 3, 4, 5), (0, 2, 4, 5))
    tmp226 = einsum(t1.aa, (0, 1), v.aabb.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp220 = einsum(t2.abab, (0, 1, 2, 3), tmp160, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp216 = einsum(t1.aa, (0, 1), v.aabb.vvvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp205 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp199 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 5), (4, 0, 5, 3))
    tmp196 = einsum(v.aabb.vvov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 5), (4, 0, 5, 3))
    tmp187 = einsum(t1.aa, (0, 1), tmp177, (2, 0), (2, 1))
    tmp186 = einsum(t1.aa, (0, 1), tmp175, (2, 0), (2, 1))
    tmp185 = einsum(tmp173, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp168 = einsum(tmp6, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp167 = einsum(t1.aa, (0, 1), tmp5, (1, 2), (0, 2))
    tmp166 = einsum(t1.aa, (0, 1), tmp4, (2, 1), (0, 2))
    tmp165 = einsum(t1.aa, (0, 1), tmp156, (2, 0), (2, 1))
    tmp164 = einsum(t1.aa, (0, 1), tmp154, (2, 0), (2, 1))
    tmp162 = einsum(t2.aaaa, (0, 1, 2, 3), tmp158, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp161 = einsum(t2.abab, (0, 1, 2, 3), tmp160, (4, 0, 1, 3), (4, 2))
    tmp159 = einsum(tmp158, (0, 1, 2, 3), t2.aaaa, (2, 1, 4, 3), (0, 4))
    tmp153 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 1, 3), (0, 4))
    tmp152 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 3, 1), (4, 2)) * -1
    tmp150 = einsum(t1.aa, (0, 1), v.aabb.vvov, (2, 1, 3, 4), (0, 3, 2, 4))
    tmp148 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp146 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (4, 1), (4, 0, 2, 3))
    tmp141 = einsum(t1.aa, (0, 1), v.aaaa.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp139 = einsum(t1.aa, (0, 1), tmp137, (0, 2), (2, 1))
    tmp136 = einsum(t1.aa, (0, 1), f.aa.vv, (2, 1), (0, 2))
    tmp129 = einsum(tmp108, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp128 = einsum(t1.aa, (0, 1), tmp106, (2, 0), (2, 1))
    tmp127 = einsum(t1.aa, (0, 1), tmp104, (2, 0), (2, 1))
    tmp118 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp117 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 0, 1, 3), (4, 2))
    tmp116 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 0, 1, 3), (4, 2))
    tmp101 = einsum(t1.aa, (0, 1), v.aaaa.oovv, (2, 0, 3, 1), (2, 3))
    tmp98 = einsum(t1.aa, (0, 1), f.aa.oo, (2, 0), (2, 1))
    tmp84 = einsum(tmp15, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp83 = einsum(tmp13, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp82 = einsum(tmp12, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp81 = einsum(tmp11, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp80 = einsum(t2.aaaa, (0, 1, 2, 3), tmp9, (1, 3), (0, 2))
    tmp79 = einsum(tmp7, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp77 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovov, (1, 3, 4, 5), (0, 4, 2, 5))
    tmp75 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp73 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp71 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp69 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp67 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp63 = einsum(v.aabb.vvov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 5, 0, 1))
    tmp61 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 5, 1, 2))
    tmp59 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 5, 2, 3))
    tmp51 = einsum(f.bb.ov, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp50 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp43 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 1, 4), (4, 3))
    tmp41 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.bbbb, (0, 2, 4, 1), (4, 3)) * -1
    tmp22 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (4, 1))
    tmp20 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (0, 3, 1, 4), (2, 4)) * -1

    return {f"tmp101": tmp101, f"tmp104": tmp104, f"tmp106": tmp106, f"tmp108": tmp108, f"tmp11": tmp11, f"tmp116": tmp116, f"tmp117": tmp117, f"tmp118": tmp118, f"tmp12": tmp12, f"tmp127": tmp127, f"tmp128": tmp128, f"tmp129": tmp129, f"tmp13": tmp13, f"tmp136": tmp136, f"tmp137": tmp137, f"tmp139": tmp139, f"tmp141": tmp141, f"tmp146": tmp146, f"tmp148": tmp148, f"tmp15": tmp15, f"tmp150": tmp150, f"tmp152": tmp152, f"tmp153": tmp153, f"tmp154": tmp154, f"tmp156": tmp156, f"tmp158": tmp158, f"tmp159": tmp159, f"tmp160": tmp160, f"tmp161": tmp161, f"tmp162": tmp162, f"tmp164": tmp164, f"tmp165": tmp165, f"tmp166": tmp166, f"tmp167": tmp167, f"tmp168": tmp168, f"tmp173": tmp173, f"tmp175": tmp175, f"tmp177": tmp177, f"tmp185": tmp185, f"tmp186": tmp186, f"tmp187": tmp187, f"tmp196": tmp196, f"tmp199": tmp199, f"tmp20": tmp20, f"tmp205": tmp205, f"tmp216": tmp216, f"tmp22": tmp22, f"tmp220": tmp220, f"tmp226": tmp226, f"tmp240": tmp240, f"tmp241": tmp241, f"tmp242": tmp242, f"tmp263": tmp263, f"tmp266": tmp266, f"tmp271": tmp271, f"tmp272": tmp272, f"tmp273": tmp273, f"tmp274": tmp274, f"tmp276": tmp276, f"tmp286": tmp286, f"tmp287": tmp287, f"tmp289": tmp289, f"tmp290": tmp290, f"tmp291": tmp291, f"tmp292": tmp292, f"tmp294": tmp294, f"tmp295": tmp295, f"tmp296": tmp296, f"tmp298": tmp298, f"tmp300": tmp300, f"tmp301": tmp301, f"tmp303": tmp303, f"tmp304": tmp304, f"tmp305": tmp305, f"tmp307": tmp307, f"tmp308": tmp308, f"tmp309": tmp309, f"tmp31": tmp31, f"tmp313": tmp313, f"tmp314": tmp314, f"tmp315": tmp315, f"tmp316": tmp316, f"tmp317": tmp317, f"tmp318": tmp318, f"tmp319": tmp319, f"tmp32": tmp32, f"tmp325": tmp325, f"tmp326": tmp326, f"tmp327": tmp327, f"tmp328": tmp328, f"tmp33": tmp33, f"tmp334": tmp334, f"tmp335": tmp335, f"tmp336": tmp336, f"tmp337": tmp337, f"tmp338": tmp338, f"tmp340": tmp340, f"tmp341": tmp341, f"tmp344": tmp344, f"tmp345": tmp345, f"tmp346": tmp346, f"tmp350": tmp350, f"tmp352": tmp352, f"tmp354": tmp354, f"tmp356": tmp356, f"tmp358": tmp358, f"tmp360": tmp360, f"tmp361": tmp361, f"tmp362": tmp362, f"tmp363": tmp363, f"tmp364": tmp364, f"tmp365": tmp365, f"tmp366": tmp366, f"tmp383": tmp383, f"tmp385": tmp385, f"tmp387": tmp387, f"tmp4": tmp4, f"tmp41": tmp41, f"tmp423": tmp423, f"tmp43": tmp43, f"tmp440": tmp440, f"tmp450": tmp450, f"tmp5": tmp5, f"tmp50": tmp50, f"tmp51": tmp51, f"tmp59": tmp59, f"tmp6": tmp6, f"tmp61": tmp61, f"tmp63": tmp63, f"tmp67": tmp67, f"tmp69": tmp69, f"tmp7": tmp7, f"tmp71": tmp71, f"tmp73": tmp73, f"tmp75": tmp75, f"tmp77": tmp77, f"tmp79": tmp79, f"tmp80": tmp80, f"tmp81": tmp81, f"tmp82": tmp82, f"tmp83": tmp83, f"tmp84": tmp84, f"tmp9": tmp9, f"tmp98": tmp98}

def hbar_matvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:48:27.157882.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp130 = np.copy(ints.tmp291)
    tmp130 += np.transpose(ints.tmp360, (0, 1, 3, 2))
    tmp130 += np.transpose(ints.tmp356, (0, 1, 3, 2)) * 2
    tmp128 = np.copy(ints.tmp315)
    tmp128 += np.transpose(v.bbbb.ooov, (0, 2, 1, 3))
    tmp126 = einsum(r1.b, (0,), ints.tmp315, (1, 2, 3, 0), (1, 2, 3))
    tmp104 = np.copy(f.bb.ov)
    tmp104 += ints.tmp12
    tmp104 += ints.tmp15
    tmp106 = np.copy(ints.tmp290)
    tmp106 += ints.tmp354 * 2
    tmp88 = np.copy(ints.tmp300)
    tmp88 += np.transpose(v.aabb.ovoo, (0, 2, 3, 1))
    tmp99 = einsum(r1.b, (0,), v.bbbb.ooov, (1, 2, 3, 0), (1, 2, 3))
    tmp102 = np.copy(ints.tmp315)
    tmp102 += np.transpose(v.bbbb.ooov, (0, 2, 1, 3))
    tmp25 = np.copy(ints.tmp148)
    tmp25 += np.transpose(ints.tmp75, (0, 1, 3, 2))
    tmp25 += np.transpose(ints.tmp69, (0, 1, 3, 2)) * 2
    tmp23 = np.copy(ints.tmp158)
    tmp23 += np.transpose(v.aaaa.ooov, (0, 2, 1, 3))
    tmp21 = einsum(r1.a, (0,), ints.tmp158, (1, 2, 3, 0), (1, 2, 3))
    tmp45 = np.copy(f.aa.ov)
    tmp45 += ints.tmp13
    tmp45 += ints.tmp9
    tmp41 = np.copy(ints.tmp158)
    tmp41 += np.transpose(v.aaaa.ooov, (0, 2, 1, 3))
    tmp43 = np.copy(ints.tmp160)
    tmp43 += v.aabb.ooov
    tmp39 = einsum(v.aaaa.ooov, (0, 1, 2, 3), r1.a, (3,), (0, 1, 2))
    tmp47 = np.copy(ints.tmp146)
    tmp47 += ints.tmp67 * 2
    tmp125 = einsum(r2.bbb, (0, 1, 2), ints.tmp11, (3, 1), (3, 2, 0))
    tmp131 = einsum(r1.b, (0,), tmp130, (1, 2, 0, 3), (1, 2, 3))
    del tmp130
    tmp129 = einsum(r2.bbb, (0, 1, 2), tmp128, (3, 4, 2, 1), (3, 4, 0)) * -1
    del tmp128
    tmp127 = einsum(t1.bb, (0, 1), tmp126, (2, 0, 3), (2, 3, 1))
    del tmp126
    tmp112 = einsum(r1.b, (0,), v.bbbb.ovov, (1, 2, 3, 0), (1, 3, 2))
    tmp113 = einsum(r2.bbb, (0, 1, 2), v.bbbb.ovvv, (3, 0, 4, 1), (2, 3, 4))
    tmp105 = einsum(tmp104, (0, 1), r2.bbb, (2, 1, 3), (0, 3, 2)) * -2
    del tmp104
    tmp107 = einsum(r1.b, (0,), tmp106, (1, 2, 3, 0), (1, 2, 3))
    del tmp106
    tmp101 = einsum(tmp88, (0, 1, 2, 3), r2.aba, (3, 4, 0), (1, 2, 4))
    tmp100 = einsum(t1.bb, (0, 1), tmp99, (2, 0, 3), (2, 3, 1))
    del tmp99
    tmp103 = einsum(r2.bbb, (0, 1, 2), tmp102, (3, 2, 4, 1), (3, 4, 0)) * -2
    del tmp102
    tmp26 = einsum(r1.a, (0,), tmp25, (1, 2, 0, 3), (1, 2, 3))
    del tmp25
    tmp24 = einsum(tmp23, (0, 1, 2, 3), r2.aaa, (4, 3, 2), (0, 1, 4)) * -1
    del tmp23
    tmp20 = einsum(r2.aaa, (0, 1, 2), ints.tmp7, (3, 1), (3, 2, 0))
    tmp22 = einsum(tmp21, (0, 1, 2), t1.aa, (1, 3), (0, 2, 3))
    del tmp21
    tmp46 = einsum(r2.aaa, (0, 1, 2), tmp45, (3, 1), (2, 3, 0)) * -1
    del tmp45
    tmp42 = einsum(r2.aaa, (0, 1, 2), tmp41, (3, 2, 4, 1), (3, 4, 0)) * -1
    del tmp41
    tmp44 = einsum(tmp43, (0, 1, 2, 3), r2.bab, (3, 4, 2), (0, 1, 4)) * -0.5
    tmp40 = einsum(tmp39, (0, 1, 2), t1.aa, (1, 3), (0, 2, 3))
    del tmp39
    tmp48 = einsum(r1.a, (0,), tmp47, (1, 2, 3, 0), (1, 2, 3)) * 0.5
    del tmp47
    tmp53 = einsum(r1.a, (0,), v.aaaa.ovov, (1, 2, 3, 0), (1, 3, 2))
    tmp54 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), r2.aaa, (3, 1, 4), (4, 0, 2)) * -1
    tmp0 = np.copy(f.bb.ov)
    tmp0 += ints.tmp12
    tmp0 += ints.tmp15
    tmp0 += ints.tmp11 * -1
    tmp119 = einsum(v.bbbb.oovv, (0, 1, 2, 3), r1.b, (3,), (0, 1, 2))
    tmp134 = np.copy(ints.tmp440)
    tmp134 += ints.tmp385 * 2
    tmp123 = np.copy(ints.tmp290)
    tmp123 += ints.tmp354 * 2
    tmp121 = np.copy(ints.tmp292)
    tmp121 += ints.tmp352
    tmp121 += ints.tmp358 * 2
    tmp132 = np.copy(tmp125) * 2
    del tmp125
    tmp132 += np.transpose(tmp127, (1, 0, 2))
    del tmp127
    tmp132 += np.transpose(tmp129, (1, 0, 2)) * -2
    del tmp129
    tmp132 += np.transpose(tmp131, (1, 0, 2))
    del tmp131
    tmp97 = np.copy(f.bb.vv) * 0.5
    tmp97 += np.transpose(ints.tmp31, (1, 0)) * 0.5
    tmp97 += np.transpose(ints.tmp33, (1, 0)) * 0.5
    tmp97 += np.transpose(ints.tmp41, (1, 0)) * -1
    tmp97 += np.transpose(ints.tmp43, (1, 0)) * -0.5
    tmp114 = np.copy(tmp112)
    del tmp112
    tmp114 += tmp113 * 2
    del tmp113
    tmp110 = np.copy(ints.tmp383)
    tmp110 += ints.tmp387 * 0.5
    tmp110 += v.bbbb.ovvv * 0.5
    tmp95 = np.copy(ints.tmp291)
    tmp95 += np.transpose(ints.tmp356, (0, 1, 3, 2)) * 2
    tmp95 += np.transpose(ints.tmp360, (0, 1, 3, 2))
    tmp108 = np.copy(np.transpose(tmp100, (1, 0, 2)))
    del tmp100
    tmp108 += np.transpose(tmp101, (1, 0, 2)) * -1
    del tmp101
    tmp108 += np.transpose(tmp103, (1, 0, 2)) * -1
    del tmp103
    tmp108 += tmp105 * -1
    del tmp105
    tmp108 += np.transpose(tmp107, (1, 0, 2))
    del tmp107
    tmp1 = np.copy(f.aa.ov)
    tmp1 += ints.tmp13
    tmp1 += ints.tmp9
    tmp1 += ints.tmp7 * -1
    tmp14 = einsum(r1.a, (0,), v.aaaa.oovv, (1, 2, 3, 0), (1, 2, 3))
    tmp27 = np.copy(np.transpose(tmp20, (1, 0, 2))) * 2
    del tmp20
    tmp27 += tmp22
    del tmp22
    tmp27 += tmp24 * -2
    del tmp24
    tmp27 += tmp26
    del tmp26
    tmp29 = np.copy(ints.tmp141)
    tmp29 += ints.tmp61 * 2
    tmp18 = np.copy(ints.tmp146)
    tmp18 += ints.tmp67 * 2
    tmp37 = np.copy(f.aa.vv) * 0.5
    tmp37 += np.transpose(ints.tmp4, (1, 0)) * 0.5
    tmp37 += np.transpose(ints.tmp6, (1, 0)) * 0.5
    tmp37 += np.transpose(ints.tmp20, (1, 0)) * -1
    tmp37 += np.transpose(ints.tmp22, (1, 0)) * -0.5
    tmp35 = np.copy(ints.tmp150)
    tmp35 += ints.tmp73
    tmp35 += ints.tmp77 * 2
    tmp49 = np.copy(np.transpose(tmp40, (1, 0, 2))) * 0.5
    del tmp40
    tmp49 += np.transpose(tmp42, (1, 0, 2)) * -1
    del tmp42
    tmp49 += np.transpose(tmp44, (1, 0, 2))
    del tmp44
    tmp49 += np.transpose(tmp46, (1, 0, 2)) * -1
    del tmp46
    tmp49 += np.transpose(tmp48, (1, 0, 2))
    del tmp48
    tmp33 = np.copy(ints.tmp148)
    tmp33 += np.transpose(ints.tmp69, (0, 1, 3, 2)) * 2
    tmp33 += np.transpose(ints.tmp75, (0, 1, 3, 2))
    tmp51 = np.copy(ints.tmp59)
    tmp51 += ints.tmp63 * 0.5
    tmp51 += v.aaaa.ovvv * 0.5
    tmp55 = np.copy(tmp53)
    del tmp53
    tmp55 += tmp54 * 2
    del tmp54
    tmp10 = einsum(r1.b, (0,), tmp0, (1, 0), (1,))
    tmp8 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.aba, (1, 3, 0), (2,))
    tmp9 = einsum(v.bbbb.ovov, (0, 1, 2, 3), r2.bbb, (1, 3, 2), (0,))
    tmp120 = einsum(t1.bb, (0, 1), tmp119, (2, 0, 3), (2, 1, 3))
    del tmp119
    tmp135 = einsum(r1.b, (0,), tmp134, (1, 2, 0, 3), (1, 2, 3))
    del tmp134
    tmp117 = einsum(r2.bbb, (0, 1, 2), ints.tmp32, (1, 3), (2, 3, 0))
    tmp124 = einsum(tmp123, (0, 1, 2, 3), r2.bbb, (4, 3, 1), (0, 2, 4)) * -1
    del tmp123
    tmp122 = einsum(tmp121, (0, 1, 2, 3), r2.aba, (2, 4, 0), (1, 3, 4))
    del tmp121
    tmp133 = einsum(tmp132, (0, 1, 2), t1.bb, (0, 3), (1, 2, 3))
    del tmp132
    tmp118 = einsum(r2.bbb, (0, 1, 2), v.bbbb.ovov, (3, 4, 2, 1), (3, 0, 4))
    tmp93 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.aba, (1, 4, 0), (2, 4, 3))
    tmp98 = einsum(r2.bbb, (0, 1, 2), tmp97, (1, 3), (2, 3, 0)) * -4
    del tmp97
    tmp94 = einsum(v.bbbb.oovv, (0, 1, 2, 3), r2.bbb, (4, 3, 1), (0, 4, 2))
    tmp115 = einsum(tmp114, (0, 1, 2), t1.bb, (1, 3), (0, 2, 3))
    del tmp114
    tmp111 = einsum(r1.b, (0,), tmp110, (1, 2, 3, 0), (1, 2, 3)) * 2
    del tmp110
    tmp92 = einsum(ints.tmp350, (0, 1, 2, 3), r2.aba, (2, 4, 0), (1, 3, 4))
    tmp96 = einsum(tmp95, (0, 1, 2, 3), r2.bbb, (4, 2, 1), (0, 3, 4)) * -2
    del tmp95
    tmp109 = einsum(tmp108, (0, 1, 2), t1.bb, (0, 3), (1, 2, 3))
    del tmp108
    tmp77 = einsum(r2.bab, (0, 1, 2), v.aabb.ovov, (3, 1, 4, 0), (3, 2, 4)) * -1
    tmp87 = np.copy(np.transpose(r2.aaa, (2, 0, 1)))
    tmp87 += einsum(t1.aa, (0, 1), r1.a, (2,), (0, 2, 1)) * 0.5
    tmp71 = einsum(tmp1, (0, 1), t1.aa, (0, 2), (2, 1))
    tmp78 = np.copy(ints.tmp315) * -1
    tmp78 += np.transpose(ints.tmp315, (0, 2, 1, 3))
    tmp78 += v.bbbb.ooov
    tmp78 += np.transpose(v.bbbb.ooov, (0, 2, 1, 3)) * -1
    tmp4 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.bab, (3, 1, 2), (0,)) * -1
    tmp3 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r2.aaa, (1, 3, 2), (0,))
    tmp5 = einsum(tmp1, (0, 1), r1.a, (1,), (0,))
    tmp63 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.aba, (1, 3, 4), (4, 0, 2))
    tmp74 = np.copy(np.transpose(r2.bbb, (2, 0, 1)))
    tmp74 += einsum(r1.b, (0,), t1.bb, (1, 2), (1, 0, 2)) * 0.5
    tmp64 = np.copy(ints.tmp158)
    tmp64 += np.transpose(ints.tmp158, (0, 2, 1, 3)) * -1
    tmp64 += v.aaaa.ooov * -1
    tmp64 += np.transpose(v.aaaa.ooov, (0, 2, 1, 3))
    tmp13 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r2.aaa, (4, 3, 2), (0, 4, 1))
    tmp15 = einsum(t1.aa, (0, 1), tmp14, (2, 0, 3), (2, 1, 3))
    del tmp14
    tmp28 = einsum(t1.aa, (0, 1), tmp27, (2, 0, 3), (2, 1, 3))
    del tmp27
    tmp30 = einsum(tmp29, (0, 1, 2, 3), r1.a, (2,), (0, 1, 3))
    del tmp29
    tmp19 = einsum(tmp18, (0, 1, 2, 3), r2.aaa, (4, 3, 1), (0, 4, 2)) * -1
    del tmp18
    tmp17 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.bab, (3, 4, 2), (0, 4, 1)) * -1
    tmp16 = einsum(ints.tmp71, (0, 1, 2, 3), r2.bab, (3, 4, 1), (0, 2, 4)) * -1
    tmp12 = einsum(ints.tmp5, (0, 1), r2.aaa, (2, 0, 3), (3, 1, 2))
    tmp32 = einsum(v.aaaa.oovv, (0, 1, 2, 3), r2.aaa, (4, 3, 1), (0, 4, 2))
    tmp38 = einsum(tmp37, (0, 1), r2.aaa, (2, 0, 3), (3, 2, 1)) * -4
    del tmp37
    tmp36 = einsum(r2.bab, (0, 1, 2), tmp35, (3, 2, 4, 0), (3, 1, 4)) * -1
    del tmp35
    tmp50 = einsum(t1.aa, (0, 1), tmp49, (0, 2, 3), (2, 1, 3)) * 2
    del tmp49
    tmp34 = einsum(tmp33, (0, 1, 2, 3), r2.aaa, (4, 2, 1), (0, 4, 3)) * -2
    del tmp33
    tmp52 = einsum(tmp51, (0, 1, 2, 3), r1.a, (3,), (0, 1, 2)) * 2
    del tmp51
    tmp56 = einsum(tmp55, (0, 1, 2), t1.aa, (1, 3), (0, 3, 2))
    del tmp55
    tmp137 = np.copy(ints.tmp423)
    tmp137 += ints.tmp450 * -1
    tmp11 = np.copy(tmp8) * -1
    del tmp8
    tmp11 += tmp9 * 2
    del tmp9
    tmp11 += tmp10
    del tmp10
    tmp136 = np.copy(tmp117) * 2
    del tmp117
    tmp136 += tmp118 * 2
    del tmp118
    tmp136 += tmp120
    del tmp120
    tmp136 += tmp122
    del tmp122
    tmp136 += tmp124 * -2
    del tmp124
    tmp136 += tmp133
    del tmp133
    tmp136 += tmp135
    del tmp135
    tmp91 = np.copy(ints.tmp271)
    tmp91 += ints.tmp294 * 2
    tmp91 += ints.tmp304
    tmp91 += ints.tmp313
    tmp91 += ints.tmp316 * 2
    tmp91 += ints.tmp317
    tmp91 += ints.tmp318 * 2
    tmp91 += ints.tmp319
    tmp91 += ints.tmp326
    tmp91 += ints.tmp327
    tmp91 += ints.tmp328
    tmp91 += ints.tmp334 * 2
    tmp91 += ints.tmp335
    tmp91 += ints.tmp337
    tmp91 += ints.tmp338
    tmp91 += ints.tmp361
    tmp91 += ints.tmp363 * 2
    tmp91 += f.bb.ov * -1
    tmp91 += ints.tmp12 * -1
    tmp91 += ints.tmp15 * -1
    tmp91 += ints.tmp286 * -1
    tmp91 += ints.tmp295 * -1
    tmp91 += ints.tmp303 * -1
    tmp91 += ints.tmp305 * -1
    tmp91 += ints.tmp325 * -1
    tmp91 += ints.tmp336 * -1
    tmp91 += ints.tmp340 * -1
    tmp91 += ints.tmp341 * -2
    tmp91 += ints.tmp362 * -1
    tmp91 += ints.tmp364 * -2
    tmp91 += ints.tmp365 * -1
    tmp91 += ints.tmp366 * -2
    tmp138 = einsum(r2.bbb, (0, 1, 2), v.bbbb.ovov, (3, 1, 4, 0), (2, 3, 4)) * -1
    tmp139 = np.copy(t2.bbbb)
    tmp139 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    tmp116 = np.copy(tmp92)
    del tmp92
    tmp116 += tmp93
    del tmp93
    tmp116 += tmp94 * 2
    del tmp94
    tmp116 += tmp96 * -1
    del tmp96
    tmp116 += tmp98 * -1
    del tmp98
    tmp116 += tmp109
    del tmp109
    tmp116 += tmp111
    del tmp111
    tmp116 += np.transpose(tmp115, (0, 2, 1))
    del tmp115
    tmp86 = np.copy(f.bb.oo)
    tmp86 += np.transpose(ints.tmp273, (1, 0))
    tmp86 += np.transpose(ints.tmp274, (1, 0))
    tmp86 += ints.tmp287
    tmp86 += np.transpose(ints.tmp296, (1, 0)) * 2
    tmp86 += np.transpose(ints.tmp298, (1, 0))
    tmp86 += np.transpose(ints.tmp308, (1, 0))
    tmp86 += np.transpose(ints.tmp309, (1, 0))
    tmp86 += np.transpose(ints.tmp272, (1, 0)) * -1
    tmp86 += np.transpose(ints.tmp307, (1, 0)) * -1
    tmp82 = np.copy(np.transpose(r2.bab, (2, 1, 0))) * -1
    tmp82 += einsum(r1.a, (0,), t1.bb, (1, 2), (1, 0, 2))
    tmp80 = np.copy(np.transpose(r2.aaa, (2, 0, 1))) * 2
    tmp80 += einsum(t1.aa, (0, 1), r1.a, (2,), (0, 2, 1))
    tmp85 = np.copy(ints.tmp276)
    tmp85 += ints.tmp289
    tmp85 += ints.tmp301
    tmp85 += ints.tmp344
    tmp85 += ints.tmp346 * 2
    tmp85 += np.transpose(v.aabb.vvov, (2, 0, 1, 3))
    tmp85 += ints.tmp263 * -1
    tmp85 += np.transpose(ints.tmp345, (0, 2, 1, 3)) * -1
    tmp81 = np.copy(ints.tmp292)
    tmp81 += ints.tmp352
    tmp81 += ints.tmp358 * 2
    tmp81 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp81 += ints.tmp350 * -1
    tmp89 = einsum(v.aabb.vvov, (0, 1, 2, 3), r2.bab, (3, 1, 4), (4, 2, 0)) * -1
    tmp89 += einsum(tmp77, (0, 1, 2), t1.aa, (0, 3), (1, 2, 3)) * -1
    tmp89 += einsum(tmp88, (0, 1, 2, 3), tmp87, (0, 3, 4), (1, 2, 4)) * -2
    del tmp87
    tmp83 = np.copy(ints.tmp314)
    tmp83 += np.transpose(v.aabb.vvoo, (2, 3, 0, 1))
    tmp83 += ints.tmp266 * -1
    tmp90 = einsum(v.aabb.ovvv, (0, 1, 2, 3), r2.bab, (3, 1, 4), (0, 4, 2))
    tmp90 += einsum(r2.bab, (0, 1, 2), tmp88, (3, 4, 2, 1), (3, 4, 0)) * -1
    del tmp88
    tmp84 = np.copy(ints.tmp32) * 0.5
    tmp84 += np.transpose(ints.tmp41, (1, 0))
    tmp84 += np.transpose(ints.tmp43, (1, 0)) * 0.5
    tmp84 += f.bb.vv * -0.5
    tmp84 += np.transpose(ints.tmp31, (1, 0)) * -0.5
    tmp84 += np.transpose(ints.tmp33, (1, 0)) * -0.5
    tmp84 += einsum(tmp0, (0, 1), t1.bb, (0, 2), (1, 2)) * 0.5
    tmp72 = np.copy(np.transpose(ints.tmp20, (1, 0))) * 2
    tmp72 += np.transpose(ints.tmp22, (1, 0))
    tmp72 += ints.tmp5
    tmp72 += f.aa.vv * -1
    tmp72 += np.transpose(ints.tmp4, (1, 0)) * -1
    tmp72 += np.transpose(ints.tmp6, (1, 0)) * -1
    tmp72 += np.transpose(tmp71, (1, 0))
    del tmp71
    tmp79 = np.copy(np.transpose(ints.tmp291, (0, 1, 3, 2)))
    tmp79 += ints.tmp356 * 2
    tmp79 += ints.tmp360
    tmp79 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    tmp79 += ints.tmp290 * -1
    tmp79 += ints.tmp354 * -2
    tmp79 += v.bbbb.oovv * -1
    tmp79 += einsum(t1.bb, (0, 1), tmp78, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp78
    tmp6 = np.copy(tmp3) * 2
    del tmp3
    tmp6 += tmp4
    del tmp4
    tmp6 += tmp5
    del tmp5
    tmp73 = np.copy(ints.tmp205)
    tmp73 += ints.tmp216
    tmp73 += ints.tmp220
    tmp73 += ints.tmp240
    tmp73 += ints.tmp242 * 2
    tmp73 += v.aabb.ovvv
    tmp73 += ints.tmp196 * -1
    tmp73 += np.transpose(ints.tmp241, (0, 1, 3, 2)) * -1
    tmp62 = np.copy(ints.tmp101)
    tmp62 += ints.tmp116 * 2
    tmp62 += ints.tmp117
    tmp62 += ints.tmp128
    tmp62 += ints.tmp129
    tmp62 += ints.tmp139
    tmp62 += ints.tmp152 * 2
    tmp62 += ints.tmp159 * 2
    tmp62 += ints.tmp161
    tmp62 += ints.tmp164 * 2
    tmp62 += ints.tmp165
    tmp62 += ints.tmp167
    tmp62 += ints.tmp186
    tmp62 += ints.tmp187
    tmp62 += ints.tmp79 * 2
    tmp62 += ints.tmp81
    tmp62 += ints.tmp98
    tmp62 += f.aa.ov * -1
    tmp62 += ints.tmp127 * -1
    tmp62 += ints.tmp136 * -1
    tmp62 += ints.tmp13 * -1
    tmp62 += ints.tmp153 * -1
    tmp62 += ints.tmp166 * -1
    tmp62 += ints.tmp168 * -1
    tmp62 += ints.tmp185 * -1
    tmp62 += ints.tmp50 * -2
    tmp62 += ints.tmp51 * -1
    tmp62 += ints.tmp80 * -2
    tmp62 += ints.tmp82 * -1
    tmp62 += ints.tmp83 * -2
    tmp62 += ints.tmp84 * -1
    tmp62 += ints.tmp9 * -1
    tmp66 = np.copy(np.transpose(r2.bbb, (2, 0, 1))) * 2
    tmp66 += einsum(r1.b, (0,), t1.bb, (1, 2), (1, 0, 2))
    tmp69 = np.copy(ints.tmp226)
    tmp69 += v.aabb.oovv
    tmp69 += ints.tmp199 * -1
    tmp58 = np.copy(f.aa.oo)
    tmp58 += np.transpose(ints.tmp106, (1, 0))
    tmp58 += np.transpose(ints.tmp108, (1, 0))
    tmp58 += ints.tmp137
    tmp58 += np.transpose(ints.tmp154, (1, 0)) * 2
    tmp58 += np.transpose(ints.tmp156, (1, 0))
    tmp58 += np.transpose(ints.tmp175, (1, 0))
    tmp58 += np.transpose(ints.tmp177, (1, 0))
    tmp58 += np.transpose(ints.tmp104, (1, 0)) * -1
    tmp58 += np.transpose(ints.tmp173, (1, 0)) * -1
    tmp70 = np.copy(ints.tmp32)
    tmp70 += np.transpose(ints.tmp41, (1, 0)) * 2
    tmp70 += np.transpose(ints.tmp43, (1, 0))
    tmp70 += f.bb.vv * -1
    tmp70 += np.transpose(ints.tmp31, (1, 0)) * -1
    tmp70 += np.transpose(ints.tmp33, (1, 0)) * -1
    tmp70 += einsum(tmp0, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp76 = einsum(r2.aba, (0, 1, 2), v.aabb.vvov, (3, 0, 4, 1), (2, 4, 3)) * -1
    tmp76 += einsum(tmp43, (0, 1, 2, 3), r2.aba, (4, 3, 1), (0, 2, 4))
    tmp75 = einsum(r2.aba, (0, 1, 2), v.aabb.ovvv, (3, 0, 4, 1), (2, 3, 4)) * -0.5
    tmp75 += einsum(tmp63, (0, 1, 2), t1.bb, (2, 3), (0, 1, 3)) * 0.5
    tmp75 += einsum(tmp43, (0, 1, 2, 3), tmp74, (2, 3, 4), (0, 1, 4)) * -1
    del tmp43, tmp74
    tmp65 = np.copy(np.transpose(ints.tmp148, (0, 1, 3, 2)))
    tmp65 += ints.tmp69 * 2
    tmp65 += ints.tmp75
    tmp65 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp65 += ints.tmp146 * -1
    tmp65 += ints.tmp67 * -2
    tmp65 += v.aaaa.oovv * -1
    tmp65 += einsum(tmp64, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3)) * -1
    del tmp64
    tmp68 = np.copy(np.transpose(r2.aba, (2, 0, 1)))
    tmp68 += einsum(r1.b, (0,), t1.aa, (1, 2), (1, 2, 0)) * -1
    tmp67 = np.copy(ints.tmp150)
    tmp67 += ints.tmp73
    tmp67 += ints.tmp77 * 2
    tmp67 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp67 += ints.tmp71 * -1
    tmp61 = np.copy(t2.aaaa)
    tmp61 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    tmp31 = np.copy(tmp12) * 2
    del tmp12
    tmp31 += tmp13 * 2
    del tmp13
    tmp31 += tmp15
    del tmp15
    tmp31 += tmp16
    del tmp16
    tmp31 += tmp17
    del tmp17
    tmp31 += np.transpose(tmp19, (0, 2, 1)) * -2
    del tmp19
    tmp31 += np.transpose(tmp28, (0, 2, 1))
    del tmp28
    tmp31 += tmp30
    del tmp30
    tmp59 = np.copy(ints.tmp118)
    tmp59 += ints.tmp162 * -1
    tmp57 = np.copy(tmp32) * 2
    del tmp32
    tmp57 += np.transpose(tmp34, (0, 2, 1)) * -1
    del tmp34
    tmp57 += np.transpose(tmp36, (0, 2, 1))
    del tmp36
    tmp57 += np.transpose(tmp38, (0, 2, 1)) * -1
    del tmp38
    tmp57 += np.transpose(tmp50, (0, 2, 1))
    del tmp50
    tmp57 += tmp52
    del tmp52
    tmp57 += tmp56
    del tmp56
    tmp60 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r2.aaa, (1, 3, 4), (4, 0, 2))
    tmp7 = np.copy(ints.tmp32)
    tmp7 += np.transpose(ints.tmp41, (1, 0)) * 2
    tmp7 += np.transpose(ints.tmp43, (1, 0))
    tmp7 += f.bb.vv * -1
    tmp7 += np.transpose(ints.tmp31, (1, 0)) * -1
    tmp7 += np.transpose(ints.tmp33, (1, 0)) * -1
    tmp2 = np.copy(np.transpose(ints.tmp20, (1, 0))) * 2
    tmp2 += np.transpose(ints.tmp22, (1, 0))
    tmp2 += ints.tmp5
    tmp2 += f.aa.vv * -1
    tmp2 += np.transpose(ints.tmp4, (1, 0)) * -1
    tmp2 += np.transpose(ints.tmp6, (1, 0)) * -1
    r2new.bbb = einsum(v.bbbb.vvvv, (0, 1, 2, 3), r2.bbb, (3, 1, 4), (0, 2, 4)) * -2
    r2new.bbb += np.transpose(tmp116, (1, 2, 0)) * -1
    r2new.bbb += np.transpose(tmp116, (2, 1, 0))
    del tmp116
    r2new.bbb += np.transpose(tmp136, (1, 2, 0))
    r2new.bbb += np.transpose(tmp136, (2, 1, 0)) * -1
    del tmp136
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp86, (2, 3), (0, 1, 3)) * -2
    r2new.bbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp11, (1,), (2, 3, 0)) * 2
    r2new.bbb += einsum(tmp137, (0, 1, 2, 3), r1.b, (3,), (2, 1, 0)) * 2
    del tmp137
    r2new.bbb += einsum(tmp139, (0, 1, 2, 3), tmp138, (4, 0, 1), (3, 2, 4)) * -2
    del tmp139, tmp138
    r2new.bbb += einsum(r1.b, (0,), tmp91, (1, 2), (0, 2, 1)) * -1
    r2new.bbb += einsum(r1.b, (0,), tmp91, (1, 2), (2, 0, 1))
    r2new.bab = einsum(r2.bab, (0, 1, 2), v.aabb.vvvv, (3, 1, 4, 0), (4, 3, 2))
    r2new.bab += einsum(tmp77, (0, 1, 2), t2.abab, (0, 2, 3, 4), (4, 3, 1)) * -1
    del tmp77
    r2new.bab += einsum(tmp79, (0, 1, 2, 3), r2.bab, (3, 4, 1), (2, 4, 0))
    del tmp79
    r2new.bab += einsum(tmp80, (0, 1, 2), tmp81, (0, 3, 1, 4), (4, 2, 3))
    del tmp80, tmp81
    r2new.bab += einsum(tmp83, (0, 1, 2, 3), tmp82, (1, 3, 4), (4, 2, 0))
    del tmp83, tmp82
    r2new.bab += einsum(tmp72, (0, 1), r2.bab, (2, 0, 3), (2, 1, 3)) * -1
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp84, (0, 3), (3, 1, 2)) * -2
    del tmp84
    r2new.bab += einsum(r1.a, (0,), tmp85, (1, 2, 0, 3), (3, 2, 1)) * -1
    del tmp85
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp86, (2, 3), (0, 1, 3)) * -1
    del tmp86
    r2new.bab += einsum(tmp6, (0,), t2.abab, (0, 1, 2, 3), (3, 2, 1))
    r2new.bab += einsum(t1.bb, (0, 1), tmp89, (2, 0, 3), (1, 3, 2))
    del tmp89
    r2new.bab += einsum(t1.aa, (0, 1), tmp90, (0, 2, 3), (3, 1, 2)) * -1
    del tmp90
    r2new.bab += einsum(r1.a, (0,), tmp91, (1, 2), (2, 0, 1))
    del tmp91
    r2new.aba = einsum(r2.aba, (0, 1, 2), v.aabb.vvvv, (3, 0, 4, 1), (3, 4, 2))
    r2new.aba += einsum(tmp63, (0, 1, 2), t2.abab, (1, 2, 3, 4), (3, 4, 0))
    del tmp63
    r2new.aba += einsum(tmp65, (0, 1, 2, 3), r2.aba, (3, 4, 1), (2, 4, 0))
    del tmp65
    r2new.aba += einsum(tmp66, (0, 1, 2), tmp67, (3, 0, 4, 1), (4, 2, 3))
    del tmp66, tmp67
    r2new.aba += einsum(tmp68, (0, 1, 2), tmp69, (3, 0, 4, 2), (1, 4, 3)) * -1
    del tmp68, tmp69
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp70, (1, 3), (0, 3, 2)) * -1
    del tmp70
    r2new.aba += einsum(tmp72, (0, 1), r2.aba, (0, 2, 3), (1, 2, 3)) * -1
    del tmp72
    r2new.aba += einsum(r1.b, (0,), tmp73, (1, 2, 3, 0), (2, 3, 1)) * -1
    del tmp73
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp58, (2, 3), (0, 1, 3)) * -1
    r2new.aba += einsum(tmp11, (0,), t2.abab, (1, 0, 2, 3), (2, 3, 1))
    r2new.aba += einsum(t1.aa, (0, 1), tmp75, (2, 0, 3), (1, 3, 2)) * 2
    del tmp75
    r2new.aba += einsum(t1.bb, (0, 1), tmp76, (2, 0, 3), (3, 1, 2))
    del tmp76
    r2new.aba += einsum(tmp62, (0, 1), r1.b, (2,), (1, 2, 0))
    r2new.aaa = einsum(r2.aaa, (0, 1, 2), v.aaaa.vvvv, (3, 1, 4, 0), (3, 4, 2)) * -2
    r2new.aaa += np.transpose(tmp31, (1, 2, 0))
    r2new.aaa += np.transpose(tmp31, (2, 1, 0)) * -1
    del tmp31
    r2new.aaa += np.transpose(tmp57, (1, 2, 0)) * -1
    r2new.aaa += np.transpose(tmp57, (2, 1, 0))
    del tmp57
    r2new.aaa += einsum(tmp58, (0, 1), r2.aaa, (2, 3, 0), (2, 3, 1)) * -2
    del tmp58
    r2new.aaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp6, (1,), (2, 3, 0)) * 2
    r2new.aaa += einsum(tmp59, (0, 1, 2, 3), r1.a, (3,), (2, 1, 0)) * 2
    del tmp59
    r2new.aaa += einsum(tmp61, (0, 1, 2, 3), tmp60, (4, 0, 1), (3, 2, 4)) * -2
    del tmp61, tmp60
    r2new.aaa += einsum(r1.a, (0,), tmp62, (1, 2), (0, 2, 1)) * -1
    r2new.aaa += einsum(r1.a, (0,), tmp62, (1, 2), (2, 0, 1))
    del tmp62
    r1new.b = einsum(r2.bbb, (0, 1, 2), v.bbbb.ovvv, (2, 1, 3, 0), (3,)) * 2
    r1new.b += einsum(v.aabb.ovvv, (0, 1, 2, 3), r2.aba, (1, 3, 0), (2,)) * -1
    r1new.b += einsum(tmp1, (0, 1), r2.aba, (1, 2, 0), (2,)) * -1
    r1new.b += einsum(r2.bbb, (0, 1, 2), tmp0, (2, 1), (0,)) * 2
    r1new.b += einsum(r1.b, (0,), tmp7, (0, 1), (1,)) * -1
    del tmp7
    r1new.b += einsum(t1.bb, (0, 1), tmp11, (0,), (1,)) * -1
    del tmp11
    r1new.a = einsum(v.aaaa.ovvv, (0, 1, 2, 3), r2.aaa, (3, 1, 0), (2,)) * 2
    r1new.a += einsum(v.aabb.vvov, (0, 1, 2, 3), r2.bab, (3, 1, 2), (0,)) * -1
    r1new.a += einsum(tmp0, (0, 1), r2.bab, (1, 2, 0), (2,)) * -1
    del tmp0
    r1new.a += einsum(tmp1, (0, 1), r2.aaa, (2, 1, 0), (2,)) * 2
    del tmp1
    r1new.a += einsum(r1.a, (0,), tmp2, (0, 1), (1,)) * -1
    del tmp2
    r1new.a += einsum(t1.aa, (0, 1), tmp6, (0,), (1,)) * -1
    del tmp6

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ip_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:52:01.173376.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp10 : array
    tmp100 : array
    tmp101 : array
    tmp103 : array
    tmp105 : array
    tmp107 : array
    tmp109 : array
    tmp11 : array
    tmp111 : array
    tmp113 : array
    tmp115 : array
    tmp117 : array
    tmp119 : array
    tmp120 : array
    tmp122 : array
    tmp124 : array
    tmp125 : array
    tmp127 : array
    tmp129 : array
    tmp13 : array
    tmp130 : array
    tmp132 : array
    tmp133 : array
    tmp135 : array
    tmp137 : array
    tmp138 : array
    tmp140 : array
    tmp141 : array
    tmp143 : array
    tmp144 : array
    tmp146 : array
    tmp148 : array
    tmp149 : array
    tmp15 : array
    tmp151 : array
    tmp152 : array
    tmp154 : array
    tmp155 : array
    tmp156 : array
    tmp157 : array
    tmp159 : array
    tmp161 : array
    tmp162 : array
    tmp163 : array
    tmp164 : array
    tmp165 : array
    tmp167 : array
    tmp168 : array
    tmp169 : array
    tmp17 : array
    tmp170 : array
    tmp172 : array
    tmp174 : array
    tmp175 : array
    tmp176 : array
    tmp177 : array
    tmp178 : array
    tmp179 : array
    tmp181 : array
    tmp182 : array
    tmp184 : array
    tmp185 : array
    tmp186 : array
    tmp187 : array
    tmp188 : array
    tmp189 : array
    tmp19 : array
    tmp190 : array
    tmp191 : array
    tmp193 : array
    tmp194 : array
    tmp196 : array
    tmp197 : array
    tmp199 : array
    tmp2 : array
    tmp201 : array
    tmp203 : array
    tmp204 : array
    tmp205 : array
    tmp206 : array
    tmp207 : array
    tmp209 : array
    tmp21 : array
    tmp210 : array
    tmp211 : array
    tmp212 : array
    tmp214 : array
    tmp215 : array
    tmp22 : array
    tmp223 : array
    tmp225 : array
    tmp230 : array
    tmp232 : array
    tmp238 : array
    tmp240 : array
    tmp247 : array
    tmp248 : array
    tmp25 : array
    tmp250 : array
    tmp251 : array
    tmp253 : array
    tmp254 : array
    tmp256 : array
    tmp26 : array
    tmp262 : array
    tmp264 : array
    tmp27 : array
    tmp275 : array
    tmp277 : array
    tmp279 : array
    tmp28 : array
    tmp281 : array
    tmp283 : array
    tmp285 : array
    tmp291 : array
    tmp292 : array
    tmp294 : array
    tmp295 : array
    tmp297 : array
    tmp299 : array
    tmp30 : array
    tmp301 : array
    tmp306 : array
    tmp307 : array
    tmp309 : array
    tmp314 : array
    tmp315 : array
    tmp317 : array
    tmp319 : array
    tmp32 : array
    tmp320 : array
    tmp324 : array
    tmp325 : array
    tmp327 : array
    tmp328 : array
    tmp333 : array
    tmp334 : array
    tmp336 : array
    tmp34 : array
    tmp346 : array
    tmp349 : array
    tmp351 : array
    tmp353 : array
    tmp355 : array
    tmp357 : array
    tmp359 : array
    tmp36 : array
    tmp361 : array
    tmp37 : array
    tmp38 : array
    tmp39 : array
    tmp391 : array
    tmp393 : array
    tmp4 : array
    tmp41 : array
    tmp422 : array
    tmp425 : array
    tmp426 : array
    tmp428 : array
    tmp43 : array
    tmp430 : array
    tmp432 : array
    tmp434 : array
    tmp436 : array
    tmp438 : array
    tmp449 : array
    tmp45 : array
    tmp451 : array
    tmp453 : array
    tmp46 : array
    tmp47 : array
    tmp49 : array
    tmp5 : array
    tmp51 : array
    tmp53 : array
    tmp55 : array
    tmp57 : array
    tmp59 : array
    tmp61 : array
    tmp62 : array
    tmp64 : array
    tmp65 : array
    tmp66 : array
    tmp68 : array
    tmp7 : array
    tmp70 : array
    tmp72 : array
    tmp74 : array
    tmp76 : array
    tmp78 : array
    tmp8 : array
    tmp80 : array
    tmp82 : array
    tmp83 : array
    tmp85 : array
    tmp86 : array
    tmp88 : array
    tmp89 : array
    tmp90 : array
    tmp92 : array
    tmp94 : array
    tmp96 : array
    tmp98 : array
    """

    tmp45 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp119 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 2, 1))
    tmp41 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    tmp38 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp39 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp36 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp89 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 1), (0, 3))
    tmp32 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 3, 0, 1), (2, 3))
    tmp82 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 1, 0, 3), (2, 3))
    tmp214 = einsum(tmp45, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp333 = einsum(t1.bb, (0, 1), tmp119, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp327 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 2, 0, 1))
    tmp324 = einsum(t1.bb, (0, 1), v.bbbb.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp174 = einsum(t1.aa, (0, 1), v.aabb.ovoo, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp176 = einsum(v.aabb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp314 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp151 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp306 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 5, 2), (0, 1, 4, 5)) * -1
    tmp124 = einsum(t1.bb, (0, 1), v.aabb.ovov, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp211 = einsum(tmp41, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp209 = einsum(tmp38, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp156 = einsum(tmp39, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp205 = einsum(t1.bb, (0, 1), tmp36, (2, 1), (0, 2))
    tmp203 = einsum(tmp89, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp155 = einsum(t1.aa, (0, 1), tmp32, (2, 1), (0, 2))
    tmp154 = einsum(tmp82, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp196 = einsum(t1.aa, (0, 1), v.aabb.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp193 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp190 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp188 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp186 = einsum(t1.bb, (0, 1), v.bbbb.ovvv, (0, 2, 3, 1), (2, 3))
    tmp184 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (0, 1), (2, 3))
    tmp181 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    tmp178 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp169 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp167 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp27 = einsum(t1.bb, (0, 1), v.aabb.ooov, (2, 3, 0, 1), (2, 3))
    tmp163 = einsum(t1.bb, (0, 1), v.bbbb.ooov, (2, 3, 0, 1), (2, 3))
    tmp161 = einsum(t1.bb, (0, 1), v.bbbb.ooov, (2, 0, 3, 1), (2, 3))
    tmp26 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    tmp25 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t1.aa, (1, 3), (0, 2))
    tmp148 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp49 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 3), (4, 0))
    tmp143 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp140 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp47 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 1, 3), (4, 0))
    tmp21 = einsum(t1.bb, (0, 1), f.bb.ov, (2, 1), (2, 0))
    tmp1 = einsum(t1.aa, (0, 1), f.aa.ov, (2, 1), (2, 0))
    tmp453 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 5), (4, 0, 5, 3))
    tmp451 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 1, 4), (4, 3))
    tmp449 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 4, 1, 3), (2, 4))
    tmp438 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 5), (4, 2, 5, 3))
    tmp436 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovov, (1, 3, 4, 5), (0, 4, 2, 5))
    tmp434 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp432 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp430 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp428 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp426 = einsum(t1.aa, (0, 1), v.aabb.vvov, (2, 1, 3, 4), (0, 3, 2, 4))
    tmp425 = einsum(t1.bb, (0, 1), v.bbbb.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp422 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (4, 2, 5, 1))
    tmp393 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (4, 1))
    tmp391 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (0, 3, 1, 4), (2, 4)) * -1
    tmp361 = einsum(t2.bbbb, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp359 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp357 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 4, 1, 5))
    tmp355 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp353 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 1, 5), (0, 4, 3, 5))
    tmp351 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp349 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 1, 2))
    tmp346 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (4, 1), (4, 0, 2, 3))
    tmp336 = einsum(tmp214, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 3, 4))
    tmp334 = einsum(tmp333, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp328 = einsum(t1.aa, (0, 1), tmp327, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp325 = einsum(tmp324, (0, 1, 2, 3), t1.bb, (4, 2), (4, 0, 1, 3))
    tmp320 = einsum(t1.aa, (0, 1), tmp174, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp319 = einsum(t1.aa, (0, 1), tmp176, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp317 = einsum(tmp314, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp315 = einsum(t1.bb, (0, 1), tmp314, (2, 3, 0, 4), (2, 3, 4, 1))
    tmp309 = einsum(t1.aa, (0, 1), tmp151, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp307 = einsum(t1.bb, (0, 1), tmp306, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp301 = einsum(t2.abab, (0, 1, 2, 3), tmp45, (4, 0, 5, 3), (4, 1, 5, 2))
    tmp299 = einsum(tmp124, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (1, 4, 2, 5))
    tmp297 = einsum(tmp124, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 1, 2, 5))
    tmp295 = einsum(tmp119, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp294 = einsum(tmp119, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp292 = einsum(t2.bbbb, (0, 1, 2, 3), tmp119, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp291 = einsum(t2.abab, (0, 1, 2, 3), tmp119, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp285 = einsum(tmp38, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp283 = einsum(tmp38, (0, 1), t2.abab, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp281 = einsum(tmp36, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp279 = einsum(t2.abab, (0, 1, 2, 3), tmp36, (4, 3), (0, 1, 4, 2))
    tmp277 = einsum(tmp89, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp275 = einsum(tmp89, (0, 1), t2.abab, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp264 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 5, 3), (0, 1, 5, 4))
    tmp262 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.bbbb, (4, 5, 3, 1), (4, 5, 0, 2)) * -1
    tmp256 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 4, 1, 5), (4, 2, 3, 5))
    tmp254 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovoo, (1, 3, 4, 5), (0, 4, 5, 2))
    tmp253 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ooov, (4, 0, 5, 3), (4, 1, 5, 2))
    tmp251 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp250 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ooov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp248 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp247 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ooov, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp240 = einsum(t1.aa, (0, 1), v.aabb.vvoo, (2, 1, 3, 4), (0, 3, 4, 2))
    tmp238 = einsum(t1.bb, (0, 1), v.bbbb.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp232 = einsum(t1.aa, (0, 1), v.aabb.oooo, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp230 = einsum(t1.bb, (0, 1), v.bbbb.oooo, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp225 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp223 = einsum(f.bb.ov, (0, 1), t2.abab, (2, 3, 4, 1), (2, 0, 3, 4))
    tmp215 = einsum(t1.bb, (0, 1), tmp214, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp212 = einsum(t1.aa, (0, 1), tmp211, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp210 = einsum(t1.bb, (0, 1), tmp209, (2, 0), (2, 1))
    tmp207 = einsum(t1.aa, (0, 1), tmp156, (2, 0), (2, 1))
    tmp206 = einsum(t1.bb, (0, 1), tmp205, (2, 0), (2, 1))
    tmp204 = einsum(t1.bb, (0, 1), tmp203, (2, 0), (2, 1))
    tmp201 = einsum(t1.aa, (0, 1), tmp155, (2, 0), (2, 1))
    tmp199 = einsum(t1.aa, (0, 1), tmp154, (2, 0), (2, 1))
    tmp197 = einsum(tmp196, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp194 = einsum(t1.aa, (0, 1), tmp193, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp191 = einsum(t1.aa, (0, 1), tmp190, (2, 1), (0, 2))
    tmp189 = einsum(tmp188, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp187 = einsum(tmp186, (0, 1), t1.bb, (2, 0), (2, 1))
    tmp185 = einsum(tmp184, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp182 = einsum(tmp181, (0, 1), t1.aa, (2, 0), (2, 1))
    tmp179 = einsum(t1.aa, (0, 1), tmp178, (2, 1), (0, 2))
    tmp177 = einsum(t1.bb, (0, 1), tmp176, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp175 = einsum(t1.bb, (0, 1), tmp174, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp172 = einsum(t1.aa, (0, 1), tmp169, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp170 = einsum(tmp169, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 3, 4))
    tmp168 = einsum(t1.bb, (0, 1), tmp167, (2, 0), (2, 1))
    tmp165 = einsum(t1.aa, (0, 1), tmp27, (2, 0), (2, 1))
    tmp164 = einsum(t1.bb, (0, 1), tmp163, (2, 0), (2, 1))
    tmp162 = einsum(t1.bb, (0, 1), tmp161, (2, 0), (2, 1))
    tmp159 = einsum(t1.aa, (0, 1), tmp26, (2, 0), (2, 1))
    tmp157 = einsum(tmp25, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp152 = einsum(t1.bb, (0, 1), tmp151, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp149 = einsum(t1.aa, (0, 1), tmp148, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp146 = einsum(t1.aa, (0, 1), tmp49, (2, 0), (2, 1))
    tmp144 = einsum(t1.bb, (0, 1), tmp143, (2, 0), (2, 1))
    tmp141 = einsum(t1.bb, (0, 1), tmp140, (2, 0), (2, 1))
    tmp138 = einsum(t1.aa, (0, 1), tmp47, (2, 0), (2, 1))
    tmp137 = einsum(tmp124, (0, 1, 2, 3), t2.abab, (4, 2, 3, 5), (4, 0, 1, 5))
    tmp135 = einsum(tmp45, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp133 = einsum(tmp45, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp132 = einsum(tmp41, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 1, 4, 5))
    tmp130 = einsum(t2.aaaa, (0, 1, 2, 3), tmp41, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp129 = einsum(t2.abab, (0, 1, 2, 3), tmp41, (4, 0, 5, 2), (4, 5, 1, 3))
    tmp127 = einsum(t2.aaaa, (0, 1, 2, 3), tmp41, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp125 = einsum(tmp124, (0, 1, 2, 3), t2.abab, (0, 2, 3, 4), (1, 4))
    tmp122 = einsum(t2.abab, (0, 1, 2, 3), tmp45, (4, 0, 1, 3), (4, 2))
    tmp120 = einsum(tmp119, (0, 1, 2, 3), t2.bbbb, (2, 1, 4, 3), (0, 4))
    tmp117 = einsum(tmp41, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 3), (0, 4)) * -1
    tmp115 = einsum(tmp39, (0, 1), t2.abab, (2, 3, 1, 4), (2, 0, 3, 4))
    tmp113 = einsum(tmp39, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp111 = einsum(tmp32, (0, 1), t2.abab, (2, 3, 1, 4), (2, 0, 3, 4))
    tmp109 = einsum(tmp32, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp107 = einsum(tmp82, (0, 1), t2.abab, (2, 3, 1, 4), (2, 0, 3, 4))
    tmp105 = einsum(tmp82, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp103 = einsum(tmp38, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp101 = einsum(tmp38, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp100 = einsum(t2.abab, (0, 1, 2, 3), tmp39, (0, 2), (1, 3))
    tmp98 = einsum(t2.aaaa, (0, 1, 2, 3), tmp39, (1, 3), (0, 2))
    tmp96 = einsum(tmp36, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp94 = einsum(tmp36, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp92 = einsum(tmp89, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp90 = einsum(t2.abab, (0, 1, 2, 3), tmp89, (1, 3), (0, 2))
    tmp88 = einsum(tmp32, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp86 = einsum(tmp32, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp85 = einsum(tmp82, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp83 = einsum(t2.aaaa, (0, 1, 2, 3), tmp82, (1, 3), (0, 2))
    tmp80 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp78 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp76 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 1, 3), (0, 4))
    tmp74 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp72 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.bbbb, (4, 0, 3, 1), (4, 2)) * -1
    tmp70 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 1, 3), (4, 2))
    tmp68 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp66 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp65 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (4, 3, 1, 5), (4, 0, 2, 5))
    tmp64 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 1, 4, 5))
    tmp62 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp61 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.abab, (1, 4, 3, 5), (0, 2, 4, 5))
    tmp59 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ooov, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp57 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    tmp55 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 3, 1, 4), (2, 4))
    tmp53 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t2.bbbb, (1, 2, 4, 3), (0, 4))
    tmp51 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (2, 1, 4, 3), (0, 4)) * -1
    tmp46 = einsum(v.aabb.oovv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 1, 4, 2))
    tmp43 = einsum(t1.aa, (0, 1), v.aaaa.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp37 = einsum(v.bbbb.oovv, (0, 1, 2, 3), t1.bb, (1, 3), (0, 2))
    tmp34 = einsum(t1.aa, (0, 1), v.aaaa.oovv, (2, 0, 3, 1), (2, 3))
    tmp30 = einsum(t1.bb, (0, 1), v.aabb.oooo, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp28 = einsum(t1.aa, (0, 1), v.aaaa.oooo, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp22 = einsum(t1.bb, (0, 1), tmp21, (0, 2), (2, 1))
    tmp19 = einsum(t1.aa, (0, 1), tmp1, (0, 2), (2, 1))
    tmp17 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (4, 2), (4, 0, 1, 3))
    tmp15 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp13 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp11 = einsum(f.bb.ov, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp10 = einsum(f.aa.ov, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp8 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp7 = einsum(f.bb.vv, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp5 = einsum(t1.aa, (0, 1), f.aa.vv, (2, 1), (0, 2))
    tmp4 = einsum(t1.bb, (0, 1), f.bb.oo, (2, 0), (2, 1))
    tmp2 = einsum(f.aa.oo, (0, 1), t1.aa, (1, 2), (0, 2))

    return {f"tmp1": tmp1, f"tmp10": tmp10, f"tmp100": tmp100, f"tmp101": tmp101, f"tmp103": tmp103, f"tmp105": tmp105, f"tmp107": tmp107, f"tmp109": tmp109, f"tmp11": tmp11, f"tmp111": tmp111, f"tmp113": tmp113, f"tmp115": tmp115, f"tmp117": tmp117, f"tmp119": tmp119, f"tmp120": tmp120, f"tmp122": tmp122, f"tmp124": tmp124, f"tmp125": tmp125, f"tmp127": tmp127, f"tmp129": tmp129, f"tmp13": tmp13, f"tmp130": tmp130, f"tmp132": tmp132, f"tmp133": tmp133, f"tmp135": tmp135, f"tmp137": tmp137, f"tmp138": tmp138, f"tmp140": tmp140, f"tmp141": tmp141, f"tmp143": tmp143, f"tmp144": tmp144, f"tmp146": tmp146, f"tmp148": tmp148, f"tmp149": tmp149, f"tmp15": tmp15, f"tmp151": tmp151, f"tmp152": tmp152, f"tmp154": tmp154, f"tmp155": tmp155, f"tmp156": tmp156, f"tmp157": tmp157, f"tmp159": tmp159, f"tmp161": tmp161, f"tmp162": tmp162, f"tmp163": tmp163, f"tmp164": tmp164, f"tmp165": tmp165, f"tmp167": tmp167, f"tmp168": tmp168, f"tmp169": tmp169, f"tmp17": tmp17, f"tmp170": tmp170, f"tmp172": tmp172, f"tmp174": tmp174, f"tmp175": tmp175, f"tmp176": tmp176, f"tmp177": tmp177, f"tmp178": tmp178, f"tmp179": tmp179, f"tmp181": tmp181, f"tmp182": tmp182, f"tmp184": tmp184, f"tmp185": tmp185, f"tmp186": tmp186, f"tmp187": tmp187, f"tmp188": tmp188, f"tmp189": tmp189, f"tmp19": tmp19, f"tmp190": tmp190, f"tmp191": tmp191, f"tmp193": tmp193, f"tmp194": tmp194, f"tmp196": tmp196, f"tmp197": tmp197, f"tmp199": tmp199, f"tmp2": tmp2, f"tmp201": tmp201, f"tmp203": tmp203, f"tmp204": tmp204, f"tmp205": tmp205, f"tmp206": tmp206, f"tmp207": tmp207, f"tmp209": tmp209, f"tmp21": tmp21, f"tmp210": tmp210, f"tmp211": tmp211, f"tmp212": tmp212, f"tmp214": tmp214, f"tmp215": tmp215, f"tmp22": tmp22, f"tmp223": tmp223, f"tmp225": tmp225, f"tmp230": tmp230, f"tmp232": tmp232, f"tmp238": tmp238, f"tmp240": tmp240, f"tmp247": tmp247, f"tmp248": tmp248, f"tmp25": tmp25, f"tmp250": tmp250, f"tmp251": tmp251, f"tmp253": tmp253, f"tmp254": tmp254, f"tmp256": tmp256, f"tmp26": tmp26, f"tmp262": tmp262, f"tmp264": tmp264, f"tmp27": tmp27, f"tmp275": tmp275, f"tmp277": tmp277, f"tmp279": tmp279, f"tmp28": tmp28, f"tmp281": tmp281, f"tmp283": tmp283, f"tmp285": tmp285, f"tmp291": tmp291, f"tmp292": tmp292, f"tmp294": tmp294, f"tmp295": tmp295, f"tmp297": tmp297, f"tmp299": tmp299, f"tmp30": tmp30, f"tmp301": tmp301, f"tmp306": tmp306, f"tmp307": tmp307, f"tmp309": tmp309, f"tmp314": tmp314, f"tmp315": tmp315, f"tmp317": tmp317, f"tmp319": tmp319, f"tmp32": tmp32, f"tmp320": tmp320, f"tmp324": tmp324, f"tmp325": tmp325, f"tmp327": tmp327, f"tmp328": tmp328, f"tmp333": tmp333, f"tmp334": tmp334, f"tmp336": tmp336, f"tmp34": tmp34, f"tmp346": tmp346, f"tmp349": tmp349, f"tmp351": tmp351, f"tmp353": tmp353, f"tmp355": tmp355, f"tmp357": tmp357, f"tmp359": tmp359, f"tmp36": tmp36, f"tmp361": tmp361, f"tmp37": tmp37, f"tmp38": tmp38, f"tmp39": tmp39, f"tmp391": tmp391, f"tmp393": tmp393, f"tmp4": tmp4, f"tmp41": tmp41, f"tmp422": tmp422, f"tmp425": tmp425, f"tmp426": tmp426, f"tmp428": tmp428, f"tmp43": tmp43, f"tmp430": tmp430, f"tmp432": tmp432, f"tmp434": tmp434, f"tmp436": tmp436, f"tmp438": tmp438, f"tmp449": tmp449, f"tmp45": tmp45, f"tmp451": tmp451, f"tmp453": tmp453, f"tmp46": tmp46, f"tmp47": tmp47, f"tmp49": tmp49, f"tmp5": tmp5, f"tmp51": tmp51, f"tmp53": tmp53, f"tmp55": tmp55, f"tmp57": tmp57, f"tmp59": tmp59, f"tmp61": tmp61, f"tmp62": tmp62, f"tmp64": tmp64, f"tmp65": tmp65, f"tmp66": tmp66, f"tmp68": tmp68, f"tmp7": tmp7, f"tmp70": tmp70, f"tmp72": tmp72, f"tmp74": tmp74, f"tmp76": tmp76, f"tmp78": tmp78, f"tmp8": tmp8, f"tmp80": tmp80, f"tmp82": tmp82, f"tmp83": tmp83, f"tmp85": tmp85, f"tmp86": tmp86, f"tmp88": tmp88, f"tmp89": tmp89, f"tmp90": tmp90, f"tmp92": tmp92, f"tmp94": tmp94, f"tmp96": tmp96, f"tmp98": tmp98}

def hbar_lmatvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:52:01.379390.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp53 = einsum(t2.bbbb, (0, 1, 2, 3), r2.bbb, (0, 1, 3), (2,))
    tmp52 = einsum(r2.aba, (0, 1, 2), t2.abab, (0, 1, 2, 3), (3,))
    tmp90 = np.copy(f.bb.oo)
    tmp90 += ints.tmp163
    tmp90 += ints.tmp167
    tmp90 += ints.tmp205
    tmp90 += ints.tmp209
    tmp90 += np.transpose(ints.tmp21, (1, 0))
    tmp88 = np.copy(ints.tmp425)
    tmp88 += np.transpose(ints.tmp430, (0, 1, 3, 2)) * 2
    tmp86 = np.copy(ints.tmp426)
    tmp86 += ints.tmp432
    tmp86 += ints.tmp436 * 2
    tmp62 = np.copy(f.bb.ov)
    tmp62 += ints.tmp36
    tmp62 += ints.tmp38
    tmp62 += ints.tmp89 * -1
    tmp76 = np.copy(ints.tmp119)
    tmp76 += np.transpose(ints.tmp119, (0, 2, 1, 3)) * -1
    tmp49 = einsum(t1.bb, (0, 1), r2.bbb, (2, 3, 1), (2, 3, 0))
    tmp78 = np.copy(v.bbbb.ooov)
    tmp78 += np.transpose(v.bbbb.ooov, (0, 2, 1, 3)) * -1
    tmp47 = einsum(t1.aa, (0, 1), r2.aba, (2, 3, 1), (2, 0, 3))
    tmp81 = np.copy(ints.tmp140) * 2
    tmp81 += ints.tmp143
    tmp81 += ints.tmp161 * -1
    tmp81 += ints.tmp203 * -1
    tmp54 = np.copy(tmp52) * -0.5
    del tmp52
    tmp54 += tmp53
    del tmp53
    tmp74 = np.copy(ints.tmp324)
    tmp74 += np.transpose(ints.tmp434, (0, 1, 3, 2)) * 2
    tmp74 += np.transpose(ints.tmp438, (0, 1, 3, 2))
    tmp40 = np.copy(f.aa.ov)
    tmp40 += ints.tmp32
    tmp40 += ints.tmp39
    tmp40 += ints.tmp82 * -1
    tmp36 = np.copy(ints.tmp47) * 2
    tmp36 += ints.tmp49
    tmp36 += ints.tmp154 * -1
    tmp36 += ints.tmp25 * -1
    tmp22 = einsum(t1.bb, (0, 1), r2.bab, (2, 3, 1), (3, 2, 0)) * -1
    tmp27 = np.copy(ints.tmp193)
    tmp27 += np.transpose(ints.tmp355, (0, 1, 3, 2)) * 2
    tmp27 += np.transpose(ints.tmp359, (0, 1, 3, 2))
    tmp34 = np.copy(v.aaaa.ooov)
    tmp34 += np.transpose(v.aaaa.ooov, (0, 2, 1, 3)) * -1
    tmp31 = einsum(r2.aaa, (0, 1, 2), t1.aa, (3, 2), (0, 1, 3))
    tmp29 = np.copy(ints.tmp349)
    tmp29 += ints.tmp357
    tmp29 += ints.tmp361 * 2
    tmp25 = einsum(r2.aaa, (0, 1, 2), t2.aaaa, (0, 1, 3, 2), (3,))
    tmp32 = np.copy(ints.tmp41) * -1
    tmp32 += np.transpose(ints.tmp41, (0, 2, 1, 3))
    tmp12 = einsum(r2.bab, (0, 1, 2), t2.abab, (1, 0, 3, 2), (3,)) * -1
    tmp14 = np.copy(ints.tmp346)
    tmp14 += np.transpose(ints.tmp351, (0, 1, 3, 2)) * 2
    tmp16 = np.copy(f.aa.oo)
    tmp16 += ints.tmp155
    tmp16 += ints.tmp156
    tmp16 += np.transpose(ints.tmp1, (1, 0))
    tmp16 += ints.tmp26
    tmp16 += ints.tmp27
    tmp84 = einsum(ints.tmp119, (0, 1, 2, 3), r1.b, (0,), (1, 2, 3))
    tmp91 = einsum(tmp90, (0, 1), r2.bbb, (2, 0, 3), (2, 1, 3)) * -1
    del tmp90
    tmp85 = einsum(v.bbbb.ovov, (0, 1, 2, 3), r2.bbb, (4, 2, 3), (4, 0, 1))
    tmp89 = einsum(tmp88, (0, 1, 2, 3), r2.bbb, (4, 0, 3), (4, 1, 2)) * -1
    del tmp88
    tmp87 = einsum(tmp86, (0, 1, 2, 3), r2.aba, (0, 4, 2), (4, 1, 3))
    del tmp86
    tmp63 = einsum(t1.bb, (0, 1), tmp62, (0, 2), (1, 2))
    tmp68 = einsum(ints.tmp428, (0, 1, 2, 3), r2.aba, (0, 4, 2), (1, 4, 3))
    tmp77 = einsum(tmp49, (0, 1, 2), tmp76, (0, 3, 2, 4), (1, 3, 4)) * 2
    del tmp76
    tmp70 = einsum(ints.tmp314, (0, 1, 2, 3), r2.bbb, (1, 0, 4), (2, 3, 4)) * -1
    tmp79 = einsum(tmp78, (0, 1, 2, 3), tmp49, (0, 4, 2), (4, 1, 3)) * 2
    del tmp78
    tmp73 = einsum(tmp47, (0, 1, 2), v.aabb.ooov, (1, 0, 3, 4), (2, 3, 4))
    tmp82 = einsum(r2.bbb, (0, 1, 2), tmp81, (1, 3), (0, 3, 2)) * -2
    del tmp81
    tmp80 = einsum(tmp54, (0,), v.bbbb.ovov, (1, 0, 2, 3), (1, 2, 3)) * 2
    tmp67 = einsum(r1.b, (0,), v.bbbb.ooov, (1, 0, 2, 3), (1, 2, 3))
    tmp71 = einsum(r2.bbb, (0, 1, 2), v.bbbb.oovv, (3, 1, 4, 2), (0, 3, 4))
    tmp72 = einsum(tmp47, (0, 1, 2), ints.tmp45, (0, 1, 3, 4), (3, 2, 4))
    tmp75 = einsum(tmp74, (0, 1, 2, 3), r2.bbb, (4, 0, 3), (4, 1, 2)) * -2
    del tmp74
    tmp69 = einsum(r2.aba, (0, 1, 2), v.aabb.ovov, (0, 2, 3, 4), (1, 3, 4))
    tmp41 = einsum(t1.aa, (0, 1), tmp40, (0, 2), (1, 2))
    tmp37 = einsum(tmp36, (0, 1), r2.aaa, (2, 0, 3), (2, 1, 3)) * -2
    del tmp36
    tmp20 = einsum(ints.tmp169, (0, 1, 2, 3), r2.aaa, (0, 1, 4), (2, 3, 4))
    tmp21 = einsum(r2.aaa, (0, 1, 2), v.aaaa.oovv, (3, 1, 4, 2), (0, 3, 4))
    tmp24 = einsum(tmp22, (0, 1, 2), ints.tmp124, (3, 1, 2, 4), (3, 0, 4))
    tmp23 = einsum(v.aabb.ovoo, (0, 1, 2, 3), tmp22, (4, 3, 2), (4, 0, 1))
    tmp28 = einsum(tmp27, (0, 1, 2, 3), r2.aaa, (4, 0, 3), (4, 1, 2)) * -2
    del tmp27
    tmp35 = einsum(tmp31, (0, 1, 2), tmp34, (0, 3, 2, 4), (1, 3, 4)) * 2
    del tmp34
    tmp30 = einsum(tmp29, (0, 1, 2, 3), r2.bab, (1, 4, 3), (4, 0, 2)) * -1
    del tmp29
    tmp19 = einsum(r1.a, (0,), v.aaaa.ooov, (1, 0, 2, 3), (1, 2, 3))
    tmp26 = einsum(tmp25, (0,), v.aaaa.ovov, (1, 2, 3, 0), (1, 3, 2)) * -1
    tmp33 = einsum(tmp32, (0, 1, 2, 3), tmp31, (0, 4, 1), (4, 2, 3)) * 2
    del tmp32
    tmp11 = einsum(r2.bab, (0, 1, 2), v.aabb.ovov, (3, 4, 0, 2), (1, 3, 4)) * -1
    tmp13 = einsum(tmp12, (0,), v.aaaa.ovov, (1, 2, 3, 0), (1, 3, 2))
    tmp8 = einsum(r1.a, (0,), ints.tmp41, (0, 1, 2, 3), (1, 2, 3))
    tmp15 = einsum(r2.aaa, (0, 1, 2), tmp14, (1, 3, 4, 2), (0, 3, 4)) * -1
    del tmp14
    tmp10 = einsum(r2.bab, (0, 1, 2), ints.tmp353, (3, 0, 4, 2), (3, 1, 4)) * -1
    tmp17 = einsum(r2.aaa, (0, 1, 2), tmp16, (1, 3), (0, 3, 2)) * -1
    del tmp16
    tmp9 = einsum(v.aaaa.ovov, (0, 1, 2, 3), r2.aaa, (4, 2, 3), (4, 0, 1))
    tmp93 = np.copy(ints.tmp306)
    tmp93 += ints.tmp333
    tmp93 += np.transpose(v.bbbb.oooo, (0, 2, 3, 1)) * -1
    tmp92 = np.copy(tmp84)
    del tmp84
    tmp92 += tmp85 * 2
    del tmp85
    tmp92 += np.transpose(tmp87, (1, 0, 2))
    del tmp87
    tmp92 += np.transpose(tmp89, (1, 0, 2)) * -2
    del tmp89
    tmp92 += np.transpose(tmp91, (1, 0, 2)) * -2
    del tmp91
    tmp64 = np.copy(np.transpose(ints.tmp186, (1, 0)))
    tmp64 += ints.tmp449 * 2
    tmp64 += ints.tmp451
    tmp64 += f.bb.vv * -1
    tmp64 += ints.tmp184 * -1
    tmp64 += ints.tmp188 * -1
    tmp64 += tmp63
    del tmp63
    tmp83 = np.copy(tmp67)
    del tmp67
    tmp83 += tmp68
    del tmp68
    tmp83 += tmp69
    del tmp69
    tmp83 += tmp70 * 2
    del tmp70
    tmp83 += tmp71 * 2
    del tmp71
    tmp83 += tmp72
    del tmp72
    tmp83 += tmp73 * -1
    del tmp73
    tmp83 += np.transpose(tmp75, (1, 0, 2)) * -1
    del tmp75
    tmp83 += np.transpose(tmp77, (1, 0, 2))
    del tmp77
    tmp83 += tmp79
    del tmp79
    tmp83 += np.transpose(tmp80, (1, 0, 2)) * -1
    del tmp80
    tmp83 += np.transpose(tmp82, (1, 0, 2))
    del tmp82
    tmp58 = np.copy(ints.tmp151)
    tmp58 += ints.tmp174
    tmp58 += np.transpose(ints.tmp176, (1, 0, 2, 3))
    tmp58 += ints.tmp214
    tmp58 += v.aabb.oooo
    tmp4 = np.copy(f.aa.oo)
    tmp4 += ints.tmp155
    tmp4 += ints.tmp156
    tmp4 += np.transpose(ints.tmp1, (1, 0))
    tmp4 += np.transpose(ints.tmp26, (1, 0))
    tmp4 += np.transpose(ints.tmp27, (1, 0))
    tmp4 += ints.tmp47 * 2
    tmp4 += ints.tmp49
    tmp4 += ints.tmp154 * -1
    tmp4 += ints.tmp25 * -1
    tmp61 = np.copy(ints.tmp45)
    tmp61 += v.aabb.ooov
    tmp55 = np.copy(ints.tmp324)
    tmp55 += np.transpose(ints.tmp434, (0, 1, 3, 2)) * 2
    tmp55 += np.transpose(ints.tmp438, (0, 1, 3, 2))
    tmp55 += np.transpose(v.bbbb.ovov, (0, 2, 3, 1))
    tmp55 += ints.tmp425 * -1
    tmp55 += np.transpose(ints.tmp430, (0, 1, 3, 2)) * -2
    tmp55 += v.bbbb.oovv * -1
    tmp66 = np.copy(tmp25)
    del tmp25
    tmp66 += tmp12 * 0.5
    del tmp12
    tmp59 = np.copy(ints.tmp119)
    tmp59 += np.transpose(ints.tmp119, (0, 2, 1, 3)) * -1
    tmp59 += v.bbbb.ooov * -1
    tmp59 += np.transpose(v.bbbb.ooov, (0, 2, 1, 3))
    tmp57 = np.copy(ints.tmp196)
    tmp57 += v.aabb.oovv
    tmp57 += ints.tmp453 * -1
    tmp60 = np.copy(ints.tmp45)
    tmp60 += v.aabb.ooov
    tmp56 = np.copy(ints.tmp426)
    tmp56 += ints.tmp432
    tmp56 += ints.tmp436 * 2
    tmp56 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp56 += ints.tmp428 * -1
    tmp65 = np.copy(f.bb.oo)
    tmp65 += ints.tmp140 * 2
    tmp65 += ints.tmp143
    tmp65 += ints.tmp163
    tmp65 += ints.tmp167
    tmp65 += ints.tmp205
    tmp65 += ints.tmp209
    tmp65 += np.transpose(ints.tmp21, (1, 0))
    tmp65 += ints.tmp161 * -1
    tmp65 += ints.tmp203 * -1
    tmp51 = np.copy(f.aa.oo)
    tmp51 += ints.tmp155
    tmp51 += ints.tmp156
    tmp51 += np.transpose(ints.tmp1, (1, 0))
    tmp51 += ints.tmp26
    tmp51 += ints.tmp27
    tmp51 += ints.tmp47 * 2
    tmp51 += ints.tmp49
    tmp51 += ints.tmp154 * -1
    tmp51 += ints.tmp25 * -1
    tmp46 = np.copy(ints.tmp151)
    tmp46 += np.transpose(ints.tmp174, (0, 1, 3, 2))
    tmp46 += ints.tmp176
    tmp46 += ints.tmp214
    tmp46 += v.aabb.oooo
    tmp42 = np.copy(np.transpose(ints.tmp181, (1, 0)))
    tmp42 += ints.tmp391 * 2
    tmp42 += ints.tmp393
    tmp42 += f.aa.vv * -1
    tmp42 += ints.tmp178 * -1
    tmp42 += ints.tmp190 * -1
    tmp42 += tmp41
    del tmp41
    tmp43 = np.copy(ints.tmp193)
    tmp43 += np.transpose(ints.tmp355, (0, 1, 3, 2)) * 2
    tmp43 += np.transpose(ints.tmp359, (0, 1, 3, 2))
    tmp43 += np.transpose(v.aaaa.ovov, (0, 2, 3, 1))
    tmp43 += ints.tmp346 * -1
    tmp43 += np.transpose(ints.tmp351, (0, 1, 3, 2)) * -2
    tmp43 += v.aaaa.oovv * -1
    tmp45 = np.copy(ints.tmp327)
    tmp45 += np.transpose(v.aabb.vvoo, (2, 3, 0, 1))
    tmp45 += ints.tmp422 * -1
    tmp50 = np.copy(ints.tmp124)
    tmp50 += np.transpose(v.aabb.ovoo, (0, 2, 3, 1))
    tmp44 = np.copy(ints.tmp349)
    tmp44 += ints.tmp357
    tmp44 += ints.tmp361 * 2
    tmp44 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp44 += ints.tmp353 * -1
    tmp48 = np.copy(ints.tmp41) * -1
    tmp48 += np.transpose(ints.tmp41, (0, 2, 1, 3))
    tmp48 += v.aaaa.ooov
    tmp48 += np.transpose(v.aaaa.ooov, (0, 2, 1, 3)) * -1
    tmp7 = np.copy(f.bb.oo)
    tmp7 += ints.tmp140 * 2
    tmp7 += ints.tmp143
    tmp7 += np.transpose(ints.tmp163, (1, 0))
    tmp7 += np.transpose(ints.tmp167, (1, 0))
    tmp7 += ints.tmp205
    tmp7 += ints.tmp209
    tmp7 += np.transpose(ints.tmp21, (1, 0))
    tmp7 += ints.tmp161 * -1
    tmp7 += ints.tmp203 * -1
    tmp39 = np.copy(ints.tmp148)
    tmp39 += ints.tmp211
    tmp39 += np.transpose(v.aaaa.oooo, (0, 2, 3, 1)) * -1
    tmp38 = np.copy(tmp19)
    del tmp19
    tmp38 += tmp20 * 2
    del tmp20
    tmp38 += tmp21 * 2
    del tmp21
    tmp38 += tmp23
    del tmp23
    tmp38 += tmp24 * -1
    del tmp24
    tmp38 += tmp26 * 2
    del tmp26
    tmp38 += np.transpose(tmp28, (1, 0, 2)) * -1
    del tmp28
    tmp38 += np.transpose(tmp30, (1, 0, 2))
    del tmp30
    tmp38 += np.transpose(tmp33, (1, 0, 2))
    del tmp33
    tmp38 += tmp35
    del tmp35
    tmp38 += np.transpose(tmp37, (1, 0, 2))
    del tmp37
    tmp18 = np.copy(tmp8)
    del tmp8
    tmp18 += tmp9 * 2
    del tmp9
    tmp18 += tmp10
    del tmp10
    tmp18 += tmp11
    del tmp11
    tmp18 += tmp13
    del tmp13
    tmp18 += np.transpose(tmp15, (1, 0, 2)) * -2
    del tmp15
    tmp18 += np.transpose(tmp17, (1, 0, 2)) * -2
    del tmp17
    tmp2 = np.copy(ints.tmp120)
    tmp2 += ints.tmp125 * 0.5
    tmp2 += ints.tmp141
    tmp2 += ints.tmp144 * 0.5
    tmp2 += ints.tmp164 * 0.5
    tmp2 += ints.tmp168 * 0.5
    tmp2 += ints.tmp187 * 0.5
    tmp2 += ints.tmp206 * 0.5
    tmp2 += ints.tmp210 * 0.5
    tmp2 += ints.tmp22 * 0.5
    tmp2 += ints.tmp37 * 0.5
    tmp2 += ints.tmp4 * 0.5
    tmp2 += ints.tmp53
    tmp2 += ints.tmp55 * 0.5
    tmp2 += ints.tmp72
    tmp2 += ints.tmp85 * 0.5
    tmp2 += ints.tmp92
    tmp2 += f.bb.ov * -0.5
    tmp2 += ints.tmp100 * -0.5
    tmp2 += ints.tmp103 * -1
    tmp2 += ints.tmp10 * -0.5
    tmp2 += ints.tmp13 * -1
    tmp2 += ints.tmp162 * -0.5
    tmp2 += ints.tmp185 * -0.5
    tmp2 += ints.tmp189 * -0.5
    tmp2 += ints.tmp204 * -0.5
    tmp2 += ints.tmp36 * -0.5
    tmp2 += ints.tmp38 * -0.5
    tmp2 += ints.tmp74 * -0.5
    tmp2 += ints.tmp7 * -0.5
    tmp2 += ints.tmp88 * -0.5
    tmp2 += ints.tmp96 * -1
    tmp3 = np.copy(ints.tmp117)
    tmp3 += ints.tmp122 * 0.5
    tmp3 += ints.tmp138
    tmp3 += ints.tmp146 * 0.5
    tmp3 += ints.tmp159 * 0.5
    tmp3 += ints.tmp165 * 0.5
    tmp3 += ints.tmp182 * 0.5
    tmp3 += ints.tmp19 * 0.5
    tmp3 += ints.tmp201 * 0.5
    tmp3 += ints.tmp207 * 0.5
    tmp3 += ints.tmp2 * 0.5
    tmp3 += ints.tmp34 * 0.5
    tmp3 += ints.tmp51
    tmp3 += ints.tmp57 * 0.5
    tmp3 += ints.tmp70
    tmp3 += ints.tmp83
    tmp3 += ints.tmp90 * 0.5
    tmp3 += f.aa.ov * -0.5
    tmp3 += ints.tmp101 * -0.5
    tmp3 += ints.tmp11 * -0.5
    tmp3 += ints.tmp157 * -0.5
    tmp3 += ints.tmp179 * -0.5
    tmp3 += ints.tmp191 * -0.5
    tmp3 += ints.tmp199 * -0.5
    tmp3 += ints.tmp32 * -0.5
    tmp3 += ints.tmp39 * -0.5
    tmp3 += ints.tmp5 * -0.5
    tmp3 += ints.tmp76 * -0.5
    tmp3 += ints.tmp86 * -1
    tmp3 += ints.tmp8 * -1
    tmp3 += ints.tmp94 * -0.5
    tmp3 += ints.tmp98 * -1
    tmp6 = np.copy(np.transpose(ints.tmp225, (1, 2, 0, 3)))
    tmp6 += np.transpose(ints.tmp230, (1, 2, 0, 3))
    tmp6 += np.transpose(ints.tmp238, (0, 2, 1, 3))
    tmp6 += np.transpose(ints.tmp251, (0, 2, 1, 3)) * 2
    tmp6 += np.transpose(ints.tmp256, (0, 2, 1, 3))
    tmp6 += ints.tmp281
    tmp6 += ints.tmp285
    tmp6 += ints.tmp295 * 2
    tmp6 += ints.tmp307
    tmp6 += ints.tmp315
    tmp6 += ints.tmp334
    tmp6 += ints.tmp119 * -1
    tmp6 += ints.tmp248 * -2
    tmp6 += ints.tmp262 * -1
    tmp6 += ints.tmp277 * -1
    tmp6 += ints.tmp292 * -2
    tmp6 += ints.tmp299 * -1
    tmp6 += np.transpose(ints.tmp317, (0, 2, 1, 3)) * -1
    tmp6 += ints.tmp325 * -1
    tmp6 += np.transpose(v.bbbb.ooov, (0, 2, 1, 3)) * -1
    tmp5 = np.copy(ints.tmp124)
    tmp5 += np.transpose(ints.tmp223, (0, 2, 1, 3))
    tmp5 += np.transpose(ints.tmp240, (0, 2, 1, 3))
    tmp5 += np.transpose(ints.tmp250, (0, 2, 1, 3))
    tmp5 += np.transpose(ints.tmp254, (0, 2, 1, 3)) * 2
    tmp5 += ints.tmp264
    tmp5 += ints.tmp279
    tmp5 += ints.tmp283
    tmp5 += ints.tmp291
    tmp5 += ints.tmp297 * 2
    tmp5 += ints.tmp328
    tmp5 += np.transpose(v.aabb.ovoo, (0, 2, 3, 1))
    tmp5 += np.transpose(ints.tmp232, (0, 2, 1, 3)) * -1
    tmp5 += ints.tmp247 * -1
    tmp5 += ints.tmp253 * -1
    tmp5 += ints.tmp275 * -1
    tmp5 += ints.tmp294 * -1
    tmp5 += ints.tmp301 * -1
    tmp5 += ints.tmp309 * -1
    tmp5 += ints.tmp319 * -1
    tmp5 += np.transpose(ints.tmp320, (0, 2, 1, 3)) * -1
    tmp5 += ints.tmp336 * -1
    tmp0 = np.copy(ints.tmp111)
    tmp0 += ints.tmp115
    tmp0 += ints.tmp129
    tmp0 += ints.tmp135 * 2
    tmp0 += np.transpose(ints.tmp17, (1, 0, 2, 3))
    tmp0 += ints.tmp197
    tmp0 += ints.tmp45
    tmp0 += np.transpose(ints.tmp46, (1, 0, 2, 3))
    tmp0 += np.transpose(ints.tmp64, (1, 0, 2, 3))
    tmp0 += np.transpose(ints.tmp68, (1, 0, 2, 3)) * 2
    tmp0 += ints.tmp80
    tmp0 += v.aabb.ooov
    tmp0 += ints.tmp107 * -1
    tmp0 += ints.tmp132 * -1
    tmp0 += ints.tmp137 * -1
    tmp0 += ints.tmp152 * -1
    tmp0 += ints.tmp175 * -1
    tmp0 += np.transpose(ints.tmp177, (1, 0, 2, 3)) * -1
    tmp0 += ints.tmp215 * -1
    tmp0 += np.transpose(ints.tmp30, (1, 0, 2, 3)) * -1
    tmp0 += ints.tmp61 * -1
    tmp0 += ints.tmp65 * -1
    tmp1 = np.copy(ints.tmp109)
    tmp1 += ints.tmp113
    tmp1 += ints.tmp130 * 2
    tmp1 += ints.tmp149
    tmp1 += np.transpose(ints.tmp15, (1, 2, 0, 3))
    tmp1 += ints.tmp170
    tmp1 += ints.tmp212
    tmp1 += np.transpose(ints.tmp28, (1, 2, 0, 3))
    tmp1 += np.transpose(ints.tmp43, (0, 2, 1, 3))
    tmp1 += np.transpose(ints.tmp62, (0, 2, 1, 3)) * 2
    tmp1 += np.transpose(ints.tmp66, (0, 2, 1, 3))
    tmp1 += ints.tmp105 * -1
    tmp1 += ints.tmp127 * -2
    tmp1 += ints.tmp133 * -1
    tmp1 += np.transpose(ints.tmp172, (0, 2, 1, 3)) * -1
    tmp1 += ints.tmp194 * -1
    tmp1 += ints.tmp41 * -1
    tmp1 += ints.tmp59 * -2
    tmp1 += ints.tmp78 * -1
    tmp1 += np.transpose(v.aaaa.ooov, (0, 2, 1, 3)) * -1
    r2new.bbb = np.copy(tmp83) * -1
    r2new.bbb += np.transpose(tmp83, (1, 0, 2))
    del tmp83
    r2new.bbb += tmp92
    r2new.bbb += np.transpose(tmp92, (1, 0, 2)) * -1
    del tmp92
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp93, (0, 1, 3, 4), (3, 4, 2)) * 2
    del tmp93
    r2new.bbb += einsum(tmp64, (0, 1), r2.bbb, (2, 3, 0), (2, 3, 1)) * -2
    r2new.bbb += einsum(tmp62, (0, 1), r1.b, (2,), (2, 0, 1))
    r2new.bbb += einsum(r1.b, (0,), tmp62, (1, 2), (1, 0, 2)) * -1
    r2new.bab = einsum(r2.bab, (0, 1, 2), tmp55, (0, 3, 4, 2), (3, 1, 4))
    del tmp55
    r2new.bab += einsum(r2.aaa, (0, 1, 2), tmp56, (1, 3, 2, 4), (3, 0, 4)) * -2
    del tmp56
    r2new.bab += einsum(tmp57, (0, 1, 2, 3), r2.bab, (4, 0, 2), (4, 1, 3)) * -1
    del tmp57
    r2new.bab += einsum(tmp58, (0, 1, 2, 3), r2.bab, (2, 0, 4), (3, 1, 4))
    del tmp58
    r2new.bab += einsum(tmp22, (0, 1, 2), tmp59, (1, 3, 2, 4), (3, 0, 4))
    del tmp59
    r2new.bab += einsum(tmp60, (0, 1, 2, 3), tmp22, (0, 4, 2), (4, 1, 3)) * -1
    del tmp22, tmp60
    r2new.bab += einsum(tmp31, (0, 1, 2), tmp61, (0, 2, 3, 4), (3, 1, 4)) * -2
    del tmp31
    r2new.bab += einsum(tmp64, (0, 1), r2.bab, (2, 3, 0), (2, 3, 1)) * -1
    del tmp64
    r2new.bab += einsum(tmp65, (0, 1), r2.bab, (0, 2, 3), (1, 2, 3)) * -1
    del tmp65
    r2new.bab += einsum(tmp4, (0, 1), r2.bab, (2, 0, 3), (2, 1, 3)) * -1
    r2new.bab += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp66, (1,), (2, 0, 3)) * 2
    del tmp66
    r2new.bab += einsum(r1.a, (0,), tmp61, (0, 1, 2, 3), (2, 1, 3))
    del tmp61
    r2new.bab += einsum(r1.a, (0,), tmp62, (1, 2), (1, 0, 2)) * -1
    del tmp62
    r2new.aba = einsum(tmp43, (0, 1, 2, 3), r2.aba, (0, 4, 3), (1, 4, 2))
    del tmp43
    r2new.aba += einsum(tmp44, (0, 1, 2, 3), r2.bbb, (4, 1, 3), (0, 4, 2)) * -2
    del tmp44
    r2new.aba += einsum(tmp45, (0, 1, 2, 3), r2.aba, (4, 0, 2), (4, 1, 3)) * -1
    del tmp45
    r2new.aba += einsum(tmp46, (0, 1, 2, 3), r2.aba, (0, 2, 4), (1, 3, 4))
    del tmp46
    r2new.aba += einsum(tmp47, (0, 1, 2), tmp48, (0, 1, 3, 4), (3, 2, 4)) * -1
    del tmp48
    r2new.aba += einsum(tmp50, (0, 1, 2, 3), tmp49, (1, 4, 2), (0, 4, 3)) * -2
    del tmp49
    r2new.aba += einsum(tmp50, (0, 1, 2, 3), tmp47, (4, 0, 1), (4, 2, 3))
    del tmp47
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp42, (2, 3), (0, 1, 3)) * -1
    r2new.aba += einsum(tmp7, (0, 1), r2.aba, (2, 0, 3), (2, 1, 3)) * -1
    r2new.aba += einsum(tmp51, (0, 1), r2.aba, (0, 2, 3), (1, 2, 3)) * -1
    del tmp51
    r2new.aba += einsum(tmp54, (0,), v.aabb.ovov, (1, 2, 3, 0), (1, 3, 2)) * 2
    del tmp54
    r2new.aba += einsum(r1.b, (0,), tmp50, (1, 0, 2, 3), (1, 2, 3))
    del tmp50
    r2new.aba += einsum(tmp40, (0, 1), r1.b, (2,), (0, 2, 1)) * -1
    r2new.aaa = np.copy(tmp18)
    r2new.aaa += np.transpose(tmp18, (1, 0, 2)) * -1
    del tmp18
    r2new.aaa += tmp38 * -1
    r2new.aaa += np.transpose(tmp38, (1, 0, 2))
    del tmp38
    r2new.aaa += einsum(tmp39, (0, 1, 2, 3), r2.aaa, (1, 0, 4), (2, 3, 4)) * -2
    del tmp39
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp42, (2, 3), (0, 1, 3)) * -2
    del tmp42
    r2new.aaa += einsum(r1.a, (0,), tmp40, (1, 2), (0, 1, 2))
    r2new.aaa += einsum(r1.a, (0,), tmp40, (1, 2), (1, 0, 2)) * -1
    del tmp40
    r1new.b = einsum(tmp5, (0, 1, 2, 3), r2.aba, (0, 1, 3), (2,))
    del tmp5
    r1new.b += einsum(r2.bbb, (0, 1, 2), tmp6, (1, 0, 3, 2), (3,)) * -2
    del tmp6
    r1new.b += einsum(tmp3, (0, 1), r2.aba, (0, 2, 1), (2,)) * 2
    r1new.b += einsum(tmp2, (0, 1), r2.bbb, (2, 0, 1), (2,)) * -4
    r1new.b += einsum(r1.b, (0,), tmp7, (0, 1), (1,)) * -1
    del tmp7
    r1new.a = einsum(r2.bab, (0, 1, 2), tmp0, (1, 3, 0, 2), (3,))
    del tmp0
    r1new.a += einsum(tmp1, (0, 1, 2, 3), r2.aaa, (1, 0, 3), (2,)) * -2
    del tmp1
    r1new.a += einsum(r2.bab, (0, 1, 2), tmp2, (0, 2), (1,)) * 2
    del tmp2
    r1new.a += einsum(tmp3, (0, 1), r2.aaa, (2, 0, 1), (2,)) * -4
    del tmp3
    r1new.a += einsum(r1.a, (0,), tmp4, (0, 1), (1,)) * -1
    del tmp4

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ea_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:55:46.551398.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp10 : array
    tmp100 : array
    tmp101 : array
    tmp103 : array
    tmp11 : array
    tmp111 : array
    tmp112 : array
    tmp114 : array
    tmp115 : array
    tmp117 : array
    tmp118 : array
    tmp120 : array
    tmp121 : array
    tmp123 : array
    tmp125 : array
    tmp127 : array
    tmp128 : array
    tmp13 : array
    tmp130 : array
    tmp131 : array
    tmp133 : array
    tmp134 : array
    tmp136 : array
    tmp137 : array
    tmp139 : array
    tmp141 : array
    tmp142 : array
    tmp144 : array
    tmp145 : array
    tmp147 : array
    tmp149 : array
    tmp150 : array
    tmp151 : array
    tmp153 : array
    tmp154 : array
    tmp156 : array
    tmp157 : array
    tmp158 : array
    tmp159 : array
    tmp160 : array
    tmp161 : array
    tmp163 : array
    tmp164 : array
    tmp169 : array
    tmp171 : array
    tmp173 : array
    tmp174 : array
    tmp175 : array
    tmp176 : array
    tmp177 : array
    tmp178 : array
    tmp179 : array
    tmp181 : array
    tmp183 : array
    tmp185 : array
    tmp186 : array
    tmp187 : array
    tmp188 : array
    tmp19 : array
    tmp190 : array
    tmp191 : array
    tmp193 : array
    tmp194 : array
    tmp195 : array
    tmp196 : array
    tmp197 : array
    tmp198 : array
    tmp2 : array
    tmp20 : array
    tmp200 : array
    tmp201 : array
    tmp22 : array
    tmp226 : array
    tmp228 : array
    tmp23 : array
    tmp230 : array
    tmp232 : array
    tmp238 : array
    tmp240 : array
    tmp246 : array
    tmp247 : array
    tmp249 : array
    tmp250 : array
    tmp252 : array
    tmp254 : array
    tmp256 : array
    tmp26 : array
    tmp27 : array
    tmp276 : array
    tmp278 : array
    tmp28 : array
    tmp284 : array
    tmp285 : array
    tmp287 : array
    tmp288 : array
    tmp29 : array
    tmp290 : array
    tmp292 : array
    tmp294 : array
    tmp305 : array
    tmp307 : array
    tmp309 : array
    tmp31 : array
    tmp310 : array
    tmp33 : array
    tmp34 : array
    tmp35 : array
    tmp36 : array
    tmp4 : array
    tmp43 : array
    tmp45 : array
    tmp47 : array
    tmp49 : array
    tmp5 : array
    tmp51 : array
    tmp53 : array
    tmp55 : array
    tmp57 : array
    tmp59 : array
    tmp61 : array
    tmp63 : array
    tmp65 : array
    tmp67 : array
    tmp69 : array
    tmp7 : array
    tmp71 : array
    tmp73 : array
    tmp74 : array
    tmp76 : array
    tmp77 : array
    tmp79 : array
    tmp8 : array
    tmp81 : array
    tmp82 : array
    tmp83 : array
    tmp85 : array
    tmp86 : array
    tmp88 : array
    tmp89 : array
    tmp90 : array
    tmp92 : array
    tmp94 : array
    tmp96 : array
    tmp98 : array
    """

    tmp35 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp36 = einsum(v.aabb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp33 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp89 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (2, 1), (0, 3))
    tmp29 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 3, 0, 1), (2, 3))
    tmp82 = einsum(t1.aa, (0, 1), v.aaaa.ovov, (2, 1, 0, 3), (2, 3))
    tmp117 = einsum(t1.aa, (0, 1), v.aabb.ovov, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp114 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 2, 1))
    tmp200 = einsum(t1.bb, (0, 1), tmp35, (2, 1), (0, 2))
    tmp197 = einsum(t1.aa, (0, 1), tmp36, (2, 1), (0, 2))
    tmp195 = einsum(t1.bb, (0, 1), tmp33, (2, 1), (0, 2))
    tmp193 = einsum(tmp89, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp190 = einsum(t1.aa, (0, 1), tmp29, (2, 1), (0, 2))
    tmp187 = einsum(tmp82, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp28 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (2, 3), (0, 1))
    tmp177 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp175 = einsum(t1.bb, (0, 1), v.bbbb.ovvv, (0, 2, 3, 1), (2, 3))
    tmp173 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t1.bb, (0, 1), (2, 3))
    tmp27 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (0, 3), (1, 2))
    tmp26 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp163 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t1.aa, (0, 1), (2, 3))
    tmp160 = einsum(t1.bb, (0, 1), v.aabb.ooov, (2, 3, 0, 1), (2, 3))
    tmp158 = einsum(t1.bb, (0, 1), v.bbbb.ooov, (2, 3, 0, 1), (2, 3))
    tmp156 = einsum(t1.bb, (0, 1), v.bbbb.ooov, (2, 0, 3, 1), (2, 3))
    tmp153 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t1.aa, (2, 3), (0, 1))
    tmp150 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t1.aa, (1, 3), (0, 2))
    tmp136 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 3), (4, 0))
    tmp133 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp130 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp127 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (4, 3, 1, 2), (0, 4)) * -1
    tmp120 = einsum(t1.bb, (0, 1), v.aabb.ovov, (2, 3, 4, 1), (2, 0, 4, 3))
    tmp111 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 2, 1))
    tmp22 = einsum(t1.bb, (0, 1), f.bb.ov, (2, 1), (2, 0))
    tmp19 = einsum(t1.aa, (0, 1), f.aa.ov, (2, 1), (2, 0))
    tmp310 = einsum(t1.aa, (0, 1), v.aabb.vvov, (2, 1, 3, 4), (0, 3, 2, 4))
    tmp309 = einsum(t1.aa, (0, 1), v.aabb.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp307 = einsum(t1.bb, (0, 1), v.bbbb.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp305 = einsum(t1.bb, (0, 1), v.bbbb.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp294 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 1, 5), (4, 0, 5, 3))
    tmp292 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 1, 5), (4, 2, 5, 3))
    tmp290 = einsum(t2.aaaa, (0, 1, 2, 3), v.aabb.ovov, (1, 3, 4, 5), (0, 4, 2, 5))
    tmp288 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    tmp287 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp285 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (4, 5, 1, 3), (0, 4, 2, 5))
    tmp284 = einsum(v.bbbb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp278 = einsum(tmp117, (0, 1, 2, 3), t2.abab, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp276 = einsum(t2.bbbb, (0, 1, 2, 3), tmp114, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp256 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 1, 5), (0, 4, 3, 5))
    tmp254 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (0, 4, 1, 5), (4, 5, 2, 3))
    tmp252 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 5, 2, 3))
    tmp250 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (1, 4, 5, 3), (0, 2, 4, 5))
    tmp249 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ovvv, (1, 4, 5, 3), (0, 2, 4, 5))
    tmp247 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovvv, (1, 3, 4, 5), (0, 2, 4, 5))
    tmp246 = einsum(t2.abab, (0, 1, 2, 3), v.bbbb.ovvv, (1, 3, 4, 5), (0, 2, 4, 5))
    tmp240 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp238 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ooov, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp232 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 1, 4), (4, 3))
    tmp230 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbbb.ovov, (0, 4, 1, 3), (2, 4))
    tmp228 = einsum(t1.aa, (0, 1), v.aabb.vvvv, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp226 = einsum(v.bbbb.vvvv, (0, 1, 2, 3), t1.bb, (4, 3), (4, 0, 1, 2))
    tmp201 = einsum(t1.bb, (0, 1), tmp200, (2, 0), (2, 1))
    tmp198 = einsum(t1.aa, (0, 1), tmp197, (2, 0), (2, 1))
    tmp196 = einsum(t1.bb, (0, 1), tmp195, (2, 0), (2, 1))
    tmp194 = einsum(t1.bb, (0, 1), tmp193, (2, 0), (2, 1))
    tmp191 = einsum(tmp190, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp188 = einsum(t1.aa, (0, 1), tmp187, (2, 0), (2, 1))
    tmp186 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t1.bb, (4, 3), (0, 4, 1, 2))
    tmp185 = einsum(v.aabb.vvov, (0, 1, 2, 3), t1.bb, (4, 3), (4, 2, 0, 1))
    tmp183 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (4, 3), (4, 0, 1, 2))
    tmp181 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t1.aa, (4, 1), (4, 0, 2, 3))
    tmp179 = einsum(t1.aa, (0, 1), tmp28, (2, 1), (0, 2))
    tmp178 = einsum(tmp177, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp176 = einsum(t1.bb, (0, 1), tmp175, (1, 2), (0, 2))
    tmp174 = einsum(tmp173, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp171 = einsum(t1.aa, (0, 1), tmp27, (1, 2), (0, 2))
    tmp169 = einsum(t1.aa, (0, 1), tmp26, (2, 1), (0, 2))
    tmp164 = einsum(t1.bb, (0, 1), tmp163, (2, 0), (2, 1))
    tmp161 = einsum(tmp160, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp159 = einsum(t1.bb, (0, 1), tmp158, (2, 0), (2, 1))
    tmp157 = einsum(t1.bb, (0, 1), tmp156, (2, 0), (2, 1))
    tmp154 = einsum(tmp153, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp151 = einsum(tmp150, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp149 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (4, 2, 5, 1))
    tmp147 = einsum(t2.bbbb, (0, 1, 2, 3), v.aabb.ovov, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp145 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp144 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 1, 5), (0, 4, 3, 5))
    tmp142 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 1), (4, 0, 5, 3))
    tmp141 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.abab, (2, 4, 3, 5), (0, 4, 1, 5))
    tmp139 = einsum(v.aaaa.ovov, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (4, 0, 5, 1))
    tmp137 = einsum(t1.aa, (0, 1), tmp136, (2, 0), (2, 1))
    tmp134 = einsum(t1.bb, (0, 1), tmp133, (2, 0), (2, 1))
    tmp131 = einsum(t1.bb, (0, 1), tmp130, (2, 0), (2, 1))
    tmp128 = einsum(tmp127, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp125 = einsum(tmp120, (0, 1, 2, 3), t2.abab, (0, 2, 4, 5), (1, 4, 3, 5))
    tmp123 = einsum(t2.aaaa, (0, 1, 2, 3), tmp111, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp121 = einsum(tmp120, (0, 1, 2, 3), t2.abab, (0, 2, 3, 4), (1, 4))
    tmp118 = einsum(tmp117, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    tmp115 = einsum(tmp114, (0, 1, 2, 3), t2.bbbb, (2, 1, 4, 3), (0, 4))
    tmp112 = einsum(t2.aaaa, (0, 1, 2, 3), tmp111, (4, 1, 0, 3), (4, 2))
    tmp103 = einsum(t2.bbbb, (0, 1, 2, 3), tmp35, (1, 3), (0, 2))
    tmp101 = einsum(t2.abab, (0, 1, 2, 3), tmp35, (1, 3), (0, 2))
    tmp100 = einsum(tmp36, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp98 = einsum(tmp36, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp96 = einsum(t2.bbbb, (0, 1, 2, 3), tmp33, (1, 3), (0, 2))
    tmp94 = einsum(tmp33, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp92 = einsum(tmp89, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp90 = einsum(t2.abab, (0, 1, 2, 3), tmp89, (1, 3), (0, 2))
    tmp88 = einsum(tmp29, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp86 = einsum(tmp29, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp85 = einsum(tmp82, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp83 = einsum(t2.aaaa, (0, 1, 2, 3), tmp82, (1, 3), (0, 2))
    tmp81 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.ovvv, (0, 4, 5, 3), (1, 2, 4, 5))
    tmp79 = einsum(t2.bbbb, (0, 1, 2, 3), v.aabb.vvov, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp77 = einsum(v.aabb.vvov, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 5, 0, 1))
    tmp76 = einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ovvv, (0, 4, 5, 2), (1, 4, 5, 3))
    tmp74 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 5, 1, 2))
    tmp73 = einsum(t2.abab, (0, 1, 2, 3), v.aaaa.ovvv, (0, 2, 4, 5), (1, 4, 5, 3))
    tmp71 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 5, 2, 3))
    tmp69 = einsum(t2.abab, (0, 1, 2, 3), v.aabb.vvov, (4, 2, 1, 3), (0, 4))
    tmp67 = einsum(v.aabb.ovvv, (0, 1, 2, 3), t2.abab, (0, 4, 1, 3), (4, 2))
    tmp65 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), t2.bbbb, (4, 0, 3, 1), (4, 2)) * -1
    tmp63 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), t2.aaaa, (4, 0, 3, 1), (4, 2)) * -1
    tmp61 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 3, 4, 5), (2, 4, 1, 5))
    tmp59 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp57 = einsum(v.aabb.ooov, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    tmp55 = einsum(v.aabb.ovoo, (0, 1, 2, 3), t2.abab, (0, 3, 1, 4), (2, 4))
    tmp53 = einsum(v.bbbb.ooov, (0, 1, 2, 3), t2.bbbb, (1, 2, 4, 3), (0, 4))
    tmp51 = einsum(v.aaaa.ooov, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 3), (0, 4))
    tmp49 = einsum(v.aabb.ovov, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (4, 1))
    tmp47 = einsum(t2.aaaa, (0, 1, 2, 3), v.aaaa.ovov, (0, 3, 1, 4), (2, 4)) * -1
    tmp45 = einsum(t1.bb, (0, 1), v.aabb.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp43 = einsum(t1.aa, (0, 1), v.aaaa.vvvv, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp34 = einsum(v.bbbb.oovv, (0, 1, 2, 3), t1.bb, (1, 3), (0, 2))
    tmp31 = einsum(t1.aa, (0, 1), v.aaaa.oovv, (2, 0, 3, 1), (2, 3))
    tmp23 = einsum(t1.bb, (0, 1), tmp22, (0, 2), (2, 1))
    tmp20 = einsum(t1.aa, (0, 1), tmp19, (0, 2), (2, 1))
    tmp13 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp11 = einsum(f.bb.ov, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp10 = einsum(f.aa.ov, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp8 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp7 = einsum(f.bb.vv, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp5 = einsum(t1.aa, (0, 1), f.aa.vv, (2, 1), (0, 2))
    tmp4 = einsum(t1.bb, (0, 1), f.bb.oo, (2, 0), (2, 1))
    tmp2 = einsum(f.aa.oo, (0, 1), t1.aa, (1, 2), (0, 2))

    return {f"tmp10": tmp10, f"tmp100": tmp100, f"tmp101": tmp101, f"tmp103": tmp103, f"tmp11": tmp11, f"tmp111": tmp111, f"tmp112": tmp112, f"tmp114": tmp114, f"tmp115": tmp115, f"tmp117": tmp117, f"tmp118": tmp118, f"tmp120": tmp120, f"tmp121": tmp121, f"tmp123": tmp123, f"tmp125": tmp125, f"tmp127": tmp127, f"tmp128": tmp128, f"tmp13": tmp13, f"tmp130": tmp130, f"tmp131": tmp131, f"tmp133": tmp133, f"tmp134": tmp134, f"tmp136": tmp136, f"tmp137": tmp137, f"tmp139": tmp139, f"tmp141": tmp141, f"tmp142": tmp142, f"tmp144": tmp144, f"tmp145": tmp145, f"tmp147": tmp147, f"tmp149": tmp149, f"tmp150": tmp150, f"tmp151": tmp151, f"tmp153": tmp153, f"tmp154": tmp154, f"tmp156": tmp156, f"tmp157": tmp157, f"tmp158": tmp158, f"tmp159": tmp159, f"tmp160": tmp160, f"tmp161": tmp161, f"tmp163": tmp163, f"tmp164": tmp164, f"tmp169": tmp169, f"tmp171": tmp171, f"tmp173": tmp173, f"tmp174": tmp174, f"tmp175": tmp175, f"tmp176": tmp176, f"tmp177": tmp177, f"tmp178": tmp178, f"tmp179": tmp179, f"tmp181": tmp181, f"tmp183": tmp183, f"tmp185": tmp185, f"tmp186": tmp186, f"tmp187": tmp187, f"tmp188": tmp188, f"tmp19": tmp19, f"tmp190": tmp190, f"tmp191": tmp191, f"tmp193": tmp193, f"tmp194": tmp194, f"tmp195": tmp195, f"tmp196": tmp196, f"tmp197": tmp197, f"tmp198": tmp198, f"tmp2": tmp2, f"tmp20": tmp20, f"tmp200": tmp200, f"tmp201": tmp201, f"tmp22": tmp22, f"tmp226": tmp226, f"tmp228": tmp228, f"tmp23": tmp23, f"tmp230": tmp230, f"tmp232": tmp232, f"tmp238": tmp238, f"tmp240": tmp240, f"tmp246": tmp246, f"tmp247": tmp247, f"tmp249": tmp249, f"tmp250": tmp250, f"tmp252": tmp252, f"tmp254": tmp254, f"tmp256": tmp256, f"tmp26": tmp26, f"tmp27": tmp27, f"tmp276": tmp276, f"tmp278": tmp278, f"tmp28": tmp28, f"tmp284": tmp284, f"tmp285": tmp285, f"tmp287": tmp287, f"tmp288": tmp288, f"tmp29": tmp29, f"tmp290": tmp290, f"tmp292": tmp292, f"tmp294": tmp294, f"tmp305": tmp305, f"tmp307": tmp307, f"tmp309": tmp309, f"tmp31": tmp31, f"tmp310": tmp310, f"tmp33": tmp33, f"tmp34": tmp34, f"tmp35": tmp35, f"tmp36": tmp36, f"tmp4": tmp4, f"tmp43": tmp43, f"tmp45": tmp45, f"tmp47": tmp47, f"tmp49": tmp49, f"tmp5": tmp5, f"tmp51": tmp51, f"tmp53": tmp53, f"tmp55": tmp55, f"tmp57": tmp57, f"tmp59": tmp59, f"tmp61": tmp61, f"tmp63": tmp63, f"tmp65": tmp65, f"tmp67": tmp67, f"tmp69": tmp69, f"tmp7": tmp7, f"tmp71": tmp71, f"tmp73": tmp73, f"tmp74": tmp74, f"tmp76": tmp76, f"tmp77": tmp77, f"tmp79": tmp79, f"tmp8": tmp8, f"tmp81": tmp81, f"tmp82": tmp82, f"tmp83": tmp83, f"tmp85": tmp85, f"tmp86": tmp86, f"tmp88": tmp88, f"tmp89": tmp89, f"tmp90": tmp90, f"tmp92": tmp92, f"tmp94": tmp94, f"tmp96": tmp96, f"tmp98": tmp98}

def hbar_lmatvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:55:46.717104.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp94 = np.copy(ints.tmp114) * -1
    tmp94 += np.transpose(ints.tmp114, (0, 2, 1, 3))
    tmp118 = np.copy(f.bb.ov)
    tmp118 += ints.tmp33
    tmp118 += ints.tmp35
    tmp62 = np.copy(f.aa.ov)
    tmp62 += ints.tmp29
    tmp62 += ints.tmp36
    tmp44 = np.copy(ints.tmp111)
    tmp44 += np.transpose(ints.tmp111, (0, 2, 1, 3)) * -1
    tmp105 = einsum(t1.aa, (0, 1), ints.tmp117, (2, 0, 3, 4), (2, 3, 1, 4))
    tmp36 = einsum(t2.bbbb, (0, 1, 2, 3), r2.bbb, (2, 3, 1), (0,))
    tmp35 = einsum(t2.abab, (0, 1, 2, 3), r2.aba, (2, 3, 0), (1,))
    tmp108 = einsum(t1.aa, (0, 1), v.aabb.ooov, (2, 0, 3, 4), (2, 3, 1, 4))
    tmp95 = einsum(t1.bb, (0, 1), tmp94, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp94
    tmp100 = einsum(ints.tmp89, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp119 = einsum(tmp118, (0, 1), t1.bb, (0, 2), (2, 1))
    del tmp118
    tmp17 = einsum(r2.bab, (0, 1, 2), t2.abab, (3, 2, 1, 0), (3,)) * -1
    tmp15 = einsum(t1.aa, (0, 1), r1.a, (1,), (0,))
    tmp63 = einsum(t1.aa, (0, 1), tmp62, (0, 2), (1, 2))
    del tmp62
    tmp48 = einsum(t1.bb, (0, 1), ints.tmp120, (2, 3, 0, 4), (2, 3, 4, 1))
    tmp53 = einsum(ints.tmp82, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp45 = einsum(t1.aa, (0, 1), tmp44, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp44
    tmp22 = einsum(r2.bbb, (0, 1, 2), t1.bb, (3, 1), (2, 3, 0))
    tmp106 = np.copy(ints.tmp287)
    tmp106 += tmp105
    del tmp105
    tmp103 = np.copy(tmp35) * -0.5
    tmp103 += tmp36
    tmp109 = np.copy(np.transpose(v.aabb.ovov, (0, 2, 1, 3)))
    tmp109 += tmp108 * -1
    del tmp108
    tmp96 = np.copy(ints.tmp285) * 2
    tmp96 += ints.tmp292
    tmp96 += np.transpose(ints.tmp307, (0, 1, 3, 2))
    tmp96 += tmp95 * -1
    del tmp95
    tmp101 = np.copy(f.bb.vv) * 0.5
    tmp101 += ints.tmp173 * 0.5
    tmp101 += ints.tmp177 * 0.5
    tmp101 += ints.tmp230 * -1
    tmp101 += ints.tmp232 * -0.5
    tmp101 += np.transpose(tmp100, (1, 0)) * 0.5
    del tmp100
    tmp98 = np.copy(v.bbbb.ooov)
    tmp98 += np.transpose(v.bbbb.ooov, (0, 2, 1, 3)) * -1
    tmp120 = np.copy(ints.tmp175)
    tmp120 += np.transpose(tmp119, (1, 0))
    del tmp119
    tmp116 = np.copy(np.transpose(ints.tmp305, (0, 1, 3, 2)))
    tmp116 += ints.tmp288 * 2
    tmp114 = np.copy(ints.tmp284)
    tmp114 += ints.tmp310
    tmp114 += ints.tmp290 * 2
    tmp34 = einsum(r1.b, (0,), t1.bb, (1, 0), (1,))
    tmp19 = np.copy(f.aa.ov)
    tmp19 += ints.tmp29
    tmp19 += ints.tmp36
    tmp19 += ints.tmp82 * -1
    tmp66 = np.copy(tmp15)
    tmp66 += tmp17
    tmp60 = np.copy(np.transpose(ints.tmp181, (0, 1, 3, 2)))
    tmp60 += ints.tmp142 * 2
    tmp64 = np.copy(ints.tmp27)
    tmp64 += np.transpose(tmp63, (1, 0))
    del tmp63
    tmp2 = einsum(t1.aa, (0, 1), r2.aaa, (2, 1, 3), (3, 0, 2))
    tmp16 = einsum(t2.aaaa, (0, 1, 2, 3), r2.aaa, (2, 3, 1), (0,))
    tmp6 = einsum(t1.bb, (0, 1), r2.bab, (1, 2, 3), (3, 0, 2)) * -1
    tmp49 = np.copy(ints.tmp141) * 0.5
    tmp49 += ints.tmp147
    tmp49 += ints.tmp186 * 0.5
    tmp49 += tmp48 * -0.5
    del tmp48
    tmp54 = np.copy(f.aa.vv) * 0.5
    tmp54 += ints.tmp26 * 0.5
    tmp54 += ints.tmp28 * 0.5
    tmp54 += ints.tmp47 * -1
    tmp54 += ints.tmp49 * -0.5
    tmp54 += np.transpose(tmp53, (1, 0)) * 0.5
    del tmp53
    tmp51 = np.copy(v.aaaa.ooov) * -1
    tmp51 += np.transpose(v.aaaa.ooov, (0, 2, 1, 3))
    tmp46 = np.copy(ints.tmp139) * 2
    tmp46 += ints.tmp145
    tmp46 += np.transpose(ints.tmp183, (0, 1, 3, 2))
    tmp46 += tmp45 * -1
    del tmp45
    tmp93 = einsum(tmp22, (0, 1, 2), v.bbbb.ovvv, (1, 3, 4, 2), (0, 3, 4)) * -1
    tmp107 = einsum(tmp106, (0, 1, 2, 3), r2.aba, (2, 4, 0), (1, 4, 3))
    del tmp106
    tmp104 = einsum(tmp103, (0,), v.bbbb.ovov, (1, 2, 0, 3), (1, 3, 2)) * 2
    del tmp103
    tmp110 = einsum(tmp109, (0, 1, 2, 3), r2.aba, (2, 4, 0), (1, 4, 3))
    del tmp109
    tmp92 = einsum(r2.bbb, (0, 1, 2), v.bbbb.oovv, (3, 2, 4, 1), (3, 0, 4))
    tmp91 = einsum(v.bbbb.ovvv, (0, 1, 2, 3), r1.b, (3,), (0, 1, 2))
    tmp97 = einsum(r2.bbb, (0, 1, 2), tmp96, (2, 3, 1, 4), (3, 0, 4)) * -2
    del tmp96
    tmp102 = einsum(r2.bbb, (0, 1, 2), tmp101, (1, 3), (2, 0, 3)) * -4
    del tmp101
    tmp99 = einsum(tmp22, (0, 1, 2), tmp98, (0, 3, 1, 4), (3, 2, 4)) * 2
    del tmp98
    tmp123 = np.copy(t2.bbbb)
    tmp123 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    tmp121 = einsum(tmp120, (0, 1), r2.bbb, (2, 1, 3), (3, 2, 0)) * -1
    del tmp120
    tmp117 = einsum(r2.bbb, (0, 1, 2), tmp116, (2, 3, 1, 4), (3, 0, 4)) * -1
    del tmp116
    tmp115 = einsum(tmp114, (0, 1, 2, 3), r2.aba, (2, 4, 0), (1, 4, 3))
    del tmp114
    tmp112 = einsum(r2.bbb, (0, 1, 2), v.bbbb.ovov, (3, 4, 2, 1), (3, 0, 4))
    tmp113 = einsum(tmp34, (0,), v.bbbb.ovov, (1, 2, 0, 3), (1, 2, 3))
    tmp80 = einsum(tmp19, (0, 1), t1.aa, (0, 2), (2, 1))
    tmp30 = np.copy(ints.tmp117)
    tmp30 += v.aabb.ooov
    tmp74 = np.copy(ints.tmp120)
    tmp74 += np.transpose(v.aabb.ovoo, (0, 2, 3, 1))
    tmp38 = np.copy(f.bb.ov)
    tmp38 += ints.tmp33
    tmp38 += ints.tmp35
    tmp38 += ints.tmp89 * -1
    tmp82 = np.copy(ints.tmp114) * -1
    tmp82 += np.transpose(ints.tmp114, (0, 2, 1, 3))
    tmp82 += v.bbbb.ooov
    tmp82 += np.transpose(v.bbbb.ooov, (0, 2, 1, 3)) * -1
    tmp86 = np.copy(t2.abab)
    tmp86 += einsum(t1.aa, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    tmp72 = np.copy(ints.tmp111)
    tmp72 += np.transpose(ints.tmp111, (0, 2, 1, 3)) * -1
    tmp72 += v.aaaa.ooov * -1
    tmp72 += np.transpose(v.aaaa.ooov, (0, 2, 1, 3))
    tmp77 = np.copy(t2.abab)
    tmp77 += einsum(t1.aa, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    tmp58 = einsum(r2.bab, (0, 1, 2), ints.tmp144, (3, 2, 4, 0), (3, 4, 1)) * -1
    tmp67 = einsum(tmp66, (0,), v.aaaa.ovov, (1, 2, 0, 3), (1, 3, 2))
    del tmp66
    tmp61 = einsum(tmp60, (0, 1, 2, 3), r2.aaa, (4, 2, 0), (1, 4, 3)) * -1
    del tmp60
    tmp59 = einsum(v.aabb.ovov, (0, 1, 2, 3), r2.bab, (3, 4, 2), (0, 4, 1)) * -1
    tmp57 = einsum(r2.aaa, (0, 1, 2), v.aaaa.ovov, (3, 4, 2, 1), (3, 0, 4))
    tmp65 = einsum(r2.aaa, (0, 1, 2), tmp64, (3, 1), (2, 0, 3)) * -1
    del tmp64
    tmp69 = np.copy(t2.aaaa)
    tmp69 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    tmp41 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), tmp2, (4, 0, 3), (4, 1, 2)) * -1
    tmp39 = einsum(v.aaaa.ovvv, (0, 1, 2, 3), r1.a, (3,), (0, 1, 2))
    tmp43 = einsum(tmp16, (0,), v.aaaa.ovov, (1, 2, 0, 3), (1, 2, 3)) * -1
    tmp42 = einsum(tmp6, (0, 1, 2), v.aabb.ovoo, (3, 4, 1, 0), (3, 2, 4))
    tmp50 = einsum(r2.bab, (0, 1, 2), tmp49, (3, 2, 4, 0), (3, 1, 4)) * -2
    del tmp49
    tmp40 = einsum(v.aaaa.oovv, (0, 1, 2, 3), r2.aaa, (4, 3, 1), (0, 4, 2))
    tmp55 = einsum(r2.aaa, (0, 1, 2), tmp54, (1, 3), (2, 0, 3)) * -4
    del tmp54
    tmp52 = einsum(tmp2, (0, 1, 2), tmp51, (0, 1, 3, 4), (3, 2, 4)) * 2
    del tmp51
    tmp47 = einsum(tmp46, (0, 1, 2, 3), r2.aaa, (4, 2, 0), (1, 4, 3)) * -2
    del tmp46
    tmp26 = einsum(t1.aa, (0, 1), r2.aba, (1, 2, 3), (3, 0, 2))
    tmp111 = np.copy(tmp91)
    del tmp91
    tmp111 += tmp92 * 2
    del tmp92
    tmp111 += tmp93 * 2
    del tmp93
    tmp111 += np.transpose(tmp97, (0, 2, 1)) * -1
    del tmp97
    tmp111 += tmp99 * -1
    del tmp99
    tmp111 += np.transpose(tmp102, (0, 2, 1)) * -1
    del tmp102
    tmp111 += np.transpose(tmp104, (0, 2, 1)) * -1
    del tmp104
    tmp111 += np.transpose(tmp107, (0, 2, 1))
    del tmp107
    tmp111 += tmp110
    del tmp110
    tmp124 = einsum(tmp123, (0, 1, 2, 3), r2.bbb, (2, 3, 4), (4, 1, 0)) * -1
    del tmp123
    tmp122 = np.copy(tmp112) * 2
    del tmp112
    tmp122 += tmp113
    del tmp113
    tmp122 += np.transpose(tmp115, (0, 2, 1))
    del tmp115
    tmp122 += np.transpose(tmp117, (0, 2, 1)) * -2
    del tmp117
    tmp122 += np.transpose(tmp121, (0, 2, 1)) * -2
    del tmp121
    tmp90 = np.copy(f.bb.oo)
    tmp90 += ints.tmp130 * 2
    tmp90 += ints.tmp133
    tmp90 += ints.tmp158
    tmp90 += ints.tmp163
    tmp90 += ints.tmp195
    tmp90 += ints.tmp200
    tmp90 += np.transpose(ints.tmp22, (1, 0))
    tmp90 += ints.tmp156 * -1
    tmp90 += ints.tmp193 * -1
    tmp88 = np.copy(np.transpose(ints.tmp27, (1, 0)))
    tmp88 += ints.tmp47 * 2
    tmp88 += ints.tmp49
    tmp88 += f.aa.vv * -1
    tmp88 += np.transpose(ints.tmp26, (1, 0)) * -1
    tmp88 += np.transpose(ints.tmp28, (1, 0)) * -1
    tmp88 += tmp80
    tmp4 = einsum(r2.bab, (0, 1, 2), t1.aa, (3, 1), (3, 2, 0)) * -1
    tmp18 = np.copy(tmp15) * 0.5
    del tmp15
    tmp18 += tmp16
    del tmp16
    tmp18 += tmp17 * 0.5
    del tmp17
    tmp84 = np.copy(ints.tmp284)
    tmp84 += ints.tmp290 * 2
    tmp84 += ints.tmp310
    tmp84 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp84 += ints.tmp287 * -1
    tmp84 += einsum(t1.aa, (0, 1), tmp30, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    tmp85 = np.copy(ints.tmp149)
    tmp85 += np.transpose(ints.tmp185, (0, 1, 3, 2)) * -1
    tmp85 += np.transpose(v.aabb.vvoo, (2, 3, 0, 1)) * -1
    tmp85 += einsum(tmp74, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    tmp89 = np.copy(np.transpose(ints.tmp175, (1, 0))) * 0.5
    tmp89 += ints.tmp230
    tmp89 += ints.tmp232 * 0.5
    tmp89 += f.bb.vv * -0.5
    tmp89 += ints.tmp173 * -0.5
    tmp89 += ints.tmp177 * -0.5
    tmp89 += einsum(t1.bb, (0, 1), tmp38, (0, 2), (1, 2)) * 0.5
    tmp83 = np.copy(ints.tmp285) * 2
    tmp83 += ints.tmp292
    tmp83 += np.transpose(ints.tmp307, (0, 1, 3, 2))
    tmp83 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    tmp83 += ints.tmp288 * -2
    tmp83 += np.transpose(ints.tmp305, (0, 1, 3, 2)) * -1
    tmp83 += v.bbbb.oovv * -1
    tmp83 += einsum(t1.bb, (0, 1), tmp82, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp82
    tmp87 = einsum(tmp86, (0, 1, 2, 3), r2.bab, (3, 2, 4), (0, 4, 1)) * -1
    del tmp86
    tmp37 = np.copy(tmp34)
    del tmp34
    tmp37 += tmp35 * -1
    del tmp35
    tmp37 += tmp36 * 2
    del tmp36
    tmp76 = np.copy(ints.tmp294)
    tmp76 += np.transpose(ints.tmp309, (0, 1, 3, 2)) * -1
    tmp76 += v.aabb.oovv * -1
    tmp76 += einsum(t1.bb, (0, 1), tmp30, (2, 3, 0, 4), (2, 3, 1, 4))
    tmp73 = np.copy(ints.tmp139) * 2
    tmp73 += ints.tmp145
    tmp73 += np.transpose(ints.tmp183, (0, 1, 3, 2))
    tmp73 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp73 += ints.tmp142 * -2
    tmp73 += np.transpose(ints.tmp181, (0, 1, 3, 2)) * -1
    tmp73 += v.aaaa.oovv * -1
    tmp73 += einsum(tmp72, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3)) * -1
    del tmp72
    tmp24 = einsum(t1.bb, (0, 1), r2.aba, (2, 1, 3), (3, 0, 2))
    tmp79 = np.copy(np.transpose(ints.tmp175, (1, 0)))
    tmp79 += ints.tmp230 * 2
    tmp79 += ints.tmp232
    tmp79 += f.bb.vv * -1
    tmp79 += np.transpose(ints.tmp173, (1, 0)) * -1
    tmp79 += np.transpose(ints.tmp177, (1, 0)) * -1
    tmp79 += einsum(t1.bb, (0, 1), tmp38, (0, 2), (1, 2))
    tmp81 = np.copy(np.transpose(ints.tmp27, (1, 0)))
    tmp81 += ints.tmp47 * 2
    tmp81 += ints.tmp49
    tmp81 += f.aa.vv * -1
    tmp81 += ints.tmp26 * -1
    tmp81 += ints.tmp28 * -1
    tmp81 += tmp80
    del tmp80
    tmp78 = einsum(tmp77, (0, 1, 2, 3), r2.aba, (2, 3, 4), (4, 0, 1))
    del tmp77
    tmp71 = np.copy(f.aa.oo)
    tmp71 += ints.tmp127 * 2
    tmp71 += ints.tmp136
    tmp71 += ints.tmp153
    tmp71 += ints.tmp160
    tmp71 += ints.tmp190
    tmp71 += ints.tmp197
    tmp71 += np.transpose(ints.tmp19, (1, 0))
    tmp71 += ints.tmp150 * -1
    tmp71 += ints.tmp187 * -1
    tmp75 = np.copy(ints.tmp141)
    tmp75 += ints.tmp147 * 2
    tmp75 += ints.tmp186
    tmp75 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp75 += ints.tmp144 * -1
    tmp75 += einsum(t1.bb, (0, 1), tmp74, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    del tmp74
    tmp68 = np.copy(tmp57) * 2
    del tmp57
    tmp68 += tmp58
    del tmp58
    tmp68 += tmp59
    del tmp59
    tmp68 += np.transpose(tmp61, (0, 2, 1)) * -2
    del tmp61
    tmp68 += np.transpose(tmp65, (0, 2, 1)) * -2
    del tmp65
    tmp68 += np.transpose(tmp67, (0, 2, 1))
    del tmp67
    tmp70 = einsum(tmp69, (0, 1, 2, 3), r2.aaa, (2, 3, 4), (4, 1, 0)) * -1
    del tmp69
    tmp56 = np.copy(tmp39)
    del tmp39
    tmp56 += tmp40 * 2
    del tmp40
    tmp56 += tmp41 * 2
    del tmp41
    tmp56 += tmp42
    del tmp42
    tmp56 += tmp43 * 2
    del tmp43
    tmp56 += np.transpose(tmp47, (0, 2, 1)) * -1
    del tmp47
    tmp56 += np.transpose(tmp50, (0, 2, 1))
    del tmp50
    tmp56 += tmp52 * -1
    del tmp52
    tmp56 += np.transpose(tmp55, (0, 2, 1)) * -1
    del tmp55
    tmp33 = np.copy(np.transpose(ints.tmp175, (1, 0)))
    tmp33 += ints.tmp230 * 2
    tmp33 += ints.tmp232
    tmp33 += f.bb.vv * -1
    tmp33 += np.transpose(ints.tmp173, (1, 0)) * -1
    tmp33 += np.transpose(ints.tmp177, (1, 0)) * -1
    tmp31 = einsum(t1.bb, (0, 1), tmp22, (2, 3, 1), (2, 3, 0)) * -1
    tmp29 = einsum(tmp26, (0, 1, 2), t1.bb, (3, 2), (0, 1, 3))
    tmp28 = np.copy(ints.tmp112)
    tmp28 += ints.tmp118 * 0.5
    tmp28 += ints.tmp128
    tmp28 += ints.tmp137 * 0.5
    tmp28 += ints.tmp154 * 0.5
    tmp28 += ints.tmp161 * 0.5
    tmp28 += ints.tmp171 * 0.5
    tmp28 += ints.tmp191 * 0.5
    tmp28 += ints.tmp198 * 0.5
    tmp28 += ints.tmp20 * 0.5
    tmp28 += ints.tmp2 * 0.5
    tmp28 += ints.tmp31 * 0.5
    tmp28 += ints.tmp51
    tmp28 += ints.tmp57 * 0.5
    tmp28 += ints.tmp63
    tmp28 += ints.tmp83
    tmp28 += ints.tmp90 * 0.5
    tmp28 += f.aa.ov * -0.5
    tmp28 += ints.tmp101 * -0.5
    tmp28 += ints.tmp11 * -0.5
    tmp28 += ints.tmp151 * -0.5
    tmp28 += ints.tmp169 * -0.5
    tmp28 += ints.tmp179 * -0.5
    tmp28 += ints.tmp188 * -0.5
    tmp28 += ints.tmp29 * -0.5
    tmp28 += ints.tmp36 * -0.5
    tmp28 += ints.tmp5 * -0.5
    tmp28 += ints.tmp69 * -0.5
    tmp28 += ints.tmp86 * -1
    tmp28 += ints.tmp8 * -1
    tmp28 += ints.tmp94 * -0.5
    tmp28 += ints.tmp98 * -1
    tmp9 = np.copy(ints.tmp115) * 2
    tmp9 += ints.tmp121
    tmp9 += ints.tmp131 * 2
    tmp9 += ints.tmp134
    tmp9 += ints.tmp159
    tmp9 += ints.tmp164
    tmp9 += ints.tmp176
    tmp9 += ints.tmp196
    tmp9 += ints.tmp201
    tmp9 += ints.tmp23
    tmp9 += ints.tmp34
    tmp9 += ints.tmp4
    tmp9 += ints.tmp53 * 2
    tmp9 += ints.tmp55
    tmp9 += ints.tmp65 * 2
    tmp9 += ints.tmp85
    tmp9 += ints.tmp92 * 2
    tmp9 += f.bb.ov * -1
    tmp9 += ints.tmp100 * -1
    tmp9 += ints.tmp103 * -2
    tmp9 += ints.tmp10 * -1
    tmp9 += ints.tmp13 * -2
    tmp9 += ints.tmp157 * -1
    tmp9 += ints.tmp174 * -1
    tmp9 += ints.tmp178 * -1
    tmp9 += ints.tmp194 * -1
    tmp9 += ints.tmp33 * -1
    tmp9 += ints.tmp35 * -1
    tmp9 += ints.tmp67 * -1
    tmp9 += ints.tmp7 * -1
    tmp9 += ints.tmp88 * -1
    tmp9 += ints.tmp96 * -2
    tmp25 = np.copy(ints.tmp284)
    tmp25 += ints.tmp290 * 2
    tmp25 += ints.tmp310
    tmp25 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp25 += ints.tmp287 * -1
    tmp23 = np.copy(ints.tmp285) * 2
    tmp23 += ints.tmp292
    tmp23 += np.transpose(ints.tmp307, (0, 1, 3, 2))
    tmp23 += np.transpose(v.bbbb.ovov, (0, 2, 1, 3))
    tmp23 += ints.tmp288 * -2
    tmp23 += np.transpose(ints.tmp305, (0, 1, 3, 2)) * -1
    tmp23 += v.bbbb.oovv * -1
    tmp27 = np.copy(np.transpose(ints.tmp309, (0, 1, 3, 2)))
    tmp27 += v.aabb.oovv
    tmp27 += ints.tmp294 * -1
    tmp32 = np.copy(ints.tmp114)
    tmp32 += v.bbbb.ooov * -1
    tmp21 = np.copy(np.transpose(ints.tmp238, (0, 3, 1, 2))) * 0.5
    tmp21 += np.transpose(ints.tmp247, (0, 2, 1, 3))
    tmp21 += np.transpose(ints.tmp254, (0, 2, 1, 3)) * 0.5
    tmp21 += np.transpose(v.bbbb.ovvv, (0, 2, 1, 3)) * 0.5
    tmp21 += ints.tmp226 * -0.5
    tmp21 += np.transpose(ints.tmp250, (0, 2, 1, 3)) * -1
    tmp21 += np.transpose(ints.tmp276, (0, 3, 1, 2)) * -0.5
    tmp20 = np.copy(ints.tmp228)
    tmp20 += np.transpose(ints.tmp240, (0, 1, 3, 2))
    tmp20 += ints.tmp246
    tmp20 += ints.tmp252 * 2
    tmp20 += np.transpose(ints.tmp278, (0, 1, 3, 2))
    tmp20 += v.aabb.ovvv
    tmp20 += ints.tmp249 * -1
    tmp20 += np.transpose(ints.tmp256, (0, 1, 3, 2)) * -1
    tmp3 = np.copy(ints.tmp139) * 2
    tmp3 += ints.tmp145
    tmp3 += np.transpose(ints.tmp183, (0, 1, 3, 2))
    tmp3 += np.transpose(v.aaaa.ovov, (0, 2, 1, 3))
    tmp3 += ints.tmp142 * -2
    tmp3 += np.transpose(ints.tmp181, (0, 1, 3, 2)) * -1
    tmp3 += v.aaaa.oovv * -1
    tmp7 = np.copy(np.transpose(ints.tmp185, (0, 1, 3, 2)))
    tmp7 += np.transpose(v.aabb.vvoo, (2, 3, 0, 1))
    tmp7 += ints.tmp149 * -1
    tmp0 = np.copy(ints.tmp125)
    tmp0 += np.transpose(ints.tmp45, (0, 2, 1, 3))
    tmp0 += ints.tmp61
    tmp0 += np.transpose(ints.tmp73, (0, 2, 1, 3))
    tmp0 += np.transpose(ints.tmp79, (0, 2, 1, 3)) * 2
    tmp0 += np.transpose(v.aabb.vvov, (2, 0, 1, 3))
    tmp0 += np.transpose(ints.tmp76, (0, 2, 1, 3)) * -1
    tmp0 += ints.tmp81 * -1
    tmp12 = einsum(tmp2, (0, 1, 2), t1.aa, (3, 2), (0, 1, 3)) * -1
    tmp5 = np.copy(ints.tmp141)
    tmp5 += ints.tmp147 * 2
    tmp5 += ints.tmp186
    tmp5 += np.transpose(v.aabb.ovov, (0, 2, 1, 3))
    tmp5 += ints.tmp144 * -1
    tmp13 = np.copy(ints.tmp111)
    tmp13 += v.aaaa.ooov * -1
    tmp8 = np.copy(ints.tmp112) * 2
    tmp8 += ints.tmp118
    tmp8 += ints.tmp128 * 2
    tmp8 += ints.tmp137
    tmp8 += ints.tmp154
    tmp8 += ints.tmp161
    tmp8 += ints.tmp171
    tmp8 += ints.tmp191
    tmp8 += ints.tmp198
    tmp8 += ints.tmp20
    tmp8 += ints.tmp2
    tmp8 += ints.tmp31
    tmp8 += ints.tmp51 * 2
    tmp8 += ints.tmp57
    tmp8 += ints.tmp63 * 2
    tmp8 += ints.tmp83 * 2
    tmp8 += ints.tmp90
    tmp8 += f.aa.ov * -1
    tmp8 += ints.tmp101 * -1
    tmp8 += ints.tmp11 * -1
    tmp8 += ints.tmp151 * -1
    tmp8 += ints.tmp169 * -1
    tmp8 += ints.tmp179 * -1
    tmp8 += ints.tmp188 * -1
    tmp8 += ints.tmp29 * -1
    tmp8 += ints.tmp36 * -1
    tmp8 += ints.tmp5 * -1
    tmp8 += ints.tmp69 * -1
    tmp8 += ints.tmp86 * -2
    tmp8 += ints.tmp8 * -2
    tmp8 += ints.tmp94 * -1
    tmp8 += ints.tmp98 * -2
    tmp11 = np.copy(ints.tmp120)
    tmp11 += np.transpose(v.aabb.ovoo, (0, 2, 3, 1))
    tmp1 = np.copy(ints.tmp59) * 0.5
    tmp1 += np.transpose(ints.tmp71, (0, 1, 3, 2))
    tmp1 += np.transpose(ints.tmp77, (0, 1, 3, 2)) * 0.5
    tmp1 += v.aaaa.ovvv * 0.5
    tmp1 += ints.tmp123 * -0.5
    tmp1 += np.transpose(ints.tmp43, (0, 2, 3, 1)) * -0.5
    tmp1 += np.transpose(ints.tmp74, (0, 1, 3, 2)) * -1
    tmp10 = einsum(tmp6, (0, 1, 2), t1.aa, (3, 2), (3, 0, 1))
    tmp14 = np.copy(np.transpose(ints.tmp27, (1, 0)))
    tmp14 += ints.tmp47 * 2
    tmp14 += ints.tmp49
    tmp14 += f.aa.vv * -1
    tmp14 += np.transpose(ints.tmp26, (1, 0)) * -1
    tmp14 += np.transpose(ints.tmp28, (1, 0)) * -1
    r2new.bbb = einsum(v.bbbb.vvvv, (0, 1, 2, 3), r2.bbb, (3, 1, 4), (0, 2, 4)) * -2
    r2new.bbb += np.transpose(tmp111, (1, 2, 0)) * -1
    r2new.bbb += np.transpose(tmp111, (2, 1, 0))
    del tmp111
    r2new.bbb += np.transpose(tmp122, (1, 2, 0))
    r2new.bbb += np.transpose(tmp122, (2, 1, 0)) * -1
    del tmp122
    r2new.bbb += einsum(v.bbbb.ovov, (0, 1, 2, 3), tmp124, (4, 0, 2), (3, 1, 4)) * -2
    del tmp124
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp90, (2, 3), (0, 1, 3)) * -2
    r2new.bbb += einsum(r1.b, (0,), tmp38, (1, 2), (0, 2, 1))
    r2new.bbb += einsum(r1.b, (0,), tmp38, (1, 2), (2, 0, 1)) * -1
    r2new.bab = einsum(r2.bab, (0, 1, 2), v.aabb.vvvv, (3, 1, 4, 0), (4, 3, 2))
    r2new.bab += einsum(tmp6, (0, 1, 2), v.aabb.vvov, (3, 2, 1, 4), (4, 3, 0))
    r2new.bab += einsum(v.aabb.ovvv, (0, 1, 2, 3), tmp4, (0, 4, 3), (2, 1, 4))
    r2new.bab += einsum(r1.a, (0,), v.aabb.vvov, (1, 0, 2, 3), (3, 1, 2)) * -1
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp83, (2, 3, 0, 4), (4, 1, 3))
    del tmp83
    r2new.bab += einsum(r2.aaa, (0, 1, 2), tmp84, (2, 3, 1, 4), (4, 0, 3)) * -2
    del tmp84
    r2new.bab += einsum(tmp85, (0, 1, 2, 3), r2.bab, (4, 2, 0), (4, 3, 1))
    del tmp85
    r2new.bab += einsum(tmp87, (0, 1, 2), v.aabb.ovov, (0, 3, 2, 4), (4, 3, 1)) * -1
    del tmp87
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp88, (1, 3), (0, 3, 2)) * -1
    del tmp88
    r2new.bab += einsum(tmp89, (0, 1), r2.bab, (0, 2, 3), (1, 2, 3)) * -2
    del tmp89
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp90, (2, 3), (0, 1, 3)) * -1
    del tmp90
    r2new.bab += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp18, (0,), (3, 1, 2)) * 2
    r2new.bab += einsum(r1.a, (0,), tmp38, (1, 2), (2, 0, 1)) * -1
    r2new.aba = einsum(r2.aba, (0, 1, 2), v.aabb.vvvv, (3, 0, 4, 1), (3, 4, 2))
    r2new.aba += einsum(tmp24, (0, 1, 2), v.aabb.vvov, (3, 2, 1, 4), (3, 4, 0)) * -1
    r2new.aba += einsum(r1.b, (0,), v.aabb.ovvv, (1, 2, 3, 0), (2, 3, 1)) * -1
    r2new.aba += einsum(tmp26, (0, 1, 2), v.aabb.ovvv, (1, 3, 4, 2), (3, 4, 0)) * -1
    r2new.aba += einsum(tmp73, (0, 1, 2, 3), r2.aba, (2, 4, 0), (3, 4, 1))
    del tmp73
    r2new.aba += einsum(r2.bbb, (0, 1, 2), tmp75, (3, 2, 4, 1), (4, 0, 3)) * -2
    del tmp75
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp76, (2, 3, 1, 4), (0, 4, 3))
    del tmp76
    r2new.aba += einsum(tmp78, (0, 1, 2), v.aabb.ovov, (1, 3, 2, 4), (3, 4, 0))
    del tmp78
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp79, (1, 3), (0, 3, 2)) * -1
    del tmp79
    r2new.aba += einsum(tmp81, (0, 1), r2.aba, (0, 2, 3), (1, 2, 3)) * -1
    del tmp81
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp71, (2, 3), (0, 1, 3)) * -1
    r2new.aba += einsum(v.aabb.ovov, (0, 1, 2, 3), tmp37, (2,), (1, 3, 0))
    r2new.aba += einsum(tmp19, (0, 1), r1.b, (2,), (1, 2, 0)) * -1
    r2new.aaa = einsum(r2.aaa, (0, 1, 2), v.aaaa.vvvv, (3, 1, 4, 0), (3, 4, 2)) * -2
    r2new.aaa += np.transpose(tmp56, (1, 2, 0)) * -1
    r2new.aaa += np.transpose(tmp56, (2, 1, 0))
    del tmp56
    r2new.aaa += np.transpose(tmp68, (1, 2, 0))
    r2new.aaa += np.transpose(tmp68, (2, 1, 0)) * -1
    del tmp68
    r2new.aaa += einsum(v.aaaa.ovov, (0, 1, 2, 3), tmp70, (4, 0, 2), (3, 1, 4)) * -2
    del tmp70
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp71, (2, 3), (0, 1, 3)) * -2
    del tmp71
    r2new.aaa += einsum(tmp19, (0, 1), r1.a, (2,), (2, 1, 0))
    r2new.aaa += einsum(r1.a, (0,), tmp19, (1, 2), (2, 0, 1)) * -1
    r1new.b = einsum(r2.aba, (0, 1, 2), tmp20, (2, 0, 3, 1), (3,)) * -1
    del tmp20
    r1new.b += einsum(r2.bbb, (0, 1, 2), tmp21, (2, 3, 0, 1), (3,)) * -4
    del tmp21
    r1new.b += einsum(tmp23, (0, 1, 2, 3), tmp22, (0, 1, 2), (3,)) * 2
    del tmp22, tmp23
    r1new.b += einsum(tmp25, (0, 1, 2, 3), tmp24, (0, 1, 2), (3,))
    del tmp24, tmp25
    r1new.b += einsum(tmp27, (0, 1, 2, 3), tmp26, (0, 1, 2), (3,))
    del tmp26, tmp27
    r1new.b += einsum(tmp9, (0, 1), r2.bbb, (2, 1, 0), (2,)) * -2
    r1new.b += einsum(tmp28, (0, 1), r2.aba, (1, 2, 0), (2,)) * 2
    del tmp28
    r1new.b += einsum(tmp29, (0, 1, 2), tmp30, (0, 1, 2, 3), (3,)) * -1
    del tmp30, tmp29
    r1new.b += einsum(tmp32, (0, 1, 2, 3), tmp31, (0, 2, 1), (3,)) * -2
    del tmp32, tmp31
    r1new.b += einsum(r1.b, (0,), tmp33, (0, 1), (1,)) * -1
    del tmp33
    r1new.b += einsum(tmp38, (0, 1), tmp37, (0,), (1,)) * -1
    del tmp38, tmp37
    r1new.a = einsum(tmp0, (0, 1, 2, 3), r2.bab, (3, 1, 0), (2,)) * -1
    del tmp0
    r1new.a += einsum(tmp1, (0, 1, 2, 3), r2.aaa, (1, 2, 0), (3,)) * -4
    del tmp1
    r1new.a += einsum(tmp3, (0, 1, 2, 3), tmp2, (0, 1, 2), (3,)) * 2
    del tmp2, tmp3
    r1new.a += einsum(tmp5, (0, 1, 2, 3), tmp4, (0, 1, 3), (2,)) * -1
    del tmp4, tmp5
    r1new.a += einsum(tmp6, (0, 1, 2), tmp7, (0, 1, 2, 3), (3,)) * -1
    del tmp6, tmp7
    r1new.a += einsum(r2.aaa, (0, 1, 2), tmp8, (2, 1), (0,)) * -2
    del tmp8
    r1new.a += einsum(tmp9, (0, 1), r2.bab, (1, 2, 0), (2,))
    del tmp9
    r1new.a += einsum(tmp11, (0, 1, 2, 3), tmp10, (0, 1, 2), (3,))
    del tmp11, tmp10
    r1new.a += einsum(tmp13, (0, 1, 2, 3), tmp12, (0, 2, 1), (3,)) * -2
    del tmp13, tmp12
    r1new.a += einsum(r1.a, (0,), tmp14, (0, 1), (1,)) * -1
    del tmp14
    r1new.a += einsum(tmp19, (0, 1), tmp18, (0,), (1,)) * -2
    del tmp19, tmp18

    return {f"r1new": r1new, f"r2new": r2new}

