"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T16:53:22.180022
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:53:24.005263.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 0, 1), (2,))
    tmp3 = einsum(t1.aa, (0, 1), v.baa.xov, (2, 3, 1), (2, 0, 3))
    tmp1 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (1, 2), (0,)) * 0.5
    tmp1 += tmp0
    tmp5 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 3, 1), (2, 0, 3))
    tmp7 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (0, 3, 4))
    tmp7 += einsum(t1.bb, (0, 1), tmp0, (2,), (2, 0, 1)) * 0.5
    del tmp0
    tmp4 = np.copy(f.aa.ov) * 2
    tmp4 += einsum(v.baa.xov, (0, 1, 2), tmp3, (0, 1, 3), (3, 2)) * -1
    del tmp3
    tmp2 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp2 += einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp2 += einsum(t1.aa, (0, 1), tmp1, (2,), (2, 0, 1))
    del tmp1
    tmp6 = np.copy(f.bb.ov)
    tmp6 += einsum(v.bbb.xov, (0, 1, 2), tmp5, (0, 1, 3), (3, 2)) * -0.5
    del tmp5
    e_cc = einsum(v.baa.xov, (0, 1, 2), tmp2, (0, 1, 2), ())
    del tmp2
    e_cc += einsum(t1.aa, (0, 1), tmp4, (0, 1), ()) * 0.5
    del tmp4
    e_cc += einsum(tmp6, (0, 1), t1.bb, (0, 1), ())
    del tmp6
    e_cc += einsum(tmp7, (0, 1, 2), v.bbb.xov, (0, 1, 2), ())
    del tmp7

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:53:48.694394.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    t1new : Namespace of arrays
        Updated T1 residuals.
    t2new : Namespace of arrays
        Updated T2 residuals.
    """

    t1new = Namespace()
    t2new = Namespace()
    tmp17 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 3, 1), (2, 0, 3))
    tmp0 = einsum(t1.aa, (0, 1), v.baa.xov, (2, 3, 1), (2, 0, 3))
    tmp6 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 0, 1), (2,))
    tmp5 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (1, 2), (0,))
    tmp34 = einsum(t1.bb, (0, 1), v.bbb.xvv, (2, 3, 1), (2, 0, 3))
    tmp86 = einsum(tmp17, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp92 = einsum(tmp17, (0, 1, 2), tmp17, (0, 3, 4), (1, 3, 2, 4))
    tmp71 = einsum(t1.bb, (0, 1), tmp17, (2, 3, 0), (2, 3, 1))
    tmp79 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp16 = einsum(v.baa.xvv, (0, 1, 2), t1.aa, (3, 2), (0, 3, 1))
    tmp50 = einsum(tmp0, (0, 1, 2), t1.aa, (2, 3), (0, 1, 3))
    tmp36 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp47 = einsum(tmp0, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp58 = einsum(tmp0, (0, 1, 2), tmp0, (0, 3, 4), (1, 3, 2, 4))
    tmp7 = np.copy(tmp5)
    tmp7 += tmp6
    tmp18 = einsum(tmp17, (0, 1, 2), v.bbb.xov, (0, 1, 3), (2, 3))
    tmp26 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (4, 1, 3))
    tmp11 = einsum(tmp0, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp3 = einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp32 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp83 = einsum(tmp34, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp87 = einsum(tmp86, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    del tmp86
    tmp24 = einsum(tmp17, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp64 = einsum(t1.bb, (0, 1), f.bb.ov, (0, 2), (2, 1))
    tmp93 = einsum(tmp92, (0, 1, 2, 3), t1.bb, (2, 4), (1, 0, 3, 4))
    del tmp92
    tmp68 = einsum(t1.bb, (0, 1), f.bb.ov, (2, 1), (2, 0))
    tmp72 = np.copy(v.bbb.xov)
    tmp72 += tmp34
    tmp72 += tmp71 * -1
    tmp80 = einsum(tmp79, (0, 1, 2, 3), t1.bb, (3, 4), (1, 2, 0, 4))
    del tmp79
    tmp96 = einsum(tmp17, (0, 1, 2), tmp34, (0, 3, 4), (1, 3, 2, 4))
    tmp69 = np.copy(tmp16)
    tmp69 += tmp50 * -1
    tmp40 = einsum(f.aa.ov, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp66 = einsum(v.baa.xoo, (0, 1, 2), tmp17, (0, 3, 4), (1, 2, 3, 4))
    tmp73 = einsum(tmp0, (0, 1, 2), tmp17, (0, 3, 4), (1, 2, 3, 4))
    tmp62 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp37 = einsum(tmp36, (0, 1, 2, 3), t1.aa, (3, 4), (1, 2, 0, 4))
    del tmp36
    tmp1 = einsum(tmp0, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp48 = einsum(tmp47, (0, 1, 2, 3), t1.aa, (3, 4), (0, 1, 2, 4))
    del tmp47
    tmp59 = einsum(tmp58, (0, 1, 2, 3), t1.aa, (2, 4), (1, 0, 3, 4))
    del tmp58
    tmp15 = einsum(v.baa.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp51 = np.copy(v.baa.xov)
    tmp51 += tmp16
    tmp51 += tmp50 * -1
    del tmp50
    tmp45 = einsum(v.baa.xoo, (0, 1, 2), tmp16, (0, 3, 4), (3, 1, 2, 4))
    tmp55 = einsum(tmp0, (0, 1, 2), tmp16, (0, 3, 4), (1, 3, 2, 4))
    tmp43 = einsum(f.aa.ov, (0, 1), t1.aa, (2, 1), (0, 2))
    tmp21 = einsum(tmp7, (0,), v.baa.xov, (0, 1, 2), (1, 2))
    tmp19 = einsum(tmp7, (0,), v.bbb.xov, (0, 1, 2), (1, 2))
    tmp27 = np.copy(t2.bbbb)
    tmp27 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -0.5
    tmp30 = np.copy(f.bb.ov)
    tmp30 += tmp18 * -1
    tmp29 = np.copy(tmp26)
    tmp29 += einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (0, 3, 4)) * 2
    tmp29 += einsum(tmp7, (0,), t1.bb, (1, 2), (0, 1, 2))
    tmp12 = np.copy(f.aa.ov)
    tmp12 += tmp11 * -1
    tmp10 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp10 += tmp3 * 0.5
    tmp10 += einsum(tmp7, (0,), t1.aa, (1, 2), (0, 1, 2)) * 0.5
    tmp4 = np.copy(t2.aaaa)
    tmp4 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1)) * -0.5
    tmp90 = einsum(tmp32, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 4, 3))
    tmp95 = einsum(tmp34, (0, 1, 2), tmp34, (0, 3, 4), (1, 3, 2, 4))
    tmp91 = einsum(v.bbb.xov, (0, 1, 2), tmp34, (0, 3, 4), (3, 1, 2, 4))
    tmp84 = einsum(t1.bb, (0, 1), tmp83, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp83
    tmp88 = einsum(tmp87, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 4, 3))
    del tmp87
    tmp98 = einsum(tmp24, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3))
    tmp78 = einsum(f.bb.oo, (0, 1), t2.bbbb, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp82 = np.copy(f.bb.vv)
    tmp82 += tmp64 * -1
    tmp94 = einsum(t1.bb, (0, 1), tmp93, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp93
    tmp65 = np.copy(f.bb.vv)
    tmp65 += tmp64 * -1
    del tmp64
    tmp85 = einsum(tmp68, (0, 1), t2.bbbb, (2, 0, 3, 4), (1, 2, 3, 4))
    tmp89 = einsum(tmp72, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp81 = einsum(tmp80, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3))
    del tmp80
    tmp97 = einsum(tmp96, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3))
    del tmp96
    tmp77 = einsum(tmp34, (0, 1, 2), tmp0, (0, 3, 4), (3, 4, 1, 2))
    tmp75 = np.copy(v.bbb.xov)
    tmp75 += tmp34
    tmp75 += tmp71 * -1
    del tmp71
    tmp70 = einsum(tmp69, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    del tmp69
    tmp76 = einsum(tmp34, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp14 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp2 = einsum(v.bbb.xov, (0, 1, 2), tmp0, (0, 3, 4), (3, 4, 1, 2))
    tmp41 = np.copy(f.aa.vv)
    tmp41 += tmp40 * -1
    tmp67 = einsum(t1.bb, (0, 1), tmp66, (2, 3, 4, 0), (2, 3, 4, 1))
    del tmp66
    tmp74 = einsum(t1.bb, (0, 1), tmp73, (2, 3, 4, 0), (2, 3, 4, 1))
    del tmp73
    tmp63 = einsum(t1.bb, (0, 1), tmp62, (2, 3, 4, 0), (3, 2, 4, 1))
    del tmp62
    tmp33 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp38 = einsum(tmp37, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    del tmp37
    tmp61 = einsum(tmp1, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    tmp49 = einsum(tmp48, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    del tmp48
    tmp42 = np.copy(f.aa.vv)
    tmp42 += tmp40 * -1
    del tmp40
    tmp60 = einsum(tmp59, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp59
    tmp54 = einsum(tmp16, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 3, 4, 2))
    tmp53 = einsum(tmp15, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    tmp57 = einsum(tmp16, (0, 1, 2), tmp16, (0, 3, 4), (3, 1, 4, 2))
    tmp52 = einsum(v.baa.xov, (0, 1, 2), tmp51, (0, 3, 4), (1, 3, 2, 4))
    del tmp51
    tmp46 = einsum(tmp45, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    del tmp45
    tmp56 = einsum(tmp55, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp55
    tmp39 = einsum(t2.aaaa, (0, 1, 2, 3), f.aa.oo, (4, 1), (4, 0, 2, 3))
    tmp44 = einsum(t2.aaaa, (0, 1, 2, 3), tmp43, (1, 4), (4, 0, 2, 3))
    tmp22 = np.copy(f.aa.ov)
    tmp22 += tmp11 * -1
    del tmp11
    tmp22 += tmp21
    del tmp21
    tmp20 = np.copy(f.bb.ov)
    tmp20 += tmp18 * -1
    del tmp18
    tmp20 += tmp19
    del tmp19
    tmp25 = einsum(v.baa.xov, (0, 1, 2), tmp17, (0, 3, 4), (1, 3, 4, 2))
    tmp35 = np.copy(f.bb.oo)
    tmp35 += einsum(v.bbb.xoo, (0, 1, 2), tmp17, (0, 2, 3), (3, 1)) * -1
    del tmp17
    tmp35 += einsum(tmp7, (0,), v.bbb.xoo, (0, 1, 2), (1, 2))
    tmp9 = np.copy(tmp5)
    del tmp5
    tmp9 += tmp6
    del tmp6
    tmp28 = np.copy(tmp26) * 0.5
    del tmp26
    tmp28 += einsum(v.bbb.xov, (0, 1, 2), tmp27, (1, 3, 2, 4), (0, 3, 4))
    del tmp27
    tmp28 += einsum(tmp7, (0,), t1.bb, (1, 2), (0, 1, 2)) * 0.5
    tmp31 = einsum(tmp29, (0, 1, 2), v.bbb.xov, (0, 3, 2), (3, 1))
    del tmp29
    tmp31 += einsum(tmp30, (0, 1), t1.bb, (2, 1), (0, 2))
    del tmp30
    tmp23 = np.copy(f.aa.oo)
    tmp23 += einsum(tmp0, (0, 1, 2), v.baa.xoo, (0, 3, 1), (2, 3)) * -1
    del tmp0
    tmp23 += einsum(tmp7, (0,), v.baa.xoo, (0, 1, 2), (1, 2))
    tmp13 = einsum(tmp10, (0, 1, 2), v.baa.xov, (0, 3, 2), (3, 1)) * 2
    del tmp10
    tmp13 += einsum(tmp12, (0, 1), t1.aa, (2, 1), (0, 2))
    del tmp12
    tmp8 = np.copy(tmp3) * 0.5
    del tmp3
    tmp8 += einsum(v.baa.xov, (0, 1, 2), tmp4, (1, 3, 2, 4), (0, 3, 4))
    del tmp4
    tmp8 += einsum(tmp7, (0,), t1.aa, (1, 2), (0, 1, 2)) * 0.5
    del tmp7
    t2new.bbbb = np.copy(np.transpose(tmp78, (1, 0, 3, 2))) * 2
    t2new.bbbb += tmp81
    t2new.bbbb += np.transpose(tmp78, (0, 1, 3, 2)) * -2
    del tmp78
    t2new.bbbb += np.transpose(tmp81, (0, 1, 3, 2)) * -1
    del tmp81
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp82, (3, 4), (0, 1, 4, 2)) * -2
    del tmp82
    t2new.bbbb += einsum(tmp65, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 4, 1)) * 2
    t2new.bbbb += np.transpose(tmp84, (1, 0, 3, 2))
    t2new.bbbb += np.transpose(tmp85, (1, 0, 3, 2)) * 2
    t2new.bbbb += np.transpose(tmp88, (1, 0, 2, 3))
    t2new.bbbb += np.transpose(tmp88, (1, 0, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp84, (1, 0, 2, 3)) * -1
    t2new.bbbb += np.transpose(tmp84, (0, 1, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp85, (0, 1, 3, 2)) * -2
    del tmp85
    t2new.bbbb += tmp88 * -1
    t2new.bbbb += np.transpose(tmp88, (0, 1, 3, 2))
    del tmp88
    t2new.bbbb += tmp84
    del tmp84
    t2new.bbbb += tmp89
    t2new.bbbb += np.transpose(tmp89, (1, 0, 2, 3)) * -1
    del tmp89
    t2new.bbbb += np.transpose(tmp90, (0, 1, 3, 2))
    t2new.bbbb += np.transpose(tmp90, (1, 0, 3, 2)) * -1
    t2new.bbbb += tmp90 * -1
    t2new.bbbb += np.transpose(tmp90, (1, 0, 2, 3))
    del tmp90
    t2new.bbbb += np.transpose(tmp91, (0, 1, 3, 2))
    t2new.bbbb += tmp94
    t2new.bbbb += np.transpose(tmp94, (0, 1, 3, 2)) * -1
    del tmp94
    t2new.bbbb += tmp95
    t2new.bbbb += np.transpose(tmp95, (0, 1, 3, 2)) * -1
    del tmp95
    t2new.bbbb += np.transpose(tmp97, (0, 1, 3, 2))
    t2new.bbbb += np.transpose(tmp97, (1, 0, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp91, (1, 0, 3, 2)) * -1
    del tmp91
    t2new.bbbb += tmp98 * -1
    t2new.bbbb += np.transpose(tmp98, (1, 0, 2, 3))
    del tmp98
    t2new.bbbb += tmp97 * -1
    t2new.bbbb += np.transpose(tmp97, (1, 0, 2, 3))
    del tmp97
    t2new.abab = einsum(tmp63, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    del tmp63
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), f.bb.oo, (4, 1), (0, 4, 2, 3)) * -1
    t2new.abab += einsum(f.aa.oo, (0, 1), t2.abab, (1, 2, 3, 4), (0, 2, 3, 4)) * -1
    t2new.abab += einsum(tmp41, (0, 1), t2.abab, (2, 3, 0, 4), (2, 3, 1, 4))
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp65, (3, 4), (0, 1, 2, 4))
    del tmp65
    t2new.abab += einsum(tmp67, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    del tmp67
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp68, (1, 4), (0, 4, 2, 3)) * -1
    del tmp68
    t2new.abab += einsum(tmp43, (0, 1), t2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -1
    del tmp43
    t2new.abab += einsum(tmp70, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4)) * -1
    del tmp70
    t2new.abab += einsum(v.baa.xov, (0, 1, 2), tmp72, (0, 3, 4), (1, 3, 2, 4))
    del tmp72
    t2new.abab += einsum(tmp33, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 3, 4)) * -1
    t2new.abab += einsum(tmp14, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3)) * -1
    t2new.abab += einsum(tmp74, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    del tmp74
    t2new.abab += einsum(tmp75, (0, 1, 2), tmp16, (0, 3, 4), (3, 1, 4, 2))
    del tmp75
    t2new.abab += einsum(tmp2, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3)) * -1
    t2new.abab += einsum(tmp76, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -1
    del tmp76
    t2new.abab += einsum(tmp77, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3)) * -1
    del tmp77
    t2new.aaaa = np.copy(tmp38)
    t2new.aaaa += np.transpose(tmp39, (1, 0, 3, 2)) * 2
    t2new.aaaa += np.transpose(tmp38, (0, 1, 3, 2)) * -1
    del tmp38
    t2new.aaaa += np.transpose(tmp39, (0, 1, 3, 2)) * -2
    del tmp39
    t2new.aaaa += einsum(tmp41, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 1, 4)) * -2
    del tmp41
    t2new.aaaa += einsum(tmp42, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 4, 1)) * 2
    del tmp42
    t2new.aaaa += np.transpose(tmp44, (1, 0, 3, 2)) * 2
    t2new.aaaa += np.transpose(tmp46, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp49, (1, 0, 2, 3))
    t2new.aaaa += np.transpose(tmp49, (1, 0, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp46, (1, 0, 2, 3)) * -1
    t2new.aaaa += np.transpose(tmp44, (0, 1, 3, 2)) * -2
    del tmp44
    t2new.aaaa += np.transpose(tmp46, (0, 1, 3, 2)) * -1
    t2new.aaaa += tmp49 * -1
    t2new.aaaa += np.transpose(tmp49, (0, 1, 3, 2))
    del tmp49
    t2new.aaaa += tmp46
    del tmp46
    t2new.aaaa += tmp52
    t2new.aaaa += np.transpose(tmp52, (1, 0, 2, 3)) * -1
    del tmp52
    t2new.aaaa += np.transpose(tmp53, (0, 1, 3, 2))
    t2new.aaaa += np.transpose(tmp53, (1, 0, 3, 2)) * -1
    t2new.aaaa += tmp53 * -1
    t2new.aaaa += np.transpose(tmp53, (1, 0, 2, 3))
    del tmp53
    t2new.aaaa += np.transpose(tmp54, (0, 1, 3, 2))
    t2new.aaaa += np.transpose(tmp56, (0, 1, 3, 2))
    t2new.aaaa += np.transpose(tmp56, (1, 0, 3, 2)) * -1
    t2new.aaaa += tmp57
    t2new.aaaa += np.transpose(tmp57, (0, 1, 3, 2)) * -1
    del tmp57
    t2new.aaaa += tmp60
    t2new.aaaa += np.transpose(tmp60, (0, 1, 3, 2)) * -1
    del tmp60
    t2new.aaaa += np.transpose(tmp54, (1, 0, 3, 2)) * -1
    del tmp54
    t2new.aaaa += tmp61 * -1
    t2new.aaaa += np.transpose(tmp61, (1, 0, 2, 3))
    del tmp61
    t2new.aaaa += tmp56 * -1
    t2new.aaaa += np.transpose(tmp56, (1, 0, 2, 3))
    del tmp56
    t1new.bb = einsum(t2.bbbb, (0, 1, 2, 3), tmp24, (4, 1, 0, 3), (4, 2)) * -2
    del tmp24
    t1new.bb += f.bb.ov
    t1new.bb += einsum(f.bb.vv, (0, 1), t1.bb, (2, 1), (2, 0))
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), tmp25, (0, 4, 1, 2), (4, 3)) * -1
    del tmp25
    t1new.bb += einsum(v.bbb.xvv, (0, 1, 2), tmp28, (0, 3, 2), (3, 1)) * 2
    del tmp28
    t1new.bb += einsum(tmp9, (0,), v.bbb.xov, (0, 1, 2), (1, 2))
    t1new.bb += einsum(tmp31, (0, 1), t1.bb, (0, 2), (1, 2)) * -1
    del tmp31
    t1new.bb += einsum(tmp32, (0, 1, 2, 3), t2.bbbb, (1, 2, 4, 3), (0, 4)) * -2
    del tmp32
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), tmp33, (0, 4, 1, 2), (4, 3)) * -1
    del tmp33
    t1new.bb += einsum(v.bbb.xoo, (0, 1, 2), tmp34, (0, 2, 3), (1, 3)) * -1
    del tmp34
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), tmp20, (1, 3), (0, 2)) * 2
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), tmp22, (0, 2), (1, 3))
    t1new.bb += einsum(t1.bb, (0, 1), tmp35, (0, 2), (2, 1)) * -1
    del tmp35
    t1new.aa = einsum(t2.aaaa, (0, 1, 2, 3), tmp1, (4, 1, 0, 3), (4, 2)) * -2
    del tmp1
    t1new.aa += f.aa.ov
    t1new.aa += einsum(tmp2, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4)) * -1
    del tmp2
    t1new.aa += einsum(f.aa.vv, (0, 1), t1.aa, (2, 1), (2, 0))
    t1new.aa += einsum(v.baa.xvv, (0, 1, 2), tmp8, (0, 3, 2), (3, 1)) * 2
    del tmp8
    t1new.aa += einsum(tmp9, (0,), v.baa.xov, (0, 1, 2), (1, 2))
    del tmp9
    t1new.aa += einsum(tmp13, (0, 1), t1.aa, (0, 2), (1, 2)) * -1
    del tmp13
    t1new.aa += einsum(tmp14, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4)) * -1
    del tmp14
    t1new.aa += einsum(t2.aaaa, (0, 1, 2, 3), tmp15, (4, 0, 1, 3), (4, 2)) * -2
    del tmp15
    t1new.aa += einsum(v.baa.xoo, (0, 1, 2), tmp16, (0, 2, 3), (1, 3)) * -1
    del tmp16
    t1new.aa += einsum(t2.abab, (0, 1, 2, 3), tmp20, (1, 3), (0, 2))
    del tmp20
    t1new.aa += einsum(tmp22, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3)) * 2
    del tmp22
    t1new.aa += einsum(tmp23, (0, 1), t1.aa, (0, 2), (1, 2)) * -1
    del tmp23

    return {f"t1new": t1new, f"t2new": t2new}

def update_lams(f=None, l1=None, l2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:55:58.376778.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    l1new : Namespace of arrays
        Updated L1 residuals.
    l2new : Namespace of arrays
        Updated L2 residuals.
    """

    l1new = Namespace()
    l2new = Namespace()
    tmp13 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 0, 1), (2,))
    tmp12 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (1, 2), (0,))
    tmp54 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    tmp52 = einsum(l1.aa, (0, 1), t1.aa, (2, 0), (1, 2))
    tmp53 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (2, 4))
    tmp65 = einsum(t1.bb, (0, 1), l1.bb, (1, 2), (2, 0))
    tmp67 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    tmp66 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    tmp27 = einsum(v.baa.xvv, (0, 1, 2), t1.aa, (3, 2), (0, 3, 1))
    tmp7 = einsum(t1.bb, (0, 1), v.bbb.xvv, (2, 3, 1), (2, 0, 3))
    tmp4 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 3, 1), (2, 0, 3))
    tmp14 = np.copy(tmp12)
    tmp14 += tmp13
    tmp1 = einsum(t1.aa, (0, 1), v.baa.xov, (2, 3, 1), (2, 0, 3))
    tmp101 = np.copy(tmp12)
    del tmp12
    tmp101 += tmp13
    del tmp13
    tmp48 = einsum(t1.aa, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp50 = einsum(l2.abab, (0, 1, 2, 3), t1.aa, (4, 0), (2, 4, 3, 1))
    tmp55 = np.copy(tmp52) * 0.5
    tmp55 += tmp53
    tmp55 += tmp54 * 0.5
    tmp63 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp68 = np.copy(tmp65)
    tmp68 += tmp66
    tmp68 += tmp67 * 2
    tmp61 = einsum(l2.abab, (0, 1, 2, 3), t1.bb, (4, 1), (2, 3, 4, 0))
    tmp158 = np.copy(v.baa.xov)
    tmp158 += tmp27
    tmp160 = np.copy(v.bbb.xov)
    tmp160 += tmp7
    tmp107 = einsum(v.bbb.xov, (0, 1, 2), tmp4, (0, 1, 3), (3, 2))
    tmp108 = einsum(v.bbb.xov, (0, 1, 2), tmp14, (0,), (1, 2))
    tmp11 = einsum(v.baa.xov, (0, 1, 2), tmp1, (0, 1, 3), (3, 2))
    tmp165 = einsum(v.baa.xov, (0, 1, 2), tmp101, (0,), (1, 2))
    tmp15 = einsum(v.baa.xov, (0, 1, 2), tmp14, (0,), (1, 2))
    tmp17 = einsum(v.baa.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp49 = einsum(tmp48, (0, 1, 2, 3), t2.aaaa, (1, 0, 4, 3), (2, 4))
    tmp51 = einsum(tmp50, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (1, 4))
    tmp46 = einsum(l1.aa, (0, 1), t2.aaaa, (2, 1, 3, 0), (2, 3))
    tmp56 = einsum(tmp55, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp47 = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2))
    tmp42 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    tmp43 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 1), (0, 4))
    tmp41 = einsum(t1.bb, (0, 1), l1.bb, (2, 0), (2, 1))
    tmp38 = einsum(t1.aa, (0, 1), l1.aa, (2, 0), (2, 1))
    tmp35 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    tmp34 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4))
    tmp59 = einsum(t2.abab, (0, 1, 2, 3), l1.aa, (2, 0), (1, 3))
    tmp60 = einsum(l1.bb, (0, 1), t2.bbbb, (2, 1, 3, 0), (2, 3))
    tmp64 = einsum(t2.bbbb, (0, 1, 2, 3), tmp63, (1, 0, 4, 3), (4, 2))
    tmp69 = einsum(tmp68, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp62 = einsum(t2.abab, (0, 1, 2, 3), tmp61, (0, 1, 4, 2), (4, 3))
    tmp144 = einsum(tmp101, (0,), v.bbb.xvv, (0, 1, 2), (1, 2))
    tmp202 = einsum(tmp7, (0, 1, 2), v.bbb.xov, (0, 1, 3), (3, 2))
    tmp195 = einsum(v.bbb.xov, (0, 1, 2), tmp101, (0,), (1, 2))
    tmp190 = einsum(l2.abab, (0, 1, 2, 3), tmp158, (4, 2, 0), (4, 3, 1))
    tmp189 = einsum(v.bbb.xvv, (0, 1, 2), l1.bb, (2, 3), (0, 3, 1))
    tmp131 = einsum(tmp50, (0, 1, 2, 3), tmp1, (4, 0, 1), (4, 2, 3))
    tmp129 = einsum(v.baa.xoo, (0, 1, 2), tmp50, (2, 1, 3, 4), (0, 3, 4))
    tmp191 = einsum(tmp160, (0, 1, 2), l2.bbbb, (3, 2, 4, 1), (0, 4, 3))
    tmp132 = einsum(tmp63, (0, 1, 2, 3), tmp4, (4, 0, 2), (4, 1, 3)) * -1
    tmp130 = einsum(v.bbb.xoo, (0, 1, 2), tmp63, (2, 3, 1, 4), (0, 3, 4)) * -1
    tmp109 = np.copy(f.bb.ov)
    tmp109 += tmp107 * -1
    tmp109 += tmp108
    tmp193 = np.copy(v.bbb.xoo)
    tmp193 += np.transpose(tmp4, (0, 2, 1))
    tmp166 = np.copy(f.aa.ov)
    tmp166 += tmp11 * -1
    tmp166 += tmp165
    tmp146 = np.copy(v.baa.xoo)
    tmp146 += np.transpose(tmp1, (0, 2, 1))
    tmp161 = einsum(l2.abab, (0, 1, 2, 3), tmp160, (4, 3, 1), (4, 2, 0))
    del tmp160
    tmp159 = einsum(l2.aaaa, (0, 1, 2, 3), tmp158, (4, 3, 1), (4, 2, 0))
    del tmp158
    tmp150 = einsum(l1.aa, (0, 1), v.baa.xvv, (2, 3, 0), (2, 1, 3))
    tmp83 = einsum(tmp61, (0, 1, 2, 3), v.bbb.xoo, (4, 2, 1), (4, 0, 3))
    tmp84 = einsum(tmp1, (0, 1, 2), tmp48, (3, 1, 2, 4), (0, 3, 4))
    tmp82 = einsum(v.baa.xoo, (0, 1, 2), tmp48, (2, 3, 1, 4), (0, 3, 4)) * -1
    tmp85 = einsum(tmp61, (0, 1, 2, 3), tmp4, (4, 1, 2), (4, 0, 3))
    tmp16 = np.copy(f.aa.ov)
    tmp16 += tmp11 * -1
    tmp16 += tmp15
    tmp102 = einsum(v.baa.xvv, (0, 1, 2), tmp101, (0,), (1, 2))
    tmp174 = einsum(tmp27, (0, 1, 2), v.baa.xov, (0, 1, 3), (3, 2))
    tmp5 = np.copy(v.bbb.xoo)
    tmp5 += tmp4
    tmp25 = einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp24 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp2 = np.copy(v.baa.xoo)
    tmp2 += tmp1
    tmp18 = einsum(tmp17, (0, 1, 2, 3), t2.abab, (4, 5, 2, 3), (4, 0, 5, 1))
    tmp110 = np.copy(v.bbb.xoo)
    tmp110 += np.transpose(tmp4, (0, 2, 1))
    tmp95 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 5, 0, 1), (2, 4, 3, 5))
    tmp96 = einsum(tmp61, (0, 1, 2, 3), t1.aa, (4, 3), (0, 4, 1, 2))
    tmp139 = einsum(tmp63, (0, 1, 2, 3), t1.bb, (4, 3), (1, 0, 2, 4))
    tmp138 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp8 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (4, 1, 3))
    tmp9 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (0, 3, 4))
    tmp116 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp118 = einsum(tmp4, (0, 1, 2), tmp4, (0, 3, 4), (1, 3, 2, 4))
    tmp117 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp119 = einsum(tmp4, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp57 = np.copy(np.transpose(l1.aa, (1, 0))) * -0.5
    tmp57 += t1.aa * -0.5
    tmp57 += tmp46 * -1
    tmp57 += tmp47 * -0.5
    tmp57 += tmp49
    tmp57 += tmp51 * 0.5
    tmp57 += tmp56
    tmp74 = np.copy(tmp65)
    tmp74 += np.transpose(tmp66, (1, 0))
    tmp74 += np.transpose(tmp67, (1, 0)) * 2
    tmp44 = np.copy(tmp41)
    del tmp41
    tmp44 += np.transpose(tmp42, (1, 0))
    tmp44 += tmp43 * 2
    tmp39 = np.copy(tmp38) * 0.5
    del tmp38
    tmp39 += np.transpose(tmp34, (1, 0))
    tmp39 += tmp35 * 0.5
    tmp70 = np.copy(np.transpose(l1.bb, (1, 0))) * -1
    tmp70 += t1.bb * -1
    tmp70 += tmp59 * -1
    tmp70 += tmp60 * -2
    tmp70 += tmp62
    tmp70 += tmp64 * 2
    tmp70 += tmp69
    tmp72 = np.copy(tmp52) * 0.5
    tmp72 += tmp53
    tmp72 += np.transpose(tmp54, (1, 0)) * 0.5
    tmp93 = einsum(tmp48, (0, 1, 2, 3), t1.aa, (4, 3), (0, 1, 4, 2))
    tmp92 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp19 = np.copy(v.baa.xoo)
    tmp19 += np.transpose(tmp1, (0, 2, 1))
    tmp29 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp30 = einsum(tmp1, (0, 1, 2), tmp1, (0, 3, 4), (1, 3, 2, 4))
    tmp28 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp31 = einsum(tmp1, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp203 = np.copy(f.bb.vv)
    tmp203 += np.transpose(tmp202, (1, 0)) * -1
    tmp203 += np.transpose(tmp144, (1, 0))
    tmp204 = np.copy(f.bb.ov)
    tmp204 += tmp107 * -1
    tmp204 += tmp195
    tmp192 = np.copy(tmp189)
    tmp192 += tmp129 * -1
    tmp192 += tmp130 * -2
    tmp192 += tmp131 * -1
    tmp192 += tmp132 * -2
    tmp192 += tmp190
    del tmp190
    tmp192 += tmp191 * 2
    del tmp191
    tmp210 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp127 = einsum(tmp109, (0, 1), t1.bb, (2, 1), (0, 2))
    tmp124 = einsum(v.bbb.xoo, (0, 1, 2), tmp4, (0, 2, 3), (1, 3))
    tmp126 = einsum(v.bbb.xoo, (0, 1, 2), tmp14, (0,), (1, 2))
    tmp113 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp220 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (3, 1, 2, 4))
    tmp209 = einsum(tmp4, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp208 = einsum(v.bbb.xov, (0, 1, 2), tmp65, (3, 1), (0, 3, 2))
    tmp211 = einsum(tmp193, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp194 = einsum(tmp193, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp152 = np.copy(v.bbb.xov)
    tmp152 += tmp7
    tmp151 = np.copy(v.baa.xov)
    tmp151 += tmp27
    tmp175 = einsum(v.baa.xvv, (0, 1, 2), tmp14, (0,), (1, 2))
    tmp199 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp77 = einsum(tmp1, (0, 1, 2), v.baa.xoo, (0, 3, 1), (3, 2))
    tmp164 = einsum(tmp101, (0,), v.baa.xoo, (0, 1, 2), (1, 2))
    tmp167 = einsum(tmp166, (0, 1), t1.aa, (2, 1), (0, 2))
    tmp156 = einsum(tmp146, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp147 = einsum(tmp146, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp186 = einsum(tmp1, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp184 = einsum(v.baa.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp162 = np.copy(tmp150)
    tmp162 += tmp82 * -2
    tmp162 += tmp83 * -1
    tmp162 += tmp84 * -2
    tmp162 += tmp85 * -1
    tmp162 += tmp159 * 2
    del tmp159
    tmp162 += tmp161
    del tmp161
    tmp182 = einsum(tmp52, (0, 1), v.baa.xov, (2, 1, 3), (2, 0, 3))
    tmp22 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp79 = einsum(tmp14, (0,), v.baa.xoo, (0, 1, 2), (1, 2))
    tmp80 = einsum(t1.aa, (0, 1), tmp16, (2, 1), (0, 2))
    tmp178 = np.copy(f.aa.vv)
    tmp178 += np.transpose(tmp174, (1, 0)) * -1
    tmp178 += np.transpose(tmp102, (1, 0))
    tmp171 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp122 = np.copy(tmp42)
    del tmp42
    tmp122 += tmp43 * 2
    del tmp43
    tmp106 = einsum(v.bbb.xov, (0, 1, 2), tmp5, (0, 3, 4), (4, 3, 1, 2))
    tmp86 = np.copy(v.baa.xov)
    tmp86 += tmp27
    tmp86 += tmp24 * 2
    tmp86 += tmp25
    tmp105 = einsum(tmp2, (0, 1, 2), v.bbb.xov, (0, 3, 4), (2, 1, 3, 4))
    tmp111 = np.copy(np.transpose(tmp18, (1, 0, 2, 3)))
    tmp111 += einsum(tmp110, (0, 1, 2), tmp2, (0, 3, 4), (4, 3, 2, 1))
    tmp104 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp97 = np.copy(tmp95)
    del tmp95
    tmp97 += tmp96
    tmp136 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 4), (4, 0, 1, 2)) * -1
    tmp136 += einsum(t2.abab, (0, 1, 2, 3), tmp61, (0, 4, 5, 2), (4, 5, 1, 3)) * 0.5
    tmp136 += einsum(t2.bbbb, (0, 1, 2, 3), tmp63, (4, 1, 5, 3), (4, 5, 0, 2)) * -2
    tmp135 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 5), (3, 4, 1, 5))
    tmp135 += einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (5, 0, 2, 4)) * 4
    tmp134 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 5, 1), (3, 4, 0, 5))
    tmp141 = np.copy(t1.bb) * -1
    tmp141 += tmp59 * -1
    del tmp59
    tmp141 += tmp60 * -2
    del tmp60
    tmp141 += tmp62
    del tmp62
    tmp141 += tmp64 * 2
    del tmp64
    tmp141 += tmp69
    del tmp69
    tmp140 = np.copy(np.transpose(tmp138, (1, 0, 3, 2)))
    del tmp138
    tmp140 += np.transpose(tmp139, (0, 1, 3, 2)) * -1
    tmp137 = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 4), (0, 4, 1, 2))
    tmp137 += einsum(t2.abab, (0, 1, 2, 3), tmp50, (0, 4, 5, 3), (4, 5, 1, 2)) * -1
    tmp10 = np.copy(v.bbb.xov)
    tmp10 += tmp7
    tmp10 += tmp8
    tmp10 += tmp9 * 2
    tmp125 = np.copy(tmp8) * 0.5
    tmp125 += tmp9
    tmp114 = einsum(tmp110, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp120 = np.copy(np.transpose(tmp116, (3, 2, 1, 0)))
    tmp120 += einsum(t2.bbbb, (0, 1, 2, 3), tmp117, (4, 5, 2, 3), (5, 4, 0, 1))
    tmp120 += np.transpose(tmp118, (2, 3, 1, 0))
    tmp120 += np.transpose(tmp119, (1, 3, 0, 2))
    tmp120 += np.transpose(tmp119, (3, 2, 0, 1)) * -1
    tmp115 = np.copy(v.bbb.xov)
    tmp115 += tmp8
    del tmp8
    tmp115 += tmp9 * 2
    del tmp9
    tmp58 = einsum(v.baa.xov, (0, 1, 2), tmp57, (1, 2), (0,)) * 2
    del tmp57
    tmp75 = einsum(v.bbb.xoo, (0, 1, 2), tmp74, (2, 1), (0,))
    del tmp74
    tmp45 = einsum(tmp44, (0, 1), v.bbb.xvv, (2, 1, 0), (2,))
    del tmp44
    tmp40 = einsum(tmp39, (0, 1), v.baa.xvv, (2, 1, 0), (2,)) * 2
    del tmp39
    tmp71 = einsum(v.bbb.xov, (0, 1, 2), tmp70, (1, 2), (0,))
    del tmp70
    tmp73 = einsum(tmp72, (0, 1), v.baa.xoo, (2, 1, 0), (2,)) * 2
    del tmp72
    tmp88 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 5), (2, 4, 1, 5))
    tmp98 = np.copy(t1.aa) * -0.5
    tmp98 += tmp46 * -1
    del tmp46
    tmp98 += tmp47 * -0.5
    del tmp47
    tmp98 += tmp49
    del tmp49
    tmp98 += tmp51 * 0.5
    del tmp51
    tmp98 += tmp56
    del tmp56
    tmp94 = np.copy(np.transpose(tmp92, (1, 0, 3, 2)))
    del tmp92
    tmp94 += np.transpose(tmp93, (0, 1, 3, 2)) * -1
    tmp89 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp89 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 5, 0)) * 0.25
    tmp90 = einsum(l1.aa, (0, 1), t2.aaaa, (2, 3, 4, 0), (1, 2, 3, 4)) * -1
    tmp90 += einsum(t2.aaaa, (0, 1, 2, 3), tmp48, (4, 1, 5, 3), (4, 5, 0, 2)) * -2
    tmp90 += einsum(t2.abab, (0, 1, 2, 3), tmp50, (4, 5, 1, 3), (4, 5, 0, 2)) * 0.5
    tmp91 = einsum(l1.aa, (0, 1), t2.abab, (2, 3, 0, 4), (1, 2, 3, 4))
    tmp91 += einsum(tmp61, (0, 1, 2, 3), t2.abab, (4, 1, 3, 5), (0, 4, 2, 5)) * -1
    tmp3 = einsum(tmp2, (0, 1, 2), v.baa.xov, (0, 3, 4), (2, 1, 3, 4))
    tmp20 = np.copy(np.transpose(tmp18, (0, 1, 3, 2)))
    del tmp18
    tmp20 += einsum(tmp19, (0, 1, 2), tmp5, (0, 3, 4), (2, 1, 4, 3))
    tmp6 = einsum(v.baa.xov, (0, 1, 2), tmp5, (0, 3, 4), (1, 4, 3, 2))
    tmp0 = einsum(v.baa.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp26 = np.copy(v.baa.xov)
    tmp26 += tmp24 * 2
    tmp26 += tmp25
    tmp32 = np.copy(np.transpose(tmp28, (3, 2, 1, 0)))
    tmp32 += einsum(tmp29, (0, 1, 2, 3), t2.aaaa, (4, 5, 2, 3), (1, 0, 4, 5))
    tmp32 += np.transpose(tmp30, (2, 3, 1, 0))
    tmp32 += np.transpose(tmp31, (1, 3, 0, 2))
    tmp32 += np.transpose(tmp31, (3, 2, 0, 1)) * -1
    tmp23 = einsum(tmp19, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp78 = np.copy(tmp24) * 2
    del tmp24
    tmp78 += tmp25
    del tmp25
    tmp36 = np.copy(tmp34)
    del tmp34
    tmp36 += tmp35 * 0.5
    del tmp35
    tmp225 = einsum(l2.bbbb, (0, 1, 2, 3), tmp203, (1, 4), (2, 3, 4, 0)) * -1
    tmp223 = np.copy(f.bb.vv)
    tmp223 += np.transpose(tmp202, (1, 0)) * -1
    del tmp202
    tmp223 += einsum(v.bbb.xvv, (0, 1, 2), tmp14, (0,), (1, 2))
    del tmp14
    tmp196 = np.copy(f.bb.ov)
    tmp196 += tmp195
    del tmp195
    tmp224 = einsum(tmp63, (0, 1, 2, 3), tmp204, (2, 4), (0, 1, 4, 3))
    tmp219 = einsum(tmp117, (0, 1, 2, 3), tmp139, (4, 5, 0, 1), (4, 5, 2, 3))
    del tmp139
    tmp217 = einsum(tmp192, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp230 = einsum(tmp210, (0, 1, 2, 3), tmp63, (1, 4, 2, 5), (4, 0, 5, 3)) * -1
    tmp198 = np.copy(f.bb.oo)
    tmp198 += tmp124 * -1
    tmp198 += np.transpose(tmp126, (1, 0))
    tmp198 += np.transpose(tmp127, (1, 0))
    tmp222 = einsum(tmp113, (0, 1, 2, 3), tmp63, (4, 5, 0, 2), (5, 4, 3, 1))
    tmp227 = np.copy(np.transpose(tmp116, (3, 2, 1, 0)))
    del tmp116
    tmp227 += np.transpose(tmp118, (0, 3, 1, 2))
    del tmp118
    tmp218 = np.copy(f.bb.oo)
    tmp218 += tmp124 * -1
    tmp218 += einsum(v.bbb.xoo, (0, 1, 2), tmp101, (0,), (1, 2))
    del tmp101
    tmp218 += einsum(tmp204, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp226 = einsum(l2.bbbb, (0, 1, 2, 3), tmp119, (2, 3, 4, 5), (4, 5, 0, 1))
    del tmp119
    tmp221 = einsum(tmp220, (0, 1, 2, 3), l2.bbbb, (3, 2, 4, 5), (4, 5, 0, 1))
    del tmp220
    tmp229 = einsum(tmp63, (0, 1, 2, 3), tmp209, (1, 2, 4, 5), (0, 4, 3, 5))
    tmp228 = einsum(tmp208, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 4, 2))
    tmp212 = einsum(tmp211, (0, 1, 2, 3), l1.bb, (4, 1), (2, 0, 3, 4))
    tmp216 = einsum(l2.bbbb, (0, 1, 2, 3), tmp194, (4, 3, 1, 5), (4, 2, 5, 0))
    tmp215 = np.copy(f.bb.ov)
    tmp215 += tmp108
    del tmp108
    tmp213 = einsum(tmp110, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (2, 1, 3, 4))
    tmp214 = np.copy(tmp189)
    del tmp189
    tmp214 += tmp129 * -1
    tmp214 += tmp130 * -2
    tmp214 += tmp131 * -1
    tmp214 += tmp132 * -2
    tmp214 += einsum(l2.abab, (0, 1, 2, 3), tmp151, (4, 2, 0), (4, 3, 1))
    tmp214 += einsum(tmp152, (0, 1, 2), l2.bbbb, (3, 2, 4, 1), (0, 4, 3)) * 2
    tmp176 = np.copy(f.aa.vv)
    tmp176 += np.transpose(tmp174, (1, 0)) * -1
    del tmp174
    tmp176 += np.transpose(tmp175, (1, 0))
    del tmp175
    tmp201 = einsum(tmp17, (0, 1, 2, 3), tmp96, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp96
    tmp200 = einsum(l2.abab, (0, 1, 2, 3), tmp199, (4, 0, 1, 5), (2, 3, 4, 5))
    del tmp199
    tmp206 = einsum(tmp110, (0, 1, 2), tmp19, (0, 3, 4), (4, 3, 2, 1))
    tmp207 = einsum(v.bbb.xvv, (0, 1, 2), tmp146, (0, 3, 4), (4, 3, 1, 2))
    tmp168 = np.copy(f.aa.oo)
    tmp168 += tmp77 * -1
    tmp168 += np.transpose(tmp164, (1, 0))
    del tmp164
    tmp168 += np.transpose(tmp167, (1, 0))
    del tmp167
    tmp197 = einsum(tmp193, (0, 1, 2), v.baa.xvv, (0, 3, 4), (2, 1, 3, 4))
    del tmp193
    tmp205 = einsum(tmp146, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    del tmp146
    tmp169 = np.copy(f.aa.ov)
    tmp169 += tmp165
    del tmp165
    tmp188 = einsum(v.baa.xov, (0, 1, 2), tmp110, (0, 3, 4), (1, 3, 4, 2))
    del tmp110
    tmp157 = einsum(tmp156, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 1), (0, 5, 3, 4))
    tmp148 = einsum(tmp147, (0, 1, 2, 3), l1.aa, (4, 1), (2, 0, 3, 4))
    tmp187 = einsum(tmp48, (0, 1, 2, 3), tmp186, (1, 2, 4, 5), (0, 4, 3, 5))
    tmp181 = np.copy(np.transpose(tmp28, (3, 2, 1, 0)))
    del tmp28
    tmp181 += np.transpose(tmp30, (0, 3, 1, 2))
    del tmp30
    tmp180 = einsum(l2.aaaa, (0, 1, 2, 3), tmp31, (2, 3, 4, 5), (4, 5, 0, 1))
    del tmp31
    tmp185 = einsum(tmp48, (0, 1, 2, 3), tmp184, (4, 0, 2, 5), (1, 4, 3, 5)) * -1
    tmp163 = einsum(v.baa.xov, (0, 1, 2), tmp162, (0, 3, 4), (3, 1, 4, 2))
    tmp183 = einsum(v.baa.xov, (0, 1, 2), tmp182, (0, 3, 4), (3, 1, 2, 4))
    tmp173 = einsum(tmp29, (0, 1, 2, 3), tmp93, (4, 5, 0, 1), (4, 5, 2, 3))
    del tmp93
    tmp155 = np.copy(f.aa.ov)
    tmp155 += tmp15
    del tmp15
    tmp153 = np.copy(tmp150)
    del tmp150
    tmp153 += tmp82 * -2
    tmp153 += tmp83 * -1
    tmp153 += tmp84 * -2
    tmp153 += tmp85 * -1
    tmp153 += einsum(l2.aaaa, (0, 1, 2, 3), tmp151, (4, 3, 1), (4, 2, 0)) * 2
    del tmp151
    tmp153 += einsum(l2.abab, (0, 1, 2, 3), tmp152, (4, 3, 1), (4, 2, 0))
    del tmp152
    tmp177 = einsum(tmp48, (0, 1, 2, 3), tmp166, (2, 4), (0, 1, 4, 3))
    tmp170 = einsum(tmp48, (0, 1, 2, 3), tmp22, (2, 4, 3, 5), (1, 0, 5, 4))
    tmp154 = np.copy(f.aa.oo)
    tmp154 += tmp77 * -1
    tmp154 += np.transpose(tmp79, (1, 0))
    tmp154 += tmp80
    tmp179 = einsum(l2.aaaa, (0, 1, 2, 3), tmp178, (1, 4), (2, 3, 4, 0)) * -1
    del tmp178
    tmp172 = einsum(tmp171, (0, 1, 2, 3), l2.aaaa, (3, 2, 4, 5), (4, 5, 0, 1))
    del tmp171
    tmp149 = einsum(v.baa.xvv, (0, 1, 2), tmp19, (0, 3, 4), (4, 3, 1, 2))
    del tmp19
    tmp123 = einsum(v.bbb.xov, (0, 1, 2), tmp122, (3, 2), (0, 1, 3)) * 0.5
    del tmp122
    tmp123 += einsum(l1.bb, (0, 1), tmp5, (2, 1, 3), (2, 3, 0)) * 0.5
    tmp112 = einsum(t2.abab, (0, 1, 2, 3), tmp104, (4, 2, 5, 3), (0, 4, 1, 5)) * 0.5
    tmp112 += einsum(t2.abab, (0, 1, 2, 3), tmp105, (0, 4, 5, 3), (4, 5, 1, 2)) * -0.5
    del tmp105
    tmp112 += einsum(tmp106, (0, 1, 2, 3), t2.abab, (4, 0, 5, 3), (4, 2, 1, 5)) * -0.5
    del tmp106
    tmp112 += einsum(tmp86, (0, 1, 2), tmp5, (0, 3, 4), (1, 4, 3, 2)) * 0.5
    tmp112 += einsum(t2.abab, (0, 1, 2, 3), tmp109, (4, 3), (0, 4, 1, 2)) * 0.5
    tmp112 += einsum(tmp111, (0, 1, 2, 3), t1.aa, (0, 4), (1, 3, 2, 4)) * -0.5
    del tmp111
    tmp145 = np.copy(f.bb.vv)
    tmp145 += np.transpose(tmp144, (1, 0))
    del tmp144
    tmp142 = einsum(l1.bb, (0, 1), tmp7, (2, 3, 0), (2, 3, 1)) * 0.25
    tmp142 += einsum(v.baa.xvv, (0, 1, 2), tmp134, (3, 4, 1, 2), (0, 4, 3)) * 0.25
    del tmp134
    tmp142 += einsum(v.bbb.xvv, (0, 1, 2), tmp135, (3, 4, 1, 2), (0, 4, 3)) * 0.25
    del tmp135
    tmp142 += einsum(tmp61, (0, 1, 2, 3), tmp86, (4, 0, 3), (4, 2, 1)) * 0.25
    tmp142 += einsum(tmp63, (0, 1, 2, 3), tmp10, (4, 0, 3), (4, 2, 1)) * 0.5
    del tmp63
    tmp142 += einsum(tmp136, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 2, 0)) * -0.5
    del tmp136
    tmp142 += einsum(tmp137, (0, 1, 2, 3), v.baa.xov, (4, 0, 3), (4, 2, 1)) * 0.25
    del tmp137
    tmp142 += einsum(tmp97, (0, 1, 2, 3), tmp1, (4, 0, 1), (4, 3, 2)) * -0.25
    tmp142 += einsum(tmp97, (0, 1, 2, 3), v.baa.xoo, (4, 0, 1), (4, 3, 2)) * -0.25
    tmp142 += einsum(tmp140, (0, 1, 2, 3), tmp4, (4, 0, 2), (4, 3, 1)) * -0.5
    tmp142 += einsum(tmp140, (0, 1, 2, 3), v.bbb.xoo, (4, 0, 2), (4, 3, 1)) * -0.5
    del tmp140
    tmp142 += einsum(tmp141, (0, 1), v.bbb.xov, (2, 3, 1), (2, 0, 3)) * -0.25
    del tmp141
    tmp142 += einsum(tmp68, (0, 1), v.bbb.xoo, (2, 3, 0), (2, 1, 3)) * -0.25
    del tmp68
    tmp128 = np.copy(f.bb.oo)
    tmp128 += tmp124 * -1
    del tmp124
    tmp128 += einsum(tmp125, (0, 1, 2), v.bbb.xov, (0, 3, 2), (1, 3)) * 2
    del tmp125
    tmp128 += np.transpose(tmp126, (1, 0))
    del tmp126
    tmp128 += np.transpose(tmp127, (1, 0))
    del tmp127
    tmp143 = np.copy(tmp65) * 0.5
    del tmp65
    tmp143 += tmp66 * 0.5
    del tmp66
    tmp143 += tmp67
    del tmp67
    tmp133 = np.copy(tmp129) * -0.25
    del tmp129
    tmp133 += tmp130 * -0.5
    del tmp130
    tmp133 += tmp131 * -0.25
    del tmp131
    tmp133 += tmp132 * -0.5
    del tmp132
    tmp133 += einsum(l2.abab, (0, 1, 2, 3), tmp86, (4, 2, 0), (4, 3, 1)) * 0.25
    tmp133 += einsum(tmp10, (0, 1, 2), l2.bbbb, (3, 2, 4, 1), (0, 4, 3)) * 0.5
    tmp121 = einsum(t2.bbbb, (0, 1, 2, 3), tmp113, (4, 2, 5, 3), (4, 0, 1, 5))
    del tmp113
    tmp121 += einsum(t2.bbbb, (0, 1, 2, 3), tmp114, (1, 4, 5, 3), (5, 0, 4, 2)) * -2
    tmp121 += einsum(tmp115, (0, 1, 2), tmp5, (0, 3, 4), (4, 1, 3, 2))
    del tmp115
    tmp121 += einsum(t2.bbbb, (0, 1, 2, 3), tmp109, (4, 3), (4, 0, 1, 2))
    tmp121 += einsum(tmp7, (0, 1, 2), tmp5, (0, 3, 4), (4, 3, 1, 2)) * -1
    del tmp7, tmp5
    tmp121 += einsum(tmp120, (0, 1, 2, 3), t1.bb, (0, 4), (1, 3, 2, 4)) * -1
    del tmp120
    tmp76 = np.copy(tmp40)
    del tmp40
    tmp76 += tmp45
    del tmp45
    tmp76 += tmp58 * -1
    del tmp58
    tmp76 += tmp71 * -1
    del tmp71
    tmp76 += tmp73 * -1
    del tmp73
    tmp76 += tmp75 * -1
    del tmp75
    tmp99 = einsum(l1.aa, (0, 1), tmp27, (2, 3, 0), (2, 3, 1))
    tmp99 += einsum(v.bbb.xvv, (0, 1, 2), tmp88, (3, 4, 2, 1), (0, 4, 3))
    del tmp88
    tmp99 += einsum(v.baa.xvv, (0, 1, 2), tmp89, (3, 4, 1, 2), (0, 4, 3)) * 4
    del tmp89
    tmp99 += einsum(tmp86, (0, 1, 2), tmp48, (1, 3, 4, 2), (0, 4, 3)) * 2
    del tmp48
    tmp99 += einsum(tmp10, (0, 1, 2), tmp50, (3, 4, 1, 2), (0, 4, 3))
    tmp99 += einsum(tmp90, (0, 1, 2, 3), v.baa.xov, (4, 1, 3), (4, 2, 0)) * -2
    del tmp90
    tmp99 += einsum(tmp91, (0, 1, 2, 3), v.bbb.xov, (4, 2, 3), (4, 1, 0))
    del tmp91
    tmp99 += einsum(tmp1, (0, 1, 2), tmp94, (1, 3, 2, 4), (0, 4, 3)) * -2
    del tmp1
    tmp99 += einsum(v.baa.xoo, (0, 1, 2), tmp94, (1, 3, 2, 4), (0, 4, 3)) * -2
    del tmp94
    tmp99 += einsum(tmp97, (0, 1, 2, 3), tmp4, (4, 2, 3), (4, 1, 0)) * -1
    del tmp4
    tmp99 += einsum(v.bbb.xoo, (0, 1, 2), tmp97, (3, 4, 1, 2), (0, 4, 3)) * -1
    del tmp97
    tmp99 += einsum(tmp98, (0, 1), v.baa.xov, (2, 3, 1), (2, 0, 3)) * -2
    del tmp98
    tmp99 += einsum(tmp55, (0, 1), v.baa.xoo, (2, 3, 0), (2, 1, 3)) * -2
    del tmp55
    tmp87 = np.copy(tmp82) * -1
    del tmp82
    tmp87 += tmp83 * -0.5
    del tmp83
    tmp87 += tmp84 * -1
    del tmp84
    tmp87 += tmp85 * -0.5
    del tmp85
    tmp87 += einsum(l2.aaaa, (0, 1, 2, 3), tmp86, (4, 3, 1), (4, 2, 0))
    del tmp86
    tmp87 += einsum(tmp10, (0, 1, 2), l2.abab, (3, 2, 4, 1), (0, 4, 3)) * 0.5
    tmp21 = einsum(tmp0, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp21 += einsum(t2.abab, (0, 1, 2, 3), tmp3, (0, 4, 5, 2), (5, 4, 1, 3)) * -1
    del tmp3
    tmp21 += einsum(tmp6, (0, 1, 2, 3), t2.abab, (4, 1, 3, 5), (0, 4, 2, 5)) * -1
    del tmp6
    tmp21 += einsum(tmp10, (0, 1, 2), tmp2, (0, 3, 4), (4, 3, 1, 2))
    del tmp10
    tmp21 += einsum(t2.abab, (0, 1, 2, 3), tmp16, (4, 2), (4, 0, 1, 3))
    tmp21 += einsum(tmp20, (0, 1, 2, 3), t1.bb, (2, 4), (1, 0, 3, 4)) * -1
    del tmp20
    tmp33 = einsum(tmp22, (0, 1, 2, 3), t2.aaaa, (4, 5, 1, 3), (0, 4, 5, 2)) * 0.5
    del tmp22
    tmp33 += einsum(t2.aaaa, (0, 1, 2, 3), tmp23, (4, 1, 5, 3), (4, 0, 5, 2)) * -1
    tmp33 += einsum(tmp2, (0, 1, 2), tmp26, (0, 3, 4), (2, 3, 1, 4)) * 0.5
    del tmp26
    tmp33 += einsum(tmp16, (0, 1), t2.aaaa, (2, 3, 4, 1), (0, 2, 3, 4)) * 0.5
    tmp33 += einsum(tmp2, (0, 1, 2), tmp27, (0, 3, 4), (2, 1, 3, 4)) * -0.5
    del tmp27
    tmp33 += einsum(tmp32, (0, 1, 2, 3), t1.aa, (0, 4), (1, 3, 2, 4)) * -0.5
    del tmp32
    tmp100 = np.copy(tmp52)
    del tmp52
    tmp100 += tmp53 * 2
    del tmp53
    tmp100 += tmp54
    del tmp54
    tmp103 = np.copy(f.aa.vv)
    tmp103 += np.transpose(tmp102, (1, 0))
    del tmp102
    tmp81 = np.copy(f.aa.oo)
    tmp81 += tmp77 * -1
    del tmp77
    tmp81 += einsum(v.baa.xov, (0, 1, 2), tmp78, (0, 3, 2), (3, 1))
    del tmp78
    tmp81 += np.transpose(tmp79, (1, 0))
    del tmp79
    tmp81 += tmp80
    del tmp80
    tmp37 = einsum(v.baa.xov, (0, 1, 2), tmp36, (3, 2), (0, 1, 3)) * 2
    del tmp36
    tmp37 += einsum(tmp2, (0, 1, 2), l1.aa, (3, 1), (0, 2, 3))
    del tmp2
    l2new.bbbb = np.copy(np.transpose(tmp117, (3, 2, 1, 0)))
    l2new.bbbb += einsum(tmp114, (0, 1, 2, 3), l1.bb, (4, 1), (3, 4, 2, 0)) * -1
    del tmp114
    l2new.bbbb += np.transpose(tmp117, (2, 3, 1, 0)) * -1
    del tmp117
    l2new.bbbb += np.transpose(tmp212, (3, 2, 0, 1))
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp213, (3, 4, 5, 1), (5, 0, 2, 4)) * 2
    del tmp213
    l2new.bbbb += einsum(v.bbb.xov, (0, 1, 2), tmp214, (0, 3, 4), (2, 4, 3, 1)) * -1
    del tmp214
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp198, (3, 4), (0, 1, 2, 4)) * -2
    l2new.bbbb += einsum(tmp215, (0, 1), l1.bb, (2, 3), (1, 2, 3, 0)) * -1
    del tmp215
    l2new.bbbb += np.transpose(tmp216, (2, 3, 0, 1)) * -2
    l2new.bbbb += np.transpose(tmp217, (3, 2, 1, 0))
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp218, (3, 4), (0, 1, 4, 2)) * 2
    del tmp218
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp196, (2, 3), (3, 0, 2, 1))
    l2new.bbbb += np.transpose(tmp216, (3, 2, 1, 0)) * -2
    l2new.bbbb += np.transpose(tmp217, (2, 3, 0, 1))
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp196, (2, 3), (0, 3, 1, 2))
    l2new.bbbb += np.transpose(tmp216, (3, 2, 0, 1)) * 2
    del tmp216
    l2new.bbbb += np.transpose(tmp217, (2, 3, 1, 0)) * -1
    del tmp217
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp196, (2, 3), (0, 3, 2, 1)) * -1
    l2new.bbbb += np.transpose(tmp219, (3, 2, 1, 0)) * 2
    del tmp219
    l2new.bbbb += np.transpose(tmp221, (2, 3, 1, 0)) * -2
    del tmp221
    l2new.bbbb += np.transpose(tmp222, (2, 3, 1, 0)) * 2
    l2new.bbbb += einsum(tmp223, (0, 1), l2.bbbb, (2, 0, 3, 4), (1, 2, 3, 4)) * -1
    del tmp223
    l2new.bbbb += np.transpose(tmp224, (2, 3, 1, 0)) * -2
    l2new.bbbb += np.transpose(tmp225, (2, 3, 1, 0)) * -1
    l2new.bbbb += np.transpose(tmp222, (3, 2, 1, 0)) * -2
    del tmp222
    l2new.bbbb += np.transpose(tmp225, (3, 2, 1, 0)) * 2
    del tmp225
    l2new.bbbb += np.transpose(tmp224, (3, 2, 1, 0)) * 2
    del tmp224
    l2new.bbbb += np.transpose(tmp226, (2, 3, 0, 1)) * -2
    l2new.bbbb += np.transpose(tmp226, (2, 3, 1, 0)) * 2
    del tmp226
    l2new.bbbb += einsum(tmp227, (0, 1, 2, 3), l2.bbbb, (4, 5, 0, 2), (4, 5, 1, 3)) * -2
    del tmp227
    l2new.bbbb += einsum(tmp211, (0, 1, 2, 3), l1.bb, (4, 1), (3, 4, 0, 2))
    del tmp211
    l2new.bbbb += np.transpose(tmp212, (3, 2, 1, 0)) * -1
    del tmp212
    l2new.bbbb += einsum(tmp107, (0, 1), l1.bb, (2, 3), (1, 2, 3, 0))
    l2new.bbbb += np.transpose(tmp228, (3, 2, 0, 1)) * -1
    l2new.bbbb += np.transpose(tmp229, (3, 2, 0, 1)) * -2
    l2new.bbbb += np.transpose(tmp230, (3, 2, 0, 1)) * -2
    l2new.bbbb += np.transpose(tmp228, (2, 3, 0, 1))
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp107, (2, 3), (0, 3, 1, 2)) * -1
    l2new.bbbb += np.transpose(tmp229, (2, 3, 0, 1)) * 2
    l2new.bbbb += np.transpose(tmp230, (2, 3, 0, 1)) * 2
    l2new.bbbb += np.transpose(tmp228, (3, 2, 1, 0))
    l2new.bbbb += einsum(tmp107, (0, 1), l1.bb, (2, 3), (1, 2, 0, 3)) * -1
    l2new.bbbb += np.transpose(tmp229, (3, 2, 1, 0)) * 2
    l2new.bbbb += np.transpose(tmp230, (3, 2, 1, 0)) * 2
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp107, (2, 3), (0, 3, 2, 1))
    l2new.bbbb += np.transpose(tmp228, (2, 3, 1, 0)) * -1
    del tmp228
    l2new.bbbb += np.transpose(tmp229, (2, 3, 1, 0)) * -2
    del tmp229
    l2new.bbbb += np.transpose(tmp230, (2, 3, 1, 0)) * -2
    del tmp230
    l2new.abab = np.copy(np.transpose(tmp17, (2, 3, 0, 1)))
    del tmp17
    l2new.abab += einsum(l1.bb, (0, 1), tmp188, (2, 3, 1, 4), (4, 0, 2, 3)) * -1
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp156, (4, 2, 5, 0), (5, 1, 4, 3)) * -1
    del tmp156
    l2new.abab += einsum(tmp192, (0, 1, 2), v.baa.xov, (0, 3, 4), (4, 2, 3, 1))
    del tmp192
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp168, (2, 4), (0, 1, 4, 3)) * -1
    l2new.abab += einsum(tmp169, (0, 1), l1.bb, (2, 3), (1, 2, 0, 3))
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp194, (4, 3, 5, 1), (0, 5, 2, 4)) * -1
    del tmp194
    l2new.abab += einsum(v.bbb.xov, (0, 1, 2), tmp162, (0, 3, 4), (4, 2, 3, 1))
    del tmp162
    l2new.abab += einsum(l1.aa, (0, 1), tmp196, (2, 3), (0, 3, 1, 2))
    del tmp196
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp197, (3, 4, 0, 5), (5, 1, 2, 4)) * -1
    del tmp197
    l2new.abab += einsum(tmp198, (0, 1), l2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -1
    del tmp198
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), tmp0, (1, 4, 3, 5), (4, 5, 0, 2)) * -1
    del tmp0
    l2new.abab += np.transpose(tmp200, (2, 3, 0, 1))
    del tmp200
    l2new.abab += np.transpose(tmp201, (2, 3, 0, 1))
    del tmp201
    l2new.abab += einsum(tmp176, (0, 1), l2.abab, (0, 2, 3, 4), (1, 2, 3, 4))
    l2new.abab += einsum(tmp166, (0, 1), tmp50, (2, 0, 3, 4), (1, 4, 2, 3)) * -1
    del tmp166
    l2new.abab += einsum(tmp104, (0, 1, 2, 3), tmp61, (4, 5, 0, 2), (1, 3, 4, 5)) * -1
    del tmp104
    l2new.abab += einsum(tmp203, (0, 1), l2.abab, (2, 0, 3, 4), (2, 1, 3, 4))
    del tmp203
    l2new.abab += einsum(tmp204, (0, 1), tmp61, (2, 3, 0, 4), (4, 1, 2, 3)) * -1
    del tmp204
    l2new.abab += einsum(tmp205, (0, 1, 2, 3), l1.aa, (4, 1), (4, 3, 0, 2)) * -1
    l2new.abab += einsum(tmp206, (0, 1, 2, 3), l2.abab, (4, 5, 0, 2), (4, 5, 1, 3))
    del tmp206
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp207, (2, 4, 1, 5), (0, 5, 4, 3)) * -1
    del tmp207
    l2new.abab += einsum(tmp182, (0, 1, 2), v.bbb.xov, (0, 3, 4), (2, 4, 1, 3)) * -1
    del tmp182
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), tmp188, (1, 4, 2, 5), (5, 3, 0, 4))
    del tmp188
    l2new.abab += einsum(tmp208, (0, 1, 2), v.baa.xov, (0, 3, 4), (4, 2, 3, 1)) * -1
    del tmp208
    l2new.abab += einsum(tmp205, (0, 1, 2, 3), tmp61, (1, 4, 2, 5), (5, 3, 0, 4))
    del tmp205
    l2new.abab += einsum(tmp11, (0, 1), l1.bb, (2, 3), (1, 2, 0, 3)) * -1
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), tmp184, (4, 0, 1, 5), (5, 3, 4, 2))
    del tmp184
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), tmp186, (0, 1, 4, 5), (5, 3, 4, 2))
    del tmp50, tmp186
    l2new.abab += einsum(tmp61, (0, 1, 2, 3), tmp209, (1, 2, 4, 5), (3, 5, 0, 4))
    del tmp209
    l2new.abab += einsum(tmp210, (0, 1, 2, 3), tmp61, (4, 1, 2, 5), (5, 3, 4, 0))
    del tmp61, tmp210
    l2new.abab += einsum(tmp107, (0, 1), l1.aa, (2, 3), (2, 1, 3, 0)) * -1
    del tmp107
    l2new.aaaa = np.copy(np.transpose(tmp29, (3, 2, 1, 0)))
    l2new.aaaa += einsum(tmp23, (0, 1, 2, 3), l1.aa, (4, 2), (3, 4, 0, 1)) * -1
    del tmp23
    l2new.aaaa += np.transpose(tmp29, (2, 3, 1, 0)) * -1
    del tmp29
    l2new.aaaa += np.transpose(tmp148, (3, 2, 0, 1))
    l2new.aaaa += einsum(l2.aaaa, (0, 1, 2, 3), tmp149, (3, 4, 5, 1), (5, 0, 2, 4)) * 2
    del tmp149
    l2new.aaaa += einsum(v.baa.xov, (0, 1, 2), tmp153, (0, 3, 4), (2, 4, 3, 1)) * -1
    del tmp153
    l2new.aaaa += einsum(l2.aaaa, (0, 1, 2, 3), tmp154, (3, 4), (0, 1, 2, 4)) * -2
    del tmp154
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp155, (2, 3), (3, 0, 1, 2)) * -1
    del tmp155
    l2new.aaaa += np.transpose(tmp157, (2, 3, 0, 1)) * -2
    l2new.aaaa += np.transpose(tmp163, (3, 2, 1, 0))
    l2new.aaaa += einsum(tmp168, (0, 1), l2.aaaa, (2, 3, 4, 0), (2, 3, 1, 4)) * 2
    del tmp168
    l2new.aaaa += einsum(tmp169, (0, 1), l1.aa, (2, 3), (1, 2, 0, 3))
    l2new.aaaa += np.transpose(tmp157, (3, 2, 1, 0)) * -2
    l2new.aaaa += np.transpose(tmp163, (2, 3, 0, 1))
    l2new.aaaa += einsum(tmp169, (0, 1), l1.aa, (2, 3), (2, 1, 3, 0))
    l2new.aaaa += np.transpose(tmp157, (3, 2, 0, 1)) * 2
    del tmp157
    l2new.aaaa += np.transpose(tmp163, (2, 3, 1, 0)) * -1
    del tmp163
    l2new.aaaa += einsum(tmp169, (0, 1), l1.aa, (2, 3), (2, 1, 0, 3)) * -1
    del tmp169
    l2new.aaaa += np.transpose(tmp170, (2, 3, 1, 0)) * 2
    l2new.aaaa += np.transpose(tmp172, (2, 3, 1, 0)) * -2
    del tmp172
    l2new.aaaa += np.transpose(tmp173, (3, 2, 1, 0)) * 2
    del tmp173
    l2new.aaaa += einsum(l2.aaaa, (0, 1, 2, 3), tmp176, (1, 4), (4, 0, 2, 3)) * -1
    del tmp176
    l2new.aaaa += np.transpose(tmp177, (2, 3, 1, 0)) * -2
    l2new.aaaa += np.transpose(tmp179, (2, 3, 1, 0)) * -1
    l2new.aaaa += np.transpose(tmp170, (3, 2, 1, 0)) * -2
    del tmp170
    l2new.aaaa += np.transpose(tmp179, (3, 2, 1, 0)) * 2
    del tmp179
    l2new.aaaa += np.transpose(tmp177, (3, 2, 1, 0)) * 2
    del tmp177
    l2new.aaaa += np.transpose(tmp180, (2, 3, 0, 1)) * -2
    l2new.aaaa += np.transpose(tmp180, (2, 3, 1, 0)) * 2
    del tmp180
    l2new.aaaa += einsum(l2.aaaa, (0, 1, 2, 3), tmp181, (2, 4, 3, 5), (0, 1, 4, 5)) * -2
    del tmp181
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp147, (2, 1, 3, 4), (4, 0, 2, 3))
    del tmp147
    l2new.aaaa += np.transpose(tmp148, (3, 2, 1, 0)) * -1
    del tmp148
    l2new.aaaa += einsum(tmp11, (0, 1), l1.aa, (2, 3), (1, 2, 3, 0))
    l2new.aaaa += np.transpose(tmp183, (3, 2, 0, 1)) * -1
    l2new.aaaa += np.transpose(tmp185, (3, 2, 0, 1)) * -2
    l2new.aaaa += np.transpose(tmp187, (3, 2, 0, 1)) * -2
    l2new.aaaa += np.transpose(tmp183, (2, 3, 0, 1))
    l2new.aaaa += einsum(tmp11, (0, 1), l1.aa, (2, 3), (2, 1, 3, 0)) * -1
    l2new.aaaa += np.transpose(tmp185, (2, 3, 0, 1)) * 2
    l2new.aaaa += np.transpose(tmp187, (2, 3, 0, 1)) * 2
    l2new.aaaa += np.transpose(tmp183, (3, 2, 1, 0))
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp11, (2, 3), (3, 0, 2, 1)) * -1
    l2new.aaaa += np.transpose(tmp185, (3, 2, 1, 0)) * 2
    l2new.aaaa += np.transpose(tmp187, (3, 2, 1, 0)) * 2
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp11, (2, 3), (0, 3, 2, 1))
    del tmp11
    l2new.aaaa += np.transpose(tmp183, (2, 3, 1, 0)) * -1
    del tmp183
    l2new.aaaa += np.transpose(tmp185, (2, 3, 1, 0)) * -2
    del tmp185
    l2new.aaaa += np.transpose(tmp187, (2, 3, 1, 0)) * -2
    del tmp187
    l1new.bb = np.copy(np.transpose(f.bb.ov, (1, 0)))
    l1new.bb += einsum(tmp112, (0, 1, 2, 3), l2.abab, (3, 4, 0, 2), (4, 1)) * -2
    del tmp112
    l1new.bb += einsum(tmp121, (0, 1, 2, 3), l2.bbbb, (4, 3, 1, 2), (4, 0)) * 2
    del tmp121
    l1new.bb += einsum(v.bbb.xvv, (0, 1, 2), tmp123, (0, 3, 2), (1, 3)) * -2
    del tmp123
    l1new.bb += einsum(tmp76, (0,), v.bbb.xov, (0, 1, 2), (2, 1))
    l1new.bb += einsum(l1.bb, (0, 1), tmp128, (1, 2), (0, 2)) * -1
    del tmp128
    l1new.bb += einsum(v.bbb.xvv, (0, 1, 2), tmp133, (0, 3, 2), (1, 3)) * 4
    del tmp133
    l1new.bb += einsum(v.bbb.xov, (0, 1, 2), tmp142, (0, 1, 3), (2, 3)) * -4
    del tmp142
    l1new.bb += einsum(tmp109, (0, 1), tmp143, (2, 0), (1, 2)) * -2
    del tmp109, tmp143
    l1new.bb += einsum(tmp145, (0, 1), l1.bb, (0, 2), (1, 2))
    del tmp145
    l1new.aa = np.copy(np.transpose(f.aa.ov, (1, 0)))
    l1new.aa += einsum(l2.abab, (0, 1, 2, 3), tmp21, (4, 2, 3, 1), (0, 4)) * -1
    del tmp21
    l1new.aa += einsum(tmp33, (0, 1, 2, 3), l2.aaaa, (4, 3, 1, 2), (4, 0)) * 4
    del tmp33
    l1new.aa += einsum(tmp37, (0, 1, 2), v.baa.xvv, (0, 3, 2), (3, 1)) * -1
    del tmp37
    l1new.aa += einsum(tmp76, (0,), v.baa.xov, (0, 1, 2), (2, 1))
    del tmp76
    l1new.aa += einsum(tmp81, (0, 1), l1.aa, (2, 0), (2, 1)) * -1
    del tmp81
    l1new.aa += einsum(v.baa.xvv, (0, 1, 2), tmp87, (0, 3, 2), (1, 3)) * 2
    del tmp87
    l1new.aa += einsum(tmp99, (0, 1, 2), v.baa.xov, (0, 1, 3), (3, 2)) * -1
    del tmp99
    l1new.aa += einsum(tmp16, (0, 1), tmp100, (2, 0), (1, 2)) * -1
    del tmp16, tmp100
    l1new.aa += einsum(l1.aa, (0, 1), tmp103, (0, 2), (2, 1))
    del tmp103

    return {f"l1new": l1new, f"l2new": l2new}

def make_rdm1_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:56:01.508347.

    Parameters
    ----------
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm1 : Namespace of arrays
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    rdm1.aa = Namespace()
    rdm1.bb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    tmp3 = einsum(t1.bb, (0, 1), l1.bb, (1, 2), (2, 0))
    tmp4 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    tmp5 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    tmp1 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 1), (4, 0))
    tmp0 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    tmp2 = einsum(l1.aa, (0, 1), t1.aa, (2, 0), (1, 2))
    tmp11 = np.copy(tmp3)
    tmp11 += tmp4
    tmp11 += tmp5 * 2
    tmp9 = einsum(l2.abab, (0, 1, 2, 3), t1.bb, (4, 1), (2, 3, 4, 0))
    tmp10 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp7 = einsum(t1.aa, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp8 = np.copy(tmp2) * 0.5
    tmp8 += tmp1
    tmp8 += tmp0 * 0.5
    tmp6 = einsum(l2.abab, (0, 1, 2, 3), t1.aa, (4, 0), (2, 4, 3, 1))
    rdm1.bb.vv = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 1), (0, 4)) * 2
    rdm1.bb.vv += einsum(t1.bb, (0, 1), l1.bb, (2, 0), (2, 1))
    rdm1.bb.vv += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    rdm1.aa.vv = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    rdm1.aa.vv += einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4)) * 2
    rdm1.aa.vv += einsum(t1.aa, (0, 1), l1.aa, (2, 0), (2, 1))
    rdm1.bb.vo = np.copy(l1.bb)
    rdm1.aa.vo = np.copy(l1.aa)
    rdm1.bb.ov = einsum(t2.abab, (0, 1, 2, 3), l1.aa, (2, 0), (1, 3))
    rdm1.bb.ov += t1.bb
    rdm1.bb.ov += einsum(l1.bb, (0, 1), t2.bbbb, (2, 1, 3, 0), (2, 3)) * 2
    rdm1.bb.ov += einsum(t2.abab, (0, 1, 2, 3), tmp9, (0, 1, 4, 2), (4, 3)) * -1
    del tmp9
    rdm1.bb.ov += einsum(tmp10, (0, 1, 2, 3), t2.bbbb, (1, 0, 4, 3), (2, 4)) * -2
    del tmp10
    rdm1.bb.ov += einsum(t1.bb, (0, 1), tmp11, (0, 2), (2, 1)) * -1
    del tmp11
    rdm1.aa.ov = np.copy(t1.aa)
    rdm1.aa.ov += einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2))
    rdm1.aa.ov += einsum(l1.aa, (0, 1), t2.aaaa, (2, 1, 3, 0), (2, 3)) * 2
    rdm1.aa.ov += einsum(tmp6, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (1, 4)) * -1
    del tmp6
    rdm1.aa.ov += einsum(t2.aaaa, (0, 1, 2, 3), tmp7, (1, 0, 4, 3), (4, 2)) * -2
    del tmp7
    rdm1.aa.ov += einsum(tmp8, (0, 1), t1.aa, (0, 2), (1, 2)) * -2
    del tmp8
    rdm1.bb.oo = np.copy(np.transpose(tmp3, (1, 0))) * -1
    del tmp3
    rdm1.bb.oo += delta.bb.oo
    rdm1.bb.oo += np.transpose(tmp4, (1, 0)) * -1
    del tmp4
    rdm1.bb.oo += np.transpose(tmp5, (1, 0)) * -2
    del tmp5
    rdm1.aa.oo = np.copy(delta.aa.oo)
    del delta
    rdm1.aa.oo += np.transpose(tmp0, (1, 0)) * -1
    del tmp0
    rdm1.aa.oo += np.transpose(tmp1, (1, 0)) * -2
    del tmp1
    rdm1.aa.oo += np.transpose(tmp2, (1, 0)) * -1
    del tmp2
    rdm1.aa = np.block([[rdm1.aa.oo, rdm1.aa.ov], [rdm1.aa.vo, rdm1.aa.vv]])
    rdm1.bb = np.block([[rdm1.bb.oo, rdm1.bb.ov], [rdm1.bb.vo, rdm1.bb.vv]])

    return rdm1

def make_rdm2_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:57:05.288911.

    Parameters
    ----------
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm2 : Namespace of arrays
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    rdm2.aaaa = Namespace()
    rdm2.abab = Namespace()
    rdm2.bbbb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    tmp18 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp14 = einsum(l2.abab, (0, 1, 2, 3), t1.bb, (4, 1), (2, 3, 4, 0))
    tmp8 = einsum(t1.bb, (0, 1), l1.bb, (1, 2), (2, 0))
    tmp9 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    tmp10 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    tmp1 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 1), (4, 0))
    tmp0 = einsum(l1.aa, (0, 1), t1.aa, (2, 0), (1, 2))
    tmp2 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    tmp6 = einsum(t1.aa, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp26 = einsum(l2.abab, (0, 1, 2, 3), t1.aa, (4, 0), (2, 4, 3, 1))
    tmp90 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp92 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 5), (3, 4, 1, 5))
    tmp69 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp67 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp19 = einsum(t1.bb, (0, 1), tmp18, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp17 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp52 = einsum(t2.abab, (0, 1, 2, 3), tmp14, (0, 4, 5, 2), (4, 5, 1, 3))
    tmp51 = einsum(tmp18, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 2, 4, 5)) * -1
    tmp16 = np.copy(tmp8)
    tmp16 += tmp9
    tmp16 += tmp10 * 2
    tmp13 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 5, 0, 1), (2, 4, 3, 5))
    tmp15 = einsum(tmp14, (0, 1, 2, 3), t1.aa, (4, 3), (0, 4, 1, 2))
    tmp12 = np.copy(tmp0) * 0.5
    tmp12 += tmp1
    tmp12 += tmp2 * 0.5
    tmp7 = einsum(tmp6, (0, 1, 2, 3), t1.aa, (4, 3), (0, 1, 4, 2))
    tmp5 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp30 = einsum(tmp6, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (0, 2, 4, 5)) * -1
    tmp31 = einsum(t2.abab, (0, 1, 2, 3), tmp26, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp122 = np.copy(tmp92)
    tmp122 += tmp90 * 4
    tmp79 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    tmp106 = einsum(t1.bb, (0, 1), l1.bb, (2, 0), (2, 1))
    tmp80 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 1), (0, 4))
    tmp109 = einsum(t1.bb, (0, 1), tmp18, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp112 = einsum(l2.abab, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp88 = einsum(l2.aaaa, (0, 1, 2, 3), t2.abab, (3, 4, 1, 5), (2, 4, 0, 5))
    tmp63 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    tmp62 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4))
    tmp103 = einsum(t1.aa, (0, 1), l1.aa, (2, 0), (2, 1))
    tmp84 = np.copy(tmp67) * 4
    tmp84 += tmp69
    tmp105 = einsum(t1.aa, (0, 1), tmp6, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp82 = einsum(l2.abab, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 0), (4, 3, 5, 1))
    tmp65 = einsum(l2.bbbb, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (4, 2, 5, 0))
    tmp48 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (3, 4), (4, 0, 1, 2))
    tmp54 = np.copy(np.transpose(tmp17, (1, 0, 3, 2)))
    tmp54 += np.transpose(tmp19, (0, 1, 3, 2)) * -1
    tmp101 = np.copy(tmp52)
    tmp101 += tmp51 * 4
    tmp35 = einsum(l1.bb, (0, 1), t2.bbbb, (2, 1, 3, 0), (2, 3))
    tmp34 = einsum(t2.abab, (0, 1, 2, 3), l1.aa, (2, 0), (1, 3))
    tmp38 = einsum(t2.abab, (0, 1, 2, 3), tmp14, (0, 1, 4, 2), (4, 3))
    tmp39 = einsum(t2.bbbb, (0, 1, 2, 3), tmp18, (1, 0, 4, 3), (4, 2))
    tmp49 = einsum(tmp16, (0, 1), t1.bb, (0, 2), (1, 2)) * 0.5
    tmp53 = np.copy(tmp8) * 0.5
    tmp53 += tmp9 * 0.5
    tmp53 += tmp10
    tmp40 = einsum(tmp16, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp59 = einsum(t2.abab, (0, 1, 2, 3), tmp18, (4, 1, 5, 3), (0, 4, 5, 2)) * -1
    tmp60 = einsum(tmp14, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 1, 2, 5))
    tmp44 = np.copy(tmp13)
    tmp44 += tmp15
    tmp25 = einsum(tmp6, (0, 1, 2, 3), t2.aaaa, (1, 0, 4, 3), (2, 4))
    tmp27 = einsum(tmp26, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (1, 4))
    tmp28 = einsum(tmp12, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp42 = einsum(tmp26, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 1, 4, 5))
    tmp43 = einsum(t2.abab, (0, 1, 2, 3), tmp6, (4, 0, 5, 2), (4, 5, 1, 3)) * -1
    tmp20 = einsum(l1.aa, (0, 1), t2.aaaa, (2, 1, 3, 0), (2, 3))
    tmp21 = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2))
    tmp24 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 4), (4, 0, 1, 2))
    tmp4 = np.copy(tmp0)
    tmp4 += tmp1 * 2
    tmp4 += tmp2
    tmp32 = np.copy(np.transpose(tmp5, (1, 0, 3, 2)))
    tmp32 += np.transpose(tmp7, (0, 1, 3, 2)) * -1
    tmp77 = np.copy(tmp30) * 4
    tmp77 += tmp31
    tmp56 = einsum(tmp12, (0, 1), t1.aa, (0, 2), (1, 2)) * 2
    tmp131 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 5, 0, 1), (4, 5, 2, 3))
    tmp129 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 3, 4, 0), (4, 2, 3, 1))
    tmp128 = einsum(l2.abab, (0, 1, 2, 3), t1.bb, (3, 4), (2, 0, 1, 4))
    tmp130 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 5), (0, 1, 4, 5))
    tmp127 = einsum(l2.aaaa, (0, 1, 2, 3), t1.aa, (3, 4), (2, 0, 1, 4))
    tmp123 = einsum(t1.bb, (0, 1), tmp122, (0, 2, 3, 4), (2, 1, 3, 4))
    del tmp122
    tmp114 = np.copy(tmp106) * 0.5
    tmp114 += tmp79 * 0.5
    tmp114 += tmp80
    tmp125 = einsum(t1.bb, (0, 1), tmp109, (0, 2, 3, 4), (2, 3, 4, 1)) * -1
    tmp107 = np.copy(tmp106)
    del tmp106
    tmp107 += tmp79
    tmp107 += tmp80 * 2
    tmp124 = einsum(t2.bbbb, (0, 1, 2, 3), tmp18, (1, 0, 4, 5), (4, 5, 2, 3)) * -1
    tmp120 = einsum(l1.bb, (0, 1), t2.bbbb, (2, 1, 3, 4), (2, 0, 3, 4))
    tmp126 = np.copy(tmp88)
    tmp126 += tmp112
    tmp85 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 5, 1), (3, 4, 0, 5))
    tmp113 = einsum(tmp14, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4))
    tmp110 = np.copy(tmp103)
    tmp110 += tmp62 * 2
    tmp110 += tmp63
    tmp118 = einsum(t2.aaaa, (0, 1, 2, 3), tmp6, (1, 0, 4, 5), (4, 5, 2, 3)) * -1
    tmp117 = einsum(tmp84, (0, 1, 2, 3), t1.aa, (0, 4), (1, 4, 2, 3))
    tmp119 = einsum(tmp105, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 3, 4)) * -1
    tmp115 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (4, 1), (0, 4, 2, 3))
    tmp121 = np.copy(tmp92)
    tmp121 += tmp90 * 4
    tmp83 = np.copy(tmp82)
    tmp83 += tmp65
    tmp108 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 5), (2, 4, 1, 5))
    tmp111 = einsum(tmp26, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    tmp116 = np.copy(tmp67) * 4
    tmp116 += tmp69
    tmp104 = np.copy(tmp103) * 0.5
    del tmp103
    tmp104 += tmp62
    tmp104 += tmp63 * 0.5
    tmp95 = einsum(t1.bb, (0, 1), tmp48, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp91 = einsum(tmp90, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 2), (1, 4, 3, 5))
    tmp99 = einsum(tmp54, (0, 1, 2, 3), t2.bbbb, (0, 1, 4, 5), (2, 3, 4, 5))
    tmp102 = einsum(tmp101, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3))
    del tmp101
    tmp36 = np.copy(t1.bb)
    tmp36 += tmp34
    tmp36 += tmp35 * 2
    tmp98 = einsum(tmp16, (0, 1), t2.bbbb, (2, 0, 3, 4), (2, 1, 3, 4)) * -1
    tmp100 = einsum(tmp54, (0, 1, 2, 3), t1.bb, (0, 4), (1, 3, 2, 4))
    tmp94 = np.copy(tmp34)
    tmp94 += tmp35 * 2
    tmp50 = np.copy(tmp38) * 0.5
    tmp50 += tmp39
    tmp50 += tmp49
    del tmp49
    tmp97 = einsum(tmp53, (0, 1), t2.bbbb, (2, 0, 3, 4), (2, 1, 3, 4)) * -2
    tmp81 = np.copy(tmp79)
    tmp81 += tmp80 * 2
    tmp89 = einsum(tmp88, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5))
    tmp96 = np.copy(tmp79) * 0.5
    del tmp79
    tmp96 += tmp80
    del tmp80
    tmp93 = einsum(t2.bbbb, (0, 1, 2, 3), tmp92, (1, 4, 3, 5), (4, 0, 5, 2))
    tmp47 = np.copy(t1.bb)
    tmp47 += tmp34
    del tmp34
    tmp47 += tmp35 * 2
    del tmp35
    tmp41 = np.copy(tmp38)
    del tmp38
    tmp41 += tmp39 * 2
    del tmp39
    tmp41 += tmp40
    del tmp40
    tmp58 = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 4), (0, 4, 1, 2))
    tmp61 = einsum(t2.abab, (0, 1, 2, 3), tmp26, (0, 4, 5, 3), (4, 5, 1, 2))
    tmp87 = np.copy(tmp60)
    tmp87 += tmp59
    tmp45 = einsum(tmp44, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 3, 4))
    tmp37 = einsum(l1.aa, (0, 1), t2.abab, (2, 3, 0, 4), (1, 2, 3, 4))
    tmp73 = np.copy(tmp62)
    tmp73 += tmp63 * 0.5
    tmp46 = einsum(tmp14, (0, 1, 2, 3), t2.abab, (4, 1, 3, 5), (0, 4, 2, 5))
    tmp29 = np.copy(tmp25)
    tmp29 += tmp27 * 0.5
    tmp29 += tmp28
    del tmp28
    tmp86 = np.copy(tmp43)
    tmp86 += tmp42
    tmp71 = np.copy(tmp20) * 2
    tmp71 += tmp21
    tmp72 = einsum(tmp24, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    tmp74 = einsum(t2.aaaa, (0, 1, 2, 3), tmp4, (1, 4), (4, 0, 2, 3)) * -1
    tmp22 = np.copy(t1.aa)
    tmp22 += tmp20 * 2
    tmp22 += tmp21
    tmp75 = einsum(tmp32, (0, 1, 2, 3), t2.aaaa, (0, 1, 4, 5), (2, 3, 4, 5))
    tmp68 = einsum(t2.aaaa, (0, 1, 2, 3), tmp67, (1, 4, 3, 5), (4, 0, 5, 2))
    tmp78 = einsum(tmp77, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    del tmp77
    tmp64 = np.copy(tmp62) * 2
    del tmp62
    tmp64 += tmp63
    del tmp63
    tmp57 = np.copy(tmp25) * 2
    del tmp25
    tmp57 += tmp27
    del tmp27
    tmp57 += tmp56
    del tmp56
    tmp66 = einsum(t2.abab, (0, 1, 2, 3), tmp65, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp70 = einsum(tmp69, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (4, 1, 5, 3))
    tmp23 = np.copy(t1.aa)
    tmp23 += tmp20 * 2
    del tmp20
    tmp23 += tmp21
    del tmp21
    tmp76 = einsum(tmp32, (0, 1, 2, 3), t1.aa, (0, 4), (1, 3, 2, 4))
    tmp55 = einsum(tmp54, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 3, 4)) * 2
    del tmp54
    tmp33 = einsum(tmp32, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 3, 4)) * 2
    del tmp32
    tmp11 = np.copy(delta.bb.oo) * -1
    tmp11 += tmp8
    del tmp8
    tmp11 += tmp9
    del tmp9
    tmp11 += tmp10 * 2
    del tmp10
    tmp3 = np.copy(delta.aa.oo) * -1
    tmp3 += tmp0
    del tmp0
    tmp3 += tmp1 * 2
    del tmp1
    tmp3 += tmp2
    del tmp2
    rdm2.bbbb.vvvv = np.copy(np.transpose(tmp131, (1, 0, 3, 2))) * 2
    del tmp131
    rdm2.bbbb.vvvv += einsum(tmp129, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3)) * 2
    rdm2.abab.vvvv = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 5), (0, 1, 4, 5))
    rdm2.abab.vvvv += einsum(tmp128, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    rdm2.aaaa.vvvv = np.copy(np.transpose(tmp130, (1, 0, 3, 2))) * 2
    del tmp130
    rdm2.aaaa.vvvv += einsum(t1.aa, (0, 1), tmp127, (0, 2, 3, 4), (2, 3, 1, 4)) * 2
    rdm2.bbbb.vvvo = np.copy(np.transpose(tmp129, (2, 1, 3, 0))) * 2
    rdm2.abab.vvvo = einsum(l2.abab, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    rdm2.aaaa.vvvo = np.copy(np.transpose(tmp127, (2, 1, 3, 0))) * 2
    rdm2.bbbb.vvov = np.copy(np.transpose(tmp129, (2, 1, 0, 3))) * -2
    del tmp129
    rdm2.abab.vvov = np.copy(np.transpose(tmp128, (1, 2, 0, 3)))
    del tmp128
    rdm2.aaaa.vvov = np.copy(np.transpose(tmp127, (2, 1, 0, 3))) * -2
    del tmp127
    rdm2.bbbb.vovv = np.copy(np.transpose(tmp120, (1, 0, 3, 2))) * 2
    rdm2.bbbb.vovv += einsum(tmp107, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.vovv += einsum(tmp114, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.bbbb.vovv += np.transpose(tmp123, (2, 0, 1, 3))
    rdm2.bbbb.vovv += np.transpose(tmp123, (2, 0, 3, 1)) * -1
    rdm2.bbbb.vovv += np.transpose(tmp124, (1, 0, 3, 2)) * 2
    rdm2.bbbb.vovv += np.transpose(tmp125, (1, 0, 3, 2)) * 2
    rdm2.abab.vovv = einsum(t2.abab, (0, 1, 2, 3), l1.aa, (4, 0), (4, 1, 2, 3))
    rdm2.abab.vovv += einsum(tmp110, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.abab.vovv += einsum(t1.aa, (0, 1), tmp126, (0, 2, 3, 4), (3, 2, 1, 4)) * 2
    del tmp126
    rdm2.abab.vovv += einsum(tmp85, (0, 1, 2, 3), t1.bb, (0, 4), (2, 1, 3, 4)) * -1
    rdm2.abab.vovv += einsum(t2.abab, (0, 1, 2, 3), tmp14, (0, 1, 4, 5), (5, 4, 2, 3)) * -1
    rdm2.abab.vovv += einsum(tmp113, (0, 1, 2, 3), t1.aa, (0, 4), (2, 1, 4, 3)) * -1
    rdm2.aaaa.vovv = np.copy(np.transpose(tmp115, (1, 0, 3, 2))) * 2
    rdm2.aaaa.vovv += einsum(tmp110, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.vovv += einsum(tmp110, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.vovv += np.transpose(tmp117, (2, 0, 1, 3))
    rdm2.aaaa.vovv += np.transpose(tmp117, (2, 0, 3, 1)) * -1
    rdm2.aaaa.vovv += np.transpose(tmp118, (1, 0, 3, 2)) * 2
    rdm2.aaaa.vovv += np.transpose(tmp119, (1, 0, 3, 2)) * 2
    rdm2.bbbb.ovvv = np.copy(np.transpose(tmp120, (0, 1, 3, 2))) * -2
    del tmp120
    rdm2.bbbb.ovvv += einsum(tmp107, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.ovvv += einsum(tmp114, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.bbbb.ovvv += einsum(tmp121, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3)) * -1
    del tmp121
    rdm2.bbbb.ovvv += np.transpose(tmp123, (0, 2, 3, 1))
    del tmp123
    rdm2.bbbb.ovvv += np.transpose(tmp124, (0, 1, 3, 2)) * -2
    del tmp124
    rdm2.bbbb.ovvv += np.transpose(tmp125, (0, 1, 3, 2)) * -2
    del tmp125
    rdm2.abab.ovvv = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (4, 1), (0, 4, 2, 3))
    rdm2.abab.ovvv += einsum(tmp114, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.abab.ovvv += einsum(tmp108, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -1
    rdm2.abab.ovvv += einsum(tmp83, (0, 1, 2, 3), t1.bb, (1, 4), (0, 3, 2, 4)) * 2
    rdm2.abab.ovvv += einsum(t2.abab, (0, 1, 2, 3), tmp26, (0, 4, 1, 5), (4, 5, 2, 3)) * -1
    rdm2.abab.ovvv += einsum(tmp111, (0, 1, 2, 3), t1.bb, (1, 4), (0, 3, 2, 4)) * -1
    rdm2.aaaa.ovvv = np.copy(np.transpose(tmp115, (0, 1, 3, 2))) * -2
    del tmp115
    rdm2.aaaa.ovvv += einsum(tmp110, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.ovvv += einsum(tmp110, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ovvv += einsum(t1.aa, (0, 1), tmp116, (0, 2, 3, 4), (2, 3, 1, 4)) * -1
    del tmp116
    rdm2.aaaa.ovvv += np.transpose(tmp117, (0, 2, 3, 1))
    del tmp117
    rdm2.aaaa.ovvv += np.transpose(tmp118, (0, 1, 3, 2)) * -2
    del tmp118
    rdm2.aaaa.ovvv += np.transpose(tmp119, (0, 1, 3, 2)) * -2
    del tmp119
    rdm2.bbbb.vvoo = np.copy(l2.bbbb) * 2
    rdm2.abab.vvoo = np.copy(l2.abab)
    rdm2.aaaa.vvoo = np.copy(l2.aaaa) * 2
    rdm2.bbbb.vovo = einsum(tmp114, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.bbbb.vovo += np.transpose(tmp92, (2, 1, 3, 0)) * -1
    rdm2.bbbb.vovo += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.vovo += np.transpose(tmp90, (2, 1, 3, 0)) * -4
    rdm2.bbbb.vovo += np.transpose(tmp109, (2, 1, 3, 0)) * 2
    rdm2.abab.vovo = einsum(tmp104, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.abab.vovo += np.transpose(tmp85, (2, 1, 3, 0)) * -1
    rdm2.abab.vovo += einsum(tmp14, (0, 1, 2, 3), t1.aa, (0, 4), (3, 2, 4, 1)) * -1
    rdm2.aaaa.vovo = einsum(tmp110, (0, 1), delta.aa.oo, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.vovo += np.transpose(tmp67, (2, 1, 3, 0)) * -4
    rdm2.aaaa.vovo += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.vovo += np.transpose(tmp69, (2, 1, 3, 0)) * -1
    rdm2.aaaa.vovo += np.transpose(tmp105, (2, 1, 3, 0)) * 2
    rdm2.bbbb.voov = einsum(tmp114, (0, 1), delta.bb.oo, (2, 3), (0, 2, 3, 1)) * -2
    del tmp114
    rdm2.bbbb.voov += np.transpose(tmp92, (2, 1, 0, 3))
    rdm2.bbbb.voov += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.voov += np.transpose(tmp90, (2, 1, 0, 3)) * 4
    rdm2.bbbb.voov += np.transpose(tmp109, (2, 1, 0, 3)) * -2
    rdm2.abab.voov = einsum(t1.bb, (0, 1), l1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.abab.voov += np.transpose(tmp112, (2, 1, 0, 3)) * 2
    del tmp112
    rdm2.abab.voov += np.transpose(tmp88, (2, 1, 0, 3)) * 2
    del tmp88
    rdm2.abab.voov += np.transpose(tmp113, (2, 1, 0, 3)) * -1
    del tmp113
    rdm2.aaaa.voov = einsum(delta.aa.oo, (0, 1), tmp104, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.aaaa.voov += np.transpose(tmp67, (2, 1, 0, 3)) * 4
    rdm2.aaaa.voov += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.voov += np.transpose(tmp69, (2, 1, 0, 3))
    rdm2.aaaa.voov += np.transpose(tmp105, (2, 1, 0, 3)) * -2
    rdm2.bbbb.ovvo = einsum(delta.bb.oo, (0, 1), tmp107, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.ovvo += np.transpose(tmp92, (1, 2, 3, 0))
    rdm2.bbbb.ovvo += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.ovvo += np.transpose(tmp90, (1, 2, 3, 0)) * 4
    rdm2.bbbb.ovvo += np.transpose(tmp109, (1, 2, 3, 0)) * -2
    rdm2.abab.ovvo = einsum(t1.aa, (0, 1), l1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.abab.ovvo += np.transpose(tmp65, (0, 3, 2, 1)) * 2
    del tmp65
    rdm2.abab.ovvo += np.transpose(tmp82, (0, 3, 2, 1)) * 2
    del tmp82
    rdm2.abab.ovvo += np.transpose(tmp111, (0, 3, 2, 1)) * -1
    del tmp111
    rdm2.aaaa.ovvo = einsum(tmp110, (0, 1), delta.aa.oo, (2, 3), (2, 0, 1, 3)) * -1
    del tmp110
    rdm2.aaaa.ovvo += np.transpose(tmp67, (1, 2, 3, 0)) * 4
    rdm2.aaaa.ovvo += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.ovvo += np.transpose(tmp69, (1, 2, 3, 0))
    rdm2.aaaa.ovvo += np.transpose(tmp105, (1, 2, 3, 0)) * -2
    rdm2.bbbb.ovov = einsum(delta.bb.oo, (0, 1), tmp107, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.ovov += np.transpose(tmp92, (1, 2, 0, 3)) * -1
    del tmp92
    rdm2.bbbb.ovov += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.ovov += np.transpose(tmp90, (1, 2, 0, 3)) * -4
    del tmp90
    rdm2.bbbb.ovov += np.transpose(tmp109, (1, 2, 0, 3)) * 2
    del tmp109
    rdm2.abab.ovov = einsum(delta.aa.oo, (0, 1), tmp107, (2, 3), (0, 2, 1, 3))
    del tmp107
    rdm2.abab.ovov += np.transpose(tmp108, (1, 2, 0, 3)) * -1
    del tmp108
    rdm2.abab.ovov += einsum(t1.bb, (0, 1), tmp26, (2, 3, 0, 4), (3, 4, 2, 1)) * -1
    rdm2.aaaa.ovov = einsum(delta.aa.oo, (0, 1), tmp104, (2, 3), (0, 2, 1, 3)) * 2
    del tmp104
    rdm2.aaaa.ovov += np.transpose(tmp67, (1, 2, 0, 3)) * -4
    del tmp67
    rdm2.aaaa.ovov += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ovov += np.transpose(tmp69, (1, 2, 0, 3)) * -1
    del tmp69
    rdm2.aaaa.ovov += np.transpose(tmp105, (1, 2, 0, 3)) * 2
    del tmp105
    rdm2.bbbb.oovv = np.copy(t2.bbbb) * 2
    rdm2.bbbb.oovv += einsum(tmp81, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    rdm2.bbbb.oovv += np.transpose(tmp89, (0, 1, 3, 2)) * -2
    rdm2.bbbb.oovv += np.transpose(tmp91, (0, 1, 3, 2)) * -8
    rdm2.bbbb.oovv += np.transpose(tmp93, (0, 1, 3, 2)) * -2
    rdm2.bbbb.oovv += np.transpose(tmp93, (1, 0, 2, 3)) * -2
    rdm2.bbbb.oovv += einsum(tmp47, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.oovv += np.transpose(tmp89, (1, 0, 3, 2)) * 2
    del tmp89
    rdm2.bbbb.oovv += tmp91 * 8
    del tmp91
    rdm2.bbbb.oovv += tmp93 * 2
    rdm2.bbbb.oovv += np.transpose(tmp93, (1, 0, 3, 2)) * 2
    del tmp93
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp36, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp94, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.oovv += einsum(tmp94, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -1
    del tmp94
    rdm2.bbbb.oovv += tmp95 * 2
    rdm2.bbbb.oovv += einsum(t2.bbbb, (0, 1, 2, 3), tmp96, (3, 4), (0, 1, 4, 2)) * 4
    del tmp96
    rdm2.bbbb.oovv += np.transpose(tmp95, (0, 1, 3, 2)) * -2
    del tmp95
    rdm2.bbbb.oovv += np.transpose(tmp97, (0, 1, 3, 2)) * -1
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp41, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.bbbb.oovv += np.transpose(tmp98, (0, 1, 3, 2)) * -1
    rdm2.bbbb.oovv += einsum(tmp41, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3))
    rdm2.bbbb.oovv += np.transpose(tmp98, (1, 0, 3, 2))
    del tmp98
    rdm2.bbbb.oovv += einsum(tmp50, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * 2
    rdm2.bbbb.oovv += np.transpose(tmp97, (1, 0, 3, 2))
    del tmp97
    rdm2.bbbb.oovv += einsum(tmp50, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.bbbb.oovv += np.transpose(tmp99, (1, 0, 3, 2)) * 2
    del tmp99
    rdm2.bbbb.oovv += einsum(tmp100, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3)) * 2
    del tmp100
    rdm2.bbbb.oovv += np.transpose(tmp102, (1, 0, 2, 3))
    rdm2.bbbb.oovv += tmp102 * -1
    rdm2.bbbb.oovv += np.transpose(tmp102, (1, 0, 3, 2)) * -1
    rdm2.bbbb.oovv += np.transpose(tmp102, (0, 1, 3, 2))
    del tmp102
    rdm2.abab.oovv = np.copy(t2.abab)
    rdm2.abab.oovv += einsum(tmp81, (0, 1), t2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -1
    del tmp81
    rdm2.abab.oovv += einsum(tmp83, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5)) * 4
    del tmp83
    rdm2.abab.oovv += einsum(tmp84, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5))
    del tmp84
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp36, (2, 3), (0, 2, 1, 3))
    rdm2.abab.oovv += einsum(tmp71, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.abab.oovv += einsum(tmp37, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -1
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp73, (2, 4), (0, 1, 4, 3)) * -2
    rdm2.abab.oovv += einsum(t1.bb, (0, 1), tmp58, (2, 0, 3, 4), (2, 3, 4, 1)) * -1
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp16, (1, 4), (0, 4, 2, 3)) * -1
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp41, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.abab.oovv += einsum(tmp12, (0, 1), t2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -2
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp44, (0, 4, 1, 5), (4, 5, 2, 3))
    rdm2.abab.oovv += einsum(tmp45, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    rdm2.abab.oovv += einsum(tmp85, (0, 1, 2, 3), t2.abab, (4, 0, 2, 5), (4, 1, 3, 5))
    del tmp85
    rdm2.abab.oovv += einsum(tmp29, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.abab.oovv += einsum(tmp46, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    rdm2.abab.oovv += einsum(tmp86, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -2
    del tmp86
    rdm2.abab.oovv += einsum(tmp87, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4)) * -2
    del tmp87
    rdm2.abab.oovv += einsum(tmp61, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4))
    rdm2.aaaa.oovv = np.copy(t2.aaaa) * 2
    rdm2.aaaa.oovv += einsum(tmp64, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 4, 1)) * -2
    del tmp64
    rdm2.aaaa.oovv += np.transpose(tmp66, (0, 1, 3, 2)) * -2
    rdm2.aaaa.oovv += np.transpose(tmp68, (0, 1, 3, 2)) * -8
    rdm2.aaaa.oovv += np.transpose(tmp70, (0, 1, 3, 2)) * -2
    rdm2.aaaa.oovv += np.transpose(tmp70, (1, 0, 2, 3)) * -2
    rdm2.aaaa.oovv += einsum(tmp22, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.oovv += tmp66 * 2
    del tmp66
    rdm2.aaaa.oovv += tmp68 * 8
    del tmp68
    rdm2.aaaa.oovv += tmp70 * 2
    rdm2.aaaa.oovv += np.transpose(tmp70, (1, 0, 3, 2)) * 2
    del tmp70
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp23, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp71, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.oovv += einsum(tmp71, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -1
    del tmp71
    rdm2.aaaa.oovv += tmp72 * 2
    rdm2.aaaa.oovv += einsum(t2.aaaa, (0, 1, 2, 3), tmp73, (3, 4), (0, 1, 4, 2)) * 4
    del tmp73
    rdm2.aaaa.oovv += np.transpose(tmp72, (0, 1, 3, 2)) * -2
    del tmp72
    rdm2.aaaa.oovv += np.transpose(tmp74, (1, 0, 3, 2)) * -2
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp57, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.aaaa.oovv += einsum(tmp29, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * 2
    rdm2.aaaa.oovv += np.transpose(tmp74, (0, 1, 3, 2)) * 2
    del tmp74
    rdm2.aaaa.oovv += einsum(tmp57, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1))
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp29, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.aaaa.oovv += np.transpose(tmp75, (1, 0, 3, 2)) * 2
    del tmp75
    rdm2.aaaa.oovv += einsum(tmp76, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * 2
    del tmp76
    rdm2.aaaa.oovv += np.transpose(tmp78, (1, 0, 2, 3))
    rdm2.aaaa.oovv += tmp78 * -1
    rdm2.aaaa.oovv += np.transpose(tmp78, (1, 0, 3, 2)) * -1
    rdm2.aaaa.oovv += np.transpose(tmp78, (0, 1, 3, 2))
    del tmp78
    rdm2.bbbb.vooo = einsum(l1.bb, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.vooo += einsum(l1.bb, (0, 1), delta.bb.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.vooo += np.transpose(tmp18, (3, 2, 1, 0)) * 2
    rdm2.abab.vooo = einsum(l1.aa, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.abab.vooo += np.transpose(tmp14, (3, 2, 0, 1)) * -1
    del tmp14
    rdm2.aaaa.vooo = einsum(l1.aa, (0, 1), delta.aa.oo, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.vooo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.vooo += np.transpose(tmp6, (3, 2, 1, 0)) * 2
    rdm2.bbbb.ovoo = einsum(l1.bb, (0, 1), delta.bb.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.ovoo += einsum(l1.bb, (0, 1), delta.bb.oo, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.ovoo += np.transpose(tmp18, (2, 3, 1, 0)) * -2
    del tmp18
    rdm2.abab.ovoo = einsum(delta.aa.oo, (0, 1), l1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.abab.ovoo += np.transpose(tmp26, (1, 3, 0, 2)) * -1
    del tmp26
    rdm2.aaaa.ovoo = einsum(l1.aa, (0, 1), delta.aa.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ovoo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.ovoo += np.transpose(tmp6, (2, 3, 1, 0)) * -2
    del tmp6
    rdm2.bbbb.oovo = einsum(delta.bb.oo, (0, 1), tmp47, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.oovo += einsum(tmp36, (0, 1), delta.bb.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.oovo += np.transpose(tmp48, (2, 1, 3, 0)) * 2
    rdm2.bbbb.oovo += einsum(delta.bb.oo, (0, 1), tmp41, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.bbbb.oovo += einsum(tmp41, (0, 1), delta.bb.oo, (2, 3), (2, 0, 1, 3))
    rdm2.bbbb.oovo += np.transpose(tmp51, (1, 2, 3, 0)) * 4
    rdm2.bbbb.oovo += np.transpose(tmp52, (1, 2, 3, 0))
    rdm2.bbbb.oovo += einsum(tmp16, (0, 1), t1.bb, (2, 3), (1, 2, 3, 0))
    rdm2.bbbb.oovo += np.transpose(tmp51, (2, 1, 3, 0)) * -4
    rdm2.bbbb.oovo += np.transpose(tmp52, (2, 1, 3, 0)) * -1
    rdm2.bbbb.oovo += einsum(t1.bb, (0, 1), tmp16, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.bbbb.oovo += np.transpose(tmp55, (2, 1, 3, 0)) * -1
    rdm2.abab.oovo = einsum(delta.bb.oo, (0, 1), tmp22, (2, 3), (2, 0, 3, 1))
    rdm2.abab.oovo += np.transpose(tmp58, (0, 2, 3, 1)) * -1
    del tmp58
    rdm2.abab.oovo += einsum(tmp29, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.abab.oovo += np.transpose(tmp59, (0, 2, 3, 1)) * -2
    del tmp59
    rdm2.abab.oovo += np.transpose(tmp60, (0, 2, 3, 1)) * -2
    del tmp60
    rdm2.abab.oovo += einsum(tmp53, (0, 1), t1.aa, (2, 3), (2, 1, 3, 0)) * -2
    rdm2.abab.oovo += einsum(tmp44, (0, 1, 2, 3), t1.aa, (0, 4), (1, 3, 4, 2))
    del tmp44
    rdm2.abab.oovo += np.transpose(tmp61, (0, 2, 3, 1))
    del tmp61
    rdm2.aaaa.oovo = einsum(delta.aa.oo, (0, 1), tmp22, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.oovo += einsum(delta.aa.oo, (0, 1), tmp23, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.oovo += np.transpose(tmp24, (2, 1, 3, 0)) * 2
    rdm2.aaaa.oovo += einsum(delta.aa.oo, (0, 1), tmp57, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.aaaa.oovo += einsum(tmp57, (0, 1), delta.aa.oo, (2, 3), (2, 0, 1, 3))
    del tmp57
    rdm2.aaaa.oovo += np.transpose(tmp30, (1, 2, 3, 0)) * 4
    rdm2.aaaa.oovo += np.transpose(tmp31, (1, 2, 3, 0))
    rdm2.aaaa.oovo += einsum(tmp4, (0, 1), t1.aa, (2, 3), (1, 2, 3, 0))
    rdm2.aaaa.oovo += np.transpose(tmp30, (2, 1, 3, 0)) * -4
    rdm2.aaaa.oovo += np.transpose(tmp31, (2, 1, 3, 0)) * -1
    rdm2.aaaa.oovo += einsum(t1.aa, (0, 1), tmp4, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.aaaa.oovo += np.transpose(tmp33, (2, 1, 3, 0)) * -1
    rdm2.bbbb.ooov = einsum(delta.bb.oo, (0, 1), tmp47, (2, 3), (2, 0, 1, 3)) * -1
    del tmp47
    rdm2.bbbb.ooov += einsum(tmp36, (0, 1), delta.bb.oo, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.ooov += np.transpose(tmp48, (2, 1, 0, 3)) * -2
    del tmp48
    rdm2.bbbb.ooov += einsum(delta.bb.oo, (0, 1), tmp50, (2, 3), (2, 0, 1, 3)) * 2
    rdm2.bbbb.ooov += einsum(tmp50, (0, 1), delta.bb.oo, (2, 3), (2, 0, 3, 1)) * -2
    del tmp50
    rdm2.bbbb.ooov += np.transpose(tmp51, (1, 2, 0, 3)) * -4
    rdm2.bbbb.ooov += np.transpose(tmp52, (1, 2, 0, 3)) * -1
    rdm2.bbbb.ooov += einsum(tmp53, (0, 1), t1.bb, (2, 3), (1, 2, 0, 3)) * -2
    rdm2.bbbb.ooov += np.transpose(tmp51, (2, 1, 0, 3)) * 4
    del tmp51
    rdm2.bbbb.ooov += np.transpose(tmp52, (2, 1, 0, 3))
    del tmp52
    rdm2.bbbb.ooov += einsum(t1.bb, (0, 1), tmp53, (2, 3), (0, 3, 2, 1)) * 2
    del tmp53
    rdm2.bbbb.ooov += np.transpose(tmp55, (2, 1, 0, 3))
    del tmp55
    rdm2.abab.ooov = einsum(delta.aa.oo, (0, 1), tmp36, (2, 3), (0, 2, 1, 3))
    del tmp36
    rdm2.abab.ooov += np.transpose(tmp37, (1, 2, 0, 3)) * -1
    del tmp37
    rdm2.abab.ooov += einsum(delta.aa.oo, (0, 1), tmp41, (2, 3), (0, 2, 1, 3)) * -1
    del tmp41
    rdm2.abab.ooov += np.transpose(tmp42, (1, 2, 0, 3)) * -2
    del tmp42
    rdm2.abab.ooov += np.transpose(tmp43, (1, 2, 0, 3)) * -2
    del tmp43
    rdm2.abab.ooov += einsum(tmp12, (0, 1), t1.bb, (2, 3), (1, 2, 0, 3)) * -2
    rdm2.abab.ooov += np.transpose(tmp45, (1, 2, 0, 3))
    del tmp45
    rdm2.abab.ooov += np.transpose(tmp46, (1, 2, 0, 3))
    del tmp46
    rdm2.aaaa.ooov = einsum(delta.aa.oo, (0, 1), tmp22, (2, 3), (2, 0, 1, 3)) * -1
    del tmp22
    rdm2.aaaa.ooov += einsum(delta.aa.oo, (0, 1), tmp23, (2, 3), (0, 2, 1, 3))
    del tmp23
    rdm2.aaaa.ooov += np.transpose(tmp24, (2, 1, 0, 3)) * -2
    del tmp24
    rdm2.aaaa.ooov += einsum(tmp29, (0, 1), delta.aa.oo, (2, 3), (0, 2, 3, 1)) * 2
    rdm2.aaaa.ooov += einsum(tmp29, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1)) * -2
    del tmp29
    rdm2.aaaa.ooov += np.transpose(tmp30, (1, 2, 0, 3)) * -4
    rdm2.aaaa.ooov += np.transpose(tmp31, (1, 2, 0, 3)) * -1
    rdm2.aaaa.ooov += einsum(tmp12, (0, 1), t1.aa, (2, 3), (1, 2, 0, 3)) * -2
    rdm2.aaaa.ooov += np.transpose(tmp30, (2, 1, 0, 3)) * 4
    del tmp30
    rdm2.aaaa.ooov += np.transpose(tmp31, (2, 1, 0, 3))
    del tmp31
    rdm2.aaaa.ooov += einsum(t1.aa, (0, 1), tmp12, (2, 3), (0, 3, 2, 1)) * 2
    rdm2.aaaa.ooov += np.transpose(tmp33, (2, 1, 0, 3))
    del tmp33
    rdm2.bbbb.oooo = einsum(tmp11, (0, 1), delta.bb.oo, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.bbbb.oooo += einsum(delta.bb.oo, (0, 1), tmp11, (2, 3), (3, 0, 1, 2))
    rdm2.bbbb.oooo += einsum(delta.bb.oo, (0, 1), tmp16, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.bbbb.oooo += einsum(delta.bb.oo, (0, 1), tmp16, (2, 3), (0, 3, 2, 1))
    del tmp16
    rdm2.bbbb.oooo += np.transpose(tmp17, (3, 2, 1, 0)) * 2
    del tmp17
    rdm2.bbbb.oooo += np.transpose(tmp19, (2, 3, 1, 0)) * -2
    del tmp19
    rdm2.abab.oooo = einsum(delta.aa.oo, (0, 1), tmp11, (2, 3), (0, 3, 1, 2)) * -1
    del tmp11
    rdm2.abab.oooo += einsum(tmp12, (0, 1), delta.bb.oo, (2, 3), (1, 2, 0, 3)) * -2
    del tmp12
    rdm2.abab.oooo += np.transpose(tmp13, (1, 3, 0, 2))
    del tmp13
    rdm2.abab.oooo += np.transpose(tmp15, (1, 3, 0, 2))
    del tmp15
    rdm2.aaaa.oooo = einsum(delta.aa.oo, (0, 1), tmp3, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.aaaa.oooo += einsum(tmp3, (0, 1), delta.aa.oo, (2, 3), (1, 2, 3, 0))
    del tmp3
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp4, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp4, (2, 3), (0, 3, 2, 1))
    del tmp4, delta
    rdm2.aaaa.oooo += np.transpose(tmp5, (3, 2, 1, 0)) * 2
    del tmp5
    rdm2.aaaa.oooo += np.transpose(tmp7, (2, 3, 1, 0)) * -2
    del tmp7
    rdm2.aaaa = pack_2e(rdm2.aaaa.oooo, rdm2.aaaa.ooov, rdm2.aaaa.oovo, rdm2.aaaa.ovoo, rdm2.aaaa.vooo, rdm2.aaaa.oovv, rdm2.aaaa.ovov, rdm2.aaaa.ovvo, rdm2.aaaa.voov, rdm2.aaaa.vovo, rdm2.aaaa.vvoo, rdm2.aaaa.ovvv, rdm2.aaaa.vovv, rdm2.aaaa.vvov, rdm2.aaaa.vvvo, rdm2.aaaa.vvvv)
    rdm2.abab = pack_2e(rdm2.abab.oooo, rdm2.abab.ooov, rdm2.abab.oovo, rdm2.abab.ovoo, rdm2.abab.vooo, rdm2.abab.oovv, rdm2.abab.ovov, rdm2.abab.ovvo, rdm2.abab.voov, rdm2.abab.vovo, rdm2.abab.vvoo, rdm2.abab.ovvv, rdm2.abab.vovv, rdm2.abab.vvov, rdm2.abab.vvvo, rdm2.abab.vvvv)
    rdm2.bbbb = pack_2e(rdm2.bbbb.oooo, rdm2.bbbb.ooov, rdm2.bbbb.oovo, rdm2.bbbb.ovoo, rdm2.bbbb.vooo, rdm2.bbbb.oovv, rdm2.bbbb.ovov, rdm2.bbbb.ovvo, rdm2.bbbb.voov, rdm2.bbbb.vovo, rdm2.bbbb.vvoo, rdm2.bbbb.ovvv, rdm2.bbbb.vovv, rdm2.bbbb.vvov, rdm2.bbbb.vvvo, rdm2.bbbb.vvvv)
    rdm2 = Namespace(
        aaaa=np.transpose(rdm2.aaaa, (0, 2, 1, 3)),
        aabb=np.transpose(rdm2.abab, (0, 2, 1, 3)),
        bbbb=np.transpose(rdm2.bbbb, (0, 2, 1, 3)),
    )

    return rdm2

def hbar_matvec_ip_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:58:31.362610.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp103 : array
    tmp107 : array
    tmp11 : array
    tmp111 : array
    tmp113 : array
    tmp12 : array
    tmp121 : array
    tmp123 : array
    tmp125 : array
    tmp127 : array
    tmp128 : array
    tmp129 : array
    tmp137 : array
    tmp138 : array
    tmp14 : array
    tmp141 : array
    tmp148 : array
    tmp153 : array
    tmp156 : array
    tmp157 : array
    tmp159 : array
    tmp160 : array
    tmp161 : array
    tmp163 : array
    tmp166 : array
    tmp17 : array
    tmp170 : array
    tmp172 : array
    tmp173 : array
    tmp174 : array
    tmp175 : array
    tmp176 : array
    tmp178 : array
    tmp18 : array
    tmp180 : array
    tmp183 : array
    tmp184 : array
    tmp185 : array
    tmp186 : array
    tmp189 : array
    tmp19 : array
    tmp190 : array
    tmp197 : array
    tmp199 : array
    tmp2 : array
    tmp204 : array
    tmp206 : array
    tmp208 : array
    tmp21 : array
    tmp210 : array
    tmp22 : array
    tmp220 : array
    tmp24 : array
    tmp26 : array
    tmp27 : array
    tmp29 : array
    tmp30 : array
    tmp32 : array
    tmp33 : array
    tmp34 : array
    tmp36 : array
    tmp37 : array
    tmp39 : array
    tmp4 : array
    tmp41 : array
    tmp42 : array
    tmp43 : array
    tmp47 : array
    tmp49 : array
    tmp51 : array
    tmp52 : array
    tmp54 : array
    tmp55 : array
    tmp57 : array
    tmp58 : array
    tmp59 : array
    tmp61 : array
    tmp66 : array
    tmp67 : array
    tmp69 : array
    tmp7 : array
    tmp71 : array
    tmp72 : array
    tmp75 : array
    tmp78 : array
    tmp79 : array
    tmp80 : array
    tmp82 : array
    tmp83 : array
    tmp84 : array
    tmp86 : array
    tmp88 : array
    tmp9 : array
    tmp90 : array
    tmp92 : array
    tmp94 : array
    tmp97 : array
    tmp98 : array
    """

    tmp8 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (1, 2), (0,))
    tmp10 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 0, 1), (2,))
    tmp16 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 3, 1), (2, 0, 3))
    tmp6 = einsum(t1.aa, (0, 1), v.baa.xov, (2, 3, 1), (2, 0, 3))
    tmp54 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (4, 1, 3))
    tmp51 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (0, 3, 4))
    tmp37 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp97 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp196 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp36 = einsum(t1.bb, (0, 1), f.bb.ov, (2, 1), (2, 0))
    tmp107 = einsum(v.baa.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp39 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp71 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp2 = einsum(v.baa.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp152 = einsum(v.baa.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp4 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp26 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp29 = einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp120 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp1 = einsum(f.aa.ov, (0, 1), t1.aa, (2, 1), (0, 2))
    tmp68 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp21 = einsum(v.bbb.xov, (0, 1, 2), tmp8, (0,), (1, 2))
    tmp18 = einsum(v.bbb.xov, (0, 1, 2), tmp10, (0,), (1, 2))
    tmp17 = einsum(tmp16, (0, 1, 2), v.bbb.xov, (0, 1, 3), (2, 3))
    tmp19 = einsum(v.baa.xov, (0, 1, 2), tmp10, (0,), (1, 2))
    tmp14 = einsum(v.baa.xov, (0, 1, 2), tmp8, (0,), (1, 2))
    tmp12 = einsum(v.baa.xov, (0, 1, 2), tmp6, (0, 1, 3), (3, 2))
    tmp220 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.ov, (4, 3), (4, 0, 1, 2))
    tmp210 = einsum(v.bbb.xoo, (0, 1, 2), tmp54, (0, 3, 4), (3, 1, 2, 4))
    tmp208 = einsum(v.bbb.xoo, (0, 1, 2), tmp51, (0, 3, 4), (3, 1, 2, 4))
    tmp206 = einsum(t2.bbbb, (0, 1, 2, 3), tmp37, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp204 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp199 = einsum(t2.bbbb, (0, 1, 2, 3), tmp97, (4, 5, 3, 2), (0, 1, 5, 4))
    tmp197 = einsum(t2.bbbb, (0, 1, 2, 3), tmp196, (4, 5, 2, 3), (0, 1, 4, 5)) * -1
    del tmp196
    tmp190 = einsum(v.bbb.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp189 = einsum(tmp36, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp186 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp185 = einsum(tmp54, (0, 1, 2), v.bbb.xvv, (0, 3, 2), (1, 3))
    tmp184 = einsum(tmp51, (0, 1, 2), v.bbb.xvv, (0, 3, 2), (1, 3)) * -1
    tmp183 = einsum(f.bb.vv, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp180 = einsum(t2.abab, (0, 1, 2, 3), tmp107, (4, 1, 2, 5), (0, 4, 3, 5))
    tmp178 = einsum(v.bbb.xov, (0, 1, 2), tmp54, (0, 1, 3), (3, 2))
    tmp176 = einsum(v.bbb.xov, (0, 1, 2), tmp51, (0, 1, 3), (3, 2))
    tmp175 = einsum(t2.abab, (0, 1, 2, 3), tmp39, (4, 5, 1, 2), (0, 4, 5, 3))
    tmp174 = einsum(t2.abab, (0, 1, 2, 3), tmp39, (0, 4, 1, 2), (4, 3))
    tmp173 = einsum(t2.bbbb, (0, 1, 2, 3), tmp37, (4, 0, 1, 3), (4, 2))
    tmp172 = einsum(f.aa.ov, (0, 1), t2.abab, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp170 = einsum(t1.bb, (0, 1), f.bb.oo, (2, 0), (2, 1))
    tmp166 = einsum(t2.bbbb, (0, 1, 2, 3), tmp97, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp163 = einsum(tmp71, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (1, 4, 2, 5))
    tmp161 = einsum(v.baa.xoo, (0, 1, 2), tmp51, (0, 3, 4), (1, 2, 3, 4))
    tmp160 = einsum(v.baa.xoo, (0, 1, 2), tmp54, (0, 3, 4), (1, 2, 3, 4))
    tmp159 = einsum(t2.abab, (0, 1, 2, 3), tmp2, (4, 0, 5, 2), (4, 5, 1, 3))
    tmp157 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp156 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (0, 2), (1, 3))
    tmp153 = einsum(t2.abab, (0, 1, 2, 3), tmp152, (4, 2, 5, 3), (0, 4, 1, 5))
    del tmp152
    tmp148 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp141 = einsum(tmp107, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (4, 1, 5, 2))
    tmp138 = einsum(tmp4, (0, 1, 2, 3), t2.abab, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp137 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (4, 3), (0, 4, 1, 2))
    tmp129 = einsum(tmp26, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp128 = einsum(tmp29, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp127 = einsum(tmp37, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp125 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp123 = einsum(t2.abab, (0, 1, 2, 3), tmp107, (4, 5, 2, 3), (0, 4, 1, 5))
    tmp121 = einsum(t2.abab, (0, 1, 2, 3), tmp120, (4, 5, 2, 3), (0, 1, 4, 5))
    del tmp120
    tmp113 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp111 = einsum(tmp1, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp103 = einsum(t2.aaaa, (0, 1, 2, 3), f.aa.ov, (4, 3), (4, 0, 1, 2))
    tmp98 = einsum(tmp97, (0, 1, 2, 3), t2.abab, (4, 0, 5, 3), (4, 1, 5, 2))
    tmp94 = einsum(t2.aaaa, (0, 1, 2, 3), tmp71, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp92 = einsum(tmp29, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp90 = einsum(tmp26, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp88 = einsum(tmp29, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp86 = einsum(tmp26, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp84 = einsum(t2.aaaa, (0, 1, 2, 3), tmp2, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp83 = einsum(tmp4, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    tmp82 = einsum(t2.aaaa, (0, 1, 2, 3), tmp2, (4, 0, 1, 3), (4, 2))
    tmp80 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp79 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp78 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp75 = einsum(f.aa.oo, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp72 = einsum(t2.aaaa, (0, 1, 2, 3), tmp71, (4, 5, 3, 2), (0, 1, 5, 4))
    tmp69 = einsum(tmp68, (0, 1, 2, 3), t2.aaaa, (4, 5, 2, 3), (4, 5, 0, 1)) * -1
    del tmp68
    tmp67 = einsum(tmp29, (0, 1, 2), v.baa.xvv, (0, 3, 2), (1, 3))
    tmp66 = einsum(tmp26, (0, 1, 2), v.baa.xvv, (0, 3, 2), (1, 3)) * -1
    tmp61 = einsum(f.aa.vv, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp59 = einsum(t1.bb, (0, 1), tmp21, (2, 1), (0, 2))
    tmp58 = einsum(tmp18, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp57 = einsum(t1.bb, (0, 1), tmp17, (2, 1), (0, 2))
    tmp55 = einsum(v.bbb.xov, (0, 1, 2), tmp54, (0, 3, 2), (3, 1))
    tmp52 = einsum(v.bbb.xov, (0, 1, 2), tmp51, (0, 3, 2), (3, 1))
    tmp49 = einsum(v.baa.xov, (0, 1, 2), tmp16, (0, 3, 4), (1, 3, 4, 2))
    tmp47 = einsum(v.bbb.xov, (0, 1, 2), tmp16, (0, 3, 4), (3, 1, 4, 2))
    tmp43 = einsum(v.bbb.xoo, (0, 1, 2), tmp8, (0,), (1, 2))
    tmp42 = einsum(v.bbb.xoo, (0, 1, 2), tmp10, (0,), (1, 2))
    tmp41 = einsum(tmp16, (0, 1, 2), v.bbb.xoo, (0, 3, 1), (3, 2))
    del tmp16
    tmp34 = einsum(t1.aa, (0, 1), tmp19, (2, 1), (0, 2))
    tmp33 = einsum(tmp14, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp32 = einsum(t1.aa, (0, 1), tmp12, (2, 1), (0, 2))
    tmp30 = einsum(tmp29, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp27 = einsum(tmp26, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp24 = einsum(tmp6, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp22 = einsum(tmp6, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp11 = einsum(tmp10, (0,), v.baa.xoo, (0, 1, 2), (1, 2))
    del tmp10
    tmp9 = einsum(tmp8, (0,), v.baa.xoo, (0, 1, 2), (1, 2))
    del tmp8
    tmp7 = einsum(v.baa.xoo, (0, 1, 2), tmp6, (0, 2, 3), (1, 3))
    del tmp6

    return {f"tmp1": tmp1, f"tmp103": tmp103, f"tmp107": tmp107, f"tmp11": tmp11, f"tmp111": tmp111, f"tmp113": tmp113, f"tmp12": tmp12, f"tmp121": tmp121, f"tmp123": tmp123, f"tmp125": tmp125, f"tmp127": tmp127, f"tmp128": tmp128, f"tmp129": tmp129, f"tmp137": tmp137, f"tmp138": tmp138, f"tmp14": tmp14, f"tmp141": tmp141, f"tmp148": tmp148, f"tmp153": tmp153, f"tmp156": tmp156, f"tmp157": tmp157, f"tmp159": tmp159, f"tmp160": tmp160, f"tmp161": tmp161, f"tmp163": tmp163, f"tmp166": tmp166, f"tmp17": tmp17, f"tmp170": tmp170, f"tmp172": tmp172, f"tmp173": tmp173, f"tmp174": tmp174, f"tmp175": tmp175, f"tmp176": tmp176, f"tmp178": tmp178, f"tmp18": tmp18, f"tmp180": tmp180, f"tmp183": tmp183, f"tmp184": tmp184, f"tmp185": tmp185, f"tmp186": tmp186, f"tmp189": tmp189, f"tmp19": tmp19, f"tmp190": tmp190, f"tmp197": tmp197, f"tmp199": tmp199, f"tmp2": tmp2, f"tmp204": tmp204, f"tmp206": tmp206, f"tmp208": tmp208, f"tmp21": tmp21, f"tmp210": tmp210, f"tmp22": tmp22, f"tmp220": tmp220, f"tmp24": tmp24, f"tmp26": tmp26, f"tmp27": tmp27, f"tmp29": tmp29, f"tmp30": tmp30, f"tmp32": tmp32, f"tmp33": tmp33, f"tmp34": tmp34, f"tmp36": tmp36, f"tmp37": tmp37, f"tmp39": tmp39, f"tmp4": tmp4, f"tmp41": tmp41, f"tmp42": tmp42, f"tmp43": tmp43, f"tmp47": tmp47, f"tmp49": tmp49, f"tmp51": tmp51, f"tmp52": tmp52, f"tmp54": tmp54, f"tmp55": tmp55, f"tmp57": tmp57, f"tmp58": tmp58, f"tmp59": tmp59, f"tmp61": tmp61, f"tmp66": tmp66, f"tmp67": tmp67, f"tmp69": tmp69, f"tmp7": tmp7, f"tmp71": tmp71, f"tmp72": tmp72, f"tmp75": tmp75, f"tmp78": tmp78, f"tmp79": tmp79, f"tmp80": tmp80, f"tmp82": tmp82, f"tmp83": tmp83, f"tmp84": tmp84, f"tmp86": tmp86, f"tmp88": tmp88, f"tmp9": tmp9, f"tmp90": tmp90, f"tmp92": tmp92, f"tmp94": tmp94, f"tmp97": tmp97, f"tmp98": tmp98}

def hbar_matvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:58:31.468713.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp8 = einsum(r2.aaa, (0, 1, 2), v.baa.xov, (3, 1, 2), (3, 0))
    tmp9 = einsum(v.bbb.xov, (0, 1, 2), r2.bab, (1, 3, 2), (0, 3)) * -1
    tmp39 = einsum(v.baa.xov, (0, 1, 2), r2.aba, (1, 3, 2), (0, 3))
    tmp70 = np.copy(ints.tmp52) * 2
    tmp70 += ints.tmp55
    tmp72 = np.copy(ints.tmp206)
    del ints.tmp206
    tmp72 += np.transpose(ints.tmp37, (0, 2, 1, 3)) * 0.5
    tmp40 = einsum(v.bbb.xov, (0, 1, 2), r2.bbb, (3, 1, 2), (0, 3))
    tmp68 = np.copy(ints.tmp51)
    tmp68 += ints.tmp54 * 0.5
    tmp49 = np.copy(ints.tmp186)
    del ints.tmp186
    tmp49 += ints.tmp166 * 2
    del ints.tmp166
    tmp59 = np.copy(ints.tmp54)
    tmp59 += ints.tmp51 * 2
    tmp63 = np.copy(ints.tmp210)
    del ints.tmp210
    tmp63 += ints.tmp208 * 2
    del ints.tmp208
    tmp61 = np.copy(f.bb.oo)
    tmp61 += ints.tmp36
    tmp25 = np.copy(ints.tmp88)
    del ints.tmp88
    tmp25 += ints.tmp86 * 2
    del ints.tmp86
    tmp21 = np.copy(tmp8) * 2
    tmp21 += tmp9
    tmp19 = np.copy(ints.tmp113)
    tmp19 += ints.tmp94 * 2
    tmp23 = np.copy(f.aa.oo)
    tmp23 += ints.tmp1
    tmp15 = np.copy(ints.tmp2)
    tmp15 += np.transpose(ints.tmp84, (0, 2, 1, 3)) * 2
    del ints.tmp84
    tmp13 = np.copy(ints.tmp27) * 2
    tmp13 += ints.tmp30
    tmp11 = np.copy(ints.tmp26)
    tmp11 += ints.tmp29 * 0.5
    tmp10 = np.copy(tmp8) * 2
    del tmp8
    tmp10 += tmp9
    del tmp9
    tmp67 = einsum(tmp39, (0, 1), v.bbb.xov, (0, 2, 3), (1, 2, 3))
    tmp71 = einsum(r2.bbb, (0, 1, 2), tmp70, (3, 1), (0, 3, 2)) * -2
    del tmp70
    tmp66 = einsum(r2.aba, (0, 1, 2), ints.tmp163, (0, 3, 2, 4), (3, 1, 4))
    tmp73 = einsum(tmp72, (0, 1, 2, 3), r1.b, (2,), (0, 1, 3)) * 2
    del tmp72
    tmp69 = einsum(tmp68, (0, 1, 2), tmp40, (0, 3), (3, 1, 2)) * 4
    del tmp68
    tmp43 = einsum(ints.tmp107, (0, 1, 2, 3), r2.aba, (0, 1, 2), (3,))
    tmp44 = einsum(ints.tmp97, (0, 1, 2, 3), r2.bbb, (1, 0, 2), (3,)) * -1
    del ints.tmp97
    tmp53 = einsum(t1.bb, (0, 1), f.bb.ov, (0, 2), (2, 1))
    tmp58 = einsum(tmp49, (0, 1, 2, 3), r2.bbb, (4, 1, 3), (4, 0, 2)) * -1
    tmp60 = einsum(tmp39, (0, 1), tmp59, (0, 2, 3), (1, 2, 3))
    del tmp59
    tmp64 = einsum(r1.b, (0,), tmp63, (1, 0, 2, 3), (1, 2, 3))
    del tmp63
    tmp57 = einsum(tmp40, (0, 1), v.bbb.xov, (0, 2, 3), (1, 2, 3))
    tmp62 = einsum(tmp61, (0, 1), r2.bbb, (2, 0, 3), (2, 1, 3)) * -1
    del tmp61
    tmp31 = einsum(ints.tmp71, (0, 1, 2, 3), r2.aaa, (1, 0, 2), (3,)) * -1
    del ints.tmp71
    tmp32 = einsum(ints.tmp107, (0, 1, 2, 3), r2.bab, (1, 0, 3), (2,)) * -1
    del ints.tmp107
    tmp29 = einsum(f.aa.ov, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp26 = einsum(tmp25, (0, 1, 2, 3), r1.a, (1,), (0, 2, 3))
    del tmp25
    tmp22 = einsum(v.baa.xov, (0, 1, 2), tmp21, (0, 3), (1, 3, 2))
    del tmp21
    tmp18 = einsum(ints.tmp98, (0, 1, 2, 3), r2.bab, (1, 4, 3), (0, 4, 2)) * -1
    tmp20 = einsum(r2.aaa, (0, 1, 2), tmp19, (3, 1, 4, 2), (0, 3, 4)) * -1
    del tmp19
    tmp24 = einsum(r2.aaa, (0, 1, 2), tmp23, (1, 3), (0, 3, 2)) * -1
    del tmp23
    tmp16 = einsum(r1.a, (0,), tmp15, (1, 0, 2, 3), (1, 2, 3))
    del tmp15
    tmp14 = einsum(r2.aaa, (0, 1, 2), tmp13, (3, 1), (0, 3, 2)) * -2
    del tmp13
    tmp12 = einsum(tmp11, (0, 1, 2), tmp10, (0, 3), (3, 1, 2)) * 2
    del tmp11
    tmp74 = np.copy(tmp66)
    del tmp66
    tmp74 += tmp67
    del tmp67
    tmp74 += np.transpose(tmp69, (1, 0, 2))
    del tmp69
    tmp74 += np.transpose(tmp71, (1, 0, 2))
    del tmp71
    tmp74 += tmp73
    del tmp73
    tmp75 = np.copy(ints.tmp199)
    del ints.tmp199
    tmp75 += np.transpose(ints.tmp204, (0, 2, 1, 3)) * -1
    del ints.tmp204
    tmp45 = np.copy(tmp43) * 0.5
    del tmp43
    tmp45 += tmp44
    del tmp44
    tmp54 = np.copy(np.transpose(ints.tmp176, (1, 0))) * 2
    del ints.tmp176
    tmp54 += np.transpose(ints.tmp178, (1, 0))
    del ints.tmp178
    tmp54 += f.bb.vv * -1
    tmp54 += tmp53
    del tmp53
    tmp65 = np.copy(tmp57) * 2
    del tmp57
    tmp65 += np.transpose(tmp58, (1, 0, 2)) * -2
    del tmp58
    tmp65 += np.transpose(tmp60, (1, 0, 2))
    del tmp60
    tmp65 += np.transpose(tmp62, (1, 0, 2)) * -2
    del tmp62
    tmp65 += tmp64
    del tmp64
    tmp56 = np.copy(ints.tmp170)
    del ints.tmp170
    tmp56 += ints.tmp173 * 2
    del ints.tmp173
    tmp56 += ints.tmp174
    del ints.tmp174
    tmp56 += ints.tmp184 * 2
    del ints.tmp184
    tmp56 += ints.tmp189
    del ints.tmp189
    tmp56 += f.bb.ov * -1
    tmp56 += ints.tmp156 * -1
    del ints.tmp156
    tmp56 += ints.tmp157 * -2
    del ints.tmp157
    tmp56 += ints.tmp183 * -1
    del ints.tmp183
    tmp56 += ints.tmp185 * -1
    del ints.tmp185
    tmp76 = np.copy(ints.tmp197)
    del ints.tmp197
    tmp76 += np.transpose(ints.tmp220, (1, 2, 0, 3)) * -1
    del ints.tmp220
    tmp55 = np.copy(ints.tmp153)
    del ints.tmp153
    tmp55 += np.transpose(ints.tmp160, (1, 0, 2, 3))
    del ints.tmp160
    tmp55 += np.transpose(ints.tmp161, (1, 0, 2, 3)) * 2
    del ints.tmp161
    tmp55 += np.transpose(ints.tmp172, (1, 0, 2, 3))
    del ints.tmp172
    tmp55 += ints.tmp4
    tmp55 += ints.tmp159 * -1
    del ints.tmp159
    tmp55 += ints.tmp175 * -1
    del ints.tmp175
    tmp51 = np.copy(ints.tmp123)
    tmp51 += ints.tmp125
    tmp33 = np.copy(tmp31)
    del tmp31
    tmp33 += tmp32 * -0.5
    del tmp32
    tmp50 = np.copy(ints.tmp180)
    del ints.tmp180
    tmp50 += ints.tmp190 * -1
    del ints.tmp190
    tmp52 = np.copy(ints.tmp51) * 2
    del ints.tmp51
    tmp52 += ints.tmp54
    del ints.tmp54
    tmp52 += v.bbb.xov
    tmp47 = np.copy(f.bb.oo)
    tmp47 += ints.tmp36
    tmp47 += np.transpose(ints.tmp52, (1, 0)) * 2
    tmp47 += np.transpose(ints.tmp55, (1, 0))
    tmp48 = np.copy(f.aa.oo)
    tmp48 += ints.tmp1
    tmp48 += np.transpose(ints.tmp27, (1, 0)) * 2
    tmp48 += np.transpose(ints.tmp30, (1, 0))
    tmp38 = np.copy(ints.tmp123)
    del ints.tmp123
    tmp38 += ints.tmp125
    del ints.tmp125
    tmp36 = np.copy(ints.tmp113)
    del ints.tmp113
    tmp36 += ints.tmp94 * 2
    del ints.tmp94
    tmp35 = np.copy(ints.tmp111)
    del ints.tmp111
    tmp35 += ints.tmp66 * 2
    del ints.tmp66
    tmp35 += ints.tmp75
    del ints.tmp75
    tmp35 += ints.tmp82 * 2
    del ints.tmp82
    tmp35 += ints.tmp83
    del ints.tmp83
    tmp35 += f.aa.ov * -1
    tmp35 += ints.tmp61 * -1
    del ints.tmp61
    tmp35 += ints.tmp67 * -1
    del ints.tmp67
    tmp35 += ints.tmp78 * -2
    del ints.tmp78
    tmp35 += ints.tmp79 * -1
    del ints.tmp79
    tmp30 = np.copy(np.transpose(ints.tmp90, (1, 0))) * 2
    del ints.tmp90
    tmp30 += np.transpose(ints.tmp92, (1, 0))
    del ints.tmp92
    tmp30 += f.aa.vv * -1
    tmp30 += tmp29
    del tmp29
    tmp42 = np.copy(ints.tmp26) * 2
    del ints.tmp26
    tmp42 += ints.tmp29
    del ints.tmp29
    tmp42 += v.baa.xov
    tmp46 = np.copy(ints.tmp121)
    del ints.tmp121
    tmp46 += np.transpose(ints.tmp128, (0, 2, 1, 3))
    del ints.tmp128
    tmp46 += np.transpose(ints.tmp129, (0, 2, 1, 3)) * 2
    del ints.tmp129
    tmp46 += np.transpose(ints.tmp137, (0, 2, 1, 3))
    del ints.tmp137
    tmp46 += ints.tmp39
    tmp46 += ints.tmp127 * -1
    del ints.tmp127
    tmp46 += ints.tmp138 * -1
    del ints.tmp138
    tmp37 = np.copy(ints.tmp141)
    del ints.tmp141
    tmp37 += ints.tmp148 * -1
    del ints.tmp148
    tmp41 = np.copy(tmp39) * -0.5
    del tmp39
    tmp41 += tmp40
    del tmp40
    tmp27 = np.copy(tmp18)
    del tmp18
    tmp27 += np.transpose(tmp20, (1, 0, 2)) * -2
    del tmp20
    tmp27 += np.transpose(tmp22, (1, 0, 2))
    del tmp22
    tmp27 += np.transpose(tmp24, (1, 0, 2)) * -2
    del tmp24
    tmp27 += tmp26
    del tmp26
    tmp17 = np.copy(np.transpose(tmp12, (1, 0, 2)))
    del tmp12
    tmp17 += np.transpose(tmp14, (1, 0, 2))
    del tmp14
    tmp17 += tmp16
    del tmp16
    tmp28 = np.copy(ints.tmp72)
    del ints.tmp72
    tmp28 += np.transpose(ints.tmp80, (0, 2, 1, 3)) * -1
    del ints.tmp80
    tmp34 = np.copy(ints.tmp103)
    del ints.tmp103
    tmp34 += np.transpose(ints.tmp69, (2, 0, 1, 3)) * -1
    del ints.tmp69
    tmp3 = np.copy(f.aa.ov)
    tmp3 += ints.tmp14
    del ints.tmp14
    tmp3 += ints.tmp19
    del ints.tmp19
    tmp3 += ints.tmp12 * -1
    del ints.tmp12
    tmp7 = np.copy(f.bb.oo)
    tmp7 += ints.tmp36
    del ints.tmp36
    tmp7 += np.transpose(ints.tmp42, (1, 0))
    del ints.tmp42
    tmp7 += np.transpose(ints.tmp43, (1, 0))
    del ints.tmp43
    tmp7 += np.transpose(ints.tmp52, (1, 0)) * 2
    del ints.tmp52
    tmp7 += np.transpose(ints.tmp55, (1, 0))
    del ints.tmp55
    tmp7 += np.transpose(ints.tmp58, (1, 0))
    del ints.tmp58
    tmp7 += np.transpose(ints.tmp59, (1, 0))
    del ints.tmp59
    tmp7 += np.transpose(ints.tmp41, (1, 0)) * -1
    del ints.tmp41
    tmp7 += np.transpose(ints.tmp57, (1, 0)) * -1
    del ints.tmp57
    tmp5 = np.copy(ints.tmp37)
    del ints.tmp37
    tmp5 += ints.tmp47 * -1
    del ints.tmp47
    tmp2 = np.copy(f.bb.ov)
    tmp2 += ints.tmp18
    del ints.tmp18
    tmp2 += ints.tmp21
    del ints.tmp21
    tmp2 += ints.tmp17 * -1
    del ints.tmp17
    tmp6 = np.copy(ints.tmp39)
    del ints.tmp39
    tmp6 += ints.tmp49
    del ints.tmp49
    tmp4 = np.copy(f.aa.oo)
    tmp4 += np.transpose(ints.tmp11, (1, 0))
    del ints.tmp11
    tmp4 += ints.tmp1
    del ints.tmp1
    tmp4 += np.transpose(ints.tmp27, (1, 0)) * 2
    del ints.tmp27
    tmp4 += np.transpose(ints.tmp30, (1, 0))
    del ints.tmp30
    tmp4 += np.transpose(ints.tmp33, (1, 0))
    del ints.tmp33
    tmp4 += np.transpose(ints.tmp34, (1, 0))
    del ints.tmp34
    tmp4 += np.transpose(ints.tmp9, (1, 0))
    del ints.tmp9
    tmp4 += np.transpose(ints.tmp32, (1, 0)) * -1
    del ints.tmp32
    tmp4 += np.transpose(ints.tmp7, (1, 0)) * -1
    del ints.tmp7
    tmp1 = np.copy(ints.tmp24)
    del ints.tmp24
    tmp1 += ints.tmp4
    del ints.tmp4
    tmp0 = np.copy(ints.tmp22)
    del ints.tmp22
    tmp0 += ints.tmp2 * -1
    del ints.tmp2
    r2new.bbb = np.copy(tmp65)
    r2new.bbb += np.transpose(tmp65, (1, 0, 2)) * -1
    del tmp65
    r2new.bbb += tmp74 * -1
    r2new.bbb += np.transpose(tmp74, (1, 0, 2))
    del tmp74
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp75, (3, 4, 1, 0), (3, 4, 2)) * -2
    del tmp75
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp54, (2, 3), (0, 1, 3)) * -2
    r2new.bbb += einsum(tmp45, (0,), t2.bbbb, (1, 2, 3, 0), (1, 2, 3)) * -4
    r2new.bbb += einsum(tmp76, (0, 1, 2, 3), r1.b, (2,), (1, 0, 3)) * 2
    del tmp76
    r2new.bbb += einsum(tmp56, (0, 1), r1.b, (2,), (2, 0, 1)) * -1
    r2new.bbb += einsum(tmp56, (0, 1), r1.b, (2,), (0, 2, 1))
    r2new.bab = einsum(r2.aaa, (0, 1, 2), ints.tmp163, (1, 3, 2, 4), (3, 0, 4)) * 2
    del ints.tmp163
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp49, (3, 0, 4, 2), (3, 1, 4)) * -1
    del tmp49
    r2new.bab += einsum(tmp50, (0, 1, 2, 3), r2.bab, (4, 1, 3), (4, 0, 2))
    del tmp50
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp51, (3, 1, 4, 0), (4, 3, 2))
    del tmp51
    r2new.bab += einsum(tmp52, (0, 1, 2), tmp10, (0, 3), (1, 3, 2)) * -1
    del tmp10, tmp52
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp54, (2, 3), (0, 1, 3)) * -1
    del tmp54
    r2new.bab += einsum(t2.abab, (0, 1, 2, 3), tmp33, (2,), (1, 0, 3)) * -2
    r2new.bab += einsum(tmp55, (0, 1, 2, 3), r1.a, (1,), (2, 0, 3))
    del tmp55
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp47, (0, 3), (3, 1, 2)) * -1
    r2new.bab += einsum(tmp48, (0, 1), r2.bab, (2, 0, 3), (2, 1, 3)) * -1
    r2new.bab += einsum(tmp56, (0, 1), r1.a, (2,), (0, 2, 1))
    del tmp56
    r2new.aba = einsum(ints.tmp98, (0, 1, 2, 3), r2.bbb, (4, 1, 3), (0, 4, 2)) * 2
    del ints.tmp98
    r2new.aba += einsum(tmp36, (0, 1, 2, 3), r2.aba, (1, 4, 3), (0, 4, 2)) * -1
    del tmp36
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp37, (3, 1, 4, 2), (0, 3, 4))
    del tmp37
    r2new.aba += einsum(tmp38, (0, 1, 2, 3), r2.aba, (1, 3, 4), (0, 2, 4))
    del tmp38
    r2new.aba += einsum(tmp41, (0, 1), tmp42, (0, 2, 3), (2, 1, 3)) * -2
    del tmp41, tmp42
    r2new.aba += einsum(tmp30, (0, 1), r2.aba, (2, 3, 0), (2, 3, 1)) * -1
    r2new.aba += einsum(t2.abab, (0, 1, 2, 3), tmp45, (3,), (0, 1, 2)) * -2
    del tmp45
    r2new.aba += einsum(tmp46, (0, 1, 2, 3), r1.b, (2,), (0, 1, 3))
    del tmp46
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp47, (1, 3), (0, 3, 2)) * -1
    del tmp47
    r2new.aba += einsum(tmp48, (0, 1), r2.aba, (0, 2, 3), (1, 2, 3)) * -1
    del tmp48
    r2new.aba += einsum(r1.b, (0,), tmp35, (1, 2), (1, 0, 2))
    r2new.aaa = np.copy(tmp17) * -1
    r2new.aaa += np.transpose(tmp17, (1, 0, 2))
    del tmp17
    r2new.aaa += tmp27
    r2new.aaa += np.transpose(tmp27, (1, 0, 2)) * -1
    del tmp27
    r2new.aaa += einsum(tmp28, (0, 1, 2, 3), r2.aaa, (2, 3, 4), (0, 1, 4)) * 2
    del tmp28
    r2new.aaa += einsum(tmp30, (0, 1), r2.aaa, (2, 3, 0), (2, 3, 1)) * -2
    del tmp30
    r2new.aaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp33, (3,), (0, 1, 2)) * -4
    del tmp33
    r2new.aaa += einsum(tmp34, (0, 1, 2, 3), r1.a, (0,), (2, 1, 3)) * -2
    del tmp34
    r2new.aaa += einsum(tmp35, (0, 1), r1.a, (2,), (2, 0, 1)) * -1
    r2new.aaa += einsum(tmp35, (0, 1), r1.a, (2,), (0, 2, 1))
    del tmp35
    r1new.b = einsum(tmp5, (0, 1, 2, 3), r2.bbb, (1, 2, 3), (0,)) * -2
    del tmp5
    r1new.b += einsum(r2.aba, (0, 1, 2), tmp6, (0, 3, 1, 2), (3,))
    del tmp6
    r1new.b += einsum(tmp3, (0, 1), r2.aba, (0, 2, 1), (2,)) * -1
    r1new.b += einsum(r2.bbb, (0, 1, 2), tmp2, (1, 2), (0,)) * 2
    r1new.b += einsum(tmp7, (0, 1), r1.b, (0,), (1,)) * -1
    del tmp7
    r1new.a = einsum(tmp0, (0, 1, 2, 3), r2.aaa, (1, 2, 3), (0,)) * 2
    del tmp0
    r1new.a += einsum(tmp1, (0, 1, 2, 3), r2.bab, (2, 1, 3), (0,))
    del tmp1
    r1new.a += einsum(tmp2, (0, 1), r2.bab, (0, 2, 1), (2,)) * -1
    del tmp2
    r1new.a += einsum(tmp3, (0, 1), r2.aaa, (2, 0, 1), (2,)) * 2
    del tmp3
    r1new.a += einsum(r1.a, (0,), tmp4, (0, 1), (1,)) * -1
    del tmp4

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_matvec_ea_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:59:58.647334.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp106 : array
    tmp107 : array
    tmp109 : array
    tmp11 : array
    tmp110 : array
    tmp112 : array
    tmp113 : array
    tmp114 : array
    tmp116 : array
    tmp122 : array
    tmp125 : array
    tmp126 : array
    tmp13 : array
    tmp132 : array
    tmp136 : array
    tmp138 : array
    tmp139 : array
    tmp140 : array
    tmp15 : array
    tmp151 : array
    tmp154 : array
    tmp155 : array
    tmp157 : array
    tmp163 : array
    tmp164 : array
    tmp166 : array
    tmp167 : array
    tmp168 : array
    tmp170 : array
    tmp172 : array
    tmp173 : array
    tmp174 : array
    tmp176 : array
    tmp177 : array
    tmp179 : array
    tmp18 : array
    tmp180 : array
    tmp181 : array
    tmp182 : array
    tmp183 : array
    tmp187 : array
    tmp19 : array
    tmp190 : array
    tmp199 : array
    tmp2 : array
    tmp20 : array
    tmp201 : array
    tmp203 : array
    tmp216 : array
    tmp22 : array
    tmp224 : array
    tmp23 : array
    tmp26 : array
    tmp29 : array
    tmp30 : array
    tmp32 : array
    tmp33 : array
    tmp4 : array
    tmp40 : array
    tmp42 : array
    tmp44 : array
    tmp46 : array
    tmp47 : array
    tmp51 : array
    tmp56 : array
    tmp57 : array
    tmp59 : array
    tmp60 : array
    tmp67 : array
    tmp68 : array
    tmp7 : array
    tmp74 : array
    tmp76 : array
    tmp78 : array
    tmp82 : array
    tmp85 : array
    tmp9 : array
    tmp91 : array
    tmp93 : array
    tmp96 : array
    tmp98 : array
    tmp99 : array
    """

    tmp175 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp59 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (4, 1, 3))
    tmp40 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp56 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (0, 3, 4))
    tmp51 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp23 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp2 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp156 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp164 = einsum(t1.bb, (0, 1), f.bb.ov, (2, 1), (2, 0))
    tmp26 = einsum(v.baa.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp42 = einsum(v.baa.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp29 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp32 = einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp97 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp4 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp107 = einsum(f.aa.ov, (0, 1), t1.aa, (2, 1), (0, 2))
    tmp95 = einsum(v.baa.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp6 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (1, 2), (0,))
    tmp45 = einsum(t1.bb, (0, 1), v.bbb.xvv, (2, 3, 1), (2, 0, 3))
    tmp10 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 0, 1), (2,))
    tmp17 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 3, 1), (2, 0, 3))
    tmp12 = einsum(t1.aa, (0, 1), v.baa.xov, (2, 3, 1), (2, 0, 3))
    tmp8 = einsum(v.baa.xvv, (0, 1, 2), t1.aa, (3, 2), (0, 3, 1))
    tmp224 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (3, 1, 2, 4))
    tmp216 = einsum(t2.bbbb, (0, 1, 2, 3), tmp175, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp203 = einsum(v.bbb.xvv, (0, 1, 2), tmp59, (0, 3, 4), (3, 4, 1, 2))
    tmp201 = einsum(tmp40, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 2), (4, 5, 3, 1))
    tmp199 = einsum(tmp56, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp190 = einsum(t2.bbbb, (0, 1, 2, 3), tmp51, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp187 = einsum(t2.abab, (0, 1, 2, 3), tmp23, (0, 4, 5, 2), (4, 1, 5, 3))
    tmp183 = einsum(tmp56, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp182 = einsum(t2.abab, (0, 1, 2, 3), tmp2, (0, 4, 2, 5), (1, 5, 4, 3))
    tmp181 = einsum(v.baa.xvv, (0, 1, 2), tmp59, (0, 3, 4), (3, 1, 2, 4))
    tmp180 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp179 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (0, 2), (1, 3))
    tmp177 = einsum(t2.abab, (0, 1, 2, 3), tmp156, (0, 4, 1, 2), (4, 3))
    tmp176 = einsum(t2.bbbb, (0, 1, 2, 3), tmp175, (4, 0, 1, 3), (4, 2))
    del tmp175
    tmp174 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp173 = einsum(t1.bb, (0, 1), f.bb.oo, (2, 0), (2, 1))
    tmp172 = einsum(t1.bb, (0, 1), tmp164, (0, 2), (2, 1))
    tmp170 = einsum(tmp59, (0, 1, 2), v.bbb.xov, (0, 3, 2), (1, 3))
    tmp168 = einsum(tmp56, (0, 1, 2), v.bbb.xov, (0, 3, 2), (1, 3))
    tmp167 = einsum(tmp59, (0, 1, 2), v.bbb.xvv, (0, 3, 2), (1, 3))
    tmp166 = einsum(tmp56, (0, 1, 2), v.bbb.xvv, (0, 3, 2), (1, 3)) * -1
    tmp163 = einsum(f.bb.vv, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp157 = einsum(t2.abab, (0, 1, 2, 3), tmp156, (0, 4, 1, 5), (4, 2, 5, 3))
    del tmp156
    tmp155 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp154 = einsum(t2.abab, (0, 1, 2, 3), tmp26, (0, 4, 5, 3), (1, 4, 2, 5))
    tmp151 = einsum(t2.abab, (0, 1, 2, 3), tmp42, (0, 4, 5, 3), (1, 2, 4, 5))
    tmp140 = einsum(v.bbb.xvv, (0, 1, 2), tmp29, (0, 3, 4), (3, 4, 1, 2))
    tmp139 = einsum(tmp40, (0, 1, 2, 3), t2.abab, (4, 0, 5, 2), (4, 5, 3, 1))
    tmp138 = einsum(v.bbb.xvv, (0, 1, 2), tmp32, (0, 3, 4), (3, 4, 1, 2))
    tmp136 = einsum(v.bbb.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp132 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp126 = einsum(tmp97, (0, 1, 2, 3), t2.abab, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp125 = einsum(t2.abab, (0, 1, 2, 3), tmp26, (4, 1, 2, 5), (0, 4, 3, 5))
    tmp122 = einsum(tmp4, (0, 1, 2, 3), t2.abab, (4, 0, 2, 5), (4, 1, 5, 3))
    tmp116 = einsum(tmp32, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp114 = einsum(tmp29, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp113 = einsum(v.baa.xvv, (0, 1, 2), tmp32, (0, 3, 2), (3, 1))
    tmp112 = einsum(tmp29, (0, 1, 2), v.baa.xvv, (0, 3, 2), (1, 3)) * -1
    tmp110 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp109 = einsum(tmp107, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp106 = einsum(f.aa.vv, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp99 = einsum(t2.aaaa, (0, 1, 2, 3), tmp95, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp98 = einsum(tmp97, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    del tmp97
    tmp96 = einsum(tmp95, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 3), (0, 4))
    del tmp95
    tmp93 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp91 = einsum(f.aa.oo, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp85 = einsum(t2.abab, (0, 1, 2, 3), tmp51, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp82 = einsum(tmp23, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 1, 5, 2))
    tmp78 = einsum(tmp32, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp76 = einsum(t2.aaaa, (0, 1, 2, 3), tmp2, (1, 4, 3, 5), (0, 2, 5, 4))
    tmp74 = einsum(tmp29, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp68 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp67 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp60 = einsum(v.bbb.xov, (0, 1, 2), tmp59, (0, 1, 3), (3, 2))
    tmp57 = einsum(tmp56, (0, 1, 2), v.bbb.xov, (0, 1, 3), (2, 3))
    tmp47 = einsum(tmp6, (0,), v.bbb.xvv, (0, 1, 2), (1, 2))
    tmp46 = einsum(v.bbb.xov, (0, 1, 2), tmp45, (0, 1, 3), (2, 3))
    del tmp45
    tmp44 = einsum(tmp10, (0,), v.bbb.xvv, (0, 1, 2), (1, 2))
    tmp33 = einsum(v.baa.xov, (0, 1, 2), tmp32, (0, 1, 3), (3, 2))
    tmp30 = einsum(tmp29, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp22 = einsum(tmp6, (0,), v.bbb.xov, (0, 1, 2), (1, 2))
    tmp20 = einsum(v.baa.xov, (0, 1, 2), tmp10, (0,), (1, 2))
    tmp19 = einsum(v.bbb.xov, (0, 1, 2), tmp10, (0,), (1, 2))
    tmp18 = einsum(tmp17, (0, 1, 2), v.bbb.xov, (0, 1, 3), (2, 3))
    del tmp17
    tmp15 = einsum(tmp6, (0,), v.baa.xov, (0, 1, 2), (1, 2))
    tmp13 = einsum(v.baa.xov, (0, 1, 2), tmp12, (0, 1, 3), (3, 2))
    del tmp12
    tmp11 = einsum(v.baa.xvv, (0, 1, 2), tmp10, (0,), (1, 2))
    del tmp10
    tmp9 = einsum(v.baa.xov, (0, 1, 2), tmp8, (0, 1, 3), (2, 3))
    del tmp8
    tmp7 = einsum(tmp6, (0,), v.baa.xvv, (0, 1, 2), (1, 2))
    del tmp6

    return {f"tmp106": tmp106, f"tmp107": tmp107, f"tmp109": tmp109, f"tmp11": tmp11, f"tmp110": tmp110, f"tmp112": tmp112, f"tmp113": tmp113, f"tmp114": tmp114, f"tmp116": tmp116, f"tmp122": tmp122, f"tmp125": tmp125, f"tmp126": tmp126, f"tmp13": tmp13, f"tmp132": tmp132, f"tmp136": tmp136, f"tmp138": tmp138, f"tmp139": tmp139, f"tmp140": tmp140, f"tmp15": tmp15, f"tmp151": tmp151, f"tmp154": tmp154, f"tmp155": tmp155, f"tmp157": tmp157, f"tmp163": tmp163, f"tmp164": tmp164, f"tmp166": tmp166, f"tmp167": tmp167, f"tmp168": tmp168, f"tmp170": tmp170, f"tmp172": tmp172, f"tmp173": tmp173, f"tmp174": tmp174, f"tmp176": tmp176, f"tmp177": tmp177, f"tmp179": tmp179, f"tmp18": tmp18, f"tmp180": tmp180, f"tmp181": tmp181, f"tmp182": tmp182, f"tmp183": tmp183, f"tmp187": tmp187, f"tmp19": tmp19, f"tmp190": tmp190, f"tmp199": tmp199, f"tmp2": tmp2, f"tmp20": tmp20, f"tmp201": tmp201, f"tmp203": tmp203, f"tmp216": tmp216, f"tmp22": tmp22, f"tmp224": tmp224, f"tmp23": tmp23, f"tmp26": tmp26, f"tmp29": tmp29, f"tmp30": tmp30, f"tmp32": tmp32, f"tmp33": tmp33, f"tmp4": tmp4, f"tmp40": tmp40, f"tmp42": tmp42, f"tmp44": tmp44, f"tmp46": tmp46, f"tmp47": tmp47, f"tmp51": tmp51, f"tmp56": tmp56, f"tmp57": tmp57, f"tmp59": tmp59, f"tmp60": tmp60, f"tmp67": tmp67, f"tmp68": tmp68, f"tmp7": tmp7, f"tmp74": tmp74, f"tmp76": tmp76, f"tmp78": tmp78, f"tmp82": tmp82, f"tmp85": tmp85, f"tmp9": tmp9, f"tmp91": tmp91, f"tmp93": tmp93, f"tmp96": tmp96, f"tmp98": tmp98, f"tmp99": tmp99}

def hbar_matvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:59:58.746642.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp13 = einsum(r2.aaa, (0, 1, 2), v.baa.xov, (3, 2, 1), (3, 0))
    tmp14 = einsum(r2.bab, (0, 1, 2), v.bbb.xov, (3, 2, 0), (3, 1)) * -1
    tmp50 = np.copy(ints.tmp155)
    del ints.tmp155
    tmp50 += ints.tmp190 * 2
    del ints.tmp190
    tmp39 = einsum(v.bbb.xov, (0, 1, 2), r2.bbb, (3, 2, 1), (0, 3))
    tmp38 = einsum(v.baa.xov, (0, 1, 2), r2.aba, (2, 3, 1), (0, 3))
    tmp71 = np.copy(ints.tmp59)
    tmp71 += ints.tmp56 * 2
    tmp73 = np.copy(ints.tmp40)
    tmp73 += ints.tmp201 * 2
    del ints.tmp201
    tmp62 = np.copy(ints.tmp56) * 2
    tmp62 += ints.tmp59
    tmp66 = np.copy(ints.tmp199)
    del ints.tmp199
    tmp66 += ints.tmp203 * 0.5
    del ints.tmp203
    tmp59 = einsum(f.bb.ov, (0, 1), r2.bbb, (2, 1, 3), (0, 3, 2))
    tmp64 = np.copy(np.transpose(ints.tmp57, (1, 0)))
    tmp64 += np.transpose(ints.tmp60, (1, 0)) * 0.5
    tmp64 += f.bb.vv * -0.5
    tmp24 = np.copy(ints.tmp93)
    tmp24 += ints.tmp82 * 2
    tmp28 = np.copy(ints.tmp2)
    tmp28 += ints.tmp76 * 2
    del ints.tmp76
    tmp26 = np.copy(tmp13) * 2
    tmp26 += tmp14
    tmp18 = np.copy(np.transpose(ints.tmp30, (1, 0)))
    tmp18 += np.transpose(ints.tmp33, (1, 0)) * 0.5
    tmp18 += f.aa.vv * -0.5
    tmp16 = np.copy(ints.tmp29) * 2
    tmp16 += ints.tmp32
    tmp15 = np.copy(tmp13)
    tmp15 += tmp14 * 0.5
    tmp11 = einsum(r2.aaa, (0, 1, 2), f.aa.ov, (3, 1), (3, 2, 0))
    tmp20 = np.copy(ints.tmp74)
    del ints.tmp74
    tmp20 += ints.tmp78 * 0.5
    del ints.tmp78
    tmp70 = einsum(r2.bbb, (0, 1, 2), tmp50, (3, 2, 4, 1), (3, 0, 4)) * -1
    tmp69 = einsum(v.bbb.xov, (0, 1, 2), tmp39, (0, 3), (1, 3, 2))
    tmp72 = einsum(tmp38, (0, 1), tmp71, (0, 2, 3), (2, 1, 3))
    del tmp71
    tmp74 = einsum(r1.b, (0,), tmp73, (1, 2, 0, 3), (1, 2, 3))
    del tmp73
    tmp63 = einsum(tmp62, (0, 1, 2), tmp39, (0, 3), (1, 3, 2)) * 2
    del tmp62
    tmp58 = einsum(r2.aba, (0, 1, 2), ints.tmp187, (2, 3, 0, 4), (3, 4, 1))
    tmp61 = einsum(v.bbb.xov, (0, 1, 2), tmp38, (0, 3), (1, 3, 2))
    tmp67 = einsum(r1.b, (0,), tmp66, (1, 2, 0, 3), (1, 2, 3)) * 2
    del tmp66
    tmp60 = einsum(t1.bb, (0, 1), tmp59, (0, 2, 3), (2, 3, 1))
    del tmp59
    tmp65 = einsum(r2.bbb, (0, 1, 2), tmp64, (1, 3), (2, 0, 3)) * -4
    del tmp64
    tmp8 = einsum(ints.tmp51, (0, 1, 2, 3), r2.bbb, (2, 3, 0), (1,))
    tmp7 = einsum(r2.aba, (0, 1, 2), ints.tmp26, (2, 3, 0, 1), (3,))
    tmp47 = einsum(r1.b, (0,), f.bb.ov, (1, 0), (1,))
    tmp3 = einsum(r2.aaa, (0, 1, 2), ints.tmp23, (2, 3, 1, 0), (3,)) * -1
    tmp4 = einsum(r2.bab, (0, 1, 2), ints.tmp26, (3, 2, 1, 0), (3,)) * -1
    tmp32 = einsum(f.aa.ov, (0, 1), r1.a, (1,), (0,))
    tmp45 = einsum(t1.bb, (0, 1), f.bb.ov, (0, 2), (2, 1))
    tmp43 = einsum(f.aa.ov, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp25 = einsum(tmp24, (0, 1, 2, 3), r2.aaa, (4, 3, 1), (0, 4, 2)) * -1
    del tmp24
    tmp23 = einsum(r2.bab, (0, 1, 2), ints.tmp85, (3, 2, 4, 0), (3, 4, 1)) * -1
    tmp29 = einsum(r1.a, (0,), tmp28, (1, 2, 0, 3), (1, 2, 3))
    del tmp28
    tmp27 = einsum(tmp26, (0, 1), v.baa.xov, (0, 2, 3), (2, 3, 1))
    del tmp26
    tmp19 = einsum(r2.aaa, (0, 1, 2), tmp18, (1, 3), (2, 0, 3)) * -4
    del tmp18
    tmp17 = einsum(tmp16, (0, 1, 2), tmp15, (0, 3), (1, 2, 3)) * 2
    del tmp16, tmp15
    tmp12 = einsum(t1.aa, (0, 1), tmp11, (0, 2, 3), (2, 3, 1))
    del tmp11
    tmp21 = einsum(r1.a, (0,), tmp20, (1, 2, 0, 3), (1, 2, 3)) * 2
    del tmp20
    tmp0 = np.copy(f.bb.ov)
    tmp0 += ints.tmp19
    del ints.tmp19
    tmp0 += ints.tmp22
    del ints.tmp22
    tmp0 += ints.tmp18 * -1
    del ints.tmp18
    tmp1 = np.copy(f.aa.ov)
    tmp1 += ints.tmp15
    del ints.tmp15
    tmp1 += ints.tmp20
    del ints.tmp20
    tmp1 += ints.tmp13 * -1
    del ints.tmp13
    tmp55 = np.copy(f.bb.oo)
    tmp55 += ints.tmp164
    del ints.tmp164
    tmp55 += np.transpose(ints.tmp168, (1, 0)) * 2
    del ints.tmp168
    tmp55 += np.transpose(ints.tmp170, (1, 0))
    del ints.tmp170
    tmp75 = np.copy(tmp69) * 2
    del tmp69
    tmp75 += np.transpose(tmp70, (0, 2, 1)) * -2
    del tmp70
    tmp75 += np.transpose(tmp72, (0, 2, 1))
    del tmp72
    tmp75 += tmp74
    del tmp74
    tmp68 = np.copy(tmp58)
    del tmp58
    tmp68 += tmp60 * 2
    del tmp60
    tmp68 += tmp61
    del tmp61
    tmp68 += np.transpose(tmp63, (0, 2, 1))
    del tmp63
    tmp68 += np.transpose(tmp65, (0, 2, 1))
    del tmp65
    tmp68 += tmp67
    del tmp67
    tmp57 = einsum(ints.tmp51, (0, 1, 2, 3), r2.bbb, (3, 2, 4), (0, 1, 4)) * -1
    del ints.tmp51
    tmp56 = np.copy(ints.tmp166) * 2
    del ints.tmp166
    tmp56 += ints.tmp172
    del ints.tmp172
    tmp56 += ints.tmp173
    del ints.tmp173
    tmp56 += ints.tmp176 * 2
    del ints.tmp176
    tmp56 += ints.tmp177
    del ints.tmp177
    tmp56 += f.bb.ov * -1
    tmp56 += ints.tmp163 * -1
    del ints.tmp163
    tmp56 += ints.tmp167 * -1
    del ints.tmp167
    tmp56 += ints.tmp179 * -1
    del ints.tmp179
    tmp56 += ints.tmp180 * -2
    del ints.tmp180
    tmp76 = np.copy(tmp47) * -1
    tmp76 += tmp7
    tmp76 += tmp8 * 2
    tmp51 = np.copy(ints.tmp154)
    del ints.tmp154
    tmp51 += ints.tmp174 * -1
    del ints.tmp174
    tmp49 = einsum(ints.tmp26, (0, 1, 2, 3), r2.bab, (3, 2, 4), (0, 1, 4)) * -1
    tmp33 = np.copy(tmp32) * 0.5
    del tmp32
    tmp33 += tmp3 * -1
    tmp33 += tmp4 * 0.5
    tmp54 = np.copy(ints.tmp157)
    del ints.tmp157
    tmp54 += np.transpose(ints.tmp181, (0, 2, 1, 3))
    del ints.tmp181
    tmp54 += np.transpose(ints.tmp183, (0, 2, 1, 3)) * 2
    del ints.tmp183
    tmp54 += ints.tmp4
    tmp54 += ints.tmp151 * -1
    del ints.tmp151
    tmp54 += np.transpose(ints.tmp182, (0, 2, 1, 3)) * -1
    del ints.tmp182
    tmp53 = np.copy(ints.tmp56) * 2
    del ints.tmp56
    tmp53 += ints.tmp59
    del ints.tmp59
    tmp53 += v.bbb.xov
    tmp46 = np.copy(np.transpose(ints.tmp57, (1, 0))) * 2
    tmp46 += np.transpose(ints.tmp60, (1, 0))
    tmp46 += f.bb.vv * -1
    tmp46 += tmp45
    del tmp45
    tmp52 = np.copy(tmp13) * 2
    del tmp13
    tmp52 += tmp14
    del tmp14
    tmp44 = np.copy(np.transpose(ints.tmp30, (1, 0))) * 2
    tmp44 += np.transpose(ints.tmp33, (1, 0))
    tmp44 += f.aa.vv * -1
    tmp44 += tmp43
    del tmp43
    tmp36 = np.copy(ints.tmp82) * 2
    del ints.tmp82
    tmp36 += ints.tmp93
    del ints.tmp93
    tmp35 = einsum(r2.aba, (0, 1, 2), ints.tmp26, (3, 4, 0, 1), (3, 2, 4))
    del ints.tmp26
    tmp42 = np.copy(ints.tmp126)
    del ints.tmp126
    tmp42 += np.transpose(ints.tmp138, (0, 1, 3, 2))
    del ints.tmp138
    tmp42 += np.transpose(ints.tmp140, (0, 1, 3, 2)) * 2
    del ints.tmp140
    tmp42 += ints.tmp42
    tmp42 += ints.tmp122 * -1
    del ints.tmp122
    tmp42 += np.transpose(ints.tmp139, (0, 1, 3, 2)) * -1
    del ints.tmp139
    tmp40 = np.copy(tmp38) * -1
    del tmp38
    tmp40 += tmp39 * 2
    del tmp39
    tmp34 = np.copy(ints.tmp109)
    del ints.tmp109
    tmp34 += ints.tmp112 * 2
    del ints.tmp112
    tmp34 += ints.tmp91
    del ints.tmp91
    tmp34 += ints.tmp96 * 2
    del ints.tmp96
    tmp34 += ints.tmp98
    del ints.tmp98
    tmp34 += f.aa.ov * -1
    tmp34 += ints.tmp106 * -1
    del ints.tmp106
    tmp34 += ints.tmp113 * -1
    del ints.tmp113
    tmp34 += ints.tmp67 * -2
    del ints.tmp67
    tmp34 += ints.tmp68 * -1
    del ints.tmp68
    tmp31 = np.copy(f.aa.oo)
    tmp31 += ints.tmp107
    del ints.tmp107
    tmp31 += np.transpose(ints.tmp114, (1, 0)) * 2
    del ints.tmp114
    tmp31 += np.transpose(ints.tmp116, (1, 0))
    del ints.tmp116
    tmp37 = np.copy(ints.tmp125)
    del ints.tmp125
    tmp37 += ints.tmp136 * -1
    del ints.tmp136
    tmp41 = np.copy(ints.tmp32)
    del ints.tmp32
    tmp41 += v.baa.xov
    tmp41 += ints.tmp29 * 2
    del ints.tmp29
    tmp48 = np.copy(tmp47) * -0.5
    del tmp47
    tmp48 += tmp7 * 0.5
    tmp48 += tmp8
    tmp30 = np.copy(tmp23)
    del tmp23
    tmp30 += np.transpose(tmp25, (0, 2, 1)) * -2
    del tmp25
    tmp30 += np.transpose(tmp27, (0, 2, 1))
    del tmp27
    tmp30 += tmp29
    del tmp29
    tmp22 = np.copy(tmp12) * 2
    del tmp12
    tmp22 += tmp17
    del tmp17
    tmp22 += np.transpose(tmp19, (0, 2, 1))
    del tmp19
    tmp22 += tmp21
    del tmp21
    tmp10 = einsum(ints.tmp23, (0, 1, 2, 3), r2.aaa, (2, 3, 4), (0, 1, 4))
    del ints.tmp23
    tmp9 = np.copy(tmp7)
    del tmp7
    tmp9 += tmp8 * 2
    del tmp8
    tmp9 += einsum(r1.b, (0,), tmp0, (1, 0), (1,)) * -1
    tmp6 = np.copy(ints.tmp46)
    del ints.tmp46
    tmp6 += np.transpose(ints.tmp57, (1, 0)) * 2
    del ints.tmp57
    tmp6 += np.transpose(ints.tmp60, (1, 0))
    del ints.tmp60
    tmp6 += f.bb.vv * -1
    tmp6 += np.transpose(ints.tmp44, (1, 0)) * -1
    del ints.tmp44
    tmp6 += np.transpose(ints.tmp47, (1, 0)) * -1
    del ints.tmp47
    tmp5 = np.copy(tmp3) * -2
    del tmp3
    tmp5 += tmp4
    del tmp4
    tmp5 += einsum(tmp1, (0, 1), r1.a, (1,), (0,))
    tmp2 = np.copy(np.transpose(ints.tmp30, (1, 0))) * 2
    del ints.tmp30
    tmp2 += np.transpose(ints.tmp33, (1, 0))
    del ints.tmp33
    tmp2 += ints.tmp9
    del ints.tmp9
    tmp2 += f.aa.vv * -1
    tmp2 += np.transpose(ints.tmp11, (1, 0)) * -1
    del ints.tmp11
    tmp2 += np.transpose(ints.tmp7, (1, 0)) * -1
    del ints.tmp7
    r2new.bbb = einsum(ints.tmp224, (0, 1, 2, 3), r2.bbb, (3, 1, 4), (0, 2, 4)) * 2
    del ints.tmp224
    r2new.bbb += einsum(r1.b, (0,), ints.tmp216, (1, 2, 3, 0), (3, 2, 1)) * 2
    del ints.tmp216
    r2new.bbb += einsum(tmp57, (0, 1, 2), t2.bbbb, (0, 1, 3, 4), (3, 4, 2)) * 2
    del tmp57
    r2new.bbb += np.transpose(tmp68, (1, 2, 0)) * -1
    r2new.bbb += np.transpose(tmp68, (2, 1, 0))
    del tmp68
    r2new.bbb += np.transpose(tmp75, (1, 2, 0))
    r2new.bbb += np.transpose(tmp75, (2, 1, 0)) * -1
    del tmp75
    r2new.bbb += einsum(tmp55, (0, 1), r2.bbb, (2, 3, 0), (2, 3, 1)) * -2
    r2new.bbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp76, (1,), (2, 3, 0)) * -2
    del tmp76
    r2new.bbb += einsum(r1.b, (0,), tmp56, (1, 2), (0, 2, 1)) * -1
    r2new.bbb += einsum(tmp56, (0, 1), r1.b, (2,), (1, 2, 0))
    r2new.bab = einsum(ints.tmp187, (0, 1, 2, 3), r2.aaa, (4, 2, 0), (3, 4, 1)) * 2
    del ints.tmp187
    r2new.bab += einsum(r2.bab, (0, 1, 2), ints.tmp132, (3, 1, 4, 0), (4, 3, 2))
    r2new.bab += einsum(t2.abab, (0, 1, 2, 3), tmp49, (0, 1, 4), (3, 2, 4)) * -1
    del tmp49
    r2new.bab += einsum(tmp50, (0, 1, 2, 3), r2.bab, (3, 4, 1), (2, 4, 0)) * -1
    del tmp50
    r2new.bab += einsum(tmp51, (0, 1, 2, 3), r2.bab, (4, 3, 1), (4, 2, 0))
    del tmp51
    r2new.bab += einsum(tmp52, (0, 1), tmp53, (0, 2, 3), (3, 1, 2)) * -1
    del tmp52, tmp53
    r2new.bab += einsum(r1.a, (0,), tmp54, (1, 2, 0, 3), (3, 2, 1)) * -1
    del tmp54
    r2new.bab += einsum(tmp46, (0, 1), r2.bab, (0, 2, 3), (1, 2, 3)) * -1
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp44, (1, 3), (0, 3, 2)) * -1
    r2new.bab += einsum(tmp55, (0, 1), r2.bab, (2, 3, 0), (2, 3, 1)) * -1
    del tmp55
    r2new.bab += einsum(t2.abab, (0, 1, 2, 3), tmp33, (0,), (3, 2, 1)) * 2
    r2new.bab += einsum(tmp56, (0, 1), r1.a, (2,), (1, 2, 0))
    del tmp56
    r2new.aba = einsum(t2.abab, (0, 1, 2, 3), tmp35, (0, 4, 1), (2, 3, 4))
    del tmp35
    r2new.aba += einsum(r2.aba, (0, 1, 2), ints.tmp132, (3, 0, 4, 1), (3, 4, 2))
    del ints.tmp132
    r2new.aba += einsum(r2.bbb, (0, 1, 2), ints.tmp85, (3, 2, 4, 1), (4, 0, 3)) * 2
    del ints.tmp85
    r2new.aba += einsum(tmp36, (0, 1, 2, 3), r2.aba, (3, 4, 1), (2, 4, 0)) * -1
    del tmp36
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp37, (3, 2, 4, 1), (0, 4, 3))
    del tmp37
    r2new.aba += einsum(tmp41, (0, 1, 2), tmp40, (0, 3), (2, 3, 1)) * -1
    del tmp41, tmp40
    r2new.aba += einsum(tmp42, (0, 1, 2, 3), r1.b, (3,), (1, 2, 0)) * -1
    del tmp42
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp44, (0, 3), (3, 1, 2)) * -1
    del tmp44
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp46, (1, 3), (0, 3, 2)) * -1
    del tmp46
    r2new.aba += einsum(tmp31, (0, 1), r2.aba, (2, 3, 0), (2, 3, 1)) * -1
    r2new.aba += einsum(t2.abab, (0, 1, 2, 3), tmp48, (1,), (2, 3, 0)) * -2
    del tmp48
    r2new.aba += einsum(r1.b, (0,), tmp34, (1, 2), (2, 0, 1))
    r2new.aaa = einsum(ints.tmp99, (0, 1, 2, 3), r1.a, (3,), (2, 1, 0)) * 2
    del ints.tmp99
    r2new.aaa += einsum(tmp10, (0, 1, 2), t2.aaaa, (0, 1, 3, 4), (3, 4, 2)) * 2
    del tmp10
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), ints.tmp110, (3, 0, 4, 1), (3, 4, 2)) * -2
    del ints.tmp110
    r2new.aaa += np.transpose(tmp22, (1, 2, 0)) * -1
    r2new.aaa += np.transpose(tmp22, (2, 1, 0))
    del tmp22
    r2new.aaa += np.transpose(tmp30, (1, 2, 0))
    r2new.aaa += np.transpose(tmp30, (2, 1, 0)) * -1
    del tmp30
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp31, (2, 3), (0, 1, 3)) * -2
    del tmp31
    r2new.aaa += einsum(tmp33, (0,), t2.aaaa, (1, 0, 2, 3), (2, 3, 1)) * 4
    del tmp33
    r2new.aaa += einsum(tmp34, (0, 1), r1.a, (2,), (2, 1, 0)) * -1
    r2new.aaa += einsum(r1.a, (0,), tmp34, (1, 2), (2, 0, 1))
    del tmp34
    r1new.b = einsum(r2.bbb, (0, 1, 2), ints.tmp40, (2, 3, 0, 1), (3,)) * 2
    del ints.tmp40
    r1new.b += einsum(r2.aba, (0, 1, 2), ints.tmp42, (2, 0, 3, 1), (3,)) * -1
    del ints.tmp42
    r1new.b += einsum(r2.aba, (0, 1, 2), tmp1, (2, 0), (1,)) * -1
    r1new.b += einsum(r2.bbb, (0, 1, 2), tmp0, (2, 1), (0,)) * 2
    r1new.b += einsum(tmp6, (0, 1), r1.b, (0,), (1,)) * -1
    del tmp6
    r1new.b += einsum(t1.bb, (0, 1), tmp9, (0,), (1,))
    del tmp9
    r1new.a = einsum(r2.aaa, (0, 1, 2), ints.tmp2, (2, 3, 1, 0), (3,)) * -2
    del ints.tmp2
    r1new.a += einsum(r2.bab, (0, 1, 2), ints.tmp4, (2, 3, 1, 0), (3,)) * -1
    del ints.tmp4
    r1new.a += einsum(r2.bab, (0, 1, 2), tmp0, (2, 0), (1,)) * -1
    del tmp0
    r1new.a += einsum(r2.aaa, (0, 1, 2), tmp1, (2, 1), (0,)) * 2
    del tmp1
    r1new.a += einsum(tmp2, (0, 1), r1.a, (0,), (1,)) * -1
    del tmp2
    r1new.a += einsum(t1.aa, (0, 1), tmp5, (0,), (1,)) * -1
    del tmp5

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ip_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:03:21.725052.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp10 : array
    tmp100 : array
    tmp102 : array
    tmp103 : array
    tmp105 : array
    tmp108 : array
    tmp11 : array
    tmp110 : array
    tmp112 : array
    tmp114 : array
    tmp116 : array
    tmp118 : array
    tmp119 : array
    tmp121 : array
    tmp123 : array
    tmp125 : array
    tmp127 : array
    tmp129 : array
    tmp13 : array
    tmp131 : array
    tmp133 : array
    tmp135 : array
    tmp137 : array
    tmp138 : array
    tmp140 : array
    tmp142 : array
    tmp143 : array
    tmp145 : array
    tmp147 : array
    tmp148 : array
    tmp15 : array
    tmp150 : array
    tmp151 : array
    tmp153 : array
    tmp155 : array
    tmp156 : array
    tmp158 : array
    tmp159 : array
    tmp161 : array
    tmp162 : array
    tmp164 : array
    tmp166 : array
    tmp167 : array
    tmp168 : array
    tmp17 : array
    tmp170 : array
    tmp171 : array
    tmp172 : array
    tmp174 : array
    tmp175 : array
    tmp176 : array
    tmp177 : array
    tmp179 : array
    tmp181 : array
    tmp182 : array
    tmp183 : array
    tmp184 : array
    tmp185 : array
    tmp187 : array
    tmp188 : array
    tmp19 : array
    tmp190 : array
    tmp192 : array
    tmp195 : array
    tmp197 : array
    tmp199 : array
    tmp2 : array
    tmp201 : array
    tmp204 : array
    tmp205 : array
    tmp207 : array
    tmp209 : array
    tmp21 : array
    tmp211 : array
    tmp213 : array
    tmp215 : array
    tmp217 : array
    tmp219 : array
    tmp22 : array
    tmp220 : array
    tmp221 : array
    tmp222 : array
    tmp223 : array
    tmp225 : array
    tmp226 : array
    tmp228 : array
    tmp23 : array
    tmp231 : array
    tmp239 : array
    tmp241 : array
    tmp246 : array
    tmp247 : array
    tmp249 : array
    tmp25 : array
    tmp255 : array
    tmp257 : array
    tmp264 : array
    tmp265 : array
    tmp267 : array
    tmp268 : array
    tmp270 : array
    tmp271 : array
    tmp273 : array
    tmp28 : array
    tmp280 : array
    tmp283 : array
    tmp294 : array
    tmp296 : array
    tmp298 : array
    tmp30 : array
    tmp300 : array
    tmp302 : array
    tmp304 : array
    tmp310 : array
    tmp311 : array
    tmp313 : array
    tmp314 : array
    tmp316 : array
    tmp318 : array
    tmp32 : array
    tmp320 : array
    tmp325 : array
    tmp326 : array
    tmp327 : array
    tmp329 : array
    tmp33 : array
    tmp335 : array
    tmp337 : array
    tmp339 : array
    tmp34 : array
    tmp340 : array
    tmp344 : array
    tmp346 : array
    tmp352 : array
    tmp354 : array
    tmp358 : array
    tmp36 : array
    tmp362 : array
    tmp364 : array
    tmp37 : array
    tmp388 : array
    tmp39 : array
    tmp390 : array
    tmp4 : array
    tmp417 : array
    tmp418 : array
    tmp419 : array
    tmp42 : array
    tmp421 : array
    tmp423 : array
    tmp437 : array
    tmp439 : array
    tmp44 : array
    tmp441 : array
    tmp442 : array
    tmp46 : array
    tmp47 : array
    tmp48 : array
    tmp5 : array
    tmp50 : array
    tmp52 : array
    tmp54 : array
    tmp55 : array
    tmp56 : array
    tmp57 : array
    tmp59 : array
    tmp60 : array
    tmp62 : array
    tmp64 : array
    tmp65 : array
    tmp67 : array
    tmp68 : array
    tmp7 : array
    tmp70 : array
    tmp72 : array
    tmp74 : array
    tmp75 : array
    tmp77 : array
    tmp78 : array
    tmp79 : array
    tmp8 : array
    tmp80 : array
    tmp82 : array
    tmp83 : array
    tmp85 : array
    tmp87 : array
    tmp89 : array
    tmp91 : array
    tmp94 : array
    tmp97 : array
    """

    tmp29 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (1, 2), (0,))
    tmp31 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 0, 1), (2,))
    tmp106 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 3, 1), (2, 0, 3))
    tmp27 = einsum(t1.aa, (0, 1), v.baa.xov, (2, 3, 1), (2, 0, 3))
    tmp170 = einsum(v.baa.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp325 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp47 = einsum(v.bbb.xov, (0, 1, 2), tmp29, (0,), (1, 2))
    tmp48 = einsum(tmp31, (0,), v.baa.xov, (0, 1, 2), (1, 2))
    tmp44 = einsum(tmp31, (0,), v.bbb.xov, (0, 1, 2), (1, 2))
    tmp107 = einsum(tmp106, (0, 1, 2), v.bbb.xov, (0, 1, 3), (2, 3))
    tmp39 = einsum(v.baa.xov, (0, 1, 2), tmp29, (0,), (1, 2))
    tmp99 = einsum(v.baa.xov, (0, 1, 2), tmp27, (0, 1, 3), (3, 2))
    tmp166 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp59 = einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp77 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (4, 1, 3))
    tmp82 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (0, 3, 4))
    tmp56 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp230 = einsum(tmp106, (0, 1, 2), tmp27, (0, 3, 4), (3, 4, 1, 2))
    tmp351 = einsum(tmp106, (0, 1, 2), tmp106, (0, 3, 4), (1, 3, 2, 4))
    tmp41 = einsum(v.baa.xvv, (0, 1, 2), t1.aa, (3, 2), (0, 3, 1))
    tmp45 = einsum(t1.bb, (0, 1), v.bbb.xvv, (2, 3, 1), (2, 0, 3))
    tmp194 = einsum(v.bbb.xoo, (0, 1, 2), tmp27, (0, 3, 4), (3, 4, 1, 2))
    tmp196 = einsum(tmp106, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp334 = einsum(tmp106, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp171 = einsum(t2.abab, (0, 1, 2, 3), tmp170, (4, 5, 2, 3), (0, 4, 1, 5))
    tmp326 = einsum(t2.bbbb, (0, 1, 2, 3), tmp325, (4, 5, 2, 3), (0, 1, 5, 4)) * -1
    tmp54 = einsum(tmp27, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp137 = einsum(v.bbb.xov, (0, 1, 2), tmp106, (0, 3, 4), (3, 1, 4, 2))
    tmp282 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp279 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp25 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp64 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp36 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp246 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp227 = einsum(tmp27, (0, 1, 2), tmp27, (0, 3, 4), (1, 3, 2, 4))
    tmp225 = einsum(t1.bb, (0, 1), tmp47, (2, 1), (0, 2))
    tmp176 = einsum(t1.aa, (0, 1), tmp48, (2, 1), (0, 2))
    tmp221 = einsum(t1.bb, (0, 1), tmp44, (2, 1), (0, 2))
    tmp219 = einsum(tmp107, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp175 = einsum(t1.aa, (0, 1), tmp39, (2, 1), (0, 2))
    tmp174 = einsum(t1.aa, (0, 1), tmp99, (2, 1), (0, 2))
    tmp208 = einsum(tmp31, (0,), v.baa.xvv, (0, 1, 2), (1, 2))
    tmp206 = einsum(tmp29, (0,), v.bbb.xvv, (0, 1, 2), (1, 2))
    tmp203 = einsum(tmp31, (0,), v.bbb.xvv, (0, 1, 2), (1, 2))
    tmp198 = einsum(v.baa.xvv, (0, 1, 2), tmp29, (0,), (1, 2))
    tmp189 = einsum(tmp27, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp187 = einsum(v.bbb.xoo, (0, 1, 2), tmp29, (0,), (1, 2))
    tmp32 = einsum(tmp31, (0,), v.baa.xoo, (0, 1, 2), (1, 2))
    tmp183 = einsum(tmp31, (0,), v.bbb.xoo, (0, 1, 2), (1, 2))
    del tmp31
    tmp181 = einsum(tmp106, (0, 1, 2), v.bbb.xoo, (0, 3, 1), (3, 2))
    tmp30 = einsum(tmp29, (0,), v.baa.xoo, (0, 1, 2), (1, 2))
    del tmp29
    tmp28 = einsum(tmp27, (0, 1, 2), v.baa.xoo, (0, 3, 1), (3, 2))
    tmp167 = einsum(t2.aaaa, (0, 1, 2, 3), tmp166, (4, 5, 2, 3), (0, 1, 5, 4)) * -1
    tmp60 = einsum(v.baa.xov, (0, 1, 2), tmp59, (0, 3, 2), (3, 1))
    tmp161 = einsum(v.bbb.xov, (0, 1, 2), tmp77, (0, 3, 2), (3, 1))
    tmp158 = einsum(tmp82, (0, 1, 2), v.bbb.xov, (0, 3, 2), (1, 3))
    tmp57 = einsum(tmp56, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp142 = einsum(tmp106, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp50 = einsum(tmp27, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp96 = einsum(v.baa.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp93 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp67 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp23 = einsum(v.baa.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp33 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp21 = einsum(t1.bb, (0, 1), f.bb.ov, (2, 1), (2, 0))
    tmp1 = einsum(f.aa.ov, (0, 1), t1.aa, (2, 1), (0, 2))
    tmp442 = einsum(t2.abab, (0, 1, 2, 3), tmp170, (4, 1, 2, 5), (0, 4, 3, 5))
    tmp441 = einsum(v.bbb.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp439 = einsum(v.bbb.xov, (0, 1, 2), tmp77, (0, 1, 3), (3, 2))
    tmp437 = einsum(tmp82, (0, 1, 2), v.bbb.xov, (0, 1, 3), (2, 3))
    tmp423 = einsum(t2.bbbb, (0, 1, 2, 3), tmp325, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp421 = einsum(t2.abab, (0, 1, 2, 3), tmp325, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp419 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp418 = einsum(t2.abab, (0, 1, 2, 3), tmp170, (0, 4, 5, 3), (1, 4, 2, 5))
    tmp417 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp390 = einsum(v.baa.xov, (0, 1, 2), tmp59, (0, 1, 3), (3, 2))
    tmp388 = einsum(tmp56, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp364 = einsum(t2.abab, (0, 1, 2, 3), tmp166, (0, 4, 5, 2), (4, 1, 5, 3))
    tmp362 = einsum(tmp166, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 1, 5, 2))
    tmp358 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp354 = einsum(tmp230, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 3, 4))
    tmp352 = einsum(tmp351, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    del tmp351
    tmp346 = einsum(tmp41, (0, 1, 2), tmp106, (0, 3, 4), (1, 3, 4, 2))
    tmp344 = einsum(tmp106, (0, 1, 2), tmp45, (0, 3, 4), (1, 3, 2, 4))
    tmp340 = einsum(tmp194, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 3, 4))
    tmp339 = einsum(tmp196, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 3, 4))
    tmp337 = einsum(t1.bb, (0, 1), tmp334, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp335 = einsum(tmp334, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 3, 4))
    del tmp334
    tmp329 = einsum(tmp171, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 3, 4))
    tmp327 = einsum(tmp326, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 3, 4)) * -1
    tmp320 = einsum(tmp54, (0, 1, 2, 3), t2.abab, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp318 = einsum(tmp106, (0, 1, 2), tmp77, (0, 3, 4), (1, 3, 2, 4))
    tmp316 = einsum(tmp56, (0, 1, 2), tmp106, (0, 3, 4), (1, 3, 4, 2))
    tmp314 = einsum(t2.bbbb, (0, 1, 2, 3), tmp137, (4, 5, 1, 3), (4, 0, 5, 2))
    tmp313 = einsum(tmp137, (0, 1, 2, 3), t2.abab, (4, 2, 5, 3), (4, 0, 1, 5))
    tmp311 = einsum(tmp106, (0, 1, 2), tmp82, (0, 3, 4), (1, 3, 2, 4))
    tmp310 = einsum(tmp106, (0, 1, 2), tmp59, (0, 3, 4), (3, 1, 2, 4))
    tmp304 = einsum(t2.bbbb, (0, 1, 2, 3), tmp47, (4, 3), (0, 1, 4, 2))
    tmp302 = einsum(t2.abab, (0, 1, 2, 3), tmp47, (4, 3), (0, 1, 4, 2))
    tmp300 = einsum(tmp44, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp298 = einsum(t2.abab, (0, 1, 2, 3), tmp44, (4, 3), (0, 1, 4, 2))
    tmp296 = einsum(tmp107, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp294 = einsum(tmp107, (0, 1), t2.abab, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp283 = einsum(t2.abab, (0, 1, 2, 3), tmp282, (4, 2, 5, 3), (0, 1, 4, 5))
    del tmp282
    tmp280 = einsum(t2.bbbb, (0, 1, 2, 3), tmp279, (4, 5, 2, 3), (0, 1, 4, 5)) * -1
    del tmp279
    tmp273 = einsum(v.bbb.xoo, (0, 1, 2), tmp77, (0, 3, 4), (3, 1, 2, 4))
    tmp271 = einsum(tmp56, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp270 = einsum(tmp25, (0, 1, 2, 3), t2.abab, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp268 = einsum(tmp82, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp267 = einsum(tmp59, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp265 = einsum(tmp64, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 3), (4, 1, 2, 5))
    tmp264 = einsum(t2.abab, (0, 1, 2, 3), tmp64, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp257 = einsum(tmp41, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp255 = einsum(tmp45, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp249 = einsum(tmp36, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 3, 4))
    tmp247 = einsum(tmp246, (0, 1, 2, 3), t1.bb, (1, 4), (3, 0, 2, 4))
    tmp241 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.ov, (4, 3), (4, 0, 1, 2))
    tmp239 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (4, 3), (0, 4, 1, 2))
    tmp231 = einsum(tmp230, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    del tmp230
    tmp228 = einsum(t1.aa, (0, 1), tmp227, (2, 3, 4, 0), (2, 3, 4, 1))
    del tmp227
    tmp226 = einsum(tmp225, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp223 = einsum(tmp176, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp222 = einsum(t1.bb, (0, 1), tmp221, (2, 0), (2, 1))
    tmp220 = einsum(tmp219, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp217 = einsum(tmp175, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp215 = einsum(tmp174, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp213 = einsum(tmp45, (0, 1, 2), tmp27, (0, 3, 4), (3, 4, 1, 2))
    tmp211 = einsum(tmp27, (0, 1, 2), tmp41, (0, 3, 4), (1, 3, 2, 4))
    tmp209 = einsum(t1.aa, (0, 1), tmp208, (2, 1), (0, 2))
    del tmp208
    tmp207 = einsum(tmp206, (0, 1), t1.bb, (2, 1), (2, 0))
    del tmp206
    tmp205 = einsum(tmp106, (0, 1, 2), tmp45, (0, 2, 3), (1, 3))
    del tmp106
    tmp204 = einsum(t1.bb, (0, 1), tmp203, (2, 1), (0, 2))
    del tmp203
    tmp201 = einsum(tmp41, (0, 1, 2), tmp27, (0, 3, 1), (3, 2))
    tmp199 = einsum(tmp198, (0, 1), t1.aa, (2, 1), (2, 0))
    del tmp198
    tmp197 = einsum(tmp196, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    del tmp196
    tmp195 = einsum(tmp194, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    del tmp194
    tmp192 = einsum(tmp189, (0, 1, 2, 3), t1.aa, (3, 4), (0, 1, 2, 4))
    tmp190 = einsum(tmp189, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 3, 4))
    del tmp189
    tmp188 = einsum(tmp187, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp185 = einsum(tmp32, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp184 = einsum(tmp183, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp182 = einsum(tmp181, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp179 = einsum(tmp30, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp177 = einsum(tmp28, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp172 = einsum(t1.bb, (0, 1), tmp171, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp168 = einsum(t1.aa, (0, 1), tmp167, (2, 3, 0, 4), (2, 3, 4, 1)) * -1
    tmp164 = einsum(tmp60, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp162 = einsum(t1.bb, (0, 1), tmp161, (2, 0), (2, 1))
    tmp159 = einsum(tmp158, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp156 = einsum(tmp57, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp155 = einsum(t2.abab, (0, 1, 2, 3), tmp142, (4, 5, 1, 2), (0, 4, 5, 3))
    tmp153 = einsum(tmp82, (0, 1, 2), tmp27, (0, 3, 4), (3, 4, 1, 2))
    tmp151 = einsum(tmp27, (0, 1, 2), tmp59, (0, 3, 4), (1, 3, 2, 4))
    tmp150 = einsum(t2.abab, (0, 1, 2, 3), tmp50, (4, 5, 0, 2), (4, 5, 1, 3))
    tmp148 = einsum(tmp50, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp147 = einsum(tmp27, (0, 1, 2), tmp77, (0, 3, 4), (1, 2, 3, 4))
    tmp145 = einsum(tmp27, (0, 1, 2), tmp56, (0, 3, 4), (1, 3, 2, 4))
    del tmp27
    tmp143 = einsum(t2.abab, (0, 1, 2, 3), tmp142, (0, 4, 1, 2), (4, 3))
    tmp140 = einsum(tmp54, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    tmp138 = einsum(t2.bbbb, (0, 1, 2, 3), tmp137, (4, 1, 0, 3), (4, 2))
    tmp135 = einsum(tmp50, (0, 1, 2, 3), t2.aaaa, (2, 1, 4, 3), (0, 4))
    tmp133 = einsum(t2.abab, (0, 1, 2, 3), tmp48, (4, 2), (0, 4, 1, 3))
    tmp131 = einsum(tmp48, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp129 = einsum(t2.abab, (0, 1, 2, 3), tmp39, (4, 2), (0, 4, 1, 3))
    tmp127 = einsum(tmp39, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp125 = einsum(t2.abab, (0, 1, 2, 3), tmp99, (4, 2), (0, 4, 1, 3))
    tmp123 = einsum(t2.aaaa, (0, 1, 2, 3), tmp99, (4, 3), (0, 1, 4, 2))
    tmp121 = einsum(t2.bbbb, (0, 1, 2, 3), tmp47, (1, 3), (0, 2))
    tmp119 = einsum(t2.abab, (0, 1, 2, 3), tmp47, (1, 3), (0, 2))
    tmp118 = einsum(t2.abab, (0, 1, 2, 3), tmp48, (0, 2), (1, 3))
    tmp116 = einsum(tmp48, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp114 = einsum(t2.bbbb, (0, 1, 2, 3), tmp44, (1, 3), (0, 2))
    tmp112 = einsum(tmp44, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp110 = einsum(t2.bbbb, (0, 1, 2, 3), tmp107, (1, 3), (0, 2))
    tmp108 = einsum(t2.abab, (0, 1, 2, 3), tmp107, (1, 3), (0, 2))
    del tmp107
    tmp105 = einsum(t2.abab, (0, 1, 2, 3), tmp39, (0, 2), (1, 3))
    tmp103 = einsum(t2.aaaa, (0, 1, 2, 3), tmp39, (1, 3), (0, 2))
    tmp102 = einsum(t2.abab, (0, 1, 2, 3), tmp99, (0, 2), (1, 3))
    tmp100 = einsum(tmp99, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    del tmp99
    tmp97 = einsum(t2.abab, (0, 1, 2, 3), tmp96, (4, 2, 5, 3), (0, 4, 1, 5))
    del tmp96
    tmp94 = einsum(t2.aaaa, (0, 1, 2, 3), tmp93, (4, 2, 5, 3), (0, 1, 4, 5)) * -1
    del tmp93
    tmp91 = einsum(tmp59, (0, 1, 2), v.baa.xvv, (0, 3, 2), (1, 3))
    tmp89 = einsum(tmp77, (0, 1, 2), v.bbb.xvv, (0, 3, 2), (1, 3))
    tmp87 = einsum(v.bbb.xvv, (0, 1, 2), tmp82, (0, 3, 2), (3, 1)) * -1
    tmp85 = einsum(v.baa.xvv, (0, 1, 2), tmp56, (0, 3, 2), (3, 1)) * -1
    tmp83 = einsum(tmp82, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp80 = einsum(v.baa.xoo, (0, 1, 2), tmp59, (0, 3, 4), (3, 1, 2, 4))
    tmp79 = einsum(t2.abab, (0, 1, 2, 3), tmp67, (4, 5, 1, 2), (0, 4, 5, 3))
    tmp78 = einsum(v.baa.xoo, (0, 1, 2), tmp77, (0, 3, 4), (1, 2, 3, 4))
    tmp75 = einsum(tmp56, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp74 = einsum(t2.abab, (0, 1, 2, 3), tmp23, (4, 0, 5, 2), (4, 5, 1, 3))
    tmp72 = einsum(t2.aaaa, (0, 1, 2, 3), tmp23, (1, 4, 5, 3), (0, 4, 5, 2))
    tmp70 = einsum(tmp25, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    tmp68 = einsum(t2.abab, (0, 1, 2, 3), tmp67, (0, 4, 1, 2), (4, 3))
    tmp65 = einsum(tmp64, (0, 1, 2, 3), t2.bbbb, (1, 2, 4, 3), (0, 4))
    tmp62 = einsum(tmp23, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 3), (0, 4))
    tmp55 = einsum(tmp45, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp52 = einsum(tmp41, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp46 = einsum(v.bbb.xoo, (0, 1, 2), tmp45, (0, 2, 3), (1, 3))
    del tmp45
    tmp42 = einsum(tmp41, (0, 1, 2), v.baa.xoo, (0, 3, 1), (3, 2))
    del tmp41
    tmp37 = einsum(tmp36, (0, 1, 2, 3), t1.bb, (3, 4), (1, 0, 2, 4))
    tmp34 = einsum(tmp33, (0, 1, 2, 3), t1.aa, (1, 4), (3, 0, 2, 4))
    tmp22 = einsum(tmp21, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp19 = einsum(tmp1, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp17 = einsum(f.aa.ov, (0, 1), t2.abab, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp15 = einsum(t2.aaaa, (0, 1, 2, 3), f.aa.ov, (4, 3), (4, 0, 1, 2))
    tmp13 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp11 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp10 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (0, 2), (1, 3))
    tmp8 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp7 = einsum(f.bb.vv, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp5 = einsum(t1.aa, (0, 1), f.aa.vv, (2, 1), (0, 2))
    tmp4 = einsum(t1.bb, (0, 1), f.bb.oo, (2, 0), (2, 1))
    tmp2 = einsum(f.aa.oo, (0, 1), t1.aa, (1, 2), (0, 2))

    return {f"tmp1": tmp1, f"tmp10": tmp10, f"tmp100": tmp100, f"tmp102": tmp102, f"tmp103": tmp103, f"tmp105": tmp105, f"tmp108": tmp108, f"tmp11": tmp11, f"tmp110": tmp110, f"tmp112": tmp112, f"tmp114": tmp114, f"tmp116": tmp116, f"tmp118": tmp118, f"tmp119": tmp119, f"tmp121": tmp121, f"tmp123": tmp123, f"tmp125": tmp125, f"tmp127": tmp127, f"tmp129": tmp129, f"tmp13": tmp13, f"tmp131": tmp131, f"tmp133": tmp133, f"tmp135": tmp135, f"tmp137": tmp137, f"tmp138": tmp138, f"tmp140": tmp140, f"tmp142": tmp142, f"tmp143": tmp143, f"tmp145": tmp145, f"tmp147": tmp147, f"tmp148": tmp148, f"tmp15": tmp15, f"tmp150": tmp150, f"tmp151": tmp151, f"tmp153": tmp153, f"tmp155": tmp155, f"tmp156": tmp156, f"tmp158": tmp158, f"tmp159": tmp159, f"tmp161": tmp161, f"tmp162": tmp162, f"tmp164": tmp164, f"tmp166": tmp166, f"tmp167": tmp167, f"tmp168": tmp168, f"tmp17": tmp17, f"tmp170": tmp170, f"tmp171": tmp171, f"tmp172": tmp172, f"tmp174": tmp174, f"tmp175": tmp175, f"tmp176": tmp176, f"tmp177": tmp177, f"tmp179": tmp179, f"tmp181": tmp181, f"tmp182": tmp182, f"tmp183": tmp183, f"tmp184": tmp184, f"tmp185": tmp185, f"tmp187": tmp187, f"tmp188": tmp188, f"tmp19": tmp19, f"tmp190": tmp190, f"tmp192": tmp192, f"tmp195": tmp195, f"tmp197": tmp197, f"tmp199": tmp199, f"tmp2": tmp2, f"tmp201": tmp201, f"tmp204": tmp204, f"tmp205": tmp205, f"tmp207": tmp207, f"tmp209": tmp209, f"tmp21": tmp21, f"tmp211": tmp211, f"tmp213": tmp213, f"tmp215": tmp215, f"tmp217": tmp217, f"tmp219": tmp219, f"tmp22": tmp22, f"tmp220": tmp220, f"tmp221": tmp221, f"tmp222": tmp222, f"tmp223": tmp223, f"tmp225": tmp225, f"tmp226": tmp226, f"tmp228": tmp228, f"tmp23": tmp23, f"tmp231": tmp231, f"tmp239": tmp239, f"tmp241": tmp241, f"tmp246": tmp246, f"tmp247": tmp247, f"tmp249": tmp249, f"tmp25": tmp25, f"tmp255": tmp255, f"tmp257": tmp257, f"tmp264": tmp264, f"tmp265": tmp265, f"tmp267": tmp267, f"tmp268": tmp268, f"tmp270": tmp270, f"tmp271": tmp271, f"tmp273": tmp273, f"tmp28": tmp28, f"tmp280": tmp280, f"tmp283": tmp283, f"tmp294": tmp294, f"tmp296": tmp296, f"tmp298": tmp298, f"tmp30": tmp30, f"tmp300": tmp300, f"tmp302": tmp302, f"tmp304": tmp304, f"tmp310": tmp310, f"tmp311": tmp311, f"tmp313": tmp313, f"tmp314": tmp314, f"tmp316": tmp316, f"tmp318": tmp318, f"tmp32": tmp32, f"tmp320": tmp320, f"tmp325": tmp325, f"tmp326": tmp326, f"tmp327": tmp327, f"tmp329": tmp329, f"tmp33": tmp33, f"tmp335": tmp335, f"tmp337": tmp337, f"tmp339": tmp339, f"tmp34": tmp34, f"tmp340": tmp340, f"tmp344": tmp344, f"tmp346": tmp346, f"tmp352": tmp352, f"tmp354": tmp354, f"tmp358": tmp358, f"tmp36": tmp36, f"tmp362": tmp362, f"tmp364": tmp364, f"tmp37": tmp37, f"tmp388": tmp388, f"tmp39": tmp39, f"tmp390": tmp390, f"tmp4": tmp4, f"tmp417": tmp417, f"tmp418": tmp418, f"tmp419": tmp419, f"tmp42": tmp42, f"tmp421": tmp421, f"tmp423": tmp423, f"tmp437": tmp437, f"tmp439": tmp439, f"tmp44": tmp44, f"tmp441": tmp441, f"tmp442": tmp442, f"tmp46": tmp46, f"tmp47": tmp47, f"tmp48": tmp48, f"tmp5": tmp5, f"tmp50": tmp50, f"tmp52": tmp52, f"tmp54": tmp54, f"tmp55": tmp55, f"tmp56": tmp56, f"tmp57": tmp57, f"tmp59": tmp59, f"tmp60": tmp60, f"tmp62": tmp62, f"tmp64": tmp64, f"tmp65": tmp65, f"tmp67": tmp67, f"tmp68": tmp68, f"tmp7": tmp7, f"tmp70": tmp70, f"tmp72": tmp72, f"tmp74": tmp74, f"tmp75": tmp75, f"tmp77": tmp77, f"tmp78": tmp78, f"tmp79": tmp79, f"tmp8": tmp8, f"tmp80": tmp80, f"tmp82": tmp82, f"tmp83": tmp83, f"tmp85": tmp85, f"tmp87": tmp87, f"tmp89": tmp89, f"tmp91": tmp91, f"tmp94": tmp94, f"tmp97": tmp97}

def hbar_lmatvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:03:21.915349.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp15 = np.copy(ints.tmp77)
    tmp15 += v.bbb.xov
    tmp15 += ints.tmp82 * 2
    tmp13 = np.copy(ints.tmp59)
    tmp13 += v.baa.xov
    tmp13 += ints.tmp56 * 2
    tmp38 = einsum(r2.bbb, (0, 1, 2), t2.bbbb, (0, 1, 3, 2), (3,))
    tmp37 = einsum(t2.abab, (0, 1, 2, 3), r2.aba, (0, 1, 2), (3,))
    tmp34 = np.copy(ints.tmp56) * 2
    del ints.tmp56
    tmp34 += ints.tmp59
    del ints.tmp59
    tmp34 += v.baa.xov
    tmp16 = einsum(tmp15, (0, 1, 2), r2.bab, (1, 3, 2), (0, 3)) * -1
    tmp14 = einsum(tmp13, (0, 1, 2), r2.aaa, (3, 1, 2), (0, 3)) * -1
    del tmp13
    tmp58 = einsum(tmp15, (0, 1, 2), r2.bbb, (3, 1, 2), (0, 3)) * -1
    del tmp15
    tmp60 = np.copy(f.bb.oo)
    tmp60 += np.transpose(ints.tmp21, (1, 0))
    tmp42 = np.copy(ints.tmp419)
    del ints.tmp419
    tmp42 += ints.tmp423 * 2
    del ints.tmp423
    tmp54 = np.copy(ints.tmp158) * 2
    tmp54 += ints.tmp161
    tmp39 = np.copy(tmp37) * -0.5
    del tmp37
    tmp39 += tmp38
    del tmp38
    tmp51 = einsum(tmp34, (0, 1, 2), r2.aba, (1, 3, 2), (0, 3))
    tmp25 = np.copy(ints.tmp57) * 2
    tmp25 += ints.tmp60
    tmp23 = einsum(t2.aaaa, (0, 1, 2, 3), r2.aaa, (0, 1, 3), (2,))
    tmp17 = np.copy(tmp14) * -2
    del tmp14
    tmp17 += tmp16
    del tmp16
    tmp19 = np.copy(f.aa.oo)
    tmp19 += np.transpose(ints.tmp1, (1, 0))
    tmp9 = einsum(t2.abab, (0, 1, 2, 3), r2.bab, (1, 0, 3), (2,)) * -1
    tmp11 = np.copy(ints.tmp358)
    tmp11 += ints.tmp362 * 2
    tmp59 = einsum(tmp58, (0, 1), v.bbb.xov, (0, 2, 3), (2, 1, 3)) * -1
    del tmp58
    tmp61 = einsum(r2.bbb, (0, 1, 2), tmp60, (1, 3), (0, 3, 2)) * -1
    del tmp60
    tmp57 = einsum(tmp42, (0, 1, 2, 3), r2.bbb, (4, 0, 2), (4, 1, 3)) * -1
    tmp46 = einsum(t1.bb, (0, 1), f.bb.ov, (0, 2), (2, 1))
    tmp49 = einsum(r1.b, (0,), ints.tmp64, (1, 0, 2, 3), (1, 2, 3))
    tmp55 = einsum(tmp54, (0, 1), r2.bbb, (2, 0, 3), (2, 1, 3)) * -2
    del tmp54
    tmp53 = einsum(tmp39, (0,), ints.tmp325, (1, 2, 3, 0), (1, 2, 3)) * 2
    del ints.tmp325
    tmp50 = einsum(ints.tmp421, (0, 1, 2, 3), r2.aba, (0, 4, 2), (1, 4, 3))
    tmp52 = einsum(tmp51, (0, 1), v.bbb.xov, (0, 2, 3), (2, 1, 3))
    del tmp51
    tmp35 = np.copy(ints.tmp77) * 0.5
    del ints.tmp77
    tmp35 += ints.tmp82
    del ints.tmp82
    tmp35 += v.bbb.xov * 0.5
    tmp29 = einsum(f.aa.ov, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp26 = einsum(r2.aaa, (0, 1, 2), tmp25, (1, 3), (0, 3, 2)) * -2
    del tmp25
    tmp22 = einsum(ints.tmp23, (0, 1, 2, 3), r1.a, (1,), (0, 2, 3))
    tmp24 = einsum(ints.tmp166, (0, 1, 2, 3), tmp23, (3,), (0, 1, 2))
    tmp18 = einsum(tmp17, (0, 1), v.baa.xov, (0, 2, 3), (2, 1, 3))
    del tmp17
    tmp20 = einsum(r2.aaa, (0, 1, 2), tmp19, (1, 3), (0, 3, 2)) * -1
    del tmp19
    tmp10 = einsum(tmp9, (0,), ints.tmp166, (1, 2, 3, 0), (1, 2, 3))
    del ints.tmp166
    tmp8 = einsum(ints.tmp364, (0, 1, 2, 3), r2.bab, (1, 4, 3), (0, 4, 2)) * -1
    tmp12 = einsum(r2.aaa, (0, 1, 2), tmp11, (1, 3, 2, 4), (0, 3, 4)) * -1
    del tmp11
    tmp63 = np.copy(ints.tmp246)
    del ints.tmp246
    tmp63 += np.transpose(ints.tmp326, (2, 3, 0, 1)) * -1
    del ints.tmp326
    tmp62 = np.copy(np.transpose(tmp57, (1, 0, 2))) * -1
    del tmp57
    tmp62 += np.transpose(tmp59, (1, 0, 2))
    del tmp59
    tmp62 += np.transpose(tmp61, (1, 0, 2)) * -1
    del tmp61
    tmp47 = np.copy(ints.tmp437) * 2
    del ints.tmp437
    tmp47 += ints.tmp439
    del ints.tmp439
    tmp47 += f.bb.vv * -1
    tmp47 += np.transpose(tmp46, (1, 0))
    del tmp46
    tmp56 = einsum(f.bb.ov, (0, 1), r1.b, (2,), (0, 2, 1))
    tmp56 += tmp49
    del tmp49
    tmp56 += tmp50
    del tmp50
    tmp56 += np.transpose(tmp52, (1, 0, 2))
    del tmp52
    tmp56 += tmp53 * -1
    del tmp53
    tmp56 += np.transpose(tmp55, (1, 0, 2))
    del tmp55
    tmp45 = einsum(tmp34, (0, 1, 2), r2.aaa, (3, 1, 2), (0, 3)) * 2
    tmp45 += einsum(tmp35, (0, 1, 2), r2.bab, (1, 3, 2), (0, 3)) * -2
    tmp43 = np.copy(ints.tmp441)
    del ints.tmp441
    tmp43 += np.transpose(ints.tmp442, (1, 0, 2, 3)) * -1
    del ints.tmp442
    tmp40 = np.copy(f.bb.oo)
    tmp40 += ints.tmp158 * 2
    tmp40 += ints.tmp161
    tmp40 += np.transpose(ints.tmp21, (1, 0))
    tmp44 = np.copy(ints.tmp171)
    tmp44 += np.transpose(ints.tmp36, (1, 0, 2, 3))
    tmp41 = np.copy(f.aa.oo)
    tmp41 += np.transpose(ints.tmp1, (1, 0))
    tmp41 += ints.tmp57 * 2
    tmp41 += ints.tmp60
    tmp48 = np.copy(tmp23)
    del tmp23
    tmp48 += tmp9 * 0.5
    del tmp9
    tmp36 = einsum(tmp34, (0, 1, 2), r2.aba, (1, 3, 2), (0, 3)) * -0.5
    del tmp34
    tmp36 += einsum(tmp35, (0, 1, 2), r2.bbb, (3, 1, 2), (0, 3)) * 2
    del tmp35
    tmp32 = np.copy(ints.tmp417)
    del ints.tmp417
    tmp32 += np.transpose(ints.tmp418, (1, 0, 2, 3)) * -1
    del ints.tmp418
    tmp30 = np.copy(ints.tmp388) * 2
    del ints.tmp388
    tmp30 += ints.tmp390
    del ints.tmp390
    tmp30 += f.aa.vv * -1
    tmp30 += np.transpose(tmp29, (1, 0))
    del tmp29
    tmp33 = np.copy(ints.tmp171)
    del ints.tmp171
    tmp33 += np.transpose(ints.tmp36, (0, 1, 3, 2))
    del ints.tmp36
    tmp31 = np.copy(ints.tmp358)
    del ints.tmp358
    tmp31 += ints.tmp362 * 2
    del ints.tmp362
    tmp27 = einsum(f.aa.ov, (0, 1), r1.a, (2,), (0, 2, 1)) * -1
    tmp27 += tmp22 * -1
    del tmp22
    tmp27 += tmp24 * 2
    del tmp24
    tmp27 += np.transpose(tmp26, (1, 0, 2)) * -1
    del tmp26
    tmp21 = np.copy(tmp8)
    del tmp8
    tmp21 += tmp10
    del tmp10
    tmp21 += np.transpose(tmp12, (1, 0, 2)) * -2
    del tmp12
    tmp21 += np.transpose(tmp18, (1, 0, 2))
    del tmp18
    tmp21 += np.transpose(tmp20, (1, 0, 2)) * -2
    del tmp20
    tmp28 = np.copy(ints.tmp167)
    del ints.tmp167
    tmp28 += np.transpose(ints.tmp33, (2, 3, 0, 1)) * -1
    del ints.tmp33
    tmp3 = np.copy(ints.tmp100)
    del ints.tmp100
    tmp3 += ints.tmp108 * 0.5
    del ints.tmp108
    tmp3 += ints.tmp135
    del ints.tmp135
    tmp3 += ints.tmp140 * 0.5
    del ints.tmp140
    tmp3 += ints.tmp156
    del ints.tmp156
    tmp3 += ints.tmp164 * 0.5
    del ints.tmp164
    tmp3 += ints.tmp179 * 0.5
    del ints.tmp179
    tmp3 += ints.tmp185 * 0.5
    del ints.tmp185
    tmp3 += ints.tmp19 * 0.5
    del ints.tmp19
    tmp3 += ints.tmp201 * 0.5
    del ints.tmp201
    tmp3 += ints.tmp217 * 0.5
    del ints.tmp217
    tmp3 += ints.tmp223 * 0.5
    del ints.tmp223
    tmp3 += ints.tmp2 * 0.5
    del ints.tmp2
    tmp3 += ints.tmp42 * 0.5
    del ints.tmp42
    tmp3 += ints.tmp62
    del ints.tmp62
    tmp3 += ints.tmp70 * 0.5
    del ints.tmp70
    tmp3 += ints.tmp85
    del ints.tmp85
    tmp3 += f.aa.ov * -0.5
    tmp3 += ints.tmp103 * -1
    del ints.tmp103
    tmp3 += ints.tmp112 * -0.5
    del ints.tmp112
    tmp3 += ints.tmp116 * -1
    del ints.tmp116
    tmp3 += ints.tmp119 * -0.5
    del ints.tmp119
    tmp3 += ints.tmp11 * -0.5
    del ints.tmp11
    tmp3 += ints.tmp177 * -0.5
    del ints.tmp177
    tmp3 += ints.tmp199 * -0.5
    del ints.tmp199
    tmp3 += ints.tmp209 * -0.5
    del ints.tmp209
    tmp3 += ints.tmp215 * -0.5
    del ints.tmp215
    tmp3 += ints.tmp39 * -0.5
    del ints.tmp39
    tmp3 += ints.tmp48 * -0.5
    del ints.tmp48
    tmp3 += ints.tmp5 * -0.5
    del ints.tmp5
    tmp3 += ints.tmp8 * -1
    del ints.tmp8
    tmp3 += ints.tmp91 * -0.5
    del ints.tmp91
    tmp7 = np.copy(f.bb.oo)
    tmp7 += ints.tmp158 * 2
    del ints.tmp158
    tmp7 += ints.tmp161
    del ints.tmp161
    tmp7 += np.transpose(ints.tmp183, (1, 0))
    del ints.tmp183
    tmp7 += np.transpose(ints.tmp187, (1, 0))
    del ints.tmp187
    tmp7 += np.transpose(ints.tmp21, (1, 0))
    del ints.tmp21
    tmp7 += ints.tmp221
    del ints.tmp221
    tmp7 += ints.tmp225
    del ints.tmp225
    tmp7 += ints.tmp181 * -1
    del ints.tmp181
    tmp7 += ints.tmp219 * -1
    del ints.tmp219
    tmp5 = np.copy(ints.tmp142)
    del ints.tmp142
    tmp5 += np.transpose(ints.tmp239, (0, 2, 1, 3))
    del ints.tmp239
    tmp5 += np.transpose(ints.tmp257, (0, 2, 1, 3))
    del ints.tmp257
    tmp5 += ints.tmp267
    del ints.tmp267
    tmp5 += ints.tmp271 * 2
    del ints.tmp271
    tmp5 += ints.tmp283
    del ints.tmp283
    tmp5 += ints.tmp298
    del ints.tmp298
    tmp5 += ints.tmp302
    del ints.tmp302
    tmp5 += ints.tmp310
    del ints.tmp310
    tmp5 += ints.tmp316 * 2
    del ints.tmp316
    tmp5 += ints.tmp346
    del ints.tmp346
    tmp5 += np.transpose(ints.tmp67, (0, 2, 1, 3))
    tmp5 += np.transpose(ints.tmp249, (0, 2, 1, 3)) * -1
    del ints.tmp249
    tmp5 += ints.tmp264 * -1
    del ints.tmp264
    tmp5 += ints.tmp270 * -1
    del ints.tmp270
    tmp5 += ints.tmp294 * -1
    del ints.tmp294
    tmp5 += ints.tmp313 * -1
    del ints.tmp313
    tmp5 += ints.tmp320 * -1
    del ints.tmp320
    tmp5 += ints.tmp329 * -1
    del ints.tmp329
    tmp5 += ints.tmp339 * -1
    del ints.tmp339
    tmp5 += np.transpose(ints.tmp340, (0, 2, 1, 3)) * -1
    del ints.tmp340
    tmp5 += ints.tmp354 * -1
    del ints.tmp354
    tmp2 = np.copy(ints.tmp102) * 0.5
    del ints.tmp102
    tmp2 += ints.tmp110
    del ints.tmp110
    tmp2 += ints.tmp138
    del ints.tmp138
    tmp2 += ints.tmp143 * 0.5
    del ints.tmp143
    tmp2 += ints.tmp159
    del ints.tmp159
    tmp2 += ints.tmp162 * 0.5
    del ints.tmp162
    tmp2 += ints.tmp184 * 0.5
    del ints.tmp184
    tmp2 += ints.tmp188 * 0.5
    del ints.tmp188
    tmp2 += ints.tmp205 * 0.5
    del ints.tmp205
    tmp2 += ints.tmp222 * 0.5
    del ints.tmp222
    tmp2 += ints.tmp226 * 0.5
    del ints.tmp226
    tmp2 += ints.tmp22 * 0.5
    del ints.tmp22
    tmp2 += ints.tmp46 * 0.5
    del ints.tmp46
    tmp2 += ints.tmp4 * 0.5
    del ints.tmp4
    tmp2 += ints.tmp65
    del ints.tmp65
    tmp2 += ints.tmp68 * 0.5
    del ints.tmp68
    tmp2 += ints.tmp87
    del ints.tmp87
    tmp2 += f.bb.ov * -0.5
    tmp2 += ints.tmp105 * -0.5
    del ints.tmp105
    tmp2 += ints.tmp10 * -0.5
    del ints.tmp10
    tmp2 += ints.tmp114 * -1
    del ints.tmp114
    tmp2 += ints.tmp118 * -0.5
    del ints.tmp118
    tmp2 += ints.tmp121 * -1
    del ints.tmp121
    tmp2 += ints.tmp13 * -1
    del ints.tmp13
    tmp2 += ints.tmp182 * -0.5
    del ints.tmp182
    tmp2 += ints.tmp204 * -0.5
    del ints.tmp204
    tmp2 += ints.tmp207 * -0.5
    del ints.tmp207
    tmp2 += ints.tmp220 * -0.5
    del ints.tmp220
    tmp2 += ints.tmp44 * -0.5
    del ints.tmp44
    tmp2 += ints.tmp47 * -0.5
    del ints.tmp47
    tmp2 += ints.tmp7 * -0.5
    del ints.tmp7
    tmp2 += ints.tmp89 * -0.5
    del ints.tmp89
    tmp6 = np.copy(np.transpose(ints.tmp241, (1, 2, 0, 3)))
    del ints.tmp241
    tmp6 += np.transpose(ints.tmp247, (0, 2, 1, 3))
    del ints.tmp247
    tmp6 += np.transpose(ints.tmp255, (0, 2, 1, 3))
    del ints.tmp255
    tmp6 += ints.tmp268 * 2
    del ints.tmp268
    tmp6 += ints.tmp273
    del ints.tmp273
    tmp6 += ints.tmp300
    del ints.tmp300
    tmp6 += ints.tmp304
    del ints.tmp304
    tmp6 += ints.tmp314 * 2
    del ints.tmp314
    tmp6 += ints.tmp327
    del ints.tmp327
    tmp6 += ints.tmp335
    del ints.tmp335
    tmp6 += ints.tmp352
    del ints.tmp352
    tmp6 += ints.tmp137 * -1
    del ints.tmp137
    tmp6 += ints.tmp265 * -2
    del ints.tmp265
    tmp6 += ints.tmp280 * -1
    del ints.tmp280
    tmp6 += ints.tmp296 * -1
    del ints.tmp296
    tmp6 += ints.tmp311 * -2
    del ints.tmp311
    tmp6 += ints.tmp318 * -1
    del ints.tmp318
    tmp6 += np.transpose(ints.tmp337, (0, 2, 1, 3)) * -1
    del ints.tmp337
    tmp6 += ints.tmp344 * -1
    del ints.tmp344
    tmp6 += np.transpose(ints.tmp64, (1, 2, 0, 3)) * -1
    del ints.tmp64
    tmp4 = np.copy(f.aa.oo)
    tmp4 += ints.tmp175
    del ints.tmp175
    tmp4 += ints.tmp176
    del ints.tmp176
    tmp4 += np.transpose(ints.tmp1, (1, 0))
    del ints.tmp1
    tmp4 += np.transpose(ints.tmp30, (1, 0))
    del ints.tmp30
    tmp4 += np.transpose(ints.tmp32, (1, 0))
    del ints.tmp32
    tmp4 += ints.tmp57 * 2
    del ints.tmp57
    tmp4 += ints.tmp60
    del ints.tmp60
    tmp4 += ints.tmp174 * -1
    del ints.tmp174
    tmp4 += ints.tmp28 * -1
    del ints.tmp28
    tmp1 = np.copy(ints.tmp127)
    del ints.tmp127
    tmp1 += ints.tmp131
    del ints.tmp131
    tmp1 += ints.tmp148 * 2
    del ints.tmp148
    tmp1 += np.transpose(ints.tmp15, (1, 2, 0, 3))
    del ints.tmp15
    tmp1 += ints.tmp168
    del ints.tmp168
    tmp1 += ints.tmp190
    del ints.tmp190
    tmp1 += ints.tmp228
    del ints.tmp228
    tmp1 += np.transpose(ints.tmp34, (0, 2, 1, 3))
    del ints.tmp34
    tmp1 += np.transpose(ints.tmp52, (0, 2, 1, 3))
    del ints.tmp52
    tmp1 += ints.tmp75 * 2
    del ints.tmp75
    tmp1 += ints.tmp80
    del ints.tmp80
    tmp1 += ints.tmp123 * -1
    del ints.tmp123
    tmp1 += ints.tmp145 * -2
    del ints.tmp145
    tmp1 += ints.tmp151 * -1
    del ints.tmp151
    tmp1 += np.transpose(ints.tmp192, (0, 2, 1, 3)) * -1
    del ints.tmp192
    tmp1 += ints.tmp211 * -1
    del ints.tmp211
    tmp1 += np.transpose(ints.tmp23, (1, 2, 0, 3)) * -1
    del ints.tmp23
    tmp1 += ints.tmp50 * -1
    del ints.tmp50
    tmp1 += ints.tmp72 * -2
    del ints.tmp72
    tmp1 += ints.tmp94 * -1
    del ints.tmp94
    tmp0 = np.copy(ints.tmp129)
    del ints.tmp129
    tmp0 += ints.tmp133
    del ints.tmp133
    tmp0 += ints.tmp147
    del ints.tmp147
    tmp0 += ints.tmp153 * 2
    del ints.tmp153
    tmp0 += np.transpose(ints.tmp17, (1, 0, 2, 3))
    del ints.tmp17
    tmp0 += ints.tmp213
    del ints.tmp213
    tmp0 += np.transpose(ints.tmp25, (1, 0, 2, 3))
    tmp0 += ints.tmp54
    del ints.tmp54
    tmp0 += np.transpose(ints.tmp55, (1, 0, 2, 3))
    del ints.tmp55
    tmp0 += ints.tmp78
    del ints.tmp78
    tmp0 += ints.tmp83 * 2
    del ints.tmp83
    tmp0 += ints.tmp97
    del ints.tmp97
    tmp0 += ints.tmp125 * -1
    del ints.tmp125
    tmp0 += ints.tmp150 * -1
    del ints.tmp150
    tmp0 += ints.tmp155 * -1
    del ints.tmp155
    tmp0 += ints.tmp172 * -1
    del ints.tmp172
    tmp0 += ints.tmp195 * -1
    del ints.tmp195
    tmp0 += np.transpose(ints.tmp197, (1, 0, 2, 3)) * -1
    del ints.tmp197
    tmp0 += ints.tmp231 * -1
    del ints.tmp231
    tmp0 += ints.tmp37 * -1
    del ints.tmp37
    tmp0 += ints.tmp74 * -1
    del ints.tmp74
    tmp0 += ints.tmp79 * -1
    del ints.tmp79
    r2new.bbb = np.copy(tmp56) * -1
    r2new.bbb += np.transpose(tmp56, (1, 0, 2))
    del tmp56
    r2new.bbb += tmp62 * 2
    r2new.bbb += np.transpose(tmp62, (1, 0, 2)) * -2
    del tmp62
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp63, (3, 4, 1, 0), (3, 4, 2)) * 2
    del tmp63
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp47, (2, 3), (0, 1, 3)) * -2
    r2new.bab = einsum(r1.a, (0,), f.bb.ov, (1, 2), (1, 0, 2)) * -1
    r2new.bab += einsum(ints.tmp25, (0, 1, 2, 3), r1.a, (1,), (2, 0, 3))
    del ints.tmp25
    r2new.bab += einsum(r2.aaa, (0, 1, 2), ints.tmp421, (1, 3, 2, 4), (3, 0, 4)) * 2
    del ints.tmp421
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp42, (0, 3, 2, 4), (3, 1, 4)) * -1
    del tmp42
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp43, (3, 1, 2, 4), (0, 3, 4)) * -1
    del tmp43
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp44, (1, 3, 0, 4), (4, 3, 2))
    del tmp44
    r2new.bab += einsum(tmp45, (0, 1), v.bbb.xov, (0, 2, 3), (2, 1, 3)) * -1
    del tmp45
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp47, (2, 3), (0, 1, 3)) * -1
    del tmp47
    r2new.bab += einsum(tmp48, (0,), ints.tmp170, (1, 2, 0, 3), (2, 1, 3)) * 2
    del tmp48
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp40, (0, 3), (3, 1, 2)) * -1
    r2new.bab += einsum(tmp41, (0, 1), r2.bab, (2, 0, 3), (2, 1, 3)) * -1
    r2new.aba = einsum(f.aa.ov, (0, 1), r1.b, (2,), (0, 2, 1)) * -1
    r2new.aba += einsum(ints.tmp67, (0, 1, 2, 3), r1.b, (2,), (0, 1, 3))
    del ints.tmp67
    r2new.aba += einsum(r2.bbb, (0, 1, 2), ints.tmp364, (3, 1, 4, 2), (3, 0, 4)) * 2
    del ints.tmp364
    r2new.aba += einsum(tmp31, (0, 1, 2, 3), r2.aba, (0, 4, 2), (1, 4, 3)) * -1
    del tmp31
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp32, (3, 1, 2, 4), (0, 3, 4)) * -1
    del tmp32
    r2new.aba += einsum(tmp33, (0, 1, 2, 3), r2.aba, (0, 2, 4), (1, 3, 4))
    del tmp33
    r2new.aba += einsum(v.baa.xov, (0, 1, 2), tmp36, (0, 3), (1, 3, 2)) * -2
    del tmp36
    r2new.aba += einsum(tmp30, (0, 1), r2.aba, (2, 3, 0), (2, 3, 1)) * -1
    r2new.aba += einsum(tmp39, (0,), ints.tmp170, (1, 2, 3, 0), (1, 2, 3)) * 2
    del tmp39, ints.tmp170
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp40, (1, 3), (0, 3, 2)) * -1
    del tmp40
    r2new.aba += einsum(tmp41, (0, 1), r2.aba, (0, 2, 3), (1, 2, 3)) * -1
    del tmp41
    r2new.aaa = np.copy(tmp21)
    r2new.aaa += np.transpose(tmp21, (1, 0, 2)) * -1
    del tmp21
    r2new.aaa += tmp27
    r2new.aaa += np.transpose(tmp27, (1, 0, 2)) * -1
    del tmp27
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp28, (0, 1, 3, 4), (3, 4, 2)) * 2
    del tmp28
    r2new.aaa += einsum(tmp30, (0, 1), r2.aaa, (2, 3, 0), (2, 3, 1)) * -2
    del tmp30
    r1new.b = einsum(r2.aba, (0, 1, 2), tmp5, (0, 1, 3, 2), (3,))
    del tmp5
    r1new.b += einsum(tmp6, (0, 1, 2, 3), r2.bbb, (0, 1, 3), (2,)) * 2
    del tmp6
    r1new.b += einsum(tmp3, (0, 1), r2.aba, (0, 2, 1), (2,)) * 2
    r1new.b += einsum(r2.bbb, (0, 1, 2), tmp2, (1, 2), (0,)) * -4
    r1new.b += einsum(tmp7, (0, 1), r1.b, (0,), (1,)) * -1
    del tmp7
    r1new.a = einsum(r2.bab, (0, 1, 2), tmp0, (1, 3, 0, 2), (3,))
    del tmp0
    r1new.a += einsum(tmp1, (0, 1, 2, 3), r2.aaa, (0, 1, 3), (2,)) * 2
    del tmp1
    r1new.a += einsum(tmp2, (0, 1), r2.bab, (0, 2, 1), (2,)) * 2
    del tmp2
    r1new.a += einsum(tmp3, (0, 1), r2.aaa, (2, 0, 1), (2,)) * -4
    del tmp3
    r1new.a += einsum(r1.a, (0,), tmp4, (0, 1), (1,)) * -1
    del tmp4

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ea_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:06:54.044194.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp10 : array
    tmp100 : array
    tmp102 : array
    tmp103 : array
    tmp105 : array
    tmp106 : array
    tmp108 : array
    tmp11 : array
    tmp110 : array
    tmp111 : array
    tmp113 : array
    tmp115 : array
    tmp117 : array
    tmp119 : array
    tmp121 : array
    tmp122 : array
    tmp124 : array
    tmp13 : array
    tmp132 : array
    tmp133 : array
    tmp135 : array
    tmp136 : array
    tmp138 : array
    tmp139 : array
    tmp141 : array
    tmp142 : array
    tmp144 : array
    tmp146 : array
    tmp148 : array
    tmp149 : array
    tmp151 : array
    tmp152 : array
    tmp154 : array
    tmp155 : array
    tmp157 : array
    tmp158 : array
    tmp160 : array
    tmp162 : array
    tmp163 : array
    tmp165 : array
    tmp166 : array
    tmp168 : array
    tmp170 : array
    tmp172 : array
    tmp175 : array
    tmp178 : array
    tmp180 : array
    tmp182 : array
    tmp185 : array
    tmp19 : array
    tmp190 : array
    tmp192 : array
    tmp194 : array
    tmp195 : array
    tmp196 : array
    tmp197 : array
    tmp198 : array
    tmp199 : array
    tmp2 : array
    tmp20 : array
    tmp201 : array
    tmp203 : array
    tmp205 : array
    tmp206 : array
    tmp208 : array
    tmp211 : array
    tmp214 : array
    tmp216 : array
    tmp218 : array
    tmp22 : array
    tmp221 : array
    tmp23 : array
    tmp236 : array
    tmp239 : array
    tmp24 : array
    tmp243 : array
    tmp246 : array
    tmp250 : array
    tmp251 : array
    tmp253 : array
    tmp255 : array
    tmp257 : array
    tmp26 : array
    tmp263 : array
    tmp265 : array
    tmp271 : array
    tmp272 : array
    tmp274 : array
    tmp275 : array
    tmp277 : array
    tmp279 : array
    tmp281 : array
    tmp29 : array
    tmp301 : array
    tmp303 : array
    tmp309 : array
    tmp31 : array
    tmp310 : array
    tmp312 : array
    tmp313 : array
    tmp315 : array
    tmp317 : array
    tmp319 : array
    tmp33 : array
    tmp330 : array
    tmp332 : array
    tmp334 : array
    tmp335 : array
    tmp34 : array
    tmp36 : array
    tmp365 : array
    tmp38 : array
    tmp387 : array
    tmp4 : array
    tmp40 : array
    tmp41 : array
    tmp42 : array
    tmp430 : array
    tmp44 : array
    tmp47 : array
    tmp49 : array
    tmp5 : array
    tmp52 : array
    tmp53 : array
    tmp55 : array
    tmp57 : array
    tmp58 : array
    tmp60 : array
    tmp61 : array
    tmp63 : array
    tmp64 : array
    tmp66 : array
    tmp67 : array
    tmp69 : array
    tmp7 : array
    tmp70 : array
    tmp72 : array
    tmp73 : array
    tmp75 : array
    tmp77 : array
    tmp79 : array
    tmp8 : array
    tmp81 : array
    tmp82 : array
    tmp84 : array
    tmp85 : array
    tmp87 : array
    tmp89 : array
    tmp91 : array
    tmp92 : array
    tmp94 : array
    tmp95 : array
    tmp97 : array
    tmp99 : array
    """

    tmp28 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (1, 2), (0,))
    tmp32 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 0, 1), (2,))
    tmp109 = einsum(t1.bb, (0, 1), v.bbb.xov, (2, 3, 1), (2, 0, 3))
    tmp101 = einsum(t1.aa, (0, 1), v.baa.xov, (2, 3, 1), (2, 0, 3))
    tmp41 = einsum(v.bbb.xov, (0, 1, 2), tmp28, (0,), (1, 2))
    tmp42 = einsum(v.baa.xov, (0, 1, 2), tmp32, (0,), (1, 2))
    tmp38 = einsum(v.bbb.xov, (0, 1, 2), tmp32, (0,), (1, 2))
    tmp110 = einsum(tmp109, (0, 1, 2), v.bbb.xov, (0, 1, 3), (2, 3))
    tmp34 = einsum(v.baa.xov, (0, 1, 2), tmp28, (0,), (1, 2))
    tmp102 = einsum(tmp101, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp60 = einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp84 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (4, 1, 3))
    tmp81 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (0, 3, 4))
    tmp57 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp30 = einsum(v.baa.xvv, (0, 1, 2), t1.aa, (3, 2), (0, 3, 1))
    tmp39 = einsum(t1.bb, (0, 1), v.bbb.xvv, (2, 3, 1), (2, 0, 3))
    tmp49 = einsum(v.baa.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp243 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp138 = einsum(tmp101, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp135 = einsum(tmp109, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp26 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp236 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp72 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp66 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp220 = einsum(t1.bb, (0, 1), tmp41, (2, 1), (0, 2))
    tmp217 = einsum(t1.aa, (0, 1), tmp42, (2, 1), (0, 2))
    tmp215 = einsum(t1.bb, (0, 1), tmp38, (2, 1), (0, 2))
    tmp213 = einsum(t1.bb, (0, 1), tmp110, (2, 1), (0, 2))
    tmp210 = einsum(t1.aa, (0, 1), tmp34, (2, 1), (0, 2))
    tmp207 = einsum(t1.aa, (0, 1), tmp102, (2, 1), (0, 2))
    tmp33 = einsum(v.baa.xvv, (0, 1, 2), tmp32, (0,), (1, 2))
    tmp197 = einsum(tmp28, (0,), v.bbb.xvv, (0, 1, 2), (1, 2))
    tmp194 = einsum(v.bbb.xvv, (0, 1, 2), tmp32, (0,), (1, 2))
    tmp29 = einsum(v.baa.xvv, (0, 1, 2), tmp28, (0,), (1, 2))
    tmp184 = einsum(v.bbb.xoo, (0, 1, 2), tmp28, (0,), (1, 2))
    tmp181 = einsum(tmp32, (0,), v.baa.xoo, (0, 1, 2), (1, 2))
    tmp179 = einsum(v.bbb.xoo, (0, 1, 2), tmp32, (0,), (1, 2))
    del tmp32
    tmp177 = einsum(tmp109, (0, 1, 2), v.bbb.xoo, (0, 3, 1), (3, 2))
    tmp174 = einsum(tmp28, (0,), v.baa.xoo, (0, 1, 2), (1, 2))
    del tmp28
    tmp171 = einsum(v.baa.xoo, (0, 1, 2), tmp101, (0, 2, 3), (1, 3))
    tmp44 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp157 = einsum(v.baa.xov, (0, 1, 2), tmp60, (0, 3, 2), (3, 1))
    tmp154 = einsum(tmp84, (0, 1, 2), v.bbb.xov, (0, 3, 2), (1, 3))
    tmp151 = einsum(tmp81, (0, 1, 2), v.bbb.xov, (0, 3, 2), (1, 3))
    tmp148 = einsum(tmp57, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp141 = einsum(tmp109, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp132 = einsum(v.baa.xov, (0, 1, 2), tmp101, (0, 3, 4), (3, 1, 4, 2))
    tmp99 = einsum(v.baa.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp24 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp69 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp63 = einsum(v.baa.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp22 = einsum(t1.bb, (0, 1), f.bb.ov, (2, 1), (2, 0))
    tmp19 = einsum(f.aa.ov, (0, 1), t1.aa, (2, 1), (0, 2))
    tmp430 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (3, 1, 2, 4))
    tmp387 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp365 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp335 = einsum(tmp30, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp334 = einsum(tmp101, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp332 = einsum(tmp39, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 4, 2))
    tmp330 = einsum(tmp109, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp319 = einsum(t2.abab, (0, 1, 2, 3), tmp49, (4, 1, 2, 5), (0, 4, 3, 5))
    tmp317 = einsum(v.bbb.xov, (0, 1, 2), tmp84, (0, 3, 4), (3, 1, 4, 2))
    tmp315 = einsum(tmp57, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp313 = einsum(t2.bbbb, (0, 1, 2, 3), tmp243, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp312 = einsum(t2.abab, (0, 1, 2, 3), tmp243, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp310 = einsum(tmp81, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp309 = einsum(v.bbb.xov, (0, 1, 2), tmp60, (0, 3, 4), (3, 1, 4, 2))
    tmp303 = einsum(tmp138, (0, 1, 2, 3), t2.abab, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp301 = einsum(t2.bbbb, (0, 1, 2, 3), tmp135, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp281 = einsum(t2.abab, (0, 1, 2, 3), tmp26, (1, 2, 4, 5), (0, 4, 3, 5))
    tmp279 = einsum(tmp84, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp277 = einsum(v.bbb.xvv, (0, 1, 2), tmp57, (0, 3, 4), (3, 4, 1, 2))
    tmp275 = einsum(tmp236, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 2), (4, 5, 3, 1))
    tmp274 = einsum(tmp236, (0, 1, 2, 3), t2.abab, (4, 0, 5, 1), (4, 5, 3, 2))
    tmp272 = einsum(tmp81, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp271 = einsum(v.bbb.xvv, (0, 1, 2), tmp60, (0, 3, 4), (3, 4, 1, 2))
    tmp265 = einsum(tmp72, (0, 1, 2, 3), t2.abab, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp263 = einsum(t2.bbbb, (0, 1, 2, 3), tmp66, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp257 = einsum(v.bbb.xov, (0, 1, 2), tmp84, (0, 1, 3), (3, 2))
    tmp255 = einsum(tmp81, (0, 1, 2), v.bbb.xov, (0, 1, 3), (2, 3))
    tmp253 = einsum(tmp30, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp251 = einsum(tmp39, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp250 = einsum(v.bbb.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp246 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp239 = einsum(tmp39, (0, 1, 2), v.bbb.xov, (0, 1, 3), (3, 2))
    tmp221 = einsum(tmp220, (0, 1), t1.bb, (1, 2), (0, 2))
    del tmp220
    tmp218 = einsum(tmp217, (0, 1), t1.aa, (1, 2), (0, 2))
    del tmp217
    tmp216 = einsum(tmp215, (0, 1), t1.bb, (1, 2), (0, 2))
    del tmp215
    tmp214 = einsum(tmp213, (0, 1), t1.bb, (1, 2), (0, 2))
    del tmp213
    tmp211 = einsum(tmp210, (0, 1), t1.aa, (1, 2), (0, 2))
    del tmp210
    tmp208 = einsum(tmp207, (0, 1), t1.aa, (1, 2), (0, 2))
    del tmp207
    tmp206 = einsum(v.baa.xov, (0, 1, 2), tmp39, (0, 3, 4), (1, 3, 2, 4))
    tmp205 = einsum(tmp109, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp203 = einsum(tmp30, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 3, 4, 2))
    tmp201 = einsum(tmp101, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp199 = einsum(tmp33, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp198 = einsum(tmp197, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp196 = einsum(tmp109, (0, 1, 2), tmp39, (0, 2, 3), (1, 3))
    del tmp109
    tmp195 = einsum(tmp194, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp192 = einsum(tmp30, (0, 1, 2), tmp101, (0, 3, 1), (3, 2))
    del tmp101
    tmp190 = einsum(t1.aa, (0, 1), tmp29, (2, 1), (0, 2))
    tmp185 = einsum(tmp184, (0, 1), t1.bb, (1, 2), (0, 2))
    del tmp184
    tmp182 = einsum(tmp181, (0, 1), t1.aa, (1, 2), (0, 2))
    del tmp181
    tmp180 = einsum(t1.bb, (0, 1), tmp179, (2, 0), (2, 1))
    del tmp179
    tmp178 = einsum(tmp177, (0, 1), t1.bb, (1, 2), (0, 2))
    del tmp177
    tmp175 = einsum(tmp174, (0, 1), t1.aa, (1, 2), (0, 2))
    del tmp174
    tmp172 = einsum(tmp171, (0, 1), t1.aa, (1, 2), (0, 2))
    del tmp171
    tmp170 = einsum(t2.abab, (0, 1, 2, 3), tmp49, (0, 4, 5, 3), (1, 4, 2, 5))
    tmp168 = einsum(tmp81, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp166 = einsum(v.baa.xov, (0, 1, 2), tmp60, (0, 3, 4), (3, 1, 4, 2))
    tmp165 = einsum(tmp44, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (1, 4, 2, 5))
    tmp163 = einsum(tmp44, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 1, 5, 2))
    tmp162 = einsum(tmp84, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp160 = einsum(v.baa.xov, (0, 1, 2), tmp57, (0, 3, 4), (3, 1, 4, 2))
    tmp158 = einsum(tmp157, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp155 = einsum(tmp154, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp152 = einsum(t1.bb, (0, 1), tmp151, (2, 0), (2, 1))
    tmp149 = einsum(tmp148, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp146 = einsum(t2.abab, (0, 1, 2, 3), tmp141, (0, 4, 1, 5), (4, 2, 5, 3))
    tmp144 = einsum(tmp132, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp142 = einsum(t2.abab, (0, 1, 2, 3), tmp141, (0, 4, 1, 2), (4, 3))
    tmp139 = einsum(tmp138, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    tmp136 = einsum(t2.bbbb, (0, 1, 2, 3), tmp135, (4, 1, 0, 3), (4, 2))
    tmp133 = einsum(tmp132, (0, 1, 2, 3), t2.aaaa, (2, 1, 4, 3), (0, 4))
    tmp124 = einsum(t2.bbbb, (0, 1, 2, 3), tmp41, (1, 3), (0, 2))
    tmp122 = einsum(t2.abab, (0, 1, 2, 3), tmp41, (1, 3), (0, 2))
    tmp121 = einsum(t2.abab, (0, 1, 2, 3), tmp42, (0, 2), (1, 3))
    tmp119 = einsum(tmp42, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp117 = einsum(t2.bbbb, (0, 1, 2, 3), tmp38, (1, 3), (0, 2))
    tmp115 = einsum(t2.abab, (0, 1, 2, 3), tmp38, (1, 3), (0, 2))
    tmp113 = einsum(tmp110, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp111 = einsum(t2.abab, (0, 1, 2, 3), tmp110, (1, 3), (0, 2))
    tmp108 = einsum(t2.abab, (0, 1, 2, 3), tmp34, (0, 2), (1, 3))
    tmp106 = einsum(t2.aaaa, (0, 1, 2, 3), tmp34, (1, 3), (0, 2))
    tmp105 = einsum(t2.abab, (0, 1, 2, 3), tmp102, (0, 2), (1, 3))
    tmp103 = einsum(tmp102, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp100 = einsum(tmp99, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (4, 5, 1, 2))
    tmp97 = einsum(tmp81, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp95 = einsum(v.baa.xvv, (0, 1, 2), tmp60, (0, 3, 4), (3, 4, 1, 2))
    tmp94 = einsum(t2.abab, (0, 1, 2, 3), tmp24, (0, 2, 4, 5), (1, 5, 4, 3))
    tmp92 = einsum(t2.aaaa, (0, 1, 2, 3), tmp24, (1, 4, 3, 5), (0, 2, 5, 4))
    tmp91 = einsum(tmp84, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp89 = einsum(tmp57, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp87 = einsum(v.baa.xvv, (0, 1, 2), tmp60, (0, 3, 2), (3, 1))
    tmp85 = einsum(v.bbb.xvv, (0, 1, 2), tmp84, (0, 3, 2), (3, 1))
    tmp82 = einsum(tmp81, (0, 1, 2), v.bbb.xvv, (0, 3, 2), (1, 3)) * -1
    tmp79 = einsum(v.baa.xvv, (0, 1, 2), tmp57, (0, 3, 2), (3, 1)) * -1
    tmp77 = einsum(t2.abab, (0, 1, 2, 3), tmp69, (0, 4, 1, 5), (4, 2, 5, 3))
    tmp75 = einsum(tmp63, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp73 = einsum(tmp72, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    tmp70 = einsum(t2.abab, (0, 1, 2, 3), tmp69, (0, 4, 1, 2), (4, 3))
    tmp67 = einsum(t2.bbbb, (0, 1, 2, 3), tmp66, (4, 0, 1, 3), (4, 2))
    tmp64 = einsum(tmp63, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 3), (0, 4))
    tmp61 = einsum(v.baa.xov, (0, 1, 2), tmp60, (0, 1, 3), (3, 2))
    tmp58 = einsum(tmp57, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp55 = einsum(v.baa.xvv, (0, 1, 2), tmp39, (0, 3, 4), (3, 1, 2, 4))
    tmp53 = einsum(tmp30, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp52 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp47 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp40 = einsum(v.bbb.xoo, (0, 1, 2), tmp39, (0, 2, 3), (1, 3))
    del tmp39
    tmp36 = einsum(tmp30, (0, 1, 2), v.baa.xoo, (0, 3, 1), (3, 2))
    tmp31 = einsum(v.baa.xov, (0, 1, 2), tmp30, (0, 1, 3), (2, 3))
    del tmp30
    tmp23 = einsum(tmp22, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp20 = einsum(tmp19, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp13 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp11 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp10 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (0, 2), (1, 3))
    tmp8 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp7 = einsum(f.bb.vv, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp5 = einsum(f.aa.vv, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp4 = einsum(t1.bb, (0, 1), f.bb.oo, (2, 0), (2, 1))
    tmp2 = einsum(f.aa.oo, (0, 1), t1.aa, (1, 2), (0, 2))

    return {f"tmp10": tmp10, f"tmp100": tmp100, f"tmp102": tmp102, f"tmp103": tmp103, f"tmp105": tmp105, f"tmp106": tmp106, f"tmp108": tmp108, f"tmp11": tmp11, f"tmp110": tmp110, f"tmp111": tmp111, f"tmp113": tmp113, f"tmp115": tmp115, f"tmp117": tmp117, f"tmp119": tmp119, f"tmp121": tmp121, f"tmp122": tmp122, f"tmp124": tmp124, f"tmp13": tmp13, f"tmp132": tmp132, f"tmp133": tmp133, f"tmp135": tmp135, f"tmp136": tmp136, f"tmp138": tmp138, f"tmp139": tmp139, f"tmp141": tmp141, f"tmp142": tmp142, f"tmp144": tmp144, f"tmp146": tmp146, f"tmp148": tmp148, f"tmp149": tmp149, f"tmp151": tmp151, f"tmp152": tmp152, f"tmp154": tmp154, f"tmp155": tmp155, f"tmp157": tmp157, f"tmp158": tmp158, f"tmp160": tmp160, f"tmp162": tmp162, f"tmp163": tmp163, f"tmp165": tmp165, f"tmp166": tmp166, f"tmp168": tmp168, f"tmp170": tmp170, f"tmp172": tmp172, f"tmp175": tmp175, f"tmp178": tmp178, f"tmp180": tmp180, f"tmp182": tmp182, f"tmp185": tmp185, f"tmp19": tmp19, f"tmp190": tmp190, f"tmp192": tmp192, f"tmp194": tmp194, f"tmp195": tmp195, f"tmp196": tmp196, f"tmp197": tmp197, f"tmp198": tmp198, f"tmp199": tmp199, f"tmp2": tmp2, f"tmp20": tmp20, f"tmp201": tmp201, f"tmp203": tmp203, f"tmp205": tmp205, f"tmp206": tmp206, f"tmp208": tmp208, f"tmp211": tmp211, f"tmp214": tmp214, f"tmp216": tmp216, f"tmp218": tmp218, f"tmp22": tmp22, f"tmp221": tmp221, f"tmp23": tmp23, f"tmp236": tmp236, f"tmp239": tmp239, f"tmp24": tmp24, f"tmp243": tmp243, f"tmp246": tmp246, f"tmp250": tmp250, f"tmp251": tmp251, f"tmp253": tmp253, f"tmp255": tmp255, f"tmp257": tmp257, f"tmp26": tmp26, f"tmp263": tmp263, f"tmp265": tmp265, f"tmp271": tmp271, f"tmp272": tmp272, f"tmp274": tmp274, f"tmp275": tmp275, f"tmp277": tmp277, f"tmp279": tmp279, f"tmp281": tmp281, f"tmp29": tmp29, f"tmp301": tmp301, f"tmp303": tmp303, f"tmp309": tmp309, f"tmp31": tmp31, f"tmp310": tmp310, f"tmp312": tmp312, f"tmp313": tmp313, f"tmp315": tmp315, f"tmp317": tmp317, f"tmp319": tmp319, f"tmp33": tmp33, f"tmp330": tmp330, f"tmp332": tmp332, f"tmp334": tmp334, f"tmp335": tmp335, f"tmp34": tmp34, f"tmp36": tmp36, f"tmp365": tmp365, f"tmp38": tmp38, f"tmp387": tmp387, f"tmp4": tmp4, f"tmp40": tmp40, f"tmp41": tmp41, f"tmp42": tmp42, f"tmp430": tmp430, f"tmp44": tmp44, f"tmp47": tmp47, f"tmp49": tmp49, f"tmp5": tmp5, f"tmp52": tmp52, f"tmp53": tmp53, f"tmp55": tmp55, f"tmp57": tmp57, f"tmp58": tmp58, f"tmp60": tmp60, f"tmp61": tmp61, f"tmp63": tmp63, f"tmp64": tmp64, f"tmp66": tmp66, f"tmp67": tmp67, f"tmp69": tmp69, f"tmp7": tmp7, f"tmp70": tmp70, f"tmp72": tmp72, f"tmp73": tmp73, f"tmp75": tmp75, f"tmp77": tmp77, f"tmp79": tmp79, f"tmp8": tmp8, f"tmp81": tmp81, f"tmp82": tmp82, f"tmp84": tmp84, f"tmp85": tmp85, f"tmp87": tmp87, f"tmp89": tmp89, f"tmp91": tmp91, f"tmp92": tmp92, f"tmp94": tmp94, f"tmp95": tmp95, f"tmp97": tmp97, f"tmp99": tmp99}

def hbar_lmatvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T17:06:54.210873.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp46 = np.copy(ints.tmp84)
    tmp46 += v.bbb.xov
    tmp46 += ints.tmp81 * 2
    tmp44 = np.copy(ints.tmp60)
    tmp44 += v.baa.xov
    tmp44 += ints.tmp57 * 2
    tmp60 = np.copy(ints.tmp57) * 2
    del ints.tmp57
    tmp60 += ints.tmp60
    del ints.tmp60
    tmp60 += v.baa.xov
    tmp16 = einsum(t2.abab, (0, 1, 2, 3), r2.bab, (3, 2, 1), (0,)) * -1
    tmp15 = einsum(r2.aaa, (0, 1, 2), t2.aaaa, (3, 2, 0, 1), (3,))
    tmp47 = einsum(r2.bab, (0, 1, 2), tmp46, (3, 2, 0), (3, 1)) * -1
    tmp45 = einsum(r2.aaa, (0, 1, 2), tmp44, (3, 2, 1), (3, 0)) * -1
    del tmp44
    tmp70 = np.copy(ints.tmp246)
    tmp70 += ints.tmp313 * 2
    tmp34 = einsum(t2.abab, (0, 1, 2, 3), r2.aba, (2, 3, 0), (1,))
    tmp85 = einsum(tmp46, (0, 1, 2), r2.bbb, (3, 2, 1), (0, 3)) * -1
    del tmp46
    tmp21 = einsum(t1.bb, (0, 1), r2.bbb, (2, 1, 3), (3, 0, 2))
    tmp78 = np.copy(ints.tmp255)
    tmp78 += ints.tmp257 * 0.5
    tmp78 += f.bb.vv * -0.5
    tmp61 = einsum(r2.aba, (0, 1, 2), tmp60, (3, 2, 0), (3, 1))
    tmp35 = einsum(t2.bbbb, (0, 1, 2, 3), r2.bbb, (2, 3, 1), (0,))
    tmp51 = np.copy(ints.tmp58)
    tmp51 += ints.tmp61 * 0.5
    tmp51 += f.aa.vv * -0.5
    tmp53 = np.copy(tmp15) * 2
    tmp53 += tmp16
    tmp42 = np.copy(ints.tmp47)
    tmp42 += ints.tmp163 * 2
    tmp48 = np.copy(tmp45) * -2
    del tmp45
    tmp48 += tmp47
    del tmp47
    tmp2 = einsum(t1.aa, (0, 1), r2.aaa, (2, 1, 3), (3, 0, 2))
    tmp84 = einsum(tmp70, (0, 1, 2, 3), r2.bbb, (4, 2, 0), (1, 4, 3)) * -1
    tmp83 = einsum(tmp34, (0,), ints.tmp243, (0, 1, 2, 3), (1, 2, 3))
    tmp86 = einsum(tmp85, (0, 1), v.bbb.xov, (0, 2, 3), (2, 3, 1)) * -1
    del tmp85
    tmp82 = einsum(f.bb.ov, (0, 1), tmp21, (2, 0, 3), (2, 1, 3))
    tmp81 = einsum(r1.b, (0,), ints.tmp236, (1, 2, 0, 3), (1, 2, 3))
    tmp79 = einsum(r2.bbb, (0, 1, 2), tmp78, (1, 3), (2, 0, 3)) * -4
    del tmp78
    tmp77 = einsum(tmp61, (0, 1), v.bbb.xov, (0, 2, 3), (2, 3, 1))
    tmp75 = einsum(r2.aba, (0, 1, 2), ints.tmp312, (2, 3, 0, 4), (3, 4, 1))
    tmp76 = einsum(ints.tmp243, (0, 1, 2, 3), tmp35, (0,), (1, 2, 3))
    tmp66 = einsum(t1.bb, (0, 1), f.bb.ov, (0, 2), (2, 1))
    tmp62 = np.copy(ints.tmp81) * 2
    del ints.tmp81
    tmp62 += ints.tmp84
    del ints.tmp84
    tmp62 += v.bbb.xov
    tmp64 = einsum(f.aa.ov, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp52 = einsum(tmp51, (0, 1), r2.aaa, (2, 0, 3), (3, 2, 1)) * -4
    del tmp51
    tmp54 = einsum(ints.tmp44, (0, 1, 2, 3), tmp53, (0,), (1, 2, 3))
    tmp43 = einsum(tmp42, (0, 1, 2, 3), r2.aaa, (4, 2, 0), (1, 4, 3)) * -1
    del tmp42
    tmp49 = einsum(v.baa.xov, (0, 1, 2), tmp48, (0, 3), (1, 2, 3))
    del tmp48
    tmp40 = einsum(f.aa.ov, (0, 1), tmp2, (2, 0, 3), (2, 1, 3))
    tmp39 = einsum(r1.a, (0,), ints.tmp24, (1, 2, 0, 3), (1, 2, 3))
    tmp41 = einsum(r2.bab, (0, 1, 2), ints.tmp165, (3, 2, 4, 0), (3, 4, 1)) * -1
    tmp25 = einsum(r2.aba, (0, 1, 2), t1.aa, (3, 0), (2, 3, 1))
    tmp6 = einsum(r2.bab, (0, 1, 2), t1.bb, (3, 0), (2, 3, 1)) * -1
    tmp74 = einsum(r2.bbb, (0, 1, 2), t2.bbbb, (3, 4, 0, 1), (2, 3, 4))
    tmp87 = np.copy(tmp81)
    del tmp81
    tmp87 += tmp82 * 2
    del tmp82
    tmp87 += tmp83
    del tmp83
    tmp87 += np.transpose(tmp84, (0, 2, 1)) * -2
    del tmp84
    tmp87 += np.transpose(tmp86, (0, 2, 1)) * 2
    del tmp86
    tmp80 = einsum(f.bb.ov, (0, 1), r1.b, (2,), (0, 1, 2))
    tmp80 += tmp75
    del tmp75
    tmp80 += tmp76 * 2
    del tmp76
    tmp80 += np.transpose(tmp77, (0, 2, 1))
    del tmp77
    tmp80 += np.transpose(tmp79, (0, 2, 1))
    del tmp79
    tmp73 = np.copy(f.bb.oo)
    tmp73 += ints.tmp151 * 2
    del ints.tmp151
    tmp73 += ints.tmp154
    del ints.tmp154
    tmp73 += np.transpose(ints.tmp22, (1, 0))
    del ints.tmp22
    tmp67 = np.copy(ints.tmp255) * 2
    tmp67 += ints.tmp257
    tmp67 += f.bb.vv * -1
    tmp67 += np.transpose(tmp66, (1, 0))
    del tmp66
    tmp72 = einsum(r2.aaa, (0, 1, 2), tmp60, (3, 2, 1), (3, 0)) * 2
    del tmp60
    tmp72 += einsum(tmp62, (0, 1, 2), r2.bab, (2, 3, 1), (0, 3)) * -1
    tmp65 = np.copy(ints.tmp58) * 2
    tmp65 += ints.tmp61
    tmp65 += f.aa.vv * -1
    tmp65 += np.transpose(tmp64, (1, 0))
    del tmp64
    tmp71 = np.copy(ints.tmp170)
    tmp71 += np.transpose(ints.tmp52, (0, 1, 3, 2)) * -1
    tmp69 = einsum(t2.abab, (0, 1, 2, 3), r2.bab, (3, 2, 4), (0, 4, 1)) * -1
    tmp63 = np.copy(tmp61) * -1
    del tmp61
    tmp63 += einsum(r2.bbb, (0, 1, 2), tmp62, (3, 2, 1), (3, 0)) * 2
    del tmp62
    tmp58 = np.copy(ints.tmp163) * 2
    tmp58 += ints.tmp47
    tmp68 = np.copy(tmp34) * -0.5
    tmp68 += tmp35
    tmp59 = np.copy(ints.tmp250)
    tmp59 += np.transpose(ints.tmp319, (0, 1, 3, 2)) * -1
    tmp57 = einsum(r2.aba, (0, 1, 2), t2.abab, (3, 4, 0, 1), (2, 3, 4))
    tmp56 = np.copy(f.aa.oo)
    tmp56 += ints.tmp148 * 2
    del ints.tmp148
    tmp56 += ints.tmp157
    del ints.tmp157
    tmp56 += np.transpose(ints.tmp19, (1, 0))
    del ints.tmp19
    tmp55 = einsum(f.aa.ov, (0, 1), r1.a, (2,), (0, 1, 2))
    tmp55 += np.transpose(tmp52, (0, 2, 1))
    del tmp52
    tmp55 += tmp54
    del tmp54
    tmp38 = einsum(r2.aaa, (0, 1, 2), t2.aaaa, (3, 4, 0, 1), (2, 3, 4))
    tmp50 = np.copy(tmp39)
    del tmp39
    tmp50 += tmp40 * 2
    del tmp40
    tmp50 += tmp41
    del tmp41
    tmp50 += np.transpose(tmp43, (0, 2, 1)) * -2
    del tmp43
    tmp50 += np.transpose(tmp49, (0, 2, 1))
    del tmp49
    tmp36 = einsum(r1.b, (0,), t1.bb, (1, 0), (1,))
    tmp36 += tmp34 * -1
    del tmp34
    tmp36 += tmp35 * 2
    del tmp35
    tmp30 = np.copy(ints.tmp135)
    del ints.tmp135
    tmp30 += ints.tmp66 * -1
    del ints.tmp66
    tmp27 = np.copy(ints.tmp103)
    tmp27 += ints.tmp111 * 0.5
    tmp27 += ints.tmp133
    tmp27 += ints.tmp139 * 0.5
    tmp27 += ints.tmp149
    tmp27 += ints.tmp158 * 0.5
    tmp27 += ints.tmp175 * 0.5
    tmp27 += ints.tmp182 * 0.5
    tmp27 += ints.tmp192 * 0.5
    tmp27 += ints.tmp20 * 0.5
    tmp27 += ints.tmp211 * 0.5
    tmp27 += ints.tmp218 * 0.5
    tmp27 += ints.tmp2 * 0.5
    tmp27 += ints.tmp36 * 0.5
    tmp27 += ints.tmp64
    tmp27 += ints.tmp73 * 0.5
    tmp27 += ints.tmp79
    tmp27 += f.aa.ov * -0.5
    tmp27 += ints.tmp106 * -1
    tmp27 += ints.tmp115 * -0.5
    tmp27 += ints.tmp119 * -1
    tmp27 += ints.tmp11 * -0.5
    tmp27 += ints.tmp122 * -0.5
    tmp27 += ints.tmp172 * -0.5
    tmp27 += ints.tmp190 * -0.5
    tmp27 += ints.tmp199 * -0.5
    tmp27 += ints.tmp208 * -0.5
    tmp27 += ints.tmp34 * -0.5
    tmp27 += ints.tmp42 * -0.5
    tmp27 += ints.tmp5 * -0.5
    tmp27 += ints.tmp87 * -0.5
    tmp27 += ints.tmp8 * -1
    tmp22 = np.copy(ints.tmp243)
    tmp22 += ints.tmp310 * 2
    del ints.tmp310
    tmp22 += ints.tmp317
    del ints.tmp317
    tmp22 += np.transpose(ints.tmp332, (0, 1, 3, 2))
    del ints.tmp332
    tmp22 += np.transpose(ints.tmp246, (0, 1, 3, 2)) * -1
    del ints.tmp246
    tmp22 += ints.tmp313 * -2
    del ints.tmp313
    tmp22 += np.transpose(ints.tmp330, (0, 1, 3, 2)) * -1
    del ints.tmp330
    tmp19 = np.copy(ints.tmp253)
    del ints.tmp253
    tmp19 += np.transpose(ints.tmp265, (0, 1, 3, 2))
    del ints.tmp265
    tmp19 += np.transpose(ints.tmp271, (0, 1, 3, 2))
    del ints.tmp271
    tmp19 += np.transpose(ints.tmp277, (0, 1, 3, 2)) * 2
    del ints.tmp277
    tmp19 += np.transpose(ints.tmp303, (0, 1, 3, 2))
    del ints.tmp303
    tmp19 += ints.tmp99
    tmp19 += ints.tmp274 * -1
    del ints.tmp274
    tmp19 += np.transpose(ints.tmp281, (0, 1, 3, 2)) * -1
    del ints.tmp281
    tmp20 = np.copy(ints.tmp236) * 0.5
    del ints.tmp236
    tmp20 += ints.tmp251 * 0.5
    del ints.tmp251
    tmp20 += np.transpose(ints.tmp275, (0, 2, 1, 3))
    del ints.tmp275
    tmp20 += np.transpose(ints.tmp301, (0, 3, 1, 2)) * 0.5
    del ints.tmp301
    tmp20 += np.transpose(ints.tmp263, (0, 3, 1, 2)) * -0.5
    del ints.tmp263
    tmp20 += np.transpose(ints.tmp272, (0, 3, 1, 2)) * -1
    del ints.tmp272
    tmp20 += np.transpose(ints.tmp279, (0, 3, 1, 2)) * -0.5
    del ints.tmp279
    tmp37 = np.copy(f.bb.ov)
    tmp37 += ints.tmp38
    tmp37 += ints.tmp41
    tmp37 += ints.tmp110 * -1
    del ints.tmp110
    tmp24 = np.copy(ints.tmp309)
    del ints.tmp309
    tmp24 += ints.tmp315 * 2
    del ints.tmp315
    tmp24 += ints.tmp335
    del ints.tmp335
    tmp24 += ints.tmp49
    tmp24 += ints.tmp312 * -1
    tmp26 = np.copy(ints.tmp250)
    del ints.tmp250
    tmp26 += ints.tmp334
    del ints.tmp334
    tmp26 += np.transpose(ints.tmp319, (0, 1, 3, 2)) * -1
    del ints.tmp319
    tmp23 = einsum(t1.bb, (0, 1), r2.aba, (2, 1, 3), (3, 0, 2))
    tmp29 = einsum(tmp21, (0, 1, 2), t1.bb, (3, 2), (0, 1, 3)) * -1
    tmp32 = np.copy(ints.tmp138)
    del ints.tmp138
    tmp32 += ints.tmp72
    del ints.tmp72
    tmp33 = np.copy(np.transpose(ints.tmp239, (1, 0)))
    del ints.tmp239
    tmp33 += ints.tmp255 * 2
    del ints.tmp255
    tmp33 += ints.tmp257
    del ints.tmp257
    tmp33 += f.bb.vv * -1
    tmp33 += np.transpose(ints.tmp194, (1, 0)) * -1
    del ints.tmp194
    tmp33 += np.transpose(ints.tmp197, (1, 0)) * -1
    del ints.tmp197
    tmp28 = np.copy(ints.tmp105)
    tmp28 += ints.tmp113 * 2
    tmp28 += ints.tmp136 * 2
    tmp28 += ints.tmp142
    tmp28 += ints.tmp152 * 2
    tmp28 += ints.tmp155
    tmp28 += ints.tmp180
    tmp28 += ints.tmp185
    tmp28 += ints.tmp196
    tmp28 += ints.tmp216
    tmp28 += ints.tmp221
    tmp28 += ints.tmp23
    tmp28 += ints.tmp40
    tmp28 += ints.tmp4
    tmp28 += ints.tmp67 * 2
    tmp28 += ints.tmp70
    tmp28 += ints.tmp82 * 2
    tmp28 += f.bb.ov * -1
    tmp28 += ints.tmp108 * -1
    tmp28 += ints.tmp10 * -1
    tmp28 += ints.tmp117 * -2
    tmp28 += ints.tmp121 * -1
    tmp28 += ints.tmp124 * -2
    tmp28 += ints.tmp13 * -2
    tmp28 += ints.tmp178 * -1
    tmp28 += ints.tmp195 * -1
    tmp28 += ints.tmp198 * -1
    tmp28 += ints.tmp214 * -1
    tmp28 += ints.tmp38 * -1
    tmp28 += ints.tmp41 * -1
    tmp28 += ints.tmp7 * -1
    tmp28 += ints.tmp85 * -1
    tmp31 = einsum(t1.bb, (0, 1), tmp25, (2, 3, 1), (2, 3, 0))
    tmp0 = np.copy(ints.tmp146)
    del ints.tmp146
    tmp0 += np.transpose(ints.tmp26, (0, 2, 1, 3))
    tmp0 += np.transpose(ints.tmp55, (0, 2, 1, 3))
    del ints.tmp55
    tmp0 += ints.tmp77
    del ints.tmp77
    tmp0 += ints.tmp91
    del ints.tmp91
    tmp0 += ints.tmp97 * 2
    del ints.tmp97
    tmp0 += ints.tmp100 * -1
    del ints.tmp100
    tmp0 += np.transpose(ints.tmp94, (0, 2, 1, 3)) * -1
    del ints.tmp94
    tmp14 = np.copy(np.transpose(ints.tmp31, (1, 0)))
    del ints.tmp31
    tmp14 += ints.tmp58 * 2
    del ints.tmp58
    tmp14 += ints.tmp61
    del ints.tmp61
    tmp14 += f.aa.vv * -1
    tmp14 += np.transpose(ints.tmp29, (1, 0)) * -1
    del ints.tmp29
    tmp14 += np.transpose(ints.tmp33, (1, 0)) * -1
    del ints.tmp33
    tmp11 = np.copy(ints.tmp132)
    del ints.tmp132
    tmp11 += ints.tmp63 * -1
    del ints.tmp63
    tmp7 = np.copy(np.transpose(ints.tmp205, (0, 1, 3, 2)))
    del ints.tmp205
    tmp7 += np.transpose(ints.tmp52, (0, 1, 3, 2))
    del ints.tmp52
    tmp7 += ints.tmp170 * -1
    del ints.tmp170
    tmp5 = np.copy(ints.tmp162)
    del ints.tmp162
    tmp5 += ints.tmp168 * 2
    del ints.tmp168
    tmp5 += ints.tmp206
    del ints.tmp206
    tmp5 += ints.tmp49
    tmp5 += ints.tmp165 * -1
    tmp18 = np.copy(f.aa.ov)
    tmp18 += ints.tmp34
    tmp18 += ints.tmp42
    tmp18 += ints.tmp102 * -1
    del ints.tmp102
    tmp17 = einsum(t1.aa, (0, 1), r1.a, (1,), (0,)) * 0.5
    tmp17 += tmp15
    del tmp15
    tmp17 += tmp16 * 0.5
    del tmp16
    tmp3 = np.copy(ints.tmp160) * 2
    del ints.tmp160
    tmp3 += ints.tmp166
    del ints.tmp166
    tmp3 += np.transpose(ints.tmp203, (0, 1, 3, 2))
    del ints.tmp203
    tmp3 += ints.tmp44
    tmp3 += ints.tmp163 * -2
    del ints.tmp163
    tmp3 += np.transpose(ints.tmp201, (0, 1, 3, 2)) * -1
    del ints.tmp201
    tmp3 += np.transpose(ints.tmp47, (0, 1, 3, 2)) * -1
    del ints.tmp47
    tmp9 = np.copy(ints.tmp105) * 0.5
    del ints.tmp105
    tmp9 += ints.tmp113
    del ints.tmp113
    tmp9 += ints.tmp136
    del ints.tmp136
    tmp9 += ints.tmp142 * 0.5
    del ints.tmp142
    tmp9 += ints.tmp152
    del ints.tmp152
    tmp9 += ints.tmp155 * 0.5
    del ints.tmp155
    tmp9 += ints.tmp180 * 0.5
    del ints.tmp180
    tmp9 += ints.tmp185 * 0.5
    del ints.tmp185
    tmp9 += ints.tmp196 * 0.5
    del ints.tmp196
    tmp9 += ints.tmp216 * 0.5
    del ints.tmp216
    tmp9 += ints.tmp221 * 0.5
    del ints.tmp221
    tmp9 += ints.tmp23 * 0.5
    del ints.tmp23
    tmp9 += ints.tmp40 * 0.5
    del ints.tmp40
    tmp9 += ints.tmp4 * 0.5
    del ints.tmp4
    tmp9 += ints.tmp67
    del ints.tmp67
    tmp9 += ints.tmp70 * 0.5
    del ints.tmp70
    tmp9 += ints.tmp82
    del ints.tmp82
    tmp9 += f.bb.ov * -0.5
    tmp9 += ints.tmp108 * -0.5
    del ints.tmp108
    tmp9 += ints.tmp10 * -0.5
    del ints.tmp10
    tmp9 += ints.tmp117 * -1
    del ints.tmp117
    tmp9 += ints.tmp121 * -0.5
    del ints.tmp121
    tmp9 += ints.tmp124 * -1
    del ints.tmp124
    tmp9 += ints.tmp13 * -1
    del ints.tmp13
    tmp9 += ints.tmp178 * -0.5
    del ints.tmp178
    tmp9 += ints.tmp195 * -0.5
    del ints.tmp195
    tmp9 += ints.tmp198 * -0.5
    del ints.tmp198
    tmp9 += ints.tmp214 * -0.5
    del ints.tmp214
    tmp9 += ints.tmp38 * -0.5
    del ints.tmp38
    tmp9 += ints.tmp41 * -0.5
    del ints.tmp41
    tmp9 += ints.tmp7 * -0.5
    del ints.tmp7
    tmp9 += ints.tmp85 * -0.5
    del ints.tmp85
    tmp4 = einsum(r2.bab, (0, 1, 2), t1.aa, (3, 1), (3, 2, 0)) * -1
    tmp13 = np.copy(ints.tmp141)
    del ints.tmp141
    tmp13 += ints.tmp69
    del ints.tmp69
    tmp10 = einsum(tmp2, (0, 1, 2), t1.aa, (3, 2), (0, 1, 3)) * -1
    tmp8 = np.copy(ints.tmp103) * 2
    del ints.tmp103
    tmp8 += ints.tmp111
    del ints.tmp111
    tmp8 += ints.tmp133 * 2
    del ints.tmp133
    tmp8 += ints.tmp139
    del ints.tmp139
    tmp8 += ints.tmp149 * 2
    del ints.tmp149
    tmp8 += ints.tmp158
    del ints.tmp158
    tmp8 += ints.tmp175
    del ints.tmp175
    tmp8 += ints.tmp182
    del ints.tmp182
    tmp8 += ints.tmp192
    del ints.tmp192
    tmp8 += ints.tmp20
    del ints.tmp20
    tmp8 += ints.tmp211
    del ints.tmp211
    tmp8 += ints.tmp218
    del ints.tmp218
    tmp8 += ints.tmp2
    del ints.tmp2
    tmp8 += ints.tmp36
    del ints.tmp36
    tmp8 += ints.tmp64 * 2
    del ints.tmp64
    tmp8 += ints.tmp73
    del ints.tmp73
    tmp8 += ints.tmp79 * 2
    del ints.tmp79
    tmp8 += f.aa.ov * -1
    tmp8 += ints.tmp106 * -2
    del ints.tmp106
    tmp8 += ints.tmp115 * -1
    del ints.tmp115
    tmp8 += ints.tmp119 * -2
    del ints.tmp119
    tmp8 += ints.tmp11 * -1
    del ints.tmp11
    tmp8 += ints.tmp122 * -1
    del ints.tmp122
    tmp8 += ints.tmp172 * -1
    del ints.tmp172
    tmp8 += ints.tmp190 * -1
    del ints.tmp190
    tmp8 += ints.tmp199 * -1
    del ints.tmp199
    tmp8 += ints.tmp208 * -1
    del ints.tmp208
    tmp8 += ints.tmp34 * -1
    del ints.tmp34
    tmp8 += ints.tmp42 * -1
    del ints.tmp42
    tmp8 += ints.tmp5 * -1
    del ints.tmp5
    tmp8 += ints.tmp87 * -1
    del ints.tmp87
    tmp8 += ints.tmp8 * -2
    del ints.tmp8
    tmp1 = np.copy(ints.tmp144) * 0.5
    del ints.tmp144
    tmp1 += np.transpose(ints.tmp24, (0, 2, 3, 1)) * 0.5
    del ints.tmp24
    tmp1 += np.transpose(ints.tmp53, (0, 2, 3, 1)) * 0.5
    del ints.tmp53
    tmp1 += np.transpose(ints.tmp92, (0, 1, 3, 2))
    del ints.tmp92
    tmp1 += ints.tmp75 * -0.5
    del ints.tmp75
    tmp1 += ints.tmp89 * -1
    del ints.tmp89
    tmp1 += ints.tmp95 * -0.5
    del ints.tmp95
    tmp12 = einsum(t1.aa, (0, 1), tmp6, (2, 3, 1), (0, 2, 3))
    r2new.bbb = einsum(ints.tmp430, (0, 1, 2, 3), r2.bbb, (3, 2, 4), (1, 0, 4)) * -2
    del ints.tmp430
    r2new.bbb += einsum(ints.tmp243, (0, 1, 2, 3), tmp74, (4, 1, 0), (3, 2, 4)) * 2
    del ints.tmp243, tmp74
    r2new.bbb += np.transpose(tmp80, (1, 2, 0)) * -1
    r2new.bbb += np.transpose(tmp80, (2, 1, 0))
    del tmp80
    r2new.bbb += np.transpose(tmp87, (1, 2, 0))
    r2new.bbb += np.transpose(tmp87, (2, 1, 0)) * -1
    del tmp87
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp73, (2, 3), (0, 1, 3)) * -2
    r2new.bab = einsum(r1.a, (0,), f.bb.ov, (1, 2), (2, 0, 1)) * -1
    r2new.bab += einsum(r1.a, (0,), ints.tmp26, (1, 2, 0, 3), (3, 2, 1)) * -1
    del ints.tmp26
    r2new.bab += einsum(r2.aaa, (0, 1, 2), ints.tmp312, (2, 3, 1, 4), (4, 0, 3)) * 2
    del ints.tmp312
    r2new.bab += einsum(r2.bab, (0, 1, 2), ints.tmp387, (3, 1, 0, 4), (4, 3, 2))
    r2new.bab += einsum(ints.tmp49, (0, 1, 2, 3), tmp69, (0, 4, 1), (3, 2, 4)) * -1
    del tmp69
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp70, (2, 3, 0, 4), (4, 1, 3)) * -1
    del tmp70
    r2new.bab += einsum(tmp71, (0, 1, 2, 3), r2.bab, (4, 2, 0), (4, 3, 1))
    del tmp71
    r2new.bab += einsum(tmp72, (0, 1), v.bbb.xov, (0, 2, 3), (3, 1, 2)) * -1
    del tmp72
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp67, (0, 3), (3, 1, 2)) * -1
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp65, (1, 3), (0, 3, 2)) * -1
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp73, (2, 3), (0, 1, 3)) * -1
    del tmp73
    r2new.bab += einsum(tmp53, (0,), ints.tmp49, (0, 1, 2, 3), (3, 2, 1))
    del tmp53
    r2new.aba = einsum(ints.tmp49, (0, 1, 2, 3), tmp57, (4, 0, 1), (2, 3, 4))
    del tmp57
    r2new.aba += einsum(f.aa.ov, (0, 1), r1.b, (2,), (1, 2, 0)) * -1
    r2new.aba += einsum(r2.bbb, (0, 1, 2), ints.tmp165, (3, 2, 4, 1), (4, 0, 3)) * 2
    del ints.tmp165
    r2new.aba += einsum(r2.aba, (0, 1, 2), ints.tmp387, (0, 3, 4, 1), (3, 4, 2))
    del ints.tmp387
    r2new.aba += einsum(ints.tmp99, (0, 1, 2, 3), r1.b, (3,), (1, 2, 0)) * -1
    del ints.tmp99
    r2new.aba += einsum(tmp58, (0, 1, 2, 3), r2.aba, (2, 4, 0), (3, 4, 1)) * -1
    del tmp58
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp59, (2, 3, 4, 1), (0, 4, 3)) * -1
    del tmp59
    r2new.aba += einsum(tmp63, (0, 1), v.baa.xov, (0, 2, 3), (3, 1, 2)) * -1
    del tmp63
    r2new.aba += einsum(tmp65, (0, 1), r2.aba, (0, 2, 3), (1, 2, 3)) * -1
    del tmp65
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp67, (1, 3), (0, 3, 2)) * -1
    del tmp67
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp56, (2, 3), (0, 1, 3)) * -1
    r2new.aba += einsum(tmp68, (0,), ints.tmp49, (1, 0, 2, 3), (2, 3, 1)) * 2
    del ints.tmp49, tmp68
    r2new.aaa = einsum(tmp38, (0, 1, 2), ints.tmp44, (2, 1, 3, 4), (4, 3, 0)) * 2
    del ints.tmp44, tmp38
    r2new.aaa += einsum(ints.tmp365, (0, 1, 2, 3), r2.aaa, (2, 3, 4), (1, 0, 4)) * 2
    del ints.tmp365
    r2new.aaa += np.transpose(tmp50, (1, 2, 0))
    r2new.aaa += np.transpose(tmp50, (2, 1, 0)) * -1
    del tmp50
    r2new.aaa += np.transpose(tmp55, (1, 2, 0)) * -1
    r2new.aaa += np.transpose(tmp55, (2, 1, 0))
    del tmp55
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp56, (2, 3), (0, 1, 3)) * -2
    del tmp56
    r1new.b = einsum(r2.aba, (0, 1, 2), tmp19, (2, 0, 3, 1), (3,)) * -1
    del tmp19
    r1new.b += einsum(r2.bbb, (0, 1, 2), tmp20, (2, 3, 1, 0), (3,)) * -4
    del tmp20
    r1new.b += einsum(tmp22, (0, 1, 2, 3), tmp21, (0, 1, 2), (3,)) * 2
    del tmp21, tmp22
    r1new.b += einsum(tmp23, (0, 1, 2), tmp24, (0, 1, 2, 3), (3,))
    del tmp23, tmp24
    r1new.b += einsum(tmp26, (0, 1, 2, 3), tmp25, (0, 1, 3), (2,))
    del tmp25, tmp26
    r1new.b += einsum(r2.aba, (0, 1, 2), tmp27, (2, 0), (1,)) * 2
    del tmp27
    r1new.b += einsum(r2.bbb, (0, 1, 2), tmp28, (2, 1), (0,)) * -2
    del tmp28
    r1new.b += einsum(tmp29, (0, 1, 2), tmp30, (0, 2, 1, 3), (3,)) * -2
    del tmp29, tmp30
    r1new.b += einsum(tmp32, (0, 1, 2, 3), tmp31, (0, 1, 2), (3,)) * -1
    del tmp32, tmp31
    r1new.b += einsum(tmp33, (0, 1), r1.b, (0,), (1,)) * -1
    del tmp33
    r1new.b += einsum(tmp36, (0,), tmp37, (0, 1), (1,)) * -1
    del tmp36, tmp37
    r1new.a = einsum(tmp0, (0, 1, 2, 3), r2.bab, (3, 1, 0), (2,)) * -1
    del tmp0
    r1new.a += einsum(r2.aaa, (0, 1, 2), tmp1, (2, 0, 1, 3), (3,)) * 4
    del tmp1
    r1new.a += einsum(tmp2, (0, 1, 2), tmp3, (0, 1, 2, 3), (3,)) * 2
    del tmp2, tmp3
    r1new.a += einsum(tmp5, (0, 1, 2, 3), tmp4, (0, 1, 3), (2,)) * -1
    del tmp5, tmp4
    r1new.a += einsum(tmp6, (0, 1, 2), tmp7, (0, 1, 2, 3), (3,)) * -1
    del tmp6, tmp7
    r1new.a += einsum(r2.aaa, (0, 1, 2), tmp8, (2, 1), (0,)) * -2
    del tmp8
    r1new.a += einsum(r2.bab, (0, 1, 2), tmp9, (2, 0), (1,)) * 2
    del tmp9
    r1new.a += einsum(tmp10, (0, 1, 2), tmp11, (0, 2, 1, 3), (3,)) * -2
    del tmp10, tmp11
    r1new.a += einsum(tmp12, (0, 1, 2), tmp13, (0, 1, 2, 3), (3,))
    del tmp12, tmp13
    r1new.a += einsum(r1.a, (0,), tmp14, (0, 1), (1,)) * -1
    del tmp14
    r1new.a += einsum(tmp18, (0, 1), tmp17, (0,), (1,)) * -2
    del tmp18, tmp17

    return {f"r1new": r1new, f"r2new": r2new}

