"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T15:25:23.742399
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:25:24.460053.

    Parameters
    ----------
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp1 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp1 += einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    e_cc = einsum(tmp0, (0, 1, 2), v.bbb.xov, (0, 1, 2), ())
    del tmp0
    e_cc += einsum(tmp1, (0, 1, 2), v.baa.xov, (0, 1, 2), ())
    del tmp1

    return e_cc

def update_amps(f=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:25:43.291244.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    t2new : Namespace of arrays
        Updated T2 residuals.
    """

    t1new = Namespace()
    t2new = Namespace()
    tmp17 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp10 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp29 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (4, 1, 3))
    tmp30 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (0, 3, 4))
    tmp18 = np.copy(np.transpose(tmp17, (1, 0, 2, 3)))
    tmp18 += np.transpose(tmp17, (1, 0, 3, 2)) * -1
    tmp4 = einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp3 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp13 = np.copy(np.transpose(tmp10, (1, 0, 2, 3)))
    tmp13 += np.transpose(tmp10, (1, 0, 3, 2)) * -1
    tmp31 = np.copy(tmp29) * 0.5
    tmp31 += tmp30
    tmp41 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp53 = einsum(t2.bbbb, (0, 1, 2, 3), tmp18, (1, 4, 5, 3), (4, 0, 5, 2))
    tmp7 = np.copy(tmp3) * 2
    tmp7 += tmp4
    tmp12 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp14 = einsum(t2.aaaa, (0, 1, 2, 3), tmp13, (1, 4, 5, 3), (4, 0, 5, 2))
    tmp5 = np.copy(tmp3) * 2
    tmp5 += tmp4
    tmp56 = einsum(t2.abab, (0, 1, 2, 3), tmp13, (0, 4, 5, 2), (4, 1, 5, 3))
    del tmp13
    tmp59 = einsum(tmp17, (0, 1, 2, 3), t2.bbbb, (4, 5, 3, 2), (4, 5, 1, 0))
    tmp32 = einsum(tmp31, (0, 1, 2), v.bbb.xov, (0, 1, 3), (2, 3)) * 2
    tmp54 = np.copy(np.transpose(tmp41, (1, 0, 3, 2)))
    tmp54 += np.transpose(tmp53, (1, 0, 3, 2)) * -2
    del tmp53
    tmp47 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp33 = np.copy(tmp29)
    tmp33 += tmp30 * 2
    tmp45 = einsum(v.bbb.xov, (0, 1, 2), tmp31, (0, 3, 2), (3, 1)) * 2
    del tmp31
    tmp27 = einsum(v.baa.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 2, 3, 4))
    tmp34 = np.copy(tmp3)
    tmp34 += tmp4 * 0.5
    tmp8 = einsum(tmp7, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp36 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp39 = einsum(v.bbb.xov, (0, 1, 2), tmp7, (0, 3, 4), (3, 1, 4, 2))
    del tmp7
    tmp22 = einsum(tmp10, (0, 1, 2, 3), t2.aaaa, (4, 5, 3, 2), (4, 5, 1, 0))
    tmp15 = np.copy(np.transpose(tmp12, (1, 0, 3, 2)))
    tmp15 += np.transpose(tmp14, (1, 0, 3, 2)) * -2
    del tmp14
    tmp0 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 1, 2, 4))
    tmp25 = einsum(v.baa.xov, (0, 1, 2), tmp5, (0, 3, 2), (1, 3)) * 0.5
    tmp19 = einsum(t2.abab, (0, 1, 2, 3), tmp18, (1, 4, 3, 5), (0, 4, 2, 5))
    del tmp18
    tmp57 = einsum(t2.abab, (0, 1, 2, 3), tmp56, (0, 4, 2, 5), (4, 1, 5, 3))
    del tmp56
    tmp60 = einsum(t2.bbbb, (0, 1, 2, 3), tmp59, (4, 5, 0, 1), (5, 4, 2, 3)) * -1
    del tmp59
    tmp58 = einsum(t2.bbbb, (0, 1, 2, 3), tmp41, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp49 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.oo, (4, 1), (4, 0, 2, 3))
    tmp52 = einsum(tmp30, (0, 1, 2), tmp29, (0, 3, 4), (3, 1, 4, 2))
    del tmp29, tmp30
    tmp51 = np.copy(f.bb.vv) * -1
    tmp51 += tmp32
    tmp55 = einsum(tmp54, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp54
    tmp48 = einsum(tmp47, (0, 1, 2, 3), t2.bbbb, (1, 3, 4, 5), (2, 0, 4, 5))
    del tmp47
    tmp61 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (3, 1, 2, 4))
    tmp50 = einsum(v.bbb.xov, (0, 1, 2), tmp33, (0, 3, 4), (3, 1, 4, 2))
    tmp62 = einsum(t2.bbbb, (0, 1, 2, 3), tmp45, (4, 1), (0, 4, 2, 3)) * -1
    tmp28 = einsum(tmp27, (0, 1, 2, 3), t2.abab, (1, 3, 4, 5), (0, 2, 4, 5))
    del tmp27
    tmp42 = einsum(v.baa.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp35 = np.copy(f.aa.vv) * -1
    tmp35 += einsum(v.baa.xov, (0, 1, 2), tmp34, (0, 1, 3), (2, 3)) * 2
    del tmp34
    tmp38 = np.copy(np.transpose(tmp12, (1, 0, 3, 2)))
    tmp38 += einsum(tmp10, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 2), (0, 4, 3, 5)) * 2
    tmp38 += tmp8 * -1
    tmp46 = einsum(tmp5, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp44 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp37 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp37 += einsum(tmp36, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (1, 4, 2, 5)) * -1
    tmp43 = einsum(t2.abab, (0, 1, 2, 3), tmp36, (4, 5, 2, 3), (0, 4, 1, 5))
    tmp40 = einsum(t2.abab, (0, 1, 2, 3), tmp17, (4, 1, 3, 5), (0, 4, 2, 5)) * -1
    tmp40 += tmp39
    tmp6 = einsum(tmp5, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp23 = einsum(tmp22, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 5), (1, 0, 4, 5)) * -1
    del tmp22
    tmp21 = einsum(t2.aaaa, (0, 1, 2, 3), tmp12, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp12
    tmp16 = einsum(t2.aaaa, (0, 1, 2, 3), tmp15, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp15
    tmp1 = einsum(t2.aaaa, (0, 1, 2, 3), tmp0, (4, 0, 5, 1), (5, 4, 2, 3))
    del tmp0
    tmp9 = np.copy(f.aa.vv) * -0.5
    tmp9 += einsum(tmp5, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3)) * 0.5
    del tmp5
    tmp26 = einsum(tmp25, (0, 1), t2.aaaa, (2, 0, 3, 4), (1, 2, 3, 4)) * -2
    del tmp25
    tmp2 = einsum(f.aa.oo, (0, 1), t2.aaaa, (2, 1, 3, 4), (0, 2, 3, 4))
    tmp20 = einsum(t2.abab, (0, 1, 2, 3), tmp19, (4, 1, 5, 3), (4, 0, 5, 2)) * -1
    del tmp19
    tmp24 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp11 = einsum(tmp4, (0, 1, 2), tmp3, (0, 3, 4), (3, 1, 4, 2))
    del tmp3, tmp4
    t2new.bbbb = np.copy(np.transpose(tmp48, (0, 1, 3, 2))) * -2
    del tmp48
    t2new.bbbb += np.transpose(tmp49, (1, 0, 3, 2)) * 2
    t2new.bbbb += np.transpose(tmp49, (0, 1, 3, 2)) * -2
    del tmp49
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp32, (4, 3), (0, 1, 2, 4)) * -2
    t2new.bbbb += np.transpose(tmp50, (1, 0, 3, 2))
    t2new.bbbb += einsum(tmp51, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 0, 4)) * 2
    del tmp51
    t2new.bbbb += einsum(f.bb.vv, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 4, 0)) * 2
    t2new.bbbb += np.transpose(tmp50, (1, 0, 2, 3)) * -1
    t2new.bbbb += np.transpose(tmp17, (1, 0, 3, 2))
    t2new.bbbb += np.transpose(tmp17, (1, 0, 2, 3)) * -1
    del tmp17
    t2new.bbbb += np.transpose(tmp50, (0, 1, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp52, (0, 1, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp52, (1, 0, 2, 3)) * -2
    t2new.bbbb += np.transpose(tmp55, (0, 1, 3, 2)) * 2
    t2new.bbbb += np.transpose(tmp57, (1, 0, 2, 3)) * -1
    t2new.bbbb += tmp52 * 2
    t2new.bbbb += np.transpose(tmp52, (1, 0, 3, 2)) * 2
    del tmp52
    t2new.bbbb += np.transpose(tmp55, (1, 0, 3, 2)) * -2
    del tmp55
    t2new.bbbb += tmp57
    del tmp57
    t2new.bbbb += tmp50
    del tmp50
    t2new.bbbb += tmp58 * -2
    t2new.bbbb += np.transpose(tmp58, (1, 0, 2, 3)) * 2
    del tmp58
    t2new.bbbb += tmp60 * 2
    del tmp60
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp61, (4, 2, 5, 3), (0, 1, 4, 5)) * -2
    del tmp61
    t2new.bbbb += np.transpose(tmp62, (0, 1, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp62, (1, 0, 3, 2)) * 2
    del tmp62
    t2new.abab = np.copy(tmp28)
    del tmp28
    t2new.abab += einsum(f.bb.oo, (0, 1), t2.abab, (2, 1, 3, 4), (2, 0, 3, 4)) * -1
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), f.aa.oo, (4, 0), (4, 1, 2, 3)) * -1
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp32, (4, 3), (0, 1, 2, 4)) * -1
    del tmp32
    t2new.abab += einsum(tmp33, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    del tmp33
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp35, (2, 4), (0, 1, 4, 3)) * -1
    del tmp35
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), f.bb.vv, (4, 3), (0, 1, 2, 4))
    t2new.abab += tmp36
    del tmp36
    t2new.abab += einsum(tmp37, (0, 1, 2, 3), t2.abab, (4, 0, 2, 5), (4, 1, 3, 5)) * -1
    del tmp37
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp38, (0, 4, 2, 5), (4, 1, 5, 3)) * -1
    del tmp38
    t2new.abab += einsum(tmp40, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5)) * 2
    del tmp40
    t2new.abab += tmp39
    del tmp39
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp41, (4, 1, 5, 3), (0, 4, 2, 5)) * -1
    del tmp41
    t2new.abab += einsum(tmp42, (0, 1, 2, 3), t2.abab, (1, 4, 5, 3), (0, 4, 5, 2)) * -1
    del tmp42
    t2new.abab += einsum(tmp43, (0, 1, 2, 3), t2.abab, (1, 3, 4, 5), (0, 2, 4, 5))
    del tmp43
    t2new.abab += einsum(tmp44, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 5, 0, 2))
    del tmp44
    t2new.abab += einsum(tmp45, (0, 1), t2.abab, (2, 1, 3, 4), (2, 0, 3, 4)) * -1
    del tmp45
    t2new.abab += einsum(tmp46, (0, 1), t2.abab, (1, 2, 3, 4), (0, 2, 3, 4)) * -1
    del tmp46
    t2new.aaaa = np.copy(np.transpose(tmp1, (0, 1, 3, 2))) * -2
    del tmp1
    t2new.aaaa += np.transpose(tmp2, (1, 0, 3, 2)) * 2
    t2new.aaaa += np.transpose(tmp2, (0, 1, 3, 2)) * -2
    del tmp2
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp6, (4, 3), (0, 1, 2, 4)) * -2
    del tmp6
    t2new.aaaa += tmp8
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp9, (4, 3), (0, 1, 4, 2)) * 4
    del tmp9
    t2new.aaaa += einsum(f.aa.vv, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 4, 0)) * 2
    t2new.aaaa += np.transpose(tmp8, (0, 1, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp10, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp10, (1, 0, 2, 3)) * -1
    del tmp10
    t2new.aaaa += np.transpose(tmp8, (1, 0, 2, 3)) * -1
    t2new.aaaa += np.transpose(tmp11, (0, 1, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp11, (1, 0, 2, 3)) * -2
    t2new.aaaa += np.transpose(tmp16, (1, 0, 2, 3)) * 2
    t2new.aaaa += np.transpose(tmp20, (0, 1, 3, 2)) * -1
    t2new.aaaa += tmp11 * 2
    t2new.aaaa += np.transpose(tmp11, (1, 0, 3, 2)) * 2
    del tmp11
    t2new.aaaa += tmp16 * -2
    del tmp16
    t2new.aaaa += tmp20
    del tmp20
    t2new.aaaa += np.transpose(tmp8, (1, 0, 3, 2))
    del tmp8
    t2new.aaaa += tmp21 * -2
    t2new.aaaa += np.transpose(tmp21, (1, 0, 2, 3)) * 2
    del tmp21
    t2new.aaaa += tmp23 * 2
    del tmp23
    t2new.aaaa += einsum(tmp24, (0, 1, 2, 3), t2.aaaa, (4, 5, 1, 3), (4, 5, 0, 2)) * -2
    del tmp24
    t2new.aaaa += np.transpose(tmp26, (1, 0, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp26, (0, 1, 3, 2)) * 2
    del tmp26

    return {f"t2new": t2new}

def update_lams(f=None, l2=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:26:12.909477.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    l2 : Namespace of arrays
        L2 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    l2new : Namespace of arrays
        Updated L2 residuals.
    """

    l1new = Namespace()
    l2new = Namespace()
    tmp8 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp9 = einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp13 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp12 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (4, 1, 3))
    tmp0 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4))
    tmp1 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    tmp51 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 1), (0, 4))
    tmp50 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    tmp73 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    tmp72 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    tmp33 = np.copy(v.baa.xov)
    tmp33 += tmp8 * 2
    tmp33 += tmp9
    tmp35 = np.copy(v.bbb.xov)
    tmp35 += tmp12
    tmp35 += tmp13 * 2
    tmp56 = np.copy(tmp12) * 0.5
    tmp56 += tmp13
    tmp44 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    tmp43 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (2, 4))
    tmp18 = np.copy(tmp8) * 2
    tmp18 += tmp9
    tmp14 = np.copy(v.bbb.xov)
    tmp14 += tmp12
    del tmp12
    tmp14 += tmp13 * 2
    del tmp13
    tmp10 = np.copy(v.baa.xov) * 0.5
    tmp10 += tmp8
    del tmp8
    tmp10 += tmp9 * 0.5
    del tmp9
    tmp2 = np.copy(tmp0)
    del tmp0
    tmp2 += tmp1 * 0.5
    del tmp1
    tmp52 = np.copy(tmp50)
    del tmp50
    tmp52 += tmp51 * 2
    del tmp51
    tmp74 = np.copy(tmp72) * 0.5
    del tmp72
    tmp74 += tmp73
    del tmp73
    tmp99 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp98 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (5, 1, 4, 3))
    tmp94 = einsum(tmp33, (0, 1, 2), l2.abab, (2, 3, 1, 4), (0, 4, 3))
    tmp95 = einsum(tmp35, (0, 1, 2), l2.bbbb, (3, 2, 4, 1), (0, 4, 3))
    tmp83 = einsum(v.bbb.xov, (0, 1, 2), tmp56, (0, 3, 2), (1, 3)) * 2
    tmp65 = einsum(tmp56, (0, 1, 2), v.bbb.xov, (0, 1, 3), (3, 2)) * 2
    tmp45 = np.copy(tmp43) * 2
    del tmp43
    tmp45 += tmp44
    del tmp44
    tmp27 = einsum(tmp18, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp36 = einsum(l2.abab, (0, 1, 2, 3), tmp35, (4, 3, 1), (4, 2, 0))
    del tmp35
    tmp34 = einsum(l2.aaaa, (0, 1, 2, 3), tmp33, (4, 3, 1), (4, 2, 0))
    del tmp33
    tmp40 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp39 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp15 = einsum(tmp14, (0, 1, 2), l2.abab, (3, 2, 4, 1), (0, 4, 3))
    tmp11 = einsum(l2.aaaa, (0, 1, 2, 3), tmp10, (4, 3, 1), (4, 2, 0)) * 4
    tmp3 = einsum(tmp2, (0, 1), v.baa.xov, (2, 3, 1), (2, 3, 0)) * 2
    tmp78 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp53 = einsum(v.bbb.xov, (0, 1, 2), tmp52, (3, 2), (0, 1, 3)) * 0.5
    tmp87 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp79 = einsum(v.bbb.xov, (0, 1, 2), tmp52, (3, 2), (0, 1, 3))
    del tmp52
    tmp75 = einsum(v.bbb.xov, (0, 1, 2), tmp74, (3, 1), (0, 3, 2))
    tmp103 = einsum(v.bbb.xov, (0, 1, 2), tmp74, (3, 1), (0, 3, 2)) * 2
    del tmp74
    tmp100 = np.copy(tmp98)
    del tmp98
    tmp100 += tmp99 * 4
    del tmp99
    tmp96 = np.copy(tmp94)
    del tmp94
    tmp96 += tmp95 * 2
    del tmp95
    tmp68 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp84 = np.copy(f.bb.oo)
    tmp84 += np.transpose(tmp83, (1, 0))
    del tmp83
    tmp89 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (3, 1, 2, 4))
    tmp66 = np.copy(f.bb.vv) * -1
    tmp66 += np.transpose(tmp65, (1, 0))
    del tmp65
    tmp20 = einsum(tmp18, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp62 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp60 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 5, 0, 1), (2, 4, 3, 5))
    tmp59 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp22 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp23 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp6 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp48 = einsum(v.baa.xov, (0, 1, 2), tmp45, (3, 1), (0, 3, 2))
    tmp25 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp46 = einsum(v.baa.xov, (0, 1, 2), tmp45, (3, 1), (0, 3, 2)) * 0.5
    del tmp45
    tmp28 = np.copy(f.aa.vv) * -1
    tmp28 += tmp27
    del tmp27
    tmp37 = np.copy(tmp34) * 2
    del tmp34
    tmp37 += tmp36
    del tmp36
    tmp41 = np.copy(tmp39) * 4
    del tmp39
    tmp41 += tmp40
    del tmp40
    tmp31 = einsum(tmp2, (0, 1), v.baa.xov, (2, 3, 1), (2, 3, 0))
    del tmp2
    tmp16 = np.copy(tmp11)
    del tmp11
    tmp16 += tmp15
    del tmp15
    tmp4 = np.copy(v.baa.xov)
    tmp4 += tmp3 * -1
    tmp92 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp92 += einsum(t2.bbbb, (0, 1, 2, 3), tmp78, (4, 5, 3, 2), (0, 1, 5, 4)) * -1
    tmp54 = np.copy(v.bbb.xov) * 0.5
    tmp54 += tmp53 * -1
    del tmp53
    tmp88 = einsum(tmp78, (0, 1, 2, 3), tmp87, (4, 5, 0, 1), (4, 5, 2, 3))
    del tmp87
    tmp80 = np.copy(v.bbb.xov)
    tmp80 += tmp79 * -1
    tmp82 = einsum(l2.abab, (0, 1, 2, 3), tmp10, (4, 2, 0), (4, 3, 1)) * 2
    tmp82 += einsum(tmp14, (0, 1, 2), l2.bbbb, (3, 2, 4, 1), (0, 4, 3)) * 2
    tmp102 = einsum(v.bbb.xov, (0, 1, 2), tmp75, (0, 3, 4), (1, 3, 2, 4)) * -2
    tmp104 = einsum(v.bbb.xov, (0, 1, 2), tmp103, (0, 3, 4), (1, 3, 2, 4)) * -1
    del tmp103
    tmp101 = einsum(tmp78, (0, 1, 2, 3), tmp100, (4, 0, 5, 3), (4, 1, 5, 2))
    del tmp100
    tmp97 = einsum(v.bbb.xov, (0, 1, 2), tmp96, (0, 3, 4), (1, 3, 2, 4))
    del tmp96
    tmp86 = einsum(l2.abab, (0, 1, 2, 3), tmp10, (4, 2, 0), (4, 3, 1))
    tmp86 += einsum(tmp14, (0, 1, 2), l2.bbbb, (3, 2, 4, 1), (0, 4, 3))
    tmp81 = einsum(l2.bbbb, (0, 1, 2, 3), tmp68, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp85 = einsum(tmp84, (0, 1), l2.bbbb, (2, 3, 4, 0), (4, 1, 2, 3)) * -2
    del tmp84
    tmp93 = einsum(v.bbb.xov, (0, 1, 2), tmp79, (0, 3, 4), (1, 3, 2, 4)) * -1
    del tmp79
    tmp90 = einsum(l2.bbbb, (0, 1, 2, 3), tmp89, (4, 0, 5, 1), (2, 3, 5, 4))
    del tmp89
    tmp91 = einsum(tmp66, (0, 1), l2.bbbb, (2, 0, 3, 4), (3, 4, 2, 1)) * -1
    tmp69 = einsum(v.baa.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp21 = np.copy(f.aa.oo)
    tmp21 += tmp20
    del tmp20
    tmp63 = einsum(l2.abab, (0, 1, 2, 3), tmp62, (4, 0, 5, 1), (2, 3, 4, 5))
    del tmp62
    tmp77 = einsum(t2.abab, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 0), (5, 1, 4, 3))
    tmp77 += einsum(l2.abab, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp76 = einsum(t2.aaaa, (0, 1, 2, 3), l2.abab, (3, 4, 1, 5), (0, 5, 2, 4))
    tmp76 += einsum(t2.abab, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (0, 5, 2, 4))
    tmp61 = einsum(tmp60, (0, 1, 2, 3), tmp59, (1, 3, 4, 5), (0, 2, 4, 5))
    del tmp60
    tmp64 = np.copy(f.aa.vv) * -0.5
    tmp64 += einsum(tmp18, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3)) * 0.5
    tmp67 = einsum(v.baa.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 2, 3, 4))
    tmp67 += einsum(t2.abab, (0, 1, 2, 3), tmp59, (4, 5, 2, 3), (0, 4, 1, 5))
    tmp57 = np.copy(f.bb.oo) * 0.5
    tmp57 += einsum(tmp56, (0, 1, 2), v.bbb.xov, (0, 3, 2), (1, 3))
    del tmp56
    tmp71 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 5, 1), (3, 4, 0, 5))
    tmp58 = einsum(l2.abab, (0, 1, 2, 3), tmp10, (4, 2, 0), (4, 3, 1)) * 0.5
    del tmp10
    tmp58 += einsum(tmp14, (0, 1, 2), l2.bbbb, (3, 2, 4, 1), (0, 4, 3)) * 0.5
    del tmp14
    tmp55 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp70 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 5, 1), (5, 0, 4, 3))
    tmp24 = einsum(tmp22, (0, 1, 2, 3), tmp23, (4, 5, 0, 1), (4, 5, 2, 3))
    del tmp23
    tmp7 = einsum(l2.aaaa, (0, 1, 2, 3), tmp6, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp30 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp30 += einsum(t2.aaaa, (0, 1, 2, 3), tmp22, (4, 5, 3, 2), (0, 1, 5, 4)) * -1
    tmp49 = einsum(tmp48, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 3, 2, 4)) * -1
    tmp26 = einsum(l2.aaaa, (0, 1, 2, 3), tmp25, (4, 0, 5, 1), (2, 3, 5, 4))
    del tmp25
    tmp47 = einsum(v.baa.xov, (0, 1, 2), tmp46, (0, 3, 4), (3, 1, 4, 2)) * -2
    del tmp46
    tmp29 = einsum(l2.aaaa, (0, 1, 2, 3), tmp28, (1, 4), (2, 3, 0, 4)) * -1
    del tmp28
    tmp38 = einsum(v.baa.xov, (0, 1, 2), tmp37, (0, 3, 4), (3, 1, 4, 2))
    tmp19 = np.copy(f.aa.oo) * 0.5
    tmp19 += einsum(tmp18, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3)) * 0.5
    del tmp18
    tmp42 = einsum(tmp41, (0, 1, 2, 3), tmp22, (1, 4, 5, 3), (0, 4, 2, 5))
    del tmp41
    tmp32 = einsum(v.baa.xov, (0, 1, 2), tmp31, (0, 3, 4), (3, 1, 4, 2)) * -2
    del tmp31
    tmp17 = einsum(v.baa.xov, (0, 1, 2), tmp16, (0, 3, 4), (3, 1, 4, 2))
    del tmp16
    tmp5 = einsum(v.baa.xov, (0, 1, 2), tmp4, (0, 3, 4), (3, 1, 4, 2))
    del tmp4
    l2new.bbbb = einsum(tmp54, (0, 1, 2), v.bbb.xov, (0, 3, 4), (4, 2, 3, 1)) * 2
    l2new.bbbb += einsum(tmp80, (0, 1, 2), v.bbb.xov, (0, 3, 4), (2, 4, 3, 1)) * -1
    del tmp80
    l2new.bbbb += np.transpose(tmp81, (3, 2, 0, 1)) * 2
    l2new.bbbb += einsum(tmp82, (0, 1, 2), v.bbb.xov, (0, 3, 4), (4, 2, 1, 3)) * -1
    del tmp82
    l2new.bbbb += np.transpose(tmp85, (3, 2, 0, 1)) * -1
    l2new.bbbb += np.transpose(tmp81, (3, 2, 1, 0)) * -2
    l2new.bbbb += einsum(v.bbb.xov, (0, 1, 2), tmp86, (0, 3, 4), (2, 4, 1, 3)) * 2
    del tmp86
    l2new.bbbb += np.transpose(tmp85, (3, 2, 1, 0))
    del tmp85
    l2new.bbbb += np.transpose(tmp88, (3, 2, 1, 0)) * 2
    del tmp88
    l2new.bbbb += np.transpose(tmp90, (2, 3, 1, 0)) * -2
    del tmp90
    l2new.bbbb += np.transpose(tmp91, (3, 2, 1, 0)) * 2
    l2new.bbbb += np.transpose(tmp91, (2, 3, 1, 0)) * -2
    del tmp91
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp92, (2, 3, 4, 5), (0, 1, 5, 4)) * 2
    del tmp92
    l2new.bbbb += np.transpose(tmp93, (2, 3, 1, 0)) * -1
    l2new.bbbb += np.transpose(tmp81, (2, 3, 0, 1)) * -2
    l2new.bbbb += np.transpose(tmp97, (3, 2, 1, 0))
    l2new.bbbb += np.transpose(tmp81, (2, 3, 1, 0)) * 2
    del tmp81
    l2new.bbbb += np.transpose(tmp97, (3, 2, 0, 1)) * -1
    del tmp97
    l2new.bbbb += np.transpose(tmp101, (3, 2, 0, 1))
    l2new.bbbb += np.transpose(tmp102, (3, 2, 1, 0))
    l2new.bbbb += np.transpose(tmp101, (2, 3, 0, 1)) * -1
    l2new.bbbb += np.transpose(tmp104, (2, 3, 1, 0)) * -1
    l2new.bbbb += np.transpose(tmp101, (3, 2, 1, 0)) * -1
    l2new.bbbb += np.transpose(tmp102, (3, 2, 0, 1)) * -1
    del tmp102
    l2new.bbbb += np.transpose(tmp101, (2, 3, 1, 0))
    del tmp101
    l2new.bbbb += np.transpose(tmp104, (2, 3, 0, 1))
    del tmp104
    l2new.bbbb += np.transpose(tmp93, (3, 2, 1, 0))
    del tmp93
    l2new.abab = einsum(tmp54, (0, 1, 2), v.baa.xov, (0, 3, 4), (4, 2, 3, 1)) * 2
    del tmp54
    l2new.abab += einsum(tmp55, (0, 1, 2, 3), l2.abab, (3, 4, 5, 1), (2, 4, 5, 0)) * -1
    del tmp55
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp57, (3, 4), (0, 1, 2, 4)) * -2
    del tmp57
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp6, (4, 2, 5, 0), (5, 1, 4, 3)) * -1
    del tmp6
    l2new.abab += einsum(tmp58, (0, 1, 2), v.baa.xov, (0, 3, 4), (4, 2, 3, 1)) * 4
    del tmp58
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp21, (2, 4), (0, 1, 4, 3)) * -1
    l2new.abab += np.transpose(tmp61, (2, 3, 0, 1))
    del tmp61
    l2new.abab += np.transpose(tmp63, (2, 3, 0, 1))
    del tmp63
    l2new.abab += einsum(tmp64, (0, 1), l2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -2
    del tmp64
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp66, (1, 4), (0, 4, 2, 3)) * -1
    del tmp66
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp67, (2, 4, 3, 5), (0, 1, 4, 5))
    del tmp67
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp68, (4, 3, 5, 1), (0, 5, 2, 4)) * -1
    del tmp68
    l2new.abab += einsum(tmp37, (0, 1, 2), v.bbb.xov, (0, 3, 4), (2, 4, 1, 3))
    del tmp37
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp69, (4, 2, 5, 1), (0, 5, 4, 3)) * -1
    del tmp69
    l2new.abab += einsum(tmp59, (0, 1, 2, 3), tmp70, (4, 0, 5, 3), (2, 5, 4, 1))
    del tmp70
    l2new.abab += einsum(tmp48, (0, 1, 2), v.bbb.xov, (0, 3, 4), (2, 4, 1, 3)) * -1
    del tmp48
    l2new.abab += einsum(tmp71, (0, 1, 2, 3), tmp59, (4, 1, 3, 5), (2, 5, 4, 0))
    del tmp59, tmp71
    l2new.abab += einsum(tmp75, (0, 1, 2), v.baa.xov, (0, 3, 4), (4, 2, 3, 1)) * -2
    del tmp75
    l2new.abab += einsum(v.bbb.xov, (0, 1, 2), tmp3, (0, 3, 4), (4, 2, 3, 1)) * -1
    del tmp3
    l2new.abab += einsum(tmp76, (0, 1, 2, 3), tmp22, (0, 4, 5, 2), (5, 3, 4, 1)) * -2
    del tmp22, tmp76
    l2new.abab += einsum(tmp77, (0, 1, 2, 3), tmp78, (1, 4, 5, 3), (2, 5, 0, 4)) * -2
    del tmp78, tmp77
    l2new.aaaa = np.copy(np.transpose(tmp5, (3, 2, 1, 0)))
    l2new.aaaa += np.transpose(tmp5, (2, 3, 1, 0)) * -1
    del tmp5
    l2new.aaaa += np.transpose(tmp7, (3, 2, 0, 1)) * 2
    l2new.aaaa += np.transpose(tmp17, (3, 2, 0, 1)) * -1
    l2new.aaaa += einsum(tmp19, (0, 1), l2.aaaa, (2, 3, 4, 0), (2, 3, 4, 1)) * -4
    del tmp19
    l2new.aaaa += np.transpose(tmp7, (3, 2, 1, 0)) * -2
    l2new.aaaa += np.transpose(tmp17, (3, 2, 1, 0))
    del tmp17
    l2new.aaaa += einsum(tmp21, (0, 1), l2.aaaa, (2, 3, 4, 0), (2, 3, 1, 4)) * 2
    del tmp21
    l2new.aaaa += np.transpose(tmp24, (3, 2, 1, 0)) * 2
    del tmp24
    l2new.aaaa += np.transpose(tmp26, (2, 3, 1, 0)) * -2
    del tmp26
    l2new.aaaa += np.transpose(tmp29, (3, 2, 1, 0)) * 2
    l2new.aaaa += np.transpose(tmp29, (2, 3, 1, 0)) * -2
    del tmp29
    l2new.aaaa += einsum(tmp30, (0, 1, 2, 3), l2.aaaa, (4, 5, 0, 1), (4, 5, 3, 2)) * 2
    del tmp30
    l2new.aaaa += np.transpose(tmp32, (3, 2, 0, 1)) * -1
    l2new.aaaa += np.transpose(tmp7, (2, 3, 0, 1)) * -2
    l2new.aaaa += np.transpose(tmp38, (2, 3, 0, 1))
    l2new.aaaa += np.transpose(tmp7, (2, 3, 1, 0)) * 2
    del tmp7
    l2new.aaaa += np.transpose(tmp38, (2, 3, 1, 0)) * -1
    del tmp38
    l2new.aaaa += np.transpose(tmp42, (3, 2, 0, 1))
    l2new.aaaa += np.transpose(tmp47, (2, 3, 0, 1))
    l2new.aaaa += np.transpose(tmp42, (2, 3, 0, 1)) * -1
    l2new.aaaa += np.transpose(tmp47, (3, 2, 0, 1)) * -1
    del tmp47
    l2new.aaaa += np.transpose(tmp42, (3, 2, 1, 0)) * -1
    l2new.aaaa += np.transpose(tmp49, (2, 3, 1, 0)) * -1
    l2new.aaaa += np.transpose(tmp42, (2, 3, 1, 0))
    del tmp42
    l2new.aaaa += np.transpose(tmp49, (3, 2, 1, 0))
    del tmp49
    l2new.aaaa += np.transpose(tmp32, (2, 3, 0, 1))
    del tmp32

    return {f"l2new": l2new}

def make_rdm1_f(l2=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:26:13.923469.

    Parameters
    ----------
    l2 : Namespace of arrays
        L2 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm1 : Namespace of arrays
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    rdm1.aa = Namespace()
    rdm1.bb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    rdm1.bb.vv = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    rdm1.bb.vv += einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 1), (0, 4)) * 2
    rdm1.aa.vv = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    rdm1.aa.vv += einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4)) * 2
    rdm1.bb.oo = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 0, 4), (1, 4)) * -1
    rdm1.bb.oo += einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (0, 4)) * -2
    rdm1.bb.oo += delta.bb.oo
    rdm1.aa.oo = np.copy(delta.aa.oo)
    del delta
    rdm1.aa.oo += einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (4, 2)) * -2
    rdm1.aa.oo += einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 3, 4, 1), (0, 4)) * -1
    rdm1.aa.oo = np.zeros((t2.aa.shape[0], t2.aa.shape[0]))
    rdm1.aa.vv = np.zeros((t2.aa.shape[-1], t2.aa.shape[-1]))
    rdm1.bb.oo = np.zeros((t2.bb.shape[0], t2.bb.shape[0]))
    rdm1.bb.vv = np.zeros((t2.bb.shape[-1], t2.bb.shape[-1]))
    rdm1.aa = np.block([[rdm1.aa.oo, rdm1.aa.ov], [rdm1.aa.vo, rdm1.aa.vv]])
    rdm1.bb = np.block([[rdm1.bb.oo, rdm1.bb.ov], [rdm1.bb.vo, rdm1.bb.vv]])

    return rdm1

def make_rdm2_f(l2=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:26:29.603509.

    Parameters
    ----------
    l2 : Namespace of arrays
        L2 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm2 : Namespace of arrays
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    rdm2.aaaa = Namespace()
    rdm2.abab = Namespace()
    rdm2.bbbb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    tmp6 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    tmp5 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    tmp0 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 1), (4, 0))
    tmp1 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    tmp25 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    tmp26 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 1), (0, 4))
    tmp13 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4))
    tmp14 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    tmp39 = einsum(l2.aaaa, (0, 1, 2, 3), t2.abab, (3, 4, 1, 5), (2, 4, 0, 5))
    tmp12 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp28 = np.copy(tmp5)
    tmp28 += tmp6 * 2
    tmp37 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp41 = einsum(l2.abab, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp11 = np.copy(tmp5) * 0.5
    tmp11 += tmp6
    tmp20 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp30 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp22 = einsum(l2.abab, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 0), (4, 3, 5, 1))
    tmp18 = einsum(t2.abab, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (0, 5, 2, 4))
    tmp8 = np.copy(tmp0)
    tmp8 += tmp1 * 0.5
    tmp4 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp45 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 5, 0, 1), (4, 5, 2, 3))
    tmp44 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 5), (0, 1, 4, 5))
    tmp27 = np.copy(tmp25) * 0.5
    tmp27 += tmp26
    tmp43 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 0, 5), (5, 1, 4, 3))
    tmp15 = np.copy(tmp13) * 2
    tmp15 += tmp14
    tmp33 = np.copy(tmp25)
    del tmp25
    tmp33 += tmp26 * 2
    del tmp26
    tmp24 = np.copy(tmp13)
    del tmp13
    tmp24 += tmp14 * 0.5
    del tmp14
    tmp29 = einsum(t2.abab, (0, 1, 2, 3), l2.abab, (2, 4, 5, 1), (5, 0, 4, 3))
    tmp40 = einsum(t2.abab, (0, 1, 2, 3), tmp39, (0, 4, 2, 5), (4, 1, 5, 3))
    tmp36 = einsum(tmp12, (0, 1, 2, 3), t2.bbbb, (1, 0, 4, 5), (3, 2, 4, 5))
    tmp34 = einsum(tmp28, (0, 1), t2.bbbb, (2, 0, 3, 4), (1, 2, 3, 4)) * -1
    tmp38 = einsum(t2.bbbb, (0, 1, 2, 3), tmp37, (1, 4, 3, 5), (4, 0, 5, 2))
    tmp42 = einsum(t2.abab, (0, 1, 2, 3), tmp41, (0, 4, 2, 5), (1, 4, 3, 5))
    tmp35 = einsum(tmp11, (0, 1), t2.bbbb, (2, 0, 3, 4), (2, 1, 3, 4)) * -2
    tmp9 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 5, 0, 1), (2, 4, 3, 5))
    tmp31 = np.copy(tmp20) * 4
    tmp31 += tmp30
    tmp3 = np.copy(tmp0) * 2
    tmp3 += tmp1
    tmp32 = np.copy(tmp22)
    tmp32 += tmp18
    tmp23 = einsum(t2.abab, (0, 1, 2, 3), tmp22, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp21 = einsum(t2.aaaa, (0, 1, 2, 3), tmp20, (1, 4, 3, 5), (0, 4, 2, 5))
    tmp16 = einsum(t2.aaaa, (0, 1, 2, 3), tmp8, (1, 4), (0, 4, 2, 3)) * -2
    tmp19 = einsum(tmp18, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 5, 2))
    tmp17 = einsum(tmp4, (0, 1, 2, 3), t2.aaaa, (1, 0, 4, 5), (3, 2, 4, 5))
    tmp10 = np.copy(delta.bb.oo) * -1
    tmp10 += tmp5
    tmp10 += tmp6 * 2
    tmp7 = np.copy(delta.bb.oo) * -0.5
    tmp7 += tmp5 * 0.5
    del tmp5
    tmp7 += tmp6
    del tmp6
    tmp2 = np.copy(delta.aa.oo) * -0.5
    tmp2 += tmp0
    del tmp0
    tmp2 += tmp1 * 0.5
    del tmp1
    rdm2.bbbb.vvvv = np.copy(np.transpose(tmp45, (1, 0, 3, 2))) * 2
    del tmp45
    rdm2.abab.vvvv = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 5), (0, 1, 4, 5))
    rdm2.aaaa.vvvv = np.copy(np.transpose(tmp44, (1, 0, 3, 2))) * 2
    del tmp44
    rdm2.bbbb.vvoo = np.copy(l2.bbbb) * 2
    rdm2.abab.vvoo = np.copy(l2.abab)
    rdm2.aaaa.vvoo = np.copy(l2.aaaa) * 2
    rdm2.bbbb.vovo = einsum(tmp27, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.bbbb.vovo += np.transpose(tmp43, (2, 1, 3, 0)) * -1
    rdm2.bbbb.vovo += np.transpose(tmp37, (2, 1, 3, 0)) * -4
    rdm2.abab.vovo = einsum(delta.bb.oo, (0, 1), tmp15, (2, 3), (2, 0, 3, 1))
    rdm2.abab.vovo += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 5, 1), (0, 4, 5, 3)) * -1
    rdm2.aaaa.vovo = einsum(delta.aa.oo, (0, 1), tmp15, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.vovo += np.transpose(tmp20, (2, 1, 3, 0)) * -4
    rdm2.aaaa.vovo += np.transpose(tmp30, (2, 1, 3, 0)) * -1
    rdm2.bbbb.voov = einsum(delta.bb.oo, (0, 1), tmp33, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.voov += np.transpose(tmp43, (2, 1, 0, 3))
    rdm2.bbbb.voov += np.transpose(tmp37, (2, 1, 0, 3)) * 4
    rdm2.abab.voov = np.copy(np.transpose(tmp41, (2, 1, 0, 3))) * 2
    del tmp41
    rdm2.abab.voov += np.transpose(tmp39, (2, 1, 0, 3)) * 2
    del tmp39
    rdm2.aaaa.voov = einsum(delta.aa.oo, (0, 1), tmp24, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.aaaa.voov += np.transpose(tmp20, (2, 1, 0, 3)) * 4
    rdm2.aaaa.voov += np.transpose(tmp30, (2, 1, 0, 3))
    rdm2.bbbb.ovvo = einsum(tmp27, (0, 1), delta.bb.oo, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.bbbb.ovvo += np.transpose(tmp43, (1, 2, 3, 0))
    rdm2.bbbb.ovvo += np.transpose(tmp37, (1, 2, 3, 0)) * 4
    rdm2.abab.ovvo = np.copy(np.transpose(tmp18, (0, 3, 2, 1))) * 2
    del tmp18
    rdm2.abab.ovvo += np.transpose(tmp22, (0, 3, 2, 1)) * 2
    del tmp22
    rdm2.aaaa.ovvo = einsum(delta.aa.oo, (0, 1), tmp15, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.ovvo += np.transpose(tmp20, (1, 2, 3, 0)) * 4
    rdm2.aaaa.ovvo += np.transpose(tmp30, (1, 2, 3, 0))
    rdm2.bbbb.ovov = einsum(delta.bb.oo, (0, 1), tmp33, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.ovov += np.transpose(tmp43, (1, 2, 0, 3)) * -1
    del tmp43
    rdm2.bbbb.ovov += np.transpose(tmp37, (1, 2, 0, 3)) * -4
    del tmp37
    rdm2.abab.ovov = einsum(delta.aa.oo, (0, 1), tmp33, (2, 3), (0, 2, 1, 3))
    rdm2.abab.ovov += np.transpose(tmp29, (1, 2, 0, 3)) * -1
    rdm2.aaaa.ovov = einsum(delta.aa.oo, (0, 1), tmp24, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.aaaa.ovov += np.transpose(tmp20, (1, 2, 0, 3)) * -4
    del tmp20
    rdm2.aaaa.ovov += np.transpose(tmp30, (1, 2, 0, 3)) * -1
    del tmp30
    rdm2.bbbb.oovv = np.copy(t2.bbbb) * 2
    rdm2.bbbb.oovv += einsum(t2.bbbb, (0, 1, 2, 3), tmp33, (3, 4), (0, 1, 2, 4)) * -2
    del tmp33
    rdm2.bbbb.oovv += np.transpose(tmp34, (0, 1, 3, 2))
    rdm2.bbbb.oovv += np.transpose(tmp35, (1, 0, 3, 2))
    rdm2.bbbb.oovv += np.transpose(tmp35, (0, 1, 3, 2)) * -1
    del tmp35
    rdm2.bbbb.oovv += np.transpose(tmp34, (1, 0, 3, 2)) * -1
    del tmp34
    rdm2.bbbb.oovv += np.transpose(tmp36, (0, 1, 3, 2)) * -2
    del tmp36
    rdm2.bbbb.oovv += np.transpose(tmp38, (0, 1, 3, 2)) * -8
    rdm2.bbbb.oovv += np.transpose(tmp40, (0, 1, 3, 2)) * -2
    rdm2.bbbb.oovv += np.transpose(tmp42, (0, 1, 3, 2)) * -2
    rdm2.bbbb.oovv += np.transpose(tmp42, (1, 0, 2, 3)) * -2
    rdm2.bbbb.oovv += tmp38 * 8
    del tmp38
    rdm2.bbbb.oovv += np.transpose(tmp40, (1, 0, 3, 2)) * 2
    del tmp40
    rdm2.bbbb.oovv += tmp42 * 2
    rdm2.bbbb.oovv += np.transpose(tmp42, (1, 0, 3, 2)) * 2
    del tmp42
    rdm2.bbbb.oovv += einsum(t2.bbbb, (0, 1, 2, 3), tmp27, (3, 4), (0, 1, 4, 2)) * 4
    rdm2.abab.oovv = np.copy(t2.abab)
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp27, (3, 4), (0, 1, 2, 4)) * -2
    del tmp27
    rdm2.abab.oovv += einsum(tmp3, (0, 1), t2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -1
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp28, (1, 4), (0, 4, 2, 3)) * -1
    del tmp28
    rdm2.abab.oovv += einsum(tmp9, (0, 1, 2, 3), t2.abab, (0, 2, 4, 5), (1, 3, 4, 5))
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp29, (0, 4, 3, 5), (4, 1, 2, 5))
    del tmp29
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp31, (0, 4, 2, 5), (4, 1, 5, 3))
    del tmp31
    rdm2.abab.oovv += einsum(t2.bbbb, (0, 1, 2, 3), tmp32, (4, 1, 5, 3), (4, 0, 5, 2)) * 4
    del tmp32
    rdm2.abab.oovv += einsum(tmp15, (0, 1), t2.abab, (2, 3, 0, 4), (2, 3, 1, 4)) * -1
    rdm2.aaaa.oovv = np.copy(t2.aaaa) * 2
    rdm2.aaaa.oovv += einsum(t2.aaaa, (0, 1, 2, 3), tmp15, (3, 4), (0, 1, 2, 4)) * -2
    del tmp15
    rdm2.aaaa.oovv += np.transpose(tmp16, (1, 0, 3, 2)) * 2
    rdm2.aaaa.oovv += np.transpose(tmp16, (0, 1, 3, 2)) * -2
    del tmp16
    rdm2.aaaa.oovv += np.transpose(tmp17, (0, 1, 3, 2)) * -2
    del tmp17
    rdm2.aaaa.oovv += np.transpose(tmp19, (0, 1, 3, 2)) * -2
    rdm2.aaaa.oovv += np.transpose(tmp21, (0, 1, 3, 2)) * -8
    rdm2.aaaa.oovv += np.transpose(tmp23, (0, 1, 3, 2)) * -2
    rdm2.aaaa.oovv += np.transpose(tmp23, (1, 0, 2, 3)) * -2
    rdm2.aaaa.oovv += tmp19 * 2
    del tmp19
    rdm2.aaaa.oovv += tmp21 * 8
    del tmp21
    rdm2.aaaa.oovv += tmp23 * 2
    rdm2.aaaa.oovv += np.transpose(tmp23, (1, 0, 3, 2)) * 2
    del tmp23
    rdm2.aaaa.oovv += einsum(t2.aaaa, (0, 1, 2, 3), tmp24, (3, 4), (0, 1, 4, 2)) * 4
    del tmp24
    rdm2.bbbb.oooo = einsum(delta.bb.oo, (0, 1), tmp10, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.bbbb.oooo += einsum(delta.bb.oo, (0, 1), tmp10, (2, 3), (3, 0, 1, 2))
    del tmp10
    rdm2.bbbb.oooo += einsum(tmp11, (0, 1), delta.bb.oo, (2, 3), (1, 2, 0, 3)) * -2
    rdm2.bbbb.oooo += einsum(tmp11, (0, 1), delta.bb.oo, (2, 3), (2, 1, 0, 3)) * 2
    del tmp11
    rdm2.bbbb.oooo += np.transpose(tmp12, (3, 2, 1, 0)) * 2
    del tmp12
    rdm2.abab.oooo = einsum(delta.aa.oo, (0, 1), tmp7, (2, 3), (0, 3, 1, 2)) * -2
    del tmp7
    rdm2.abab.oooo += einsum(delta.bb.oo, (0, 1), tmp8, (2, 3), (3, 0, 2, 1)) * -2
    del tmp8
    rdm2.abab.oooo += np.transpose(tmp9, (1, 3, 0, 2))
    del tmp9
    rdm2.aaaa.oooo = einsum(delta.aa.oo, (0, 1), tmp2, (2, 3), (0, 3, 1, 2)) * -2
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp2, (2, 3), (3, 0, 1, 2)) * 2
    del tmp2
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp3, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp3, (2, 3), (0, 3, 2, 1))
    del delta, tmp3
    rdm2.aaaa.oooo += np.transpose(tmp4, (3, 2, 1, 0)) * 2
    del tmp4
    rdm2.aaaa.ooov = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[0], t2.aaaa.shape[0], t2.aaaa.shape[-1]))
    rdm2.aaaa.oovo = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[0], t2.aaaa.shape[-1], t2.aaaa.shape[0]))
    rdm2.aaaa.ovoo = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[-1], t2.aaaa.shape[0], t2.aaaa.shape[0]))
    rdm2.aaaa.vooo = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[0], t2.aaaa.shape[0], t2.aaaa.shape[0]))
    rdm2.aaaa.ovvv = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[-1], t2.aaaa.shape[-1], t2.aaaa.shape[-1]))
    rdm2.aaaa.vovv = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[0], t2.aaaa.shape[-1], t2.aaaa.shape[-1]))
    rdm2.aaaa.vvov = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[-1], t2.aaaa.shape[0], t2.aaaa.shape[-1]))
    rdm2.aaaa.vvvo = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[-1], t2.aaaa.shape[-1], t2.aaaa.shape[0]))
    rdm2.aabb.ooov = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[0], t2.bbbb.shape[0], t2.bbbb.shape[-1]))
    rdm2.aabb.oovo = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[0], t2.bbbb.shape[-1], t2.bbbb.shape[0]))
    rdm2.aabb.ovoo = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[-1], t2.bbbb.shape[0], t2.bbbb.shape[0]))
    rdm2.aabb.vooo = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[0], t2.bbbb.shape[0], t2.bbbb.shape[0]))
    rdm2.aabb.ovvv = np.zeros((t2.aaaa.shape[0], t2.aaaa.shape[-1], t2.bbbb.shape[-1], t2.bbbb.shape[-1]))
    rdm2.aabb.vovv = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[0], t2.bbbb.shape[-1], t2.bbbb.shape[-1]))
    rdm2.aabb.vvov = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[-1], t2.bbbb.shape[0], t2.bbbb.shape[-1]))
    rdm2.aabb.vvvo = np.zeros((t2.aaaa.shape[-1], t2.aaaa.shape[-1], t2.bbbb.shape[-1], t2.bbbb.shape[0]))
    rdm2.bbaa.ooov = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[0], t2.aaaa.shape[0], t2.aaaa.shape[-1]))
    rdm2.bbaa.oovo = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[0], t2.aaaa.shape[-1], t2.aaaa.shape[0]))
    rdm2.bbaa.ovoo = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[-1], t2.aaaa.shape[0], t2.aaaa.shape[0]))
    rdm2.bbaa.vooo = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[0], t2.aaaa.shape[0], t2.aaaa.shape[0]))
    rdm2.bbaa.ovvv = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[-1], t2.aaaa.shape[-1], t2.aaaa.shape[-1]))
    rdm2.bbaa.vovv = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[0], t2.aaaa.shape[-1], t2.aaaa.shape[-1]))
    rdm2.bbaa.vvov = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[-1], t2.aaaa.shape[0], t2.aaaa.shape[-1]))
    rdm2.bbaa.vvvo = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[-1], t2.aaaa.shape[-1], t2.aaaa.shape[0]))
    rdm2.bbbb.ooov = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[0], t2.bbbb.shape[0], t2.bbbb.shape[-1]))
    rdm2.bbbb.oovo = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[0], t2.bbbb.shape[-1], t2.bbbb.shape[0]))
    rdm2.bbbb.ovoo = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[-1], t2.bbbb.shape[0], t2.bbbb.shape[0]))
    rdm2.bbbb.vooo = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[0], t2.bbbb.shape[0], t2.bbbb.shape[0]))
    rdm2.bbbb.ovvv = np.zeros((t2.bbbb.shape[0], t2.bbbb.shape[-1], t2.bbbb.shape[-1], t2.bbbb.shape[-1]))
    rdm2.bbbb.vovv = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[0], t2.bbbb.shape[-1], t2.bbbb.shape[-1]))
    rdm2.bbbb.vvov = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[-1], t2.bbbb.shape[0], t2.bbbb.shape[-1]))
    rdm2.bbbb.vvvo = np.zeros((t2.bbbb.shape[-1], t2.bbbb.shape[-1], t2.bbbb.shape[-1], t2.bbbb.shape[0]))
    rdm2.aaaa = pack_2e(rdm2.aaaa.oooo, rdm2.aaaa.ooov, rdm2.aaaa.oovo, rdm2.aaaa.ovoo, rdm2.aaaa.vooo, rdm2.aaaa.oovv, rdm2.aaaa.ovov, rdm2.aaaa.ovvo, rdm2.aaaa.voov, rdm2.aaaa.vovo, rdm2.aaaa.vvoo, rdm2.aaaa.ovvv, rdm2.aaaa.vovv, rdm2.aaaa.vvov, rdm2.aaaa.vvvo, rdm2.aaaa.vvvv)
    rdm2.abab = pack_2e(rdm2.abab.oooo, rdm2.abab.ooov, rdm2.abab.oovo, rdm2.abab.ovoo, rdm2.abab.vooo, rdm2.abab.oovv, rdm2.abab.ovov, rdm2.abab.ovvo, rdm2.abab.voov, rdm2.abab.vovo, rdm2.abab.vvoo, rdm2.abab.ovvv, rdm2.abab.vovv, rdm2.abab.vvov, rdm2.abab.vvvo, rdm2.abab.vvvv)
    rdm2.bbbb = pack_2e(rdm2.bbbb.oooo, rdm2.bbbb.ooov, rdm2.bbbb.oovo, rdm2.bbbb.ovoo, rdm2.bbbb.vooo, rdm2.bbbb.oovv, rdm2.bbbb.ovov, rdm2.bbbb.ovvo, rdm2.bbbb.voov, rdm2.bbbb.vovo, rdm2.bbbb.vvoo, rdm2.bbbb.ovvv, rdm2.bbbb.vovv, rdm2.bbbb.vvov, rdm2.bbbb.vvvo, rdm2.bbbb.vvvv)
    rdm2 = Namespace(
        aaaa=np.transpose(rdm2.aaaa, (0, 2, 1, 3)),
        aabb=np.transpose(rdm2.abab, (0, 2, 1, 3)),
        bbbb=np.transpose(rdm2.bbbb, (0, 2, 1, 3)),
    )

    return rdm2

def hbar_matvec_ip_intermediates(f=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:27:38.441351.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp101 : array
    tmp108 : array
    tmp111 : array
    tmp112 : array
    tmp114 : array
    tmp115 : array
    tmp116 : array
    tmp118 : array
    tmp12 : array
    tmp121 : array
    tmp125 : array
    tmp126 : array
    tmp127 : array
    tmp128 : array
    tmp129 : array
    tmp131 : array
    tmp133 : array
    tmp136 : array
    tmp139 : array
    tmp14 : array
    tmp142 : array
    tmp143 : array
    tmp148 : array
    tmp150 : array
    tmp153 : array
    tmp155 : array
    tmp157 : array
    tmp159 : array
    tmp16 : array
    tmp169 : array
    tmp17 : array
    tmp19 : array
    tmp20 : array
    tmp27 : array
    tmp28 : array
    tmp3 : array
    tmp30 : array
    tmp32 : array
    tmp33 : array
    tmp36 : array
    tmp37 : array
    tmp38 : array
    tmp40 : array
    tmp41 : array
    tmp42 : array
    tmp44 : array
    tmp46 : array
    tmp48 : array
    tmp5 : array
    tmp50 : array
    tmp52 : array
    tmp55 : array
    tmp56 : array
    tmp6 : array
    tmp61 : array
    tmp65 : array
    tmp69 : array
    tmp77 : array
    tmp79 : array
    tmp8 : array
    tmp81 : array
    tmp83 : array
    tmp84 : array
    tmp85 : array
    tmp9 : array
    tmp92 : array
    tmp93 : array
    tmp96 : array
    """

    tmp19 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (4, 1, 3))
    tmp16 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (0, 3, 4))
    tmp12 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp55 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp147 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp65 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp14 = einsum(v.baa.xov, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp32 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp1 = einsum(v.baa.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp107 = einsum(v.baa.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp3 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp5 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp8 = einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp76 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp29 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp169 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp159 = einsum(tmp19, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp157 = einsum(v.bbb.xoo, (0, 1, 2), tmp16, (0, 3, 4), (3, 1, 2, 4))
    tmp155 = einsum(t2.bbbb, (0, 1, 2, 3), tmp12, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp153 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp150 = einsum(tmp55, (0, 1, 2, 3), t2.bbbb, (4, 5, 3, 2), (4, 5, 1, 0))
    tmp148 = einsum(t2.bbbb, (0, 1, 2, 3), tmp147, (4, 5, 2, 3), (0, 1, 4, 5)) * -1
    del tmp147
    tmp143 = einsum(v.bbb.xvv, (0, 1, 2), tmp19, (0, 3, 2), (3, 1))
    tmp142 = einsum(tmp16, (0, 1, 2), v.bbb.xvv, (0, 3, 2), (1, 3)) * -1
    tmp139 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp136 = einsum(v.baa.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp133 = einsum(tmp65, (0, 1, 2, 3), t2.abab, (4, 1, 2, 5), (4, 0, 5, 3))
    tmp131 = einsum(tmp19, (0, 1, 2), v.bbb.xov, (0, 1, 3), (2, 3))
    tmp129 = einsum(v.bbb.xov, (0, 1, 2), tmp16, (0, 1, 3), (3, 2))
    tmp128 = einsum(tmp14, (0, 1, 2, 3), t2.abab, (4, 2, 3, 5), (4, 0, 1, 5))
    tmp127 = einsum(tmp14, (0, 1, 2, 3), t2.abab, (0, 2, 3, 4), (1, 4))
    tmp126 = einsum(t2.bbbb, (0, 1, 2, 3), tmp12, (4, 0, 1, 3), (4, 2))
    tmp125 = einsum(f.aa.ov, (0, 1), t2.abab, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp121 = einsum(t2.bbbb, (0, 1, 2, 3), tmp55, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp118 = einsum(t2.abab, (0, 1, 2, 3), tmp32, (0, 4, 5, 2), (4, 1, 5, 3))
    tmp116 = einsum(v.baa.xoo, (0, 1, 2), tmp16, (0, 3, 4), (1, 2, 3, 4))
    tmp115 = einsum(v.baa.xoo, (0, 1, 2), tmp19, (0, 3, 4), (1, 2, 3, 4))
    tmp114 = einsum(t2.abab, (0, 1, 2, 3), tmp1, (4, 0, 5, 2), (4, 5, 1, 3))
    tmp112 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp111 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (0, 2), (1, 3))
    tmp108 = einsum(t2.abab, (0, 1, 2, 3), tmp107, (4, 2, 5, 3), (0, 4, 1, 5))
    del tmp107
    tmp101 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp96 = einsum(t2.abab, (0, 1, 2, 3), tmp65, (0, 4, 5, 3), (1, 4, 2, 5))
    tmp93 = einsum(tmp3, (0, 1, 2, 3), t2.abab, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp92 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (4, 3), (0, 4, 1, 2))
    tmp85 = einsum(v.bbb.xoo, (0, 1, 2), tmp5, (0, 3, 4), (3, 1, 2, 4))
    tmp84 = einsum(v.bbb.xoo, (0, 1, 2), tmp8, (0, 3, 4), (3, 1, 2, 4))
    tmp83 = einsum(tmp12, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (4, 0, 2, 5))
    tmp81 = einsum(v.baa.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 2, 3, 4))
    tmp79 = einsum(t2.abab, (0, 1, 2, 3), tmp65, (4, 5, 2, 3), (0, 4, 1, 5))
    tmp77 = einsum(tmp76, (0, 1, 2, 3), t2.abab, (4, 5, 2, 3), (4, 5, 0, 1))
    del tmp76
    tmp69 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp61 = einsum(t2.aaaa, (0, 1, 2, 3), f.aa.ov, (4, 3), (4, 0, 1, 2))
    tmp56 = einsum(t2.abab, (0, 1, 2, 3), tmp55, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp52 = einsum(t2.aaaa, (0, 1, 2, 3), tmp32, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp50 = einsum(tmp8, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp48 = einsum(tmp5, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp46 = einsum(v.baa.xoo, (0, 1, 2), tmp8, (0, 3, 4), (3, 1, 2, 4))
    tmp44 = einsum(v.baa.xoo, (0, 1, 2), tmp5, (0, 3, 4), (3, 1, 2, 4))
    tmp42 = einsum(t2.aaaa, (0, 1, 2, 3), tmp1, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp41 = einsum(tmp3, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    tmp40 = einsum(t2.aaaa, (0, 1, 2, 3), tmp1, (4, 0, 1, 3), (4, 2))
    tmp38 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 1, 2, 4))
    tmp37 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp36 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp33 = einsum(tmp32, (0, 1, 2, 3), t2.aaaa, (4, 5, 3, 2), (4, 5, 1, 0))
    tmp30 = einsum(tmp29, (0, 1, 2, 3), t2.aaaa, (4, 5, 2, 3), (4, 5, 0, 1)) * -1
    del tmp29
    tmp28 = einsum(v.baa.xvv, (0, 1, 2), tmp8, (0, 3, 2), (3, 1))
    tmp27 = einsum(v.baa.xvv, (0, 1, 2), tmp5, (0, 3, 2), (3, 1)) * -1
    tmp20 = einsum(v.bbb.xov, (0, 1, 2), tmp19, (0, 3, 2), (3, 1))
    tmp17 = einsum(v.bbb.xov, (0, 1, 2), tmp16, (0, 3, 2), (3, 1))
    tmp9 = einsum(tmp8, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp6 = einsum(tmp5, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))

    return {f"tmp1": tmp1, f"tmp101": tmp101, f"tmp108": tmp108, f"tmp111": tmp111, f"tmp112": tmp112, f"tmp114": tmp114, f"tmp115": tmp115, f"tmp116": tmp116, f"tmp118": tmp118, f"tmp12": tmp12, f"tmp121": tmp121, f"tmp125": tmp125, f"tmp126": tmp126, f"tmp127": tmp127, f"tmp128": tmp128, f"tmp129": tmp129, f"tmp131": tmp131, f"tmp133": tmp133, f"tmp136": tmp136, f"tmp139": tmp139, f"tmp14": tmp14, f"tmp142": tmp142, f"tmp143": tmp143, f"tmp148": tmp148, f"tmp150": tmp150, f"tmp153": tmp153, f"tmp155": tmp155, f"tmp157": tmp157, f"tmp159": tmp159, f"tmp16": tmp16, f"tmp169": tmp169, f"tmp17": tmp17, f"tmp19": tmp19, f"tmp20": tmp20, f"tmp27": tmp27, f"tmp28": tmp28, f"tmp3": tmp3, f"tmp30": tmp30, f"tmp32": tmp32, f"tmp33": tmp33, f"tmp36": tmp36, f"tmp37": tmp37, f"tmp38": tmp38, f"tmp40": tmp40, f"tmp41": tmp41, f"tmp42": tmp42, f"tmp44": tmp44, f"tmp46": tmp46, f"tmp48": tmp48, f"tmp5": tmp5, f"tmp50": tmp50, f"tmp52": tmp52, f"tmp55": tmp55, f"tmp56": tmp56, f"tmp6": tmp6, f"tmp61": tmp61, f"tmp65": tmp65, f"tmp69": tmp69, f"tmp77": tmp77, f"tmp79": tmp79, f"tmp8": tmp8, f"tmp81": tmp81, f"tmp83": tmp83, f"tmp84": tmp84, f"tmp85": tmp85, f"tmp9": tmp9, f"tmp92": tmp92, f"tmp93": tmp93, f"tmp96": tmp96}

def hbar_matvec_ip(f=None, r1=None, r2=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:27:38.525467.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp3 = einsum(v.bbb.xov, (0, 1, 2), r2.bab, (1, 3, 2), (0, 3)) * -1
    tmp2 = einsum(r2.aaa, (0, 1, 2), v.baa.xov, (3, 1, 2), (3, 0))
    tmp52 = np.copy(ints.tmp159)
    del ints.tmp159
    tmp52 += ints.tmp157 * 2
    del ints.tmp157
    tmp39 = np.copy(ints.tmp139)
    del ints.tmp139
    tmp39 += ints.tmp121 * 2
    del ints.tmp121
    tmp31 = einsum(r2.aba, (0, 1, 2), v.baa.xov, (3, 0, 2), (3, 1))
    tmp50 = np.copy(ints.tmp19)
    tmp50 += ints.tmp16 * 2
    tmp32 = einsum(v.bbb.xov, (0, 1, 2), r2.bbb, (3, 1, 2), (0, 3))
    tmp59 = np.copy(ints.tmp17) * 2
    tmp59 += ints.tmp20
    tmp57 = np.copy(ints.tmp16)
    tmp57 += ints.tmp19 * 0.5
    tmp61 = np.copy(ints.tmp12)
    tmp61 += np.transpose(ints.tmp155, (0, 2, 1, 3)) * 2
    del ints.tmp155
    tmp14 = np.copy(ints.tmp69)
    tmp14 += ints.tmp52 * 2
    tmp18 = np.copy(ints.tmp46)
    del ints.tmp46
    tmp18 += ints.tmp44 * 2
    del ints.tmp44
    tmp16 = np.copy(tmp2) * 2
    tmp16 += tmp3
    tmp4 = np.copy(tmp2) * 2
    tmp4 += tmp3
    tmp5 = np.copy(ints.tmp5)
    tmp5 += ints.tmp8 * 0.5
    tmp7 = np.copy(ints.tmp6) * 2
    tmp7 += ints.tmp9
    tmp9 = np.copy(ints.tmp1)
    tmp9 += np.transpose(ints.tmp42, (0, 2, 1, 3)) * 2
    del ints.tmp42
    tmp53 = einsum(r1.b, (0,), tmp52, (1, 0, 2, 3), (1, 2, 3))
    del tmp52
    tmp49 = einsum(tmp39, (0, 1, 2, 3), r2.bbb, (4, 1, 3), (4, 0, 2)) * -1
    tmp51 = einsum(tmp31, (0, 1), tmp50, (0, 2, 3), (1, 2, 3))
    del tmp50
    tmp47 = einsum(r2.bbb, (0, 1, 2), f.bb.oo, (3, 1), (3, 0, 2))
    tmp48 = einsum(tmp32, (0, 1), v.bbb.xov, (0, 2, 3), (1, 2, 3))
    tmp60 = einsum(r2.bbb, (0, 1, 2), tmp59, (3, 1), (0, 3, 2)) * -2
    del tmp59
    tmp58 = einsum(tmp32, (0, 1), tmp57, (0, 2, 3), (1, 2, 3)) * 4
    del tmp57
    tmp55 = einsum(r2.aba, (0, 1, 2), ints.tmp118, (0, 3, 2, 4), (3, 1, 4))
    tmp62 = einsum(r1.b, (0,), tmp61, (1, 0, 2, 3), (1, 2, 3))
    del tmp61
    tmp56 = einsum(v.bbb.xov, (0, 1, 2), tmp31, (0, 3), (3, 1, 2))
    tmp36 = einsum(ints.tmp55, (0, 1, 2, 3), r2.bbb, (1, 0, 2), (3,)) * -1
    del ints.tmp55
    tmp35 = einsum(r2.aba, (0, 1, 2), ints.tmp65, (0, 1, 2, 3), (3,))
    tmp23 = einsum(ints.tmp32, (0, 1, 2, 3), r2.aaa, (0, 1, 2), (3,))
    del ints.tmp32
    tmp24 = einsum(ints.tmp65, (0, 1, 2, 3), r2.bab, (1, 0, 3), (2,)) * -1
    del ints.tmp65
    tmp13 = einsum(ints.tmp56, (0, 1, 2, 3), r2.bab, (1, 4, 3), (0, 4, 2)) * -1
    tmp15 = einsum(tmp14, (0, 1, 2, 3), r2.aaa, (4, 1, 3), (4, 0, 2)) * -1
    del tmp14
    tmp19 = einsum(r1.a, (0,), tmp18, (1, 0, 2, 3), (1, 2, 3))
    del tmp18
    tmp17 = einsum(tmp16, (0, 1), v.baa.xov, (0, 2, 3), (2, 1, 3))
    del tmp16
    tmp12 = einsum(f.aa.oo, (0, 1), r2.aaa, (2, 1, 3), (0, 2, 3))
    tmp6 = einsum(tmp4, (0, 1), tmp5, (0, 2, 3), (1, 2, 3)) * 2
    del tmp4, tmp5
    tmp8 = einsum(r2.aaa, (0, 1, 2), tmp7, (3, 1), (0, 3, 2)) * -2
    del tmp7
    tmp10 = einsum(r1.a, (0,), tmp9, (1, 0, 2, 3), (1, 2, 3))
    del tmp9
    tmp54 = np.copy(tmp47) * 2
    del tmp47
    tmp54 += tmp48 * 2
    del tmp48
    tmp54 += np.transpose(tmp49, (1, 0, 2)) * -2
    del tmp49
    tmp54 += np.transpose(tmp51, (1, 0, 2))
    del tmp51
    tmp54 += tmp53
    del tmp53
    tmp63 = np.copy(tmp55)
    del tmp55
    tmp63 += tmp56
    del tmp56
    tmp63 += np.transpose(tmp58, (1, 0, 2))
    del tmp58
    tmp63 += np.transpose(tmp60, (1, 0, 2))
    del tmp60
    tmp63 += tmp62
    del tmp62
    tmp46 = np.copy(f.bb.ov)
    tmp46 += ints.tmp111
    del ints.tmp111
    tmp46 += ints.tmp112 * 2
    del ints.tmp112
    tmp46 += ints.tmp143
    del ints.tmp143
    tmp46 += ints.tmp126 * -2
    del ints.tmp126
    tmp46 += ints.tmp127 * -1
    del ints.tmp127
    tmp46 += ints.tmp142 * -2
    del ints.tmp142
    tmp44 = np.copy(np.transpose(ints.tmp129, (1, 0))) * 2
    del ints.tmp129
    tmp44 += np.transpose(ints.tmp131, (1, 0))
    del ints.tmp131
    tmp44 += f.bb.vv * -1
    tmp65 = np.copy(ints.tmp148)
    del ints.tmp148
    tmp65 += np.transpose(ints.tmp169, (1, 2, 0, 3)) * -1
    del ints.tmp169
    tmp37 = np.copy(tmp35) * 0.5
    del tmp35
    tmp37 += tmp36
    del tmp36
    tmp64 = np.copy(ints.tmp150)
    del ints.tmp150
    tmp64 += np.transpose(ints.tmp153, (0, 2, 1, 3)) * -1
    del ints.tmp153
    tmp25 = np.copy(tmp23) * 2
    del tmp23
    tmp25 += tmp24 * -1
    del tmp24
    tmp42 = np.copy(tmp2)
    del tmp2
    tmp42 += tmp3 * 0.5
    del tmp3
    tmp40 = np.copy(ints.tmp133)
    del ints.tmp133
    tmp40 += ints.tmp136 * -1
    del ints.tmp136
    tmp1 = np.copy(f.bb.oo)
    tmp1 += np.transpose(ints.tmp17, (1, 0)) * 2
    del ints.tmp17
    tmp1 += np.transpose(ints.tmp20, (1, 0))
    del ints.tmp20
    tmp41 = np.copy(ints.tmp79)
    tmp41 += ints.tmp81
    tmp43 = np.copy(ints.tmp16) * 2
    del ints.tmp16
    tmp43 += ints.tmp19
    del ints.tmp19
    tmp43 += v.bbb.xov
    tmp0 = np.copy(f.aa.oo)
    tmp0 += np.transpose(ints.tmp6, (1, 0)) * 2
    del ints.tmp6
    tmp0 += np.transpose(ints.tmp9, (1, 0))
    del ints.tmp9
    tmp45 = np.copy(ints.tmp108)
    del ints.tmp108
    tmp45 += np.transpose(ints.tmp115, (1, 0, 2, 3))
    del ints.tmp115
    tmp45 += np.transpose(ints.tmp116, (1, 0, 2, 3)) * 2
    del ints.tmp116
    tmp45 += np.transpose(ints.tmp125, (1, 0, 2, 3))
    del ints.tmp125
    tmp45 += ints.tmp3
    tmp45 += ints.tmp114 * -1
    del ints.tmp114
    tmp45 += ints.tmp128 * -1
    del ints.tmp128
    tmp27 = np.copy(f.aa.ov)
    tmp27 += ints.tmp28
    del ints.tmp28
    tmp27 += ints.tmp36 * 2
    del ints.tmp36
    tmp27 += ints.tmp37
    del ints.tmp37
    tmp27 += ints.tmp27 * -2
    del ints.tmp27
    tmp27 += ints.tmp40 * -2
    del ints.tmp40
    tmp27 += ints.tmp41 * -1
    del ints.tmp41
    tmp28 = np.copy(ints.tmp52) * 2
    del ints.tmp52
    tmp28 += ints.tmp69
    del ints.tmp69
    tmp30 = np.copy(ints.tmp79)
    del ints.tmp79
    tmp30 += ints.tmp81
    del ints.tmp81
    tmp34 = np.copy(ints.tmp5) * 2
    del ints.tmp5
    tmp34 += ints.tmp8
    del ints.tmp8
    tmp34 += v.baa.xov
    tmp29 = np.copy(ints.tmp101)
    del ints.tmp101
    tmp29 += ints.tmp96 * -1
    del ints.tmp96
    tmp38 = np.copy(ints.tmp14)
    tmp38 += ints.tmp77
    del ints.tmp77
    tmp38 += np.transpose(ints.tmp84, (0, 2, 1, 3))
    del ints.tmp84
    tmp38 += np.transpose(ints.tmp85, (0, 2, 1, 3)) * 2
    del ints.tmp85
    tmp38 += np.transpose(ints.tmp92, (0, 2, 1, 3))
    del ints.tmp92
    tmp38 += ints.tmp83 * -1
    del ints.tmp83
    tmp38 += ints.tmp93 * -1
    del ints.tmp93
    tmp22 = np.copy(np.transpose(ints.tmp48, (1, 0))) * 2
    del ints.tmp48
    tmp22 += np.transpose(ints.tmp50, (1, 0))
    del ints.tmp50
    tmp22 += f.aa.vv * -1
    tmp33 = np.copy(tmp31) * -0.5
    del tmp31
    tmp33 += tmp32
    del tmp32
    tmp21 = np.copy(ints.tmp33)
    del ints.tmp33
    tmp21 += np.transpose(ints.tmp38, (0, 2, 1, 3)) * -1
    del ints.tmp38
    tmp26 = np.copy(ints.tmp30)
    del ints.tmp30
    tmp26 += np.transpose(ints.tmp61, (1, 2, 0, 3)) * -1
    del ints.tmp61
    tmp20 = np.copy(tmp12) * 2
    del tmp12
    tmp20 += tmp13
    del tmp13
    tmp20 += np.transpose(tmp15, (1, 0, 2)) * -2
    del tmp15
    tmp20 += np.transpose(tmp17, (1, 0, 2))
    del tmp17
    tmp20 += tmp19
    del tmp19
    tmp11 = np.copy(np.transpose(tmp6, (1, 0, 2)))
    del tmp6
    tmp11 += np.transpose(tmp8, (1, 0, 2))
    del tmp8
    tmp11 += tmp10
    del tmp10
    r2new.bbb = np.copy(tmp54)
    r2new.bbb += np.transpose(tmp54, (1, 0, 2)) * -1
    del tmp54
    r2new.bbb += tmp63 * -1
    r2new.bbb += np.transpose(tmp63, (1, 0, 2))
    del tmp63
    r2new.bbb += einsum(tmp64, (0, 1, 2, 3), r2.bbb, (3, 2, 4), (0, 1, 4)) * -2
    del tmp64
    r2new.bbb += einsum(tmp44, (0, 1), r2.bbb, (2, 3, 0), (2, 3, 1)) * -2
    r2new.bbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp37, (3,), (0, 1, 2)) * -4
    r2new.bbb += einsum(r1.b, (0,), tmp65, (1, 2, 0, 3), (2, 1, 3)) * 2
    del tmp65
    r2new.bbb += einsum(r1.b, (0,), tmp46, (1, 2), (0, 1, 2))
    r2new.bbb += einsum(tmp46, (0, 1), r1.b, (2,), (0, 2, 1)) * -1
    r2new.bab = einsum(r2.aaa, (0, 1, 2), ints.tmp118, (1, 3, 2, 4), (3, 0, 4)) * 2
    del ints.tmp118
    r2new.bab += einsum(tmp39, (0, 1, 2, 3), r2.bab, (1, 4, 3), (0, 4, 2)) * -1
    del tmp39
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp40, (3, 1, 4, 2), (0, 3, 4))
    del tmp40
    r2new.bab += einsum(tmp41, (0, 1, 2, 3), r2.bab, (3, 1, 4), (2, 0, 4))
    del tmp41
    r2new.bab += einsum(tmp43, (0, 1, 2), tmp42, (0, 3), (1, 3, 2)) * -2
    del tmp43, tmp42
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp44, (2, 3), (0, 1, 3)) * -1
    del tmp44
    r2new.bab += einsum(tmp25, (0,), t2.abab, (1, 2, 0, 3), (2, 1, 3)) * -1
    r2new.bab += einsum(r1.a, (0,), tmp45, (1, 0, 2, 3), (2, 1, 3))
    del tmp45
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp0, (1, 3), (0, 3, 2)) * -1
    r2new.bab += einsum(tmp1, (0, 1), r2.bab, (0, 2, 3), (1, 2, 3)) * -1
    r2new.bab += einsum(tmp46, (0, 1), r1.a, (2,), (0, 2, 1)) * -1
    del tmp46
    r2new.aba = einsum(r2.bbb, (0, 1, 2), ints.tmp56, (3, 1, 4, 2), (3, 0, 4)) * 2
    del ints.tmp56
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp28, (3, 0, 4, 2), (3, 1, 4)) * -1
    del tmp28
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp29, (3, 1, 4, 2), (0, 3, 4)) * -1
    del tmp29
    r2new.aba += einsum(tmp30, (0, 1, 2, 3), r2.aba, (1, 3, 4), (0, 2, 4))
    del tmp30
    r2new.aba += einsum(tmp33, (0, 1), tmp34, (0, 2, 3), (2, 1, 3)) * -2
    del tmp33, tmp34
    r2new.aba += einsum(tmp22, (0, 1), r2.aba, (2, 3, 0), (2, 3, 1)) * -1
    r2new.aba += einsum(t2.abab, (0, 1, 2, 3), tmp37, (3,), (0, 1, 2)) * -2
    del tmp37
    r2new.aba += einsum(r1.b, (0,), tmp38, (1, 2, 0, 3), (1, 2, 3))
    del tmp38
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp0, (0, 3), (3, 1, 2)) * -1
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp1, (1, 3), (0, 3, 2)) * -1
    r2new.aba += einsum(tmp27, (0, 1), r1.b, (2,), (0, 2, 1)) * -1
    r2new.aaa = np.copy(tmp11) * -1
    r2new.aaa += np.transpose(tmp11, (1, 0, 2))
    del tmp11
    r2new.aaa += tmp20
    r2new.aaa += np.transpose(tmp20, (1, 0, 2)) * -1
    del tmp20
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp21, (3, 4, 1, 0), (3, 4, 2)) * -2
    del tmp21
    r2new.aaa += einsum(tmp22, (0, 1), r2.aaa, (2, 3, 0), (2, 3, 1)) * -2
    del tmp22
    r2new.aaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp25, (3,), (0, 1, 2)) * -2
    del tmp25
    r2new.aaa += einsum(r1.a, (0,), tmp26, (1, 2, 0, 3), (2, 1, 3)) * 2
    del tmp26
    r2new.aaa += einsum(tmp27, (0, 1), r1.a, (2,), (2, 0, 1))
    r2new.aaa += einsum(tmp27, (0, 1), r1.a, (2,), (0, 2, 1)) * -1
    del tmp27
    r1new.b = einsum(r2.aba, (0, 1, 2), f.aa.ov, (0, 2), (1,)) * -1
    r1new.b += einsum(f.bb.ov, (0, 1), r2.bbb, (2, 0, 1), (2,)) * 2
    r1new.b += einsum(r2.bbb, (0, 1, 2), ints.tmp12, (3, 1, 0, 2), (3,)) * 2
    del ints.tmp12
    r1new.b += einsum(r2.aba, (0, 1, 2), ints.tmp14, (0, 3, 1, 2), (3,))
    del ints.tmp14
    r1new.b += einsum(r1.b, (0,), tmp1, (0, 1), (1,)) * -1
    del tmp1
    r1new.a = einsum(r2.aaa, (0, 1, 2), f.aa.ov, (1, 2), (0,)) * 2
    r1new.a += einsum(r2.aaa, (0, 1, 2), ints.tmp1, (3, 1, 0, 2), (3,)) * 2
    del ints.tmp1
    r1new.a += einsum(f.bb.ov, (0, 1), r2.bab, (0, 2, 1), (2,)) * -1
    r1new.a += einsum(ints.tmp3, (0, 1, 2, 3), r2.bab, (2, 1, 3), (0,))
    del ints.tmp3
    r1new.a += einsum(r1.a, (0,), tmp0, (0, 1), (1,)) * -1
    del tmp0

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_matvec_ea_intermediates(f=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:28:48.043964.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp105 : array
    tmp107 : array
    tmp110 : array
    tmp111 : array
    tmp113 : array
    tmp12 : array
    tmp120 : array
    tmp121 : array
    tmp122 : array
    tmp124 : array
    tmp126 : array
    tmp127 : array
    tmp128 : array
    tmp129 : array
    tmp130 : array
    tmp134 : array
    tmp137 : array
    tmp14 : array
    tmp141 : array
    tmp143 : array
    tmp144 : array
    tmp148 : array
    tmp150 : array
    tmp152 : array
    tmp16 : array
    tmp165 : array
    tmp17 : array
    tmp172 : array
    tmp19 : array
    tmp20 : array
    tmp22 : array
    tmp23 : array
    tmp29 : array
    tmp3 : array
    tmp31 : array
    tmp33 : array
    tmp37 : array
    tmp38 : array
    tmp41 : array
    tmp42 : array
    tmp5 : array
    tmp50 : array
    tmp53 : array
    tmp55 : array
    tmp56 : array
    tmp6 : array
    tmp62 : array
    tmp66 : array
    tmp68 : array
    tmp69 : array
    tmp70 : array
    tmp72 : array
    tmp77 : array
    tmp8 : array
    tmp80 : array
    tmp82 : array
    tmp9 : array
    tmp90 : array
    tmp94 : array
    tmp95 : array
    tmp96 : array
    """

    tmp142 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp19 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (4, 1, 3))
    tmp12 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp16 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (0, 3, 4))
    tmp112 = einsum(v.baa.xov, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp41 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp37 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp1 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp62 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp14 = einsum(v.baa.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp5 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp8 = einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp54 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp3 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp52 = einsum(v.baa.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp172 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (3, 1, 2, 4))
    tmp165 = einsum(t2.bbbb, (0, 1, 2, 3), tmp142, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp152 = einsum(tmp19, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp150 = einsum(tmp12, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 2), (4, 5, 3, 1))
    tmp148 = einsum(tmp16, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp144 = einsum(tmp112, (0, 1, 2, 3), t2.abab, (0, 2, 3, 4), (1, 4))
    tmp143 = einsum(t2.bbbb, (0, 1, 2, 3), tmp142, (4, 0, 1, 3), (4, 2))
    del tmp142
    tmp141 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp137 = einsum(t2.bbbb, (0, 1, 2, 3), tmp41, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp134 = einsum(t2.abab, (0, 1, 2, 3), tmp37, (0, 4, 5, 2), (4, 1, 5, 3))
    tmp130 = einsum(tmp16, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp129 = einsum(tmp1, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (4, 3, 1, 5))
    tmp128 = einsum(tmp19, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp127 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp126 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (0, 2), (1, 3))
    tmp124 = einsum(v.bbb.xov, (0, 1, 2), tmp19, (0, 3, 2), (3, 1))
    tmp122 = einsum(v.bbb.xov, (0, 1, 2), tmp16, (0, 3, 2), (3, 1))
    tmp121 = einsum(v.bbb.xvv, (0, 1, 2), tmp19, (0, 3, 2), (3, 1))
    tmp120 = einsum(tmp16, (0, 1, 2), v.bbb.xvv, (0, 3, 2), (1, 3)) * -1
    tmp113 = einsum(t2.abab, (0, 1, 2, 3), tmp112, (0, 4, 1, 5), (4, 2, 5, 3))
    del tmp112
    tmp111 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp110 = einsum(t2.abab, (0, 1, 2, 3), tmp62, (0, 4, 5, 3), (1, 4, 2, 5))
    tmp107 = einsum(tmp14, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (4, 5, 1, 2))
    tmp105 = einsum(v.baa.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp96 = einsum(tmp5, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp95 = einsum(tmp12, (0, 1, 2, 3), t2.abab, (4, 0, 5, 2), (4, 5, 3, 1))
    tmp94 = einsum(tmp8, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp90 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp82 = einsum(tmp54, (0, 1, 2, 3), t2.abab, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp80 = einsum(t2.abab, (0, 1, 2, 3), tmp62, (4, 1, 2, 5), (0, 4, 3, 5))
    tmp77 = einsum(tmp3, (0, 1, 2, 3), t2.abab, (4, 0, 2, 5), (4, 1, 5, 3))
    tmp72 = einsum(tmp8, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp70 = einsum(tmp5, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp69 = einsum(v.baa.xvv, (0, 1, 2), tmp8, (0, 3, 2), (3, 1))
    tmp68 = einsum(v.baa.xvv, (0, 1, 2), tmp5, (0, 3, 2), (3, 1)) * -1
    tmp66 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp56 = einsum(t2.aaaa, (0, 1, 2, 3), tmp52, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp55 = einsum(tmp54, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    del tmp54
    tmp53 = einsum(t2.aaaa, (0, 1, 2, 3), tmp52, (4, 0, 1, 3), (4, 2))
    del tmp52
    tmp50 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp42 = einsum(t2.abab, (0, 1, 2, 3), tmp41, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp38 = einsum(t2.aaaa, (0, 1, 2, 3), tmp37, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp33 = einsum(v.baa.xvv, (0, 1, 2), tmp8, (0, 3, 4), (3, 4, 1, 2))
    tmp31 = einsum(tmp1, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (4, 5, 3, 1))
    tmp29 = einsum(v.baa.xvv, (0, 1, 2), tmp5, (0, 3, 4), (3, 4, 1, 2))
    tmp23 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp22 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp20 = einsum(tmp19, (0, 1, 2), v.bbb.xov, (0, 1, 3), (2, 3))
    tmp17 = einsum(v.bbb.xov, (0, 1, 2), tmp16, (0, 1, 3), (3, 2))
    tmp9 = einsum(tmp8, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp6 = einsum(tmp5, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))

    return {f"tmp1": tmp1, f"tmp105": tmp105, f"tmp107": tmp107, f"tmp110": tmp110, f"tmp111": tmp111, f"tmp113": tmp113, f"tmp12": tmp12, f"tmp120": tmp120, f"tmp121": tmp121, f"tmp122": tmp122, f"tmp124": tmp124, f"tmp126": tmp126, f"tmp127": tmp127, f"tmp128": tmp128, f"tmp129": tmp129, f"tmp130": tmp130, f"tmp134": tmp134, f"tmp137": tmp137, f"tmp14": tmp14, f"tmp141": tmp141, f"tmp143": tmp143, f"tmp144": tmp144, f"tmp148": tmp148, f"tmp150": tmp150, f"tmp152": tmp152, f"tmp16": tmp16, f"tmp165": tmp165, f"tmp17": tmp17, f"tmp172": tmp172, f"tmp19": tmp19, f"tmp20": tmp20, f"tmp22": tmp22, f"tmp23": tmp23, f"tmp29": tmp29, f"tmp3": tmp3, f"tmp31": tmp31, f"tmp33": tmp33, f"tmp37": tmp37, f"tmp38": tmp38, f"tmp41": tmp41, f"tmp42": tmp42, f"tmp5": tmp5, f"tmp50": tmp50, f"tmp53": tmp53, f"tmp55": tmp55, f"tmp56": tmp56, f"tmp6": tmp6, f"tmp62": tmp62, f"tmp66": tmp66, f"tmp68": tmp68, f"tmp69": tmp69, f"tmp70": tmp70, f"tmp72": tmp72, f"tmp77": tmp77, f"tmp8": tmp8, f"tmp80": tmp80, f"tmp82": tmp82, f"tmp9": tmp9, f"tmp90": tmp90, f"tmp94": tmp94, f"tmp95": tmp95, f"tmp96": tmp96}

def hbar_matvec_ea(f=None, r1=None, r2=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:28:48.122475.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp4 = einsum(v.bbb.xov, (0, 1, 2), r2.bab, (2, 3, 1), (0, 3)) * -1
    tmp3 = einsum(r2.aaa, (0, 1, 2), v.baa.xov, (3, 2, 1), (3, 0))
    tmp40 = np.copy(ints.tmp111)
    del ints.tmp111
    tmp40 += ints.tmp137 * 2
    del ints.tmp137
    tmp52 = np.copy(ints.tmp12)
    tmp52 += ints.tmp150 * 2
    del ints.tmp150
    tmp31 = einsum(r2.bbb, (0, 1, 2), v.bbb.xov, (3, 2, 1), (3, 0))
    tmp50 = np.copy(ints.tmp19)
    tmp50 += ints.tmp16 * 2
    tmp30 = einsum(v.baa.xov, (0, 1, 2), r2.aba, (2, 3, 1), (0, 3))
    tmp57 = np.copy(ints.tmp16) * 2
    tmp57 += ints.tmp19
    tmp60 = np.copy(ints.tmp148)
    del ints.tmp148
    tmp60 += ints.tmp152 * 0.5
    del ints.tmp152
    tmp44 = np.copy(np.transpose(ints.tmp17, (1, 0)))
    tmp44 += np.transpose(ints.tmp20, (1, 0)) * 0.5
    tmp44 += f.bb.vv * -0.5
    tmp14 = np.copy(ints.tmp50)
    tmp14 += ints.tmp38 * 2
    tmp16 = np.copy(tmp3) * 2
    tmp16 += tmp4
    tmp18 = np.copy(ints.tmp1)
    tmp18 += ints.tmp31 * 2
    del ints.tmp31
    tmp8 = np.copy(np.transpose(ints.tmp6, (1, 0)))
    tmp8 += np.transpose(ints.tmp9, (1, 0)) * 0.5
    tmp8 += f.aa.vv * -0.5
    tmp6 = np.copy(ints.tmp5) * 2
    tmp6 += ints.tmp8
    tmp5 = np.copy(tmp3)
    del tmp3
    tmp5 += tmp4 * 0.5
    del tmp4
    tmp10 = np.copy(ints.tmp29)
    del ints.tmp29
    tmp10 += ints.tmp33 * 0.5
    del ints.tmp33
    tmp49 = einsum(r2.bbb, (0, 1, 2), tmp40, (3, 2, 4, 1), (3, 0, 4)) * -1
    tmp53 = einsum(tmp52, (0, 1, 2, 3), r1.b, (2,), (0, 1, 3))
    del tmp52
    tmp48 = einsum(tmp31, (0, 1), v.bbb.xov, (0, 2, 3), (2, 1, 3))
    tmp51 = einsum(tmp50, (0, 1, 2), tmp30, (0, 3), (1, 3, 2))
    del tmp50
    tmp37 = einsum(r2.bbb, (0, 1, 2), ints.tmp41, (2, 3, 1, 0), (3,)) * -1
    tmp36 = einsum(ints.tmp62, (0, 1, 2, 3), r2.aba, (2, 3, 0), (1,))
    tmp35 = einsum(f.bb.ov, (0, 1), r1.b, (1,), (0,))
    tmp58 = einsum(tmp31, (0, 1), tmp57, (0, 2, 3), (2, 1, 3)) * 2
    del tmp57
    tmp55 = einsum(r2.aba, (0, 1, 2), ints.tmp134, (2, 3, 0, 4), (3, 4, 1))
    tmp61 = einsum(tmp60, (0, 1, 2, 3), r1.b, (2,), (0, 1, 3)) * 2
    del tmp60
    tmp56 = einsum(tmp30, (0, 1), v.bbb.xov, (0, 2, 3), (2, 1, 3))
    tmp59 = einsum(r2.bbb, (0, 1, 2), tmp44, (1, 3), (2, 0, 3)) * -4
    tmp22 = einsum(r2.aaa, (0, 1, 2), ints.tmp37, (2, 3, 1, 0), (3,)) * -1
    tmp23 = einsum(ints.tmp62, (0, 1, 2, 3), r2.bab, (3, 2, 1), (0,)) * -1
    tmp21 = einsum(f.aa.ov, (0, 1), r1.a, (1,), (0,))
    tmp15 = einsum(r2.aaa, (0, 1, 2), tmp14, (3, 2, 4, 1), (3, 0, 4)) * -1
    del tmp14
    tmp17 = einsum(tmp16, (0, 1), v.baa.xov, (0, 2, 3), (2, 3, 1))
    del tmp16
    tmp13 = einsum(r2.bab, (0, 1, 2), ints.tmp42, (3, 2, 4, 0), (3, 4, 1)) * -1
    tmp19 = einsum(r1.a, (0,), tmp18, (1, 2, 0, 3), (1, 2, 3))
    del tmp18
    tmp9 = einsum(tmp8, (0, 1), r2.aaa, (2, 0, 3), (3, 2, 1)) * -4
    del tmp8
    tmp7 = einsum(tmp6, (0, 1, 2), tmp5, (0, 3), (1, 2, 3)) * 2
    del tmp6
    tmp11 = einsum(r1.a, (0,), tmp10, (1, 2, 0, 3), (1, 2, 3)) * 2
    del tmp10
    tmp54 = np.copy(tmp48) * 2
    del tmp48
    tmp54 += np.transpose(tmp49, (0, 2, 1)) * -2
    del tmp49
    tmp54 += np.transpose(tmp51, (0, 2, 1))
    del tmp51
    tmp54 += tmp53
    del tmp53
    tmp47 = einsum(r2.bbb, (0, 1, 2), ints.tmp41, (3, 4, 0, 1), (3, 4, 2))
    del ints.tmp41
    tmp38 = np.copy(tmp35) * -1
    del tmp35
    tmp38 += tmp36
    del tmp36
    tmp38 += tmp37 * 2
    del tmp37
    tmp46 = np.copy(f.bb.ov)
    tmp46 += ints.tmp121
    del ints.tmp121
    tmp46 += ints.tmp126
    del ints.tmp126
    tmp46 += ints.tmp127 * 2
    del ints.tmp127
    tmp46 += ints.tmp120 * -2
    del ints.tmp120
    tmp46 += ints.tmp143 * -2
    del ints.tmp143
    tmp46 += ints.tmp144 * -1
    del ints.tmp144
    tmp62 = np.copy(tmp55)
    del tmp55
    tmp62 += tmp56
    del tmp56
    tmp62 += np.transpose(tmp58, (0, 2, 1))
    del tmp58
    tmp62 += np.transpose(tmp59, (0, 2, 1))
    del tmp59
    tmp62 += tmp61
    del tmp61
    tmp45 = np.copy(f.bb.oo)
    tmp45 += np.transpose(ints.tmp122, (1, 0)) * 2
    del ints.tmp122
    tmp45 += np.transpose(ints.tmp124, (1, 0))
    del ints.tmp124
    tmp24 = np.copy(tmp21)
    del tmp21
    tmp24 += tmp22 * -2
    del tmp22
    tmp24 += tmp23
    del tmp23
    tmp42 = np.copy(ints.tmp16) * 2
    del ints.tmp16
    tmp42 += ints.tmp19
    del ints.tmp19
    tmp42 += v.bbb.xov
    tmp43 = np.copy(ints.tmp113)
    del ints.tmp113
    tmp43 += np.transpose(ints.tmp128, (0, 2, 1, 3))
    del ints.tmp128
    tmp43 += np.transpose(ints.tmp130, (0, 2, 1, 3)) * 2
    del ints.tmp130
    tmp43 += ints.tmp3
    tmp43 += ints.tmp107 * -1
    del ints.tmp107
    tmp43 += np.transpose(ints.tmp129, (0, 2, 1, 3)) * -1
    del ints.tmp129
    tmp41 = np.copy(ints.tmp110)
    del ints.tmp110
    tmp41 += ints.tmp141 * -1
    del ints.tmp141
    tmp0 = np.copy(np.transpose(ints.tmp6, (1, 0))) * 2
    del ints.tmp6
    tmp0 += np.transpose(ints.tmp9, (1, 0))
    del ints.tmp9
    tmp0 += f.aa.vv * -1
    tmp39 = einsum(r2.bab, (0, 1, 2), ints.tmp62, (3, 4, 1, 0), (3, 4, 2)) * -1
    tmp27 = einsum(ints.tmp62, (0, 1, 2, 3), r2.aba, (2, 3, 4), (0, 4, 1))
    del ints.tmp62
    tmp33 = np.copy(ints.tmp5) * 2
    del ints.tmp5
    tmp33 += ints.tmp8
    del ints.tmp8
    tmp33 += v.baa.xov
    tmp1 = np.copy(np.transpose(ints.tmp17, (1, 0))) * 2
    del ints.tmp17
    tmp1 += np.transpose(ints.tmp20, (1, 0))
    del ints.tmp20
    tmp1 += f.bb.vv * -1
    tmp26 = np.copy(f.aa.ov)
    tmp26 += ints.tmp22 * 2
    del ints.tmp22
    tmp26 += ints.tmp23
    del ints.tmp23
    tmp26 += ints.tmp69
    del ints.tmp69
    tmp26 += ints.tmp53 * -2
    del ints.tmp53
    tmp26 += ints.tmp55 * -1
    del ints.tmp55
    tmp26 += ints.tmp68 * -2
    del ints.tmp68
    tmp25 = np.copy(f.aa.oo)
    tmp25 += np.transpose(ints.tmp70, (1, 0)) * 2
    del ints.tmp70
    tmp25 += np.transpose(ints.tmp72, (1, 0))
    del ints.tmp72
    tmp34 = np.copy(ints.tmp14)
    tmp34 += ints.tmp82
    del ints.tmp82
    tmp34 += np.transpose(ints.tmp94, (0, 1, 3, 2))
    del ints.tmp94
    tmp34 += np.transpose(ints.tmp96, (0, 1, 3, 2)) * 2
    del ints.tmp96
    tmp34 += ints.tmp77 * -1
    del ints.tmp77
    tmp34 += np.transpose(ints.tmp95, (0, 1, 3, 2)) * -1
    del ints.tmp95
    tmp29 = np.copy(ints.tmp105)
    del ints.tmp105
    tmp29 += ints.tmp80 * -1
    del ints.tmp80
    tmp28 = np.copy(ints.tmp38) * 2
    del ints.tmp38
    tmp28 += ints.tmp50
    del ints.tmp50
    tmp32 = np.copy(tmp30) * -0.5
    del tmp30
    tmp32 += tmp31
    del tmp31
    tmp2 = einsum(r2.aaa, (0, 1, 2), ints.tmp37, (3, 4, 1, 0), (3, 4, 2)) * -1
    del ints.tmp37
    tmp20 = np.copy(tmp13)
    del tmp13
    tmp20 += np.transpose(tmp15, (0, 2, 1)) * -2
    del tmp15
    tmp20 += np.transpose(tmp17, (0, 2, 1))
    del tmp17
    tmp20 += tmp19
    del tmp19
    tmp12 = np.copy(tmp7)
    del tmp7
    tmp12 += np.transpose(tmp9, (0, 2, 1))
    del tmp9
    tmp12 += tmp11
    del tmp11
    r2new.bbb = einsum(ints.tmp165, (0, 1, 2, 3), r1.b, (3,), (2, 1, 0)) * 2
    del ints.tmp165
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), ints.tmp172, (3, 0, 4, 1), (3, 4, 2)) * -2
    del ints.tmp172
    r2new.bbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp47, (1, 0, 4), (2, 3, 4)) * -2
    del tmp47
    r2new.bbb += np.transpose(tmp54, (1, 2, 0))
    r2new.bbb += np.transpose(tmp54, (2, 1, 0)) * -1
    del tmp54
    r2new.bbb += np.transpose(tmp62, (1, 2, 0)) * -1
    r2new.bbb += np.transpose(tmp62, (2, 1, 0))
    del tmp62
    r2new.bbb += einsum(tmp38, (0,), t2.bbbb, (1, 0, 2, 3), (2, 3, 1)) * -2
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp45, (2, 3), (0, 1, 3)) * -2
    r2new.bbb += einsum(tmp46, (0, 1), r1.b, (2,), (2, 1, 0))
    r2new.bbb += einsum(tmp46, (0, 1), r1.b, (2,), (1, 2, 0)) * -1
    r2new.bab = einsum(ints.tmp134, (0, 1, 2, 3), r2.aaa, (4, 2, 0), (3, 4, 1)) * 2
    del ints.tmp134
    r2new.bab += einsum(t2.abab, (0, 1, 2, 3), tmp39, (0, 1, 4), (3, 2, 4)) * -1
    del tmp39
    r2new.bab += einsum(r2.bab, (0, 1, 2), ints.tmp90, (3, 1, 4, 0), (4, 3, 2))
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp40, (3, 2, 4, 0), (4, 1, 3)) * -1
    del tmp40
    r2new.bab += einsum(tmp41, (0, 1, 2, 3), r2.bab, (4, 3, 1), (4, 2, 0))
    del tmp41
    r2new.bab += einsum(tmp42, (0, 1, 2), tmp5, (0, 3), (2, 3, 1)) * -2
    del tmp5, tmp42
    r2new.bab += einsum(r1.a, (0,), tmp43, (1, 2, 0, 3), (3, 2, 1)) * -1
    del tmp43
    r2new.bab += einsum(tmp44, (0, 1), r2.bab, (0, 2, 3), (1, 2, 3)) * -2
    del tmp44
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp0, (1, 3), (0, 3, 2)) * -1
    r2new.bab += einsum(tmp24, (0,), t2.abab, (0, 1, 2, 3), (3, 2, 1))
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp45, (2, 3), (0, 1, 3)) * -1
    del tmp45
    r2new.bab += einsum(tmp46, (0, 1), r1.a, (2,), (1, 2, 0)) * -1
    del tmp46
    r2new.aba = einsum(ints.tmp42, (0, 1, 2, 3), r2.bbb, (4, 3, 1), (2, 4, 0)) * 2
    del ints.tmp42
    r2new.aba += einsum(tmp27, (0, 1, 2), t2.abab, (0, 2, 3, 4), (3, 4, 1))
    del tmp27
    r2new.aba += einsum(ints.tmp90, (0, 1, 2, 3), r2.aba, (1, 3, 4), (0, 2, 4))
    del ints.tmp90
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp28, (3, 2, 4, 0), (4, 1, 3)) * -1
    del tmp28
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp29, (3, 2, 4, 1), (0, 4, 3)) * -1
    del tmp29
    r2new.aba += einsum(tmp33, (0, 1, 2), tmp32, (0, 3), (2, 3, 1)) * -2
    del tmp33, tmp32
    r2new.aba += einsum(r1.b, (0,), tmp34, (1, 2, 3, 0), (2, 3, 1)) * -1
    del tmp34
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp0, (0, 3), (3, 1, 2)) * -1
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp1, (1, 3), (0, 3, 2)) * -1
    r2new.aba += einsum(tmp38, (0,), t2.abab, (1, 0, 2, 3), (2, 3, 1)) * -1
    del tmp38
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp25, (2, 3), (0, 1, 3)) * -1
    r2new.aba += einsum(tmp26, (0, 1), r1.b, (2,), (1, 2, 0)) * -1
    r2new.aaa = einsum(t2.aaaa, (0, 1, 2, 3), tmp2, (0, 1, 4), (2, 3, 4)) * 2
    del tmp2
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), ints.tmp66, (3, 1, 4, 0), (3, 4, 2)) * 2
    del ints.tmp66
    r2new.aaa += einsum(r1.a, (0,), ints.tmp56, (1, 2, 3, 0), (3, 2, 1)) * 2
    del ints.tmp56
    r2new.aaa += np.transpose(tmp12, (1, 2, 0)) * -1
    r2new.aaa += np.transpose(tmp12, (2, 1, 0))
    del tmp12
    r2new.aaa += np.transpose(tmp20, (1, 2, 0))
    r2new.aaa += np.transpose(tmp20, (2, 1, 0)) * -1
    del tmp20
    r2new.aaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp24, (1,), (2, 3, 0)) * 2
    del tmp24
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp25, (2, 3), (0, 1, 3)) * -2
    del tmp25
    r2new.aaa += einsum(r1.a, (0,), tmp26, (1, 2), (0, 2, 1))
    r2new.aaa += einsum(r1.a, (0,), tmp26, (1, 2), (2, 0, 1)) * -1
    del tmp26
    r1new.b = einsum(f.bb.ov, (0, 1), r2.bbb, (2, 1, 0), (2,)) * 2
    r1new.b += einsum(f.aa.ov, (0, 1), r2.aba, (1, 2, 0), (2,)) * -1
    r1new.b += einsum(ints.tmp12, (0, 1, 2, 3), r2.bbb, (3, 2, 0), (1,)) * -2
    del ints.tmp12
    r1new.b += einsum(ints.tmp14, (0, 1, 2, 3), r2.aba, (1, 3, 0), (2,)) * -1
    del ints.tmp14
    r1new.b += einsum(r1.b, (0,), tmp1, (0, 1), (1,)) * -1
    del tmp1
    r1new.a = einsum(r2.aaa, (0, 1, 2), f.aa.ov, (2, 1), (0,)) * 2
    r1new.a += einsum(r2.bab, (0, 1, 2), f.bb.ov, (2, 0), (1,)) * -1
    r1new.a += einsum(ints.tmp1, (0, 1, 2, 3), r2.aaa, (3, 2, 0), (1,)) * -2
    del ints.tmp1
    r1new.a += einsum(r2.bab, (0, 1, 2), ints.tmp3, (2, 3, 1, 0), (3,)) * -1
    del ints.tmp3
    r1new.a += einsum(r1.a, (0,), tmp0, (0, 1), (1,)) * -1
    del tmp0

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ip_intermediates(f=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:30:00.495801.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp10 : array
    tmp100 : array
    tmp104 : array
    tmp105 : array
    tmp107 : array
    tmp12 : array
    tmp125 : array
    tmp127 : array
    tmp130 : array
    tmp132 : array
    tmp14 : array
    tmp146 : array
    tmp153 : array
    tmp157 : array
    tmp16 : array
    tmp161 : array
    tmp162 : array
    tmp163 : array
    tmp165 : array
    tmp166 : array
    tmp168 : array
    tmp17 : array
    tmp181 : array
    tmp183 : array
    tmp185 : array
    tmp186 : array
    tmp19 : array
    tmp20 : array
    tmp202 : array
    tmp204 : array
    tmp22 : array
    tmp24 : array
    tmp25 : array
    tmp27 : array
    tmp28 : array
    tmp3 : array
    tmp30 : array
    tmp32 : array
    tmp34 : array
    tmp35 : array
    tmp37 : array
    tmp38 : array
    tmp39 : array
    tmp4 : array
    tmp40 : array
    tmp42 : array
    tmp43 : array
    tmp45 : array
    tmp47 : array
    tmp49 : array
    tmp51 : array
    tmp54 : array
    tmp57 : array
    tmp6 : array
    tmp63 : array
    tmp65 : array
    tmp69 : array
    tmp71 : array
    tmp77 : array
    tmp78 : array
    tmp8 : array
    tmp80 : array
    tmp81 : array
    tmp83 : array
    tmp84 : array
    tmp86 : array
    tmp93 : array
    tmp96 : array
    """

    tmp165 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp146 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp37 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (4, 1, 3))
    tmp42 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp19 = einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp16 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp104 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp95 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp92 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp14 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp24 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp56 = einsum(v.baa.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp53 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp27 = einsum(v.baa.xov, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp12 = einsum(v.baa.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp204 = einsum(t2.bbbb, (0, 1, 2, 3), tmp165, (4, 5, 3, 2), (0, 1, 4, 5)) * -1
    tmp202 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp186 = einsum(t2.abab, (0, 1, 2, 3), tmp146, (4, 1, 2, 5), (0, 4, 3, 5))
    tmp185 = einsum(v.baa.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp183 = einsum(tmp37, (0, 1, 2), v.bbb.xov, (0, 1, 3), (2, 3))
    tmp181 = einsum(v.bbb.xov, (0, 1, 2), tmp42, (0, 1, 3), (3, 2))
    tmp168 = einsum(tmp165, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 2), (4, 0, 5, 3))
    tmp166 = einsum(t2.abab, (0, 1, 2, 3), tmp165, (4, 1, 3, 5), (0, 4, 2, 5))
    tmp163 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp162 = einsum(t2.abab, (0, 1, 2, 3), tmp146, (0, 4, 5, 3), (1, 4, 2, 5))
    tmp161 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp157 = einsum(t2.abab, (0, 1, 2, 3), tmp146, (4, 5, 2, 3), (0, 4, 1, 5))
    tmp153 = einsum(v.baa.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 2, 3, 4))
    tmp132 = einsum(tmp19, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp130 = einsum(tmp16, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp127 = einsum(t2.aaaa, (0, 1, 2, 3), tmp104, (4, 5, 3, 2), (0, 1, 4, 5)) * -1
    tmp125 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 1, 2, 4))
    tmp107 = einsum(t2.abab, (0, 1, 2, 3), tmp104, (4, 0, 2, 5), (4, 1, 5, 3))
    tmp105 = einsum(t2.aaaa, (0, 1, 2, 3), tmp104, (4, 1, 3, 5), (0, 4, 2, 5))
    tmp100 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp96 = einsum(t2.abab, (0, 1, 2, 3), tmp95, (4, 2, 5, 3), (0, 1, 4, 5))
    del tmp95
    tmp93 = einsum(t2.bbbb, (0, 1, 2, 3), tmp92, (4, 2, 5, 3), (0, 1, 4, 5)) * -1
    del tmp92
    tmp86 = einsum(tmp37, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp84 = einsum(tmp16, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp83 = einsum(tmp14, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (1, 4, 2, 5))
    tmp81 = einsum(v.bbb.xoo, (0, 1, 2), tmp42, (0, 3, 4), (3, 1, 2, 4))
    tmp80 = einsum(tmp19, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp78 = einsum(t2.bbbb, (0, 1, 2, 3), tmp24, (1, 4, 5, 3), (0, 4, 5, 2))
    tmp77 = einsum(tmp24, (0, 1, 2, 3), t2.abab, (4, 0, 5, 3), (4, 1, 2, 5))
    tmp71 = einsum(v.bbb.xov, (0, 1, 2), tmp37, (0, 3, 2), (3, 1))
    tmp69 = einsum(v.bbb.xov, (0, 1, 2), tmp42, (0, 3, 2), (3, 1))
    tmp65 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp63 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (4, 3), (0, 4, 1, 2))
    tmp57 = einsum(tmp56, (0, 1, 2, 3), t2.abab, (4, 5, 1, 2), (4, 0, 5, 3))
    del tmp56
    tmp54 = einsum(tmp53, (0, 1, 2, 3), t2.aaaa, (4, 5, 1, 3), (4, 5, 0, 2)) * -1
    del tmp53
    tmp51 = einsum(tmp19, (0, 1, 2), v.baa.xvv, (0, 3, 2), (1, 3))
    tmp49 = einsum(v.bbb.xvv, (0, 1, 2), tmp37, (0, 3, 2), (3, 1))
    tmp47 = einsum(tmp42, (0, 1, 2), v.bbb.xvv, (0, 3, 2), (1, 3)) * -1
    tmp45 = einsum(tmp16, (0, 1, 2), v.baa.xvv, (0, 3, 2), (1, 3)) * -1
    tmp43 = einsum(v.baa.xoo, (0, 1, 2), tmp42, (0, 3, 4), (1, 2, 3, 4))
    tmp40 = einsum(v.baa.xoo, (0, 1, 2), tmp19, (0, 3, 4), (3, 1, 2, 4))
    tmp39 = einsum(tmp27, (0, 1, 2, 3), t2.abab, (4, 1, 3, 5), (4, 0, 2, 5))
    tmp38 = einsum(v.baa.xoo, (0, 1, 2), tmp37, (0, 3, 4), (1, 2, 3, 4))
    tmp35 = einsum(v.baa.xoo, (0, 1, 2), tmp16, (0, 3, 4), (3, 1, 2, 4))
    tmp34 = einsum(t2.abab, (0, 1, 2, 3), tmp12, (4, 0, 5, 2), (4, 5, 1, 3))
    tmp32 = einsum(t2.aaaa, (0, 1, 2, 3), tmp12, (1, 4, 5, 3), (0, 4, 5, 2))
    tmp30 = einsum(tmp14, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    tmp28 = einsum(tmp27, (0, 1, 2, 3), t2.abab, (0, 1, 3, 4), (2, 4))
    tmp25 = einsum(t2.bbbb, (0, 1, 2, 3), tmp24, (0, 4, 1, 3), (4, 2))
    tmp22 = einsum(tmp12, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 3), (0, 4))
    tmp20 = einsum(tmp19, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp17 = einsum(tmp16, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp10 = einsum(f.aa.ov, (0, 1), t2.abab, (2, 3, 1, 4), (0, 2, 3, 4))
    tmp8 = einsum(t2.aaaa, (0, 1, 2, 3), f.aa.ov, (4, 3), (4, 0, 1, 2))
    tmp6 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp4 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp3 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (0, 2), (1, 3))
    tmp1 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))

    return {f"tmp1": tmp1, f"tmp10": tmp10, f"tmp100": tmp100, f"tmp104": tmp104, f"tmp105": tmp105, f"tmp107": tmp107, f"tmp12": tmp12, f"tmp125": tmp125, f"tmp127": tmp127, f"tmp130": tmp130, f"tmp132": tmp132, f"tmp14": tmp14, f"tmp146": tmp146, f"tmp153": tmp153, f"tmp157": tmp157, f"tmp16": tmp16, f"tmp161": tmp161, f"tmp162": tmp162, f"tmp163": tmp163, f"tmp165": tmp165, f"tmp166": tmp166, f"tmp168": tmp168, f"tmp17": tmp17, f"tmp181": tmp181, f"tmp183": tmp183, f"tmp185": tmp185, f"tmp186": tmp186, f"tmp19": tmp19, f"tmp20": tmp20, f"tmp202": tmp202, f"tmp204": tmp204, f"tmp22": tmp22, f"tmp24": tmp24, f"tmp25": tmp25, f"tmp27": tmp27, f"tmp28": tmp28, f"tmp3": tmp3, f"tmp30": tmp30, f"tmp32": tmp32, f"tmp34": tmp34, f"tmp35": tmp35, f"tmp37": tmp37, f"tmp38": tmp38, f"tmp39": tmp39, f"tmp4": tmp4, f"tmp40": tmp40, f"tmp42": tmp42, f"tmp43": tmp43, f"tmp45": tmp45, f"tmp47": tmp47, f"tmp49": tmp49, f"tmp51": tmp51, f"tmp54": tmp54, f"tmp57": tmp57, f"tmp6": tmp6, f"tmp63": tmp63, f"tmp65": tmp65, f"tmp69": tmp69, f"tmp71": tmp71, f"tmp77": tmp77, f"tmp78": tmp78, f"tmp8": tmp8, f"tmp80": tmp80, f"tmp81": tmp81, f"tmp83": tmp83, f"tmp84": tmp84, f"tmp86": tmp86, f"tmp93": tmp93, f"tmp96": tmp96}

def hbar_lmatvec_ip(f=None, r1=None, r2=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:30:00.581927.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp18 = np.copy(ints.tmp37)
    tmp18 += v.bbb.xov
    tmp18 += ints.tmp42 * 2
    tmp16 = np.copy(ints.tmp19)
    tmp16 += v.baa.xov
    tmp16 += ints.tmp16 * 2
    tmp34 = np.copy(ints.tmp16) * 2
    del ints.tmp16
    tmp34 += ints.tmp19
    del ints.tmp19
    tmp34 += v.baa.xov
    tmp38 = einsum(t2.bbbb, (0, 1, 2, 3), r2.bbb, (0, 1, 3), (2,))
    tmp37 = einsum(r2.aba, (0, 1, 2), t2.abab, (0, 1, 2, 3), (3,))
    tmp19 = einsum(tmp18, (0, 1, 2), r2.bab, (1, 3, 2), (0, 3)) * -1
    tmp17 = einsum(tmp16, (0, 1, 2), r2.aaa, (3, 1, 2), (0, 3)) * -1
    del tmp16
    tmp48 = einsum(r2.aba, (0, 1, 2), tmp34, (3, 0, 2), (3, 1))
    tmp51 = np.copy(ints.tmp69) * 2
    tmp51 += ints.tmp71
    tmp39 = np.copy(tmp37) * -0.5
    del tmp37
    tmp39 += tmp38
    del tmp38
    tmp56 = einsum(tmp18, (0, 1, 2), r2.bbb, (3, 1, 2), (0, 3)) * -1
    del tmp18
    tmp40 = np.copy(ints.tmp163)
    del ints.tmp163
    tmp40 += np.transpose(ints.tmp168, (1, 0, 3, 2)) * 2
    del ints.tmp168
    tmp24 = einsum(t2.aaaa, (0, 1, 2, 3), r2.aaa, (0, 1, 3), (2,))
    tmp26 = np.copy(ints.tmp17) * 2
    tmp26 += ints.tmp20
    tmp12 = einsum(t2.abab, (0, 1, 2, 3), r2.bab, (1, 0, 3), (2,)) * -1
    tmp20 = np.copy(tmp17) * -2
    del tmp17
    tmp20 += tmp19
    del tmp19
    tmp14 = np.copy(ints.tmp100)
    tmp14 += np.transpose(ints.tmp105, (1, 0, 3, 2)) * 2
    tmp49 = einsum(tmp48, (0, 1), v.bbb.xov, (0, 2, 3), (2, 1, 3))
    del tmp48
    tmp52 = einsum(tmp51, (0, 1), r2.bbb, (2, 0, 3), (2, 1, 3)) * -2
    del tmp51
    tmp47 = einsum(r2.aba, (0, 1, 2), ints.tmp166, (0, 3, 2, 4), (3, 1, 4))
    tmp46 = einsum(r1.b, (0,), ints.tmp24, (1, 0, 2, 3), (1, 2, 3))
    tmp50 = einsum(tmp39, (0,), ints.tmp165, (1, 2, 3, 0), (1, 2, 3)) * 2
    del ints.tmp165
    tmp57 = einsum(tmp56, (0, 1), v.bbb.xov, (0, 2, 3), (2, 1, 3)) * -1
    del tmp56
    tmp54 = einsum(r2.bbb, (0, 1, 2), f.bb.oo, (3, 1), (3, 0, 2))
    tmp55 = einsum(tmp40, (0, 1, 2, 3), r2.bbb, (4, 1, 3), (4, 0, 2)) * -1
    tmp35 = np.copy(ints.tmp37) * 0.5
    del ints.tmp37
    tmp35 += ints.tmp42
    del ints.tmp42
    tmp35 += v.bbb.xov * 0.5
    tmp25 = einsum(tmp24, (0,), ints.tmp104, (1, 2, 3, 0), (1, 2, 3))
    tmp27 = einsum(r2.aaa, (0, 1, 2), tmp26, (1, 3), (0, 3, 2)) * -2
    del tmp26
    tmp23 = einsum(r1.a, (0,), ints.tmp12, (1, 0, 2, 3), (1, 2, 3))
    tmp13 = einsum(tmp12, (0,), ints.tmp104, (1, 2, 3, 0), (1, 2, 3))
    del ints.tmp104
    tmp21 = einsum(tmp20, (0, 1), v.baa.xov, (0, 2, 3), (2, 1, 3))
    del tmp20
    tmp10 = einsum(f.aa.oo, (0, 1), r2.aaa, (2, 1, 3), (0, 2, 3))
    tmp15 = einsum(tmp14, (0, 1, 2, 3), r2.aaa, (4, 1, 3), (4, 0, 2)) * -1
    del tmp14
    tmp11 = einsum(ints.tmp107, (0, 1, 2, 3), r2.bab, (1, 4, 3), (0, 4, 2)) * -1
    tmp53 = einsum(r1.b, (0,), f.bb.ov, (1, 2), (1, 0, 2))
    tmp53 += tmp46
    del tmp46
    tmp53 += tmp47
    del tmp47
    tmp53 += np.transpose(tmp49, (1, 0, 2))
    del tmp49
    tmp53 += tmp50 * -1
    del tmp50
    tmp53 += np.transpose(tmp52, (1, 0, 2))
    del tmp52
    tmp58 = np.copy(tmp54)
    del tmp54
    tmp58 += np.transpose(tmp55, (1, 0, 2)) * -1
    del tmp55
    tmp58 += np.transpose(tmp57, (1, 0, 2))
    del tmp57
    tmp44 = np.copy(ints.tmp181) * 2
    del ints.tmp181
    tmp44 += ints.tmp183
    del ints.tmp183
    tmp44 += f.bb.vv * -1
    tmp59 = np.copy(ints.tmp202)
    del ints.tmp202
    tmp59 += np.transpose(ints.tmp204, (2, 0, 3, 1)) * -1
    del ints.tmp204
    tmp42 = np.copy(ints.tmp153)
    tmp42 += np.transpose(ints.tmp157, (1, 0, 3, 2))
    tmp9 = np.copy(f.bb.oo)
    tmp9 += ints.tmp69 * 2
    del ints.tmp69
    tmp9 += ints.tmp71
    del ints.tmp71
    tmp41 = np.copy(ints.tmp185)
    del ints.tmp185
    tmp41 += np.transpose(ints.tmp186, (1, 0, 3, 2)) * -1
    del ints.tmp186
    tmp43 = einsum(tmp34, (0, 1, 2), r2.aaa, (3, 1, 2), (0, 3))
    tmp43 += einsum(tmp35, (0, 1, 2), r2.bab, (1, 3, 2), (0, 3)) * -1
    tmp4 = np.copy(f.aa.oo)
    tmp4 += ints.tmp17 * 2
    del ints.tmp17
    tmp4 += ints.tmp20
    del ints.tmp20
    tmp45 = np.copy(tmp24) * 2
    del tmp24
    tmp45 += tmp12
    del tmp12
    tmp30 = np.copy(ints.tmp130) * 2
    del ints.tmp130
    tmp30 += ints.tmp132
    del ints.tmp132
    tmp30 += f.aa.vv * -1
    tmp36 = einsum(r2.aba, (0, 1, 2), tmp34, (3, 0, 2), (3, 1)) * -0.5
    del tmp34
    tmp36 += einsum(tmp35, (0, 1, 2), r2.bbb, (3, 1, 2), (0, 3)) * 2
    del tmp35
    tmp31 = np.copy(ints.tmp100)
    del ints.tmp100
    tmp31 += np.transpose(ints.tmp105, (1, 0, 3, 2)) * 2
    del ints.tmp105
    tmp32 = np.copy(ints.tmp161)
    del ints.tmp161
    tmp32 += np.transpose(ints.tmp162, (1, 0, 3, 2)) * -1
    del ints.tmp162
    tmp33 = np.copy(ints.tmp153)
    del ints.tmp153
    tmp33 += np.transpose(ints.tmp157, (1, 0, 3, 2))
    del ints.tmp157
    tmp28 = einsum(r1.a, (0,), f.aa.ov, (1, 2), (1, 0, 2)) * -1
    tmp28 += tmp23 * -1
    del tmp23
    tmp28 += tmp25 * 2
    del tmp25
    tmp28 += np.transpose(tmp27, (1, 0, 2)) * -1
    del tmp27
    tmp22 = np.copy(tmp10) * 2
    del tmp10
    tmp22 += tmp11
    del tmp11
    tmp22 += tmp13
    del tmp13
    tmp22 += np.transpose(tmp15, (1, 0, 2)) * -2
    del tmp15
    tmp22 += np.transpose(tmp21, (1, 0, 2))
    del tmp21
    tmp29 = np.copy(ints.tmp125)
    del ints.tmp125
    tmp29 += np.transpose(ints.tmp127, (2, 0, 3, 1)) * -1
    del ints.tmp127
    tmp6 = np.copy(ints.tmp24)
    del ints.tmp24
    tmp6 += np.transpose(ints.tmp78, (2, 0, 1, 3)) * 2
    del ints.tmp78
    tmp6 += np.transpose(ints.tmp93, (2, 0, 1, 3))
    del ints.tmp93
    tmp6 += ints.tmp65 * -1
    del ints.tmp65
    tmp6 += np.transpose(ints.tmp81, (2, 0, 1, 3)) * -2
    del ints.tmp81
    tmp6 += np.transpose(ints.tmp86, (2, 0, 1, 3)) * -1
    del ints.tmp86
    tmp7 = np.copy(f.aa.ov) * 0.5
    tmp7 += ints.tmp1
    tmp7 += ints.tmp4 * 0.5
    tmp7 += ints.tmp51 * 0.5
    tmp7 += ints.tmp22 * -1
    tmp7 += ints.tmp30 * -0.5
    tmp7 += ints.tmp45 * -1
    tmp8 = np.copy(f.bb.ov)
    tmp8 += ints.tmp3
    tmp8 += ints.tmp49
    tmp8 += ints.tmp6 * 2
    tmp8 += ints.tmp25 * -2
    tmp8 += ints.tmp28 * -1
    tmp8 += ints.tmp47 * -2
    tmp5 = np.copy(ints.tmp27)
    tmp5 += ints.tmp63
    del ints.tmp63
    tmp5 += np.transpose(ints.tmp80, (0, 2, 1, 3))
    del ints.tmp80
    tmp5 += np.transpose(ints.tmp84, (0, 2, 1, 3)) * 2
    del ints.tmp84
    tmp5 += np.transpose(ints.tmp96, (0, 2, 1, 3))
    del ints.tmp96
    tmp5 += np.transpose(ints.tmp77, (0, 2, 1, 3)) * -1
    del ints.tmp77
    tmp5 += np.transpose(ints.tmp83, (0, 2, 1, 3)) * -1
    del ints.tmp83
    tmp1 = np.copy(ints.tmp12)
    del ints.tmp12
    tmp1 += np.transpose(ints.tmp32, (2, 0, 1, 3)) * 2
    del ints.tmp32
    tmp1 += np.transpose(ints.tmp54, (2, 0, 1, 3))
    del ints.tmp54
    tmp1 += np.transpose(ints.tmp35, (2, 0, 1, 3)) * -2
    del ints.tmp35
    tmp1 += np.transpose(ints.tmp40, (2, 0, 1, 3)) * -1
    del ints.tmp40
    tmp1 += ints.tmp8 * -1
    del ints.tmp8
    tmp2 = np.copy(f.aa.ov)
    tmp2 += ints.tmp1 * 2
    del ints.tmp1
    tmp2 += ints.tmp4
    del ints.tmp4
    tmp2 += ints.tmp51
    del ints.tmp51
    tmp2 += ints.tmp22 * -2
    del ints.tmp22
    tmp2 += ints.tmp30 * -1
    del ints.tmp30
    tmp2 += ints.tmp45 * -2
    del ints.tmp45
    tmp0 = np.copy(ints.tmp10)
    del ints.tmp10
    tmp0 += ints.tmp14
    tmp0 += np.transpose(ints.tmp38, (1, 0, 2, 3))
    del ints.tmp38
    tmp0 += np.transpose(ints.tmp43, (1, 0, 2, 3)) * 2
    del ints.tmp43
    tmp0 += np.transpose(ints.tmp57, (1, 0, 2, 3))
    del ints.tmp57
    tmp0 += np.transpose(ints.tmp34, (1, 0, 2, 3)) * -1
    del ints.tmp34
    tmp0 += np.transpose(ints.tmp39, (1, 0, 2, 3)) * -1
    del ints.tmp39
    tmp3 = np.copy(f.bb.ov) * 0.5
    tmp3 += ints.tmp3 * 0.5
    del ints.tmp3
    tmp3 += ints.tmp49 * 0.5
    del ints.tmp49
    tmp3 += ints.tmp6
    del ints.tmp6
    tmp3 += ints.tmp25 * -1
    del ints.tmp25
    tmp3 += ints.tmp28 * -0.5
    del ints.tmp28
    tmp3 += ints.tmp47 * -1
    del ints.tmp47
    r2new.bbb = np.copy(tmp53) * -1
    r2new.bbb += np.transpose(tmp53, (1, 0, 2))
    del tmp53
    r2new.bbb += tmp58 * 2
    r2new.bbb += np.transpose(tmp58, (1, 0, 2)) * -2
    del tmp58
    r2new.bbb += einsum(tmp59, (0, 1, 2, 3), r2.bbb, (3, 1, 4), (0, 2, 4)) * 2
    del tmp59
    r2new.bbb += einsum(tmp44, (0, 1), r2.bbb, (2, 3, 0), (2, 3, 1)) * -2
    r2new.bab = einsum(r2.aaa, (0, 1, 2), ints.tmp166, (1, 3, 2, 4), (3, 0, 4)) * 2
    del ints.tmp166
    r2new.bab += einsum(ints.tmp14, (0, 1, 2, 3), r1.a, (1,), (2, 0, 3))
    del ints.tmp14
    r2new.bab += einsum(r1.a, (0,), f.bb.ov, (1, 2), (1, 0, 2)) * -1
    r2new.bab += einsum(tmp40, (0, 1, 2, 3), r2.bab, (1, 4, 3), (0, 4, 2)) * -1
    del tmp40
    r2new.bab += einsum(tmp41, (0, 1, 2, 3), r2.bab, (4, 1, 3), (4, 0, 2)) * -1
    del tmp41
    r2new.bab += einsum(tmp42, (0, 1, 2, 3), r2.bab, (3, 1, 4), (2, 0, 4))
    del tmp42
    r2new.bab += einsum(v.bbb.xov, (0, 1, 2), tmp43, (0, 3), (1, 3, 2)) * -2
    del tmp43
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp44, (2, 3), (0, 1, 3)) * -1
    del tmp44
    r2new.bab += einsum(ints.tmp146, (0, 1, 2, 3), tmp45, (2,), (1, 0, 3))
    del tmp45
    r2new.bab += einsum(tmp4, (0, 1), r2.bab, (2, 0, 3), (2, 1, 3)) * -1
    r2new.bab += einsum(tmp9, (0, 1), r2.bab, (0, 2, 3), (1, 2, 3)) * -1
    r2new.aba = einsum(f.aa.ov, (0, 1), r1.b, (2,), (0, 2, 1)) * -1
    r2new.aba += einsum(ints.tmp107, (0, 1, 2, 3), r2.bbb, (4, 1, 3), (0, 4, 2)) * 2
    del ints.tmp107
    r2new.aba += einsum(ints.tmp27, (0, 1, 2, 3), r1.b, (2,), (0, 1, 3))
    del ints.tmp27
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp31, (3, 0, 4, 2), (3, 1, 4)) * -1
    del tmp31
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp32, (3, 1, 4, 2), (0, 3, 4)) * -1
    del tmp32
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp33, (3, 0, 4, 1), (3, 4, 2))
    del tmp33
    r2new.aba += einsum(tmp36, (0, 1), v.baa.xov, (0, 2, 3), (2, 1, 3)) * -2
    del tmp36
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp30, (2, 3), (0, 1, 3)) * -1
    r2new.aba += einsum(ints.tmp146, (0, 1, 2, 3), tmp39, (3,), (0, 1, 2)) * 2
    del tmp39, ints.tmp146
    r2new.aba += einsum(tmp4, (0, 1), r2.aba, (0, 2, 3), (1, 2, 3)) * -1
    r2new.aba += einsum(tmp9, (0, 1), r2.aba, (2, 0, 3), (2, 1, 3)) * -1
    r2new.aaa = np.copy(tmp22)
    r2new.aaa += np.transpose(tmp22, (1, 0, 2)) * -1
    del tmp22
    r2new.aaa += tmp28
    r2new.aaa += np.transpose(tmp28, (1, 0, 2)) * -1
    del tmp28
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp29, (3, 1, 4, 0), (3, 4, 2)) * 2
    del tmp29
    r2new.aaa += einsum(tmp30, (0, 1), r2.aaa, (2, 3, 0), (2, 3, 1)) * -2
    del tmp30
    r1new.b = einsum(r2.aba, (0, 1, 2), tmp5, (0, 3, 1, 2), (3,))
    del tmp5
    r1new.b += einsum(tmp6, (0, 1, 2, 3), r2.bbb, (1, 2, 3), (0,)) * -2
    del tmp6
    r1new.b += einsum(tmp7, (0, 1), r2.aba, (0, 2, 1), (2,)) * -2
    del tmp7
    r1new.b += einsum(tmp8, (0, 1), r2.bbb, (2, 0, 1), (2,)) * 2
    del tmp8
    r1new.b += einsum(tmp9, (0, 1), r1.b, (0,), (1,)) * -1
    del tmp9
    r1new.a = einsum(tmp0, (0, 1, 2, 3), r2.bab, (2, 1, 3), (0,))
    del tmp0
    r1new.a += einsum(tmp1, (0, 1, 2, 3), r2.aaa, (1, 2, 3), (0,)) * -2
    del tmp1
    r1new.a += einsum(tmp2, (0, 1), r2.aaa, (2, 0, 1), (2,)) * 2
    del tmp2
    r1new.a += einsum(tmp3, (0, 1), r2.bab, (0, 2, 1), (2,)) * -2
    del tmp3
    r1new.a += einsum(r1.a, (0,), tmp4, (0, 1), (1,)) * -1
    del tmp4

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ea_intermediates(f=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:31:13.403365.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp102 : array
    tmp106 : array
    tmp108 : array
    tmp110 : array
    tmp111 : array
    tmp113 : array
    tmp12 : array
    tmp126 : array
    tmp14 : array
    tmp146 : array
    tmp149 : array
    tmp157 : array
    tmp158 : array
    tmp159 : array
    tmp16 : array
    tmp161 : array
    tmp163 : array
    tmp165 : array
    tmp166 : array
    tmp168 : array
    tmp17 : array
    tmp182 : array
    tmp183 : array
    tmp19 : array
    tmp20 : array
    tmp200 : array
    tmp23 : array
    tmp26 : array
    tmp29 : array
    tmp3 : array
    tmp32 : array
    tmp34 : array
    tmp36 : array
    tmp38 : array
    tmp4 : array
    tmp40 : array
    tmp41 : array
    tmp43 : array
    tmp44 : array
    tmp46 : array
    tmp48 : array
    tmp50 : array
    tmp51 : array
    tmp53 : array
    tmp54 : array
    tmp56 : array
    tmp58 : array
    tmp59 : array
    tmp6 : array
    tmp68 : array
    tmp71 : array
    tmp73 : array
    tmp79 : array
    tmp81 : array
    tmp87 : array
    tmp88 : array
    tmp90 : array
    tmp91 : array
    tmp93 : array
    tmp95 : array
    tmp97 : array
    """

    tmp146 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp165 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp43 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (4, 1, 3))
    tmp40 = einsum(t2.bbbb, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp110 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp19 = einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp16 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp14 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp68 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp31 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp25 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp58 = einsum(v.baa.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp12 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp28 = einsum(v.baa.xov, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp22 = einsum(v.baa.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp200 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (3, 1, 2, 4))
    tmp183 = einsum(t2.abab, (0, 1, 2, 3), tmp146, (0, 4, 5, 3), (1, 4, 2, 5))
    tmp182 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp168 = einsum(tmp165, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 2), (4, 0, 5, 3))
    tmp166 = einsum(t2.abab, (0, 1, 2, 3), tmp165, (4, 1, 3, 5), (0, 4, 2, 5))
    tmp163 = einsum(v.bbb.xov, (0, 1, 2), tmp43, (0, 3, 2), (3, 1))
    tmp161 = einsum(v.bbb.xov, (0, 1, 2), tmp40, (0, 3, 2), (3, 1))
    tmp159 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp158 = einsum(t2.abab, (0, 1, 2, 3), tmp146, (4, 1, 2, 5), (0, 4, 3, 5))
    tmp157 = einsum(v.baa.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp149 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp126 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp113 = einsum(t2.abab, (0, 1, 2, 3), tmp110, (4, 0, 2, 5), (4, 1, 5, 3))
    tmp111 = einsum(tmp110, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 2), (4, 0, 5, 3))
    tmp108 = einsum(tmp19, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp106 = einsum(tmp16, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp102 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp97 = einsum(tmp14, (0, 1, 2, 3), t2.abab, (4, 0, 1, 5), (4, 2, 5, 3))
    tmp95 = einsum(tmp43, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp93 = einsum(tmp16, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp91 = einsum(tmp68, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 2), (4, 5, 3, 1))
    tmp90 = einsum(tmp68, (0, 1, 2, 3), t2.abab, (4, 0, 5, 1), (4, 5, 3, 2))
    tmp88 = einsum(tmp40, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp87 = einsum(tmp19, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp81 = einsum(tmp31, (0, 1, 2, 3), t2.abab, (0, 2, 4, 5), (1, 4, 5, 3))
    tmp79 = einsum(t2.bbbb, (0, 1, 2, 3), tmp25, (0, 4, 1, 5), (4, 2, 3, 5))
    tmp73 = einsum(v.bbb.xov, (0, 1, 2), tmp43, (0, 1, 3), (3, 2))
    tmp71 = einsum(v.bbb.xov, (0, 1, 2), tmp40, (0, 1, 3), (3, 2))
    tmp59 = einsum(tmp58, (0, 1, 2, 3), t2.abab, (0, 4, 5, 2), (4, 5, 1, 3))
    tmp56 = einsum(tmp40, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp54 = einsum(tmp19, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp53 = einsum(tmp12, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (4, 3, 1, 5))
    tmp51 = einsum(tmp12, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 1), (4, 5, 3, 2))
    tmp50 = einsum(tmp43, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp48 = einsum(v.baa.xvv, (0, 1, 2), tmp16, (0, 3, 4), (3, 4, 1, 2))
    tmp46 = einsum(tmp19, (0, 1, 2), v.baa.xvv, (0, 3, 2), (1, 3))
    tmp44 = einsum(v.bbb.xvv, (0, 1, 2), tmp43, (0, 3, 2), (3, 1))
    tmp41 = einsum(v.bbb.xvv, (0, 1, 2), tmp40, (0, 3, 2), (3, 1)) * -1
    tmp38 = einsum(tmp16, (0, 1, 2), v.baa.xvv, (0, 3, 2), (1, 3)) * -1
    tmp36 = einsum(tmp28, (0, 1, 2, 3), t2.abab, (0, 1, 4, 5), (2, 4, 3, 5))
    tmp34 = einsum(t2.aaaa, (0, 1, 2, 3), tmp22, (0, 4, 1, 5), (4, 2, 3, 5))
    tmp32 = einsum(tmp31, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (1, 4))
    del tmp31
    tmp29 = einsum(tmp28, (0, 1, 2, 3), t2.abab, (0, 1, 3, 4), (2, 4))
    del tmp28
    tmp26 = einsum(t2.bbbb, (0, 1, 2, 3), tmp25, (0, 4, 1, 3), (4, 2))
    del tmp25
    tmp23 = einsum(tmp22, (0, 1, 2, 3), t2.aaaa, (0, 2, 4, 3), (1, 4))
    del tmp22
    tmp20 = einsum(tmp19, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp17 = einsum(tmp16, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp6 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp4 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp3 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (0, 2), (1, 3))
    tmp1 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))

    return {f"tmp1": tmp1, f"tmp102": tmp102, f"tmp106": tmp106, f"tmp108": tmp108, f"tmp110": tmp110, f"tmp111": tmp111, f"tmp113": tmp113, f"tmp12": tmp12, f"tmp126": tmp126, f"tmp14": tmp14, f"tmp146": tmp146, f"tmp149": tmp149, f"tmp157": tmp157, f"tmp158": tmp158, f"tmp159": tmp159, f"tmp16": tmp16, f"tmp161": tmp161, f"tmp163": tmp163, f"tmp165": tmp165, f"tmp166": tmp166, f"tmp168": tmp168, f"tmp17": tmp17, f"tmp182": tmp182, f"tmp183": tmp183, f"tmp19": tmp19, f"tmp20": tmp20, f"tmp200": tmp200, f"tmp23": tmp23, f"tmp26": tmp26, f"tmp29": tmp29, f"tmp3": tmp3, f"tmp32": tmp32, f"tmp34": tmp34, f"tmp36": tmp36, f"tmp38": tmp38, f"tmp4": tmp4, f"tmp40": tmp40, f"tmp41": tmp41, f"tmp43": tmp43, f"tmp44": tmp44, f"tmp46": tmp46, f"tmp48": tmp48, f"tmp50": tmp50, f"tmp51": tmp51, f"tmp53": tmp53, f"tmp54": tmp54, f"tmp56": tmp56, f"tmp58": tmp58, f"tmp59": tmp59, f"tmp6": tmp6, f"tmp68": tmp68, f"tmp71": tmp71, f"tmp73": tmp73, f"tmp79": tmp79, f"tmp81": tmp81, f"tmp87": tmp87, f"tmp88": tmp88, f"tmp90": tmp90, f"tmp91": tmp91, f"tmp93": tmp93, f"tmp95": tmp95, f"tmp97": tmp97}

def hbar_lmatvec_ea(f=None, r1=None, r2=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T15:31:13.481880.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp22 = np.copy(ints.tmp43)
    tmp22 += v.bbb.xov
    tmp22 += ints.tmp40 * 2
    tmp20 = np.copy(ints.tmp19)
    tmp20 += v.baa.xov
    tmp20 += ints.tmp16 * 2
    tmp12 = einsum(r2.bbb, (0, 1, 2), t2.bbbb, (3, 2, 0, 1), (3,))
    tmp11 = einsum(t2.abab, (0, 1, 2, 3), r2.aba, (2, 3, 0), (1,))
    tmp34 = np.copy(ints.tmp16) * 2
    del ints.tmp16
    tmp34 += ints.tmp19
    del ints.tmp19
    tmp34 += v.baa.xov
    tmp23 = einsum(tmp22, (0, 1, 2), r2.bab, (2, 3, 1), (0, 3)) * -1
    tmp21 = einsum(tmp20, (0, 1, 2), r2.aaa, (3, 2, 1), (0, 3)) * -1
    del tmp20
    tmp39 = np.copy(ints.tmp159)
    del ints.tmp159
    tmp39 += np.transpose(ints.tmp168, (1, 0, 3, 2)) * 2
    del ints.tmp168
    tmp53 = einsum(r2.bbb, (0, 1, 2), tmp22, (3, 2, 1), (3, 0)) * -1
    del tmp22
    tmp37 = np.copy(tmp11) * -0.5
    tmp37 += tmp12
    tmp46 = einsum(tmp34, (0, 1, 2), r2.aba, (2, 3, 1), (0, 3))
    tmp42 = np.copy(ints.tmp71)
    tmp42 += ints.tmp73 * 0.5
    tmp42 += f.bb.vv * -0.5
    tmp24 = np.copy(tmp21) * -2
    del tmp21
    tmp24 += tmp23
    del tmp23
    tmp18 = np.copy(ints.tmp102)
    tmp18 += np.transpose(ints.tmp111, (1, 0, 3, 2)) * 2
    tmp6 = einsum(t2.abab, (0, 1, 2, 3), r2.bab, (3, 2, 1), (0,)) * -1
    tmp4 = np.copy(ints.tmp17) * 2
    del ints.tmp17
    tmp4 += ints.tmp20
    del ints.tmp20
    tmp4 += f.aa.vv * -1
    tmp5 = einsum(t2.aaaa, (0, 1, 2, 3), r2.aaa, (2, 3, 1), (0,))
    tmp52 = einsum(r2.bbb, (0, 1, 2), tmp39, (3, 2, 4, 1), (3, 0, 4)) * -1
    tmp51 = einsum(ints.tmp68, (0, 1, 2, 3), r1.b, (2,), (0, 1, 3))
    tmp54 = einsum(tmp53, (0, 1), v.bbb.xov, (0, 2, 3), (2, 3, 1)) * -1
    del tmp53
    tmp49 = einsum(tmp37, (0,), ints.tmp165, (1, 0, 2, 3), (1, 2, 3)) * 2
    tmp47 = einsum(tmp46, (0, 1), v.bbb.xov, (0, 2, 3), (2, 3, 1))
    del tmp46
    tmp48 = einsum(tmp42, (0, 1), r2.bbb, (2, 0, 3), (3, 2, 1)) * -4
    tmp45 = einsum(ints.tmp166, (0, 1, 2, 3), r2.aba, (2, 4, 0), (1, 3, 4))
    tmp35 = np.copy(ints.tmp40) * 2
    del ints.tmp40
    tmp35 += ints.tmp43
    del ints.tmp43
    tmp35 += v.bbb.xov
    tmp25 = einsum(tmp24, (0, 1), v.baa.xov, (0, 2, 3), (2, 3, 1))
    del tmp24
    tmp16 = einsum(ints.tmp113, (0, 1, 2, 3), r2.bab, (3, 4, 1), (0, 2, 4)) * -1
    tmp19 = einsum(r2.aaa, (0, 1, 2), tmp18, (3, 2, 4, 1), (3, 0, 4)) * -1
    del tmp18
    tmp15 = einsum(r1.a, (0,), ints.tmp12, (1, 2, 0, 3), (1, 2, 3))
    tmp17 = einsum(ints.tmp110, (0, 1, 2, 3), tmp6, (1,), (0, 2, 3))
    tmp28 = einsum(tmp4, (0, 1), r2.aaa, (2, 0, 3), (3, 2, 1)) * -2
    tmp27 = einsum(ints.tmp110, (0, 1, 2, 3), tmp5, (1,), (0, 2, 3))
    tmp43 = np.copy(f.bb.oo)
    tmp43 += ints.tmp161 * 2
    del ints.tmp161
    tmp43 += ints.tmp163
    del ints.tmp163
    tmp55 = np.copy(tmp51)
    del tmp51
    tmp55 += np.transpose(tmp52, (0, 2, 1)) * -2
    del tmp52
    tmp55 += np.transpose(tmp54, (0, 2, 1)) * 2
    del tmp54
    tmp44 = einsum(r2.bbb, (0, 1, 2), t2.bbbb, (3, 4, 0, 1), (2, 3, 4))
    tmp50 = einsum(r1.b, (0,), f.bb.ov, (1, 2), (1, 2, 0))
    tmp50 += tmp45
    del tmp45
    tmp50 += np.transpose(tmp47, (0, 2, 1))
    del tmp47
    tmp50 += np.transpose(tmp48, (0, 2, 1))
    del tmp48
    tmp50 += tmp49 * -1
    del tmp49
    tmp40 = np.copy(ints.tmp182)
    del ints.tmp182
    tmp40 += np.transpose(ints.tmp183, (1, 0, 3, 2)) * -1
    del ints.tmp183
    tmp41 = einsum(r2.aaa, (0, 1, 2), tmp34, (3, 2, 1), (3, 0))
    tmp41 += einsum(tmp35, (0, 1, 2), r2.bab, (2, 3, 1), (0, 3)) * -0.5
    tmp38 = einsum(t2.abab, (0, 1, 2, 3), r2.bab, (3, 2, 4), (0, 4, 1)) * -1
    tmp7 = np.copy(tmp5) * 2
    del tmp5
    tmp7 += tmp6
    del tmp6
    tmp30 = np.copy(f.aa.oo)
    tmp30 += ints.tmp106 * 2
    del ints.tmp106
    tmp30 += ints.tmp108
    del ints.tmp108
    tmp10 = np.copy(ints.tmp71) * 2
    del ints.tmp71
    tmp10 += ints.tmp73
    del ints.tmp73
    tmp10 += f.bb.vv * -1
    tmp36 = einsum(tmp34, (0, 1, 2), r2.aba, (2, 3, 1), (0, 3)) * -0.5
    del tmp34
    tmp36 += einsum(r2.bbb, (0, 1, 2), tmp35, (3, 2, 1), (3, 0))
    del tmp35
    tmp31 = einsum(t2.abab, (0, 1, 2, 3), r2.aba, (2, 3, 4), (4, 0, 1))
    tmp32 = np.copy(ints.tmp102)
    del ints.tmp102
    tmp32 += np.transpose(ints.tmp111, (1, 0, 3, 2)) * 2
    del ints.tmp111
    tmp33 = np.copy(ints.tmp157)
    del ints.tmp157
    tmp33 += np.transpose(ints.tmp158, (1, 0, 3, 2)) * -1
    del ints.tmp158
    tmp26 = np.copy(tmp15)
    del tmp15
    tmp26 += tmp16
    del tmp16
    tmp26 += tmp17
    del tmp17
    tmp26 += np.transpose(tmp19, (0, 2, 1)) * -2
    del tmp19
    tmp26 += np.transpose(tmp25, (0, 2, 1))
    del tmp25
    tmp29 = einsum(f.aa.ov, (0, 1), r1.a, (2,), (0, 1, 2)) * -1
    tmp29 += tmp27 * 2
    del tmp27
    tmp29 += np.transpose(tmp28, (0, 2, 1)) * -1
    del tmp28
    tmp14 = einsum(t2.aaaa, (0, 1, 2, 3), r2.aaa, (2, 3, 4), (4, 0, 1))
    tmp13 = np.copy(tmp11) * -1
    del tmp11
    tmp13 += tmp12 * 2
    del tmp12
    tmp9 = np.copy(np.transpose(ints.tmp79, (0, 3, 1, 2))) * 0.5
    del ints.tmp79
    tmp9 += np.transpose(ints.tmp88, (0, 3, 1, 2))
    del ints.tmp88
    tmp9 += np.transpose(ints.tmp95, (0, 3, 1, 2)) * 0.5
    del ints.tmp95
    tmp9 += ints.tmp68 * -0.5
    del ints.tmp68
    tmp9 += np.transpose(ints.tmp91, (0, 2, 1, 3)) * -1
    del ints.tmp91
    tmp2 = np.copy(f.aa.ov) * 0.5
    tmp2 += ints.tmp1
    del ints.tmp1
    tmp2 += ints.tmp46 * 0.5
    del ints.tmp46
    tmp2 += ints.tmp4 * 0.5
    del ints.tmp4
    tmp2 += ints.tmp23 * -1
    del ints.tmp23
    tmp2 += ints.tmp32 * -0.5
    del ints.tmp32
    tmp2 += ints.tmp38 * -1
    del ints.tmp38
    tmp8 = np.copy(ints.tmp58)
    tmp8 += np.transpose(ints.tmp81, (0, 1, 3, 2))
    del ints.tmp81
    tmp8 += np.transpose(ints.tmp87, (0, 1, 3, 2))
    del ints.tmp87
    tmp8 += np.transpose(ints.tmp93, (0, 1, 3, 2)) * 2
    del ints.tmp93
    tmp8 += ints.tmp90 * -1
    del ints.tmp90
    tmp8 += np.transpose(ints.tmp97, (0, 1, 3, 2)) * -1
    del ints.tmp97
    tmp3 = np.copy(f.bb.ov) * 0.5
    tmp3 += ints.tmp3 * 0.5
    del ints.tmp3
    tmp3 += ints.tmp44 * 0.5
    del ints.tmp44
    tmp3 += ints.tmp6
    del ints.tmp6
    tmp3 += ints.tmp26 * -1
    del ints.tmp26
    tmp3 += ints.tmp29 * -0.5
    del ints.tmp29
    tmp3 += ints.tmp41 * -1
    del ints.tmp41
    tmp1 = np.copy(np.transpose(ints.tmp34, (0, 3, 1, 2))) * 0.5
    del ints.tmp34
    tmp1 += np.transpose(ints.tmp48, (0, 3, 1, 2))
    del ints.tmp48
    tmp1 += np.transpose(ints.tmp54, (0, 3, 1, 2)) * 0.5
    del ints.tmp54
    tmp1 += ints.tmp12 * -0.5
    del ints.tmp12
    tmp1 += np.transpose(ints.tmp51, (0, 2, 1, 3)) * -1
    del ints.tmp51
    tmp0 = np.copy(ints.tmp14)
    tmp0 += np.transpose(ints.tmp36, (0, 2, 1, 3))
    del ints.tmp36
    tmp0 += np.transpose(ints.tmp50, (0, 2, 1, 3))
    del ints.tmp50
    tmp0 += np.transpose(ints.tmp56, (0, 2, 1, 3)) * 2
    del ints.tmp56
    tmp0 += ints.tmp53 * -1
    del ints.tmp53
    tmp0 += np.transpose(ints.tmp59, (0, 2, 1, 3)) * -1
    del ints.tmp59
    r2new.bbb = einsum(ints.tmp200, (0, 1, 2, 3), r2.bbb, (1, 3, 4), (0, 2, 4)) * -2
    del ints.tmp200
    r2new.bbb += einsum(ints.tmp165, (0, 1, 2, 3), tmp44, (4, 0, 1), (3, 2, 4)) * -2
    del ints.tmp165, tmp44
    r2new.bbb += np.transpose(tmp50, (1, 2, 0)) * -1
    r2new.bbb += np.transpose(tmp50, (2, 1, 0))
    del tmp50
    r2new.bbb += np.transpose(tmp55, (1, 2, 0))
    r2new.bbb += np.transpose(tmp55, (2, 1, 0)) * -1
    del tmp55
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp43, (2, 3), (0, 1, 3)) * -2
    r2new.bab = einsum(r2.aaa, (0, 1, 2), ints.tmp166, (2, 3, 1, 4), (4, 0, 3)) * 2
    del ints.tmp166
    r2new.bab += einsum(ints.tmp146, (0, 1, 2, 3), tmp38, (0, 4, 1), (3, 2, 4)) * -1
    del tmp38
    r2new.bab += einsum(ints.tmp14, (0, 1, 2, 3), r1.a, (2,), (3, 1, 0)) * -1
    del ints.tmp14
    r2new.bab += einsum(r1.a, (0,), f.bb.ov, (1, 2), (2, 0, 1)) * -1
    r2new.bab += einsum(r2.bab, (0, 1, 2), ints.tmp149, (3, 1, 4, 0), (4, 3, 2))
    r2new.bab += einsum(tmp39, (0, 1, 2, 3), r2.bab, (3, 4, 1), (2, 4, 0)) * -1
    del tmp39
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp40, (3, 2, 4, 1), (0, 4, 3)) * -1
    del tmp40
    r2new.bab += einsum(tmp41, (0, 1), v.bbb.xov, (0, 2, 3), (3, 1, 2)) * -2
    del tmp41
    r2new.bab += einsum(tmp42, (0, 1), r2.bab, (0, 2, 3), (1, 2, 3)) * -2
    del tmp42
    r2new.bab += einsum(tmp4, (0, 1), r2.bab, (2, 0, 3), (2, 1, 3)) * -1
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp43, (2, 3), (0, 1, 3)) * -1
    del tmp43
    r2new.bab += einsum(tmp7, (0,), ints.tmp146, (0, 1, 2, 3), (3, 2, 1))
    r2new.aba = einsum(r1.b, (0,), ints.tmp58, (1, 2, 3, 0), (2, 3, 1)) * -1
    del ints.tmp58
    r2new.aba += einsum(r2.bbb, (0, 1, 2), ints.tmp113, (3, 2, 4, 1), (4, 0, 3)) * 2
    del ints.tmp113
    r2new.aba += einsum(f.aa.ov, (0, 1), r1.b, (2,), (1, 2, 0)) * -1
    r2new.aba += einsum(ints.tmp146, (0, 1, 2, 3), tmp31, (4, 0, 1), (2, 3, 4))
    del tmp31
    r2new.aba += einsum(r2.aba, (0, 1, 2), ints.tmp149, (3, 0, 4, 1), (3, 4, 2))
    del ints.tmp149
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp32, (3, 2, 4, 0), (4, 1, 3)) * -1
    del tmp32
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp33, (3, 2, 4, 1), (0, 4, 3)) * -1
    del tmp33
    r2new.aba += einsum(tmp36, (0, 1), v.baa.xov, (0, 2, 3), (3, 1, 2)) * -2
    del tmp36
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp10, (1, 3), (0, 3, 2)) * -1
    r2new.aba += einsum(tmp4, (0, 1), r2.aba, (0, 2, 3), (1, 2, 3)) * -1
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp30, (2, 3), (0, 1, 3)) * -1
    r2new.aba += einsum(ints.tmp146, (0, 1, 2, 3), tmp37, (1,), (2, 3, 0)) * 2
    del tmp37, ints.tmp146
    r2new.aaa = einsum(tmp14, (0, 1, 2), ints.tmp110, (2, 1, 3, 4), (4, 3, 0)) * 2
    del ints.tmp110, tmp14
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), ints.tmp126, (3, 1, 4, 0), (3, 4, 2)) * 2
    del ints.tmp126
    r2new.aaa += np.transpose(tmp26, (1, 2, 0))
    r2new.aaa += np.transpose(tmp26, (2, 1, 0)) * -1
    del tmp26
    r2new.aaa += np.transpose(tmp29, (1, 2, 0))
    r2new.aaa += np.transpose(tmp29, (2, 1, 0)) * -1
    del tmp29
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp30, (2, 3), (0, 1, 3)) * -2
    del tmp30
    r1new.b = einsum(r2.aba, (0, 1, 2), tmp8, (2, 0, 3, 1), (3,)) * -1
    del tmp8
    r1new.b += einsum(tmp9, (0, 1, 2, 3), r2.bbb, (2, 3, 0), (1,)) * -4
    del tmp9
    r1new.b += einsum(r2.bbb, (0, 1, 2), tmp3, (2, 1), (0,)) * 4
    r1new.b += einsum(r2.aba, (0, 1, 2), tmp2, (2, 0), (1,)) * -2
    r1new.b += einsum(r1.b, (0,), tmp10, (0, 1), (1,)) * -1
    del tmp10
    r1new.b += einsum(tmp13, (0,), f.bb.ov, (0, 1), (1,)) * -1
    del tmp13
    r1new.a = einsum(r2.bab, (0, 1, 2), tmp0, (2, 3, 1, 0), (3,)) * -1
    del tmp0
    r1new.a += einsum(r2.aaa, (0, 1, 2), tmp1, (2, 3, 0, 1), (3,)) * -4
    del tmp1
    r1new.a += einsum(tmp2, (0, 1), r2.aaa, (2, 1, 0), (2,)) * 4
    del tmp2
    r1new.a += einsum(tmp3, (0, 1), r2.bab, (1, 2, 0), (2,)) * -2
    del tmp3
    r1new.a += einsum(tmp4, (0, 1), r1.a, (0,), (1,)) * -1
    del tmp4
    r1new.a += einsum(tmp7, (0,), f.aa.ov, (0, 1), (1,)) * -1
    del tmp7

    return {f"r1new": r1new, f"r2new": r2new}

