"""
Code generated by `albert`:
https://github.com/obackhouse/albert

  * date: 2024-09-29T16:05:42.765972
  * python version: 3.10.15 (main, Sep  9 2024, 03:02:45) [GCC 11.4.0]
  * albert version: 0.0.0
  * caller: /opt/hostedtoolcache/Python/3.10.15/x64/lib/python3.10/site-packages/albert/codegen/einsum.py
  * node: fv-az1788-690
  * system: Linux
  * processor: x86_64
  * release: 6.8.0-1014-azure
"""

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, dirsum, Namespace


def energy(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:05:44.594754.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    e_cc : float
        Coupled cluster energy.
    """

    tmp0 = einsum(v.bbb.xov, (0, 1, 2), t1.bb, (1, 2), (0,))
    tmp1 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (1, 2), (0,)) * 0.5
    tmp1 += tmp0
    tmp3 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (3, 2), (0, 3, 1))
    tmp5 = einsum(v.bbb.xov, (0, 1, 2), t1.bb, (3, 2), (0, 3, 1))
    tmp2 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp2 += einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp2 += einsum(t1.aa, (0, 1), tmp1, (2,), (2, 0, 1))
    del tmp1
    tmp4 = np.copy(f.aa.ov)
    tmp4 += einsum(v.baa.xov, (0, 1, 2), tmp3, (0, 1, 3), (3, 2)) * -0.5
    del tmp3
    tmp6 = np.copy(f.bb.ov) * 2
    tmp6 += einsum(v.bbb.xov, (0, 1, 2), tmp5, (0, 1, 3), (3, 2)) * -1
    del tmp5
    tmp7 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (0, 3, 4))
    tmp7 += einsum(tmp0, (0,), t1.bb, (1, 2), (0, 1, 2)) * 0.5
    del tmp0
    e_cc = einsum(tmp2, (0, 1, 2), v.baa.xov, (0, 1, 2), ())
    del tmp2
    e_cc += einsum(tmp4, (0, 1), t1.aa, (0, 1), ())
    del tmp4
    e_cc += einsum(t1.bb, (0, 1), tmp6, (0, 1), ()) * 0.5
    del tmp6
    e_cc += einsum(v.bbb.xov, (0, 1, 2), tmp7, (0, 1, 2), ())
    del tmp7

    return e_cc

def update_amps(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:07:11.932861.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    t1new : Namespace of arrays
        Updated T1 residuals.
    t2new : Namespace of arrays
        Updated T2 residuals.
    """

    t1new = Namespace()
    t2new = Namespace()
    tmp6 = einsum(v.bbb.xov, (0, 1, 2), t1.bb, (1, 2), (0,))
    tmp5 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (1, 2), (0,))
    tmp21 = einsum(v.bbb.xov, (0, 1, 2), t1.bb, (3, 2), (0, 3, 1))
    tmp0 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (3, 2), (0, 3, 1))
    tmp9 = np.copy(tmp5)
    tmp9 += tmp6
    tmp44 = einsum(v.bbb.xvv, (0, 1, 2), t1.bb, (3, 2), (0, 3, 1))
    tmp143 = einsum(tmp21, (0, 1, 2), t1.bb, (2, 3), (0, 1, 3))
    tmp149 = einsum(v.bbb.xov, (0, 1, 2), t1.bb, (1, 3), (0, 3, 2))
    tmp36 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (0, 3, 4))
    tmp32 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (4, 1, 3))
    tmp7 = np.copy(tmp5)
    del tmp5
    tmp7 += tmp6
    del tmp6
    tmp22 = einsum(v.bbb.xov, (0, 1, 2), tmp21, (0, 1, 3), (3, 2))
    tmp80 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (1, 3), (0, 3, 2))
    tmp11 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp3 = einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp14 = einsum(tmp0, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp20 = einsum(v.baa.xvv, (0, 1, 2), t1.aa, (3, 2), (0, 3, 1))
    tmp78 = einsum(tmp0, (0, 1, 2), t1.aa, (2, 3), (0, 1, 3))
    tmp35 = einsum(v.bbb.xov, (0, 1, 2), tmp9, (0,), (1, 2))
    tmp166 = np.copy(tmp44)
    tmp166 += tmp143 * -1
    tmp202 = np.copy(v.bbb.xvv)
    tmp202 += np.transpose(tmp149, (0, 2, 1)) * -1
    tmp42 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp37 = np.copy(tmp32)
    tmp37 += tmp36 * 2
    tmp37 += einsum(tmp7, (0,), t1.bb, (1, 2), (0, 1, 2))
    tmp192 = np.copy(f.bb.ov) * -1
    tmp192 += tmp22
    tmp19 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp89 = np.copy(v.baa.xvv)
    tmp89 += np.transpose(tmp80, (0, 2, 1)) * -1
    tmp72 = np.copy(tmp11) * 2
    tmp72 += tmp3
    tmp72 += einsum(tmp7, (0,), t1.aa, (1, 2), (0, 1, 2))
    tmp74 = np.copy(f.aa.ov) * -1
    tmp74 += tmp14
    tmp87 = np.copy(tmp20)
    tmp87 += tmp78 * -1
    tmp197 = np.copy(v.bbb.xvv)
    tmp197 += np.transpose(tmp149, (0, 2, 1)) * -1
    tmp43 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp96 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp101 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp134 = np.copy(f.bb.ov)
    tmp134 += tmp22 * -1
    tmp134 += tmp35
    tmp222 = einsum(tmp21, (0, 1, 2), tmp21, (0, 3, 4), (3, 1, 4, 2))
    tmp167 = einsum(tmp166, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp203 = einsum(tmp21, (0, 1, 2), tmp202, (0, 3, 4), (1, 2, 3, 4))
    tmp209 = einsum(v.bbb.xoo, (0, 1, 2), tmp202, (0, 3, 4), (1, 2, 3, 4))
    del tmp202
    tmp159 = einsum(t1.bb, (0, 1), tmp42, (2, 0, 3, 4), (2, 3, 1, 4))
    tmp191 = einsum(v.bbb.xov, (0, 1, 2), tmp37, (0, 3, 2), (1, 3))
    tmp193 = einsum(tmp192, (0, 1), t1.bb, (2, 1), (0, 2))
    del tmp192
    tmp177 = einsum(v.bbb.xoo, (0, 1, 2), tmp9, (0,), (1, 2))
    tmp45 = einsum(v.bbb.xoo, (0, 1, 2), tmp21, (0, 2, 3), (1, 3))
    tmp187 = einsum(tmp21, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp146 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp15 = np.copy(f.aa.ov)
    tmp15 += tmp14 * -1
    tmp12 = np.copy(tmp11)
    tmp12 += tmp3 * 0.5
    tmp12 += einsum(tmp7, (0,), t1.aa, (1, 2), (0, 1, 2)) * 0.5
    tmp154 = einsum(t1.aa, (0, 1), v.baa.xoo, (2, 3, 0), (2, 3, 1))
    tmp39 = np.copy(f.bb.ov)
    tmp39 += tmp22 * -1
    tmp57 = np.copy(tmp20)
    tmp57 += tmp11 * 2
    tmp57 += tmp3
    tmp57 += einsum(tmp7, (0,), t1.aa, (1, 2), (0, 1, 2))
    tmp10 = einsum(v.baa.xov, (0, 1, 2), tmp9, (0,), (1, 2))
    tmp94 = einsum(t1.aa, (0, 1), tmp19, (2, 0, 3, 4), (2, 3, 1, 4))
    tmp98 = einsum(tmp89, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp18 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp73 = einsum(tmp72, (0, 1, 2), v.baa.xov, (0, 3, 2), (3, 1))
    del tmp72
    tmp75 = einsum(tmp74, (0, 1), t1.aa, (2, 1), (2, 0))
    del tmp74
    tmp113 = einsum(tmp0, (0, 1, 2), tmp0, (0, 3, 4), (1, 3, 2, 4))
    tmp81 = np.copy(v.baa.xvv)
    tmp81 += np.transpose(tmp80, (0, 2, 1)) * -1
    tmp51 = einsum(v.baa.xoo, (0, 1, 2), tmp9, (0,), (1, 2))
    tmp27 = einsum(v.baa.xoo, (0, 1, 2), tmp0, (0, 2, 3), (1, 3))
    tmp88 = einsum(tmp87, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp90 = einsum(tmp0, (0, 1, 2), tmp89, (0, 3, 4), (1, 2, 3, 4))
    del tmp89
    tmp68 = einsum(v.baa.xoo, (0, 1, 2), tmp0, (0, 3, 4), (3, 1, 2, 4))
    tmp200 = np.copy(tmp44) * -1
    tmp200 += tmp143
    tmp231 = einsum(v.bbb.xov, (0, 1, 2), tmp197, (0, 3, 4), (1, 4, 3, 2))
    tmp196 = np.copy(tmp44)
    tmp196 += tmp143 * -1
    tmp182 = np.copy(tmp44)
    tmp182 += tmp32
    tmp182 += tmp36 * 2
    tmp182 += einsum(tmp7, (0,), t1.bb, (1, 2), (0, 1, 2))
    tmp145 = einsum(tmp43, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 3, 4))
    tmp215 = np.copy(np.transpose(tmp96, (1, 0, 2, 3)))
    tmp215 += np.transpose(tmp96, (1, 0, 3, 2)) * -1
    tmp208 = np.copy(np.transpose(tmp101, (1, 0, 2, 3)))
    tmp208 += np.transpose(tmp101, (1, 0, 3, 2)) * -1
    tmp174 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp129 = np.copy(tmp32) * 0.5
    tmp129 += tmp36
    tmp185 = einsum(v.bbb.xoo, (0, 1, 2), tmp44, (0, 3, 4), (3, 1, 2, 4))
    tmp31 = einsum(v.bbb.xov, (0, 1, 2), tmp21, (0, 3, 4), (3, 1, 4, 2))
    tmp46 = einsum(tmp7, (0,), v.bbb.xoo, (0, 1, 2), (1, 2))
    tmp229 = einsum(tmp101, (0, 1, 2, 3), t2.bbbb, (4, 5, 3, 2), (4, 5, 1, 0))
    tmp217 = einsum(v.bbb.xoo, (0, 1, 2), tmp32, (0, 3, 4), (3, 1, 2, 4))
    tmp135 = einsum(tmp134, (0, 1), t1.bb, (0, 2), (2, 1))
    del tmp134
    tmp133 = einsum(v.bbb.xvv, (0, 1, 2), tmp9, (0,), (1, 2))
    tmp132 = einsum(tmp44, (0, 1, 2), v.bbb.xov, (0, 1, 3), (3, 2))
    tmp131 = np.copy(tmp32)
    tmp131 += tmp36 * 2
    tmp227 = einsum(tmp222, (0, 1, 2, 3), t1.bb, (2, 4), (1, 0, 3, 4))
    tmp224 = einsum(tmp21, (0, 1, 2), tmp44, (0, 3, 4), (1, 3, 2, 4))
    tmp213 = np.copy(np.transpose(tmp101, (1, 0, 2, 3)))
    tmp213 += np.transpose(tmp101, (1, 0, 3, 2)) * -1
    tmp204 = np.copy(np.transpose(tmp167, (1, 0, 3, 2))) * -1
    tmp204 += np.transpose(tmp203, (0, 1, 3, 2))
    del tmp203
    tmp144 = np.copy(v.bbb.xov)
    tmp144 += tmp44
    tmp144 += tmp143 * -1
    tmp219 = np.copy(tmp159)
    tmp219 += np.transpose(tmp209, (1, 0, 3, 2))
    tmp211 = np.copy(np.transpose(tmp96, (1, 0, 2, 3)))
    tmp211 += np.transpose(tmp96, (1, 0, 3, 2)) * -1
    tmp194 = np.copy(np.transpose(tmp191, (1, 0)))
    del tmp191
    tmp194 += np.transpose(tmp193, (1, 0)) * -1
    del tmp193
    tmp234 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp178 = np.copy(f.bb.oo)
    tmp178 += np.transpose(tmp45, (1, 0)) * -1
    tmp178 += np.transpose(tmp177, (1, 0))
    del tmp177
    tmp189 = einsum(tmp187, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp150 = np.copy(v.bbb.xvv)
    tmp150 += tmp149 * -1
    tmp141 = np.copy(v.baa.xvv)
    tmp141 += tmp80 * -1
    tmp162 = einsum(t1.bb, (0, 1), tmp146, (2, 0, 3, 4), (2, 3, 1, 4))
    tmp163 = np.copy(v.bbb.xvv)
    tmp163 += tmp149 * -1
    del tmp149
    tmp16 = einsum(tmp15, (0, 1), t1.aa, (2, 1), (2, 0)) * 0.5
    tmp13 = einsum(tmp12, (0, 1, 2), v.baa.xov, (0, 3, 2), (3, 1))
    del tmp12
    tmp147 = np.copy(v.baa.xvv)
    tmp147 += tmp80 * -1
    del tmp80
    tmp170 = einsum(v.bbb.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 4, 1, 2))
    tmp155 = np.copy(tmp154) * -1
    del tmp154
    tmp155 += tmp11 * 2
    tmp155 += tmp3
    tmp40 = einsum(tmp39, (0, 1), t1.bb, (2, 1), (2, 0)) * 0.5
    tmp38 = einsum(v.bbb.xov, (0, 1, 2), tmp37, (0, 3, 2), (1, 3)) * 0.5
    del tmp37
    tmp60 = einsum(tmp15, (0, 1), t1.aa, (0, 2), (2, 1))
    del tmp15
    tmp59 = einsum(v.baa.xvv, (0, 1, 2), tmp7, (0,), (1, 2))
    tmp58 = einsum(tmp57, (0, 1, 2), v.baa.xov, (0, 1, 3), (3, 2))
    del tmp57
    tmp97 = np.copy(np.transpose(tmp96, (1, 0, 2, 3))) * -1
    tmp97 += np.transpose(tmp96, (1, 0, 3, 2))
    tmp64 = np.copy(f.aa.ov)
    tmp64 += tmp14 * -1
    tmp64 += tmp10
    tmp110 = np.copy(tmp94)
    tmp110 += np.transpose(tmp98, (1, 0, 3, 2))
    tmp28 = einsum(tmp7, (0,), v.baa.xoo, (0, 1, 2), (1, 2))
    tmp102 = np.copy(np.transpose(tmp101, (1, 0, 2, 3))) * -1
    tmp102 += np.transpose(tmp101, (1, 0, 3, 2))
    tmp100 = einsum(t1.aa, (0, 1), tmp18, (2, 0, 3, 4), (2, 3, 1, 4))
    tmp120 = einsum(t2.aaaa, (0, 1, 2, 3), tmp96, (4, 5, 3, 2), (0, 1, 5, 4))
    tmp106 = np.copy(np.transpose(tmp101, (1, 0, 2, 3))) * -1
    tmp106 += np.transpose(tmp101, (1, 0, 3, 2))
    tmp83 = np.copy(v.baa.xov)
    tmp83 += tmp20
    tmp83 += tmp78 * -1
    tmp79 = np.copy(tmp20)
    tmp79 += tmp78 * -1
    tmp2 = einsum(v.baa.xov, (0, 1, 2), tmp0, (0, 3, 4), (3, 1, 4, 2))
    tmp48 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 1, 2, 4))
    tmp76 = np.copy(np.transpose(tmp73, (1, 0)))
    del tmp73
    tmp76 += tmp75 * -1
    del tmp75
    tmp62 = np.copy(tmp11) * 2
    tmp62 += tmp3
    tmp125 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp104 = np.copy(np.transpose(tmp96, (1, 0, 2, 3))) * -1
    tmp104 += np.transpose(tmp96, (1, 0, 3, 2))
    tmp117 = einsum(tmp113, (0, 1, 2, 3), t1.aa, (2, 4), (1, 0, 3, 4))
    tmp122 = einsum(v.baa.xov, (0, 1, 2), tmp81, (0, 3, 4), (1, 4, 3, 2))
    tmp66 = einsum(v.baa.xoo, (0, 1, 2), tmp20, (0, 3, 4), (3, 1, 2, 4))
    tmp52 = np.copy(f.aa.oo)
    tmp52 += np.transpose(tmp27, (1, 0)) * -1
    tmp52 += np.transpose(tmp51, (1, 0))
    del tmp51
    tmp91 = np.copy(np.transpose(tmp88, (1, 0, 3, 2))) * -1
    tmp91 += np.transpose(tmp90, (0, 1, 3, 2))
    del tmp90
    tmp115 = einsum(tmp20, (0, 1, 2), tmp0, (0, 3, 4), (3, 1, 4, 2))
    tmp85 = np.copy(tmp20) * -1
    tmp85 += tmp78
    del tmp78
    tmp70 = einsum(tmp68, (0, 1, 2, 3), t1.aa, (3, 4), (0, 1, 2, 4))
    tmp108 = einsum(tmp3, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp54 = np.copy(tmp11) * 2
    tmp54 += tmp3
    tmp25 = einsum(tmp7, (0,), v.baa.xov, (0, 1, 2), (1, 2))
    tmp33 = np.copy(t2.bbbb)
    tmp33 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -0.5
    tmp23 = einsum(tmp7, (0,), v.bbb.xov, (0, 1, 2), (1, 2))
    tmp4 = np.copy(t2.aaaa)
    tmp4 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -0.5
    tmp221 = einsum(tmp44, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 4, 2))
    tmp201 = einsum(tmp32, (0, 1, 2), tmp200, (0, 3, 4), (3, 1, 4, 2))
    del tmp200
    tmp232 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp232 += einsum(tmp231, (0, 1, 2, 3), t1.bb, (0, 4), (3, 2, 4, 1))
    del tmp231
    tmp198 = einsum(v.bbb.xov, (0, 1, 2), tmp196, (0, 3, 4), (3, 1, 4, 2)) * -1
    del tmp196
    tmp198 += einsum(tmp197, (0, 1, 2), tmp21, (0, 3, 4), (3, 4, 2, 1))
    tmp183 = np.copy(f.bb.vv) * -1
    tmp183 += einsum(v.bbb.xov, (0, 1, 2), tmp182, (0, 1, 3), (2, 3))
    del tmp182
    tmp183 += einsum(tmp7, (0,), v.bbb.xvv, (0, 1, 2), (1, 2)) * -1
    tmp183 += einsum(tmp39, (0, 1), t1.bb, (0, 2), (1, 2))
    del tmp39
    tmp216 = np.copy(tmp145)
    tmp216 += einsum(tmp215, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5))
    del tmp215
    tmp175 = np.copy(t2.bbbb)
    tmp175 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1)) * 2
    tmp206 = einsum(tmp166, (0, 1, 2), tmp32, (0, 3, 4), (3, 1, 4, 2))
    tmp210 = np.copy(tmp159)
    tmp210 += einsum(t2.bbbb, (0, 1, 2, 3), tmp208, (1, 4, 5, 3), (0, 4, 2, 5)) * -2
    del tmp208
    tmp210 += np.transpose(tmp209, (1, 0, 3, 2))
    del tmp209
    tmp176 = einsum(t2.bbbb, (0, 1, 2, 3), tmp174, (4, 0, 5, 1), (5, 4, 2, 3))
    tmp180 = einsum(tmp129, (0, 1, 2), v.bbb.xov, (0, 1, 3), (2, 3))
    tmp186 = einsum(t1.bb, (0, 1), tmp185, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp185
    tmp233 = einsum(t1.bb, (0, 1), tmp31, (2, 3, 0, 4), (2, 3, 1, 4))
    tmp223 = einsum(tmp222, (0, 1, 2, 3), t2.bbbb, (3, 2, 4, 5), (1, 0, 4, 5))
    del tmp222
    tmp181 = einsum(t1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * 2
    tmp181 += t2.bbbb * -1
    tmp47 = np.copy(f.bb.oo)
    tmp47 += np.transpose(tmp45, (1, 0)) * -1
    del tmp45
    tmp47 += np.transpose(tmp46, (1, 0))
    del tmp46
    tmp230 = einsum(tmp229, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 5), (1, 0, 4, 5)) * -1
    del tmp229
    tmp218 = einsum(t1.bb, (0, 1), tmp217, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp217
    tmp207 = einsum(tmp36, (0, 1, 2), tmp32, (0, 3, 4), (3, 1, 4, 2))
    tmp136 = np.copy(f.bb.vv)
    tmp136 += tmp132 * -1
    del tmp132
    tmp136 += np.transpose(tmp133, (1, 0))
    del tmp133
    tmp136 += np.transpose(tmp135, (1, 0)) * -1
    del tmp135
    tmp184 = einsum(tmp131, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp228 = einsum(tmp227, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 4, 3))
    del tmp227
    tmp225 = einsum(t1.bb, (0, 1), tmp224, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp224
    tmp214 = np.copy(tmp159) * 0.5
    tmp214 += einsum(t2.bbbb, (0, 1, 2, 3), tmp213, (1, 4, 5, 3), (0, 4, 2, 5)) * -1
    del tmp213
    tmp214 += einsum(v.bbb.xoo, (0, 1, 2), tmp197, (0, 3, 4), (1, 2, 4, 3)) * 0.5
    del tmp197
    tmp205 = einsum(tmp204, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp204
    tmp199 = einsum(v.bbb.xov, (0, 1, 2), tmp144, (0, 3, 4), (1, 3, 2, 4))
    tmp220 = einsum(tmp219, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp219
    tmp212 = np.copy(tmp145)
    tmp212 += einsum(tmp211, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5))
    del tmp211
    tmp188 = einsum(t2.bbbb, (0, 1, 2, 3), tmp187, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp187
    tmp195 = einsum(t2.bbbb, (0, 1, 2, 3), tmp194, (4, 1), (4, 0, 2, 3)) * -1
    del tmp194
    tmp226 = einsum(tmp44, (0, 1, 2), tmp44, (0, 3, 4), (3, 1, 4, 2))
    tmp235 = einsum(tmp234, (0, 1, 2, 3), t2.bbbb, (4, 5, 2, 3), (4, 5, 0, 1)) * -1
    del tmp234
    tmp179 = einsum(t2.bbbb, (0, 1, 2, 3), tmp178, (1, 4), (4, 0, 2, 3)) * -1
    del tmp178
    tmp190 = einsum(t1.bb, (0, 1), tmp189, (2, 0, 3, 4), (2, 3, 1, 4))
    del tmp189
    tmp151 = einsum(v.baa.xoo, (0, 1, 2), tmp150, (0, 3, 4), (1, 2, 4, 3))
    tmp142 = einsum(tmp141, (0, 1, 2), tmp21, (0, 3, 4), (3, 4, 2, 1))
    del tmp141
    tmp139 = einsum(v.bbb.xoo, (0, 1, 2), tmp20, (0, 3, 4), (3, 1, 2, 4))
    tmp160 = np.copy(np.transpose(tmp159, (1, 0, 3, 2)))
    tmp160 += einsum(v.bbb.xoo, (0, 1, 2), tmp150, (0, 3, 4), (1, 2, 4, 3))
    tmp130 = einsum(tmp129, (0, 1, 2), v.bbb.xov, (0, 1, 3), (2, 3)) * 2
    del tmp129
    tmp152 = np.copy(v.bbb.xov)
    tmp152 += tmp44
    tmp152 += tmp143 * -1
    del tmp143
    tmp168 = np.copy(np.transpose(tmp167, (1, 0, 2, 3))) * -1
    del tmp167
    tmp168 += einsum(tmp21, (0, 1, 2), tmp150, (0, 3, 4), (1, 2, 4, 3))
    tmp164 = einsum(t1.aa, (0, 1), tmp162, (0, 2, 3, 4), (2, 1, 4, 3))
    del tmp162
    tmp164 += einsum(tmp163, (0, 1, 2), v.baa.xvv, (0, 3, 4), (3, 4, 2, 1))
    del tmp163
    tmp137 = einsum(v.baa.xoo, (0, 1, 2), tmp21, (0, 3, 4), (1, 2, 3, 4))
    tmp140 = einsum(tmp0, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 2, 3, 4))
    tmp17 = np.copy(tmp13)
    del tmp13
    tmp17 += np.transpose(tmp16, (1, 0))
    del tmp16
    tmp138 = np.copy(t2.abab)
    tmp138 += einsum(t1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    tmp127 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp165 = np.copy(np.transpose(tmp88, (1, 0, 2, 3))) * -1
    del tmp88
    tmp165 += einsum(tmp0, (0, 1, 2), tmp147, (0, 3, 4), (1, 2, 4, 3))
    tmp173 = einsum(tmp0, (0, 1, 2), tmp44, (0, 3, 4), (1, 2, 3, 4))
    tmp148 = einsum(tmp146, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (1, 4, 2, 5))
    tmp148 += einsum(v.bbb.xoo, (0, 1, 2), tmp147, (0, 3, 4), (1, 2, 4, 3)) * -1
    tmp172 = einsum(v.baa.xoo, (0, 1, 2), tmp44, (0, 3, 4), (1, 2, 3, 4))
    tmp153 = einsum(tmp0, (0, 1, 2), tmp21, (0, 3, 4), (1, 2, 3, 4))
    tmp171 = einsum(tmp170, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 0, 5, 2))
    del tmp170
    tmp1 = einsum(tmp0, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp157 = einsum(t2.abab, (0, 1, 2, 3), tmp101, (1, 4, 5, 3), (0, 4, 2, 5)) * -1
    del tmp101
    tmp157 += einsum(v.bbb.xov, (0, 1, 2), tmp155, (0, 3, 4), (3, 1, 4, 2))
    tmp169 = einsum(tmp0, (0, 1, 2), tmp150, (0, 3, 4), (1, 2, 4, 3))
    del tmp150
    tmp156 = einsum(t2.aaaa, (0, 1, 2, 3), tmp96, (1, 4, 5, 3), (4, 0, 5, 2)) * 2
    del tmp96
    tmp156 += einsum(tmp155, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2)) * -1
    del tmp155
    tmp156 += einsum(v.baa.xoo, (0, 1, 2), tmp147, (0, 3, 4), (1, 2, 4, 3))
    del tmp147
    tmp41 = np.copy(tmp38)
    del tmp38
    tmp41 += np.transpose(tmp40, (1, 0))
    del tmp40
    tmp128 = np.copy(t2.abab)
    tmp128 += einsum(t1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1)) * 2
    tmp161 = einsum(t2.abab, (0, 1, 2, 3), tmp146, (4, 5, 2, 3), (0, 4, 1, 5))
    del tmp146
    tmp61 = np.copy(f.aa.vv) * -1
    tmp61 += tmp58
    del tmp58
    tmp61 += np.transpose(tmp59, (1, 0)) * -1
    del tmp59
    tmp61 += np.transpose(tmp60, (1, 0))
    del tmp60
    tmp158 = einsum(v.bbb.xoo, (0, 1, 2), tmp11, (0, 3, 4), (3, 1, 2, 4))
    tmp99 = np.copy(tmp94)
    tmp99 += einsum(tmp97, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 2), (4, 1, 5, 3)) * -2
    del tmp97
    tmp99 += np.transpose(tmp98, (1, 0, 3, 2))
    del tmp98
    tmp65 = np.copy(f.aa.vv)
    tmp65 += einsum(tmp20, (0, 1, 2), v.baa.xov, (0, 1, 3), (3, 2)) * -1
    tmp65 += einsum(v.baa.xvv, (0, 1, 2), tmp9, (0,), (1, 2))
    del tmp9
    tmp65 += einsum(t1.aa, (0, 1), tmp64, (0, 2), (2, 1)) * -1
    del tmp64
    tmp111 = einsum(t2.aaaa, (0, 1, 2, 3), tmp110, (4, 1, 5, 3), (0, 4, 2, 5))
    del tmp110
    tmp119 = einsum(tmp20, (0, 1, 2), tmp20, (0, 3, 4), (1, 3, 2, 4))
    tmp29 = np.copy(f.aa.oo)
    tmp29 += np.transpose(tmp27, (1, 0)) * -1
    del tmp27
    tmp29 += np.transpose(tmp28, (1, 0))
    del tmp28
    tmp103 = np.copy(tmp100)
    tmp103 += einsum(t2.abab, (0, 1, 2, 3), tmp102, (1, 4, 3, 5), (0, 4, 2, 5)) * -1
    del tmp102
    tmp121 = einsum(t2.aaaa, (0, 1, 2, 3), tmp120, (4, 5, 0, 1), (5, 4, 2, 3)) * -1
    del tmp120
    tmp107 = np.copy(tmp100)
    tmp107 += einsum(t2.abab, (0, 1, 2, 3), tmp106, (1, 4, 3, 5), (0, 4, 2, 5)) * -1
    del tmp106
    tmp84 = einsum(tmp83, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    del tmp83
    tmp82 = einsum(v.baa.xov, (0, 1, 2), tmp79, (0, 3, 4), (3, 1, 4, 2)) * -1
    del tmp79
    tmp82 += einsum(tmp0, (0, 1, 2), tmp81, (0, 3, 4), (1, 2, 4, 3))
    del tmp0
    tmp124 = einsum(tmp2, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    tmp50 = einsum(t2.aaaa, (0, 1, 2, 3), tmp48, (4, 0, 5, 1), (5, 4, 2, 3))
    tmp69 = einsum(tmp68, (0, 1, 2, 3), t2.aaaa, (1, 3, 4, 5), (0, 2, 4, 5))
    del tmp68
    tmp77 = einsum(t2.aaaa, (0, 1, 2, 3), tmp76, (4, 1), (0, 4, 2, 3)) * -1
    del tmp76
    tmp63 = einsum(tmp62, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp126 = einsum(t2.aaaa, (0, 1, 2, 3), tmp125, (4, 5, 2, 3), (0, 1, 4, 5)) * -1
    del tmp125
    tmp105 = np.copy(tmp94) * 0.5
    tmp105 += einsum(t2.aaaa, (0, 1, 2, 3), tmp104, (1, 4, 3, 5), (0, 4, 2, 5)) * -1
    del tmp104
    tmp105 += einsum(v.baa.xoo, (0, 1, 2), tmp81, (0, 3, 4), (1, 2, 4, 3)) * 0.5
    del tmp81
    tmp93 = einsum(tmp3, (0, 1, 2), tmp87, (0, 3, 4), (1, 3, 2, 4))
    tmp118 = einsum(t1.aa, (0, 1), tmp117, (2, 3, 0, 4), (2, 3, 1, 4))
    del tmp117
    tmp49 = np.copy(t2.aaaa)
    tmp49 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1)) * 2
    tmp114 = einsum(t2.aaaa, (0, 1, 2, 3), tmp113, (4, 5, 1, 0), (5, 4, 2, 3))
    del tmp113
    tmp123 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp123 += einsum(tmp122, (0, 1, 2, 3), t1.aa, (0, 4), (3, 2, 4, 1))
    del tmp122
    tmp67 = einsum(tmp66, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    del tmp66
    tmp53 = einsum(t2.aaaa, (0, 1, 2, 3), tmp52, (1, 4), (0, 4, 2, 3)) * -1
    tmp92 = einsum(tmp91, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 5, 2))
    del tmp91
    tmp116 = einsum(tmp115, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    del tmp115
    tmp86 = einsum(tmp85, (0, 1, 2), tmp3, (0, 3, 4), (3, 1, 4, 2))
    del tmp85
    tmp71 = einsum(tmp70, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    del tmp70
    tmp109 = einsum(tmp108, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3))
    del tmp108
    tmp95 = einsum(tmp3, (0, 1, 2), tmp11, (0, 3, 4), (3, 1, 4, 2))
    tmp55 = einsum(tmp54, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    del tmp54
    tmp112 = einsum(tmp20, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 3, 4, 2))
    tmp56 = einsum(t1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * 2
    tmp56 += t2.aaaa * -1
    tmp26 = np.copy(f.aa.ov)
    tmp26 += tmp14 * -1
    del tmp14
    tmp26 += tmp25
    del tmp25
    tmp30 = einsum(tmp21, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    del tmp21
    tmp34 = np.copy(tmp32)
    del tmp32
    tmp34 += einsum(tmp33, (0, 1, 2, 3), v.bbb.xov, (4, 0, 2), (4, 1, 3)) * 2
    del tmp33
    tmp34 += einsum(tmp7, (0,), t1.bb, (1, 2), (0, 1, 2))
    tmp24 = np.copy(f.bb.ov)
    tmp24 += tmp22 * -1
    del tmp22
    tmp24 += tmp23
    del tmp23
    tmp8 = np.copy(tmp3)
    del tmp3
    tmp8 += einsum(v.baa.xov, (0, 1, 2), tmp4, (1, 3, 2, 4), (0, 3, 4)) * 2
    del tmp4
    tmp8 += einsum(tmp7, (0,), t1.aa, (1, 2), (0, 1, 2))
    del tmp7
    t2new.bbbb = einsum(t2.bbbb, (0, 1, 2, 3), tmp47, (1, 4), (0, 4, 2, 3)) * -1
    t2new.bbbb += einsum(tmp174, (0, 1, 2, 3), tmp175, (0, 2, 4, 5), (1, 3, 5, 4)) * 0.5
    del tmp175
    t2new.bbbb += np.transpose(tmp176, (0, 1, 3, 2)) * -1
    del tmp176
    t2new.bbbb += np.transpose(tmp179, (1, 0, 3, 2)) * -1
    t2new.bbbb += einsum(tmp180, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 4, 0)) * -4
    del tmp180
    t2new.bbbb += np.transpose(tmp179, (0, 1, 3, 2)) * 2
    del tmp179
    t2new.bbbb += einsum(tmp174, (0, 1, 2, 3), tmp181, (0, 2, 4, 5), (1, 3, 5, 4)) * -0.5
    del tmp174, tmp181
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp183, (3, 4), (0, 1, 4, 2)) * 2
    del tmp183
    t2new.bbbb += tmp184
    t2new.bbbb += einsum(tmp136, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 4, 1)) * 2
    t2new.bbbb += np.transpose(tmp184, (0, 1, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp186, (1, 0, 3, 2))
    t2new.bbbb += np.transpose(tmp188, (1, 0, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp190, (1, 0, 2, 3))
    t2new.bbbb += np.transpose(tmp190, (1, 0, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp195, (1, 0, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp186, (1, 0, 2, 3)) * -1
    t2new.bbbb += np.transpose(tmp186, (0, 1, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp188, (0, 1, 3, 2)) * 2
    del tmp188
    t2new.bbbb += tmp190 * -1
    t2new.bbbb += np.transpose(tmp190, (0, 1, 3, 2))
    del tmp190
    t2new.bbbb += np.transpose(tmp195, (0, 1, 3, 2)) * 2
    del tmp195
    t2new.bbbb += tmp186
    del tmp186
    t2new.bbbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp198, (4, 1, 5, 3), (0, 4, 5, 2)) * 2
    del tmp198
    t2new.bbbb += tmp199
    t2new.bbbb += np.transpose(tmp201, (1, 0, 2, 3))
    t2new.bbbb += tmp205 * -2
    t2new.bbbb += np.transpose(tmp199, (1, 0, 2, 3)) * -1
    del tmp199
    t2new.bbbb += np.transpose(tmp206, (1, 0, 3, 2))
    t2new.bbbb += np.transpose(tmp159, (0, 1, 3, 2))
    t2new.bbbb += tmp207 * 2
    t2new.bbbb += np.transpose(tmp207, (1, 0, 3, 2)) * 2
    t2new.bbbb += einsum(tmp210, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5)) * -2
    del tmp210
    t2new.bbbb += einsum(tmp212, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5)) * -1
    del tmp212
    t2new.bbbb += np.transpose(tmp159, (1, 0, 3, 2)) * -1
    t2new.bbbb += np.transpose(tmp207, (0, 1, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp207, (1, 0, 2, 3)) * -2
    del tmp207
    t2new.bbbb += einsum(tmp214, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (4, 0, 2, 5)) * 4
    del tmp214
    t2new.bbbb += einsum(t2.abab, (0, 1, 2, 3), tmp216, (0, 4, 2, 5), (1, 4, 5, 3))
    del tmp216
    t2new.bbbb += np.transpose(tmp218, (1, 0, 3, 2))
    t2new.bbbb += tmp159 * -1
    t2new.bbbb += np.transpose(tmp220, (0, 1, 3, 2)) * 2
    t2new.bbbb += np.transpose(tmp218, (0, 1, 3, 2)) * -1
    del tmp218
    t2new.bbbb += np.transpose(tmp159, (1, 0, 2, 3))
    del tmp159
    t2new.bbbb += np.transpose(tmp220, (1, 0, 3, 2)) * -2
    del tmp220
    t2new.bbbb += np.transpose(tmp221, (0, 1, 3, 2))
    t2new.bbbb += np.transpose(tmp223, (0, 1, 3, 2)) * -2
    del tmp223
    t2new.bbbb += np.transpose(tmp225, (0, 1, 3, 2))
    t2new.bbbb += np.transpose(tmp225, (1, 0, 3, 2)) * -1
    t2new.bbbb += tmp226
    t2new.bbbb += np.transpose(tmp226, (0, 1, 3, 2)) * -1
    del tmp226
    t2new.bbbb += tmp228
    t2new.bbbb += np.transpose(tmp228, (0, 1, 3, 2)) * -1
    del tmp228
    t2new.bbbb += np.transpose(tmp221, (1, 0, 3, 2)) * -1
    del tmp221
    t2new.bbbb += tmp230 * 2
    del tmp230
    t2new.bbbb += einsum(tmp232, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (4, 5, 3, 2)) * 2
    del tmp232
    t2new.bbbb += np.transpose(tmp184, (1, 0, 2, 3)) * -1
    t2new.bbbb += np.transpose(tmp184, (1, 0, 3, 2))
    del tmp184
    t2new.bbbb += np.transpose(tmp233, (1, 0, 2, 3))
    t2new.bbbb += np.transpose(tmp205, (1, 0, 3, 2)) * -2
    t2new.bbbb += np.transpose(tmp201, (1, 0, 3, 2)) * -1
    del tmp201
    t2new.bbbb += tmp233 * -1
    del tmp233
    t2new.bbbb += np.transpose(tmp205, (0, 1, 3, 2)) * 2
    del tmp205
    t2new.bbbb += np.transpose(tmp206, (1, 0, 2, 3)) * -1
    del tmp206
    t2new.bbbb += einsum(t1.bb, (0, 1), tmp235, (2, 3, 0, 4), (2, 3, 1, 4)) * -2
    del tmp235
    t2new.bbbb += tmp225 * -1
    t2new.bbbb += np.transpose(tmp225, (1, 0, 2, 3))
    del tmp225
    t2new.abab = einsum(t2.abab, (0, 1, 2, 3), tmp47, (1, 4), (0, 4, 2, 3)) * -1
    t2new.abab += einsum(tmp127, (0, 1, 2, 3), tmp128, (0, 2, 4, 5), (1, 3, 4, 5)) * 0.5
    del tmp128
    t2new.abab += einsum(tmp127, (0, 1, 2, 3), t2.abab, (1, 3, 4, 5), (0, 2, 4, 5)) * 0.5
    del tmp127
    t2new.abab += einsum(tmp130, (0, 1), t2.abab, (2, 3, 4, 1), (2, 3, 4, 0)) * -1
    del tmp130
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp52, (0, 4), (4, 1, 2, 3)) * -1
    del tmp52
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp61, (2, 4), (0, 1, 4, 3)) * -1
    t2new.abab += einsum(tmp131, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    del tmp131
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp136, (3, 4), (0, 1, 2, 4))
    del tmp136
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp41, (1, 4), (0, 4, 2, 3)) * -2
    t2new.abab += einsum(tmp138, (0, 1, 2, 3), tmp137, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp137
    t2new.abab += einsum(tmp139, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4)) * -1
    del tmp139
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp17, (0, 4), (4, 1, 2, 3)) * -2
    t2new.abab += einsum(tmp138, (0, 1, 2, 3), tmp140, (4, 0, 1, 5), (4, 5, 2, 3))
    del tmp140
    t2new.abab += einsum(tmp142, (0, 1, 2, 3), t2.abab, (4, 1, 2, 5), (4, 0, 3, 5)) * -1
    del tmp142
    t2new.abab += einsum(v.baa.xov, (0, 1, 2), tmp144, (0, 3, 4), (1, 3, 2, 4))
    del tmp144
    t2new.abab += tmp145 * -1
    del tmp145
    t2new.abab += einsum(tmp148, (0, 1, 2, 3), t2.abab, (4, 0, 2, 5), (4, 1, 3, 5))
    del tmp148
    t2new.abab += tmp100 * -1
    del tmp100
    t2new.abab += einsum(tmp151, (0, 1, 2, 3), t2.abab, (0, 4, 5, 2), (1, 4, 5, 3)) * -1
    del tmp151
    t2new.abab += einsum(tmp152, (0, 1, 2), tmp20, (0, 3, 4), (3, 1, 4, 2))
    del tmp152
    t2new.abab += einsum(tmp138, (0, 1, 2, 3), tmp153, (4, 0, 5, 1), (4, 5, 2, 3))
    del tmp138, tmp153
    t2new.abab += einsum(tmp156, (0, 1, 2, 3), t2.abab, (0, 4, 2, 5), (1, 4, 3, 5)) * -1
    del tmp156
    t2new.abab += einsum(tmp157, (0, 1, 2, 3), t2.bbbb, (4, 1, 5, 3), (0, 4, 2, 5)) * 2
    del tmp157
    t2new.abab += einsum(v.bbb.xov, (0, 1, 2), tmp62, (0, 3, 4), (3, 1, 4, 2))
    del tmp62
    t2new.abab += einsum(tmp158, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4)) * -2
    del tmp158
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp160, (1, 4, 3, 5), (0, 4, 2, 5)) * -1
    del tmp160
    t2new.abab += einsum(tmp161, (0, 1, 2, 3), t2.abab, (1, 3, 4, 5), (0, 2, 4, 5))
    del tmp161
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp164, (2, 4, 3, 5), (0, 1, 4, 5))
    del tmp164
    t2new.abab += einsum(tmp165, (0, 1, 2, 3), t2.abab, (1, 4, 2, 5), (0, 4, 3, 5)) * -1
    del tmp165
    t2new.abab += einsum(tmp87, (0, 1, 2), tmp36, (0, 3, 4), (1, 3, 2, 4)) * 2
    del tmp36, tmp87
    t2new.abab += einsum(t2.abab, (0, 1, 2, 3), tmp168, (4, 1, 3, 5), (0, 4, 2, 5)) * -1
    del tmp168
    t2new.abab += einsum(tmp166, (0, 1, 2), tmp11, (0, 3, 4), (3, 1, 4, 2)) * 2
    del tmp11, tmp166
    t2new.abab += einsum(t1.aa, (0, 1), tmp1, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    t2new.abab += einsum(tmp169, (0, 1, 2, 3), t2.abab, (1, 4, 5, 2), (0, 4, 5, 3)) * -1
    del tmp169
    t2new.abab += einsum(tmp171, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3)) * -1
    del tmp171
    t2new.abab += einsum(tmp172, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -1
    del tmp172
    t2new.abab += einsum(tmp173, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3)) * -1
    del tmp173
    t2new.aaaa = einsum(t2.aaaa, (0, 1, 2, 3), tmp29, (1, 4), (0, 4, 2, 3)) * -1
    t2new.aaaa += einsum(tmp48, (0, 1, 2, 3), tmp49, (0, 2, 4, 5), (1, 3, 5, 4)) * 0.5
    del tmp49
    t2new.aaaa += np.transpose(tmp50, (0, 1, 3, 2)) * -1
    del tmp50
    t2new.aaaa += np.transpose(tmp53, (0, 1, 3, 2)) * -1
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp55, (4, 3), (0, 1, 2, 4)) * -2
    del tmp55
    t2new.aaaa += np.transpose(tmp53, (1, 0, 3, 2)) * 2
    del tmp53
    t2new.aaaa += einsum(tmp48, (0, 1, 2, 3), tmp56, (0, 2, 4, 5), (1, 3, 5, 4)) * -0.5
    del tmp48, tmp56
    t2new.aaaa += einsum(tmp61, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 1, 4)) * 2
    del tmp61
    t2new.aaaa += tmp63
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp65, (3, 4), (0, 1, 2, 4)) * 2
    del tmp65
    t2new.aaaa += np.transpose(tmp63, (0, 1, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp67, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp69, (1, 0, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp71, (1, 0, 2, 3))
    t2new.aaaa += np.transpose(tmp71, (1, 0, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp77, (0, 1, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp67, (1, 0, 2, 3)) * -1
    t2new.aaaa += np.transpose(tmp67, (0, 1, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp69, (0, 1, 3, 2)) * 2
    del tmp69
    t2new.aaaa += tmp71 * -1
    t2new.aaaa += np.transpose(tmp71, (0, 1, 3, 2))
    del tmp71
    t2new.aaaa += np.transpose(tmp77, (1, 0, 3, 2)) * 2
    del tmp77
    t2new.aaaa += tmp67
    del tmp67
    t2new.aaaa += einsum(tmp82, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (4, 0, 2, 5)) * 2
    del tmp82
    t2new.aaaa += tmp84
    t2new.aaaa += np.transpose(tmp86, (0, 1, 3, 2))
    t2new.aaaa += np.transpose(tmp92, (1, 0, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp84, (1, 0, 2, 3)) * -1
    del tmp84
    t2new.aaaa += np.transpose(tmp93, (1, 0, 3, 2))
    t2new.aaaa += np.transpose(tmp94, (0, 1, 3, 2))
    t2new.aaaa += tmp95 * 2
    t2new.aaaa += np.transpose(tmp95, (1, 0, 3, 2)) * 2
    t2new.aaaa += einsum(tmp99, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (0, 4, 2, 5)) * -2
    del tmp99
    t2new.aaaa += einsum(tmp103, (0, 1, 2, 3), t2.abab, (4, 1, 5, 3), (0, 4, 2, 5)) * -1
    del tmp103
    t2new.aaaa += np.transpose(tmp94, (1, 0, 3, 2)) * -1
    t2new.aaaa += np.transpose(tmp95, (0, 1, 3, 2)) * -2
    t2new.aaaa += np.transpose(tmp95, (1, 0, 2, 3)) * -2
    del tmp95
    t2new.aaaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp105, (4, 1, 5, 3), (0, 4, 5, 2)) * 4
    del tmp105
    t2new.aaaa += einsum(t2.abab, (0, 1, 2, 3), tmp107, (4, 1, 5, 3), (0, 4, 5, 2))
    del tmp107
    t2new.aaaa += np.transpose(tmp109, (1, 0, 3, 2))
    t2new.aaaa += tmp94 * -1
    t2new.aaaa += np.transpose(tmp111, (1, 0, 2, 3)) * 2
    t2new.aaaa += np.transpose(tmp109, (0, 1, 3, 2)) * -1
    del tmp109
    t2new.aaaa += np.transpose(tmp94, (1, 0, 2, 3))
    del tmp94
    t2new.aaaa += tmp111 * -2
    del tmp111
    t2new.aaaa += np.transpose(tmp112, (0, 1, 3, 2))
    t2new.aaaa += np.transpose(tmp114, (0, 1, 3, 2)) * -2
    del tmp114
    t2new.aaaa += np.transpose(tmp116, (0, 1, 3, 2))
    t2new.aaaa += np.transpose(tmp116, (1, 0, 3, 2)) * -1
    t2new.aaaa += tmp118
    t2new.aaaa += np.transpose(tmp118, (0, 1, 3, 2)) * -1
    del tmp118
    t2new.aaaa += tmp119
    t2new.aaaa += np.transpose(tmp119, (0, 1, 3, 2)) * -1
    del tmp119
    t2new.aaaa += np.transpose(tmp112, (1, 0, 3, 2)) * -1
    del tmp112
    t2new.aaaa += tmp121 * 2
    del tmp121
    t2new.aaaa += einsum(tmp123, (0, 1, 2, 3), t2.aaaa, (4, 5, 0, 1), (4, 5, 3, 2)) * 2
    del tmp123
    t2new.aaaa += np.transpose(tmp63, (1, 0, 2, 3)) * -1
    t2new.aaaa += np.transpose(tmp63, (1, 0, 3, 2))
    del tmp63
    t2new.aaaa += np.transpose(tmp124, (1, 0, 2, 3))
    t2new.aaaa += tmp92 * -2
    t2new.aaaa += tmp86 * -1
    del tmp86
    t2new.aaaa += tmp124 * -1
    del tmp124
    t2new.aaaa += np.transpose(tmp92, (1, 0, 2, 3)) * 2
    del tmp92
    t2new.aaaa += np.transpose(tmp93, (1, 0, 2, 3)) * -1
    del tmp93
    t2new.aaaa += einsum(tmp126, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3)) * -2
    del tmp126
    t2new.aaaa += tmp116 * -1
    t2new.aaaa += np.transpose(tmp116, (1, 0, 2, 3))
    del tmp116
    t1new.bb = np.copy(f.bb.ov)
    t1new.bb += einsum(tmp30, (0, 1, 2, 3), t2.abab, (0, 2, 3, 4), (1, 4)) * -1
    del tmp30
    t1new.bb += einsum(f.bb.vv, (0, 1), t1.bb, (2, 1), (2, 0))
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), tmp31, (4, 1, 0, 3), (4, 2)) * -2
    del tmp31
    t1new.bb += einsum(tmp34, (0, 1, 2), v.bbb.xvv, (0, 3, 2), (1, 3))
    del tmp34
    t1new.bb += tmp35
    del tmp35
    t1new.bb += einsum(tmp41, (0, 1), t1.bb, (0, 2), (1, 2)) * -2
    del tmp41
    t1new.bb += einsum(tmp42, (0, 1, 2, 3), t2.bbbb, (1, 2, 4, 3), (0, 4)) * -2
    del tmp42
    t1new.bb += einsum(tmp43, (0, 1, 2, 3), t2.abab, (0, 2, 3, 4), (1, 4)) * -1
    del tmp43
    t1new.bb += einsum(v.bbb.xoo, (0, 1, 2), tmp44, (0, 2, 3), (1, 3)) * -1
    del tmp44
    t1new.bb += einsum(t2.abab, (0, 1, 2, 3), tmp26, (0, 2), (1, 3))
    t1new.bb += einsum(t2.bbbb, (0, 1, 2, 3), tmp24, (1, 3), (0, 2)) * 2
    t1new.bb += einsum(tmp47, (0, 1), t1.bb, (0, 2), (1, 2)) * -1
    del tmp47
    t1new.aa = np.copy(f.aa.ov)
    t1new.aa += einsum(t1.aa, (0, 1), f.aa.vv, (2, 1), (0, 2))
    t1new.aa += einsum(t2.abab, (0, 1, 2, 3), tmp1, (4, 0, 1, 3), (4, 2)) * -1
    del tmp1
    t1new.aa += einsum(t2.aaaa, (0, 1, 2, 3), tmp2, (4, 1, 0, 3), (4, 2)) * -2
    del tmp2
    t1new.aa += einsum(tmp8, (0, 1, 2), v.baa.xvv, (0, 3, 2), (1, 3))
    del tmp8
    t1new.aa += tmp10
    del tmp10
    t1new.aa += einsum(t1.aa, (0, 1), tmp17, (0, 2), (2, 1)) * -2
    del tmp17
    t1new.aa += einsum(t2.abab, (0, 1, 2, 3), tmp18, (4, 0, 1, 3), (4, 2)) * -1
    del tmp18
    t1new.aa += einsum(t2.aaaa, (0, 1, 2, 3), tmp19, (4, 0, 1, 3), (4, 2)) * -2
    del tmp19
    t1new.aa += einsum(tmp20, (0, 1, 2), v.baa.xoo, (0, 3, 1), (3, 2)) * -1
    del tmp20
    t1new.aa += einsum(t2.abab, (0, 1, 2, 3), tmp24, (1, 3), (0, 2))
    del tmp24
    t1new.aa += einsum(t2.aaaa, (0, 1, 2, 3), tmp26, (1, 3), (0, 2)) * 2
    del tmp26
    t1new.aa += einsum(t1.aa, (0, 1), tmp29, (0, 2), (2, 1)) * -1
    del tmp29

    return {f"t1new": t1new, f"t2new": t2new}

def update_lams(f=None, l1=None, l2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:09:52.203814.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    l1new : Namespace of arrays
        Updated L1 residuals.
    l2new : Namespace of arrays
        Updated L2 residuals.
    """

    l1new = Namespace()
    l2new = Namespace()
    tmp12 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (1, 2), (0,))
    tmp13 = einsum(v.bbb.xov, (0, 1, 2), t1.bb, (1, 2), (0,))
    tmp4 = einsum(v.bbb.xov, (0, 1, 2), t1.bb, (3, 2), (0, 3, 1))
    tmp14 = np.copy(tmp12)
    tmp14 += tmp13
    tmp1 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (3, 2), (0, 3, 1))
    tmp43 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    tmp44 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 0, 1), (4, 2))
    tmp8 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (4, 1, 3))
    tmp9 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (0, 3, 4))
    tmp7 = einsum(v.bbb.xvv, (0, 1, 2), t1.bb, (3, 2), (0, 3, 1))
    tmp25 = einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp24 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp27 = einsum(v.baa.xvv, (0, 1, 2), t1.aa, (3, 2), (0, 3, 1))
    tmp103 = einsum(v.bbb.xov, (0, 1, 2), tmp4, (0, 1, 3), (3, 2))
    tmp104 = einsum(v.bbb.xov, (0, 1, 2), tmp14, (0,), (1, 2))
    tmp15 = einsum(v.baa.xov, (0, 1, 2), tmp14, (0,), (1, 2))
    tmp11 = einsum(v.baa.xov, (0, 1, 2), tmp1, (0, 1, 3), (3, 2))
    tmp35 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 0, 1), (4, 2))
    tmp36 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    tmp64 = einsum(l1.bb, (0, 1), t1.bb, (2, 0), (1, 2))
    tmp66 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    tmp65 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    tmp54 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    tmp53 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 1), (4, 0))
    tmp52 = einsum(t1.aa, (0, 1), l1.aa, (1, 2), (2, 0))
    tmp118 = np.copy(tmp43)
    tmp118 += tmp44 * 2
    tmp206 = np.copy(tmp7)
    tmp206 += tmp8
    tmp206 += tmp9 * 2
    tmp161 = np.copy(v.bbb.xov)
    tmp161 += tmp7
    tmp161 += tmp8
    tmp161 += tmp9 * 2
    tmp50 = einsum(l2.abab, (0, 1, 2, 3), t1.aa, (4, 0), (2, 4, 3, 1))
    tmp62 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp159 = np.copy(v.baa.xov)
    tmp159 += tmp27
    tmp159 += tmp24 * 2
    tmp159 += tmp25
    tmp98 = np.copy(tmp12)
    del tmp12
    tmp98 += tmp13
    del tmp13
    tmp105 = np.copy(f.bb.ov)
    tmp105 += tmp103 * -1
    tmp105 += tmp104
    tmp123 = np.copy(tmp8) * 0.5
    tmp123 += tmp9
    tmp60 = einsum(l2.abab, (0, 1, 2, 3), t1.bb, (4, 1), (2, 3, 4, 0))
    tmp172 = np.copy(tmp27) * 0.5
    tmp172 += tmp24
    tmp172 += tmp25 * 0.5
    tmp74 = np.copy(tmp24) * 2
    tmp74 += tmp25
    tmp16 = np.copy(f.aa.ov)
    tmp16 += tmp11 * -1
    tmp16 += tmp15
    tmp48 = einsum(t1.aa, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp37 = np.copy(tmp35)
    tmp37 += tmp36 * 0.5
    tmp67 = np.copy(tmp64)
    tmp67 += tmp65
    tmp67 += tmp66 * 2
    tmp55 = np.copy(tmp52) * 0.5
    tmp55 += tmp53
    tmp55 += tmp54 * 0.5
    tmp17 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp112 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp29 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp119 = einsum(v.bbb.xov, (0, 1, 2), tmp118, (3, 2), (0, 1, 3))
    tmp197 = np.copy(v.bbb.xoo)
    tmp197 += np.transpose(tmp4, (0, 2, 1))
    tmp208 = einsum(v.bbb.xvv, (0, 1, 2), tmp14, (0,), (1, 2))
    tmp207 = einsum(v.bbb.xov, (0, 1, 2), tmp206, (0, 1, 3), (3, 2))
    del tmp206
    tmp194 = einsum(l2.bbbb, (0, 1, 2, 3), tmp161, (4, 3, 1), (4, 2, 0))
    tmp130 = einsum(tmp50, (0, 1, 2, 3), tmp1, (4, 0, 1), (4, 2, 3))
    tmp131 = einsum(tmp62, (0, 1, 2, 3), tmp4, (4, 1, 2), (4, 0, 3))
    tmp128 = einsum(tmp50, (0, 1, 2, 3), v.baa.xoo, (4, 1, 0), (4, 2, 3))
    tmp129 = einsum(tmp62, (0, 1, 2, 3), v.bbb.xoo, (4, 2, 0), (4, 1, 3)) * -1
    tmp193 = einsum(l2.abab, (0, 1, 2, 3), tmp159, (4, 2, 0), (4, 3, 1))
    tmp192 = einsum(l1.bb, (0, 1), v.bbb.xvv, (2, 3, 0), (2, 1, 3))
    tmp141 = einsum(t1.bb, (0, 1), tmp62, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp140 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp199 = einsum(tmp98, (0,), v.bbb.xov, (0, 1, 2), (1, 2))
    tmp135 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp134 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 5), (3, 4, 1, 5))
    tmp126 = einsum(tmp105, (0, 1), t1.bb, (2, 1), (0, 2))
    tmp124 = einsum(v.bbb.xov, (0, 1, 2), tmp123, (0, 3, 2), (3, 1)) * 2
    del tmp123
    tmp125 = einsum(v.bbb.xoo, (0, 1, 2), tmp14, (0,), (1, 2))
    tmp122 = einsum(tmp4, (0, 1, 2), v.bbb.xoo, (0, 3, 1), (3, 2))
    tmp86 = einsum(tmp60, (0, 1, 2, 3), t1.aa, (4, 3), (0, 4, 1, 2))
    tmp95 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 5, 0, 1), (2, 4, 3, 5))
    tmp149 = np.copy(v.baa.xoo)
    tmp149 += np.transpose(tmp1, (0, 2, 1))
    tmp173 = einsum(tmp172, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp174 = einsum(v.baa.xvv, (0, 1, 2), tmp14, (0,), (1, 2)) * 0.5
    tmp165 = einsum(tmp98, (0,), v.baa.xov, (0, 1, 2), (1, 2))
    tmp73 = einsum(v.baa.xoo, (0, 1, 2), tmp1, (0, 2, 3), (1, 3))
    tmp75 = einsum(tmp74, (0, 1, 2), v.baa.xov, (0, 3, 2), (3, 1))
    tmp77 = einsum(tmp16, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp76 = einsum(v.baa.xoo, (0, 1, 2), tmp14, (0,), (1, 2))
    tmp81 = einsum(tmp48, (0, 1, 2, 3), tmp1, (4, 0, 2), (4, 1, 3)) * -1
    tmp160 = einsum(tmp159, (0, 1, 2), l2.aaaa, (3, 2, 4, 1), (0, 4, 3))
    del tmp159
    tmp162 = einsum(l2.abab, (0, 1, 2, 3), tmp161, (4, 3, 1), (4, 2, 0))
    del tmp161
    tmp153 = einsum(v.baa.xvv, (0, 1, 2), l1.aa, (2, 3), (0, 3, 1))
    tmp82 = einsum(tmp60, (0, 1, 2, 3), tmp4, (4, 1, 2), (4, 0, 3))
    tmp80 = einsum(v.bbb.xoo, (0, 1, 2), tmp60, (3, 2, 1, 4), (0, 3, 4))
    tmp79 = einsum(v.baa.xoo, (0, 1, 2), tmp48, (2, 3, 1, 4), (0, 3, 4)) * -1
    tmp88 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 5, 1), (5, 0, 4, 2))
    tmp89 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp146 = einsum(tmp37, (0, 1), v.baa.xov, (2, 3, 1), (2, 3, 0)) * 2
    tmp93 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp85 = einsum(tmp48, (0, 1, 2, 3), t1.aa, (4, 3), (1, 0, 2, 4))
    tmp61 = einsum(tmp60, (0, 1, 2, 3), t2.abab, (0, 1, 3, 4), (2, 4))
    tmp68 = einsum(tmp67, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp59 = einsum(l1.bb, (0, 1), t2.bbbb, (2, 1, 3, 0), (2, 3))
    tmp63 = einsum(tmp62, (0, 1, 2, 3), t2.bbbb, (1, 0, 4, 3), (2, 4))
    tmp58 = einsum(t2.abab, (0, 1, 2, 3), l1.aa, (2, 0), (1, 3))
    tmp40 = einsum(t1.aa, (0, 1), l1.aa, (2, 0), (2, 1))
    tmp42 = einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp46 = einsum(l1.aa, (0, 1), t2.aaaa, (2, 1, 3, 0), (2, 3))
    tmp51 = einsum(tmp50, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (1, 4))
    tmp47 = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2))
    tmp49 = einsum(t2.aaaa, (0, 1, 2, 3), tmp48, (1, 0, 4, 3), (4, 2))
    tmp56 = einsum(t1.aa, (0, 1), tmp55, (0, 2), (2, 1))
    tmp94 = np.copy(v.bbb.xoo)
    tmp94 += np.transpose(tmp4, (0, 2, 1))
    tmp18 = einsum(t2.abab, (0, 1, 2, 3), tmp17, (4, 5, 2, 3), (0, 4, 1, 5))
    tmp2 = np.copy(v.baa.xoo)
    tmp2 += tmp1
    tmp5 = np.copy(v.bbb.xoo)
    tmp5 += tmp4
    tmp111 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp113 = einsum(tmp112, (0, 1, 2, 3), t2.bbbb, (4, 5, 2, 3), (4, 5, 1, 0)) * -1
    tmp115 = einsum(v.bbb.xoo, (0, 1, 2), tmp4, (0, 3, 4), (3, 1, 2, 4))
    tmp114 = einsum(tmp4, (0, 1, 2), tmp4, (0, 3, 4), (1, 3, 2, 4))
    tmp19 = np.copy(v.baa.xoo)
    tmp19 += np.transpose(tmp1, (0, 2, 1))
    tmp31 = einsum(tmp1, (0, 1, 2), tmp1, (0, 3, 4), (3, 1, 4, 2))
    tmp30 = einsum(t2.aaaa, (0, 1, 2, 3), tmp29, (4, 5, 2, 3), (0, 1, 5, 4)) * -1
    tmp32 = einsum(tmp1, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp28 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 1, 2, 4))
    tmp190 = np.copy(v.bbb.xov)
    tmp190 += tmp119 * -1
    tmp220 = einsum(tmp197, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp209 = np.copy(f.bb.vv) * -1
    tmp209 += tmp207
    del tmp207
    tmp209 += np.transpose(tmp208, (1, 0)) * -1
    del tmp208
    tmp195 = np.copy(tmp192)
    tmp195 += tmp128 * -1
    tmp195 += tmp129 * -2
    tmp195 += tmp130 * -1
    tmp195 += tmp131 * -2
    tmp195 += tmp193
    del tmp193
    tmp195 += tmp194 * 2
    del tmp194
    tmp142 = np.copy(np.transpose(tmp140, (1, 0, 3, 2)))
    del tmp140
    tmp142 += np.transpose(tmp141, (0, 1, 3, 2)) * -1
    del tmp141
    tmp210 = np.copy(f.bb.ov)
    tmp210 += tmp103 * -1
    tmp210 += tmp199
    tmp83 = np.copy(v.baa.xov)
    tmp83 += tmp27
    tmp83 += tmp24 * 2
    tmp83 += tmp25
    tmp10 = np.copy(v.bbb.xov)
    tmp10 += tmp7
    tmp10 += tmp8
    tmp10 += tmp9 * 2
    tmp239 = np.copy(tmp134)
    tmp239 += tmp135 * 4
    tmp217 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp108 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp216 = einsum(v.bbb.xov, (0, 1, 2), tmp4, (0, 3, 4), (3, 1, 4, 2))
    tmp228 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (3, 1, 2, 4))
    tmp198 = einsum(tmp197, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp127 = np.copy(f.bb.oo)
    tmp127 += tmp122 * -1
    del tmp122
    tmp127 += tmp124
    del tmp124
    tmp127 += np.transpose(tmp125, (1, 0))
    del tmp125
    tmp127 += np.transpose(tmp126, (1, 0))
    del tmp126
    tmp214 = einsum(v.bbb.xov, (0, 1, 2), tmp67, (3, 1), (0, 3, 2))
    tmp139 = np.copy(tmp95)
    tmp139 += tmp86
    tmp202 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp150 = einsum(tmp149, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp188 = einsum(v.baa.xov, (0, 1, 2), tmp55, (3, 1), (0, 3, 2)) * 2
    tmp182 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp175 = np.copy(f.aa.vv) * -0.5
    tmp175 += tmp173
    del tmp173
    tmp175 += np.transpose(tmp174, (1, 0)) * -1
    del tmp174
    tmp177 = np.copy(f.aa.ov)
    tmp177 += tmp11 * -1
    tmp177 += tmp165
    tmp38 = einsum(tmp37, (0, 1), v.baa.xov, (2, 3, 1), (2, 3, 0))
    del tmp37
    tmp167 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xvv, (0, 3, 4), (3, 1, 2, 4))
    tmp78 = np.copy(f.aa.oo)
    tmp78 += tmp73 * -1
    tmp78 += np.transpose(tmp75, (1, 0))
    del tmp75
    tmp78 += np.transpose(tmp76, (1, 0))
    del tmp76
    tmp78 += tmp77
    del tmp77
    tmp163 = np.copy(tmp153)
    tmp163 += tmp79 * -2
    tmp163 += tmp80 * -1
    tmp163 += tmp81 * -2
    tmp163 += tmp82 * -1
    tmp163 += tmp160 * 2
    del tmp160
    tmp163 += tmp162
    del tmp162
    tmp186 = np.copy(tmp88) * 4
    tmp186 += tmp89
    tmp147 = np.copy(v.baa.xov)
    tmp147 += tmp146 * -1
    del tmp146
    tmp170 = np.copy(np.transpose(tmp93, (1, 0, 3, 2)))
    tmp170 += np.transpose(tmp85, (0, 1, 3, 2)) * -1
    tmp22 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp157 = einsum(v.baa.xvv, (0, 1, 2), tmp149, (0, 3, 4), (3, 4, 1, 2))
    tmp184 = einsum(v.baa.xov, (0, 1, 2), tmp1, (0, 3, 4), (3, 1, 4, 2))
    tmp143 = np.copy(t1.bb) * -1
    tmp143 += tmp58 * -1
    tmp143 += tmp59 * -2
    tmp143 += tmp61
    tmp143 += tmp63 * 2
    tmp143 += tmp68
    tmp137 = einsum(l1.bb, (0, 1), t2.bbbb, (2, 3, 4, 0), (1, 2, 3, 4)) * -1
    tmp137 += einsum(t2.abab, (0, 1, 2, 3), tmp60, (0, 4, 5, 2), (4, 5, 1, 3)) * 0.5
    tmp137 += einsum(t2.bbbb, (0, 1, 2, 3), tmp62, (4, 1, 5, 3), (4, 5, 0, 2)) * -2
    tmp138 = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 4), (0, 4, 1, 2))
    tmp138 += einsum(tmp50, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (1, 2, 4, 5)) * -1
    tmp136 = np.copy(tmp134)
    del tmp134
    tmp136 += np.transpose(tmp135, (0, 1, 3, 2)) * 4
    del tmp135
    tmp133 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 5, 1), (3, 4, 0, 5))
    tmp41 = np.copy(tmp40) * 0.5
    del tmp40
    tmp41 += tmp35
    del tmp35
    tmp41 += np.transpose(tmp36, (1, 0)) * 0.5
    del tmp36
    tmp70 = np.copy(tmp52) * 0.5
    del tmp52
    tmp70 += np.transpose(tmp53, (1, 0))
    del tmp53
    tmp70 += tmp54 * 0.5
    del tmp54
    tmp69 = np.copy(np.transpose(l1.bb, (1, 0))) * -1
    tmp69 += t1.bb * -1
    tmp69 += tmp58 * -1
    del tmp58
    tmp69 += tmp59 * -2
    del tmp59
    tmp69 += tmp61
    del tmp61
    tmp69 += tmp63 * 2
    del tmp63
    tmp69 += tmp68
    del tmp68
    tmp71 = np.copy(tmp64)
    del tmp64
    tmp71 += tmp65
    del tmp65
    tmp71 += np.transpose(tmp66, (1, 0)) * 2
    del tmp66
    tmp45 = np.copy(tmp42)
    del tmp42
    tmp45 += tmp43
    del tmp43
    tmp45 += np.transpose(tmp44, (1, 0)) * 2
    del tmp44
    tmp57 = np.copy(np.transpose(l1.aa, (1, 0))) * -0.5
    tmp57 += t1.aa * -0.5
    tmp57 += tmp46 * -1
    tmp57 += tmp47 * -0.5
    tmp57 += tmp49
    tmp57 += tmp51 * 0.5
    tmp57 += tmp56
    tmp106 = np.copy(np.transpose(tmp18, (1, 0, 2, 3)))
    tmp106 += einsum(tmp94, (0, 1, 2), tmp2, (0, 3, 4), (4, 3, 2, 1))
    tmp100 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp101 = einsum(v.bbb.xov, (0, 1, 2), tmp2, (0, 3, 4), (4, 3, 1, 2))
    tmp102 = einsum(tmp5, (0, 1, 2), v.bbb.xov, (0, 3, 4), (2, 1, 3, 4))
    tmp116 = np.copy(np.transpose(tmp111, (3, 2, 1, 0)))
    tmp116 += np.transpose(tmp113, (2, 3, 1, 0))
    tmp116 += np.transpose(tmp114, (2, 3, 1, 0))
    tmp116 += np.transpose(tmp115, (1, 3, 0, 2))
    tmp116 += np.transpose(tmp115, (3, 2, 0, 1)) * -1
    tmp109 = einsum(tmp94, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp110 = np.copy(v.bbb.xov)
    tmp110 += tmp8
    del tmp8
    tmp110 += tmp9 * 2
    del tmp9
    tmp0 = einsum(v.bbb.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 4, 1, 2))
    tmp6 = einsum(tmp5, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 2, 1, 4))
    tmp20 = np.copy(np.transpose(tmp18, (0, 1, 3, 2)))
    tmp20 += einsum(tmp19, (0, 1, 2), tmp5, (0, 3, 4), (2, 1, 4, 3))
    tmp3 = einsum(tmp2, (0, 1, 2), v.baa.xov, (0, 3, 4), (2, 1, 3, 4))
    tmp91 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 4), (4, 0, 1, 2)) * -1
    tmp91 += einsum(t2.aaaa, (0, 1, 2, 3), tmp48, (4, 1, 5, 3), (4, 5, 0, 2)) * -2
    tmp91 += einsum(t2.abab, (0, 1, 2, 3), tmp50, (4, 5, 1, 3), (4, 5, 0, 2)) * 0.5
    tmp90 = np.copy(tmp88)
    del tmp88
    tmp90 += np.transpose(tmp89, (0, 1, 3, 2)) * 0.25
    del tmp89
    tmp87 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 5), (2, 4, 1, 5))
    tmp92 = einsum(t2.abab, (0, 1, 2, 3), l1.aa, (2, 4), (4, 0, 1, 3))
    tmp92 += einsum(tmp60, (0, 1, 2, 3), t2.abab, (4, 1, 3, 5), (0, 4, 2, 5)) * -1
    tmp96 = np.copy(t1.aa) * -0.5
    tmp96 += tmp46 * -1
    del tmp46
    tmp96 += tmp47 * -0.5
    del tmp47
    tmp96 += tmp49
    del tmp49
    tmp96 += tmp51 * 0.5
    del tmp51
    tmp96 += tmp56
    del tmp56
    tmp26 = np.copy(v.baa.xov)
    tmp26 += tmp24 * 2
    del tmp24
    tmp26 += tmp25
    del tmp25
    tmp23 = einsum(tmp19, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp33 = np.copy(np.transpose(tmp28, (3, 2, 1, 0)))
    tmp33 += np.transpose(tmp30, (2, 3, 1, 0))
    tmp33 += np.transpose(tmp31, (2, 3, 1, 0))
    tmp33 += np.transpose(tmp32, (1, 3, 0, 2))
    tmp33 += np.transpose(tmp32, (3, 2, 0, 1)) * -1
    tmp219 = einsum(tmp190, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp221 = einsum(tmp220, (0, 1, 2, 3), l1.bb, (4, 1), (2, 0, 3, 4))
    tmp232 = einsum(l2.bbbb, (0, 1, 2, 3), tmp209, (1, 4), (2, 3, 4, 0)) * -1
    tmp227 = einsum(tmp195, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp231 = einsum(tmp112, (0, 1, 2, 3), tmp142, (4, 5, 0, 1), (4, 5, 2, 3)) * 0.5
    tmp234 = einsum(tmp115, (0, 1, 2, 3), l2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    del tmp115
    tmp233 = einsum(tmp62, (0, 1, 2, 3), tmp210, (2, 4), (0, 1, 4, 3))
    tmp223 = np.copy(tmp192)
    del tmp192
    tmp223 += tmp128 * -1
    tmp223 += tmp129 * -2
    tmp223 += tmp130 * -1
    tmp223 += tmp131 * -2
    tmp223 += einsum(l2.abab, (0, 1, 2, 3), tmp83, (4, 2, 0), (4, 3, 1))
    tmp223 += einsum(tmp10, (0, 1, 2), l2.bbbb, (3, 2, 4, 1), (0, 4, 3)) * 2
    tmp240 = einsum(tmp112, (0, 1, 2, 3), tmp239, (4, 0, 5, 3), (4, 1, 5, 2))
    del tmp239
    tmp237 = einsum(tmp62, (0, 1, 2, 3), tmp217, (4, 0, 2, 5), (1, 4, 3, 5)) * -1
    tmp230 = einsum(tmp62, (0, 1, 2, 3), tmp108, (2, 4, 3, 5), (1, 0, 5, 4))
    tmp225 = np.copy(f.bb.ov)
    tmp225 += tmp104
    del tmp104
    tmp238 = einsum(tmp216, (0, 1, 2, 3), tmp62, (4, 0, 1, 5), (4, 2, 5, 3))
    tmp229 = einsum(tmp228, (0, 1, 2, 3), l2.bbbb, (3, 2, 4, 5), (4, 5, 0, 1))
    del tmp228
    tmp222 = einsum(tmp94, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (2, 1, 3, 4))
    tmp200 = np.copy(f.bb.ov)
    tmp200 += tmp199
    del tmp199
    tmp226 = einsum(l2.bbbb, (0, 1, 2, 3), tmp198, (4, 3, 1, 5), (4, 2, 5, 0))
    tmp224 = einsum(l2.bbbb, (0, 1, 2, 3), tmp127, (3, 4), (4, 2, 0, 1)) * -2
    tmp236 = einsum(v.bbb.xov, (0, 1, 2), tmp118, (3, 2), (0, 1, 3)) * -0.5
    del tmp118
    tmp241 = einsum(tmp214, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp235 = np.copy(np.transpose(tmp111, (3, 2, 1, 0)))
    del tmp111
    tmp235 += np.transpose(tmp113, (0, 3, 1, 2))
    del tmp113
    tmp235 += np.transpose(tmp114, (0, 3, 1, 2))
    del tmp114
    tmp166 = np.copy(f.aa.ov)
    tmp166 += tmp165
    del tmp165
    tmp211 = einsum(v.bbb.xov, (0, 1, 2), tmp149, (0, 3, 4), (3, 4, 1, 2))
    tmp201 = einsum(v.baa.xvv, (0, 1, 2), tmp197, (0, 3, 4), (4, 3, 1, 2))
    del tmp197
    tmp196 = np.copy(f.aa.oo) * 0.5
    tmp196 += tmp73 * -0.5
    del tmp73
    tmp196 += einsum(v.baa.xov, (0, 1, 2), tmp74, (0, 3, 2), (3, 1)) * 0.5
    del tmp74
    tmp196 += einsum(v.baa.xoo, (0, 1, 2), tmp14, (0,), (1, 2)) * 0.5
    tmp196 += einsum(tmp16, (0, 1), t1.aa, (2, 1), (2, 0)) * 0.5
    tmp204 = einsum(tmp17, (0, 1, 2, 3), tmp139, (4, 0, 5, 1), (4, 5, 2, 3)) * 0.5
    tmp218 = einsum(l2.aaaa, (0, 1, 2, 3), t2.abab, (3, 4, 1, 5), (2, 4, 0, 5))
    tmp218 += einsum(l2.abab, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp205 = np.copy(f.aa.vv) * -1
    tmp205 += einsum(tmp172, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3)) * 2
    del tmp172
    tmp205 += einsum(v.baa.xvv, (0, 1, 2), tmp14, (0,), (1, 2)) * -1
    del tmp14
    tmp215 = einsum(t2.aaaa, (0, 1, 2, 3), l2.abab, (3, 4, 1, 5), (0, 5, 2, 4))
    tmp215 += einsum(t2.abab, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 1), (0, 5, 2, 4))
    tmp212 = np.copy(tmp18)
    del tmp18
    tmp212 += einsum(tmp19, (0, 1, 2), tmp94, (0, 3, 4), (2, 1, 4, 3))
    tmp191 = einsum(tmp94, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp213 = einsum(tmp149, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (2, 1, 3, 4))
    del tmp149
    tmp203 = einsum(tmp202, (0, 1, 2, 3), l2.abab, (1, 2, 4, 5), (4, 5, 0, 3))
    del tmp202
    tmp151 = einsum(tmp150, (0, 1, 2, 3), l1.aa, (4, 1), (2, 0, 3, 4))
    tmp189 = einsum(v.baa.xov, (0, 1, 2), tmp188, (0, 3, 4), (3, 1, 4, 2))
    tmp183 = einsum(tmp182, (0, 1, 2, 3), tmp48, (1, 4, 2, 5), (4, 0, 5, 3)) * -1
    tmp180 = np.copy(np.transpose(tmp28, (3, 2, 1, 0)))
    del tmp28
    tmp180 += np.transpose(tmp30, (0, 3, 1, 2))
    del tmp30
    tmp180 += np.transpose(tmp31, (0, 3, 1, 2))
    del tmp31
    tmp176 = einsum(l2.aaaa, (0, 1, 2, 3), tmp175, (1, 4), (2, 3, 4, 0)) * -2
    del tmp175
    tmp178 = einsum(tmp48, (0, 1, 2, 3), tmp177, (2, 4), (0, 1, 4, 3))
    tmp152 = einsum(tmp19, (0, 1, 2), v.baa.xvv, (0, 3, 4), (2, 1, 3, 4))
    tmp181 = einsum(v.baa.xov, (0, 1, 2), tmp38, (0, 3, 4), (3, 1, 4, 2)) * -2
    tmp154 = np.copy(tmp153) * 0.5
    del tmp153
    tmp154 += tmp79 * -1
    tmp154 += tmp80 * -0.5
    tmp154 += tmp81 * -1
    tmp154 += tmp82 * -0.5
    tmp154 += einsum(l2.aaaa, (0, 1, 2, 3), tmp83, (4, 3, 1), (4, 2, 0))
    tmp154 += einsum(l2.abab, (0, 1, 2, 3), tmp10, (4, 3, 1), (4, 2, 0)) * 0.5
    tmp168 = einsum(tmp167, (0, 1, 2, 3), l2.aaaa, (3, 2, 4, 5), (4, 5, 0, 1))
    del tmp167
    tmp155 = einsum(l2.aaaa, (0, 1, 2, 3), tmp78, (3, 4), (2, 4, 0, 1)) * -2
    tmp164 = einsum(v.baa.xov, (0, 1, 2), tmp163, (0, 3, 4), (3, 1, 4, 2))
    tmp187 = einsum(tmp186, (0, 1, 2, 3), tmp29, (1, 4, 5, 3), (0, 4, 2, 5))
    del tmp186
    tmp148 = einsum(v.baa.xov, (0, 1, 2), tmp147, (0, 3, 4), (3, 1, 4, 2))
    del tmp147
    tmp171 = einsum(tmp29, (0, 1, 2, 3), tmp170, (4, 5, 0, 1), (4, 5, 2, 3)) * 0.5
    del tmp170
    tmp169 = einsum(tmp48, (0, 1, 2, 3), tmp22, (2, 4, 3, 5), (1, 0, 5, 4))
    tmp156 = np.copy(f.aa.ov)
    tmp156 += tmp15
    del tmp15
    tmp179 = einsum(l2.aaaa, (0, 1, 2, 3), tmp32, (2, 3, 4, 5), (4, 5, 0, 1))
    del tmp32
    tmp158 = einsum(tmp157, (0, 1, 2, 3), l2.aaaa, (4, 2, 5, 1), (0, 5, 3, 4))
    tmp185 = einsum(tmp184, (0, 1, 2, 3), tmp48, (4, 0, 1, 5), (4, 2, 5, 3))
    tmp132 = np.copy(tmp128) * -0.5
    del tmp128
    tmp132 += tmp129 * -1
    del tmp129
    tmp132 += tmp130 * -0.5
    del tmp130
    tmp132 += tmp131 * -1
    del tmp131
    tmp132 += einsum(l2.abab, (0, 1, 2, 3), tmp83, (4, 2, 0), (4, 3, 1)) * 0.5
    tmp132 += einsum(tmp10, (0, 1, 2), l2.bbbb, (3, 2, 4, 1), (0, 4, 3))
    tmp144 = einsum(tmp7, (0, 1, 2), l1.bb, (2, 3), (0, 1, 3))
    tmp144 += einsum(tmp133, (0, 1, 2, 3), v.baa.xvv, (4, 3, 2), (4, 1, 0))
    tmp144 += einsum(v.bbb.xvv, (0, 1, 2), tmp136, (3, 4, 1, 2), (0, 4, 3))
    del tmp136
    tmp144 += einsum(tmp60, (0, 1, 2, 3), tmp83, (4, 0, 3), (4, 2, 1))
    tmp144 += einsum(tmp10, (0, 1, 2), tmp62, (1, 3, 4, 2), (0, 4, 3)) * 2
    del tmp62
    tmp144 += einsum(tmp137, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 2, 0)) * -2
    del tmp137
    tmp144 += einsum(tmp138, (0, 1, 2, 3), v.baa.xov, (4, 0, 3), (4, 2, 1))
    del tmp138
    tmp144 += einsum(tmp139, (0, 1, 2, 3), tmp1, (4, 0, 1), (4, 3, 2)) * -1
    tmp144 += einsum(tmp139, (0, 1, 2, 3), v.baa.xoo, (4, 0, 1), (4, 3, 2)) * -1
    del tmp139
    tmp144 += einsum(tmp4, (0, 1, 2), tmp142, (1, 3, 2, 4), (0, 4, 3)) * -2
    tmp144 += einsum(tmp142, (0, 1, 2, 3), v.bbb.xoo, (4, 0, 2), (4, 3, 1)) * -2
    del tmp142
    tmp144 += einsum(v.bbb.xov, (0, 1, 2), tmp143, (3, 2), (0, 3, 1)) * -1
    del tmp143
    tmp144 += einsum(tmp67, (0, 1), v.bbb.xoo, (2, 3, 0), (2, 1, 3)) * -1
    tmp121 = einsum(tmp41, (0, 1), v.baa.xvv, (2, 1, 0), (2,))
    tmp121 += einsum(tmp45, (0, 1), v.bbb.xvv, (2, 1, 0), (2,)) * 0.5
    tmp121 += einsum(tmp57, (0, 1), v.baa.xov, (2, 0, 1), (2,)) * -1
    tmp121 += einsum(tmp69, (0, 1), v.bbb.xov, (2, 0, 1), (2,)) * -0.5
    tmp121 += einsum(tmp70, (0, 1), v.baa.xoo, (2, 1, 0), (2,)) * -1
    tmp121 += einsum(tmp71, (0, 1), v.bbb.xoo, (2, 1, 0), (2,)) * -0.5
    tmp107 = einsum(tmp100, (0, 1, 2, 3), t2.abab, (4, 5, 2, 3), (4, 0, 5, 1)) * 0.5
    tmp107 += einsum(tmp101, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (1, 2, 4, 5)) * -0.5
    del tmp101
    tmp107 += einsum(t2.abab, (0, 1, 2, 3), tmp102, (1, 4, 5, 3), (0, 5, 4, 2)) * -0.5
    del tmp102
    tmp107 += einsum(tmp5, (0, 1, 2), tmp83, (0, 3, 4), (3, 2, 1, 4)) * 0.5
    tmp107 += einsum(t2.abab, (0, 1, 2, 3), tmp105, (4, 3), (0, 4, 1, 2)) * 0.5
    tmp107 += einsum(t1.aa, (0, 1), tmp106, (0, 2, 3, 4), (2, 4, 3, 1)) * -0.5
    del tmp106
    tmp145 = np.copy(f.bb.vv)
    tmp145 += einsum(tmp98, (0,), v.bbb.xvv, (0, 1, 2), (1, 2))
    tmp117 = einsum(tmp108, (0, 1, 2, 3), t2.bbbb, (4, 5, 2, 3), (0, 4, 5, 1))
    del tmp108
    tmp117 += einsum(tmp109, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 3), (2, 4, 1, 5)) * -2
    tmp117 += einsum(tmp5, (0, 1, 2), tmp110, (0, 3, 4), (2, 3, 1, 4))
    del tmp110
    tmp117 += einsum(tmp105, (0, 1), t2.bbbb, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp117 += einsum(tmp7, (0, 1, 2), tmp5, (0, 3, 4), (4, 3, 1, 2)) * -1
    del tmp7
    tmp117 += einsum(tmp116, (0, 1, 2, 3), t1.bb, (0, 4), (1, 3, 2, 4)) * -1
    del tmp116
    tmp120 = np.copy(tmp119)
    tmp120 += einsum(tmp5, (0, 1, 2), l1.bb, (3, 1), (0, 2, 3))
    del tmp5
    tmp99 = np.copy(f.aa.vv)
    tmp99 += einsum(tmp98, (0,), v.baa.xvv, (0, 1, 2), (1, 2))
    del tmp98
    tmp21 = einsum(tmp0, (0, 1, 2, 3), t2.abab, (4, 5, 1, 2), (0, 4, 5, 3))
    tmp21 += einsum(t2.abab, (0, 1, 2, 3), tmp3, (0, 4, 5, 2), (5, 4, 1, 3)) * -1
    del tmp3
    tmp21 += einsum(tmp6, (0, 1, 2, 3), t2.abab, (4, 1, 3, 5), (0, 4, 2, 5)) * -1
    del tmp6
    tmp21 += einsum(tmp2, (0, 1, 2), tmp10, (0, 3, 4), (2, 1, 3, 4))
    tmp21 += einsum(t2.abab, (0, 1, 2, 3), tmp16, (4, 2), (4, 0, 1, 3))
    tmp21 += einsum(tmp20, (0, 1, 2, 3), t1.bb, (2, 4), (1, 0, 3, 4)) * -1
    del tmp20
    tmp72 = einsum(tmp41, (0, 1), v.baa.xvv, (2, 1, 0), (2,)) * 2
    del tmp41
    tmp72 += einsum(tmp45, (0, 1), v.bbb.xvv, (2, 1, 0), (2,))
    del tmp45
    tmp72 += einsum(tmp57, (0, 1), v.baa.xov, (2, 0, 1), (2,)) * -2
    del tmp57
    tmp72 += einsum(tmp69, (0, 1), v.bbb.xov, (2, 0, 1), (2,)) * -1
    del tmp69
    tmp72 += einsum(tmp70, (0, 1), v.baa.xoo, (2, 1, 0), (2,)) * -2
    del tmp70
    tmp72 += einsum(tmp71, (0, 1), v.bbb.xoo, (2, 1, 0), (2,)) * -1
    del tmp71
    tmp97 = einsum(l1.aa, (0, 1), tmp27, (2, 3, 0), (2, 3, 1)) * 0.25
    tmp97 += einsum(tmp85, (0, 1, 2, 3), v.baa.xoo, (4, 2, 1), (4, 3, 0)) * 0.5
    tmp97 += einsum(v.bbb.xoo, (0, 1, 2), tmp86, (3, 4, 2, 1), (0, 4, 3)) * -0.25
    tmp97 += einsum(tmp87, (0, 1, 2, 3), v.bbb.xvv, (4, 2, 3), (4, 1, 0)) * 0.25
    tmp97 += einsum(tmp1, (0, 1, 2), tmp85, (1, 3, 2, 4), (0, 4, 3)) * -0.5
    del tmp1, tmp85
    tmp97 += einsum(tmp86, (0, 1, 2, 3), tmp4, (4, 2, 3), (4, 1, 0)) * -0.25
    del tmp4, tmp86
    tmp97 += einsum(tmp90, (0, 1, 2, 3), v.baa.xvv, (4, 2, 3), (4, 1, 0))
    del tmp90
    tmp97 += einsum(tmp83, (0, 1, 2), tmp48, (1, 3, 4, 2), (0, 4, 3)) * 0.5
    del tmp48
    tmp97 += einsum(tmp50, (0, 1, 2, 3), tmp10, (4, 2, 3), (4, 1, 0)) * 0.25
    tmp97 += einsum(tmp91, (0, 1, 2, 3), v.baa.xov, (4, 1, 3), (4, 2, 0)) * -0.5
    del tmp91
    tmp97 += einsum(tmp92, (0, 1, 2, 3), v.bbb.xov, (4, 2, 3), (4, 1, 0)) * 0.25
    del tmp92
    tmp97 += einsum(tmp19, (0, 1, 2), tmp93, (2, 3, 1, 4), (0, 4, 3)) * -0.5
    del tmp93, tmp19
    tmp97 += einsum(tmp95, (0, 1, 2, 3), tmp94, (4, 3, 2), (4, 1, 0)) * -0.25
    del tmp95, tmp94
    tmp97 += einsum(v.baa.xov, (0, 1, 2), tmp96, (3, 2), (0, 3, 1)) * -0.5
    del tmp96
    tmp97 += einsum(tmp55, (0, 1), v.baa.xoo, (2, 3, 0), (2, 1, 3)) * -0.5
    tmp39 = np.copy(tmp38)
    tmp39 += einsum(l1.aa, (0, 1), tmp2, (2, 1, 3), (2, 3, 0)) * 0.5
    tmp34 = einsum(t2.aaaa, (0, 1, 2, 3), tmp22, (4, 5, 2, 3), (4, 0, 1, 5)) * 0.5
    del tmp22
    tmp34 += einsum(tmp23, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (0, 4, 2, 5)) * -1
    tmp34 += einsum(tmp2, (0, 1, 2), tmp26, (0, 3, 4), (2, 3, 1, 4)) * 0.5
    del tmp26
    tmp34 += einsum(t2.aaaa, (0, 1, 2, 3), tmp16, (4, 3), (4, 0, 1, 2)) * 0.5
    tmp34 += einsum(tmp27, (0, 1, 2), tmp2, (0, 3, 4), (4, 3, 1, 2)) * -0.5
    del tmp27, tmp2
    tmp34 += einsum(tmp33, (0, 1, 2, 3), t1.aa, (0, 4), (1, 3, 2, 4)) * -0.5
    del tmp33
    tmp84 = np.copy(tmp79) * -0.5
    del tmp79
    tmp84 += tmp80 * -0.25
    del tmp80
    tmp84 += tmp81 * -0.5
    del tmp81
    tmp84 += tmp82 * -0.25
    del tmp82
    tmp84 += einsum(l2.aaaa, (0, 1, 2, 3), tmp83, (4, 3, 1), (4, 2, 0)) * 0.5
    del tmp83
    tmp84 += einsum(l2.abab, (0, 1, 2, 3), tmp10, (4, 3, 1), (4, 2, 0)) * 0.25
    del tmp10
    l2new.bbbb = np.copy(np.transpose(tmp219, (3, 2, 1, 0)))
    l2new.bbbb += einsum(tmp109, (0, 1, 2, 3), l1.bb, (4, 1), (3, 4, 2, 0)) * -1
    del tmp109
    l2new.bbbb += np.transpose(tmp219, (2, 3, 1, 0)) * -1
    del tmp219
    l2new.bbbb += np.transpose(tmp221, (3, 2, 0, 1))
    l2new.bbbb += einsum(tmp222, (0, 1, 2, 3), l2.bbbb, (4, 3, 5, 0), (2, 4, 5, 1)) * 2
    del tmp222
    l2new.bbbb += einsum(tmp223, (0, 1, 2), v.bbb.xov, (0, 3, 4), (4, 2, 1, 3)) * -1
    del tmp223
    l2new.bbbb += np.transpose(tmp224, (3, 2, 1, 0)) * -1
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp225, (2, 3), (3, 0, 1, 2)) * -1
    del tmp225
    l2new.bbbb += np.transpose(tmp226, (2, 3, 0, 1)) * -2
    l2new.bbbb += np.transpose(tmp227, (3, 2, 1, 0))
    l2new.bbbb += np.transpose(tmp224, (3, 2, 0, 1))
    del tmp224
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp200, (2, 3), (3, 0, 2, 1))
    l2new.bbbb += np.transpose(tmp226, (3, 2, 1, 0)) * -2
    l2new.bbbb += np.transpose(tmp227, (2, 3, 0, 1))
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp200, (2, 3), (0, 3, 1, 2))
    l2new.bbbb += np.transpose(tmp226, (3, 2, 0, 1)) * 2
    del tmp226
    l2new.bbbb += np.transpose(tmp227, (2, 3, 1, 0)) * -1
    del tmp227
    l2new.bbbb += einsum(tmp200, (0, 1), l1.bb, (2, 3), (2, 1, 0, 3)) * -1
    l2new.bbbb += np.transpose(tmp229, (2, 3, 1, 0)) * -2
    del tmp229
    l2new.bbbb += np.transpose(tmp230, (2, 3, 1, 0)) * 2
    l2new.bbbb += np.transpose(tmp231, (3, 2, 1, 0)) * 4
    del tmp231
    l2new.bbbb += np.transpose(tmp232, (2, 3, 1, 0)) * 2
    l2new.bbbb += np.transpose(tmp233, (2, 3, 1, 0)) * -2
    l2new.bbbb += np.transpose(tmp230, (3, 2, 1, 0)) * -2
    del tmp230
    l2new.bbbb += np.transpose(tmp232, (3, 2, 1, 0)) * -2
    del tmp232
    l2new.bbbb += np.transpose(tmp233, (3, 2, 1, 0)) * 2
    del tmp233
    l2new.bbbb += np.transpose(tmp234, (2, 3, 0, 1)) * -2
    l2new.bbbb += np.transpose(tmp234, (2, 3, 1, 0)) * 2
    del tmp234
    l2new.bbbb += einsum(l2.bbbb, (0, 1, 2, 3), tmp235, (2, 4, 3, 5), (0, 1, 4, 5)) * -2
    del tmp235
    l2new.bbbb += einsum(v.bbb.xov, (0, 1, 2), tmp119, (0, 3, 4), (2, 4, 3, 1))
    del tmp119
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp220, (2, 1, 3, 4), (4, 0, 2, 3))
    del tmp220
    l2new.bbbb += einsum(tmp236, (0, 1, 2), v.bbb.xov, (0, 3, 4), (2, 4, 1, 3)) * 2
    del tmp236
    l2new.bbbb += np.transpose(tmp221, (3, 2, 1, 0)) * -1
    del tmp221
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp103, (2, 3), (3, 0, 1, 2))
    l2new.bbbb += np.transpose(tmp237, (3, 2, 0, 1)) * -2
    l2new.bbbb += np.transpose(tmp238, (3, 2, 0, 1)) * -2
    l2new.bbbb += np.transpose(tmp240, (3, 2, 0, 1))
    l2new.bbbb += np.transpose(tmp241, (2, 3, 0, 1)) * -1
    l2new.bbbb += einsum(tmp103, (0, 1), l1.bb, (2, 3), (2, 1, 3, 0)) * -1
    l2new.bbbb += np.transpose(tmp237, (2, 3, 0, 1)) * 2
    l2new.bbbb += np.transpose(tmp238, (2, 3, 0, 1)) * 2
    l2new.bbbb += np.transpose(tmp240, (2, 3, 0, 1)) * -1
    l2new.bbbb += np.transpose(tmp241, (3, 2, 0, 1))
    l2new.bbbb += einsum(l1.bb, (0, 1), tmp103, (2, 3), (3, 0, 2, 1)) * -1
    l2new.bbbb += np.transpose(tmp237, (3, 2, 1, 0)) * 2
    l2new.bbbb += np.transpose(tmp238, (3, 2, 1, 0)) * 2
    l2new.bbbb += np.transpose(tmp240, (3, 2, 1, 0)) * -1
    l2new.bbbb += np.transpose(tmp241, (2, 3, 1, 0))
    l2new.bbbb += einsum(tmp103, (0, 1), l1.bb, (2, 3), (2, 1, 0, 3))
    l2new.bbbb += np.transpose(tmp237, (2, 3, 1, 0)) * -2
    del tmp237
    l2new.bbbb += np.transpose(tmp238, (2, 3, 1, 0)) * -2
    del tmp238
    l2new.bbbb += np.transpose(tmp240, (2, 3, 1, 0))
    del tmp240
    l2new.bbbb += np.transpose(tmp241, (3, 2, 1, 0)) * -1
    del tmp241
    l2new.abab = einsum(tmp190, (0, 1, 2), v.baa.xov, (0, 3, 4), (4, 2, 3, 1))
    del tmp190
    l2new.abab += einsum(tmp191, (0, 1, 2, 3), l1.bb, (4, 2), (3, 4, 0, 1)) * -1
    l2new.abab += einsum(tmp157, (0, 1, 2, 3), l2.abab, (3, 4, 1, 5), (2, 4, 0, 5)) * -1
    del tmp157
    l2new.abab += einsum(tmp195, (0, 1, 2), v.baa.xov, (0, 3, 4), (4, 2, 3, 1))
    del tmp195
    l2new.abab += einsum(tmp196, (0, 1), l2.abab, (2, 3, 0, 4), (2, 3, 1, 4)) * -2
    del tmp196
    l2new.abab += einsum(tmp166, (0, 1), l1.bb, (2, 3), (1, 2, 0, 3))
    l2new.abab += einsum(tmp198, (0, 1, 2, 3), l2.abab, (4, 3, 5, 1), (4, 2, 5, 0)) * -1
    del tmp198
    l2new.abab += einsum(tmp163, (0, 1, 2), v.bbb.xov, (0, 3, 4), (2, 4, 1, 3))
    del tmp163
    l2new.abab += einsum(tmp200, (0, 1), l1.aa, (2, 3), (2, 1, 3, 0))
    del tmp200
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp201, (3, 4, 0, 5), (5, 1, 2, 4)) * -1
    del tmp201
    l2new.abab += einsum(tmp127, (0, 1), l2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -1
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), tmp0, (1, 4, 3, 5), (4, 5, 0, 2)) * -1
    del tmp0
    l2new.abab += np.transpose(tmp203, (2, 3, 0, 1))
    del tmp203
    l2new.abab += np.transpose(tmp204, (2, 3, 0, 1)) * 2
    del tmp204
    l2new.abab += einsum(tmp205, (0, 1), l2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -1
    del tmp205
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), tmp177, (1, 4), (4, 3, 0, 2)) * -1
    del tmp177
    l2new.abab += einsum(tmp60, (0, 1, 2, 3), tmp100, (2, 4, 3, 5), (4, 5, 0, 1)) * -1
    del tmp100
    l2new.abab += einsum(l2.abab, (0, 1, 2, 3), tmp209, (1, 4), (0, 4, 2, 3)) * -1
    del tmp209
    l2new.abab += einsum(tmp60, (0, 1, 2, 3), tmp210, (2, 4), (3, 4, 0, 1)) * -1
    del tmp210
    l2new.abab += einsum(v.bbb.xov, (0, 1, 2), tmp38, (0, 3, 4), (4, 2, 3, 1)) * -2
    del tmp38
    l2new.abab += einsum(l1.aa, (0, 1), tmp211, (2, 1, 3, 4), (0, 4, 2, 3)) * -1
    l2new.abab += einsum(tmp212, (0, 1, 2, 3), l2.abab, (4, 5, 0, 2), (4, 5, 1, 3))
    del tmp212
    l2new.abab += einsum(tmp213, (0, 1, 2, 3), l2.abab, (4, 2, 0, 5), (4, 3, 1, 5)) * -1
    del tmp213
    l2new.abab += einsum(tmp87, (0, 1, 2, 3), tmp17, (1, 4, 5, 3), (5, 2, 0, 4))
    del tmp87
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), tmp191, (1, 4, 2, 5), (5, 3, 0, 4))
    del tmp191
    l2new.abab += einsum(tmp188, (0, 1, 2), v.bbb.xov, (0, 3, 4), (2, 4, 1, 3)) * -1
    del tmp188
    l2new.abab += einsum(tmp133, (0, 1, 2, 3), tmp17, (4, 1, 3, 5), (2, 5, 4, 0))
    del tmp17, tmp133
    l2new.abab += einsum(tmp60, (0, 1, 2, 3), tmp211, (4, 0, 2, 5), (3, 5, 4, 1))
    del tmp211
    l2new.abab += einsum(tmp214, (0, 1, 2), v.baa.xov, (0, 3, 4), (4, 2, 3, 1)) * -1
    del tmp214
    l2new.abab += einsum(tmp182, (0, 1, 2, 3), tmp50, (1, 2, 4, 5), (3, 5, 0, 4))
    del tmp182
    l2new.abab += einsum(l1.bb, (0, 1), tmp11, (2, 3), (3, 0, 2, 1)) * -1
    l2new.abab += einsum(tmp50, (0, 1, 2, 3), tmp184, (0, 1, 4, 5), (5, 3, 4, 2))
    del tmp50, tmp184
    l2new.abab += einsum(tmp215, (0, 1, 2, 3), tmp29, (0, 4, 5, 2), (5, 3, 4, 1)) * -2
    del tmp29, tmp215
    l2new.abab += einsum(l1.aa, (0, 1), tmp103, (2, 3), (0, 3, 1, 2)) * -1
    del tmp103
    l2new.abab += einsum(tmp216, (0, 1, 2, 3), tmp60, (4, 0, 1, 5), (5, 3, 4, 2))
    del tmp216
    l2new.abab += einsum(tmp217, (0, 1, 2, 3), tmp60, (4, 1, 2, 5), (5, 3, 4, 0))
    del tmp60, tmp217
    l2new.abab += einsum(tmp218, (0, 1, 2, 3), tmp112, (1, 4, 5, 3), (2, 5, 0, 4)) * -2
    del tmp112, tmp218
    l2new.aaaa = np.copy(np.transpose(tmp148, (3, 2, 1, 0)))
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp23, (2, 3, 1, 4), (4, 0, 2, 3)) * -1
    del tmp23
    l2new.aaaa += np.transpose(tmp148, (2, 3, 1, 0)) * -1
    del tmp148
    l2new.aaaa += np.transpose(tmp151, (3, 2, 0, 1))
    l2new.aaaa += einsum(tmp152, (0, 1, 2, 3), l2.aaaa, (4, 3, 5, 0), (2, 4, 5, 1)) * 2
    del tmp152
    l2new.aaaa += einsum(v.baa.xov, (0, 1, 2), tmp154, (0, 3, 4), (2, 4, 3, 1)) * -2
    del tmp154
    l2new.aaaa += np.transpose(tmp155, (3, 2, 0, 1)) * -1
    l2new.aaaa += einsum(tmp156, (0, 1), l1.aa, (2, 3), (1, 2, 3, 0)) * -1
    del tmp156
    l2new.aaaa += np.transpose(tmp158, (2, 3, 0, 1)) * -2
    l2new.aaaa += np.transpose(tmp164, (3, 2, 1, 0))
    l2new.aaaa += np.transpose(tmp155, (3, 2, 1, 0))
    del tmp155
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp166, (2, 3), (3, 0, 2, 1))
    l2new.aaaa += np.transpose(tmp158, (3, 2, 1, 0)) * -2
    l2new.aaaa += np.transpose(tmp164, (2, 3, 0, 1))
    l2new.aaaa += einsum(tmp166, (0, 1), l1.aa, (2, 3), (2, 1, 3, 0))
    l2new.aaaa += np.transpose(tmp158, (3, 2, 0, 1)) * 2
    del tmp158
    l2new.aaaa += np.transpose(tmp164, (2, 3, 1, 0)) * -1
    del tmp164
    l2new.aaaa += einsum(tmp166, (0, 1), l1.aa, (2, 3), (2, 1, 0, 3)) * -1
    del tmp166
    l2new.aaaa += np.transpose(tmp168, (2, 3, 1, 0)) * -2
    del tmp168
    l2new.aaaa += np.transpose(tmp169, (2, 3, 1, 0)) * 2
    l2new.aaaa += np.transpose(tmp171, (3, 2, 1, 0)) * 4
    del tmp171
    l2new.aaaa += np.transpose(tmp176, (2, 3, 1, 0)) * 2
    l2new.aaaa += np.transpose(tmp178, (2, 3, 1, 0)) * -2
    l2new.aaaa += np.transpose(tmp169, (3, 2, 1, 0)) * -2
    del tmp169
    l2new.aaaa += np.transpose(tmp176, (3, 2, 1, 0)) * -2
    del tmp176
    l2new.aaaa += np.transpose(tmp178, (3, 2, 1, 0)) * 2
    del tmp178
    l2new.aaaa += np.transpose(tmp179, (2, 3, 0, 1)) * -2
    l2new.aaaa += np.transpose(tmp179, (2, 3, 1, 0)) * 2
    del tmp179
    l2new.aaaa += einsum(tmp180, (0, 1, 2, 3), l2.aaaa, (4, 5, 0, 2), (4, 5, 1, 3)) * -2
    del tmp180
    l2new.aaaa += np.transpose(tmp181, (3, 2, 0, 1)) * -1
    l2new.aaaa += einsum(tmp150, (0, 1, 2, 3), l1.aa, (4, 1), (3, 4, 0, 2))
    del tmp150
    l2new.aaaa += np.transpose(tmp181, (2, 3, 0, 1))
    del tmp181
    l2new.aaaa += np.transpose(tmp151, (3, 2, 1, 0)) * -1
    del tmp151
    l2new.aaaa += np.transpose(tmp183, (3, 2, 0, 1)) * -2
    l2new.aaaa += einsum(tmp11, (0, 1), l1.aa, (2, 3), (1, 2, 3, 0))
    l2new.aaaa += np.transpose(tmp185, (3, 2, 0, 1)) * -2
    l2new.aaaa += np.transpose(tmp187, (3, 2, 0, 1))
    l2new.aaaa += np.transpose(tmp189, (2, 3, 0, 1)) * -1
    l2new.aaaa += np.transpose(tmp183, (2, 3, 0, 1)) * 2
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp11, (2, 3), (0, 3, 1, 2)) * -1
    l2new.aaaa += np.transpose(tmp185, (2, 3, 0, 1)) * 2
    l2new.aaaa += np.transpose(tmp187, (2, 3, 0, 1)) * -1
    l2new.aaaa += np.transpose(tmp189, (3, 2, 0, 1))
    l2new.aaaa += np.transpose(tmp183, (3, 2, 1, 0)) * 2
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp11, (2, 3), (3, 0, 2, 1)) * -1
    l2new.aaaa += np.transpose(tmp185, (3, 2, 1, 0)) * 2
    l2new.aaaa += np.transpose(tmp187, (3, 2, 1, 0)) * -1
    l2new.aaaa += np.transpose(tmp189, (2, 3, 1, 0))
    l2new.aaaa += np.transpose(tmp183, (2, 3, 1, 0)) * -2
    del tmp183
    l2new.aaaa += einsum(l1.aa, (0, 1), tmp11, (2, 3), (0, 3, 2, 1))
    del tmp11
    l2new.aaaa += np.transpose(tmp185, (2, 3, 1, 0)) * -2
    del tmp185
    l2new.aaaa += np.transpose(tmp187, (2, 3, 1, 0))
    del tmp187
    l2new.aaaa += np.transpose(tmp189, (3, 2, 1, 0)) * -1
    del tmp189
    l1new.bb = np.copy(np.transpose(f.bb.ov, (1, 0)))
    l1new.bb += einsum(l2.abab, (0, 1, 2, 3), tmp107, (2, 4, 3, 0), (1, 4)) * -2
    del tmp107
    l1new.bb += einsum(tmp117, (0, 1, 2, 3), l2.bbbb, (4, 3, 1, 2), (4, 0)) * 2
    del tmp117
    l1new.bb += einsum(tmp120, (0, 1, 2), v.bbb.xvv, (0, 3, 2), (3, 1)) * -1
    del tmp120
    l1new.bb += einsum(tmp121, (0,), v.bbb.xov, (0, 1, 2), (2, 1)) * 2
    del tmp121
    l1new.bb += einsum(tmp127, (0, 1), l1.bb, (2, 0), (2, 1)) * -1
    del tmp127
    l1new.bb += einsum(tmp132, (0, 1, 2), v.bbb.xvv, (0, 3, 2), (3, 1)) * 2
    del tmp132
    l1new.bb += einsum(v.bbb.xov, (0, 1, 2), tmp144, (0, 1, 3), (2, 3)) * -1
    del tmp144
    l1new.bb += einsum(tmp67, (0, 1), tmp105, (1, 2), (2, 0)) * -1
    del tmp105, tmp67
    l1new.bb += einsum(l1.bb, (0, 1), tmp145, (0, 2), (2, 1))
    del tmp145
    l1new.aa = np.copy(np.transpose(f.aa.ov, (1, 0)))
    l1new.aa += einsum(tmp21, (0, 1, 2, 3), l2.abab, (4, 3, 1, 2), (4, 0)) * -1
    del tmp21
    l1new.aa += einsum(l2.aaaa, (0, 1, 2, 3), tmp34, (4, 2, 3, 1), (0, 4)) * 4
    del tmp34
    l1new.aa += einsum(v.baa.xvv, (0, 1, 2), tmp39, (0, 3, 2), (1, 3)) * -2
    del tmp39
    l1new.aa += einsum(tmp72, (0,), v.baa.xov, (0, 1, 2), (2, 1))
    del tmp72
    l1new.aa += einsum(l1.aa, (0, 1), tmp78, (1, 2), (0, 2)) * -1
    del tmp78
    l1new.aa += einsum(tmp84, (0, 1, 2), v.baa.xvv, (0, 3, 2), (3, 1)) * 4
    del tmp84
    l1new.aa += einsum(v.baa.xov, (0, 1, 2), tmp97, (0, 1, 3), (2, 3)) * -4
    del tmp97
    l1new.aa += einsum(tmp16, (0, 1), tmp55, (2, 0), (1, 2)) * -2
    del tmp16, tmp55
    l1new.aa += einsum(tmp99, (0, 1), l1.aa, (0, 2), (1, 2))
    del tmp99

    return {f"l1new": l1new, f"l2new": l2new}

def make_rdm1_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:09:55.457370.

    Parameters
    ----------
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm1 : Namespace of arrays
        One-particle reduced density matrix.
    """

    rdm1 = Namespace()
    rdm1.aa = Namespace()
    rdm1.bb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    tmp4 = einsum(l1.bb, (0, 1), t1.bb, (2, 0), (1, 2))
    tmp5 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    tmp3 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    tmp0 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    tmp1 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (2, 4))
    tmp2 = einsum(t1.aa, (0, 1), l1.aa, (1, 2), (2, 0))
    tmp10 = einsum(l2.abab, (0, 1, 2, 3), t1.bb, (4, 1), (2, 3, 4, 0))
    tmp11 = np.copy(tmp4) * 0.5
    tmp11 += tmp5 * 0.5
    tmp11 += tmp3
    tmp9 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp8 = np.copy(tmp2) * 0.5
    tmp8 += tmp1
    tmp8 += tmp0 * 0.5
    tmp6 = einsum(l2.abab, (0, 1, 2, 3), t1.aa, (4, 0), (2, 4, 3, 1))
    tmp7 = einsum(t1.aa, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm1.bb.vv = einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    rdm1.bb.vv += einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 0, 1), (4, 2)) * 2
    rdm1.bb.vv += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    rdm1.aa.vv = einsum(t1.aa, (0, 1), l1.aa, (2, 0), (2, 1))
    rdm1.aa.vv += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    rdm1.aa.vv += einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 0, 1), (4, 2)) * 2
    rdm1.bb.vo = np.copy(l1.bb)
    rdm1.aa.vo = np.copy(l1.aa)
    rdm1.bb.ov = einsum(l1.bb, (0, 1), t2.bbbb, (2, 1, 3, 0), (2, 3)) * 2
    rdm1.bb.ov += t1.bb
    rdm1.bb.ov += einsum(t2.abab, (0, 1, 2, 3), l1.aa, (2, 0), (1, 3))
    rdm1.bb.ov += einsum(t2.bbbb, (0, 1, 2, 3), tmp9, (1, 0, 4, 3), (4, 2)) * -2
    del tmp9
    rdm1.bb.ov += einsum(t2.abab, (0, 1, 2, 3), tmp10, (0, 1, 4, 2), (4, 3)) * -1
    del tmp10
    rdm1.bb.ov += einsum(t1.bb, (0, 1), tmp11, (0, 2), (2, 1)) * -2
    del tmp11
    rdm1.aa.ov = np.copy(t1.aa)
    rdm1.aa.ov += einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2))
    rdm1.aa.ov += einsum(l1.aa, (0, 1), t2.aaaa, (2, 1, 3, 0), (2, 3)) * 2
    rdm1.aa.ov += einsum(t2.abab, (0, 1, 2, 3), tmp6, (0, 4, 1, 3), (4, 2)) * -1
    del tmp6
    rdm1.aa.ov += einsum(t2.aaaa, (0, 1, 2, 3), tmp7, (1, 0, 4, 3), (4, 2)) * -2
    del tmp7
    rdm1.aa.ov += einsum(tmp8, (0, 1), t1.aa, (0, 2), (1, 2)) * -2
    del tmp8
    rdm1.bb.oo = np.copy(np.transpose(tmp3, (1, 0))) * -2
    del tmp3
    rdm1.bb.oo += np.transpose(tmp4, (1, 0)) * -1
    del tmp4
    rdm1.bb.oo += delta.bb.oo
    rdm1.bb.oo += np.transpose(tmp5, (1, 0)) * -1
    del tmp5
    rdm1.aa.oo = np.copy(np.transpose(tmp0, (1, 0))) * -1
    del tmp0
    rdm1.aa.oo += np.transpose(tmp1, (1, 0)) * -2
    del tmp1
    rdm1.aa.oo += np.transpose(tmp2, (1, 0)) * -1
    del tmp2
    rdm1.aa.oo += delta.aa.oo
    del delta
    rdm1.aa = np.block([[rdm1.aa.oo, rdm1.aa.ov], [rdm1.aa.vo, rdm1.aa.vv]])
    rdm1.bb = np.block([[rdm1.bb.oo, rdm1.bb.ov], [rdm1.bb.vo, rdm1.bb.vv]])

    return rdm1

def make_rdm2_f(l1=None, l2=None, t1=None, t2=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:10:59.420749.

    Parameters
    ----------
    l1 : Namespace of arrays
        L1 amplitudes.
    l2 : Namespace of arrays
        L2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.

    Returns
    -------
    rdm2 : Namespace of arrays
        Two-particle reduced density matrix.
    """

    rdm2 = Namespace()
    rdm2.aaaa = Namespace()
    rdm2.abab = Namespace()
    rdm2.bbbb = Namespace()
    delta = Namespace(
        aa=Namespace(oo=np.eye(t2.aaaa.shape[0]), vv=np.eye(t2.aaaa.shape[-1])),
        bb=Namespace(oo=np.eye(t2.bbbb.shape[0]), vv=np.eye(t2.bbbb.shape[-1])),
    )
    tmp9 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    tmp8 = einsum(l1.bb, (0, 1), t1.bb, (2, 0), (1, 2))
    tmp10 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (2, 3, 4, 1), (4, 0))
    tmp19 = einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp13 = einsum(l2.abab, (0, 1, 2, 3), t1.bb, (4, 1), (2, 3, 4, 0))
    tmp0 = einsum(t1.aa, (0, 1), l1.aa, (1, 2), (2, 0))
    tmp1 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (2, 4))
    tmp2 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    tmp6 = einsum(t1.aa, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2))
    tmp27 = einsum(l2.abab, (0, 1, 2, 3), t1.aa, (4, 0), (2, 4, 3, 1))
    tmp88 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 5), (3, 4, 1, 5))
    tmp89 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp70 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp72 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp17 = np.copy(tmp8)
    tmp17 += tmp9
    tmp17 += tmp10 * 2
    tmp18 = einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    tmp20 = einsum(t1.bb, (0, 1), tmp19, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp53 = einsum(t2.abab, (0, 1, 2, 3), tmp13, (0, 4, 5, 2), (4, 5, 1, 3))
    tmp54 = einsum(t2.bbbb, (0, 1, 2, 3), tmp19, (4, 1, 5, 3), (4, 5, 0, 2)) * -1
    tmp29 = np.copy(tmp0) * 0.5
    tmp29 += tmp1
    tmp29 += tmp2 * 0.5
    tmp14 = einsum(t1.aa, (0, 1), tmp13, (2, 3, 4, 1), (2, 0, 3, 4))
    tmp12 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 5, 0, 1), (2, 4, 3, 5))
    tmp5 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (2, 3, 4, 5), (4, 5, 0, 1))
    tmp7 = einsum(t1.aa, (0, 1), tmp6, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp32 = einsum(t2.abab, (0, 1, 2, 3), tmp27, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp33 = einsum(tmp6, (0, 1, 2, 3), t2.aaaa, (4, 1, 5, 3), (0, 2, 4, 5)) * -1
    tmp90 = np.copy(tmp88)
    tmp90 += tmp89 * 4
    tmp111 = einsum(tmp19, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4))
    tmp83 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 3, 0, 1), (4, 2))
    tmp108 = einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp82 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    tmp86 = einsum(l2.abab, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    tmp85 = einsum(l2.aaaa, (0, 1, 2, 3), t2.abab, (3, 4, 1, 5), (2, 4, 0, 5))
    tmp66 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    tmp105 = einsum(t1.aa, (0, 1), l1.aa, (2, 0), (2, 1))
    tmp65 = einsum(t2.aaaa, (0, 1, 2, 3), l2.aaaa, (4, 3, 0, 1), (4, 2))
    tmp118 = np.copy(tmp70) * 4
    tmp118 += tmp72
    tmp107 = einsum(t1.aa, (0, 1), tmp6, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp113 = einsum(t2.aaaa, (0, 1, 2, 3), l2.abab, (3, 4, 1, 5), (0, 5, 2, 4))
    tmp68 = einsum(l2.bbbb, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (4, 2, 5, 0))
    tmp40 = einsum(t2.abab, (0, 1, 2, 3), tmp13, (0, 1, 4, 2), (4, 3))
    tmp42 = einsum(tmp17, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp41 = einsum(t2.bbbb, (0, 1, 2, 3), tmp19, (1, 0, 4, 3), (4, 2))
    tmp16 = np.copy(tmp8) * 0.5
    tmp16 += tmp9 * 0.5
    tmp16 += tmp10
    tmp55 = np.copy(np.transpose(tmp18, (1, 0, 3, 2)))
    tmp55 += np.transpose(tmp20, (0, 1, 3, 2)) * -1
    tmp36 = einsum(t2.abab, (0, 1, 2, 3), l1.aa, (2, 0), (1, 3))
    tmp37 = einsum(l1.bb, (0, 1), t2.bbbb, (2, 1, 3, 0), (2, 3))
    tmp103 = np.copy(tmp53)
    tmp103 += tmp54 * 4
    tmp50 = einsum(l1.bb, (0, 1), t2.bbbb, (2, 3, 4, 0), (1, 2, 3, 4))
    tmp30 = einsum(t1.aa, (0, 1), tmp29, (0, 2), (2, 1)) * 2
    tmp26 = einsum(t2.aaaa, (0, 1, 2, 3), tmp6, (1, 0, 4, 3), (4, 2))
    tmp28 = einsum(t2.abab, (0, 1, 2, 3), tmp27, (0, 4, 1, 3), (4, 2))
    tmp46 = np.copy(tmp12)
    tmp46 += tmp14
    tmp61 = einsum(t2.abab, (0, 1, 2, 3), tmp19, (4, 1, 5, 3), (0, 4, 5, 2)) * -1
    tmp62 = einsum(tmp13, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 1, 2, 5))
    tmp44 = einsum(t2.abab, (0, 1, 2, 3), tmp6, (4, 0, 5, 2), (4, 5, 1, 3)) * -1
    tmp45 = einsum(t2.bbbb, (0, 1, 2, 3), tmp27, (4, 5, 1, 3), (4, 5, 0, 2))
    tmp22 = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 1), (0, 2))
    tmp21 = einsum(l1.aa, (0, 1), t2.aaaa, (2, 1, 3, 0), (2, 3))
    tmp34 = np.copy(np.transpose(tmp5, (1, 0, 3, 2)))
    tmp34 += np.transpose(tmp7, (0, 1, 3, 2)) * -1
    tmp80 = np.copy(tmp33) * 4
    tmp80 += tmp32
    tmp25 = einsum(t2.aaaa, (0, 1, 2, 3), l1.aa, (3, 4), (4, 0, 1, 2))
    tmp57 = einsum(t1.aa, (0, 1), tmp29, (0, 2), (2, 1))
    tmp51 = einsum(tmp17, (0, 1), t1.bb, (0, 2), (1, 2)) * 0.5
    tmp131 = einsum(l2.bbbb, (0, 1, 2, 3), t1.bb, (3, 4), (2, 0, 1, 4))
    tmp133 = einsum(t2.bbbb, (0, 1, 2, 3), l2.bbbb, (4, 5, 0, 1), (4, 5, 2, 3))
    tmp130 = einsum(l2.abab, (0, 1, 2, 3), t1.bb, (3, 4), (2, 0, 1, 4))
    tmp129 = einsum(l2.aaaa, (0, 1, 2, 3), t1.aa, (3, 4), (2, 0, 1, 4))
    tmp132 = einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 5), (0, 1, 4, 5))
    tmp126 = einsum(tmp90, (0, 1, 2, 3), t1.bb, (0, 4), (1, 4, 2, 3))
    tmp124 = einsum(t2.bbbb, (0, 1, 2, 3), l1.bb, (4, 1), (0, 4, 2, 3))
    tmp128 = einsum(tmp111, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 3, 4)) * -1
    tmp109 = np.copy(tmp108)
    tmp109 += tmp82
    tmp109 += tmp83 * 2
    tmp122 = np.copy(tmp108) * 0.5
    del tmp108
    tmp122 += tmp82 * 0.5
    tmp122 += tmp83
    tmp127 = einsum(tmp19, (0, 1, 2, 3), t2.bbbb, (1, 0, 4, 5), (2, 3, 4, 5)) * -1
    tmp87 = np.copy(tmp85)
    tmp87 += tmp86
    tmp115 = einsum(tmp13, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4))
    tmp91 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 5, 1), (3, 4, 0, 5))
    tmp112 = np.copy(tmp105) * 0.5
    tmp112 += tmp65
    tmp112 += tmp66 * 0.5
    tmp116 = einsum(l1.aa, (0, 1), t2.aaaa, (2, 1, 3, 4), (2, 0, 3, 4))
    tmp106 = np.copy(tmp105)
    del tmp105
    tmp106 += tmp65 * 2
    tmp106 += tmp66
    tmp119 = einsum(t1.aa, (0, 1), tmp118, (0, 2, 3, 4), (2, 1, 3, 4))
    del tmp118
    tmp121 = einsum(tmp107, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 3, 4)) * -1
    tmp120 = einsum(tmp6, (0, 1, 2, 3), t2.aaaa, (1, 0, 4, 5), (2, 3, 4, 5)) * -1
    tmp125 = np.copy(tmp88) * 0.25
    tmp125 += tmp89
    tmp114 = einsum(t1.aa, (0, 1), tmp27, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp110 = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 5), (2, 4, 1, 5))
    tmp123 = np.copy(tmp113)
    tmp123 += tmp68
    tmp117 = np.copy(tmp70) * 4
    tmp117 += tmp72
    tmp99 = np.copy(tmp82)
    tmp99 += tmp83 * 2
    tmp43 = np.copy(tmp40)
    tmp43 += tmp41 * 2
    tmp43 += tmp42
    del tmp42
    tmp100 = einsum(t2.bbbb, (0, 1, 2, 3), tmp16, (1, 4), (0, 4, 2, 3)) * -2
    tmp94 = einsum(t2.abab, (0, 1, 2, 3), tmp85, (0, 4, 2, 5), (4, 1, 5, 3))
    tmp101 = einsum(t2.bbbb, (0, 1, 2, 3), tmp55, (0, 1, 4, 5), (4, 5, 2, 3))
    tmp38 = np.copy(t1.bb)
    tmp38 += tmp36
    tmp38 += tmp37 * 2
    tmp64 = np.copy(t1.bb)
    tmp64 += tmp36
    tmp64 += tmp37 * 2
    tmp97 = np.copy(tmp36)
    tmp97 += tmp37 * 2
    tmp95 = einsum(t2.bbbb, (0, 1, 2, 3), tmp89, (1, 4, 3, 5), (4, 0, 5, 2))
    tmp102 = einsum(tmp55, (0, 1, 2, 3), t1.bb, (0, 4), (1, 3, 2, 4))
    tmp104 = einsum(t1.bb, (0, 1), tmp103, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp103
    tmp84 = np.copy(tmp82) * 0.5
    del tmp82
    tmp84 += tmp83
    del tmp83
    tmp96 = einsum(tmp88, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 2), (1, 4, 3, 5))
    tmp98 = einsum(t1.bb, (0, 1), tmp50, (0, 2, 3, 4), (2, 3, 1, 4))
    tmp39 = einsum(t2.abab, (0, 1, 2, 3), l1.aa, (2, 4), (4, 0, 1, 3))
    tmp31 = np.copy(tmp26) * 2
    tmp31 += tmp28
    tmp31 += tmp30
    del tmp30
    tmp4 = np.copy(tmp0)
    tmp4 += tmp1 * 2
    tmp4 += tmp2
    tmp47 = einsum(t1.bb, (0, 1), tmp46, (2, 3, 0, 4), (2, 3, 4, 1))
    tmp63 = einsum(tmp27, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (1, 2, 4, 5))
    tmp76 = np.copy(tmp65) * 2
    tmp76 += tmp66
    tmp93 = np.copy(tmp62)
    tmp93 += tmp61
    tmp60 = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (3, 4), (0, 4, 1, 2))
    tmp92 = np.copy(tmp44)
    tmp92 += tmp45
    tmp74 = np.copy(tmp21) * 2
    tmp74 += tmp22
    tmp48 = einsum(tmp13, (0, 1, 2, 3), t2.abab, (4, 1, 3, 5), (0, 4, 2, 5))
    tmp79 = einsum(tmp34, (0, 1, 2, 3), t1.aa, (0, 4), (1, 3, 2, 4))
    tmp73 = einsum(t2.aaaa, (0, 1, 2, 3), tmp72, (1, 4, 3, 5), (0, 4, 2, 5))
    tmp81 = einsum(t1.aa, (0, 1), tmp80, (0, 2, 3, 4), (2, 3, 1, 4))
    del tmp80
    tmp78 = einsum(t2.aaaa, (0, 1, 2, 3), tmp34, (0, 1, 4, 5), (4, 5, 2, 3))
    tmp75 = einsum(tmp25, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    tmp69 = einsum(t2.abab, (0, 1, 2, 3), tmp68, (4, 1, 5, 3), (0, 4, 2, 5))
    tmp59 = np.copy(t1.aa) * 0.5
    tmp59 += tmp21
    tmp59 += tmp22 * 0.5
    tmp71 = einsum(t2.aaaa, (0, 1, 2, 3), tmp70, (1, 4, 3, 5), (4, 0, 5, 2))
    tmp77 = einsum(tmp29, (0, 1), t2.aaaa, (2, 0, 3, 4), (1, 2, 3, 4)) * -2
    tmp67 = np.copy(tmp65)
    del tmp65
    tmp67 += tmp66 * 0.5
    del tmp66
    tmp24 = np.copy(t1.aa)
    tmp24 += tmp21 * 2
    tmp24 += tmp22
    tmp56 = einsum(tmp55, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 3, 4)) * 2
    del tmp55
    tmp58 = np.copy(tmp26)
    del tmp26
    tmp58 += tmp28 * 0.5
    del tmp28
    tmp58 += tmp57
    del tmp57
    tmp35 = einsum(tmp34, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 3, 4)) * 2
    del tmp34
    tmp23 = np.copy(t1.aa)
    tmp23 += tmp21 * 2
    del tmp21
    tmp23 += tmp22
    del tmp22
    tmp52 = np.copy(tmp40) * 0.5
    del tmp40
    tmp52 += tmp41
    del tmp41
    tmp52 += tmp51
    del tmp51
    tmp49 = np.copy(t1.bb) * 0.5
    tmp49 += tmp36 * 0.5
    del tmp36
    tmp49 += tmp37
    del tmp37
    tmp15 = np.copy(delta.bb.oo) * -1
    tmp15 += tmp8
    tmp15 += tmp9
    tmp15 += tmp10 * 2
    tmp11 = np.copy(delta.bb.oo) * -0.5
    tmp11 += tmp8 * 0.5
    del tmp8
    tmp11 += tmp9 * 0.5
    del tmp9
    tmp11 += tmp10
    del tmp10
    tmp3 = np.copy(delta.aa.oo) * -1
    tmp3 += tmp0
    del tmp0
    tmp3 += tmp1 * 2
    del tmp1
    tmp3 += tmp2
    del tmp2
    rdm2.bbbb.vvvv = np.copy(np.transpose(tmp133, (1, 0, 3, 2))) * 2
    del tmp133
    rdm2.bbbb.vvvv += einsum(tmp131, (0, 1, 2, 3), t1.bb, (0, 4), (1, 2, 4, 3)) * 2
    rdm2.abab.vvvv = einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 5), (0, 1, 4, 5))
    rdm2.abab.vvvv += einsum(t1.aa, (0, 1), tmp130, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.aaaa.vvvv = np.copy(np.transpose(tmp132, (1, 0, 3, 2))) * 2
    del tmp132
    rdm2.aaaa.vvvv += einsum(tmp129, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * 2
    rdm2.bbbb.vvvo = np.copy(np.transpose(tmp131, (2, 1, 3, 0))) * 2
    rdm2.abab.vvvo = einsum(l2.abab, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3))
    rdm2.aaaa.vvvo = np.copy(np.transpose(tmp129, (2, 1, 3, 0))) * 2
    rdm2.bbbb.vvov = np.copy(np.transpose(tmp131, (2, 1, 0, 3))) * -2
    del tmp131
    rdm2.abab.vvov = np.copy(np.transpose(tmp130, (1, 2, 0, 3)))
    del tmp130
    rdm2.aaaa.vvov = np.copy(np.transpose(tmp129, (2, 1, 0, 3))) * -2
    del tmp129
    rdm2.bbbb.vovv = np.copy(np.transpose(tmp124, (1, 0, 3, 2))) * 2
    rdm2.bbbb.vovv += einsum(tmp122, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * -2
    rdm2.bbbb.vovv += einsum(t1.bb, (0, 1), tmp109, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.vovv += np.transpose(tmp126, (2, 0, 1, 3))
    rdm2.bbbb.vovv += np.transpose(tmp126, (2, 0, 3, 1)) * -1
    rdm2.bbbb.vovv += np.transpose(tmp127, (1, 0, 3, 2)) * 2
    rdm2.bbbb.vovv += np.transpose(tmp128, (1, 0, 3, 2)) * 2
    rdm2.abab.vovv = einsum(t2.abab, (0, 1, 2, 3), l1.aa, (4, 0), (4, 1, 2, 3))
    rdm2.abab.vovv += einsum(tmp112, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.abab.vovv += einsum(t1.aa, (0, 1), tmp87, (0, 2, 3, 4), (3, 2, 1, 4)) * 2
    rdm2.abab.vovv += einsum(tmp91, (0, 1, 2, 3), t1.bb, (0, 4), (2, 1, 3, 4)) * -1
    rdm2.abab.vovv += einsum(tmp13, (0, 1, 2, 3), t2.abab, (0, 1, 4, 5), (3, 2, 4, 5)) * -1
    rdm2.abab.vovv += einsum(t1.aa, (0, 1), tmp115, (0, 2, 3, 4), (3, 2, 1, 4)) * -1
    rdm2.aaaa.vovv = np.copy(np.transpose(tmp116, (1, 0, 3, 2))) * 2
    rdm2.aaaa.vovv += einsum(t1.aa, (0, 1), tmp106, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.vovv += einsum(tmp112, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.aaaa.vovv += np.transpose(tmp119, (2, 0, 1, 3))
    rdm2.aaaa.vovv += np.transpose(tmp119, (2, 0, 3, 1)) * -1
    rdm2.aaaa.vovv += np.transpose(tmp120, (1, 0, 3, 2)) * 2
    rdm2.aaaa.vovv += np.transpose(tmp121, (1, 0, 3, 2)) * 2
    rdm2.bbbb.ovvv = np.copy(np.transpose(tmp124, (0, 1, 3, 2))) * -2
    del tmp124
    rdm2.bbbb.ovvv += einsum(tmp122, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1)) * 2
    rdm2.bbbb.ovvv += einsum(t1.bb, (0, 1), tmp109, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.ovvv += einsum(t1.bb, (0, 1), tmp125, (0, 2, 3, 4), (2, 3, 1, 4)) * -4
    del tmp125
    rdm2.bbbb.ovvv += np.transpose(tmp126, (0, 2, 3, 1))
    del tmp126
    rdm2.bbbb.ovvv += np.transpose(tmp127, (0, 1, 3, 2)) * -2
    del tmp127
    rdm2.bbbb.ovvv += np.transpose(tmp128, (0, 1, 3, 2)) * -2
    del tmp128
    rdm2.abab.ovvv = einsum(t2.abab, (0, 1, 2, 3), l1.bb, (4, 1), (0, 4, 2, 3))
    rdm2.abab.ovvv += einsum(tmp122, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1)) * 2
    del tmp122
    rdm2.abab.ovvv += einsum(tmp110, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -1
    rdm2.abab.ovvv += einsum(tmp123, (0, 1, 2, 3), t1.bb, (1, 4), (0, 3, 2, 4)) * 2
    del tmp123
    rdm2.abab.ovvv += einsum(tmp27, (0, 1, 2, 3), t2.abab, (0, 2, 4, 5), (1, 3, 4, 5)) * -1
    rdm2.abab.ovvv += einsum(tmp114, (0, 1, 2, 3), t1.bb, (1, 4), (0, 3, 2, 4)) * -1
    rdm2.aaaa.ovvv = np.copy(np.transpose(tmp116, (0, 1, 3, 2))) * -2
    del tmp116
    rdm2.aaaa.ovvv += einsum(t1.aa, (0, 1), tmp106, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.ovvv += einsum(tmp112, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.aaaa.ovvv += einsum(tmp117, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -1
    del tmp117
    rdm2.aaaa.ovvv += np.transpose(tmp119, (0, 2, 3, 1))
    del tmp119
    rdm2.aaaa.ovvv += np.transpose(tmp120, (0, 1, 3, 2)) * -2
    del tmp120
    rdm2.aaaa.ovvv += np.transpose(tmp121, (0, 1, 3, 2)) * -2
    del tmp121
    rdm2.bbbb.vvoo = np.copy(l2.bbbb) * 2
    rdm2.abab.vvoo = np.copy(l2.abab)
    rdm2.aaaa.vvoo = np.copy(l2.aaaa) * 2
    rdm2.bbbb.vovo = einsum(delta.bb.oo, (0, 1), tmp109, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.vovo += np.transpose(tmp89, (2, 1, 3, 0)) * -4
    rdm2.bbbb.vovo += einsum(t1.bb, (0, 1), l1.bb, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.vovo += np.transpose(tmp88, (2, 1, 3, 0)) * -1
    rdm2.bbbb.vovo += np.transpose(tmp111, (2, 1, 3, 0)) * 2
    rdm2.abab.vovo = einsum(tmp112, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.abab.vovo += np.transpose(tmp91, (2, 1, 3, 0)) * -1
    rdm2.abab.vovo += einsum(tmp13, (0, 1, 2, 3), t1.aa, (0, 4), (3, 2, 4, 1)) * -1
    rdm2.aaaa.vovo = einsum(tmp112, (0, 1), delta.aa.oo, (2, 3), (0, 2, 1, 3)) * 2
    rdm2.aaaa.vovo += np.transpose(tmp70, (2, 1, 3, 0)) * -4
    rdm2.aaaa.vovo += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.vovo += np.transpose(tmp72, (2, 1, 3, 0)) * -1
    rdm2.aaaa.vovo += np.transpose(tmp107, (2, 1, 3, 0)) * 2
    rdm2.bbbb.voov = einsum(delta.bb.oo, (0, 1), tmp109, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.voov += np.transpose(tmp89, (2, 1, 0, 3)) * 4
    rdm2.bbbb.voov += einsum(t1.bb, (0, 1), l1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.voov += np.transpose(tmp88, (2, 1, 0, 3))
    rdm2.bbbb.voov += np.transpose(tmp111, (2, 1, 0, 3)) * -2
    rdm2.abab.voov = np.copy(np.transpose(tmp86, (2, 1, 0, 3))) * 2
    del tmp86
    rdm2.abab.voov += einsum(l1.aa, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.abab.voov += np.transpose(tmp85, (2, 1, 0, 3)) * 2
    del tmp85
    rdm2.abab.voov += np.transpose(tmp115, (2, 1, 0, 3)) * -1
    del tmp115
    rdm2.aaaa.voov = einsum(tmp106, (0, 1), delta.aa.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.voov += np.transpose(tmp70, (2, 1, 0, 3)) * 4
    rdm2.aaaa.voov += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.voov += np.transpose(tmp72, (2, 1, 0, 3))
    rdm2.aaaa.voov += np.transpose(tmp107, (2, 1, 0, 3)) * -2
    rdm2.bbbb.ovvo = einsum(delta.bb.oo, (0, 1), tmp109, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.ovvo += np.transpose(tmp89, (1, 2, 3, 0)) * 4
    rdm2.bbbb.ovvo += einsum(t1.bb, (0, 1), l1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.ovvo += np.transpose(tmp88, (1, 2, 3, 0))
    rdm2.bbbb.ovvo += np.transpose(tmp111, (1, 2, 3, 0)) * -2
    rdm2.abab.ovvo = np.copy(np.transpose(tmp68, (0, 3, 2, 1))) * 2
    del tmp68
    rdm2.abab.ovvo += einsum(l1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.abab.ovvo += np.transpose(tmp113, (0, 3, 2, 1)) * 2
    del tmp113
    rdm2.abab.ovvo += np.transpose(tmp114, (0, 3, 2, 1)) * -1
    del tmp114
    rdm2.aaaa.ovvo = einsum(tmp112, (0, 1), delta.aa.oo, (2, 3), (2, 0, 1, 3)) * -2
    del tmp112
    rdm2.aaaa.ovvo += np.transpose(tmp70, (1, 2, 3, 0)) * 4
    rdm2.aaaa.ovvo += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.ovvo += np.transpose(tmp72, (1, 2, 3, 0))
    rdm2.aaaa.ovvo += np.transpose(tmp107, (1, 2, 3, 0)) * -2
    rdm2.bbbb.ovov = einsum(delta.bb.oo, (0, 1), tmp109, (2, 3), (0, 2, 1, 3))
    rdm2.bbbb.ovov += np.transpose(tmp89, (1, 2, 0, 3)) * -4
    del tmp89
    rdm2.bbbb.ovov += einsum(t1.bb, (0, 1), l1.bb, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.ovov += np.transpose(tmp88, (1, 2, 0, 3)) * -1
    del tmp88
    rdm2.bbbb.ovov += np.transpose(tmp111, (1, 2, 0, 3)) * 2
    del tmp111
    rdm2.abab.ovov = einsum(delta.aa.oo, (0, 1), tmp109, (2, 3), (0, 2, 1, 3))
    del tmp109
    rdm2.abab.ovov += np.transpose(tmp110, (1, 2, 0, 3)) * -1
    del tmp110
    rdm2.abab.ovov += einsum(tmp27, (0, 1, 2, 3), t1.bb, (2, 4), (1, 3, 0, 4)) * -1
    rdm2.aaaa.ovov = einsum(tmp106, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    del tmp106
    rdm2.aaaa.ovov += np.transpose(tmp70, (1, 2, 0, 3)) * -4
    del tmp70
    rdm2.aaaa.ovov += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ovov += np.transpose(tmp72, (1, 2, 0, 3)) * -1
    del tmp72
    rdm2.aaaa.ovov += np.transpose(tmp107, (1, 2, 0, 3)) * 2
    del tmp107
    rdm2.bbbb.oovv = np.copy(t2.bbbb) * 2
    rdm2.bbbb.oovv += einsum(tmp84, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 4, 1)) * -4
    rdm2.bbbb.oovv += np.transpose(tmp94, (0, 1, 3, 2)) * -2
    rdm2.bbbb.oovv += np.transpose(tmp95, (0, 1, 3, 2)) * -8
    rdm2.bbbb.oovv += np.transpose(tmp96, (0, 1, 3, 2)) * -2
    rdm2.bbbb.oovv += np.transpose(tmp96, (1, 0, 2, 3)) * -2
    rdm2.bbbb.oovv += einsum(tmp64, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.oovv += np.transpose(tmp94, (1, 0, 3, 2)) * 2
    del tmp94
    rdm2.bbbb.oovv += tmp95 * 8
    del tmp95
    rdm2.bbbb.oovv += tmp96 * 2
    rdm2.bbbb.oovv += np.transpose(tmp96, (1, 0, 3, 2)) * 2
    del tmp96
    rdm2.bbbb.oovv += einsum(tmp38, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp97, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.oovv += einsum(tmp97, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -1
    del tmp97
    rdm2.bbbb.oovv += tmp98 * 2
    rdm2.bbbb.oovv += einsum(tmp99, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 1, 4)) * 2
    del tmp99
    rdm2.bbbb.oovv += np.transpose(tmp98, (0, 1, 3, 2)) * -2
    del tmp98
    rdm2.bbbb.oovv += np.transpose(tmp100, (0, 1, 3, 2)) * -2
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp43, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.bbbb.oovv += einsum(tmp43, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3))
    rdm2.bbbb.oovv += np.transpose(tmp100, (1, 0, 3, 2)) * 2
    del tmp100
    rdm2.bbbb.oovv += einsum(tmp43, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1))
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp43, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.bbbb.oovv += np.transpose(tmp101, (1, 0, 3, 2)) * 2
    del tmp101
    rdm2.bbbb.oovv += einsum(t1.bb, (0, 1), tmp102, (0, 2, 3, 4), (2, 3, 1, 4)) * 2
    del tmp102
    rdm2.bbbb.oovv += np.transpose(tmp104, (1, 0, 2, 3))
    rdm2.bbbb.oovv += tmp104 * -1
    rdm2.bbbb.oovv += np.transpose(tmp104, (1, 0, 3, 2)) * -1
    rdm2.bbbb.oovv += np.transpose(tmp104, (0, 1, 3, 2))
    del tmp104
    rdm2.abab.oovv = np.copy(t2.abab)
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp84, (3, 4), (0, 1, 2, 4)) * -2
    del tmp84
    rdm2.abab.oovv += einsum(t2.aaaa, (0, 1, 2, 3), tmp87, (1, 4, 3, 5), (0, 4, 2, 5)) * 4
    del tmp87
    rdm2.abab.oovv += einsum(tmp90, (0, 1, 2, 3), t2.abab, (4, 0, 5, 2), (4, 1, 5, 3))
    del tmp90
    rdm2.abab.oovv += einsum(tmp38, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.abab.oovv += einsum(tmp74, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp39, (0, 2, 3, 4), (2, 3, 1, 4)) * -1
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp76, (2, 4), (0, 1, 4, 3)) * -1
    rdm2.abab.oovv += einsum(tmp60, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4)) * -1
    rdm2.abab.oovv += einsum(t2.abab, (0, 1, 2, 3), tmp16, (1, 4), (0, 4, 2, 3)) * -2
    rdm2.abab.oovv += einsum(tmp43, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.abab.oovv += einsum(tmp4, (0, 1), t2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -1
    rdm2.abab.oovv += einsum(tmp46, (0, 1, 2, 3), t2.abab, (0, 2, 4, 5), (1, 3, 4, 5))
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp47, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.abab.oovv += einsum(tmp91, (0, 1, 2, 3), t2.abab, (4, 0, 2, 5), (4, 1, 3, 5))
    del tmp91
    rdm2.abab.oovv += einsum(tmp31, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.abab.oovv += einsum(t1.aa, (0, 1), tmp48, (0, 2, 3, 4), (2, 3, 1, 4))
    rdm2.abab.oovv += einsum(tmp92, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * -2
    del tmp92
    rdm2.abab.oovv += einsum(tmp93, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4)) * -2
    del tmp93
    rdm2.abab.oovv += einsum(tmp63, (0, 1, 2, 3), t1.bb, (1, 4), (0, 2, 3, 4))
    rdm2.aaaa.oovv = np.copy(t2.aaaa) * 2
    rdm2.aaaa.oovv += einsum(t2.aaaa, (0, 1, 2, 3), tmp67, (3, 4), (0, 1, 2, 4)) * -4
    del tmp67
    rdm2.aaaa.oovv += np.transpose(tmp69, (0, 1, 3, 2)) * -2
    rdm2.aaaa.oovv += np.transpose(tmp71, (0, 1, 3, 2)) * -8
    rdm2.aaaa.oovv += np.transpose(tmp73, (0, 1, 3, 2)) * -2
    rdm2.aaaa.oovv += np.transpose(tmp73, (1, 0, 2, 3)) * -2
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp59, (2, 3), (2, 0, 1, 3)) * -2
    rdm2.aaaa.oovv += tmp69 * 2
    del tmp69
    rdm2.aaaa.oovv += tmp71 * 8
    del tmp71
    rdm2.aaaa.oovv += tmp73 * 2
    rdm2.aaaa.oovv += np.transpose(tmp73, (1, 0, 3, 2)) * 2
    del tmp73
    rdm2.aaaa.oovv += einsum(tmp24, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.oovv += einsum(tmp74, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp74, (2, 3), (0, 2, 3, 1)) * -1
    del tmp74
    rdm2.aaaa.oovv += tmp75 * 2
    rdm2.aaaa.oovv += einsum(t2.aaaa, (0, 1, 2, 3), tmp76, (3, 4), (0, 1, 4, 2)) * 2
    del tmp76
    rdm2.aaaa.oovv += np.transpose(tmp75, (0, 1, 3, 2)) * -2
    del tmp75
    rdm2.aaaa.oovv += np.transpose(tmp77, (1, 0, 3, 2)) * -2
    rdm2.aaaa.oovv += einsum(tmp31, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp31, (2, 3), (0, 2, 3, 1))
    rdm2.aaaa.oovv += np.transpose(tmp77, (0, 1, 3, 2)) * 2
    del tmp77
    rdm2.aaaa.oovv += einsum(t1.aa, (0, 1), tmp31, (2, 3), (2, 0, 1, 3))
    rdm2.aaaa.oovv += einsum(tmp31, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3)) * -1
    rdm2.aaaa.oovv += np.transpose(tmp78, (1, 0, 3, 2)) * 2
    del tmp78
    rdm2.aaaa.oovv += einsum(tmp79, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3)) * 2
    del tmp79
    rdm2.aaaa.oovv += np.transpose(tmp81, (1, 0, 2, 3))
    rdm2.aaaa.oovv += tmp81 * -1
    rdm2.aaaa.oovv += np.transpose(tmp81, (1, 0, 3, 2)) * -1
    rdm2.aaaa.oovv += np.transpose(tmp81, (0, 1, 3, 2))
    del tmp81
    rdm2.bbbb.vooo = einsum(delta.bb.oo, (0, 1), l1.bb, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.vooo += einsum(l1.bb, (0, 1), delta.bb.oo, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.vooo += np.transpose(tmp19, (3, 2, 1, 0)) * 2
    rdm2.abab.vooo = einsum(l1.aa, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2.abab.vooo += np.transpose(tmp13, (3, 2, 0, 1)) * -1
    del tmp13
    rdm2.aaaa.vooo = einsum(l1.aa, (0, 1), delta.aa.oo, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.vooo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.vooo += np.transpose(tmp6, (3, 2, 1, 0)) * 2
    rdm2.bbbb.ovoo = einsum(delta.bb.oo, (0, 1), l1.bb, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.bbbb.ovoo += einsum(l1.bb, (0, 1), delta.bb.oo, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.ovoo += np.transpose(tmp19, (2, 3, 1, 0)) * -2
    del tmp19
    rdm2.abab.ovoo = einsum(l1.bb, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    rdm2.abab.ovoo += np.transpose(tmp27, (1, 3, 0, 2)) * -1
    del tmp27
    rdm2.aaaa.ovoo = einsum(l1.aa, (0, 1), delta.aa.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.aaaa.ovoo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (0, 2, 1, 3))
    rdm2.aaaa.ovoo += np.transpose(tmp6, (2, 3, 1, 0)) * -2
    del tmp6
    rdm2.bbbb.oovo = einsum(tmp64, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    del tmp64
    rdm2.bbbb.oovo += einsum(tmp38, (0, 1), delta.bb.oo, (2, 3), (2, 0, 1, 3)) * -1
    rdm2.bbbb.oovo += np.transpose(tmp50, (2, 1, 3, 0)) * 2
    rdm2.bbbb.oovo += einsum(delta.bb.oo, (0, 1), tmp43, (2, 3), (2, 0, 3, 1)) * -1
    rdm2.bbbb.oovo += einsum(delta.bb.oo, (0, 1), tmp43, (2, 3), (0, 2, 3, 1))
    rdm2.bbbb.oovo += np.transpose(tmp53, (1, 2, 3, 0))
    rdm2.bbbb.oovo += np.transpose(tmp54, (1, 2, 3, 0)) * 4
    rdm2.bbbb.oovo += einsum(tmp17, (0, 1), t1.bb, (2, 3), (1, 2, 3, 0))
    rdm2.bbbb.oovo += np.transpose(tmp53, (2, 1, 3, 0)) * -1
    rdm2.bbbb.oovo += np.transpose(tmp54, (2, 1, 3, 0)) * -4
    rdm2.bbbb.oovo += einsum(tmp17, (0, 1), t1.bb, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.bbbb.oovo += np.transpose(tmp56, (2, 1, 3, 0)) * -1
    rdm2.abab.oovo = einsum(tmp59, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3)) * 2
    del tmp59
    rdm2.abab.oovo += np.transpose(tmp60, (0, 2, 3, 1)) * -1
    del tmp60
    rdm2.abab.oovo += einsum(tmp58, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3)) * -2
    rdm2.abab.oovo += np.transpose(tmp61, (0, 2, 3, 1)) * -2
    del tmp61
    rdm2.abab.oovo += np.transpose(tmp62, (0, 2, 3, 1)) * -2
    del tmp62
    rdm2.abab.oovo += einsum(tmp16, (0, 1), t1.aa, (2, 3), (2, 1, 3, 0)) * -2
    rdm2.abab.oovo += einsum(t1.aa, (0, 1), tmp46, (0, 2, 3, 4), (2, 4, 1, 3))
    del tmp46
    rdm2.abab.oovo += np.transpose(tmp63, (0, 2, 3, 1))
    del tmp63
    rdm2.aaaa.oovo = einsum(delta.aa.oo, (0, 1), tmp23, (2, 3), (2, 0, 3, 1))
    rdm2.aaaa.oovo += einsum(delta.aa.oo, (0, 1), tmp24, (2, 3), (0, 2, 3, 1)) * -1
    rdm2.aaaa.oovo += np.transpose(tmp25, (2, 1, 3, 0)) * 2
    rdm2.aaaa.oovo += einsum(delta.aa.oo, (0, 1), tmp58, (2, 3), (2, 0, 3, 1)) * -2
    rdm2.aaaa.oovo += einsum(delta.aa.oo, (0, 1), tmp58, (2, 3), (0, 2, 3, 1)) * 2
    del tmp58
    rdm2.aaaa.oovo += np.transpose(tmp32, (1, 2, 3, 0))
    rdm2.aaaa.oovo += np.transpose(tmp33, (1, 2, 3, 0)) * 4
    rdm2.aaaa.oovo += einsum(t1.aa, (0, 1), tmp4, (2, 3), (3, 0, 1, 2))
    rdm2.aaaa.oovo += np.transpose(tmp32, (2, 1, 3, 0)) * -1
    rdm2.aaaa.oovo += np.transpose(tmp33, (2, 1, 3, 0)) * -4
    rdm2.aaaa.oovo += einsum(tmp4, (0, 1), t1.aa, (2, 3), (2, 1, 3, 0)) * -1
    rdm2.aaaa.oovo += np.transpose(tmp35, (2, 1, 3, 0)) * -1
    rdm2.bbbb.ooov = einsum(tmp49, (0, 1), delta.bb.oo, (2, 3), (0, 2, 3, 1)) * -2
    del tmp49
    rdm2.bbbb.ooov += einsum(tmp38, (0, 1), delta.bb.oo, (2, 3), (2, 0, 3, 1))
    rdm2.bbbb.ooov += np.transpose(tmp50, (2, 1, 0, 3)) * -2
    del tmp50
    rdm2.bbbb.ooov += einsum(tmp52, (0, 1), delta.bb.oo, (2, 3), (0, 2, 3, 1)) * 2
    rdm2.bbbb.ooov += einsum(delta.bb.oo, (0, 1), tmp52, (2, 3), (0, 2, 1, 3)) * -2
    del tmp52
    rdm2.bbbb.ooov += np.transpose(tmp53, (1, 2, 0, 3)) * -1
    rdm2.bbbb.ooov += np.transpose(tmp54, (1, 2, 0, 3)) * -4
    rdm2.bbbb.ooov += einsum(tmp17, (0, 1), t1.bb, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.bbbb.ooov += np.transpose(tmp53, (2, 1, 0, 3))
    del tmp53
    rdm2.bbbb.ooov += np.transpose(tmp54, (2, 1, 0, 3)) * 4
    del tmp54
    rdm2.bbbb.ooov += einsum(tmp17, (0, 1), t1.bb, (2, 3), (2, 1, 0, 3))
    rdm2.bbbb.ooov += np.transpose(tmp56, (2, 1, 0, 3))
    del tmp56
    rdm2.abab.ooov = einsum(tmp38, (0, 1), delta.aa.oo, (2, 3), (2, 0, 3, 1))
    del tmp38
    rdm2.abab.ooov += np.transpose(tmp39, (1, 2, 0, 3)) * -1
    del tmp39
    rdm2.abab.ooov += einsum(delta.aa.oo, (0, 1), tmp43, (2, 3), (0, 2, 1, 3)) * -1
    del tmp43
    rdm2.abab.ooov += np.transpose(tmp44, (1, 2, 0, 3)) * -2
    del tmp44
    rdm2.abab.ooov += np.transpose(tmp45, (1, 2, 0, 3)) * -2
    del tmp45
    rdm2.abab.ooov += einsum(tmp4, (0, 1), t1.bb, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.abab.ooov += np.transpose(tmp47, (1, 2, 0, 3))
    del tmp47
    rdm2.abab.ooov += np.transpose(tmp48, (1, 2, 0, 3))
    del tmp48
    rdm2.aaaa.ooov = einsum(delta.aa.oo, (0, 1), tmp23, (2, 3), (2, 0, 1, 3)) * -1
    del tmp23
    rdm2.aaaa.ooov += einsum(delta.aa.oo, (0, 1), tmp24, (2, 3), (0, 2, 1, 3))
    del tmp24
    rdm2.aaaa.ooov += np.transpose(tmp25, (2, 1, 0, 3)) * -2
    del tmp25
    rdm2.aaaa.ooov += einsum(tmp31, (0, 1), delta.aa.oo, (2, 3), (0, 2, 3, 1))
    rdm2.aaaa.ooov += einsum(delta.aa.oo, (0, 1), tmp31, (2, 3), (0, 2, 1, 3)) * -1
    del tmp31
    rdm2.aaaa.ooov += np.transpose(tmp32, (1, 2, 0, 3)) * -1
    rdm2.aaaa.ooov += np.transpose(tmp33, (1, 2, 0, 3)) * -4
    rdm2.aaaa.ooov += einsum(tmp29, (0, 1), t1.aa, (2, 3), (1, 2, 0, 3)) * -2
    rdm2.aaaa.ooov += np.transpose(tmp32, (2, 1, 0, 3))
    del tmp32
    rdm2.aaaa.ooov += np.transpose(tmp33, (2, 1, 0, 3)) * 4
    del tmp33
    rdm2.aaaa.ooov += einsum(tmp29, (0, 1), t1.aa, (2, 3), (2, 1, 0, 3)) * 2
    del tmp29
    rdm2.aaaa.ooov += np.transpose(tmp35, (2, 1, 0, 3))
    del tmp35
    rdm2.bbbb.oooo = einsum(delta.bb.oo, (0, 1), tmp15, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.bbbb.oooo += einsum(delta.bb.oo, (0, 1), tmp15, (2, 3), (3, 0, 1, 2))
    del tmp15
    rdm2.bbbb.oooo += einsum(delta.bb.oo, (0, 1), tmp16, (2, 3), (3, 0, 2, 1)) * -2
    del tmp16
    rdm2.bbbb.oooo += einsum(tmp17, (0, 1), delta.bb.oo, (2, 3), (2, 1, 0, 3))
    del tmp17
    rdm2.bbbb.oooo += np.transpose(tmp18, (3, 2, 1, 0)) * 2
    del tmp18
    rdm2.bbbb.oooo += np.transpose(tmp20, (2, 3, 1, 0)) * -2
    del tmp20
    rdm2.abab.oooo = einsum(delta.aa.oo, (0, 1), tmp11, (2, 3), (0, 3, 1, 2)) * -2
    del tmp11
    rdm2.abab.oooo += einsum(tmp4, (0, 1), delta.bb.oo, (2, 3), (1, 2, 0, 3)) * -1
    rdm2.abab.oooo += np.transpose(tmp12, (1, 3, 0, 2))
    del tmp12
    rdm2.abab.oooo += np.transpose(tmp14, (1, 3, 0, 2))
    del tmp14
    rdm2.aaaa.oooo = einsum(delta.aa.oo, (0, 1), tmp3, (2, 3), (0, 3, 1, 2)) * -1
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp3, (2, 3), (3, 0, 1, 2))
    del tmp3
    rdm2.aaaa.oooo += einsum(delta.aa.oo, (0, 1), tmp4, (2, 3), (3, 0, 2, 1)) * -1
    rdm2.aaaa.oooo += einsum(tmp4, (0, 1), delta.aa.oo, (2, 3), (2, 1, 0, 3))
    del delta, tmp4
    rdm2.aaaa.oooo += np.transpose(tmp5, (3, 2, 1, 0)) * 2
    del tmp5
    rdm2.aaaa.oooo += np.transpose(tmp7, (2, 3, 1, 0)) * -2
    del tmp7
    rdm2.aaaa = pack_2e(rdm2.aaaa.oooo, rdm2.aaaa.ooov, rdm2.aaaa.oovo, rdm2.aaaa.ovoo, rdm2.aaaa.vooo, rdm2.aaaa.oovv, rdm2.aaaa.ovov, rdm2.aaaa.ovvo, rdm2.aaaa.voov, rdm2.aaaa.vovo, rdm2.aaaa.vvoo, rdm2.aaaa.ovvv, rdm2.aaaa.vovv, rdm2.aaaa.vvov, rdm2.aaaa.vvvo, rdm2.aaaa.vvvv)
    rdm2.abab = pack_2e(rdm2.abab.oooo, rdm2.abab.ooov, rdm2.abab.oovo, rdm2.abab.ovoo, rdm2.abab.vooo, rdm2.abab.oovv, rdm2.abab.ovov, rdm2.abab.ovvo, rdm2.abab.voov, rdm2.abab.vovo, rdm2.abab.vvoo, rdm2.abab.ovvv, rdm2.abab.vovv, rdm2.abab.vvov, rdm2.abab.vvvo, rdm2.abab.vvvv)
    rdm2.bbbb = pack_2e(rdm2.bbbb.oooo, rdm2.bbbb.ooov, rdm2.bbbb.oovo, rdm2.bbbb.ovoo, rdm2.bbbb.vooo, rdm2.bbbb.oovv, rdm2.bbbb.ovov, rdm2.bbbb.ovvo, rdm2.bbbb.voov, rdm2.bbbb.vovo, rdm2.bbbb.vvoo, rdm2.bbbb.ovvv, rdm2.bbbb.vovv, rdm2.bbbb.vvov, rdm2.bbbb.vvvo, rdm2.bbbb.vvvv)
    rdm2 = Namespace(
        aaaa=np.transpose(rdm2.aaaa, (0, 2, 1, 3)),
        aabb=np.transpose(rdm2.abab, (0, 2, 1, 3)),
        bbbb=np.transpose(rdm2.bbbb, (0, 2, 1, 3)),
    )

    return rdm2

def hbar_matvec_ip_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:15:26.065422.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp101 : array
    tmp102 : array
    tmp103 : array
    tmp105 : array
    tmp11 : array
    tmp116 : array
    tmp117 : array
    tmp118 : array
    tmp12 : array
    tmp120 : array
    tmp122 : array
    tmp124 : array
    tmp126 : array
    tmp128 : array
    tmp131 : array
    tmp132 : array
    tmp137 : array
    tmp138 : array
    tmp139 : array
    tmp14 : array
    tmp140 : array
    tmp141 : array
    tmp142 : array
    tmp143 : array
    tmp144 : array
    tmp145 : array
    tmp152 : array
    tmp156 : array
    tmp159 : array
    tmp16 : array
    tmp161 : array
    tmp163 : array
    tmp166 : array
    tmp168 : array
    tmp17 : array
    tmp170 : array
    tmp171 : array
    tmp173 : array
    tmp177 : array
    tmp178 : array
    tmp179 : array
    tmp18 : array
    tmp181 : array
    tmp183 : array
    tmp185 : array
    tmp186 : array
    tmp187 : array
    tmp189 : array
    tmp19 : array
    tmp2 : array
    tmp200 : array
    tmp201 : array
    tmp202 : array
    tmp206 : array
    tmp208 : array
    tmp21 : array
    tmp210 : array
    tmp212 : array
    tmp214 : array
    tmp216 : array
    tmp218 : array
    tmp219 : array
    tmp22 : array
    tmp220 : array
    tmp228 : array
    tmp233 : array
    tmp236 : array
    tmp24 : array
    tmp241 : array
    tmp242 : array
    tmp243 : array
    tmp248 : array
    tmp249 : array
    tmp251 : array
    tmp252 : array
    tmp256 : array
    tmp257 : array
    tmp258 : array
    tmp26 : array
    tmp260 : array
    tmp262 : array
    tmp263 : array
    tmp264 : array
    tmp268 : array
    tmp269 : array
    tmp27 : array
    tmp275 : array
    tmp276 : array
    tmp277 : array
    tmp278 : array
    tmp279 : array
    tmp281 : array
    tmp284 : array
    tmp286 : array
    tmp287 : array
    tmp289 : array
    tmp29 : array
    tmp291 : array
    tmp292 : array
    tmp293 : array
    tmp295 : array
    tmp298 : array
    tmp30 : array
    tmp302 : array
    tmp303 : array
    tmp304 : array
    tmp305 : array
    tmp306 : array
    tmp307 : array
    tmp308 : array
    tmp310 : array
    tmp315 : array
    tmp316 : array
    tmp317 : array
    tmp318 : array
    tmp32 : array
    tmp320 : array
    tmp322 : array
    tmp325 : array
    tmp326 : array
    tmp327 : array
    tmp328 : array
    tmp329 : array
    tmp33 : array
    tmp330 : array
    tmp334 : array
    tmp335 : array
    tmp337 : array
    tmp338 : array
    tmp339 : array
    tmp34 : array
    tmp340 : array
    tmp341 : array
    tmp342 : array
    tmp344 : array
    tmp345 : array
    tmp346 : array
    tmp350 : array
    tmp351 : array
    tmp352 : array
    tmp354 : array
    tmp356 : array
    tmp357 : array
    tmp358 : array
    tmp36 : array
    tmp362 : array
    tmp363 : array
    tmp364 : array
    tmp365 : array
    tmp366 : array
    tmp367 : array
    tmp37 : array
    tmp372 : array
    tmp373 : array
    tmp374 : array
    tmp385 : array
    tmp387 : array
    tmp389 : array
    tmp39 : array
    tmp392 : array
    tmp394 : array
    tmp396 : array
    tmp4 : array
    tmp401 : array
    tmp403 : array
    tmp41 : array
    tmp414 : array
    tmp416 : array
    tmp418 : array
    tmp42 : array
    tmp43 : array
    tmp434 : array
    tmp438 : array
    tmp440 : array
    tmp442 : array
    tmp447 : array
    tmp449 : array
    tmp453 : array
    tmp455 : array
    tmp457 : array
    tmp459 : array
    tmp461 : array
    tmp47 : array
    tmp49 : array
    tmp51 : array
    tmp52 : array
    tmp54 : array
    tmp55 : array
    tmp57 : array
    tmp58 : array
    tmp59 : array
    tmp6 : array
    tmp61 : array
    tmp67 : array
    tmp69 : array
    tmp7 : array
    tmp70 : array
    tmp72 : array
    tmp74 : array
    tmp78 : array
    tmp79 : array
    tmp80 : array
    tmp81 : array
    tmp82 : array
    tmp83 : array
    tmp85 : array
    tmp87 : array
    tmp9 : array
    tmp90 : array
    tmp92 : array
    tmp93 : array
    tmp95 : array
    tmp98 : array
    """

    tmp8 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (1, 2), (0,))
    tmp10 = einsum(v.bbb.xov, (0, 1, 2), t1.bb, (1, 2), (0,))
    tmp16 = einsum(v.bbb.xov, (0, 1, 2), t1.bb, (3, 2), (0, 3, 1))
    tmp6 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (3, 2), (0, 3, 1))
    tmp131 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp21 = einsum(tmp8, (0,), v.bbb.xov, (0, 1, 2), (1, 2))
    tmp18 = einsum(v.bbb.xov, (0, 1, 2), tmp10, (0,), (1, 2))
    tmp17 = einsum(tmp16, (0, 1, 2), v.bbb.xov, (0, 1, 3), (2, 3))
    tmp54 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (4, 1, 3))
    tmp51 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (0, 3, 4))
    tmp156 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp19 = einsum(tmp10, (0,), v.baa.xov, (0, 1, 2), (1, 2))
    tmp14 = einsum(tmp8, (0,), v.baa.xov, (0, 1, 2), (1, 2))
    tmp12 = einsum(v.baa.xov, (0, 1, 2), tmp6, (0, 1, 3), (3, 2))
    tmp29 = einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp26 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp92 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp449 = einsum(tmp16, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp47 = einsum(v.bbb.xov, (0, 1, 2), tmp16, (0, 3, 4), (3, 1, 4, 2))
    tmp276 = einsum(v.bbb.xvv, (0, 1, 2), t1.bb, (3, 2), (0, 3, 1))
    tmp37 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp401 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp394 = einsum(t2.bbbb, (0, 1, 2, 3), tmp131, (4, 5, 3, 2), (0, 1, 5, 4))
    tmp391 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp387 = einsum(tmp16, (0, 1, 2), tmp16, (0, 3, 4), (3, 1, 4, 2))
    tmp59 = einsum(tmp21, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp58 = einsum(tmp18, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp57 = einsum(tmp17, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp252 = einsum(v.baa.xoo, (0, 1, 2), tmp16, (0, 3, 4), (1, 2, 3, 4))
    tmp55 = einsum(v.bbb.xov, (0, 1, 2), tmp54, (0, 3, 2), (3, 1))
    tmp52 = einsum(v.bbb.xov, (0, 1, 2), tmp51, (0, 3, 2), (3, 1))
    tmp49 = einsum(tmp16, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp36 = einsum(f.bb.ov, (0, 1), t1.bb, (2, 1), (0, 2))
    tmp264 = einsum(v.bbb.xoo, (0, 1, 2), tmp6, (0, 3, 4), (3, 4, 1, 2))
    tmp22 = einsum(tmp6, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp249 = einsum(tmp6, (0, 1, 2), tmp16, (0, 3, 4), (1, 2, 3, 4))
    tmp278 = einsum(tmp8, (0,), v.bbb.xvv, (0, 1, 2), (1, 2))
    tmp275 = einsum(tmp10, (0,), v.bbb.xvv, (0, 1, 2), (1, 2))
    tmp43 = einsum(tmp8, (0,), v.bbb.xoo, (0, 1, 2), (1, 2))
    tmp42 = einsum(v.bbb.xoo, (0, 1, 2), tmp10, (0,), (1, 2))
    tmp41 = einsum(tmp16, (0, 1, 2), v.bbb.xoo, (0, 3, 1), (3, 2))
    tmp39 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp2 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp214 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp210 = einsum(t2.abab, (0, 1, 2, 3), tmp156, (4, 5, 2, 3), (0, 4, 1, 5))
    tmp280 = einsum(v.bbb.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 4, 1, 2))
    tmp24 = einsum(v.bbb.xov, (0, 1, 2), tmp6, (0, 3, 4), (3, 4, 1, 2))
    tmp69 = einsum(v.baa.xvv, (0, 1, 2), t1.aa, (3, 2), (0, 3, 1))
    tmp4 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp207 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp34 = einsum(tmp19, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp33 = einsum(tmp14, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp32 = einsum(tmp12, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp173 = einsum(v.baa.xoo, (0, 1, 2), tmp6, (0, 3, 4), (3, 1, 2, 4))
    tmp30 = einsum(tmp29, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp27 = einsum(tmp26, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp1 = einsum(t1.aa, (0, 1), f.aa.ov, (2, 1), (2, 0))
    tmp11 = einsum(tmp10, (0,), v.baa.xoo, (0, 1, 2), (1, 2))
    tmp9 = einsum(tmp8, (0,), v.baa.xoo, (0, 1, 2), (1, 2))
    tmp7 = einsum(v.baa.xoo, (0, 1, 2), tmp6, (0, 2, 3), (1, 3))
    tmp103 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 1, 2, 4))
    tmp93 = einsum(t2.aaaa, (0, 1, 2, 3), tmp92, (4, 5, 3, 2), (0, 1, 5, 4))
    tmp89 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp85 = einsum(tmp6, (0, 1, 2), tmp6, (0, 3, 4), (1, 3, 2, 4))
    tmp72 = einsum(v.baa.xvv, (0, 1, 2), tmp10, (0,), (1, 2))
    del tmp10
    tmp67 = einsum(v.baa.xvv, (0, 1, 2), tmp8, (0,), (1, 2))
    del tmp8
    tmp461 = einsum(tmp449, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp459 = einsum(tmp449, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 3, 4))
    tmp457 = einsum(tmp16, (0, 1, 2), tmp54, (0, 3, 4), (1, 3, 2, 4))
    tmp455 = einsum(tmp47, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp453 = einsum(tmp16, (0, 1, 2), tmp51, (0, 3, 4), (1, 3, 2, 4))
    tmp447 = einsum(v.bbb.xoo, (0, 1, 2), tmp276, (0, 3, 4), (3, 1, 2, 4))
    tmp442 = einsum(tmp21, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp440 = einsum(tmp18, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp438 = einsum(t2.bbbb, (0, 1, 2, 3), tmp17, (4, 3), (0, 1, 4, 2))
    tmp434 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp418 = einsum(tmp54, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp416 = einsum(tmp51, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp414 = einsum(t2.bbbb, (0, 1, 2, 3), tmp37, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp403 = einsum(tmp401, (0, 1, 2, 3), t1.bb, (3, 4), (1, 2, 0, 4))
    tmp396 = einsum(tmp394, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp392 = einsum(tmp391, (0, 1, 2, 3), t2.bbbb, (4, 5, 2, 3), (4, 5, 0, 1)) * -1
    del tmp391
    tmp389 = einsum(tmp387, (0, 1, 2, 3), t1.bb, (2, 4), (1, 0, 3, 4))
    tmp385 = einsum(tmp16, (0, 1, 2), tmp276, (0, 3, 4), (1, 3, 2, 4))
    tmp374 = einsum(tmp59, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp373 = einsum(tmp58, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp372 = einsum(tmp57, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp367 = einsum(tmp252, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp366 = einsum(tmp55, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp365 = einsum(tmp52, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp364 = einsum(t2.abab, (0, 1, 2, 3), tmp49, (4, 5, 1, 2), (0, 4, 5, 3))
    tmp363 = einsum(t2.abab, (0, 1, 2, 3), tmp49, (0, 4, 1, 2), (4, 3))
    tmp362 = einsum(tmp47, (0, 1, 2, 3), t2.bbbb, (2, 1, 4, 3), (0, 4))
    tmp358 = einsum(v.baa.xoo, (0, 1, 2), tmp276, (0, 3, 4), (1, 2, 3, 4))
    tmp357 = einsum(v.baa.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp356 = einsum(tmp36, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp354 = einsum(tmp264, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp352 = einsum(tmp6, (0, 1, 2), tmp51, (0, 3, 4), (1, 2, 3, 4))
    tmp351 = einsum(t2.abab, (0, 1, 2, 3), tmp22, (4, 5, 0, 2), (4, 5, 1, 3))
    tmp350 = einsum(tmp6, (0, 1, 2), tmp54, (0, 3, 4), (1, 2, 3, 4))
    tmp346 = einsum(v.bbb.xoo, (0, 1, 2), tmp276, (0, 2, 3), (1, 3))
    tmp345 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp344 = einsum(tmp249, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp342 = einsum(tmp6, (0, 1, 2), tmp276, (0, 3, 4), (1, 2, 3, 4))
    tmp341 = einsum(tmp278, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp340 = einsum(tmp276, (0, 1, 2), tmp16, (0, 3, 1), (3, 2))
    tmp339 = einsum(tmp275, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp338 = einsum(tmp54, (0, 1, 2), v.bbb.xvv, (0, 3, 2), (1, 3))
    tmp337 = einsum(tmp51, (0, 1, 2), v.bbb.xvv, (0, 3, 2), (1, 3)) * -1
    tmp335 = einsum(tmp16, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp334 = einsum(f.bb.vv, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp330 = einsum(t1.bb, (0, 1), tmp43, (2, 0), (2, 1))
    tmp329 = einsum(tmp42, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp328 = einsum(tmp41, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp327 = einsum(tmp19, (0, 1), t2.abab, (2, 3, 1, 4), (2, 0, 3, 4))
    tmp326 = einsum(tmp14, (0, 1), t2.abab, (2, 3, 1, 4), (2, 0, 3, 4))
    tmp325 = einsum(t2.abab, (0, 1, 2, 3), tmp12, (4, 2), (0, 4, 1, 3))
    tmp322 = einsum(t2.abab, (0, 1, 2, 3), tmp156, (4, 1, 2, 5), (0, 4, 3, 5))
    tmp320 = einsum(v.bbb.xov, (0, 1, 2), tmp54, (0, 1, 3), (3, 2))
    tmp318 = einsum(v.bbb.xov, (0, 1, 2), tmp51, (0, 1, 3), (3, 2))
    tmp317 = einsum(t2.abab, (0, 1, 2, 3), tmp39, (4, 5, 1, 2), (0, 4, 5, 3))
    tmp316 = einsum(t2.abab, (0, 1, 2, 3), tmp39, (0, 4, 1, 2), (4, 3))
    tmp315 = einsum(t2.bbbb, (0, 1, 2, 3), tmp37, (4, 0, 1, 3), (4, 2))
    tmp310 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (4, 2), (4, 0, 1, 3))
    tmp308 = einsum(t1.bb, (0, 1), f.bb.oo, (2, 0), (2, 1))
    tmp307 = einsum(t2.bbbb, (0, 1, 2, 3), tmp21, (1, 3), (0, 2))
    tmp306 = einsum(tmp19, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp305 = einsum(t2.bbbb, (0, 1, 2, 3), tmp18, (1, 3), (0, 2))
    tmp304 = einsum(t2.bbbb, (0, 1, 2, 3), tmp17, (1, 3), (0, 2))
    tmp303 = einsum(t2.abab, (0, 1, 2, 3), tmp14, (0, 2), (1, 3))
    tmp302 = einsum(t2.abab, (0, 1, 2, 3), tmp12, (0, 2), (1, 3))
    tmp298 = einsum(t2.bbbb, (0, 1, 2, 3), tmp131, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp295 = einsum(t2.abab, (0, 1, 2, 3), tmp92, (0, 4, 5, 2), (4, 1, 5, 3))
    tmp293 = einsum(v.baa.xoo, (0, 1, 2), tmp51, (0, 3, 4), (1, 2, 3, 4))
    tmp292 = einsum(v.baa.xoo, (0, 1, 2), tmp54, (0, 3, 4), (1, 2, 3, 4))
    tmp291 = einsum(t2.abab, (0, 1, 2, 3), tmp2, (4, 0, 5, 2), (4, 5, 1, 3))
    tmp289 = einsum(t1.bb, (0, 1), tmp214, (2, 3, 4, 0), (3, 2, 4, 1))
    tmp287 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp286 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (0, 2), (1, 3))
    tmp284 = einsum(tmp210, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp281 = einsum(tmp280, (0, 1, 2, 3), t2.abab, (4, 5, 1, 3), (4, 0, 5, 2))
    del tmp280
    tmp279 = einsum(tmp6, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp277 = einsum(tmp276, (0, 1, 2), v.bbb.xov, (0, 1, 3), (3, 2))
    tmp269 = einsum(t1.aa, (0, 1), tmp264, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp268 = einsum(tmp24, (0, 1, 2, 3), t2.abab, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp263 = einsum(v.bbb.xoo, (0, 1, 2), tmp69, (0, 3, 4), (3, 1, 2, 4))
    tmp262 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp260 = einsum(t1.aa, (0, 1), tmp252, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp258 = einsum(tmp26, (0, 1, 2), tmp16, (0, 3, 4), (1, 3, 4, 2))
    tmp257 = einsum(t2.abab, (0, 1, 2, 3), tmp47, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp256 = einsum(tmp29, (0, 1, 2), tmp16, (0, 3, 4), (1, 3, 4, 2))
    tmp251 = einsum(t1.aa, (0, 1), tmp249, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp248 = einsum(tmp69, (0, 1, 2), tmp16, (0, 3, 4), (1, 3, 4, 2))
    tmp243 = einsum(t2.abab, (0, 1, 2, 3), tmp21, (4, 3), (0, 1, 4, 2))
    tmp242 = einsum(t2.abab, (0, 1, 2, 3), tmp18, (4, 3), (0, 1, 4, 2))
    tmp241 = einsum(t2.abab, (0, 1, 2, 3), tmp17, (4, 3), (0, 1, 4, 2))
    tmp236 = einsum(tmp156, (0, 1, 2, 3), t2.abab, (0, 4, 5, 3), (4, 1, 5, 2))
    tmp233 = einsum(t2.abab, (0, 1, 2, 3), tmp4, (4, 0, 5, 3), (4, 1, 5, 2))
    tmp228 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (4, 3), (0, 4, 1, 2))
    tmp220 = einsum(v.bbb.xoo, (0, 1, 2), tmp26, (0, 3, 4), (3, 1, 2, 4))
    tmp219 = einsum(v.bbb.xoo, (0, 1, 2), tmp29, (0, 3, 4), (3, 1, 2, 4))
    tmp218 = einsum(t2.abab, (0, 1, 2, 3), tmp37, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp216 = einsum(t1.aa, (0, 1), tmp214, (2, 0, 3, 4), (2, 4, 3, 1))
    tmp212 = einsum(t1.aa, (0, 1), tmp210, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp208 = einsum(t2.abab, (0, 1, 2, 3), tmp207, (4, 5, 2, 3), (0, 1, 4, 5))
    del tmp207
    tmp206 = einsum(v.baa.xvv, (0, 1, 2), tmp16, (0, 3, 4), (3, 4, 1, 2))
    tmp202 = einsum(t1.aa, (0, 1), tmp34, (2, 0), (2, 1))
    tmp201 = einsum(tmp33, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp200 = einsum(tmp32, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp189 = einsum(tmp173, (0, 1, 2, 3), t1.aa, (3, 4), (0, 1, 2, 4))
    tmp187 = einsum(tmp173, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 3, 4))
    tmp186 = einsum(tmp30, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp185 = einsum(t1.aa, (0, 1), tmp27, (2, 0), (2, 1))
    tmp183 = einsum(tmp6, (0, 1, 2), tmp29, (0, 3, 4), (1, 3, 2, 4))
    tmp181 = einsum(tmp22, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp179 = einsum(tmp6, (0, 1, 2), tmp26, (0, 3, 4), (1, 3, 2, 4))
    tmp178 = einsum(t2.abab, (0, 1, 2, 3), tmp24, (4, 0, 1, 3), (4, 2))
    tmp177 = einsum(t2.aaaa, (0, 1, 2, 3), tmp22, (4, 1, 0, 3), (4, 2))
    tmp171 = einsum(v.baa.xoo, (0, 1, 2), tmp69, (0, 3, 4), (3, 1, 2, 4))
    tmp170 = einsum(tmp69, (0, 1, 2), v.baa.xoo, (0, 3, 1), (3, 2))
    tmp168 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp166 = einsum(t1.aa, (0, 1), tmp1, (0, 2), (2, 1))
    tmp163 = einsum(t2.aaaa, (0, 1, 2, 3), tmp19, (4, 3), (0, 1, 4, 2))
    tmp161 = einsum(t2.aaaa, (0, 1, 2, 3), tmp14, (4, 3), (0, 1, 4, 2))
    tmp159 = einsum(t2.aaaa, (0, 1, 2, 3), tmp12, (4, 3), (0, 1, 4, 2))
    tmp152 = einsum(t2.aaaa, (0, 1, 2, 3), f.aa.ov, (4, 3), (4, 0, 1, 2))
    tmp145 = einsum(tmp11, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp144 = einsum(t1.aa, (0, 1), tmp9, (2, 0), (2, 1))
    tmp143 = einsum(t1.aa, (0, 1), tmp7, (2, 0), (2, 1))
    tmp142 = einsum(t2.abab, (0, 1, 2, 3), tmp21, (1, 3), (0, 2))
    tmp141 = einsum(t2.aaaa, (0, 1, 2, 3), tmp19, (1, 3), (0, 2))
    tmp140 = einsum(tmp18, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp139 = einsum(t2.abab, (0, 1, 2, 3), tmp17, (1, 3), (0, 2))
    tmp138 = einsum(t2.aaaa, (0, 1, 2, 3), tmp14, (1, 3), (0, 2))
    tmp137 = einsum(tmp12, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp132 = einsum(t2.abab, (0, 1, 2, 3), tmp131, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp128 = einsum(t2.aaaa, (0, 1, 2, 3), tmp92, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp126 = einsum(tmp29, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp124 = einsum(tmp26, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp122 = einsum(tmp29, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp120 = einsum(tmp26, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp118 = einsum(t2.aaaa, (0, 1, 2, 3), tmp2, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp117 = einsum(tmp4, (0, 1, 2, 3), t2.abab, (1, 2, 4, 3), (0, 4))
    tmp116 = einsum(t2.aaaa, (0, 1, 2, 3), tmp2, (4, 0, 1, 3), (4, 2))
    tmp105 = einsum(tmp103, (0, 1, 2, 3), t1.aa, (3, 4), (1, 2, 0, 4))
    tmp102 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp101 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp98 = einsum(f.aa.oo, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp95 = einsum(tmp93, (0, 1, 2, 3), t1.aa, (3, 4), (0, 1, 2, 4))
    tmp90 = einsum(t2.aaaa, (0, 1, 2, 3), tmp89, (4, 5, 2, 3), (0, 1, 4, 5)) * -1
    del tmp89
    tmp87 = einsum(tmp85, (0, 1, 2, 3), t1.aa, (2, 4), (1, 0, 3, 4))
    tmp83 = einsum(tmp6, (0, 1, 2), tmp69, (0, 3, 4), (1, 3, 2, 4))
    tmp82 = einsum(t1.aa, (0, 1), tmp72, (2, 1), (0, 2))
    tmp81 = einsum(tmp69, (0, 1, 2), tmp6, (0, 3, 1), (3, 2))
    tmp80 = einsum(t1.aa, (0, 1), tmp67, (2, 1), (0, 2))
    tmp79 = einsum(v.baa.xvv, (0, 1, 2), tmp29, (0, 3, 2), (3, 1))
    tmp78 = einsum(v.baa.xvv, (0, 1, 2), tmp26, (0, 3, 2), (3, 1)) * -1
    tmp74 = einsum(v.baa.xvv, (0, 1, 2), tmp6, (0, 3, 4), (3, 4, 1, 2))
    tmp70 = einsum(tmp69, (0, 1, 2), v.baa.xov, (0, 1, 3), (3, 2))
    tmp61 = einsum(t1.aa, (0, 1), f.aa.vv, (2, 1), (0, 2))

    return {f"tmp1": tmp1, f"tmp101": tmp101, f"tmp102": tmp102, f"tmp103": tmp103, f"tmp105": tmp105, f"tmp11": tmp11, f"tmp116": tmp116, f"tmp117": tmp117, f"tmp118": tmp118, f"tmp12": tmp12, f"tmp120": tmp120, f"tmp122": tmp122, f"tmp124": tmp124, f"tmp126": tmp126, f"tmp128": tmp128, f"tmp131": tmp131, f"tmp132": tmp132, f"tmp137": tmp137, f"tmp138": tmp138, f"tmp139": tmp139, f"tmp14": tmp14, f"tmp140": tmp140, f"tmp141": tmp141, f"tmp142": tmp142, f"tmp143": tmp143, f"tmp144": tmp144, f"tmp145": tmp145, f"tmp152": tmp152, f"tmp156": tmp156, f"tmp159": tmp159, f"tmp16": tmp16, f"tmp161": tmp161, f"tmp163": tmp163, f"tmp166": tmp166, f"tmp168": tmp168, f"tmp17": tmp17, f"tmp170": tmp170, f"tmp171": tmp171, f"tmp173": tmp173, f"tmp177": tmp177, f"tmp178": tmp178, f"tmp179": tmp179, f"tmp18": tmp18, f"tmp181": tmp181, f"tmp183": tmp183, f"tmp185": tmp185, f"tmp186": tmp186, f"tmp187": tmp187, f"tmp189": tmp189, f"tmp19": tmp19, f"tmp2": tmp2, f"tmp200": tmp200, f"tmp201": tmp201, f"tmp202": tmp202, f"tmp206": tmp206, f"tmp208": tmp208, f"tmp21": tmp21, f"tmp210": tmp210, f"tmp212": tmp212, f"tmp214": tmp214, f"tmp216": tmp216, f"tmp218": tmp218, f"tmp219": tmp219, f"tmp22": tmp22, f"tmp220": tmp220, f"tmp228": tmp228, f"tmp233": tmp233, f"tmp236": tmp236, f"tmp24": tmp24, f"tmp241": tmp241, f"tmp242": tmp242, f"tmp243": tmp243, f"tmp248": tmp248, f"tmp249": tmp249, f"tmp251": tmp251, f"tmp252": tmp252, f"tmp256": tmp256, f"tmp257": tmp257, f"tmp258": tmp258, f"tmp26": tmp26, f"tmp260": tmp260, f"tmp262": tmp262, f"tmp263": tmp263, f"tmp264": tmp264, f"tmp268": tmp268, f"tmp269": tmp269, f"tmp27": tmp27, f"tmp275": tmp275, f"tmp276": tmp276, f"tmp277": tmp277, f"tmp278": tmp278, f"tmp279": tmp279, f"tmp281": tmp281, f"tmp284": tmp284, f"tmp286": tmp286, f"tmp287": tmp287, f"tmp289": tmp289, f"tmp29": tmp29, f"tmp291": tmp291, f"tmp292": tmp292, f"tmp293": tmp293, f"tmp295": tmp295, f"tmp298": tmp298, f"tmp30": tmp30, f"tmp302": tmp302, f"tmp303": tmp303, f"tmp304": tmp304, f"tmp305": tmp305, f"tmp306": tmp306, f"tmp307": tmp307, f"tmp308": tmp308, f"tmp310": tmp310, f"tmp315": tmp315, f"tmp316": tmp316, f"tmp317": tmp317, f"tmp318": tmp318, f"tmp32": tmp32, f"tmp320": tmp320, f"tmp322": tmp322, f"tmp325": tmp325, f"tmp326": tmp326, f"tmp327": tmp327, f"tmp328": tmp328, f"tmp329": tmp329, f"tmp33": tmp33, f"tmp330": tmp330, f"tmp334": tmp334, f"tmp335": tmp335, f"tmp337": tmp337, f"tmp338": tmp338, f"tmp339": tmp339, f"tmp34": tmp34, f"tmp340": tmp340, f"tmp341": tmp341, f"tmp342": tmp342, f"tmp344": tmp344, f"tmp345": tmp345, f"tmp346": tmp346, f"tmp350": tmp350, f"tmp351": tmp351, f"tmp352": tmp352, f"tmp354": tmp354, f"tmp356": tmp356, f"tmp357": tmp357, f"tmp358": tmp358, f"tmp36": tmp36, f"tmp362": tmp362, f"tmp363": tmp363, f"tmp364": tmp364, f"tmp365": tmp365, f"tmp366": tmp366, f"tmp367": tmp367, f"tmp37": tmp37, f"tmp372": tmp372, f"tmp373": tmp373, f"tmp374": tmp374, f"tmp385": tmp385, f"tmp387": tmp387, f"tmp389": tmp389, f"tmp39": tmp39, f"tmp392": tmp392, f"tmp394": tmp394, f"tmp396": tmp396, f"tmp4": tmp4, f"tmp401": tmp401, f"tmp403": tmp403, f"tmp41": tmp41, f"tmp414": tmp414, f"tmp416": tmp416, f"tmp418": tmp418, f"tmp42": tmp42, f"tmp43": tmp43, f"tmp434": tmp434, f"tmp438": tmp438, f"tmp440": tmp440, f"tmp442": tmp442, f"tmp447": tmp447, f"tmp449": tmp449, f"tmp453": tmp453, f"tmp455": tmp455, f"tmp457": tmp457, f"tmp459": tmp459, f"tmp461": tmp461, f"tmp47": tmp47, f"tmp49": tmp49, f"tmp51": tmp51, f"tmp52": tmp52, f"tmp54": tmp54, f"tmp55": tmp55, f"tmp57": tmp57, f"tmp58": tmp58, f"tmp59": tmp59, f"tmp6": tmp6, f"tmp61": tmp61, f"tmp67": tmp67, f"tmp69": tmp69, f"tmp7": tmp7, f"tmp70": tmp70, f"tmp72": tmp72, f"tmp74": tmp74, f"tmp78": tmp78, f"tmp79": tmp79, f"tmp80": tmp80, f"tmp81": tmp81, f"tmp82": tmp82, f"tmp83": tmp83, f"tmp85": tmp85, f"tmp87": tmp87, f"tmp9": tmp9, f"tmp90": tmp90, f"tmp92": tmp92, f"tmp93": tmp93, f"tmp95": tmp95, f"tmp98": tmp98}

def hbar_matvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:15:26.265626.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp47 = einsum(r2.aba, (0, 1, 2), v.baa.xov, (3, 0, 2), (3, 1))
    tmp48 = einsum(r2.bbb, (0, 1, 2), v.bbb.xov, (3, 1, 2), (3, 0))
    tmp9 = einsum(v.baa.xov, (0, 1, 2), r2.aaa, (3, 1, 2), (0, 3))
    tmp10 = einsum(r2.bab, (0, 1, 2), v.bbb.xov, (3, 0, 2), (3, 1)) * -1
    tmp49 = np.copy(tmp47) * -0.5
    tmp49 += tmp48
    tmp66 = np.copy(ints.tmp37)
    tmp66 += np.transpose(ints.tmp47, (0, 2, 1, 3))
    tmp53 = np.copy(tmp47) * -1
    tmp53 += tmp48 * 2
    tmp17 = np.copy(tmp9)
    tmp17 += tmp10 * 0.5
    tmp14 = np.copy(ints.tmp22)
    tmp14 += np.transpose(ints.tmp2, (0, 2, 1, 3))
    tmp11 = np.copy(tmp9) * 2
    tmp11 += tmp10
    tmp78 = einsum(v.bbb.xoo, (0, 1, 2), tmp49, (0, 3), (3, 1, 2)) * 2
    tmp76 = einsum(tmp66, (0, 1, 2, 3), r2.bbb, (4, 1, 3), (4, 0, 2)) * -2
    tmp77 = einsum(ints.tmp16, (0, 1, 2), tmp53, (0, 3), (3, 1, 2))
    tmp18 = einsum(ints.tmp6, (0, 1, 2), tmp17, (0, 3), (1, 2, 3))
    del tmp17
    tmp15 = einsum(tmp14, (0, 1, 2, 3), r2.aaa, (4, 2, 3), (4, 0, 1)) * -1
    tmp16 = einsum(tmp11, (0, 1), v.baa.xoo, (0, 2, 3), (2, 3, 1)) * 0.5
    tmp92 = np.copy(ints.tmp389)
    del ints.tmp389
    tmp92 += np.transpose(ints.tmp403, (1, 2, 0, 3))
    del ints.tmp403
    tmp92 += np.transpose(ints.tmp418, (0, 2, 1, 3))
    del ints.tmp418
    tmp92 += np.transpose(ints.tmp447, (0, 2, 1, 3))
    del ints.tmp447
    tmp92 += ints.tmp459
    del ints.tmp459
    tmp92 += np.transpose(ints.tmp416, (0, 2, 1, 3)) * 2
    del ints.tmp416
    tmp92 += ints.tmp455 * 2
    del ints.tmp455
    tmp88 = np.copy(ints.tmp276)
    tmp88 += ints.tmp54
    tmp88 += ints.tmp51 * 2
    tmp59 = np.copy(ints.tmp335)
    del ints.tmp335
    tmp59 += ints.tmp345
    del ints.tmp345
    tmp59 += ints.tmp298 * 2
    del ints.tmp298
    tmp90 = np.copy(f.bb.oo)
    tmp90 += ints.tmp36
    tmp90 += np.transpose(ints.tmp42, (1, 0))
    tmp90 += np.transpose(ints.tmp43, (1, 0))
    tmp90 += np.transpose(ints.tmp58, (1, 0))
    tmp90 += np.transpose(ints.tmp59, (1, 0))
    tmp74 = np.copy(ints.tmp276)
    tmp74 += ints.tmp51 * 2
    tmp74 += ints.tmp54
    tmp83 = np.copy(ints.tmp52) * 2
    tmp83 += ints.tmp55
    tmp83 += ints.tmp41 * -1
    tmp83 += ints.tmp57 * -1
    tmp81 = np.copy(ints.tmp37)
    tmp81 += np.transpose(ints.tmp385, (0, 2, 1, 3))
    del ints.tmp385
    tmp81 += np.transpose(ints.tmp414, (0, 2, 1, 3)) * 2
    del ints.tmp414
    tmp81 += np.transpose(ints.tmp453, (0, 2, 1, 3)) * 2
    del ints.tmp453
    tmp81 += np.transpose(ints.tmp457, (0, 2, 1, 3))
    del ints.tmp457
    tmp81 += ints.tmp461
    del ints.tmp461
    tmp81 += np.transpose(ints.tmp47, (0, 2, 1, 3))
    tmp79 = np.copy(np.transpose(tmp76, (1, 2, 0))) * -1
    del tmp76
    tmp79 += np.transpose(tmp77, (1, 2, 0)) * -1
    del tmp77
    tmp79 += np.transpose(tmp78, (0, 2, 1))
    del tmp78
    tmp2 = np.copy(f.bb.ov)
    tmp2 += ints.tmp18
    tmp2 += ints.tmp21
    tmp2 += ints.tmp17 * -1
    del ints.tmp17
    tmp3 = np.copy(f.aa.ov)
    tmp3 += ints.tmp14
    tmp3 += ints.tmp19
    tmp3 += ints.tmp12 * -1
    del ints.tmp12
    tmp29 = np.copy(tmp9) * 2
    del tmp9
    tmp29 += tmp10
    del tmp10
    tmp31 = np.copy(f.aa.oo)
    tmp31 += np.transpose(ints.tmp11, (1, 0))
    tmp31 += ints.tmp1
    tmp31 += np.transpose(ints.tmp33, (1, 0))
    tmp31 += np.transpose(ints.tmp34, (1, 0))
    tmp31 += np.transpose(ints.tmp9, (1, 0))
    tmp33 = np.copy(ints.tmp105)
    del ints.tmp105
    tmp33 += np.transpose(ints.tmp122, (1, 0, 2, 3))
    del ints.tmp122
    tmp33 += np.transpose(ints.tmp171, (1, 0, 2, 3))
    del ints.tmp171
    tmp33 += np.transpose(ints.tmp187, (2, 0, 1, 3))
    del ints.tmp187
    tmp33 += np.transpose(ints.tmp87, (2, 0, 1, 3))
    del ints.tmp87
    tmp33 += np.transpose(ints.tmp120, (1, 0, 2, 3)) * 2
    del ints.tmp120
    tmp33 += np.transpose(ints.tmp181, (2, 0, 1, 3)) * 2
    del ints.tmp181
    tmp27 = np.copy(ints.tmp168)
    tmp27 += ints.tmp74
    tmp27 += ints.tmp128 * 2
    tmp21 = np.copy(ints.tmp118)
    del ints.tmp118
    tmp21 += ints.tmp179
    del ints.tmp179
    tmp21 += ints.tmp183 * 0.5
    del ints.tmp183
    tmp21 += np.transpose(ints.tmp189, (0, 2, 1, 3)) * 0.5
    del ints.tmp189
    tmp21 += ints.tmp22 * 0.5
    tmp21 += np.transpose(ints.tmp2, (0, 2, 1, 3)) * 0.5
    tmp21 += ints.tmp83 * 0.5
    del ints.tmp83
    tmp19 = np.copy(np.transpose(tmp15, (1, 2, 0))) * -1
    del tmp15
    tmp19 += np.transpose(tmp16, (2, 1, 0))
    del tmp16
    tmp19 += tmp18 * -1
    del tmp18
    tmp23 = np.copy(ints.tmp27) * 2
    tmp23 += ints.tmp30
    tmp23 += ints.tmp32 * -1
    tmp23 += ints.tmp7 * -1
    tmp12 = np.copy(ints.tmp26)
    tmp12 += ints.tmp29 * 0.5
    tmp12 += ints.tmp69 * 0.5
    tmp86 = einsum(v.bbb.xov, (0, 1, 2), tmp48, (0, 3), (3, 1, 2))
    tmp93 = einsum(r1.b, (0,), tmp92, (1, 2, 0, 3), (1, 2, 3))
    del tmp92
    tmp89 = einsum(tmp88, (0, 1, 2), tmp47, (0, 3), (1, 3, 2))
    del tmp88
    tmp87 = einsum(r2.bbb, (0, 1, 2), tmp59, (3, 1, 4, 2), (0, 3, 4)) * -1
    tmp91 = einsum(tmp90, (0, 1), r2.bbb, (2, 0, 3), (1, 2, 3)) * -1
    del tmp90
    tmp73 = einsum(tmp47, (0, 1), v.bbb.xov, (0, 2, 3), (1, 2, 3))
    del tmp47
    tmp72 = einsum(ints.tmp449, (0, 1, 2, 3), r2.bbb, (3, 1, 4), (0, 2, 4)) * -1
    del ints.tmp449
    tmp75 = einsum(tmp74, (0, 1, 2), tmp48, (0, 3), (1, 3, 2)) * 2
    del tmp48, tmp74
    tmp71 = einsum(r2.aba, (0, 1, 2), ints.tmp295, (0, 3, 2, 4), (3, 1, 4))
    tmp84 = einsum(tmp83, (0, 1), r2.bbb, (2, 1, 3), (0, 2, 3)) * -2
    del tmp83
    tmp82 = einsum(r1.b, (0,), tmp81, (1, 0, 2, 3), (1, 2, 3))
    del tmp81
    tmp80 = einsum(t1.bb, (0, 1), tmp79, (2, 0, 3), (2, 3, 1))
    del tmp79
    tmp63 = einsum(tmp2, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp56 = einsum(r2.aba, (0, 1, 2), ints.tmp156, (0, 1, 2, 3), (3,))
    tmp57 = einsum(ints.tmp131, (0, 1, 2, 3), r2.bbb, (1, 0, 2), (3,)) * -1
    del ints.tmp131
    tmp40 = einsum(r2.bab, (0, 1, 2), ints.tmp156, (1, 0, 3, 2), (3,)) * -1
    del ints.tmp156
    tmp39 = einsum(ints.tmp92, (0, 1, 2, 3), r2.aaa, (1, 0, 2), (3,)) * -1
    del ints.tmp92
    tmp0 = np.copy(ints.tmp24)
    tmp0 += ints.tmp4
    tmp67 = np.copy(ints.tmp16)
    del ints.tmp16
    tmp67 += v.bbb.xoo
    tmp37 = einsum(t1.aa, (0, 1), tmp3, (0, 2), (2, 1))
    tmp54 = np.copy(ints.tmp6)
    del ints.tmp6
    tmp54 += v.baa.xoo
    tmp52 = np.copy(ints.tmp39)
    tmp52 += ints.tmp49
    tmp26 = einsum(r2.bab, (0, 1, 2), ints.tmp132, (3, 0, 4, 2), (3, 1, 4)) * -1
    tmp30 = einsum(tmp29, (0, 1), v.baa.xov, (0, 2, 3), (2, 1, 3))
    del tmp29
    tmp32 = einsum(tmp31, (0, 1), r2.aaa, (2, 0, 3), (2, 1, 3)) * -1
    del tmp31
    tmp34 = einsum(tmp33, (0, 1, 2, 3), r1.a, (0,), (1, 2, 3))
    del tmp33
    tmp28 = einsum(r2.aaa, (0, 1, 2), tmp27, (3, 1, 4, 2), (0, 3, 4)) * -1
    del tmp27
    tmp8 = einsum(r2.aaa, (0, 1, 2), ints.tmp173, (3, 1, 4, 0), (3, 4, 2)) * -1
    del ints.tmp173
    tmp22 = einsum(tmp21, (0, 1, 2, 3), r1.a, (2,), (0, 1, 3)) * 2
    del tmp21
    tmp20 = einsum(tmp19, (0, 1, 2), t1.aa, (1, 3), (0, 2, 3)) * 2
    del tmp19
    tmp24 = einsum(tmp23, (0, 1), r2.aaa, (2, 1, 3), (2, 0, 3)) * -2
    del tmp23
    tmp13 = einsum(tmp12, (0, 1, 2), tmp11, (0, 3), (3, 1, 2)) * 2
    del tmp12
    tmp94 = np.copy(tmp86) * 2
    del tmp86
    tmp94 += np.transpose(tmp87, (1, 0, 2)) * -2
    del tmp87
    tmp94 += tmp89
    del tmp89
    tmp94 += tmp91 * -2
    del tmp91
    tmp94 += tmp93
    del tmp93
    tmp70 = np.copy(ints.tmp302)
    del ints.tmp302
    tmp70 += ints.tmp304 * 2
    del ints.tmp304
    tmp70 += ints.tmp308
    del ints.tmp308
    tmp70 += ints.tmp315 * 2
    del ints.tmp315
    tmp70 += ints.tmp316
    del ints.tmp316
    tmp70 += ints.tmp329
    del ints.tmp329
    tmp70 += ints.tmp330
    del ints.tmp330
    tmp70 += ints.tmp337 * 2
    del ints.tmp337
    tmp70 += ints.tmp340
    del ints.tmp340
    tmp70 += ints.tmp346
    del ints.tmp346
    tmp70 += ints.tmp356
    del ints.tmp356
    tmp70 += ints.tmp362 * 2
    del ints.tmp362
    tmp70 += ints.tmp363
    del ints.tmp363
    tmp70 += ints.tmp365 * 2
    del ints.tmp365
    tmp70 += ints.tmp366
    del ints.tmp366
    tmp70 += ints.tmp373
    del ints.tmp373
    tmp70 += ints.tmp374
    del ints.tmp374
    tmp70 += f.bb.ov * -1
    tmp70 += ints.tmp18 * -1
    del ints.tmp18
    tmp70 += ints.tmp21 * -1
    del ints.tmp21
    tmp70 += ints.tmp286 * -1
    del ints.tmp286
    tmp70 += ints.tmp287 * -2
    del ints.tmp287
    tmp70 += ints.tmp303 * -1
    del ints.tmp303
    tmp70 += ints.tmp305 * -2
    del ints.tmp305
    tmp70 += ints.tmp306 * -1
    del ints.tmp306
    tmp70 += ints.tmp307 * -2
    del ints.tmp307
    tmp70 += ints.tmp328 * -1
    del ints.tmp328
    tmp70 += ints.tmp334 * -1
    del ints.tmp334
    tmp70 += ints.tmp338 * -1
    del ints.tmp338
    tmp70 += ints.tmp339 * -1
    del ints.tmp339
    tmp70 += ints.tmp341 * -1
    del ints.tmp341
    tmp70 += ints.tmp372 * -1
    del ints.tmp372
    tmp85 = np.copy(tmp71)
    del tmp71
    tmp85 += tmp72 * 2
    del tmp72
    tmp85 += tmp73
    del tmp73
    tmp85 += tmp75
    del tmp75
    tmp85 += tmp80
    del tmp80
    tmp85 += tmp82
    del tmp82
    tmp85 += tmp84
    del tmp84
    tmp64 = np.copy(ints.tmp277)
    del ints.tmp277
    tmp64 += np.transpose(ints.tmp318, (1, 0)) * 2
    del ints.tmp318
    tmp64 += np.transpose(ints.tmp320, (1, 0))
    del ints.tmp320
    tmp64 += f.bb.vv * -1
    tmp64 += np.transpose(ints.tmp275, (1, 0)) * -1
    del ints.tmp275
    tmp64 += np.transpose(ints.tmp278, (1, 0)) * -1
    del ints.tmp278
    tmp64 += tmp63
    del tmp63
    tmp97 = np.copy(ints.tmp396)
    del ints.tmp396
    tmp97 += np.transpose(ints.tmp434, (1, 2, 0, 3))
    del ints.tmp434
    tmp97 += ints.tmp440
    del ints.tmp440
    tmp97 += ints.tmp442
    del ints.tmp442
    tmp97 += ints.tmp392 * -1
    del ints.tmp392
    tmp97 += ints.tmp438 * -1
    del ints.tmp438
    tmp95 = np.copy(ints.tmp387)
    del ints.tmp387
    tmp95 += ints.tmp394
    del ints.tmp394
    tmp95 += np.transpose(ints.tmp401, (0, 2, 1, 3)) * -1
    del ints.tmp401
    tmp96 = np.copy(tmp56) * 0.5
    tmp96 += tmp57
    tmp69 = np.copy(tmp39) * 2
    tmp69 += tmp40 * -1
    tmp62 = np.copy(ints.tmp276)
    del ints.tmp276
    tmp62 += ints.tmp51 * 2
    del ints.tmp51
    tmp62 += ints.tmp54
    del ints.tmp54
    tmp62 += v.bbb.xov
    tmp4 = np.copy(f.aa.oo)
    tmp4 += np.transpose(ints.tmp11, (1, 0))
    del ints.tmp11
    tmp4 += ints.tmp1
    del ints.tmp1
    tmp4 += np.transpose(ints.tmp27, (1, 0)) * 2
    del ints.tmp27
    tmp4 += np.transpose(ints.tmp30, (1, 0))
    del ints.tmp30
    tmp4 += np.transpose(ints.tmp33, (1, 0))
    del ints.tmp33
    tmp4 += np.transpose(ints.tmp34, (1, 0))
    del ints.tmp34
    tmp4 += np.transpose(ints.tmp9, (1, 0))
    del ints.tmp9
    tmp4 += np.transpose(ints.tmp32, (1, 0)) * -1
    del ints.tmp32
    tmp4 += np.transpose(ints.tmp7, (1, 0)) * -1
    del ints.tmp7
    tmp68 = einsum(tmp0, (0, 1, 2, 3), r2.bab, (4, 1, 3), (0, 2, 4)) * 0.5
    tmp68 += einsum(r2.bab, (0, 1, 2), tmp66, (3, 0, 4, 2), (1, 4, 3)) * 0.5
    del tmp66
    tmp68 += einsum(tmp67, (0, 1, 2), tmp11, (0, 3), (3, 2, 1)) * 0.5
    del tmp67
    tmp61 = np.copy(ints.tmp210)
    tmp61 += ints.tmp214
    tmp61 += ints.tmp249
    tmp61 += np.transpose(ints.tmp252, (1, 0, 2, 3))
    tmp61 += np.transpose(ints.tmp264, (0, 1, 3, 2))
    tmp65 = np.copy(ints.tmp24)
    del ints.tmp24
    tmp65 += ints.tmp281
    del ints.tmp281
    tmp65 += np.transpose(ints.tmp292, (1, 0, 2, 3))
    del ints.tmp292
    tmp65 += np.transpose(ints.tmp293, (1, 0, 2, 3)) * 2
    del ints.tmp293
    tmp65 += np.transpose(ints.tmp310, (1, 0, 2, 3))
    del ints.tmp310
    tmp65 += ints.tmp326
    del ints.tmp326
    tmp65 += ints.tmp327
    del ints.tmp327
    tmp65 += ints.tmp342
    del ints.tmp342
    tmp65 += ints.tmp350
    del ints.tmp350
    tmp65 += ints.tmp352 * 2
    del ints.tmp352
    tmp65 += np.transpose(ints.tmp358, (1, 0, 2, 3))
    del ints.tmp358
    tmp65 += ints.tmp4
    del ints.tmp4
    tmp65 += ints.tmp284 * -1
    del ints.tmp284
    tmp65 += np.transpose(ints.tmp289, (1, 0, 2, 3)) * -1
    del ints.tmp289
    tmp65 += ints.tmp291 * -1
    del ints.tmp291
    tmp65 += ints.tmp317 * -1
    del ints.tmp317
    tmp65 += ints.tmp325 * -1
    del ints.tmp325
    tmp65 += ints.tmp344 * -1
    del ints.tmp344
    tmp65 += ints.tmp351 * -1
    del ints.tmp351
    tmp65 += ints.tmp354 * -1
    del ints.tmp354
    tmp65 += ints.tmp364 * -1
    del ints.tmp364
    tmp65 += np.transpose(ints.tmp367, (1, 0, 2, 3)) * -1
    del ints.tmp367
    tmp60 = np.copy(ints.tmp279)
    del ints.tmp279
    tmp60 += ints.tmp357
    del ints.tmp357
    tmp60 += ints.tmp322 * -1
    del ints.tmp322
    tmp7 = np.copy(f.bb.oo)
    tmp7 += ints.tmp36
    del ints.tmp36
    tmp7 += np.transpose(ints.tmp42, (1, 0))
    del ints.tmp42
    tmp7 += np.transpose(ints.tmp43, (1, 0))
    del ints.tmp43
    tmp7 += np.transpose(ints.tmp52, (1, 0)) * 2
    del ints.tmp52
    tmp7 += np.transpose(ints.tmp55, (1, 0))
    del ints.tmp55
    tmp7 += np.transpose(ints.tmp58, (1, 0))
    del ints.tmp58
    tmp7 += np.transpose(ints.tmp59, (1, 0))
    del ints.tmp59
    tmp7 += np.transpose(ints.tmp41, (1, 0)) * -1
    del ints.tmp41
    tmp7 += np.transpose(ints.tmp57, (1, 0)) * -1
    del ints.tmp57
    tmp43 = np.copy(ints.tmp116) * 2
    del ints.tmp116
    tmp43 += ints.tmp117
    del ints.tmp117
    tmp43 += ints.tmp137 * 2
    del ints.tmp137
    tmp43 += ints.tmp139
    del ints.tmp139
    tmp43 += ints.tmp144
    del ints.tmp144
    tmp43 += ints.tmp145
    del ints.tmp145
    tmp43 += ints.tmp166
    del ints.tmp166
    tmp43 += ints.tmp170
    del ints.tmp170
    tmp43 += ints.tmp177 * 2
    del ints.tmp177
    tmp43 += ints.tmp178
    del ints.tmp178
    tmp43 += ints.tmp185 * 2
    del ints.tmp185
    tmp43 += ints.tmp186
    del ints.tmp186
    tmp43 += ints.tmp201
    del ints.tmp201
    tmp43 += ints.tmp202
    del ints.tmp202
    tmp43 += ints.tmp78 * 2
    del ints.tmp78
    tmp43 += ints.tmp81
    del ints.tmp81
    tmp43 += ints.tmp98
    del ints.tmp98
    tmp43 += f.aa.ov * -1
    tmp43 += ints.tmp101 * -2
    del ints.tmp101
    tmp43 += ints.tmp102 * -1
    del ints.tmp102
    tmp43 += ints.tmp138 * -2
    del ints.tmp138
    tmp43 += ints.tmp140 * -1
    del ints.tmp140
    tmp43 += ints.tmp141 * -2
    del ints.tmp141
    tmp43 += ints.tmp142 * -1
    del ints.tmp142
    tmp43 += ints.tmp143 * -1
    del ints.tmp143
    tmp43 += ints.tmp14 * -1
    del ints.tmp14
    tmp43 += ints.tmp19 * -1
    del ints.tmp19
    tmp43 += ints.tmp200 * -1
    del ints.tmp200
    tmp43 += ints.tmp61 * -1
    del ints.tmp61
    tmp43 += ints.tmp79 * -1
    del ints.tmp79
    tmp43 += ints.tmp80 * -1
    del ints.tmp80
    tmp43 += ints.tmp82 * -1
    del ints.tmp82
    tmp50 = np.copy(ints.tmp26) * 2
    del ints.tmp26
    tmp50 += ints.tmp29
    del ints.tmp29
    tmp50 += ints.tmp69
    del ints.tmp69
    tmp50 += v.baa.xov
    tmp46 = np.copy(ints.tmp210)
    del ints.tmp210
    tmp46 += ints.tmp214
    del ints.tmp214
    tmp46 += ints.tmp249
    del ints.tmp249
    tmp46 += np.transpose(ints.tmp252, (1, 0, 2, 3))
    del ints.tmp252
    tmp46 += np.transpose(ints.tmp264, (0, 1, 3, 2))
    del ints.tmp264
    tmp51 = np.copy(ints.tmp208)
    del ints.tmp208
    tmp51 += np.transpose(ints.tmp219, (0, 2, 1, 3))
    del ints.tmp219
    tmp51 += np.transpose(ints.tmp220, (0, 2, 1, 3)) * 2
    del ints.tmp220
    tmp51 += np.transpose(ints.tmp228, (0, 2, 1, 3))
    del ints.tmp228
    tmp51 += ints.tmp242
    del ints.tmp242
    tmp51 += ints.tmp243
    del ints.tmp243
    tmp51 += ints.tmp248
    del ints.tmp248
    tmp51 += ints.tmp256
    del ints.tmp256
    tmp51 += ints.tmp258 * 2
    del ints.tmp258
    tmp51 += np.transpose(ints.tmp263, (0, 2, 1, 3))
    del ints.tmp263
    tmp51 += ints.tmp39
    tmp51 += ints.tmp49
    tmp51 += ints.tmp212 * -1
    del ints.tmp212
    tmp51 += np.transpose(ints.tmp216, (0, 2, 1, 3)) * -1
    del ints.tmp216
    tmp51 += ints.tmp218 * -1
    del ints.tmp218
    tmp51 += ints.tmp233 * -1
    del ints.tmp233
    tmp51 += ints.tmp241 * -1
    del ints.tmp241
    tmp51 += ints.tmp251 * -1
    del ints.tmp251
    tmp51 += ints.tmp257 * -1
    del ints.tmp257
    tmp51 += ints.tmp260 * -1
    del ints.tmp260
    tmp51 += ints.tmp268 * -1
    del ints.tmp268
    tmp51 += np.transpose(ints.tmp269, (0, 2, 1, 3)) * -1
    del ints.tmp269
    tmp38 = np.copy(np.transpose(ints.tmp124, (1, 0))) * 2
    del ints.tmp124
    tmp38 += np.transpose(ints.tmp126, (1, 0))
    del ints.tmp126
    tmp38 += ints.tmp70
    del ints.tmp70
    tmp38 += f.aa.vv * -1
    tmp38 += np.transpose(ints.tmp67, (1, 0)) * -1
    del ints.tmp67
    tmp38 += np.transpose(ints.tmp72, (1, 0)) * -1
    del ints.tmp72
    tmp38 += tmp37
    del tmp37
    tmp45 = np.copy(ints.tmp206)
    del ints.tmp206
    tmp45 += ints.tmp262
    del ints.tmp262
    tmp45 += ints.tmp236 * -1
    del ints.tmp236
    tmp55 = einsum(tmp14, (0, 1, 2, 3), r2.aba, (2, 4, 3), (0, 1, 4))
    del tmp14
    tmp55 += einsum(r2.aba, (0, 1, 2), tmp52, (3, 4, 1, 2), (0, 3, 4))
    del tmp52
    tmp55 += einsum(tmp53, (0, 1), tmp54, (0, 2, 3), (2, 3, 1))
    del tmp53, tmp54
    tmp44 = np.copy(ints.tmp128) * 2
    del ints.tmp128
    tmp44 += ints.tmp168
    del ints.tmp168
    tmp44 += ints.tmp74
    del ints.tmp74
    tmp58 = np.copy(tmp56)
    del tmp56
    tmp58 += tmp57 * 2
    del tmp57
    tmp35 = np.copy(tmp26)
    del tmp26
    tmp35 += np.transpose(tmp28, (1, 0, 2)) * -2
    del tmp28
    tmp35 += np.transpose(tmp30, (1, 0, 2))
    del tmp30
    tmp35 += np.transpose(tmp32, (1, 0, 2)) * -2
    del tmp32
    tmp35 += tmp34
    del tmp34
    tmp36 = np.copy(np.transpose(ints.tmp85, (0, 2, 1, 3)))
    del ints.tmp85
    tmp36 += np.transpose(ints.tmp93, (0, 2, 1, 3))
    del ints.tmp93
    tmp36 += ints.tmp103 * -1
    del ints.tmp103
    tmp41 = np.copy(tmp39)
    del tmp39
    tmp41 += tmp40 * -0.5
    del tmp40
    tmp25 = np.copy(tmp8) * 2
    del tmp8
    tmp25 += np.transpose(tmp13, (1, 0, 2))
    del tmp13
    tmp25 += tmp20
    del tmp20
    tmp25 += tmp22
    del tmp22
    tmp25 += np.transpose(tmp24, (1, 0, 2))
    del tmp24
    tmp42 = np.copy(ints.tmp152)
    del ints.tmp152
    tmp42 += np.transpose(ints.tmp161, (2, 0, 1, 3))
    del ints.tmp161
    tmp42 += np.transpose(ints.tmp163, (2, 0, 1, 3))
    del ints.tmp163
    tmp42 += np.transpose(ints.tmp95, (2, 0, 1, 3))
    del ints.tmp95
    tmp42 += np.transpose(ints.tmp159, (2, 0, 1, 3)) * -1
    del ints.tmp159
    tmp42 += np.transpose(ints.tmp90, (2, 0, 1, 3)) * -1
    del ints.tmp90
    tmp5 = np.copy(ints.tmp39)
    del ints.tmp39
    tmp5 += ints.tmp49
    del ints.tmp49
    tmp6 = np.copy(ints.tmp37)
    del ints.tmp37
    tmp6 += ints.tmp47 * -1
    del ints.tmp47
    tmp1 = np.copy(ints.tmp22)
    del ints.tmp22
    tmp1 += ints.tmp2 * -1
    del ints.tmp2
    r2new.bbb = np.copy(tmp85) * -1
    r2new.bbb += np.transpose(tmp85, (1, 0, 2))
    del tmp85
    r2new.bbb += tmp94
    r2new.bbb += np.transpose(tmp94, (1, 0, 2)) * -1
    del tmp94
    r2new.bbb += einsum(tmp95, (0, 1, 2, 3), r2.bbb, (2, 3, 4), (0, 1, 4)) * 2
    del tmp95
    r2new.bbb += einsum(tmp64, (0, 1), r2.bbb, (2, 3, 0), (2, 3, 1)) * -2
    r2new.bbb += einsum(tmp96, (0,), t2.bbbb, (1, 2, 3, 0), (1, 2, 3)) * -4
    del tmp96
    r2new.bbb += einsum(r1.b, (0,), tmp97, (1, 2, 0, 3), (2, 1, 3)) * -2
    del tmp97
    r2new.bbb += einsum(tmp70, (0, 1), r1.b, (2,), (2, 0, 1)) * -1
    r2new.bbb += einsum(r1.b, (0,), tmp70, (1, 2), (1, 0, 2))
    r2new.bab = einsum(r2.aaa, (0, 1, 2), ints.tmp295, (1, 3, 2, 4), (3, 0, 4)) * 2
    del ints.tmp295
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp59, (3, 0, 4, 2), (3, 1, 4)) * -1
    del tmp59
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp60, (3, 1, 4, 2), (0, 3, 4)) * -1
    del tmp60
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp61, (3, 1, 4, 0), (4, 3, 2))
    del tmp61
    r2new.bab += einsum(tmp62, (0, 1, 2), tmp11, (0, 3), (1, 3, 2)) * -1
    del tmp11, tmp62
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp64, (2, 3), (0, 1, 3)) * -1
    del tmp64
    r2new.bab += einsum(tmp65, (0, 1, 2, 3), r1.a, (1,), (2, 0, 3))
    del tmp65
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp4, (1, 3), (0, 3, 2)) * -1
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp7, (0, 3), (3, 1, 2)) * -1
    r2new.bab += einsum(tmp68, (0, 1, 2), t1.bb, (1, 3), (2, 0, 3)) * 2
    del tmp68
    r2new.bab += einsum(t2.abab, (0, 1, 2, 3), tmp69, (2,), (1, 0, 3)) * -1
    del tmp69
    r2new.bab += einsum(r1.a, (0,), tmp70, (1, 2), (1, 0, 2))
    del tmp70
    r2new.aba = einsum(r2.bbb, (0, 1, 2), ints.tmp132, (3, 1, 4, 2), (3, 0, 4)) * 2
    del ints.tmp132
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp44, (3, 0, 4, 2), (3, 1, 4)) * -1
    del tmp44
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp45, (3, 1, 4, 2), (0, 3, 4)) * -1
    del tmp45
    r2new.aba += einsum(tmp46, (0, 1, 2, 3), r2.aba, (1, 3, 4), (0, 2, 4))
    del tmp46
    r2new.aba += einsum(tmp50, (0, 1, 2), tmp49, (0, 3), (1, 3, 2)) * -2
    del tmp49, tmp50
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp38, (2, 3), (0, 1, 3)) * -1
    r2new.aba += einsum(tmp51, (0, 1, 2, 3), r1.b, (2,), (0, 1, 3))
    del tmp51
    r2new.aba += einsum(tmp4, (0, 1), r2.aba, (0, 2, 3), (1, 2, 3)) * -1
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp7, (1, 3), (0, 3, 2)) * -1
    r2new.aba += einsum(t1.aa, (0, 1), tmp55, (2, 0, 3), (2, 3, 1))
    del tmp55
    r2new.aba += einsum(tmp58, (0,), t2.abab, (1, 2, 3, 0), (1, 2, 3)) * -1
    del tmp58
    r2new.aba += einsum(tmp43, (0, 1), r1.b, (2,), (0, 2, 1))
    r2new.aaa = np.copy(tmp25) * -1
    r2new.aaa += np.transpose(tmp25, (1, 0, 2))
    del tmp25
    r2new.aaa += tmp35
    r2new.aaa += np.transpose(tmp35, (1, 0, 2)) * -1
    del tmp35
    r2new.aaa += einsum(tmp36, (0, 1, 2, 3), r2.aaa, (1, 3, 4), (0, 2, 4)) * 2
    del tmp36
    r2new.aaa += einsum(tmp38, (0, 1), r2.aaa, (2, 3, 0), (2, 3, 1)) * -2
    del tmp38
    r2new.aaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp41, (3,), (0, 1, 2)) * -4
    del tmp41
    r2new.aaa += einsum(tmp42, (0, 1, 2, 3), r1.a, (0,), (2, 1, 3)) * -2
    del tmp42
    r2new.aaa += einsum(tmp43, (0, 1), r1.a, (2,), (2, 0, 1)) * -1
    r2new.aaa += einsum(r1.a, (0,), tmp43, (1, 2), (1, 0, 2))
    del tmp43
    r1new.b = einsum(r2.aba, (0, 1, 2), tmp5, (0, 3, 1, 2), (3,))
    del tmp5
    r1new.b += einsum(r2.bbb, (0, 1, 2), tmp6, (3, 0, 1, 2), (3,)) * -2
    del tmp6
    r1new.b += einsum(tmp2, (0, 1), r2.bbb, (2, 0, 1), (2,)) * 2
    r1new.b += einsum(r2.aba, (0, 1, 2), tmp3, (0, 2), (1,)) * -1
    r1new.b += einsum(r1.b, (0,), tmp7, (0, 1), (1,)) * -1
    del tmp7
    r1new.a = einsum(r2.bab, (0, 1, 2), tmp0, (3, 1, 0, 2), (3,))
    del tmp0
    r1new.a += einsum(tmp1, (0, 1, 2, 3), r2.aaa, (2, 1, 3), (0,)) * -2
    del tmp1
    r1new.a += einsum(r2.bab, (0, 1, 2), tmp2, (0, 2), (1,)) * -1
    del tmp2
    r1new.a += einsum(r2.aaa, (0, 1, 2), tmp3, (1, 2), (0,)) * 2
    del tmp3
    r1new.a += einsum(r1.a, (0,), tmp4, (0, 1), (1,)) * -1
    del tmp4

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_matvec_ea_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:20:15.106031.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp100 : array
    tmp105 : array
    tmp11 : array
    tmp115 : array
    tmp117 : array
    tmp119 : array
    tmp12 : array
    tmp122 : array
    tmp124 : array
    tmp126 : array
    tmp13 : array
    tmp130 : array
    tmp135 : array
    tmp136 : array
    tmp137 : array
    tmp138 : array
    tmp147 : array
    tmp148 : array
    tmp149 : array
    tmp15 : array
    tmp156 : array
    tmp157 : array
    tmp159 : array
    tmp160 : array
    tmp162 : array
    tmp167 : array
    tmp17 : array
    tmp171 : array
    tmp172 : array
    tmp173 : array
    tmp175 : array
    tmp177 : array
    tmp178 : array
    tmp179 : array
    tmp18 : array
    tmp180 : array
    tmp181 : array
    tmp183 : array
    tmp184 : array
    tmp185 : array
    tmp186 : array
    tmp187 : array
    tmp19 : array
    tmp190 : array
    tmp193 : array
    tmp195 : array
    tmp197 : array
    tmp2 : array
    tmp20 : array
    tmp205 : array
    tmp206 : array
    tmp207 : array
    tmp218 : array
    tmp22 : array
    tmp221 : array
    tmp227 : array
    tmp23 : array
    tmp237 : array
    tmp239 : array
    tmp243 : array
    tmp245 : array
    tmp250 : array
    tmp256 : array
    tmp26 : array
    tmp265 : array
    tmp266 : array
    tmp267 : array
    tmp276 : array
    tmp279 : array
    tmp29 : array
    tmp290 : array
    tmp293 : array
    tmp298 : array
    tmp299 : array
    tmp30 : array
    tmp300 : array
    tmp301 : array
    tmp302 : array
    tmp303 : array
    tmp305 : array
    tmp315 : array
    tmp316 : array
    tmp318 : array
    tmp319 : array
    tmp32 : array
    tmp321 : array
    tmp322 : array
    tmp323 : array
    tmp325 : array
    tmp327 : array
    tmp328 : array
    tmp33 : array
    tmp330 : array
    tmp331 : array
    tmp332 : array
    tmp333 : array
    tmp335 : array
    tmp336 : array
    tmp337 : array
    tmp341 : array
    tmp342 : array
    tmp343 : array
    tmp344 : array
    tmp345 : array
    tmp346 : array
    tmp347 : array
    tmp353 : array
    tmp354 : array
    tmp355 : array
    tmp356 : array
    tmp357 : array
    tmp360 : array
    tmp364 : array
    tmp365 : array
    tmp366 : array
    tmp367 : array
    tmp368 : array
    tmp370 : array
    tmp371 : array
    tmp374 : array
    tmp375 : array
    tmp376 : array
    tmp380 : array
    tmp383 : array
    tmp387 : array
    tmp388 : array
    tmp389 : array
    tmp390 : array
    tmp391 : array
    tmp392 : array
    tmp393 : array
    tmp396 : array
    tmp4 : array
    tmp40 : array
    tmp411 : array
    tmp413 : array
    tmp415 : array
    tmp42 : array
    tmp425 : array
    tmp430 : array
    tmp44 : array
    tmp45 : array
    tmp453 : array
    tmp46 : array
    tmp469 : array
    tmp47 : array
    tmp471 : array
    tmp481 : array
    tmp485 : array
    tmp51 : array
    tmp56 : array
    tmp57 : array
    tmp59 : array
    tmp60 : array
    tmp67 : array
    tmp68 : array
    tmp7 : array
    tmp78 : array
    tmp8 : array
    tmp80 : array
    tmp82 : array
    tmp86 : array
    tmp89 : array
    tmp9 : array
    tmp94 : array
    tmp95 : array
    tmp96 : array
    tmp97 : array
    tmp98 : array
    tmp99 : array
    """

    tmp6 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (1, 2), (0,))
    tmp10 = einsum(v.bbb.xov, (0, 1, 2), t1.bb, (1, 2), (0,))
    tmp17 = einsum(v.bbb.xov, (0, 1, 2), t1.bb, (3, 2), (0, 3, 1))
    tmp12 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (3, 2), (0, 3, 1))
    tmp22 = einsum(v.bbb.xov, (0, 1, 2), tmp6, (0,), (1, 2))
    tmp19 = einsum(v.bbb.xov, (0, 1, 2), tmp10, (0,), (1, 2))
    tmp18 = einsum(v.bbb.xov, (0, 1, 2), tmp17, (0, 1, 3), (3, 2))
    tmp59 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (4, 1, 3))
    tmp56 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (0, 3, 4))
    tmp20 = einsum(tmp10, (0,), v.baa.xov, (0, 1, 2), (1, 2))
    tmp15 = einsum(v.baa.xov, (0, 1, 2), tmp6, (0,), (1, 2))
    tmp13 = einsum(tmp12, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp32 = einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp29 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp45 = einsum(v.bbb.xvv, (0, 1, 2), t1.bb, (3, 2), (0, 3, 1))
    tmp343 = einsum(v.bbb.xov, (0, 1, 2), tmp17, (0, 3, 4), (3, 1, 4, 2))
    tmp360 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp40 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp51 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp23 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp2 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp302 = einsum(v.bbb.xoo, (0, 1, 2), tmp6, (0,), (1, 2))
    tmp301 = einsum(v.bbb.xoo, (0, 1, 2), tmp10, (0,), (1, 2))
    tmp300 = einsum(tmp17, (0, 1, 2), v.bbb.xoo, (0, 3, 1), (3, 2))
    tmp303 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp337 = einsum(tmp22, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp336 = einsum(tmp19, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp335 = einsum(tmp18, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp325 = einsum(v.bbb.xov, (0, 1, 2), tmp59, (0, 3, 2), (3, 1))
    tmp323 = einsum(v.bbb.xov, (0, 1, 2), tmp56, (0, 3, 2), (3, 1))
    tmp327 = einsum(tmp17, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp316 = einsum(f.bb.ov, (0, 1), t1.bb, (2, 1), (0, 2))
    tmp47 = einsum(v.bbb.xvv, (0, 1, 2), tmp6, (0,), (1, 2))
    tmp44 = einsum(tmp10, (0,), v.bbb.xvv, (0, 1, 2), (1, 2))
    tmp26 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp42 = einsum(v.bbb.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 4, 1, 2))
    tmp8 = einsum(v.baa.xvv, (0, 1, 2), t1.aa, (3, 2), (0, 3, 1))
    tmp179 = einsum(tmp12, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp136 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp4 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp197 = einsum(tmp20, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp195 = einsum(tmp15, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp193 = einsum(tmp13, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp11 = einsum(v.baa.xvv, (0, 1, 2), tmp10, (0,), (1, 2))
    tmp7 = einsum(v.baa.xvv, (0, 1, 2), tmp6, (0,), (1, 2))
    tmp175 = einsum(tmp32, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp173 = einsum(tmp29, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp177 = einsum(v.baa.xov, (0, 1, 2), tmp12, (0, 3, 4), (3, 1, 4, 2))
    tmp157 = einsum(t1.aa, (0, 1), f.aa.ov, (2, 1), (2, 0))
    tmp126 = einsum(tmp10, (0,), v.baa.xoo, (0, 1, 2), (1, 2))
    del tmp10
    tmp124 = einsum(v.baa.xoo, (0, 1, 2), tmp6, (0,), (1, 2))
    del tmp6
    tmp122 = einsum(v.baa.xoo, (0, 1, 2), tmp12, (0, 2, 3), (1, 3))
    tmp130 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp485 = einsum(v.bbb.xov, (0, 1, 2), tmp45, (0, 3, 4), (3, 1, 2, 4))
    tmp481 = einsum(t2.bbbb, (0, 1, 2, 3), tmp343, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp471 = einsum(v.bbb.xvv, (0, 1, 2), tmp45, (0, 3, 4), (3, 1, 2, 4))
    tmp469 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (3, 1, 2, 4))
    tmp453 = einsum(tmp360, (0, 1, 2, 3), t2.bbbb, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp430 = einsum(v.bbb.xov, (0, 1, 2), tmp59, (0, 3, 4), (3, 1, 4, 2))
    tmp425 = einsum(v.bbb.xov, (0, 1, 2), tmp56, (0, 3, 4), (3, 1, 4, 2))
    tmp415 = einsum(v.bbb.xvv, (0, 1, 2), tmp59, (0, 3, 4), (3, 4, 1, 2))
    tmp413 = einsum(t2.bbbb, (0, 1, 2, 3), tmp40, (1, 4, 3, 5), (0, 2, 5, 4))
    tmp411 = einsum(v.bbb.xvv, (0, 1, 2), tmp56, (0, 3, 4), (3, 4, 1, 2))
    tmp396 = einsum(tmp56, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp393 = einsum(tmp59, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp392 = einsum(tmp22, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp391 = einsum(tmp20, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp390 = einsum(tmp19, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp389 = einsum(t2.bbbb, (0, 1, 2, 3), tmp18, (1, 3), (0, 2))
    tmp388 = einsum(t2.abab, (0, 1, 2, 3), tmp15, (0, 2), (1, 3))
    tmp387 = einsum(t2.abab, (0, 1, 2, 3), tmp13, (0, 2), (1, 3))
    tmp383 = einsum(t2.bbbb, (0, 1, 2, 3), tmp51, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp380 = einsum(tmp23, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (1, 4, 2, 5))
    tmp376 = einsum(v.baa.xvv, (0, 1, 2), tmp56, (0, 3, 4), (3, 1, 2, 4))
    tmp375 = einsum(t2.abab, (0, 1, 2, 3), tmp2, (0, 4, 2, 5), (1, 5, 4, 3))
    tmp374 = einsum(v.baa.xvv, (0, 1, 2), tmp59, (0, 3, 4), (3, 1, 2, 4))
    tmp371 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp370 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (0, 2), (1, 3))
    tmp368 = einsum(tmp302, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp367 = einsum(tmp301, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp366 = einsum(tmp300, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp365 = einsum(t2.abab, (0, 1, 2, 3), tmp303, (0, 4, 1, 2), (4, 3))
    tmp364 = einsum(t2.bbbb, (0, 1, 2, 3), tmp360, (4, 0, 1, 3), (4, 2))
    tmp357 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp356 = einsum(t1.bb, (0, 1), f.bb.oo, (2, 0), (2, 1))
    tmp355 = einsum(tmp337, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp354 = einsum(tmp336, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp353 = einsum(t1.bb, (0, 1), tmp335, (2, 0), (2, 1))
    tmp347 = einsum(t1.bb, (0, 1), tmp325, (2, 0), (2, 1))
    tmp346 = einsum(tmp323, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp345 = einsum(t2.abab, (0, 1, 2, 3), tmp327, (0, 4, 1, 2), (4, 3))
    tmp344 = einsum(t2.bbbb, (0, 1, 2, 3), tmp343, (4, 1, 0, 3), (4, 2))
    tmp342 = einsum(v.baa.xvv, (0, 1, 2), tmp17, (0, 3, 4), (3, 4, 1, 2))
    tmp341 = einsum(tmp316, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp333 = einsum(tmp45, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp332 = einsum(tmp47, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp331 = einsum(tmp45, (0, 1, 2), tmp17, (0, 3, 1), (3, 2))
    tmp330 = einsum(tmp44, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp328 = einsum(t2.abab, (0, 1, 2, 3), tmp327, (0, 4, 1, 5), (4, 2, 5, 3))
    tmp322 = einsum(v.bbb.xvv, (0, 1, 2), tmp59, (0, 3, 2), (3, 1))
    tmp321 = einsum(tmp56, (0, 1, 2), v.bbb.xvv, (0, 3, 2), (1, 3)) * -1
    tmp319 = einsum(v.bbb.xvv, (0, 1, 2), tmp17, (0, 3, 4), (3, 4, 1, 2))
    tmp318 = einsum(v.baa.xvv, (0, 1, 2), tmp45, (0, 3, 4), (3, 1, 2, 4))
    tmp315 = einsum(f.bb.vv, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp305 = einsum(t2.abab, (0, 1, 2, 3), tmp303, (0, 4, 1, 5), (4, 2, 5, 3))
    tmp299 = einsum(tmp45, (0, 1, 2), v.bbb.xoo, (0, 3, 1), (3, 2))
    tmp298 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp293 = einsum(t2.abab, (0, 1, 2, 3), tmp26, (0, 4, 5, 3), (1, 4, 2, 5))
    tmp290 = einsum(t2.abab, (0, 1, 2, 3), tmp42, (0, 4, 5, 3), (1, 2, 4, 5))
    tmp279 = einsum(tmp29, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp276 = einsum(v.bbb.xov, (0, 1, 2), tmp32, (0, 3, 4), (3, 1, 4, 2))
    tmp267 = einsum(tmp29, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp266 = einsum(tmp40, (0, 1, 2, 3), t2.abab, (4, 0, 5, 2), (4, 5, 3, 1))
    tmp265 = einsum(tmp32, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp256 = einsum(v.baa.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp250 = einsum(tmp12, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp245 = einsum(v.bbb.xov, (0, 1, 2), tmp8, (0, 3, 4), (3, 1, 4, 2))
    tmp243 = einsum(t2.abab, (0, 1, 2, 3), tmp179, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp239 = einsum(v.bbb.xvv, (0, 1, 2), tmp8, (0, 3, 4), (3, 4, 1, 2))
    tmp237 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp227 = einsum(t2.abab, (0, 1, 2, 3), tmp136, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp221 = einsum(t2.abab, (0, 1, 2, 3), tmp26, (4, 1, 2, 5), (0, 4, 3, 5))
    tmp218 = einsum(t2.abab, (0, 1, 2, 3), tmp4, (1, 4, 2, 5), (0, 4, 3, 5))
    tmp207 = einsum(t1.aa, (0, 1), tmp197, (2, 0), (2, 1))
    tmp206 = einsum(tmp195, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp205 = einsum(t1.aa, (0, 1), tmp193, (2, 0), (2, 1))
    tmp190 = einsum(tmp8, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 3, 4, 2))
    tmp187 = einsum(tmp11, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp186 = einsum(tmp12, (0, 1, 2), tmp8, (0, 2, 3), (1, 3))
    tmp185 = einsum(t1.aa, (0, 1), tmp7, (2, 1), (0, 2))
    tmp184 = einsum(t1.aa, (0, 1), tmp175, (2, 0), (2, 1))
    tmp183 = einsum(t1.aa, (0, 1), tmp173, (2, 0), (2, 1))
    tmp181 = einsum(t2.aaaa, (0, 1, 2, 3), tmp177, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp180 = einsum(t2.abab, (0, 1, 2, 3), tmp179, (4, 0, 1, 3), (4, 2))
    tmp178 = einsum(t2.aaaa, (0, 1, 2, 3), tmp177, (4, 1, 0, 3), (4, 2))
    tmp172 = einsum(tmp32, (0, 1, 2), v.baa.xvv, (0, 3, 2), (1, 3))
    tmp171 = einsum(v.baa.xvv, (0, 1, 2), tmp29, (0, 3, 2), (3, 1)) * -1
    tmp167 = einsum(tmp12, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp162 = einsum(tmp8, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp160 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xvv, (0, 3, 4), (3, 1, 2, 4))
    tmp159 = einsum(t1.aa, (0, 1), tmp157, (0, 2), (2, 1))
    tmp156 = einsum(t1.aa, (0, 1), f.aa.vv, (2, 1), (0, 2))
    tmp149 = einsum(t1.aa, (0, 1), tmp126, (2, 0), (2, 1))
    tmp148 = einsum(tmp124, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp147 = einsum(tmp122, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp138 = einsum(t2.aaaa, (0, 1, 2, 3), tmp130, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp137 = einsum(t2.abab, (0, 1, 2, 3), tmp136, (4, 0, 1, 3), (4, 2))
    tmp135 = einsum(t2.aaaa, (0, 1, 2, 3), tmp130, (4, 0, 1, 3), (4, 2))
    tmp119 = einsum(tmp8, (0, 1, 2), v.baa.xoo, (0, 3, 1), (3, 2))
    tmp117 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp115 = einsum(f.aa.oo, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp105 = einsum(v.baa.xov, (0, 1, 2), tmp32, (0, 3, 4), (3, 1, 4, 2))
    tmp100 = einsum(v.baa.xov, (0, 1, 2), tmp29, (0, 3, 4), (3, 1, 4, 2))
    tmp99 = einsum(t2.abab, (0, 1, 2, 3), tmp22, (1, 3), (0, 2))
    tmp98 = einsum(t2.aaaa, (0, 1, 2, 3), tmp20, (1, 3), (0, 2))
    tmp97 = einsum(tmp19, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp96 = einsum(tmp18, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp95 = einsum(t2.aaaa, (0, 1, 2, 3), tmp15, (1, 3), (0, 2))
    tmp94 = einsum(t2.aaaa, (0, 1, 2, 3), tmp13, (1, 3), (0, 2))
    tmp89 = einsum(t2.abab, (0, 1, 2, 3), tmp51, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp86 = einsum(tmp23, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 1, 5, 2))
    tmp82 = einsum(v.baa.xvv, (0, 1, 2), tmp32, (0, 3, 4), (3, 4, 1, 2))
    tmp80 = einsum(t2.aaaa, (0, 1, 2, 3), tmp2, (1, 4, 3, 5), (0, 2, 5, 4))
    tmp78 = einsum(tmp29, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp68 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp67 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp60 = einsum(v.bbb.xov, (0, 1, 2), tmp59, (0, 1, 3), (3, 2))
    tmp57 = einsum(v.bbb.xov, (0, 1, 2), tmp56, (0, 1, 3), (3, 2))
    tmp46 = einsum(v.bbb.xov, (0, 1, 2), tmp45, (0, 1, 3), (2, 3))
    tmp33 = einsum(tmp32, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp30 = einsum(tmp29, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp9 = einsum(tmp8, (0, 1, 2), v.baa.xov, (0, 1, 3), (3, 2))

    return {f"tmp100": tmp100, f"tmp105": tmp105, f"tmp11": tmp11, f"tmp115": tmp115, f"tmp117": tmp117, f"tmp119": tmp119, f"tmp12": tmp12, f"tmp122": tmp122, f"tmp124": tmp124, f"tmp126": tmp126, f"tmp13": tmp13, f"tmp130": tmp130, f"tmp135": tmp135, f"tmp136": tmp136, f"tmp137": tmp137, f"tmp138": tmp138, f"tmp147": tmp147, f"tmp148": tmp148, f"tmp149": tmp149, f"tmp15": tmp15, f"tmp156": tmp156, f"tmp157": tmp157, f"tmp159": tmp159, f"tmp160": tmp160, f"tmp162": tmp162, f"tmp167": tmp167, f"tmp17": tmp17, f"tmp171": tmp171, f"tmp172": tmp172, f"tmp173": tmp173, f"tmp175": tmp175, f"tmp177": tmp177, f"tmp178": tmp178, f"tmp179": tmp179, f"tmp18": tmp18, f"tmp180": tmp180, f"tmp181": tmp181, f"tmp183": tmp183, f"tmp184": tmp184, f"tmp185": tmp185, f"tmp186": tmp186, f"tmp187": tmp187, f"tmp19": tmp19, f"tmp190": tmp190, f"tmp193": tmp193, f"tmp195": tmp195, f"tmp197": tmp197, f"tmp2": tmp2, f"tmp20": tmp20, f"tmp205": tmp205, f"tmp206": tmp206, f"tmp207": tmp207, f"tmp218": tmp218, f"tmp22": tmp22, f"tmp221": tmp221, f"tmp227": tmp227, f"tmp23": tmp23, f"tmp237": tmp237, f"tmp239": tmp239, f"tmp243": tmp243, f"tmp245": tmp245, f"tmp250": tmp250, f"tmp256": tmp256, f"tmp26": tmp26, f"tmp265": tmp265, f"tmp266": tmp266, f"tmp267": tmp267, f"tmp276": tmp276, f"tmp279": tmp279, f"tmp29": tmp29, f"tmp290": tmp290, f"tmp293": tmp293, f"tmp298": tmp298, f"tmp299": tmp299, f"tmp30": tmp30, f"tmp300": tmp300, f"tmp301": tmp301, f"tmp302": tmp302, f"tmp303": tmp303, f"tmp305": tmp305, f"tmp315": tmp315, f"tmp316": tmp316, f"tmp318": tmp318, f"tmp319": tmp319, f"tmp32": tmp32, f"tmp321": tmp321, f"tmp322": tmp322, f"tmp323": tmp323, f"tmp325": tmp325, f"tmp327": tmp327, f"tmp328": tmp328, f"tmp33": tmp33, f"tmp330": tmp330, f"tmp331": tmp331, f"tmp332": tmp332, f"tmp333": tmp333, f"tmp335": tmp335, f"tmp336": tmp336, f"tmp337": tmp337, f"tmp341": tmp341, f"tmp342": tmp342, f"tmp343": tmp343, f"tmp344": tmp344, f"tmp345": tmp345, f"tmp346": tmp346, f"tmp347": tmp347, f"tmp353": tmp353, f"tmp354": tmp354, f"tmp355": tmp355, f"tmp356": tmp356, f"tmp357": tmp357, f"tmp360": tmp360, f"tmp364": tmp364, f"tmp365": tmp365, f"tmp366": tmp366, f"tmp367": tmp367, f"tmp368": tmp368, f"tmp370": tmp370, f"tmp371": tmp371, f"tmp374": tmp374, f"tmp375": tmp375, f"tmp376": tmp376, f"tmp380": tmp380, f"tmp383": tmp383, f"tmp387": tmp387, f"tmp388": tmp388, f"tmp389": tmp389, f"tmp390": tmp390, f"tmp391": tmp391, f"tmp392": tmp392, f"tmp393": tmp393, f"tmp396": tmp396, f"tmp4": tmp4, f"tmp40": tmp40, f"tmp411": tmp411, f"tmp413": tmp413, f"tmp415": tmp415, f"tmp42": tmp42, f"tmp425": tmp425, f"tmp430": tmp430, f"tmp44": tmp44, f"tmp45": tmp45, f"tmp453": tmp453, f"tmp46": tmp46, f"tmp469": tmp469, f"tmp47": tmp47, f"tmp471": tmp471, f"tmp481": tmp481, f"tmp485": tmp485, f"tmp51": tmp51, f"tmp56": tmp56, f"tmp57": tmp57, f"tmp59": tmp59, f"tmp60": tmp60, f"tmp67": tmp67, f"tmp68": tmp68, f"tmp7": tmp7, f"tmp78": tmp78, f"tmp8": tmp8, f"tmp80": tmp80, f"tmp82": tmp82, f"tmp86": tmp86, f"tmp89": tmp89, f"tmp9": tmp9, f"tmp94": tmp94, f"tmp95": tmp95, f"tmp96": tmp96, f"tmp97": tmp97, f"tmp98": tmp98, f"tmp99": tmp99}

def hbar_matvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:20:15.278661.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp63 = einsum(v.bbb.xov, (0, 1, 2), r2.bbb, (3, 2, 1), (0, 3))
    tmp62 = einsum(r2.aba, (0, 1, 2), v.baa.xov, (3, 2, 0), (3, 1))
    tmp14 = einsum(r2.aaa, (0, 1, 2), v.baa.xov, (3, 2, 1), (3, 0))
    tmp15 = einsum(r2.bab, (0, 1, 2), v.bbb.xov, (3, 2, 0), (3, 1)) * -1
    tmp81 = np.copy(ints.tmp17)
    del ints.tmp17
    tmp81 += v.bbb.xoo
    tmp64 = np.copy(tmp62) * -1
    tmp64 += tmp63 * 2
    tmp120 = np.copy(f.bb.ov)
    tmp120 += ints.tmp19
    tmp120 += ints.tmp22
    tmp116 = einsum(r1.b, (0,), ints.tmp360, (1, 2, 3, 0), (1, 2, 3))
    tmp122 = np.copy(ints.tmp298)
    tmp122 += ints.tmp319
    tmp122 += ints.tmp383 * 2
    tmp103 = np.copy(ints.tmp430)
    del ints.tmp430
    tmp103 += np.transpose(ints.tmp485, (0, 1, 3, 2))
    del ints.tmp485
    tmp103 += ints.tmp51
    tmp103 += ints.tmp425 * 2
    del ints.tmp425
    tmp101 = np.copy(ints.tmp343)
    tmp101 += np.transpose(ints.tmp360, (0, 2, 1, 3))
    tmp99 = einsum(r1.b, (0,), ints.tmp343, (1, 2, 3, 0), (1, 2, 3))
    tmp42 = einsum(r1.a, (0,), ints.tmp177, (1, 2, 3, 0), (1, 2, 3))
    tmp44 = np.copy(ints.tmp130)
    tmp44 += np.transpose(ints.tmp177, (0, 2, 1, 3))
    tmp46 = np.copy(ints.tmp105)
    del ints.tmp105
    tmp46 += np.transpose(ints.tmp190, (0, 1, 3, 2))
    del ints.tmp190
    tmp46 += ints.tmp23
    tmp46 += ints.tmp100 * 2
    del ints.tmp100
    tmp21 = einsum(ints.tmp130, (0, 1, 2, 3), r1.a, (3,), (0, 1, 2))
    tmp28 = np.copy(ints.tmp117)
    tmp28 += ints.tmp167
    tmp28 += ints.tmp86 * 2
    tmp16 = np.copy(tmp14)
    tmp16 += tmp15 * 0.5
    tmp24 = np.copy(ints.tmp12)
    del ints.tmp12
    tmp24 += v.baa.xoo
    tmp26 = np.copy(f.aa.ov)
    tmp26 += ints.tmp15
    tmp26 += ints.tmp20
    tmp119 = einsum(tmp81, (0, 1, 2), tmp64, (0, 3), (1, 2, 3))
    tmp118 = einsum(ints.tmp40, (0, 1, 2, 3), r2.bbb, (2, 3, 4), (0, 4, 1))
    tmp121 = einsum(r2.bbb, (0, 1, 2), tmp120, (3, 1), (3, 2, 0)) * -2
    del tmp120
    tmp117 = einsum(t1.bb, (0, 1), tmp116, (2, 0, 3), (2, 3, 1))
    del tmp116
    tmp123 = einsum(r1.b, (0,), tmp122, (1, 2, 3, 0), (1, 2, 3))
    del tmp122
    tmp98 = einsum(ints.tmp18, (0, 1), r2.bbb, (2, 1, 3), (0, 3, 2))
    tmp104 = einsum(tmp103, (0, 1, 2, 3), r1.b, (3,), (0, 1, 2))
    del tmp103
    tmp102 = einsum(r2.bbb, (0, 1, 2), tmp101, (3, 4, 2, 1), (3, 4, 0)) * -1
    del tmp101
    tmp100 = einsum(t1.bb, (0, 1), tmp99, (2, 0, 3), (2, 3, 1))
    del tmp99
    tmp43 = einsum(t1.aa, (0, 1), tmp42, (2, 0, 3), (2, 3, 1))
    del tmp42
    tmp45 = einsum(tmp44, (0, 1, 2, 3), r2.aaa, (4, 3, 1), (0, 2, 4)) * -1
    del tmp44
    tmp41 = einsum(ints.tmp13, (0, 1), r2.aaa, (2, 1, 3), (0, 3, 2))
    tmp47 = einsum(r1.a, (0,), tmp46, (1, 2, 3, 0), (1, 2, 3))
    del tmp46
    tmp22 = einsum(tmp21, (0, 1, 2), t1.aa, (1, 3), (0, 2, 3))
    del tmp21
    tmp29 = einsum(r1.a, (0,), tmp28, (1, 2, 3, 0), (1, 2, 3))
    del tmp28
    tmp25 = einsum(tmp24, (0, 1, 2), tmp16, (0, 3), (1, 2, 3)) * 2
    tmp23 = einsum(ints.tmp2, (0, 1, 2, 3), r2.aaa, (3, 2, 4), (0, 4, 1)) * -1
    tmp27 = einsum(r2.aaa, (0, 1, 2), tmp26, (3, 1), (2, 3, 0)) * -2
    del tmp26
    tmp0 = np.copy(f.bb.ov)
    tmp0 += ints.tmp19
    tmp0 += ints.tmp22
    tmp0 += ints.tmp18 * -1
    del ints.tmp18
    tmp112 = np.copy(ints.tmp45) * 0.5
    tmp112 += ints.tmp56
    tmp112 += ints.tmp59 * 0.5
    tmp124 = np.copy(np.transpose(tmp117, (1, 0, 2)))
    del tmp117
    tmp124 += tmp118 * 2
    del tmp118
    tmp124 += np.transpose(tmp119, (1, 0, 2))
    del tmp119
    tmp124 += tmp121 * -1
    del tmp121
    tmp124 += np.transpose(tmp123, (1, 0, 2))
    del tmp123
    tmp126 = np.copy(ints.tmp411)
    del ints.tmp411
    tmp126 += ints.tmp415 * 0.5
    del ints.tmp415
    tmp114 = np.copy(f.bb.vv) * 0.5
    tmp114 += np.transpose(ints.tmp44, (1, 0)) * 0.5
    tmp114 += np.transpose(ints.tmp47, (1, 0)) * 0.5
    tmp114 += np.transpose(ints.tmp57, (1, 0)) * -1
    tmp114 += np.transpose(ints.tmp60, (1, 0)) * -0.5
    tmp105 = np.copy(tmp98) * 2
    del tmp98
    tmp105 += np.transpose(tmp100, (1, 0, 2))
    del tmp100
    tmp105 += np.transpose(tmp102, (1, 0, 2)) * -2
    del tmp102
    tmp105 += np.transpose(tmp104, (1, 0, 2))
    del tmp104
    tmp107 = np.copy(ints.tmp40)
    tmp107 += np.transpose(ints.tmp471, (0, 2, 1, 3))
    del ints.tmp471
    tmp107 += ints.tmp413 * 2
    del ints.tmp413
    tmp96 = np.copy(ints.tmp45)
    tmp96 += ints.tmp59
    tmp96 += ints.tmp56 * 2
    tmp94 = np.copy(ints.tmp298)
    tmp94 += ints.tmp319
    tmp94 += ints.tmp383 * 2
    tmp1 = np.copy(f.aa.ov)
    tmp1 += ints.tmp15
    tmp1 += ints.tmp20
    tmp1 += ints.tmp13 * -1
    del ints.tmp13
    tmp56 = einsum(r2.aba, (0, 1, 2), ints.tmp26, (3, 4, 0, 1), (3, 2, 4))
    tmp72 = np.copy(ints.tmp136)
    tmp72 += np.transpose(ints.tmp179, (1, 0, 2, 3))
    tmp39 = np.copy(tmp14) * 2
    del tmp14
    tmp39 += tmp15
    del tmp15
    tmp50 = np.copy(ints.tmp162)
    del ints.tmp162
    tmp50 += np.transpose(ints.tmp2, (0, 2, 1, 3))
    tmp50 += np.transpose(ints.tmp80, (0, 2, 1, 3)) * 2
    del ints.tmp80
    tmp37 = np.copy(ints.tmp117)
    tmp37 += ints.tmp167
    tmp37 += ints.tmp86 * 2
    tmp48 = np.copy(np.transpose(tmp41, (1, 0, 2))) * 2
    del tmp41
    tmp48 += tmp43
    del tmp43
    tmp48 += tmp45 * -2
    del tmp45
    tmp48 += tmp47
    del tmp47
    tmp32 = np.copy(ints.tmp78)
    del ints.tmp78
    tmp32 += ints.tmp82 * 0.5
    del ints.tmp82
    tmp17 = np.copy(ints.tmp29) * 2
    tmp17 += ints.tmp32
    tmp17 += ints.tmp8
    tmp30 = np.copy(np.transpose(tmp22, (1, 0, 2)))
    del tmp22
    tmp30 += tmp23 * 2
    del tmp23
    tmp30 += np.transpose(tmp25, (1, 0, 2))
    del tmp25
    tmp30 += np.transpose(tmp27, (1, 0, 2)) * -1
    del tmp27
    tmp30 += np.transpose(tmp29, (1, 0, 2))
    del tmp29
    tmp19 = np.copy(f.aa.vv) * 0.5
    tmp19 += np.transpose(ints.tmp11, (1, 0)) * 0.5
    tmp19 += np.transpose(ints.tmp7, (1, 0)) * 0.5
    tmp19 += np.transpose(ints.tmp30, (1, 0)) * -1
    tmp19 += np.transpose(ints.tmp33, (1, 0)) * -0.5
    tmp9 = einsum(r2.bbb, (0, 1, 2), ints.tmp51, (2, 3, 1, 0), (3,)) * -1
    tmp8 = einsum(r2.aba, (0, 1, 2), ints.tmp26, (2, 3, 0, 1), (3,))
    tmp10 = einsum(r1.b, (0,), tmp0, (1, 0), (1,))
    tmp113 = einsum(tmp112, (0, 1, 2), tmp63, (0, 3), (1, 2, 3)) * 4
    del tmp112
    tmp111 = einsum(tmp62, (0, 1), v.bbb.xov, (0, 2, 3), (2, 1, 3))
    tmp125 = einsum(t1.bb, (0, 1), tmp124, (0, 2, 3), (2, 3, 1))
    del tmp124
    tmp110 = einsum(r2.aba, (0, 1, 2), ints.tmp380, (2, 3, 0, 4), (3, 4, 1))
    tmp127 = einsum(r1.b, (0,), tmp126, (1, 2, 0, 3), (1, 2, 3)) * 2
    del tmp126
    tmp115 = einsum(tmp114, (0, 1), r2.bbb, (2, 0, 3), (3, 1, 2)) * -4
    del tmp114
    tmp92 = einsum(ints.tmp46, (0, 1), r2.bbb, (2, 0, 3), (3, 1, 2))
    tmp106 = einsum(t1.bb, (0, 1), tmp105, (0, 2, 3), (2, 3, 1))
    del tmp105
    tmp108 = einsum(r1.b, (0,), tmp107, (1, 2, 0, 3), (1, 2, 3))
    del tmp107
    tmp93 = einsum(v.bbb.xov, (0, 1, 2), tmp63, (0, 3), (1, 3, 2))
    del tmp63
    tmp97 = einsum(tmp62, (0, 1), tmp96, (0, 2, 3), (2, 3, 1))
    del tmp62, tmp96
    tmp95 = einsum(r2.bbb, (0, 1, 2), tmp94, (3, 2, 4, 1), (3, 4, 0)) * -1
    del tmp94
    tmp90 = einsum(r2.bbb, (0, 1, 2), ints.tmp51, (3, 4, 0, 1), (3, 4, 2))
    del ints.tmp51
    tmp4 = einsum(r2.bab, (0, 1, 2), ints.tmp26, (3, 2, 1, 0), (3,)) * -1
    tmp5 = einsum(tmp1, (0, 1), r1.a, (1,), (0,))
    tmp3 = einsum(r2.aaa, (0, 1, 2), ints.tmp23, (2, 3, 1, 0), (3,)) * -1
    tmp86 = np.copy(ints.tmp26)
    tmp86 += ints.tmp333
    del ints.tmp333
    tmp86 += ints.tmp393
    del ints.tmp393
    tmp86 += ints.tmp396 * 2
    del ints.tmp396
    tmp86 += ints.tmp380 * -1
    tmp85 = np.copy(ints.tmp303)
    del ints.tmp303
    tmp85 += ints.tmp327
    del ints.tmp327
    tmp75 = einsum(r2.bab, (0, 1, 2), ints.tmp26, (3, 4, 1, 0), (3, 4, 2)) * -1
    tmp77 = np.copy(np.transpose(r2.bab, (2, 1, 0))) * -1
    tmp77 += einsum(r1.a, (0,), t1.bb, (1, 2), (1, 0, 2))
    tmp66 = einsum(tmp1, (0, 1), t1.aa, (0, 2), (2, 1))
    tmp79 = np.copy(ints.tmp343)
    del ints.tmp343
    tmp79 += np.transpose(ints.tmp360, (0, 2, 1, 3))
    del ints.tmp360
    tmp70 = np.copy(ints.tmp136)
    del ints.tmp136
    tmp70 += ints.tmp179
    del ints.tmp179
    tmp71 = np.copy(ints.tmp245)
    del ints.tmp245
    tmp71 += ints.tmp26
    del ints.tmp26
    tmp71 += ints.tmp276
    del ints.tmp276
    tmp71 += ints.tmp279 * 2
    del ints.tmp279
    tmp71 += ints.tmp89 * -1
    tmp73 = np.copy(tmp56) * -1
    tmp73 += einsum(r1.b, (0,), tmp72, (1, 2, 3, 0), (1, 2, 3))
    del tmp72
    tmp60 = np.copy(ints.tmp130)
    del ints.tmp130
    tmp60 += np.transpose(ints.tmp177, (0, 2, 1, 3))
    del ints.tmp177
    tmp35 = einsum(ints.tmp9, (0, 1), r2.aaa, (2, 0, 3), (3, 1, 2))
    tmp40 = einsum(tmp39, (0, 1), v.baa.xov, (0, 2, 3), (2, 3, 1))
    del tmp39
    tmp36 = einsum(ints.tmp89, (0, 1, 2, 3), r2.bab, (3, 4, 1), (0, 2, 4)) * -1
    tmp51 = einsum(tmp50, (0, 1, 2, 3), r1.a, (1,), (0, 2, 3))
    del tmp50
    tmp38 = einsum(tmp37, (0, 1, 2, 3), r2.aaa, (4, 3, 1), (0, 4, 2)) * -1
    del tmp37
    tmp49 = einsum(t1.aa, (0, 1), tmp48, (2, 0, 3), (2, 1, 3))
    del tmp48
    tmp33 = einsum(tmp32, (0, 1, 2, 3), r1.a, (2,), (0, 1, 3)) * 2
    del tmp32
    tmp18 = einsum(tmp16, (0, 1), tmp17, (0, 2, 3), (2, 3, 1)) * 2
    del tmp17
    tmp31 = einsum(t1.aa, (0, 1), tmp30, (0, 2, 3), (2, 1, 3))
    del tmp30
    tmp20 = einsum(tmp19, (0, 1), r2.aaa, (2, 0, 3), (3, 2, 1)) * -4
    del tmp19
    tmp12 = einsum(ints.tmp23, (0, 1, 2, 3), r2.aaa, (3, 2, 4), (0, 1, 4)) * -1
    del ints.tmp23
    tmp89 = np.copy(ints.tmp299)
    del ints.tmp299
    tmp89 += ints.tmp321 * 2
    del ints.tmp321
    tmp89 += ints.tmp331
    del ints.tmp331
    tmp89 += ints.tmp341
    del ints.tmp341
    tmp89 += ints.tmp344 * 2
    del ints.tmp344
    tmp89 += ints.tmp345
    del ints.tmp345
    tmp89 += ints.tmp346 * 2
    del ints.tmp346
    tmp89 += ints.tmp347
    del ints.tmp347
    tmp89 += ints.tmp354
    del ints.tmp354
    tmp89 += ints.tmp355
    del ints.tmp355
    tmp89 += ints.tmp356
    del ints.tmp356
    tmp89 += ints.tmp364 * 2
    del ints.tmp364
    tmp89 += ints.tmp365
    del ints.tmp365
    tmp89 += ints.tmp367
    del ints.tmp367
    tmp89 += ints.tmp368
    del ints.tmp368
    tmp89 += ints.tmp387
    del ints.tmp387
    tmp89 += ints.tmp389 * 2
    del ints.tmp389
    tmp89 += f.bb.ov * -1
    tmp89 += ints.tmp19 * -1
    del ints.tmp19
    tmp89 += ints.tmp22 * -1
    del ints.tmp22
    tmp89 += ints.tmp315 * -1
    del ints.tmp315
    tmp89 += ints.tmp322 * -1
    del ints.tmp322
    tmp89 += ints.tmp330 * -1
    del ints.tmp330
    tmp89 += ints.tmp332 * -1
    del ints.tmp332
    tmp89 += ints.tmp353 * -1
    del ints.tmp353
    tmp89 += ints.tmp366 * -1
    del ints.tmp366
    tmp89 += ints.tmp370 * -1
    del ints.tmp370
    tmp89 += ints.tmp371 * -2
    del ints.tmp371
    tmp89 += ints.tmp388 * -1
    del ints.tmp388
    tmp89 += ints.tmp390 * -2
    del ints.tmp390
    tmp89 += ints.tmp391 * -1
    del ints.tmp391
    tmp89 += ints.tmp392 * -2
    del ints.tmp392
    tmp11 = np.copy(tmp8)
    del tmp8
    tmp11 += tmp9 * 2
    del tmp9
    tmp11 += tmp10 * -1
    del tmp10
    tmp128 = np.copy(tmp110)
    del tmp110
    tmp128 += tmp111
    del tmp111
    tmp128 += tmp113
    del tmp113
    tmp128 += tmp115 * -1
    del tmp115
    tmp128 += tmp125
    del tmp125
    tmp128 += tmp127
    del tmp127
    tmp88 = np.copy(f.bb.oo)
    tmp88 += np.transpose(ints.tmp301, (1, 0))
    del ints.tmp301
    tmp88 += np.transpose(ints.tmp302, (1, 0))
    del ints.tmp302
    tmp88 += ints.tmp316
    del ints.tmp316
    tmp88 += np.transpose(ints.tmp323, (1, 0)) * 2
    del ints.tmp323
    tmp88 += np.transpose(ints.tmp325, (1, 0))
    del ints.tmp325
    tmp88 += np.transpose(ints.tmp336, (1, 0))
    del ints.tmp336
    tmp88 += np.transpose(ints.tmp337, (1, 0))
    del ints.tmp337
    tmp88 += np.transpose(ints.tmp300, (1, 0)) * -1
    del ints.tmp300
    tmp88 += np.transpose(ints.tmp335, (1, 0)) * -1
    del ints.tmp335
    tmp129 = np.copy(ints.tmp453)
    del ints.tmp453
    tmp129 += ints.tmp481 * -1
    del ints.tmp481
    tmp109 = np.copy(tmp92) * 2
    del tmp92
    tmp109 += tmp93 * 2
    del tmp93
    tmp109 += tmp95 * -2
    del tmp95
    tmp109 += tmp97
    del tmp97
    tmp109 += tmp106
    del tmp106
    tmp109 += tmp108
    del tmp108
    tmp91 = einsum(t1.bb, (0, 1), tmp90, (2, 0, 3), (2, 3, 1))
    tmp83 = np.copy(ints.tmp46) * 0.5
    tmp83 += np.transpose(ints.tmp57, (1, 0))
    tmp83 += np.transpose(ints.tmp60, (1, 0)) * 0.5
    tmp83 += f.bb.vv * -0.5
    tmp83 += np.transpose(ints.tmp44, (1, 0)) * -0.5
    tmp83 += np.transpose(ints.tmp47, (1, 0)) * -0.5
    tmp83 += einsum(tmp0, (0, 1), t1.bb, (0, 2), (1, 2)) * 0.5
    tmp6 = np.copy(tmp3) * -2
    del tmp3
    tmp6 += tmp4
    del tmp4
    tmp6 += tmp5
    del tmp5
    tmp84 = np.copy(ints.tmp305)
    del ints.tmp305
    tmp84 += np.transpose(ints.tmp318, (0, 2, 1, 3))
    del ints.tmp318
    tmp84 += ints.tmp328
    del ints.tmp328
    tmp84 += np.transpose(ints.tmp374, (0, 2, 1, 3))
    del ints.tmp374
    tmp84 += np.transpose(ints.tmp376, (0, 2, 1, 3)) * 2
    del ints.tmp376
    tmp84 += ints.tmp4
    tmp84 += ints.tmp290 * -1
    del ints.tmp290
    tmp84 += np.transpose(ints.tmp375, (0, 2, 1, 3)) * -1
    del ints.tmp375
    tmp82 = np.copy(ints.tmp45)
    del ints.tmp45
    tmp82 += ints.tmp56 * 2
    del ints.tmp56
    tmp82 += ints.tmp59
    del ints.tmp59
    tmp82 += v.bbb.xov
    tmp82 += einsum(tmp81, (0, 1, 2), t1.bb, (2, 3), (0, 1, 3)) * -1
    del tmp81
    tmp76 = einsum(ints.tmp4, (0, 1, 2, 3), r2.bab, (3, 2, 4), (0, 4, 1)) * -1
    tmp87 = einsum(ints.tmp42, (0, 1, 2, 3), r2.bab, (3, 1, 4), (0, 4, 2))
    tmp87 += einsum(tmp75, (0, 1, 2), t1.bb, (1, 3), (0, 2, 3))
    tmp87 += einsum(tmp77, (0, 1, 2), tmp85, (3, 4, 0, 1), (3, 4, 2))
    del tmp85
    tmp87 += einsum(r1.a, (0,), tmp86, (1, 2, 0, 3), (1, 2, 3)) * -1
    del tmp86
    tmp78 = np.copy(ints.tmp342)
    del ints.tmp342
    tmp78 += ints.tmp357
    del ints.tmp357
    tmp78 += ints.tmp293 * -1
    del ints.tmp293
    tmp67 = np.copy(np.transpose(ints.tmp30, (1, 0))) * 2
    tmp67 += np.transpose(ints.tmp33, (1, 0))
    tmp67 += ints.tmp9
    tmp67 += f.aa.vv * -1
    tmp67 += np.transpose(ints.tmp11, (1, 0)) * -1
    tmp67 += np.transpose(ints.tmp7, (1, 0)) * -1
    tmp67 += np.transpose(tmp66, (1, 0))
    del tmp66
    tmp80 = np.copy(ints.tmp298)
    del ints.tmp298
    tmp80 += ints.tmp319
    del ints.tmp319
    tmp80 += ints.tmp383 * 2
    del ints.tmp383
    tmp80 += einsum(t1.bb, (0, 1), tmp79, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp79
    tmp65 = np.copy(ints.tmp29) * 2
    del ints.tmp29
    tmp65 += ints.tmp32
    del ints.tmp32
    tmp65 += ints.tmp8
    del ints.tmp8
    tmp65 += v.baa.xov
    tmp65 += einsum(tmp24, (0, 1, 2), t1.aa, (2, 3), (0, 1, 3)) * -1
    del tmp24
    tmp58 = np.copy(np.transpose(r2.aba, (2, 0, 1)))
    tmp58 += einsum(r1.b, (0,), t1.aa, (1, 2), (1, 2, 0)) * -1
    tmp69 = np.copy(ints.tmp227)
    del ints.tmp227
    tmp69 += np.transpose(ints.tmp239, (0, 1, 3, 2))
    del ints.tmp239
    tmp69 += ints.tmp243
    del ints.tmp243
    tmp69 += np.transpose(ints.tmp265, (0, 1, 3, 2))
    del ints.tmp265
    tmp69 += np.transpose(ints.tmp267, (0, 1, 3, 2)) * 2
    del ints.tmp267
    tmp69 += ints.tmp42
    tmp69 += ints.tmp218 * -1
    del ints.tmp218
    tmp69 += np.transpose(ints.tmp266, (0, 1, 3, 2)) * -1
    del ints.tmp266
    tmp68 = np.copy(ints.tmp46)
    tmp68 += np.transpose(ints.tmp57, (1, 0)) * 2
    tmp68 += np.transpose(ints.tmp60, (1, 0))
    tmp68 += f.bb.vv * -1
    tmp68 += np.transpose(ints.tmp44, (1, 0)) * -1
    tmp68 += np.transpose(ints.tmp47, (1, 0)) * -1
    tmp68 += einsum(tmp0, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp53 = np.copy(f.aa.oo)
    tmp53 += np.transpose(ints.tmp124, (1, 0))
    del ints.tmp124
    tmp53 += np.transpose(ints.tmp126, (1, 0))
    del ints.tmp126
    tmp53 += ints.tmp157
    del ints.tmp157
    tmp53 += np.transpose(ints.tmp173, (1, 0)) * 2
    del ints.tmp173
    tmp53 += np.transpose(ints.tmp175, (1, 0))
    del ints.tmp175
    tmp53 += np.transpose(ints.tmp195, (1, 0))
    del ints.tmp195
    tmp53 += np.transpose(ints.tmp197, (1, 0))
    del ints.tmp197
    tmp53 += np.transpose(ints.tmp122, (1, 0)) * -1
    del ints.tmp122
    tmp53 += np.transpose(ints.tmp193, (1, 0)) * -1
    del ints.tmp193
    tmp74 = einsum(r2.aba, (0, 1, 2), ints.tmp4, (3, 4, 0, 1), (2, 3, 4)) * -1
    tmp74 += einsum(tmp70, (0, 1, 2, 3), r2.aba, (4, 3, 1), (0, 2, 4))
    del tmp70
    tmp74 += einsum(tmp71, (0, 1, 2, 3), r1.b, (3,), (0, 1, 2))
    del tmp71
    tmp74 += einsum(t1.aa, (0, 1), tmp73, (0, 2, 3), (2, 3, 1)) * -1
    del tmp73
    tmp61 = np.copy(ints.tmp117)
    del ints.tmp117
    tmp61 += ints.tmp167
    del ints.tmp167
    tmp61 += ints.tmp86 * 2
    del ints.tmp86
    tmp61 += einsum(tmp60, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 4, 3)) * -1
    del tmp60
    tmp59 = np.copy(ints.tmp250)
    del ints.tmp250
    tmp59 += ints.tmp256
    del ints.tmp256
    tmp59 += ints.tmp221 * -1
    del ints.tmp221
    tmp57 = einsum(ints.tmp42, (0, 1, 2, 3), r2.aba, (1, 3, 4), (0, 4, 2))
    tmp55 = np.copy(ints.tmp115)
    del ints.tmp115
    tmp55 += ints.tmp119
    del ints.tmp119
    tmp55 += ints.tmp135 * 2
    del ints.tmp135
    tmp55 += ints.tmp137
    del ints.tmp137
    tmp55 += ints.tmp148
    del ints.tmp148
    tmp55 += ints.tmp149
    del ints.tmp149
    tmp55 += ints.tmp159
    del ints.tmp159
    tmp55 += ints.tmp171 * 2
    del ints.tmp171
    tmp55 += ints.tmp178 * 2
    del ints.tmp178
    tmp55 += ints.tmp180
    del ints.tmp180
    tmp55 += ints.tmp183 * 2
    del ints.tmp183
    tmp55 += ints.tmp184
    del ints.tmp184
    tmp55 += ints.tmp186
    del ints.tmp186
    tmp55 += ints.tmp206
    del ints.tmp206
    tmp55 += ints.tmp207
    del ints.tmp207
    tmp55 += ints.tmp94 * 2
    del ints.tmp94
    tmp55 += ints.tmp96
    del ints.tmp96
    tmp55 += f.aa.ov * -1
    tmp55 += ints.tmp147 * -1
    del ints.tmp147
    tmp55 += ints.tmp156 * -1
    del ints.tmp156
    tmp55 += ints.tmp15 * -1
    del ints.tmp15
    tmp55 += ints.tmp172 * -1
    del ints.tmp172
    tmp55 += ints.tmp185 * -1
    del ints.tmp185
    tmp55 += ints.tmp187 * -1
    del ints.tmp187
    tmp55 += ints.tmp205 * -1
    del ints.tmp205
    tmp55 += ints.tmp20 * -1
    del ints.tmp20
    tmp55 += ints.tmp67 * -2
    del ints.tmp67
    tmp55 += ints.tmp68 * -1
    del ints.tmp68
    tmp55 += ints.tmp95 * -2
    del ints.tmp95
    tmp55 += ints.tmp97 * -1
    del ints.tmp97
    tmp55 += ints.tmp98 * -2
    del ints.tmp98
    tmp55 += ints.tmp99 * -1
    del ints.tmp99
    tmp52 = np.copy(tmp35) * 2
    del tmp35
    tmp52 += tmp36
    del tmp36
    tmp52 += np.transpose(tmp38, (0, 2, 1)) * -2
    del tmp38
    tmp52 += np.transpose(tmp40, (0, 2, 1))
    del tmp40
    tmp52 += np.transpose(tmp49, (0, 2, 1))
    del tmp49
    tmp52 += tmp51
    del tmp51
    tmp54 = np.copy(ints.tmp138)
    del ints.tmp138
    tmp54 += ints.tmp181 * -1
    del ints.tmp181
    tmp34 = np.copy(tmp18)
    del tmp18
    tmp34 += np.transpose(tmp20, (0, 2, 1)) * -1
    del tmp20
    tmp34 += np.transpose(tmp31, (0, 2, 1))
    del tmp31
    tmp34 += tmp33
    del tmp33
    tmp13 = einsum(t1.aa, (0, 1), tmp12, (2, 0, 3), (2, 3, 1))
    tmp7 = np.copy(ints.tmp46)
    del ints.tmp46
    tmp7 += np.transpose(ints.tmp57, (1, 0)) * 2
    del ints.tmp57
    tmp7 += np.transpose(ints.tmp60, (1, 0))
    del ints.tmp60
    tmp7 += f.bb.vv * -1
    tmp7 += np.transpose(ints.tmp44, (1, 0)) * -1
    del ints.tmp44
    tmp7 += np.transpose(ints.tmp47, (1, 0)) * -1
    del ints.tmp47
    tmp2 = np.copy(np.transpose(ints.tmp30, (1, 0))) * 2
    del ints.tmp30
    tmp2 += np.transpose(ints.tmp33, (1, 0))
    del ints.tmp33
    tmp2 += ints.tmp9
    del ints.tmp9
    tmp2 += f.aa.vv * -1
    tmp2 += np.transpose(ints.tmp11, (1, 0)) * -1
    del ints.tmp11
    tmp2 += np.transpose(ints.tmp7, (1, 0)) * -1
    del ints.tmp7
    r2new.bbb = einsum(r2.bbb, (0, 1, 2), ints.tmp469, (3, 0, 4, 1), (3, 4, 2)) * -2
    del ints.tmp469
    r2new.bbb += einsum(tmp90, (0, 1, 2), t2.bbbb, (1, 0, 3, 4), (3, 4, 2)) * -2
    del tmp90
    r2new.bbb += einsum(t1.bb, (0, 1), tmp91, (0, 2, 3), (3, 1, 2)) * -2
    del tmp91
    r2new.bbb += np.transpose(tmp109, (1, 2, 0))
    r2new.bbb += np.transpose(tmp109, (2, 1, 0)) * -1
    del tmp109
    r2new.bbb += np.transpose(tmp128, (1, 2, 0)) * -1
    r2new.bbb += np.transpose(tmp128, (2, 1, 0))
    del tmp128
    r2new.bbb += einsum(r2.bbb, (0, 1, 2), tmp88, (2, 3), (0, 1, 3)) * -2
    r2new.bbb += einsum(t2.bbbb, (0, 1, 2, 3), tmp11, (1,), (2, 3, 0)) * -2
    r2new.bbb += einsum(r1.b, (0,), tmp129, (1, 2, 3, 0), (3, 2, 1)) * 2
    del tmp129
    r2new.bbb += einsum(r1.b, (0,), tmp89, (1, 2), (0, 2, 1)) * -1
    r2new.bbb += einsum(r1.b, (0,), tmp89, (1, 2), (2, 0, 1))
    r2new.bab = einsum(ints.tmp237, (0, 1, 2, 3), r2.bab, (3, 1, 4), (2, 0, 4))
    r2new.bab += einsum(t2.abab, (0, 1, 2, 3), tmp75, (0, 1, 4), (3, 2, 4)) * -1
    del tmp75
    r2new.bab += einsum(tmp76, (0, 1, 2), t1.bb, (0, 3), (3, 2, 1))
    del tmp76
    r2new.bab += einsum(r2.aaa, (0, 1, 2), ints.tmp380, (2, 3, 1, 4), (4, 0, 3)) * 2
    del ints.tmp380
    r2new.bab += einsum(tmp78, (0, 1, 2, 3), tmp77, (1, 3, 4), (4, 2, 0))
    del tmp77, tmp78
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp80, (3, 2, 4, 0), (4, 1, 3)) * -1
    del tmp80
    r2new.bab += einsum(tmp16, (0, 1), tmp82, (0, 2, 3), (3, 1, 2)) * -2
    del tmp16, tmp82
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp67, (1, 3), (0, 3, 2)) * -1
    r2new.bab += einsum(tmp83, (0, 1), r2.bab, (0, 2, 3), (1, 2, 3)) * -2
    del tmp83
    r2new.bab += einsum(r1.a, (0,), tmp84, (1, 2, 0, 3), (3, 2, 1)) * -1
    del tmp84
    r2new.bab += einsum(tmp87, (0, 1, 2), t1.aa, (0, 3), (2, 3, 1)) * -1
    del tmp87
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp88, (2, 3), (0, 1, 3)) * -1
    del tmp88
    r2new.bab += einsum(t2.abab, (0, 1, 2, 3), tmp6, (0,), (3, 2, 1))
    r2new.bab += einsum(r1.a, (0,), tmp89, (1, 2), (2, 0, 1))
    del tmp89
    r2new.aba = einsum(ints.tmp237, (0, 1, 2, 3), r2.aba, (1, 3, 4), (0, 2, 4))
    del ints.tmp237
    r2new.aba += einsum(t2.abab, (0, 1, 2, 3), tmp56, (0, 4, 1), (2, 3, 4))
    del tmp56
    r2new.aba += einsum(tmp57, (0, 1, 2), t1.aa, (0, 3), (3, 2, 1)) * -1
    del tmp57
    r2new.aba += einsum(ints.tmp89, (0, 1, 2, 3), r2.bbb, (4, 3, 1), (2, 4, 0)) * 2
    del ints.tmp89
    r2new.aba += einsum(tmp58, (0, 1, 2), tmp59, (3, 0, 4, 2), (1, 4, 3)) * -1
    del tmp58, tmp59
    r2new.aba += einsum(tmp61, (0, 1, 2, 3), r2.aba, (3, 4, 1), (2, 4, 0)) * -1
    del tmp61
    r2new.aba += einsum(tmp65, (0, 1, 2), tmp64, (0, 3), (2, 3, 1)) * -1
    del tmp64, tmp65
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp67, (0, 3), (3, 1, 2)) * -1
    del tmp67
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp68, (1, 3), (0, 3, 2)) * -1
    del tmp68
    r2new.aba += einsum(tmp69, (0, 1, 2, 3), r1.b, (3,), (1, 2, 0)) * -1
    del tmp69
    r2new.aba += einsum(tmp74, (0, 1, 2), t1.bb, (1, 3), (2, 3, 0))
    del tmp74
    r2new.aba += einsum(tmp53, (0, 1), r2.aba, (2, 3, 0), (2, 3, 1)) * -1
    r2new.aba += einsum(t2.abab, (0, 1, 2, 3), tmp11, (1,), (2, 3, 0)) * -1
    r2new.aba += einsum(tmp55, (0, 1), r1.b, (2,), (1, 2, 0))
    r2new.aaa = einsum(ints.tmp160, (0, 1, 2, 3), r2.aaa, (3, 1, 4), (0, 2, 4)) * 2
    del ints.tmp160
    r2new.aaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp12, (1, 0, 4), (2, 3, 4)) * -2
    del tmp12
    r2new.aaa += einsum(tmp13, (0, 1, 2), t1.aa, (0, 3), (2, 3, 1)) * -2
    del tmp13
    r2new.aaa += np.transpose(tmp34, (1, 2, 0)) * -1
    r2new.aaa += np.transpose(tmp34, (2, 1, 0))
    del tmp34
    r2new.aaa += np.transpose(tmp52, (1, 2, 0))
    r2new.aaa += np.transpose(tmp52, (2, 1, 0)) * -1
    del tmp52
    r2new.aaa += einsum(r2.aaa, (0, 1, 2), tmp53, (2, 3), (0, 1, 3)) * -2
    del tmp53
    r2new.aaa += einsum(t2.aaaa, (0, 1, 2, 3), tmp6, (1,), (2, 3, 0)) * 2
    r2new.aaa += einsum(tmp54, (0, 1, 2, 3), r1.a, (3,), (2, 1, 0)) * 2
    del tmp54
    r2new.aaa += einsum(r1.a, (0,), tmp55, (1, 2), (0, 2, 1)) * -1
    r2new.aaa += einsum(r1.a, (0,), tmp55, (1, 2), (2, 0, 1))
    del tmp55
    r1new.b = einsum(ints.tmp42, (0, 1, 2, 3), r2.aba, (1, 3, 0), (2,)) * -1
    del ints.tmp42
    r1new.b += einsum(r2.bbb, (0, 1, 2), ints.tmp40, (2, 3, 1, 0), (3,)) * -2
    del ints.tmp40
    r1new.b += einsum(tmp1, (0, 1), r2.aba, (1, 2, 0), (2,)) * -1
    r1new.b += einsum(tmp0, (0, 1), r2.bbb, (2, 1, 0), (2,)) * 2
    r1new.b += einsum(r1.b, (0,), tmp7, (0, 1), (1,)) * -1
    del tmp7
    r1new.b += einsum(t1.bb, (0, 1), tmp11, (0,), (1,))
    del tmp11
    r1new.a = einsum(ints.tmp4, (0, 1, 2, 3), r2.bab, (3, 2, 0), (1,)) * -1
    del ints.tmp4
    r1new.a += einsum(ints.tmp2, (0, 1, 2, 3), r2.aaa, (3, 2, 0), (1,)) * -2
    del ints.tmp2
    r1new.a += einsum(r2.bab, (0, 1, 2), tmp0, (2, 0), (1,)) * -1
    del tmp0
    r1new.a += einsum(r2.aaa, (0, 1, 2), tmp1, (2, 1), (0,)) * 2
    del tmp1
    r1new.a += einsum(r1.a, (0,), tmp2, (0, 1), (1,)) * -1
    del tmp2
    r1new.a += einsum(tmp6, (0,), t1.aa, (0, 1), (1,)) * -1
    del tmp6

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ip_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:24:45.344414.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp1 : array
    tmp10 : array
    tmp100 : array
    tmp102 : array
    tmp103 : array
    tmp105 : array
    tmp106 : array
    tmp107 : array
    tmp108 : array
    tmp11 : array
    tmp110 : array
    tmp112 : array
    tmp114 : array
    tmp116 : array
    tmp118 : array
    tmp119 : array
    tmp121 : array
    tmp123 : array
    tmp125 : array
    tmp127 : array
    tmp129 : array
    tmp13 : array
    tmp131 : array
    tmp133 : array
    tmp135 : array
    tmp137 : array
    tmp138 : array
    tmp140 : array
    tmp142 : array
    tmp143 : array
    tmp145 : array
    tmp147 : array
    tmp148 : array
    tmp15 : array
    tmp150 : array
    tmp151 : array
    tmp153 : array
    tmp155 : array
    tmp156 : array
    tmp158 : array
    tmp159 : array
    tmp161 : array
    tmp162 : array
    tmp164 : array
    tmp166 : array
    tmp167 : array
    tmp168 : array
    tmp17 : array
    tmp170 : array
    tmp171 : array
    tmp172 : array
    tmp174 : array
    tmp175 : array
    tmp176 : array
    tmp177 : array
    tmp179 : array
    tmp181 : array
    tmp182 : array
    tmp183 : array
    tmp184 : array
    tmp185 : array
    tmp187 : array
    tmp188 : array
    tmp189 : array
    tmp19 : array
    tmp190 : array
    tmp192 : array
    tmp194 : array
    tmp195 : array
    tmp196 : array
    tmp197 : array
    tmp198 : array
    tmp199 : array
    tmp2 : array
    tmp201 : array
    tmp203 : array
    tmp204 : array
    tmp205 : array
    tmp206 : array
    tmp207 : array
    tmp208 : array
    tmp209 : array
    tmp21 : array
    tmp211 : array
    tmp213 : array
    tmp215 : array
    tmp217 : array
    tmp219 : array
    tmp22 : array
    tmp220 : array
    tmp221 : array
    tmp222 : array
    tmp223 : array
    tmp225 : array
    tmp226 : array
    tmp227 : array
    tmp228 : array
    tmp23 : array
    tmp230 : array
    tmp231 : array
    tmp239 : array
    tmp241 : array
    tmp246 : array
    tmp247 : array
    tmp249 : array
    tmp25 : array
    tmp255 : array
    tmp257 : array
    tmp264 : array
    tmp265 : array
    tmp267 : array
    tmp268 : array
    tmp27 : array
    tmp270 : array
    tmp271 : array
    tmp273 : array
    tmp28 : array
    tmp280 : array
    tmp283 : array
    tmp294 : array
    tmp296 : array
    tmp298 : array
    tmp30 : array
    tmp300 : array
    tmp302 : array
    tmp304 : array
    tmp310 : array
    tmp311 : array
    tmp313 : array
    tmp314 : array
    tmp316 : array
    tmp318 : array
    tmp32 : array
    tmp320 : array
    tmp325 : array
    tmp326 : array
    tmp327 : array
    tmp329 : array
    tmp33 : array
    tmp334 : array
    tmp335 : array
    tmp337 : array
    tmp339 : array
    tmp34 : array
    tmp340 : array
    tmp344 : array
    tmp346 : array
    tmp351 : array
    tmp352 : array
    tmp354 : array
    tmp358 : array
    tmp36 : array
    tmp369 : array
    tmp37 : array
    tmp375 : array
    tmp377 : array
    tmp39 : array
    tmp4 : array
    tmp41 : array
    tmp415 : array
    tmp418 : array
    tmp42 : array
    tmp420 : array
    tmp44 : array
    tmp45 : array
    tmp46 : array
    tmp461 : array
    tmp462 : array
    tmp463 : array
    tmp464 : array
    tmp467 : array
    tmp469 : array
    tmp47 : array
    tmp471 : array
    tmp48 : array
    tmp486 : array
    tmp487 : array
    tmp489 : array
    tmp491 : array
    tmp492 : array
    tmp493 : array
    tmp5 : array
    tmp50 : array
    tmp52 : array
    tmp54 : array
    tmp55 : array
    tmp56 : array
    tmp57 : array
    tmp59 : array
    tmp60 : array
    tmp62 : array
    tmp64 : array
    tmp65 : array
    tmp67 : array
    tmp68 : array
    tmp7 : array
    tmp70 : array
    tmp72 : array
    tmp74 : array
    tmp75 : array
    tmp77 : array
    tmp78 : array
    tmp79 : array
    tmp8 : array
    tmp80 : array
    tmp82 : array
    tmp83 : array
    tmp85 : array
    tmp87 : array
    tmp89 : array
    tmp91 : array
    tmp94 : array
    tmp97 : array
    tmp99 : array
    """

    tmp29 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (1, 2), (0,))
    tmp31 = einsum(v.bbb.xov, (0, 1, 2), t1.bb, (1, 2), (0,))
    tmp106 = einsum(v.bbb.xov, (0, 1, 2), t1.bb, (3, 2), (0, 3, 1))
    tmp27 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (3, 2), (0, 3, 1))
    tmp170 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp325 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp47 = einsum(tmp29, (0,), v.bbb.xov, (0, 1, 2), (1, 2))
    tmp48 = einsum(tmp31, (0,), v.baa.xov, (0, 1, 2), (1, 2))
    tmp44 = einsum(v.bbb.xov, (0, 1, 2), tmp31, (0,), (1, 2))
    tmp107 = einsum(v.bbb.xov, (0, 1, 2), tmp106, (0, 1, 3), (3, 2))
    tmp39 = einsum(tmp29, (0,), v.baa.xov, (0, 1, 2), (1, 2))
    tmp99 = einsum(tmp27, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp166 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp59 = einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp77 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (4, 1, 3))
    tmp82 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (0, 3, 4))
    tmp56 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp45 = einsum(v.bbb.xvv, (0, 1, 2), t1.bb, (3, 2), (0, 3, 1))
    tmp41 = einsum(v.baa.xvv, (0, 1, 2), t1.aa, (3, 2), (0, 3, 1))
    tmp230 = einsum(tmp27, (0, 1, 2), tmp106, (0, 3, 4), (1, 2, 3, 4))
    tmp351 = einsum(tmp106, (0, 1, 2), tmp106, (0, 3, 4), (3, 1, 4, 2))
    tmp194 = einsum(tmp27, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 2, 3, 4))
    tmp196 = einsum(v.baa.xoo, (0, 1, 2), tmp106, (0, 3, 4), (1, 2, 3, 4))
    tmp334 = einsum(v.bbb.xoo, (0, 1, 2), tmp106, (0, 3, 4), (3, 1, 2, 4))
    tmp171 = einsum(tmp170, (0, 1, 2, 3), t2.abab, (4, 5, 2, 3), (4, 0, 5, 1))
    tmp326 = einsum(t2.bbbb, (0, 1, 2, 3), tmp325, (4, 5, 2, 3), (0, 1, 5, 4)) * -1
    tmp54 = einsum(tmp27, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp137 = einsum(v.bbb.xov, (0, 1, 2), tmp106, (0, 3, 4), (3, 1, 4, 2))
    tmp282 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp279 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp25 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp64 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp36 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp246 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp227 = einsum(tmp27, (0, 1, 2), tmp27, (0, 3, 4), (3, 1, 4, 2))
    tmp225 = einsum(tmp47, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp176 = einsum(tmp48, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp221 = einsum(t1.bb, (0, 1), tmp44, (2, 1), (0, 2))
    tmp219 = einsum(tmp107, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp175 = einsum(tmp39, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp174 = einsum(tmp99, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp208 = einsum(v.baa.xvv, (0, 1, 2), tmp31, (0,), (1, 2))
    tmp206 = einsum(tmp29, (0,), v.bbb.xvv, (0, 1, 2), (1, 2))
    tmp203 = einsum(tmp31, (0,), v.bbb.xvv, (0, 1, 2), (1, 2))
    tmp198 = einsum(tmp29, (0,), v.baa.xvv, (0, 1, 2), (1, 2))
    tmp189 = einsum(tmp27, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp187 = einsum(tmp29, (0,), v.bbb.xoo, (0, 1, 2), (1, 2))
    tmp32 = einsum(v.baa.xoo, (0, 1, 2), tmp31, (0,), (1, 2))
    tmp183 = einsum(v.bbb.xoo, (0, 1, 2), tmp31, (0,), (1, 2))
    del tmp31
    tmp181 = einsum(tmp106, (0, 1, 2), v.bbb.xoo, (0, 3, 1), (3, 2))
    tmp30 = einsum(tmp29, (0,), v.baa.xoo, (0, 1, 2), (1, 2))
    del tmp29
    tmp28 = einsum(v.baa.xoo, (0, 1, 2), tmp27, (0, 2, 3), (1, 3))
    tmp167 = einsum(t2.aaaa, (0, 1, 2, 3), tmp166, (4, 5, 2, 3), (0, 1, 5, 4)) * -1
    tmp60 = einsum(tmp59, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp161 = einsum(v.bbb.xov, (0, 1, 2), tmp77, (0, 3, 2), (3, 1))
    tmp158 = einsum(v.bbb.xov, (0, 1, 2), tmp82, (0, 3, 2), (3, 1))
    tmp57 = einsum(v.baa.xov, (0, 1, 2), tmp56, (0, 3, 2), (3, 1))
    tmp142 = einsum(tmp106, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp50 = einsum(v.baa.xov, (0, 1, 2), tmp27, (0, 3, 4), (3, 1, 4, 2))
    tmp96 = einsum(v.bbb.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 4, 1, 2))
    tmp93 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp67 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp23 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp33 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 1, 2, 4))
    tmp21 = einsum(f.bb.ov, (0, 1), t1.bb, (2, 1), (0, 2))
    tmp1 = einsum(t1.aa, (0, 1), f.aa.ov, (2, 1), (2, 0))
    tmp493 = einsum(t2.abab, (0, 1, 2, 3), tmp170, (4, 1, 2, 5), (0, 4, 3, 5))
    tmp492 = einsum(tmp27, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp491 = einsum(v.baa.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp489 = einsum(v.bbb.xov, (0, 1, 2), tmp77, (0, 1, 3), (3, 2))
    tmp487 = einsum(v.bbb.xov, (0, 1, 2), tmp82, (0, 1, 3), (3, 2))
    tmp486 = einsum(v.bbb.xov, (0, 1, 2), tmp45, (0, 1, 3), (2, 3))
    tmp471 = einsum(t2.bbbb, (0, 1, 2, 3), tmp325, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp469 = einsum(t2.abab, (0, 1, 2, 3), tmp325, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp467 = einsum(v.bbb.xvv, (0, 1, 2), tmp106, (0, 3, 4), (3, 4, 1, 2))
    tmp464 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp463 = einsum(t2.abab, (0, 1, 2, 3), tmp170, (0, 4, 5, 3), (1, 4, 2, 5))
    tmp462 = einsum(v.baa.xvv, (0, 1, 2), tmp106, (0, 3, 4), (3, 4, 1, 2))
    tmp461 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp420 = einsum(tmp59, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp418 = einsum(v.baa.xov, (0, 1, 2), tmp56, (0, 1, 3), (3, 2))
    tmp415 = einsum(tmp41, (0, 1, 2), v.baa.xov, (0, 1, 3), (3, 2))
    tmp377 = einsum(tmp166, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (1, 4, 2, 5))
    tmp375 = einsum(t2.aaaa, (0, 1, 2, 3), tmp166, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp369 = einsum(tmp27, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp358 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp354 = einsum(tmp230, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 3, 4))
    tmp352 = einsum(tmp351, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp346 = einsum(tmp106, (0, 1, 2), tmp41, (0, 3, 4), (3, 1, 2, 4))
    tmp344 = einsum(tmp45, (0, 1, 2), tmp106, (0, 3, 4), (3, 1, 4, 2))
    tmp340 = einsum(t1.aa, (0, 1), tmp194, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp339 = einsum(t1.aa, (0, 1), tmp196, (0, 2, 3, 4), (2, 3, 4, 1))
    tmp337 = einsum(tmp334, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp335 = einsum(tmp334, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 3, 4))
    tmp329 = einsum(t1.aa, (0, 1), tmp171, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp327 = einsum(tmp326, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 3, 4)) * -1
    tmp320 = einsum(t2.abab, (0, 1, 2, 3), tmp54, (4, 0, 5, 3), (4, 1, 5, 2))
    tmp318 = einsum(tmp106, (0, 1, 2), tmp77, (0, 3, 4), (1, 3, 2, 4))
    tmp316 = einsum(tmp106, (0, 1, 2), tmp56, (0, 3, 4), (3, 1, 2, 4))
    tmp314 = einsum(tmp137, (0, 1, 2, 3), t2.bbbb, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp313 = einsum(t2.abab, (0, 1, 2, 3), tmp137, (4, 5, 1, 3), (0, 4, 5, 2))
    tmp311 = einsum(tmp106, (0, 1, 2), tmp82, (0, 3, 4), (1, 3, 2, 4))
    tmp310 = einsum(tmp59, (0, 1, 2), tmp106, (0, 3, 4), (1, 3, 4, 2))
    tmp304 = einsum(t2.bbbb, (0, 1, 2, 3), tmp47, (4, 3), (0, 1, 4, 2))
    tmp302 = einsum(t2.abab, (0, 1, 2, 3), tmp47, (4, 3), (0, 1, 4, 2))
    tmp300 = einsum(t2.bbbb, (0, 1, 2, 3), tmp44, (4, 3), (0, 1, 4, 2))
    tmp298 = einsum(t2.abab, (0, 1, 2, 3), tmp44, (4, 3), (0, 1, 4, 2))
    tmp296 = einsum(tmp107, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 0, 4))
    tmp294 = einsum(t2.abab, (0, 1, 2, 3), tmp107, (4, 3), (0, 1, 4, 2))
    tmp283 = einsum(t2.abab, (0, 1, 2, 3), tmp282, (4, 5, 2, 3), (0, 1, 4, 5))
    del tmp282
    tmp280 = einsum(tmp279, (0, 1, 2, 3), t2.bbbb, (4, 5, 1, 3), (4, 5, 0, 2)) * -1
    del tmp279
    tmp273 = einsum(tmp77, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp271 = einsum(v.bbb.xoo, (0, 1, 2), tmp56, (0, 3, 4), (3, 1, 2, 4))
    tmp270 = einsum(t2.abab, (0, 1, 2, 3), tmp25, (4, 0, 5, 3), (4, 1, 5, 2))
    tmp268 = einsum(v.bbb.xoo, (0, 1, 2), tmp82, (0, 3, 4), (3, 1, 2, 4))
    tmp267 = einsum(v.bbb.xoo, (0, 1, 2), tmp59, (0, 3, 4), (3, 1, 2, 4))
    tmp265 = einsum(t2.bbbb, (0, 1, 2, 3), tmp64, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp264 = einsum(t2.abab, (0, 1, 2, 3), tmp64, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp257 = einsum(v.bbb.xoo, (0, 1, 2), tmp41, (0, 3, 4), (3, 1, 2, 4))
    tmp255 = einsum(v.bbb.xoo, (0, 1, 2), tmp45, (0, 3, 4), (3, 1, 2, 4))
    tmp249 = einsum(t1.aa, (0, 1), tmp36, (2, 0, 3, 4), (2, 3, 4, 1))
    tmp247 = einsum(tmp246, (0, 1, 2, 3), t1.bb, (1, 4), (3, 0, 2, 4))
    tmp241 = einsum(f.bb.ov, (0, 1), t2.bbbb, (2, 3, 4, 1), (0, 2, 3, 4))
    tmp239 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (4, 3), (0, 4, 1, 2))
    tmp231 = einsum(tmp230, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp228 = einsum(tmp227, (0, 1, 2, 3), t1.aa, (3, 4), (0, 1, 2, 4))
    tmp226 = einsum(t1.bb, (0, 1), tmp225, (2, 0), (2, 1))
    tmp223 = einsum(t1.aa, (0, 1), tmp176, (2, 0), (2, 1))
    tmp222 = einsum(tmp221, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp220 = einsum(tmp219, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp217 = einsum(t1.aa, (0, 1), tmp175, (2, 0), (2, 1))
    tmp215 = einsum(t1.aa, (0, 1), tmp174, (2, 0), (2, 1))
    tmp213 = einsum(tmp27, (0, 1, 2), tmp45, (0, 3, 4), (1, 2, 3, 4))
    tmp211 = einsum(tmp27, (0, 1, 2), tmp41, (0, 3, 4), (1, 3, 2, 4))
    tmp209 = einsum(t1.aa, (0, 1), tmp208, (2, 1), (0, 2))
    tmp207 = einsum(tmp206, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp205 = einsum(tmp45, (0, 1, 2), tmp106, (0, 3, 1), (3, 2))
    tmp204 = einsum(tmp203, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp201 = einsum(tmp27, (0, 1, 2), tmp41, (0, 2, 3), (1, 3))
    tmp199 = einsum(tmp198, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp197 = einsum(tmp196, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp195 = einsum(t1.bb, (0, 1), tmp194, (2, 3, 4, 0), (2, 3, 4, 1))
    tmp192 = einsum(tmp189, (0, 1, 2, 3), t1.aa, (3, 4), (0, 1, 2, 4))
    tmp190 = einsum(tmp189, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 3, 4))
    tmp188 = einsum(tmp187, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp185 = einsum(tmp32, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp184 = einsum(tmp183, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp182 = einsum(tmp181, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp179 = einsum(tmp30, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp177 = einsum(tmp28, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp172 = einsum(tmp171, (0, 1, 2, 3), t1.bb, (3, 4), (0, 1, 2, 4))
    tmp168 = einsum(tmp167, (0, 1, 2, 3), t1.aa, (2, 4), (0, 1, 3, 4)) * -1
    tmp164 = einsum(tmp60, (0, 1), t1.aa, (1, 2), (0, 2))
    tmp162 = einsum(tmp161, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp159 = einsum(tmp158, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp156 = einsum(t1.aa, (0, 1), tmp57, (2, 0), (2, 1))
    tmp155 = einsum(t2.abab, (0, 1, 2, 3), tmp142, (4, 5, 1, 2), (0, 4, 5, 3))
    tmp153 = einsum(tmp27, (0, 1, 2), tmp82, (0, 3, 4), (1, 2, 3, 4))
    tmp151 = einsum(tmp59, (0, 1, 2), tmp27, (0, 3, 4), (3, 1, 4, 2))
    tmp150 = einsum(t2.abab, (0, 1, 2, 3), tmp50, (4, 5, 0, 2), (4, 5, 1, 3))
    tmp148 = einsum(tmp50, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 3), (0, 4, 1, 5))
    tmp147 = einsum(tmp27, (0, 1, 2), tmp77, (0, 3, 4), (1, 2, 3, 4))
    tmp145 = einsum(tmp56, (0, 1, 2), tmp27, (0, 3, 4), (3, 1, 4, 2))
    tmp143 = einsum(t2.abab, (0, 1, 2, 3), tmp142, (0, 4, 1, 2), (4, 3))
    tmp140 = einsum(t2.abab, (0, 1, 2, 3), tmp54, (4, 0, 1, 3), (4, 2))
    tmp138 = einsum(t2.bbbb, (0, 1, 2, 3), tmp137, (4, 1, 0, 3), (4, 2))
    tmp135 = einsum(t2.aaaa, (0, 1, 2, 3), tmp50, (4, 1, 0, 3), (4, 2))
    tmp133 = einsum(t2.abab, (0, 1, 2, 3), tmp48, (4, 2), (0, 4, 1, 3))
    tmp131 = einsum(t2.aaaa, (0, 1, 2, 3), tmp48, (4, 3), (0, 1, 4, 2))
    tmp129 = einsum(t2.abab, (0, 1, 2, 3), tmp39, (4, 2), (0, 4, 1, 3))
    tmp127 = einsum(t2.aaaa, (0, 1, 2, 3), tmp39, (4, 3), (0, 1, 4, 2))
    tmp125 = einsum(t2.abab, (0, 1, 2, 3), tmp99, (4, 2), (0, 4, 1, 3))
    tmp123 = einsum(t2.aaaa, (0, 1, 2, 3), tmp99, (4, 3), (0, 1, 4, 2))
    tmp121 = einsum(tmp47, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp119 = einsum(t2.abab, (0, 1, 2, 3), tmp47, (1, 3), (0, 2))
    tmp118 = einsum(tmp48, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    tmp116 = einsum(tmp48, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp114 = einsum(tmp44, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp112 = einsum(tmp44, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp110 = einsum(tmp107, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp108 = einsum(tmp107, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp105 = einsum(t2.abab, (0, 1, 2, 3), tmp39, (0, 2), (1, 3))
    tmp103 = einsum(tmp39, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp102 = einsum(t2.abab, (0, 1, 2, 3), tmp99, (0, 2), (1, 3))
    tmp100 = einsum(tmp99, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp97 = einsum(tmp96, (0, 1, 2, 3), t2.abab, (4, 5, 1, 2), (4, 0, 5, 3))
    del tmp96
    tmp94 = einsum(t2.aaaa, (0, 1, 2, 3), tmp93, (4, 5, 2, 3), (0, 1, 4, 5)) * -1
    del tmp93
    tmp91 = einsum(v.baa.xvv, (0, 1, 2), tmp59, (0, 3, 2), (3, 1))
    tmp89 = einsum(v.bbb.xvv, (0, 1, 2), tmp77, (0, 3, 2), (3, 1))
    tmp87 = einsum(v.bbb.xvv, (0, 1, 2), tmp82, (0, 3, 2), (3, 1)) * -1
    tmp85 = einsum(v.baa.xvv, (0, 1, 2), tmp56, (0, 3, 2), (3, 1)) * -1
    tmp83 = einsum(v.baa.xoo, (0, 1, 2), tmp82, (0, 3, 4), (1, 2, 3, 4))
    tmp80 = einsum(tmp59, (0, 1, 2), v.baa.xoo, (0, 3, 4), (1, 3, 4, 2))
    tmp79 = einsum(t2.abab, (0, 1, 2, 3), tmp67, (4, 1, 5, 2), (0, 4, 5, 3))
    tmp78 = einsum(v.baa.xoo, (0, 1, 2), tmp77, (0, 3, 4), (1, 2, 3, 4))
    tmp75 = einsum(v.baa.xoo, (0, 1, 2), tmp56, (0, 3, 4), (3, 1, 2, 4))
    tmp74 = einsum(t2.abab, (0, 1, 2, 3), tmp23, (0, 4, 5, 2), (4, 5, 1, 3))
    tmp72 = einsum(t2.aaaa, (0, 1, 2, 3), tmp23, (4, 1, 5, 3), (0, 4, 5, 2))
    tmp70 = einsum(tmp25, (0, 1, 2, 3), t2.abab, (0, 2, 4, 3), (1, 4))
    tmp68 = einsum(tmp67, (0, 1, 2, 3), t2.abab, (0, 1, 3, 4), (2, 4))
    tmp65 = einsum(tmp64, (0, 1, 2, 3), t2.bbbb, (0, 2, 4, 3), (1, 4))
    tmp62 = einsum(t2.aaaa, (0, 1, 2, 3), tmp23, (0, 4, 1, 3), (4, 2))
    tmp55 = einsum(v.baa.xoo, (0, 1, 2), tmp45, (0, 3, 4), (1, 2, 3, 4))
    tmp52 = einsum(v.baa.xoo, (0, 1, 2), tmp41, (0, 3, 4), (3, 1, 2, 4))
    tmp46 = einsum(tmp45, (0, 1, 2), v.bbb.xoo, (0, 3, 1), (3, 2))
    tmp42 = einsum(v.baa.xoo, (0, 1, 2), tmp41, (0, 2, 3), (1, 3))
    tmp37 = einsum(tmp36, (0, 1, 2, 3), t1.bb, (3, 4), (1, 0, 2, 4))
    tmp34 = einsum(tmp33, (0, 1, 2, 3), t1.aa, (1, 4), (3, 0, 2, 4))
    tmp22 = einsum(tmp21, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp19 = einsum(t1.aa, (0, 1), tmp1, (0, 2), (2, 1))
    tmp17 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (4, 2), (4, 0, 1, 3))
    tmp15 = einsum(t2.aaaa, (0, 1, 2, 3), f.aa.ov, (4, 3), (4, 0, 1, 2))
    tmp13 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp11 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp10 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (0, 2), (1, 3))
    tmp8 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp7 = einsum(f.bb.vv, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp5 = einsum(t1.aa, (0, 1), f.aa.vv, (2, 1), (0, 2))
    tmp4 = einsum(t1.bb, (0, 1), f.bb.oo, (2, 0), (2, 1))
    tmp2 = einsum(t1.aa, (0, 1), f.aa.oo, (2, 0), (2, 1))

    return {f"tmp1": tmp1, f"tmp10": tmp10, f"tmp100": tmp100, f"tmp102": tmp102, f"tmp103": tmp103, f"tmp105": tmp105, f"tmp106": tmp106, f"tmp107": tmp107, f"tmp108": tmp108, f"tmp11": tmp11, f"tmp110": tmp110, f"tmp112": tmp112, f"tmp114": tmp114, f"tmp116": tmp116, f"tmp118": tmp118, f"tmp119": tmp119, f"tmp121": tmp121, f"tmp123": tmp123, f"tmp125": tmp125, f"tmp127": tmp127, f"tmp129": tmp129, f"tmp13": tmp13, f"tmp131": tmp131, f"tmp133": tmp133, f"tmp135": tmp135, f"tmp137": tmp137, f"tmp138": tmp138, f"tmp140": tmp140, f"tmp142": tmp142, f"tmp143": tmp143, f"tmp145": tmp145, f"tmp147": tmp147, f"tmp148": tmp148, f"tmp15": tmp15, f"tmp150": tmp150, f"tmp151": tmp151, f"tmp153": tmp153, f"tmp155": tmp155, f"tmp156": tmp156, f"tmp158": tmp158, f"tmp159": tmp159, f"tmp161": tmp161, f"tmp162": tmp162, f"tmp164": tmp164, f"tmp166": tmp166, f"tmp167": tmp167, f"tmp168": tmp168, f"tmp17": tmp17, f"tmp170": tmp170, f"tmp171": tmp171, f"tmp172": tmp172, f"tmp174": tmp174, f"tmp175": tmp175, f"tmp176": tmp176, f"tmp177": tmp177, f"tmp179": tmp179, f"tmp181": tmp181, f"tmp182": tmp182, f"tmp183": tmp183, f"tmp184": tmp184, f"tmp185": tmp185, f"tmp187": tmp187, f"tmp188": tmp188, f"tmp189": tmp189, f"tmp19": tmp19, f"tmp190": tmp190, f"tmp192": tmp192, f"tmp194": tmp194, f"tmp195": tmp195, f"tmp196": tmp196, f"tmp197": tmp197, f"tmp198": tmp198, f"tmp199": tmp199, f"tmp2": tmp2, f"tmp201": tmp201, f"tmp203": tmp203, f"tmp204": tmp204, f"tmp205": tmp205, f"tmp206": tmp206, f"tmp207": tmp207, f"tmp208": tmp208, f"tmp209": tmp209, f"tmp21": tmp21, f"tmp211": tmp211, f"tmp213": tmp213, f"tmp215": tmp215, f"tmp217": tmp217, f"tmp219": tmp219, f"tmp22": tmp22, f"tmp220": tmp220, f"tmp221": tmp221, f"tmp222": tmp222, f"tmp223": tmp223, f"tmp225": tmp225, f"tmp226": tmp226, f"tmp227": tmp227, f"tmp228": tmp228, f"tmp23": tmp23, f"tmp230": tmp230, f"tmp231": tmp231, f"tmp239": tmp239, f"tmp241": tmp241, f"tmp246": tmp246, f"tmp247": tmp247, f"tmp249": tmp249, f"tmp25": tmp25, f"tmp255": tmp255, f"tmp257": tmp257, f"tmp264": tmp264, f"tmp265": tmp265, f"tmp267": tmp267, f"tmp268": tmp268, f"tmp27": tmp27, f"tmp270": tmp270, f"tmp271": tmp271, f"tmp273": tmp273, f"tmp28": tmp28, f"tmp280": tmp280, f"tmp283": tmp283, f"tmp294": tmp294, f"tmp296": tmp296, f"tmp298": tmp298, f"tmp30": tmp30, f"tmp300": tmp300, f"tmp302": tmp302, f"tmp304": tmp304, f"tmp310": tmp310, f"tmp311": tmp311, f"tmp313": tmp313, f"tmp314": tmp314, f"tmp316": tmp316, f"tmp318": tmp318, f"tmp32": tmp32, f"tmp320": tmp320, f"tmp325": tmp325, f"tmp326": tmp326, f"tmp327": tmp327, f"tmp329": tmp329, f"tmp33": tmp33, f"tmp334": tmp334, f"tmp335": tmp335, f"tmp337": tmp337, f"tmp339": tmp339, f"tmp34": tmp34, f"tmp340": tmp340, f"tmp344": tmp344, f"tmp346": tmp346, f"tmp351": tmp351, f"tmp352": tmp352, f"tmp354": tmp354, f"tmp358": tmp358, f"tmp36": tmp36, f"tmp369": tmp369, f"tmp37": tmp37, f"tmp375": tmp375, f"tmp377": tmp377, f"tmp39": tmp39, f"tmp4": tmp4, f"tmp41": tmp41, f"tmp415": tmp415, f"tmp418": tmp418, f"tmp42": tmp42, f"tmp420": tmp420, f"tmp44": tmp44, f"tmp45": tmp45, f"tmp46": tmp46, f"tmp461": tmp461, f"tmp462": tmp462, f"tmp463": tmp463, f"tmp464": tmp464, f"tmp467": tmp467, f"tmp469": tmp469, f"tmp47": tmp47, f"tmp471": tmp471, f"tmp48": tmp48, f"tmp486": tmp486, f"tmp487": tmp487, f"tmp489": tmp489, f"tmp491": tmp491, f"tmp492": tmp492, f"tmp493": tmp493, f"tmp5": tmp5, f"tmp50": tmp50, f"tmp52": tmp52, f"tmp54": tmp54, f"tmp55": tmp55, f"tmp56": tmp56, f"tmp57": tmp57, f"tmp59": tmp59, f"tmp60": tmp60, f"tmp62": tmp62, f"tmp64": tmp64, f"tmp65": tmp65, f"tmp67": tmp67, f"tmp68": tmp68, f"tmp7": tmp7, f"tmp70": tmp70, f"tmp72": tmp72, f"tmp74": tmp74, f"tmp75": tmp75, f"tmp77": tmp77, f"tmp78": tmp78, f"tmp79": tmp79, f"tmp8": tmp8, f"tmp80": tmp80, f"tmp82": tmp82, f"tmp83": tmp83, f"tmp85": tmp85, f"tmp87": tmp87, f"tmp89": tmp89, f"tmp91": tmp91, f"tmp94": tmp94, f"tmp97": tmp97, f"tmp99": tmp99}

def hbar_lmatvec_ip(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:24:45.546867.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp50 = np.copy(ints.tmp41)
    tmp50 += ints.tmp56 * 2
    tmp50 += ints.tmp59
    tmp50 += v.baa.xov
    tmp47 = einsum(t1.aa, (0, 1), r2.aba, (2, 3, 1), (2, 0, 3))
    tmp30 = np.copy(ints.tmp27)
    del ints.tmp27
    tmp30 += v.baa.xoo
    tmp33 = np.copy(ints.tmp106)
    del ints.tmp106
    tmp33 += v.bbb.xoo
    tmp52 = einsum(r2.bbb, (0, 1, 2), t1.bb, (3, 2), (0, 1, 3))
    tmp16 = np.copy(ints.tmp45)
    tmp16 += ints.tmp77
    tmp16 += v.bbb.xov
    tmp16 += ints.tmp82 * 2
    tmp14 = np.copy(ints.tmp41)
    del ints.tmp41
    tmp14 += ints.tmp59
    del ints.tmp59
    tmp14 += v.baa.xov
    tmp14 += ints.tmp56 * 2
    del ints.tmp56
    tmp27 = einsum(t1.aa, (0, 1), r2.aaa, (2, 3, 1), (2, 3, 0))
    tmp32 = einsum(r2.bab, (0, 1, 2), t1.bb, (3, 2), (1, 0, 3)) * -1
    tmp74 = einsum(tmp50, (0, 1, 2), r2.aba, (1, 3, 2), (0, 3)) * 0.5
    tmp75 = einsum(tmp30, (0, 1, 2), tmp47, (1, 2, 3), (0, 3)) * 0.5
    tmp76 = einsum(tmp52, (0, 1, 2), tmp33, (3, 0, 2), (3, 1))
    tmp55 = einsum(t2.abab, (0, 1, 2, 3), r2.aba, (0, 1, 2), (3,))
    tmp56 = einsum(t2.bbbb, (0, 1, 2, 3), r2.bbb, (0, 1, 3), (2,))
    tmp17 = einsum(r2.bab, (0, 1, 2), tmp16, (3, 0, 2), (3, 1)) * -1
    tmp15 = einsum(r2.aaa, (0, 1, 2), tmp14, (3, 1, 2), (3, 0)) * -1
    del tmp14
    tmp31 = einsum(tmp30, (0, 1, 2), tmp27, (1, 3, 2), (0, 3))
    tmp34 = einsum(tmp32, (0, 1, 2), tmp33, (3, 1, 2), (3, 0)) * 0.5
    tmp64 = np.copy(f.bb.ov)
    tmp64 += ints.tmp44
    tmp64 += ints.tmp47
    tmp64 += ints.tmp107 * -1
    del ints.tmp107
    tmp88 = np.copy(f.bb.oo)
    tmp88 += ints.tmp183
    tmp88 += ints.tmp187
    tmp88 += np.transpose(ints.tmp21, (1, 0))
    tmp88 += ints.tmp221
    tmp88 += ints.tmp225
    tmp58 = np.copy(ints.tmp464)
    del ints.tmp464
    tmp58 += ints.tmp467
    del ints.tmp467
    tmp58 += ints.tmp471 * 2
    del ints.tmp471
    tmp86 = einsum(tmp16, (0, 1, 2), r2.bbb, (3, 1, 2), (0, 3)) * -1
    del tmp16
    tmp62 = np.copy(ints.tmp137)
    tmp62 += np.transpose(ints.tmp64, (0, 2, 1, 3))
    tmp77 = np.copy(tmp74)
    del tmp74
    tmp77 += tmp75 * -1
    del tmp75
    tmp77 += tmp76 * -1
    del tmp76
    tmp81 = np.copy(ints.tmp158) * 2
    tmp81 += ints.tmp161
    tmp81 += ints.tmp181 * -1
    tmp81 += ints.tmp219 * -1
    tmp79 = np.copy(tmp55) * -0.5
    tmp79 += tmp56
    tmp41 = np.copy(f.aa.ov)
    tmp41 += ints.tmp39
    tmp41 += ints.tmp48
    tmp41 += ints.tmp99 * -1
    del ints.tmp99
    tmp18 = np.copy(tmp15) * -2
    del tmp15
    tmp18 += tmp17
    del tmp17
    tmp20 = np.copy(f.aa.oo)
    tmp20 += ints.tmp175
    tmp20 += ints.tmp176
    tmp20 += np.transpose(ints.tmp1, (1, 0))
    tmp20 += ints.tmp30
    tmp20 += ints.tmp32
    tmp10 = einsum(t2.abab, (0, 1, 2, 3), r2.bab, (1, 0, 3), (2,)) * -1
    tmp12 = np.copy(ints.tmp358)
    tmp12 += ints.tmp369
    tmp12 += ints.tmp375 * 2
    tmp25 = einsum(t2.aaaa, (0, 1, 2, 3), r2.aaa, (0, 1, 3), (2,))
    tmp35 = np.copy(tmp31) * -1
    del tmp31
    tmp35 += tmp34
    del tmp34
    tmp28 = np.copy(ints.tmp23)
    tmp28 += np.transpose(ints.tmp50, (0, 2, 1, 3))
    tmp37 = np.copy(ints.tmp57) * 2
    tmp37 += ints.tmp60
    tmp37 += ints.tmp174 * -1
    tmp37 += ints.tmp28 * -1
    tmp65 = einsum(tmp64, (0, 1), t1.bb, (0, 2), (2, 1))
    tmp84 = einsum(r1.b, (0,), ints.tmp137, (0, 1, 2, 3), (1, 2, 3))
    tmp89 = einsum(r2.bbb, (0, 1, 2), tmp88, (1, 3), (0, 3, 2)) * -1
    del tmp88
    tmp85 = einsum(tmp58, (0, 1, 2, 3), r2.bbb, (4, 0, 2), (4, 1, 3)) * -1
    tmp87 = einsum(v.bbb.xov, (0, 1, 2), tmp86, (0, 3), (1, 3, 2)) * -1
    del tmp86
    tmp73 = einsum(tmp52, (0, 1, 2), tmp62, (0, 2, 3, 4), (1, 3, 4)) * 2
    tmp70 = einsum(r1.b, (0,), ints.tmp64, (1, 0, 2, 3), (1, 2, 3))
    tmp78 = einsum(v.bbb.xov, (0, 1, 2), tmp77, (0, 3), (1, 3, 2)) * 2
    del tmp77
    tmp72 = einsum(ints.tmp334, (0, 1, 2, 3), r2.bbb, (1, 0, 4), (2, 3, 4)) * -1
    del ints.tmp334
    tmp71 = einsum(ints.tmp469, (0, 1, 2, 3), r2.aba, (0, 4, 2), (1, 4, 3))
    tmp82 = einsum(r2.bbb, (0, 1, 2), tmp81, (1, 3), (0, 3, 2)) * -2
    del tmp81
    tmp80 = einsum(ints.tmp325, (0, 1, 2, 3), tmp79, (3,), (0, 1, 2)) * 2
    del ints.tmp325, tmp79
    tmp51 = np.copy(ints.tmp45)
    del ints.tmp45
    tmp51 += ints.tmp77
    del ints.tmp77
    tmp51 += ints.tmp82 * 2
    del ints.tmp82
    tmp51 += v.bbb.xov
    tmp42 = einsum(tmp41, (0, 1), t1.aa, (0, 2), (2, 1))
    tmp8 = einsum(ints.tmp50, (0, 1, 2, 3), r1.a, (0,), (1, 2, 3))
    tmp19 = einsum(tmp18, (0, 1), v.baa.xov, (0, 2, 3), (2, 1, 3))
    del tmp18
    tmp21 = einsum(tmp20, (0, 1), r2.aaa, (2, 0, 3), (2, 1, 3)) * -1
    del tmp20
    tmp9 = einsum(r2.bab, (0, 1, 2), ints.tmp377, (3, 0, 4, 2), (3, 1, 4)) * -1
    tmp11 = einsum(tmp10, (0,), ints.tmp166, (1, 2, 3, 0), (1, 2, 3))
    tmp13 = einsum(tmp12, (0, 1, 2, 3), r2.aaa, (4, 0, 2), (4, 1, 3)) * -1
    del tmp12
    tmp26 = einsum(tmp25, (0,), ints.tmp166, (1, 2, 3, 0), (1, 2, 3))
    del ints.tmp166
    tmp36 = einsum(tmp35, (0, 1), v.baa.xov, (0, 2, 3), (2, 1, 3)) * 2
    del tmp35
    tmp29 = einsum(tmp28, (0, 1, 2, 3), tmp27, (0, 4, 2), (4, 1, 3)) * 2
    del tmp28
    tmp38 = einsum(tmp37, (0, 1), r2.aaa, (2, 0, 3), (2, 1, 3)) * -2
    del tmp37
    tmp23 = einsum(ints.tmp23, (0, 1, 2, 3), r1.a, (1,), (0, 2, 3))
    tmp24 = einsum(r2.aaa, (0, 1, 2), ints.tmp189, (1, 0, 3, 4), (3, 4, 2)) * -1
    del ints.tmp189
    tmp66 = np.copy(np.transpose(ints.tmp486, (1, 0)))
    del ints.tmp486
    tmp66 += ints.tmp487 * 2
    del ints.tmp487
    tmp66 += ints.tmp489
    del ints.tmp489
    tmp66 += f.bb.vv * -1
    tmp66 += ints.tmp203 * -1
    del ints.tmp203
    tmp66 += ints.tmp206 * -1
    del ints.tmp206
    tmp66 += tmp65
    del tmp65
    tmp90 = np.copy(tmp84)
    del tmp84
    tmp90 += np.transpose(tmp85, (1, 0, 2)) * -2
    del tmp85
    tmp90 += np.transpose(tmp87, (1, 0, 2)) * 2
    del tmp87
    tmp90 += np.transpose(tmp89, (1, 0, 2)) * -2
    del tmp89
    tmp83 = np.copy(tmp70)
    del tmp70
    tmp83 += tmp71
    del tmp71
    tmp83 += tmp72 * 2
    del tmp72
    tmp83 += np.transpose(tmp73, (1, 0, 2)) * -1
    del tmp73
    tmp83 += np.transpose(tmp78, (1, 0, 2))
    del tmp78
    tmp83 += tmp80 * -1
    del tmp80
    tmp83 += np.transpose(tmp82, (1, 0, 2))
    del tmp82
    tmp91 = np.copy(np.transpose(ints.tmp326, (2, 3, 0, 1)))
    del ints.tmp326
    tmp91 += np.transpose(ints.tmp351, (2, 3, 0, 1))
    del ints.tmp351
    tmp91 += ints.tmp246 * -1
    del ints.tmp246
    tmp4 = np.copy(f.aa.oo)
    tmp4 += ints.tmp175
    tmp4 += ints.tmp176
    tmp4 += np.transpose(ints.tmp1, (1, 0))
    tmp4 += np.transpose(ints.tmp30, (1, 0))
    tmp4 += np.transpose(ints.tmp32, (1, 0))
    tmp4 += ints.tmp57 * 2
    tmp4 += ints.tmp60
    tmp4 += ints.tmp174 * -1
    tmp4 += ints.tmp28 * -1
    tmp69 = np.copy(ints.tmp25)
    tmp69 += np.transpose(ints.tmp54, (1, 0, 2, 3))
    tmp68 = np.copy(tmp25) * 2
    del tmp25
    tmp68 += tmp10
    del tmp10
    tmp63 = einsum(r2.aaa, (0, 1, 2), tmp50, (3, 1, 2), (3, 0)) * 2
    tmp63 += einsum(r2.bab, (0, 1, 2), tmp51, (3, 0, 2), (3, 1)) * -1
    tmp63 += einsum(tmp30, (0, 1, 2), tmp27, (1, 3, 2), (0, 3)) * 2
    del tmp27
    tmp63 += einsum(tmp32, (0, 1, 2), tmp33, (3, 1, 2), (3, 0)) * -1
    tmp60 = np.copy(ints.tmp171)
    tmp60 += ints.tmp194
    tmp60 += np.transpose(ints.tmp196, (1, 0, 2, 3))
    tmp60 += ints.tmp230
    tmp60 += np.transpose(ints.tmp36, (1, 0, 2, 3))
    tmp67 = np.copy(f.bb.oo)
    tmp67 += ints.tmp158 * 2
    tmp67 += ints.tmp161
    tmp67 += ints.tmp183
    tmp67 += ints.tmp187
    tmp67 += np.transpose(ints.tmp21, (1, 0))
    tmp67 += ints.tmp221
    tmp67 += ints.tmp225
    tmp67 += ints.tmp181 * -1
    tmp67 += ints.tmp219 * -1
    tmp61 = np.copy(ints.tmp25)
    tmp61 += np.transpose(ints.tmp54, (1, 0, 2, 3))
    tmp59 = np.copy(ints.tmp491)
    del ints.tmp491
    tmp59 += np.transpose(ints.tmp492, (1, 0, 2, 3))
    del ints.tmp492
    tmp59 += np.transpose(ints.tmp493, (1, 0, 2, 3)) * -1
    del ints.tmp493
    tmp54 = np.copy(f.aa.oo)
    tmp54 += ints.tmp175
    del ints.tmp175
    tmp54 += ints.tmp176
    del ints.tmp176
    tmp54 += np.transpose(ints.tmp1, (1, 0))
    del ints.tmp1
    tmp54 += ints.tmp30
    del ints.tmp30
    tmp54 += ints.tmp32
    del ints.tmp32
    tmp54 += ints.tmp57 * 2
    del ints.tmp57
    tmp54 += ints.tmp60
    del ints.tmp60
    tmp54 += ints.tmp174 * -1
    del ints.tmp174
    tmp54 += ints.tmp28 * -1
    del ints.tmp28
    tmp48 = np.copy(ints.tmp23)
    tmp48 += np.transpose(ints.tmp50, (0, 2, 1, 3))
    tmp43 = np.copy(np.transpose(ints.tmp415, (1, 0)))
    del ints.tmp415
    tmp43 += ints.tmp418 * 2
    del ints.tmp418
    tmp43 += ints.tmp420
    del ints.tmp420
    tmp43 += f.aa.vv * -1
    tmp43 += ints.tmp198 * -1
    del ints.tmp198
    tmp43 += ints.tmp208 * -1
    del ints.tmp208
    tmp43 += tmp42
    del tmp42
    tmp46 = np.copy(ints.tmp171)
    del ints.tmp171
    tmp46 += np.transpose(ints.tmp194, (0, 1, 3, 2))
    del ints.tmp194
    tmp46 += np.transpose(ints.tmp196, (1, 0, 2, 3))
    del ints.tmp196
    tmp46 += ints.tmp230
    del ints.tmp230
    tmp46 += np.transpose(ints.tmp36, (0, 1, 3, 2))
    del ints.tmp36
    tmp49 = np.copy(ints.tmp142)
    tmp49 += np.transpose(ints.tmp67, (0, 2, 1, 3))
    tmp7 = np.copy(f.bb.oo)
    tmp7 += ints.tmp158 * 2
    del ints.tmp158
    tmp7 += ints.tmp161
    del ints.tmp161
    tmp7 += np.transpose(ints.tmp183, (1, 0))
    del ints.tmp183
    tmp7 += np.transpose(ints.tmp187, (1, 0))
    del ints.tmp187
    tmp7 += np.transpose(ints.tmp21, (1, 0))
    del ints.tmp21
    tmp7 += ints.tmp221
    del ints.tmp221
    tmp7 += ints.tmp225
    del ints.tmp225
    tmp7 += ints.tmp181 * -1
    del ints.tmp181
    tmp7 += ints.tmp219 * -1
    del ints.tmp219
    tmp45 = np.copy(ints.tmp461)
    del ints.tmp461
    tmp45 += np.transpose(ints.tmp462, (1, 0, 2, 3))
    del ints.tmp462
    tmp45 += np.transpose(ints.tmp463, (1, 0, 2, 3)) * -1
    del ints.tmp463
    tmp57 = np.copy(tmp55) * -1
    del tmp55
    tmp57 += tmp56 * 2
    del tmp56
    tmp44 = np.copy(ints.tmp358)
    del ints.tmp358
    tmp44 += ints.tmp369
    del ints.tmp369
    tmp44 += ints.tmp375 * 2
    del ints.tmp375
    tmp53 = einsum(tmp50, (0, 1, 2), r2.aba, (1, 3, 2), (0, 3)) * -1
    del tmp50
    tmp53 += einsum(tmp51, (0, 1, 2), r2.bbb, (3, 1, 2), (0, 3)) * 2
    del tmp51
    tmp53 += einsum(tmp30, (0, 1, 2), tmp47, (1, 2, 3), (0, 3))
    del tmp30
    tmp53 += einsum(tmp52, (0, 1, 2), tmp33, (3, 0, 2), (3, 1)) * 2
    del tmp52, tmp33
    tmp40 = np.copy(ints.tmp167)
    del ints.tmp167
    tmp40 += ints.tmp227
    del ints.tmp227
    tmp40 += np.transpose(ints.tmp33, (2, 3, 0, 1)) * -1
    del ints.tmp33
    tmp22 = np.copy(tmp8)
    del tmp8
    tmp22 += tmp9
    del tmp9
    tmp22 += tmp11
    del tmp11
    tmp22 += np.transpose(tmp13, (1, 0, 2)) * -2
    del tmp13
    tmp22 += np.transpose(tmp19, (1, 0, 2))
    del tmp19
    tmp22 += np.transpose(tmp21, (1, 0, 2)) * -2
    del tmp21
    tmp39 = np.copy(tmp23)
    del tmp23
    tmp39 += tmp24 * 2
    del tmp24
    tmp39 += tmp26 * -2
    del tmp26
    tmp39 += np.transpose(tmp29, (1, 0, 2)) * -1
    del tmp29
    tmp39 += np.transpose(tmp36, (1, 0, 2))
    del tmp36
    tmp39 += np.transpose(tmp38, (1, 0, 2))
    del tmp38
    tmp5 = np.copy(ints.tmp142)
    del ints.tmp142
    tmp5 += np.transpose(ints.tmp239, (0, 2, 1, 3))
    del ints.tmp239
    tmp5 += np.transpose(ints.tmp257, (0, 2, 1, 3))
    del ints.tmp257
    tmp5 += ints.tmp267
    del ints.tmp267
    tmp5 += ints.tmp271 * 2
    del ints.tmp271
    tmp5 += ints.tmp283
    del ints.tmp283
    tmp5 += ints.tmp298
    del ints.tmp298
    tmp5 += ints.tmp302
    del ints.tmp302
    tmp5 += ints.tmp310
    del ints.tmp310
    tmp5 += ints.tmp316 * 2
    del ints.tmp316
    tmp5 += ints.tmp346
    del ints.tmp346
    tmp5 += np.transpose(ints.tmp67, (0, 2, 1, 3))
    del ints.tmp67
    tmp5 += np.transpose(ints.tmp249, (0, 2, 1, 3)) * -1
    del ints.tmp249
    tmp5 += ints.tmp264 * -1
    del ints.tmp264
    tmp5 += ints.tmp270 * -1
    del ints.tmp270
    tmp5 += ints.tmp294 * -1
    del ints.tmp294
    tmp5 += ints.tmp313 * -1
    del ints.tmp313
    tmp5 += ints.tmp320 * -1
    del ints.tmp320
    tmp5 += ints.tmp329 * -1
    del ints.tmp329
    tmp5 += ints.tmp339 * -1
    del ints.tmp339
    tmp5 += np.transpose(ints.tmp340, (0, 2, 1, 3)) * -1
    del ints.tmp340
    tmp5 += ints.tmp354 * -1
    del ints.tmp354
    tmp2 = np.copy(ints.tmp102) * 0.5
    del ints.tmp102
    tmp2 += ints.tmp110
    del ints.tmp110
    tmp2 += ints.tmp138
    del ints.tmp138
    tmp2 += ints.tmp143 * 0.5
    del ints.tmp143
    tmp2 += ints.tmp159
    del ints.tmp159
    tmp2 += ints.tmp162 * 0.5
    del ints.tmp162
    tmp2 += ints.tmp184 * 0.5
    del ints.tmp184
    tmp2 += ints.tmp188 * 0.5
    del ints.tmp188
    tmp2 += ints.tmp205 * 0.5
    del ints.tmp205
    tmp2 += ints.tmp222 * 0.5
    del ints.tmp222
    tmp2 += ints.tmp226 * 0.5
    del ints.tmp226
    tmp2 += ints.tmp22 * 0.5
    del ints.tmp22
    tmp2 += ints.tmp46 * 0.5
    del ints.tmp46
    tmp2 += ints.tmp4 * 0.5
    del ints.tmp4
    tmp2 += ints.tmp65
    del ints.tmp65
    tmp2 += ints.tmp68 * 0.5
    del ints.tmp68
    tmp2 += ints.tmp87
    del ints.tmp87
    tmp2 += f.bb.ov * -0.5
    tmp2 += ints.tmp105 * -0.5
    del ints.tmp105
    tmp2 += ints.tmp10 * -0.5
    del ints.tmp10
    tmp2 += ints.tmp114 * -1
    del ints.tmp114
    tmp2 += ints.tmp118 * -0.5
    del ints.tmp118
    tmp2 += ints.tmp121 * -1
    del ints.tmp121
    tmp2 += ints.tmp13 * -1
    del ints.tmp13
    tmp2 += ints.tmp182 * -0.5
    del ints.tmp182
    tmp2 += ints.tmp204 * -0.5
    del ints.tmp204
    tmp2 += ints.tmp207 * -0.5
    del ints.tmp207
    tmp2 += ints.tmp220 * -0.5
    del ints.tmp220
    tmp2 += ints.tmp44 * -0.5
    del ints.tmp44
    tmp2 += ints.tmp47 * -0.5
    del ints.tmp47
    tmp2 += ints.tmp7 * -0.5
    del ints.tmp7
    tmp2 += ints.tmp89 * -0.5
    del ints.tmp89
    tmp6 = np.copy(np.transpose(ints.tmp241, (1, 2, 0, 3)))
    del ints.tmp241
    tmp6 += np.transpose(ints.tmp247, (0, 2, 1, 3))
    del ints.tmp247
    tmp6 += np.transpose(ints.tmp255, (0, 2, 1, 3))
    del ints.tmp255
    tmp6 += ints.tmp268 * 2
    del ints.tmp268
    tmp6 += ints.tmp273
    del ints.tmp273
    tmp6 += ints.tmp300
    del ints.tmp300
    tmp6 += ints.tmp304
    del ints.tmp304
    tmp6 += ints.tmp314 * 2
    del ints.tmp314
    tmp6 += ints.tmp327
    del ints.tmp327
    tmp6 += ints.tmp335
    del ints.tmp335
    tmp6 += ints.tmp352
    del ints.tmp352
    tmp6 += ints.tmp137 * -1
    del ints.tmp137
    tmp6 += ints.tmp265 * -2
    del ints.tmp265
    tmp6 += ints.tmp280 * -1
    del ints.tmp280
    tmp6 += ints.tmp296 * -1
    del ints.tmp296
    tmp6 += ints.tmp311 * -2
    del ints.tmp311
    tmp6 += ints.tmp318 * -1
    del ints.tmp318
    tmp6 += np.transpose(ints.tmp337, (0, 2, 1, 3)) * -1
    del ints.tmp337
    tmp6 += ints.tmp344 * -1
    del ints.tmp344
    tmp6 += np.transpose(ints.tmp64, (1, 2, 0, 3)) * -1
    del ints.tmp64
    tmp3 = np.copy(ints.tmp100)
    del ints.tmp100
    tmp3 += ints.tmp108 * 0.5
    del ints.tmp108
    tmp3 += ints.tmp135
    del ints.tmp135
    tmp3 += ints.tmp140 * 0.5
    del ints.tmp140
    tmp3 += ints.tmp156
    del ints.tmp156
    tmp3 += ints.tmp164 * 0.5
    del ints.tmp164
    tmp3 += ints.tmp179 * 0.5
    del ints.tmp179
    tmp3 += ints.tmp185 * 0.5
    del ints.tmp185
    tmp3 += ints.tmp19 * 0.5
    del ints.tmp19
    tmp3 += ints.tmp201 * 0.5
    del ints.tmp201
    tmp3 += ints.tmp217 * 0.5
    del ints.tmp217
    tmp3 += ints.tmp223 * 0.5
    del ints.tmp223
    tmp3 += ints.tmp2 * 0.5
    del ints.tmp2
    tmp3 += ints.tmp42 * 0.5
    del ints.tmp42
    tmp3 += ints.tmp62
    del ints.tmp62
    tmp3 += ints.tmp70 * 0.5
    del ints.tmp70
    tmp3 += ints.tmp85
    del ints.tmp85
    tmp3 += f.aa.ov * -0.5
    tmp3 += ints.tmp103 * -1
    del ints.tmp103
    tmp3 += ints.tmp112 * -0.5
    del ints.tmp112
    tmp3 += ints.tmp116 * -1
    del ints.tmp116
    tmp3 += ints.tmp119 * -0.5
    del ints.tmp119
    tmp3 += ints.tmp11 * -0.5
    del ints.tmp11
    tmp3 += ints.tmp177 * -0.5
    del ints.tmp177
    tmp3 += ints.tmp199 * -0.5
    del ints.tmp199
    tmp3 += ints.tmp209 * -0.5
    del ints.tmp209
    tmp3 += ints.tmp215 * -0.5
    del ints.tmp215
    tmp3 += ints.tmp39 * -0.5
    del ints.tmp39
    tmp3 += ints.tmp48 * -0.5
    del ints.tmp48
    tmp3 += ints.tmp5 * -0.5
    del ints.tmp5
    tmp3 += ints.tmp8 * -1
    del ints.tmp8
    tmp3 += ints.tmp91 * -0.5
    del ints.tmp91
    tmp0 = np.copy(ints.tmp129)
    del ints.tmp129
    tmp0 += ints.tmp133
    del ints.tmp133
    tmp0 += ints.tmp147
    del ints.tmp147
    tmp0 += ints.tmp153 * 2
    del ints.tmp153
    tmp0 += np.transpose(ints.tmp17, (1, 0, 2, 3))
    del ints.tmp17
    tmp0 += ints.tmp213
    del ints.tmp213
    tmp0 += np.transpose(ints.tmp25, (1, 0, 2, 3))
    del ints.tmp25
    tmp0 += ints.tmp54
    del ints.tmp54
    tmp0 += np.transpose(ints.tmp55, (1, 0, 2, 3))
    del ints.tmp55
    tmp0 += ints.tmp78
    del ints.tmp78
    tmp0 += ints.tmp83 * 2
    del ints.tmp83
    tmp0 += ints.tmp97
    del ints.tmp97
    tmp0 += ints.tmp125 * -1
    del ints.tmp125
    tmp0 += ints.tmp150 * -1
    del ints.tmp150
    tmp0 += ints.tmp155 * -1
    del ints.tmp155
    tmp0 += ints.tmp172 * -1
    del ints.tmp172
    tmp0 += ints.tmp195 * -1
    del ints.tmp195
    tmp0 += np.transpose(ints.tmp197, (1, 0, 2, 3)) * -1
    del ints.tmp197
    tmp0 += ints.tmp231 * -1
    del ints.tmp231
    tmp0 += ints.tmp37 * -1
    del ints.tmp37
    tmp0 += ints.tmp74 * -1
    del ints.tmp74
    tmp0 += ints.tmp79 * -1
    del ints.tmp79
    tmp1 = np.copy(ints.tmp127)
    del ints.tmp127
    tmp1 += ints.tmp131
    del ints.tmp131
    tmp1 += ints.tmp148 * 2
    del ints.tmp148
    tmp1 += np.transpose(ints.tmp15, (1, 2, 0, 3))
    del ints.tmp15
    tmp1 += ints.tmp168
    del ints.tmp168
    tmp1 += ints.tmp190
    del ints.tmp190
    tmp1 += ints.tmp228
    del ints.tmp228
    tmp1 += np.transpose(ints.tmp34, (0, 2, 1, 3))
    del ints.tmp34
    tmp1 += np.transpose(ints.tmp52, (0, 2, 1, 3))
    del ints.tmp52
    tmp1 += ints.tmp75 * 2
    del ints.tmp75
    tmp1 += ints.tmp80
    del ints.tmp80
    tmp1 += ints.tmp123 * -1
    del ints.tmp123
    tmp1 += ints.tmp145 * -2
    del ints.tmp145
    tmp1 += ints.tmp151 * -1
    del ints.tmp151
    tmp1 += np.transpose(ints.tmp192, (0, 2, 1, 3)) * -1
    del ints.tmp192
    tmp1 += ints.tmp211 * -1
    del ints.tmp211
    tmp1 += np.transpose(ints.tmp23, (1, 2, 0, 3)) * -1
    del ints.tmp23
    tmp1 += ints.tmp50 * -1
    del ints.tmp50
    tmp1 += ints.tmp72 * -2
    del ints.tmp72
    tmp1 += ints.tmp94 * -1
    del ints.tmp94
    r2new.bbb = np.copy(tmp83) * -1
    r2new.bbb += np.transpose(tmp83, (1, 0, 2))
    del tmp83
    r2new.bbb += tmp90
    r2new.bbb += np.transpose(tmp90, (1, 0, 2)) * -1
    del tmp90
    r2new.bbb += einsum(tmp91, (0, 1, 2, 3), r2.bbb, (2, 3, 4), (0, 1, 4)) * 2
    del tmp91
    r2new.bbb += einsum(tmp66, (0, 1), r2.bbb, (2, 3, 0), (2, 3, 1)) * -2
    r2new.bbb += einsum(r1.b, (0,), tmp64, (1, 2), (0, 1, 2))
    r2new.bbb += einsum(tmp64, (0, 1), r1.b, (2,), (0, 2, 1)) * -1
    r2new.bab = einsum(ints.tmp469, (0, 1, 2, 3), r2.aaa, (4, 0, 2), (1, 4, 3)) * 2
    del ints.tmp469
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp58, (0, 3, 2, 4), (3, 1, 4)) * -1
    del tmp58
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp59, (3, 1, 2, 4), (0, 3, 4)) * -1
    del tmp59
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp60, (1, 3, 0, 4), (4, 3, 2))
    del tmp60
    r2new.bab += einsum(tmp32, (0, 1, 2), tmp61, (3, 0, 2, 4), (1, 3, 4)) * -1
    del tmp61
    r2new.bab += einsum(tmp62, (0, 1, 2, 3), tmp32, (4, 0, 1), (2, 4, 3)) * -1
    del tmp32, tmp62
    r2new.bab += einsum(v.bbb.xov, (0, 1, 2), tmp63, (0, 3), (1, 3, 2)) * -1
    del tmp63
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp66, (2, 3), (0, 1, 3)) * -1
    del tmp66
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp4, (1, 3), (0, 3, 2)) * -1
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp67, (0, 3), (3, 1, 2)) * -1
    del tmp67
    r2new.bab += einsum(tmp68, (0,), ints.tmp170, (1, 2, 0, 3), (2, 1, 3))
    del tmp68
    r2new.bab += einsum(r1.a, (0,), tmp69, (1, 0, 2, 3), (2, 1, 3))
    del tmp69
    r2new.bab += einsum(tmp64, (0, 1), r1.a, (2,), (0, 2, 1)) * -1
    del tmp64
    r2new.aba = einsum(r2.bbb, (0, 1, 2), ints.tmp377, (3, 1, 4, 2), (3, 0, 4)) * 2
    del ints.tmp377
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp44, (0, 3, 2, 4), (3, 1, 4)) * -1
    del tmp44
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp45, (3, 1, 2, 4), (0, 3, 4)) * -1
    del tmp45
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp46, (0, 3, 1, 4), (3, 4, 2))
    del tmp46
    r2new.aba += einsum(tmp47, (0, 1, 2), tmp48, (0, 3, 1, 4), (3, 2, 4))
    del tmp48
    r2new.aba += einsum(tmp47, (0, 1, 2), tmp49, (1, 2, 3, 4), (0, 3, 4))
    del tmp47
    r2new.aba += einsum(tmp53, (0, 1), v.baa.xov, (0, 2, 3), (2, 1, 3)) * -1
    del tmp53
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp43, (2, 3), (0, 1, 3)) * -1
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp54, (0, 3), (3, 1, 2)) * -1
    del tmp54
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp7, (1, 3), (0, 3, 2)) * -1
    r2new.aba += einsum(ints.tmp170, (0, 1, 2, 3), tmp57, (3,), (0, 1, 2))
    del ints.tmp170, tmp57
    r2new.aba += einsum(r1.b, (0,), tmp49, (1, 0, 2, 3), (1, 2, 3))
    del tmp49
    r2new.aba += einsum(r1.b, (0,), tmp41, (1, 2), (1, 0, 2)) * -1
    r2new.aaa = np.copy(tmp22)
    r2new.aaa += np.transpose(tmp22, (1, 0, 2)) * -1
    del tmp22
    r2new.aaa += tmp39 * -1
    r2new.aaa += np.transpose(tmp39, (1, 0, 2))
    del tmp39
    r2new.aaa += einsum(tmp40, (0, 1, 2, 3), r2.aaa, (0, 1, 4), (2, 3, 4)) * 2
    del tmp40
    r2new.aaa += einsum(tmp43, (0, 1), r2.aaa, (2, 3, 0), (2, 3, 1)) * -2
    del tmp43
    r2new.aaa += einsum(r1.a, (0,), tmp41, (1, 2), (0, 1, 2))
    r2new.aaa += einsum(r1.a, (0,), tmp41, (1, 2), (1, 0, 2)) * -1
    del tmp41
    r1new.b = einsum(r2.aba, (0, 1, 2), tmp5, (0, 1, 3, 2), (3,))
    del tmp5
    r1new.b += einsum(r2.bbb, (0, 1, 2), tmp6, (0, 1, 3, 2), (3,)) * 2
    del tmp6
    r1new.b += einsum(tmp2, (0, 1), r2.bbb, (2, 0, 1), (2,)) * -4
    r1new.b += einsum(r2.aba, (0, 1, 2), tmp3, (0, 2), (1,)) * 2
    r1new.b += einsum(r1.b, (0,), tmp7, (0, 1), (1,)) * -1
    del tmp7
    r1new.a = einsum(r2.bab, (0, 1, 2), tmp0, (1, 3, 0, 2), (3,))
    del tmp0
    r1new.a += einsum(tmp1, (0, 1, 2, 3), r2.aaa, (1, 0, 3), (2,)) * -2
    del tmp1
    r1new.a += einsum(r2.bab, (0, 1, 2), tmp2, (0, 2), (1,)) * 2
    del tmp2
    r1new.a += einsum(r2.aaa, (0, 1, 2), tmp3, (1, 2), (0,)) * -4
    del tmp3
    r1new.a += einsum(r1.a, (0,), tmp4, (0, 1), (1,)) * -1
    del tmp4

    return {f"r1new": r1new, f"r2new": r2new}

def hbar_lmatvec_ea_intermediates(f=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:29:26.557922.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    tmp10 : array
    tmp100 : array
    tmp101 : array
    tmp102 : array
    tmp103 : array
    tmp105 : array
    tmp106 : array
    tmp108 : array
    tmp109 : array
    tmp11 : array
    tmp110 : array
    tmp111 : array
    tmp113 : array
    tmp115 : array
    tmp117 : array
    tmp119 : array
    tmp121 : array
    tmp122 : array
    tmp124 : array
    tmp13 : array
    tmp132 : array
    tmp133 : array
    tmp135 : array
    tmp136 : array
    tmp138 : array
    tmp139 : array
    tmp141 : array
    tmp142 : array
    tmp144 : array
    tmp146 : array
    tmp148 : array
    tmp149 : array
    tmp151 : array
    tmp152 : array
    tmp154 : array
    tmp155 : array
    tmp157 : array
    tmp158 : array
    tmp160 : array
    tmp162 : array
    tmp163 : array
    tmp165 : array
    tmp166 : array
    tmp168 : array
    tmp170 : array
    tmp171 : array
    tmp172 : array
    tmp174 : array
    tmp175 : array
    tmp177 : array
    tmp178 : array
    tmp179 : array
    tmp180 : array
    tmp181 : array
    tmp182 : array
    tmp184 : array
    tmp185 : array
    tmp19 : array
    tmp190 : array
    tmp192 : array
    tmp194 : array
    tmp195 : array
    tmp196 : array
    tmp197 : array
    tmp198 : array
    tmp199 : array
    tmp2 : array
    tmp20 : array
    tmp201 : array
    tmp203 : array
    tmp205 : array
    tmp206 : array
    tmp207 : array
    tmp208 : array
    tmp210 : array
    tmp211 : array
    tmp213 : array
    tmp214 : array
    tmp215 : array
    tmp216 : array
    tmp217 : array
    tmp218 : array
    tmp22 : array
    tmp220 : array
    tmp221 : array
    tmp23 : array
    tmp236 : array
    tmp239 : array
    tmp24 : array
    tmp243 : array
    tmp246 : array
    tmp250 : array
    tmp251 : array
    tmp253 : array
    tmp255 : array
    tmp257 : array
    tmp26 : array
    tmp263 : array
    tmp265 : array
    tmp271 : array
    tmp272 : array
    tmp274 : array
    tmp275 : array
    tmp277 : array
    tmp279 : array
    tmp281 : array
    tmp29 : array
    tmp30 : array
    tmp301 : array
    tmp303 : array
    tmp309 : array
    tmp31 : array
    tmp310 : array
    tmp312 : array
    tmp313 : array
    tmp315 : array
    tmp317 : array
    tmp319 : array
    tmp33 : array
    tmp330 : array
    tmp332 : array
    tmp334 : array
    tmp335 : array
    tmp34 : array
    tmp36 : array
    tmp38 : array
    tmp387 : array
    tmp39 : array
    tmp4 : array
    tmp40 : array
    tmp41 : array
    tmp42 : array
    tmp426 : array
    tmp44 : array
    tmp47 : array
    tmp49 : array
    tmp490 : array
    tmp5 : array
    tmp52 : array
    tmp53 : array
    tmp55 : array
    tmp57 : array
    tmp58 : array
    tmp60 : array
    tmp61 : array
    tmp63 : array
    tmp64 : array
    tmp66 : array
    tmp67 : array
    tmp69 : array
    tmp7 : array
    tmp70 : array
    tmp72 : array
    tmp73 : array
    tmp75 : array
    tmp77 : array
    tmp79 : array
    tmp8 : array
    tmp81 : array
    tmp82 : array
    tmp84 : array
    tmp85 : array
    tmp87 : array
    tmp89 : array
    tmp91 : array
    tmp92 : array
    tmp94 : array
    tmp95 : array
    tmp97 : array
    tmp99 : array
    """

    tmp28 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (1, 2), (0,))
    tmp32 = einsum(v.bbb.xov, (0, 1, 2), t1.bb, (1, 2), (0,))
    tmp109 = einsum(v.bbb.xov, (0, 1, 2), t1.bb, (3, 2), (0, 3, 1))
    tmp101 = einsum(v.baa.xov, (0, 1, 2), t1.aa, (3, 2), (0, 3, 1))
    tmp41 = einsum(tmp28, (0,), v.bbb.xov, (0, 1, 2), (1, 2))
    tmp42 = einsum(tmp32, (0,), v.baa.xov, (0, 1, 2), (1, 2))
    tmp38 = einsum(tmp32, (0,), v.bbb.xov, (0, 1, 2), (1, 2))
    tmp110 = einsum(v.bbb.xov, (0, 1, 2), tmp109, (0, 1, 3), (3, 2))
    tmp34 = einsum(tmp28, (0,), v.baa.xov, (0, 1, 2), (1, 2))
    tmp102 = einsum(tmp101, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp60 = einsum(t2.abab, (0, 1, 2, 3), v.bbb.xov, (4, 1, 3), (4, 0, 2))
    tmp84 = einsum(t2.abab, (0, 1, 2, 3), v.baa.xov, (4, 0, 2), (4, 1, 3))
    tmp81 = einsum(v.bbb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (0, 3, 4))
    tmp57 = einsum(v.baa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (0, 3, 4))
    tmp30 = einsum(t1.aa, (0, 1), v.baa.xvv, (2, 3, 1), (2, 0, 3))
    tmp39 = einsum(v.bbb.xvv, (0, 1, 2), t1.bb, (3, 2), (0, 3, 1))
    tmp49 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp243 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp138 = einsum(tmp101, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp135 = einsum(tmp109, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp26 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp236 = einsum(v.bbb.xov, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp72 = einsum(v.bbb.xov, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp66 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp220 = einsum(tmp41, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp217 = einsum(tmp42, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp215 = einsum(tmp38, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp213 = einsum(tmp110, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp210 = einsum(tmp34, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp207 = einsum(tmp102, (0, 1), t1.aa, (2, 1), (2, 0))
    tmp33 = einsum(tmp32, (0,), v.baa.xvv, (0, 1, 2), (1, 2))
    tmp197 = einsum(tmp28, (0,), v.bbb.xvv, (0, 1, 2), (1, 2))
    tmp194 = einsum(tmp32, (0,), v.bbb.xvv, (0, 1, 2), (1, 2))
    tmp29 = einsum(tmp28, (0,), v.baa.xvv, (0, 1, 2), (1, 2))
    tmp184 = einsum(tmp28, (0,), v.bbb.xoo, (0, 1, 2), (1, 2))
    tmp181 = einsum(tmp32, (0,), v.baa.xoo, (0, 1, 2), (1, 2))
    tmp179 = einsum(tmp32, (0,), v.bbb.xoo, (0, 1, 2), (1, 2))
    del tmp32
    tmp177 = einsum(v.bbb.xoo, (0, 1, 2), tmp109, (0, 2, 3), (1, 3))
    tmp174 = einsum(tmp28, (0,), v.baa.xoo, (0, 1, 2), (1, 2))
    del tmp28
    tmp171 = einsum(v.baa.xoo, (0, 1, 2), tmp101, (0, 2, 3), (1, 3))
    tmp44 = einsum(v.baa.xov, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp157 = einsum(tmp60, (0, 1, 2), v.baa.xov, (0, 3, 2), (1, 3))
    tmp154 = einsum(v.bbb.xov, (0, 1, 2), tmp84, (0, 3, 2), (3, 1))
    tmp151 = einsum(tmp81, (0, 1, 2), v.bbb.xov, (0, 3, 2), (1, 3))
    tmp148 = einsum(v.baa.xov, (0, 1, 2), tmp57, (0, 3, 2), (3, 1))
    tmp141 = einsum(tmp109, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp132 = einsum(v.baa.xov, (0, 1, 2), tmp101, (0, 3, 4), (3, 1, 4, 2))
    tmp99 = einsum(v.bbb.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 4, 1, 2))
    tmp24 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp69 = einsum(v.bbb.xoo, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 2, 4))
    tmp63 = einsum(v.baa.xoo, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 2, 3, 4))
    tmp22 = einsum(f.bb.ov, (0, 1), t1.bb, (2, 1), (0, 2))
    tmp19 = einsum(t1.aa, (0, 1), f.aa.ov, (2, 1), (2, 0))
    tmp490 = einsum(v.bbb.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (3, 1, 2, 4))
    tmp426 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp387 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xvv, (0, 3, 4), (3, 1, 2, 4))
    tmp335 = einsum(v.bbb.xov, (0, 1, 2), tmp30, (0, 3, 4), (3, 1, 4, 2))
    tmp334 = einsum(tmp101, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp332 = einsum(v.bbb.xov, (0, 1, 2), tmp39, (0, 3, 4), (3, 1, 2, 4))
    tmp330 = einsum(tmp109, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp319 = einsum(t2.abab, (0, 1, 2, 3), tmp49, (4, 1, 2, 5), (0, 4, 3, 5))
    tmp317 = einsum(v.bbb.xov, (0, 1, 2), tmp84, (0, 3, 4), (3, 1, 4, 2))
    tmp315 = einsum(v.bbb.xov, (0, 1, 2), tmp57, (0, 3, 4), (3, 1, 4, 2))
    tmp313 = einsum(t2.bbbb, (0, 1, 2, 3), tmp243, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp312 = einsum(t2.abab, (0, 1, 2, 3), tmp243, (1, 4, 5, 3), (0, 4, 2, 5))
    tmp310 = einsum(tmp81, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp309 = einsum(tmp60, (0, 1, 2), v.bbb.xov, (0, 3, 4), (1, 3, 2, 4))
    tmp303 = einsum(tmp138, (0, 1, 2, 3), t2.abab, (1, 2, 4, 5), (0, 4, 5, 3))
    tmp301 = einsum(t2.bbbb, (0, 1, 2, 3), tmp135, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp281 = einsum(t2.abab, (0, 1, 2, 3), tmp26, (1, 4, 2, 5), (0, 4, 3, 5))
    tmp279 = einsum(v.bbb.xvv, (0, 1, 2), tmp84, (0, 3, 4), (3, 4, 1, 2))
    tmp277 = einsum(v.bbb.xvv, (0, 1, 2), tmp57, (0, 3, 4), (3, 4, 1, 2))
    tmp275 = einsum(tmp236, (0, 1, 2, 3), t2.bbbb, (4, 0, 5, 1), (4, 5, 3, 2))
    tmp274 = einsum(t2.abab, (0, 1, 2, 3), tmp236, (1, 4, 3, 5), (0, 2, 5, 4))
    tmp272 = einsum(tmp81, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp271 = einsum(tmp60, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp265 = einsum(t2.abab, (0, 1, 2, 3), tmp72, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp263 = einsum(t2.bbbb, (0, 1, 2, 3), tmp66, (0, 4, 1, 5), (4, 2, 3, 5))
    tmp257 = einsum(v.bbb.xov, (0, 1, 2), tmp84, (0, 1, 3), (3, 2))
    tmp255 = einsum(tmp81, (0, 1, 2), v.bbb.xov, (0, 1, 3), (2, 3))
    tmp253 = einsum(tmp30, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp251 = einsum(tmp39, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp250 = einsum(v.baa.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp246 = einsum(v.bbb.xoo, (0, 1, 2), v.bbb.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp239 = einsum(tmp39, (0, 1, 2), v.bbb.xov, (0, 1, 3), (3, 2))
    tmp221 = einsum(t1.bb, (0, 1), tmp220, (2, 0), (2, 1))
    tmp218 = einsum(t1.aa, (0, 1), tmp217, (2, 0), (2, 1))
    tmp216 = einsum(tmp215, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp214 = einsum(tmp213, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp211 = einsum(t1.aa, (0, 1), tmp210, (2, 0), (2, 1))
    tmp208 = einsum(t1.aa, (0, 1), tmp207, (2, 0), (2, 1))
    tmp206 = einsum(tmp39, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp205 = einsum(v.baa.xvv, (0, 1, 2), tmp109, (0, 3, 4), (3, 4, 1, 2))
    tmp203 = einsum(tmp30, (0, 1, 2), v.baa.xov, (0, 3, 4), (1, 3, 4, 2))
    tmp201 = einsum(tmp101, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp199 = einsum(t1.aa, (0, 1), tmp33, (2, 1), (0, 2))
    tmp198 = einsum(tmp197, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp196 = einsum(tmp39, (0, 1, 2), tmp109, (0, 3, 1), (3, 2))
    tmp195 = einsum(tmp194, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp192 = einsum(tmp101, (0, 1, 2), tmp30, (0, 2, 3), (1, 3))
    tmp190 = einsum(t1.aa, (0, 1), tmp29, (2, 1), (0, 2))
    tmp185 = einsum(tmp184, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp182 = einsum(t1.aa, (0, 1), tmp181, (2, 0), (2, 1))
    tmp180 = einsum(t1.bb, (0, 1), tmp179, (2, 0), (2, 1))
    tmp178 = einsum(tmp177, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp175 = einsum(t1.aa, (0, 1), tmp174, (2, 0), (2, 1))
    tmp172 = einsum(t1.aa, (0, 1), tmp171, (2, 0), (2, 1))
    tmp170 = einsum(t2.abab, (0, 1, 2, 3), tmp49, (0, 4, 5, 3), (1, 4, 2, 5))
    tmp168 = einsum(tmp81, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp166 = einsum(v.baa.xov, (0, 1, 2), tmp60, (0, 3, 4), (3, 1, 4, 2))
    tmp165 = einsum(tmp44, (0, 1, 2, 3), t2.abab, (0, 4, 3, 5), (1, 4, 2, 5))
    tmp163 = einsum(tmp44, (0, 1, 2, 3), t2.aaaa, (4, 0, 5, 3), (4, 1, 5, 2))
    tmp162 = einsum(tmp84, (0, 1, 2), v.baa.xov, (0, 3, 4), (3, 1, 4, 2))
    tmp160 = einsum(v.baa.xov, (0, 1, 2), tmp57, (0, 3, 4), (3, 1, 4, 2))
    tmp158 = einsum(t1.aa, (0, 1), tmp157, (2, 0), (2, 1))
    tmp155 = einsum(tmp154, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp152 = einsum(tmp151, (0, 1), t1.bb, (1, 2), (0, 2))
    tmp149 = einsum(t1.aa, (0, 1), tmp148, (2, 0), (2, 1))
    tmp146 = einsum(t2.abab, (0, 1, 2, 3), tmp141, (0, 4, 1, 5), (4, 2, 5, 3))
    tmp144 = einsum(t2.aaaa, (0, 1, 2, 3), tmp132, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp142 = einsum(t2.abab, (0, 1, 2, 3), tmp141, (0, 4, 1, 2), (4, 3))
    tmp139 = einsum(t2.abab, (0, 1, 2, 3), tmp138, (4, 0, 1, 3), (4, 2))
    tmp136 = einsum(tmp135, (0, 1, 2, 3), t2.bbbb, (2, 1, 4, 3), (0, 4))
    tmp133 = einsum(t2.aaaa, (0, 1, 2, 3), tmp132, (4, 1, 0, 3), (4, 2))
    tmp124 = einsum(tmp41, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp122 = einsum(t2.abab, (0, 1, 2, 3), tmp41, (1, 3), (0, 2))
    tmp121 = einsum(t2.abab, (0, 1, 2, 3), tmp42, (0, 2), (1, 3))
    tmp119 = einsum(tmp42, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp117 = einsum(tmp38, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp115 = einsum(tmp38, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    tmp113 = einsum(tmp110, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3))
    tmp111 = einsum(t2.abab, (0, 1, 2, 3), tmp110, (1, 3), (0, 2))
    tmp108 = einsum(t2.abab, (0, 1, 2, 3), tmp34, (0, 2), (1, 3))
    tmp106 = einsum(tmp34, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp105 = einsum(t2.abab, (0, 1, 2, 3), tmp102, (0, 2), (1, 3))
    tmp103 = einsum(tmp102, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp100 = einsum(t2.abab, (0, 1, 2, 3), tmp99, (0, 4, 3, 5), (1, 2, 4, 5))
    tmp97 = einsum(tmp81, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp95 = einsum(tmp60, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 2, 3, 4))
    tmp94 = einsum(t2.abab, (0, 1, 2, 3), tmp24, (0, 4, 2, 5), (1, 5, 4, 3))
    tmp92 = einsum(t2.aaaa, (0, 1, 2, 3), tmp24, (1, 3, 4, 5), (0, 2, 5, 4))
    tmp91 = einsum(v.baa.xvv, (0, 1, 2), tmp84, (0, 3, 4), (3, 1, 2, 4))
    tmp89 = einsum(v.baa.xvv, (0, 1, 2), tmp57, (0, 3, 4), (3, 4, 1, 2))
    tmp87 = einsum(v.baa.xvv, (0, 1, 2), tmp60, (0, 3, 2), (3, 1))
    tmp85 = einsum(v.bbb.xvv, (0, 1, 2), tmp84, (0, 3, 2), (3, 1))
    tmp82 = einsum(tmp81, (0, 1, 2), v.bbb.xvv, (0, 3, 2), (1, 3)) * -1
    tmp79 = einsum(v.baa.xvv, (0, 1, 2), tmp57, (0, 3, 2), (3, 1)) * -1
    tmp77 = einsum(t2.abab, (0, 1, 2, 3), tmp69, (0, 1, 4, 5), (4, 2, 5, 3))
    tmp75 = einsum(t2.aaaa, (0, 1, 2, 3), tmp63, (4, 0, 1, 5), (4, 2, 3, 5))
    tmp73 = einsum(t2.abab, (0, 1, 2, 3), tmp72, (4, 0, 1, 3), (4, 2))
    tmp70 = einsum(t2.abab, (0, 1, 2, 3), tmp69, (0, 1, 4, 2), (4, 3))
    tmp67 = einsum(tmp66, (0, 1, 2, 3), t2.bbbb, (0, 2, 4, 3), (1, 4))
    tmp64 = einsum(tmp63, (0, 1, 2, 3), t2.aaaa, (1, 2, 4, 3), (0, 4))
    tmp61 = einsum(tmp60, (0, 1, 2), v.baa.xov, (0, 1, 3), (2, 3))
    tmp58 = einsum(v.baa.xov, (0, 1, 2), tmp57, (0, 1, 3), (3, 2))
    tmp55 = einsum(tmp39, (0, 1, 2), v.baa.xvv, (0, 3, 4), (1, 3, 4, 2))
    tmp53 = einsum(v.baa.xvv, (0, 1, 2), tmp30, (0, 3, 4), (3, 1, 2, 4))
    tmp52 = einsum(v.baa.xvv, (0, 1, 2), v.bbb.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp47 = einsum(v.baa.xvv, (0, 1, 2), v.baa.xoo, (0, 3, 4), (3, 4, 1, 2))
    tmp40 = einsum(tmp39, (0, 1, 2), v.bbb.xoo, (0, 3, 1), (3, 2))
    tmp36 = einsum(tmp30, (0, 1, 2), v.baa.xoo, (0, 3, 1), (3, 2))
    tmp31 = einsum(tmp30, (0, 1, 2), v.baa.xov, (0, 1, 3), (3, 2))
    tmp23 = einsum(tmp22, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp20 = einsum(tmp19, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp13 = einsum(t2.bbbb, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp11 = einsum(t2.abab, (0, 1, 2, 3), f.bb.ov, (1, 3), (0, 2))
    tmp10 = einsum(t2.abab, (0, 1, 2, 3), f.aa.ov, (0, 2), (1, 3))
    tmp8 = einsum(f.aa.ov, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3))
    tmp7 = einsum(f.bb.vv, (0, 1), t1.bb, (2, 1), (2, 0))
    tmp5 = einsum(t1.aa, (0, 1), f.aa.vv, (2, 1), (0, 2))
    tmp4 = einsum(t1.bb, (0, 1), f.bb.oo, (2, 0), (2, 1))
    tmp2 = einsum(f.aa.oo, (0, 1), t1.aa, (1, 2), (0, 2))

    return {f"tmp10": tmp10, f"tmp100": tmp100, f"tmp101": tmp101, f"tmp102": tmp102, f"tmp103": tmp103, f"tmp105": tmp105, f"tmp106": tmp106, f"tmp108": tmp108, f"tmp109": tmp109, f"tmp11": tmp11, f"tmp110": tmp110, f"tmp111": tmp111, f"tmp113": tmp113, f"tmp115": tmp115, f"tmp117": tmp117, f"tmp119": tmp119, f"tmp121": tmp121, f"tmp122": tmp122, f"tmp124": tmp124, f"tmp13": tmp13, f"tmp132": tmp132, f"tmp133": tmp133, f"tmp135": tmp135, f"tmp136": tmp136, f"tmp138": tmp138, f"tmp139": tmp139, f"tmp141": tmp141, f"tmp142": tmp142, f"tmp144": tmp144, f"tmp146": tmp146, f"tmp148": tmp148, f"tmp149": tmp149, f"tmp151": tmp151, f"tmp152": tmp152, f"tmp154": tmp154, f"tmp155": tmp155, f"tmp157": tmp157, f"tmp158": tmp158, f"tmp160": tmp160, f"tmp162": tmp162, f"tmp163": tmp163, f"tmp165": tmp165, f"tmp166": tmp166, f"tmp168": tmp168, f"tmp170": tmp170, f"tmp171": tmp171, f"tmp172": tmp172, f"tmp174": tmp174, f"tmp175": tmp175, f"tmp177": tmp177, f"tmp178": tmp178, f"tmp179": tmp179, f"tmp180": tmp180, f"tmp181": tmp181, f"tmp182": tmp182, f"tmp184": tmp184, f"tmp185": tmp185, f"tmp19": tmp19, f"tmp190": tmp190, f"tmp192": tmp192, f"tmp194": tmp194, f"tmp195": tmp195, f"tmp196": tmp196, f"tmp197": tmp197, f"tmp198": tmp198, f"tmp199": tmp199, f"tmp2": tmp2, f"tmp20": tmp20, f"tmp201": tmp201, f"tmp203": tmp203, f"tmp205": tmp205, f"tmp206": tmp206, f"tmp207": tmp207, f"tmp208": tmp208, f"tmp210": tmp210, f"tmp211": tmp211, f"tmp213": tmp213, f"tmp214": tmp214, f"tmp215": tmp215, f"tmp216": tmp216, f"tmp217": tmp217, f"tmp218": tmp218, f"tmp22": tmp22, f"tmp220": tmp220, f"tmp221": tmp221, f"tmp23": tmp23, f"tmp236": tmp236, f"tmp239": tmp239, f"tmp24": tmp24, f"tmp243": tmp243, f"tmp246": tmp246, f"tmp250": tmp250, f"tmp251": tmp251, f"tmp253": tmp253, f"tmp255": tmp255, f"tmp257": tmp257, f"tmp26": tmp26, f"tmp263": tmp263, f"tmp265": tmp265, f"tmp271": tmp271, f"tmp272": tmp272, f"tmp274": tmp274, f"tmp275": tmp275, f"tmp277": tmp277, f"tmp279": tmp279, f"tmp281": tmp281, f"tmp29": tmp29, f"tmp30": tmp30, f"tmp301": tmp301, f"tmp303": tmp303, f"tmp309": tmp309, f"tmp31": tmp31, f"tmp310": tmp310, f"tmp312": tmp312, f"tmp313": tmp313, f"tmp315": tmp315, f"tmp317": tmp317, f"tmp319": tmp319, f"tmp33": tmp33, f"tmp330": tmp330, f"tmp332": tmp332, f"tmp334": tmp334, f"tmp335": tmp335, f"tmp34": tmp34, f"tmp36": tmp36, f"tmp38": tmp38, f"tmp387": tmp387, f"tmp39": tmp39, f"tmp4": tmp4, f"tmp40": tmp40, f"tmp41": tmp41, f"tmp42": tmp42, f"tmp426": tmp426, f"tmp44": tmp44, f"tmp47": tmp47, f"tmp49": tmp49, f"tmp490": tmp490, f"tmp5": tmp5, f"tmp52": tmp52, f"tmp53": tmp53, f"tmp55": tmp55, f"tmp57": tmp57, f"tmp58": tmp58, f"tmp60": tmp60, f"tmp61": tmp61, f"tmp63": tmp63, f"tmp64": tmp64, f"tmp66": tmp66, f"tmp67": tmp67, f"tmp69": tmp69, f"tmp7": tmp7, f"tmp70": tmp70, f"tmp72": tmp72, f"tmp73": tmp73, f"tmp75": tmp75, f"tmp77": tmp77, f"tmp79": tmp79, f"tmp8": tmp8, f"tmp81": tmp81, f"tmp82": tmp82, f"tmp84": tmp84, f"tmp85": tmp85, f"tmp87": tmp87, f"tmp89": tmp89, f"tmp91": tmp91, f"tmp92": tmp92, f"tmp94": tmp94, f"tmp95": tmp95, f"tmp97": tmp97, f"tmp99": tmp99}

def hbar_lmatvec_ea(f=None, r1=None, r2=None, t1=None, t2=None, v=None, **kwargs):
    """
    Code generated by `albert` 0.0.0 on 2024-09-29T16:29:26.733647.

    Parameters
    ----------
    f : Namespace of arrays
        Fock matrix.
    r1 : Namespace of arrays
        R1 amplitudes.
    r2 : Namespace of arrays
        R2 amplitudes.
    t1 : Namespace of arrays
        T1 amplitudes.
    t2 : Namespace of arrays
        T2 amplitudes.
    v : Namespace of arrays
        Electron repulsion integrals.

    Returns
    -------
    r1new : Namespace of arrays
        Updated R1 residuals.
    r2new : Namespace of arrays
        Updated R2 residuals.
    """

    ints = kwargs["ints"]
    r1new = Namespace()
    r2new = Namespace()
    tmp58 = np.copy(ints.tmp101)
    del ints.tmp101
    tmp58 += v.baa.xoo
    tmp75 = einsum(t1.aa, (0, 1), tmp58, (2, 3, 0), (2, 3, 1))
    tmp101 = np.copy(f.bb.ov)
    tmp101 += ints.tmp38
    tmp101 += ints.tmp41
    tmp60 = np.copy(ints.tmp109)
    del ints.tmp109
    tmp60 += v.bbb.xoo
    tmp22 = einsum(t1.bb, (0, 1), r2.bbb, (2, 1, 3), (3, 0, 2))
    tmp76 = np.copy(ints.tmp30)
    tmp76 += ints.tmp57 * 2
    tmp76 += ints.tmp60
    tmp76 += v.baa.xov
    tmp76 += tmp75 * -1
    del tmp75
    tmp46 = np.copy(ints.tmp39)
    tmp46 += ints.tmp84
    tmp46 += v.bbb.xov
    tmp46 += ints.tmp81 * 2
    tmp44 = np.copy(ints.tmp30)
    del ints.tmp30
    tmp44 += ints.tmp60
    del ints.tmp60
    tmp44 += v.baa.xov
    tmp44 += ints.tmp57 * 2
    del ints.tmp57
    tmp50 = np.copy(f.aa.ov)
    tmp50 += ints.tmp34
    tmp50 += ints.tmp42
    tmp2 = einsum(r2.aaa, (0, 1, 2), t1.aa, (3, 1), (2, 3, 0))
    tmp6 = einsum(r2.bab, (0, 1, 2), t1.bb, (3, 0), (2, 3, 1)) * -1
    tmp102 = einsum(tmp101, (0, 1), t1.bb, (0, 2), (1, 2))
    del tmp101
    tmp36 = einsum(r2.bbb, (0, 1, 2), t2.bbbb, (3, 2, 0, 1), (3,))
    tmp34 = einsum(r1.b, (0,), t1.bb, (1, 0), (1,))
    tmp110 = einsum(tmp60, (0, 1, 2), tmp22, (1, 2, 3), (0, 3))
    tmp109 = einsum(tmp76, (0, 1, 2), r2.aba, (2, 3, 1), (0, 3)) * 0.5
    tmp113 = einsum(ints.tmp110, (0, 1), t1.bb, (0, 2), (1, 2))
    tmp47 = einsum(r2.bab, (0, 1, 2), tmp46, (3, 2, 0), (3, 1)) * -1
    tmp45 = einsum(tmp44, (0, 1, 2), r2.aaa, (3, 2, 1), (0, 3)) * -1
    del tmp44
    tmp51 = einsum(tmp50, (0, 1), t1.aa, (0, 2), (2, 1))
    del tmp50
    tmp64 = einsum(ints.tmp102, (0, 1), t1.aa, (0, 2), (1, 2))
    tmp17 = einsum(t2.abab, (0, 1, 2, 3), r2.bab, (3, 2, 1), (0,)) * -1
    tmp15 = einsum(r1.a, (0,), t1.aa, (1, 0), (1,))
    tmp16 = einsum(t2.aaaa, (0, 1, 2, 3), r2.aaa, (2, 3, 1), (0,))
    tmp59 = einsum(tmp2, (0, 1, 2), tmp58, (3, 0, 1), (3, 2))
    del tmp58
    tmp61 = einsum(tmp6, (0, 1, 2), tmp60, (3, 0, 1), (3, 2)) * 0.5
    tmp99 = einsum(r2.bbb, (0, 1, 2), tmp46, (3, 2, 1), (3, 0)) * -1
    del tmp46
    tmp97 = np.copy(ints.tmp246)
    tmp97 += ints.tmp330
    tmp97 += ints.tmp313 * 2
    tmp103 = np.copy(ints.tmp239)
    tmp103 += tmp102
    del tmp102
    tmp35 = einsum(t2.abab, (0, 1, 2, 3), r2.aba, (2, 3, 0), (1,))
    tmp86 = np.copy(ints.tmp135)
    tmp86 += np.transpose(ints.tmp66, (0, 2, 1, 3))
    tmp116 = np.copy(tmp34) * 0.5
    tmp116 += tmp36
    tmp111 = np.copy(tmp109)
    del tmp109
    tmp111 += tmp110
    del tmp110
    tmp114 = np.copy(f.bb.vv) * 0.5
    tmp114 += ints.tmp194 * 0.5
    tmp114 += ints.tmp197 * 0.5
    tmp114 += ints.tmp255 * -1
    tmp114 += ints.tmp257 * -0.5
    tmp114 += np.transpose(tmp113, (1, 0)) * 0.5
    del tmp113
    tmp19 = np.copy(f.aa.ov)
    tmp19 += ints.tmp34
    tmp19 += ints.tmp42
    tmp19 += ints.tmp102 * -1
    del ints.tmp102
    tmp77 = einsum(tmp60, (0, 1, 2), t1.bb, (2, 3), (0, 1, 3))
    del tmp60
    tmp42 = np.copy(ints.tmp201)
    tmp42 += ints.tmp47
    tmp42 += ints.tmp163 * 2
    tmp48 = np.copy(tmp45) * -2
    del tmp45
    tmp48 += tmp47
    del tmp47
    tmp52 = np.copy(ints.tmp31)
    tmp52 += np.transpose(tmp51, (1, 0))
    del tmp51
    tmp65 = np.copy(f.aa.vv) * 0.5
    tmp65 += ints.tmp29 * 0.5
    tmp65 += ints.tmp33 * 0.5
    tmp65 += ints.tmp58 * -1
    tmp65 += ints.tmp61 * -0.5
    tmp65 += np.transpose(tmp64, (1, 0)) * 0.5
    del tmp64
    tmp67 = np.copy(tmp15) * 0.5
    tmp67 += tmp16
    tmp67 += tmp17 * 0.5
    tmp56 = np.copy(ints.tmp132)
    tmp56 += np.transpose(ints.tmp63, (0, 2, 1, 3))
    tmp62 = np.copy(tmp59)
    del tmp59
    tmp62 += tmp61
    del tmp61
    tmp100 = einsum(tmp99, (0, 1), v.bbb.xov, (0, 2, 3), (2, 1, 3)) * -1
    del tmp99
    tmp98 = einsum(r2.bbb, (0, 1, 2), tmp97, (2, 3, 1, 4), (3, 4, 0)) * -1
    del tmp97
    tmp95 = einsum(r1.b, (0,), ints.tmp236, (1, 2, 0, 3), (1, 2, 3))
    tmp104 = einsum(r2.bbb, (0, 1, 2), tmp103, (3, 1), (2, 3, 0)) * -1
    del tmp103
    tmp96 = einsum(tmp35, (0,), ints.tmp243, (0, 1, 2, 3), (1, 2, 3))
    tmp106 = einsum(r2.aba, (0, 1, 2), ints.tmp312, (2, 3, 0, 4), (3, 4, 1))
    tmp108 = einsum(tmp22, (0, 1, 2), tmp86, (0, 1, 3, 4), (3, 4, 2)) * 2
    tmp107 = einsum(ints.tmp236, (0, 1, 2, 3), tmp22, (4, 0, 2), (4, 1, 3))
    tmp117 = einsum(tmp116, (0,), ints.tmp243, (0, 1, 2, 3), (1, 2, 3)) * 2
    del tmp116
    tmp112 = einsum(v.bbb.xov, (0, 1, 2), tmp111, (0, 3), (1, 3, 2)) * 2
    del tmp111
    tmp115 = einsum(tmp114, (0, 1), r2.bbb, (2, 0, 3), (3, 1, 2)) * -4
    del tmp114
    tmp84 = np.copy(ints.tmp141)
    tmp84 += ints.tmp69
    tmp80 = einsum(tmp19, (0, 1), t1.aa, (0, 2), (2, 1))
    tmp88 = np.copy(t2.abab)
    tmp88 += einsum(t1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    tmp78 = np.copy(ints.tmp39)
    del ints.tmp39
    tmp78 += ints.tmp81 * 2
    del ints.tmp81
    tmp78 += ints.tmp84
    del ints.tmp84
    tmp78 += v.bbb.xov
    tmp78 += tmp77 * -1
    del tmp77
    tmp38 = np.copy(f.bb.ov)
    tmp38 += ints.tmp38
    tmp38 += ints.tmp41
    tmp38 += ints.tmp110 * -1
    del ints.tmp110
    tmp30 = np.copy(ints.tmp138)
    del ints.tmp138
    tmp30 += ints.tmp72
    del ints.tmp72
    tmp73 = np.copy(t2.abab)
    tmp73 += einsum(t1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    tmp43 = einsum(r2.aaa, (0, 1, 2), tmp42, (2, 3, 1, 4), (3, 0, 4)) * -1
    del tmp42
    tmp41 = einsum(ints.tmp165, (0, 1, 2, 3), r2.bab, (3, 4, 1), (0, 2, 4)) * -1
    tmp40 = einsum(ints.tmp24, (0, 1, 2, 3), r1.a, (2,), (0, 1, 3))
    tmp49 = einsum(tmp48, (0, 1), v.baa.xov, (0, 2, 3), (2, 3, 1))
    del tmp48
    tmp53 = einsum(tmp52, (0, 1), r2.aaa, (2, 1, 3), (3, 2, 0)) * -1
    del tmp52
    tmp66 = einsum(r2.aaa, (0, 1, 2), tmp65, (1, 3), (2, 0, 3)) * -4
    del tmp65
    tmp68 = einsum(ints.tmp44, (0, 1, 2, 3), tmp67, (0,), (1, 2, 3)) * 2
    tmp57 = einsum(tmp56, (0, 1, 2, 3), tmp2, (0, 1, 4), (2, 4, 3)) * 2
    tmp63 = einsum(v.baa.xov, (0, 1, 2), tmp62, (0, 3), (1, 2, 3)) * 2
    del tmp62
    tmp55 = einsum(ints.tmp24, (0, 1, 2, 3), tmp2, (4, 0, 2), (4, 1, 3))
    tmp26 = einsum(t1.aa, (0, 1), r2.aba, (1, 2, 3), (3, 0, 2))
    tmp31 = einsum(t1.bb, (0, 1), tmp22, (2, 3, 1), (2, 3, 0)) * -1
    tmp105 = np.copy(tmp95)
    del tmp95
    tmp105 += tmp96
    del tmp96
    tmp105 += tmp98 * -2
    del tmp98
    tmp105 += tmp100 * 2
    del tmp100
    tmp105 += tmp104 * -2
    del tmp104
    tmp94 = einsum(r2.bbb, (0, 1, 2), t2.bbbb, (3, 4, 0, 1), (2, 3, 4))
    tmp93 = np.copy(f.bb.oo)
    tmp93 += ints.tmp151 * 2
    del ints.tmp151
    tmp93 += ints.tmp154
    del ints.tmp154
    tmp93 += ints.tmp179
    del ints.tmp179
    tmp93 += ints.tmp184
    del ints.tmp184
    tmp93 += ints.tmp215
    del ints.tmp215
    tmp93 += ints.tmp220
    del ints.tmp220
    tmp93 += np.transpose(ints.tmp22, (1, 0))
    del ints.tmp22
    tmp93 += ints.tmp177 * -1
    del ints.tmp177
    tmp93 += ints.tmp213 * -1
    del ints.tmp213
    tmp118 = np.copy(tmp106)
    del tmp106
    tmp118 += tmp107 * 2
    del tmp107
    tmp118 += tmp108
    del tmp108
    tmp118 += tmp112
    del tmp112
    tmp118 += tmp115 * -1
    del tmp115
    tmp118 += tmp117
    del tmp117
    tmp4 = einsum(r2.bab, (0, 1, 2), t1.aa, (3, 1), (3, 2, 0)) * -1
    tmp85 = np.copy(ints.tmp170)
    tmp85 += np.transpose(ints.tmp205, (0, 1, 3, 2)) * -1
    tmp85 += np.transpose(ints.tmp52, (0, 1, 3, 2)) * -1
    tmp85 += einsum(tmp84, (0, 1, 2, 3), t1.aa, (0, 4), (1, 2, 4, 3))
    del tmp84
    tmp91 = np.copy(np.transpose(ints.tmp31, (1, 0)))
    tmp91 += ints.tmp58 * 2
    tmp91 += ints.tmp61
    tmp91 += f.aa.vv * -1
    tmp91 += np.transpose(ints.tmp29, (1, 0)) * -1
    tmp91 += np.transpose(ints.tmp33, (1, 0)) * -1
    tmp91 += tmp80
    tmp89 = einsum(r2.bab, (0, 1, 2), tmp88, (3, 4, 1, 0), (3, 2, 4)) * -1
    del tmp88
    tmp90 = einsum(r2.aaa, (0, 1, 2), tmp76, (3, 2, 1), (3, 0)) * 2
    tmp90 += einsum(r2.bab, (0, 1, 2), tmp78, (3, 2, 0), (3, 1)) * -1
    tmp87 = np.copy(ints.tmp246)
    tmp87 += ints.tmp313 * 2
    tmp87 += ints.tmp330
    tmp87 += einsum(t1.bb, (0, 1), tmp86, (2, 0, 3, 4), (2, 3, 1, 4)) * -1
    del tmp86
    tmp92 = np.copy(np.transpose(ints.tmp239, (1, 0))) * 0.5
    tmp92 += ints.tmp255
    tmp92 += ints.tmp257 * 0.5
    tmp92 += f.bb.vv * -0.5
    tmp92 += ints.tmp194 * -0.5
    tmp92 += ints.tmp197 * -0.5
    tmp92 += einsum(tmp38, (0, 1), t1.bb, (0, 2), (2, 1)) * 0.5
    tmp83 = np.copy(tmp34) * 0.5
    tmp83 += tmp35 * -0.5
    tmp83 += tmp36
    tmp82 = np.copy(np.transpose(ints.tmp239, (1, 0)))
    tmp82 += ints.tmp255 * 2
    tmp82 += ints.tmp257
    tmp82 += f.bb.vv * -1
    tmp82 += np.transpose(ints.tmp194, (1, 0)) * -1
    tmp82 += np.transpose(ints.tmp197, (1, 0)) * -1
    tmp82 += einsum(tmp38, (0, 1), t1.bb, (0, 2), (2, 1))
    tmp70 = np.copy(f.aa.oo)
    tmp70 += ints.tmp148 * 2
    del ints.tmp148
    tmp70 += ints.tmp157
    del ints.tmp157
    tmp70 += ints.tmp174
    del ints.tmp174
    tmp70 += ints.tmp181
    del ints.tmp181
    tmp70 += np.transpose(ints.tmp19, (1, 0))
    del ints.tmp19
    tmp70 += ints.tmp210
    del ints.tmp210
    tmp70 += ints.tmp217
    del ints.tmp217
    tmp70 += ints.tmp171 * -1
    del ints.tmp171
    tmp70 += ints.tmp207 * -1
    del ints.tmp207
    tmp72 = np.copy(np.transpose(ints.tmp319, (0, 1, 3, 2)))
    tmp72 += ints.tmp250 * -1
    tmp72 += ints.tmp334 * -1
    tmp72 += einsum(tmp30, (0, 1, 2, 3), t1.bb, (2, 4), (0, 1, 3, 4))
    tmp79 = einsum(tmp76, (0, 1, 2), r2.aba, (2, 3, 1), (0, 3)) * -1
    del tmp76
    tmp79 += einsum(r2.bbb, (0, 1, 2), tmp78, (3, 2, 1), (3, 0)) * 2
    del tmp78
    tmp81 = np.copy(np.transpose(ints.tmp31, (1, 0)))
    tmp81 += ints.tmp58 * 2
    tmp81 += ints.tmp61
    tmp81 += f.aa.vv * -1
    tmp81 += ints.tmp29 * -1
    tmp81 += ints.tmp33 * -1
    tmp81 += tmp80
    del tmp80
    tmp74 = einsum(tmp73, (0, 1, 2, 3), r2.aba, (2, 3, 4), (4, 0, 1))
    del tmp73
    tmp71 = np.copy(ints.tmp163) * 2
    tmp71 += ints.tmp201
    tmp71 += ints.tmp47
    tmp71 += einsum(tmp56, (0, 1, 2, 3), t1.aa, (1, 4), (0, 2, 4, 3)) * -1
    del tmp56
    tmp24 = einsum(r2.aba, (0, 1, 2), t1.bb, (3, 1), (2, 3, 0))
    tmp54 = np.copy(tmp40)
    del tmp40
    tmp54 += tmp41
    del tmp41
    tmp54 += np.transpose(tmp43, (0, 2, 1)) * -2
    del tmp43
    tmp54 += np.transpose(tmp49, (0, 2, 1))
    del tmp49
    tmp54 += np.transpose(tmp53, (0, 2, 1)) * -2
    del tmp53
    tmp69 = np.copy(tmp55) * 2
    del tmp55
    tmp69 += np.transpose(tmp57, (0, 2, 1))
    del tmp57
    tmp69 += np.transpose(tmp63, (0, 2, 1))
    del tmp63
    tmp69 += np.transpose(tmp66, (0, 2, 1)) * -1
    del tmp66
    tmp69 += tmp68
    del tmp68
    tmp39 = einsum(t2.aaaa, (0, 1, 2, 3), r2.aaa, (2, 3, 4), (4, 0, 1))
    tmp12 = einsum(tmp2, (0, 1, 2), t1.aa, (3, 2), (0, 1, 3)) * -1
    tmp29 = einsum(tmp26, (0, 1, 2), t1.bb, (3, 2), (0, 1, 3))
    tmp23 = np.copy(ints.tmp243)
    tmp23 += ints.tmp310 * 2
    del ints.tmp310
    tmp23 += ints.tmp317
    del ints.tmp317
    tmp23 += np.transpose(ints.tmp332, (0, 1, 3, 2))
    del ints.tmp332
    tmp23 += np.transpose(ints.tmp246, (0, 1, 3, 2)) * -1
    del ints.tmp246
    tmp23 += ints.tmp313 * -2
    del ints.tmp313
    tmp23 += np.transpose(ints.tmp330, (0, 1, 3, 2)) * -1
    del ints.tmp330
    tmp20 = np.copy(ints.tmp253)
    del ints.tmp253
    tmp20 += np.transpose(ints.tmp265, (0, 1, 3, 2))
    del ints.tmp265
    tmp20 += np.transpose(ints.tmp271, (0, 1, 3, 2))
    del ints.tmp271
    tmp20 += np.transpose(ints.tmp277, (0, 1, 3, 2)) * 2
    del ints.tmp277
    tmp20 += np.transpose(ints.tmp303, (0, 1, 3, 2))
    del ints.tmp303
    tmp20 += ints.tmp99
    tmp20 += ints.tmp274 * -1
    del ints.tmp274
    tmp20 += np.transpose(ints.tmp281, (0, 1, 3, 2)) * -1
    del ints.tmp281
    tmp8 = np.copy(ints.tmp105)
    del ints.tmp105
    tmp8 += ints.tmp113 * 2
    del ints.tmp113
    tmp8 += ints.tmp136 * 2
    del ints.tmp136
    tmp8 += ints.tmp142
    del ints.tmp142
    tmp8 += ints.tmp152 * 2
    del ints.tmp152
    tmp8 += ints.tmp155
    del ints.tmp155
    tmp8 += ints.tmp180
    del ints.tmp180
    tmp8 += ints.tmp185
    del ints.tmp185
    tmp8 += ints.tmp196
    del ints.tmp196
    tmp8 += ints.tmp216
    del ints.tmp216
    tmp8 += ints.tmp221
    del ints.tmp221
    tmp8 += ints.tmp23
    del ints.tmp23
    tmp8 += ints.tmp40
    del ints.tmp40
    tmp8 += ints.tmp4
    del ints.tmp4
    tmp8 += ints.tmp67 * 2
    del ints.tmp67
    tmp8 += ints.tmp70
    del ints.tmp70
    tmp8 += ints.tmp82 * 2
    del ints.tmp82
    tmp8 += f.bb.ov * -1
    tmp8 += ints.tmp108 * -1
    del ints.tmp108
    tmp8 += ints.tmp10 * -1
    del ints.tmp10
    tmp8 += ints.tmp117 * -2
    del ints.tmp117
    tmp8 += ints.tmp121 * -1
    del ints.tmp121
    tmp8 += ints.tmp124 * -2
    del ints.tmp124
    tmp8 += ints.tmp13 * -2
    del ints.tmp13
    tmp8 += ints.tmp178 * -1
    del ints.tmp178
    tmp8 += ints.tmp195 * -1
    del ints.tmp195
    tmp8 += ints.tmp198 * -1
    del ints.tmp198
    tmp8 += ints.tmp214 * -1
    del ints.tmp214
    tmp8 += ints.tmp38 * -1
    del ints.tmp38
    tmp8 += ints.tmp41 * -1
    del ints.tmp41
    tmp8 += ints.tmp7 * -1
    del ints.tmp7
    tmp8 += ints.tmp85 * -1
    del ints.tmp85
    tmp32 = np.copy(ints.tmp135)
    del ints.tmp135
    tmp32 += ints.tmp66 * -1
    del ints.tmp66
    tmp21 = np.copy(ints.tmp236) * 0.5
    del ints.tmp236
    tmp21 += ints.tmp251 * 0.5
    del ints.tmp251
    tmp21 += np.transpose(ints.tmp275, (0, 2, 1, 3))
    del ints.tmp275
    tmp21 += np.transpose(ints.tmp301, (0, 3, 1, 2)) * 0.5
    del ints.tmp301
    tmp21 += np.transpose(ints.tmp263, (0, 3, 1, 2)) * -0.5
    del ints.tmp263
    tmp21 += np.transpose(ints.tmp272, (0, 3, 1, 2)) * -1
    del ints.tmp272
    tmp21 += np.transpose(ints.tmp279, (0, 3, 1, 2)) * -0.5
    del ints.tmp279
    tmp25 = np.copy(ints.tmp309)
    del ints.tmp309
    tmp25 += ints.tmp315 * 2
    del ints.tmp315
    tmp25 += ints.tmp335
    del ints.tmp335
    tmp25 += ints.tmp49
    tmp25 += ints.tmp312 * -1
    tmp27 = np.copy(ints.tmp250)
    del ints.tmp250
    tmp27 += ints.tmp334
    del ints.tmp334
    tmp27 += np.transpose(ints.tmp319, (0, 1, 3, 2)) * -1
    del ints.tmp319
    tmp28 = np.copy(ints.tmp103)
    tmp28 += ints.tmp111 * 0.5
    tmp28 += ints.tmp133
    tmp28 += ints.tmp139 * 0.5
    tmp28 += ints.tmp149
    tmp28 += ints.tmp158 * 0.5
    tmp28 += ints.tmp175 * 0.5
    tmp28 += ints.tmp182 * 0.5
    tmp28 += ints.tmp192 * 0.5
    tmp28 += ints.tmp20 * 0.5
    tmp28 += ints.tmp211 * 0.5
    tmp28 += ints.tmp218 * 0.5
    tmp28 += ints.tmp2 * 0.5
    tmp28 += ints.tmp36 * 0.5
    tmp28 += ints.tmp64
    tmp28 += ints.tmp73 * 0.5
    tmp28 += ints.tmp79
    tmp28 += f.aa.ov * -0.5
    tmp28 += ints.tmp106 * -1
    tmp28 += ints.tmp115 * -0.5
    tmp28 += ints.tmp119 * -1
    tmp28 += ints.tmp11 * -0.5
    tmp28 += ints.tmp122 * -0.5
    tmp28 += ints.tmp172 * -0.5
    tmp28 += ints.tmp190 * -0.5
    tmp28 += ints.tmp199 * -0.5
    tmp28 += ints.tmp208 * -0.5
    tmp28 += ints.tmp34 * -0.5
    tmp28 += ints.tmp42 * -0.5
    tmp28 += ints.tmp5 * -0.5
    tmp28 += ints.tmp87 * -0.5
    tmp28 += ints.tmp8 * -1
    tmp33 = np.copy(np.transpose(ints.tmp239, (1, 0)))
    del ints.tmp239
    tmp33 += ints.tmp255 * 2
    del ints.tmp255
    tmp33 += ints.tmp257
    del ints.tmp257
    tmp33 += f.bb.vv * -1
    tmp33 += np.transpose(ints.tmp194, (1, 0)) * -1
    del ints.tmp194
    tmp33 += np.transpose(ints.tmp197, (1, 0)) * -1
    del ints.tmp197
    tmp37 = np.copy(tmp34)
    del tmp34
    tmp37 += tmp35 * -1
    del tmp35
    tmp37 += tmp36 * 2
    del tmp36
    tmp3 = np.copy(ints.tmp160) * 2
    del ints.tmp160
    tmp3 += ints.tmp166
    del ints.tmp166
    tmp3 += np.transpose(ints.tmp203, (0, 1, 3, 2))
    del ints.tmp203
    tmp3 += ints.tmp44
    tmp3 += ints.tmp163 * -2
    del ints.tmp163
    tmp3 += np.transpose(ints.tmp201, (0, 1, 3, 2)) * -1
    del ints.tmp201
    tmp3 += np.transpose(ints.tmp47, (0, 1, 3, 2)) * -1
    del ints.tmp47
    tmp14 = np.copy(np.transpose(ints.tmp31, (1, 0)))
    del ints.tmp31
    tmp14 += ints.tmp58 * 2
    del ints.tmp58
    tmp14 += ints.tmp61
    del ints.tmp61
    tmp14 += f.aa.vv * -1
    tmp14 += np.transpose(ints.tmp29, (1, 0)) * -1
    del ints.tmp29
    tmp14 += np.transpose(ints.tmp33, (1, 0)) * -1
    del ints.tmp33
    tmp13 = np.copy(ints.tmp132)
    del ints.tmp132
    tmp13 += ints.tmp63 * -1
    del ints.tmp63
    tmp10 = einsum(tmp6, (0, 1, 2), t1.aa, (3, 2), (3, 0, 1))
    tmp0 = np.copy(ints.tmp146)
    del ints.tmp146
    tmp0 += np.transpose(ints.tmp26, (0, 2, 1, 3))
    tmp0 += np.transpose(ints.tmp55, (0, 2, 1, 3))
    del ints.tmp55
    tmp0 += ints.tmp77
    del ints.tmp77
    tmp0 += ints.tmp91
    del ints.tmp91
    tmp0 += ints.tmp97 * 2
    del ints.tmp97
    tmp0 += ints.tmp100 * -1
    del ints.tmp100
    tmp0 += np.transpose(ints.tmp94, (0, 2, 1, 3)) * -1
    del ints.tmp94
    tmp7 = np.copy(np.transpose(ints.tmp205, (0, 1, 3, 2)))
    del ints.tmp205
    tmp7 += np.transpose(ints.tmp52, (0, 1, 3, 2))
    del ints.tmp52
    tmp7 += ints.tmp170 * -1
    del ints.tmp170
    tmp1 = np.copy(ints.tmp144) * 0.5
    del ints.tmp144
    tmp1 += np.transpose(ints.tmp24, (0, 2, 3, 1)) * 0.5
    del ints.tmp24
    tmp1 += np.transpose(ints.tmp53, (0, 2, 3, 1)) * 0.5
    del ints.tmp53
    tmp1 += np.transpose(ints.tmp92, (0, 1, 3, 2))
    del ints.tmp92
    tmp1 += ints.tmp75 * -0.5
    del ints.tmp75
    tmp1 += ints.tmp89 * -1
    del ints.tmp89
    tmp1 += ints.tmp95 * -0.5
    del ints.tmp95
    tmp5 = np.copy(ints.tmp162)
    del ints.tmp162
    tmp5 += ints.tmp168 * 2
    del ints.tmp168
    tmp5 += ints.tmp206
    del ints.tmp206
    tmp5 += ints.tmp49
    tmp5 += ints.tmp165 * -1
    tmp11 = np.copy(ints.tmp141)
    del ints.tmp141
    tmp11 += ints.tmp69
    del ints.tmp69
    tmp9 = np.copy(ints.tmp103) * 2
    del ints.tmp103
    tmp9 += ints.tmp111
    del ints.tmp111
    tmp9 += ints.tmp133 * 2
    del ints.tmp133
    tmp9 += ints.tmp139
    del ints.tmp139
    tmp9 += ints.tmp149 * 2
    del ints.tmp149
    tmp9 += ints.tmp158
    del ints.tmp158
    tmp9 += ints.tmp175
    del ints.tmp175
    tmp9 += ints.tmp182
    del ints.tmp182
    tmp9 += ints.tmp192
    del ints.tmp192
    tmp9 += ints.tmp20
    del ints.tmp20
    tmp9 += ints.tmp211
    del ints.tmp211
    tmp9 += ints.tmp218
    del ints.tmp218
    tmp9 += ints.tmp2
    del ints.tmp2
    tmp9 += ints.tmp36
    del ints.tmp36
    tmp9 += ints.tmp64 * 2
    del ints.tmp64
    tmp9 += ints.tmp73
    del ints.tmp73
    tmp9 += ints.tmp79 * 2
    del ints.tmp79
    tmp9 += f.aa.ov * -1
    tmp9 += ints.tmp106 * -2
    del ints.tmp106
    tmp9 += ints.tmp115 * -1
    del ints.tmp115
    tmp9 += ints.tmp119 * -2
    del ints.tmp119
    tmp9 += ints.tmp11 * -1
    del ints.tmp11
    tmp9 += ints.tmp122 * -1
    del ints.tmp122
    tmp9 += ints.tmp172 * -1
    del ints.tmp172
    tmp9 += ints.tmp190 * -1
    del ints.tmp190
    tmp9 += ints.tmp199 * -1
    del ints.tmp199
    tmp9 += ints.tmp208 * -1
    del ints.tmp208
    tmp9 += ints.tmp34 * -1
    del ints.tmp34
    tmp9 += ints.tmp42 * -1
    del ints.tmp42
    tmp9 += ints.tmp5 * -1
    del ints.tmp5
    tmp9 += ints.tmp87 * -1
    del ints.tmp87
    tmp9 += ints.tmp8 * -2
    del ints.tmp8
    tmp18 = np.copy(tmp15)
    del tmp15
    tmp18 += tmp16 * 2
    del tmp16
    tmp18 += tmp17
    del tmp17
    r2new.bbb = einsum(r2.bbb, (0, 1, 2), ints.tmp490, (3, 4, 0, 1), (4, 3, 2)) * 2
    del ints.tmp490
    r2new.bbb += einsum(ints.tmp243, (0, 1, 2, 3), tmp94, (4, 0, 1), (3, 2, 4)) * -2
    del tmp94
    r2new.bbb += einsum(tmp31, (0, 1, 2), ints.tmp243, (2, 1, 3, 4), (4, 3, 0)) * 2
    del ints.tmp243
    r2new.bbb += np.transpose(tmp105, (1, 2, 0))
    r2new.bbb += np.transpose(tmp105, (2, 1, 0)) * -1
    del tmp105
    r2new.bbb += np.transpose(tmp118, (1, 2, 0)) * -1
    r2new.bbb += np.transpose(tmp118, (2, 1, 0))
    del tmp118
    r2new.bbb += einsum(tmp93, (0, 1), r2.bbb, (2, 3, 0), (2, 3, 1)) * -2
    r2new.bbb += einsum(tmp38, (0, 1), r1.b, (2,), (2, 1, 0))
    r2new.bbb += einsum(tmp38, (0, 1), r1.b, (2,), (1, 2, 0)) * -1
    r2new.bab = einsum(ints.tmp426, (0, 1, 2, 3), r2.bab, (2, 1, 4), (3, 0, 4))
    r2new.bab += einsum(ints.tmp99, (0, 1, 2, 3), tmp4, (0, 4, 2), (3, 1, 4))
    r2new.bab += einsum(ints.tmp26, (0, 1, 2, 3), tmp6, (4, 0, 2), (3, 1, 4))
    r2new.bab += einsum(ints.tmp26, (0, 1, 2, 3), r1.a, (2,), (3, 1, 0)) * -1
    r2new.bab += einsum(r2.aaa, (0, 1, 2), ints.tmp312, (2, 3, 1, 4), (4, 0, 3)) * 2
    del ints.tmp312
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp85, (2, 3, 1, 4), (0, 4, 3))
    del tmp85
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp87, (2, 3, 0, 4), (4, 1, 3)) * -1
    del tmp87
    r2new.bab += einsum(tmp89, (0, 1, 2), ints.tmp49, (0, 2, 3, 4), (4, 3, 1)) * -1
    del tmp89
    r2new.bab += einsum(v.bbb.xov, (0, 1, 2), tmp90, (0, 3), (2, 3, 1)) * -1
    del tmp90
    r2new.bab += einsum(tmp91, (0, 1), r2.bab, (2, 0, 3), (2, 1, 3)) * -1
    del tmp91
    r2new.bab += einsum(r2.bab, (0, 1, 2), tmp92, (0, 3), (3, 1, 2)) * -2
    del tmp92
    r2new.bab += einsum(tmp93, (0, 1), r2.bab, (2, 3, 0), (2, 3, 1)) * -1
    del tmp93
    r2new.bab += einsum(tmp67, (0,), ints.tmp49, (0, 1, 2, 3), (3, 2, 1)) * 2
    del tmp67
    r2new.bab += einsum(tmp38, (0, 1), r1.a, (2,), (1, 2, 0)) * -1
    r2new.aba = einsum(ints.tmp426, (0, 1, 2, 3), r2.aba, (0, 3, 4), (1, 2, 4))
    del ints.tmp426
    r2new.aba += einsum(ints.tmp26, (0, 1, 2, 3), tmp24, (4, 0, 1), (2, 3, 4)) * -1
    del ints.tmp26
    r2new.aba += einsum(tmp26, (0, 1, 2), ints.tmp99, (1, 3, 4, 2), (3, 4, 0)) * -1
    r2new.aba += einsum(ints.tmp99, (0, 1, 2, 3), r1.b, (3,), (1, 2, 0)) * -1
    del ints.tmp99
    r2new.aba += einsum(ints.tmp165, (0, 1, 2, 3), r2.bbb, (4, 3, 1), (2, 4, 0)) * 2
    del ints.tmp165
    r2new.aba += einsum(tmp71, (0, 1, 2, 3), r2.aba, (2, 4, 0), (3, 4, 1)) * -1
    del tmp71
    r2new.aba += einsum(tmp72, (0, 1, 2, 3), r2.aba, (4, 3, 0), (4, 2, 1))
    del tmp72
    r2new.aba += einsum(tmp74, (0, 1, 2), ints.tmp49, (1, 2, 3, 4), (3, 4, 0))
    del tmp74
    r2new.aba += einsum(tmp79, (0, 1), v.baa.xov, (0, 2, 3), (3, 1, 2)) * -1
    del tmp79
    r2new.aba += einsum(r2.aba, (0, 1, 2), tmp81, (0, 3), (3, 1, 2)) * -1
    del tmp81
    r2new.aba += einsum(tmp82, (0, 1), r2.aba, (2, 0, 3), (2, 1, 3)) * -1
    del tmp82
    r2new.aba += einsum(tmp70, (0, 1), r2.aba, (2, 3, 0), (2, 3, 1)) * -1
    r2new.aba += einsum(tmp83, (0,), ints.tmp49, (1, 0, 2, 3), (2, 3, 1)) * 2
    del ints.tmp49, tmp83
    r2new.aba += einsum(tmp19, (0, 1), r1.b, (2,), (1, 2, 0)) * -1
    r2new.aaa = einsum(r2.aaa, (0, 1, 2), ints.tmp387, (3, 4, 1, 0), (4, 3, 2)) * -2
    del ints.tmp387
    r2new.aaa += einsum(ints.tmp44, (0, 1, 2, 3), tmp39, (4, 0, 1), (3, 2, 4)) * -2
    del tmp39
    r2new.aaa += einsum(ints.tmp44, (0, 1, 2, 3), tmp12, (4, 1, 0), (3, 2, 4)) * 2
    del ints.tmp44
    r2new.aaa += np.transpose(tmp54, (1, 2, 0))
    r2new.aaa += np.transpose(tmp54, (2, 1, 0)) * -1
    del tmp54
    r2new.aaa += np.transpose(tmp69, (1, 2, 0)) * -1
    r2new.aaa += np.transpose(tmp69, (2, 1, 0))
    del tmp69
    r2new.aaa += einsum(tmp70, (0, 1), r2.aaa, (2, 3, 0), (2, 3, 1)) * -2
    del tmp70
    r2new.aaa += einsum(r1.a, (0,), tmp19, (1, 2), (0, 2, 1))
    r2new.aaa += einsum(tmp19, (0, 1), r1.a, (2,), (1, 2, 0)) * -1
    r1new.b = einsum(r2.aba, (0, 1, 2), tmp20, (2, 0, 3, 1), (3,)) * -1
    del tmp20
    r1new.b += einsum(tmp21, (0, 1, 2, 3), r2.bbb, (2, 3, 0), (1,)) * 4
    del tmp21
    r1new.b += einsum(tmp23, (0, 1, 2, 3), tmp22, (0, 1, 2), (3,)) * 2
    del tmp22, tmp23
    r1new.b += einsum(tmp25, (0, 1, 2, 3), tmp24, (0, 1, 2), (3,))
    del tmp24, tmp25
    r1new.b += einsum(tmp26, (0, 1, 2), tmp27, (0, 1, 3, 2), (3,))
    del tmp26, tmp27
    r1new.b += einsum(tmp28, (0, 1), r2.aba, (1, 2, 0), (2,)) * 2
    del tmp28
    r1new.b += einsum(tmp8, (0, 1), r2.bbb, (2, 1, 0), (2,)) * -2
    r1new.b += einsum(tmp30, (0, 1, 2, 3), tmp29, (0, 1, 2), (3,)) * -1
    del tmp30, tmp29
    r1new.b += einsum(tmp31, (0, 1, 2), tmp32, (0, 2, 1, 3), (3,)) * -2
    del tmp31, tmp32
    r1new.b += einsum(r1.b, (0,), tmp33, (0, 1), (1,)) * -1
    del tmp33
    r1new.b += einsum(tmp38, (0, 1), tmp37, (0,), (1,)) * -1
    del tmp38, tmp37
    r1new.a = einsum(tmp0, (0, 1, 2, 3), r2.bab, (3, 1, 0), (2,)) * -1
    del tmp0
    r1new.a += einsum(tmp1, (0, 1, 2, 3), r2.aaa, (1, 2, 0), (3,)) * 4
    del tmp1
    r1new.a += einsum(tmp3, (0, 1, 2, 3), tmp2, (0, 1, 2), (3,)) * 2
    del tmp2, tmp3
    r1new.a += einsum(tmp5, (0, 1, 2, 3), tmp4, (0, 1, 3), (2,)) * -1
    del tmp4, tmp5
    r1new.a += einsum(tmp6, (0, 1, 2), tmp7, (0, 1, 2, 3), (3,)) * -1
    del tmp6, tmp7
    r1new.a += einsum(tmp8, (0, 1), r2.bab, (1, 2, 0), (2,))
    del tmp8
    r1new.a += einsum(tmp9, (0, 1), r2.aaa, (2, 1, 0), (2,)) * -2
    del tmp9
    r1new.a += einsum(tmp11, (0, 1, 2, 3), tmp10, (0, 1, 2), (3,))
    del tmp11, tmp10
    r1new.a += einsum(tmp13, (0, 1, 2, 3), tmp12, (0, 2, 1), (3,)) * -2
    del tmp12, tmp13
    r1new.a += einsum(r1.a, (0,), tmp14, (0, 1), (1,)) * -1
    del tmp14
    r1new.a += einsum(tmp19, (0, 1), tmp18, (0,), (1,)) * -1
    del tmp19, tmp18

    return {f"r1new": r1new, f"r2new": r2new}

